/*
 * AUTOGENERATED - DON'T EDIT
 * Your edits in this file will be overwritten in the next build!
 * Modify the docusaurus.config.js file at your site's root instead.
 */
export default {
  "title": "LLM Platform Documentation",
  "tagline": "Comprehensive Documentation for the Enterprise AI Integration Platform",
  "favicon": "img/favicon.ico",
  "url": "https://llm-docs.bluefly.io",
  "baseUrl": "/",
  "organizationName": "bluefly",
  "projectName": "llm-docs",
  "onBrokenLinks": "warn",
  "onBrokenMarkdownLinks": "warn",
  "i18n": {
    "defaultLocale": "en",
    "locales": [
      "en"
    ],
    "path": "i18n",
    "localeConfigs": {}
  },
  "presets": [
    [
      "classic",
      {
        "docs": {
          "sidebarPath": "/Users/flux423/Sites/LLM/_CommonNPM/llm-docs/sidebars.js",
          "routeBasePath": "/",
          "editUrl": "https://gitlab.bluefly.io/llm/llm-docs/-/edit/main/",
          "exclude": [
            "**/__DELETE_LATER/**",
            "**/venv/**",
            "**/node_modules/**",
            "**/demo_consolidated/**",
            "**/move_consolidated/**",
            "**/*.test.md",
            "**/planning/INNOVATION_ROADMAP_SLIDES.md",
            "**/planning/ENHANCED_INNOVATION_ROADMAP.md",
            "**/platform-deployment-status.md",
            "**/development/tdd/enforcement.md",
            "**/modules/development/drupal_migration_plus/ATTRIBUTION.md",
            "**/modules/development/drupal_migration_plus/FIELD_MAPPING_TUTORIAL.md",
            "**/modules/development/langchain/BENCHMARKS.md",
            "**/modules/development/native_ai/SETTINGS_FORM_UI.md",
            "**/packages/development/bfapiclient/README.md",
            "**/operations/documentation-consolidation.md",
            "**/components/bluefly_insights/INTEGRATION.md",
            "**/cicd/bfcicomponents/CHANGELOG.md",
            "**/cicd/bfcicomponents/TROUBLESHOOTING.md",
            "**/cicd/bfcicomponents/api.md",
            "**/cicd/bfcicomponents/api/bfapi-roadmap.md",
            "**/cicd/bfcicomponents/api/bfapiclient-roadmap.md",
            "**/cicd/bfcicomponents/architecture/bfcicomponents-roadmap.md",
            "**/cicd/bfcicomponents/archive/**",
            "**/cicd/bfcicomponents/components/terraform-deploy/**",
            "**/cicd/bfcicomponents/components/todo-aggregator/**",
            "**/cicd/bfcicomponents/development/CLAUDE.md",
            "**/cicd/bfcicomponents/guide/support.md",
            "**/cicd/bfcicomponents/planning/**",
            "**/cicd/bfcicomponents/semantic-release.md",
            "**/packages/*/package-info.md",
            "**/packages/bfrfp/api.md",
            "**/packages/bfrfp/api/api-reference.md",
            "**/packages/bfrfp/archive/AI_README.md",
            "**/packages/bfrfp/ml/ML_INTEGRATION.md",
            "**/packages/llm-gateway-sdk/README.md",
            "**/packages/llm-gateway/README.md",
            "**/packages/llm-mcp/architecture/mcp-config.md",
            "**/packages/llm-mcp/mcp-servers/**",
            "**/packages/llm-mcp/performance/performance-tuning.md",
            "**/packages/llm-ui/README.md",
            "**/packages/llm-ui/accessible-components.md",
            "**/packages/llm-ui/api/accessibility-api.md",
            "**/packages/tddai/src/ci/**/templates/**",
            "**/packages/secure-project/API_REFERENCE.md",
            "**/packages/secure-project/README.md",
            "**/models/tddai-model/README.md",
            "**/packages/bfrfp/README.md",
            "**/packages/llm-mcp/README.md",
            "**/packages/llm-ui/README.md",
            "**/cicd/bfcicomponents/README.md"
          ]
        },
        "blog": false,
        "theme": {
          "customCss": "/Users/flux423/Sites/LLM/_CommonNPM/llm-docs/src/css/custom.css"
        }
      }
    ]
  ],
  "themeConfig": {
    "image": "img/docusaurus-social-card.jpg",
    "navbar": {
      "title": "LLM Platform",
      "logo": {
        "alt": "LLM Platform Logo",
        "src": "img/logo.png",
        "href": "/",
        "target": "_self"
      },
      "items": [
        {
          "to": "platform-architecture",
          "label": "Architecture",
          "position": "left"
        },
        {
          "to": "INTEGRATION",
          "label": "Integration",
          "position": "left"
        },
        {
          "to": "TESTING",
          "label": "Testing",
          "position": "left"
        },
        {
          "type": "dropdown",
          "label": "Packages",
          "position": "left",
          "items": [
            {
              "to": "packages/llm-gateway/",
              "label": "🚀 LLM Gateway"
            },
            {
              "to": "packages/llm-gateway-sdk/",
              "label": "🔗 Gateway SDK"
            },
            {
              "to": "packages/llm-mcp/",
              "label": "🤖 MCP Server"
            },
            {
              "to": "packages/apple-fm/",
              "label": "🍎 Apple Foundation Models"
            },
            {
              "to": "packages/bfrfp/",
              "label": "📄 RFP Generator"
            },
            {
              "to": "packages/tddai/",
              "label": "🧪 TDD AI Framework"
            },
            {
              "to": "packages/llmcli/",
              "label": "⚡ CLI Tools"
            },
            {
              "to": "packages/llm-ui/",
              "label": "🎨 UI Components"
            },
            {
              "to": "packages/secure-project/",
              "label": "🔒 Security Project"
            },
            {
              "to": "cicd/bfcicomponents/",
              "label": "🔧 CI/CD Components"
            },
            {
              "to": "models/tddai-model/",
              "label": "🤖 TDDAI Model"
            }
          ]
        },
        {
          "href": "https://gitlab.bluefly.io/llm",
          "label": "GitLab",
          "position": "right"
        }
      ],
      "hideOnScroll": false
    },
    "footer": {
      "style": "dark",
      "links": [
        {
          "title": "Documentation",
          "items": [
            {
              "label": "Architecture",
              "to": "platform-architecture"
            },
            {
              "label": "Integration Guide",
              "to": "INTEGRATION"
            },
            {
              "label": "Testing",
              "to": "TESTING"
            }
          ]
        },
        {
          "title": "NPM Packages",
          "items": [
            {
              "label": "apple-fm - Foundation Models",
              "to": "packages/apple-fm/"
            },
            {
              "label": "llmcli - CLI Tool",
              "to": "packages/llmcli/"
            },
            {
              "label": "llm-gateway - API Gateway",
              "to": "packages/llm-gateway/"
            },
            {
              "label": "tddai - TDD Framework",
              "to": "packages/tddai/"
            }
          ]
        },
        {
          "title": "GitLab Repositories",
          "items": [
            {
              "label": "LLM Platform",
              "href": "https://gitlab.bluefly.io/llm"
            },
            {
              "label": "CI/CD Components",
              "href": "https://gitlab.bluefly.io/llm/bfcicomponents"
            },
            {
              "label": "Documentation Hub",
              "href": "https://gitlab.bluefly.io/llm/llm-docs"
            }
          ]
        }
      ],
      "copyright": "Copyright © 2025 LLM Platform. Built with Docusaurus."
    },
    "prism": {
      "theme": {
        "plain": {
          "color": "#393A34",
          "backgroundColor": "#f6f8fa"
        },
        "styles": [
          {
            "types": [
              "comment",
              "prolog",
              "doctype",
              "cdata"
            ],
            "style": {
              "color": "#999988",
              "fontStyle": "italic"
            }
          },
          {
            "types": [
              "namespace"
            ],
            "style": {
              "opacity": 0.7
            }
          },
          {
            "types": [
              "string",
              "attr-value"
            ],
            "style": {
              "color": "#e3116c"
            }
          },
          {
            "types": [
              "punctuation",
              "operator"
            ],
            "style": {
              "color": "#393A34"
            }
          },
          {
            "types": [
              "entity",
              "url",
              "symbol",
              "number",
              "boolean",
              "variable",
              "constant",
              "property",
              "regex",
              "inserted"
            ],
            "style": {
              "color": "#36acaa"
            }
          },
          {
            "types": [
              "atrule",
              "keyword",
              "attr-name",
              "selector"
            ],
            "style": {
              "color": "#00a4db"
            }
          },
          {
            "types": [
              "function",
              "deleted",
              "tag"
            ],
            "style": {
              "color": "#d73a49"
            }
          },
          {
            "types": [
              "function-variable"
            ],
            "style": {
              "color": "#6f42c1"
            }
          },
          {
            "types": [
              "tag",
              "selector",
              "keyword"
            ],
            "style": {
              "color": "#00009f"
            }
          }
        ]
      },
      "darkTheme": {
        "plain": {
          "color": "#F8F8F2",
          "backgroundColor": "#282A36"
        },
        "styles": [
          {
            "types": [
              "prolog",
              "constant",
              "builtin"
            ],
            "style": {
              "color": "rgb(189, 147, 249)"
            }
          },
          {
            "types": [
              "inserted",
              "function"
            ],
            "style": {
              "color": "rgb(80, 250, 123)"
            }
          },
          {
            "types": [
              "deleted"
            ],
            "style": {
              "color": "rgb(255, 85, 85)"
            }
          },
          {
            "types": [
              "changed"
            ],
            "style": {
              "color": "rgb(255, 184, 108)"
            }
          },
          {
            "types": [
              "punctuation",
              "symbol"
            ],
            "style": {
              "color": "rgb(248, 248, 242)"
            }
          },
          {
            "types": [
              "string",
              "char",
              "tag",
              "selector"
            ],
            "style": {
              "color": "rgb(255, 121, 198)"
            }
          },
          {
            "types": [
              "keyword",
              "variable"
            ],
            "style": {
              "color": "rgb(189, 147, 249)",
              "fontStyle": "italic"
            }
          },
          {
            "types": [
              "comment"
            ],
            "style": {
              "color": "rgb(98, 114, 164)"
            }
          },
          {
            "types": [
              "attr-name"
            ],
            "style": {
              "color": "rgb(241, 250, 140)"
            }
          }
        ]
      },
      "additionalLanguages": [
        "php",
        "bash",
        "json",
        "yaml"
      ],
      "magicComments": [
        {
          "className": "theme-code-block-highlighted-line",
          "line": "highlight-next-line",
          "block": {
            "start": "highlight-start",
            "end": "highlight-end"
          }
        }
      ]
    },
    "colorMode": {
      "defaultMode": "light",
      "disableSwitch": false,
      "respectPrefersColorScheme": false
    },
    "docs": {
      "versionPersistence": "localStorage",
      "sidebar": {
        "hideable": false,
        "autoCollapseCategories": false
      }
    },
    "metadata": [],
    "tableOfContents": {
      "minHeadingLevel": 2,
      "maxHeadingLevel": 3
    }
  },
  "baseUrlIssueBanner": true,
  "onDuplicateRoutes": "warn",
  "staticDirectories": [
    "static"
  ],
  "customFields": {},
  "plugins": [],
  "themes": [],
  "scripts": [],
  "headTags": [],
  "stylesheets": [],
  "clientModules": [],
  "titleDelimiter": "|",
  "noIndex": false,
  "markdown": {
    "format": "mdx",
    "mermaid": false,
    "mdx1Compat": {
      "comments": true,
      "admonitions": true,
      "headingIds": true
    }
  }
};
