module.exports = {
  title: 'Bluefly.io LLM Platform',
  description: 'Documentation for the Bluefly.io LLM Platform - A Revolutionary Emergent Consciousness Framework for Drupal',
  themeConfig: {
    nav: [
      { text: 'Home', link: '/' },
      { text: 'Architecture', link: '/architecture/' },
      { text: 'Development', link: '/development/' },
      { text: 'Integration', link: '/integration/' },
      { text: 'Operations', link: '/operations/' },
      { text: 'Reference', link: '/reference/' },
      { text: 'Recipes', link: '/recipes/' },
      { text: 'Agents', link: '/agents/' }
    ],
    sidebar: {
      '/architecture/': [
        {
          title: 'Architecture',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['emergent-consciousness', 'Emergent Consciousness Framework'],
            ['system-design', 'System Design'],
            ['security', 'Security Architecture'],
            ['performance', 'Performance Architecture']
          ]
        }
      ],
      '/development/': [
        {
          title: 'Development',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['environment', 'Development Environment'],
            ['testing', 'Testing Strategy'],
            ['best-practices', 'Best Practices'],
            ['configuration', 'Configuration Management']
          ]
        }
      ],
      '/integration/': [
        {
          title: 'Integration',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['drupal', 'Drupal Integration'],
            ['openapi', 'OpenAPI Integration'],
            ['monitoring', 'Monitoring Integration'],
            ['audit', 'Integration Audit']
          ]
        }
      ],
      '/operations/': [
        {
          title: 'Operations',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['deployment', 'Deployment Guide'],
            ['monitoring', 'Monitoring Guide'],
            ['security', 'Security Operations'],
            ['performance', 'Performance Operations']
          ]
        }
      ],
      '/reference/': [
        {
          title: 'Reference',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['api', 'API Reference'],
            ['cli', 'CLI Reference'],
            ['configuration', 'Configuration Reference'],
            ['recipes', 'Recipe Reference']
          ]
        }
      ],
      '/recipes/': [
        {
          title: 'Recipes',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['drupal', 'Drupal Recipes'],
            ['llm', 'LLM Recipes'],
            ['integration', 'Integration Recipes'],
            ['deployment', 'Deployment Recipes']
          ]
        }
      ],
      '/agents/': [
        {
          title: 'Agents',
          collapsable: false,
          children: [
            ['', 'Overview'],
            ['architecture', 'Agent Architecture'],
            ['development', 'Agent Development'],
            ['deployment', 'Agent Deployment'],
            ['monitoring', 'Agent Monitoring']
          ]
        }
      ]
    }
  },
  plugins: [
    '@vuepress/back-to-top',
    '@vuepress/medium-zoom',
    '@vuepress/active-header-links',
    '@vuepress/search',
    '@vuepress/nprogress'
  ]
} 