# BFCIComponents GitLab Configuration

This directory contains GitLab - specific configuration files and templates for the BFCIComponents project.

## Directory Structure

- **issue_templates /** - Templates for creating new issues
- **merge_request_templates /** - Templates for creating merge requests
- **project_templates /** - Templates for configuring GitLab projects
- **CODEOWNERS** - Defines code ownership and review requirements
- **gitlab - ci.yml** - Template CI / CD configuration for projects

## Templates

### Issue Templates

- **Bug.md** - Template for reporting bugs
- **Feature.md** - Template for requesting new features
- **Component.md** - Template for proposing new CI / CD components

### Merge Request Templates

- **Default.md** - Default template for merge requests
- **Component.md** - Template for component - specific merge requests

### Project Templates

- **node - project.yml** - Configuration for Node.js projects using BFCIComponents

## Usage

### Project Setup

1. Copy the relevant templates to your project's `.gitlab`directory
2. Customize the templates as needed for your project
3. Include the appropriate CI / CD components in your`.gitlab - ci.yml`file

### Using in GitLab CI / CD

To use these components in your GitLab CI / CD pipeline, include them in your`.gitlab - ci.yml`file:

```yaml
include:
  - component: 'gitlab://Blueflyio / BFCIComponents / components / nodejs - base.yml'
    inputs:
      node_version: '20'
      project_type: 'app'
      use_custom_image: true
      custom_image_path: 'registry.gitlab.bluefly.io/bluefly/internal-projects/core-assets/bluefly-docker-image:latest'
```text

For a complete example, see the `gitlab - ci.yml` template in this directory.
