# Roadmap

_Generated on 2025-05-30_

Found 735 TODO items in the codebase.

## BUG Items (2)

### index.js

- **Line 12:** 1: Safari 10/11 doesn't reliably return the same Strings value.
- **Line 18:** 2: Safari 10/11 use the same cached strings value when the string parts are the same.

## FIXME Items (8)

### built-in-definitions.js

- **Line 206:** Pure disabled to work around zloirock/core-js#262.

### referencer.js

- **Line 64:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### subscribe.js

- **Line 86:** when underlying TS bug fixed, see https://github.com/microsoft/TypeScript/issues/31613

### instanceOf.js

- **Line 18:** https://github.com/graphql/graphql-js/issues/2317

### printer.js

- **Line 341:** https://github.com/graphql/graphql-js/issues/2203

### introspection.js

- **Line 278:** add test case

### buildClientSchema.js

- **Line 154:** Properly type IntrospectionType, it's a breaking change so fix in v17

## HACK Items (2)

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### rollup-plugin-typescript2.cjs.js

- **Line 28193:** for rollup-plugin-vue, it creates virtual modules in form 'file.vue?rollup-plugin-vue=script.ts'

## NOTE Items (289)

### inline-callSuper-helpers.js

- **Line 43:** This doesn't work if this.__proto__.constructor has been modified.

### index.js

- **Line 11:** contrary to various Github issues, Edge 16+ *does* correctly infer the name of Arrow Functions.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### index.js

- **Line 10:** DO NOT REMOVE the null character `\0` as it may be used by other plugins

### index.d.ts

- **Line 214:** In extreme cases, this feature may result in some paths being

### index.js

- **Line 64:** This isn't preferable, but we've no other way to test this bit. Removing the tslib devDep
- **Line 451:** `dir` can be a value like `dist` in which case, `path.relative` could result in a value

### index.js

- **Line 177:** that we use posix.join because:

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 405:** The default timeout interval is 5 seconds if this method is not called.
- **Line 411:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 849:** that the type must be either an array or a tuple.
- **Line 1379:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### index.d.ts

- **Line 461:** the property name that the schema is testing will always be a string.

### index.d.ts

- **Line 71:** These definitions support NodeJS and TypeScript 4.9+.

### events.d.ts

- **Line 38:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support NodeJS and TypeScript 4.8 and earlier.

### net.d.ts

- **Line 44:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### readline.d.ts

- **Line 97:** According to the documentation:
- **Line 429:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 265:** that the provided high water mark will not be validated ahead of

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### util.d.ts

- **Line 1456:** that an effort will be made to coerce the given values into strings.

### vm.d.ts

- **Line 658:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 123:** this property is currently true by default but it will be changed to false in the next major version because Node's resolution

### simplify.d.ts

- **Line 6:** that it does *not* guarantee that it would match the same versions in all cases,

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### consistent-type-exports.js

- **Line 92:** it is valid to export values as types. We will avoid reporting errors

### indent.js

- **Line 3:** this file is rather type-unsafe in its current state.

### member-delimiter-style.js

- **Line 42:** can't have "none" for single line delimiter as it's invalid syntax

### member-ordering.js

- **Line 612:** Not all members have names

### naming-convention.js

- **Line 31:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 96:** that bigint cannot have + prefixed to it

### no-misused-promises.js

- **Line 429:** - we currently do not support 'spread' arguments - adding support for them

### no-non-null-asserted-optional-chain.js

- **Line 55:** these cases are still invalid for 3.9:

### no-unnecessary-condition.js

- **Line 217:** It's also unnecessary if the types that don't overlap at all

### collectUnusedVariables.js

- **Line 28:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.js

- **Line 11:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 23:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 36:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### Referencer.js

- **Line 311:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### isUnsafeAssignment.js

- **Line 11:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 1757:** that there may be 0 declarations (i.e. `const;`).

### convert.js

- **Line 1463:** - for compat with 3.7.x, where node.exportClause is always undefined and
- **Line 1637:** - NewExpression cannot have an optional chain in it

### getScriptKind.js

- **Line 34:** - we only respect the user's jsx setting for unknown extensions

### index.js

- **Line 35:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### node-utils.js

- **Line 548:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 33:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 90:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,

### resolveProjectList.js

- **Line 53:** - we initialize the global cache based on the first config we encounter.

### json-schema.js

- **Line 2:** - @types/json-schema@7.0.4 added some function declarations to the type package

### ESLint.d.ts

- **Line 120:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 59:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### helpers.js

- **Line 29:** If this is found to have issues, please also revist the logic in

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### index.js

- **Line 49:** this will only work on the server since it attempts to read the map file

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### referencer.js

- **Line 180:** Not referring variableScope. It is intended.
- **Line 471:** In ES6, ForStatement dynamically generates
- **Line 496:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 650:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 24:** See

### cli-engine.js

- **Line 841:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### rule-validator.js

- **Line 116:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 298:** that we should not overuse queries (e.g., by appending the current time

### flat-rule-tester.js

- **Line 138:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 307:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 239:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 43:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### GraphQLError.js

- **Line 65:** that if this Error represents more than one node, the source may not

### locatedError.js

- **Line 20:** this uses a brand-check to support GraphQL errors originating from other contexts.

### execute.js

- **Line 511:** we don't rely on a `catch` method, but we do expect "thenable"

### values.js

- **Line 35:** The returned value is a plain Object with a prototype, since it is
- **Line 253:** ValuesOfCorrectTypeRule validation should catch this before

### ast.d.ts

- **Line 64:** is undefined for punctuation tokens, but typed as string for

### ast.js

- **Line 147:** fragment variable definitions are deprecated and will removed in v17.0.0

### printer.js

- **Line 95:** fragment variable definitions are experimental and may be changed

### visitor.d.ts

- **Line 33:** ancestors includes arrays which contain the parent of visited node.

### index.d.ts

- **Line 2:** the `graphql/subscription` module has been deprecated with its

### definition.d.ts

- **Line 204:** the enforcement of non-nullability occurs within the executor.
- **Line 763:** If a value is not provided in a definition, the name of the enum value

### definition.js

- **Line 1137:** variables will be resolved to a value before calling this function.

### introspection.d.ts

- **Line 23:** that these are GraphQLField and not GraphQLFieldConfig,

### schema.js

- **Line 70:** When the schema is constructed, by default only the types that are
- **Line 109:** If an array of `directives` are provided to GraphQLSchema, that will be

### extendSchema.js

- **Line 191:** While this could make early assertions to get the correctly
- **Line 480:** While this could make assertions to get the correctly typed

### stripIgnoredCharacters.js

- **Line 26:** It is required to have a delimiter character between neighboring

### TypeInfo.js

- **Line 119:** many of the types below are explicitly typed as "unknown" to drop

### valueFromAST.js

- **Line 57:** This does no further checking that this variable is correct.

### NoDeprecatedCustomRule.js

- **Line 20:** This rule is optional and is not part of the Validation section of the GraphQL

### NoSchemaIntrospectionCustomRule.js

- **Line 20:** This rule is optional and is not part of the Validation section of the

### OverlappingFieldsCanBeMergedRule.js

- **Line 95:** This is the *only time* that a the fields "within" a set are compared
- **Line 150:** this is the *only place* `collectConflictsWithin` is called.

### ValuesOfCorrectTypeRule.js

- **Line 33:** TypeInfo will traverse into a list's item type, so look to the

### version.js

- **Line 7:** This file is autogenerated using "resources/gen-version.js" script and

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### index.js

- **Line 88:** ** If `leading` and `trailing` options are `true`, `func` is

### index.js

- **Line 526:** ** The cache is exposed as the `cache` property on the memoized

### constants.js

- **Line 3:** this is the semver.org version of the spec that it implements

### re.js

- **Line 116:** that the only major, minor, patch, and pre-release sections of
- **Line 139:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 206:** that these all use the loose form, because they'll be

### index.js

- **Line 363:** flushing CAN potentially switch us into not-flowing mode

### index.js

- **Line 543:** we can't clone the form-data object without having it as a dependency
- **Line 742:** per spec we have to first exhaust the lists then process them

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### index.d.ts

- **Line 879:** that this will be extremely memory-hungry on large filesystems.

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 493:** that we might know *something* about it if there has been a previous
- **Line 638:** even on case-sensitive systems, it is **not** safe to test the
- **Line 854:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1676:** As of Node 19, this is very slow, compared to other methods of

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that [@link OptionsBase.allowStale] is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### regenerate.js

- **Line 166:** the `- 1` makes `end` inclusive.
- **Line 203:** we cannot `return` just yet, in case any following pairs still
- **Line 365:** we cannot `return` just yet, as there may still be other
- **Line 376:** we cannot return yet.
- **Line 409:** we cannot `return` just yet.
- **Line 517:** the `\b` escape sequence for U+0008 BACKSPACE in strings has a
- **Line 523:** IE < 9 treats `'\v'` as `'v'`, so avoid using it.
- **Line 538:** `-` (U+002D HYPHEN-MINUS) is escaped in this way rather
- **Line 864:** the loop starts at the next index.
- **Line 1182:** `valueOf` is aliased as `toArray`.

### rewrite-pattern.js

- **Line 85:** `unicodeMatchPropertyValue` throws on invalid values.
- **Line 97:** `unicodeMatchProperty` throws on invalid properties.
- **Line 981:** `processTerm` mutates `tree` and `groups`.

### parser.js

- **Line 7:** The ECMA-262 standard uses the term "Assertion" for /^/. Here the
- **Line 148:** The following productions refer to the "set notation and
- **Line 213:** The following productions refer to the

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 747:** ending in / means that we'll get a final ""

### rollup-plugin-typescript2.cjs.js

- **Line 7288:** ** This function only supports comparing values with tags of
- **Line 7787:** ** This function only supports cloning values with tags of
- **Line 8235:** ** If this function becomes hot, i.e. is invoked a lot in a short
- **Line 8543:** ** Unlike `_.pullAll`, this method returns a new array.
- **Line 8571:** ** Unlike `_.pullAllBy`, this method returns a new array.
- **Line 8606:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 8788:** ** This method mutates `array`.
- **Line 9291:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`
- **Line 9314:** ** Unlike `_.difference`, this method mutates `array`.
- **Line 9342:** ** Unlike `_.differenceBy`, this method mutates `array`.
- **Line 9371:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 9399:** ** Unlike `_.at`, this method mutates `array`.
- **Line 9435:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`
- **Line 9483:** ** This method mutates `array` and is based on
- **Line 9509:** ** This method is used instead of
- **Line 10131:** ** Unlike `_.pull`, this method returns a new array.
- **Line 10611:** ** This method mutates the wrapped array.
- **Line 10701:** ** This method returns `true` for
- **Line 10750:** ** Unlike `_.remove`, this method returns a new array.
- **Line 10930:** ** As with other "Collections" methods, objects with a "length"
- **Line 11681:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 11782:** ** This method doesn't set the "length" property of curried functions.
- **Line 12292:** ** This method doesn't set the "length" property of partially
- **Line 12390:** ** This method is based on the
- **Line 12621:** ** This method is loosely based on the
- **Line 12743:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 13122:** ** This method supports comparing arrays, array buffers, booleans,
- **Line 13218:** ** This method is based on
- **Line 13305:** ** This method is loosely based on
- **Line 13414:** ** This method is equivalent to `_.matches` when `source` is
- **Line 13517:** ** This method can't reliably detect native functions in the presence
- **Line 13595:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 14183:** ** This method mutates `object` and is loosely based on
- **Line 14226:** ** This method mutates `object`.
- **Line 14896:** ** Non-object values are coerced to objects. See the
- **Line 14928:** ** Non-object values are coerced to objects.
- **Line 15095:** ** This method is considerably slower than `_.pick`.
- **Line 15668:** ** JavaScript follows the IEEE-754 standard for resolving
- **Line 15842:** ** No other characters are escaped. To escape additional
- **Line 16073:** ** This method aligns with the
- **Line 16288:** ** In the development build `_.template` utilizes
- **Line 16754:** ** No other HTML entities are unescaped. To unescape additional
- **Line 16883:** ** This method doesn't set the "length" property of bound functions.
- **Line 16969:** ** The created function is equivalent to `_.conformsTo` with
- **Line 17159:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 17166:** ** Multiple values can be checked by combining several matchers
- **Line 17198:** ** Partial comparisons will match empty array and empty object
- **Line 17294:** ** Use `_.runInContext` to create a pristine `lodash` function to
- **Line 28087:** this does not need normalization as we only compare Rollup <-> Rollup, and not Rollup <-> TS
- **Line 28129:** that result.code is non-existent if emitDeclarationOnly per https://github.com/ezolenko/rollup-plugin-typescript2/issues/268

### index.d.ts

- **Line 1:** named reexports are used instead of `export *` because

### rollup.d.ts

- **Line 108:** if plugins use new this.cache to opt-out auto transform cache

### loadConfigFile.js

- **Line 350:** that we do not have coverage for Windows-only code paths

### rollup.js

- **Line 10565:** that class fields do not end up on the prototype
- **Line 11220:** that unknown test values are always included

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### source-map.debug.js

- **Line 1381:** The order of the mappings is NOT guaranteed.

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### get.d.ts

- **Line 86:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### lib.dom.d.ts

- **Line 1305:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6148:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### tsserverlibrary.d.ts

- **Line 653:** Paths may also be directories.
- **Line 1509:** this us query-only operation and does not generate any output on disk.
- **Line 4727:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5941:** that `@extends` is a synonym of `@augments`.
- **Line 6167:** that this field is only set by the module resolution process when
- **Line 6411:** that the resulting nodes cannot be checked.
- **Line 8094:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 9266:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9540:** The file might not exist.
- **Line 9635:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11167:** It is not allowed to call release on a SourceFile that was not acquired from

### tsserverlibrary.js

- **Line 30279:** that theoretically the following condition would hold true literals like 009,
- **Line 54287:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 138022:** that no attempt is made to take advantage of type argument inference
- **Line 155133:** there might be:
- **Line 166046:** that separators are part of the node in statements and class elements.
- **Line 166143:** after calling this, the TextChanges object must be discarded!
- **Line 175023:** that this does not return projects in info.containingProjects

### uri.all.js

- **Line 1178:** We do not parse query strings for HTTP URIs

### line.js

- **Line 4:** that startCol and endCol are absolute positions

## REVIEW Items (1)

### tsserverlibrary.js

- **Line 180130:** can optimize by coalescing simple edits

## TODO Items (417)

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### built-ins.json.js

- **Line 1:** Remove in Babel 8

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### api.js

- **Line 446:** Throw more verbose error
- **Line 756:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 814:** Maybe move elsewhere?

### formatter.js

- **Line 10:** add [additonal formatters][1]

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### index.js

- **Line 206:** remove version checks for 1.20 - 1.25 when we bump peer deps
- **Line 254:** remove options hook and hoist declarations when version checks are removed

### index.js

- **Line 353:** remove this in next major

### promises.d.ts

- **Line 85:** Add `EventEmitter` close

### perf_hooks.d.ts

- **Line 89:** Narrow this based on entry type.

### util.d.ts

- **Line 96:** , inspect: inspect

### wasi.d.ts

- **Line 130:** avoid DOM dependency until WASM moved to own lib.
- **Line 147:** Narrow to DOM types

### indent.js

- **Line 310:** This is invalid, there can be more than one extends in interface

### key-spacing.js

- **Line 35:** replace with native .at() once Node 14 stops being supported

### no-inferrable-types.js

- **Line 153:** - if we add more references

### no-mixed-enums.js

- **Line 145:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-qualifier.js

- **Line 69:** PERF `getSymbolsInScope` gets a long list. Is there a better way?

### no-unnecessary-type-arguments.js

- **Line 69:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 242:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 161:** - we could break down the spread and compare the array type against each argument
- **Line 199:** - handle generic iterable case

### no-unused-vars.js

- **Line 439:** ######

### quotes.js

- **Line 42:** this rule has only had messages since v7.0 - remove this when we remove support for v6

### strict-boolean-expressions.js

- **Line 475:** we have to compare to 0n if the type is bigint
- **Line 480:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 119:** Do we need to investigate the precedence here?
- **Line 152:** JSXElement?
- **Line 208:** Should prefix `++` and `--` be moved to the `Update` precedence?

### getContextualType.js

- **Line 66:** - support return statement checking

### isUnsafeAssignment.js

- **Line 29:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 22:** - delete this in next major

### convert.js

- **Line 1661:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 57:** Support Windows CRLF

### getWatchProgramsForProjects.js

- **Line 263:** this needs refinement and development, but we're allowing users to opt-in to this for now for testing and feedback.

### RuleCreator.js

- **Line 24:** - when the above PR lands; add type checking for the context.report `data` property

### SourceCode.d.ts

- **Line 261:** rename to 'tokens'

### constants.js

- **Line 3:** increment this version if there are schema changes

### built-in-definitions.js

- **Line 322:** We should introduce overloaded instance methods definition
- **Line 346:** add async iterator dependencies when we support sub-dependencies

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### compat.js

- **Line 28:** use `.flatMap` in core-js@4
- **Line 53:** Obsolete, remove from `core-js@4`

### targets-parser.js

- **Line 13:** Remove from `core-js@4`

### browser.js

- **Line 111:** add a `localStorage` variable to explicitly enable/disable colors

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### referencer.js

- **Line 596:** ExportDeclaration doesn't exist. for bc?
- **Line 615:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1035:** Needed?
- **Line 1108:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 669:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1202:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### index.js

- **Line 233:** what if headers is in nested array form... ?

### execute.js

- **Line 356:** deprecate `subscribe` and move all logic here
- **Line 482:** find a way to memoize, in case this field is within a List type.
- **Line 837:** remove in 17.0.0 release

### validate.js

- **Line 178:** Ensure proper locations.
- **Line 423:** change to contravariant?
- **Line 444:** validate default values?

### buildClientSchema.js

- **Line 192:** Temporary workaround until GraphQL ecosystem will fully support

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### magic-string.cjs.js

- **Line 114:** is this block necessary?...
- **Line 737:** last chunk in the array may not be the last chunk, if it's moved...
- **Line 895:** deprecate this? not really very useful
- **Line 1175:** there's a bunch of this sort of thing, needs cleaning up

### range.js

- **Line 489:** build?

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### test.js

- **Line 105:** Should we be stricter and perform validation?

### regenerate.js

- **Line 1141:** Optimize this by writing and using `dataIntersectionData()`.

### rewrite-pattern.js

- **Line 670:** consider changing this at the regenerate level.
- **Line 877:** remove modifiers: 'parse' in regexpu-core v7

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### rollup-plugin-typescript2.cjs.js

- **Line 895:** remove this in the next major version
- **Line 28065:** use module resolution cache

### index.js

- **Line 2459:** emit errors properly. Example: EMFILE on Macos.
- **Line 3085:** real check
- **Line 3571:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-
- **Line 3714:** this is not equal to path-normalize module - investigate why

### rollup.js

- **Line 6223:** this should be removed once ImportExpression follows official ESTree
- **Line 11630:** once ImportExpression follows official ESTree specs with "null" as
- **Line 14644:** we are pretending it was not found while it should behave like "undefined"

### watch.js

- **Line 138:** throws or warn? Currently just ignore, uses new event

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### init.js

- **Line 5:** see what's the best path for this

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### tsserverlibrary.js

- **Line 24536:** : if there is inline sourceMap in jsFile, use that
- **Line 24539:** : if there is inline sourceMap in dtsFile, use that
- **Line 26775:** GH#18217
- **Line 27757:** should we separate these branches out?
- **Line 52572:** could probably serialize as function + ns + class, now that that's OK
- **Line 52627:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 152708:** Handle auto quote preference.
- **Line 162156:** should have its own kind?

### uri.all.js

- **Line 1013:** normalize IPv6 address as per RFC 5952

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### URL-impl.js

- **Line 24:** query stuff

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### client.ts

- **Line 66:** [llmcli] Add unit test for request interceptor registration.
- **Line 67:** [llmcli] Add integration test for interceptor execution order.
- **Line 68:** [llmcli] Add OpenAPI doc for interceptor usage (if exposed).
- **Line 69:** [llmcli] Add error handling for invalid interceptors.
- **Line 78:** [llmcli] Add unit test for response interceptor registration.
- **Line 79:** [llmcli] Add integration test for response transformation.
- **Line 90:** [llmcli] Add unit test for error interceptor registration.
- **Line 91:** [llmcli] Add integration test for error handling flow.

### AddAgentToolsRequest.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for AddAgentToolsRequest type.
- **Line 10:** [llmcli] Add validation utilities for AddAgentToolsRequest fields.
- **Line 11:** [llmcli] Add unit test for AddAgentToolsRequest serialization/deserialization.

### AddAgentToolsResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for AddAgentToolsResponse type.
- **Line 10:** [llmcli] Add validation utilities for AddAgentToolsResponse fields.
- **Line 11:** [llmcli] Add unit test for AddAgentToolsResponse serialization/deserialization.
- **Line 12:** [llmcli] Add stricter typing for fields if possible.
- **Line 13:** [llmcli] Add contract test for error scenarios.

### Agent.ts

- **Line 18:** [llmcli] Add OpenAPI contract test for Agent type.
- **Line 19:** [llmcli] Add validation utilities for Agent fields.
- **Line 20:** [llmcli] Add unit test for Agent serialization/deserialization.

### AgentDetails.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for AgentDetails type.
- **Line 10:** [llmcli] Add validation utilities for AgentDetails fields.
- **Line 11:** [llmcli] Add unit test for AgentDetails serialization/deserialization.

### AgentMemory.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for AgentMemory type.
- **Line 10:** [llmcli] Add validation utilities for AgentMemory fields.
- **Line 11:** [llmcli] Add unit test for AgentMemory serialization/deserialization.

### CreateAgentRequest.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for CreateAgentRequest type.
- **Line 10:** [llmcli] Add validation utilities for CreateAgentRequest fields.
- **Line 11:** [llmcli] Add unit test for CreateAgentRequest serialization/deserialization.

### EmbeddingsRequest.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for EmbeddingsRequest type.
- **Line 10:** [llmcli] Add validation utilities for EmbeddingsRequest fields.
- **Line 11:** [llmcli] Add unit test for EmbeddingsRequest serialization/deserialization.

### EmbeddingsResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for EmbeddingsResponse type.
- **Line 10:** [llmcli] Add validation utilities for EmbeddingsResponse fields.
- **Line 11:** [llmcli] Add unit test for EmbeddingsResponse serialization/deserialization.

### GenerateRequest.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for GenerateRequest type.
- **Line 10:** [llmcli] Add validation utilities for GenerateRequest fields.
- **Line 11:** [llmcli] Add unit test for GenerateRequest serialization/deserialization.

### GenerateResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for GenerateResponse type.
- **Line 10:** [llmcli] Add validation utilities for GenerateResponse fields.
- **Line 11:** [llmcli] Add unit test for GenerateResponse serialization/deserialization.

### HealthResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for HealthResponse type.
- **Line 10:** [llmcli] Add validation utilities for HealthResponse fields.
- **Line 11:** [llmcli] Add unit test for HealthResponse serialization/deserialization.

### McpToolsResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for McpToolsResponse type.
- **Line 10:** [llmcli] Add validation utilities for McpToolsResponse fields.
- **Line 11:** [llmcli] Add unit test for McpToolsResponse serialization/deserialization.

### Model.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for Model type.
- **Line 10:** [llmcli] Add validation utilities for Model fields.
- **Line 11:** [llmcli] Add unit test for Model serialization/deserialization.

### ModelDetails.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for ModelDetails type.
- **Line 10:** [llmcli] Add validation utilities for ModelDetails fields.
- **Line 11:** [llmcli] Add unit test for ModelDetails serialization/deserialization.

### RunAgentRequest.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for RunAgentRequest type.
- **Line 10:** [llmcli] Add validation utilities for RunAgentRequest fields.
- **Line 11:** [llmcli] Add unit test for RunAgentRequest serialization/deserialization.

### RunAgentResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for RunAgentResponse type.
- **Line 10:** [llmcli] Add validation utilities for RunAgentResponse fields.
- **Line 11:** [llmcli] Add unit test for RunAgentResponse serialization/deserialization.

### TokenizeRequest.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for TokenizeRequest type.
- **Line 10:** [llmcli] Add validation utilities for TokenizeRequest fields.
- **Line 11:** [llmcli] Add unit test for TokenizeRequest serialization/deserialization.

### TokenizeResponse.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for TokenizeResponse type.
- **Line 10:** [llmcli] Add validation utilities for TokenizeResponse fields.
- **Line 11:** [llmcli] Add unit test for TokenizeResponse serialization/deserialization.

### ToolTemplate.ts

- **Line 9:** [llmcli] Add OpenAPI contract test for ToolTemplate type.
- **Line 10:** [llmcli] Add validation utilities for ToolTemplate fields.
- **Line 11:** [llmcli] Add unit test for ToolTemplate serialization/deserialization.

### AdminService.ts

- **Line 9:** Enhance request and response typing beyond generic Record<string, any> for better type safety.
- **Line 10:** Add detailed parameter and response interface definitions for all methods.
- **Line 11:** Implement retry and error handling strategies for transient failures.
- **Line 14:** [llmcli] Add integration tests for all admin endpoints.
- **Line 16:** [llmcli] Add audit logging for all admin operations.
- **Line 32:** Fix ESLint spacing and import quote style issues in this file.
- **Line 33:** Add proper TypeScript interfaces for request and response payloads to replace generic Record<string, any>.
- **Line 34:** Implement error handling and retry logic for API calls.
- **Line 35:** Add method-level comments for all public static methods if needed to enhance clarity.
- **Line 39:** [llmcli] Add unit test for getSystemStatus.
- **Line 40:** [llmcli] Add OpenAPI doc for /admin/status endpoint.
- **Line 41:** [llmcli] Add error handling for status failures.
- **Line 42:** [llmcli] Add audit logging for system status checks.
- **Line 48:** Define a proper SystemStatus interface to replace Record<string, any>.
- **Line 67:** Define a User interface for user records.
- **Line 84:** Define a CreateUserRequest interface for the request body.
- **Line 85:** Define a CreateUserResponse interface for the response.
- **Line 109:** Define a UserDetails interface for the response.
- **Line 135:** Define an UpdateUserRequest interface for the request body.
- **Line 164:** Confirm if soft delete or hard delete is implemented.
- **Line 188:** Define an ApiActivity interface for the response.
- **Line 229:** Define a SystemMetrics interface for the response.
- **Line 245:** Define a ModelMetrics interface for the response.
- **Line 261:** Define a SystemSettings interface for the response.
- **Line 278:** Define an UpdateSystemSettingsRequest interface for the request body.

### AgentsService.ts

- **Line 21:** [llmcli] Add OpenAPI contract test for all static methods.
- **Line 22:** [llmcli] Add integration tests for all agent endpoints.
- **Line 23:** [llmcli] Add error handling for API and network failures.
- **Line 24:** [llmcli] Add audit logging for all agent operations.
- **Line 31:** [llmcli] Add unit test for listAgents.
- **Line 32:** [llmcli] Add OpenAPI doc for /agents endpoint.
- **Line 33:** [llmcli] Add error handling for registry failures.
- **Line 34:** [llmcli] Add audit logging for agent listing.

### AnalyzeService.ts

- **Line 13:** [llmcli] Add integration tests for all analysis endpoints.
- **Line 15:** [llmcli] Add audit logging for all analysis operations.
- **Line 22:** [llmcli] Add unit test for analyzeDocument.
- **Line 23:** [llmcli] Add OpenAPI doc for /analyze/document endpoint.
- **Line 24:** [llmcli] Add error handling for invalid input.
- **Line 25:** [llmcli] Add audit logging for document analysis.

### AuthService.ts

- **Line 13:** [llmcli] Add integration tests for all auth endpoints.
- **Line 15:** [llmcli] Add audit logging for all auth operations.
- **Line 22:** [llmcli] Add unit test for login.
- **Line 23:** [llmcli] Add OpenAPI doc for /auth/login endpoint.
- **Line 24:** [llmcli] Add error handling for invalid credentials.
- **Line 25:** [llmcli] Add audit logging for login attempts.

### LearningService.ts

- **Line 13:** [llmcli] Add integration tests for all learning endpoints.
- **Line 15:** [llmcli] Add audit logging for all learning operations.
- **Line 22:** [llmcli] Add unit test for listDatasets.
- **Line 23:** [llmcli] Add OpenAPI doc for /learning/datasets endpoint.
- **Line 25:** [llmcli] Add audit logging for dataset listing.

### McpService.ts

- **Line 14:** [llmcli] Add integration tests for all MCP endpoints.
- **Line 16:** [llmcli] Add audit logging for all MCP operations.
- **Line 23:** [llmcli] Add unit test for listMcpTools.
- **Line 24:** [llmcli] Add OpenAPI doc for /mcp/tools endpoint.
- **Line 26:** [llmcli] Add audit logging for MCP tool listing.

### ModelsService.ts

- **Line 21:** [llmcli] Add integration tests for all model endpoints.
- **Line 23:** [llmcli] Add audit logging for all model operations.
- **Line 30:** [llmcli] Add unit test for listModels.
- **Line 31:** [llmcli] Add OpenAPI doc for /models endpoint.
- **Line 33:** [llmcli] Add audit logging for model listing.

### graphqlClient.ts

- **Line 28:** [llmcli] Add integration tests for query and mutation execution.
- **Line 29:** [llmcli] Add error handling for GraphQL errors and network failures.
- **Line 30:** [llmcli] Add audit logging for all GraphQL operations.
- **Line 67:** [llmcli] Add unit test for constructor logic.
- **Line 68:** [llmcli] Add OpenAPI doc for client config structure.
- **Line 87:** [llmcli] Add integration test for executeRequest.
- **Line 88:** [llmcli] Add OpenAPI doc for request/response structure.
- **Line 89:** [llmcli] Add error handling for transport and GraphQL errors.
- **Line 90:** [llmcli] Add audit logging for all requests.
- **Line 154:** [llmcli] Add integration test for query method.
- **Line 155:** [llmcli] Add OpenAPI doc for query endpoint.
- **Line 156:** [llmcli] Add error handling for invalid queries.
- **Line 157:** [llmcli] Add audit logging for query operations.
- **Line 186:** [llmcli] Add integration test for mutate method.
- **Line 187:** [llmcli] Add OpenAPI doc for mutation endpoint.
- **Line 188:** [llmcli] Add error handling for invalid mutations.
- **Line 189:** [llmcli] Add audit logging for mutation operations.

### index.ts

- **Line 25:** [AI-401] Generation Script: Ensure the SDK generation script (`llm-gatewayclient/scripts/generate-sdk.js` or similar, possibly invoked by `llm-gateway/scripts/generate-sdk.js`) is robust, well-documented, and handles OpenAPI schema updates gracefully.
- **Line 26:** [AI-402] Versioning: Implement a clear versioning strategy for the client library, aligned with llm-gateway versions. Consider embedding the llm-gateway version it was generated against into the client.
- **Line 27:** [AI-403] Custom Interceptors: Provide clear documentation and examples for adding custom request/response interceptors (e.g., for tenant-specific headers, advanced error handling).
- **Line 28:** [AI-404] Error Handling: Standardize error handling within the client. Auto-generated clients might throw generic HTTP errors; enhance this to provide more specific error types or parsed error responses from llm-gateway.
- **Line 29:** [AI-405] Authentication: Ensure authentication mechanisms (e.g., token injection via interceptors) are secure and easy to configure. Document different auth strategies (e.g., API keys, OAuth tokens).
- **Line 30:** [AI-406] Tree Shaking: Verify that the client library is structured to support tree shaking by bundlers (like Webpack/Rollup in acui) to minimize final bundle sizes.
- **Line 31:** [AI-407] Documentation: Auto-generate or supplement documentation for the client library (perhaps using TypeDoc, linking from BFDOCS), including usage examples for each service and model. The existing `USAGE.md` should be expanded.
- **Line 32:** [AI-408] Testing: Implement a strategy for testing the client library. This might involve mock API servers or integration tests against a running llm-gateway instance in a test environment.
- **Line 33:** [AI-409] Configuration Management: Allow for flexible configuration of the API client (e.g., base URL, timeouts, custom headers) at runtime. See `./core/config`.
- **Line 34:** [AI-410] GraphQL Support: If GraphQL is a primary or growing part of llm-gateway, ensure the GraphQL client (`./graphql/graphqlClient`) is as feature-rich and well-integrated as the REST client.
- **Line 35:** [AI-411] Extensibility: Design patterns for extending generated services or models if specific business logic needs to be added on the client-side without modifying generated code directly.
- **Line 36:** [AI-412] SDK Regeneration CI: Set up a CI job in `BFCIComponents` that automatically regenerates `llm-gatewayclient` whenever `llm-gateway/openapi.yaml` changes and creates a merge request.
- **Line 37:** [AI-413] Deprecation Handling: Establish a process for handling deprecated API endpoints in the client, potentially logging warnings or providing migration paths.
- **Line 38:** [AI-414] Offline/Mocking Support: Consider utilities for mocking API responses within the client to facilitate frontend development and testing when llm-gateway is unavailable.
- **Line 39:** [AI-415] Integration with bfllm/llm-mcp: If the client needs to interact directly with bfllm or llm-mcp for specific tasks (though usually this would be via llm-gateway), define how that would be structured.
- **Line 76:** Fix ESLint spacing errors on export lines

### ModernApiClient.ts

- **Line 41:** [llmcli] Add unit test for service initialization.
- **Line 42:** [llmcli] Add OpenAPI doc for service registration.
- **Line 43:** [llmcli] Add error handling for missing service definitions.
- **Line 75:** [llmcli] Add integration test for optimizedRequest.
- **Line 77:** [llmcli] Add error handling for request failures.
- **Line 149:** [llmcli] Add unit test for createServiceProxy.
- **Line 150:** [llmcli] Add OpenAPI doc for proxy usage.
- **Line 151:** [llmcli] Add error handling for invalid service names.
- **Line 199:** [llmcli] Add integration test for batchRequests.
- **Line 200:** [llmcli] Add OpenAPI doc for batch request structure.
- **Line 201:** [llmcli] Add error handling for batch failures.
- **Line 202:** [llmcli] Add audit logging for batch requests.

### UnifiedPlatformClient.ts

- **Line 187:** [llmcli] Add OpenAPI contract test for all public methods.
- **Line 188:** [llmcli] Add integration tests for service discovery and failover.
- **Line 189:** [llmcli] Add error handling for service unavailability.
- **Line 190:** [llmcli] Add audit logging for all API calls.
- **Line 209:** [llmcli] Add unit test for client initialization.
- **Line 210:** [llmcli] Add OpenAPI doc for service config structure.
- **Line 211:** [llmcli] Add error handling for invalid configs.
- **Line 319:** [llmcli] Add integration test for inference execution.
- **Line 320:** [llmcli] Add OpenAPI doc for inference request/response.
- **Line 321:** [llmcli] Add error handling for model errors.
- **Line 322:** [llmcli] Add audit logging for inference requests.
- **Line 354:** [llmcli] Add integration test for streaming inference.
- **Line 355:** [llmcli] Add OpenAPI doc for streaming endpoint.
- **Line 356:** [llmcli] Add error handling for stream interruptions.
- **Line 357:** [llmcli] Add audit logging for streaming requests.
- **Line 390:** [llmcli] Add integration test for model listing.
- **Line 391:** [llmcli] Add OpenAPI doc for model list endpoint.
- **Line 393:** [llmcli] Add audit logging for model list requests.
- **Line 412:** [llmcli] Add integration test for getModel.
- **Line 413:** [llmcli] Add OpenAPI doc for model details endpoint.
- **Line 414:** [llmcli] Add error handling for missing model.
- **Line 415:** [llmcli] Add audit logging for model detail requests.
- **Line 438:** [llmcli] Add integration test for agent fleet creation.
- **Line 439:** [llmcli] Add OpenAPI doc for agent fleet endpoint.
- **Line 440:** [llmcli] Add error handling for invalid fleet config.
- **Line 441:** [llmcli] Add audit logging for agent fleet creation.
- **Line 452:** [llmcli] Add integration test for agent fleet listing.
- **Line 453:** [llmcli] Add OpenAPI doc for agent fleet list endpoint.
- **Line 455:** [llmcli] Add audit logging for agent fleet list requests.
- **Line 474:** [llmcli] Add integration test for getAgentFleet.
- **Line 475:** [llmcli] Add OpenAPI doc for agent fleet details endpoint.
- **Line 476:** [llmcli] Add error handling for missing fleet.
- **Line 477:** [llmcli] Add audit logging for agent fleet detail requests.
- **Line 487:** [llmcli] Add integration test for scaling agent fleet.
- **Line 488:** [llmcli] Add OpenAPI doc for scaling endpoint.
- **Line 489:** [llmcli] Add error handling for scaling failures.
- **Line 490:** [llmcli] Add audit logging for scaling requests.
- **Line 503:** [llmcli] Add integration test for agent fleet deletion.
- **Line 504:** [llmcli] Add OpenAPI doc for delete endpoint.
- **Line 505:** [llmcli] Add error handling for deletion failures.
- **Line 506:** [llmcli] Add audit logging for agent fleet deletion.
- **Line 520:** [llmcli] Add integration test for MCP tool listing.
- **Line 521:** [llmcli] Add OpenAPI doc for MCP tool list endpoint.
- **Line 523:** [llmcli] Add audit logging for MCP tool list requests.
- **Line 542:** [llmcli] Add integration test for MCP tool execution.
- **Line 543:** [llmcli] Add OpenAPI doc for MCP tool execution endpoint.
- **Line 544:** [llmcli] Add error handling for tool failures.
- **Line 545:** [llmcli] Add audit logging for MCP tool execution.
- **Line 555:** [llmcli] Add integration test for MCP tool schema retrieval.
- **Line 556:** [llmcli] Add OpenAPI doc for MCP tool schema endpoint.
- **Line 557:** [llmcli] Add error handling for missing tool.
- **Line 558:** [llmcli] Add audit logging for MCP tool schema requests.
- **Line 581:** [llmcli] Add integration test for Drupal node creation.
- **Line 582:** [llmcli] Add OpenAPI doc for node creation endpoint.
- **Line 583:** [llmcli] Add error handling for invalid node data.
- **Line 584:** [llmcli] Add audit logging for node creation.
- **Line 594:** [llmcli] Add integration test for Drupal node retrieval.
- **Line 595:** [llmcli] Add OpenAPI doc for node retrieval endpoint.
- **Line 596:** [llmcli] Add error handling for missing node.
- **Line 597:** [llmcli] Add audit logging for node retrieval.
- **Line 616:** [llmcli] Add integration test for Drupal node update.
- **Line 617:** [llmcli] Add OpenAPI doc for node update endpoint.
- **Line 619:** [llmcli] Add audit logging for node update.
- **Line 630:** [llmcli] Add integration test for Drupal node listing.
- **Line 631:** [llmcli] Add OpenAPI doc for node list endpoint.
- **Line 633:** [llmcli] Add audit logging for node list requests.
- **Line 651:** [llmcli] Add integration test for workflow creation.
- **Line 652:** [llmcli] Add OpenAPI doc for workflow creation endpoint.
- **Line 653:** [llmcli] Add error handling for invalid workflow data.
- **Line 654:** [llmcli] Add audit logging for workflow creation.
- **Line 664:** [llmcli] Add integration test for workflow execution.
- **Line 665:** [llmcli] Add OpenAPI doc for workflow execution endpoint.
- **Line 666:** [llmcli] Add error handling for execution failures.
- **Line 667:** [llmcli] Add audit logging for workflow execution.
- **Line 679:** [llmcli] Add integration test for workflow listing.
- **Line 680:** [llmcli] Add OpenAPI doc for workflow list endpoint.
- **Line 682:** [llmcli] Add audit logging for workflow list requests.
- **Line 696:** [llmcli] Add integration test for platform status retrieval.
- **Line 697:** [llmcli] Add OpenAPI doc for status endpoint.
- **Line 699:** [llmcli] Add audit logging for status requests.
- **Line 755:** [llmcli] Add integration test for metrics retrieval.
- **Line 756:** [llmcli] Add OpenAPI doc for metrics endpoint.
- **Line 757:** [llmcli] Add error handling for metrics failures.
- **Line 758:** [llmcli] Add audit logging for metrics requests.
- **Line 802:** [llmcli] Add integration test for subscription logic.
- **Line 803:** [llmcli] Add OpenAPI doc for subscription endpoint.
- **Line 804:** [llmcli] Add error handling for subscription failures.
- **Line 805:** [llmcli] Add audit logging for subscription requests.
- **Line 823:** [llmcli] Add integration test for unsubscription logic.
- **Line 824:** [llmcli] Add OpenAPI doc for unsubscription endpoint.
- **Line 825:** [llmcli] Add error handling for unsubscription failures.
- **Line 826:** [llmcli] Add audit logging for unsubscription requests.
- **Line 1029:** [llmcli] Add integration test for destroy logic.
- **Line 1030:** [llmcli] Add OpenAPI doc for destroy endpoint (if exposed).
- **Line 1031:** [llmcli] Add error handling for destroy failures.
- **Line 1032:** [llmcli] Add audit logging for destroy requests.

## XXX Items (16)

### browser.js

- **Line 209:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 280:** DO NOT USE. This is a temporary stub function.
- **Line 281:** It WILL be removed in the next major release.

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### preload.js

- **Line 3:** remove in v8 or beyond

### test.js

- **Line 354:** 80');
- **Line 355:** 1337');
- **Line 362:** 443');
- **Line 370:** 70');
- **Line 374:** 21');

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### ast.js

- **Line 483:** abstract out this map method

### index.js

- **Line 699:** remove this slice.  Just pass the start index.

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

