# Drupal Packagist Component

Enterprise Drupal module publishing to Packagist with semantic versioning

## Usage

```yaml
include:
  - component: $CI_SERVER_FQDN/$CI_PROJECT_PATH/drupal-packagist@main
    inputs:
      php_version: "8.3"
      release_branch: "main"
```

## Inputs

| Input | Description | Type | Default | Required |
|-------|-------------|------|---------|----------|
| `php_version` | PHP version to use | string | `8.3` | ❌ |
| `drupal_version` | Target Drupal version | string | `11.x` | ❌ |
| `packagist_token` | Packagist API token | string | |  |
| `release_branch` | Branch to release from | string | `main` | ❌ |
| `enable_documentation` | Generate API documentation | boolean | `true` | ❌ |
| `enable_security_scan` | Run security scanning | boolean | `true` | ❌ |
| `min_test_coverage` | Minimum test coverage percentage | number | `80` | ❌ |

## Features

- Automated semantic versioning based on commits
- Packagist publishing with webhook integration
- Comprehensive test suite execution
- API documentation generation
- Security vulnerability scanning
- Strict validation for Drupal coding standards

## Requirements

- GitLab 17.0+ for component support
- Properly structured Drupal module with composer.json
- PHPUnit tests for test coverage
- Packagist account with API token

## License

MIT License - see LICENSE.md for details