# Bfrfp K8s Component

Kubernetes resources for the RFP service

## Usage

This component provides Kubernetes resource definitions for the bfrfp service.

```yaml
include:
  - component: gitlab.bluefly.io/llm/bfcicomponents/components/k8s/bfrfp@main
    inputs:
      environment: production
      replicas: 2
      image_tag: latest
```

## Inputs

| Input | Description | Type | Default | Required |
|-------|-------------|------|---------|----------|
| `environment` | Target environment | string | `development` | ❌ |
| `replicas` | Number of replicas | number | `1` | ❌ |
| `image_tag` | Docker image tag | string | `latest` | ❌ |

## Resources

- Deployment
- Service
- ConfigMap (when applicable)
- Secrets (when applicable)

## Configuration

The kubernetes resources in this component are configured for optimal performance in production environments.
Adjust resource requests and limits based on your specific needs.

## License

MIT License - see LICENSE.md for details
