# Service Monitors Component

Service monitor configurations for applications

## Usage

```yaml
include:
  - component: gitlab.bluefly.io/llm/bfcicomponents/components/monitoring/service-monitors@main
    inputs:
      # Add component-specific inputs here
```

## Inputs

| Input | Description | Type | Default | Required |
|-------|-------------|------|---------|----------|
| `environment` | Target environment | string | `development` | ❌ |
| `service_name` | Service to monitor | string | |  |

## Features

- Real-time monitoring and alerting
- Dashboard visualization
- Performance metrics tracking
- Error detection and notification
- SLO/SLA compliance tracking

## Requirements

- Prometheus operator in the cluster
- Kubernetes service discovery
- Proper labeling for service identification

## License

MIT License - see LICENSE.md for details
