# Deploy Component

This component provides standardized deployment templates for Bluefly CI / CD pipelines.

## Inputs

| Name | Type | Required | Default | Description |
|------|------|----------|---------|-------------|
| stage | string | false | deploy | The stage in which to run this component |
| environment | string | false | production | The deployment environment (dev, staging, production) |
| image | string | false | alpine:latest | Docker image to use for deployment |
| use_custom_image | boolean | false | false | Whether to use a custom image |
| custom_image_path | string | false | "" | Path to custom Docker image if use_custom_image is true |
| deploy_script | string | false | "echo 'Deploying to environment'" | Script to run for deployment |
| variables | object | false | {} | Additional variables to pass to the job |
| only | array | false | [main] | Branches to run this job on |

## Usage Example

```yaml
include:
  - project: 'bluefly / internal - projects / llm / bfcicomponents'
    file: 'templates / deploy / template.yml'

deploy_to_staging:
  extends: .deploy_template
  variables:
    DEPLOY_ENVIRONMENT: staging
    DEPLOY_STRATEGY: blue - green
  only:
    - staging
