# Development Standards Component

This component provides standardized development standards enforcement for Bluefly CI / CD pipelines.

## Inputs

| Name | Type | Required | Default | Description |
|------|------|----------|---------|-------------|
| stage | string | false | validate | The stage in which to run this component |
| image | string | false | node:16 | Docker image to use for validation |
| use_custom_image | boolean | false | false | Whether to use a custom image |
| custom_image_path | string | false | "" | Path to custom Docker image if use_custom_image is true |
| code_quality_enabled | boolean | false | true | Whether to enable code quality checks |
| documentation_required | boolean | false | true | Whether to require documentation |
| variables | object | false | {} | Additional variables to pass to the job |
| allow_failure | boolean | false | true | Whether to allow this job to fail without failing the pipeline |

## Usage Example

```yaml
include:
  - project: 'bluefly / internal - projects / llm / bfcicomponents'
    file: 'templates / development - standards / template.yml'

enforce_standards:
  extends: .development_standards_template
  variables:
    CODE_QUALITY_ENABLED: "true"
    DOCUMENTATION_REQUIRED: "true"
    CODE_STANDARD: "airbnb"
  allow_failure: false
