# Support Guide

This guide provides information about getting help and support for BFCI Components.

## Getting Help

### Documentation

1. Start with our comprehensive documentation:

   - [Getting Started Guide](. / getting - started.md)
   - [Configuration Guide](. / configuration.md)
   - [Component Registry Guide](. / component - registry.md)
   - [Usage Examples](. / examples.md)

2. Check the [Components Reference](.. / components / ) for detailed component documentation

### Issue Tracking

If you encounter issues:

1. Search existing issues in our [GitLab Issue Tracker](<https://gitlab.bluefly.io> / Blueflyio / internal - projects / llm / bfcicomponents/ - /issues)
2. Check the [Known Issues](#known - issues) section below
3. Create a new issue if needed

## Creating Issues

When creating a new issue, please include:

1. Component version(s)
2. GitLab CI / CD configuration
3. Error messages or logs
4. Steps to reproduce
5. Expected vs actual behavior

## Common Problems

### Authentication Issues

1. Check your GitLab credentials
2. Verify registry access
3. Review token permissions

### Component Integration

1. Verify component versions
2. Check configuration syntax
3. Review dependencies

### Pipeline Failures

1. Check job logs
2. Verify environment variables
3. Review cache configuration

## Known Issues

Current known issues and workarounds:

1. Issue: Cache invalidation in parallel jobs

   - Workaround: Use unique cache keys

2. Issue: Version conflicts with npm packages

   - Workaround: Pin dependency versions

3. Issue: Docker build timeouts

   - Workaround: Optimize Dockerfile

## Contact Information

### Support Channels

1. GitLab Issues (preferred)
2. Internal Slack: #bfci - support
3. Email: <devops@bluefly.io>

### Response Times

- Critical issues: 2 - 4 hours
- Major issues: 24 hours
- Minor issues: 48 - 72 hours

## Contributing

Want to help improve BFCI Components?

1. Read our [Contributing Guide](. / contributing.md)
2. Submit merge requests
3. Help improve documentation

## Security Issues

For security - related issues:

1. DO NOT create public issues
2. Email <security@bluefly.io>
3. Follow responsible disclosure

## Support Policy

- Active support for latest major version
- Security updates for previous version
- Migration assistance available
- Custom support plans for enterprise users
