# BFCI Components Documentation

Welcome to the BFCI Components documentation. This guide will help you understand and use our standardized CI/CD components effectively.

## Overview

BFCI Components is a collection of reusable CI/CD components designed to standardize and simplify GitLab pipeline configurations across Bluefly projects. These components provide:

- Standardized build, test, and deployment workflows
- Consistent security scanning and quality checks
- Automated dependency management
- Container image building and publishing

## Getting Started

1. [Installation Guide](./guide/installation.md)
2. [Basic Configuration](./guide/configuration.md)
3. [Component Registry](./guide/component-registry.md)
4. [Usage Examples](./guide/examples.md)

## Component Reference

Browse our collection of pre-built components:

- [Build Components](./components/build.md)
- [Test Components](./components/test.md)
- [Deploy Components](./components/deploy.md)
- [Security Components](./components/security.md)

## Project Information

- [Contributing Guidelines](./guide/contributing.md)
- [Maintenance Guide](./guide/maintenance.md)
- [Migration Guide](./guide/migration.md)

## Support

Need help? Check out our [support resources](./guide/support.md) or [create an issue](https://gitlab.bluefly.io/llm/bfcicomponents/-/issues).
