# Component Migration Plan

## Legacy Components Categorization

### API Components
- `api-service.yml` → components/api/api-service-legacy/

### Build Components
- `drupal-build.yml` → components/drupal/drupal-build/

### CI/CD Components
- `auto-devops-simple.yml` → components/ci/auto-devops-simple/
- `auto-devops.yml.disabled` → components/ci/auto-devops/

### Base Components
- `base.yml` → components/shared/base/
- `ultimate-base.yml` → components/shared/ultimate-base/

### Config Components
- `common-config.yml` → components/shared/common-config/

### Docker Components
- `docker.yml` → components/shared/docker/
- `docker-rate-limit-fix.yml` → components/shared/docker-rate-limit-fix/

### Documentation Components
- `docs.yml` → components/docs/docs-legacy/

### Drupal Components
- `drupal-e2e-testing.yml` → components/drupal/drupal-e2e-testing/
- `drupal-modules.yml` → components/drupal/drupal-modules/
- `drupal-tdd.yml` → components/drupal/drupal-tdd-legacy/
- `drupal-tdd-enhanced.yml` → components/drupal/drupal-tdd-enhanced/
- `drupal-tdd-mutation-enhanced.yml` → components/drupal/drupal-tdd-mutation/
- `drupal-performance-enhanced.yml` → components/drupal/drupal-performance/
- `drupal-security-enhanced.yml` → components/drupal/drupal-security/
- `ai-drupal-self-healing.yml` → components/drupal/drupal-self-healing/

### Library Components
- `library.yml` → components/nodejs/library-legacy/

### Node.js Components
- `nodejs.yml` → components/nodejs/nodejs-legacy/
- `nodejs-enhanced.yml` → components/nodejs/nodejs-enhanced/

### PHP Components
- `php-packagist.yml` → components/php/php-packagist/

### General Components
- `safe.yml` → components/shared/safe-legacy/
- `simple.yml` → components/shared/simple-legacy/
- `ultimate-simple.yml` → components/shared/ultimate-simple/
- `ultimate-unified.yml` → components/shared/ultimate-unified/

## Migration Strategy

1. For each component:
   - Create destination directory
   - Copy content to template.yml
   - Create README.md with documentation
   - Add LICENSE.md

2. Ensure spec.inputs structure following GitLab 17.0+ standards

3. Update existing references if necessary

4. Run validation tests