# Monitoring Component

This component provides standardized monitoring setup for Bluefly CI / CD pipelines.

## Inputs

| Name | Type | Required | Default | Description |
|------|------|----------|---------|-------------|
| stage | string | false | deploy | The stage in which to run this component |
| image | string | false | alpine:latest | Docker image to use for monitoring setup |
| use_custom_image | boolean | false | false | Whether to use a custom image |
| custom_image_path | string | false | "" | Path to custom Docker image if use_custom_image is true |
| monitoring_enabled | boolean | false | true | Whether to enable monitoring |
| monitoring_service | string | false | "prometheus" | Monitoring service to use |
| alert_threshold | string | false | "80" | Threshold for alerts |
| report_interval | string | false | "5m" | Interval for reporting metrics |
| variables | object | false | {} | Additional variables to pass to the job |
| only | array | false | [main, development] | Branches to run this job on |

## Usage Example

```yaml
include:
  - project: 'bluefly / internal - projects / llm / bfcicomponents'
    file: 'templates / monitoring / template.yml'

setup_project_monitoring:
  extends: .monitoring_template
  variables:
    MONITORING_SERVICE: "datadog"
    ALERT_THRESHOLD: "90"
    REPORT_INTERVAL: "1m"
  only:
    - main
