# Roadmap

_Generated on 2025-05-30_

Found 425 TODO items in the codebase.

## BUG Items (1)

### dns.d.ts

- **Line 113:** in the name resolution service used by the operating system.

## FIXME Items (7)

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### referencer.js

- **Line 62:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

## HACK Items (5)

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

### runmain-hack.js

- **Line 3:** to avoid Module.runMain on node 18.6.0

### bin.js

- **Line 59:** technically, this function is not marked @internal so it's possible
- **Line 462:** workaround node regression

## NOTE Items (236)

### PolicyEngineService.php

- **Line 790:** In a production system, this would likely use a database table instead.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 365:** The default timeout interval is 5 seconds if this method is not called.
- **Line 371:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 806:** that the type must be either an array or a tuple.
- **Line 1363:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### index.d.ts

- **Line 461:** the property name that the schema is testing will always be a string.

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 19:** the list doesn't contain prefix-only modules like `node:test`.

### net.d.ts

- **Line 48:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 492:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 459:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 1199:** ** When you enable mocking for a specific timer, its associated
- **Line 1202:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1247:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1269:** ** After each test completes, this function is called on
- **Line 1282:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1386:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1657:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 215:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 677:** This is a contrived example in that the linker function creates a new

### simplify.d.ts

- **Line 6:** that it does *not* guarantee that it would match the same versions in all cases,

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### consistent-type-exports.js

- **Line 89:** it is valid to export values as types. We will avoid reporting errors

### indent.js

- **Line 3:** this file is rather type-unsafe in its current state.

### member-delimiter-style.js

- **Line 87:** can't have "none" for single line delimiter as it's invalid syntax
- **Line 92:** - need to define this last as it references the enums

### member-ordering.js

- **Line 605:** Not all members have names

### naming-convention.js

- **Line 9:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 74:** that bigint cannot have + prefixed to it

### no-misused-promises.js

- **Line 440:** - we currently do not support 'spread' arguments - adding support for them

### no-unnecessary-condition.js

- **Line 248:** It's also unnecessary if the types that don't overlap at all

### prefer-find.js

- **Line 191:** we're always looking for array member access to be "computed",

### compareNodes.js

- **Line 182:** - we purposely ignore optional flag because for our purposes

### collectUnusedVariables.js

- **Line 28:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.js

- **Line 12:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 24:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 37:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### Referencer.js

- **Line 319:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### isUnsafeAssignment.js

- **Line 34:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 883:** that there may be 0 declarations (i.e. `const;`).

### convert.js

- **Line 1636:** - NewExpression cannot have an optional chain in it

### getScriptKind.js

- **Line 34:** - we only respect the user's jsx setting for unknown extensions

### index.js

- **Line 35:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### node-utils.js

- **Line 621:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 49:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 127:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,

### createParseSettings.js

- **Line 43:** - we intentionally use "unnecessary" `?.` here because in TS<5.3 this enum doesn't exist

### resolveProjectList.js

- **Line 49:** - we initialize the global cache based on the first config we encounter.

### ESLint.d.ts

- **Line 121:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 60:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### semver.js

- **Line 18:** this is the semver.org version of the spec that it implements
- **Line 139:** that the only major, minor, patch, and pre-release sections of
- **Line 167:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 257:** that these all use the loose form, because they'll be

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### referencer.js

- **Line 178:** Not referring variableScope. It is intended.
- **Line 496:** In ES6, ForStatement dynamically generates
- **Line 521:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 660:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 24:** See

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### cli-engine.js

- **Line 850:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### rule-validator.js

- **Line 117:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 284:** that we should not overuse queries (e.g., by appending the current time

### fork-context.js

- **Line 90:** `create` is just a wrapper that augments `new CodePathSegment`.

### flat-rule-tester.js

- **Line 150:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 312:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 275:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 44:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### diff.js

- **Line 878:** that diff_commonPrefix and diff_commonSuffix are unicode-aware
- **Line 1040:** this runs after equality check has ruled out exact equality

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### index.js

- **Line 526:** ** The cache is exposed as the `cache` property on the memoized

### index.js

- **Line 1679:** ** This method is loosely based on
- **Line 1856:** ** Non-object values are coerced to objects.
- **Line 1889:** ** This method mutates `object`.

### index.js

- **Line 363:** flushing CAN potentially switch us into not-flowing mode

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### index.d.ts

- **Line 879:** that this will be extremely memory-hungry on large filesystems.

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 493:** that we might know *something* about it if there has been a previous
- **Line 638:** even on case-sensitive systems, it is **not** safe to test the
- **Line 854:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1676:** As of Node 19, this is very slow, compared to other methods of

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that [@link OptionsBase.allowStale] is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### index.js

- **Line 60:** INSERT never advances the offset.

### doc.d.ts

- **Line 204:** that, like cursorNodeStart, this is a misnomer and may actually be the text between two

### index.d.ts

- **Line 131:** that resolving these types is somewhat complicated, and it wasn't

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### source-map.debug.js

- **Line 1381:** The order of the mappings is NOT guaranteed.

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### index.d.ts

- **Line 2776:** It is intentional that this is not a type guard.
- **Line 2873:** that this is a shallow collection: it only returns `type.types` or `[type]`.

### get.d.ts

- **Line 150:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### jsonify.d.ts

- **Line 11:** The return value has to be `any` and not `unknown` so it can match `void`.

### node-internal-modules-esm-resolve.js

- **Line 258:** fs check redundances will be handled by Descriptor cache here.

### runmain-hack.js

- **Line 6:** that I attempted a try-catch around `Module._load`, but it poisons some sort of cache such that subsequent `import()` is impossible.

### bin.js

- **Line 41:** When transitioning into the child-process after `phase2`,
- **Line 147:** argv and restArgs may be overwritten by child process
- **Line 247:** When we transition to a child process for ESM, the entry-point script determined
- **Line 294:** that we need to explicitly re-resolve the entry-point information in the final
- **Line 316:** resolution relative to cwd option (not `process.cwd()`) is legacy backwards-compat; should be changed in next major: https://github.com/TypeStrong/ts-node/issues/1834
- **Line 470:** eval and repl may both run, but never with stdin.

### file-extensions.js

- **Line 108:** TS's resolver is only used by, and only required for, typechecking.

### index.js

- **Line 285:** fileURLToPath does not exist on early node v10

### repl.d.ts

- **Line 13:** typically, you will want to call `start()` instead of using this method.

### repl.js

- **Line 196:** `code` argument is deprecated
- **Line 205:** deprecated
- **Line 212:** should not be killing the process here, but this codepath is deprecated anyway
- **Line 388:** REPL does not respect sourcemaps!

### resolver-functions.js

- **Line 100:** seems to be called with empty typeDirectiveNames array for all files.

### ts-internals.js

- **Line 13:** This factory returns *only* functions which need a reference to the TS

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

### uri.all.js

- **Line 1178:** We do not parse query strings for HTTP URIs

### stringify.js

- **Line 24:** Be careful editing this code!  It's been tuned for performance

### v8-compile-cache.js

- **Line 228:** that this actually includes the newline character(s) in the

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### drupal.ts

- **Line 16:** According to our TDD policy, we need to implement to pass tests in

### express.ts

- **Line 15:** This is just a stub implementation. Create a proper adapter following

### auditLogger.ts

- **Line 15:** According to our TDD policy, we must have 95%+ test coverage (see coverageThreshold in jest.config.js).

### complianceFramework.ts

- **Line 15:** This file indicates it's in GREEN phase of TDD but has 0% test coverage,

### dataSeparation.ts

- **Line 16:** Our TDD policy requires 95%+ test coverage. Current implementation fails

### policyEngine.ts

- **Line 16:** According to our TDD policy, implementation must follow tests.

### securityAlert.ts

- **Line 16:** Test-driven development requires implementing code to pass existing tests.

## REVIEW Items (1)

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

## TODO Items (164)

### SeparationOfDutiesFunctionalTest.php

- **Line 67:** Define or mock the 'perform financial approval' permission if it doesn't exist.
- **Line 68:** Define a route or path that requires 'perform financial approval'.
- **Line 77:** Replace '/admin/finance/approve-transaction' with the actual path

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### source-map-support.js

- **Line 138:** un-copy these from resolve-uri; see if they can be exported from that lib
- **Line 392:** Remove now that windows path support was added to resolve-uri and thus trace-mapping?
- **Line 629:** is there a better way to reliably get an instance of NodeError?

### api.js

- **Line 540:** Throw more verbose error
- **Line 850:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 908:** Maybe move elsewhere?

### formatter.js

- **Line 10:** add [additonal formatters][1]

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 94:** Add `EventEmitter` close

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### indent.js

- **Line 304:** This is invalid, there can be more than one extends in interface

### no-inferrable-types.js

- **Line 131:** - if we add more references

### no-mixed-enums.js

- **Line 144:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-type-arguments.js

- **Line 68:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 247:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 160:** - we could break down the spread and compare the array type against each argument
- **Line 198:** - handle generic iterable case

### no-unused-vars.js

- **Line 397:** ######

### analyzeChain.js

- **Line 163:** - we could further reduce the false-positive rate of this check by
- **Line 376:** - #7170

### compareNodes.js

- **Line 135:** - handle this once TS supports it (https://github.com/microsoft/TypeScript/issues/42734)

### strict-boolean-expressions.js

- **Line 474:** we have to compare to 0n if the type is bigint
- **Line 479:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 120:** Do we need to investigate the precedence here?
- **Line 153:** JSXElement?

### getContextualType.js

- **Line 62:** - support return statement checking

### isUnsafeAssignment.js

- **Line 65:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 23:** - delete this in next major

### convert.js

- **Line 1657:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 56:** Support Windows CRLF

### createProjectService.js

- **Line 10:** Once we drop support for TS<5.3 we can import from "typescript" directly
- **Line 12:** see getWatchProgramsForProjects

### getWatchProgramsForProjects.js

- **Line 201:** file issue on TypeScript to suggest making optional?
- **Line 258:** this needs refinement and development, but we're allowing users to opt-in to this for now for testing and feedback.

### context.js

- **Line 5:** Use `SourceCode#getAncestors` (we'll be forced to soon)
- **Line 24:** Use `SourceCode#getScope` (we'll be forced to soon)

### RuleCreator.js

- **Line 13:** - when the above PR lands; add type checking for the context.report `data` property

### SourceCode.d.ts

- **Line 279:** rename to 'tokens'

### index.js

- **Line 3:** remove this in the next major version

### constants.js

- **Line 3:** increment this version if there are schema changes

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### index.js

- **Line 119:** this is not equal to path-normalize module - investigate why

### fsevents-handler.js

- **Line 15:** real check
- **Line 503:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-

### nodefs-handler.js

- **Line 36:** emit errors properly. Example: EMFILE on Macos.

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### browser.js

- **Line 111:** add a `localStorage` variable to explicitly enable/disable colors

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### eslint-plugin-prettier.js

- **Line 73:** Only use property when our eslint peerDependency is >=8.40.0.

### referencer.js

- **Line 621:** ExportDeclaration doesn't exist. for bc?
- **Line 640:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1021:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 694:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1228:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### doc.js

- **Line 1246:** Remove this in v4

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### range.js

- **Line 489:** build?

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### index.js

- **Line 1237:** handle type-only imports
- **Line 1354:** this actually references a parameter

### init.js

- **Line 5:** see what's the best path for this

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### node-internal-modules-cjs-helpers.js

- **Line 20:** Use this set when resolving pkg#exports conditions in loader.js.

### node-internal-modules-esm-resolve.js

- **Line 92:** receive cached fs implementations here

### node-options.js

- **Line 50:** handle errors somehow

### bin.js

- **Line 454:** this comes from BootstrapState

### configuration.js

- **Line 303:** technically, outDir is absolute path, but exclude should be relative glob pattern?
- **Line 304:** compute baseUrl

### esm.js

- **Line 103:** file://./foo sets `hostname` to `'.'`.  Perhaps we should special-case this.

### index.js

- **Line 227:** switch to getCanonicalFileName we already create later in scope
- **Line 390:** ordering of this with getScriptVersion?  Should they sync up?

### repl.js

- **Line 126:** Figure out how to handle completion here.
- **Line 156:** should evalCode API get the same error-handling benefits?
- **Line 203:** assert that `service` is set; remove all `service!` non-null assertions

### resolver-functions.js

- **Line 101:** consider using `ts.loadWithTypeDirectiveCache`

### swc.js

- **Line 107:** cache the results of this; slightly faster

### util.js

- **Line 135:** technically breaks if projectOption is path to a file, not a directory,

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### typescript.js

- **Line 13781:** don't use slice
- **Line 19811:** Should prefix `++` and `--` be moved to the `Update` precedence?
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### uri.all.js

- **Line 1013:** normalize IPv6 address as per RFC 5952

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### drupal.ts

- **Line 8:** Current implementation has 22.22% test coverage despite having a test file

### express.ts

- **Line 6:** This file has 33.33% test coverage. The test file expressAdapter.test.ts

### koa.ts

- **Line 6:** This file has 33.33% test coverage. The test file koaAdapter.test.ts

### auditLogger.ts

- **Line 7:** This class has 2.42% test coverage but comprehensive tests in auditLogger.test.ts.

### complianceFramework.ts

- **Line 7:** Current implementation has 0% test coverage. Tests in complianceFramework.test.ts

### dataSeparation.ts

- **Line 7:** Current implementation has 1.69% test coverage despite having comprehensive

### industryCompliance.ts

- **Line 28:** [llmcli] Add OpenAPI contract test for framework initialization endpoint (if exposed).
- **Line 29:** [llmcli] Add integration test for framework registration logic.
- **Line 30:** [llmcli] Log initialization events for audit.
- **Line 31:** [llmcli] Refactor to use typed response per OpenAPI (if applicable).
- **Line 32:** [llmcli] Add contract test for error scenarios.

### policyEngine.ts

- **Line 7:** Current implementation has 1.74% test coverage despite comprehensive

### securityAlert.ts

- **Line 7:** Current implementation has 12.5% test coverage despite having tests

## XXX Items (11)

### browser.js

- **Line 209:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 280:** DO NOT USE. This is a temporary stub function.
- **Line 281:** It WILL be removed in the next major release.

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### ast.js

- **Line 483:** abstract out this map method

### preload.js

- **Line 3:** remove in v8 or beyond

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

