-- LLM Platform Sample Data
-- Version: 1.0.0
-- Populating Models and ModelVersions tables with sample data

START TRANSACTION;

-- Insert sample data into Models table
INSERT INTO models (name, provider, base_model, description, capabilities, is_active) VALUES
(
    'claude-3-sonnet',
    'Anthropic',
    'claude-3',
    'Anthropic Claude 3 Sonnet - Balanced model for a wide range of tasks',
    '{"vision": true, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'claude-3-opus',
    'Anthropic',
    'claude-3',
    'Anthropic Claude 3 Opus - Most powerful Claude model for complex tasks',
    '{"vision": true, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'claude-3-haiku',
    'Anthropic',
    'claude-3',
    'Anthropic Claude 3 Haiku - Fast and cost-effective model for simpler tasks',
    '{"vision": true, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'gpt-4o',
    'OpenAI',
    'gpt-4',
    'OpenAI GPT-4o - Multimodal model with optimal balance of intelligence and speed',
    '{"vision": true, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'gpt-4-turbo',
    'OpenAI',
    'gpt-4',
    'OpenAI GPT-4 Turbo - Fast and powerful language model',
    '{"vision": true, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'gpt-3.5-turbo',
    'OpenAI',
    'gpt-3.5',
    'OpenAI GPT-3.5 Turbo - Cost-effective model for simpler tasks',
    '{"vision": false, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'text-embedding-ada-002',
    'OpenAI',
    'ada',
    'OpenAI Text Embedding Ada 002 - Efficient text embedding model',
    '{"vision": false, "streaming": false, "function_calling": false, "json_mode": false, "embeddings": true}',
    true
),
(
    'mistral-large',
    'Mistral AI',
    'mistral',
    'Mistral Large - Most powerful model from Mistral AI',
    '{"vision": false, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'mistral-medium',
    'Mistral AI',
    'mistral',
    'Mistral Medium - Balanced model for a wide range of tasks',
    '{"vision": false, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
),
(
    'mistral-small',
    'Mistral AI',
    'mistral',
    'Mistral Small - Fast and cost-effective model',
    '{"vision": false, "streaming": true, "function_calling": true, "json_mode": true, "embeddings": false}',
    true
);

-- Insert sample data into ModelVersions table
INSERT INTO model_versions (model_id, version, parameters, context_window, input_token_cost, output_token_cost, is_default) VALUES
-- Claude 3 Sonnet
(1, '1.0', 100000000000, 200000, 0.000003, 0.000015, false),
(1, '1.1', 100000000000, 200000, 0.000003, 0.000015, true),

-- Claude 3 Opus
(2, '1.0', 175000000000, 200000, 0.000015, 0.000075, false),
(2, '1.1', 175000000000, 200000, 0.000015, 0.000075, true),

-- Claude 3 Haiku
(3, '1.0', 75000000000, 200000, 0.000001, 0.000005, false),
(3, '1.1', 75000000000, 200000, 0.000001, 0.000005, true),

-- GPT-4o
(4, '1.0', 250000000000, 128000, 0.000005, 0.000015, true),

-- GPT-4 Turbo
(5, '2023-12-01', 175000000000, 128000, 0.000010, 0.000030, false),
(5, '2024-04-09', 175000000000, 128000, 0.000010, 0.000030, true),

-- GPT-3.5 Turbo
(6, '2023-12-01', 13000000000, 16385, 0.0000005, 0.0000015, false),
(6, '2024-04-09', 13000000000, 16385, 0.0000005, 0.0000015, true),

-- Embedding Ada
(7, '002', 1800000000, 8191, 0.0000001, 0.0000001, true),

-- Mistral Large
(8, '2024-04', 32000000000, 32768, 0.000008, 0.000024, true),

-- Mistral Medium
(9, '2024-04', 16000000000, 32768, 0.000003, 0.000009, true),

-- Mistral Small
(10, '2024-04', 8000000000, 32768, 0.000001, 0.000003, true);

COMMIT;