---
id: development
---
# TODOs for Development Workflow

- [ ] Remove all hardcoded local paths from scripts and configs; use environment variables or npm packages instead.
- [ ] Audit all imports and ensure all dependencies are managed via npm and listed in `package.json`.
- [ ] Standardize configuration management and document all required environment variables.
- [ ] Add/expand tests for all new and existing features, following TDD.
- [ ] Enforce OpenAPI validation for all new and existing endpoints.
- [ ] Integrate security checks and observability hooks in all new code.
- [ ] Ensure all development scripts and workflows are validated in CI/CD.
- [ ] Update developer documentation and add usage examples for all new features.

--- 
