---
id: integration
---
# Module Integration Documentation

This section contains documentation related to module integration patterns, code quality standards, and architectural guidelines.

## Table of Contents

### Integration Standards

- [Integration Summary](summary) - Overview of module integration strategies
- [Integration Patterns](patterns) - Common integration patterns used across modules
- [Integration Code Quality](code-quality) - Code quality checklist for integration points
- [Service Naming Conventions](service-naming-conventions) - Conventions for naming services and interfaces

### Architecture and Planning

- [Submodule Restructuring](submodule-restructuring) - Plan for restructuring submodules

## Module-Specific Integration Guides

Each module has its own integration documentation:

- [LLM Platform](../llm/integration)
- [AI Swarm Intelligence](../ai_swarm_intelligence/integration)
- [Field ECA Bridge](../field_eca_bridge/integration)
- [Secure Drupal](../secure_drupal/integration)
- [LangChain](../langchain/integration)
