---
id: modules-development-drupal_migration_plus-ATTRIBUTION
---
# Attribution and Credits

## Foundation Project

**Drupal Migration Plus** is built upon the excellent foundation provided by **Acquia Migrate Accelerate**.

### Acquia Migrate Accelerate

- **Project**: [Acquia Migrate Accelerate](https://www.drupal.org/project/acquia_migrate)
- **License**: GPL-2.0-or-later  
- **Copyright**: Acquia, Inc.
- **Original Repository**: <https://git.drupalcode.org/project/acquia_migrate>

### Key Architectural Concepts Inherited

The following core concepts and implementations from Acquia Migrate Accelerate form the foundation of this project:

1. **Migration Clustering System**
   - Heuristic-based migration grouping
   - Logical site builder concepts
   - Dependency resolution algorithms

2. **Migration Repository Pattern**
   - Centralized migration state management
   - Virtual initial migration concept
   - Fingerprinting and tracking system

3. **Batch Processing Framework**
   - Import/rollback/refresh operations
   - Progress tracking and error handling
   - Instantaneous batch interruption

4. **React-based User Interface**
   - Dashboard architecture
   - Real-time progress updates
   - Migration preview capabilities

5. **HTTP API Design**
   - REST endpoint patterns
   - JSON:API-style responses
   - Error handling strategies

## Original Contributors

### Acquia Engineering Team

Special recognition goes to the Acquia engineering team who created the original Acquia Migrate Accelerate:

- **Lead Architect**: Wim Leers (@wimleers)
- **Core Development Team**: Acquia migration specialists
- **Quality Assurance**: Acquia QA team
- **Product Management**: Acquia product team

### Community Contributors

Recognition for all community members who contributed to Acquia Migrate Accelerate through:

- Code contributions
- Issue reporting and testing
- Documentation improvements
- Feature requests and feedback
- Translation efforts

## Modifications and Extensions

**Drupal Migration Plus** extends the original work with:

### New Features Added

- **Multi-CMS Support**: WordPress, Joomla, and other CMS platforms
- **AI Integration**: Intelligent field mapping and content analysis
- **Self-Healing Capabilities**: Automatic adaptation to module changes
- **Recipe System**: Reusable migration patterns and templates
- **Drupal 11 Compatibility**: Modern API usage and architectural patterns

### Architectural Improvements

- **Enhanced Service Architecture**: Improved dependency injection
- **Plugin System Extensions**: More extensible heuristics and adapters
- **Event-Driven Processing**: Enhanced event system for customization
- **Performance Optimizations**: Better memory and processing efficiency

## Legal Notice

This project maintains the same GPL-2.0-or-later license as the original Acquia Migrate Accelerate project. All original copyright notices and attributions are preserved.

### Original License

```
Copyright (C) Acquia, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
```

### Extended Work License

```
Drupal Migration Plus extensions and modifications
Copyright (C) 2024 Drupal Migration Plus Team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
```

## Acknowledgments

We extend our deepest gratitude to:

1. **Acquia, Inc.** for their significant investment in Drupal migration tooling
2. **The original Acquia Migrate team** for their innovative architecture and implementation
3. **The Drupal community** for supporting and using migration tools
4. **All contributors** who have helped improve migration tooling for Drupal

## Contact

For questions about attribution or licensing:

- Project issues: <https://www.drupal.org/project/issues/drupal_migration_plus>
- Original project: <https://www.drupal.org/project/issues/acquia_migrate>

---

*This attribution document ensures proper credit to all original contributors while documenting the evolution and extension of the migration tooling ecosystem.*
