# Cursor Directory Integration

> Note: This document replaces a symlink that previously pointed to `./llm-mcp/docs/guides/cursor-directory-integration.md` which doesn't exist.

This document describes how to integrate Cursor Directory functionality with the Model Control Plane.

## Overview

The Cursor Directory integration allows the MCP to efficiently scan and index code directories for improved context retrieval and code understanding.

## Configuration

To enable Cursor Directory integration, update your MCP configuration:

```javascript
const mcp = new ModelControlPlane({
  features: {
    cursorDirectory: {
      enabled: true,
      scanInterval: 3600, // seconds
      excludePatterns: ['node_modules', '.git']
    }
  }
});
```

## Usage

Once configured, the MCP will automatically utilize the Cursor Directory for code-related queries and operations.

```javascript
// The system will automatically use cursor directory context
const result = await mcp.generateCodeCompletion({
  code: 'function calculateTotal(',
  language: 'javascript',
  useFileContext: true
});
```

For more details, see the API documentation.