# BFRFP API Reference

This document provides details about the BFRFP API endpoints and usage.

## Authentication

API requests require authentication using an API key.

## Endpoints

### RFP Analysis

````text
POST /api / analyze
```text

Analyzes an RFP document and returns structured information.

### Response Generation

```text
POST /api / generate
```text

Generates a response based on RFP analysis and templates.

### AI Completion

```text
POST /api / ai / completion
```text

Creates a completion using the AI model.

## Error Codes

- `400`: Bad Request
- `401`: Unauthorized
- `404`: Not Found
- `500`: Internal Server Error
````
