---
title: Package Information
description: NPM package details for llm-ui
sidebar_position: 99
---

# Package Information

## Basic Info
- **Name**: `@bluefly/llm-ui`
- **Version**: `0.1.6`
- **Description**: AI-powered UI components for the LLM Platform ecosystem with UI Suite integration
- **License**: MIT
- **Repository**: [GitLab](https://gitlab.bluefly.io/llm/llm-ui)

## Available Scripts
- **`npm run build`**: tsc
- **`npm run build:patterns`**: tsc && npm run export:patterns
- **`npm run export:patterns`**: npx tsx scripts/export-patterns.ts
- **`npm run dev`**: tsc --watch
- **`npm run test`**: jest
- **`npm run test:watch`**: jest --watch
- **`npm run test:coverage`**: jest --coverage
- **`npm run test:unit`**: jest --testPathPattern=unit
- **`npm run test:integration`**: jest --testPathPattern=integration
- **`npm run test:ci`**: jest --ci --coverage --maxWorkers=2
- **`npm run test:e2e`**: nightwatch --config nightwatch.conf.js
- **`npm run lint`**: eslint src --ext .ts,.tsx
- **`npm run lint:fix`**: eslint src --ext .ts,.tsx --fix
- **`npm run type-check`**: tsc --noEmit
- **`npm run docker:build`**: docker build -t registry.gitlab.bluefly.io/llm/llm-ui:latest .
- **`npm run docker:push`**: docker push registry.gitlab.bluefly.io/llm/llm-ui:latest
- **`npm run katenary:convert`**: cd ../llm-gateway && katenary convert -f deployment/katenary/docker-compose.katenary.yml -o deployment/helm-charts/llm-ui
- **`npm run katenary:deploy`**: cd ../llm-gateway && katenary deploy -f deployment/katenary/docker-compose.katenary.yml
- **`npm run k8s:generate`**: npm run docker:build && npm run katenary:convert
- **`npm run k8s:deploy`**: npm run docker:push && npm run katenary:deploy
- **`npm run deploy:staging`**: npm run k8s:generate && kubectl apply -f ../llm-gateway/deployment/helm-charts/llm-ui --namespace=llm-staging
- **`npm run deploy:production`**: npm run k8s:generate && kubectl apply -f ../llm-gateway/deployment/helm-charts/llm-ui --namespace=llm-production

## Dependencies (6)
- @chakra-ui/react
- axios
- eventemitter3
- react
- react-dom
- zod

## Dev Dependencies (16)
- @testing-library/react
- @testing-library/react-hooks
- @types/jest
- @types/node
- @types/react
- @types/react-dom
- @types/testing-library__jest-dom
- @typescript-eslint/eslint-plugin
- @typescript-eslint/parser
- eslint

... and 6 more
