# BFUI Planning Documents

This directory contains planning documents related to BFUI component library development, integration, and migration strategies.

## Contents

### Integration Plans

- [BFUI Integration Master Plan](./BFUI_INTEGRATION_MASTER_PLAN.md) - Comprehensive approach to integrate React-based BFUI components with Drupal projects
- [BFUI Integration Revised Plan](./BFUI_INTEGRATION_REVISED_PLAN.md) - Revised approach using llmcli as the integration point

### Migration Plans

- [Migration Plan](./migration-plan.md) - Structured approach to modernize the BFUI component library by migrating JavaScript to TypeScript and Chakra UI to Tailwind CSS

## Related Documents

- [Tailwind Migration Summary](/docs/tailwind-migration-summary.md) - Progress summary on the Tailwind CSS migration
- [Project-Specific Integration](/docs/integration/project-specific-integration.md) - Specific strategies for integrating BFUI with each project
- [Remaining Issues](/docs/implementation/remaining-issues.md) - Current issues and next steps for implementation

## Implementation Timeline

The general implementation timeline follows these phases:

1. **Foundation** - Setup tooling, linting, and core type definitions
2. **Component Migration** - Convert JavaScript components to TypeScript
3. **Styling Migration** - Implement Tailwind-based styling system
4. **Finalization** - Complete documentation, testing, and optimization

Refer to the individual plan documents for detailed timelines and progress tracking.