---
title: Package Information
description: NPM package details for llmcli
sidebar_position: 99
---

# Package Information

## Basic Info
- **Name**: `@bluefly/llmcli`
- **Version**: `1.0.4`
- **Description**: AI-powered CLI toolkit with TDD and multi-provider support
- **License**: MIT
- **Repository**: [GitLab](https://gitlab.bluefly.io/llm/llmcli)

## Available Scripts
- **`npm run build`**: tsc
- **`npm run dev`**: tsc --watch
- **`npm run test`**: NODE_OPTIONS=--experimental-vm-modules jest
- **`npm run test:watch`**: NODE_OPTIONS=--experimental-vm-modules jest --watch
- **`npm run test:coverage`**: NODE_OPTIONS=--experimental-vm-modules jest --coverage
- **`npm run test:ci`**: jest --ci --coverage --watchAll=false
- **`npm run test:unit`**: jest __tests__/unit
- **`npm run test:integration`**: jest __tests__/integration
- **`npm run lint`**: eslint src/**/*.ts bin/llmcli
- **`npm run lint:fix`**: eslint src/**/*.ts bin/llmcli --fix
- **`npm run typecheck`**: tsc --noEmit
- **`npm run clean`**: rm -rf dist coverage
- **`npm run prepare`**: npm run build

## Dependencies (12)
- @types/uuid
- @zilliz/milvus2-sdk-node
- axios
- chalk
- commander
- dotenv
- inquirer
- js-yaml
- openai
- ora
- uuid
- zod

## Dev Dependencies (10)
- @types/inquirer
- @types/jest
- @types/js-yaml
- @types/node
- @typescript-eslint/eslint-plugin
- @typescript-eslint/parser
- eslint
- jest
- ts-jest
- typescript

