# Secure Headers

**Purpose:**
Enforces HTTP security headers (CSP, X-Frame-Options, etc.) for Secure Drupal, providing a strong baseline for browser-based security and compliance.

## Features
- Content Security Policy (CSP)
- X-Frame-Options
- X-Content-Type-Options
- Referrer-Policy
- Strict-Transport-Security
- Extensible for additional headers

## Configuration
- Default policies are enforced out-of-the-box.
- Future: Admin UI for custom header configuration (via config schema).

## Extending
- Add or modify headers in `SecurityHeadersSubscriber.php`.
- Integrate with other Secure Drupal modules for dynamic policy adjustment.

## Compliance
- Supports NIST, FedRAMP, PCI DSS, and modern browser security standards.

## Installation
```bash
drush en secure_headers
```

## Contributing
Report security issues to [security@bluefly.io](mailto:security@bluefly.io) 