# OpenAPI Compliance Enforcer

Automates OpenAPI spec validation and compliance reporting for all custom APIs in your Drupal platform.

## Features
- Validates OpenAPI (Swagger) specs for all custom modules and endpoints
- Drush command for manual and CI/CD validation
- Admin UI for compliance status and reporting
- Integrates with Spectral and Swagger-PHP for robust validation
- GitLab CI/CD and CLI integration ready

## Usage
- Run `drush openapi:validate` to validate all OpenAPI specs
- Visit `/admin/reports/openapi-compliance` for a UI dashboard
- Integrate with your CI pipeline for automated checks

## Requirements
- Drupal 10 or 11
- Composer dependencies: `swagger-api/swagger-php`, `stoplight/spectral`, `symfony/yaml`

## Roadmap
- Automated remediation suggestions
- Integration with platform-wide compliance dashboards
- API endpoint for remote validation 