---
title: Package Information
description: NPM package details for secure-project
sidebar_position: 99
---

# Package Information

## Basic Info
- **Name**: `@bluefly/secure-project`
- **Version**: `0.1.4`
- **Description**: SAST-enhanced government compliance security analysis for LLM Platform LLM ecosystem
- **License**: MIT
- **Repository**: [GitLab](https://gitlab.bluefly.io/llm/secure-project)

## Available Scripts
- **`npm run build`**: tsc
- **`npm run build:minimal`**: tsc --project tsconfig.minimal.json
- **`npm run bridge`**: node scripts/bridge-production.js http
- **`npm run bridge:process`**: node scripts/bridge-production.js process
- **`npm run bridge:minimal`**: node scripts/bridge-minimal.js http
- **`npm run bridge:minimal:process`**: node scripts/bridge-minimal.js process
- **`npm run bridge:health`**: node scripts/bridge-production.js health
- **`npm run bridge:minimal:health`**: node scripts/bridge-minimal.js health
- **`npm run test`**: jest
- **`npm run test:watch`**: jest --watch
- **`npm run test:coverage`**: jest --coverage
- **`npm run test:unit`**: jest --testPathPattern=__tests__/unit
- **`npm run test:integration`**: jest --testPathPattern=__tests__/integration
- **`npm run test:ci`**: jest --ci --coverage --watchAll=false
- **`npm run test:debug`**: jest --detectOpenHandles --forceExit
- **`npm run test:e2e`**: nightwatch --config nightwatch.conf.js
- **`npm run typecheck`**: tsc --noEmit
- **`npm run lint`**: eslint src --ext .ts
- **`npm run lint:fix`**: eslint src --ext .ts --fix

## Dependencies (5)
- express
- uuid
- js-yaml
- jsonwebtoken
- pg

## Dev Dependencies (13)
- @jest/globals
- @types/express
- @types/jest
- @types/js-yaml
- @types/node
- @types/uuid
- @types/jsonwebtoken
- @types/pg
- jest
- jest-environment-node

... and 3 more
