// Nightwatch E2E: Secure Drupal Audit Log Review

module.exports = {
  '@tags': ['secure_drupal', 'audit_log', 'compliance'],

  'Review and Validate Audit Logs': function (browser) {
    // 1. Log in as admin
    browser
      .drupalLogin({username: 'admin', password: 'admin'});

    // 2. Visit Audit Log page
    browser
      .url(browser.launchUrl + '/admin/reports/audit-log')
      .waitForElementVisible('body', 2000)
      .assert.containsText('body', 'Audit Log')
      .assert.containsText('body', 'User')
      .assert.containsText('body', 'Action')
      .assert.containsText('body', 'Timestamp');

    // 3. Check for recent admin actions
    browser
      .assert.containsText('body', 'admin')
      .assert.containsText('body', 'Logged in')
      .assert.containsText('body', 'Changed configuration');

    browser.end();
  }
};