// Nightwatch E2E: Secure Drupal Auto-Logout Functionality

module.exports = {
  '@tags': ['secure_drupal', 'autologout', 'security'],

  'Test Auto-Logout After Inactivity': function (browser) {
    // 1. Log in as admin
    browser
      .drupalLogin({username: 'admin', password: 'admin'});

    // 2. Visit Autologout configuration page
    browser
      .url(browser.launchUrl + '/admin/config/people/autologout')
      .waitForElementVisible('form', 2000)
      .assert.containsText('body', 'Auto Logout')
      .setValue('input[name="timeout"]', '1') // Set timeout to 1 minute for test
      .click('input#edit-submit')
      .waitForElementVisible('.messages--status', 2000)
      .assert.containsText('.messages--status', 'The configuration options have been saved');

    // 3. Wait for 70 seconds to trigger auto-logout
    browser
      .pause(70000)
      .url(browser.launchUrl + '/admin')
      .waitForElementVisible('form#user-login-form', 5000)
      .assert.containsText('body', 'You have been logged out due to inactivity');

    browser.end();
  }
};