// Nightwatch E2E: Secure Drupal GDPR and Encryption Configuration

module.exports = {
  '@tags': ['secure_drupal', 'gdpr', 'encryption', 'privacy'],

  'Configure and Validate GDPR and Encryption Settings': function (browser) {
    // 1. Log in as admin
    browser
      .drupalLogin({username: 'admin', password: 'admin'});

    // 2. Visit GDPR configuration page
    browser
      .url(browser.launchUrl + '/admin/config/system/gdpr')
      .waitForElementVisible('form', 2000)
      .assert.containsText('body', 'GDPR Compliance')
      .setValue('input[name="gdpr_enabled"]', true)
      .click('input#edit-submit')
      .waitForElementVisible('.messages--status', 2000)
      .assert.containsText('.messages--status', 'The configuration options have been saved');

    // 3. Visit Encryption configuration page
    browser
      .url(browser.launchUrl + '/admin/config/system/encrypt')
      .waitForElementVisible('form', 2000)
      .assert.containsText('body', 'Encryption Settings')
      .setValue('input[name="encryption_enabled"]', true)
      .click('input#edit-submit')
      .waitForElementVisible('.messages--status', 2000)
      .assert.containsText('.messages--status', 'The configuration options have been saved');

    browser.end();
  }
};