module.exports = {
  'Anonymous user cannot access Secure Drupal recipe admin pages': function (browser) {
    const pages = [
      '/admin/recipes/secure-drupal',
      '/admin/recipes/secure-drupal/config'
    ];
    pages.forEach(path => {
      browser
        .url(browser.launchUrl + path)
        .waitForElementVisible('body', 1000)
        .assert.containsText('body', 'Access denied');
    });
  },

  'Admin user can access all Secure Drupal recipe admin pages': function (browser) {
    const pages = [
      { path: '/admin/recipes/secure-drupal', title: 'Secure Drupal Recipes' },
      { path: '/admin/recipes/secure-drupal/config', title: 'Secure Drupal Configuration' }
    ];
    browser.loginAsAdmin();
    pages.forEach(page => {
      browser
        .url(browser.launchUrl + page.path)
        .waitForElementVisible('body', 1000)
        .assert.containsText('body', page.title);
    });
    browser.logout();
  }
}; 