# ReelCode Standards Validation

## Summary

- **Files Validated**: [totalFiles]
- **Valid Files**: [validFiles]
- **Invalid Files**: [invalidFiles]
- **Total Errors**: [totalErrors]
- **Total Warnings**: [totalWarnings]

[#if valid]
 **All files pass standards validation!**
[else]
❌ **Standards validation failed!**
[/if]

## Validation Results

[#if errors]
### Errors

| File | Rule | Message | Line |
|------|------|---------|------|
[#each errors]
| `[filePath]` | [rule] | Message | [line] |
[/each]
[/if]

[#if warnings]
### Warnings

| File | Rule | Message | Line |
|------|------|---------|------|
[#each warnings]
| `[filePath]` | [rule] | Message | [line] |
[/each]
[/if]

## Standards Info

- **Standards Version**: [standards.version]
- **Project ID**: [standards.projectId]

## How to Fix

1. Run `tddai validate file <file-path>` locally to see detailed error information
2. Fix the issues according to the project standards
3. Run validation again to verify the fixes

For more information, see the [ReelCode documentation](https://github.com/bluefly/tddai/blob/main/README.md).