const express = require('express');
const router = express.Router();
const modelController = require('../controllers/modelController');
const { authenticate } = require('../middleware/auth');
const { standardLimiter } = require('../middleware/rateLimit');
const { validate } = require('../middleware/validation');

// Apply authentication and rate limiting to all routes
router.use(authenticate, standardLimiter);

// GET /models - List models with optional filtering
router.get('/', validate('listModels'), modelController.getModels);

// GET /models/:id - Get a model by ID
router.get('/:id', modelController.getModelById);

module.exports = router;