// @ts-check

/** @type {import('@docusaurus/plugin-content-docs').SidebarsConfig} */
const sidebars = {
  tutorialSidebar: [
    // Main documentation hub
    {
      type: 'doc',
      id: 'index',
      label: '🏠 Documentation Hub',
    },


    // NPM Packages - Only the main packages
    {
      type: 'category',
      label: '📦 NPM Packages',
      collapsed: false,
      items: [
        {
          type: 'doc',
          id: 'packages/llm-gateway/index',
          label: '🚀 LLM Gateway',
        },
        {
          type: 'doc',
          id: 'packages/llm-gateway-sdk/index',
          label: '🔗 Gateway SDK',
        },
        {
          type: 'doc',
          id: 'packages/llm-mcp/index',
          label: '🤖 MCP Server',
        },
        {
          type: 'doc',
          id: 'packages/apple-fm/index',
          label: '🍎 Apple Foundation Models',
        },
        {
          type: 'doc',
          id: 'packages/bfrfp/index',
          label: '📄 RFP Generator',
        },
        {
          type: 'doc',
          id: 'packages/tddai/index',
          label: '🧪 TDD AI Framework',
        },
        {
          type: 'doc',
          id: 'packages/llmcli/index',
          label: '⚡ CLI Tools',
        },
        {
          type: 'doc',
          id: 'packages/llm-ui/index',
          label: '🎨 UI Components',
        },
        {
          type: 'doc',
          id: 'packages/secure-project/index',
          label: '🔒 Security Project',
        },
      ],
    },

    // AI Models
    {
      type: 'category',
      label: '🤖 AI Models',
      collapsed: true,
      items: [
        {
          type: 'doc',
          id: 'models/tddai-model/index',
          label: 'TDDAI Model',
        },
      ],
    },

    // CI/CD Components
    {
      type: 'category',
      label: '🔧 CI/CD Components',
      collapsed: true,
      items: [
        {
          type: 'doc',
          id: 'cicd/bfcicomponents/index',
          label: 'BF CI Components',
        },
      ],
    },
  ],
};

module.exports = sidebars;
