# Roadmap

_Generated on 2025-05-30_

Found 3144 TODO items in the codebase.

## BUG Items (8)

### index.js

- **Line 12:** 1: Safari 10/11 doesn't reliably return the same Strings value.
- **Line 18:** 2: Safari 10/11 use the same cached strings value when the string parts are the same.

### subchannel-call.js

- **Line 209:** reports indicate that Node synthesizes a NGHTTP2_CANCEL

### dns.d.ts

- **Line 114:** in the name resolution service used by the operating system.

### index.js

- **Line 60:** in Node.js <6.3.1, which treats this as out-of-bounds

### mocha.js

- **Line 13384:** in node.  Should never happen.

### inspect.js

- **Line 97:** with user-supplied inspect function returns non-string

### test-buffer.js

- **Line 443:** regression test

## FIXME Items (34)

### lint.js

- **Line 40:** preprocessors can modify nodes which are then cached to ajv-instance by absolute path

### domains.js

- **Line 17:** temporary fix for our lab environments

### index.js

- **Line 118:** backward compatibility, remove on 1.0.0

### no-unused-components.js

- **Line 41:** find a better way to detect possible discriminator

### resolve-plugins.test.ts

- **Line 4:** skipping due to the 'Test environment has been torn down' Jest error.

### built-in-definitions.js

- **Line 206:** Pure disabled to work around zloirock/core-js#262.

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### referencer.js

- **Line 62:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### node.js

- **Line 200:** Should probably have an option in net.Socket to create a
- **Line 208:** Hack to have stream not keep the event loop alive.

### haml.js

- **Line 20:** these comments should be allowed to span indented lines

### less.js

- **Line 490:** it does not include dot for numbers like .5em :(

### r.js

- **Line 50:** Support Unicode identifiers.

### hook.js

- **Line 11:** Typescript extensions are added temporarily until we find a better

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

### profile.js

- **Line 201:** Work around to not clear everything other than what we're setting

### query.js

- **Line 92:** Workspace support in query does not work as expected so this does not

### index.js

- **Line 52:** HACK

### perfect-scrollbar.common.js

- **Line 787:** this is a workaround for <select> issue in FF and IE #571

### prism-less.js

- **Line 1:** :

### prism-matlab.js

- **Line 10:** We could handle imaginary numbers as a whole

### prism-perl.js

- **Line 51:** Multi-line single-quoted strings are not supported as they would break variables containing '
- **Line 120:** Not sure about the handling of ::, ', and #

### prism-prolog.js

- **Line 13:** Should we list all null-ary predicates (not followed by a parenthesis) like halt, trace, etc.?

### prism-pure.js

- **Line 49:** How can we prevent | and , to be highlighted as operator when they are used alone?

### prism-wiki.js

- **Line 44:** Nested structures should be handled

### create-hash.js

- **Line 4:** test binary

### oas-validate.js

- **Line 168:** dropped 'noRefs:true' here

### dispatcher-weakref.js

- **Line 36:** remove workaround when the Node bug is fixed

### tsserverlibrary.js

- **Line 148700:** getter and setter use the same symbol. And it is rare to use only setter without getter, so in most cases the symbol always has getter flag.

## HACK Items (33)

### multipart.js

- **Line 102:** because streams2 _always_ doesn't emit 'end' until nextTick, so let

### extend-error.js

- **Line 58:** We have to cast the errors to `any` so we can use symbol indexers.

### isomorphic.node.js

- **Line 27:** We have to cast the objects to `any` so we can use symbol indexers.

### Observable.ts

- **Line 43:** Since TypeScript inherits static properties too, we have to

### openapi.request.validator.js

- **Line 89:** for express 5, temporarily make req.query mutable
- **Line 107:** for express 5, Restore the original descriptor

### node.js

- **Line 178:** to have stream not keep the event loop alive.

### capnproto.js

- **Line 45:** eating everything after the first title

### htmlbars.js

- **Line 337:** This lets handlebars do the auto-detection if it's been loaded (by

### qml.js

- **Line 213:** prevents detection of keywords after dots

### stan.js

- **Line 507:** in range constraints, lower must follow "<"
- **Line 512:** in range constraints, upper must follow either , or <

### typescript.js

- **Line 556:** prevents detection of keywords in some circumstances

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### mocha.js

- **Line 14132:** to fix a circular dependency issue when used with browserify

### display.js

- **Line 319:** Check if the argument looks like a run-script banner. This can be

### index.js

- **Line 650:** this is an option set in tests to stop the local prefix from being set

### index.ts

- **Line 173:** sometimes subschemas contain only a single SchemaObject or ParameterObject and get incorrectly hinted

### OpenApi.ts

- **Line 78:** for allowing ISpecificationExtension

### prism-line-highlight.js

- **Line 290:** to limit the number of times applyHash() runs

### prism.js

- **Line 230:** to trip TS' flow analysis */) {
- **Line 1216:** for components to work correctly in node.js

### index.js

- **Line 17:** an instance of Argv with process.argv into Argv

### AsyncAction.ts

- **Line 122:** Since code elsewhere is relying on the "truthiness" of the

### QueueAction.ts

- **Line 38:** In the past, this was returning `void`. However, `void` isn't a valid

### types.ts

- **Line 337:** As of TS 4.2.2, The provided types for the iterator results of a `ReadableStreamDefaultReader`

### styled-components.native.cjs.js

- **Line 1976:** for first rule in CSS

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

### runmain-hack.js

- **Line 3:** to avoid Module.runMain on node 18.6.0

### bin.js

- **Line 59:** technically, this function is not marked @internal so it's possible
- **Line 462:** workaround node regression

### tsserverlibrary.js

- **Line 170214:** 1"
- **Line 170218:** 1", "// ", "hack   1", undefined, "hack"]

## NOTE Items (1123)

### alerting-rules.test.js

- **Line 220:** This test would need actual Slack webhook testing in real environment

### performance-baseline.test.js

- **Line 217:** This assertion would be conditional on load testing

### index.js

- **Line 97:** According to the JSON Reference spec, these should already be URLs,

### resolve-external.js

- **Line 48:** We only care about EXTERNAL references here. INTERNAL references are only relevant when dereferencing.

### bundle.js

- **Line 14:** lazy-load SwaggerParser, so the CLI can set the env.DEBUG variable first

### action_container.js

- **Line 321:** if add_mutually_exclusive_group ever gains title= and

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### js-yaml.js

- **Line 443:** line breaking/folding is implemented for only the folded style.
- **Line 462:** that this implies
- **Line 501:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 514:** a long line without a suitable break point will exceed the width limit.
- **Line 557:** the match index will always be <= length-2.
- **Line 2838:** JS-YAML does not support schema-specific tag resolution restrictions.

### index.js

- **Line 133:** This is safe to do, because we haven't dereferenced circular $refs yet

### inline-callSuper-helpers.js

- **Line 43:** This doesn't work if this.__proto__.constructor has been modified.

### index.js

- **Line 11:** contrary to various Github issues, Edge 16+ *does* correctly infer the name of Arrow Functions.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### ajv.bundle.js

- **Line 6413:** We do not parse query strings for HTTP URIs

### compile.js

- **Line 810:** would it be useful to also check if it's a string?
- **Line 1048:** that this _might_ e.g. remove all elements of an array in a 2nd branch _and_ fail with `const: []` in the 1st, but that's expected behavior

### formats.js

- **Line 5:** that quoted emails are deliberately unsupported (as in ajv), who would want \x01 in email

### javascript.js

- **Line 94:** that /^.*$/u.test('\n') is false, so don't combine .* with anchors here!

### main.d.ts

- **Line 146:** if you listen for this event, you should always handle the `stream` no matter if you care about the

### constants.js

- **Line 48:** This enum is not currently used in any implemented API in this

### load-balancer-child-handler.js

- **Line 133:** state updates are only propagated from the child balancer if that

### metadata.js

- **Line 175:** Node <8.9 formats http2 headers incorrectly.

### server-interceptors.js

- **Line 486:** response compression is currently not supported, so this

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### extend-error.js

- **Line 54:** We specifically exclude properties that we have already set on the new error.

### index.js

- **Line 10:** this method is only supported in non-web environments

### chat_models.d.ts

- **Line 56:** Not all providers support tool_choice. An error will be thrown

### graph.js

- **Line 133:** this doesn't check for duplicates, nor does it connect the graphs.

### sax.js

- **Line 752:** do not apply default ns to attributes:

### types.d.ts

- **Line 145:** that some options, like reasoning summaries, are only available when using the responses

### text_splitter.js

- **Line 534:** the alternative syntax for headings (below) is not handled here
- **Line 543:** that this splitter doesn't handle horizontal lines defined

### configurable-module-host.interface.d.ts

- **Line 32:** this property is not supposed to be used as a value.

### class-serializer.interceptor.js

- **Line 12:** (external)

### console-logger.service.d.ts

- **Line 13:** This option is not used when `json` is enabled.

### discoverable-meta-host-collection.js

- **Line 69:** Regarding the ternary statement below,

### repl-native-commands.js

- **Line 28:** If the command was retrieve from the context, it will have a `help`

### _md.js

- **Line 99:** sha512 requires length to be 128bit integer, but length in JS will overflow before that
- **Line 106:** we do division by 4 later, which should be fused in single op with modulo by JIT

### blake1.js

- **Line 215:** we cannot re-use compress from blake2s, since there is additional xor over u256[SIGMA[e]]

### blake2.js

- **Line 20:** V is LE here

### eskdf.js

- **Line 57:** that length here also repeats two lines below

### hkdf.js

- **Line 17:** some libraries treat zero-length array as 'not provided';

### sha3-addons.js

- **Line 18:** it is safe to use bigints here, since they used only for length encoding (not actual data).
- **Line 46:** second modulo is necessary since we don't need to add padding if current element takes whole block

### sha3.js

- **Line 51:** all indices are x2 since we store state as u32 instead of u64 (bigints to slow in js)
- **Line 96:** we accept arguments in bytes instead of bits here.

### types.d.ts

- **Line 441:** With [pagination](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
- **Line 738:** that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
- **Line 778:** ** This endpoint is only available to organizations with access to the enhanced billing platform. For more information, see "[About the enhanced billing platform](https://docs.github.com/billing/using-the-new-billing-platform)."
- **Line 3091:** that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 3150:** ** To prevent leaking sensitive information, the `bypass_actors` property is only returned if the user
- **Line 5075:** ** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
- **Line 5645:** that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 8042:** If making a request on behalf of a GitHub App you must also have permissions to write the contents of the head repository.
- **Line 8480:** there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
- **Line 9057:** **
- **Line 9192:** ** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
- **Line 9981:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of users.
- **Line 86398:** ** A parameter can override this parameter. See `members_allowed_repository_creation_type` in this table for details.
- **Line 86410:** ** This parameter is closing down and will be removed in the future. Its return value ignores internal repositories. Using this parameter overrides values set in `members_can_create_repositories`. See the parameter deprecation notice in the operation description for details.
- **Line 93781:** ** If you're creating a repository in an organization that has disabled repository projects, the default is `false`, and if you pass `true`, the API returns an error.
- **Line 100520:** ** Providing `conclusion` will automatically set the `status` parameter to `completed`. You cannot change a check run conclusion to `stale`, only GitHub can set this.
- **Line 105563:** ** Use either `tree.sha` or `content` to specify the contents of the entry. Using both `tree.sha` and `content` will return an error.
- **Line 110565:** ** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a hypermedia resource. For more information, see "[Getting started with the REST API](https://docs.github.com/rest/using-the-rest-api/getting-started-with-the-rest-api#hypermedia)."
- **Line 112101:** ** Topic `names` will be saved as lowercase.
- **Line 114779:** ** Alternatively, you can pass a single email address or an `array` of emails addresses directly, but we recommend that you pass an object using the `emails` key.

### Attributes.d.ts

- **Line 4:** only the own enumerable keys are counted as valid attribute keys.

### utils.js

- **Line 28:** we intentionally don't URI-encode the metadata - that responsibility falls on the metadata implementation

### environment.js

- **Line 64:** falling back to `false` instead of `undefined` as required by the specification.

### bedrock-runtime.js

- **Line 188:** We approximate the token count since this value is not directly available in the body

### instrumentation.js

- **Line 45:** If the Pino logger is configured with `nestedKey`, then

### log-sending-utils.js

- **Line 126:** A PINO_CONFIG event was added to pino (2024-04-04) to send config

### utils.js

- **Line 22:** that both of those functions are sync

### SemanticAttributes.js

- **Line 28:** The `error.type` SHOULD be predictable and SHOULD have low cardinality.
- **Line 52:** HTTP request method value SHOULD be &#34;known&#34; to the instrumentation.
- **Line 75:** The resend count SHOULD be updated each time an HTTP request gets resent by the client, regardless of what was the cause of the resending (e.g. redirection, authorization failure, 503 Server Unavailable, network issues, or any other).
- **Line 89:** MUST NOT be populated when this is not supported by the HTTP server framework as the route attribute should have low-cardinality and the URI path can NOT substitute it.
- **Line 104:** The value SHOULD be normalized to lowercase.
- **Line 110:** `network.protocol.version` refers to the version of the protocol used and might be different from the protocol client&#39;s version. If the HTTP client has a version of `0.27.2`, but sends HTTP version `1.1`, this attribute should be set to `1.1`.
- **Line 116:** When observed from the client side, and when communicating through an intermediary, `server.address` SHOULD represent the server address behind any intermediaries, for example proxies, if it&#39;s available.
- **Line 122:** When observed from the client side, and when communicating through an intermediary, `server.port` SHOULD represent the server port behind any intermediaries, for example proxies, if it&#39;s available.
- **Line 128:** For network calls, URL usually has `scheme://host[:port][path][?query][#fragment]` format, where the fragment is not transmitted over HTTP, but if it is known, it SHOULD be included nevertheless.
- **Line 140:** Sensitive content provided in query string SHOULD be scrubbed when instrumentations can identify it.

### undici.js

- **Line 306:** server errors are considered valid responses and it's the lib consumer
- **Line 314:** in `undici@6.3.0` when request aborted the error type changes from

### otlp-grpc-env-configuration.js

- **Line 138:** the spec does not make any exception for

### grpc-exporter-transport.d.ts

- **Line 12:** Ensure that you're only importing/requiring gRPC inside the function providing the channel credentials,
- **Line 21:** Ensure that you're only importing/requiring gRPC inside the function providing the metadata,

### ConsoleLogRecordExporter.js

- **Line 22:** This {@link LogRecordExporter} is intended for diagnostics use only, output rendered to the console may change at any time.

### util.js

- **Line 17:** other languages provide this as a built in function. This is

### ExponentialHistogram.js

- **Line 345:** this should be impossible. If we get here it's because

### types.d.ts

- **Line 25:** that we'll always have n+1 buckets, where n is the number of boundaries.

### ConsoleMetricExporter.d.ts

- **Line 13:** This [@link PushMetricExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### AsyncMetricStorage.d.ts

- **Line 27:** This is a stateful operation and may reset any interval-related

### ConsoleSpanExporter.d.ts

- **Line 8:** This [@link SpanExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### SimpleSpanProcessor.d.ts

- **Line 12:** This [@link SpanProcessor] exports every ended span individually instead of batching spans together, which causes significant performance overhead with most exporters. For production use, please consider using the [@link BatchSpanProcessor] instead.

### experimental_metrics.js

- **Line 1654:** that the total slab memory is not constant and may vary over time.

### SemanticResourceAttributes.d.ts

- **Line 22:** Availability zones are called &#34;zones&#34; on Alibaba Cloud and Google Cloud.
- **Line 30:** The prefix of the service SHOULD match the one specified in `cloud.provider`.
- **Line 80:** Multiple log groups must be supported for cases like multi-container applications, where a single application has sidecar containers, and each write to their own log group.
- **Line 88:** See the [log group ARN format documentation](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/iam-access-control-overview-cwl.html#CWL_ARN_Format).
- **Line 102:** See the [log stream ARN format documentation](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/iam-access-control-overview-cwl.html#CWL_ARN_Format). One log group can contain several log streams, so these ARNs necessarily identify both a log group and a log stream.
- **Line 146:** The device identifier MUST only be defined using the values outlined below. This value is not an advertising identifier and MUST NOT be used as such. On iOS (Swift or Objective-C), this value MUST be equal to the [vendor identifier](https://developer.apple.com/documentation/uikit/uidevice/1620059-identifierforvendor). On Android (Java or Kotlin), this value MUST be equal to the Firebase Installation ID or a globally unique UUID which is persisted across sessions in your application. More information can be found [here](https://developer.android.com/training/articles/user-data-ids) on best practices and exact implementation details. Caution should be taken when storing personal data or anything which can identify a user. GDPR and data protection laws may apply, ensure you do your own due diligence.
- **Line 154:** It&#39;s recommended this value represents a machine readable version of the model identifier rather than the market or consumer-friendly name of the device.
- **Line 162:** It&#39;s recommended this value represents a human readable version of the device model rather than a machine readable alternative.
- **Line 170:** This is the name of the function as configured/deployed on the FaaS platform and is usually different from the name of the callback function (which may be stored in the [`code.namespace`/`code.function`](../../trace/semantic_conventions/span-general.md#source-code-attributes) span attributes).
- **Line 178:** Depending on the cloud provider, use:
- **Line 199:** Depending on the cloud provider and platform, use:
- **Line 215:** * **AWS Lambda:** Use the (full) log stream name.
- **Line 223:** It&#39;s recommended to set this attribute since e.g. too little memory can easily stop a Java AWS Lambda function from working correctly. On AWS Lambda, the environment variable `AWS_LAMBDA_FUNCTION_MEMORY_SIZE` provides this information.
- **Line 471:** MUST be the same for all instances of horizontally scaled services. If the value was not specified, SDKs MUST fallback to `unknown_service:` concatenated with [`process.executable.name`](process.md#process), e.g. `unknown_service:bash`. If `process.executable.name` is not available, the value MUST be set to `unknown_service`.
- **Line 479:** A string value having a meaning that helps to distinguish a group of services, for example the team name that owns a group of services. `service.name` is expected to be unique within the same namespace. If `service.namespace` is not specified in the Resource then `service.name` is expected to be unique for all services that have no explicit namespace defined (so the empty/unspecified namespace is simply one more valid namespace). Zero-length namespace string is assumed equal to unspecified namespace.
- **Line 487:** MUST be unique for each instance of the same `service.namespace,service.name` pair (in other words `service.namespace,service.name,service.instance.id` triplet MUST be globally unique). The ID helps to distinguish instances of the same service that exist at the same time (e.g. instances of a horizontally scaled service). It is preferable for the ID to be persistent and stay the same for the lifetime of the service instance, however it is acceptable that the ID is ephemeral and changes during important lifetime events for the service (e.g. service restarts). If the service has no inherent unique ID that can be used as the value of this attribute it is recommended to generate a random Version 1 or Version 4 RFC 4122 UUID (services aiming for reproducible UUIDs may also use Version 5, see RFC 4122 for more recommendations).

### SemanticAttributes.js

- **Line 156:** This may be different from `faas.id` if an alias is involved.
- **Line 188:** In some SQL databases, the database name to be used is called &#34;schema name&#34;.
- **Line 196:** The value may be sanitized to exclude sensitive information.
- **Line 204:** When setting this to an SQL keyword, it is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if the operation name is provided by the library being instrumented. If the SQL statement has an ambiguous operation, or performs more than one operation, this value may be omitted.
- **Line 212:** If setting a `db.mssql.instance_name`, `net.peer.port` is no longer required (but still recommended if non-standard).
- **Line 238:** This mirrors the db.sql.table attribute but references cassandra rather than sql. It is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if it is provided by the library being instrumented. If the operation is acting upon an anonymous table, or more than one table, this value MUST NOT be set.
- **Line 288:** It is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if it is provided by the library being instrumented. If the operation is acting upon an anonymous table, or more than one table, this value MUST NOT be set.
- **Line 314:** An exception is considered to have escaped (or left) the scope of a span,
- **Line 391:** SHOULD be equal to the `faas.name` resource attribute of the invoked function.
- **Line 399:** SHOULD be equal to the `cloud.provider` resource attribute of the invoked function.
- **Line 407:** SHOULD be equal to the `cloud.region` resource attribute of the invoked function.
- **Line 559:** `http.url` MUST NOT contain credentials passed via URL in form of `https://username:password@www.example.com/`. In such case the attribute&#39;s value should be `https://www.example.com/`.
- **Line 573:** When the header is present but empty the attribute SHOULD be set to the empty string. Note that this is a valid situation that is expected in certain cases, according the aforementioned [section of RFC 7230](https://tools.ietf.org/html/rfc7230#section-5.4). When the header is not set the attribute MUST NOT be set.
- **Line 593:** If `net.transport` is not specified, it can be assumed to be `IP.TCP` except if `http.flavor` is `QUIC`, in which case `IP.UDP` is assumed.
- **Line 631:** `http.url` is usually not readily available on the server side but would have to be assembled in a cumbersome and sometimes lossy process from other information (see e.g. open-telemetry/opentelemetry-python/pull/148). It is thus preferred to supply the raw data that is available.
- **Line 645:** This is not necessarily the same as `net.peer.ip`, which would
- **Line 879:** If the key type is not string, it&#39;s string representation has to be supplied for the attribute. If the key has no unambiguous, canonical string form, don&#39;t include its value.
- **Line 917:** This is the logical name of the service from the RPC interface perspective, which can be different from the name of any implementing class. The `code.namespace` attribute may be used to store the latter (despite the attribute name, it may include a class name; e.g., class with method actually executing the call on the server side, RPC client stub class on the client side).
- **Line 925:** This is the logical name of the method from the RPC interface perspective, which can be different from the name of any implementing method/function. The `code.function` attribute may be used to store the latter (e.g., method actually executing the call on the server side, RPC client stub method on the client side).
- **Line 969:** This way we guarantee that the values will be consistent between different implementations.

### index.js

- **Line 21:** This function currently is returning false-positives

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### jtd-schema.ts

- **Line 33:** see the end of
- **Line 80:** relies on the fact that tuples don't have an index at 0.5, but arrays

### rules.js

- **Line 32:** actually it is only one visitor object

### octokit.js

- **Line 21:** replace with import ... assert { type: 'json' } once supported

### verify.js

- **Line 130:** we cannot check if the installation has all required permissions, it's

### iterate.js

- **Line 82:** this option does not exist on Node 18, but this is ok since the logic works without it. It just consumes more memory.

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### context.d.ts

- **Line 183:** that you are responsible for calling `deferred.dispose()` to free the underlying
- **Line 276:** that the QuickJS authors recommend using [[defineProp]] to define new

### deferred-promise.d.ts

- **Line 58:** that after resolving a promise, you may need to call
- **Line 67:** that after rejecting a promise, you may need to call

### index.js

- **Line 89:** that there is a hard limit on the number of WebAssembly modules in older

### module-asyncify.js

- **Line 72:** that only a single async action can occur at a time inside the entire WebAssembly module.

### module-test.js

- **Line 60:** this is currently only available when building from source

### api-gateway.d.ts

- **Line 5:** that although non-string types will be accepted, they will be
- **Line 12:** that this doesn't have to be a context from a custom lambda outhorizer, AWS also has a cognito

### cdk-custom-resource.d.ts

- **Line 32:** this is not to be confused with traditional CloudFormation custom resources.
- **Line 67:** If the name-value pairs contain sensitive information, you should use the `NoEcho` field to mask the output of the custom resource. Otherwise, the values are visible through APIs that surface property values (such as `DescribeStackEvents`).

### cloudformation-custom-resource.d.ts

- **Line 23:** responses are *not* returned from the Lambda handler but rather they are sent to the event ResponseURL.

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 517:** remember that ranges are inclusive, so for example "Range: users=0-3"
- **Line 1066:** calling res.set() after res.append() will reset the previously-set header value.

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 365:** The default timeout interval is 5 seconds if this method is not called.
- **Line 371:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 806:** that the type must be either an array or a tuple.
- **Line 1363:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### index.d.ts

- **Line 461:** the property name that the schema is testing will always be a string.

### index.d.ts

- **Line 71:** the value will still be escaped if used as an identifier (??) by

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 18:** the list doesn't contain prefix-only modules like `node:test`.

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 497:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 569:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 706:** If a `wait` timeout is specified, it begins counting down only after the test function finishes executing.
- **Line 1499:** ** When you enable mocking for a specific timer, its associated
- **Line 1502:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1547:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1569:** ** After each test completes, this function is called on
- **Line 1582:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1686:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1900:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 296:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 718:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 490:** that LOBs in objects will be represented as Lob instances and will not be String or Buffer, regardless of any fetchAsString,
- **Line 990:** This property can only be used in the node-oracledb Thick mode. See Enabling node-oracledb Thick Mode.
- **Line 1017:** if you connect to Oracle Database 18, the version will only be accurate if node-oracledb is also using Oracle Database 18 client libraries.
- **Line 1933:** only non-pooled connections can be privileged.
- **Line 2150:** batchErrors can affect autocommit mode.
- **Line 2167:** that some classes of error will always return via the executeMany() callback error object,
- **Line 2276:** it is an asynchronous method and requires a round-trip to the database.
- **Line 2946:** that if the metadata of a collection is changed externally, the cache can get out of sync. If this happens, the cache can be cleared by calling pool.reconfigure({sodaMetadataCache: false}). See pool.reconfigure().
- **Line 3055:** that enqueued Strings are returned as UTF-8 encoded Buffers.
- **Line 3609:** that a commit should be performed before attempting to create an index.
- **Line 3630:** SODA operations do not commit an open transaction the way that SQL always does for DDL statements.
- **Line 3636:** you should never use SQL DROP TABLE command on the database table underlying a collection. This will
- **Line 3696:** SodaDocuments returned from sodaCollection.insertOneAndGet() or from sodaOperation.replaceOneAndGet()
- **Line 4081:** settings from skip() and limit() non-terminals are ignored because they only apply to read operations.

### simplify.d.ts

- **Line 6:** that it does *not* guarantee that it would match the same versions in all cases,

### index.d.ts

- **Line 33:** this check is done on the path itself without checking if the path actually exists on the disk.

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### consistent-type-exports.js

- **Line 89:** it is valid to export values as types. We will avoid reporting errors

### indent.js

- **Line 3:** this file is rather type-unsafe in its current state.

### member-delimiter-style.js

- **Line 87:** can't have "none" for single line delimiter as it's invalid syntax
- **Line 92:** - need to define this last as it references the enums

### member-ordering.js

- **Line 605:** Not all members have names

### naming-convention.js

- **Line 9:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 74:** that bigint cannot have + prefixed to it

### no-misused-promises.js

- **Line 440:** - we currently do not support 'spread' arguments - adding support for them

### no-unnecessary-condition.js

- **Line 248:** It's also unnecessary if the types that don't overlap at all

### prefer-find.js

- **Line 191:** we're always looking for array member access to be "computed",

### compareNodes.js

- **Line 182:** - we purposely ignore optional flag because for our purposes

### collectUnusedVariables.js

- **Line 28:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.js

- **Line 12:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 24:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 37:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### Referencer.js

- **Line 319:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### isUnsafeAssignment.js

- **Line 34:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 883:** that there may be 0 declarations (i.e. `const;`).

### convert.js

- **Line 1636:** - NewExpression cannot have an optional chain in it

### getScriptKind.js

- **Line 34:** - we only respect the user's jsx setting for unknown extensions

### index.js

- **Line 35:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### node-utils.js

- **Line 621:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 49:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 127:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,

### createParseSettings.js

- **Line 43:** - we intentionally use "unnecessary" `?.` here because in TS<5.3 this enum doesn't exist

### resolveProjectList.js

- **Line 49:** - we initialize the global cache based on the first config we encounter.

### ESLint.d.ts

- **Line 121:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 60:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### node.js

- **Line 371:** We are ignoring errors here, to let parser continue with other

### es6.js

- **Line 116:** this node type is *not* an AssignmentExpression with a Pattern on

### path-visitor.js

- **Line 251:** that the visitor object is the prototype of Context.prototype,

### types.js

- **Line 576:** that the list returned by this function is a copy of the internal

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### semver.js

- **Line 18:** this is the semver.org version of the spec that it implements
- **Line 139:** that the only major, minor, patch, and pre-release sections of
- **Line 167:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 257:** that these all use the loose form, because they'll be

### helpers.js

- **Line 29:** If this is found to have issues, please also revist the logic in

### index.js

- **Line 42:** This is another guard against urls, if they're not inside strings or parantheses.

### Client.js

- **Line 224:** that this might not work before login depending on server.

### parseListUnix.js

- **Line 34:** local listings on MacOSX also use '@'

### arrtree.js

- **Line 43:** the ones-complement will always be < 0

### _stream_readable.js

- **Line 107:** 0 is a valid value, means "don't call _read preemptively ever"
- **Line 396:** that this may be asynchronous, or synchronous.  Yes, it is

### _stream_writable.js

- **Line 106:** 0 is a valid value, means that we always return false if

### genCombMulTo.js

- **Line 3:** This could be potentionally used to generate loop-less multiplications

### es5.js

- **Line 244:** that simple async functions are implemented on top of

### bn.js

- **Line 544:** at this stage it is known that the top bit is set
- **Line 1104:** that ncarry could be >= 0x3ffffff
- **Line 2002:** lo is 27bit maximum
- **Line 2098:** `hint` is a lowest bit before trailing zeroes
- **Line 2099:** if `extended` is present - it will be filled with destroyed bits
- **Line 2392:** (qj / bhi) is (0x3ffffff * 0x4000000 + 0x3ffffff) / 0x2000000 max
- **Line 2425:** 1) `mode` can be set to `mod` to request mod only,
- **Line 3370:** Max is such because of generalized Riemann hypothesis.

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### index.js

- **Line 39:** types are explicitly listed here for easier bundling

### mbcs.js

- **Line 112:** This assumes that there are no 4-byte common chars.

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### index.js

- **Line 33:** by @antirez: this is actually the XMODEM CRC 16 algorithm, using the

### command.js

- **Line 539:** using closure to access lots of lexical scoped variables.

### webSocket.d.ts

- **Line 68:** that both messages will be sent as returned by the functions, they are by default serialized using JSON.stringify, just
- **Line 103:** that at least one consumer has to subscribe to the created subject - otherwise "nexted" values will be just buffered and not sent,

### iif.d.ts

- **Line 15:** that Observables for both cases (true and false) are optional. If condition points to an Observable that
- **Line 56:** that only one Observable is passed to the operator.

### refCount.d.ts

- **Line 12:** that using the [@link share] operator is exactly the same as using the *publish* operator

### repeat.d.ts

- **Line 12:** `repeat(0)` returns an empty observable and `repeat()` will repeat forever

### timeInterval.d.ts

- **Line 34:** The values will never be this precise,

### Scheduler.d.ts

- **Line 26:** the extra arrow function wrapper is to make testing by overriding

### asap.d.ts

- **Line 17:** that using `asap` scheduler does not necessarily mean that your task will be first to process

### types.d.ts

- **Line 4:** This will add Symbol.observable globally for all TypeScript users,

### bindCallback.ts

- **Line 95:** that the Observable created by the output function will always emit a single value

### bindNodeCallback.ts

- **Line 74:** that `func` will not be called at the same time output function is,
- **Line 91:** that `bindNodeCallback` can be used in non-Node.js environments as well.
- **Line 106:** that even if error parameter is technically present in callback, but its value

### concat.ts

- **Line 58:** that if some input Observable never completes, `concat` will also never complete

### fromEvent.ts

- **Line 81:** that if event target calls registered function with more than one argument, second
- **Line 150:** optional configuration parameter

### fromEventPattern.ts

- **Line 93:** that we return the token here...

### onErrorResumeNext.ts

- **Line 35:** that there is no way to handle any errors thrown by sources via the result of

### zip.ts

- **Line 287:** there is actually a name collision here with Subscriber.next and Iterator.next

### catchError.ts

- **Line 121:** overriding `error` instead of `_error` because we don't want

### concatAll.ts

- **Line 27:** `concatAll` is equivalent to `mergeAll` with concurrency parameter set

### concatMap.ts

- **Line 32:** `concatMap` is equivalent to `mergeMap` with concurrency parameter set

### concatMapTo.ts

- **Line 32:** `concatMapTo` is equivalent to `mergeMapTo` with concurrency parameter

### map.ts

- **Line 79:** This looks unoptimized, but it's actually purposefully NOT

### onErrorResumeNext.ts

- **Line 47:** that you do not get any access to errors emitted by the Observables. In particular do not

### tap.ts

- **Line 37:** this is different to a `subscribe` on the Observable. If the Observable

### MiscJSDoc.ts

- **Line 323:** that you can make iterator an instance of Iterable by having it return itself

### context.d.ts

- **Line 58:** groups.

### util.js

- **Line 22:** These type checking functions intentionally don't use `instanceof`

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### index.js

- **Line 46:** if these are wrong, you'll need to change index.js too
- **Line 48:** lengthRe is sneaky: you can omit units for 0
- **Line 792:** if this is wrong, you'll need to change tokenTypes.js too

### index.js

- **Line 659:** neither ISO-8601 nor JavaScript supports seconds in timezone offsets

### index.js

- **Line 58:** because local time is used, the

### index.js

- **Line 17:** about bundle size: `set` does not internally use `setX` functions from date-fns but instead opts

### index.js

- **Line 25:** that 'Days - abbreviated - Formatting' has periods at the end.

### index.js

- **Line 20:** in German, the names of days of the week and months are capitalized.

### index.js

- **Line 22:** in Indonesian, the names of days of the week and months are capitalized.

### index.js

- **Line 7:** no implementation for weeks

### index.js

- **Line 22:** in Malay, the names of days of the week and months are capitalized.

### index.js

- **Line 20:** in English, the names of days of the week and months are capitalized.

### index.js

- **Line 30:** the order of '1' since it is a sub-string of '10', so must be lower priority
- **Line 32:** the order of 'thg 1' since it is sub-string of 'thg 10', so must be lower priority
- **Line 34:** the order of 'Mười' since it is sub-string of Mười Một, so must be lower priority

### purify.cjs.d.ts

- **Line 176:** that the `USE_PROFILES` setting will override the `ALLOWED_TAGS` setting

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### edwards.js

- **Line 11:** Important as we are creating point in Base.call()

### short.js

- **Line 105:** all vectors are roots of: a + b * lambda = 0 (mod n)

### index.js

- **Line 218:** Greg Maxwell's trick, inspired by:

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### index.js

- **Line 23:** I'm intentionally not DRYing up the other variables to keep them "lazy".

### main.d.ts

- **Line 691:** These declarations exist to avoid type errors when you omit "dom" from

### escodegen.js

- **Line 152:** Flag order:

### accessors.js

- **Line 102:** that `value` here refers to the normalised value.

### convert.js

- **Line 1482:** - for compat with 3.7.x, where node.exportClause is always undefined and

### json-schema.js

- **Line 2:** - @types/json-schema@7.0.4 added some function declarations to the type package

### referencer.js

- **Line 178:** Not referring variableScope. It is intended.
- **Line 496:** In ES6, ForStatement dynamically generates
- **Line 521:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 660:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 24:** See

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### cli-engine.js

- **Line 850:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### rule-validator.js

- **Line 117:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 284:** that we should not overuse queries (e.g., by appending the current time

### fork-context.js

- **Line 90:** `create` is just a wrapper that augments `new CodePathSegment`.

### flat-rule-tester.js

- **Line 150:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 312:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 275:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 44:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### events.js

- **Line 137:** The comments on the `throw` lines are intentional, they show

### openapi.metadata.js

- **Line 10:** base path is empty when path is fully qualified i.e. req.path.startsWith('')

### request.js

- **Line 316:** X-Forwarded-Proto is normally only ever a
- **Line 434:** X-Forwarded-Host is normally only ever a

### node.js

- **Line 171:** stream._type is used for test-module-load-list.js

### diff.js

- **Line 878:** that diff_commonPrefix and diff_commonSuffix are unicode-aware
- **Line 1040:** this runs after equality check has ruled out exact equality

### browser.d.ts

- **Line 48:** that if the decompression result is larger than the size of this buffer, it will be truncated to fit.
- **Line 101:** that this is exponential: while level 0 uses 4 kB, level 4 uses 64 kB, level 8 uses 1 MB, and level 12 uses 16 MB.
- **Line 931:** that attributes usually only work in conjunction with the `os` setting: you must use

### browser.js

- **Line 498:** that the semicolon was intentional

### isFileLike.d.ts

- **Line 5:** that this function will return `false` for Blob, because the FormDataEncoder expects FormData to return File when a value is binary data.

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### FormData.d.ts

- **Line 19:** that this object is not a part of Node.js, so you might need to check if an HTTP client of your choice support spec-compliant FormData.

### Formidable.js

- **Line 452:** probably not needed, because we check options.enabledPlugins in the constructor

### multipart.js

- **Line 19:** we (currently) support both multipart/form-data and multipart/related
- **Line 40:** that it's a good practice (but it's up to you) to use the `this.options` instead

### copy.js

- **Line 92:** that The initial srcStat.atime cannot be trusted

### gaxios.js

- **Line 414:** once the minimum version reaches Node 16,

### index.js

- **Line 140:** node.js converts all incoming headers to lower case.

### logging-utils.d.ts

- **Line 89:** that this interface may change at any time, as we're reserving the

### logging-utils.js

- **Line 264:** Google does not explicitly endorse or recommend this package; it's just
- **Line 328:** that these cached functions will need to deal with changes in the backend.

### handlebars.amd.js

- **Line 451:** for 5.0: Change to "obj == null" in 5.0
- **Line 917:** Using env.VM references rather than local var references throughout this section to allow

### index.d.ts

- **Line 198:** for backward compatibility of this typing

### python.js

- **Line 297:** no leading \b because floats can start with a decimal point

### swift.js

- **Line 159:** Contextual keywords are reserved only in specific contexts.

### typescript.js

- **Line 421:** this might not work how you think.  We don't actually always

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that [@link OptionsBase.allowStale] is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### utf16.js

- **Line 4:** UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

### extend-node.js

- **Line 3:** not polyfilled with safer-buffer on a purpose, as overrides Buffer
- **Line 12:** this does use older Buffer API on a purpose

### hook.js

- **Line 86:** that the expected `line` isn't 100% valid ESM. It is derived

### errors.js

- **Line 322:** extra classes have been shaken out.
- **Line 361:** no need to implement `kIsNodeError` symbol, would be hard,

### get-format.js

- **Line 125:** we don’t implement WASM, so we don’t need

### package-json-reader.js

- **Line 132:** in Node, this is now a native module.

### resolve.js

- **Line 136:** from Node 15 onwards we can use `throwIfNoEntry: false` instead.
- **Line 140:** in Node code this returns `new Stats`,
- **Line 1082:** The Node code supports `base` as a string (in this internal API) too,
- **Line 1106:** actual code uses `canBeRequiredWithoutScheme`.
- **Line 1175:** this is from:

### prompt.js

- **Line 42:** As this is a public interface, we cannot do an instanceof check as we won't

### autoPipelining.js

- **Line 117:** that the first value in args may be a (possibly empty) array.

### ClusterSubscriber.js

- **Line 31:** that this event is only triggered if the connection to
- **Line 108:** that auto reconnection is enabled here.

### index.js

- **Line 32:** that `reset` will move the cursor to the previous element,

### Pipeline.js

- **Line 219:** To avoid an unhandled promise rejection, this will unconditionally always return this.promise,

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### index.d.ts

- **Line 4:** This file is expected to change dramatically in the next major release and have been
- **Line 49:** that references to the value are usually not what you want as they move around the value structure relative to where the error happens.
- **Line 522:** that key and value can be anything including objects, array, etc.
- **Line 569:** that the adjust feature will not perform any type validation on the adjusted value and it must match the value expected by the rule it is used in.
- **Line 695:** This method does not exist in browser builds of Joi
- **Line 1025:** that if value is an object, any changes to the object after `default()` is called will change the
- **Line 1069:** that if you provide an `Error`, it will be returned as-is, unmodified and undecorated with any of the
- **Line 1089:** that external validation rules are only called after the all other validation rules for the entire schema (from the value root) are checked.
- **Line 1108:** that if value is an object, any changes to the object after `failover()` is called will change the reference and any future assignment.
- **Line 1143:** that `keep()` will terminate the current ruleset and cannot be followed by another rule option.
- **Line 1156:** that `message()` will terminate the current ruleset and cannot be followed by another rule option.
- **Line 1163:** that while `any.message()` applies only to the last rule or ruleset, `any.messages()` applies to the entire schema.
- **Line 1298:** that `warn()` will terminate the current ruleset and cannot be followed by another rule option.
- **Line 2266:** that the types are already formed and do not need to be called as functions (e.g. `string`, not `string()`).

### agent.d.ts

- **Line 112:** that the runnable should still only stream a single action or

### initialize.js

- **Line 50:** this tools cast is safe as the overload signatures prevent

### index.js

- **Line 6:** This functionality is currently in beta.

### time_weighted.d.ts

- **Line 93:** When adding documents to a vector store, use addDocuments

### serpapi.d.ts

- **Line 8:** you must provide location, gl and hl or your region and language will

### async_caller.js

- **Line 122:** this doesn't cancel the underlying request,

### generic.js

- **Line 30:** that this will wrap and trace ALL SDK methods, not just

### stringify.js

- **Line 19:** Be careful editing this code!  It's been tuned for performance
- **Line 22:** to future-self: No, you can't remove the `toLowerCase()` call.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### index.js

- **Line 441:** ** This method is loosely based on
- **Line 686:** ** Non-object values are coerced to objects. See the
- **Line 718:** ** Non-object values are coerced to objects.

### index.js

- **Line 52:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are classified

### _equalByTag.js

- **Line 34:** ** This function only supports comparing values with tags of

### _initCloneByTag.js

- **Line 32:** ** This function only supports cloning values with tags of

### _setData.js

- **Line 7:** ** If this function becomes hot, i.e. is invoked a lot in a short

### assignInWith.js

- **Line 11:** ** This method mutates `object`.

### bindAll.js

- **Line 11:** ** This method doesn't set the "length" property of bound functions.

### conforms.js

- **Line 12:** ** The created function is equivalent to `_.conformsTo` with

### core.js

- **Line 1705:** ** This method is used instead of
- **Line 1919:** ** Unlike `_.remove`, this method returns a new array.
- **Line 2002:** ** As with other "Collections" methods, objects with a "length"
- **Line 2271:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 2405:** ** This method is loosely based on the
- **Line 2868:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 3076:** ** This method mutates `object` and is loosely based on
- **Line 3413:** ** No other characters are escaped. To escape additional
- **Line 3515:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 3522:** ** Multiple values can be checked by combining several matchers
- **Line 3554:** ** Use `_.runInContext` to create a pristine `lodash` function to

### curryRight.js

- **Line 13:** ** This method doesn't set the "length" property of curried functions.

### debounce.js

- **Line 23:** ** If `leading` and `trailing` options are `true`, `func` is

### difference.js

- **Line 12:** ** Unlike `_.pullAll`, this method returns a new array.

### differenceBy.js

- **Line 15:** ** Unlike `_.pullAllBy`, this method returns a new array.

### every.js

- **Line 12:** ** This method returns `true` for

### fill.js

- **Line 8:** ** This method mutates `array`.

### isEqual.js

- **Line 7:** ** This method supports comparing arrays, array buffers, booleans,

### isInteger.js

- **Line 6:** ** This method is based on

### lodash.js

- **Line 7059:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 7824:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 11196:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 11867:** ** This method is equivalent to `_.matches` when `source` is
- **Line 11970:** ** This method can't reliably detect native functions in the presence
- **Line 14741:** ** In the development build `_.template` utilizes

### matchesProperty.js

- **Line 12:** ** Partial comparisons will match empty array and empty object

### memoize.js

- **Line 13:** ** The cache is exposed as the `cache` property on the memoized

### omit.js

- **Line 19:** ** This method is considerably slower than `_.pick`.

### parseInt.js

- **Line 15:** ** This method aligns with the

### partial.js

- **Line 17:** ** This method doesn't set the "length" property of partially

### pull.js

- **Line 9:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`

### pullAll.js

- **Line 6:** ** Unlike `_.difference`, this method mutates `array`.

### pullAllBy.js

- **Line 9:** ** Unlike `_.differenceBy`, this method mutates `array`.

### pullAt.js

- **Line 12:** ** Unlike `_.at`, this method mutates `array`.

### range.js

- **Line 9:** ** JavaScript follows the IEEE-754 standard for resolving

### remove.js

- **Line 9:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`

### rest.js

- **Line 12:** ** This method is based on the

### reverse.js

- **Line 11:** ** This method mutates `array` and is based on

### unescape.js

- **Line 13:** ** No other HTML entities are unescaped. To unescape additional

### without.js

- **Line 10:** ** Unlike `_.pull`, this method returns a new array.

### wrapperReverse.js

- **Line 9:** ** This method mutates the wrapped array.

### index.js

- **Line 174:** that we must ALWAYS check specially whether those values are MIN_VALUE
- **Line 424:** the compiler should inline these constant values below and then remove these variables, so there should be

### index.js

- **Line 126:** that although this function takes a callback parameter it is _not_ an

### token_set.js

- **Line 318:** Using Object.keys here as this.edges is very likely
- **Line 367:** As with the #toString method, we are using

### chai.js

- **Line 1144:** that dots and bracket in `name` must be backslash-escaped when
- **Line 3857:** that we have to use [[DefineProperty]] instead of [[Put]]

### mocha.js

- **Line 2657:** Includes leading newline
- **Line 7182:** cannot use `length < kMaxLength` here because that fails when
- **Line 11275:** ** This function is used to avoid a [JIT bug](https://bugs.webkit.org/show_bug.cgi?id=142792)
- **Line 11335:** ** This function is based on [`ToLength`](https://people.mozilla.org/~jorendorff/es6-draft.html#sec-tolength).
- **Line 11593:** ** This function is loosely based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
- **Line 11750:** ** This function is based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
- **Line 14369:** Converting a Buffer containing an orphan surrogate to a String

### tokenizer_test.js

- **Line 55:** slicing here to prevent asserting on parts

### domiterator.js

- **Line 494:** that ifr will be manipulated here

### mark.js

- **Line 838:** that dict will be updated automatically, as it'll change

### onload.js

- **Line 3:** that in Chrome the onload event will already be fired. Reason

### index.d.ts

- **Line 3:** marking anything protected or private in the exported
- **Line 88:** encoding is not actually read-only, and setEncoding(enc)

### observable.d.ts

- **Line 36:** current propagation mechanism will in case of self reruning autoruns behave unexpectedly

### mobx.umd.js

- **Line 3764:** we are concurrently reading/deleting the same keys

### observablemap.d.ts

- **Line 64:** that all the keys being stringified.
- **Line 70:** that the values migth still be observable. For a deep clone use mobx.toJS.

### mustache.js

- **Line 563:** The `originalTemplate` is only ever used to extract the portion

### index.js

- **Line 543:** we can't clone the form-data object without having it as a dependency
- **Line 742:** per spec we have to first exhaust the lists then process them

### index.js

- **Line 147:** This could be implemented using a single negative lookbehind

### index.js

- **Line 27:** We cannot use the name property command file because in the case of

### update-notifier.js

- **Line 41:** that this isn't another http request over the network, because

### install.js

- **Line 93:** there used to be registry completion here,

### publish.js

- **Line 116:** that publishConfig might have changed as well!

### npm.js

- **Line 109:** that this might not be the actual name of the command
- **Line 154:** this MUST be shorter than the actual argv length, because it

### log-file.js

- **Line 16:** that each log event can write more than one line to the

### queryable.js

- **Line 141:** that occurrences of Symbol(append) will throw,

### reify-output.js

- **Line 23:** fails and crashes if we're running audit fix and there was an error

### build-ideal-tree.js

- **Line 37:** some of these symbols are shared so we can hit
- **Line 579:** any that can't be fixed at the root level without --force
- **Line 841:** this is the same "maximally naive" deduping tree-building
- **Line 1035:** that the virtual root will also have virtual copies of the
- **Line 1116:** that this WILL fetch bundled meta-deps which are also dependencies
- **Line 1269:** that the peers in the set can conflict either with each other,

### load-actual.js

- **Line 137:** hidden lockfile will be rejected if it's not the latest thing

### rebuild.js

- **Line 260:** that 'scripts' might be missing entirely, and the package may

### reify.js

- **Line 301:** that each rollback *also* calls the previous one when it's

### deepest-nesting-target.js

- **Line 7:** this will skip past the first target if edge is peer

### diff.js

- **Line 145:** that if ideal has integrity, and resolved doesn't, we treat
- **Line 189:** we DON'T diff fsChildren themselves, because they are either
- **Line 262:** that moving over a bundled dep will break the links to other

### edge.js

- **Line 110:** this condition means we explicitly do not support overriding

### node.js

- **Line 143:** this *only* works for non-file: deps, so we avoid even
- **Line 220:** this is _slightly_ less efficient for the initial tree
- **Line 853:** the subtle breaking change from v6: it is no longer possible
- **Line 994:** that there are cases where Arborist will opt to insert a node

### optional-set.js

- **Line 8:** that this is *only* going to work with trees where calcDepFlags

### place-dep.js

- **Line 90:** this sets the parent's canPlace as the parent of this
- **Line 301:** if the virtualRoot *doesn't* have the peer, then that means

### query-selector-all.js

- **Line 519:** this uses a Promise.all around a map without in-line concurrency handling
- **Line 861:** this runs over each node and should not throw

### shrinkwrap.js

- **Line 30:** that between this.add() and this.commit(), `this.data` will be out of
- **Line 86:** name is included if necessary, for alias packages

### definition.js

- **Line 178:** these are not quite the same as the description printed

### index.js

- **Line 393:** we pull registry without restricting to the current 'where' because we want to
- **Line 804:** not encrypted, no idea why we bothered to do this, but oh well

### set-envs.js

- **Line 99:** this doesn't afect the *current* node process, of course, since

### index.js

- **Line 89:** the first or second parameter must be a static version or range

### field_behavior.js

- **Line 11:** This enum **may** receive new values in the future.

### entry-index.js

- **Line 126:** - Cleverness ahoy!

### index.js

- **Line 59:** `iterator.next()` can be called many times in parallel.
- **Line 145:** We *must* do this for async iterators otherwise we'll spin up

### read-entry.js

- **Line 65:** gnutar and bsdtar treat unrecognized types as 'File'

### strip-absolute-path.js

- **Line 5:** that windows will think that //x/y/z/a has a "root" of //x/y, and in

### unpack.js

- **Line 97:** that on windows, we always drop the entire cache whenever a

### dbcs-codec.js

- **Line 284:** '>>> 0' keeps 32-bit num positive.

### utf32.js

- **Line 123:** codepoint is a signed int32 and can be negative.
- **Line 124:** We copied this block from below to help V8 optimize it (it works with array, not buffer).
- **Line 156:** codepoint is signed int32 and can be negative. We keep it that way to help V8 with optimizations.

### index.js

- **Line 135:** Streaming API naturally depends on 'stream' module from Node.js. Unfortunately in browser environments this module can add

### streams.js

- **Line 5:** Due to 'stream' module being pretty large (~100Kb, significant in browser environments),

### entry.js

- **Line 15:** we will also store any request headers
- **Line 26:** we must not store the real response's age header, or when we load
- **Line 311:** we do not set the x-local-cache-hash header because we do not know
- **Line 394:** be sure to remove the headers property from the

### policy.js

- **Line 123:** this is a hack to avoid parsing the cache-control

### fetcher.js

- **Line 172:** that they should *not* calculate or check integrity or cache,
- **Line 189:** cacache will raise a EINTEGRITY error if the integrity doesn't match

### git.js

- **Line 169:** that this does mean that a dependency MAY in theory end up

### registry.js

- **Line 79:** this might be either an in-flight promise for a request,

### is-package-bin.js

- **Line 5:** this is not possible in remote or file fetchers, since

### tar-create-options.js

- **Line 16:** that npm-packlist is already filtering out

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 493:** that we might know *something* about it if there has been a previous
- **Line 638:** even on case-sensitive systems, it is **not** safe to test the
- **Line 854:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1676:** As of Node 19, this is very slow, compared to other methods of

### container.js

- **Line 121:** that this location is relative to the location of the first character

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### store.js

- **Line 169:** that an expired initial root is still considered valid.

### updater.js

- **Line 311:** This may be a slow operation if there are many delegated roles.

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### index.js

- **Line 37:** We cannot override the `name` property, as that is `readOnly`

### core.js

- **Line 31:** there is an invariant here that isn't represented in the type system
- **Line 403:** this is not a standard header.
- **Line 426:** the `retry-after-ms` header may not be standard, but is a good idea and we'd like proactive support for it.
- **Line 639:** modified from https://github.com/JS-DevTools/host-environment/blob/b1ab79ecde37db5d6e163c050e54fe7d287d7c92/src/isomorphic.browser.ts
- **Line 644:** The order matters here!
- **Line 689:** this iOS check is untested and may not work

### index.d.ts

- **Line 49:** that request timeouts are retried by default, so in a worst-case scenario you may wait
- **Line 207:** this means you won't be able to use non-deployment endpoints. Not supported with Assistants APIs.

### ChatCompletionStream.js

- **Line 38:** that messages sent to the model do not appear in `.on('message')`

### EventStream.js

- **Line 161:** _emit('error', error) should only be called from #handleError().

### Util.js

- **Line 16:** TS was complaining about using `.filter().map()` here for some reason

### net.d.ts

- **Line 48:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### transcriptions.d.ts

- **Line 288:** Streaming is not supported for the `whisper-1` model and will be ignored.

### assistants.d.ts

- **Line 552:** that the file search tool may output fewer than `max_num_results` results.

### realtime.d.ts

- **Line 1386:** that the server sets default instructions which will be used if this field
- **Line 1702:** that once a session has been initialized with a particular `model`, it

### threads.d.ts

- **Line 358:** that the overlap must not exceed half of `max_chunk_size_tokens`.

### completions.d.ts

- **Line 367:** ** If the stream is interrupted or cancelled, you may not receive the
- **Line 836:** ** If the stream is interrupted, you may not receive the final usage

### completions.d.ts

- **Line 159:** that <|endoftext|> is the document separator that the model sees during
- **Line 171:** ** Because this parameter generates many completions, it can quickly

### permissions.d.ts

- **Line 6:** ** Calling this endpoint requires an [admin API key](../admin-api-keys).
- **Line 24:** ** This endpoint requires an [admin API key](../admin-api-keys).

### models.d.ts

- **Line 22:** no pagination actually occurs yet, this is for forwards-compatibility.

### file-batches.d.ts

- **Line 36:** this will return even if one of the files failed to process, you need to

### files.js

- **Line 72:** this will return even if the file failed to process, you need to check
- **Line 112:** the file will be asynchronously processed (you can use the alternative

### ChatCompletionStream.ts

- **Line 736:** we do not include an "object" type on the snapshot,

### cli.js

- **Line 81:** this will generate a recognizable error for the user to act on
- **Line 114:** may be directory

### load.ts

- **Line 244:** 'in' is a unique required property of parameters. and parameters can live in subschemas (i.e. "parameters" doesn’t have to be part of the traceable path)

### path-item-object.ts

- **Line 30:** the actual key doesn’t matter here, as long as it can match between PathItem and OperationObject

### schema-object.ts

- **Line 55:** guarantee readonly happens once, here
- **Line 75:** for objects, treat enum as oneOf

### types.ts

- **Line 145:** paths object does support $refs; the schema just defines it in a weird way
- **Line 659:** this isn’t validated, so any string entered will be accepted as-is.

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### unicode.js

- **Line 99:** excluding NULL and ASCII whitespace

### preprocessor-mixin.js

- **Line 16:** avoid reporting error twice on advance/retreat

### parser-mixin.js

- **Line 43:** For cases like <p> <p> </p> - First 'p' closes without a closing
- **Line 86:** generate location info for elements
- **Line 103:** <body> and <html> are never popped from the stack, so we need to updated
- **Line 140:** _attachElementToTree is called from _appendElement, _insertElement and _insertTemplate methods.
- **Line 183:** store last foster parenting location, so we will be able to find inserted text
- **Line 209:** if we have location assigned by another token, then just update end position

### tokenizer-mixin.js

- **Line 93:** if we have pending character token make it's end location equal to the
- **Line 117:** if we have character token and it's location wasn't set in the _emitCurrentToken(),
- **Line 132:** patch initial states for each mode to obtain token start position

### preprocessor-mixin.js

- **Line 25:** LF should be in the last column of the line

### formatting-element-list.js

- **Line 59:** build attrs map for the new element so we can perform fast lookups
- **Line 81:** remove bottommost candidates until Noah's Ark condition will not be met

### index.js

- **Line 350:** use <template> element as a fragment context if context element was not provided,
- **Line 356:** create fake element which will be used as 'document' for fragment parsing.
- **Line 939:** store next element for the next loop iteration (it may be deleted from the stack by step 9.5)
- **Line 1042:** do nothing =)
- **Line 1389:** If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
- **Line 1583:** here we assume that we always act as an user agent with enabled plugins, so we parse

### open-element-stack.js

- **Line 257:** here we assume that root <html> element is always first in the open element stack, so

### index.js

- **Line 163:** used in tests and by rewriting stream

### index.js

- **Line 176:** String.fromCharCode() function can handle only characters from BMP subset.
- **Line 434:** store emited start tag's tagName to determine is the following end tag token is appropriate.
- **Line 502:** used then we emit character explicitly. This is always a non-whitespace and a non-null character.
- **Line 522:** we use greedy search, so we continue lookup at this point
- **Line 1402:** sequence lookup can be abrupted by hibernation. In that case lookup
- **Line 2026:** matching can be abrupted by hibernation. In that case match

### named-entity-data.js

- **Line 3:** this file contains auto-generated array mapped radix tree that is used for the named entity references consumption

### preprocessor.js

- **Line 13:** HTML input preprocessing
- **Line 33:** err reporting is noop by default. Enabled by mixin.
- **Line 42:** try to peek a surrogate pair
- **Line 47:** we have a surrogate pair. Peek pair character and recalculate code point.
- **Line 50:** add gap that should be avoided during retreat
- **Line 57:** we are at the end of a chunk, therefore we can't infer surrogate pair yet.
- **Line 63:** isolated surrogate
- **Line 108:** any U+000A LINE FEED (LF) characters that immediately follow a U+000D CARRIAGE RETURN (CR) character
- **Line 116:** all U+000D CARRIAGE RETURN (CR) characters must be converted to U+000A LINE FEED (LF) characters

### index.d.ts

- **Line 879:** that this will be extremely memory-hungry on large filesystems.

### index.js

- **Line 23:** the oid can be obtained via the following sql query:

### index.js

- **Line 85:** this function must be synchronous.

### index.js

- **Line 177:** Change prototype *after* Buffer.from is defined to workaround Chrome bug:
- **Line 323:** cannot use `length < K_MAX_LENGTH` here because that fails when

### polished.cjs.js

- **Line 2327:** At a later stage we can optimize this function as right now a hsl

### index.js

- **Line 60:** INSERT never advances the offset.

### doc.d.ts

- **Line 204:** that, like cursorNodeStart, this is a misnomer and may actually be the text between two

### index.d.ts

- **Line 131:** that resolving these types is somewhat complicated, and it wasn't

### prism-csharp.js

- **Line 6:** This is a simple text based replacement. Be careful when using backreferences!

### prism-cshtml.js

- **Line 41:** about the above bracket patterns:

### prism-textile.js

- **Line 98:** superscripts and subscripts are not handled specifically

### prism.js

- **Line 559:** All language definitions required to highlight the code must be included in the main `prism.js` file for
- **Line 1238:** This can cause infinite recursion. Be careful when you embed different languages or even the same language into
- **Line 1923:** Elements which are already loaded or currently loading will not be touched by this method.

### protobuf.js

- **Line 1071:** that this uses `end`, not `pos`
- **Line 1553:** that the casts below are theoretically unnecessary as of today, but older statically

### protobuf.js

- **Line 2113:** that values inherit valuesById on their prototype which makes them a TypeScript-
- **Line 6959:** Extension fields aren't actual fields on the declaring type, but nested objects.

### index.d.ts

- **Line 239:** that the shape of the resulting cache may be different if the
- **Line 342:** that we may store fewer items than this if maxSize is hit.
- **Line 363:** that we still will only keep up to max *actual items*,
- **Line 380:** that when [@link maxSize] or [@link maxEntrySize] are set, every
- **Line 433:** that this may significantly degrade performance,
- **Line 438:** that this means that [@link allowStale] is a bit pointless,
- **Line 466:** that the [@link get] return value will still be `undefined` unless

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### index.d.ts

- **Line 67:** it isn't recommended to use it for long duration and few points, as it may delay action
- **Line 114:** Depending on time penalty may go to next durations
- **Line 129:** Depending on time reward may go to next durations
- **Line 510:** The method won't close the Valkey client, as it may be shared with other instances.

### RateLimiterValkeyGlide.js

- **Line 242:** The method won't going to close the Valkey client, as it may be shared with other instances.

### index.js

- **Line 160:** we intentionally leave the stream paused,

### react-dom-server.browser.development.js

- **Line 743:** there is a special case that prevents it from being written to the DOM
- **Line 754:** `option.selected` is not updated if `select.multiple` is
- **Line 756:** if you add a camelCased prop to this list,
- **Line 1567:** menuitem's close tag should be omitted, but that causes problems.
- **Line 1587:** the use of `==` which checks for null or undefined.
- **Line 1709:** that we've removed escapeTextForBrowser() calls here since the
- **Line 3332:** We use just two stacks regardless of how many context providers you have.
- **Line 4128:** when changing this, also consider https://github.com/facebook/react/issues/11526

### react-dom-test-utils.development.js

- **Line 1458:** Top level event types are a subset of the entire set of handler types

### react-dom-unstable-native-dependencies.development.js

- **Line 873:** ideally these would be imported from DOMTopLevelEventTypes,

### react-dom.development.js

- **Line 2191:** that this would throw on non-element objects.
- **Line 2200:** we don't warn about invalid children here.
- **Line 2880:** that events in this list will *not* be listened to at the top level
- **Line 2908:** that this module is currently shared and assumed to be stateless.
- **Line 3464:** This will not work correctly for non-generic events such as `change`,
- **Line 6966:** IE10+ supports the Selection object, but it does not support
- **Line 7201:** this does not catch all invalid nesting, nor does it try to (as it's
- **Line 11718:** memo() and forwardRef() we'll compare outer rather than inner type.
- **Line 13211:** During these life-cycles, instance.props/instance.state are what
- **Line 17095:** This only applies to SimpleMemoComponent, not MemoComponent,
- **Line 18071:** that the "rows" will be workInProgress, but any nested children
- **Line 20423:** these two variables *must* always be updated together.
- **Line 20983:** It doesn't matter whether the component that suspended was
- **Line 22064:** that this will happen even if batchedUpdates is higher up
- **Line 22980:** This currently assumes there are no passive effects on the root fiber
- **Line 23740:** The following is done to avoid a v8 performance cliff.
- **Line 23949:** We don't reset the actualTime counts. It's useful to accumulate

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### react.development.js

- **Line 1895:** Memo only checks outer props here.

### index.js

- **Line 315:** cannot use `length < kMaxLength()` here because that fails when

### public-encrypt.js

- **Line 15:** encryption is ranomized so can't test to see if they encrypt the same

### pako_deflate.js

- **Line 908:** this function should be optimized to avoid extra copying from
- **Line 2762:** that the length 255 (match length 258) can be represented

### pako_inflate.js

- **Line 300:** adler32 takes 12% for level 0 and 2% for level 6.
- **Line 423:** we can't get significant speed boost here.

### capability.js

- **Line 25:** this doesn't actually make an http request.

### headers.js

- **Line 96:** that Safari 10.0 on iOS 10.3 doesn't need to override the mime type, so the content-type is preserved.

### url.js

- **Line 69:** that any invalid chars are also handled, but these

### yargs.js

- **Line 1062:** that parsed.aliases is a normalized bidirectional map :)

### Reflect.js

- **Line 1349:** not a real clear, just makes the previous data unreachable

### ReflectNoConflict.js

- **Line 720:** This is an approximation as we cannot check for [[Call]] internal method.
- **Line 726:** This is an approximation as we cannot check for [[Construct]] internal method.

### regenerate.js

- **Line 166:** the `- 1` makes `end` inclusive.
- **Line 203:** we cannot `return` just yet, in case any following pairs still
- **Line 365:** we cannot `return` just yet, as there may still be other
- **Line 376:** we cannot return yet.
- **Line 409:** we cannot `return` just yet.
- **Line 517:** the `\b` escape sequence for U+0008 BACKSPACE in strings has a
- **Line 523:** IE < 9 treats `'\v'` as `'v'`, so avoid using it.
- **Line 538:** `-` (U+002D HYPHEN-MINUS) is escaped in this way rather
- **Line 864:** the loop starts at the next index.
- **Line 1182:** `valueOf` is aliased as `toArray`.

### rewrite-pattern.js

- **Line 85:** `unicodeMatchPropertyValue` throws on invalid values.
- **Line 97:** `unicodeMatchProperty` throws on invalid properties.
- **Line 981:** `processTerm` mutates `tree` and `groups`.

### parser.js

- **Line 7:** The ECMA-262 standard uses the term "Assertion" for /^/. Here the
- **Line 148:** The following productions refer to the "set notation and
- **Line 213:** The following productions refer to the

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### rollup.d.ts

- **Line 128:** if plugins use new this.cache to opt-out auto transform cache

### loadConfigFile.js

- **Line 389:** that we do not have coverage for Windows-only code paths

### rollup.js

- **Line 6637:** this doesn't skip properties with defined getters/setters which we use to pack wrap booleans
- **Line 9618:** that class fields do not end up on the prototype
- **Line 12853:** that we use posix.join because:
- **Line 14336:** that unknown test values are always included

### AjaxResponse.d.ts

- **Line 23:** It is advised not to hold this in memory, as it will retain references to all of it's event handlers

### types.d.ts

- **Line 39:** this is only honored if the request is asynchronous (`async` is `true`).
- **Line 92:** that, by default, RxJS will add the following headers under certain conditions:
- **Line 141:** that the type of `"document"` (such as an XML document) is ignored if the global context is
- **Line 154:** This AJAX implementation relies on the built-in serialization and setting

### timer.d.ts

- **Line 97:** that this observable will never complete.

### connect.d.ts

- **Line 29:** that using a [@link takeUntil] inside of `connect`'s `selector` _might_ mean you were looking

### OperatorSubscriber.d.ts

- **Line 34:** This currently **ONLY** exists to support the strange behavior of [@link groupBy], where unsubscription

### refCount.d.ts

- **Line 12:** that using the [@link share] operator is exactly the same as using the `multicast(() => new Subject())` operator

### repeat.d.ts

- **Line 30:** that `repeat` will _not_ catch errors. Use [@link retry] for that.
- **Line 76:** that the second repeat cannot be called until the first

### Subscription.d.ts

- **Line 65:** THIS ASSUMES THAT [@link _hasParent] HAS ALREADY BEEN CHECKED.
- **Line 77:** that `Subscription` instances, when unsubscribed, will automatically remove themselves

### ajax.ts

- **Line 443:** that download load handling is a bit different below, because it has

### AnyCatcher.ts

- **Line 2:** that we cannot apply the `internal` tag here because the declaration

### fetch.ts

- **Line 151:** that any error that comes from our selector will be

### fromEvent.ts

- **Line 211:** optional configuration parameter which will be passed to addEventListener

### generate.ts

- **Line 350:** that folks not using TypeScript may trip over this.

### timer.ts

- **Line 149:** that this *could* be negative, in which case

### using.ts

- **Line 42:** Optional chaining did not work here.

### endWith.ts

- **Line 20:** Passing a last argument of a Scheduler is _deprecated_, and may result in incorrect

### mergeInternals.ts

- **Line 110:** that this call will increment `active` ahead of the

### publishBehavior.ts

- **Line 21:** that this has *never* supported the selector function.

### publishLast.ts

- **Line 71:** that this has *never* supported a selector function like `publish` and `publishReplay`.

### share.ts

- **Line 61:** that resetting on error or complete of the source Observable does not behave like a transparent retry or restart

### skipLast.ts

- **Line 55:** that it is the _same size_ as the skip count.

### timeout.ts

- **Line 308:** The default for `scheduler` will be the `scheduler` argument if it exists, or

### Subject.ts

- **Line 41:** This must be here to obscure Observable's constructor.

### socksclient.js

- **Line 482:** As of Tor v0.3.5.7+, if user/pass auth is an option from the client, by default it will always take priority.

### socksclient.d.ts

- **Line 36:** Supports callbacks and promises. Only supports the connect command.
- **Line 45:** Supports callbacks and promises. Only supports the connect method.
- **Line 46:** Implemented via createConnection() factory function.
- **Line 74:** If the Socks client is not BoundWaitingForConnection or Established, the connection will be closed.
- **Line 135:** No auth and user/pass are currently supported.

### index.js

- **Line 24:** 'error' and 'ready' events emitted below only relevant when sonic.sync===false

### styled-components.js

- **Line 196:** its typeof might be other than 'symbol' or 'number' if it's a polyfill.

### styled-components.native.cjs.js

- **Line 243:** This stylis instance is only used to split rules from SSR'd style tags
- **Line 259:** This means "autocomplete missing semicolons"
- **Line 1088:** We cannot mutate the deferred array itself as all clones
- **Line 1144:** This is just for backwards-compatibility with jest-styled-components
- **Line 3513:** that all containers can store any content. If you write a rule inside

### HelperManager.js

- **Line 36:** that TypeScript and Babel do this differently; TypeScript does a simple existence

### flow.js

- **Line 351:** bracketL has already been consumed
- **Line 363:** both bracketL have already been consumed

### types.js

- **Line 26:** These "type casts" are *not* valid TS expressions.

### typescript.js

- **Line 75:** TypeScript's implementation is much more complicated because
- **Line 241:** In TypeScript implementation we must provide `yieldContext` and `awaitContext`,
- **Line 824:** TS uses parseLeftHandSideExpressionOrHigher,
- **Line 993:** this won't be called unless the keyword is allowed in `shouldParseExportDeclaration`.
- **Line 1466:** The reason we do this in `parseIdentifierStatement` and not `parseStatement`
- **Line 1544:** When the JSX plugin is on, type assertions (`<T> x`) aren't valid syntax.

### statement.js

- **Line 175:** falls through to _var
- **Line 265:** that this can happen either in place of a regular variable declaration

### RootTransformer.js

- **Line 80:** that we always want to enable the imports transformer, even when the import transform

### index.js

- **Line 646:** for future: we could return early if we found an action handler in parseArgs, as none of following code needed?

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 363:** flushing CAN potentially switch us into not-flowing mode

### index.js

- **Line 673:** this'll only find backticks entered in req.query(String)

### request-base.js

- **Line 157:** we do not include ESOCKETTIMEDOUT because that is from `request` package
- **Line 160:** we do not include EADDRINFO because it was removed from libuv in 2014
- **Line 457:** that the reason this doesn't work is because in v13 as compared to v14
- **Line 490:** that for this to work the origin must not be
- **Line 536:** as this method is designed to return a useful non-this value,

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### get.d.ts

- **Line 125:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### jsonify.d.ts

- **Line 5:** The return value has to be `any` and not `unknown` so it can match `void`.
- **Line 67:** The use of tuples in this first condition side-steps distributive conditional types

### index.d.ts

- **Line 2776:** It is intentional that this is not a type guard.
- **Line 2873:** that this is a shallow collection: it only returns `type.types` or `[type]`.

### node-internal-modules-esm-resolve.js

- **Line 258:** fs check redundances will be handled by Descriptor cache here.

### runmain-hack.js

- **Line 6:** that I attempted a try-catch around `Module._load`, but it poisons some sort of cache such that subsequent `import()` is impossible.

### bin.js

- **Line 41:** When transitioning into the child-process after `phase2`,
- **Line 147:** argv and restArgs may be overwritten by child process
- **Line 247:** When we transition to a child process for ESM, the entry-point script determined
- **Line 294:** that we need to explicitly re-resolve the entry-point information in the final
- **Line 316:** resolution relative to cwd option (not `process.cwd()`) is legacy backwards-compat; should be changed in next major: https://github.com/TypeStrong/ts-node/issues/1834
- **Line 470:** eval and repl may both run, but never with stdin.

### file-extensions.js

- **Line 108:** TS's resolver is only used by, and only required for, typechecking.

### index.js

- **Line 285:** fileURLToPath does not exist on early node v10

### repl.d.ts

- **Line 13:** typically, you will want to call `start()` instead of using this method.

### repl.js

- **Line 196:** `code` argument is deprecated
- **Line 205:** deprecated
- **Line 212:** should not be killing the process here, but this codepath is deprecated anyway
- **Line 388:** REPL does not respect sourcemaps!

### resolver-functions.js

- **Line 100:** seems to be called with empty typeDirectiveNames array for all files.

### ts-internals.js

- **Line 13:** This factory returns *only* functions which need a reference to the TS

### index.d.ts

- **Line 1:** named reexports are used instead of `export *` because

### index.js

- **Line 245:** overwritten later (depends on usePolling)

### mapping-list.js

- **Line 41:** The order of the mappings is NOT guaranteed.

### read-wasm.js

- **Line 3:** This file is replaced with "read-wasm-browser.js" when this module is

### url.js

- **Line 9:** This file is overridden in the 'package.json#browser' field to

### index.js

- **Line 64:** that http://stackoverflow.com/a/4467559/3191 does NOT work for large modulos

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### index.js

- **Line 51:** that IE<9 does not support __defineGetter__ or __defineSetter__ so it just renders the method harmless)
- **Line 270:** this constructor is not exported

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

### output.js

- **Line 101:** includes "all" option

### propmangle.js

- **Line 190:** debug is either false (disabled), or a string of the debug suffix to use (enabled).
- **Line 191:** debug may be enabled as an empty string, which is falsy. Also treat passing 'true'

### constants.js

- **Line 112:** object prototypes should not be able to be referenced. e.g. `Object#hasOwnProperty`.

### body.js

- **Line 89:** setting source to a Uint8Array here breaks some mocking assumptions.
- **Line 455:** that streaming decoder is stateful and cannot be reused

### file.js

- **Line 25:** Blob handles this for us

### headers.js

- **Line 47:** webidl conversion to array has already been done.
- **Line 63:** null should throw
- **Line 106:** undici does not implement forbidden header names

### index.js

- **Line 329:** AbortSignal.reason was added in node v17.2.0
- **Line 437:** Since fetching is only called from fetch, body should already be
- **Line 781:** since the connection is destroyed on redirect, which sets fetchParams to a
- **Line 1336:** keepalive is a noop outside of browser context.

### request.js

- **Line 437:** Copy the `set-cookie` meta-data.
- **Line 554:** that headers added in the network layer by the user agent will not

### response.js

- **Line 384:** undici does not implement forbidden response-header names
- **Line 395:** undici does not implement CORS-safelisted response-header names
- **Line 538:** the spec doesn't include async iterables,

### util.js

- **Line 208:** As the referrer-policy can contain multiple policies
- **Line 342:** the fetch spec doesn't make use of embedder policy or CSP list
- **Line 360:** policy cannot (shouldn't) be null or an empty string.
- **Line 369:** node isn't a browser and doesn't implement document/iframes,
- **Line 378:** we need to clone it as it's mutated
- **Line 626:** Chromium blocks the request at this point, but Firefox

### webidl.js

- **Line 424:** DOMString converter perform ? ToString(V)
- **Line 535:** resizable ArrayBuffers are currently a proposal.
- **Line 575:** resizable array buffers are currently a proposal
- **Line 607:** resizable ArrayBuffers are currently a proposal

### util.js

- **Line 67:** "In parallel" just means non-blocking
- **Line 68:** 2: readOperation itself cannot be async as double

### connection.js

- **Line 61:** undici extension, allow setting custom headers.
- **Line 70:** both of these are handled by undici currently.

### v8-compile-cache.js

- **Line 228:** that this actually includes the newline character(s) in the

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### ponyfill.d.ts

- **Line 202:** that the chunks seen in each branch will be the same object. If the chunks are not immutable,
- **Line 757:** that the lock can still be released even if some ongoing writes have not yet finished (i.e. even if the
- **Line 769:** that what "success" means is up to the underlying sink; it might indicate simply that the chunk has been

### parser.js

- **Line 53:** May modify input array

### types.d.ts

- **Line 88:** this is required if nodeClass is not provided.

### base.js

- **Line 21:** Intentionally not using string interpolation for performance reasons.

### tsserver.js

- **Line 183064:** importScripts is synchronous

### tsserverlibrary.js

- **Line 1437:** This means that if a property exists in both `first` and `second`, the property in `first` will be chosen.
- **Line 3208:** We differ here in that we allow X and X.Y, with missing parts having the default
- **Line 3904:** that writing will fail later on if it exists and is not a directory
- **Line 4728:** Ensure this is up-to-date with src/debug/debug.ts
- **Line 4826:** If modifying this enum, must modify `TypeFormatFlags` too!
- **Line 5528:** ES module kinds should be contiguous to more easily check whether a module kind is *any* ES module kind.
- **Line 8088:** Performance optimization - shortcut if the root segments differ as there would be no
- **Line 8096:** Performance optimization - shortcut if there are no relative path segments in
- **Line 10477:** nextLine is in the Zs space, and should be considered to be a whitespace.
- **Line 14268:** This is similar to `isStatement` but does not access parent pointers.
- **Line 14773:** This does not consider whether a name appears as a free identifier or not, so at the expression `x.y` this includes both `x` and `y`.
- **Line 14973:** it is expected that the `nodeArray` and the `node` are within the same file.
- **Line 15853:** that we will not include methods/accessors of a class because they would require
- **Line 18308:** that this doesn't actually wrap the input in double quotes.
- **Line 19134:** This function may use `parent` pointers.
- **Line 19147:** This function does not use `parent` pointers and will not include modifiers from JSDoc.
- **Line 20397:** that this requires file.impliedNodeFormat be set already; meaning it must be set very early on
- **Line 21443:** This requires a node with a valid `parent` pointer.
- **Line 21614:** that this accepts the values 'Infinity', '-Infinity', and 'NaN', and that this is intentional.
- **Line 22224:** Needs cover grammar to disallow JSDoc postfix-optional
- **Line 23005:** The following properties are commonly set by the binder and are added here to
- **Line 23193:** we do not use `setChildren` here because typeArguments in an identifier do not contribute to transformations
- **Line 24836:** without the assignment to `undefined`, we don't narrow the initial type of `cooked`.
- **Line 27502:** It is expected that new lexical init statements must be evaluated before existing lexical init statements,
- **Line 28921:** This always results in a runtime error.
- **Line 30400:** We don't need to care about global import collisions as this is a module.
- **Line 30856:** The version in utilities includes ExclamationToken, which is not a binary operator.
- **Line 31201:** You should not use this, it is only exported to support `createNode` in `~/src/deprecatedCompat/deprecations.ts`.
- **Line 32114:** this function mutates nodes from this SourceFile. That means any existing nodes
- **Line 32200:** 'allowIn' and 'allowYield' track 1:1 with the [in] and [yield] concepts in the ES6
- **Line 32232:** it should not be necessary to save/restore these flags during speculative/lookahead
- **Line 32258:** it is necessary that this value be saved/restored during speculative/lookahead
- **Line 32263:** any errors at the end of the file that do not precede a regular node, should get
- **Line 32810:** it is not actually necessary to save/restore the context flags here.  That's
- **Line 33532:** This may be too conservative.  Perhaps we could reuse the node and set the bit
- **Line 33552:** we *can* reuse tokens when the strict mode changes.  That's because tokens
- **Line 33635:** these are almost certainly not safe to ever reuse.  Expressions commonly
- **Line 33925:** the newlines are important here.  For example, if that above code
- **Line 35163:** for ease of implementation we treat productions '2' and '3' as the same thing.
- **Line 35205:** we call reScanGreaterToken so that we get an appropriately merged token
- **Line 35578:** even when 'IgnoreMissingOpenBrace' is passed, parseBody will still error.
- **Line 35590:** we are passed in an expression which was produced from parseBinaryExpressionOrHigher.
- **Line 35595:** we explicitly 'allowIn' in the whenTrue part of the condition expression, and
- **Line 35930:** to make our lives simpler, we decompose the NewExpression productions and
- **Line 36572:** if token is EqualsToken it is interpreted as CoverInitializedName production
- **Line 37459:** this is not legal as per the grammar.  But we allow it in the parser and
- **Line 38377:** According to usejsdoc.org, a tag goes to end of line, except the last tag.
- **Line 39166:** that y[] is accepted as an entity name, but the postfix brackets are not saved for checking.
- **Line 39258:** passing in 'true' for setNodeParents is very important.  When incrementally
- **Line 39973:** The order here is important to default lib ordering as entries will have the same
- **Line 42929:** used \ in place of / above to avoid issues with multiline comments.
- **Line 45953:** that when properties declared in Javascript constructors
- **Line 46072:** Nested ambient modules always should go to to 'locals' table to prevent their automatic merge
- **Line 47831:** the node text must be exactly "use strict" or 'use strict'.  It is not ok for the
- **Line 48329:** that jsdoc preceding an ExpressionStatement like `x.prototype.y;` is also treated as a declaration.
- **Line 48551:** we check for this here because this class may be merging into a module.  The
- **Line 49248:** we only look at files already found by module resolution,
- **Line 50178:** if target is transient, then it is mutable, and mergeSymbol with both mutate and return it.
- **Line 52229:** that prototype-property assignment to locations outside the current file (eg globals) doesn't work, so
- **Line 55329:** that `new:T` parameters are not handled, but should be before calling this function.
- **Line 57986:** we overwrite links because we just cloned the symbol
- **Line 58609:** that we use the links object as the target here because the symbol object is used as the unique
- **Line 62241:** that the generic type created by this function has no symbol associated with it. The same
- **Line 65243:** that this check ignores type parameters and only considers the
- **Line 66619:** that extraneous children (as in `<NoChild>extra</NoChild>`) don't pass this check,
- **Line 66676:** that these checks are specifically ordered to produce correct results. In particular,
- **Line 67642:** See ~/tests/cases/conformance/types/typeRelationships/assignmentCompatibility/assignmentCompatWithDiscriminatedUnion.ts
- **Line 72558:** that we include any and unknown in the exclusion test because their domain includes null and undefined.
- **Line 73571:** a parameter initializer should refer to class-this unless function-this is explicitly annotated.
- **Line 75474:** we will not warn "children" attribute overwritten if "children" attribute is specified in object spread.
- **Line 75933:** that this is not tracked well within the compiler, so the answer may be incorrect.
- **Line 79695:** Return value of `[]` means a different thing than `undefined`. `[]` means func returns `void`, `undefined` means it returns `never`.
- **Line 80260:** do not raise error if leftType is unknown as related error was already reported
- **Line 80265:** do not raise error if right is unknown as related error was already reported
- **Line 80316:** If property cannot be a SpreadAssignment, then allProperties does not need to be provided
- **Line 80654:** that this and `checkBinaryExpression` above should behave mostly the same, except this elides some
- **Line 80771:** unknown type here denotes error type. Old compiler treated this case as any type so do we.
- **Line 83450:** this is in sync with the transformation that happens for type node.
- **Line 84223:** in ES6 spec initializer is required in variable declarations where name is binding pattern
- **Line 85028:** You probably don't want to call this directly and should be calling
- **Line 86088:** `member` cannot be a synthetic node.
- **Line 86102:** this function can be used for speculative checking,
- **Line 86213:** `member` can be a synthetic node without a parent.
- **Line 86259:** assignability is checked in checkClassDeclaration
- **Line 88011:** that the memberFlags come from previous iteration.
- **Line 88664:** does not handle isShorthandPropertyAssignment (and probably a few more)
- **Line 91558:** Before you can add a new method to `visitEachChildTable`, you must first ensure the `Node` subtype you
- **Line 97660:** when updating logic here also update `getEntityNameForDecoratorMetadata` in checker.ts so that aliases can be marked as referenced
- **Line 99090:** do not add more ancestor flags without also updating AncestorFactsMask below.
- **Line 99817:** see `insertDefaultValueAssignmentForBindingPattern` in es2015.ts
- **Line 101107:** when adding a new ancestor flag, be sure to update the subtree flags below.
- **Line 101484:** return value is emitted only to simplify debugging, call to converted loop body does not do any dispatching on it.
- **Line 102120:** This must be executed *after* the subtree has been visited.
- **Line 102886:** that all assignments to the LHS are emitted in the body, including
- **Line 102888:** also that because an extra statement is needed to assign to the LHS,
- **Line 103329:** that the incrementor of a `for` loop is evaluated in a *new* per-iteration
- **Line 103412:** if loop uses only 'continue' it still will be emitted as simple loop
- **Line 103934:** We use `isPackedArrayLiteral` below rather than just `isArrayLiteral`
- **Line 104155:** This function expects to be called with an original source tree node.
- **Line 104405:** `x` must be an Iterator, not an Iterable.
- **Line 104539:** changes to this enum should be reflected in the __generator helper.
- **Line 105159:** `expression` must be defined for `yield*`.
- **Line 116553:** You probably don't want to call this directly and should be using `emitList` or `emitExpressionList` instead.
- **Line 117231:** that names generated by makeTempVariableName and makeUniqueName will never conflict.
- **Line 118241:** that there is no need to call this function when the program is updated with additional files without reloading config files,
- **Line 118539:** If patchWriteFileEnsuringDirectory has been called,
- **Line 119708:** : Currently we try the real path only if the
- **Line 120773:** body of ambient module is always a module block, if it exists
- **Line 120977:** this only makes sense for case-insensitive file systems, and only on files which are not redirected
- **Line 122949:** that until doneAffected is called it would keep reporting same result
- **Line 123225:** that it is assumed that when asked about binder and checker diagnostics, the file has been taken out of affected files/changed file set
- **Line 124078:** that .d.ts file also has .d.ts extension hence will be part of default extensions
- **Line 126784:** we arent deleting entry if file became missing in new program or
- **Line 130607:** If the node is a modifier, we don't adjust its location if it is the `default` modifier as that is handled
- **Line 130691:** We don't adjust the location of the `default` keyword as that is handled specially by `getSymbolAtLocation`.
- **Line 130990:** that the span of a node's tokens is [node.getStart(...), node.end).
- **Line 131222:** that we also balance out the already provided type arguments, arrays, object literals while doing so
- **Line 133328:** I think we shouldn't actually see resolved module symbols here, but weird merges
- **Line 136155:** this assumes we won't have more than one body in the completion nodes, which should be the case.
- **Line 136899:** 'previousToken' (and thus 'contextToken') can be undefined if we are the beginning of the file
- **Line 137054:** for `<div someBool f>` we don't want to treat this as a jsx inializer, instead it's the attribute name.
- **Line 138333:** if one only performs this step when m.name is an identifier,
- **Line 139551:** 'node' cannot be a SourceFile.
- **Line 141359:** if this is an external module symbol, the name doesn't include quotes.
- **Line 141360:** getLocalSymbolForExportDefault handles `export default class C {}`, but not `export default C` or `export [C as default]`.
- **Line 141501:** that not every construct has been accounted for. This function can
- **Line 145297:** Delete the surrounding trivia because it will have been retained in newImportDecls.
- **Line 145510:** Unfortunately, we will lose trivia that was on this node.
- **Line 146107:** We only have a substring match if the lowercase part is prefix match of some
- **Line 146151:** if the segment contains a space or an asterisk then we must assume that it's a
- **Line 146176:** We only have a substring match if the lowercase part is prefix match of
- **Line 146218:** we may have more pattern parts than candidate parts.  This is because multiple
- **Line 147691:** the subtlety around trailing commas (in getArgumentCount) does not apply
- **Line 147716:** this subtlety only applies to the last comma.  If you had "Foo(a,," then
- **Line 150948:** that we are considering parents only from the same line with initial node -
- **Line 153057:** This is handled in `finishClassesWithNodesInsertedAtStart`.
- **Line 153445:** this may mutate `nodeIn`.
- **Line 153467:** output node may be mutated input node.
- **Line 153922:** We will only delete a comma *after* a node. This will leave a trailing comma if we delete the last node.
- **Line 155304:** this is a mostly copy of `isReferenceToType` from checker.ts. While this violates DRY, it keeps
- **Line 155357:** - the choice of the last call signature is arbitrary
- **Line 156633:** that this is ultimately derived from a map indexed by symbol names,
- **Line 160449:** Some locations are not handled yet:
- **Line 160778:** that the codefix will never fire with an existing `@type` tag, so there is no need to merge tags
- **Line 161805:** that there are cases in which the symbol declaration is not present. For example, in the code below both
- **Line 165346:** If this parameter was already there, it would have been previously updated with the type if not type was present
- **Line 165647:** that we add the current node's type parameters *after* updating the corresponding scope.
- **Line 170195:** while getting todo comments seems like a syntactic operation, we actually
- **Line 170260:** `?:` means 'non-capture group'.  It allows us to have groups without having to
- **Line 170278:** that the outermost group *is* a capture group.  We want to capture the preamble
- **Line 170286:** that the outermost group is *not* a capture group, but the innermost groups
- **Line 172337:** If updating this, be sure to also update `allCommandNames` in `testRunner/unittests/tsserver/session.ts`.
- **Line 173255:** entry is now poisoned since it does not really contain typings for a given combination of compiler options\typings options.
- **Line 176522:** that we need to create a copy of the array since the list of project can change
- **Line 179225:** that configured projects can set skipLibCheck (on by default in jsconfig.json) to
- **Line 179452:** that the value of `isLocal` may depend on whether or not the checker has run on the containing file
- **Line 182072:** Log before writing the response, else the editor can complete its activity before the server does
- **Line 183003:** We only use this "builder" because we don't infer correctly when calling `createOverload` directly in < TS 4.7,
- **Line 183026:** These exports are deprecated in favor of using a `NodeFactory` instance and exist here purely for backwards compatibility reasons.
- **Line 183884:** It is unsafe to change any properties of a `Node` that relate to its AST children, as those changes won't be

### schemas.js

- **Line 811:** `Missing required key: "Key"`,

### app.test.ts

- **Line 273:** In real app, these would be set by helmet middleware

### centralized-config-manager.ts

- **Line 23:** SecretsManager integration available but not required for this implementation

### enhancedKVCacheSession.controller.ts

- **Line 36:** In production, this would be imported from a shared package

### auth.service.ts

- **Line 127:** AxiosError check might not be relevant here if not making HTTP calls within auth service itself

## OPTIMIZE Items (11)

### bundle.js

- **Line 111:** all $refs in the schema), and then crawls the resolved value.

### Subscription.ts

- **Line 194:** for the common case when adding the first subscription.

### index.js

- **Line 91:** for Arrays. Big arrays could kill the performance otherwise!

### index.js

- **Line 171:** error stack

### mocha.js

- **Line 9457:** the case of one listener. Don't need the extra array object.
- **Line 10715:** for the common case where a string is valid.

### index.js

- **Line 249:** for compressibility

### create-logger.js

- **Line 91:** the hot-path which is the single object.

### logger.js

- **Line 224:** for the hotpath of logging JSON literals

### tsserverlibrary.js

- **Line 81486:** for the common case of a call to a function with a single non-generic call

### enhancedKVCacheSession.controller.ts

- **Line 571:** cache performance

## REVIEW Items (13)

### types.d.ts

- **Line 2861:** requests to access organization resources with fine-grained personal access tokens
- **Line 2870:** a request to access organization resources with a fine-grained personal access token
- **Line 4410:** custom deployment protection rules for a workflow run
- **Line 4472:** pending deployments for a workflow run
- **Line 7690:** comments are in ascending order by ID.
- **Line 24253:** Requested Issue Event
- **Line 24271:** Request Removed Issue Event
- **Line 24289:** Dismissed Issue Event

### sequential_chain.d.ts

- **Line 39:** from a New York Times play critic of the above play:`,
- **Line 127:** from a New York Times play critic of the above play:`

### url.js

- **Line 190:** our test case against browsers more comprehensively.

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

### tsserverlibrary.js

- **Line 10447:** 2's-complement if this is confusing.

## TODO Items (1839)

### AdaptiveRateLimiter.test.ts

- **Line 54:** Add tests for RL optimization, clustering, memory pressure, and distributed sync
- **Line 55:** Add performance/load tests for high-traffic scenarios

### bfllmIntegration.test.ts

- **Line 12:** Add tests for API client integration
- **Line 13:** Add tests for caching and retry logic
- **Line 14:** Add tests for LangChain integration

### chatbotWorkflow.test.ts

- **Line 14:** Add tests for response types and error handling

### langchainAgent.test.ts

- **Line 12:** Add tests for Zod input validation on tools
- **Line 13:** Add tests for tool registration and execution
- **Line 14:** Add tests for memory options (inMemory, redis, custom)

### langchainIntegration.test.ts

- **Line 12:** Add tests for runAgentWithInference
- **Line 13:** Add tests for advanced agent workflows

### authService.test.ts

- **Line 12:** Add tests for JWT, RBAC, OAuth/SSO, password reset, 2FA

### evaluationService.test.ts

- **Line 16:** Add tests for actual model evaluation logic
- **Line 17:** Add tests for metrics calculation and aggregation

### integrationsService.test.ts

- **Line 21:** Mock attemptWebhookDelivery to simulate retries
- **Line 47:** Add tests for API integration, event handling, and error propagation
- **Line 48:** Add integration tests for real third-party services when available

### McpService.test.ts

- **Line 50:** Add tests for tool discovery, execution, and error propagation
- **Line 51:** Add integration tests for real llm-mcp service when available

### modelService.test.ts

- **Line 18:** Add tests for registerModel, getModelDetails, updateModel, deleteModel
- **Line 19:** Add tests for predict, generate, analyze, createModelVersion, listModelVersions, checkModelHealth

### SelfHealingSystemMonitor.test.ts

- **Line 63:** Add tests for predictPerformanceDegradation, updatePredictiveModels, assessMaintenanceNeeds
- **Line 64:** Add integration tests for distributed failure, circuit breaker analysis, and failover

### systemService.test.ts

- **Line 8:** Implement test logic
- **Line 25:** Add tests for getSystemMetrics and getModelMetrics
- **Line 26:** Add tests for error handling and edge cases

### index.d.ts

- **Line 21:** [AI-201] Enhance logger configuration to support more transports (e.g., file, remote logging service like ELK stack or Datadog) based on environment (development, staging, production).
- **Line 22:** [AI-202] Implement structured logging for all log messages to improve parseability and searchability in log management systems. Include context like request ID, user ID, etc.
- **Line 23:** [AI-203] Integrate a more sophisticated health check mechanism (beyond a simple HTTP endpoint) that verifies connectivity to dependent services (e.g., database, acllm, acmcp, external model providers). See `acapi/src/routes/health.ts`.
- **Line 24:** [AI-204] Add support for HTTPS and SSL/TLS certificate configuration for production deployments. This should be configurable via environment variables.
- **Line 25:** [AI-205] Implement request correlation IDs (e.g., `X-Request-ID` header) that are generated at the edge or by this service and propagated through all log messages and downstream service calls for better traceability.
- **Line 26:** [AI-206] Refine the graceful shutdown process to allow active requests a configurable timeout period to complete before forcefully closing connections.
- **Line 27:** [AI-207] Explore integration with a process manager like PM2 for production deployments to handle automatic restarts, clustering, and monitoring.
- **Line 28:** [AI-208] Standardize environment variable naming conventions (e.g., all prefixed with `BF_API_`) and document them thoroughly in BFDOCS.
- **Line 29:** [AI-209] Add more detailed startup logging, including loaded configuration values (excluding secrets) and detected feature flags.
- **Line 30:** [AI-210] Consider implementing a maintenance mode feature that can be toggled via an API endpoint or environment variable, returning appropriate HTTP status codes (e.g., 503 Service Unavailable).
- **Line 31:** [AI-211] For unhandled rejections and uncaught exceptions, consider if there are specific types of errors that should trigger different shutdown procedures or alerts (e.g., critical database connection failure vs. a minor background task issue).
- **Line 32:** [AI-212] Integrate with accli for commands like `accli api start`, `accli api status`, `accli api logs` for easier management.

### index.js

- **Line 10655:** Refactor me.
- **Line 10854:** add method description.
- **Line 11719:** add contructor description
- **Line 11759:** add method description
- **Line 11770:** (indexzero): how do we configure this?
- **Line 18421:** can its length be used as dataLevel if nil is removed?
- **Line 20809:** change to reference
- **Line 20875:** var
- **Line 32946:** Add support for other providers (e.g., Memcached) as needed
- **Line 33573:** Add validation for action values

### DitaImporter.php

- **Line 155:** Process map relationships after all topics are imported.
- **Line 306:** Handle keywords

### index.ts

- **Line 8:** Implement proper logging
- **Line 9:** Implement service logic
- **Line 43:** Implement submitDitaJob service function
- **Line 61:** Implement getJobStatus service function

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### formatter.js

- **Line 10:** add [additonal formatters][1]

### js-yaml.js

- **Line 1621:** rework to inline fn with no type cast?
- **Line 3002:** Add tag format check.

### yargs.js

- **Line 217:** make this work with aliases, using a check similar to
- **Line 561:** remove this compatibility hack when we release yargs@15.x:

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### core-js-compat.js

- **Line 1:** Remove in Babel 8

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### source-map-support.js

- **Line 138:** un-copy these from resolve-uri; see if they can be exported from that lib
- **Line 392:** Remove now that windows path support was added to resolve-uri and thus trace-mapping?
- **Line 629:** is there a better way to reliably get an instance of NodeError?

### ajv.bundle.js

- **Line 6248:** normalize IPv6 address as per RFC 5952

### compile.js

- **Line 654:** isJSON true for speed?
- **Line 793:** we don't always need this, remove when no uncertainity?
- **Line 815:** we already know that we have an object here, optimize?
- **Line 922:** perhaps we can optimize this out if dynamic evaluation isn't needed _even with this if processed_
- **Line 1239:** this is draft/next only atm, recheck if dynamicResolve() can fail in runtime and what should happen

### formats.js

- **Line 159:** iri, iri-reference, idn-email, idn-hostname

### index.ts

- **Line 133:** Other constants as well

### api.js

- **Line 540:** Throw more verbose error
- **Line 850:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 908:** Maybe move elsewhere?

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### base.js

- **Line 11:** Make cache key consistent across versions of LangChain.

### manager.js

- **Line 716:** Deprecate async method in favor of this one.

### chat_history.js

- **Line 3:** Combine into one class for 0.2

### base.js

- **Line 189:** Figure out correct value.
- **Line 239:** Fix when we remove the RunnableLambda backwards compatibility shim.

### chat_models.js

- **Line 90:** Remove cast after figuring out inheritance

### index.js

- **Line 11:** Use a star export when we deprecate the

### utils.js

- **Line 31:** Throw an error?
- **Line 177:** Remove this mapper when we deprecate the old message format.

### index.js

- **Line 68:** This should be an abstract method, but we'd like to avoid breaking

### base.js

- **Line 335:** Add input schema for runnables
- **Line 341:** Add output schemas for runnables
- **Line 2087:** Figure out why the compiler needs help eliminating Error as a RunOutput type

### remote.js

- **Line 162:** Start checking for type: ChatPromptValue and ChatPromptValueConcrete
- **Line 170:** Start checking for type: StringPromptValue

### utils.d.ts

- **Line 9:** Refactor and remove.

### log_stream.js

- **Line 100:** Remove this hacky check
- **Line 396:** Remove hack

### tracer_langchain.js

- **Line 115:** Stop using `this.runMap` in favour of LangSmith's `RunTree`

### event_source_parse.js

- **Line 18:** Use Async iteration for both cases?

### chat_models.js

- **Line 177:** Function messages do not support array content, fix cast
- **Line 426:** add support for `addLangChainErrorFields`

### embeddings.js

- **Line 46:** Update to `false` on next minor release (see: https://github.com/langchain-ai/langchainjs/pull/3612)

### index.js

- **Line 5:** remove for consola@3

### index.js

- **Line 129:** type `octokit.auth` based on passed options.authStrategy

### TraceState.js

- **Line 37:** Benchmark the different approaches(map vs list) and
- **Line 78:** Consider to add warning log

### enums.js

- **Line 29:** Add these semantic attributes to:

### sns.js

- **Line 36:** Use SEMATTRS_MESSAGING_DESTINATION_NAME when implemented

### sqs.js

- **Line 90:** How should this be handled?

### instrumentation.js

- **Line 130:** instrument error handlers
- **Line 182:** Fix router spans (getRouterPath does not work properly) to

### instrumentation.js

- **Line 195:** what to do if we are pretty sure it's going to throw

### serverUtils.js

- **Line 73:** Investigate this call/signature – it was inherited from very old

### http.js

- **Line 518:** get error attributes for metrics

### utils.js

- **Line 353:** http.url attribute, it should substitute any parameters to avoid high cardinality.
- **Line 683:** http.target attribute, it should substitute any parameters to avoid high cardinality.

### instrumentation.js

- **Line 39:** : use semantic convention

### instrumentation.js

- **Line 190:** remove the `as ...` casts below when the TS version is upgraded.

### internal.js

- **Line 80:** this is duplicated in basic tracer. Consolidate on a common helper in core
- **Line 113:** SDK types don't provide resource schema URL at this time

### ResourceImpl.js

- **Line 36:** Consider to add check/validation on attributes.

### MetricReader.js

- **Line 25:** use BindOncePromise here once a new version of @opentelemetry/core is available.

### DeltaMetricProcessor.js

- **Line 28:** find a reasonable mean to clean the memo;

### MeterSelector.js

- **Line 30:** semver filter? no spec yet.

### index.js

- **Line 20:** Replace wildcard export with named exports before next major version

### sdk.js

- **Line 274:** This is a workaround to fix https://github.com/open-telemetry/opentelemetry-js/issues/3609

### index.js

- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### code.js

- **Line 128:** do not allow arrays here

### index.js

- **Line 38:** refactor - remove compilations
- **Line 42:** if getFullPath removed 1 tests fails
- **Line 138:** maybe localRefs should hold SchemaEnv
- **Line 170:** returns AnySchemaObject (if the schema can be inlined) or validation function
- **Line 186:** `Object.keys(root.schema).length > 0` should not be needed - but removing breaks 2 tests
- **Line 230:** PREVENT_SCOPE_CHANGE could be defined in keyword def?

### parse.js

- **Line 270:** loopEnum

### resolve.js

- **Line 12:** refactor to use keyword definitions

### util.js

- **Line 22:** refactor to use Set
- **Line 166:** maybe use global escapePointer

### boolSchema.js

- **Line 36:** maybe some other interface should be used for non-keyword validation errors...

### dataType.js

- **Line 128:** use gen.property

### index.js

- **Line 79:** maybe some hook to execute it in the end to check whether props/items are Name, as in assignEvaluated
- **Line 168:** assign unevaluated
- **Line 188:** typecast
- **Line 213:** make it "ok" call?
- **Line 426:** value.code for standalone

### keyword.js

- **Line 94:** add tests

### subschema.js

- **Line 57:** something is possibly wrong here with not changing parentDataProperty and not appending dataPathArr

### core.js

- **Line 379:** return type should be Ajv
- **Line 460:** atm it is allowed to overwrite schemas without id (instead of not adding them)
- **Line 506:** tests fail without this line

### oneOf.js

- **Line 26:** possibly fail straight away (with warning or exception) if there are two empty always valid schemas

### ref.js

- **Line 72:** will not work with async, it has to be returned with the result
- **Line 97:** tagged
- **Line 105:** refactor

### dynamicRef.js

- **Line 26:** the assumption here is that `recursiveRef: #` always points to the root

### format.js

- **Line 31:** simplify

### properties.js

- **Line 132:** maybe an option instead of hard-coded 8?

### pattern.js

- **Line 17:** regexp should be wrapped in try/catchs

### index.ts

- **Line 79:** possibly, it should be readonly

### subschema.ts

- **Line 8:** use Optional? align with SchemCxt property types

### core.ts

- **Line 400:** allow passing schema URI

### jtd-schema.ts

- **Line 133:** we can't actually check that everything in the union was specified
- **Line 177:** currently allows descriminator to be present in schema
- **Line 195:** these should only be allowed at the top level

### dependencies.ts

- **Line 19:** change to string[]

### root-config-schema.js

- **Line 411:** if we want full validation we need to override apis, theme and the root

### config-resolvers.js

- **Line 73:** implement or reuse Resolver approach so it will work in node and browser envs

### spec.js

- **Line 7:** populate with spec-related rules similar to `arazzo1Rules`

### utils.js

- **Line 214:** merge everything else here

### codeframes.js

- **Line 11:** temporary
- **Line 137:** test it

### format.js

- **Line 138:** support multiple location
- **Line 183:** support multiple locations
- **Line 280:** multiple errors

### index.js

- **Line 4:** add a type for "types" https://github.com/DefinitelyTyped/DefinitelyTyped/blob/master/types/js-yaml/index.d.ts

### ref-utils.js

- **Line 75:** proper detection of mapping refs

### ajv.js

- **Line 22:** fix it

### asyncapi2.js

- **Line 8:** validate semver format and supported version
- **Line 186:** strictly this does not cover all cases
- **Line 188:** support official list of schema formats and custom values
- **Line 424:** validate scopes
- **Line 606:** add avro support
- **Line 664:** some fields are subscribe only
- **Line 670:** enum: [1, 2]

### oas2.js

- **Line 74:** verify special $ref handling for Path Item

### oas3.js

- **Line 276:** figure out how to describe/validate this

### redocly-yaml.js

- **Line 156:** depricated in favor of struct
- **Line 405:** add better type tree for this
- **Line 456:** Remove `undefined` assertion from codebase overall
- **Line 926:** deprecated

### utils.js

- **Line 175:** use it everywhere

### walk.js

- **Line 92:** test for walk through duplicated $ref-ed node

### login.test.ts

- **Line 14:** bug with rewrite local config file

### config-resolvers.test.ts

- **Line 230:** fix circular test

### types.ts

- **Line 281:** sync types

### glob-assets.js

- **Line 18:** Temporary workaround for https://github.com/mrmlnc/fast-glob/issues/47

### index.js

- **Line 246:** Make it return a web stream at some point.

### index.js

- **Line 265:** Use `not ''` when the `not` operator is available.
- **Line 270:** Use `not` operator here to remove `Map` and `Set` from type guard:

### context.js

- **Line 84:** Manage own callback registration

### module-asyncify.js

- **Line 78:** we should really figure out generator for the Promise monad...

### runtime.js

- **Line 91:** Does this happen? Are we responsible for disposing? I don't think so

### index.d.ts

- **Line 5:** export * from "./trigger/alexa";
- **Line 25:** export * from "./trigger/cognito-sync";
- **Line 28:** export * from "./trigger/config";

### index.d.ts

- **Line 101:** handling for regex parameters

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### indexable.d.ts

- **Line 2:** these methods are not used within @types/node, and should be removed at the next

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 90:** Add `EventEmitter` close

### globals.d.ts

- **Line 254:** In next major @types/node version, change default TReturn to undefined.

### module.d.ts

- **Line 759:** consider removing in a future major version update

### net.d.ts

- **Line 46:** remove empty ConnectOpts placeholder at next major @types/node version.

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### test.d.ts

- **Line 2275:** change the export to a wrapper function once node@0db38f0 is merged (breaking change)

### timers.d.ts

- **Line 69:** remove in a future major version bump

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### indent.js

- **Line 304:** This is invalid, there can be more than one extends in interface

### no-inferrable-types.js

- **Line 131:** - if we add more references

### no-mixed-enums.js

- **Line 144:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-type-arguments.js

- **Line 68:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 247:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 160:** - we could break down the spread and compare the array type against each argument
- **Line 198:** - handle generic iterable case

### no-unused-vars.js

- **Line 397:** ######

### analyzeChain.js

- **Line 163:** - we could further reduce the false-positive rate of this check by
- **Line 376:** - #7170

### compareNodes.js

- **Line 135:** - handle this once TS supports it (https://github.com/microsoft/TypeScript/issues/42734)

### strict-boolean-expressions.js

- **Line 474:** we have to compare to 0n if the type is bigint
- **Line 479:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 120:** Do we need to investigate the precedence here?
- **Line 153:** JSXElement?

### getContextualType.js

- **Line 62:** - support return statement checking

### isUnsafeAssignment.js

- **Line 65:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 23:** - delete this in next major

### convert.js

- **Line 1657:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 56:** Support Windows CRLF

### createProjectService.js

- **Line 10:** Once we drop support for TS<5.3 we can import from "typescript" directly
- **Line 12:** see getWatchProgramsForProjects

### getWatchProgramsForProjects.js

- **Line 201:** file issue on TypeScript to suggest making optional?
- **Line 258:** this needs refinement and development, but we're allowing users to opt-in to this for now for testing and feedback.

### context.js

- **Line 5:** Use `SourceCode#getAncestors` (we'll be forced to soon)
- **Line 24:** Use `SourceCode#getScope` (we'll be forced to soon)

### RuleCreator.js

- **Line 13:** - when the above PR lands; add type checking for the context.report `data` property

### SourceCode.d.ts

- **Line 279:** rename to 'tokens'

### agent.js

- **Line 196:** need to fix on node itself

### core.js

- **Line 53:** Figure out how to silently coerce Expressions to
- **Line 168:** Not in the Mozilla Parser API, but used by Esprima.
- **Line 188:** Missing from the Parser API.
- **Line 229:** Report this nonsense.

### es6.js

- **Line 17:** This could be represented as a RestElement in .params.

### jsx.js

- **Line 51:** Esprima should return JSXText instead.
- **Line 68:** Does this make sense? Can't really be an JSXElement.
- **Line 74:** Same concern.

### scope.js

- **Line 209:** Broaden this to accept any pattern.

### types.js

- **Line 550:** Warn if fields are overridden with incompatible types.

### constants.js

- **Line 3:** increment this version if there are schema changes

### built-in-definitions.js

- **Line 337:** We should introduce overloaded instance methods definition
- **Line 360:** add async iterator dependencies when we support sub-dependencies

### parseListUnix.js

- **Line 117:** change this if DEVICE_TYPE implemented

### _stream_writable.js

- **Line 265:** defer error events consistently everywhere, not just the cb

### json.js

- **Line 77:** maybe make this configurable or part of "strict" option

### utils.js

- **Line 392:** Make these a separate, strict decoder?

### common.js

- **Line 73:** remove origFn?

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### iso2022.js

- **Line 35:** refactor me

### mbcs.js

- **Line 90:** Do we really need this?
- **Line 201:** This set of data comes from the character frequency-

### sbcs.js

- **Line 69:** 0x20 might not be a space in all character sets...
- **Line 79:** Is this OK? The buffer could have ended in the middle of a word...
- **Line 84:** - This is a bit of a hack to take care of a case

### unicode.js

- **Line 20:** Do some statistics to check for unsigned UTF-16BE
- **Line 41:** Do some statistics to check for unsigned UTF-16LE

### fsevents-handler.js

- **Line 15:** real check
- **Line 503:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-

### lexer.js

- **Line 196:** <!-- XML comment support

### cell.js

- **Line 169:** cells should always exist - some tests don't fill it in though

### concurrently.js

- **Line 14:** Add some tests for this.

### concurrently.spec.ts

- **Line 126:** This is null within Node, but should be 0 outside (eg from real terminal)

### innerSubscribe.d.ts

- **Line 43:** We want to refactor this and remove it. It is retaining values it shouldn't for long

### Notification.ts

- **Line 8:** When this enum is removed, replace it with a type alias. See #4556.

### AjaxObservable.ts

- **Line 329:** Make betterer.

### onErrorResumeNext.ts

- **Line 119:** resolve issue with passing no arguments.

### index.js

- **Line 154:** maybe save() to a url target could be a PUT or something?

### compat.js

- **Line 28:** use `.flatMap` in core-js@4
- **Line 53:** Obsolete, remove from `core-js@4`

### targets-parser.js

- **Line 13:** Remove from `core-js@4`

### basic.d.ts

- **Line 24:** Make it this when targeting TypeScript 4.1:

### index.js

- **Line 10:** Remove String()

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### array-buffer.js

- **Line 64:** remove after dropping support for Node 20.
- **Line 66:** use `ArrayBuffer.transferToFixedLength()` instead once it is available

### prefer-todo.js

- **Line 26:** we should support this too (needs custom fixer)

### eslint-plugin-prettier.js

- **Line 73:** Only use property when our eslint peerDependency is >=8.40.0.

### referencer.js

- **Line 621:** ExportDeclaration doesn't exist. for bc?
- **Line 640:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1021:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 694:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1228:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### base.path.js

- **Line 52:** performance optimization

### openapi.multipart.js

- **Line 11:** check that format: binary (for upload) else do not use multer.any()
- **Line 44:** maybe also check in the api doc if it is a single upload or multiple
- **Line 125:** improve multer error handling

### openapi.request.validator.js

- **Line 150:** Add support for oneOf, anyOf, allOf as the body schema
- **Line 166:** may not always be in this position

### openapi.response.validator.js

- **Line 65:** public for test only - fix me
- **Line 208:** support content other than JSON

### openapi.security.js

- **Line 23:** move the following 3 check conditions to a dedicated upstream middleware
- **Line 44:** handle AND'd and OR'd security
- **Line 160:** oauth2 validation
- **Line 166:** openidconnect validation

### req.parameter.mutator.js

- **Line 144:** handle url encoded?
- **Line 243:** add && !allowReserved to improve performance. When allowReserved is true, commas are common and we do not need to do this extra work
- **Line 257:** is this method still necessary with the new qs processing introduced in the express-5 support
- **Line 347:** improve json check, but ensure its cheap

### schema.preprocessor.js

- **Line 33:** remove me when dropping node 10 support
- **Line 406:** replace with visitor
- **Line 423:** the schema failed to resolve.
- **Line 456:** This does not handle JSON query parameters

### util.js

- **Line 7:** this should recurse or use ajv.getSchema - if implemented as such, may want to cache the result
- **Line 75:** cache schemas - so that we don't recurse every time

### util.js

- **Line 65:** - do this some other way

### utils.js

- **Line 219:** RFC1738 format

### request.js

- **Line 452:** change req.host to return host in next major

### browser.js

- **Line 36:** add a `localStorage` variable to explicitly enable/disable colors

### test-stable.js

- **Line 260:** This is a known limitation of the current implementation.

### uri-js.test.ts

- **Line 734:** Verify this

### BufferSource.js

- **Line 64:** if it should be equivalent ASCII

### StringSource.js

- **Line 98:** handle the scenario when there are multiple lines
- **Line 99:** col should be set to number of chars after last '\n'
- **Line 110:** rename to updateBufferReadIndex

### BaseOutputBuilder.js

- **Line 8:** better to pass tag path

### JsArrBuilder.js

- **Line 79:** set pi flag

### JsMinArrBuilder.js

- **Line 38:** shift this check to the parser
- **Line 63:** TagPathMatcher

### JsObjBuilder.js

- **Line 129:** use bytes join

### booleanParser.js

- **Line 15:** performance: don't convert

### Xml2JsParser.js

- **Line 45:** Separate TagValueParser as separate class. So no scope issue in node builder class
- **Line 120:** this will lead 2 extra stack operation
- **Line 127:** let's user set a stop node boundary detector for complex contents like script tag
- **Line 128:** pass tag name only to avoid string operations
- **Line 168:** shift parsing to output builder
- **Line 193:** return TagPath Object. User can call match method with path
- **Line 221:** if option is set then replace entities

### XmlPartReader.js

- **Line 138:** use regex to verify attributes if not set to ignore

### XmlSpecialTagsReader.js

- **Line 18:** test if tagName is just xml
- **Line 49:** use readChAt like used in partReader

### DocTypeReader.js

- **Line 3:** handle comments

### node2json.js

- **Line 55:** if a node is not an array, then check if it should be an array

### OrderedObjParser.js

- **Line 125:** change regex to capture NS
- **Line 187:** remove this line
- **Line 448:** use jPath to simplify the logic

### browser.js

- **Line 68:** optimize/split up?
- **Line 455:** find out how this code works (debt)
- **Line 2015:** Better tree shaking

### index.js

- **Line 10:** Remove the `...` when https://github.com/tc39/proposal-iterator-helpers is available.

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### Formidable.js

- **Line 169:** too much nesting
- **Line 294:** uncomment when switch tests to Jest
- **Line 445:** use Set/Map and pass plugin name instead of the `idx` index

### JSON.js

- **Line 15:** consider using a string decoder

### index.js

- **Line 5:** Document the `context` option and add to types when I know it's something I want to keep.

### logging-utils.js

- **Line 189:** `fields` needs to be turned into a string here, one way or another.
- **Line 244:** `fields` needs to be turned into a string here.

### index.d.ts

- **Line 66:** replace Function with actual signature

### core.js

- **Line 653:** We need negative look-behind support to do this properly
- **Line 2221:** remove with version 11.0
- **Line 2253:** remove v12, deprecated
- **Line 2404:** remove with v12
- **Line 2474:** Remove with v12 API

### ada.js

- **Line 49:** These spaces are not required by the Ada syntax

### elm.js

- **Line 25:** other constructors (built-in, infix).

### haml.js

- **Line 9:** support filter tags like :javascript, support inline HTML

### haskell.js

- **Line 37:** other constructors (build-in, infix).
- **Line 158:** characters.

### java.js

- **Line 101:** can this be removed somehow?

### julia.js

- **Line 366:** neatly escape normal code in string literal

### less.js

- **Line 129:** find a better solution?

### llvm.js

- **Line 90:** split into different categories of keywords

### markdown.js

- **Line 48:** fix to allow these to work with sublanguage also

### powershell.js

- **Line 66:** 'validate[A-Z]+' can't work in keywords

### python.js

- **Line 159:** Could these be supplemented by a CamelCase matcher in certain

### r.js

- **Line 194:** replace with negative look-behind when available

### swift.js

- **Line 273:** The following characters are also allowed, but the regex isn't supported yet.
- **Line 475:** Update for leading `-` after lookbehind is supported everywhere
- **Line 809:** Interpolation can contain any expression, so there's room for improvement here.

### vbnet.js

- **Line 151:** Use `beforeMatch:` for leading spaces
- **Line 159:** Use `beforeMatch:` for indentation once available

### yaml.js

- **Line 141:** remove |$ hack when we have proper look-ahead support

### index.d.ts

- **Line 107:** Old API, remove with v12

### dbcs-codec.js

- **Line 348:** What if we have no default? (resCode == undefined)
- **Line 472:** Callback with seq.

### dbcs-data.js

- **Line 64:** KDDI extension to Shift_JIS
- **Line 65:** IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
- **Line 66:** IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.

### extend-node.js

- **Line 169:** Set _charsWritten.

### register.js

- **Line 5:** should this be a Set?

### ClusterSubscriber.js

- **Line 168:** should probably disconnect the subscriber and try again.

### index.js

- **Line 31:** Add an option that enables or disables sharded PubSub

### Redis.js

- **Line 356:** We should be able to remove this as the PR has already been merged.

### ipv6.js

- **Line 301:** probably useful to have a numeric version of this too
- **Line 530:** Improve the semantics of this helper function
- **Line 549:** Make private?
- **Line 949:** revisit why this is necessary

### index.js

- **Line 38:** Use `error?.code` when targeting Node.js 14

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### index.d.ts

- **Line 10:** express type of Schema in a type-parameter (.default, .valid, .example etc)
- **Line 1610:** support number and symbol index

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### sign.js

- **Line 239:** Remove in favor of the modulus length check before signing once node 15+ is the minimum supported version

### agent.js

- **Line 82:** Remove in the future. Only for backwards compatibility.
- **Line 213:** Rename input to "intermediate_steps"

### executor.js

- **Line 299:** Update BaseChain implementation on breaking change
- **Line 339:** Update BaseChain implementation on breaking change to include this
- **Line 662:** Deprecate these other parameters

### index.js

- **Line 234:** Add .bind to core runnable interface.

### conversational_retrieval_chain.js

- **Line 160:** Deprecate on a breaking release

### retrieval.js

- **Line 41:** Fix typing by adding withConfig to core RunnableInterface

### generative_agent_memory.js

- **Line 228:** Mock "now" to simulate different times
- **Line 512:** clear memory contents

### generative_agent.js

- **Line 43:** Add support for daily summaries

### node.js

- **Line 3:** Make this the default, add web entrypoint in next breaking release

### runner_utils.js

- **Line 405:** Parallelize and/or put in callbacks to speed up evals.
- **Line 537:** Collect the runs as well.
- **Line 542:** Insert evaluation inline for immediate feedback.

### sql_db.js

- **Line 131:** Potential security issue here

### axios-fetch-adapter.js

- **Line 155:** this needs to be fixed to run in newer browser-like environments

### client.js

- **Line 1013:** Untangle types
- **Line 1090:** make dotted order required when the migration finishes
- **Line 1571:** Add a head request

### _runner.js

- **Line 714:** Deprecate this and rely on interop on 0.2 minor bump.
- **Line 824:** fix this by porting LangChainStringEvaluator to langsmith sdk
- **Line 836:** Remove this, handle outside the manager
- **Line 851:** this is `any`. does it work properly?

### evaluate_comparative.js

- **Line 90:** add URL to the comparative experiment

### langchain.js

- **Line 23:** CallbackManager.configure() is only async due to LangChainTracer

### run_trees.js

- **Line 261:** Deprecate

### traceable.js

- **Line 281:** deal with possible nested promises and async iterables

### index.js

- **Line 456:** Create or update the example in the background

### vercel.js

- **Line 513:** add first_token_time
- **Line 649:** Figure out why this happens.

### mocha.js

- **Line 2708:** add to stats
- **Line 6563:** Replace with `process.browser`

### magic-string.cjs.js

- **Line 131:** is this block necessary?...
- **Line 830:** last chunk in the array may not be the last chunk, if it's moved...
- **Line 1310:** there's a bunch of this sort of thing, needs cleaning up

### index.d.ts

- **Line 1:** Make it this when TS suports that.

### index.js

- **Line 213:** Remove these aliases in the next major version

### utilities.js

- **Line 1:** When targeting Node.js 16, use `String.prototype.replaceAll`.

### index.d.ts

- **Line 1300:** Remove this in meow 14.

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### mime_cli.ts

- **Line 13:** Use json imports to access package.json once "import attributes" are

### index.js

- **Line 48:** remove when Node v8 support drops

### mobxreactlite.cjs.development.js

- **Line 220:** remove in next major

### ObserverComponent.ts

- **Line 3:** this type could be improved in the next major release:

### useObserver.ts

- **Line 17:** optimize to use number?

### mobx.umd.js

- **Line 2083:** deprecate?
- **Line 3558:** replace with atom (breaking change)
- **Line 3979:** ideally, value = change.value would be done here, so that values can be
- **Line 4109:** 'fireImmediately' can be true?
- **Line 4649:** remove in some future build

### async.js

- **Line 2903:** size could be changed

### index.js

- **Line 151:** Replace everything below with `urlObject.pathname = urlObject.pathname.replace(/(?<!\b[a-z][a-z\d+\-.]{1,50}:)\/{2,}/g, '/');` when Safari supports negative lookbehind.

### npx-cli.js

- **Line 9:** remove the affordances for removed items in npm v9

### cache.js

- **Line 82:** - eventually...

### completion.js

- **Line 178:** this was dead code, leaving it in case we find some command we
- **Line 214:** Ignoring coverage, see 'non EPIPE errors cause failures' test.

### config.js

- **Line 128:** complete with valid values, if possible.

### doctor.js

- **Line 118:** when we have an in progress indicator that could go here
- **Line 328:** display layer should do this

### fund.js

- **Line 80:** add !workspacesEnabled option handling to libnpmfund

### link.js

- **Line 165:** write tests for unmatching version specs, this is hard to test

### ls.js

- **Line 300:** there is a LOT of overlap with lib/utils/explain-dep.js here

### outdated.js

- **Line 121:** normalize usage of edges and avoid looping through nodes here

### pkg.js

- **Line 77:** https://github.com/npm/cli/issues/5508 a raw mode has been requested similar

### rebuild.js

- **Line 34:** when extending ReifyCmd
- **Line 78:** add tests for a package with missing version

### npm.js

- **Line 89:** should we throw here?

### display.js

- **Line 390:** this could probably be moved to arborist now that display is refactored

### get-workspaces.js

- **Line 12:** we need a better error to be bubbled up here if this call fails

### reify-output.js

- **Line 19:** output JSON if flatOptions.json is true

### build-ideal-tree.js

- **Line 364:** make buildIdealTree() and loadActual handle a missing root path,
- **Line 533:** create synthetic test case to simulate realpath failure
- **Line 550:** provide a way to fix bundled deps by exposing metadata about
- **Line 1217:** post arborist refactor, will need to check for installStrategy=linked

### index.js

- **Line 94:** we only ever look at this.options.replaceRegistryHost, not
- **Line 110:** We should change these to static functions instead
- **Line 145:** why is includeWorkspaceRoot a param?
- **Line 146:** why is workspaces a param?

### isolated-reifier.js

- **Line 112:** this approach feels wrong
- **Line 166:** make sure that idealTree object exists
- **Line 168:** test workspaces having bundled deps
- **Line 264:** we should probably not reference this.idealTree
- **Line 277:** We should mock better the inventory object because it is used by audit-report.js ... maybe
- **Line 388:** we should no-op is an edge has already been created with the same fromKey and toKey

### load-actual.js

- **Line 58:** remove options param in next semver major

### rebuild.js

- **Line 371:** these run before they're awaited

### reify.js

- **Line 57:** tests should not be this deep into internals
- **Line 330:** rollbacks shouldn't be relied on to throw err
- **Line 1525:** this ignores options.save

### can-place-dep.js

- **Line 366:** represent peerPath in ERESOLVE error somehow?

### node.js

- **Line 122:** if this came from pacote.manifest we don't have to do this,

### query-selector-all.js

- **Line 724:** Need a test with an infinite loop
- **Line 805:** (future) loop over ancestry property

### shrinkwrap.js

- **Line 153:** limit concurrency here, this is recursive
- **Line 212:** what uses this?
- **Line 436:** emit a warning here or something if both are present.

### vuln.js

- **Line 62:** duped entries may require different fixes but the current

### definition.js

- **Line 5:** some kind of categorization system, so we can

### definitions.js

- **Line 87:** refactor these type definitions so that they are less
- **Line 89:** use better type definition/validation API, nopt's is so weird.
- **Line 2253:** this is a derived value, and should be reworked when we have a

### index.js

- **Line 6:** make these getters so that we only have to make dirty
- **Line 10:** move nerfdart auth stuff into a nested object that
- **Line 37:** when we switch off of nopt, use an arg parser that supports

### index.js

- **Line 1:** set the scope config from package.json or explicit cli config
- **Line 821:** evaluate removing 'email' from the credentials object returned here

### type-defs.js

- **Line 60:** make nopt less of a global beast so this kludge isn't necessary

### normalize.js

- **Line 446:** exports is much more complicated than this in verbose format

### diff.js

- **Line 113:** Remove the `+ 1` here to make behavior match Myers algorithm

### index.js

- **Line 81:** When there is more than one value present for a given directive (e.g., two Expires header fields, multiple Cache-Control: max-age directives),

### init-package-json.js

- **Line 48:** test for non-default definitions

### index.js

- **Line 1289:** allow reseeding after first request

### index.js

- **Line 7:** we test this condition in the diff command

### entry.js

- **Line 298:** if the cache write fails, log a warning but return the response anyway

### fetcher.js

- **Line 251:** check error class, once those are rolled out to our deps

### git.js

- **Line 225:** after cloning, create a tarball of the folder, and add to the cache

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### read.js

- **Line 16:** add tests for edit
- **Line 32:** add tests for timeout
- **Line 41:** add tests for edit + default
- **Line 57:** add tests for rejecting
- **Line 66:** add tests for silent
- **Line 73:** add tests for default
- **Line 79:** add tests for sigint

### cert.js

- **Line 142:** test coverage for this case

### entry.js

- **Line 23:** Remove this parameter once have completely switched to 'dsse' entries
- **Line 27:** Remove this conditional once have completely ditched "intoto" entries

### certificate.js

- **Line 113:** Add support for authorityCertIssuer/authorityCertSerialNumber

### index.js

- **Line 9:** this should really be a hardcoded list of algorithms we support,
- **Line 568:** - it's unclear _which_ of these Node will actually use as its name

### mkdir.js

- **Line 4:** This should probably be a class, not functionally

### updater.js

- **Line 251:** use length for fetching

### Document-9b4560a1.js

- **Line 18:** Set true in v2

### Schema-88e323a7.js

- **Line 393:** deprecate/remove class check
- **Line 484:** remove in v2

### index.js

- **Line 436:** move to linter

### core.js

- **Line 55:** handle blob, arraybuffer, other content types, etc.
- **Line 629:** add support for Cloudflare workers, etc.

### AbstractChatCompletionRunner.js

- **Line 310:** support audio here

### EventEmitter.js

- **Line 65:** handle errors

### events.d.ts

- **Line 425:** These should be described using static getter/setter pairs:

### streaming.js

- **Line 58:** Is this where the error should be thrown?

### uploads.js

- **Line 153:** make nested formats configurable

### openapi-sampler.js

- **Line 2389:** implement arrays

### index.js

- **Line 82:** remove this in the next major version

### index.js

- **Line 43:** Use native `finally` keyword when targeting Node.js 10

### dateRange.js

- **Line 69:** implement me!

### compose.js

- **Line 75:** (ronag): highWaterMark?

### destroy.js

- **Line 262:** Remove isRequest branches.
- **Line 273:** Don't lose err?

### end-of-stream.js

- **Line 73:** (ronag): Improve soft detection to include core modules and

### readable.js

- **Line 940:** (ronag): Should this.destroy(err) emit

### transform.js

- **Line 77:** (ronag): This should preferably always be
- **Line 89:** (ronag): 0 is not optimal since we have

### basic.test.ts

- **Line 432:** 2019-03-30 -- We don't really want the indentation in this case? Or at least some better formatting.

### doc.js

- **Line 1246:** Remove this in v4

### prism-groovy.js

- **Line 40:** Slash strings (e.g. /foo/) can contain line breaks but this will cause a lot of trouble with

### prism-perl.js

- **Line 19:** Could be nice to handle Heredoc too.

### prism-wiki.js

- **Line 15:** Multi-line

### index.d.ts

- **Line 155:** Promise?

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### test.js

- **Line 105:** Should we be stricter and perform validation?

### react-dom-server.browser.development.js

- **Line 702:** This prevents the assignment of defaultValue to regular
- **Line 3286:** type this more strictly:
- **Line 3912:** (yungsters): Remove support for children content in <textarea>.

### react-dom-test-utils.development.js

- **Line 1174:** Support the entire DOM.scry query syntax. For now, these simple

### react-dom-unstable-fizz.browser.development.js

- **Line 133:** decide on the top-level export form.

### react-dom-unstable-native-dependencies.development.js

- **Line 243:** If this is a HostRoot we might want to bail out.
- **Line 377:** shouldPreventMouseEvent is DOM-specific and definitely should not
- **Line 918:** (evv): rename timeStamp to timestamp in internal code
- **Line 922:** Instead of making gestures recompute filtered velocity, we could
- **Line 1155:** This shouldn't bubble.
- **Line 1419:** stop one short of the current responder.

### react-dom.development.js

- **Line 291:** See if caughtError and rethrowError can be unified.
- **Line 1885:** Once it's just Fiber we can move this to node._wrapperState
- **Line 2215:** this seems like it could cause a DEV-only throw for hydration
- **Line 2237:** Remove support for `selected` in <option>.
- **Line 3009:** Check if this was a nested HostRoot when used with
- **Line 3591:** It may be a good idea to cache this to prevent unnecessary DOM
- **Line 3800:** Upgrade this definition once we're on a newer version of Flow that
- **Line 3960:** This function shares a lot of logic with attemptToDispatchEvent.
- **Line 4246:** can we stop exporting these?
- **Line 4341:** Warn if _enabled is false.
- **Line 4360:** If this is the first discrete event in the queue. Schedule an increased
- **Line 4365:** Warn.
- **Line 5902:** Only do this for the relevant Safaris maybe?
- **Line 5960:** Handle wasCustomComponentTag
- **Line 6065:** Make sure that we check isMounted before firing any of these events.
- **Line 6153:** Make sure we check if this is still unmounted or do any clean
- **Line 6176:** This cast may not be sound for SVG, MathML or custom elements.
- **Line 6375:** Ensure that an update gets scheduled if any of the special props
- **Line 6500:** Only ignore them on controlled tags.
- **Line 6536:** Warn if there is more than a single textNode as a child.
- **Line 6537:** Should we use domElement.firstChild.nodeValue to compare?
- **Line 6673:** Consider not doing this for input and textarea.
- **Line 6734:** Remove this special case if we can just avoid inserting empty
- **Line 7212:** Distinguish by namespace here -- for <title>, including it here
- **Line 7600:** take namespace into account when validating.
- **Line 7803:** Possibly defer this until the commit phase where all the events
- **Line 7843:** Warn, we didn't find the end comment boundary.
- **Line 9596:** Figure out why `ownerDocument` is sometimes undefined in IE8.
- **Line 10213:** Disabled elements should not respond to mouse events
- **Line 10329:** this looks the same as nextUnitOfWork in scheduler. Can we unify them?
- **Line 10920:** (bvaughn) Replace this behavior with an invariant() in the future.
- **Line 11113:** Consider lifting this into Scheduler.
- **Line 11245:** Remove BlockingMode and ConcurrentMode by reading from the root
- **Line 11257:** Think of a better name for Never. The key difference with Idle is that
- **Line 11291:** This corresponds to Scheduler's NormalPriority, not LowPriority. Update
- **Line 11301:** Should we warn if timeoutMs is lower than the normal pri expiration time?
- **Line 11341:** Handle LowPriority
- **Line 11702:** if it was but can no longer be simple,
- **Line 12129:** Because we don't have a work-in-progress, this will add the
- **Line 12483:** Pass `current` as argument
- **Line 12550:** This should ideally use the true event time of this update rather than
- **Line 12552:** We should skip this update if it was already committed but currently
- **Line 13457:** Clean this up once we turn on the string ref warning for
- **Line 13601:** For the shouldClone case, this could be micro-optimized a bit by
- **Line 13989:** This breaks on empty slots like null children. That's
- **Line 14011:** Move out of the loop. This only happens for the first run.
- **Line 14014:** Defer siblings if we're not at the right index for this slot.
- **Line 14303:** If key === null and child.key === null, then this only applies to
- **Line 14916:** Warn if no hooks are used at all during mount, then some are used during update.
- **Line 15339:** Not sure if this is the desired semantics, but it's what we
- **Line 15522:** If deps are provided, should we skip comparing the ref itself?
- **Line 16746:** Type this specific to this type of component.
- **Line 16840:** Better heuristic.
- **Line 16926:** current can be non-null here even if the component
- **Line 17099:** Move the reset at in beginWork out of the common path so that
- **Line 17286:** Warn in a future release.
- **Line 17317:** Restructure so we never read values from the instance.
- **Line 17923:** Would it be better to store the fallback fragment on
- **Line 18271:** We could fast path by just rendering the tail now.
- **Line 18309:** If workInProgress.child is null, we can continue on the tail immediately.
- **Line 18348:** Consider unifying this with how the root works.
- **Line 18477:** Once we add back resuming, we should check if the children are
- **Line 18720:** This assumes that we're about to evaluate the component and process
- **Line 18910:** Split the update API as separate for the props vs. children.
- **Line 18915:** Experiencing an error where oldProps is null. Suggests a host
- **Line 19089:** Move createInstance to beginWork and keep it on a context
- **Line 19097:** Move this and createInstance step into the beginPhase
- **Line 19214:** This will still suspend a synchronous tree if anything
- **Line 19218:** Move this back to throwException because this is too late
- **Line 19240:** Only schedule updates if these values are non equal, i.e. it changed.
- **Line 19439:** This is meant to mimic the train model or JND but this
- **Line 19454:** We can probably just avoid popping it instead and only
- **Line 19519:** popHydrationState
- **Line 19780:** revisit this when we implement resuming.
- **Line 19900:** (#17945) We should call all passive destroy functions (for all fibers)
- **Line 20216:** Reconsider this implementation trade off.
- **Line 20259:** this is recursive.
- **Line 20376:** Find a more efficient way to do this.
- **Line 20675:** Type the updateQueue to be specific to host components.
- **Line 20875:** Warn in strict mode if getDerivedStateFromError is
- **Line 21070:** Use invariant so the message is stripped in prod?
- **Line 21244:** Should there be a way to opt out, like with `runWithPriority`?
- **Line 21261:** Rename this to computeUserBlockingExpiration
- **Line 21268:** Rename this to... something better.
- **Line 21286:** We shouldn't have to do this if the update is on a different root.
- **Line 21309:** computeExpirationForFiber also reads the priority. Pass the
- **Line 21415:** This happens to work when receiving an update during the render
- **Line 21420:** This does not account for low pri updates that were already
- **Line 21497:** If this is an update, we already read the current time. Pass the
- **Line 21515:** Instead of scheduling a new task, we should be able to change the
- **Line 21945:** Should be able to flush inside batchedUpdates, but not inside `act`.
- **Line 22132:** Consider calling `unwindWork` to pop the contexts.
- **Line 22225:** This should immediately interrupt the current render, instead
- **Line 22405:** The name stopFailedWorkTimer is misleading because Suspense
- **Line 22526:** Might be better if `flushPassiveEffects` did not automatically
- **Line 22708:** Maybe there's a better way to report this.
- **Line 22845:** Should probably move the bulk of this function to commitWork.
- **Line 22873:** findDOMNode doesn't rely on this any more but isMounted does
- **Line 22920:** Only record a mutation effect if primaryEffectTag is non-zero.
- **Line 23077:** This is always sync
- **Line 23107:** If we're rendering sync either due to Sync, Batched or expired,
- **Line 23157:** Special case idle priority?
- **Line 23259:** Track which fiber caused the interruption.
- **Line 23426:** Before we release concurrent mode, revisit this and decide whether a mocked
- **Line 23699:** we can remove these if Rollup fixes the bug.
- **Line 23704:** Consider warning about bad polyfills
- **Line 23764:** remove the User Timing integration in favor of Root Events.
- **Line 24145:** The Profiler fiber shouldn't have a type. It has a tag.
- **Line 24154:** The SuspenseComponent fiber shouldn't have a type. It has a tag.
- **Line 24167:** The SuspenseListComponent fiber shouldn't have a type. It has a tag.
- **Line 24183:** These should not need a type.
- **Line 24870:** Without `any` type, Flow says "Property cannot be accessed on any
- **Line 24955:** throw or warn if we couldn't hydrate?
- **Line 25045:** figure out the API for cross-renderer implementation.
- **Line 25083:** pass ReactDOM portal implementation as third argument

### react.development.js

- **Line 348:** remove in React 17.0.
- **Line 1007:** Test that a single child and an array with one item have the same key
- **Line 1564:** add a more generic warning for invalid values.
- **Line 1984:** Drop this when these are no longer allowed as the type argument.

### test.js

- **Line 309:** fix util.inspect

### index.js

- **Line 118:** Legacy, not needed anymore. Remove in next major version.

### bundle.js

- **Line 333:** make this comparison case-insensitive on windows?

### pako_inflate.js

- **Line 1018:** may be {}
- **Line 1550:** 2 or 1 bytes?

### response.js

- **Line 215:** this

### timeout.js

- **Line 24:** reenable this if there's a way to make it simultaneously

### argsert.js

- **Line 10:** should this eventually raise an exception.

### usage.js

- **Line 223:** hacking around i18n here

### validation.js

- **Line 134:** case-insensitive configurability

### yargs.js

- **Line 257:** actually deprecate self.defaults.
- **Line 377:** deprecate self.demand in favor of

### marked.esm.js

- **Line 2358:** parse inline content if parameter markdown=1

### GenericChildrenSwitcher.d.ts

- **Line 14:** Refactor this component:

### regenerate.js

- **Line 1141:** Optimize this by writing and using `dataIntersectionData()`.

### rewrite-pattern.js

- **Line 670:** consider changing this at the regenerate level.
- **Line 877:** remove modifiers: 'parse' in regexpu-core v7

### rollup.js

- **Line 19065:** we are pretending it was not found while it should behave like "undefined"

### watch.js

- **Line 139:** throws or warn? Currently just ignore, uses new event

### fromSubscribable.d.ts

- **Line 8:** Discuss ObservableInput supporting "Subscribable".

### errorContext.d.ts

- **Line 5:** Remove in v8

### Notification.ts

- **Line 175:** consider removing this check. The only way to cause this would be to

### NotificationFactories.ts

- **Line 31:** This is only exported to support a crazy legacy test in `groupBy`.

### generate.ts

- **Line 346:** Remove this as we move away from deprecated signatures

### finalize.ts

- **Line 67:** This try/finally was only added for `useDeprecatedSynchronousErrorHandling`.

### scan.ts

- **Line 9:** link to a "redux pattern" section in the guide (location TBD)

### switchScan.ts

- **Line 5:** Generate a marble diagram for these docs.

### windowCount.ts

- **Line 100:** We need to figure out if this really makes sense. We're technically

### withLatestFrom.ts

- **Line 66:** At somepoint, we should investigate the performance implications here, and look

### AsyncAction.ts

- **Line 124:** Clean this up when we refactor schedulers mid-version-8 or so.

### throwUnobservableError.ts

- **Line 6:** We should create error codes that can be looked up, so this can be less verbose.

### scheduler.development.js

- **Line 89:** Scheduler no longer requires these methods to be polyfilled. But
- **Line 93:** Remove fb.me link
- **Line 126:** Make this configurable

### scheduler-unstable_mock.development.js

- **Line 282:** Use symbols?

### index.js

- **Line 85:** look into also checking the `bugs`/`homepage` URLs

### range.js

- **Line 489:** build?

### test.js

- **Line 46:** Uncomment once #157 is resolved

### should-equal.js

- **Line 162:** maybe something else like getOwnPropertyNames
- **Line 184:** should i check prototypes for === or use eq?

### should-util.js

- **Line 37:** find better way

### as-function.js

- **Line 2004:** compare types object contains object case

### should.d.ts

- **Line 122:** how to express generators???

### should.js

- **Line 172:** add iterators
- **Line 639:** in future add generators instead of forEach and iterator implementation
- **Line 1389:** it could be nice to inspect its state and value
- **Line 1393:** it could be nice to inspect its state

### parse.js

- **Line 46:** Actually, everything is concatenated into one string

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### styled-components.browser.esm.js

- **Line 1549:** Explore using CSS.escape when it becomes more available
- **Line 2274:** overwrite in-place instead of remove+create?

### react-is.development.js

- **Line 27:** We don't use AsyncMode or ConcurrentMode anymore. They were temporary

### cli.js

- **Line 248:** read exclude

### typescript.js

- **Line 58:** actually a bit more complex in TypeScript, but shouldn't matter.
- **Line 78:** Would be nice to avoid lookahead. Want a hasLineBreakUpNext() method...

### TokenProcessor.js

- **Line 78:** We need to process escapes since technically you can have unicode escapes in variable

### JestHoistTransformer.js

- **Line 37:** This only works if imports transform is active, which it will be for jest.

### CJSImportTransformer.d.ts

- **Line 50:** This function has some awkward overlap with

### getImportExportSpecifierInfo.d.ts

- **Line 31:** There's some redundancy with the type detection here and the isType

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### index.js

- **Line 1099:** unless buffering emit earlier to stream
- **Line 1155:** Add chunked encoding when no length (if err)

### request-base.js

- **Line 165:** expose these as configurable defaults
- **Line 170:** we would need to make this easily configurable before adding it in (e.g. some might want to add POST)

### response-base.js

- **Line 48:** moar!
- **Line 49:** make this a util

### index.js

- **Line 26:** handle specification-extensions with plugins?
- **Line 142:** if we have a nested properties (object inside an object) and the
- **Line 144:** if default is set but type is not set, force type to typeof default
- **Line 724:** verify default
- **Line 1272:** extend to :parameters (not port)?
- **Line 1475:** APIMatic extensions (x-server-configuration) ?

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### index.js

- **Line 10:** Use `node:stream/promises` when targeting Node.js 16.

### index.js

- **Line 366:** don't read, but skip data

### index.js

- **Line 3:** use call-bind, is-date, is-regex, is-string, is-boolean-object, is-number-object
- **Line 12:** use isarray
- **Line 17:** use for-each?
- **Line 26:** use object-keys
- **Line 36:** use reflect.ownkeys and filter out non-enumerables
- **Line 52:** use object.hasown
- **Line 321:** replace with object.assign?

### super_deep.js

- **Line 52:** this one

### index.js

- **Line 1237:** handle type-only imports
- **Line 1354:** this actually references a parameter

### init.js

- **Line 5:** see what's the best path for this

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### node-internal-modules-cjs-helpers.js

- **Line 20:** Use this set when resolving pkg#exports conditions in loader.js.

### node-internal-modules-esm-resolve.js

- **Line 92:** receive cached fs implementations here

### node-options.js

- **Line 50:** handle errors somehow

### bin.js

- **Line 454:** this comes from BootstrapState

### configuration.js

- **Line 303:** technically, outDir is absolute path, but exclude should be relative glob pattern?
- **Line 304:** compute baseUrl

### esm.js

- **Line 103:** file://./foo sets `hostname` to `'.'`.  Perhaps we should special-case this.

### index.js

- **Line 227:** switch to getCanonicalFileName we already create later in scope
- **Line 390:** ordering of this with getScriptVersion?  Should they sync up?

### repl.js

- **Line 126:** Figure out how to handle completion here.
- **Line 156:** should evalCode API get the same error-handling benefits?
- **Line 203:** assert that `service` is set; remove all `service!` non-null assertions

### resolver-functions.js

- **Line 101:** consider using `ts.loadWithTypeDirectiveCache`

### swc.js

- **Line 107:** cache the results of this; slightly faster

### util.js

- **Line 135:** technically breaks if projectOption is path to a file, not a directory,

### rollup.js

- **Line 4335:** deprecate this? not really very useful

### handler.js

- **Line 70:** emit errors properly. Example: EMFILE on Macos.

### index.js

- **Line 107:** this is not equal to path-normalize module - investigate why
- **Line 203:** what if stats is undefined? remove !
- **Line 309:** (43081j): make this more efficient.

### index.js

- **Line 109:** make this more efficient

### url-state-machine.js

- **Line 1074:** If c is not a URL code point and not "%", parse error.
- **Line 1096:** Add: not a URL code point
- **Line 1121:** Use encoding override instead

### urlencoded.js

- **Line 107:** handle encoding override

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### typescript.js

- **Line 13781:** don't use slice
- **Line 19811:** Should prefix `++` and `--` be moved to the `Update` precedence?
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### api-request.js

- **Line 137:** Does this need queueMicrotask?

### api-stream.js

- **Line 127:** Avoid finished. It registers an unnecessary amount of listeners.

### readable.js

- **Line 132:** Implement.
- **Line 146:** Is this the best way to force a lock?

### cache.js

- **Line 623:** the spec is wrong, this is needed to pass WPTs

### client.js

- **Line 384:** for H2 we need to gracefully flush the remaining enqueued
- **Line 405:** (fix): Should we error here with ClientDestroyedError?

### connect.js

- **Line 10:** session re-use does not wait for the first
- **Line 113:** (fix): Can a session become invalid once established? Don't think so?

### request.js

- **Line 313:** (fix): This might be a bad idea?
- **Line 345:** adjust to support H2
- **Line 352:** Migrate header parsing here, to make Requests

### util.js

- **Line 335:** (fix): Why is body[kBodyUsed] needed?

### file.js

- **Line 98:** argument idl type check

### index.js

- **Line 83:** (fix): Find and fix root cause for leaked listener.
- **Line 302:** given global’s relevant settings object’s cross-origin isolated
- **Line 445:** What if request.client is null?
- **Line 553:** should fetching request be blocked as mixed content?
- **Line 554:** should request be blocked by Content Security Policy?
- **Line 1266:** cache
- **Line 1409:** https://github.com/whatwg/fetch/issues/1285#issuecomment-896560129
- **Line 1424:** credentials
- **Line 1430:** proxy-authentication
- **Line 1529:** Invoke some kind of callback?
- **Line 1556:** (spec): The spec doesn't specify this but we need to cancel
- **Line 1973:** (fix): Do we need connection here?

### request.js

- **Line 345:** could this be simplified with AbortSignal.any

### response.js

- **Line 95:** base-URL?

### util.js

- **Line 1004:** add comment explaining why this error occurs.

### RedirectHandler.js

- **Line 43:** (fix): Provide some way for the user to cache the file to e.g. /tmp
- **Line 45:** (fix): Do we need 100-expect support to provide a way to do this properly?
- **Line 60:** (fix): We can't access ReadableStream internal state
- **Line 70:** Should we allow re-using iterable if !this.opts.idempotent

### connection.js

- **Line 96:** enable once permessage-deflate is supported

### receiver.js

- **Line 328:** optimize this

### url-template-test.js

- **Line 331:** Is this acceptable?
- **Line 335:** This will try to match a variable called `@foo` which will fail because it is not in our context. We could catch this by ignoring reserved operators?
- **Line 336:** Same story, but $ is not a reserved operator.
- **Line 341:** Invalid prefixes are ignored. We could throw an error.
- **Line 342:** Best effort is OK?

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### URL-impl.js

- **Line 24:** query stuff

### logger.js

- **Line 49:** add class description.

### tail-file.js

- **Line 23:** add function description.

### file.js

- **Line 614:** What should we do with errors here?

### index.js

- **Line 11:** add property description.

### addPairToJSMap.js

- **Line 12:** Should drop this special case for bare << handling

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### base.js

- **Line 4:** Use a better method when it's added to Node.js (https://github.com/nodejs/node/pull/40240)

### tsserverlibrary.js

- **Line 868:** GH#19873
- **Line 7048:** GH#18217 this is used as if it's certainly defined in many places.
- **Line 10407:** Somehow track edits between file as it was during the creation of sourcemap we have and the current file and
- **Line 12807:** Add codePage support for readFile?
- **Line 14351:** determine what this does before making it public.
- **Line 14367:** GH#19856 Would like to return `node is Node & { jsDoc: JSDoc[] }` but it causes long compile times
- **Line 15786:** (drosen): TaggedTemplateExpressions may eventually support type arguments.
- **Line 20407:** Should this callback be cached?
- **Line 36875:** Review for error recovery
- **Line 39148:** Determine whether we should enforce this in the checker.
- **Line 39149:** Consider moving the `constraint` to the first type parameter as we could then remove `getEffectiveConstraintOfTypeParameter`.
- **Line 39150:** Consider only parsing a single type parameter if there is a constraint.
- **Line 39766:** The below should be strongly type-guarded and not need casts/explicit annotations, since entryOrList is related to
- **Line 39803:** It's probably fine to issue this diagnostic on all instances of the pragma
- **Line 42654:** extend type typeAcquisition
- **Line 45087:** Assert that `resolvedTarget` is actually within the package directory? That's what the spec says.... but I'm not sure we need
- **Line 46068:** Make this a more specific error and decouple it from the exclusion logic.
- **Line 46980:** bindLogicalExpression is recursive - if we want to handle deeply nested `&&` expressions
- **Line 53038:** the below is shared with similar code in `resolveName` - in fact, rephrasing all this symbol
- **Line 53044:** Should this filtered table be cached in some way?
- **Line 55366:** Use `setOriginalNode` on original declaration names where possible so these declarations see some kind of
- **Line 55584:** Issue error via symbol tracker?
- **Line 55833:** `suppressNewPrivateContext` is questionable -we need to simply be emitting privates in whatever scope they were declared in, rather
- **Line 55865:** Handle computed names
- **Line 55936:** implement handling for the localVsRemoteMap.get("remote") - should be difficult to trigger (see comment above), as only interesting cross-file js merges should make this possible
- **Line 56143:** Not part of a file's local or export symbol tables
- **Line 57705:** If back compat with pre-3.0/4.0 libs isn't required, remove the following SymbolConstructor special case transforming `symbol` into `unique symbol`
- **Line 58156:** GH#18217 If `checkBase` is undefined, we should not call this because this will always return false.
- **Line 58183:** GH#18217 Use SourceFile kind check instead
- **Line 58501:** Given that we allow type parmeters here now, is this `!isGenericMappedType(type)` check really needed?
- **Line 61584:** Adopt same permissive behavior in TS as in JS to reduce follow-on editing experience failures (requires editing fillMissingTypeArguments)
- **Line 64121:** Future work: support unions/generics/whatever via a deferred import-type
- **Line 65735:** (drosen): De-duplicate code between related functions.
- **Line 67023:** Stack errors so we get a pyramid for the "normal" comparison above, _and_ a second for this
- **Line 67339:** Find a nice way to include potential conditional type breakdowns in error output, if they seem good (they usually don't)
- **Line 69681:** remove this when we support static private identifier fields and find other solutions to get privateNamesAndStaticFields test to pass
- **Line 70134:** The `allowComplexConstraintInference` flag is a hack! This forbids inference from complex constraints within constraints!
- **Line 73602:** Maybe issue a better error than 'object is possibly undefined'
- **Line 76057:** GH#18217 Use a different variable that's allowed to be undefined
- **Line 81858:** (yuisu): Remove this check in else-if when SyntaxKind.Construct is moved and ambient context is handled
- **Line 82688:** GH#17345: These are methods, so handle computed name case. (`Always allowing computed property names is *not* the correct behavior!)
- **Line 83696:** GH#22580
- **Line 83822:** following line is possible reason for bug #41974, unusedTypeParameters_TemplateTag
- **Line 85469:** Check that target label is valid
- **Line 91008:** The spec needs to be amended to reflect this grammar.
- **Line 91293:** Deprecate and remove support
- **Line 110775:** Do all these accessibility checks inside/after the first pass in the checker when declarations are enabled, if possible
- **Line 111081:** Make safe
- **Line 111658:** GH#33569: Handle element access expressions that created late bound names (rather than silently omitting them)
- **Line 112323:** Remove check and unconditionally use onEmitNode when API is breakingly changed
- **Line 125048:** maybe useful to keep around as an alternative option for certain contexts where the mode is overridable
- **Line 133687:** GH#18217 Debug.assertNever(type);
- **Line 133949:** GH#18217 throw Debug.assertNever(type);
- **Line 134028:** Maybe we should classify these.
- **Line 134041:** This should be predicated on `token["kind"]` being compatible with `HasJSDoc["kind"]`
- **Line 134340:** we should get another classification type for these literals.
- **Line 134344:** (drosen): we should *also* get another classification type for these literals.
- **Line 136092:** support JS files.
- **Line 136829:** GH#15853
- **Line 138332:** Account for computed property name
- **Line 138531:** GH#18169
- **Line 138841:** GH#19856 Would like to return `node is Node & { parent: (ClassElement | TypeElement) & { parent: ObjectTypeDeclaration } }` but then compilation takes > 10 minutes
- **Line 139294:** GH#20090
- **Line 141652:** Cache symbol existence for files to save text search
- **Line 143232:** GH#26162
- **Line 144092:** other tags.
- **Line 146288:** find a way to determine this for any unicode characters in a
- **Line 146329:** find a way to compute this for any unicode characters in a
- **Line 153419:** this emits the file, parses it back, then formats it that -- may be a less roundabout way to do this
- **Line 153758:** only if b would start with a `(` or `[`
- **Line 153880:** There's currently no unused diagnostic for this, could be a suggestion
- **Line 154863:** This does not properly handle `function(new:C, string)` per https://github.com/google/closure-compiler/wiki/Types-in-the-Closure-Type-System#the-javascript-type-language
- **Line 156192:** GH#22492 this will cause an error if a change has been made inside the body of the node.
- **Line 156599:** share a group with fixClassDoesntImplementInheritedAbstractMember?
- **Line 159757:** (https://github.com/Microsoft/TypeScript/issues/21246): use shared helper
- **Line 161316:** use getFalsyflagsOfType
- **Line 164645:** GH#18217 Silly to use `errors ||` since it's definitely not defined (see top of `visit`)
- **Line 165091:** (acasey): test binding patterns
- **Line 165549:** GH#18217 `variableAssignments` not possibly undefined!
- **Line 165619:** (https://github.com/Microsoft/TypeScript/issues/18924): allow this
- **Line 167135:** GH#30113
- **Line 168728:** GH#16312 Return a ReadonlyArray, avoid copying inheritedDocs
- **Line 169452:** GH#18217 frequently asserted as defined
- **Line 170262:** comments can appear in one of the following forms:
- **Line 170264:** or  /////////// TODO
- **Line 170266:** or  /********** TODO
- **Line 170304:** comment code).
- **Line 171297:** GH#18217 Can we just use `if (this.scriptSnapshotShim.dispose)`?
- **Line 172101:** this is used by VS, clean this up on both sides of the interface
- **Line 172109:** it should be moved into a namespace though.
- **Line 172128:** Use a const enum (https://github.com/Microsoft/TypeScript/issues/16804)
- **Line 172762:** assert this offset is actually on the line
- **Line 173223:** add more relevant properties
- **Line 179539:** We might end up with a more logical allocation of refs to defs if we pre-sorted the defs by descending ref-count.
- **Line 179807:** GH#20447 report errors
- **Line 179863:** report errors
- **Line 181223:** avoid duplicate code (with formatonkey)
- **Line 181555:** (https://github.com/microsoft/TypeScript/issues/47839)

### typingsInstaller.js

- **Line 129679:** watch project directory

### schemas.d.ts

- **Line 60:** unions?

### setup-openapi-tools.js

- **Line 269:** Add schema validation logic here

### app.ts

- **Line 35:** [AI-301] Security: Implement more granular CORS configuration, potentially based on environment or specific routes.
- **Line 36:** [AI-302] Security: Enhance rate limiting with more sophisticated strategies (e.g., per user, per route, adaptive). Consider using a persistent store like Redis for distributed rate limiting.
- **Line 37:** [AI-303] Security: Implement robust input sanitization and output encoding, even with OpenAPI validation, as a defense-in-depth measure against XSS and other injection attacks.
- **Line 38:** [AI-304] Performance: Review middleware order for optimal performance. For example, body parsers should generally run before route-specific logic.
- **Line 39:** [AI-305] Performance: Implement caching strategies for frequently accessed, non-dynamic API responses (e.g., using ETags, Cache-Control headers, or a dedicated caching layer like Redis/Memcached).
- **Line 40:** [AI-306] Observability: Integrate distributed tracing (e.g., OpenTelemetry) to trace requests across acapi and other Your Company services like acllm and acmcp.
- **Line 41:** [AI-307] Observability: Expose detailed metrics (e.g., request latency, error rates per endpoint, resource utilization) in a Prometheus-compatible format for monitoring with Grafana. See `acui` for dashboard integration.
- **Line 42:** [AI-308] API Versioning: Develop a more comprehensive API versioning strategy (e.g., header-based, or more explicit URL path segments like /api/v2/). Ensure clear deprecation policies.
- **Line 43:** [AI-309] MCP Integration: Fully implement the `/mcp/tools` endpoint to dynamically register and serve tools from acmcp, including schema validation for tool inputs/outputs.
- **Line 44:** [AI-310] JSON-RPC: Enhance the JSON-RPC endpoint to support batch requests, notifications, and potentially WebSocket transport for real-time communication. Add robust security and authentication.
- **Line 45:** [AI-311] Error Handling: Expand custom error types and ensure the global error handler can map them to appropriate HTTP status codes and error responses as defined in the OpenAPI spec.
- **Line 46:** [AI-312] Configuration: Externalize more configuration settings (e.g., rate limit values, CORS origins, timeouts) using a centralized configuration service or environment variables, managed via `accli config` commands.
- **Line 47:** [AI-313] Dynamic Controller Loading: Refactor dynamic controller imports to be more resilient to errors and potentially allow for hot-reloading of routes during development.
- **Line 48:** [AI-314] Authentication/Authorization: Abstract authentication and authorization logic into dedicated middleware that can be easily applied to routes/controllers. Integrate with `acapi/src/services/auth.service.ts`.
- **Line 49:** [AI-315] OpenAPI Validator: Configure `validateResponses: true` in `express-openapi-validator` for development/staging environments to catch inconsistencies between implementation and spec.
- **Line 50:** [AI-316] Testing: Increase unit test coverage for middleware (especially error handling, auth, logging) and integration tests for all API routes, ensuring they conform to the OpenAPI contract.
- **Line 51:** [AI-317] Dependency Management: Regularly review and update dependencies. Address the TODO for missing type declarations for `compression` and `express-rate-limit`.
- **Line 52:** [AI-318] Internationalization (i18n): Plan for i18n support in API error messages and responses if the platform needs to support multiple languages.
- **Line 53:** [AI-319] Request Body Size Limits: Make the '5mb' limit for `express.json` and `express.urlencoded` configurable per environment or even per route if necessary.
- **Line 54:** [AI-320] Asynchronous Operations: Ensure all asynchronous operations within route handlers and services properly handle promises and use `async/await` consistently to prevent unhandled rejections.
- **Line 55:** [AI-321] Integration with acllm: Define clear interfaces and error handling for interactions with acllm, especially for model inference and agent orchestration calls.
- **Line 56:** [AI-322] Documentation: Ensure all new endpoints and changes are meticulously documented in `openapi.yaml` and that `BFDOCS` reflects the current API capabilities.
- **Line 96:** Investigate and fix missing type declarations for compression and express-rate-limit modules
- **Line 204:** Improve typing for req, res, next parameters
- **Line 325:** Handle invalid OpenAPI document type
- **Line 418:** Extend MCP tools registry with dynamic tool discovery and versioning

### admin.controller.ts

- **Line 25:** [SECURITY] Implement authentication and authorization for all admin endpoints.
- **Line 26:** [SECURITY] Ensure all sensitive operations and admin actions are logged with appropriate severity and context.
- **Line 27:** [BEST PRACTICES] Validate all user input using a schema validator (Joi/Zod) before processing.
- **Line 28:** [OPENAPI] Ensure all endpoints are fully documented and validated against OpenAPI spec.
- **Line 29:** [TEST] Increase test coverage for all endpoints, including error and edge cases.
- **Line 30:** [STABILITY] Add integration tests for user management, system status, and activity endpoints.
- **Line 31:** [STABILITY] Add monitoring hooks for admin failures and suspicious activity.
- **Line 32:** [EXTENSIBILITY] Refactor to support pluggable admin modules in the future.
- **Line 33:** [ERROR HANDLING] Standardize error codes and messages for all API errors.
- **Line 34:** [COMPLIANCE] Ensure audit logging for all admin and data access events.
- **Line 43:** [AI-MDC-TS] Refactor: Replace temporary mock implementations with actual service imports and usage.
- **Line 44:** [AI-MDC-TS] Dependencies: Ensure proper logger and systemService dependencies are injected or imported correctly.
- **Line 52:** [AI-MDC-TS] Error Handling: Add try-catch block to handle potential errors if package.json is not found or parsing fails.
- **Line 53:** [AI-MDC-TS] Type Safety: Define and use an interface for the returned version info object.
- **Line 54:** [AI-MDC-TS] Performance: Consider caching the version info if file reading is a performance concern (though unlikely for package.json).
- **Line 70:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request and Response types.
- **Line 71:** [AI-MDC-TS] Testing: Add unit/integration tests for the health check endpoint.
- **Line 72:** [AI-MDC-TS] Documentation: Add OpenAPI annotation for this endpoint.
- **Line 73:** [AI-MDC-TS] Security: Confirm if this endpoint should genuinely be public or require basic authentication/rate limiting.
- **Line 74:** [AI-MDC-TS] Logging: Enhance logging with request ID and potentially more context.
- **Line 90:** [AI-MDC-TS] Testing: Add unit/integration tests for the version endpoint.
- **Line 92:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access required).
- **Line 93:** [AI-MDC-TS] Logging: Enhance logging with user context and request ID.
- **Line 104:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request, Response, and NextFunction types.
- **Line 105:** [AI-MDC-TS] Testing: Add unit/integration tests for the status endpoint, including success and error cases.
- **Line 109:** [AI-MDC-TS] Error Handling: Use a standardized error response format and potentially more granular error handling based on systemService errors.
- **Line 110:** [AI-MDC-TS] Refactor: Replace mock `getSystemStatus` with the actual imported service call.
- **Line 127:** [AI-MDC-TS] Testing: Add unit/integration tests for the list users endpoint, including filtering and pagination.
- **Line 131:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to list users.
- **Line 137:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request and Response types (including route parameters).
- **Line 138:** [AI-MDC-TS] Testing: Add unit/integration tests for the get user details endpoint, including success and not found cases.
- **Line 140:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access or user's own profile). Validate userId format.
- **Line 142:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to retrieve user details.
- **Line 143:** [AI-MDC-TS] Error Handling: Implement specific error handling for user not found.
- **Line 149:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request and Response types (including request body).
- **Line 150:** [AI-MDC-TS] Testing: Add unit/integration tests for the create user endpoint, including success, validation errors, and service errors.
- **Line 152:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access required). Validate request body for required fields and format.
- **Line 154:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to create a user.
- **Line 155:** [AI-MDC-TS] Error Handling: Implement specific error handling for invalid input (validation) or user creation failures.
- **Line 161:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request and Response types (including route parameters and request body).
- **Line 162:** [AI-MDC-TS] Testing: Add unit/integration tests for the update user endpoint, including success, not found, validation errors, and service errors.
- **Line 164:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access or user's own profile). Validate route parameters (userId) and request body.
- **Line 166:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to update a user.
- **Line 167:** [AI-MDC-TS] Error Handling: Implement specific error handling for user not found, invalid input (validation), or update failures.
- **Line 174:** [AI-MDC-TS] Testing: Add unit/integration tests for the delete user endpoint, including success, not found, and service errors.
- **Line 176:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access required). Validate route parameters (userId).
- **Line 178:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to delete a user.
- **Line 179:** [AI-MDC-TS] Error Handling: Implement specific error handling for user not found or deletion failures.
- **Line 189:** [AI-MDC-TS] Testing: Add unit/integration tests for the API activity endpoint, including filtering and pagination.
- **Line 191:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access required). Validate query parameters.
- **Line 193:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to retrieve API activity logs.
- **Line 194:** [AI-MDC-TS] Performance: Consider pagination and filtering for potentially large activity logs.
- **Line 201:** [AI-MDC-TS] Testing: Add unit/integration tests for the user API activity endpoint, including filtering and pagination.
- **Line 203:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access or user's own activity). Validate route parameters (userId) and query parameters.
- **Line 205:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to retrieve user API activity logs.
- **Line 206:** [AI-MDC-TS] Error Handling: Implement specific error handling for user not found or activity retrieval failures.
- **Line 217:** [AI-MDC-TS] Testing: Add unit/integration tests for the system metrics endpoint, including filtering and data format.
- **Line 221:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to retrieve system metrics (e.g., from Prometheus or other monitoring tools).
- **Line 222:** [AI-MDC-TS] Performance: Consider performance implications for retrieving potentially large sets of metrics.
- **Line 229:** [AI-MDC-TS] Testing: Add unit/integration tests for the model metrics endpoint, including filtering and data format.
- **Line 233:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to retrieve model-specific metrics.
- **Line 244:** [AI-MDC-TS] Testing: Add unit/integration tests for the get settings endpoint.
- **Line 248:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to retrieve system settings.
- **Line 255:** [AI-MDC-TS] Testing: Add unit/integration tests for the update settings endpoint, including success, validation errors, and service errors.
- **Line 257:** [AI-MDC-TS] Security: Implement proper authentication and authorization checks (Admin access required). Validate request body for allowed settings and format.
- **Line 259:** [AI-MDC-TS] Implementation: Replace mock response with actual logic to update system settings.
- **Line 260:** [AI-MDC-TS] Error Handling: Implement specific error handling for invalid input (validation) or settings update failures.

### agent-workflows.controller.ts

- **Line 7:** [AI-MDC-TS] Type Safety: Define explicit TypeScript types for request body, service inputs/outputs, and response data based on OpenAPI spec.
- **Line 8:** [AI-MDC-TS] Validation: Replace manual validation with robust Zod schema validation for the request body matching the OpenAPI specification, including validation for the `steps` array and each step's structure and content.
- **Line 9:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `AgentWorkflowsService.createAgentWorkflow` using APIError with specific error codes and statuses.
- **Line 10:** [AI-MDC-TS] Testing: Add unit/integration tests for `createAgentWorkflow`, covering valid/invalid inputs, service errors, and different workflow step configurations. Create test file at: __tests__/controllers/agent-workflows.controller.test.ts
- **Line 12:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can create agent workflows.
- **Line 13:** [AI-MDC-TS] OpenAPI Alignment: Ensure the request body, response structure, and error responses strictly align with the OpenAPI definition for this endpoint.
- **Line 14:** [AI-MDC-TS] Dependency Injection: Consider using dependency injection for `AgentWorkflowsService` instead of direct import.
- **Line 20:** Define as constant or enum in a shared utility.
- **Line 27:** [llmcli] Ensure input validation for workflow steps.
- **Line 28:** [llmcli] Add integration test for workflow creation.

### agentController.ts

- **Line 64:** Implement agent listing from LangChain registry
- **Line 102:** Implement agent retrieval from LangChain registry
- **Line 249:** Implement agent update in LangChain registry
- **Line 282:** Implement agent deletion from LangChain registry
- **Line 331:** Implement agent execution through LangChain

### ai.controller.ts

- **Line 8:** [SECURITY] Ensure all sensitive operations and AI requests are logged with appropriate severity and context.
- **Line 9:** [BEST PRACTICES] Validate all user input using a schema validator (e.g., Zod, Joi) before processing.
- **Line 12:** [STABILITY] Add integration tests for AI service error handling and edge cases.
- **Line 13:** [STABILITY] Add monitoring hooks for AI failures and suspicious activity.
- **Line 14:** [EXTENSIBILITY] Refactor to support pluggable AI providers in the future.
- **Line 16:** [COMPLIANCE] Ensure audit logging for all AI and data access events.
- **Line 30:** [AI-MDC-TS] Refactor: Replace this basic console logger with the actual logger implementation (e.g., import [logger] from '../../utils/logger';) and potentially use dependency injection.
- **Line 38:** [AI-MDC-TS] Validation: Ensure these Zod schemas are fully comprehensive and strictly align with the OpenAPI specification for these endpoints.
- **Line 39:** [AI-MDC-TS] Type Safety: Generate TypeScript types directly from these Zod schemas or the OpenAPI spec to ensure type safety throughout the controller.
- **Line 76:** [llmcli] Ensure Zod validation covers all request fields.
- **Line 77:** [llmcli] Add integration test for AI service error handling.
- **Line 88:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the `validatedData` object based on the Zod schema to ensure type safety.
- **Line 100:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the `aiResponse` object returned by `aiService.generateDocstring`.
- **Line 188:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the `aiResponse` object returned by `aiService.generateReadme`.
- **Line 193:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the `response` object structure to ensure it matches the OpenAPI definition.
- **Line 235:** [AI-MDC-TS] Error Handling: Implement a more standardized and less string-matching-based approach to handle specific AI service errors. Consider using custom error types or error codes from the AI service.
- **Line 236:** [AI-MDC-TS] Error Handling: Ensure consistent and informative error responses for the client, potentially including the `correlationId` in the error body.
- **Line 280:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the `aiResponse` object returned by `aiService.getSelfHealSuggestion`.

### analyze.controller.ts

- **Line 31:** [SECURITY] Implement authentication and authorization for all endpoints.
- **Line 32:** [SECURITY] Ensure all sensitive operations are logged with appropriate severity and context.
- **Line 33:** [BEST PRACTICES] Validate all user input using a schema validator (e.g., Joi, Zod) before processing.
- **Line 36:** [STABILITY] Add integration tests for batch, RFP, and history endpoints.
- **Line 37:** [STABILITY] Add monitoring hooks for analysis failures and suspicious activity.
- **Line 38:** [EXTENSIBILITY] Refactor to support pluggable analysis providers in the future.
- **Line 40:** [COMPLIANCE] Ensure audit logging for all analysis and data access events.
- **Line 47:** [AI-MDC-TS] Refactor: Replace `require` with `import` for type safety and consistency.
- **Line 48:** [AI-MDC-TS] Refactor: Implement dependency injection for `analyzeService`, `APIError`, and `logger` instead of direct imports/requires.
- **Line 49:** [AI-MDC-TS] Type Safety: Define specific interfaces for `analyzeService`, `APIError`, and `logger` if not already defined.
- **Line 56:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request, Response, and NextFunction types. Define and use interfaces for req.body (document, options), analysis results, and the response payload.
- **Line 57:** [AI-MDC-TS] Validation: Replace manual checks with comprehensive Zod or Joi schema validation for req.body (document structure, content presence, options format) matching OpenAPI spec.
- **Line 58:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific `analyzeService.analyzeDocument` errors (e.g., invalid document format, service unavailability). Use standardized error response format.
- **Line 59:** [AI-MDC-TS] Testing: Add unit/integration tests for the analyzeDocument endpoint, covering success cases, validation errors, service errors, and performance logging.
- **Line 60:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, document identifier (if available), and key options used.
- **Line 61:** [AI-MDC-TS] OpenAPI Alignment: Ensure request/response structure, validation, and error responses strictly align with the OpenAPI definition.
- **Line 62:** [AI-MDC-TS] Performance: Monitor and optimize the performance of the analysis call. Consider adding metrics for processing time and error rate.
- **Line 93:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request, Response, and NextFunction types. Define and use interfaces for req.body (documents array, options), batch results, and the response payload.
- **Line 94:** [AI-MDC-TS] Validation: Replace manual checks with comprehensive Zod or Joi schema validation for req.body (documents array structure, individual document content presence, options format, batch processing options) matching OpenAPI spec.
- **Line 95:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific `analyzeService.analyzeDocumentBatch` errors (e.g., invalid document in batch, partial failures). Use standardized error response format.
- **Line 96:** [AI-MDC-TS] Testing: Add unit/integration tests for the analyzeDocumentBatch endpoint, covering success cases, validation errors, service errors (including partial failures), empty/large batches, and performance logging.
- **Line 97:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, batch size, and key options used.
- **Line 99:** [AI-MDC-TS] Performance: Monitor and optimize the performance of the batch analysis call. Consider adding metrics for total processing time, documents processed per second, and error rate.
- **Line 130:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request, Response, and NextFunction types. Define and use interfaces for req.params (analysisId), analysis results, and the response payload.
- **Line 131:** [AI-MDC-TS] Validation: Add comprehensive Zod or Joi schema validation for req.params (analysisId format) matching OpenAPI spec.
- **Line 132:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific `analyzeService.getDocumentAnalysisResults` errors (e.g., invalid ID format, service unavailability). Ensure standardized error response format.
- **Line 133:** [AI-MDC-TS] Testing: Add unit/integration tests for getDocumentAnalysisResults, covering success cases, not found cases (404), invalid ID format, and service errors.
- **Line 134:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, and analysisId.
- **Line 136:** [AI-MDC-TS] Security: Implement proper authentication and authorization to ensure users can only access analysis results they are permitted to see.
- **Line 137:** [AI-MDC-TS] Performance: Monitor performance for retrieving large analysis results.
- **Line 155:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request, Response, and NextFunction types. Define and use interfaces for req.body (rfpDocument, options), analysis results, and the response payload.
- **Line 156:** [AI-MDC-TS] Validation: Replace manual checks with comprehensive Zod or Joi schema validation for req.body (rfpDocument structure, content presence, options format) matching OpenAPI spec.
- **Line 157:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific `analyzeService.analyzeRFP` errors (e.g., invalid document format, service unavailability). Use standardized error response format.
- **Line 158:** [AI-MDC-TS] Testing: Add unit/integration tests for the analyzeRFP endpoint, covering success cases, validation errors, service errors, and performance logging.
- **Line 159:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, RFP document identifier (if available), and key options used.
- **Line 161:** [AI-MDC-TS] Performance: Monitor and optimize the performance of the RFP analysis call. Consider adding metrics for processing time and error rate.
- **Line 193:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific `analyzeService.getRFPAnalysisResults` errors (e.g., invalid ID format, service unavailability). Ensure standardized error response for analysis not found (404).
- **Line 194:** [AI-MDC-TS] Testing: Add unit/integration tests for getRFPAnalysisResults, covering success cases, not found cases (404), invalid ID format, and service errors.
- **Line 216:** [AI-MDC-TS] Type Safety: Replace 'any' with specific Request, Response, and NextFunction types. Define and use interfaces for req.params (analysisId), req.body (sections, template, options), response data, and the response payload.
- **Line 217:** [AI-MDC-TS] Validation: Replace manual checks with comprehensive Zod or Joi schema validation for req.params (analysisId format) and req.body (sections array structure and content, template format, options format) matching OpenAPI spec.
- **Line 218:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific `analyzeService.generateRFPResponse` errors (e.g., invalid analysisId, invalid sections, service unavailability). Use standardized error response format.
- **Line 219:** [AI-MDC-TS] Testing: Add unit/integration tests for generateRFPResponse, covering success cases, validation errors, service errors, and performance logging.
- **Line 220:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, analysisId, number of sections, template used, and key options.
- **Line 222:** [AI-MDC-TS] Security: Implement proper authentication and authorization to ensure users can only generate responses for analyses they are permitted to access.
- **Line 223:** [AI-MDC-TS] Performance: Monitor and optimize the performance of the response generation call. Consider adding metrics for processing time and error rate.

### auth.controller.ts

- **Line 106:** [INPUT VALIDATION] Validate req.body schema for logout (refreshToken).
- **Line 107:** [LOGGING] Log logout events for audit trail.
- **Line 126:** [INPUT VALIDATION] Validate req.body schema for refresh (refreshToken).
- **Line 127:** [LOGGING] Log token refresh attempts and failures.
- **Line 171:** [INPUT VALIDATION] Validate req.body schema for API key creation (name, expiresIn, permissions).
- **Line 172:** [LOGGING] Log API key creation events with user context.
- **Line 173:** [SECURITY] Ensure API key permissions are validated and restricted.
- **Line 205:** [LOGGING] Log API key listing for audit trail.
- **Line 230:** [INPUT VALIDATION] Validate req.params for keyId.
- **Line 231:** [LOGGING] Log API key revocation events.
- **Line 250:** [LOGGING] Log user profile access for audit trail.
- **Line 277:** [INPUT VALIDATION] Validate req.body schema for user update (name, email).
- **Line 278:** [LOGGING] Log user profile update events.
- **Line 305:** [INPUT VALIDATION] Validate req.body schema for password change (currentPassword, newPassword).
- **Line 306:** [SECURITY] Enforce strong password policy for newPassword.
- **Line 307:** [LOGGING] Log password change attempts and results.
- **Line 330:** [INPUT VALIDATION] Validate req.body schema for refreshToken.
- **Line 331:** [LOGGING] Log refreshToken endpoint usage.

### chatbot.controller.ts

- **Line 27:** [AI-MDC-TS] Logging: Replace console.error with the standard logger utility (e.g., import [logger] from '../../utils/logger';) and potentially use dependency injection.
- **Line 28:** [AI-MDC-TS] Error Handling: Implement standardized error handling using APIError with specific error codes and statuses.
- **Line 29:** [AI-MDC-TS] Type Safety: Define explicit TypeScript types for the `chatbot` instance based on the `ChatbotWorkflow` class interface.
- **Line 30:** [AI-MDC-TS] Dependency Injection: Consider using dependency injection for the `ChatbotWorkflow` instance instead of direct initialization.
- **Line 44:** [AI-MDC-TS] Validation: Replace the simple validation middleware with a more robust Zod schema validation matching the OpenAPI specification for the /message endpoint.
- **Line 47:** [AI-MDC-TS] Refactor: Initialize ChatbotWorkflow via dependency injection.
- **Line 53:** [AI-MDC-TS] Logging: Add logging for incoming message requests, including request ID and user context if available.
- **Line 54:** [AI-MDC-TS] Testing: Add unit/integration tests for the /message endpoint, covering success, validation errors, and service errors.
- **Line 56:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can send messages.
- **Line 58:** [AI-MDC-TS] Logging: Log successful message processing and response.
- **Line 68:** [AI-MDC-TS] Logging: Add logging for conversation reset requests, including request ID and user context if available.
- **Line 69:** [AI-MDC-TS] Testing: Add unit/integration tests for the /reset endpoint, covering success and error cases.
- **Line 70:** [AI-MDC-TS] OpenAPI Alignment: Ensure the response structure and error responses strictly align with the OpenAPI definition for this endpoint.
- **Line 71:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can reset conversations.
- **Line 72:** [AI-MDC-TS] State Management: Review the conversation reset logic in ChatbotWorkflow to ensure it correctly clears state for the user/session.
- **Line 74:** [AI-MDC-TS] Logging: Log successful conversation reset.

### compliance-audit.controller.ts

- **Line 18:** [llmcli] Ensure input validation for audit scope and modelIds.
- **Line 19:** [llmcli] Add integration test for audit initiation.

### drupal.controller.ts

- **Line 6:** Implement service
- **Line 75:** Add webhook handler for GitLab MR merge events to update Drupal nodes/fields

### enhancedKVCacheSession.controller.ts

- **Line 7:** Create comprehensive test suite for EnhancedKVCacheSessionController
- **Line 27:** [AI-MDC-TS] Dependency Management: This controller directly imports from `../../../BFLLM (DEPRECATED - migrate to LangChain)KVCacheManager`. This should be refactored to import from a published package or use dependency injection from the llm-gateway service layer.
- **Line 31:** [AI-MDC-TS] Logging: Ensure this logger import is the standard project logger (e.g., from '../../utils/logger') and consider dependency injection.
- **Line 37:** [AI-MDC-TS] Dependency Management: Address the direct import from another project/module as noted above.
- **Line 40:** [AI-MDC-TS] Type Safety: Define more specific interfaces for `CacheSessionRequest` body and query properties based on the Zod schemas, replacing `any` where possible.
- **Line 43:** [AI-MDC-TS] Type Safety: Define a specific interface or type for `cacheData` based on its expected structure, matching the `cacheDataSchema`.
- **Line 53:** [AI-MDC-TS] Type Safety: Use a boolean type directly in the interface or Zod schema rather than a string that needs parsing.
- **Line 54:** [AI-MDC-TS] Type Safety: Define as an enum type.
- **Line 60:** [AI-MDC-TS] OpenAPI Alignment: Ensure these Zod schemas fully align with the OpenAPI specification for these endpoints.
- **Line 64:** [AI-MDC-TS] Error Handling: Provide more specific error details for regex mismatch.
- **Line 66:** [AI-MDC-TS] Type Safety: Generate TypeScript types directly from these Zod schemas to ensure consistency and reduce manual interface definitions.
- **Line 76:** [AI-MDC-TS] Type Safety: Define a more specific schema or type for the items in the `blocks` array if their structure is known.
- **Line 77:** [AI-MDC-TS] Type Safety: Define a more specific schema or type for metadata structure if known, replacing `z.any()`.
- **Line 78:** [AI-MDC-TS] Type Safety: Define a more specific schema or type for `kvData` structure if known, replacing `z.any()`.
- **Line 86:** [AI-MDC-TS] Type Safety: Define a specific interface for the session metrics object, replacing `any`.
- **Line 90:** [AI-MDC-TS] Dependency Injection: Inject `AdvancedKVCacheManager` instead of initializing it directly within the constructor.
- **Line 113:** [llmcli] Ensure Zod validation covers all request body fields and options.
- **Line 114:** [llmcli] Add integration test for session creation and initialization.
- **Line 122:** [AI-MDC-TS] Validation: Use Zod schema validation for req.body.options instead of a custom validation method, ensuring type safety and OpenAPI alignment.
- **Line 126:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `kvCacheManager.initializeCacheAdvanced`.
- **Line 127:** [AI-MDC-TS] Type Safety: Define a specific interface for the `result` object returned by `initializeCacheAdvanced`.
- **Line 131:** [AI-MDC-TS] Metrics: Ensure session metrics tracking is robust and potentially uses a dedicated metrics service.
- **Line 136:** [AI-MDC-TS] Security: Be mindful of storing potentially sensitive options in session metrics.
- **Line 141:** [AI-MDC-TS] Response Formatting: Ensure the response structure strictly aligns with the OpenAPI definition for a 201 Created response.
- **Line 150:** [AI-MDC-TS] Type Safety: Ensure `sharedBlocks` is typed correctly if it's part of the `result` interface.
- **Line 154:** [AI-MDC-TS] Error Handling: Replace custom handleError with a standardized error middleware or utility that formats errors using APIError.
- **Line 163:** [llmcli] Ensure Zod validation covers session ID parameter and query parameters.
- **Line 164:** [llmcli] Add integration test for session retrieval, including stats inclusion.
- **Line 171:** [AI-MDC-TS] Validation: Use Zod schema validation for req.params.id and req.query.includeStats instead of custom validation methods, ensuring type safety and OpenAPI alignment.
- **Line 176:** [AI-MDC-TS] Logic Review: Check if `this.kvCacheManager.activeRequests` is the correct way to check for session existence. It might represent active requests *using* a session, not the session itself.
- **Line 178:** [AI-MDC-TS] Error Handling: Use APIError with a specific NOT_FOUND error code and status.
- **Line 187:** [AI-MDC-TS] Type Safety: Define a specific interface for the object retrieved from `this.kvCacheManager.activeRequests`.
- **Line 189:** [AI-MDC-TS] Metrics: Retrieve metrics from a standardized metrics system rather than a local Map.
- **Line 193:** [AI-MDC-TS] Metrics: Update metrics in a standardized metrics system.
- **Line 199:** [AI-MDC-TS] Type Safety: Define a specific interface for the `response` object structure, including `sessionData` and `cacheStatistics`.
- **Line 203:** [AI-MDC-TS] Type Safety: Ensure `blocks` property and its type are correctly handled.
- **Line 204:** [AI-MDC-TS] Type Safety: Ensure number type.
- **Line 206:** [AI-MDC-TS] Type Safety: Ensure boolean type.
- **Line 207:** [AI-MDC-TS] Type Safety: Ensure string (ISO date) or Date type.
- **Line 210:** [AI-MDC-TS] Type Safety: Ensure `metadata` property is typed correctly based on the session metrics interface.
- **Line 215:** [AI-MDC-TS] Type Safety: Define a specific interface for the object returned by `kvCacheManager.getAdvancedStats()`.
- **Line 221:** [AI-MDC-TS] Response Formatting: Ensure the response structure strictly aligns with the OpenAPI definition.
- **Line 233:** [llmcli] Ensure Zod validation covers session ID parameter and request body fields.
- **Line 234:** [llmcli] Add integration test for session updates, including different update data.
- **Line 241:** [AI-MDC-TS] Validation: Use Zod schema validation for req.params.id and the request body instead of custom validation methods, ensuring type safety and OpenAPI alignment.
- **Line 246:** [AI-MDC-TS] Logic Review: Check if `this.kvCacheManager.activeRequests` is the correct way to check for session existence.
- **Line 256:** [AI-MDC-TS] Type Safety: Define a specific interface for the `result` returned by `kvCacheManager.updateCacheAdvanced`.
- **Line 257:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `kvCacheManager.updateCacheAdvanced` (e.g., invalid position).
- **Line 292:** [llmcli] Ensure Zod validation covers session ID parameter and query parameters (positions, format, compression).
- **Line 293:** [llmcli] Add integration test for data retrieval, including different positions and formats.
- **Line 300:** [AI-MDC-TS] Validation: Use Zod schema validation for req.params.id and req.query instead of custom validation/parsing methods, ensuring type safety and OpenAPI alignment.
- **Line 315:** [AI-MDC-TS] Type Safety: Define a specific type for the return value of `kvCacheManager.retrieveCache`.
- **Line 316:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `kvCacheManager.retrieveCache` (e.g., invalid positions).
- **Line 330:** [AI-MDC-TS] Type Safety: Define a specific interface for the response object structure.
- **Line 347:** [llmcli] Ensure Zod validation covers source session ID parameter and request body fields (targetSessionId, length).
- **Line 348:** [llmcli] Add integration test for cache sharing, including invalid sessions and lengths.
- **Line 356:** [AI-MDC-TS] Security: Add authorization checks to ensure the user has permission to share the source session and access the target session.
- **Line 380:** [AI-MDC-TS] Type Safety: Define a specific type for the return value of `kvCacheManager.shareCache`.
- **Line 381:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `kvCacheManager.shareCache` (e.g., insufficient space, invalid length).
- **Line 405:** [llmcli] Ensure Zod validation covers session ID parameter.
- **Line 406:** [llmcli] Add integration test for session deletion, including not found cases.
- **Line 413:** [AI-MDC-TS] Validation: Use Zod schema validation for req.params.id instead of a custom validation method, ensuring type safety and OpenAPI alignment.
- **Line 414:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can delete sessions.
- **Line 428:** [AI-MDC-TS] Type Safety: Define a specific type for the return value of `kvCacheManager.releaseCache`.
- **Line 429:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `kvCacheManager.releaseCache`.
- **Line 433:** [AI-MDC-TS] Metrics: Remove metrics from a standardized metrics system.
- **Line 455:** [llmcli] Ensure Zod validation covers includeStats query parameter.
- **Line 456:** [llmcli] Add integration test for listing sessions, including stats inclusion.
- **Line 463:** [AI-MDC-TS] Validation: Use Zod schema validation for req.query.includeStats instead of a custom check.
- **Line 464:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can list sessions.
- **Line 468:** [AI-MDC-TS] Logic Review: Check if `this.kvCacheManager.activeRequests.keys()` is the correct way to get all session IDs.
- **Line 472:** [AI-MDC-TS] Logic Review: Check if `this.kvCacheManager.activeRequests.get(sessionId)` is the correct way to get session data.
- **Line 473:** [AI-MDC-TS] Type Safety: Define a specific interface for the object retrieved from `this.kvCacheManager.activeRequests.get(sessionId)`.
- **Line 475:** [AI-MDC-TS] Metrics: Retrieve metrics from a standardized metrics system.
- **Line 478:** [AI-MDC-TS] Type Safety: Define a specific interface for the session object being mapped.
- **Line 488:** [AI-MDC-TS] Type Safety: Define a specific interface for the metrics object within the session response.
- **Line 525:** [llmcli] Add integration test for retrieving analytics.
- **Line 536:** [AI-MDC-TS] Type Safety: Define a specific interface for the `analytics` object structure.
- **Line 539:** [AI-MDC-TS] Logic Review: Ensure `activeRequests.size` is the correct metric for total sessions.
- **Line 558:** [AI-MDC-TS] Type Safety: Define a specific interface for the `advanced` stats structure if known, replacing `{}` and `any`. Ensure type safety for properties used from `stats.advanced` (e.g., `avgCompressionRatio`).
- **Line 574:** [llmcli] Ensure Zod validation covers the strategy parameter.
- **Line 575:** [llmcli] Add integration test for cache optimization, covering different strategies.
- **Line 582:** [AI-MDC-TS] Validation: Use Zod schema validation for req.body.strategy instead of direct access, ensuring type safety and OpenAPI alignment.
- **Line 583:** [AI-MDC-TS] Type Safety: Define a specific type or enum for the `strategy` parameter.
- **Line 592:** [AI-MDC-TS] Logic Review: Implement the actual cache optimization logic within `kvCacheManager` and call the appropriate method here.
- **Line 623:** [AI-MDC-TS] Utility: Consider moving these utility methods (`generateSessionId`, `validateSessionId`, etc.) to a dedicated utility file or service if they are reused elsewhere.
- **Line 625:** [AI-MDC-TS] Logic Review: Ensure this ID generation strategy is collision-resistant and appropriate for session IDs.
- **Line 632:** [AI-MDC-TS] Validation: Use Zod schema validation directly in the endpoint handler instead of a private method, ensuring consistency and OpenAPI alignment.
- **Line 633:** [AI-MDC-TS] Error Handling: Ensure APIError is used consistently for validation errors, potentially with specific error codes.
- **Line 656:** [AI-MDC-TS] Type Safety: Define a specific interface for the `body` parameter based on the expected update data structure.
- **Line 657:** [AI-MDC-TS] Type Safety: Define specific types for the return object properties (`position`, `kvData`, `attentionWeights`).
- **Line 676:** [AI-MDC-TS] Type Safety: Define a specific interface for the `body` parameter based on the expected share data structure.
- **Line 677:** [AI-MDC-TS] Type Safety: Define specific types for the return object properties (`targetSessionId`, `length`).
- **Line 686:** [AI-MDC-TS] Validation: Call `validateSessionId` within the Zod schema validation for `targetSessionId` instead of here.
- **Line 696:** [AI-MDC-TS] Type Safety: Define a specific return type based on the Zod schema.
- **Line 717:** [AI-MDC-TS] Error Handling: Consistently use APIError with specific error codes and statuses based on the type of error, rather than relying on string matching or generic 500 errors.
- **Line 718:** [AI-MDC-TS] Logging: Enhance logging in the error handler to include more context, such as the original error stack trace and request details.
- **Line 722:** [AI-MDC-TS] Error Handling: Format Zod errors with more detail and potentially specific error codes.
- **Line 733:** [AI-MDC-TS] Resource Management: Ensure the `destroy` method is called appropriately when the application is shutting down to prevent resource leaks.
- **Line 737:** [AI-MDC-TS] Logging: Use the standard logger for the destroy message.
- **Line 743:** [AI-MDC-TS] Refactor: Avoid creating a singleton instance directly here. Instead, the controller should be instantiated and potentially injected in the application setup.

### experiments.controller.ts

- **Line 7:** [AI-MDC-TS] Type Safety: Define explicit TypeScript types for request bodies, request parameters, service inputs/outputs, and response data based on OpenAPI spec.
- **Line 8:** [AI-MDC-TS] Validation: Replace manual validation with robust Zod schema validation for request bodies and parameters matching the OpenAPI specification.
- **Line 9:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `ExperimentsService` using APIError with specific error codes and statuses.
- **Line 10:** [AI-MDC-TS] Testing: Add unit/integration tests for `createExperiment` and `logExperimentMetrics`, covering valid/invalid inputs, service errors, and different scenarios. Create test file at: __tests__/controllers/experiments.controller.test.ts
- **Line 11:** [AI-MDC-TS] Logging: Add logging for incoming requests and successful responses, including request ID and user context if available.
- **Line 12:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can create experiments and log metrics.
- **Line 13:** [AI-MDC-TS] OpenAPI Alignment: Ensure the request bodies, parameters, response structures, and error responses strictly align with the OpenAPI definition for these endpoints.
- **Line 14:** [AI-MDC-TS] Dependency Injection: Consider using dependency injection for `ExperimentsService` instead of direct import.
- **Line 25:** [llmcli] Ensure input validation for experiment fields.
- **Line 26:** [llmcli] Add integration test for experiment creation.

### InferenceController.ts

- **Line 16:** [AI-MDC-TS] Refactor: Replace mock RayVLLMAdapter with actual implementation import and dependency injection.
- **Line 17:** [AI-MDC-TS] Refactor: Define actual interfaces for RayVLLMAdapter and KVCacheManager based on their contracts.
- **Line 19:** [SECURITY] Ensure all sensitive operations and inference requests are logged with appropriate severity and context.
- **Line 23:** [STABILITY] Add integration tests for agent fleet, batch, and streaming endpoints.
- **Line 24:** [STABILITY] Add monitoring hooks for inference failures and suspicious activity.
- **Line 25:** [EXTENSIBILITY] Refactor to support pluggable inference providers in the future.
- **Line 27:** [COMPLIANCE] Ensure audit logging for all inference and data access events.
- **Line 41:** [AI-MDC-TS] Refactor: Replace mock logger with actual logger import (e.g., from '../../utils/logger').
- **Line 50:** [AI-MDC-TS] Refactor: Replace mock APIError class with actual import from '../../middleware/errorHandler'.
- **Line 61:** [AI-MDC-TS] Validation: Consider migrating from Joi to Zod for potentially better TypeScript integration and schema inference.
- **Line 105:** [llmcli] Ensure Joi validation covers all request fields.
- **Line 110:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the request body, response data, and any intermediate variables based on Joi schema and expected service output.
- **Line 111:** [AI-MDC-TS] Validation: Ensure Joi validation covers all required fields and constraints as per OpenAPI spec. Add Zod validation if migrating from Joi.
- **Line 112:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `this.rayAdapter.generate` (e.g., model not found, invalid input). Use standardized error response format.
- **Line 113:** [AI-MDC-TS] Testing: Add unit/integration tests for the generate endpoint, covering success, validation errors, service errors, cache hit/miss scenarios, and OpenTelemetry tracing.
- **Line 114:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, input parameters (safely), and outcome.
- **Line 116:** [AI-MDC-TS] Performance: Review performance of validation and adapter call. Consider adding metrics for latency and error rate.
- **Line 117:** [AI-MDC-TS] Caching: Implement actual caching logic using `this.cacheManager` instead of the heuristic.
- **Line 172:** [llmcli] Add integration test for SSE streaming.
- **Line 174:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the request body, streamed data chunks, completion event, and any intermediate variables based on Joi schema and expected adapter output.
- **Line 175:** [AI-MDC-TS] Validation: Ensure Joi validation covers all required fields and constraints. Add Zod validation if migrating from Joi.
- **Line 176:** [AI-MDC-TS] Error Handling: Implement robust error handling for streaming errors and errors from `this.rayAdapter.generateStream`. Ensure proper error events are sent to the client.
- **Line 177:** [AI-MDC-TS] Testing: Add unit/integration tests for the generateStream endpoint, covering successful streaming, validation errors, adapter errors, client disconnects, and OpenTelemetry tracing.
- **Line 178:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, input parameters (safely), streaming progress, and outcome.
- **Line 179:** [AI-MDC-TS] OpenAPI Alignment: Document this streaming endpoint using OpenAPI and ensure the data format (SSE) and error responses align with the definition.
- **Line 180:** [AI-MDC-TS] Performance: Optimize streaming efficiency, error handling during streaming, and resource management.
- **Line 181:** [AI-MDC-TS] Resource Management: Ensure `streamInterval` is not used here, and that proper cleanup happens on client disconnect.
- **Line 182:** [AI-MDC-TS] Caching: Implement caching for streaming requests if applicable.
- **Line 262:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the request body (based on batchGenerateSchema), individual request results, and the overall response data.
- **Line 263:** [AI-MDC-TS] Validation: Ensure Joi validation for `batchGenerateSchema` is comprehensive and matches OpenAPI spec. Add Zod validation if migrating from Joi.
- **Line 264:** [AI-MDC-TS] Error Handling: Implement robust error handling for individual request failures within the batch. Decide on the strategy for partial failures (e.g., return successful results and list failures).
- **Line 265:** [AI-MDC-TS] Testing: Add unit/integration tests for batchGenerate, covering successful parallel/sequential processing, validation errors, partial failures, full failures, and OpenTelemetry tracing.
- **Line 266:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, batch size, processing mode (parallel/sequential), and summary of results/failures.
- **Line 267:** [AI-MDC-TS] OpenAPI Alignment: Document this endpoint using OpenAPI, ensuring the request/response structure and error handling align with the definition.
- **Line 268:** [AI-MDC-TS] Performance: Monitor and optimize batch processing performance, especially for large batches and sequential processing.
- **Line 269:** [AI-MDC-TS] Resource Management: Ensure efficient use of resources when processing batches, particularly in parallel mode.
- **Line 347:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the request body (based on agentFleetRequestSchema), agent task structure, individual task results, and the overall response data.
- **Line 348:** [AI-MDC-TS] Validation: Ensure Joi validation for `agentFleetRequestSchema` is comprehensive and matches OpenAPI spec. Add Zod validation if migrating from Joi.
- **Line 349:** [AI-MDC-TS] Error Handling: Implement robust error handling for individual task failures within the fleet distribution. Decide on the strategy for partial failures.
- **Line 350:** [AI-MDC-TS] Testing: Add unit/integration tests for agentFleetGenerate, covering different distribution strategies, validation errors, partial/full failures, and OpenTelemetry tracing.
- **Line 351:** [AI-MDC-TS] Logging: Enhance logging with user context, request ID, fleet configuration (agent types, distribution), and summary of results/failures.
- **Line 353:** [AI-MDC-TS] Performance: Monitor and optimize task distribution and parallel execution performance.
- **Line 354:** [AI-MDC-TS] Agent Integration: Replace the mock task distribution logic (`this.distributeToAgentFleet`) and agent type mapping (`this.getAgentType`) with actual integration with an agent manager or orchestration service.

### kvCacheSession.controller.ts

- **Line 44:** Validate sessionId format more strictly (e.g. UUID)
- **Line 49:** Consider logging missing cache session for audit
- **Line 71:** Validate cacheData structure and content
- **Line 74:** Add concurrency control or locking if needed

### learning.controller.ts

- **Line 41:** [llmcli] Ensure input validation for query params.
- **Line 42:** [llmcli] Add integration test for dataset listing.
- **Line 56:** [AI-MDC-TS] Validation: Add Zod schema validation for query parameters (e.g., filters, pagination) and ensure proper type casting.
- **Line 57:** [AI-MDC-TS] Testing: Add specific unit/integration tests for listDatasets endpoint, including various query parameter combinations and error cases.
- **Line 58:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors.
- **Line 86:** [AI-MDC-TS] Testing: Add specific unit/integration tests for getDatasetDetails endpoint, including success and not found cases.
- **Line 130:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the response data object instead of implicit type.
- **Line 131:** [AI-MDC-TS] Validation: Replace manual name check with Zod schema validation for the entire request body (matching OpenAPI spec).
- **Line 132:** [AI-MDC-TS] Testing: Add specific unit/integration tests for createDataset endpoint, including success, validation errors, and service errors.
- **Line 133:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., duplicate name).
- **Line 134:** [AI-MDC-TS] OpenAPI Alignment: Ensure request body validation and response structure strictly align with the OpenAPI definition.
- **Line 183:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the request body updates and response data.
- **Line 184:** [AI-MDC-TS] Validation: Add Zod schema validation for request parameters (datasetId) and the request body (updates) matching OpenAPI spec.
- **Line 185:** [AI-MDC-TS] Testing: Add specific unit/integration tests for updateDataset endpoint, including success, not found, validation errors, and service errors.
- **Line 187:** [AI-MDC-TS] OpenAPI Alignment: Ensure request parameters, request body, and response structure strictly align with the OpenAPI definition.
- **Line 227:** [AI-MDC-TS] Type Safety: Ensure correct typing for the `success` variable returned by `learningService.deleteDataset`.
- **Line 228:** [AI-MDC-TS] Testing: Add specific unit/integration tests for deleteDataset endpoint, including success and not found cases.
- **Line 230:** [AI-MDC-TS] OpenAPI Alignment: Ensure response status (204) and absence of body on success strictly align with the OpenAPI definition.
- **Line 264:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the samples array returned by `learningService.listSamples` and for the response data.
- **Line 265:** [AI-MDC-TS] Validation: Add Zod schema validation for request parameters (datasetId) and query parameters (e.g., filters, pagination).
- **Line 266:** [AI-MDC-TS] Testing: Add specific unit/integration tests for listSamples endpoint, including success, not found, various query parameter combinations, and error cases.
- **Line 267:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., dataset not found handled, but others?).
- **Line 268:** [AI-MDC-TS] OpenAPI Alignment: Ensure request parameters, query parameters, and response structure strictly align with the OpenAPI definition.
- **Line 306:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the sample object returned by `learningService.getSample` and for the response data.
- **Line 307:** [AI-MDC-TS] Validation: Add Zod schema validation for request parameters (datasetId, sampleId) matching OpenAPI spec.
- **Line 308:** [AI-MDC-TS] Testing: Add specific unit/integration tests for getSample endpoint, including success and not found cases.
- **Line 309:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., dataset/sample not found handled, but others?).
- **Line 310:** [AI-MDC-TS] OpenAPI Alignment: Ensure request parameters and response structure strictly align with the OpenAPI definition.
- **Line 520:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the feedback array returned by `learningService.listFeedback` and for the response data.
- **Line 521:** [AI-MDC-TS] Validation: Add Zod schema validation for query parameters (e.g., filters, pagination).
- **Line 522:** [AI-MDC-TS] Testing: Add specific unit/integration tests for listFeedback endpoint, including various query parameter combinations and error cases.
- **Line 524:** [AI-MDC-TS] OpenAPI Alignment: Ensure query parameters and response structure strictly align with the OpenAPI definition.
- **Line 552:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the feedback object returned by `learningService.getFeedbackDetails` and for the response data.
- **Line 553:** [AI-MDC-TS] Validation: Add Zod schema validation for request parameters (feedbackId) matching OpenAPI spec.
- **Line 554:** [AI-MDC-TS] Testing: Add specific unit/integration tests for getFeedbackDetails endpoint, including success and not found cases.
- **Line 555:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., feedback not found handled, but others?).
- **Line 598:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the request body (modelId, datasets, hyperparameters, options) and for the response data (job object).
- **Line 599:** [AI-MDC-TS] Validation: Replace manual check with Zod schema validation for the request body matching OpenAPI spec (including validating array items). Implement validation for datasets array contents (e.g., valid dataset IDs).
- **Line 600:** [AI-MDC-TS] Testing: Add specific unit/integration tests for startTrainingJob endpoint, including success, validation errors, and service errors.
- **Line 601:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., invalid modelId, invalid dataset IDs).
- **Line 602:** [AI-MDC-TS] OpenAPI Alignment: Ensure request body validation, response status (201), and response structure strictly align with the OpenAPI definition.
- **Line 628:** [AI-MDC-TS] Type Safety: Define and use specific interfaces for the jobs array returned by `learningService.listTrainingJobs` and for the response data.
- **Line 630:** [AI-MDC-TS] Testing: Add specific unit/integration tests for listTrainingJobs endpoint, including various query parameter combinations and error cases.
- **Line 660:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the job object returned by `learningService.getTrainingJobStatus` and for the response data.
- **Line 661:** [AI-MDC-TS] Validation: Add Zod schema validation for request parameters (jobId) matching OpenAPI spec.
- **Line 662:** [AI-MDC-TS] Testing: Add specific unit/integration tests for getTrainingJobStatus endpoint, including success and not found cases.
- **Line 663:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., job not found handled, but others?).
- **Line 697:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the job object returned by `learningService.cancelTrainingJob` and for the response data.
- **Line 699:** [AI-MDC-TS] Testing: Add specific unit/integration tests for cancelTrainingJob endpoint, including success and not found cases.
- **Line 700:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific learningService errors (e.g., job not found handled, or job already completed/cancelled?).

### model-performance.controller.ts

- **Line 6:** Implement automatic model performance monitoring with metrics collection
- **Line 7:** Add intelligent model selection based on performance history
- **Line 8:** Create anomaly detection for model performance degradation
- **Line 9:** Implement A/B testing framework for model performance comparison
- **Line 10:** Add cost optimization based on performance/cost tradeoffs
- **Line 13:** [AI-MDC-TS] Testing: Add unit/integration tests for `getModelPerformance`, including valid/invalid inputs, service errors, and different model/timeRange combinations. Create test file at: __tests__/controllers/model-performance.controller.test.ts
- **Line 16:** [AI-MDC-TS] Security: Add authentication and authorization checks to ensure only authorized users can access model performance metrics.
- **Line 17:** [AI-MDC-TS] Dependency Injection: Consider using dependency injection for `ModelPerformanceService` instead of direct import.
- **Line 18:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `ModelPerformanceService.getModelPerformance` (e.g., model not found) using APIError with specific error codes and statuses.

### model.controller.ts

- **Line 73:** [AI-MDC-TS101] Define Specific Types: Replace all uses of `any` (especially in service calls and response formatting) with specific TypeScript interfaces.
- **Line 74:** [AI-MDC-TS112] Define Controller Interface: Define an interface for this controller's shape for consistency.
- **Line 154:** [AI-MDC-TS] Refine status typing: The status property typing is problematic.
- **Line 162:** Define a more specific schema for artifacts
- **Line 184:** Define as constant/enum
- **Line 220:** [AI-MDC-TS102] Input Validation: Implement robust input validation (e.g., using zod, class-validator) potentially via middleware.
- **Line 221:** [AI-MDC-TS103] Error Handling: Catch specific errors from modelService and map to appropriate APIError codes/statuses. Use type guards for error handling.
- **Line 222:** [AI-MDC-TS104] Caching Strategy: Review cache keys and invalidation logic. Consider more sophisticated caching based on request parameters or tags. Ensure cache utility is robust.
- **Line 223:** [AI-MDC-TS105] Logging: Enhance logging with request IDs, user context (if available), and more details on errors and successful operations. Remove redundant logging (e.g., logging failure in both controller and service).
- **Line 224:** [AI-MDC-TS106] Authentication/Authorization: Add checks using auth middleware or services to ensure users have appropriate permissions for actions like register/update/delete/fine-tune/deploy.
- **Line 225:** [AI-MDC-TS107] Response Formatting: Standardize response formats, potentially using a dedicated response utility or conforming strictly to OpenAPI definitions.
- **Line 226:** [AI-MDC-TS108] OpenAPI Alignment: Ensure all request parameters, bodies, and responses align precisely with the definitions in `openapi.yaml`.
- **Line 227:** [AI-MDC-TS109] Async Operations: For long-running operations like fine-tuning or batch processing, consider implementing asynchronous patterns (e.g., returning a job ID and providing a status endpoint) instead of potentially long-held HTTP requests.
- **Line 228:** [AI-MDC-TS110] Test Coverage: Add integration tests for controller methods, mocking the `ModelService` and `cache`.
- **Line 229:** [AI-MDC-TS111] Hardcoded Strings: Replace hardcoded error codes/messages (e.g., 'MODEL_NOT_FOUND') with constants or an error catalog.
- **Line 236:** [llmcli] Ensure Zod validation covers all query params.
- **Line 237:** [llmcli] Add integration test for cache hit/miss logic.
- **Line 240:** [llmcli] Add error mapping for service errors.
- **Line 246:** Consider query params in cache key
- **Line 264:** Add configurable TTL
- **Line 342:** [AI-MDC-TS-SVC-001] ModelService.listModelVersions might be missing or have a different signature.
- **Line 376:** [AI-MDC-TS-SVC-002] ModelService.getModelVersionDetails might be missing or have a different signature.
- **Line 587:** [AI-MDC-TS-SVC-003] ModelService.createEmbeddings might be missing or have a different signature.
- **Line 641:** [AI-MDC-TS-SVC-004] ModelService.processBatch might be missing or have a different signature.
- **Line 711:** [AI-MDC-TS-SVC-005] ModelService.startFineTune might be missing or have a different signature.
- **Line 743:** [AI-MDC-TS-SVC-006] ModelService.getFineTuneStatus might be missing or have a different signature.
- **Line 800:** This looks like direct manipulation of a service's internal state. Refactor to use a proper service method if needed.
- **Line 865:** Define specific type for request body and validate with Zod
- **Line 982:** [AI-MDC-TS-SVC-022] ModelService.createModelVersion might be missing or have a different signature.
- **Line 1009:** Define Zod schema for request body and validate
- **Line 1026:** [AI-MDC-TS-SVC-007] ModelService.updateModelVersion might be missing or have a different signature.
- **Line 1065:** [AI-MDC-TS-SVC-008] ModelService.deleteModelVersion might be missing or have a different signature.
- **Line 1153:** [AI-MDC-TS-SVC-009] ModelService.deployModelToEnvironment might be missing or have a different signature.
- **Line 1177:** Add Zod schema for query params (modelId, versionId, environment, status)
- **Line 1194:** [AI-MDC-TS-SVC-010] ModelService.listDeployments might be missing or have a different signature.
- **Line 1221:** [AI-MDC-TS-SVC-011] ModelService.getDeploymentDetails might be missing or have a different signature.
- **Line 1255:** Define Zod schema for request body (status) and validate
- **Line 1277:** [AI-MDC-TS-SVC-012] ModelService.updateDeploymentStatus might be missing or have a different signature.
- **Line 1311:** Add Zod schema for request body (benchmarkType, options) and validate
- **Line 1334:** Define validBenchmarkTypes as a constant or enum
- **Line 1347:** [AI-MDC-TS-SVC-013] ModelService.runBenchmark might be missing or have a different signature.
- **Line 1373:** Add Zod schema for request body (modelIds, comparisonType) and validate
- **Line 1403:** Define validComparisonTypes as a constant or enum
- **Line 1415:** [AI-MDC-TS-SVC-014] ModelService.compareModels might be missing or have a different signature.
- **Line 1604:** Add Zod schema for search query params and validate
- **Line 1605:** [AI-MDC-TS102] Input Validation: Ensure Zod schema for query params is robust and matches OpenAPI.
- **Line 1606:** [AI-MDC-TS103] Error Handling: Catch specific errors from ModelService.searchModels and map to appropriate APIError codes/statuses.
- **Line 1607:** [AI-MDC-TS105] Logging: Enhance logging with request ID and user context.
- **Line 1608:** [AI-MDC-TS106] Authentication/Authorization: Add authentication/authorization checks if search is restricted.
- **Line 1609:** [AI-MDC-TS107] Response Formatting: Standardize response format for search results per OpenAPI.
- **Line 1610:** [AI-MDC-TS108] OpenAPI Alignment: Ensure query parameters and response structure align with `openapi.yaml`.
- **Line 1611:** [AI-MDC-TS110] Test Coverage: Add integration tests for searchModels, including edge cases (empty query, no results, errors).
- **Line 1633:** [AI-MDC-TS-SVC-018] ModelService.searchModels might be missing or have a different signature.
- **Line 1660:** Define Zod schema for request body and validate (environment, confirmed?)
- **Line 1661:** [AI-MDC-TS102] Input Validation: Ensure Zod schema for body is robust and matches OpenAPI.
- **Line 1662:** [AI-MDC-TS103] Error Handling: Catch specific errors from ModelService.deployModelVersion and map to appropriate APIError codes/statuses (e.g., MODEL_VERSION_NOT_FOUND, DEPLOYMENT_FAILED).
- **Line 1663:** [AI-MDC-TS105] Logging: Enhance logging for deployment initiation and potential failures.
- **Line 1664:** [AI-MDC-TS106] Authentication/Authorization: Add authorization checks for deployment permission, especially to production.
- **Line 1665:** [AI-MDC-TS107] Response Formatting: Standardize response format for deployment result (e.g., returning a job ID or deployment status) per OpenAPI.
- **Line 1666:** [AI-MDC-TS108] OpenAPI Alignment: Ensure parameters, body, and response align with `openapi.yaml`.
- **Line 1667:** [AI-MDC-TS109] Async Operations: This is likely an async operation. Ensure the response (202 Accepted with job details) and error handling align with the async nature.
- **Line 1668:** [AI-MDC-TS110] Test Coverage: Add integration tests for deployModelVersion, including environment validation, confirmation logic, and service interactions.
- **Line 1717:** [AI-MDC-TS-SVC-018] ModelService.deployModelVersion might be missing or have a different signature.
- **Line 1722:** Based on service response, determine appropriate HTTP status (e.g., 200 OK if sync, 202 Accepted if async).
- **Line 1745:** [AI-MDC-TS103] Error Handling: Catch specific errors from ModelService.deployModelToEnvironment and map to appropriate APIError codes/statuses (e.g., MODEL_NOT_FOUND, DEPLOYMENT_FAILED).
- **Line 1751:** [AI-MDC-TS110] Test Coverage: Add integration tests for deployModelToEnvironment, including environment validation, confirmation logic, and service interactions.
- **Line 1800:** [AI-MDC-TS-SVC-019] ModelService.deployModelToEnvironment might be missing or have a different signature.

### monitoringController.ts

- **Line 5:** Create comprehensive test suite for MonitoringController
- **Line 31:** Add more specific types for insight data structure.
- **Line 37:** Add more specific types for alert data structure.
- **Line 45:** Add Zod schema for validating DashboardFilters
- **Line 57:** Add Zod schema for validating AlertConfiguration
- **Line 60:** [AI-MDC-TS] Define interfaces for response data structures for all endpoints based on OpenAPI spec.
- **Line 66:** [llmcli] Add OpenAPI contract test for this endpoint.
- **Line 67:** [llmcli] Ensure all filters are validated and documented.
- **Line 68:** [llmcli] Add integration test for dashboard data aggregation.
- **Line 69:** [llmcli] Log user context and request ID for audit.
- **Line 70:** [llmcli] Refactor to use typed response per OpenAPI.
- **Line 71:** [llmcli] Add contract test for error scenarios.
- **Line 72:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameters based on DashboardFilters interface and OpenAPI spec.
- **Line 73:** [AI-MDC-TS] Error Handling: Implement more specific error handling for issues during data fetching or processing.
- **Line 74:** [AI-MDC-TS] Testing: Add unit/integration tests for getDashboard, covering different filter combinations and error scenarios.
- **Line 85:** [AI-MDC-TS] Type Safety: Define and use interfaces for dashboardData and realtimeMetrics.
- **Line 89:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the response object structure.
- **Line 107:** [AI-MDC-TS] Error Handling: Use a standardized error response format.
- **Line 120:** [llmcli] Add integration test for real-time streaming.
- **Line 122:** [AI-MDC-TS] Error Handling: Implement proper error handling for streaming errors.
- **Line 123:** [AI-MDC-TS] Resource Management: Ensure resources (setInterval) are properly cleaned up on disconnect.
- **Line 124:** [AI-MDC-TS] Testing: Add unit/integration tests for getRealtimeStream, focusing on connection handling and data format.
- **Line 125:** [AI-MDC-TS] Performance: Consider optimizing the streaming interval and data format for large-scale deployments.
- **Line 139:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the initialData.
- **Line 145:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the metrics and streamData.
- **Line 177:** [llmcli] Add integration test for AI insights filtering and enrichment.
- **Line 181:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameters (severity, type, limit) matching OpenAPI spec.
- **Line 183:** [AI-MDC-TS] Testing: Add unit/integration tests for getAIInsights, covering different filter combinations, data enrichment logic, and error scenarios.
- **Line 184:** [AI-MDC-TS] Type Safety: Define and use interfaces for insights, enrichedInsights, and the response data structure.
- **Line 192:** [AI-MDC-TS] Type Safety: Define and use an interface for dashboardData structure, specifically the insights array.
- **Line 197:** [AI-MDC-TS] Code Clarity: Use more descriptive variable names than 'insights' for filtered results.
- **Line 208:** [AI-MDC-TS] Type Safety: Define and use an interface for the enriched insight objects.
- **Line 242:** [llmcli] Add integration test for predictive alerts and forecasts.
- **Line 246:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameters (timeHorizon, minProbability) matching OpenAPI spec.
- **Line 248:** [AI-MDC-TS] Testing: Add unit/integration tests for getPredictiveAlerts, covering different filter combinations, data generation logic, and error scenarios.
- **Line 249:** [AI-MDC-TS] Type Safety: Define and use interfaces for alerts, forecasts, and the response data structure.
- **Line 256:** [AI-MDC-TS] Type Safety: Define and use an interface for dashboardData structure, specifically the alerts array.
- **Line 266:** [AI-MDC-TS] Type Safety: Define and use an interface for the forecasts data structure.
- **Line 295:** [llmcli] Add integration test for performance analytics and optimization suggestions.
- **Line 299:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameters (component, timeRange) matching OpenAPI spec.
- **Line 301:** [AI-MDC-TS] Testing: Add unit/integration tests for getPerformanceAnalytics, covering different filter combinations, data generation logic, and error scenarios.
- **Line 302:** [AI-MDC-TS] Type Safety: Define and use interfaces for the analytics and response data structures.
- **Line 309:** [AI-MDC-TS] Type Safety: Define and use a specific interface for the analytics object structure.
- **Line 340:** [llmcli] Add integration test for security monitoring data retrieval.
- **Line 344:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameters (timeRange, threatLevel) matching OpenAPI spec.
- **Line 346:** [AI-MDC-TS] Testing: Add unit/integration tests for getSecurityMonitoring, covering different filter combinations, data generation logic, and error scenarios.
- **Line 347:** [AI-MDC-TS] Type Safety: Define and use interfaces for the securityData and response data structures.
- **Line 382:** [llmcli] Add integration test for cost optimization insights.
- **Line 386:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameter (timeRange) matching OpenAPI spec.
- **Line 388:** [AI-MDC-TS] Testing: Add unit/integration tests for getCostOptimization, covering different filter combinations, data generation logic, and error scenarios.
- **Line 389:** [AI-MDC-TS] Type Safety: Define and use interfaces for the costData and response data structures.
- **Line 422:** [llmcli] Ensure all query parameters are validated and documented.
- **Line 423:** [llmcli] Add integration test for data export functionality.
- **Line 426:** [AI-MDC-TS] Validation: Implement Zod schema validation for request query parameters (format, timeRange, components) matching OpenAPI spec. Validate format enum.
- **Line 427:** [AI-MDC-TS] Error Handling: Implement more specific error handling for issues during data generation or conversion.
- **Line 428:** [AI-MDC-TS] Testing: Add unit/integration tests for exportData, covering different formats, filter combinations, and error scenarios.
- **Line 429:** [AI-MDC-TS] Type Safety: Define and use interfaces for the exportData and response data structures.
- **Line 430:** [AI-MDC-TS] Performance: Consider handling large data exports efficiently (e.g., streaming, pagination).
- **Line 469:** [llmcli] Ensure request body is validated and documented.
- **Line 470:** [llmcli] Add integration test for alert configuration persistence.
- **Line 474:** [AI-MDC-TS] Validation: Replace manual validation with Zod schema validation for the request body based on AlertConfiguration interface and OpenAPI spec.
- **Line 475:** [AI-MDC-TS] Error Handling: Implement more specific error handling for issues during configuration validation or saving.
- **Line 476:** [AI-MDC-TS] Testing: Add unit/integration tests for configureAlerts, covering valid/invalid configurations, persistence, and error scenarios.
- **Line 477:** [AI-MDC-TS] Security: Ensure proper access control for this sensitive endpoint.
- **Line 478:** [AI-MDC-TS] Persistence: Implement robust persistence logic for saving alert configurations.
- **Line 512:** [llmcli] Add integration test for Prometheus metrics retrieval.
- **Line 515:** [AI-MDC-TS] Error Handling: Implement more specific error handling for issues during metrics retrieval.
- **Line 516:** [AI-MDC-TS] Testing: Add unit/integration tests for getMetrics.
- **Line 517:** [AI-MDC-TS] Documentation: Document the available Prometheus metrics and their meaning.

### performanceController.ts

- **Line 5:** Create comprehensive test suite for PerformanceController
- **Line 71:** [AI-MDC-TS???] Type Safety: Define and use specific interfaces for `metrics` object received from `performanceEngine.getMetrics()` instead of `any`.
- **Line 72:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the response data object instead of implicit type and `any`.
- **Line 75:** [llmcli] Add integration test for metrics aggregation.
- **Line 239:** [llmcli] Add integration test for cost optimization rules persistence.
- **Line 243:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the request body and for the response data.
- **Line 244:** [AI-MDC-TS???] Validation: Replace manual validation with Zod schema validation for the request body matching OpenAPI spec.
- **Line 245:** [AI-MDC-TS???] Error Handling: Implement more specific error handling for issues during configuration validation or saving.
- **Line 246:** [AI-MDC-TS???] Testing: Add unit/integration tests for updateCostOptimizationRules, covering valid/invalid configurations, persistence, and error scenarios.
- **Line 247:** [AI-MDC-TS???] Security: Ensure proper access control for this sensitive endpoint.
- **Line 300:** [llmcli] Add integration test for performance targets persistence.
- **Line 307:** [AI-MDC-TS???] Testing: Add unit/integration tests for updatePerformanceTargets, covering valid/invalid configurations, persistence, and error scenarios.
- **Line 361:** [llmcli] Add integration test for triggering optimization.
- **Line 365:** [AI-MDC-TS???] Error Handling: Implement more specific error handling for issues during optimization triggering.
- **Line 366:** [AI-MDC-TS???] Testing: Add unit/integration tests for triggerOptimization, covering success and error scenarios.
- **Line 367:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the response data.
- **Line 390:** [llmcli] Ensure all filters and pagination parameters are validated and documented.
- **Line 391:** [llmcli] Add integration test for optimization history retrieval.
- **Line 395:** [AI-MDC-TS???] Type Safety: Define and use interfaces for the history items, analytics, pagination, and the overall response data structure.
- **Line 396:** [AI-MDC-TS???] Validation: Implement Zod schema validation for request query parameters (limit, offset, type) matching OpenAPI spec.
- **Line 397:** [AI-MDC-TS???] Error Handling: Implement more specific error handling for issues during data retrieval or processing.
- **Line 398:** [AI-MDC-TS???] Testing: Add unit/integration tests for getOptimizationHistory, covering different filter/pagination combinations, data calculations, and error scenarios.
- **Line 399:** [AI-MDC-TS???] Code Clarity: Refactor complex calculations (success rate, actions by type) into separate helper methods for better readability.
- **Line 458:** [llmcli] Add integration test for real-time performance dashboard data retrieval.
- **Line 462:** [AI-MDC-TS???] Type Safety: Define and use interfaces for the metrics, report, dashboard, and response data structures.
- **Line 463:** [AI-MDC-TS???] Error Handling: Implement more specific error handling for issues during data fetching or processing.
- **Line 464:** [AI-MDC-TS???] Testing: Add unit/integration tests for this getDashboard method, covering data aggregation and error scenarios.
- **Line 502:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the `metrics` parameter structure.
- **Line 503:** [AI-MDC-TS???] Testing: Add unit tests for calculateSystemStatus, covering different metrics scenarios (healthy, warning, critical, unknown).
- **Line 504:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose and parameters.
- **Line 505:** [AI-MDC-TS???] Configuration: Consider making the thresholds (90%, 1000ms, 0.05) configurable.
- **Line 521:** [AI-MDC-TS???] Testing: Add unit tests for calculatePerformanceScore, covering various metrics inputs and edge cases.
- **Line 522:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose, parameters, and scoring logic.
- **Line 523:** [AI-MDC-TS???] Configuration: Consider making the weights (0.3, 0.25, 0.2) and scaling factors (10, 2000) configurable.
- **Line 524:** [AI-MDC-TS???] Code Clarity: Add comments to explain the scoring logic and calculations for each metric.
- **Line 550:** [AI-MDC-TS???] Testing: Add unit tests for identifyOptimizationOpportunities, covering different metrics scenarios and thresholds.
- **Line 551:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose, parameters, and the logic for identifying opportunities.
- **Line 577:** [AI-MDC-TS???] Testing: Add unit tests for calculatePerformanceGrade, covering different performance scores and grade boundaries.
- **Line 578:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose, parameters, and grading logic.
- **Line 579:** [AI-MDC-TS???] Configuration: Consider making the grade boundaries (90, 80, 70, 60) configurable.
- **Line 589:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the `history` array items.
- **Line 590:** [AI-MDC-TS???] Testing: Add unit tests for calculateOptimizationScore, covering different history data and edge cases (empty history, no successful actions).
- **Line 592:** [AI-MDC-TS???] Code Clarity: Add comments to explain the scoring logic and calculations (e.g., how 'impact' contributes).
- **Line 593:** [AI-MDC-TS???] Configuration: Consider making the number of recent actions (10) configurable.
- **Line 604:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the `costAnalysis` parameter structure.
- **Line 605:** [AI-MDC-TS???] Testing: Add unit tests for calculateCostEfficiency, covering different cost analysis inputs and edge cases.
- **Line 606:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose, parameters, and calculation logic.
- **Line 607:** [AI-MDC-TS???] Code Clarity: Add comments to explain the calculation logic.
- **Line 616:** [AI-MDC-TS???] Testing: Add unit tests for calculateReliabilityScore, covering different metrics inputs and edge cases.
- **Line 618:** [AI-MDC-TS???] Code Clarity: Add comments to explain the scoring logic and calculations.
- **Line 619:** [AI-MDC-TS???] Data Source: Replace hardcoded `uptime` (99.9) with actual uptime data from a monitoring source.
- **Line 620:** [AI-MDC-TS???] Configuration: Consider making the penalty factors (1000, 200) and base uptime configurable.
- **Line 635:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the returned forecast data structure.
- **Line 636:** [AI-MDC-TS???] Testing: Add unit tests for generateForecasts, although it currently returns hardcoded data, tests should ensure the structure is correct.
- **Line 637:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose and the structure of the returned data.
- **Line 638:** [AI-MDC-TS???] Data Source/AI Integration: Replace hardcoded forecast data with actual predictive forecasts generated by the AI monitoring service (`aiMonitoring`) or a dedicated forecasting module.
- **Line 662:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the returned benchmark comparison data structure.
- **Line 663:** [AI-MDC-TS???] Testing: Add unit tests for getBenchmarkComparisons, although it currently returns hardcoded data, tests should ensure the structure is correct.
- **Line 665:** [AI-MDC-TS???] Data Source: Replace hardcoded benchmark data with actual benchmark data fetched from a reliable source or generated based on historical performance.
- **Line 687:** [AI-MDC-TS???] Testing: Add unit tests for calculateSystemHealth, covering different metrics scenarios and expected health scores.
- **Line 689:** [AI-MDC-TS???] Logic: Review and potentially refine the logic for calculating system health based on performance score.
- **Line 695:** [AI-MDC-TS???] Testing: Add unit tests for generateAlerts, covering different metrics scenarios and expected alert outputs.
- **Line 696:** [AI-MDC-TS???] Documentation: Add PHPDoc/JSDoc documentation for this helper method explaining its purpose, parameters, and alert generation logic.
- **Line 697:** [AI-MDC-TS???] Configuration: Consider making the alert thresholds (85%, 90%, 1000ms) configurable.
- **Line 698:** [AI-MDC-TS???] AI Integration: Integrate with the AI monitoring service (`aiMonitoring`) to generate more intelligent and predictive alerts instead of simple threshold-based ones.
- **Line 737:** [AI-MDC-TS???] Type Safety: Define and use a specific interface for the returned trends data structure.
- **Line 738:** [AI-MDC-TS???] Testing: Add unit tests for calculateTrends, although it currently returns hardcoded data, tests should ensure the structure is correct.
- **Line 740:** [AI-MDC-TS???] Data Source/Logic: Replace hardcoded trend data with actual trend calculations based on historical metrics.
- **Line 751:** [AI-MDC-TS???] Testing: Add unit tests for generateShortTermForecasts, although it currently returns hardcoded data, tests should ensure the structure is correct.

### workflow.controller.ts

- **Line 7:** [AI-MDC-TS] Dependency Injection: Inject `WorkflowExecutionService` instead of initializing it directly here.
- **Line 64:** [AI-MDC-TS] Testing: Add unit/integration tests for `listExecutions`, covering various filter combinations (status, limit, offset), pagination, and error cases. Create test file at: __tests__/controllers/workflow.controller.test.ts
- **Line 65:** [AI-MDC-TS] OpenAPI Alignment: Ensure the request query parameters, response structure, and error responses strictly align with the OpenAPI definition for this endpoint.
- **Line 67:** [AI-MDC-TS] Security: Add authentication and authorization checks.
- **Line 68:** [AI-MDC-TS] Validation: Implement Zod schema validation for query parameters (status, limit, offset), ensuring correct type casting and default values.
- **Line 74:** [AI-MDC-TS] Type Safety: Ensure `status` is a valid `WorkflowStatus` after validation.
- **Line 76:** [AI-MDC-TS] Validation/Type Safety: Use Zod or a dedicated parsing utility to safely parse and type `limit` and `offset`.
- **Line 81:** [AI-MDC-TS] Type Safety: Define a specific interface for the `executions` array elements.
- **Line 82:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `workflowService.listExecutions` using APIError with specific error codes.
- **Line 87:** [AI-MDC-TS] Error Handling: Replace `console.error` with the standard logger utility (e.g., `logger.error`).
- **Line 88:** [AI-MDC-TS] Error Handling: Use APIError with a specific error code and status.
- **Line 114:** [AI-MDC-TS] Testing: Add unit/integration tests for `getExecution`, including success and not found cases.
- **Line 115:** [AI-MDC-TS] OpenAPI Alignment: Ensure the request path parameter, response structure, and error responses strictly align with the OpenAPI definition.
- **Line 116:** [AI-MDC-TS] Logging: Add logging for incoming requests and successful responses.
- **Line 118:** [AI-MDC-TS] Validation: Implement Zod schema validation for the `executionId` path parameter.
- **Line 122:** [AI-MDC-TS] Type Safety: Define a specific interface for the `execution` object.
- **Line 123:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `workflowService.getExecution`.
- **Line 134:** [AI-MDC-TS] Error Handling: Replace `console.error` with the standard logger utility.
- **Line 177:** [AI-MDC-TS] Testing: Add unit/integration tests for `createExecution`, covering valid/invalid inputs and service errors.
- **Line 178:** [AI-MDC-TS] OpenAPI Alignment: Ensure the request body, response structure, and error responses strictly align with the OpenAPI definition.
- **Line 181:** [AI-MDC-TS] Validation: Replace manual validation with robust Zod schema validation for the request body (name, description, steps).
- **Line 187:** [AI-MDC-TS] Error Handling: Use APIError with a specific BAD_REQUEST error code and status.
- **Line 191:** [AI-MDC-TS] Type Safety: Define specific interfaces for the input object passed to `createExecution` and the returned `execution` object.
- **Line 192:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `workflowService.createExecution`.
- **Line 231:** [AI-MDC-TS] Testing: Add unit/integration tests for `startExecution`, covering success, not found, and invalid status cases.
- **Line 239:** [AI-MDC-TS] Type Safety: Define a specific interface for the returned `execution` object.
- **Line 240:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `workflowService.startExecution` (e.g., not found, invalid status).
- **Line 288:** [AI-MDC-TS] Testing: Add unit/integration tests for `completeStep`, covering success, not found, and error cases.
- **Line 289:** [AI-MDC-TS] OpenAPI Alignment: Ensure the request path parameters, request body, response structure, and error responses strictly align with the OpenAPI definition.
- **Line 292:** [AI-MDC-TS] Validation: Implement Zod schema validation for path parameters (`executionId`, `stepId`) and the request body (`output`).
- **Line 298:** [AI-MDC-TS] Type Safety: Define specific interfaces for the input object passed to `completeStep` and the returned `execution` object.
- **Line 299:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `workflowService.completeStep` (e.g., not found, invalid state).
- **Line 347:** [AI-MDC-TS] Testing: Add unit/integration tests for `failStep`, covering valid/invalid inputs, not found, and error cases.
- **Line 351:** [AI-MDC-TS] Validation: Replace manual validation with robust Zod schema validation for path parameters (`executionId`, `stepId`) and the request body (`error`).
- **Line 362:** [AI-MDC-TS] Type Safety: Define specific interfaces for the input object passed to `failStep` and the returned `execution` object.
- **Line 363:** [AI-MDC-TS] Error Handling: Implement more granular error handling for specific errors from `workflowService.failStep` (e.g., not found, invalid state).

### index.ts

- **Line 84:** Add authentication, access control, and context enrichment

### resolvers.ts

- **Line 6:** Fetch model by ID from database
- **Line 10:** Implement filtering, pagination, and sorting
- **Line 25:** Create a new model in the database
- **Line 29:** Update model by ID
- **Line 33:** Delete model by ID
- **Line 37:** Bulk delete models by IDs

### jsonrpc.ts

- **Line 18:** Register additional JSON-RPC methods dynamically or statically

### aiMonitoring.ts

- **Line 5:** Create comprehensive test suite for AIMonitoringEngine

### authMiddleware.ts

- **Line 20:** Implement behavioral anomaly detection for authentication patterns
- **Line 21:** Add automated threat response based on suspicious authentication attempts
- **Line 22:** Create user permission analysis based on behavioral patterns
- **Line 23:** Implement Zero Trust Architecture principles with continuous verification
- **Line 24:** Add AI-powered identity verification with contextual access control
- **Line 26:** [AI-MW-AUTH101] Define Types: Replace `any` types for `req`, `res`, `next`, `decoded`, `keyData`, `user` with specific types (e.g., `Request`, `Response`, `NextFunction` from Express, custom interfaces for decoded JWT payload, `ApiKeyValidationResult`, `UserProfile`). (Partially addressed below)
- **Line 27:** [AI-MW-AUTH102] JWT Payload Structure: Define and document the expected structure of the JWT payload (`decoded`) including `sub` (subject/user ID), `username`, and `roles`. Ensure the token generation process in `authService` creates tokens with this structure. Add type guards or assertions when accessing payload properties. (Partially addressed below)
- **Line 28:** [AI-MW-AUTH103] API Key Permissions Check: Currently, the middleware validates the API key and attaches permissions to `req.apiKey`, but it doesn't *enforce* permissions based on the required operation. Implement logic (either here or in separate authorization middleware/decorators) to check if `req.apiKey.permissions` allow the requested action on the specific route.
- **Line 29:** [AI-MW-AUTH104] Role-Based Access Control (RBAC): Similarly, implement checks based on `req.user.roles` if specific roles are required for certain routes.
- **Line 30:** [AI-MW-AUTH105] Configuration Usage: Ensure `config.JWT.SECRET` path is correct based on the actual structure in `config/index.ts` (it's currently `config.security.jwtSecret`).
- **Line 31:** [AI-MW-AUTH106] Error Handling: Improve error handling within the `catch` block for `jwt.verify`. Check specific error types (e.g., `JsonWebTokenError`, `NotBeforeError`) in addition to `TokenExpiredError`. Use the centralized error handler (`next(error)`) consistently.
- **Line 32:** [AI-MW-AUTH107] Type Augmentation: Ensure `req.user` and `req.apiKey` are added to the Express Request interface augmentation in `llm-gateway/src/types/express.d.ts`.
- **Line 33:** [AI-MW-AUTH108] API Key Prefix: Standardize the API key prefix ('ApiKey '). Consider making it case-insensitive.
- **Line 34:** [AI-MW-AUTH109] Test Coverage: Add unit tests for this middleware, mocking `jwt.verify`, `authService.validateApiKey`, and `authService.getUserById` to test different scenarios (valid token, expired token, invalid token, valid key, invalid key, user not found, unsupported method).
- **Line 35:** [AI-MW-AUTH110] Logging: Add logging for successful authentication events (e.g., user ID authenticated via JWT/ApiKey) and more detailed logging for failures.

### rbac.ts

- **Line 5:** Create comprehensive test suite for RBAC middleware

### security.ts

- **Line 15:** [AI-301] Implementation
- **Line 39:** [AI-302] Implementation
- **Line 119:** [AI-303] Implementation

### index.ts

- **Line 17:** [AI-307] Implementation
- **Line 87:** [AI-306] Implementation
- **Line 377:** Implement actual Redis health check
- **Line 382:** Implement actual database health check
- **Line 387:** Implement actual LLM service health check

### metrics.ts

- **Line 2:** Create comprehensive test suite for metrics module
- **Line 21:** Implement intelligent monitoring with proactive alerting and context
- **Line 22:** Add predictive maintenance scheduling based on performance patterns
- **Line 23:** Create self-healing components with automated recovery actions
- **Line 24:** Implement resource usage prediction and optimization
- **Line 25:** Add anomaly detection with machine learning for unusual patterns

### tracing.ts

- **Line 6:** Integrate @opentelemetry/sdk-node, instrument Express, and export to Jaeger/Tempo

### drupal.routes.ts

- **Line 25:** Implement handler
- **Line 27:** Add more endpoints for validation, content sync, etc.

### health.ts

- **Line 223:** Integrate with actual metrics system (Prometheus, etc.)
- **Line 234:** Implement actual degradation event tracking

### server.ts

- **Line 7:** Implement intelligent routing based on request patterns and model availability
- **Line 8:** Add anomaly detection for API traffic with automated alerts
- **Line 9:** Create auto-scaling capabilities based on traffic patterns
- **Line 10:** Implement predictive routing to optimize resource utilization
- **Line 11:** Add comprehensive security monitoring with behavioral analysis

### AdaptiveRateLimiter.ts

- **Line 2:** Create comprehensive test suite for AdaptiveRateLimiter

### bfllmIntegration.ts

- **Line 16:** Replace with proper BFLLM API client interface

### langchainAgent.ts

- **Line 6:** [AI-LCA-TS101] Abstract LLM initialization for more providers (factory pattern).
- **Line 7:** [AI-LCA-TS102] Use Zod or JSON schema for tool input validation.
- **Line 8:** [AI-LCA-TS103] Replace direct axios MCP calls with a client SDK.
- **Line 9:** [AI-LCA-TS104] Implement specific error classes for agent/tool/MCP errors.
- **Line 10:** [AI-LCA-TS105] Support multiple memory types via options.memory.
- **Line 11:** [AI-LCA-TS106] Support more agent types (ReAct, XMLAgent, etc.).
- **Line 12:** [AI-LCA-TS107] Add robust tool creation validation and error handling.
- **Line 13:** [AI-LCA-TS108] Ensure all tool functions are async and handle Promises.
- **Line 14:** [AI-LCA-TS109] Sanitize tool inputs for security.
- **Line 15:** [AI-LCA-TS110] Load agent config from persistent source, not just constructor.
- **Line 16:** [AI-LCA-TS111] Review static factory methods for agent creation.
- **Line 17:** [AI-LCA-TS112] Add comprehensive unit tests for agent/tool/memory/run.
- **Line 18:** [AI-LCA-TS113] Enhance verbose logging for debugging.
- **Line 19:** [AI-LCA-TS114] Replace remaining `any` types with specific types.
- **Line 20:** [AI-LCA-TS115] Ensure ToolBuilder methods match ToolDefinition interface.
- **Line 21:** [AI-LCA-TS116] Verify all LangChain import paths.
- **Line 22:** [AI-LCA-TS117] Refactor async agent creation for correct usage.
- **Line 24:** [AI-WORKFLOW-101] Implement machine learning-based workflow optimization
- **Line 25:** [AI-WORKFLOW-102] Create predictive task scheduling for workflow automation
- **Line 26:** [AI-WORKFLOW-103] Add intelligent resource allocation for agent tasks
- **Line 27:** [AI-WORKFLOW-104] Implement auto-healing workflow recovery for failed steps
- **Line 28:** [AI-WORKFLOW-105] Create workflow templates with reusable components
- **Line 103:** Define specific memory options if needed

### evaluationService.ts

- **Line 4:** Replace with actual database client
- **Line 26:** Implement actual model evaluation logic

### model.service.test.ts

- **Line 184:** Add a check for the dimension of the vectors if the options parameter is used in the service

### model.service.ts

- **Line 47:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that reloadModel updates the model status to 'loading' then 'loaded', updates `lastReload`, and returns a success object, handling the 'notfound' case correctly.
- **Line 48:** [AI-MDC-TS] Logic: Implement the actual logic to reload the model (e.g., load weights, initialize instance).
- **Line 49:** [AI-MDC-TS] Error Handling: Add specific error handling for issues during the reload process (e.g., file not found, incompatible version).
- **Line 50:** [AI-MDC-TS] Performance: Monitor the performance of the reload operation, especially for large models.
- **Line 80:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that getModelStatus returns the correct status from the in-memory registry and handles the 'notfound' case correctly (returning 'notfound').
- **Line 81:** [AI-MDC-TS] Data Source: Ensure this fetches status from a reliable, potentially persistent store in a real implementation.
- **Line 104:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that unloadModel updates the model status to 'unloaded' and returns a success object, handling the 'notfound' case correctly.
- **Line 105:** [AI-MDC-TS] Logic: Implement the actual logic to unload the model (e.g., free up memory, shut down instances).
- **Line 106:** [AI-MDC-TS] Error Handling: Add specific error handling for issues during the unload process.
- **Line 131:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that getModelLogs returns the logs array from the in-memory registry and handles the 'notfound' case correctly (returning an empty array or throwing an error as per spec).
- **Line 132:** [AI-MDC-TS] Data Source: Replace in-memory log array with a proper logging system (e.g., file-based, database, external logging service).
- **Line 153:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that rollbackModelVersion updates the `activeVersion` in the in-memory registry if the model and version exist and the version is valid.
- **Line 154:** [AI-MDC-TS] Test Requirement: Add test cases for invalid modelId, invalid versionId, and cases where the version is not compatible for rollback.
- **Line 155:** [AI-MDC-TS] Persistence: Implement logic to persist the active version change to a database or configuration store.
- **Line 156:** [AI-MDC-TS] Eventing/Hook: Consider triggering an event after successful rollback for other parts of the system to react.
- **Line 181:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that getErrorLog returns the current state of the in-memory errorLog array.
- **Line 182:** [AI-MDC-TS] Data Source: Replace in-memory errorLog array with a proper error logging and monitoring system.
- **Line 240:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that registerModel creates a new model with correct properties, assigns a unique ID, initializes its versions and registry entries, and throws an error for invalid input.
- **Line 294:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that getModelDetails returns the correct model object when found, including its versions and registry status, and returns null for a non-existent model.
- **Line 313:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that updateModel correctly updates the specified fields of an existing model, preserves the ID, updates `updatedAt`, and returns the updated model, handling the non-existent model case by throwing an error.
- **Line 338:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that deleteModel removes the model, its versions, and registry entry from the in-memory stores and returns `{ success: true, modelId }` when found, and `{ success: false, modelId }` when not found.
- **Line 590:** Implement actual logic to fetch model version details
- **Line 620:** Implement actual batch processing logic, potentially routing to predict/analyze/etc. based on operation.
- **Line 635:** Implement actual fine-tuning job initiation logic.
- **Line 654:** Implement actual logic to retrieve fine-tuning job status.
- **Line 677:** Implement actual logic for updating a model version
- **Line 699:** Implement actual logic for deleting a model version
- **Line 715:** Implement actual deployment listing logic based on filters.
- **Line 741:** Implement actual deployment details retrieval logic.
- **Line 763:** Implement actual deployment status update logic.
- **Line 800:** Implement actual benchmark execution logic.
- **Line 803:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify the structure and content of the results returned by runBenchmark, especially how it incorporates input options.
- **Line 828:** Implement actual model comparison logic based on stored benchmarks.
- **Line 831:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify the structure and content of the results returned by compareModels.
- **Line 853:** Implement actual model search logic.
- **Line 854:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that searchModels correctly filters based on the query (case-insensitive partial match on name/description) and returns the expected subset of dummy models.
- **Line 873:** Implement actual model version deployment logic.
- **Line 874:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that deployModelVersion returns a deployment object with the correct modelId, versionId, environment, and confirmed status immediately upon call, and that the simulated async status update is handled (if testable).
- **Line 907:** Implement actual model deployment logic using the active version.
- **Line 908:** [AI-MDC-TS] Test Requirement: Add a test case in model.service.test.ts to verify that deployModelToEnvironment correctly fetches the active model version and calls deployModelVersion with the correct arguments, including setting 'confirmed' to true for the 'production' environment.
- **Line 919:** Replace all 'any' in function signatures with specific interfaces/types
- **Line 920:** Add/expand JSDoc for all exported functions
- **Line 921:** Add OpenAPI alignment TODOs for all endpoints
- **Line 922:** Integrate with actual bfllm service for real model operations
- **Line 925:** Implement actual logic for listing deployments
- **Line 935:** Implement actual logic for getting deployment details
- **Line 946:** Implement actual logic for updating deployment status
- **Line 953:** Implement actual benchmark execution logic
- **Line 964:** Implement actual model comparison logic
- **Line 979:** Implement actual model search logic

### SelfHealingSystemMonitor.ts

- **Line 1266:** Implement performance degradation prediction using real metrics and ML models
- **Line 1272:** Update all predictive models with recent data
- **Line 1278:** Implement predictive maintenance assessment

### stabilityMonitor.ts

- **Line 2:** Create comprehensive test suite for StabilityMonitor

### systemService.ts

- **Line 18:** [AI-SYS-TS101] Define Return Types: Replace `Promise<Object>` with specific TypeScript interfaces (e.g., `SystemStatus`, `SystemMetrics`, `ModelMetrics`) for the return types of the functions to improve type safety and clarity. Define these interfaces in `../types/`.
- **Line 19:** [AI-SYS-TS102] Implement `getModelMetrics`: The `getModelMetrics` function is currently a placeholder. Implement the actual logic to collect metrics related to model usage, potentially by:
- **Line 24:** [AI-SYS-TS103] Configuration Usage: Use the centralized `config` object (`../config/index.js`) for accessing `NODE_ENV` instead of `process.env` directly for consistency.
- **Line 25:** [AI-SYS-TS104] Health Check Endpoint Integration: Ensure the `getSystemStatus` function (or a simplified version) is used by the `/health` endpoint defined in `app.ts` or `routes/health.ts`. Consider adding checks for critical dependencies (database, external APIs) to the health check.
- **Line 26:** [AI-SYS-TS105] Metrics Endpoint Integration: Ensure `getSystemMetrics` and `getModelMetrics` are exposed via appropriate API endpoints (e.g., `/metrics`, potentially formatted for Prometheus scraping). See `Your Company_llm_platform.routing.yml` which defines a `/admin/metrics/Your Company-llm-platform` route.
- **Line 27:** [AI-SYS-TS106] Error Handling: Improve error handling in catch blocks. Use type guards (`if (error instanceof Error)`). Consider if specific errors should be thrown or if returning a default/error state within the metrics object is more appropriate for monitoring endpoints.
- **Line 28:** [AI-SYS-TS107] Unit Formatting: Standardize the formatting of units (e.g., consistently use MB or MiB, seconds or milliseconds). Consider returning raw numbers and letting the consumer format them.
- **Line 29:** [AI-SYS-TS108] CPU Usage Calculation: `process.cpuUsage()` returns microseconds since the process started. Calculating meaningful current CPU load often requires comparing usage over an interval. Consider using a library like `pidusage` or `systeminformation` for more comprehensive system metrics if needed, or adjust the calculation method.
- **Line 30:** [AI-SYS-TS109] Test Coverage: Add unit tests for these service functions, potentially mocking `process` methods if needed, to verify the structure and content of the returned objects and error handling.
- **Line 133:** Implement actual model metrics collection

### cache.enhanced.ts

- **Line 41:** Add metrics collection for cache hits/misses - COMPLETED
- **Line 42:** Fix import paths spacing issues - COMPLETED
- **Line 43:** Add TypeScript typings for class properties and methods - COMPLETED

### cache.ts

- **Line 26:** Implement predictive caching for frequently accessed content
- **Line 27:** Add dynamic TTL adjustments based on access patterns
- **Line 28:** Create intelligent cache prefetching for anticipated requests
- **Line 29:** Implement cache partitioning based on content type and request patterns
- **Line 30:** Add distributed cache invalidation across service instances
- **Line 36:** Add TypeScript typings for Cache class properties and methods
- **Line 37:** Fix import paths spacing issues

## XXX Items (83)

### edwards.js

- **Line 168:** This code assumes that zero is always zero in red

### short.js

- **Line 197:** Is there any way to tell if the number is odd without converting it

### node.js

- **Line 163:** It's lame that node doesn't expose this API out-of-the-box. It also

### http.js

- **Line 146:** what we supposed to do here?

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### helpers.js

- **Line 18:** Use #base-2 .value-0 instead?

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

### index.js

- **Line 137:** this is incorrect. we have multicharacter flags like `-iwr` that

### cache.js

- **Line 140:** this could leave other entries without content!

### ci.js

- **Line 109:** should we remove this finally??

### doctor.js

- **Line 164:** get the latest in the current major as well

### fund.js

- **Line 24:** maybe worth making this generic for all commands?

### help.js

- **Line 17:** these are used in the docs workspace and should be exported

### publish.js

- **Line 194:** can't pacote read the manifest from a directory?

### team.js

- **Line 44:** "description" option to libnpmteam is used as a description of the

### package-url-cmd.js

- **Line 26:** It is very odd that `where` is how pacote knows to look anywhere

### display.js

- **Line 328:** in a future (breaking?) change it might make sense for run-script to

### error-message.js

- **Line 386:** we should stop throwing strings
- **Line 395:** we should stop throwing other non-errors

### build-ideal-tree.js

- **Line 559:** this belongs in the audit report itself, not here.
- **Line 583:** how to handle top nodes that aren't the root?  Maybe the report
- **Line 649:** this could be faster by doing a series of inventory.query('name')
- **Line 652:** add any invalid edgesOut to the queue
- **Line 753:** also push anything that depends on a node with a name
- **Line 1006:** This is somehow load bearing.  This makes tests that print

### load-actual.js

- **Line 71:** deprecate separate method options objects.

### load-virtual.js

- **Line 37:** deprecate separate reify() options object.

### reify.js

- **Line 413:** if we have an existing diff already, there should be a way
- **Line 832:** use a magic string that isn't also a valid value, like

### edge.js

- **Line 55:** where is this used?
- **Line 66:** are all of these error states even possible?

### node.js

- **Line 1009:** need to check for two root nodes?

### place-dep.js

- **Line 42:** this only appears to be used by tests
- **Line 237:** if we are replacing SOME of a peer entry group, we will need to
- **Line 335:** handle replacing an entire peer group?
- **Line 510:** decorate more with this.canPlace and this.canPlaceSelf,

### shrinkwrap.js

- **Line 203:** this is duplicated in this.load(), but using loadFiles instead of resetFiles
- **Line 577:** is this even reachable?
- **Line 872:** why is this different from pathFixed in this.add??

### definitions.js

- **Line 127:** We should really deprecate all these `--save-blah` switches
- **Line 1665:** update arborist to just ignore it if resulting saveType is peer

### errors.js

- **Line 10:** context.code is undefined in all constructors used in cp/polyfill

### advisory.js

- **Line 267:** if bundled, then semver.intersects() means vulnerable

### normalize.js

- **Line 609:** should a future breaking change delete bin entries that cannot be accessed?

### set-path.js

- **Line 21:** we should specify a cwd that we don't go above
- **Line 33:** include the node-gyp-bin path somehow?  Probably better for

### pax.js

- **Line 54:** split the path
- **Line 134:** Values with \n in them will fail this.

### unpack.js

- **Line 678:** get the type ('symlink' or 'junction') for windows

### browser.js

- **Line 208:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 262:** DO NOT USE. This is a temporary stub function.
- **Line 263:** It WILL be removed in the next major release.

### get-bin-from-manifest.js

- **Line 10:** probably a util to parse this better?
- **Line 16:** need better error message

### index.js

- **Line 18:** this should really be split up and unit-ized for easier testing

### install.js

- **Line 42:** use a different footer line if some aren't fixable easily.

### npa.js

- **Line 259:** backwards compatibility lack of compliance with RFC 8089
- **Line 275:** end RFC 8089 violation backwards compatibility section

### fetcher.js

- **Line 101:** fill more of this in based on what we know from this.opts

### git.js

- **Line 103:** make this a custom error class

### registry.js

- **Line 47:** pacote <=9 has some logic to ignore opts.resolved if
- **Line 136:** add ETARGET and E403 revalidation of cached packuments here

### index.js

- **Line 147:** remove v.length check to remove cb from functions
- **Line 149:** if cb is no longer an argument then this.#ctx should
- **Line 165:** remove this to require throwing an error instead of

### list.js

- **Line 3:** This shares a lot in common with extract.js

### test.js

- **Line 354:** 80');
- **Line 355:** 1337');
- **Line 362:** 443');
- **Line 370:** 70');
- **Line 374:** 21');

### index.js

- **Line 343:** Switch to [].concat(...Object.values(aliases)) once node.js 6 is dropped

### preload.js

- **Line 3:** remove in v8 or beyond

### as-function.js

- **Line 21:** make it more strict: numbers, strings, symbols - and nothing else

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### ast.js

- **Line 483:** abstract out this map method

### tdigest.js

- **Line 775:** because mean and mean_cumn give rise to the same sort order

### source-map-consumer.js

- **Line 305:** keep these error codes in sync with `fitzgen/source-map-mappings`.

### compress.js

- **Line 12099:** intentionally falling down to the next case

### output.js

- **Line 1947:** I'm not exactly sure if we need it for all of these nodes,

