# Project Roadmap Summary

_Generated on 2025-05-30_

## TODO Counts by Project

| Project | TODO | FIXME | OPTIMIZE | HACK | BUG | NOTE | Total |
|---------|------|-------|----------|------|-----|------|-------|
| llm-gateway | 1 | 1 | 1 | 1 | 1 | 1 | 3144 |
| llm-gatewayclient | 1 | 1 | 00 | 1 | 1 | 1 | 735 |
| bfcicomponents | 1 | 1 | 1 | 1 | 1 | 1 | 820 |
| llmcli | 1 | 1 | 1 | 1 | 1 | 1 | 1123 |
| bfdocs | 1 | 00 | 1 | 1 | 1 | 1 | 272 |
| bfllm | 1 | 1 | 1 | 1 | 1 | 1 | 1436 |
| llm-mcp | 1 | 1 | 1 | 1 | 1 | 1 | 2139 |
| bfrfp | 1 | 1 | 1 | 1 | 1 | 1 | 1018 |
| bfui | 1 | 1 | 1 | 1 | 1 | 1 | 1351 |
| llm_platform_recipe | 1 | 00 | 1 | 00 | 00 | 1 | 44 |
| secure_project | 1 | 1 | 00 | 1 | 1 | 1 | 425 |
| **TOTAL** | **11** | **9** | **9** | **10** | **10** | **11** | **12507** |

## Top TODO Items by Project

### llm-gateway

### AdaptiveRateLimiter.test.ts

- **Line 54:** Add tests for RL optimization, clustering, memory pressure, and distributed sync
- **Line 55:** Add performance/load tests for high-traffic scenarios

### bfllmIntegration.test.ts

- **Line 12:** Add tests for API client integration
- **Line 13:** Add tests for caching and retry logic
- **Line 14:** Add tests for LangChain integration

### chatbotWorkflow.test.ts

- **Line 14:** Add tests for response types and error handling

### llm-gatewayclient

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### bfcicomponents

### openapi-test-generator.js

- **Line 670:** Implement test for [method] /path/to/resource
- **Line 675:** Implement error handling tests

### index.d.ts

- **Line 2:** item structure
- **Line 3780:** Move to react-dom
- **Line 202:** Remove the string ref special case from `PropsWithRef` once we remove LegacyRef
- **Line 522:** generalize this to everything in `keyof ReactHTML`, not just "input"
- **Line 1970:** double-check if this weird overload logic is necessary. It is possible it's either a bug

### parser.js

- **Line 18:** message, /* TODO: message */, # TODO: message, <!-- TODO: message

### llmcli

### index.ts

- **Line 244:** Implement remote config loading (Consul, etcd, etc.)
- **Line 279:** Implement config validation against schema
- **Line 133:** Other constants as well
- **Line 78:** possibly, it should be readonly

### pipeline-healer.js

- **Line 14:** Replace with actual EnhancedLangChainAgent import and usage if available
- **Line 107:** Add function documentation

### lint.js

- **Line 3:** Implement docs linting functionality

### bfdocs

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### bfllm

### index.js

- **Line 179:** Implement semantic comparison using embeddings
- **Line 36:** remove when Node v8 support drops
- **Line 129:** type `octokit.auth` based on passed options.authStrategy
- **Line 20:** Replace wildcard export with named exports before next major version
- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### meta_agent.ts

- **Line 63:** Integrate with OpenAPI schema validation using ajv

### agentPipeline.test.ts

- **Line 2:** Expand tests for more edge cases and error handling as workflow grows.

### llm-mcp

### 850.aacea4ef.chunk.js

- **Line 2:** possible optimizations: avoid overcalculating all for vertices and calc just one instead\n// TODO: precalculate dot products, normalize things beforehead etc.\n// TODO: refactor to rectangular algorithm\n\nfloat distToLine(vec2 p, vec2 a, vec2 b) {\n\tvec2 diff = b - a;\n\tvec2 perp = normalize(vec2(-diff.y, diff.x));\n\treturn dot(p - a, perp);\n}\n\nbool isNaN( float val ){\n  return ( val < 0.0 || 0.0 < val || val == 0.0 ) ? false : true;\n}\n\nvoid main() {\n\tvec2 aCoord = aCoord, bCoord = bCoord, prevCoord = prevCoord, nextCoord = nextCoord;\n\n  vec2 adjustedScale;\n  adjustedScale.x = (abs(scale.x) < MIN_DIFF) ? MIN_DIFF : scale.x;\n  adjustedScale.y = (abs(scale.y) < MIN_DIFF) ? MIN_DIFF : scale.y;\n\n  vec2 scaleRatio = adjustedScale * viewport.zw;\n\tvec2 normalWidth = thickness / scaleRatio;\n\n\tfloat lineStart = 1. - lineEnd;\n\tfloat lineBot = 1. - lineTop;\n\n\tfragColor = (lineStart * aColor + lineEnd * bColor) / 255.;\n\n\tif (isNaN(aCoord.x) || isNaN(aCoord.y) || isNaN(bCoord.x) || isNaN(bCoord.y)) return;\n\n\tif (aCoord == prevCoord) prevCoord = aCoord + normalize(bCoord - aCoord);\n\tif (bCoord == nextCoord) nextCoord = bCoord - normalize(bCoord - aCoord);\n\n\tvec2 prevDiff = aCoord - prevCoord;\n\tvec2 currDiff = bCoord - aCoord;\n\tvec2 nextDiff = nextCoord - bCoord;\n\n\tvec2 prevTangent = normalize(prevDiff * scaleRatio);\n\tvec2 currTangent = normalize(currDiff * scaleRatio);\n\tvec2 nextTangent = normalize(nextDiff * scaleRatio);\n\n\tvec2 prevNormal = vec2(-prevTangent.y, prevTangent.x);\n\tvec2 currNormal = vec2(-currTangent.y, currTangent.x);\n\tvec2 nextNormal = vec2(-nextTangent.y, nextTangent.x);\n\n\tvec2 startJoinDirection = normalize(prevTangent - currTangent);\n\tvec2 endJoinDirection = normalize(currTangent - nextTangent);\n\n\t// collapsed/unidirectional segment cases\n\t// FIXME: there should be more elegant solution\n\tvec2 prevTanDiff = abs(prevTangent - currTangent);\n\tvec2 nextTanDiff = abs(nextTangent - currTangent);\n\tif (max(prevTanDiff.x, prevTanDiff.y) < MIN_DIFF) {\n\t\tstartJoinDirection = currNormal;\n\t}\n\tif (max(nextTanDiff.x, nextTanDiff.y) < MIN_DIFF) {\n\t\tendJoinDirection = currNormal;\n\t}\n\tif (aCoord == bCoord) {\n\t\tendJoinDirection = startJoinDirection;\n\t\tcurrNormal = prevNormal;\n\t\tcurrTangent = prevTangent;\n\t}\n\n\ttangent = currTangent;\n\n\t//calculate join shifts relative to normals\n\tfloat startJoinShift = dot(currNormal, startJoinDirection);\n\tfloat endJoinShift = dot(currNormal, endJoinDirection);\n\n\tfloat startMiterRatio = abs(1. / startJoinShift);\n\tfloat endMiterRatio = abs(1. / endJoinShift);\n\n\tvec2 startJoin = startJoinDirection * startMiterRatio;\n\tvec2 endJoin = endJoinDirection * endMiterRatio;\n\n\tvec2 startTopJoin, startBotJoin, endTopJoin, endBotJoin;\n\tstartTopJoin = sign(startJoinShift) * startJoin * .5;\n\tstartBotJoin = -startTopJoin;\n\n\tendTopJoin = sign(endJoinShift) * endJoin * .5;\n\tendBotJoin = -endTopJoin;\n\n\tvec2 aTopCoord = aCoord + normalWidth * startTopJoin;\n\tvec2 bTopCoord = bCoord + normalWidth * endTopJoin;\n\tvec2 aBotCoord = aCoord + normalWidth * startBotJoin;\n\tvec2 bBotCoord = bCoord + normalWidth * endBotJoin;\n\n\t//miter anti-clipping\n\tfloat baClipping = distToLine(bCoord, aCoord, aBotCoord) / dot(normalize(normalWidth * endBotJoin), normalize(normalWidth.yx * vec2(-startBotJoin.y, startBotJoin.x)));\n\tfloat abClipping = distToLine(aCoord, bCoord, bTopCoord) / dot(normalize(normalWidth * startBotJoin), normalize(normalWidth.yx * vec2(-endBotJoin.y, endBotJoin.x)));\n\n\t//prevent close to reverse direction switch\n\tbool prevReverse = dot(currTangent, prevTangent) <= REVERSE_THRESHOLD && abs(dot(currTangent, prevNormal)) * min(length(prevDiff), length(currDiff)) <  length(normalWidth * currNormal);\n\tbool nextReverse = dot(currTangent, nextTangent) <= REVERSE_THRESHOLD && abs(dot(currTangent, nextNormal)) * min(length(nextDiff), length(currDiff)) <  length(normalWidth * currNormal);\n\n\tif (prevReverse) {\n\t\t//make join rectangular\n\t\tvec2 miterShift = normalWidth * startJoinDirection * miterLimit * .5;\n\t\tfloat normalAdjust = 1. - min(miterLimit / startMiterRatio, 1.);\n\t\taBotCoord = aCoord + miterShift - normalAdjust * normalWidth * currNormal * .5;\n\t\taTopCoord = aCoord + miterShift + normalAdjust * normalWidth * currNormal * .5;\n\t}\n\telse if (!nextReverse && baClipping > 0. && baClipping < length(normalWidth * endBotJoin)) {\n\t\t//handle miter clipping\n\t\tbTopCoord -= normalWidth * endTopJoin;\n\t\tbTopCoord += normalize(endTopJoin * normalWidth) * baClipping;\n\t}\n\n\tif (nextReverse) {\n\t\t//make join rectangular\n\t\tvec2 miterShift = normalWidth * endJoinDirection * miterLimit * .5;\n\t\tfloat normalAdjust = 1. - min(miterLimit / endMiterRatio, 1.);\n\t\tbBotCoord = bCoord + miterShift - normalAdjust * normalWidth * currNormal * .5;\n\t\tbTopCoord = bCoord + miterShift + normalAdjust * normalWidth * currNormal * .5;\n\t}\n\telse if (!prevReverse && abClipping > 0. && abClipping < length(normalWidth * startBotJoin)) {\n\t\t//handle miter clipping\n\t\taBotCoord -= normalWidth * startBotJoin;\n\t\taBotCoord += normalize(startBotJoin * normalWidth) * abClipping;\n\t}\n\n\tvec2 aTopPosition = (aTopCoord) * adjustedScale + translate;\n\tvec2 aBotPosition = (aBotCoord) * adjustedScale + translate;\n\n\tvec2 bTopPosition = (bTopCoord) * adjustedScale + translate;\n\tvec2 bBotPosition = (bBotCoord) * adjustedScale + translate;\n\n\t//position is normalized 0..1 coord on the screen\n\tvec2 position = (aTopPosition * lineTop + aBotPosition * lineBot) * lineStart + (bTopPosition * lineTop + bBotPosition * lineBot) * lineEnd;\n\n\tstartCoord = aCoord * scaleRatio + translate * viewport.zw + viewport.xy;\n\tendCoord = bCoord * scaleRatio + translate * viewport.zw + viewport.xy;\n\n\tgl_Position = vec4(position  * 2.0 - 1.0, depth, 1);\n\n\tenableStartMiter = step(dot(currTangent, prevTangent), .5);\n\tenableEndMiter = step(dot(currTangent, nextTangent), .5);\n\n\t//bevel miter cutoffs\n\tif (miterMode == 1.) {\n\t\tif (enableStartMiter == 1.) {\n\t\t\tvec2 startMiterWidth = vec2(startJoinDirection) * thickness * miterLimit * .5;\n\t\t\tstartCutoff = vec4(aCoord, aCoord);\n\t\t\tstartCutoff.zw += vec2(-startJoinDirection.y, startJoinDirection.x) / scaleRatio;\n\t\t\tstartCutoff = startCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n\t\t\tstartCutoff += viewport.xyxy;\n\t\t\tstartCutoff += startMiterWidth.xyxy;\n\t\t}\n\n\t\tif (enableEndMiter == 1.) {\n\t\t\tvec2 endMiterWidth = vec2(endJoinDirection) * thickness * miterLimit * .5;\n\t\t\tendCutoff = vec4(bCoord, bCoord);\n\t\t\tendCutoff.zw += vec2(-endJoinDirection.y, endJoinDirection.x)  / scaleRatio;\n\t\t\tendCutoff = endCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n\t\t\tendCutoff += viewport.xyxy;\n\t\t\tendCutoff += endMiterWidth.xyxy;\n\t\t}\n\t}\n\n\t//round miter cutoffs\n\telse if (miterMode == 2.) {\n\t\tif (enableStartMiter == 1.) {\n\t\t\tvec2 startMiterWidth = vec2(startJoinDirection) * thickness * abs(dot(startJoinDirection, currNormal)) * .5;\n\t\t\tstartCutoff = vec4(aCoord, aCoord);\n\t\t\tstartCutoff.zw += vec2(-startJoinDirection.y, startJoinDirection.x) / scaleRatio;\n\t\t\tstartCutoff = startCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n\t\t\tstartCutoff += viewport.xyxy;\n\t\t\tstartCutoff += startMiterWidth.xyxy;\n\t\t}\n\n\t\tif (enableEndMiter == 1.) {\n\t\t\tvec2 endMiterWidth = vec2(endJoinDirection) * thickness * abs(dot(endJoinDirection, currNormal)) * .5;\n\t\t\tendCutoff = vec4(bCoord, bCoord);\n\t\t\tendCutoff.zw += vec2(-endJoinDirection.y, endJoinDirection.x)  / scaleRatio;\n\t\t\tendCutoff = endCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n\t\t\tendCutoff += viewport.xyxy;\n\t\t\tendCutoff += endMiterWidth.xyxy;\n\t\t}\n\t}\n}\n"]),frag:o(["precision highp float;\n#define GLSLIFY 1\n\nuniform float dashLength, pixelRatio, thickness, opacity, id, miterMode;\nuniform sampler2D dashTexture;\n\nvarying vec4 fragColor;\nvarying vec2 tangent;\nvarying vec4 startCutoff, endCutoff;\nvarying vec2 startCoord, endCoord;\nvarying float enableStartMiter, enableEndMiter;\n\nfloat distToLine(vec2 p, vec2 a, vec2 b) {\n\tvec2 diff = b - a;\n\tvec2 perp = normalize(vec2(-diff.y, diff.x));\n\treturn dot(p - a, perp);\n}\n\nvoid main() {\n\tfloat alpha = 1., distToStart, distToEnd;\n\tfloat cutoff = thickness * .5;\n\n\t//bevel miter\n\tif (miterMode == 1.) {\n\t\tif (enableStartMiter == 1.) {\n\t\t\tdistToStart = distToLine(gl_FragCoord.xy, startCutoff.xy, startCutoff.zw);\n\t\t\tif (distToStart < -1.) {\n\t\t\t\tdiscard;\n\t\t\t\treturn;\n\t\t\t}\n\t\t\talpha *= min(max(distToStart + 1., 0.), 1.);\n\t\t}\n\n\t\tif (enableEndMiter == 1.) {\n\t\t\tdistToEnd = distToLine(gl_FragCoord.xy, endCutoff.xy, endCutoff.zw);\n\t\t\tif (distToEnd < -1.) {\n\t\t\t\tdiscard;\n\t\t\t\treturn;\n\t\t\t}\n\t\t\talpha *= min(max(distToEnd + 1., 0.), 1.);\n\t\t}\n\t}\n\n\t// round miter\n\telse if (miterMode == 2.) {\n\t\tif (enableStartMiter == 1.) {\n\t\t\tdistToStart = distToLine(gl_FragCoord.xy, startCutoff.xy, startCutoff.zw);\n\t\t\tif (distToStart < 0.) {\n\t\t\t\tfloat radius = length(gl_FragCoord.xy - startCoord);\n\n\t\t\t\tif(radius > cutoff + .5) {\n\t\t\t\t\tdiscard;\n\t\t\t\t\treturn;\n\t\t\t\t}\n\n\t\t\t\talpha -= smoothstep(cutoff - .5, cutoff + .5, radius);\n\t\t\t}\n\t\t}\n\n\t\tif (enableEndMiter == 1.) {\n\t\t\tdistToEnd = distToLine(gl_FragCoord.xy, endCutoff.xy, endCutoff.zw);\n\t\t\tif (distToEnd < 0.) {\n\t\t\t\tfloat radius = length(gl_FragCoord.xy - endCoord);\n\n\t\t\t\tif(radius > cutoff + .5) {\n\t\t\t\t\tdiscard;\n\t\t\t\t\treturn;\n\t\t\t\t}\n\n\t\t\t\talpha -= smoothstep(cutoff - .5, cutoff + .5, radius);\n\t\t\t}\n\t\t}\n\t}\n\n\tfloat t = fract(dot(tangent, gl_FragCoord.xy) / dashLength) * .5 + .25;\n\tfloat dash = texture2D(dashTexture, vec2(t, .5)).r;\n\n\tgl_FragColor = fragColor;\n\tgl_FragColor.a *= alpha * opacity * dash;\n}\n"]),attributes:{lineEnd:{buffer:r,divisor:0,stride:8,offset:0},lineTop:{buffer:r,divisor:0,stride:8,offset:4},aColor:{buffer:t.prop('colorBuffer'),stride:4,offset:0,divisor:1},bColor:{buffer:t.prop('colorBuffer'),stride:4,offset:4,divisor:1},prevCoord:{buffer:t.prop('positionBuffer'),stride:8,offset:0,divisor:1},aCoord:{buffer:t.prop('positionBuffer'),stride:8,offset:8,divisor:1},bCoord:{buffer:t.prop('positionBuffer'),stride:8,offset:16,divisor:1},nextCoord:{buffer:t.prop('positionBuffer'),stride:8,offset:24,divisor:1}}},n))}catch(s)[e=i]return{fill:t({primitive:"triangle",elements:function(t,e){return e.triangles},offset:0,vert:o(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec2 position, positionFract;\n\nuniform vec4 color;\nuniform vec2 scale, scaleFract, translate, translateFract;\nuniform float pixelRatio, id;\nuniform vec4 viewport;\nuniform float opacity;\n\nvarying vec4 fragColor;\n\nconst float MAX_LINES = 256.;\n\nvoid main() {\n\tfloat depth = (MAX_LINES - 4. - id) / (MAX_LINES);\n\n\tvec2 position = position * scale + translate\n       + positionFract * scale + translateFract\n       + position * scaleFract\n       + positionFract * scaleFract;\n\n\tgl_Position = vec4(position * 2.0 - 1.0, depth, 1);\n\n\tfragColor = color / 255.;\n\tfragColor.a *= opacity;\n}\n"]),frag:o(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nvoid main() {\n\tgl_FragColor = fragColor;\n}\n"]),uniforms:{scale:t.prop('scale'),color:t.prop('fill'),scaleFract:t.prop('scaleFract'),translateFract:t.prop('translateFract'),translate:t.prop('translate'),opacity:t.prop('opacity'),pixelRatio:t.context('pixelRatio'),id:t.prop('id'),viewport:function(t,e){return[e.viewport.x,e.viewport.y,t.viewportWidth,t.viewportHeight]}},attributes:{position:{buffer:t.prop('positionBuffer'),stride:8,offset:8},positionFract:{buffer:t.prop('positionFractBuffer'),stride:8,offset:8}},blend:n.blend,depth:{enable:!1},scissor:n.scissor,stencil:n.stencil,viewport:n.viewport}),rect:i,miter:e}},v.defaults={dashes:null,join:"miter",miterLimit:1,thickness:10,cap:"square",color:"black",opacity:1,overlay:!1,viewport:null,range:null,close:!1,fill:null},v.prototype.render=function(){for(var t,e=[],r=arguments.length;r--;)e[r]=arguments[r];e.length&&(t=this).update.apply(t,e),this.draw()},v.prototype.draw=function(){for(var t=this,e=[],r=arguments.length;r--;)e[r]=arguments[r];return(e.length?e:this.passes).forEach((function(e,r){var n;if(e&&Array.isArray(e))return(n=t).draw.apply(n,e);"number"===typeof e&&(e=t.passes[e]),e&&e.count>1&&e.opacity&&(t.regl._refresh(),e.fill&&e.triangles&&e.triangles.length>2&&t.shaders.fill(e),e.thickness&&(e.scale[0]*e.viewport.width>v.precisionThreshold||e.scale[1]*e.viewport.height>v.precisionThreshold||"rect"===e.join||!e.join&&(e.thickness<=2||e.count>=v.maxPoints)?t.shaders.rect(e):t.shaders.miter(e)))})),this},v.prototype.update=function(t){var e=this;if(t){null!=t.length?"number"===typeof t[0]&&(t=[positions:t]):Array.isArray(t)||(t=[t]);var r=this,o=r.regl,f=r.gl;if(t.forEach((function(t,r){var d=e.passes[r];if(void 0!==t)if(null!==t){if("number"===typeof t[0]&&(t={positions:t}),t=s(t,{positions:"positions points data coords",thickness:"thickness lineWidth lineWidths line-width linewidth width stroke-width strokewidth strokeWidth",join:"lineJoin linejoin join type mode",miterLimit:"miterlimit miterLimit",dashes:"dash dashes dasharray dash-array dashArray",color:"color colour stroke colors colours stroke-color strokeColor",fill:"fill fill-color fillColor",opacity:"alpha opacity",overlay:"overlay crease overlap intersect",close:"closed close closed-path closePath",range:"range dataBox",viewport:"viewport viewBox",hole:"holes hole hollow",splitNull:"splitNull"}),d||(e.passes[r]=d={id:r,scale:null,scaleFract:null,translate:null,translateFract:null,count:0,hole:[],depth:0,dashLength:1,dashTexture:o.texture({channels:1,data:new Uint8Array([255]),width:1,height:1,mag:"linear",min:"linear"}),colorBuffer:o.buffer({usage:"dynamic",type:"uint8",data:new Uint8Array}),positionBuffer:o.buffer({usage:"dynamic",type:"float",data:new Uint8Array}),positionFractBuffer:o.buffer({usage:"dynamic",type:"float",data:new Uint8Array})},t=a({},v.defaults,t)),null!=t.thickness&&(d.thickness=parseFloat(t.thickness)),null!=t.opacity&&(d.opacity=parseFloat(t.opacity)),null!=t.miterLimit&&(d.miterLimit=parseFloat(t.miterLimit)),null!=t.overlay&&(d.overlay=!!t.overlay,r<v.maxLines&&(d.depth=2*(v.maxLines-1-r%v.maxLines)/v.maxLines-1)),null!=t.join&&(d.join=t.join),null!=t.hole&&(d.hole=t.hole),null!=t.fill&&(d.fill=t.fill?n(t.fill,'uint8'):null),null!=t.viewport&&(d.viewport=m(t.viewport)),d.viewport||(d.viewport=m([f.drawingBufferWidth,f.drawingBufferHeight])),null!=t.close&&(d.close=t.close),null===t.positions&&(t.positions=[]),t.positions){var y,x;if(t.positions.x&&t.positions.y){var b=t.positions.x,_=t.positions.y;x=d.count=Math.max(b.length,_.length),y=new Float64Array(2*x);for(var w=0;w<x;w++)y[2*w]=b[w],y[2*w+1]=_[w]}else y=l(t.positions,'float64'),x=d.count=Math.floor(y.length/2);var T=d.bounds=i(y,2);if(d.fill){for(var k=[],M={},A=0,S=0,E=0,L=d.count;S<L;S++){var C=y[2*S],P=y[2*S+1];isNaN(C)||isNaN(P)||null==C||null==P?(C=y[2*A],P=y[2*A+1],M[S]=A):A=S,k[E++]=C,k[E++]=P}if(t.splitNull){d.count-1 in M||(M[d.count]=d.count-1);var I=Object.keys(M).map(Number).sort((function(t,e){return t-e})),z=[],O=0,D=null!=d.hole?d.hole[0]:null;if(null!=D){var R=g(I,(function(t){return t>=D}));(I=I.slice(0,R)).push(D)}for(var F=function(t){var e=k.slice(2*O,2*I[t]).concat(D?k.slice(2*D):[]),r=(d.hole||[]).map((function(e){return e-D+(I[t]-O)})),n=c(e,r);n=n.map((function(e){return e+O+(e+O<I[t]?0:D-I[t])})),z.push.apply(z,n),O=I[t]+1},B=0;B<I.length;B++)F(B);for(var N=0,j=z.length;N<j;N++)null!=M[z[N]]&&(z[N]=M[z[N]]);d.triangles=z}else{for(var U=c(k,d.hole||[]),V=0,H=U.length;V<H;V++)null!=M[U[V]]&&(U[V]=M[U[V]]);d.triangles=U}}var q=new Float64Array(y);u(q,2,T);var G=new Float64Array(2*x+6);d.close?y[0]===y[2*x-2]&&y[1]===y[2*x-1]?(G[0]=q[2*x-4],G[1]=q[2*x-3]):(G[0]=q[2*x-2],G[1]=q[2*x-1]):(G[0]=q[0],G[1]=q[1]),G.set(q,2),d.close?y[0]===y[2*x-2]&&y[1]===y[2*x-1]?(G[2*x+2]=q[2],G[2*x+3]=q[3],d.count-=1):(G[2*x+2]=q[0],G[2*x+3]=q[1],G[2*x+4]=q[2],G[2*x+5]=q[3]):(G[2*x+2]=q[2*x-2],G[2*x+3]=q[2*x-1],G[2*x+4]=q[2*x-2],G[2*x+5]=q[2*x-1]);var Y=h(G);d.positionBuffer(Y);var W=p(G,Y);d.positionFractBuffer(W)}if(t.range?d.range=t.range:d.range||(d.range=d.bounds),(t.range||t.positions)&&d.count){var X=d.bounds,Z=X[2]-X[0],J=X[3]-X[1],K=d.range[2]-d.range[0],Q=d.range[3]-d.range[1];d.scale=[Z/K,J/Q],d.translate=[-d.range[0]/K+X[0]/K||0,-d.range[1]/Q+X[1]/Q||0],d.scaleFract=p(d.scale),d.translateFract=p(d.translate)}if(t.dashes){var $,tt=0;if(!t.dashes||t.dashes.length<2)tt=1,$=new Uint8Array([255,255,255,255,255,255,255,255]);else{tt=0;for(var et=0;et<t.dashes.length;++et)tt+=t.dashes[et];$=new Uint8Array(tt*v.dashMult);for(var rt=0,nt=255,it=0;it<2;it++)for(var at=0;at<t.dashes.length;++at){for(var ot=0,st=t.dashes[at]*v.dashMult*.5;ot<st;++ot)$[rt++]=nt;nt^=255}}d.dashLength=tt,d.dashTexture({channels:1,data:$,width:$.length,height:1,mag:"linear",min:"linear"},0,0)}if(t.color){var lt=d.count,ct=t.color;ct||(ct='transparent');var ut=new Uint8Array(4*lt+4);if(Array.isArray(ct)&&"number"!==typeof ct[0]){for(var ft=0;ft<lt;ft++){var ht=n(ct[ft],'uint8');ut.set(ht,4*ft)}ut.set(n(ct[0],'uint8'),4*lt)}else for(var pt=n(ct,'uint8'),dt=0;dt<lt+1;dt++)ut.set(pt,4*dt);d.colorBuffer({usage:"dynamic",type:"uint8",data:ut})}}else e.passes[r]=null})),t.length<this.passes.length){for(var d=t.length;d<this.passes.length;d++){var y=this.passes[d];y&&(y.colorBuffer.destroy(),y.positionBuffer.destroy(),y.dashTexture.destroy())}this.passes.length=t.length}for(var x=[],b=0;b<this.passes.length;b++)null!==this.passes[b]&&x.push(this.passes[b]);return this.passes=x,this}},v.prototype.destroy=function(){return this.passes.forEach((function(t){t.colorBuffer.destroy(),t.positionBuffer.destroy(),t.dashTexture.destroy()})),this.passes.length=0,this}},{"array-bounds":76,"array-find-index":77,"array-normalize":78,"color-normalize":131,earcut:183,"es6-weak-map":238,"flatten-vertex-data":248,glslify:434,"object-assign":476,"parse-rect":481,"pick-by-alias":485,"to-float32":584}],524:[function(t,e,r){"use strict";function n(t,e){return o(t)||l(t,e)||c(t,e)||h()}function i(t){return a(t)||s(t)||c(t)||f()}function a(t){if(Array.isArray(t))return u(t)}function o(t){if(Array.isArray(t))return t}function s(t){if("undefined"!==typeof Symbol&&null!=t[Symbol.iterator]||null!=t["@@iterator"])return Array.from(t)}function l(t,e){var r=null==t?null:"undefined"!==typeof Symbol&&t[Symbol.iterator]||t["@@iterator"];if(null!=r){var n,i,a=[],o=!0,s=!1;try{for(r=r.call(t);!(o=(n=r.next()).done)&&(a.push(n.value),!e||a.length!==e);o=!0);}catch(l){s=!0,i=l}finally{try{o||null==r.return||r.return()}finally[if(s)throw i]}return a}}function c(t,e){if(t){if("string"===typeof t)return u(t,e);var r=Object.prototype.toString.call(t).slice(8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?Array.from(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?u(t,e):void 0}}function u(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function f(){throw new TypeError('Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.')}function h(){throw new TypeError('Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.')}var p=t('color-normalize'),d=t('array-bounds'),m=t('color-id'),g=t('@plotly/point-cluster'),v=t('object-assign'),y=t('glslify'),x=t('pick-by-alias'),b=t('update-diff'),_=t('flatten-vertex-data'),w=t('is-iexplorer'),T=t('to-float32'),k=t('parse-rect'),M=A;function A(t,e){var r=this;if(!(this instanceof A))return new A(t,e);"function"===typeof t?(e||(e={}),e.regl=t):(e=t,t=null),e&&e.length&&(e.positions=e);var n,i=(t=e.regl)._gl,a=[],o={},s=[],l=[null],c=[null],u=255,f=100;this.tooManyColors=w,n=t.texture({data:new Uint8Array(4*u),width:u,height:1,type:"uint8",format:"rgba",wrapS:"clamp",wrapT:"clamp",mag:"nearest",min:"nearest"}),v(this,{regl:t,gl:i,groups:s,markerCache:c,markerTextures:l,palette:a,paletteIds:o,paletteTexture:n,maxColors:u,maxSize:f,canvas:i.canvas}),this.update(e);var h={uniforms:{constPointSize:!!e.constPointSize,opacity:t.prop('opacity'),paletteSize:function(t,e){return[r.tooManyColors?0:u,n.height]},pixelRatio:t.context('pixelRatio'),scale:t.prop('scale'),scaleFract:t.prop('scaleFract'),translate:t.prop('translate'),translateFract:t.prop('translateFract'),markerTexture:t.prop('markerTexture'),paletteTexture:n},attributes:{x:function(t,e){return e.xAttr||{buffer:e.positionBuffer,stride:8,offset:0}},y:function(t,e){return e.yAttr||{buffer:e.positionBuffer,stride:8,offset:4}},xFract:function(t,e){return e.xAttr?{constant:[0,0]}:{buffer:e.positionFractBuffer,stride:8,offset:0}},yFract:function(t,e){return e.yAttr?{constant:[0,0]}:{buffer:e.positionFractBuffer,stride:8,offset:4}},size:function(t,e){return e.size.length?{buffer:e.sizeBuffer,stride:2,offset:0}:{constant:[Math.round(255*e.size/r.maxSize)]}},borderSize:function(t,e){return e.borderSize.length?{buffer:e.sizeBuffer,stride:2,offset:1}:{constant:[Math.round(255*e.borderSize/r.maxSize)]}},colorId:function(t,e){return e.color.length?{buffer:e.colorBuffer,stride:r.tooManyColors?8:4,offset:0}:{constant:r.tooManyColors?a.slice(4*e.color,4*e.color+4):[e.color]}},borderColorId:function(t,e){return e.borderColor.length?{buffer:e.colorBuffer,stride:r.tooManyColors?8:4,offset:r.tooManyColors?4:2}:{constant:r.tooManyColors?a.slice(4*e.borderColor,4*e.borderColor+4):[e.borderColor]}},isActive:function(t,e){return!0===e.activation?{constant:[1]}:e.activation?e.activation:{constant:[0]}}},blend:{enable:!0,color:[0,0,0,1],func:{srcRGB:"src alpha",dstRGB:"one minus src alpha",srcAlpha:"one minus dst alpha",dstAlpha:"one"}},scissor:{enable:!0,box:t.prop('viewport')},viewport:t.prop('viewport'),stencil:{enable:!1},depth:{enable:!1},elements:t.prop('elements'),count:t.prop('count'),offset:t.prop('offset'),primitive:"points"},p=v({},h);p.frag=y(["precision highp float;\n#define GLSLIFY 1\n\nuniform float opacity;\nuniform sampler2D markerTexture;\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragWidth, fragBorderColorLevel, fragColorLevel;\n\nfloat smoothStep(float x, float y) {\n  return 1.0 / (1.0 + exp(50.0*(x - y)));\n}\n\nvoid main() {\n  float dist = texture2D(markerTexture, gl_PointCoord).r, delta = fragWidth;\n\n  // max-distance alpha\n  if (dist < 0.003) discard;\n\n  // null-border case\n  if (fragBorderColorLevel == fragColorLevel || fragBorderColor.a == 0.) {\n    float colorAmt = smoothstep(.5 - delta, .5 + delta, dist);\n    gl_FragColor = vec4(fragColor.rgb, colorAmt * fragColor.a * opacity);\n  }\n  else {\n    float borderColorAmt = smoothstep(fragBorderColorLevel - delta, fragBorderColorLevel + delta, dist);\n    float colorAmt = smoothstep(fragColorLevel - delta, fragColorLevel + delta, dist);\n\n    vec4 color = fragBorderColor;\n    color.a *= borderColorAmt;\n    color = mix(color, fragColor, colorAmt);\n    color.a *= opacity;\n\n    gl_FragColor = color;\n  }\n\n}\n"]),p.vert=y(["precision highp float;\n#define GLSLIFY 1\n\nattribute float x, y, xFract, yFract;\nattribute float size, borderSize;\nattribute vec4 colorId, borderColorId;\nattribute float isActive;\n\nuniform bool constPointSize;\nuniform float pixelRatio;\nuniform vec2 scale, scaleFract, translate, translateFract, paletteSize;\nuniform sampler2D paletteTexture;\n\nconst float maxSize = 100.;\nconst float borderLevel = .5;\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragPointSize, fragBorderRadius, fragWidth, fragBorderColorLevel, fragColorLevel;\n\nfloat pointSizeScale = (constPointSize) ? 2. : pixelRatio;\n\nbool isDirect = (paletteSize.x < 1.);\n\nvec4 getColor(vec4 id) {\n  return isDirect ? id / 255. : texture2D(paletteTexture,\n    vec2(\n      (id.x + .5) / paletteSize.x,\n      (id.y + .5) / paletteSize.y\n    )\n  );\n}\n\nvoid main() {\n  // ignore inactive points\n  if (isActive == 0.) return;\n\n  vec2 position = vec2(x, y);\n  vec2 positionFract = vec2(xFract, yFract);\n\n  vec4 color = getColor(colorId);\n  vec4 borderColor = getColor(borderColorId);\n\n  float size = size * maxSize / 255.;\n  float borderSize = borderSize * maxSize / 255.;\n\n  gl_PointSize = 2. * size * pointSizeScale;\n  fragPointSize = size * pixelRatio;\n\n  vec2 pos = (position + translate) * scale\n      + (positionFract + translateFract) * scale\n      + (position + translate) * scaleFract\n      + (positionFract + translateFract) * scaleFract;\n\n  gl_Position = vec4(pos * 2. - 1., 0., 1.);\n\n  fragColor = color;\n  fragBorderColor = borderColor;\n  fragWidth = 1. / gl_PointSize;\n\n  fragBorderColorLevel = clamp(borderLevel - borderLevel * borderSize / size, 0., 1.);\n  fragColorLevel = clamp(borderLevel + (1. - borderLevel) * borderSize / size, 0., 1.);\n}"]),this.drawMarker=t(p);var d=v({},h);d.frag=y(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragBorderRadius, fragWidth;\n\nuniform float opacity;\n\nfloat smoothStep(float edge0, float edge1, float x) {\n\tfloat t;\n\tt = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);\n\treturn t * t * (3.0 - 2.0 * t);\n}\n\nvoid main() {\n\tfloat radius, alpha = 1.0, delta = fragWidth;\n\n\tradius = length(2.0 * gl_PointCoord.xy - 1.0);\n\n\tif (radius > 1.0 + delta) {\n\t\tdiscard;\n\t}\n\n\talpha -= smoothstep(1.0 - delta, 1.0 + delta, radius);\n\n\tfloat borderRadius = fragBorderRadius;\n\tfloat ratio = smoothstep(borderRadius - delta, borderRadius + delta, radius);\n\tvec4 color = mix(fragColor, fragBorderColor, ratio);\n\tcolor.a *= alpha * opacity;\n\tgl_FragColor = color;\n}\n"]),d.vert=y(["precision highp float;\n#define GLSLIFY 1\n\nattribute float x, y, xFract, yFract;\nattribute float size, borderSize;\nattribute vec4 colorId, borderColorId;\nattribute float isActive;\n\nuniform bool constPointSize;\nuniform float pixelRatio;\nuniform vec2 paletteSize, scale, scaleFract, translate, translateFract;\nuniform sampler2D paletteTexture;\n\nconst float maxSize = 100.;\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragBorderRadius, fragWidth;\n\nfloat pointSizeScale = (constPointSize) ? 2. : pixelRatio;\n\nbool isDirect = (paletteSize.x < 1.);\n\nvec4 getColor(vec4 id) {\n  return isDirect ? id / 255. : texture2D(paletteTexture,\n    vec2(\n      (id.x + .5) / paletteSize.x,\n      (id.y + .5) / paletteSize.y\n    )\n  );\n}\n\nvoid main() {\n  // ignore inactive points\n  if (isActive == 0.) return;\n\n  vec2 position = vec2(x, y);\n  vec2 positionFract = vec2(xFract, yFract);\n\n  vec4 color = getColor(colorId);\n  vec4 borderColor = getColor(borderColorId);\n\n  float size = size * maxSize / 255.;\n  float borderSize = borderSize * maxSize / 255.;\n\n  gl_PointSize = (size + borderSize) * pointSizeScale;\n\n  vec2 pos = (position + translate) * scale\n      + (positionFract + translateFract) * scale\n      + (position + translate) * scaleFract\n      + (positionFract + translateFract) * scaleFract;\n\n  gl_Position = vec4(pos * 2. - 1., 0., 1.);\n\n  fragBorderRadius = 1. - 2. * borderSize / (size + borderSize);\n  fragColor = color;\n  fragBorderColor = borderColor.a == 0. || borderSize == 0. ? vec4(color.rgb, 0.) : borderColor;\n  fragWidth = 1. / gl_PointSize;\n}\n"]),w&&(d.frag=d.frag.replace('smoothstep','smoothStep'),p.frag=p.frag.replace('smoothstep','smoothStep')),this.drawCircle=t(d)}A.defaults={color:"black",borderColor:"transparent",borderSize:0,size:12,opacity:1,marker:void 0,viewport:null,range:null,pixelSize:null,count:0,offset:0,bounds:null,positions:[],snap:1e4},A.prototype.render=function(){return arguments.length&&this.update.apply(this,arguments),this.draw(),this},A.prototype.draw=function(){for(var t=this,e=arguments.length,r=new Array(e),n=0;n<e;n++)r[n]=arguments[n];var i=this.groups;if(1===r.length&&Array.isArray(r[0])&&(null===r[0][0]||Array.isArray(r[0][0]))&&(r=r[0]),this.regl._refresh(),r.length)for(var a=0;a<r.length;a++)this.drawItem(a,r[a]);else i.forEach((function(e,r){t.drawItem(r)}));return this},A.prototype.drawItem=function(t,e){var r=this.groups,n=r[t];if("number"===typeof e&&(t=e,n=r[e],e=null),n&&n.count&&n.opacity){n.activation[0]&&this.drawCircle(this.getMarkerDrawOptions(0,n,e));for(var a=[],o=1;o<n.activation.length;o++)n.activation[o]&&(!0===n.activation[o]||n.activation[o].data.length)&&a.push.apply(a,i(this.getMarkerDrawOptions(o,n,e)));a.length&&this.drawMarker(a)}},A.prototype.getMarkerDrawOptions=function(t,e,r){var i=e.range,a=e.tree,o=e.viewport,s=e.activation,l=e.selectionBuffer,c=e.count;if(this.regl,!a)return r?[v({},e,{markerTexture:this.markerTextures[t],activation:s[t],count:r.length,elements:r,offset:0})]:[v({},e,{markerTexture:this.markerTextures[t],activation:s[t],offset:0})];var u=[],f=a.range(i,{lod:!0,px:[(i[2]-i[0])/o.width,(i[3]-i[1])/o.height]});if(r){for(var h=s[t].data,p=new Uint8Array(c),d=0;d<r.length;d++){var m=r[d];p[m]=h?h[m]:1}l.subdata(p)}for(var g=f.length;g--;){var y=n(f[g],2),x=y[0],b=y[1];u.push(v({},e,{markerTexture:this.markerTextures[t],activation:r?l:s[t],offset:x,count:b-x}))}return u},A.prototype.update=function(){for(var t=this,e=arguments.length,r=new Array(e),n=0;n<e;n++)r[n]=arguments[n];if(r.length){1===r.length&&Array.isArray(r[0])&&(r=r[0]);var i=this.groups,a=this.gl,o=this.regl,s=this.maxSize,l=this.maxColors,c=this.palette;this.groups=i=r.map((function(e,r){var n=i[r];if(void 0===e)return n;null===e?e={positions:null}:"function"===typeof e?e={ondraw:e}:"number"===typeof e[0]&&(e={positions:e}),null===(e=x(e,{positions:"positions data points",snap:"snap cluster lod tree",size:"sizes size radius",borderSize:"borderSizes borderSize border-size bordersize borderWidth borderWidths border-width borderwidth stroke-width strokeWidth strokewidth outline",color:"colors color fill fill-color fillColor",borderColor:"borderColors borderColor stroke stroke-color strokeColor",marker:"markers marker shape",range:"range dataBox databox",viewport:"viewport viewPort viewBox viewbox",opacity:"opacity alpha transparency",bounds:"bound bounds boundaries limits",tooManyColors:"tooManyColors palette paletteMode optimizePalette enablePalette"})).positions&&(e.positions=[]),null!=e.tooManyColors&&(t.tooManyColors=e.tooManyColors),n||(i[r]=n={id:r,scale:null,translate:null,scaleFract:null,translateFract:null,activation:[],selectionBuffer:o.buffer({data:new Uint8Array(0),usage:"stream",type:"uint8"}),sizeBuffer:o.buffer({data:new Uint8Array(0),usage:"dynamic",type:"uint8"}),colorBuffer:o.buffer({data:new Uint8Array(0),usage:"dynamic",type:"uint8"}),positionBuffer:o.buffer({data:new Uint8Array(0),usage:"dynamic",type:"float"}),positionFractBuffer:o.buffer({data:new Uint8Array(0),usage:"dynamic",type:"float"})},e=v({},A.defaults,e)),e.positions&&!("marker"in e)&&(e.marker=n.marker,delete n.marker),e.marker&&!("positions"in e)&&(e.positions=n.positions,delete n.positions);var u=0,f=0;if(b(n,e,[{snap:!0,size:function(t,e){return null==t&&(t=A.defaults.size),u+=t&&t.length?1:0,t},borderSize:function(t,e){return null==t&&(t=A.defaults.borderSize),u+=t&&t.length?1:0,t},opacity:parseFloat,color:function(e,r){return null==e&&(e=A.defaults.color),e=t.updateColor(e),f++,e},borderColor:function(e,r){return null==e&&(e=A.defaults.borderColor),e=t.updateColor(e),f++,e},bounds:function(t,e,r){return"range"in r||(r.range=null),t},positions:function(t,e,r){var n=e.snap,i=e.positionBuffer,a=e.positionFractBuffer,s=e.selectionBuffer;if(t.x||t.y)return t.x.length?e.xAttr={buffer:o.buffer(t.x),offset:0,stride:4,count:t.x.length}:e.xAttr={buffer:t.x.buffer,offset:4*t.x.offset||0,stride:4*(t.x.stride||1),count:t.x.count},t.y.length?e.yAttr={buffer:o.buffer(t.y),offset:0,stride:4,count:t.y.length}:e.yAttr={buffer:t.y.buffer,offset:4*t.y.offset||0,stride:4*(t.y.stride||1),count:t.y.count},e.count=Math.max(e.xAttr.count,e.yAttr.count),t;t=_(t,'float64');var l=e.count=Math.floor(t.length/2),c=e.bounds=l?d(t,2):null;if(r.range||e.range||(delete e.range,r.range=c),r.marker||e.marker||(delete e.marker,r.marker=null),n&&(!0===n||l>n)?e.tree=g(t,{bounds:c}):n&&n.length&&(e.tree=n),e.tree){var u={primitive:"points",usage:"static",data:e.tree,type:"uint32"};e.elements?e.elements(u):e.elements=o.elements(u)}var f=T.float32(t);return i({data:f,usage:"dynamic"}),a({data:T.fract32(t,f),usage:"dynamic"}),s({data:new Uint8Array(l),type:"uint8",usage:"stream"}),t}},{marker:function(e,r,n){var i=r.activation;if(i.forEach((function(t){return t&&t.destroy&&t.destroy()})),i.length=0,e&&"number"!==typeof e[0]){for(var a=[],s=0,l=Math.min(e.length,r.count);s<l;s++){var c=t.addMarker(e[s]);a[c]||(a[c]=new Uint8Array(r.count)),a[c][s]=1}for(var u=0;u<a.length;u++)if(a[u]){var f={data:a[u],type:"uint8",usage:"static"};i[u]?i[u](f):i[u]=o.buffer(f),i[u].data=a[u]}}else i[t.addMarker(e)]=!0;return e},range:function(t,e,r){var n=e.bounds;if(n)return t||(t=n),e.scale=[1/(t[2]-t[0]),1/(t[3]-t[1])],e.translate=[-t[0],-t[1]],e.scaleFract=T.fract(e.scale),e.translateFract=T.fract(e.translate),t},viewport:function(t){return k(t||[a.drawingBufferWidth,a.drawingBufferHeight])}}]),u){var h=n,p=h.count,m=h.size,y=h.borderSize,w=h.sizeBuffer,M=new Uint8Array(2*p);if(m.length||y.length)for(var S=0;S<p;S++)M[2*S]=Math.round(255*(null==m[S]?m:m[S])/s),M[2*S+1]=Math.round(255*(null==y[S]?y:y[S])/s);w({data:M,usage:"dynamic"})}if(f){var E,L=n,C=L.count,P=L.color,I=L.borderColor,z=L.colorBuffer;if(t.tooManyColors){if(P.length||I.length){E=new Uint8Array(8*C);for(var O=0;O<C;O++){var D=P[O];E[8*O]=c[4*D],E[8*O+1]=c[4*D+1],E[8*O+2]=c[4*D+2],E[8*O+3]=c[4*D+3];var R=I[O];E[8*O+4]=c[4*R],E[8*O+5]=c[4*R+1],E[8*O+6]=c[4*R+2],E[8*O+7]=c[4*R+3]}}}else if(P.length||I.length){E=new Uint8Array(4*C+2);for(var F=0;F<C;F++)null!=P[F]&&(E[4*F]=P[F]%l,E[4*F+1]=Math.floor(P[F]/l)),null!=I[F]&&(E[4*F+2]=I[F]%l,E[4*F+3]=Math.floor(I[F]/l))}z({data:E||new Uint8Array(0),type:"uint8",usage:"dynamic"})}return n}))}},A.prototype.addMarker=function(t){var e,r=this.markerTextures,n=this.regl,i=this.markerCache,a=null==t?0:i.indexOf(t);if(a>=0)return a;if(t instanceof Uint8Array||t instanceof Uint8ClampedArray)e=t;else{e=new Uint8Array(t.length);for(var o=0,s=t.length;o<s;o++)e[o]=255*t[o]}var l=Math.floor(Math.sqrt(e.length));return a=r.length,i.push(t),r.push(n.texture({channels:1,data:e,radius:l,mag:"linear",min:"linear"})),a},A.prototype.updateColor=function(t){var e=this.paletteIds,r=this.palette,n=this.maxColors;Array.isArray(t)||(t=[t]);var i=[];if("number"===typeof t[0]){var a=[];if(Array.isArray(t))for(var o=0;o<t.length;o+=4)a.push(t.slice(o,o+4));else for(var s=0;s<t.length;s+=4)a.push(t.subarray(s,s+4));t=a}for(var l=0;l<t.length;l++){var c=t[l];c=p(c,'uint8');var u=m(c,!1);if(null==e[u]){var f=r.length;e[u]=Math.floor(f/4),r[f]=c[0],r[f+1]=c[1],r[f+2]=c[2],r[f+3]=c[3]}i[l]=e[u]}return!this.tooManyColors&&r.length>4*n&&(this.tooManyColors=!0),this.updatePalette(r),1===i.length?i[0]:i},A.prototype.updatePalette=function(t){if(!this.tooManyColors){var e=this.maxColors,r=this.paletteTexture,n=Math.ceil(.25*t.length/e);if(n>1)for(var i=.25*(t=t.slice()).length%e;i<n*e;i++)t.push(0,0,0,0);r.height<n&&r.resize(e,n),r.subimage({width:Math.min(.25*t.length,e),height:n,data:t},0,0)}},A.prototype.destroy=function(){return this.groups.forEach((function(t){t.sizeBuffer.destroy(),t.positionBuffer.destroy(),t.positionFractBuffer.destroy(),t.colorBuffer.destroy(),t.activation.forEach((function(t){return t&&t.destroy&&t.destroy()})),t.selectionBuffer.destroy(),t.elements&&t.elements.destroy()})),this.groups.length=0,this.paletteTexture.destroy(),this.markerTextures.forEach((function(t){return t&&t.destroy&&t.destroy()})),this};var S=t('object-assign'),E=function(t,e){var r=new M(t,e),n=r.render.bind(r);return S(n,{render:n,update:r.update.bind(r),draw:r.draw.bind(r),destroy:r.destroy.bind(r),regl:r.regl,gl:r.gl,canvas:r.gl.canvas,groups:r.groups,markers:r.markerCache,palette:r.palette}),n};e.exports=E},{"@plotly/point-cluster":59,"array-bounds":76,"color-id":129,"color-normalize":131,"flatten-vertex-data":248,glslify:434,"is-iexplorer":444,"object-assign":476,"parse-rect":481,"pick-by-alias":485,"to-float32":584,"update-diff":605}],525:[function(t,e,r){"use strict";var n=t('regl-scatter2d'),i=t('pick-by-alias'),a=t('array-bounds'),o=t('raf'),s=t('array-range'),l=t('parse-rect'),c=t('flatten-vertex-data');function u(t,e){if(!(this instanceof u))return new u(t,e);this.traces=[],this.passes={},this.regl=t,this.scatter=n(t),this.canvas=this.scatter.canvas}function f(t,e,r){return(null!=t.id?t.id:t)<<16|(255&e)<<8|255&r}function h(t,e,r){var n,i,a,o,s=t[e],l=t[r];return s.length>2?(s[0],s[2],n=s[1],i=s[3]):s.length?(n=s[0],i=s[1]):(s.x,n=s.y,s.x,s.width,i=s.y+s.height),l.length>2?(a=l[0],o=l[2],l[1],l[3]):l.length?(a=l[0],o=l[1]):(a=l.x,l.y,o=l.x+l.width,l.y,l.height),[a,n,o,i]}function p(t){if("number"===typeof t)return[t,t,t,t];if(2===t.length)return[t[0],t[1],t[0],t[1]];var e=l(t);return[e.x,e.y,e.x+e.width,e.y+e.height]}e.exports=u,u.prototype.render=function(){for(var t,e=this,r=[],n=arguments.length;n--;)r[n]=arguments[n];return r.length&&(t=this).update.apply(t,r),this.regl.attributes.preserveDrawingBuffer?this.draw():(this.dirty?null==this.planned&&(this.planned=o((function(){e.draw(),e.dirty=!0,e.planned=null}))):(this.draw(),this.dirty=!0,o((function()[e.dirty=!1]))),this)},u.prototype.update=function(){for(var t,e=[],r=arguments.length;r--;)e[r]=arguments[r];if(e.length){for(var n=0;n<e.length;n++)this.updateItem(n,e[n]);this.traces=this.traces.filter(Boolean);for(var i=[],a=0,o=0;o<this.traces.length;o++){for(var s=this.traces[o],l=this.traces[o].passes,c=0;c<l.length;c++)i.push(this.passes[l[c]]);s.passOffset=a,a+=s.passes.length}return(t=this.scatter).update.apply(t,i),this}},u.prototype.updateItem=function(t,e){var r=this.regl;if(null===e)return this.traces[t]=null,this;if(!e)return this;var n,o=i(e,{data:"data items columns rows values dimensions samples x",snap:"snap cluster",size:"sizes size radius",color:"colors color fill fill-color fillColor",opacity:"opacity alpha transparency opaque",borderSize:"borderSizes borderSize border-size bordersize borderWidth borderWidths border-width borderwidth stroke-width strokeWidth strokewidth outline",borderColor:"borderColors borderColor bordercolor stroke stroke-color strokeColor",marker:"markers marker shape",range:"range ranges databox dataBox",viewport:"viewport viewBox viewbox",domain:"domain domains area areas",padding:"pad padding paddings pads margin margins",transpose:"transpose transposed",diagonal:"diagonal diag showDiagonal",upper:"upper up top upperhalf upperHalf showupperhalf showUpper showUpperHalf",lower:"lower low bottom lowerhalf lowerHalf showlowerhalf showLowerHalf showLower"}),s=this.traces[t]||(this.traces[t]={id:t,buffer:r.buffer({usage:"dynamic",type:"float",data:new Uint8Array}),color:"black",marker:null,size:12,borderColor:"transparent",borderSize:1,viewport:l([r._gl.drawingBufferWidth,r._gl.drawingBufferHeight]),padding:[0,0,0,0],opacity:1,diagonal:!0,upper:!0,lower:!0});if(null!=o.color&&(s.color=o.color),null!=o.size&&(s.size=o.size),null!=o.marker&&(s.marker=o.marker),null!=o.borderColor&&(s.borderColor=o.borderColor),null!=o.borderSize&&(s.borderSize=o.borderSize),null!=o.opacity&&(s.opacity=o.opacity),o.viewport&&(s.viewport=l(o.viewport)),null!=o.diagonal&&(s.diagonal=o.diagonal),null!=o.upper&&(s.upper=o.upper),null!=o.lower&&(s.lower=o.lower),o.data){s.buffer(c(o.data)),s.columns=o.data.length,s.count=o.data[0].length,s.bounds=[];for(var u=0;u<s.columns;u++)s.bounds[u]=a(o.data[u],1)}o.range&&(s.range=o.range,n=s.range&&"number"!==typeof s.range[0]),o.domain&&(s.domain=o.domain);var d=!1;null!=o.padding&&(Array.isArray(o.padding)&&o.padding.length===s.columns&&"number"===typeof o.padding[o.padding.length-1]?(s.padding=o.padding.map(p),d=!0):s.padding=p(o.padding));var m=s.columns,g=s.count,v=s.viewport.width,y=s.viewport.height,x=s.viewport.x,b=s.viewport.y,_=v/m,w=y/m;s.passes=[];for(var T=0;T<m;T++)for(var k=0;k<m;k++)if((s.diagonal||k!==T)&&(s.upper||!(T>k))&&(s.lower||!(T<k))){var M=f(s.id,T,k),A=this.passes[M]||(this.passes[M]={});if(o.data&&(o.transpose?A.positions={x:{buffer:s.buffer,offset:k,count:g,stride:m},y:{buffer:s.buffer,offset:T,count:g,stride:m}}:A.positions={x:{buffer:s.buffer,offset:k*g,count:g},y:{buffer:s.buffer,offset:T*g,count:g}},A.bounds=h(s.bounds,T,k)),o.domain||o.viewport||o.data){var S=d?h(s.padding,T,k):s.padding;if(s.domain){var E=h(s.domain,T,k),L=E[0],C=E[1],P=E[2],I=E[3];A.viewport=[x+L*v+S[0],b+C*y+S[1],x+P*v-S[2],b+I*y-S[3]]}else A.viewport=[x+k*_+_*S[0],b+T*w+w*S[1],x+(k+1)*_-_*S[2],b+(T+1)*w-w*S[3]]}o.color&&(A.color=s.color),o.size&&(A.size=s.size),o.marker&&(A.marker=s.marker),o.borderSize&&(A.borderSize=s.borderSize),o.borderColor&&(A.borderColor=s.borderColor),o.opacity&&(A.opacity=s.opacity),o.range&&(A.range=n?h(s.range,T,k):s.range||A.bounds),s.passes.push(M)}return this},u.prototype.draw=function(){for(var t,e=[],r=arguments.length;r--;)e[r]=arguments[r];if(e.length){for(var n=[],i=0;i<e.length;i++)if("number"===typeof e[i]){var a=this.traces[e[i]],o=a.passes,l=a.passOffset;n.push.apply(n,s(l,l+o.length))}else if(e[i].length){var c=e[i],u=this.traces[i],f=u.passes,h=u.passOffset;f=f.map((function(t,e){n[h+e]=c}))}(t=this.scatter).draw.apply(t,n)}else this.scatter.draw();return this},u.prototype.destroy=function(){return this.traces.forEach((function(t){t.buffer&&t.buffer.destroy&&t.buffer.destroy()})),this.traces=null,this.passes=null,this.scatter.destroy(),this}},{"array-bounds":76,"array-range":79,"flatten-vertex-data":248,"parse-rect":481,"pick-by-alias":485,raf:516,"regl-scatter2d":524}],526:[function(e,r,n){var i,a;i=this,a=function(){function t(t,e){this.id=Z++,this.type=t,this.data=e}function e(t){if(0===t.length)return[];var r=t.charAt(0),n=t.charAt(t.length-1);if(1<t.length&&r===n&&('"'===r||"'"===r))return['"'+t.substr(1,t.length-2).replace(/\\/g,'\\\\').replace(/"/g,'\\"')+'"'];if(r=/\[(false|true|null|\d+|'[^']*'|"[^"]*")\]/.exec(t))return e(t.substr(0,r.index)).concat(e(r[1])).concat(e(t.substr(r.index+r[0].length)));if(1===(r=t.split('.')).length)return['"'+t.replace(/\\/g,'\\\\').replace(/"/g,'\\"')+'"'];for(t=[],n=0;n<r.length;++n)t=t.concat(e(r[n]));return t}function r(t){return"["+e(t).join('][')+"]"}function n(e,r){return"function"===typeof e?new t(0,e):"number"===typeof e||"boolean"===typeof e?new t(5,e):Array.isArray(e)?new t(6,e.map((function(t,e){return n(t,r+"["+e+"]")}))):e instanceof t?e:void 0}function i(){var t={"":0},e=[""];return{id:function(r){var n=t[r];return n||(n=t[r]=e.length,e.push(r),n)},str:function(t){return e[t]}}}function a(t,e,r){function n(){var e=window.innerWidth,n=window.innerHeight;t!==document.body&&(e=(n=a.getBoundingClientRect()).right-n.left,n=n.bottom-n.top),a.width=r*e,a.height=r*n}var i,a=document.createElement('canvas');return X(a.style,{border:0,margin:0,padding:0,top:0,left:0,width:"100%",height:"100%"}),t.appendChild(a),t===document.body&&(a.style.position='absolute',X(t.style,{margin:0,padding:0})),t!==document.body&&"function"===typeof ResizeObserver?(i=new ResizeObserver((function()[setTimeout(n)]))).observe(t):window.addEventListener('resize',n,!1),n(),{canvas:a,onDestroy:function(){i?i.disconnect():window.removeEventListener('resize',n),t.removeChild(a)}}}function o(t,e){function r(r){try{return t.getContext(r,e)}catch(n){return null}}return r('webgl')||r('experimental-webgl')||r('webgl-experimental')}function s(t){return"string"===typeof t?t.split():t}function l(t){return"string"===typeof t?document.querySelector(t):t}function c(t){var e,r,n,i,c=t||{};t={};var u=[],f=[],h="undefined"===typeof window?1:window.devicePixelRatio,p=!1,d=function(t){},m=function(){};if("string"===typeof c?e=document.querySelector(c):"object"===typeof c&&("string"===typeof c.nodeName&&"function"===typeof c.appendChild&&"function"===typeof c.getBoundingClientRect?e=c:"function"===typeof c.drawArrays||"function"===typeof c.drawElements?n=(i=c).canvas:("gl"in c?i=c.gl:"canvas"in c?n=l(c.canvas):"container"in c&&(r=l(c.container)),"attributes"in c&&(t=c.attributes),"extensions"in c&&(u=s(c.extensions)),"optionalExtensions"in c&&(f=s(c.optionalExtensions)),"onDone"in c&&(d=c.onDone),"profile"in c&&(p=!!c.profile),"pixelRatio"in c&&(h=+c.pixelRatio))),e&&("canvas"===e.nodeName.toLowerCase()?n=e:r=e),!i){if(!n){if(!(e=a(r||document.body,d,h)))return null;n=e.canvas,m=e.onDestroy}void 0===t.premultipliedAlpha&&(t.premultipliedAlpha=!0),i=o(n,t)}return i?{gl:i,canvas:n,container:r,extensions:u,optionalExtensions:f,pixelRatio:h,profile:p,onDone:d,onDestroy:m}:(m(),d('webgl not supported, try upgrading your browser or graphics drivers http://get.webgl.org'),null)}function u(t,e){function r(e){var r;e=e.toLowerCase();try{r=n[e]=t.getExtension(e)}catch(i){}return!!r}for(var n={},i=0;i<e.extensions.length;++i){var a=e.extensions[i];if(!r(a))return e.onDestroy(),e.onDone('"'+a+'" extension is not supported by the current WebGL context, try upgrading your system or a different browser'),null}return e.optionalExtensions.forEach(r),{extensions:n,restore:function(){Object.keys(n).forEach((function(t){if(n[t]&&!r(t))throw Error("(regl): error restoring extension "+t)}))}}}function f(t,e){for(var r=Array(t),n=0;n<t;++n)r[n]=e(n);return r}function h(t){var e,r;return e=(65535<t)<<4,e|=r=(255<(t>>>=e))<<3,(e|=r=(15<(t>>>=r))<<2)|(r=(3<(t>>>=r))<<1)|t>>>r>>1}function p(){function t(t){t:{for(var e=16;268435456>=e;e*=16)if(t<=e){t=e;break t}t=0}return 0<(e=r[h(t)>>2]).length?e.pop():new ArrayBuffer(t)}function e(t)[r[h(t.byteLength)>>2].push(t)]var r=f(8,(function(){return[]}));return{alloc:t,free:e,allocType:function(e,r){var n=null;switch(e){case 5120:n=new Int8Array(t(r),0,r);break;case 5121:n=new Uint8Array(t(r),0,r);break;case 5122:n=new Int16Array(t(2*r),0,r);break;case 5123:n=new Uint16Array(t(2*r),0,r);break;case 5124:n=new Int32Array(t(4*r),0,r);break;case 5125:n=new Uint32Array(t(4*r),0,r);break;case 5126:n=new Float32Array(t(4*r),0,r);break;default:return null}return n.length!==r?n.subarray(0,r):n},freeType:function(t)[e(t.buffer)]}}function d(t){return!!t&&"object"===typeof t&&Array.isArray(t.shape)&&Array.isArray(t.stride)&&"number"===typeof t.offset&&t.shape.length===t.stride.length&&(Array.isArray(t.data)||et(t.data))}function m(t,e,r,n,i,a){for(var o=0;o<e;++o)for(var s=t[o],l=0;l<r;++l)for(var c=s[l],u=0;u<n;++u)i[a++]=c[u]}function g(t,e,r,n,i){for(var a=1,o=r+1;o<e.length;++o)a*=e[o];var s=e[r];if(4===e.length-r){var l=e[r+1],c=e[r+2];for(e=e[r+3],o=0;o<s;++o)m(t[o],l,c,e,n,i),i+=a}else for(o=0;o<s;++o)g(t[o],e,r+1,n,i),i+=a}function v(t){return 0|it[Object.prototype.toString.call(t)]}function y(t,e){for(var r=0;r<e.length;++r)t[r]=e[r]}function x(t,e,r,n,i,a,o){for(var s=0,l=0;l<r;++l)for(var c=0;c<n;++c)t[s++]=e[i*l+a*c+o]}function b(t,e,r,n){function i(e){this.id=l++,this.buffer=t.createBuffer(),this.type=e,this.usage=35044,this.byteLength=0,this.dimension=1,this.dtype=5121,this.persistentData=null,r.profile&&(this.stats={size:0})}function a(e,r,n){e.byteLength=r.byteLength,t.bufferData(e.type,r,n)}function o(t,e,r,n,i,o){if(t.usage=r,Array.isArray(e)){if(t.dtype=n||5126,0<e.length)if(Array.isArray(e[0])){i=lt(e);for(var s=n=1;s<i.length;++s)n*=i[s];t.dimension=n,a(t,e=st(e,i,t.dtype),r),o?t.persistentData=e:$.freeType(e)}else"number"===typeof e[0]?(t.dimension=i,y(i=$.allocType(t.dtype,e.length),e),a(t,i,r),o?t.persistentData=i:$.freeType(i)):et(e[0])&&(t.dimension=e[0].length,t.dtype=n||v(e[0])||5126,a(t,e=st(e,[e.length,e[0].length],t.dtype),r),o?t.persistentData=e:$.freeType(e))}else if(et(e))t.dtype=n||v(e),t.dimension=i,a(t,e,r),o&&(t.persistentData=new Uint8Array(new Uint8Array(e.buffer)));else if(d(e)){i=e.shape;var l=e.stride,c=(s=e.offset,0),u=0,f=0,h=0;1===i.length?(c=i[0],u=1,f=l[0],h=0):2===i.length&&(c=i[0],u=i[1],f=l[0],h=l[1]),t.dtype=n||v(e.data)||5126,t.dimension=u,x(i=$.allocType(t.dtype,c*u),e.data,c,u,f,h,s),a(t,i,r),o?t.persistentData=i:$.freeType(i)}else e instanceof ArrayBuffer&&(t.dtype=5121,t.dimension=i,a(t,e,r),o&&(t.persistentData=new Uint8Array(new Uint8Array(e))))}function s(r){e.bufferCount--,n(r),t.deleteBuffer(r.buffer),r.buffer=null,delete c[r.id]}var l=0,c={};i.prototype.bind=function(){t.bindBuffer(this.type,this.buffer)},i.prototype.destroy=function()[s(this)];var u=[];return r.profile&&(e.getTotalBufferSize=function(){var t=0;return Object.keys(c).forEach((function(e){t+=c[e].stats.size})),t}),{create:function(n,a,l,u){function f(e){var n=35044,i=null,a=0,s=0,l=1;return Array.isArray(e)||et(e)||d(e)||e instanceof ArrayBuffer?i=e:"number"===typeof e?a=0|e:e&&("data"in e&&(i=e.data),"usage"in e&&(n=ot[e.usage]),"type"in e&&(s=at[e.type]),"dimension"in e&&(l=0|e.dimension),"length"in e&&(a=0|e.length)),h.bind(),i?o(h,i,n,s,l,u):(a&&t.bufferData(h.type,a,n),h.dtype=s||5121,h.usage=n,h.dimension=l,h.byteLength=a),r.profile&&(h.stats.size=h.byteLength*ct[h.dtype]),f}e.bufferCount++;var h=new i(a);return c[h.id]=h,l||f(n),f._reglType='buffer',f._buffer=h,f.subdata=function(e,r){var n,i=0|(r||0);if(h.bind(),et(e)||e instanceof ArrayBuffer)t.bufferSubData(h.type,i,e);else if(Array.isArray(e)){if(0<e.length)if("number"===typeof e[0]){var a=$.allocType(h.dtype,e.length);y(a,e),t.bufferSubData(h.type,i,a),$.freeType(a)}else(Array.isArray(e[0])||et(e[0]))&&(n=lt(e),a=st(e,n,h.dtype),t.bufferSubData(h.type,i,a),$.freeType(a))}else if(d(e)){n=e.shape;var o=e.stride,s=a=0,l=0,c=0;1===n.length?(a=n[0],s=1,l=o[0],c=0):2===n.length&&(a=n[0],s=n[1],l=o[0],c=o[1]),n=Array.isArray(e.data)?h.dtype:v(e.data),x(n=$.allocType(n,a*s),e.data,a,s,l,c,e.offset),t.bufferSubData(h.type,i,n),$.freeType(n)}return f},r.profile&&(f.stats=h.stats),f.destroy=function()[s(h)],f},createStream:function(t,e){var r=u.pop();return r||(r=new i(t)),r.bind(),o(r,e,35040,0,1,!1),r},destroyStream:function(t)[u.push(t)],clear:function(){rt(c).forEach(s),u.forEach(s)},getBuffer:function(t){return t&&t._buffer instanceof i?t._buffer:null},restore:function(){rt(c).forEach((function(e){e.buffer=t.createBuffer(),t.bindBuffer(e.type,e.buffer),t.bufferData(e.type,e.persistentData||e.byteLength,e.usage)}))},_initBuffer:o}}function _(t,e,r,n){function i(t){this.id=l++,s[this.id]=this,this.buffer=t,this.primType=4,this.type=this.vertCount=0}function a(n,i,a,o,s,l,c){var u;if(n.buffer.bind(),i?((u=c)||et(i)&&(!d(i)||et(i.data))||(u=e.oes_element_index_uint?5125:5123),r._initBuffer(n.buffer,i,a,u,3)):(t.bufferData(34963,l,a),n.buffer.dtype=u||5121,n.buffer.usage=a,n.buffer.dimension=3,n.buffer.byteLength=l),u=c,!c){switch(n.buffer.dtype){case 5121:case 5120:u=5121;break;case 5123:case 5122:u=5123;break;case 5125:case 5124:u=5125}n.buffer.dtype=u}n.type=u,0>(i=s)&&(i=n.buffer.byteLength,5123===u?i>>=1:5125===u&&(i>>=2)),n.vertCount=i,i=o,0>o&&(i=4,1===(o=n.buffer.dimension)&&(i=0),2===o&&(i=1),3===o&&(i=4)),n.primType=i}function o(t){n.elementsCount--,delete s[t.id],t.buffer.destroy(),t.buffer=null}var s={},l=0,c={uint8:5121,uint16:5123};e.oes_element_index_uint&&(c.uint32=5125),i.prototype.bind=function()[this.buffer.bind()];var u=[];return{create:function(t,e){function s(t){if(t)if("number"===typeof t)l(t),u.primType=4,u.vertCount=0|t,u.type=5121;else{var e=null,r=35044,n=-1,i=-1,o=0,f=0;Array.isArray(t)||et(t)||d(t)?e=t:("data"in t&&(e=t.data),"usage"in t&&(r=ot[t.usage]),"primitive"in t&&(n=ut[t.primitive]),"count"in t&&(i=0|t.count),"type"in t&&(f=c[t.type]),"length"in t?o=0|t.length:(o=i,5123===f||5122===f?o*=2:5125!==f&&5124!==f||(o*=4))),a(u,e,r,n,i,o,f)}else l(),u.primType=4,u.vertCount=0,u.type=5121;return s}var l=r.create(null,34963,!0),u=new i(l._buffer);return n.elementsCount++,s(t),s._reglType='elements',s._elements=u,s.subdata=function(t,e){return l.subdata(t,e),s},s.destroy=function()[o(u)],s},createStream:function(t){var e=u.pop();return e||(e=new i(r.create(null,34963,!0,!1)._buffer)),a(e,t,35040,-1,-1,0,0),e},destroyStream:function(t)[u.push(t)],getElements:function(t){return"function"===typeof t&&t._elements instanceof i?t._elements:null},clear:function()[rt(s).forEach(o)]}}function w(t){for(var e=$.allocType(5123,t.length),r=0;r<t.length;++r)if(isNaN(t[r]))e[r]=65535;else if(1/0===t[r])e[r]=31744;else if(-1/0===t[r])e[r]=64512;else{ft[0]=t[r];var n=(a=ht[0])>>>31<<15,i=(a<<1>>>24)-127,a=a>>13&1023;e[r]=-24>i?n:-14>i?n+(a+1024>>-14-i):15<i?n+31744:n+(i+15<<10)+a}return e}function T(t){return Array.isArray(t)||et(t)}function k(t){return"[object "+t+"]"}function M(t){return Array.isArray(t)&&(0===t.length||"number"===typeof t[0])}function A(t){return!(!Array.isArray(t)||0===t.length||!T(t[0]))}function S(t){return Object.prototype.toString.call(t)}function E(t){if(!t)return!1;var e=S(t);return 0<=wt.indexOf(e)||M(t)||A(t)||d(t)}function L(t,e){36193===t.type?(t.data=w(e),$.freeType(e)):t.data=e}function C(t,e,r,n,i,a){if(t="undefined"!==typeof kt[t]?kt[t]:mt[t]*Tt[e],a&&(t*=6),i){for(n=0;1<=r;)n+=t*r*r,r/=2;return n}return t*r*n}function P(t,e,r,n,i,a,o){function s(){this.format=this.internalformat=6408,this.type=5121,this.flipY=this.premultiplyAlpha=this.compressed=!1,this.unpackAlignment=1,this.colorSpace=37444,this.channels=this.height=this.width=0}function l(t,e){t.internalformat=e.internalformat,t.format=e.format,t.type=e.type,t.compressed=e.compressed,t.premultiplyAlpha=e.premultiplyAlpha,t.flipY=e.flipY,t.unpackAlignment=e.unpackAlignment,t.colorSpace=e.colorSpace,t.width=e.width,t.height=e.height,t.channels=e.channels}function c(t,e){if("object"===typeof e&&e){"premultiplyAlpha"in e&&(t.premultiplyAlpha=e.premultiplyAlpha),"flipY"in e&&(t.flipY=e.flipY),"alignment"in e&&(t.unpackAlignment=e.alignment),"colorSpace"in e&&(t.colorSpace=V[e.colorSpace]),"type"in e&&(t.type=H[e.type]);var r=t.width,n=t.height,i=t.channels,a=!1;"shape"in e?(r=e.shape[0],n=e.shape[1],3===e.shape.length&&(i=e.shape[2],a=!0)):("radius"in e&&(r=n=e.radius),"width"in e&&(r=e.width),"height"in e&&(n=e.height),"channels"in e&&(i=e.channels,a=!0)),t.width=0|r,t.height=0|n,t.channels=0|i,r=!1,"format"in e&&(r=e.format,n=t.internalformat=q[r],t.format=at[n],r in H&&!("type"in e)&&(t.type=H[r]),r in G&&(t.compressed=!0),r=!0),!a&&r?t.channels=mt[t.format]:a&&!r&&t.channels!==dt[t.format]&&(t.format=t.internalformat=dt[t.channels])}}function u(e){t.pixelStorei(37440,e.flipY),t.pixelStorei(37441,e.premultiplyAlpha),t.pixelStorei(37443,e.colorSpace),t.pixelStorei(3317,e.unpackAlignment)}function f(){s.call(this),this.yOffset=this.xOffset=0,this.data=null,this.needsFree=!1,this.element=null,this.needsCopy=!1}function h(t,e){var r=null;if(E(e)?r=e:e&&(c(t,e),"x"in e&&(t.xOffset=0|e.x),"y"in e&&(t.yOffset=0|e.y),E(e.data)&&(r=e.data)),e.copy){var n=i.viewportWidth,a=i.viewportHeight;t.width=t.width||n-t.xOffset,t.height=t.height||a-t.yOffset,t.needsCopy=!0}else if(r){if(et(r))t.channels=t.channels||4,t.data=r,"type"in e||5121!==t.type||(t.type=0|it[Object.prototype.toString.call(r)]);else if(M(r)){switch(t.channels=t.channels||4,a=(n=r).length,t.type){case 5121:case 5123:case 5125:case 5126:(a=$.allocType(t.type,a)).set(n),t.data=a;break;case 36193:t.data=w(n)}t.alignment=1,t.needsFree=!0}else if(d(r)){n=r.data,Array.isArray(n)||5121!==t.type||(t.type=0|it[Object.prototype.toString.call(n)]),a=r.shape;var o,s,l,u,f=r.stride;3===a.length?(l=a[2],u=f[2]):u=l=1,o=a[0],s=a[1],a=f[0],f=f[1],t.alignment=1,t.width=o,t.height=s,t.channels=l,t.format=t.internalformat=dt[l],t.needsFree=!0,o=u,r=r.offset,l=t.width,u=t.height,s=t.channels;for(var h=$.allocType(36193===t.type?5126:t.type,l*u*s),p=0,m=0;m<u;++m)for(var g=0;g<l;++g)for(var v=0;v<s;++v)h[p++]=n[a*g+f*m+o*v+r];L(t,h)}else if(S(r)===gt||S(r)===vt||S(r)===yt)S(r)===gt||S(r)===vt?t.element=r:t.element=r.canvas,t.width=t.element.width,t.height=t.element.height,t.channels=4;else if(S(r)===xt)t.element=r,t.width=r.width,t.height=r.height,t.channels=4;else if(S(r)===bt)t.element=r,t.width=r.naturalWidth,t.height=r.naturalHeight,t.channels=4;else if(S(r)===_t)t.element=r,t.width=r.videoWidth,t.height=r.videoHeight,t.channels=4;else if(A(r)){for(n=t.width||r[0].length,a=t.height||r.length,f=t.channels,f=T(r[0][0])?f||r[0][0].length:f||1,o=nt.shape(r),l=1,u=0;u<o.length;++u)l*=o[u];l=$.allocType(36193===t.type?5126:t.type,l),nt.flatten(r,o,'',l),L(t,l),t.alignment=1,t.width=n,t.height=a,t.channels=f,t.format=t.internalformat=dt[f],t.needsFree=!0}}else t.width=t.width||1,t.height=t.height||1,t.channels=t.channels||4}function p(e,r,i,a,o){var s=e.element,l=e.data,c=e.internalformat,f=e.format,h=e.type,p=e.width,d=e.height;u(e),s?t.texSubImage2D(r,o,i,a,f,h,s):e.compressed?t.compressedTexSubImage2D(r,o,i,a,c,p,d,l):e.needsCopy?(n(),t.copyTexSubImage2D(r,o,i,a,e.xOffset,e.yOffset,p,d)):t.texSubImage2D(r,o,i,a,p,d,f,h,l)}function m(){return ot.pop()||new f}function g(t){t.needsFree&&$.freeType(t.data),f.call(t),ot.push(t)}function v(){s.call(this),this.genMipmaps=!1,this.mipmapHint=4352,this.mipmask=0,this.images=Array(16)}function y(t,e,r){var n=t.images[0]=m();t.mipmask=1,n.width=t.width=e,n.height=t.height=r,n.channels=t.channels=4}function x(t,e){var r=null;if(E(e))l(r=t.images[0]=m(),t),h(r,e),t.mipmask=1;else if(c(t,e),Array.isArray(e.mipmap))for(var n=e.mipmap,i=0;i<n.length;++i)l(r=t.images[i]=m(),t),r.width>>=i,r.height>>=i,h(r,n[i]),t.mipmask|=1<<i;else l(r=t.images[0]=m(),t),h(r,e),t.mipmask=1;l(t,t.images[0])}function b(e,r){for(var i=e.images,a=0;a<i.length&&i[a];++a){var o=i[a],s=r,l=a,c=o.element,f=o.data,h=o.internalformat,p=o.format,d=o.type,m=o.width,g=o.height;u(o),c?t.texImage2D(s,l,p,p,d,c):o.compressed?t.compressedTexImage2D(s,l,h,m,g,0,f):o.needsCopy?(n(),t.copyTexImage2D(s,l,p,o.xOffset,o.yOffset,m,g,0)):t.texImage2D(s,l,p,m,g,0,p,d,f||null)}}function _(){var t=st.pop()||new v;s.call(t);for(var e=t.mipmask=0;16>e;++e)t.images[e]=null;return t}function k(t){for(var e=t.images,r=0;r<e.length;++r)e[r]&&g(e[r]),e[r]=null;st.push(t)}function P(){this.magFilter=this.minFilter=9728,this.wrapT=this.wrapS=33071,this.anisotropic=1,this.genMipmaps=!1,this.mipmapHint=4352}function I(t,e){"min"in e&&(t.minFilter=U[e.min],0<=pt.indexOf(t.minFilter)&&!("faces"in e)&&(t.genMipmaps=!0)),"mag"in e&&(t.magFilter=j[e.mag]);var r=t.wrapS,n=t.wrapT;if("wrap"in e){var i=e.wrap;"string"===typeof i?r=n=N[i]:Array.isArray(i)&&(r=N[i[0]],n=N[i[1]])}else"wrapS"in e&&(r=N[e.wrapS]),"wrapT"in e&&(n=N[e.wrapT]);if(t.wrapS=r,t.wrapT=n,"anisotropic"in e&&(t.anisotropic=e.anisotropic),"mipmap"in e){switch(r=!1,typeof e.mipmap){case"string":t.mipmapHint=B[e.mipmap],r=t.genMipmaps=!0;break;case"boolean":r=t.genMipmaps=e.mipmap;break;case"object":t.genMipmaps=!1,r=!0}!r||"min"in e||(t.minFilter=9984)}}function z(r,n){t.texParameteri(n,10241,r.minFilter),t.texParameteri(n,10240,r.magFilter),t.texParameteri(n,10242,r.wrapS),t.texParameteri(n,10243,r.wrapT),e.ext_texture_filter_anisotropic&&t.texParameteri(n,34046,r.anisotropic),r.genMipmaps&&(t.hint(33170,r.mipmapHint),t.generateMipmap(n))}function O(e){s.call(this),this.mipmask=0,this.internalformat=6408,this.id=lt++,this.refCount=1,this.target=e,this.texture=t.createTexture(),this.unit=-1,this.bindCount=0,this.texInfo=new P,o.profile&&(this.stats={size:0})}function D(e){t.activeTexture(33984),t.bindTexture(e.target,e.texture)}function R(){var e=ft[0];e?t.bindTexture(e.target,e.texture):t.bindTexture(3553,null)}function F(e){var r=e.texture,n=e.unit,i=e.target;0<=n&&(t.activeTexture(33984+n),t.bindTexture(i,null),ft[n]=null),t.deleteTexture(r),e.texture=null,e.params=null,e.pixels=null,e.refCount=0,delete ct[e.id],a.textureCount--}var B={"don't care":4352,"dont care":4352,nice:4354,fast:4353},N={repeat:10497,clamp:33071,mirror:33648},j={nearest:9728,linear:9729},U=X({mipmap:9987,"nearest mipmap nearest":9984,"linear mipmap nearest":9985,"nearest mipmap linear":9986,"linear mipmap linear":9987},j),V={none:0,browser:37444},H={uint8:5121,rgba4:32819,rgb565:33635,"rgb5 a1":32820},q={alpha:6406,luminance:6409,"luminance alpha":6410,rgb:6407,rgba:6408,rgba4:32854,"rgb5 a1":32855,rgb565:36194},G={};e.ext_srgb&&(q.srgb=35904,q.srgba=35906),e.oes_texture_float&&(H.float32=H.float=5126),e.oes_texture_half_float&&(H.float16=H["half float"]=36193),e.webgl_depth_texture&&(X(q,{depth:6402,"depth stencil":34041}),X(H,{uint16:5123,uint32:5125,"depth stencil":34042})),e.webgl_compressed_texture_s3tc&&X(G,{"rgb s3tc dxt1":33776,"rgba s3tc dxt1":33777,"rgba s3tc dxt3":33778,"rgba s3tc dxt5":33779}),e.webgl_compressed_texture_atc&&X(G,{"rgb atc":35986,"rgba atc explicit alpha":35987,"rgba atc interpolated alpha":34798}),e.webgl_compressed_texture_pvrtc&&X(G,{"rgb pvrtc 4bppv1":35840,"rgb pvrtc 2bppv1":35841,"rgba pvrtc 4bppv1":35842,"rgba pvrtc 2bppv1":35843}),e.webgl_compressed_texture_etc1&&(G["rgb etc1"]=36196);var Y=Array.prototype.slice.call(t.getParameter(34467));Object.keys(G).forEach((function(t){var e=G[t];0<=Y.indexOf(e)&&(q[t]=e)}));var W=Object.keys(q);r.textureFormats=W;var Z=[];Object.keys(q).forEach((function(t)[Z[q[t]]=t]));var J=[];Object.keys(H).forEach((function(t)[J[H[t]]=t]));var K=[];Object.keys(j).forEach((function(t)[K[j[t]]=t]));var Q=[];Object.keys(U).forEach((function(t)[Q[U[t]]=t]));var tt=[];Object.keys(N).forEach((function(t)[tt[N[t]]=t]));var at=W.reduce((function(t,r){var n=q[r];return 6409===n||6406===n||6409===n||6410===n||6402===n||34041===n||e.ext_srgb&&(35904===n||35906===n)?t[n]=n:32855===n||0<=r.indexOf('rgba')?t[n]=6408:t[n]=6407,t}),{}),ot=[],st=[],lt=0,ct={},ut=r.maxTextureUnits,ft=Array(ut).map((function(){return null}));return X(O.prototype,{bind:function(){this.bindCount+=1;var e=this.unit;if(0>e){for(var r=0;r<ut;++r){var n=ft[r];if(n){if(0<n.bindCount)continue;n.unit=-1}ft[r]=this,e=r;break}o.profile&&a.maxTextureUnits<e+1&&(a.maxTextureUnits=e+1),this.unit=e,t.activeTexture(33984+e),t.bindTexture(this.target,this.texture)}return e},unbind:function()[--this.bindCount],decRef:function()[0>=--this.refCount&&F(this)]}),o.profile&&(a.getTotalTextureSize=function(){var t=0;return Object.keys(ct).forEach((function(e){t+=ct[e].stats.size})),t}),{create2D:function(e,r){function n(t,e){var r=i.texInfo;P.call(r);var a=_();return"number"===typeof t?y(a,0|t,"number"===typeof e?0|e:0|t):t?(I(r,t),x(a,t)):y(a,1,1),r.genMipmaps&&(a.mipmask=(a.width<<1)-1),i.mipmask=a.mipmask,l(i,a),i.internalformat=a.internalformat,n.width=a.width,n.height=a.height,D(i),b(a,3553),z(r,3553),R(),k(a),o.profile&&(i.stats.size=C(i.internalformat,i.type,a.width,a.height,r.genMipmaps,!1)),n.format=Z[i.internalformat],n.type=J[i.type],n.mag=K[r.magFilter],n.min=Q[r.minFilter],n.wrapS=tt[r.wrapS],n.wrapT=tt[r.wrapT],n}var i=new O(3553);return ct[i.id]=i,a.textureCount++,n(e,r),n.subimage=function(t,e,r,a){e|=0,r|=0,a|=0;var o=m();return l(o,i),o.width=0,o.height=0,h(o,t),o.width=o.width||(i.width>>a)-e,o.height=o.height||(i.height>>a)-r,D(i),p(o,3553,e,r,a),R(),g(o),n},n.resize=function(e,r){var a=0|e,s=0|r||a;if(a===i.width&&s===i.height)return n;n.width=i.width=a,n.height=i.height=s,D(i);for(var l=0;i.mipmask>>l;++l){var c=a>>l,u=s>>l;if(!c||!u)break;t.texImage2D(3553,l,i.format,c,u,0,i.format,i.type,null)}return R(),o.profile&&(i.stats.size=C(i.internalformat,i.type,a,s,!1,!1)),n},n._reglType='texture2d',n._texture=i,o.profile&&(n.stats=i.stats),n.destroy=function()[i.decRef()],n},createCube:function(e,r,n,i,s,u){function f(t,e,r,n,i,a){var s,u=d.texInfo;for(P.call(u),s=0;6>s;++s)v[s]=_();if("number"!==typeof t&&t){if("object"===typeof t)if(e)x(v[0],t),x(v[1],e),x(v[2],r),x(v[3],n),x(v[4],i),x(v[5],a);else if(I(u,t),c(d,t),"faces"in t)for(t=t.faces,s=0;6>s;++s)l(v[s],d),x(v[s],t[s]);else for(s=0;6>s;++s)x(v[s],t)}else for(t=0|t||1,s=0;6>s;++s)y(v[s],t,t);for(l(d,v[0]),d.mipmask=u.genMipmaps?(v[0].width<<1)-1:v[0].mipmask,d.internalformat=v[0].internalformat,f.width=v[0].width,f.height=v[0].height,D(d),s=0;6>s;++s)b(v[s],34069+s);for(z(u,34067),R(),o.profile&&(d.stats.size=C(d.internalformat,d.type,f.width,f.height,u.genMipmaps,!0)),f.format=Z[d.internalformat],f.type=J[d.type],f.mag=K[u.magFilter],f.min=Q[u.minFilter],f.wrapS=tt[u.wrapS],f.wrapT=tt[u.wrapT],s=0;6>s;++s)k(v[s]);return f}var d=new O(34067);ct[d.id]=d,a.cubeCount++;var v=Array(6);return f(e,r,n,i,s,u),f.subimage=function(t,e,r,n,i){r|=0,n|=0,i|=0;var a=m();return l(a,d),a.width=0,a.height=0,h(a,e),a.width=a.width||(d.width>>i)-r,a.height=a.height||(d.height>>i)-n,D(d),p(a,34069+t,r,n,i),R(),g(a),f},f.resize=function(e){if((e|=0)!==d.width){f.width=d.width=e,f.height=d.height=e,D(d);for(var r=0;6>r;++r)for(var n=0;d.mipmask>>n;++n)t.texImage2D(34069+r,n,d.format,e>>n,e>>n,0,d.format,d.type,null);return R(),o.profile&&(d.stats.size=C(d.internalformat,d.type,f.width,f.height,!1,!0)),f}},f._reglType='textureCube',f._texture=d,o.profile&&(f.stats=d.stats),f.destroy=function()[d.decRef()],f},clear:function(){for(var e=0;e<ut;++e)t.activeTexture(33984+e),t.bindTexture(3553,null),ft[e]=null;rt(ct).forEach(F),a.cubeCount=0,a.textureCount=0},getTexture:function(t){return null},restore:function(){for(var e=0;e<ut;++e){var r=ft[e];r&&(r.bindCount=0,r.unit=-1,ft[e]=null)}rt(ct).forEach((function(e){e.texture=t.createTexture(),t.bindTexture(e.target,e.texture);for(var r=0;32>r;++r)if(0!==(e.mipmask&1<<r))if(3553===e.target)t.texImage2D(3553,r,e.internalformat,e.width>>r,e.height>>r,0,e.internalformat,e.type,null);else for(var n=0;6>n;++n)t.texImage2D(34069+n,r,e.internalformat,e.width>>r,e.height>>r,0,e.internalformat,e.type,null);z(e.texInfo,e.target)}))},refresh:function(){for(var e=0;e<ut;++e){var r=ft[e];r&&(r.bindCount=0,r.unit=-1,ft[e]=null),t.activeTexture(33984+e),t.bindTexture(3553,null),t.bindTexture(34067,null)}}}}function I(t,e,r,n,i,a){function o(t,e,r){this.target=t,this.texture=e,this.renderbuffer=r;var n=t=0;e?(t=e.width,n=e.height):r&&(t=r.width,n=r.height),this.width=t,this.height=n}function s(t){t&&(t.texture&&t.texture._texture.decRef(),t.renderbuffer&&t.renderbuffer._renderbuffer.decRef())}function l(t,e,r){t&&(t.texture?t.texture._texture.refCount+=1:t.renderbuffer._renderbuffer.refCount+=1)}function c(e,r){r&&(r.texture?t.framebufferTexture2D(36160,e,r.target,r.texture._texture.texture,0):t.framebufferRenderbuffer(36160,e,36161,r.renderbuffer._renderbuffer.renderbuffer))}function u(t){var e=3553,r=null,n=null,i=t;return"object"===typeof t&&(i=t.data,"target"in t&&(e=0|t.target)),"texture2d"===(t=i._reglType)||"textureCube"===t?r=i:"renderbuffer"===t&&(n=i,e=36161),new o(e,r,n)}function f(t,e,r,a,s){return r?((t=n.create2D({width:t,height:e,format:a,type:s}))._texture.refCount=0,new o(3553,t,null)):((t=i.create({width:t,height:e,format:a}))._renderbuffer.refCount=0,new o(36161,null,t))}function h(t){return t&&(t.texture||t.renderbuffer)}function p(t,e,r){t&&(t.texture?t.texture.resize(e,r):t.renderbuffer&&t.renderbuffer.resize(e,r),t.width=e,t.height=r)}function d(){this.id=T++,k[this.id]=this,this.framebuffer=t.createFramebuffer(),this.height=this.width=0,this.colorAttachments=[],this.depthStencilAttachment=this.stencilAttachment=this.depthAttachment=null}function m(t){t.colorAttachments.forEach(s),s(t.depthAttachment),s(t.stencilAttachment),s(t.depthStencilAttachment)}function g(e){t.deleteFramebuffer(e.framebuffer),e.framebuffer=null,a.framebufferCount--,delete k[e.id]}function v(e){var n;t.bindFramebuffer(36160,e.framebuffer);var i=e.colorAttachments;for(n=0;n<i.length;++n)c(36064+n,i[n]);for(n=i.length;n<r.maxColorAttachments;++n)t.framebufferTexture2D(36160,36064+n,3553,null,0);t.framebufferTexture2D(36160,33306,3553,null,0),t.framebufferTexture2D(36160,36096,3553,null,0),t.framebufferTexture2D(36160,36128,3553,null,0),c(36096,e.depthAttachment),c(36128,e.stencilAttachment),c(33306,e.depthStencilAttachment),t.checkFramebufferStatus(36160),t.isContextLost(),t.bindFramebuffer(36160,x.next?x.next.framebuffer:null),x.cur=x.next,t.getError()}function y(t,e){function r(t,e){var i,a=0,o=0,s=!0,c=!0;i=null;var p=!0,d='rgba',g='uint8',y=1,x=null,w=null,T=null,k=!1;"number"===typeof t?(a=0|t,o=0|e||a):t?("shape"in t?(a=(o=t.shape)[0],o=o[1]):("radius"in t&&(a=o=t.radius),"width"in t&&(a=t.width),"height"in t&&(o=t.height)),("color"in t||"colors"in t)&&(i=t.color||t.colors,Array.isArray(i)),i||("colorCount"in t&&(y=0|t.colorCount),"colorTexture"in t&&(p=!!t.colorTexture,d='rgba4'),"colorType"in t&&(g=t.colorType,!p)&&("half float"===g||"float16"===g?d="rgba16f":"float"!==g&&"float32"!==g||(d='rgba32f')),"colorFormat"in t&&(d=t.colorFormat,0<=b.indexOf(d)?p=!0:0<=_.indexOf(d)&&(p=!1))),("depthTexture"in t||"depthStencilTexture"in t)&&(k=!(!t.depthTexture&&!t.depthStencilTexture)),"depth"in t&&("boolean"===typeof t.depth?s=t.depth:(x=t.depth,c=!1)),"stencil"in t&&("boolean"===typeof t.stencil?c=t.stencil:(w=t.stencil,s=!1)),"depthStencil"in t&&("boolean"===typeof t.depthStencil?s=c=t.depthStencil:(T=t.depthStencil,c=s=!1))):a=o=1;var M=null,A=null,S=null,E=null;if(Array.isArray(i))M=i.map(u);else if(i)M=[u(i)];else for(M=Array(y),i=0;i<y;++i)M[i]=f(a,o,p,d,g);for(a=a||M[0].width,o=o||M[0].height,x?A=u(x):s&&!c&&(A=f(a,o,k,'depth','uint32')),w?S=u(w):c&&!s&&(S=f(a,o,!1,'stencil','uint8')),T?E=u(T):!x&&!w&&c&&s&&(E=f(a,o,k,'depth stencil','depth stencil')),s=null,i=0;i<M.length;++i)l(M[i],a,o),M[i]&&M[i].texture&&(c=St[M[i].texture._texture.format]*Et[M[i].texture._texture.type],null===s&&(s=c));return l(A,a,o),l(S,a,o),l(E,a,o),m(n),n.width=a,n.height=o,n.colorAttachments=M,n.depthAttachment=A,n.stencilAttachment=S,n.depthStencilAttachment=E,r.color=M.map(h),r.depth=h(A),r.stencil=h(S),r.depthStencil=h(E),r.width=n.width,r.height=n.height,v(n),r}var n=new d;return a.framebufferCount++,r(t,e),X(r,{resize:function(t,e){var i=Math.max(0|t,1),a=Math.max(0|e||i,1);if(i===n.width&&a===n.height)return r;for(var o=n.colorAttachments,s=0;s<o.length;++s)p(o[s],i,a);return p(n.depthAttachment,i,a),p(n.stencilAttachment,i,a),p(n.depthStencilAttachment,i,a),n.width=r.width=i,n.height=r.height=a,v(n),r},_reglType:"framebuffer",_framebuffer:n,destroy:function(){g(n),m(n)},use:function(t){x.setFBO({framebuffer:r},t)}})}var x={cur:null,next:null,dirty:!1,setFBO:null},b=["rgba"],_=["rgba4",'rgb565',"rgb5 a1"];e.ext_srgb&&_.push('srgba'),e.ext_color_buffer_half_float&&_.push('rgba16f','rgb16f'),e.webgl_color_buffer_float&&_.push('rgba32f');var w=["uint8"];e.oes_texture_half_float&&w.push('half float','float16'),e.oes_texture_float&&w.push('float','float32');var T=0,k={};return X(x,{getFramebuffer:function(t){return"function"===typeof t&&"framebuffer"===t._reglType&&(t=t._framebuffer)instanceof d?t:null},create:y,createCube:function(t){function e(t){var i,a={color:null},o=0,s=null;i='rgba';var l='uint8',c=1;if("number"===typeof t?o=0|t:t?("shape"in t?o=t.shape[0]:("radius"in t&&(o=0|t.radius),"width"in t?o=0|t.width:"height"in t&&(o=0|t.height)),("color"in t||"colors"in t)&&(s=t.color||t.colors,Array.isArray(s)),s||("colorCount"in t&&(c=0|t.colorCount),"colorType"in t&&(l=t.colorType),"colorFormat"in t&&(i=t.colorFormat)),"depth"in t&&(a.depth=t.depth),"stencil"in t&&(a.stencil=t.stencil),"depthStencil"in t&&(a.depthStencil=t.depthStencil)):o=1,s)if(Array.isArray(s))for(t=[],i=0;i<s.length;++i)t[i]=s[i];else t=[s];else for(t=Array(c),s={radius:o,format:i,type:l},i=0;i<c;++i)t[i]=n.createCube(s);for(a.color=Array(t.length),i=0;i<t.length;++i)c=t[i],o=o||c.width,a.color[i]={target:34069,data:t[i]};for(i=0;6>i;++i){for(c=0;c<t.length;++c)a.color[c].target=34069+i;0<i&&(a.depth=r[0].depth,a.stencil=r[0].stencil,a.depthStencil=r[0].depthStencil),r[i]?r[i](a):r[i]=y(a)}return X(e,{width:o,height:o,color:t})}var r=Array(6);return e(t),X(e,{faces:r,resize:function(t){var n=0|t;if(n===e.width)return e;var i=e.color;for(t=0;t<i.length;++t)i[t].resize(n);for(t=0;6>t;++t)r[t].resize(n);return e.width=e.height=n,e},_reglType:"framebufferCube",destroy:function(){r.forEach((function(t){t.destroy()}))}})},clear:function()[rt(k).forEach(g)],restore:function(){x.cur=null,x.next=null,x.dirty=!0,rt(k).forEach((function(e){e.framebuffer=t.createFramebuffer(),v(e)}))}})}function z(){this.w=this.z=this.y=this.x=this.state=0,this.buffer=null,this.size=0,this.normalized=!1,this.type=5126,this.divisor=this.stride=this.offset=0}function O(t,e,r,n,i,a,o){function s(t){if(t!==v.currentVAO){var r=e.oes_vertex_array_object;t?r.bindVertexArrayOES(t.vao):r.bindVertexArrayOES(null),v.currentVAO=t}}function l(r){if(r!==v.currentVAO){if(r)r.bindAttrs();else{for(var n=e.angle_instanced_arrays,i=0;i<p.length;++i){var a=p[i];a.buffer?(t.enableVertexAttribArray(i),a.buffer.bind(),t.vertexAttribPointer(i,a.size,a.type,a.normalized,a.stride,a.offfset),n&&a.divisor&&n.vertexAttribDivisorANGLE(i,a.divisor)):(t.disableVertexAttribArray(i),t.vertexAttrib4f(i,a.x,a.y,a.z,a.w))}o.elements?t.bindBuffer(34963,o.elements.buffer.buffer):t.bindBuffer(34963,null)}v.currentVAO=r}}function c(){rt(g).forEach((function(t){t.destroy()}))}function u(){this.id=++m,this.attributes=[],this.elements=null,this.ownsElements=!1,this.offset=this.count=0,this.instances=-1,this.primitive=4;var t=e.oes_vertex_array_object;this.vao=t?t.createVertexArrayOES():null,g[this.id]=this,this.buffers=[]}function f(){e.oes_vertex_array_object&&rt(g).forEach((function(t){t.refresh()}))}var h=r.maxAttributes,p=Array(h);for(r=0;r<h;++r)p[r]=new z;var m=0,g={},v={Record:z,scope:{},state:p,currentVAO:null,targetVAO:null,restore:e.oes_vertex_array_object?f:function(){},createVAO:function(t){function e(t){var n;Array.isArray(t)?(n=t,r.elements&&r.ownsElements&&r.elements.destroy(),r.elements=null,r.ownsElements=!1,r.offset=0,r.count=0,r.instances=-1,r.primitive=4):(t.elements?(n=t.elements,r.ownsElements?("function"===typeof n&&"elements"===n._reglType?r.elements.destroy():r.elements(n),r.ownsElements=!1):a.getElements(t.elements)?(r.elements=t.elements,r.ownsElements=!1):(r.elements=a.create(t.elements),r.ownsElements=!0)):(r.elements=null,r.ownsElements=!1),n=t.attributes,r.offset=0,r.count=-1,r.instances=-1,r.primitive=4,r.elements&&(r.count=r.elements._elements.vertCount,r.primitive=r.elements._elements.primType),"offset"in t&&(r.offset=0|t.offset),"count"in t&&(r.count=0|t.count),"instances"in t&&(r.instances=0|t.instances),"primitive"in t&&(r.primitive=ut[t.primitive])),t={};var o=r.attributes;o.length=n.length;for(var s=0;s<n.length;++s){var l,c=n[s],u=o[s]=new z,f=c.data||c;Array.isArray(f)||et(f)||d(f)?(r.buffers[s]&&(l=r.buffers[s],et(f)&&l._buffer.byteLength>=f.byteLength?l.subdata(f):(l.destroy(),r.buffers[s]=null)),r.buffers[s]||(l=r.buffers[s]=i.create(c,34962,!1,!0)),u.buffer=i.getBuffer(l),u.size=0|u.buffer.dimension,u.normalized=!1,u.type=u.buffer.dtype,u.offset=0,u.stride=0,u.divisor=0,u.state=1,t[s]=1):i.getBuffer(c)?(u.buffer=i.getBuffer(c),u.size=0|u.buffer.dimension,u.normalized=!1,u.type=u.buffer.dtype,u.offset=0,u.stride=0,u.divisor=0,u.state=1):i.getBuffer(c.buffer)?(u.buffer=i.getBuffer(c.buffer),u.size=0|(+c.size||u.buffer.dimension),u.normalized=!!c.normalized||!1,u.type="type"in c?at[c.type]:u.buffer.dtype,u.offset=0|(c.offset||0),u.stride=0|(c.stride||0),u.divisor=0|(c.divisor||0),u.state=1):"x"in c&&(u.x=+c.x||0,u.y=+c.y||0,u.z=+c.z||0,u.w=+c.w||0,u.state=2)}for(l=0;l<r.buffers.length;++l)!t[l]&&r.buffers[l]&&(r.buffers[l].destroy(),r.buffers[l]=null);return r.refresh(),e}var r=new u;return n.vaoCount+=1,e.destroy=function(){for(var t=0;t<r.buffers.length;++t)r.buffers[t]&&r.buffers[t].destroy();r.buffers.length=0,r.ownsElements&&(r.elements.destroy(),r.elements=null,r.ownsElements=!1),r.destroy()},e._vao=r,e._reglType='vao',e(t)},getVAO:function(t){return"function"===typeof t&&t._vao?t._vao:null},destroyBuffer:function(e){for(var r=0;r<p.length;++r){var n=p[r];n.buffer===e&&(t.disableVertexAttribArray(r),n.buffer=null)}},setVAO:e.oes_vertex_array_object?s:l,clear:e.oes_vertex_array_object?c:function(){}};return u.prototype.bindAttrs=function(){for(var r=e.angle_instanced_arrays,n=this.attributes,i=0;i<n.length;++i){var o=n[i];o.buffer?(t.enableVertexAttribArray(i),t.bindBuffer(34962,o.buffer.buffer),t.vertexAttribPointer(i,o.size,o.type,o.normalized,o.stride,o.offset),r&&o.divisor&&r.vertexAttribDivisorANGLE(i,o.divisor)):(t.disableVertexAttribArray(i),t.vertexAttrib4f(i,o.x,o.y,o.z,o.w))}for(r=n.length;r<h;++r)t.disableVertexAttribArray(r);(r=a.getElements(this.elements))?t.bindBuffer(34963,r.buffer.buffer):t.bindBuffer(34963,null)},u.prototype.refresh=function(){var t=e.oes_vertex_array_object;t&&(t.bindVertexArrayOES(this.vao),this.bindAttrs(),v.currentVAO=null,t.bindVertexArrayOES(null))},u.prototype.destroy=function(){if(this.vao){var t=e.oes_vertex_array_object;this===v.currentVAO&&(v.currentVAO=null,t.bindVertexArrayOES(null)),t.deleteVertexArrayOES(this.vao),this.vao=null}this.ownsElements&&(this.elements.destroy(),this.elements=null,this.ownsElements=!1),g[this.id]&&(delete g[this.id],--n.vaoCount)},v}function D(t,e,r,n){function i(t,e,r,n){this.name=t,this.id=e,this.location=r,this.info=n}function a(t,e){for(var r=0;r<t.length;++r)if(t[r].id===e.id)return void(t[r].location=e.location);t.push(e)}function o(r,n,i){if(!(o=(i=35632===r?c:u)[n])){var a=e.str(n),o=t.createShader(r);t.shaderSource(o,a),t.compileShader(o),i[n]=o}return o}function s(t,e){this.id=p++,this.fragId=t,this.vertId=e,this.program=null,this.uniforms=[],this.attributes=[],this.refCount=1,n.profile&&(this.stats={uniformsCount:0,attributesCount:0})}function l(r,s,l){var c;c=o(35632,r.fragId);var u=o(35633,r.vertId);if(s=r.program=t.createProgram(),t.attachShader(s,c),t.attachShader(s,u),l)for(c=0;c<l.length;++c)u=l[c],t.bindAttribLocation(s,u[0],u[1]);t.linkProgram(s),u=t.getProgramParameter(s,35718),n.profile&&(r.stats.uniformsCount=u);var f=r.uniforms;for(c=0;c<u;++c)if(l=t.getActiveUniform(s,c)){if(1<l.size)for(var h=0;h<l.size;++h){var p=l.name.replace('[0]',"["+h+"]");a(f,new i(p,e.id(p),t.getUniformLocation(s,p),l))}h=l.name,1<l.size&&(h=h.replace('[0]','')),a(f,new i(h,e.id(h),t.getUniformLocation(s,h),l))}for(u=t.getProgramParameter(s,35721),n.profile&&(r.stats.attributesCount=u),r=r.attributes,c=0;c<u;++c)(l=t.getActiveAttrib(s,c))&&a(r,new i(l.name,e.id(l.name),t.getAttribLocation(s,l.name),l))}var c={},u={},f={},h=[],p=0;return n.profile&&(r.getMaxUniformsCount=function(){var t=0;return h.forEach((function(e){e.stats.uniformsCount>t&&(t=e.stats.uniformsCount)})),t},r.getMaxAttributesCount=function(){var t=0;return h.forEach((function(e){e.stats.attributesCount>t&&(t=e.stats.attributesCount)})),t}),{clear:function(){var e=t.deleteShader.bind(t);rt(c).forEach(e),c={},rt(u).forEach(e),u={},h.forEach((function(e)[t.deleteProgram(e.program)])),h.length=0,f={},r.shaderCount=0},program:function(e,n,i,a){var o=f[n];o||(o=f[n]={});var p=o[e];if(p&&(p.refCount++,!a))return p;var d=new s(n,e);return r.shaderCount++,l(d,i,a),p||(o[e]=d),h.push(d),X(d,{destroy:function(){if(d.refCount--,0>=d.refCount){t.deleteProgram(d.program);var e=h.indexOf(d);h.splice(e,1),r.shaderCount--}0>=o[d.vertId].refCount&&(t.deleteShader(u[d.vertId]),delete u[d.vertId],delete f[d.fragId][d.vertId]),Object.keys(f[d.fragId]).length||(t.deleteShader(c[d.fragId]),delete c[d.fragId],delete f[d.fragId])}})},restore:function()[c={],u={};for(var t=0;t<h.length;++t)l(h[t],null,h[t].attributes.map((function(t){return[t.location,t.name]})))},shader:o,frag:-1,vert:-1}}function R(t,e,r,n,i,a,o){function s(i){var a;a=null===e.next?5121:e.next.colorAttachments[0].texture._texture.type;var o=0,s=0,l=n.framebufferWidth,c=n.framebufferHeight,u=null;return et(i)?u=i:i&&(o=0|i.x,s=0|i.y,l=0|(i.width||n.framebufferWidth-o),c=0|(i.height||n.framebufferHeight-s),u=i.data||null),r(),i=l*c*4,u||(5121===a?u=new Uint8Array(i):5126===a&&(u=u||new Float32Array(i))),t.pixelStorei(3333,4),t.readPixels(o,s,l,c,6408,a,u),u}function l(t){var r;return e.setFBO({framebuffer:t.framebuffer},(function()[r=s(t)])),r}return function(t){return t&&"framebuffer"in t?l(t):s(t)}}function F(t){return Array.prototype.slice.call(t)}function B(t){return F(t).join('')}function N(){function t(){var t=[],e=[];return X((function(){t.push.apply(t,F(arguments))}),{def:function(){var n="v"+r++;return e.push(n),0<arguments.length&&(t.push(n,'='),t.push.apply(t,F(arguments)),t.push(';')),n},toString:function(){return B([0<e.length?"var '+e.join(',')+';":"",B(t)])}})}function e(){function e(t,e){n(t,e,'=',r.def(t,e),';')}var r=t(),n=t(),i=r.toString,a=n.toString;return X((function(){r.apply(r,F(arguments))}),{def:r.def,entry:r,exit:n,save:e,set:function(t,n,i){e(t,n),r(t,n,'=',i,';')},toString:function(){return i()+a()}})}var r=0,n=[],i=[],a=t(),o={};return{global:a,link:function(t){for(var e=0;e<i.length;++e)if(i[e]===t)return n[e];return e="g"+r++,n.push(e),i.push(t),e},block:t,proc:function(t,r){function n(){var t="a"+i.length;return i.push(t),t}var i=[];r=r||0;for(var a=0;a<r;++a)n();var s=(a=e()).toString;return o[t]=X(a,{arg:n,toString:function(){return B(["function(',i.join(),'){",s(),"}"])}})},scope:e,cond:function(){var t=B(arguments),r=e(),n=e(),i=r.toString,a=n.toString;return X(r,{then:function(){return r.apply(r,F(arguments)),this},else:function(){return n.apply(n,F(arguments)),this},toString:function(){var e=a();return e&&(e="else{"+e+"}"),B(["if(',t,'){",i(),'}',e])}})},compile:function(){var t=['"use strict";',a,"return {"];Object.keys(o).forEach((function(e){t.push('"',e,'":',o[e].toString(),',')})),t.push('}');var e=B(t).replace(/;/g,';\n').replace(/}/g,'}\n').replace(/{/g,'{\n');return Function.apply(null,n.concat(e)).apply(null,i)}}}function j(t){return Array.isArray(t)||et(t)||d(t)}function U(t){return t.sort((function(t,e){return"viewport"===t?-1:"viewport"===e?1:t<e?-1:1}))}function V(t,e,r,n){this.thisDep=t,this.contextDep=e,this.propDep=r,this.append=n}function H(t){return t&&!(t.thisDep||t.contextDep||t.propDep)}function q(t){return new V(!1,!1,!1,t)}function G(t,e){var r=t.type;if(0===r)return new V(!0,1<=(r=t.data.length),2<=r,e);if(4===r)return new V((r=t.data).thisDep,r.contextDep,r.propDep,e);if(5===r)return new V(!1,!1,!1,e);if(6===r){for(var n=r=!1,i=!1,a=0;a<t.data.length;++a){var o=t.data[a];1===o.type?i=!0:2===o.type?n=!0:3===o.type?r=!0:0===o.type?(r=!0,1<=(o=o.data)&&(n=!0),2<=o&&(i=!0)):4===o.type&&(r=r||o.data.thisDep,n=n||o.data.contextDep,i=i||o.data.propDep)}return new V(r,n,i,e)}return new V(3===r,2===r,1===r,e)}function Y(t,e,r,n,i,a,o,s,l,c,u,h,p,d,m){function g(t){return t.replace('.','_')}function v(t,e,r){var n=g(t);dt.push(t),pt[n]=ht[n]=!!r,mt[n]=e}function y(t,e,r){var n=g(t);dt.push(t),Array.isArray(r)?(ht[n]=r.slice(),pt[n]=r.slice()):ht[n]=pt[n]=r,gt[n]=e}function x(){var t=N(),r=t.link,n=t.global;t.id=xt++,t.batchId='0';var i=r(vt),a=t.shared={props:"a0"};Object.keys(vt).forEach((function(t){a[t]=n.def(i,'.',t)}));var o=t.next={},s=t.current={};Object.keys(gt).forEach((function(t){Array.isArray(ht[t])&&(o[t]=n.def(a.next,'.',t),s[t]=n.def(a.current,'.',t))}));var l=t.constants={};Object.keys(yt).forEach((function(t)[l[t]=n.def(JSON.stringify(yt[t]))])),t.invoke=function(e,n){switch(n.type){case 0:var i=["this",a.context,a.props,t.batchId];return e.def(r(n.data),'.call(',i.slice(0,Math.max(n.data.length+1,4)),')');case 1:return e.def(a.props,n.data);case 2:return e.def(a.context,n.data);case 3:return e.def('this',n.data);case 4:return n.data.append(t,e),n.data.ref;case 5:return n.data.toString();case 6:return n.data.map((function(r){return t.invoke(e,r)}))}},t.attribCache={};var u={};return t.scopeAttrib=function(t){if((t=e.id(t))in u)return u[t];var n=c.scope[t];return n||(n=c.scope[t]=new ot),u[t]=r(n)},t}function b(t){var e,r=t.static;if(t=t.dynamic,"profile"in r){var n=!!r.profile;(e=q((function(t,e){return n}))).enable=n}else if("profile"in t){var i=t.profile;e=G(i,(function(t,e){return t.invoke(e,i)}))}return e}function _(t,e){var r=t.static,n=t.dynamic;if("framebuffer"in r){var i=r.framebuffer;return i?(i=s.getFramebuffer(i),q((function(t,e){var r=t.link(i),n=t.shared;return e.set(n.framebuffer,'.next',r),n=n.context,e.set(n,'.framebufferWidth',r+".width"),e.set(n,'.framebufferHeight',r+".height"),r}))):q((function(t,e){var r=t.shared;return e.set(r.framebuffer,'.next','null'),r=r.context,e.set(r,'.framebufferWidth',r+".drawingBufferWidth"),e.set(r,'.framebufferHeight',r+".drawingBufferHeight"),"null"}))}if("framebuffer"in n){var a=n.framebuffer;return G(a,(function(t,e){var r=t.invoke(e,a),n=t.shared,i=n.framebuffer;return r=e.def(i,'.getFramebuffer(',r,')'),e.set(i,'.next',r),n=n.context,e.set(n,'.framebufferWidth',r+"?"+r+".width:"+n+".drawingBufferWidth"),e.set(n,'.framebufferHeight',r+"?"+r+".height:"+n+".drawingBufferHeight"),r}))}return null}function w(t,e,r){function n(t){if(t in i){var r=i[t];t=!0;var n,o,s=0|r.x,l=0|r.y;return"width"in r?n=0|r.width:t=!1,"height"in r?o=0|r.height:t=!1,new V(!t&&e&&e.thisDep,!t&&e&&e.contextDep,!t&&e&&e.propDep,(function(t,e){var i=t.shared.context,a=n;"width"in r||(a=e.def(i,'.','framebufferWidth','-',s));var c=o;return"height"in r||(c=e.def(i,'.','framebufferHeight','-',l)),[s,l,a,c]}))}if(t in a){var c=a[t];return t=G(c,(function(t,e){var r=t.invoke(e,c),n=t.shared.context,i=e.def(r,'.x|0'),a=e.def(r,'.y|0');return[i,a,e.def('"width" in ',r,'?',r,'.width|0:','(',n,'.','framebufferWidth','-',i,')'),r=e.def('"height" in ',r,'?',r,'.height|0:','(',n,'.','framebufferHeight','-',a,')')]})),e&&(t.thisDep=t.thisDep||e.thisDep,t.contextDep=t.contextDep||e.contextDep,t.propDep=t.propDep||e.propDep),t}return e?new V(e.thisDep,e.contextDep,e.propDep,(function(t,e){var r=t.shared.context;return[0,0,e.def(r,'.','framebufferWidth'),e.def(r,'.','framebufferHeight')]})):null}var i=t.static,a=t.dynamic;if(t=n('viewport')){var o=t;t=new V(t.thisDep,t.contextDep,t.propDep,(function(t,e){var r=o.append(t,e),n=t.shared.context;return e.set(n,'.viewportWidth',r[2]),e.set(n,'.viewportHeight',r[3]),r}))}return{viewport:t,scissor_box:n('scissor.box')}}function k(t,e){if("string"===typeof(r=t.static).frag&&"string"===typeof r.vert){if(0<Object.keys(e.dynamic).length)return null;var r=e.static,n=Object.keys(r);if(0<n.length&&"number"===typeof r[n[0]]){for(var i=[],a=0;a<n.length;++a)i.push([0|r[n[a]],n[a]]);return i}}return null}function M(t,r,n){function i(t){if(t in a){var r=e.id(a[t]);return(t=q((function(){return r}))).id=r,t}if(t in o){var n=o[t];return G(n,(function(t,e){var r=t.invoke(e,n);return e.def(t.shared.strings,'.id(',r,')')}))}return null}var a=t.static,o=t.dynamic,s=i('frag'),l=i('vert'),c=null;return H(s)&&H(l)?(c=u.program(l.id,s.id,null,n),t=q((function(t,e){return t.link(c)}))):t=new V(s&&s.thisDep||l&&l.thisDep,s&&s.contextDep||l&&l.contextDep,s&&s.propDep||l&&l.propDep,(function(t,e){var r,n,i=t.shared.shader;return r=s?s.append(t,e):e.def(i,'.','frag'),n=l?l.append(t,e):e.def(i,'.','vert'),e.def(i+".program('+n+','+r+')")})),{frag:s,vert:l,progVar:t,program:c}}function A(t,e){function r(t,e){if(t in n){var r=0|n[t];return e?o.offset=r:o.instances=r,q((function(t,n){return e&&(t.OFFSET=r),r}))}if(t in i){var a=i[t];return G(a,(function(t,r){var n=t.invoke(r,a);return e&&(t.OFFSET=n),n}))}if(e){if(u)return q((function(t,e){return t.OFFSET=0}));if(s)return new V(l.thisDep,l.contextDep,l.propDep,(function(t,e){return e.def(t.shared.vao+".currentVAO?"+t.shared.vao+".currentVAO.offset:0")}))}else if(s)return new V(l.thisDep,l.contextDep,l.propDep,(function(t,e){return e.def(t.shared.vao+".currentVAO?"+t.shared.vao+".currentVAO.instances:-1")}));return null}var n=t.static,i=t.dynamic,o={},s=!1,l=function(){if("vao"in n){var t=n.vao;return null!==t&&null===c.getVAO(t)&&(t=c.createVAO(t)),s=!0,o.vao=t,q((function(e){var r=c.getVAO(t);return r?e.link(r):"null"}))}if("vao"in i){s=!0;var e=i.vao;return G(e,(function(t,r){var n=t.invoke(r,e);return r.def(t.shared.vao+".getVAO('+n+')")}))}return null}(),u=!1,f=function(){if("elements"in n){var t=n.elements;if(o.elements=t,j(t)){var e=o.elements=a.create(t,!0);t=a.getElements(e),u=!0}else t&&(t=a.getElements(t),u=!0);return e=q((function(e,r){if(t){var n=e.link(t);return e.ELEMENTS=n}return e.ELEMENTS=null})),e.value=t,e}if("elements"in i){u=!0;var r=i.elements;return G(r,(function(t,e){var n=(i=t.shared).isBufferArgs,i=i.elements,a=t.invoke(e,r),o=e.def('null');return n=e.def(n,'(',a,')'),a=t.cond(n).then(o,'=',i,'.createStream(',a,');').else(o,'=',i,'.getElements(',a,');'),e.entry(a),e.exit(t.cond(n).then(i,'.destroyStream(',o,');')),t.ELEMENTS=o}))}return s?new V(l.thisDep,l.contextDep,l.propDep,(function(t,e){return e.def(t.shared.vao+".currentVAO?"+t.shared.elements+".getElements('+t.shared.vao+'.currentVAO.elements):null")})):null}(),h=r('offset',!0),p=function(){if("primitive"in n){var t=n.primitive;return o.primitive=t,q((function(e,r){return ut[t]}))}if("primitive"in i){var e=i.primitive;return G(e,(function(t,r){var n=t.constants.primTypes,i=t.invoke(r,e);return r.def(n,'[',i,']')}))}return u?H(f)?f.value?q((function(t,e){return e.def(t.ELEMENTS,'.primType')})):q((function(){return 4})):new V(f.thisDep,f.contextDep,f.propDep,(function(t,e){var r=t.ELEMENTS;return e.def(r,'?',r,'.primType:',4)})):s?new V(l.thisDep,l.contextDep,l.propDep,(function(t,e){return e.def(t.shared.vao+".currentVAO?"+t.shared.vao+".currentVAO.primitive:4")})):null}(),d=function(){if("count"in n){var t=0|n.count;return o.count=t,q((function(){return t}))}if("count"in i){var e=i.count;return G(e,(function(t,r){return t.invoke(r,e)}))}return u?H(f)?f?h?new V(h.thisDep,h.contextDep,h.propDep,(function(t,e){return e.def(t.ELEMENTS,'.vertCount-',t.OFFSET)})):q((function(t,e){return e.def(t.ELEMENTS,'.vertCount')})):q((function(){return-1})):new V(f.thisDep||h.thisDep,f.contextDep||h.contextDep,f.propDep||h.propDep,(function(t,e){var r=t.ELEMENTS;return t.OFFSET?e.def(r,'?',r,'.vertCount-',t.OFFSET,':-1'):e.def(r,'?',r,'.vertCount:-1')})):s?new V(l.thisDep,l.contextDep,l.propDep,(function(t,e){return e.def(t.shared.vao,'.currentVAO?',t.shared.vao,'.currentVAO.count:-1')})):null}(),m=r('instances',!1);return{elements:f,primitive:p,count:d,instances:m,offset:h,vao:l,vaoActive:s,elementsActive:u,static:o}}function S(t,e){var r=t.static,n=t.dynamic,i={};return dt.forEach((function(t){function e(e,o){if(t in r){var s=e(r[t]);i[a]=q((function(){return s}))}else if(t in n){var l=n[t];i[a]=G(l,(function(t,e){return o(t,e,t.invoke(e,l))}))}}var a=g(t);switch(t){case"cull.enable":case"blend.enable":case"dither":case"stencil.enable":case"depth.enable":case"scissor.enable":case"polygonOffset.enable":case"sample.alpha":case"sample.enable":case"depth.mask":case"lineWidth":return e((function(t){return t}),(function(t,e,r){return r}));case"depth.func":return e((function(t){return It[t]}),(function(t,e,r){return e.def(t.constants.compareFuncs,'[',r,']')}));case"depth.range":return e((function(t){return t}),(function(t,e,r){return[e.def('+',r,'[0]'),e=e.def('+',r,'[1]')]}));case"blend.func":return e((function(t){return[Pt["srcRGB"in t?t.srcRGB:t.src],Pt["dstRGB"in t?t.dstRGB:t.dst],Pt["srcAlpha"in t?t.srcAlpha:t.src],Pt["dstAlpha"in t?t.dstAlpha:t.dst]]}),(function(t,e,r){function n(t,n){return e.def('"',t,n,'" in ',r,'?',r,'.',t,n,':',r,'.',t)}t=t.constants.blendFuncs;var i=n('src','RGB'),a=n('dst','RGB'),o=(i=e.def(t,'[',i,']'),e.def(t,'[',n('src','Alpha'),']'));return[i,a=e.def(t,'[',a,']'),o,t=e.def(t,'[',n('dst','Alpha'),']')]}));case"blend.equation":return e((function(t){return"string"===typeof t?[st[t],st[t]]:"object"===typeof t?[st[t.rgb],st[t.alpha]]:void 0}),(function(t,e,r){var n=t.constants.blendEquations,i=e.def(),a=e.def();return(t=t.cond('typeof ',r,'==="string"')).then(i,'=',a,'=',n,'[',r,'];'),t.else(i,'=',n,'[',r,'.rgb];',a,'=',n,'[',r,'.alpha];'),e(t),[i,a]}));case"blend.color":return e((function(t){return f(4,(function(e){return+t[e]}))}),(function(t,e,r){return f(4,(function(t){return e.def('+',r,'[',t,']')}))}));case"stencil.mask":return e((function(t){return 0|t}),(function(t,e,r){return e.def(r,'|0')}));case"stencil.func":return e((function(t){return[It[t.cmp||"keep"],t.ref||0,"mask"in t?t.mask:-1]}),(function(t,e,r){return[t=e.def('"cmp" in ',r,'?',t.constants.compareFuncs,'[',r,'.cmp]',':',7680),e.def(r,'.ref|0'),e=e.def('"mask" in ',r,'?',r,'.mask|0:-1')]}));case"stencil.opFront":case"stencil.opBack":return e((function(e){return["stencil.opBack"===t?1029:1028,zt[e.fail||"keep"],zt[e.zfail||"keep"],zt[e.zpass||"keep"]]}),(function(e,r,n){function i(t){return r.def('"',t,'" in ',n,'?',a,'[',n,'.',t,']:',7680)}var a=e.constants.stencilOps;return["stencil.opBack"===t?1029:1028,i('fail'),i('zfail'),i('zpass')]}));case"polygonOffset.offset":return e((function(t){return[0|t.factor,0|t.units]}),(function(t,e,r){return[e.def(r,'.factor|0'),e=e.def(r,'.units|0')]}));case"cull.face":return e((function(t){var e=0;return"front"===t?e=1028:"back"===t&&(e=1029),e}),(function(t,e,r){return e.def(r,'==="front"?',1028,':',1029)}));case"frontFace":return e((function(t){return Ot[t]}),(function(t,e,r){return e.def(r+'==="cw"?2304:2305')}));case"colorMask":return e((function(t){return t.map((function(t){return!!t}))}),(function(t,e,r){return f(4,(function(t){return"!!"+r+"["+t+"]"}))}));case"sample.coverage":return e((function(t){return["value"in t?t.value:1,!!t.invert]}),(function(t,e,r){return[e.def('"value" in ',r,'?+',r,'.value:1'),e=e.def('!!',r,'.invert')]}))}})),i}function E(t,e){var r=t.static,n=t.dynamic,i={};return Object.keys(r).forEach((function(t){var e,n=r[t];if("number"===typeof n||"boolean"===typeof n)e=q((function(){return n}));else if("function"===typeof n){var a=n._reglType;"texture2d"===a||"textureCube"===a?e=q((function(t){return t.link(n)})):"framebuffer"!==a&&"framebufferCube"!==a||(e=q((function(t){return t.link(n.color[0])})))}else T(n)&&(e=q((function(t){return t.global.def('[',f(n.length,(function(t){return n[t]})),']')})));e.value=n,i[t]=e})),Object.keys(n).forEach((function(t){var e=n[t];i[t]=G(e,(function(t,r){return t.invoke(r,e)}))})),i}function L(t,r){var n=t.static,a=t.dynamic,o={};return Object.keys(n).forEach((function(t){var r=n[t],a=e.id(t),s=new ot;if(j(r))s.state=1,s.buffer=i.getBuffer(i.create(r,34962,!1,!0)),s.type=0;else if(c=i.getBuffer(r))s.state=1,s.buffer=c,s.type=0;else if("constant"in r){var l=r.constant;s.buffer='null',s.state=2,"number"===typeof l?s.x=l:Lt.forEach((function(t,e){e<l.length&&(s[t]=l[e])}))}else{var c=j(r.buffer)?i.getBuffer(i.create(r.buffer,34962,!1,!0)):i.getBuffer(r.buffer),u=0|r.offset,f=0|r.stride,h=0|r.size,p=!!r.normalized,d=0;"type"in r&&(d=at[r.type]),r=0|r.divisor,s.buffer=c,s.state=1,s.size=h,s.normalized=p,s.type=d||c.dtype,s.offset=u,s.stride=f,s.divisor=r}o[t]=q((function(t,e){var r=t.attribCache;if(a in r)return r[a];var n={isStream:!1};return Object.keys(s).forEach((function(t)[n[t]=s[t]])),s.buffer&&(n.buffer=t.link(s.buffer),n.type=n.type||n.buffer+".dtype"),r[a]=n}))})),Object.keys(a).forEach((function(t){var e=a[t];o[t]=G(e,(function(t,r){function n(t){r(l[t],'=',i,'.',t,'|0;')}var i=t.invoke(r,e),a=t.shared,o=t.constants,s=a.isBufferArgs,l=(a=a.buffer,{isStream:r.def(!1)}),c=new ot;c.state=1,Object.keys(c).forEach((function(t)[l[t]=r.def(""+c[t])]));var u=l.buffer,f=l.type;return r('if(',s,'(',i,')){',l.isStream,'=true;',u,'=',a,'.createStream(',34962,',',i,');',f,'=',u,'.dtype;','}else{',u,'=',a,'.getBuffer(',i,');','if(',u,'){',f,'=',u,'.dtype;','}else if('constant' in ',i,'){',l.state,'=',2,';',"if(typeof "+i+'.constant === 'number'){',l[Lt[0]],'=',i,'.constant;',Lt.slice(1).map((function(t){return l[t]})).join('='),'=0;','}else{',Lt.map((function(t,e){return l[t]+"='+i+'.constant.length>"+e+"?"+i+".constant["+e+"]:0;"})).join(''),'}}else{','if(',s,'(',i,'.buffer)){',u,'=',a,'.createStream(',34962,',',i,'.buffer);','}else{',u,'=',a,'.getBuffer(',i,'.buffer);','}',f,'='type' in ',i,'?',o.glTypes,'[',i,'.type]:',u,'.dtype;',l.normalized,'=!!',i,'.normalized;'),n('size'),n('offset'),n('stride'),n('divisor'),r('}}'),r.exit('if(',l.isStream,'){',a,'.destroyStream(',u,');','}'),l}))})),o}function C(t){var e=t.static,r=t.dynamic,n={};return Object.keys(e).forEach((function(t){var r=e[t];n[t]=q((function(t,e){return"number"===typeof r||"boolean"===typeof r?""+r:t.link(r)}))})),Object.keys(r).forEach((function(t){var e=r[t];n[t]=G(e,(function(t,r){return t.invoke(r,e)}))})),n}function P(t,e,n,i,a){function o(t){var e=l[t];e&&(f[t]=e)}var s=k(t,e),l=w(t,p=_(t,a),a),u=A(t,a),f=S(t,a),h=M(t,a,s);o('viewport'),o(g('scissor.box'));var p,d=0<Object.keys(f).length;if((p={framebuffer:p,draw:u,shader:h,state:f,dirty:d,scopeVAO:null,drawVAO:null,useVAO:!1,attributes:{}}).profile=b(t,a),p.uniforms=E(n,a),p.drawVAO=p.scopeVAO=u.vao,!p.drawVAO&&h.program&&!s&&r.angle_instanced_arrays&&u.static.elements){var m=!0;if(t=h.program.attributes.map((function(t){return t=e.static[t],m=m&&!!t,t})),m&&0<t.length){var v=c.getVAO(c.createVAO({attributes:t,elements:u.static.elements}));p.drawVAO=new V(null,null,null,(function(t,e){return t.link(v)})),p.useVAO=!0}}return s?p.useVAO=!0:p.attributes=L(e,a),p.context=C(i,a),p}function I(t,e,r){var n=t.shared.context,i=t.scope();Object.keys(r).forEach((function(a){e.save(n,"."+a);var o=r[a].append(t,e);Array.isArray(o)?i(n,'.',a,'=[',o.join(),'];'):i(n,'.',a,'=',o,';')})),e(i)}function z(t,e,r,n){var i,a=(s=t.shared).gl,o=s.framebuffer;ct&&(i=e.def(s.extensions,'.webgl_draw_buffers'));var s=(l=t.constants).drawBuffer,l=l.backBuffer;t=r?r.append(t,e):e.def(o,'.next'),n||e('if(',t,'!==',o,'.cur){'),e('if(',t,'){',a,'.bindFramebuffer(',36160,',',t,'.framebuffer);'),ct&&e(i,'.drawBuffersWEBGL(',s,'[',t,'.colorAttachments.length]);'),e('}else{',a,'.bindFramebuffer(',36160,',null);'),ct&&e(i,'.drawBuffersWEBGL(',l,');'),e('}',o,'.cur=',t,';'),n||e('}')}function O(t,e,r){var n=t.shared,i=n.gl,a=t.current,o=t.next,s=n.current,l=n.next,c=t.cond(s,'.dirty');dt.forEach((function(e){var n,u;if(!((e=g(e))in r.state))if(e in o){n=o[e],u=a[e];var h=f(ht[e].length,(function(t){return c.def(n,'[',t,']')}));c(t.cond(h.map((function(t,e){return t+"!=="+u+"["+e+"]"})).join('||')).then(i,'.',gt[e],'(',h,');',h.map((function(t,e){return u+"["+e+"]='+t})).join(';"),';'))}else n=c.def(l,'.',e),h=t.cond(n,'!==',s,'.',e),c(h),e in mt?h(t.cond(n).then(i,'.enable(',mt[e],');').else(i,'.disable(',mt[e],');'),s,'.',e,'=',n,';'):h(i,'.',gt[e],'(',n,');',s,'.',e,'=',n,';')})),0===Object.keys(r.state).length&&c(s,'.dirty=false;'),e(c)}function D(t,e,r,n){var i=t.shared,a=t.current,o=i.current,s=i.gl;U(Object.keys(r)).forEach((function(i){var l=r[i];if(!n||n(l)){var c=l.append(t,e);if(mt[i]){var u=mt[i];H(l)?e(s,c?".enable(':'.disable(',u,');"):e(t.cond(c).then(s,'.enable(',u,');').else(s,'.disable(',u,');')),e(o,'.',i,'=',c,';')}else if(T(c)){var f=a[i];e(s,'.',gt[i],'(',c,');',c.map((function(t,e){return f+"["+e+"]='+t})).join(';"),';')}else e(s,'.',gt[i],'(',c,');',o,'.',i,'=',c,';')}}))}function R(t,e){lt&&(t.instancing=e.def(t.shared.extensions,'.angle_instanced_arrays'))}function F(t,e,r,n,i){function a(){return"undefined"===typeof performance?"Date.now()":"performance.now()"}function o(t){t(c=e.def(),'=',a(),';'),"string"===typeof i?t(h,'.count+=',i,';'):t(h,'.count++;'),d&&(n?t(u=e.def(),'=',m,'.getNumPendingQueries();'):t(m,'.beginQuery(',h,');'))}function s(t){t(h,'.cpuTime+=',a(),'-',c,';'),d&&(n?t(m,'.pushScopeStats(',u,',',m,'.getNumPendingQueries(),',h,');'):t(m,'.endQuery();'))}function l(t){var r=e.def(p,'.profile');e(p,'.profile=',t,';'),e.exit(p,'.profile=',r,';')}var c,u,f=t.shared,h=t.stats,p=f.current,m=f.timer;if(r=r.profile){if(H(r))return void(r.enable?(o(e),s(e.exit),l('true')):l('false'));l(r=r.append(t,e))}else r=e.def(p,'.profile');o(f=t.block()),e('if(',r,'){',f,'}'),s(t=t.block()),e.exit('if(',r,'){',t,'}')}function B(t,e,r,n,i){function a(t){switch(t){case 35664:case 35667:case 35671:return 2;case 35665:case 35668:case 35672:return 3;case 35666:case 35669:case 35673:return 4;default:return 1}}function o(r,n,i){function a(){e('if(!',u,'.buffer){',l,'.enableVertexAttribArray(',c,');}');var r,a=i.type;r=i.size?e.def(i.size,'||',n):n,e('if(',u,'.type!==',a,'||',u,'.size!==',r,'||',p.map((function(t){return u+"."+t+"!=='+i[t]})).join('||'),'){',l,'.bindBuffer(',34962,',',f,'.buffer);',l,'.vertexAttribPointer(',[c,r,a,i.normalized,i.stride,i.offset],');',u,'.type=',a,';',u,'.size=',r,';',p.map((function(t){return u+'."+t+"='+i[t]+';"})).join(''),'}'),lt&&(a=i.divisor,e('if(',u,'.divisor!==',a,'){',t.instancing,'.vertexAttribDivisorANGLE(',[c,a],');',u,'.divisor=',a,';}'))}function o(){e('if(',u,'.buffer){',l,'.disableVertexAttribArray(',c,');',u,'.buffer=null;',"}if(',Lt.map((function(t,e){return u+'."+t+"!=='+h[e]})).join('||'),'){',l,'.vertexAttrib4f(',c,',',h,');',Lt.map((function(t,e){return u+'."+t+"='+h[e]+';"})).join(''),'}')}var l=s.gl,c=e.def(r,'.location'),u=e.def(s.attributes,'[',c,']');r=i.state;var f=i.buffer,h=[i.x,i.y,i.z,i.w],p=["buffer",'normalized','offset',"stride"];1===r?a():2===r?o():(e('if(',r,'===',1,'){'),a(),e('}else{'),o(),e('}'))}var s=t.shared;n.forEach((function(n){var s,l=n.name,c=r.attributes[l];if(c){if(!i(c))return;s=c.append(t,e)}else{if(!i(Dt))return;var u=t.scopeAttrib(l);s={},Object.keys(new ot).forEach((function(t){s[t]=e.def(u,'.',t)}))}o(t.link(n),a(n.info.type),s)}))}function Y(t,r,n,i,a,o){for(var s,l=t.shared,c=l.gl,u={},h=0;h<i.length;++h){var p=(x=i[h]).name,d=x.info.type,m=x.info.size,g=n.uniforms[p];if(1<m){if(!g)continue;var v=p.replace('[0]','');if(u[v])continue;u[v]=1}var y,x=t.link(x)+".location";if(g){if(!a(g))continue;if(H(g)){if(p=g.value,35678===d||35680===d)r(c,'.uniform1i(',x,',',(d=t.link(p._texture||p.color[0]._texture))+".bind());"),r.exit(d,'.unbind();');else if(35674===d||35675===d||35676===d)m=t.global.def("new Float32Array(["+Array.prototype.slice.call(p)+"])"),p=2,35675===d?p=3:35676===d&&(p=4),r(c,'.uniformMatrix',p,'fv(',x,',false,',m,');');else{switch(d){case 5126:s='1f';break;case 35664:s='2f';break;case 35665:s='3f';break;case 35666:s='4f';break;case 35670:case 5124:s='1i';break;case 35671:case 35667:s='2i';break;case 35672:case 35668:s='3i';break;case 35673:case 35669:s="4i"}1<m?(s+='v',p=t.global.def("["+Array.prototype.slice.call(p)+"]")):p=T(p)?Array.prototype.slice.call(p):p,r(c,'.uniform',s,'(',x,',',p,');')}continue}y=g.append(t,r)}else{if(!a(Dt))continue;y=r.def(l.uniforms,'[',e.id(p),']')}switch(35678===d?r('if(',y,'&&',y,'._reglType==='framebuffer'){',y,'=',y,'.color[0];','}'):35680===d&&r('if(',y,'&&',y,'._reglType==='framebufferCube'){',y,'=',y,'.color[0];','}'),p=1,d){case 35678:case 35680:d=r.def(y,'._texture'),r(c,'.uniform1i(',x,',',d,'.bind());'),r.exit(d,'.unbind();');continue;case 5124:case 35670:s='1i';break;case 35667:case 35671:s='2i',p=2;break;case 35668:case 35672:s='3i',p=3;break;case 35669:case 35673:s='4i',p=4;break;case 5126:s='1f';break;case 35664:s='2f',p=2;break;case 35665:s='3f',p=3;break;case 35666:s='4f',p=4;break;case 35674:s='Matrix2fv';break;case 35675:s='Matrix3fv';break;case 35676:s="Matrix4fv"}if(-1===s.indexOf('Matrix')&&1<m&&(s+='v',p=1),"M"===s.charAt(0)){r(c,'.uniform',s,'(',x,','),x=Math.pow(d-35674+2,2);var b=t.global.def('new Float32Array(',x,')');Array.isArray(y)?r('false,(',f(x,(function(t){return b+"["+t+"]='+y[t]})),',",b,')'):r('false,(Array.isArray(',y,')||',y,' instanceof Float32Array)?',y,':(',f(x,(function(t){return b+"["+t+"]="+y+"["+t+"]"})),',',b,')'),r(');')}else{if(1<p){d=[];var _=[];for(m=0;m<p;++m)Array.isArray(y)?_.push(y[m]):_.push(r.def(y+"["+m+"]")),o&&d.push(r.def());o&&r('if(!',t.batchId,'||',d.map((function(t,e){return t+"!=="+_[e]})).join('||'),'){',d.map((function(t,e){return t+"='+_[e]+';"})).join('')),r(c,'.uniform',s,'(',x,',',_.join(','),');')}else o&&(d=r.def(),r('if(!',t.batchId,'||',d,'!==',y,'){',d,'=',y,';')),r(c,'.uniform',s,'(',x,',',y,');');o&&r('}')}}}function W(t,e,r,n){function i(i){var a=h[i];return a?a.contextDep&&n.contextDynamic||a.propDep?a.append(t,r):a.append(t,e):e.def(f,'.',i)}function a(){function t(){r(l,'.drawElementsInstancedANGLE(',[d,g,v,m+"<<(("+v+"-5121)>>1)",s],');')}function e(){r(l,'.drawArraysInstancedANGLE(',[d,m,g,s],');')}p&&"null"!==p?y?t():(r('if(',p,'){'),t(),r('}else{'),e(),r('}')):e()}function o(){function t(){r(u+".drawElements("+[d,g,v,m+"<<(("+v+"-5121)>>1)"]+");")}function e(){r(u+".drawArrays('+[d,m,g]+');")}p&&"null"!==p?y?t():(r('if(',p,'){'),t(),r('}else{'),e(),r('}')):e()}var s,l,c=t.shared,u=c.gl,f=c.draw,h=n.draw,p=function(){var i=h.elements,a=e;return i?((i.contextDep&&n.contextDynamic||i.propDep)&&(a=r),i=i.append(t,a),h.elementsActive&&a("if('+i+')"+u+".bindBuffer(34963,'+i+'.buffer.buffer);")):(i=a.def(),a(i,'=',f,'.','elements',';','if(',i,'){',u,'.bindBuffer(',34963,',',i,'.buffer.buffer);}','else if(',c.vao,'.currentVAO){',i,'=',t.shared.elements+".getElements('+c.vao,'.currentVAO.elements);",ft?"":"if('+i+')"+u+".bindBuffer(34963,'+i+'.buffer.buffer);",'}')),i}(),d=i('primitive'),m=i('offset'),g=function(){var i=h.count,a=e;return i?((i.contextDep&&n.contextDynamic||i.propDep)&&(a=r),i=i.append(t,a)):i=a.def(f,'.','count'),i}();if("number"===typeof g){if(0===g)return}else r('if(',g,'){'),r.exit('}');lt&&(s=i('instances'),l=t.instancing);var v=p+".type",y=h.elements&&H(h.elements)&&!h.vaoActive;lt&&("number"!==typeof s||0<=s)?"string"===typeof s?(r('if(',s,'>0){'),a(),r('}else if(',s,'<0){'),o(),r('}')):a():o()}function Z(t,e,r,n,i){return i=(e=x()).proc('body',i),lt&&(e.instancing=i.def(e.shared.extensions,'.angle_instanced_arrays')),t(e,i,r,n),e.compile().body}function K(t,e,r,n){R(t,e),r.useVAO?r.drawVAO?e(t.shared.vao,'.setVAO(',r.drawVAO.append(t,e),');'):e(t.shared.vao,'.setVAO(',t.shared.vao,'.targetVAO);'):(e(t.shared.vao,'.setVAO(null);'),B(t,e,r,n.attributes,(function(){return!0}))),Y(t,e,r,n.uniforms,(function(){return!0}),!1),W(t,e,e,r)}function Q(t,e){var r=t.proc('draw',1);R(t,r),I(t,r,e.context),z(t,r,e.framebuffer),O(t,r,e),D(t,r,e.state),F(t,r,e,!1,!0);var n=e.shader.progVar.append(t,r);if(r(t.shared.gl,'.useProgram(',n,'.program);'),e.shader.program)K(t,r,e,e.shader.program);else{r(t.shared.vao,'.setVAO(null);');var i=t.global.def('{}'),a=r.def(n,'.id'),o=r.def(i,'[',a,']');r(t.cond(o).then(o,'.call(this,a0);').else(o,'=',i,'[',a,']=',t.link((function(r){return Z(K,t,e,r,1)})),'(',n,');',o,'.call(this,a0);'))}0<Object.keys(e.state).length&&r(t.shared.current,'.dirty=true;'),t.shared.vao&&r(t.shared.vao,'.setVAO(null);')}function $(t,e,r,n){function i(){return!0}t.batchId='a1',R(t,e),B(t,e,r,n.attributes,i),Y(t,e,r,n.uniforms,i,!1),W(t,e,e,r)}function tt(t,e,r,n){function i(t){return t.contextDep&&o||t.propDep}function a(t){return!i(t)}R(t,e);var o=r.contextDep,s=e.def(),l=e.def();t.shared.props=l,t.batchId=s;var c=t.scope(),u=t.scope();e(c.entry,'for(',s,'=0;',s,'<','a1',';++',s,'){',l,'=','a0','[',s,'];',u,'}',c.exit),r.needsContext&&I(t,u,r.context),r.needsFramebuffer&&z(t,u,r.framebuffer),D(t,u,r.state,i),r.profile&&i(r.profile)&&F(t,u,r,!1,!0),n?(r.useVAO?r.drawVAO?i(r.drawVAO)?u(t.shared.vao,'.setVAO(',r.drawVAO.append(t,u),');'):c(t.shared.vao,'.setVAO(',r.drawVAO.append(t,c),');'):c(t.shared.vao,'.setVAO(',t.shared.vao,'.targetVAO);'):(c(t.shared.vao,'.setVAO(null);'),B(t,c,r,n.attributes,a),B(t,u,r,n.attributes,i)),Y(t,c,r,n.uniforms,a,!1),Y(t,u,r,n.uniforms,i,!0),W(t,c,u,r)):(e=t.global.def('{}'),n=r.shader.progVar.append(t,u),l=u.def(n,'.id'),c=u.def(e,'[',l,']'),u(t.shared.gl,'.useProgram(',n,'.program);','if(!',c,'){',c,'=',e,'[',l,']=',t.link((function(e){return Z($,t,r,e,2)})),'(',n,');}',c,'.call(this,a0[',s,'],',s,');'))}function et(t,e){function r(t){return t.contextDep&&i||t.propDep}var n=t.proc('batch',2);t.batchId='0',R(t,n);var i=!1,a=!0;Object.keys(e.context).forEach((function(t)[i=i||e.context[t].propDep])),i||(I(t,n,e.context),a=!1);var o=!1;if((s=e.framebuffer)?(s.propDep?i=o=!0:s.contextDep&&i&&(o=!0),o||z(t,n,s)):z(t,n,null),e.state.viewport&&e.state.viewport.propDep&&(i=!0),O(t,n,e),D(t,n,e.state,(function(t){return!r(t)})),e.profile&&r(e.profile)||F(t,n,e,!1,'a1'),e.contextDep=i,e.needsContext=a,e.needsFramebuffer=o,(a=e.shader.progVar).contextDep&&i||a.propDep)tt(t,n,e,null);else if(a=a.append(t,n),n(t.shared.gl,'.useProgram(',a,'.program);'),e.shader.program)tt(t,n,e,e.shader.program);else{n(t.shared.vao,'.setVAO(null);');var s=t.global.def('{}'),l=(o=n.def(a,'.id'),n.def(s,'[',o,']'));n(t.cond(l).then(l,'.call(this,a0,a1);').else(l,'=',s,'[',o,']=',t.link((function(r){return Z(tt,t,e,r,2)})),'(',a,');',l,'.call(this,a0,a1);'))}0<Object.keys(e.state).length&&n(t.shared.current,'.dirty=true;'),t.shared.vao&&n(t.shared.vao,'.setVAO(null);')}function rt(t,r){function n(e){var n=r.shader[e];n&&i.set(a.shader,"."+e,n.append(t,i))}var i=t.proc('scope',3);t.batchId='a2';var a=t.shared,o=a.current;I(t,i,r.context),r.framebuffer&&r.framebuffer.append(t,i),U(Object.keys(r.state)).forEach((function(e){var n=r.state[e].append(t,i);T(n)?n.forEach((function(r,n){i.set(t.next[e],"["+n+"]",r)})):i.set(a.next,"."+e,n)})),F(t,i,r,!0,!0),["elements",'offset','count','instances',"primitive"].forEach((function(e){var n=r.draw[e];n&&i.set(a.draw,"."+e,""+n.append(t,i))})),Object.keys(r.uniforms).forEach((function(n){var o=r.uniforms[n].append(t,i);Array.isArray(o)&&(o="["+o.join()+"]"),i.set(a.uniforms,"["+e.id(n)+"]",o)})),Object.keys(r.attributes).forEach((function(e){var n=r.attributes[e].append(t,i),a=t.scopeAttrib(e);Object.keys(new ot).forEach((function(t){i.set(a,"."+t,n[t])}))})),r.scopeVAO&&i.set(a.vao,'.targetVAO',r.scopeVAO.append(t,i)),n('vert'),n('frag'),0<Object.keys(r.state).length&&(i(o,'.dirty=true;'),i.exit(o,'.dirty=true;')),i('a1(',t.shared.context,',a0,',t.batchId,');')}function nt(t){if("object"===typeof t&&!T(t)){for(var e=Object.keys(t),r=0;r<e.length;++r)if(J.isDynamic(t[e[r]]))return!0;return!1}}function it(t,e,r){function n(t,e){o.forEach((function(r){var n=i[r];J.isDynamic(n)&&(n=t.invoke(e,n),e(u,'.',r,'=',n,';'))}))}var i=e.static[r];if(i&&nt(i)){var a=t.global,o=Object.keys(i),s=!1,l=!1,c=!1,u=t.global.def('{}');o.forEach((function(e){var r=i[e];if(J.isDynamic(r))"function"===typeof r&&(r=i[e]=J.unbox(r)),e=G(r,null),s=s||e.thisDep,c=c||e.propDep,l=l||e.contextDep;else{switch(a(u,'.',e,'='),typeof r){case"number":a(r);break;case"string":a('"',r,'"');break;case"object":Array.isArray(r)&&a('[',r.join(),']');break;default:a(t.link(r))}a(';')}})),e.dynamic[r]=new J.DynamicVariable(4,{thisDep:s,contextDep:l,propDep:c,ref:u,append:n}),delete e.static[r]}}var ot=c.Record,st={add:32774,subtract:32778,"reverse subtract":32779};r.ext_blend_minmax&&(st.min=32775,st.max=32776);var lt=r.angle_instanced_arrays,ct=r.webgl_draw_buffers,ft=r.oes_vertex_array_object,ht={dirty:!0,profile:m.profile},pt={},dt=[],mt={},gt={};v('dither',3024),v('blend.enable',3042),y('blend.color','blendColor',[0,0,0,0]),y('blend.equation','blendEquationSeparate',[32774,32774]),y('blend.func','blendFuncSeparate',[1,0,1,0]),v('depth.enable',2929,!0),y('depth.func','depthFunc',513),y('depth.range','depthRange',[0,1]),y('depth.mask','depthMask',!0),y('colorMask','colorMask',[!0,!0,!0,!0]),v('cull.enable',2884),y('cull.face','cullFace',1029),y('frontFace','frontFace',2305),y('lineWidth','lineWidth',1),v('polygonOffset.enable',32823),y('polygonOffset.offset','polygonOffset',[0,0]),v('sample.alpha',32926),v('sample.enable',32928),y('sample.coverage','sampleCoverage',[1,!1]),v('stencil.enable',2960),y('stencil.mask','stencilMask',-1),y('stencil.func','stencilFunc',[519,0,-1]),y('stencil.opFront','stencilOpSeparate',[1028,7680,7680,7680]),y('stencil.opBack','stencilOpSeparate',[1029,7680,7680,7680]),v('scissor.enable',3089),y('scissor.box','scissor',[0,0,t.drawingBufferWidth,t.drawingBufferHeight]),y('viewport','viewport',[0,0,t.drawingBufferWidth,t.drawingBufferHeight]);var vt={gl:t,context:p,strings:e,next:pt,current:ht,draw:h,elements:a,buffer:i,shader:u,attributes:c.state,vao:c,uniforms:l,framebuffer:s,extensions:r,timer:d,isBufferArgs:j},yt={primTypes:ut,compareFuncs:It,blendFuncs:Pt,blendEquations:st,stencilOps:zt,glTypes:at,orientationType:Ot};ct&&(yt.backBuffer=[1029],yt.drawBuffer=f(n.maxDrawbuffers,(function(t){return 0===t?[0]:f(t,(function(t){return 36064+t}))})));var xt=0;return{next:pt,current:ht,procs:function(){var t=x(),e=t.proc('poll'),i=t.proc('refresh'),a=t.block();e(a),i(a);var o,s=t.shared,l=s.gl,c=s.next,u=s.current;a(u,'.dirty=false;'),z(t,e),z(t,i,null,!0),lt&&(o=t.link(lt)),r.oes_vertex_array_object&&i(t.link(r.oes_vertex_array_object),'.bindVertexArrayOES(null);');for(var h=0;h<n.maxAttributes;++h){var p=i.def(s.attributes,'[',h,']'),d=t.cond(p,'.buffer');d.then(l,'.enableVertexAttribArray(',h,');',l,'.bindBuffer(',34962,',',p,'.buffer.buffer);',l,'.vertexAttribPointer(',h,',',p,'.size,',p,'.type,',p,'.normalized,',p,'.stride,',p,'.offset);').else(l,'.disableVertexAttribArray(',h,');',l,'.vertexAttrib4f(',h,',',p,'.x,',p,'.y,',p,'.z,',p,'.w);',p,'.buffer=null;'),i(d),lt&&i(o,'.vertexAttribDivisorANGLE(',h,',',p,'.divisor);')}return i(t.shared.vao,'.currentVAO=null;',t.shared.vao,'.setVAO(',t.shared.vao,'.targetVAO);'),Object.keys(mt).forEach((function(r){var n=mt[r],o=a.def(c,'.',r),s=t.block();s('if(',o,'){',l,'.enable(',n,')}else{',l,'.disable(',n,')}',u,'.',r,'=',o,';'),i(s),e('if(',o,'!==',u,'.',r,'){',s,'}')})),Object.keys(gt).forEach((function(r){var n,o,s=gt[r],h=ht[r],p=t.block();p(l,'.',s,'('),T(h)?(s=h.length,n=t.global.def(c,'.',r),o=t.global.def(u,'.',r),p(f(s,(function(t){return n+"["+t+"]"})),');',f(s,(function(t){return o+"["+t+"]="+n+"["+t+"];"})).join('')),e('if(',f(s,(function(t){return n+"["+t+"]!=="+o+"["+t+"]"})).join('||'),'){',p,'}')):(n=a.def(c,'.',r),o=a.def(u,'.',r),p(n,');',u,'.',r,'=',n,';'),e('if(',n,'!==',o,'){',p,'}')),i(p)})),t.compile()}(),compile:function(t,e,r,n,i){var a=x();a.stats=a.link(i),Object.keys(e.static).forEach((function(t){it(a,e,t)})),Ct.forEach((function(e){it(a,t,e)}));var o=P(t,e,r,n,a);return Q(a,o),rt(a,o),et(a,o),X(a.compile(),{destroy:function(){o.shader.program.destroy()}})}}}function W(t,e){for(var r=0;r<t.length;++r)if(t[r]===e)return r;return-1}var X=function(t,e){for(var r=Object.keys(e),n=0;n<r.length;++n)t[r[n]]=e[r[n]];return t},Z=0,J={DynamicVariable:t,define:function(e,n){return new t(e,r(n+""))},isDynamic:function(e){return"function"===typeof e&&!e._reglType||e instanceof t},unbox:n,accessor:r},K={next:"function"===typeof requestAnimationFrame?function(t){return requestAnimationFrame(t)}:function(t){return setTimeout(t,16)},cancel:"function"===typeof cancelAnimationFrame?function(t){return cancelAnimationFrame(t)}:clearTimeout},Q="undefined"!==typeof performance&&performance.now?function(){return performance.now()}:function(){return+new Date},$=p();$.zero=p();var tt=function(t,e){var r=1;e.ext_texture_filter_anisotropic&&(r=t.getParameter(34047));var n=1,i=1;e.webgl_draw_buffers&&(n=t.getParameter(34852),i=t.getParameter(36063));var a=!!e.oes_texture_float;if(a){a=t.createTexture(),t.bindTexture(3553,a),t.texImage2D(3553,0,6408,1,1,0,6408,5126,null);var o=t.createFramebuffer();if(t.bindFramebuffer(36160,o),t.framebufferTexture2D(36160,36064,3553,a,0),t.bindTexture(3553,null),36053!==t.checkFramebufferStatus(36160))a=!1;else{t.viewport(0,0,1,1),t.clearColor(1,0,0,1),t.clear(16384);var s=$.allocType(5126,4);t.readPixels(0,0,1,1,6408,5126,s),t.getError()?a=!1:(t.deleteFramebuffer(o),t.deleteTexture(a),a=1===s[0]),$.freeType(s)}}return s=!0,"undefined"!==typeof navigator&&(/MSIE/.test(navigator.userAgent)||/Trident\//.test(navigator.appVersion)||/Edge/.test(navigator.userAgent))||(s=t.createTexture(),o=$.allocType(5121,36),t.activeTexture(33984),t.bindTexture(34067,s),t.texImage2D(34069,0,6408,3,3,0,6408,5121,o),$.freeType(o),t.bindTexture(34067,null),t.deleteTexture(s),s=!t.getError()),{colorBits:[t.getParameter(3410),t.getParameter(3411),t.getParameter(3412),t.getParameter(3413)],depthBits:t.getParameter(3414),stencilBits:t.getParameter(3415),subpixelBits:t.getParameter(3408),extensions:Object.keys(e).filter((function(t){return!!e[t]})),maxAnisotropic:r,maxDrawbuffers:n,maxColorAttachments:i,pointSizeDims:t.getParameter(33901),lineWidthDims:t.getParameter(33902),maxViewportDims:t.getParameter(3386),maxCombinedTextureUnits:t.getParameter(35661),maxCubeMapSize:t.getParameter(34076),maxRenderbufferSize:t.getParameter(34024),maxTextureUnits:t.getParameter(34930),maxTextureSize:t.getParameter(3379),maxAttributes:t.getParameter(34921),maxVertexUniforms:t.getParameter(36347),maxVertexTextureUnits:t.getParameter(35660),maxVaryingVectors:t.getParameter(36348),maxFragmentUniforms:t.getParameter(36349),glsl:t.getParameter(35724),renderer:t.getParameter(7937),vendor:t.getParameter(7936),version:t.getParameter(7938),readFloat:a,npotTextureCube:s}},et=function(t){return t instanceof Uint8Array||t instanceof Uint16Array||t instanceof Uint32Array||t instanceof Int8Array||t instanceof Int16Array||t instanceof Int32Array||t instanceof Float32Array||t instanceof Float64Array||t instanceof Uint8ClampedArray},rt=function(t){return Object.keys(t).map((function(e){return t[e]}))},nt={shape:function(t){for(var e=[];t.length;t=t[0])e.push(t.length);return e},flatten:function(t,e,r,n){var i=1;if(e.length)for(var a=0;a<e.length;++a)i*=e[a];else i=0;switch(r=n||$.allocType(r,i),e.length){case 0:break;case 1:for(n=e[0],e=0;e<n;++e)r[e]=t[e];break;case 2:for(n=e[0],e=e[1],a=i=0;a<n;++a)for(var o=t[a],s=0;s<e;++s)r[i++]=o[s];break;case 3:m(t,e[0],e[1],e[2],r,0);break;default:g(t,e,0,r,0)}return r}},it={"[object Int8Array]":5120,"[object Int16Array]":5122,"[object Int32Array]":5124,"[object Uint8Array]":5121,"[object Uint8ClampedArray]":5121,"[object Uint16Array]":5123,"[object Uint32Array]":5125,"[object Float32Array]":5126,"[object Float64Array]":5121,"[object ArrayBuffer]":5121},at={int8:5120,int16:5122,int32:5124,uint8:5121,uint16:5123,uint32:5125,float:5126,float32:5126},ot={dynamic:35048,stream:35040,static:35044},st=nt.flatten,lt=nt.shape,ct=[];ct[5120]=1,ct[5122]=2,ct[5124]=4,ct[5121]=1,ct[5123]=2,ct[5125]=4,ct[5126]=4;var ut={points:0,point:0,lines:1,line:1,triangles:4,triangle:4,"line loop":2,"line strip":3,"triangle strip":5,"triangle fan":6},ft=new Float32Array(1),ht=new Uint32Array(ft.buffer),pt=[9984,9986,9985,9987],dt=[0,6409,6410,6407,6408],mt={};mt[6409]=mt[6406]=mt[6402]=1,mt[34041]=mt[6410]=2,mt[6407]=mt[35904]=3,mt[6408]=mt[35906]=4;var gt=k('HTMLCanvasElement'),vt=k('OffscreenCanvas'),yt=k('CanvasRenderingContext2D'),xt=k('ImageBitmap'),bt=k('HTMLImageElement'),_t=k('HTMLVideoElement'),wt=Object.keys(it).concat([gt,vt,yt,xt,bt,_t]),Tt=[];Tt[5121]=1,Tt[5126]=4,Tt[36193]=2,Tt[5123]=2,Tt[5125]=4;var kt=[];kt[32854]=2,kt[32855]=2,kt[36194]=2,kt[34041]=4,kt[33776]=.5,kt[33777]=.5,kt[33778]=1,kt[33779]=1,kt[35986]=.5,kt[35987]=1,kt[34798]=1,kt[35840]=.5,kt[35841]=.25,kt[35842]=.5,kt[35843]=.25,kt[36196]=.5;var Mt=[];Mt[32854]=2,Mt[32855]=2,Mt[36194]=2,Mt[33189]=2,Mt[36168]=1,Mt[34041]=4,Mt[35907]=4,Mt[34836]=16,Mt[34842]=8,Mt[34843]=6;var At=function(t,e,r,n,i){function a(t){this.id=c++,this.refCount=1,this.renderbuffer=t,this.format=32854,this.height=this.width=0,i.profile&&(this.stats={size:0})}function o(e){var r=e.renderbuffer;t.bindRenderbuffer(36161,null),t.deleteRenderbuffer(r),e.renderbuffer=null,e.refCount=0,delete u[e.id],n.renderbufferCount--}var s={rgba4:32854,rgb565:36194,"rgb5 a1":32855,depth:33189,stencil:36168,"depth stencil":34041};e.ext_srgb&&(s.srgba=35907),e.ext_color_buffer_half_float&&(s.rgba16f=34842,s.rgb16f=34843),e.webgl_color_buffer_float&&(s.rgba32f=34836);var l=[];Object.keys(s).forEach((function(t)[l[s[t]]=t]));var c=0,u={};return a.prototype.decRef=function()[0>=--this.refCount&&o(this)],i.profile&&(n.getTotalRenderbufferSize=function(){var t=0;return Object.keys(u).forEach((function(e){t+=u[e].stats.size})),t}),{create:function(e,r){function o(e,r){var n=0,a=0,u=32854;if("object"===typeof e&&e?("shape"in e?(n=0|(a=e.shape)[0],a=0|a[1]):("radius"in e&&(n=a=0|e.radius),"width"in e&&(n=0|e.width),"height"in e&&(a=0|e.height)),"format"in e&&(u=s[e.format])):"number"===typeof e?(n=0|e,a="number"===typeof r?0|r:n):e||(n=a=1),n!==c.width||a!==c.height||u!==c.format)return o.width=c.width=n,o.height=c.height=a,c.format=u,t.bindRenderbuffer(36161,c.renderbuffer),t.renderbufferStorage(36161,u,n,a),i.profile&&(c.stats.size=Mt[c.format]*c.width*c.height),o.format=l[c.format],o}var c=new a(t.createRenderbuffer());return u[c.id]=c,n.renderbufferCount++,o(e,r),o.resize=function(e,r){var n=0|e,a=0|r||n;return n===c.width&&a===c.height||(o.width=c.width=n,o.height=c.height=a,t.bindRenderbuffer(36161,c.renderbuffer),t.renderbufferStorage(36161,c.format,n,a),i.profile&&(c.stats.size=Mt[c.format]*c.width*c.height)),o},o._reglType='renderbuffer',o._renderbuffer=c,i.profile&&(o.stats=c.stats),o.destroy=function()[c.decRef()],o},clear:function()[rt(u).forEach(o)],restore:function(){rt(u).forEach((function(e){e.renderbuffer=t.createRenderbuffer(),t.bindRenderbuffer(36161,e.renderbuffer),t.renderbufferStorage(36161,e.format,e.width,e.height)})),t.bindRenderbuffer(36161,null)}}},St=[];St[6408]=4,St[6407]=3;var Et=[];Et[5121]=1,Et[5126]=4,Et[36193]=2;var Lt=["x",'y','z',"w"],Ct='blend.func blend.equation stencil.func stencil.opFront stencil.opBack sample.coverage viewport scissor.box polygonOffset.offset'.split(' '),Pt={0:0,1:1,zero:0,one:1,"src color":768,"one minus src color":769,"src alpha":770,"one minus src alpha":771,"dst color":774,"one minus dst color":775,"dst alpha":772,"one minus dst alpha":773,"constant color":32769,"one minus constant color":32770,"constant alpha":32771,"one minus constant alpha":32772,"src alpha saturate":776},It={never:512,less:513,"<":513,equal:514,"=":514,"==":514,"===":514,lequal:515,"<=":515,greater:516,">":516,notequal:517,"!=":517,"!==":517,gequal:518,">=":518,always:519},zt={0:0,zero:0,keep:7680,replace:7681,increment:7682,decrement:7683,"increment wrap":34055,"decrement wrap":34056,invert:5386},Ot={cw:2304,ccw:2305},Dt=new V(!1,!1,!1,(function(){})),Rt=function(t,e){function r(){this.endQueryIndex=this.startQueryIndex=-1,this.sum=0,this.stats=null}function n(t,e,n){var i=o.pop()||new r;i.startQueryIndex=t,i.endQueryIndex=e,i.sum=0,i.stats=n,s.push(i)}if(!e.ext_disjoint_timer_query)return null;var i=[],a=[],o=[],s=[],l=[],c=[];return{beginQuery:function(t){var r=i.pop()||e.ext_disjoint_timer_query.createQueryEXT();e.ext_disjoint_timer_query.beginQueryEXT(35007,r),a.push(r),n(a.length-1,a.length,t)},endQuery:function()[e.ext_disjoint_timer_query.endQueryEXT(35007)],pushScopeStats:n,update:function(){var t,r;if(0!==(t=a.length)){c.length=Math.max(c.length,t+1),l.length=Math.max(l.length,t+1),l[0]=0;var n=c[0]=0;for(r=t=0;r<a.length;++r){var u=a[r];e.ext_disjoint_timer_query.getQueryObjectEXT(u,34919)?(n+=e.ext_disjoint_timer_query.getQueryObjectEXT(u,34918),i.push(u)):a[t++]=u,l[r+1]=n,c[r+1]=t}for(a.length=t,r=t=0;r<s.length;++r){var f=(n=s[r]).startQueryIndex;u=n.endQueryIndex,n.sum+=l[u]-l[f],f=c[f],(u=c[u])===f?(n.stats.gpuTime+=n.sum/1e6,o.push(n)):(n.startQueryIndex=f,n.endQueryIndex=u,s[t++]=n)}s.length=t}},getNumPendingQueries:function(){return a.length},clear:function(){i.push.apply(i,a);for(var t=0;t<i.length;t++)e.ext_disjoint_timer_query.deleteQueryEXT(i[t]);a.length=0,i.length=0},restore:function(){a.length=0,i.length=0}}};return function(t){function e(){if(0===G.length)k&&k.update(),rt=null;else{rt=K.next(e),p();for(var t=G.length-1;0<=t;--t){var r=G[t];r&&r(E,null,0)}g.flush(),k&&k.update()}}function r()[!rt&&0<G.length&&(rt=K.next(e))]function n(){rt&&(K.cancel(e),rt=null)}function a(t){t.preventDefault(),n(),Z.forEach((function(t){t()}))}function o(t){g.getError(),y.restore(),B.restore(),C.restore(),N.restore(),j.restore(),U.restore(),F.restore(),k&&k.restore(),V.procs.refresh(),r(),$.forEach((function(t){t()}))}function s(t){function e(t,e){var r={},n={};return Object.keys(t).forEach((function(i){var a=t[i];if(J.isDynamic(a))n[i]=J.unbox(a,i);else{if(e&&Array.isArray(a))for(var o=0;o<a.length;++o)if(J.isDynamic(a[o]))return void(n[i]=J.unbox(a,i));r[i]=a}})),{dynamic:n,static:r}}function r(t){for(;f.length<t;)f.push(null);return f}var n=e(t.context||{},!0),i=e(t.uniforms||{},!0),a=e(t.attributes||{},!1);t=e(function(t){function e(t){if(t in r){var e=r[t];delete r[t],Object.keys(e).forEach((function(n){r[t+"."+n]=e[n]}))}}var r=X({},t);return delete r.uniforms,delete r.attributes,delete r.context,delete r.vao,"stencil"in r&&r.stencil.op&&(r.stencil.opBack=r.stencil.opFront=r.stencil.op,delete r.stencil.op),e('blend'),e('depth'),e('cull'),e('stencil'),e('polygonOffset'),e('scissor'),e('sample'),"vao"in t&&(r.vao=t.vao),r}(t),!1);var o={gpuTime:0,cpuTime:0,count:0},s=V.compile(t,a,i,n,o),l=s.draw,c=s.batch,u=s.scope,f=[];return X((function(t,e){var n;if("function"===typeof t)return u.call(this,null,t,0);if("function"===typeof e)if("number"===typeof t)for(n=0;n<t;++n)u.call(this,null,e,n);else{if(!Array.isArray(t))return u.call(this,t,e,0);for(n=0;n<t.length;++n)u.call(this,t[n],e,n)}else if("number"===typeof t){if(0<t)return c.call(this,r(0|t),0|t)}else{if(!Array.isArray(t))return l.call(this,t);if(t.length)return c.call(this,t,t.length)}}),{stats:o,destroy:function(){s.destroy()}})}function l(t,e){var r=0;V.procs.poll();var n=e.color;n&&(g.clearColor(+n[0]||0,+n[1]||0,+n[2]||0,+n[3]||0),r|=16384),"depth"in e&&(g.clearDepth(+e.depth),r|=256),"stencil"in e&&(g.clearStencil(0|e.stencil),r|=1024),g.clear(r)}function f(t){return G.push(t),r(),{cancel:function(){function e(){var t=W(G,e);G[t]=G[G.length-1],--G.length,0>=G.length&&n()}var r=W(G,t);G[r]=e}}}function h(){var t=H.viewport,e=H.scissor_box;t[0]=t[1]=e[0]=e[1]=0,E.viewportWidth=E.framebufferWidth=E.drawingBufferWidth=t[2]=e[2]=g.drawingBufferWidth,E.viewportHeight=E.framebufferHeight=E.drawingBufferHeight=t[3]=e[3]=g.drawingBufferHeight}function p(){E.tick+=1,E.time=m(),h(),V.procs.poll()}function d(){N.refresh(),h(),V.procs.refresh(),k&&k.update()}function m(){return(Q()-M)/1e3}if(!(t=c(t)))return null;var g=t.gl,v=g.getContextAttributes();g.isContextLost();var y=u(g,t);if(!y)return null;var x=i(),w={vaoCount:0,bufferCount:0,elementsCount:0,framebufferCount:0,shaderCount:0,textureCount:0,cubeCount:0,renderbufferCount:0,maxTextureUnits:0},T=y.extensions,k=Rt(g,T),M=Q(),A=g.drawingBufferWidth,S=g.drawingBufferHeight,E={tick:0,time:0,viewportWidth:A,viewportHeight:S,framebufferWidth:A,framebufferHeight:S,drawingBufferWidth:A,drawingBufferHeight:S,pixelRatio:t.pixelRatio},L=(A={elements:null,primitive:4,count:-1,offset:0,instances:-1},tt(g,T)),C=b(g,w,t,(function(t){return F.destroyBuffer(t)})),z=_(g,T,C,w),F=O(g,T,L,w,C,z,A),B=D(g,x,w,t),N=P(g,T,L,(function()[V.procs.poll()]),E,w,t),j=At(g,T,L,w,t),U=I(g,T,L,N,j,w),V=Y(g,x,T,L,C,z,N,U,{},F,B,A,E,k,t),H=(x=R(g,U,V.procs.poll,E,v,T,L),V.next),q=g.canvas,G=[],Z=[],$=[],et=[t.onDestroy],rt=null;q&&(q.addEventListener('webglcontextlost',a,!1),q.addEventListener('webglcontextrestored',o,!1));var nt=U.setFBO=s({framebuffer:J.define.call(null,1,'framebuffer')});return d(),v=X(s,{clear:function(t){if("framebuffer"in t)if(t.framebuffer&&"framebufferCube"===t.framebuffer_reglType)for(var e=0;6>e;++e)nt(X({framebuffer:t.framebuffer.faces[e]},t),l);else nt(t,l);else l(null,t)},prop:J.define.bind(null,1),context:J.define.bind(null,2),this:J.define.bind(null,3),draw:s({}),buffer:function(t){return C.create(t,34962,!1,!1)},elements:function(t){return z.create(t,!1)},texture:N.create2D,cube:N.createCube,renderbuffer:j.create,framebuffer:U.create,framebufferCube:U.createCube,vao:F.createVAO,attributes:v,frame:f,on:function(t,e){var r;switch(t){case"frame":return f(e);case"lost":r=Z;break;case"restore":r=$;break;case"destroy":r=et}return r.push(e),{cancel:function(){for(var t=0;t<r.length;++t)if(r[t]===e){r[t]=r[r.length-1],r.pop();break}}}},limits:L,hasExtension:function(t){return 0<=L.extensions.indexOf(t.toLowerCase())},read:x,destroy:function(){G.length=0,n(),q&&(q.removeEventListener('webglcontextlost',a),q.removeEventListener('webglcontextrestored',o)),B.clear(),U.clear(),j.clear(),F.clear(),N.clear(),z.clear(),C.clear(),k&&k.clear(),et.forEach((function(t){t()}))},_gl:g,_refresh:d,poll:function(){p(),k&&k.update()},now:m,stats:w}),t.onDone(null,v),v}},"object"===typeof n&&"undefined"!==typeof r?r.exports=a():"function"===typeof t&&t.amd?t(a):i.createREGL=a()},{}],527:[function(t,e,r){"use strict";var n,i='';function a(t,e){if("string"!==typeof t)throw new TypeError('expected a string');if(1===e)return t;if(2===e)return t+t;var r=t.length*e;if(n!==t||"undefined"===typeof n)n=t,i='';else if(i.length>=r)return i.substr(0,r);for(;r>i.length&&e>1;)1&e&&(i+=t),e>>=1,t+=t;return i=(i+=t).substr(0,r)}e.exports=a},{}],528:[function(t,e,n){(function(t){(function(){e.exports=t.performance&&t.performance.now?function(){return performance.now()}:Date.now||function(){return+new Date}}).call(this)}).call(this,"undefined"!==typeof r.g?r.g:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],529:[function(t,e,r){"use strict";function n(t){for(var e=t.length,r=t[t.length-1],n=e,i=e-2;i>=0;--i){var a=r;(l=(s=t[i])-((r=a+s)-a))&&(t[--n]=r,r=l)}var o=0;for(i=n;i<e;++i){var s,l;(l=(s=r)-((r=(a=t[i])+s)-a))&&(t[o++]=l)}return t[o++]=r,t.length=o,t}e.exports=n},{}],530:[function(t,e,r){"use strict";var n=t('two-product'),i=t('robust-sum'),a=t('robust-scale'),o=t('robust-compress'),s=4;function l(t,e,r,n){return function(e){return n(t(r(e[0][0],e[1][1]),r(-e[0][1],e[1][0])))}}function c(t,e,r,n){return function(i){return n(t(e(t(r(i[1][1],i[2][2]),r(-i[1][2],i[2][1])),i[0][0]),t(e(t(r(i[1][0],i[2][2]),r(-i[1][2],i[2][0])),-i[0][1]),e(t(r(i[1][0],i[2][1]),r(-i[1][1],i[2][0])),i[0][2]))))}}function u(t){return(2===t?l:3===t?c:void 0)(i,a,n,o)}var f=[function(){return[0]},function(t){return[t[0][0]]}];function h(t,e,r,n,i,a){return function(o){switch(o.length){case 0:return t(o);case 1:return e(o);case 2:return r(o);case 3:return n(o)}var s=i[o.length];return s||(s=i[o.length]=a(o.length)),s(o)}}function p(){for(;f.length<s;)f.push(u(f.length));e.exports=h.apply(void 0,f.concat([f,u]));for(var t=0;t<f.length;++t)e.exports[t]=f[t]}p()},{"robust-compress":529,"robust-scale":536,"robust-sum":539,"two-product":588}],531:[function(t,e,r){"use strict";var n=t('two-product'),i=t('robust-sum');function a(t,e){for(var r=n(t[0],e[0]),a=1;a<t.length;++a)r=i(r,n(t[a],e[a]));return r}e.exports=a},{"robust-sum":539,"two-product":588}],532:[function(t,e,r){"use strict";var n=t('two-product'),i=t('robust-sum'),a=t('robust-subtract'),o=t('robust-scale'),s=6;function l(t){return(3===t?h:4===t?p:5===t?d:m)(i,a,n,o)}function c(){return 0}function u(){return 0}function f(){return 0}function h(t,e,r,n){function i(i,a,o){var s=r(i[0],i[0]),l=n(s,a[0]),c=n(s,o[0]),u=r(a[0],a[0]),f=n(u,i[0]),h=n(u,o[0]),p=r(o[0],o[0]),d=n(p,i[0]),m=n(p,a[0]),g=t(e(m,h),e(f,l)),v=e(d,c),y=e(g,v);return y[y.length-1]}return i}function p(t,e,r,n){function i(i,a,o,s){var l=t(r(i[0],i[0]),r(i[1],i[1])),c=n(l,a[0]),u=n(l,o[0]),f=n(l,s[0]),h=t(r(a[0],a[0]),r(a[1],a[1])),p=n(h,i[0]),d=n(h,o[0]),m=n(h,s[0]),g=t(r(o[0],o[0]),r(o[1],o[1])),v=n(g,i[0]),y=n(g,a[0]),x=n(g,s[0]),b=t(r(s[0],s[0]),r(s[1],s[1])),_=n(b,i[0]),w=n(b,a[0]),T=n(b,o[0]),k=t(t(n(e(T,x),a[1]),t(n(e(w,m),-o[1]),n(e(y,d),s[1]))),t(n(e(w,m),i[1]),t(n(e(_,f),-a[1]),n(e(p,c),s[1])))),M=t(t(n(e(T,x),i[1]),t(n(e(_,f),-o[1]),n(e(v,u),s[1]))),t(n(e(y,d),i[1]),t(n(e(v,u),-a[1]),n(e(p,c),o[1])))),A=e(k,M);return A[A.length-1]}return i}function d(t,e,r,n){function i(i,a,o,s,l){var c=t(r(i[0],i[0]),t(r(i[1],i[1]),r(i[2],i[2]))),u=n(c,a[0]),f=n(c,o[0]),h=n(c,s[0]),p=n(c,l[0]),d=t(r(a[0],a[0]),t(r(a[1],a[1]),r(a[2],a[2]))),m=n(d,i[0]),g=n(d,o[0]),v=n(d,s[0]),y=n(d,l[0]),x=t(r(o[0],o[0]),t(r(o[1],o[1]),r(o[2],o[2]))),b=n(x,i[0]),_=n(x,a[0]),w=n(x,s[0]),T=n(x,l[0]),k=t(r(s[0],s[0]),t(r(s[1],s[1]),r(s[2],s[2]))),M=n(k,i[0]),A=n(k,a[0]),S=n(k,o[0]),E=n(k,l[0]),L=t(r(l[0],l[0]),t(r(l[1],l[1]),r(l[2],l[2]))),C=n(L,i[0]),P=n(L,a[0]),I=n(L,o[0]),z=n(L,s[0]),O=t(t(t(n(t(n(e(z,E),o[1]),t(n(e(I,T),-s[1]),n(e(S,w),l[1]))),a[2]),t(n(t(n(e(z,E),a[1]),t(n(e(P,y),-s[1]),n(e(A,v),l[1]))),-o[2]),n(t(n(e(I,T),a[1]),t(n(e(P,y),-o[1]),n(e(_,g),l[1]))),s[2]))),t(n(t(n(e(S,w),a[1]),t(n(e(A,v),-o[1]),n(e(_,g),s[1]))),-l[2]),t(n(t(n(e(z,E),a[1]),t(n(e(P,y),-s[1]),n(e(A,v),l[1]))),i[2]),n(t(n(e(z,E),i[1]),t(n(e(C,p),-s[1]),n(e(M,h),l[1]))),-a[2])))),t(t(n(t(n(e(P,y),i[1]),t(n(e(C,p),-a[1]),n(e(m,u),l[1]))),s[2]),t(n(t(n(e(A,v),i[1]),t(n(e(M,h),-a[1]),n(e(m,u),s[1]))),-l[2]),n(t(n(e(S,w),a[1]),t(n(e(A,v),-o[1]),n(e(_,g),s[1]))),i[2]))),t(n(t(n(e(S,w),i[1]),t(n(e(M,h),-o[1]),n(e(b,f),s[1]))),-a[2]),t(n(t(n(e(A,v),i[1]),t(n(e(M,h),-a[1]),n(e(m,u),s[1]))),o[2]),n(t(n(e(_,g),i[1]),t(n(e(b,f),-a[1]),n(e(m,u),o[1]))),-s[2]))))),D=t(t(t(n(t(n(e(z,E),o[1]),t(n(e(I,T),-s[1]),n(e(S,w),l[1]))),i[2]),n(t(n(e(z,E),i[1]),t(n(e(C,p),-s[1]),n(e(M,h),l[1]))),-o[2])),t(n(t(n(e(I,T),i[1]),t(n(e(C,p),-o[1]),n(e(b,f),l[1]))),s[2]),n(t(n(e(S,w),i[1]),t(n(e(M,h),-o[1]),n(e(b,f),s[1]))),-l[2]))),t(t(n(t(n(e(I,T),a[1]),t(n(e(P,y),-o[1]),n(e(_,g),l[1]))),i[2]),n(t(n(e(I,T),i[1]),t(n(e(C,p),-o[1]),n(e(b,f),l[1]))),-a[2])),t(n(t(n(e(P,y),i[1]),t(n(e(C,p),-a[1]),n(e(m,u),l[1]))),o[2]),n(t(n(e(_,g),i[1]),t(n(e(b,f),-a[1]),n(e(m,u),o[1]))),-l[2])))),R=e(O,D);return R[R.length-1]}return i}function m(t,e,r,n){function i(i,a,o,s,l,c){var u=t(t(r(i[0],i[0]),r(i[1],i[1])),t(r(i[2],i[2]),r(i[3],i[3]))),f=n(u,a[0]),h=n(u,o[0]),p=n(u,s[0]),d=n(u,l[0]),m=n(u,c[0]),g=t(t(r(a[0],a[0]),r(a[1],a[1])),t(r(a[2],a[2]),r(a[3],a[3]))),v=n(g,i[0]),y=n(g,o[0]),x=n(g,s[0]),b=n(g,l[0]),_=n(g,c[0]),w=t(t(r(o[0],o[0]),r(o[1],o[1])),t(r(o[2],o[2]),r(o[3],o[3]))),T=n(w,i[0]),k=n(w,a[0]),M=n(w,s[0]),A=n(w,l[0]),S=n(w,c[0]),E=t(t(r(s[0],s[0]),r(s[1],s[1])),t(r(s[2],s[2]),r(s[3],s[3]))),L=n(E,i[0]),C=n(E,a[0]),P=n(E,o[0]),I=n(E,l[0]),z=n(E,c[0]),O=t(t(r(l[0],l[0]),r(l[1],l[1])),t(r(l[2],l[2]),r(l[3],l[3]))),D=n(O,i[0]),R=n(O,a[0]),F=n(O,o[0]),B=n(O,s[0]),N=n(O,c[0]),j=t(t(r(c[0],c[0]),r(c[1],c[1])),t(r(c[2],c[2]),r(c[3],c[3]))),U=n(j,i[0]),V=n(j,a[0]),H=n(j,o[0]),q=n(j,s[0]),G=n(j,l[0]),Y=t(t(t(n(t(t(n(t(n(e(G,N),s[1]),t(n(e(q,z),-l[1]),n(e(B,I),c[1]))),o[2]),n(t(n(e(G,N),o[1]),t(n(e(H,S),-l[1]),n(e(F,A),c[1]))),-s[2])),t(n(t(n(e(q,z),o[1]),t(n(e(H,S),-s[1]),n(e(P,M),c[1]))),l[2]),n(t(n(e(B,I),o[1]),t(n(e(F,A),-s[1]),n(e(P,M),l[1]))),-c[2]))),a[3]),t(n(t(t(n(t(n(e(G,N),s[1]),t(n(e(q,z),-l[1]),n(e(B,I),c[1]))),a[2]),n(t(n(e(G,N),a[1]),t(n(e(V,_),-l[1]),n(e(R,b),c[1]))),-s[2])),t(n(t(n(e(q,z),a[1]),t(n(e(V,_),-s[1]),n(e(C,x),c[1]))),l[2]),n(t(n(e(B,I),a[1]),t(n(e(R,b),-s[1]),n(e(C,x),l[1]))),-c[2]))),-o[3]),n(t(t(n(t(n(e(G,N),o[1]),t(n(e(H,S),-l[1]),n(e(F,A),c[1]))),a[2]),n(t(n(e(G,N),a[1]),t(n(e(V,_),-l[1]),n(e(R,b),c[1]))),-o[2])),t(n(t(n(e(H,S),a[1]),t(n(e(V,_),-o[1]),n(e(k,y),c[1]))),l[2]),n(t(n(e(F,A),a[1]),t(n(e(R,b),-o[1]),n(e(k,y),l[1]))),-c[2]))),s[3]))),t(t(n(t(t(n(t(n(e(q,z),o[1]),t(n(e(H,S),-s[1]),n(e(P,M),c[1]))),a[2]),n(t(n(e(q,z),a[1]),t(n(e(V,_),-s[1]),n(e(C,x),c[1]))),-o[2])),t(n(t(n(e(H,S),a[1]),t(n(e(V,_),-o[1]),n(e(k,y),c[1]))),s[2]),n(t(n(e(P,M),a[1]),t(n(e(C,x),-o[1]),n(e(k,y),s[1]))),-c[2]))),-l[3]),n(t(t(n(t(n(e(B,I),o[1]),t(n(e(F,A),-s[1]),n(e(P,M),l[1]))),a[2]),n(t(n(e(B,I),a[1]),t(n(e(R,b),-s[1]),n(e(C,x),l[1]))),-o[2])),t(n(t(n(e(F,A),a[1]),t(n(e(R,b),-o[1]),n(e(k,y),l[1]))),s[2]),n(t(n(e(P,M),a[1]),t(n(e(C,x),-o[1]),n(e(k,y),s[1]))),-l[2]))),c[3])),t(n(t(t(n(t(n(e(G,N),s[1]),t(n(e(q,z),-l[1]),n(e(B,I),c[1]))),a[2]),n(t(n(e(G,N),a[1]),t(n(e(V,_),-l[1]),n(e(R,b),c[1]))),-s[2])),t(n(t(n(e(q,z),a[1]),t(n(e(V,_),-s[1]),n(e(C,x),c[1]))),l[2]),n(t(n(e(B,I),a[1]),t(n(e(R,b),-s[1]),n(e(C,x),l[1]))),-c[2]))),i[3]),n(t(t(n(t(n(e(G,N),s[1]),t(n(e(q,z),-l[1]),n(e(B,I),c[1]))),i[2]),n(t(n(e(G,N),i[1]),t(n(e(U,m),-l[1]),n(e(D,d),c[1]))),-s[2])),t(n(t(n(e(q,z),i[1]),t(n(e(U,m),-s[1]),n(e(L,p),c[1]))),l[2]),n(t(n(e(B,I),i[1]),t(n(e(D,d),-s[1]),n(e(L,p),l[1]))),-c[2]))),-a[3])))),t(t(t(n(t(t(n(t(n(e(G,N),a[1]),t(n(e(V,_),-l[1]),n(e(R,b),c[1]))),i[2]),n(t(n(e(G,N),i[1]),t(n(e(U,m),-l[1]),n(e(D,d),c[1]))),-a[2])),t(n(t(n(e(V,_),i[1]),t(n(e(U,m),-a[1]),n(e(v,f),c[1]))),l[2]),n(t(n(e(R,b),i[1]),t(n(e(D,d),-a[1]),n(e(v,f),l[1]))),-c[2]))),s[3]),n(t(t(n(t(n(e(q,z),a[1]),t(n(e(V,_),-s[1]),n(e(C,x),c[1]))),i[2]),n(t(n(e(q,z),i[1]),t(n(e(U,m),-s[1]),n(e(L,p),c[1]))),-a[2])),t(n(t(n(e(V,_),i[1]),t(n(e(U,m),-a[1]),n(e(v,f),c[1]))),s[2]),n(t(n(e(C,x),i[1]),t(n(e(L,p),-a[1]),n(e(v,f),s[1]))),-c[2]))),-l[3])),t(n(t(t(n(t(n(e(B,I),a[1]),t(n(e(R,b),-s[1]),n(e(C,x),l[1]))),i[2]),n(t(n(e(B,I),i[1]),t(n(e(D,d),-s[1]),n(e(L,p),l[1]))),-a[2])),t(n(t(n(e(R,b),i[1]),t(n(e(D,d),-a[1]),n(e(v,f),l[1]))),s[2]),n(t(n(e(C,x),i[1]),t(n(e(L,p),-a[1]),n(e(v,f),s[1]))),-l[2]))),c[3]),n(t(t(n(t(n(e(q,z),o[1]),t(n(e(H,S),-s[1]),n(e(P,M),c[1]))),a[2]),n(t(n(e(q,z),a[1]),t(n(e(V,_),-s[1]),n(e(C,x),c[1]))),-o[2])),t(n(t(n(e(H,S),a[1]),t(n(e(V,_),-o[1]),n(e(k,y),c[1]))),s[2]),n(t(n(e(P,M),a[1]),t(n(e(C,x),-o[1]),n(e(k,y),s[1]))),-c[2]))),i[3]))),t(t(n(t(t(n(t(n(e(q,z),o[1]),t(n(e(H,S),-s[1]),n(e(P,M),c[1]))),i[2]),n(t(n(e(q,z),i[1]),t(n(e(U,m),-s[1]),n(e(L,p),c[1]))),-o[2])),t(n(t(n(e(H,S),i[1]),t(n(e(U,m),-o[1]),n(e(T,h),c[1]))),s[2]),n(t(n(e(P,M),i[1]),t(n(e(L,p),-o[1]),n(e(T,h),s[1]))),-c[2]))),-a[3]),n(t(t(n(t(n(e(q,z),a[1]),t(n(e(V,_),-s[1]),n(e(C,x),c[1]))),i[2]),n(t(n(e(q,z),i[1]),t(n(e(U,m),-s[1]),n(e(L,p),c[1]))),-a[2])),t(n(t(n(e(V,_),i[1]),t(n(e(U,m),-a[1]),n(e(v,f),c[1]))),s[2]),n(t(n(e(C,x),i[1]),t(n(e(L,p),-a[1]),n(e(v,f),s[1]))),-c[2]))),o[3])),t(n(t(t(n(t(n(e(H,S),a[1]),t(n(e(V,_),-o[1]),n(e(k,y),c[1]))),i[2]),n(t(n(e(H,S),i[1]),t(n(e(U,m),-o[1]),n(e(T,h),c[1]))),-a[2])),t(n(t(n(e(V,_),i[1]),t(n(e(U,m),-a[1]),n(e(v,f),c[1]))),o[2]),n(t(n(e(k,y),i[1]),t(n(e(T,h),-a[1]),n(e(v,f),o[1]))),-c[2]))),-s[3]),n(t(t(n(t(n(e(P,M),a[1]),t(n(e(C,x),-o[1]),n(e(k,y),s[1]))),i[2]),n(t(n(e(P,M),i[1]),t(n(e(L,p),-o[1]),n(e(T,h),s[1]))),-a[2])),t(n(t(n(e(C,x),i[1]),t(n(e(L,p),-a[1]),n(e(v,f),s[1]))),o[2]),n(t(n(e(k,y),i[1]),t(n(e(T,h),-a[1]),n(e(v,f),o[1]))),-s[2]))),c[3]))))),W=t(t(t(n(t(t(n(t(n(e(G,N),s[1]),t(n(e(q,z),-l[1]),n(e(B,I),c[1]))),o[2]),n(t(n(e(G,N),o[1]),t(n(e(H,S),-l[1]),n(e(F,A),c[1]))),-s[2])),t(n(t(n(e(q,z),o[1]),t(n(e(H,S),-s[1]),n(e(P,M),c[1]))),l[2]),n(t(n(e(B,I),o[1]),t(n(e(F,A),-s[1]),n(e(P,M),l[1]))),-c[2]))),i[3]),t(n(t(t(n(t(n(e(G,N),s[1]),t(n(e(q,z),-l[1]),n(e(B,I),c[1]))),i[2]),n(t(n(e(G,N),i[1]),t(n(e(U,m),-l[1]),n(e(D,d),c[1]))),-s[2])),t(n(t(n(e(q,z),i[1]),t(n(e(U,m),-s[1]),n(e(L,p),c[1]))),l[2]),n(t(n(e(B,I),i[1]),t(n(e(D,d),-s[1]),n(e(L,p),l[1]))),-c[2]))),-o[3]),n(t(t(n(t(n(e(G,N),o[1]),t(n(e(H,S),-l[1]),n(e(F,A),c[1]))),i[2]),n(t(n(e(G,N),i[1]),t(n(e(U,m),-l[1]),n(e(D,d),c[1]))),-o[2])),t(n(t(n(e(H,S),i[1]),t(n(e(U,m),-o[1]),n(e(T,h),c[1]))),l[2]),n(t(n(e(F,A),i[1]),t(n(e(D,d),-o[1]),n(e(T,h),l[1]))),-c[2]))),s[3]))),t(t(n(t(t(n(t(n(e(q,z),o[1]),t(n(e(H,S),-s[1]),n(e(P,M),c[1]))),i[2]),n(t(n(e(q,z),i[1]),t(n(e(U,m),-s[1]),n(e(L,p),c[1]))),-o[2])),t(n(t(n(e(H,S),i[1]),t(n(e(U,m),-o[1]),n(e(T,h),c[1]))),s[2]),n(t(n(e(P,M),i[1]),t(n(e(L,p),-o[1]),n(e(T,h),s[1]))),-c[2]))),-l[3]),n(t(t(n(t(n(e(B,I),o[1]),t(n(e(F,A),-s[1]),n(e(P,M),l[1]))),i[2]),n(t(n(e(B,I),i[1]),t(n(e(D,d),-s[1]),n(e(L,p),l[1]))),-o[2])),t(n(t(n(e(F,A),i[1]),t(n(e(D,d),-o[1]),n(e(T,h),l[1]))),s[2]),n(t(n(e(P,M),i[1]),t(n(e(L,p),-o[1]),n(e(T,h),s[1]))),-l[2]))),c[3])),t(n(t(t(n(t(n(e(G,N),o[1]),t(n(e(H,S),-l[1]),n(e(F,A),c[1]))),a[2]),n(t(n(e(G,N),a[1]),t(n(e(V,_),-l[1]),n(e(R,b),c[1]))),-o[2])),t(n(t(n(e(H,S),a[1]),t(n(e(V,_),-o[1]),n(e(k,y),c[1]))),l[2]),n(t(n(e(F,A),a[1]),t(n(e(R,b),-o[1]),n(e(k,y),l[1]))),-c[2]))),i[3]),n(t(t(n(t(n(e(G,N),o[1]),t(n(e(H,S),-l[1]),n(e(F,A),c[1]))),i[2]),n(t(n(e(G,N),i[1]),t(n(e(U,m),-l[1]),n(e(D,d),c[1]))),-o[2])),t(n(t(n(e(H,S),i[1]),t(n(e(U,m),-o[1]),n(e(T,h),c[1]))),l[2]),n(t(n(e(F,A),i[1]),t(n(e(D,d),-o[1]),n(e(T,h),l[1]))),-c[2]))),-a[3])))),t(t(t(n(t(t(n(t(n(e(G,N),a[1]),t(n(e(V,_),-l[1]),n(e(R,b),c[1]))),i[2]),n(t(n(e(G,N),i[1]),t(n(e(U,m),-l[1]),n(e(D,d),c[1]))),-a[2])),t(n(t(n(e(V,_),i[1]),t(n(e(U,m),-a[1]),n(e(v,f),c[1]))),l[2]),n(t(n(e(R,b),i[1]),t(n(e(D,d),-a[1]),n(e(v,f),l[1]))),-c[2]))),o[3]),n(t(t(n(t(n(e(H,S),a[1]),t(n(e(V,_),-o[1]),n(e(k,y),c[1]))),i[2]),n(t(n(e(H,S),i[1]),t(n(e(U,m),-o[1]),n(e(T,h),c[1]))),-a[2])),t(n(t(n(e(V,_),i[1]),t(n(e(U,m),-a[1]),n(e(v,f),c[1]))),o[2]),n(t(n(e(k,y),i[1]),t(n(e(T,h),-a[1]),n(e(v,f),o[1]))),-c[2]))),-l[3])),t(n(t(t(n(t(n(e(F,A),a[1]),t(n(e(R,b),-o[1]),n(e(k,y),l[1]))),i[2]),n(t(n(e(F,A),i[1]),t(n(e(D,d),-o[1]),n(e(T,h),l[1]))),-a[2])),t(n(t(n(e(R,b),i[1]),t(n(e(D,d),-a[1]),n(e(v,f),l[1]))),o[2]),n(t(n(e(k,y),i[1]),t(n(e(T,h),-a[1]),n(e(v,f),o[1]))),-l[2]))),c[3]),n(t(t(n(t(n(e(B,I),o[1]),t(n(e(F,A),-s[1]),n(e(P,M),l[1]))),a[2]),n(t(n(e(B,I),a[1]),t(n(e(R,b),-s[1]),n(e(C,x),l[1]))),-o[2])),t(n(t(n(e(F,A),a[1]),t(n(e(R,b),-o[1]),n(e(k,y),l[1]))),s[2]),n(t(n(e(P,M),a[1]),t(n(e(C,x),-o[1]),n(e(k,y),s[1]))),-l[2]))),i[3]))),t(t(n(t(t(n(t(n(e(B,I),o[1]),t(n(e(F,A),-s[1]),n(e(P,M),l[1]))),i[2]),n(t(n(e(B,I),i[1]),t(n(e(D,d),-s[1]),n(e(L,p),l[1]))),-o[2])),t(n(t(n(e(F,A),i[1]),t(n(e(D,d),-o[1]),n(e(T,h),l[1]))),s[2]),n(t(n(e(P,M),i[1]),t(n(e(L,p),-o[1]),n(e(T,h),s[1]))),-l[2]))),-a[3]),n(t(t(n(t(n(e(B,I),a[1]),t(n(e(R,b),-s[1]),n(e(C,x),l[1]))),i[2]),n(t(n(e(B,I),i[1]),t(n(e(D,d),-s[1]),n(e(L,p),l[1]))),-a[2])),t(n(t(n(e(R,b),i[1]),t(n(e(D,d),-a[1]),n(e(v,f),l[1]))),s[2]),n(t(n(e(C,x),i[1]),t(n(e(L,p),-a[1]),n(e(v,f),s[1]))),-l[2]))),o[3])),t(n(t(t(n(t(n(e(F,A),a[1]),t(n(e(R,b),-o[1]),n(e(k,y),l[1]))),i[2]),n(t(n(e(F,A),i[1]),t(n(e(D,d),-o[1]),n(e(T,h),l[1]))),-a[2])),t(n(t(n(e(R,b),i[1]),t(n(e(D,d),-a[1]),n(e(v,f),l[1]))),o[2]),n(t(n(e(k,y),i[1]),t(n(e(T,h),-a[1]),n(e(v,f),o[1]))),-l[2]))),-s[3]),n(t(t(n(t(n(e(P,M),a[1]),t(n(e(C,x),-o[1]),n(e(k,y),s[1]))),i[2]),n(t(n(e(P,M),i[1]),t(n(e(L,p),-o[1]),n(e(T,h),s[1]))),-a[2])),t(n(t(n(e(C,x),i[1]),t(n(e(L,p),-a[1]),n(e(v,f),s[1]))),o[2]),n(t(n(e(k,y),i[1]),t(n(e(T,h),-a[1]),n(e(v,f),o[1]))),-s[2]))),l[3]))))),X=e(Y,W);return X[X.length-1]}return i}var g=[c,u,f];function v(t){var e=g[t.length];return e||(e=g[t.length]=l(t.length)),e.apply(void 0,t)}function y(t,e,r,n,i,a,o,s){function l(e,r,l,c,u,f){switch(arguments.length){case 0:case 1:return 0;case 2:return n(e,r);case 3:return i(e,r,l);case 4:return a(e,r,l,c);case 5:return o(e,r,l,c,u);case 6:return s(e,r,l,c,u,f)}for(var h=new Array(arguments.length),p=0;p<arguments.length;++p)h[p]=arguments[p];return t(h)}return l}function x(){for(;g.length<=s;)g.push(l(g.length));e.exports=y.apply(void 0,[v].concat(g));for(var t=0;t<=s;++t)e.exports[t]=g[t]}x()},{"robust-scale":536,"robust-subtract":538,"robust-sum":539,"two-product":588}],533:[function(t,e,r){"use strict";var n=t('robust-determinant'),i=3;function a(t){var e=2===t?l:c;return e(t<i?n[t]:n)}function o(){return[[0]]}function s(t,e){return[[e[0]],[t[0][0]]]}function l(t){return function(e,r){return[t([[+r[0],+e[0][1]],[+r[1],+e[1][1]]]),t([[+e[0][0],+r[0]],[+e[1][0],+r[1]]]),t(e)]}}function c(t){return function(e,r){return[t([[+r[0],+e[0][1],+e[0][2]],[+r[1],+e[1][1],+e[1][2]],[+r[2],+e[2][1],+e[2][2]]]),t([[+e[0][0],+r[0],+e[0][2]],[+e[1][0],+r[1],+e[1][2]],[+e[2][0],+r[2],+e[2][2]]]),t([[+e[0][0],+e[0][1],+r[0]],[+e[1][0],+e[1][1],+r[1]],[+e[2][0],+e[2][1],+r[2]]]),t(e)]}}var u=[o,s];function f(t,e,r,n,i,a){return function(o,s){switch(o.length){case 0:return t(o,s);case 1:return e(o,s);case 2:return r(o,s);case 3:return n(o,s)}var l=i[o.length];return l||(l=i[o.length]=a(o.length)),l(o,s)}}function h(){for(;u.length<=i;)u.push(a(u.length));e.exports=f.apply(void 0,u.concat([u,a]));for(var t=0;t<i;++t)e.exports[t]=u[t]}h()},{"robust-determinant":530}],534:[function(t,e,r){"use strict";var n=t('two-product'),i=t('robust-sum'),a=t('robust-scale'),o=t('robust-subtract'),s=5,l=11102230246251565e-32,c=(3+16*l)*l,u=(7+56*l)*l;function f(t,e,r,n){return function(r,i,a){var o=t(t(e(i[1],a[0]),e(-a[1],i[0])),t(e(r[1],i[0]),e(-i[1],r[0]))),s=t(e(r[1],a[0]),e(-a[1],r[0])),l=n(o,s);return l[l.length-1]}}function h(t,e,r,n){return function(i,a,o,s){var l=t(t(r(t(e(o[1],s[0]),e(-s[1],o[0])),a[2]),t(r(t(e(a[1],s[0]),e(-s[1],a[0])),-o[2]),r(t(e(a[1],o[0]),e(-o[1],a[0])),s[2]))),t(r(t(e(a[1],s[0]),e(-s[1],a[0])),i[2]),t(r(t(e(i[1],s[0]),e(-s[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),s[2])))),c=t(t(r(t(e(o[1],s[0]),e(-s[1],o[0])),i[2]),t(r(t(e(i[1],s[0]),e(-s[1],i[0])),-o[2]),r(t(e(i[1],o[0]),e(-o[1],i[0])),s[2]))),t(r(t(e(a[1],o[0]),e(-o[1],a[0])),i[2]),t(r(t(e(i[1],o[0]),e(-o[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),o[2])))),u=n(l,c);return u[u.length-1]}}function p(t,e,r,n){return function(i,a,o,s,l){var c=t(t(t(r(t(r(t(e(s[1],l[0]),e(-l[1],s[0])),o[2]),t(r(t(e(o[1],l[0]),e(-l[1],o[0])),-s[2]),r(t(e(o[1],s[0]),e(-s[1],o[0])),l[2]))),a[3]),t(r(t(r(t(e(s[1],l[0]),e(-l[1],s[0])),a[2]),t(r(t(e(a[1],l[0]),e(-l[1],a[0])),-s[2]),r(t(e(a[1],s[0]),e(-s[1],a[0])),l[2]))),-o[3]),r(t(r(t(e(o[1],l[0]),e(-l[1],o[0])),a[2]),t(r(t(e(a[1],l[0]),e(-l[1],a[0])),-o[2]),r(t(e(a[1],o[0]),e(-o[1],a[0])),l[2]))),s[3]))),t(r(t(r(t(e(o[1],s[0]),e(-s[1],o[0])),a[2]),t(r(t(e(a[1],s[0]),e(-s[1],a[0])),-o[2]),r(t(e(a[1],o[0]),e(-o[1],a[0])),s[2]))),-l[3]),t(r(t(r(t(e(s[1],l[0]),e(-l[1],s[0])),a[2]),t(r(t(e(a[1],l[0]),e(-l[1],a[0])),-s[2]),r(t(e(a[1],s[0]),e(-s[1],a[0])),l[2]))),i[3]),r(t(r(t(e(s[1],l[0]),e(-l[1],s[0])),i[2]),t(r(t(e(i[1],l[0]),e(-l[1],i[0])),-s[2]),r(t(e(i[1],s[0]),e(-s[1],i[0])),l[2]))),-a[3])))),t(t(r(t(r(t(e(a[1],l[0]),e(-l[1],a[0])),i[2]),t(r(t(e(i[1],l[0]),e(-l[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),l[2]))),s[3]),t(r(t(r(t(e(a[1],s[0]),e(-s[1],a[0])),i[2]),t(r(t(e(i[1],s[0]),e(-s[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),s[2]))),-l[3]),r(t(r(t(e(o[1],s[0]),e(-s[1],o[0])),a[2]),t(r(t(e(a[1],s[0]),e(-s[1],a[0])),-o[2]),r(t(e(a[1],o[0]),e(-o[1],a[0])),s[2]))),i[3]))),t(r(t(r(t(e(o[1],s[0]),e(-s[1],o[0])),i[2]),t(r(t(e(i[1],s[0]),e(-s[1],i[0])),-o[2]),r(t(e(i[1],o[0]),e(-o[1],i[0])),s[2]))),-a[3]),t(r(t(r(t(e(a[1],s[0]),e(-s[1],a[0])),i[2]),t(r(t(e(i[1],s[0]),e(-s[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),s[2]))),o[3]),r(t(r(t(e(a[1],o[0]),e(-o[1],a[0])),i[2]),t(r(t(e(i[1],o[0]),e(-o[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),o[2]))),-s[3]))))),u=t(t(t(r(t(r(t(e(s[1],l[0]),e(-l[1],s[0])),o[2]),t(r(t(e(o[1],l[0]),e(-l[1],o[0])),-s[2]),r(t(e(o[1],s[0]),e(-s[1],o[0])),l[2]))),i[3]),r(t(r(t(e(s[1],l[0]),e(-l[1],s[0])),i[2]),t(r(t(e(i[1],l[0]),e(-l[1],i[0])),-s[2]),r(t(e(i[1],s[0]),e(-s[1],i[0])),l[2]))),-o[3])),t(r(t(r(t(e(o[1],l[0]),e(-l[1],o[0])),i[2]),t(r(t(e(i[1],l[0]),e(-l[1],i[0])),-o[2]),r(t(e(i[1],o[0]),e(-o[1],i[0])),l[2]))),s[3]),r(t(r(t(e(o[1],s[0]),e(-s[1],o[0])),i[2]),t(r(t(e(i[1],s[0]),e(-s[1],i[0])),-o[2]),r(t(e(i[1],o[0]),e(-o[1],i[0])),s[2]))),-l[3]))),t(t(r(t(r(t(e(o[1],l[0]),e(-l[1],o[0])),a[2]),t(r(t(e(a[1],l[0]),e(-l[1],a[0])),-o[2]),r(t(e(a[1],o[0]),e(-o[1],a[0])),l[2]))),i[3]),r(t(r(t(e(o[1],l[0]),e(-l[1],o[0])),i[2]),t(r(t(e(i[1],l[0]),e(-l[1],i[0])),-o[2]),r(t(e(i[1],o[0]),e(-o[1],i[0])),l[2]))),-a[3])),t(r(t(r(t(e(a[1],l[0]),e(-l[1],a[0])),i[2]),t(r(t(e(i[1],l[0]),e(-l[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),l[2]))),o[3]),r(t(r(t(e(a[1],o[0]),e(-o[1],a[0])),i[2]),t(r(t(e(i[1],o[0]),e(-o[1],i[0])),-a[2]),r(t(e(i[1],a[0]),e(-a[1],i[0])),o[2]))),-l[3])))),f=n(c,u);return f[f.length-1]}}function d(t){return(3===t?f:4===t?h:p)(i,n,a,o)}var m=d(3),g=d(4),v=[function(){return 0},function(){return 0},function(t,e){return e[0]-t[0]},function(t,e,r){var n,i=(t[1]-r[1])*(e[0]-r[0]),a=(t[0]-r[0])*(e[1]-r[1]),o=i-a;if(i>0){if(a<=0)return o;n=i+a}else{if(!(i<0))return o;if(a>=0)return o;n=-(i+a)}var s=c*n;return o>=s||o<=-s?o:m(t,e,r)},function(t,e,r,n){var i=t[0]-n[0],a=e[0]-n[0],o=r[0]-n[0],s=t[1]-n[1],l=e[1]-n[1],c=r[1]-n[1],f=t[2]-n[2],h=e[2]-n[2],p=r[2]-n[2],d=a*c,m=o*l,v=o*s,y=i*c,x=i*l,b=a*s,_=f*(d-m)+h*(v-y)+p*(x-b),w=(Math.abs(d)+Math.abs(m))*Math.abs(f)+(Math.abs(v)+Math.abs(y))*Math.abs(h)+(Math.abs(x)+Math.abs(b))*Math.abs(p),T=u*w;return _>T||-_>T?_:g(t,e,r,n)}];function y(t){var e=v[t.length];return e||(e=v[t.length]=d(t.length)),e.apply(void 0,t)}function x(t,e,r,n,i,a,o){return function(e,r,s,l,c){switch(arguments.length){case 0:case 1:return 0;case 2:return n(e,r);case 3:return i(e,r,s);case 4:return a(e,r,s,l);case 5:return o(e,r,s,l,c)}for(var u=new Array(arguments.length),f=0;f<arguments.length;++f)u[f]=arguments[f];return t(u)}}function b(){for(;v.length<=s;)v.push(d(v.length));e.exports=x.apply(void 0,[y].concat(v));for(var t=0;t<=s;++t)e.exports[t]=v[t]}b()},{"robust-scale":536,"robust-subtract":538,"robust-sum":539,"two-product":588}],535:[function(t,e,r){"use strict";var n=t('robust-sum'),i=t('robust-scale');function a(t,e){if(1===t.length)return i(e,t[0]);if(1===e.length)return i(t,e[0]);if(0===t.length||0===e.length)return[0];var r=[0];if(t.length<e.length)for(var a=0;a<t.length;++a)r=n(r,i(e,t[a]));else for(a=0;a<e.length;++a)r=n(r,i(t,e[a]));return r}e.exports=a},{"robust-scale":536,"robust-sum":539}],536:[function(t,e,r){"use strict";var n=t('two-product'),i=t('two-sum');function a(t,e){var r=t.length;if(1===r){var a=n(t[0],e);return a[0]?a:[a[1]]}var o=new Array(2*r),s=[.1,.1],l=[.1,.1],c=0;n(t[0],e,s),s[0]&&(o[c++]=s[0]);for(var u=1;u<r;++u){n(t[u],e,l);var f=s[1];i(f,l[0],s),s[0]&&(o[c++]=s[0]);var h=l[1],p=s[1],d=h+p,m=p-(d-h);s[1]=d,m&&(o[c++]=m)}return s[1]&&(o[c++]=s[1]),0===c&&(o[c++]=0),o.length=c,o}e.exports=a},{"two-product":588,"two-sum":589}],537:[function(t,e,r){"use strict";e.exports=a;var n=t('robust-orientation')[3];function i(t,e,r,n){for(var i=0;i<2;++i){var a=t[i],o=e[i],s=Math.min(a,o),l=Math.max(a,o),c=r[i],u=n[i],f=Math.min(c,u);if(Math.max(c,u)<s||l<f)return!1}return!0}function a(t,e,r,a){var o=n(t,r,a),s=n(e,r,a);if(o>0&&s>0||o<0&&s<0)return!1;var l=n(r,t,e),c=n(a,t,e);return!(l>0&&c>0||l<0&&c<0)&&(0!==o||0!==s||0!==l||0!==c||i(t,e,r,a))}},{"robust-orientation":534}],538:[function(t,e,r){"use strict";function n(t,e){var r=t+e,n=r-t,i=t-(r-n)+(e-n);return i?[i,r]:[r]}function i(t,e){var r=0|t.length,i=0|e.length;if(1===r&&1===i)return n(t[0],-e[0]);var a,o,s=new Array(r+i),l=0,c=0,u=0,f=Math.abs,h=t[c],p=f(h),d=-e[u],m=f(d);p<m?(o=h,(c+=1)<r&&(p=f(h=t[c]))):(o=d,(u+=1)<i&&(m=f(d=-e[u]))),c<r&&p<m||u>=i?(a=h,(c+=1)<r&&(p=f(h=t[c]))):(a=d,(u+=1)<i&&(m=f(d=-e[u])));for(var g,v,y=a+o,x=y-a,b=o-x,_=b,w=y;c<r&&u<i;)p<m?(a=h,(c+=1)<r&&(p=f(h=t[c]))):(a=d,(u+=1)<i&&(m=f(d=-e[u]))),(b=(o=_)-(x=(y=a+o)-a))&&(s[l++]=b),_=w-((g=w+y)-(v=g-w))+(y-v),w=g;for(;c<r;)(b=(o=_)-(x=(y=(a=h)+o)-a))&&(s[l++]=b),_=w-((g=w+y)-(v=g-w))+(y-v),w=g,(c+=1)<r&&(h=t[c]);for(;u<i;)(b=(o=_)-(x=(y=(a=d)+o)-a))&&(s[l++]=b),_=w-((g=w+y)-(v=g-w))+(y-v),w=g,(u+=1)<i&&(d=-e[u]);return _&&(s[l++]=_),w&&(s[l++]=w),l||(s[l++]=0),s.length=l,s}e.exports=i},{}],539:[function(t,e,r){"use strict";function n(t,e){var r=t+e,n=r-t,i=t-(r-n)+(e-n);return i?[i,r]:[r]}function i(t,e){var r=0|t.length,i=0|e.length;if(1===r&&1===i)return n(t[0],e[0]);var a,o,s=new Array(r+i),l=0,c=0,u=0,f=Math.abs,h=t[c],p=f(h),d=e[u],m=f(d);p<m?(o=h,(c+=1)<r&&(p=f(h=t[c]))):(o=d,(u+=1)<i&&(m=f(d=e[u]))),c<r&&p<m||u>=i?(a=h,(c+=1)<r&&(p=f(h=t[c]))):(a=d,(u+=1)<i&&(m=f(d=e[u])));for(var g,v,y=a+o,x=y-a,b=o-x,_=b,w=y;c<r&&u<i;)p<m?(a=h,(c+=1)<r&&(p=f(h=t[c]))):(a=d,(u+=1)<i&&(m=f(d=e[u]))),(b=(o=_)-(x=(y=a+o)-a))&&(s[l++]=b),_=w-((g=w+y)-(v=g-w))+(y-v),w=g;for(;c<r;)(b=(o=_)-(x=(y=(a=h)+o)-a))&&(s[l++]=b),_=w-((g=w+y)-(v=g-w))+(y-v),w=g,(c+=1)<r&&(h=t[c]);for(;u<i;)(b=(o=_)-(x=(y=(a=d)+o)-a))&&(s[l++]=b),_=w-((g=w+y)-(v=g-w))+(y-v),w=g,(u+=1)<i&&(d=e[u]);return _&&(s[l++]=_),w&&(s[l++]=w),l||(s[l++]=0),s.length=l,s}e.exports=i},{}],540:[function(t,e,r){var n=t('buffer'),i=n.Buffer;function a(t,e){for(var r in t)e[r]=t[r]}function o(t,e,r){return i(t,e,r)}i.from&&i.alloc&&i.allocUnsafe&&i.allocUnsafeSlow?e.exports=n:(a(n,r),r.Buffer=o),o.prototype=Object.create(i.prototype),a(i,o),o.from=function(t,e,r){if("number"===typeof t)throw new TypeError('Argument must not be a number');return i(t,e,r)},o.alloc=function(t,e,r){if("number"!==typeof t)throw new TypeError('Argument must be a number');var n=i(t);return void 0!==e?"string"===typeof r?n.fill(e,r):n.fill(e):n.fill(0),n},o.allocUnsafe=function(t){if("number"!==typeof t)throw new TypeError('Argument must be a number');return i(t)},o.allocUnsafeSlow=function(t){if("number"!==typeof t)throw new TypeError('Argument must be a number');return n.SlowBuffer(t)}},{buffer:117}],541:[function(t,e,r){"use strict";e.exports=function(t){return t<0?-1:t>0?1:0}},{}],542:[function(t,e,r){"use strict";e.exports=a;var n=t('boundary-cells'),i=t('reduce-simplicial-complex');function a(t){return i(n(t))}},{"boundary-cells":107,"reduce-simplicial-complex":521}],543:[function(t,e,r){"use strict";e.exports=p;var n=t('ndarray'),i=t('typedarray-pool'),a=t('ndarray-sort'),o=t('./lib/codegen');function s(t){for(var e=t.length,r=0,n=0;n<e;++n)r=0|Math.max(r,t[n].length);return r-1}function l(t,e){for(var r=t.length,n=i.mallocUint8(r),a=0;a<r;++a)n[a]=t[a]<e|0;return n}function c(t,e){for(var r=t.length,o=e*(e+1)/2*r|0,s=i.mallocUint32(2*o),l=0,c=0;c<r;++c)for(var u=t[c],f=(e=u.length,0);f<e;++f)for(var h=0;h<f;++h){var p=u[h],d=u[f];s[l++]=0|Math.min(p,d),s[l++]=0|Math.max(p,d)}a(n(s,[l/2|0,2]));var m=2;for(c=2;c<l;c+=2)s[c-2]===s[c]&&s[c-1]===s[c+1]||(s[m++]=s[c],s[m++]=s[c+1]);return n(s,[m/2|0,2])}function u(t,e,r,a){for(var o=t.data,s=t.shape[0],l=i.mallocDouble(s),c=0,u=0;u<s;++u){var f=o[2*u],h=o[2*u+1];if(r[f]!==r[h]){var p=e[f],d=e[h];o[2*c]=f,o[2*c+1]=h,l[c++]=(d-a)/(d-p)}}return t.shape[0]=c,n(l,[c])}function f(t,e){var r=i.mallocInt32(2*e),n=t.shape[0],a=t.data;r[0]=0;for(var o=0,s=0;s<n;++s){var l=a[2*s];if(l!==o){for(r[2*o+1]=s;++o<l;)r[2*o]=s,r[2*o+1]=s;r[2*o]=s}}for(r[2*o+1]=n;++o<e;)r[2*o]=r[2*o+1]=n;return r}function h(t){for(var e=0|t.shape[0],r=t.data,n=new Array(e),i=0;i<e;++i)n[i]=[r[2*i],r[2*i+1]];return n}function p(t,e,r,n){if(r=r||0,"undefined"===typeof n&&(n=s(t)),0===t.length||n<1)return{cells:[],vertexIds:[],vertexWeights:[]};var a=l(e,+r),p=c(t,n),d=u(p,e,a,+r),m=f(p,0|e.length),g=o(n)(t,p.data,m,a),v=h(p),y=[].slice.call(d.data,0,d.shape[0]);return i.free(a),i.free(p.data),i.free(d.data),i.free(m),{cells:g,vertexIds:v,vertexWeights:y}}},{"./lib/codegen":544,ndarray:472,"ndarray-sort":471,"typedarray-pool":601}],544:[function(t,e,r){"use strict";e.exports=i;var n=[function(){function t(t,e,r,n){for(var i=t.length,a=[],o=0;o<i;++o)t[o].length;return a}return t},function(){function t(t,e,r,n){for(var i=0|Math.min(r,n),a=0|Math.max(r,n),o=t[2*i],s=t[2*i+1];o<s;){var l=o+s>>1,c=e[2*l+1];if(c===a)return l;a<c?s=l:o=l+1}return o}function e(e,r,n,i){for(var a=e.length,o=[],s=0;s<a;++s){var l=e[s];if(2===l.length){var c=(0|i[l[0]])+(i[l[1]]<<1);if(0===c||3===c)continue;switch(c){case 0:case 3:break;case 1:o.push([t(n,r,l[0],l[1])]);break;case 2:o.push([t(n,r,l[1],l[0])])}}}return o}return e},function(){function t(t,e,r,n){for(var i=0|Math.min(r,n),a=0|Math.max(r,n),o=t[2*i],s=t[2*i+1];o<s;){var l=o+s>>1,c=e[2*l+1];if(c===a)return l;a<c?s=l:o=l+1}return o}function e(e,r,n,i){for(var a=e.length,o=[],s=0;s<a;++s){var l=e[s],c=l.length;if(3===c){if(0===(u=(0|i[l[0]])+(i[l[1]]<<1)+(i[l[2]]<<2))||7===u)continue;switch(u){case 0:case 7:break;case 1:o.push([t(n,r,l[0],l[2]),t(n,r,l[0],l[1])]);break;case 2:o.push([t(n,r,l[1],l[0]),t(n,r,l[1],l[2])]);break;case 3:o.push([t(n,r,l[0],l[2]),t(n,r,l[1],l[2])]);break;case 4:o.push([t(n,r,l[2],l[1]),t(n,r,l[2],l[0])]);break;case 5:o.push([t(n,r,l[2],l[1]),t(n,r,l[0],l[1])]);break;case 6:o.push([t(n,r,l[1],l[0]),t(n,r,l[2],l[0])])}}else if(2===c){var u;if(0===(u=(0|i[l[0]])+(i[l[1]]<<1))||3===u)continue;switch(u){case 0:case 3:break;case 1:o.push([t(n,r,l[0],l[1])]);break;case 2:o.push([t(n,r,l[1],l[0])])}}}return o}return e},function(){function t(t,e,r,n){for(var i=0|Math.min(r,n),a=0|Math.max(r,n),o=t[2*i],s=t[2*i+1];o<s;){var l=o+s>>1,c=e[2*l+1];if(c===a)return l;a<c?s=l:o=l+1}return o}function e(e,r,n,i){for(var a=e.length,o=[],s=0;s<a;++s){var l=e[s],c=l.length;if(4===c){if(0===(u=(0|i[l[0]])+(i[l[1]]<<1)+(i[l[2]]<<2)+(i[l[3]]<<3))||15===u)continue;switch(u){case 0:case 15:break;case 1:o.push([t(n,r,l[0],l[1]),t(n,r,l[0],l[2]),t(n,r,l[0],l[3])]);break;case 2:o.push([t(n,r,l[1],l[2]),t(n,r,l[1],l[0]),t(n,r,l[1],l[3])]);break;case 3:o.push([t(n,r,l[1],l[2]),t(n,r,l[0],l[2]),t(n,r,l[0],l[3])],[t(n,r,l[1],l[3]),t(n,r,l[1],l[2]),t(n,r,l[0],l[3])]);break;case 4:o.push([t(n,r,l[2],l[0]),t(n,r,l[2],l[1]),t(n,r,l[2],l[3])]);break;case 5:o.push([t(n,r,l[0],l[1]),t(n,r,l[2],l[1]),t(n,r,l[0],l[3])],[t(n,r,l[2],l[1]),t(n,r,l[2],l[3]),t(n,r,l[0],l[3])]);break;case 6:o.push([t(n,r,l[2],l[0]),t(n,r,l[1],l[0]),t(n,r,l[1],l[3])],[t(n,r,l[2],l[3]),t(n,r,l[2],l[0]),t(n,r,l[1],l[3])]);break;case 7:o.push([t(n,r,l[0],l[3]),t(n,r,l[1],l[3]),t(n,r,l[2],l[3])]);break;case 8:o.push([t(n,r,l[3],l[1]),t(n,r,l[3],l[0]),t(n,r,l[3],l[2])]);break;case 9:o.push([t(n,r,l[3],l[1]),t(n,r,l[0],l[1]),t(n,r,l[0],l[2])],[t(n,r,l[3],l[2]),t(n,r,l[3],l[1]),t(n,r,l[0],l[2])]);break;case 10:o.push([t(n,r,l[1],l[0]),t(n,r,l[3],l[0]),t(n,r,l[1],l[2])],[t(n,r,l[3],l[0]),t(n,r,l[3],l[2]),t(n,r,l[1],l[2])]);break;case 11:o.push([t(n,r,l[1],l[2]),t(n,r,l[0],l[2]),t(n,r,l[3],l[2])]);break;case 12:o.push([t(n,r,l[3],l[0]),t(n,r,l[2],l[0]),t(n,r,l[2],l[1])],[t(n,r,l[3],l[1]),t(n,r,l[3],l[0]),t(n,r,l[2],l[1])]);break;case 13:o.push([t(n,r,l[0],l[1]),t(n,r,l[2],l[1]),t(n,r,l[3],l[1])]);break;case 14:o.push([t(n,r,l[2],l[0]),t(n,r,l[1],l[0]),t(n,r,l[3],l[0])])}}else if(3===c){if(0===(u=(0|i[l[0]])+(i[l[1]]<<1)+(i[l[2]]<<2))||7===u)continue;switch(u){case 0:case 7:break;case 1:o.push([t(n,r,l[0],l[2]),t(n,r,l[0],l[1])]);break;case 2:o.push([t(n,r,l[1],l[0]),t(n,r,l[1],l[2])]);break;case 3:o.push([t(n,r,l[0],l[2]),t(n,r,l[1],l[2])]);break;case 4:o.push([t(n,r,l[2],l[1]),t(n,r,l[2],l[0])]);break;case 5:o.push([t(n,r,l[2],l[1]),t(n,r,l[0],l[1])]);break;case 6:o.push([t(n,r,l[1],l[0]),t(n,r,l[2],l[0])])}}else if(2===c){var u;if(0===(u=(0|i[l[0]])+(i[l[1]]<<1))||3===u)continue;switch(u){case 0:case 3:break;case 1:o.push([t(n,r,l[0],l[1])]);break;case 2:o.push([t(n,r,l[1],l[0])])}}}return o}return e}];function i(t){return n[t]()}},{}],545:[function(t,e,r){"use strict";var n=t('bit-twiddle'),i=t('union-find');function a(t){for(var e=0,r=Math.max,n=0,i=t.length;n<i;++n)e=r(e,t[n].length);return e-1}function o(t){for(var e=-1,r=Math.max,n=0,i=t.length;n<i;++n)for(var a=t[n],o=0,s=a.length;o<s;++o)e=r(e,a[o]);return e+1}function s(t){for(var e=new Array(t.length),r=0,n=t.length;r<n;++r)e[r]=t[r].slice(0);return e}function l(t,e){var r=t.length,n=t.length-e.length,i=Math.min;if(n)return n;switch(r){case 0:return 0;case 1:return t[0]-e[0];case 2:return(s=t[0]+t[1]-e[0]-e[1])||i(t[0],t[1])-i(e[0],e[1]);case 3:var a=t[0]+t[1],o=e[0]+e[1];if(s=a+t[2]-(o+e[2]))return s;var s,l=i(t[0],t[1]),c=i(e[0],e[1]);return(s=i(l,t[2])-i(c,e[2]))||i(l+t[2],a)-i(c+e[2],o);default:var u=t.slice(0);u.sort();var f=e.slice(0);f.sort();for(var h=0;h<r;++h)if(n=u[h]-f[h])return n;return 0}}function c(t,e){return l(t[0],e[0])}function u(t,e){if(e){for(var r=t.length,n=new Array(r),i=0;i<r;++i)n[i]=[t[i],e[i]];for(n.sort(c),i=0;i<r;++i)t[i]=n[i][0],e[i]=n[i][1];return t}return t.sort(l),t}function f(t){if(0===t.length)return[];for(var e=1,r=t.length,n=1;n<r;++n){var i=t[n];if(l(i,t[n-1])){if(n===e){e++;continue}t[e++]=i}}return t.length=e,t}function h(t,e){for(var r=0,n=t.length-1,i=-1;r<=n;){var a=r+n>>1,o=l(t[a],e);o<=0?(0===o&&(i=a),r=a+1):o>0&&(n=a-1)}return i}function p(t,e){for(var r=new Array(t.length),i=0,a=r.length;i<a;++i)r[i]=[];for(var o=[],s=(i=0,e.length);i<s;++i)for(var c=e[i],u=c.length,f=1,p=1<<u;f<p;++f){o.length=n.popCount(f);for(var d=0,m=0;m<u;++m)f&1<<m&&(o[d++]=c[m]);var g=h(t,o);if(!(g<0))for(;r[g++].push(i),!(g>=t.length||0!==l(t[g],o)););}return r}function d(t,e){if(!e)return p(f(g(t,0)),t,0);for(var r=new Array(e),n=0;n<e;++n)r[n]=[];n=0;for(var i=t.length;n<i;++n)for(var a=t[n],o=0,s=a.length;o<s;++o)r[a[o]].push(n);return r}function m(t){for(var e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0|i.length,o=1,s=1<<a;o<s;++o){for(var l=[],c=0;c<a;++c)o>>>c&1&&l.push(i[c]);e.push(l)}return u(e)}function g(t,e){if(e<0)return[];for(var r=[],i=(1<<e+1)-1,a=0;a<t.length;++a)for(var o=t[a],s=i;s<1<<o.length;s=n.nextCombination(s)){for(var l=new Array(e+1),c=0,f=0;f<o.length;++f)s&1<<f&&(l[c++]=o[f]);r.push(l)}return u(r)}function v(t){for(var e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;++a){for(var s=new Array(i.length-1),l=0,c=0;l<o;++l)l!==a&&(s[c++]=i[l]);e.push(s)}return u(e)}function y(t,e){for(var r=new i(e),n=0;n<t.length;++n)for(var a=t[n],o=0;o<a.length;++o)for(var s=o+1;s<a.length;++s)r.link(a[o],a[s]);var l=[],c=r.ranks;for(n=0;n<c.length;++n)c[n]=-1;for(n=0;n<t.length;++n){var u=r.find(t[n][0]);c[u]<0?(c[u]=l.length,l.push([t[n].slice(0)])):l[c[u]].push(t[n].slice(0))}return l}function x(t){for(var e=f(u(g(t,0))),r=new i(e.length),n=0;n<t.length;++n)for(var a=t[n],o=0;o<a.length;++o)for(var s=h(e,[a[o]]),l=o+1;l<a.length;++l)r.link(s,h(e,[a[l]]));var c=[],p=r.ranks;for(n=0;n<p.length;++n)p[n]=-1;for(n=0;n<t.length;++n){var d=r.find(h(e,[t[n][0]]));p[d]<0?(p[d]=c.length,c.push([t[n].slice(0)])):c[p[d]].push(t[n].slice(0))}return c}function b(t,e){return e?y(t,e):x(t)}r.dimension=a,r.countVertices=o,r.cloneCells=s,r.compareCells=l,r.normalize=u,r.unique=f,r.findCell=h,r.incidence=p,r.dual=d,r.explode=m,r.skeleton=g,r.boundary=v,r.connectedComponents=b},{"bit-twiddle":104,"union-find":602}],546:[function(t,e,r){arguments[4][104][0].apply(r,arguments)},{dup:104}],547:[function(t,e,r){arguments[4][545][0].apply(r,arguments)},{"bit-twiddle":546,dup:545,"union-find":548}],548:[function(t,e,r){"use strict";function n(t){this.roots=new Array(t),this.ranks=new Array(t);for(var e=0;e<t;++e)this.roots[e]=e,this.ranks[e]=0}e.exports=n,n.prototype.length=function(){return this.roots.length},n.prototype.makeSet=function(){var t=this.roots.length;return this.roots.push(t),this.ranks.push(0),t},n.prototype.find=function(t){for(var e=this.roots;e[t]!==t;){var r=e[t];e[t]=e[r],t=r}return t},n.prototype.link=function(t,e){var r=this.find(t),n=this.find(e);if(r!==n){var i=this.ranks,a=this.roots,o=i[r],s=i[n];o<s?a[r]=n:s<o?a[n]=r:(a[n]=r,++i[r])}}},{}],549:[function(t,e,r){"use strict";e.exports=o;var n=t('robust-orientation'),i=t('simplicial-complex');function a(t,e,r){return Math.abs(n(t,e,r))/Math.sqrt(Math.pow(e[0]-r[0],2)+Math.pow(e[1]-r[1],2))}function o(t,e,r){for(var n=e.length,o=t.length,s=new Array(n),l=new Array(n),c=new Array(n),u=new Array(n),f=0;f<n;++f)s[f]=l[f]=-1,c[f]=1/0,u[f]=!1;for(f=0;f<o;++f){var h=t[f];if(2!==h.length)throw new Error('Input must be a graph');var p=h[1],d=h[0];-1!==l[d]?l[d]=-2:l[d]=p,-1!==s[p]?s[p]=-2:s[p]=d}function m(t){if(u[t])return 1/0;var r=s[t],n=l[t];return r<0||n<0?1/0:a(e[t],e[r],e[n])}function g(t,e){var r=k[t],n=k[e];k[t]=n,k[e]=r,M[r]=e,M[n]=t}function v(t){return c[k[t]]}function y(t){return 1&t?t-1>>1:(t>>1)-1}function x(t){for(var e=v(t);;){var r=e,n=2*t+1,i=2*(t+1),a=t;if(n<A){var o=v(n);o<r&&(a=n,r=o)}if(i<A&&v(i)<r&&(a=i),a===t)return t;g(t,a),t=a}}function b(t){for(var e=v(t);t>0;){var r=y(t);if(!(r>=0&&e<v(r)))return t;g(t,r),t=r}}function _(){if(A>0){var t=k[0];return g(0,A-1),A-=1,x(0),t}return-1}function w(t,e){var r=k[t];return c[r]===e?t:(c[r]=-1/0,b(t),_(),c[r]=e,b((A+=1)-1))}function T(t){if(!u[t]){u[t]=!0;var e=s[t],r=l[t];s[r]>=0&&(s[r]=e),l[e]>=0&&(l[e]=r),M[e]>=0&&w(M[e],m(e)),M[r]>=0&&w(M[r],m(r))}}var k=[],M=new Array(n);for(f=0;f<n;++f)(c[f]=m(f))<1/0?(M[f]=k.length,k.push(f)):M[f]=-1;var A=k.length;for(f=A>>1;f>=0;--f)x(f);for(;;){var S=_();if(S<0||c[S]>r)break;T(S)}var E=[];for(f=0;f<n;++f)u[f]||(M[f]=E.length,E.push(e[f].slice()));function L(t,e){if(t[e]<0)return e;var r=e,n=e;do{var i=t[n];if(!u[n]||i<0||i===n)break;if(i=t[n=i],!u[n]||i<0||i===n)break;n=i,r=t[r]}while(r!==n);for(var a=e;a!==n;a=t[a])t[a]=n;return n}E.length;var C=[];return t.forEach((function(t){var e=L(s,t[0]),r=L(l,t[1]);if(e>=0&&r>=0&&e!==r){var n=M[e],i=M[r];n!==i&&C.push([n,i])}})),i.unique(i.normalize(C)),{positions:E,edges:C}}},{"robust-orientation":534,"simplicial-complex":547}],550:[function(t,e,r){"use strict";e.exports=a;var n=t('robust-orientation');function i(t,e){var r,i,a,o;if(e[0][0]<e[1][0])r=e[0],i=e[1];else{if(!(e[0][0]>e[1][0])){var s=Math.min(t[0][1],t[1][1]),l=Math.max(t[0][1],t[1][1]),c=Math.min(e[0][1],e[1][1]),u=Math.max(e[0][1],e[1][1]);return l<c?l-c:s>u?s-u:l-u}r=e[1],i=e[0]}t[0][1]<t[1][1]?(a=t[0],o=t[1]):(a=t[1],o=t[0]);var f=n(i,r,a);return f||(f=n(i,r,o))||o-i}function a(t,e){var r,a,o,s;if(e[0][0]<e[1][0])r=e[0],a=e[1];else{if(!(e[0][0]>e[1][0]))return i(e,t);r=e[1],a=e[0]}if(t[0][0]<t[1][0])o=t[0],s=t[1];else{if(!(t[0][0]>t[1][0]))return-i(t,e);o=t[1],s=t[0]}var l=n(r,a,s),c=n(r,a,o);if(l<0){if(c<=0)return l}else if(l>0){if(c>=0)return l}else if(c)return c;if(l=n(s,o,a),c=n(s,o,r),l<0){if(c<=0)return l}else if(l>0){if(c>=0)return l}else if(c)return c;return a[0]-s[0]}},{"robust-orientation":534}],551:[function(t,e,r){"use strict";e.exports=h;var n=t('binary-search-bounds'),i=t('functional-red-black-tree'),a=t('robust-orientation'),o=t('./lib/order-segments');function s(t,e,r){this.slabs=t,this.coordinates=e,this.horizontal=r}function l(t,e){return t.y-e}function c(t,e){for(var r=null;t;){var n,i,o=t.key;o[0][0]<o[1][0]?(n=o[0],i=o[1]):(n=o[1],i=o[0]);var s=a(n,i,e);if(s<0)t=t.left;else if(s>0)if(e[0]!==o[1][0])r=t,t=t.right;else{if(l=c(t.right,e))return l;t=t.left}else{if(e[0]!==o[1][0])return t;var l;if(l=c(t.right,e))return l;t=t.left}}return r}function u(t,e,r,n){this.y=t,this.index=e,this.start=r,this.closed=n}function f(t,e,r,n){this.x=t,this.segment=e,this.create=r,this.index=n}function h(t){for(var e=t.length,r=2*e,n=new Array(r),a=0;a<e;++a){var l=t[a],c=l[0][0]<l[1][0];n[2*a]=new f(l[0][0],l,c,a),n[2*a+1]=new f(l[1][0],l,!c,a)}n.sort((function(t,e){var r=t.x-e.x;return r||(r=t.create-e.create)||Math.min(t.segment[0][1],t.segment[1][1])-Math.min(e.segment[0][1],e.segment[1][1])}));var h=i(o),p=[],d=[],m=[];for(a=0;a<r;){for(var g=n[a].x,v=[];a<r;){var y=n[a];if(y.x!==g)break;a+=1,y.segment[0][0]===y.x&&y.segment[1][0]===y.x?y.create&&(y.segment[0][1]<y.segment[1][1]?(v.push(new u(y.segment[0][1],y.index,!0,!0)),v.push(new u(y.segment[1][1],y.index,!1,!1))):(v.push(new u(y.segment[1][1],y.index,!0,!1)),v.push(new u(y.segment[0][1],y.index,!1,!0)))):h=y.create?h.insert(y.segment,y.index):h.remove(y.segment)}p.push(h.root),d.push(g),m.push(v)}return new s(p,d,m)}s.prototype.castUp=function(t){var e=n.le(this.coordinates,t[0]);if(e<0)return-1;this.slabs[e];var r=c(this.slabs[e],t),i=-1;if(r&&(i=r.value),this.coordinates[e]===t[0]){var s=null;if(r&&(s=r.key),e>0){var u=c(this.slabs[e-1],t);u&&(s?o(u.key,s)>0&&(s=u.key,i=u.value):(i=u.value,s=u.key))}var f=this.horizontal[e];if(f.length>0){var h=n.ge(f,t[1],l);if(h<f.length){var p=f[h];if(t[1]===p.y){if(p.closed)return p.index;for(;h<f.length-1&&f[h+1].y===t[1];)if((p=f[h+=1]).closed)return p.index;if(p.y===t[1]&&!p.start){if((h+=1)>=f.length)return i;p=f[h]}}if(p.start)if(s){var d=a(s[0],s[1],[t[0],p.y]);s[0][0]>s[1][0]&&(d=-d),d>0&&(i=p.index)}else i=p.index;else p.y!==t[1]&&(i=p.index)}}}return i}},{"./lib/order-segments":550,"binary-search-bounds":103,"functional-red-black-tree":251,"robust-orientation":534}],552:[function(t,e,r){"use strict";var n=t('robust-dot-product'),i=t('robust-sum');function a(t,e){var r=i(n(t,e),[e[e.length-1]]);return r[r.length-1]}function o(t,e,r,n){var i=-e/(n-e);i<0?i=0:i>1&&(i=1);for(var a=1-i,o=t.length,s=new Array(o),l=0;l<o;++l)s[l]=i*t[l]+a*r[l];return s}function s(t,e){for(var r=[],n=[],i=a(t[t.length-1],e),s=t[t.length-1],l=t[0],c=0;c<t.length;++c,s=l){var u=a(l=t[c],e);if(i<0&&u>0||i>0&&u<0){var f=o(s,u,l,i);r.push(f),n.push(f.slice())}u<0?n.push(l.slice()):u>0?r.push(l.slice()):(r.push(l.slice()),n.push(l.slice())),i=u}return{positive:r,negative:n}}function l(t,e){for(var r=[],n=a(t[t.length-1],e),i=t[t.length-1],s=t[0],l=0;l<t.length;++l,i=s){var c=a(s=t[l],e);(n<0&&c>0||n>0&&c<0)&&r.push(o(i,c,s,n)),c>=0&&r.push(s.slice()),n=c}return r}function c(t,e){for(var r=[],n=a(t[t.length-1],e),i=t[t.length-1],s=t[0],l=0;l<t.length;++l,i=s){var c=a(s=t[l],e);(n<0&&c>0||n>0&&c<0)&&r.push(o(i,c,s,n)),c<=0&&r.push(s.slice()),n=c}return r}e.exports=s,e.exports.positive=l,e.exports.negative=c},{"robust-dot-product":531,"robust-sum":539}],553:[function(e,r,n){!function(){"use strict";var e={not_string:/[^s]/,not_bool:/[^t]/,not_type:/[^T]/,not_primitive:/[^v]/,number:/[diefg]/,numeric_arg:/[bcdiefguxX]/,json:/[j]/,not_json:/[^j]/,text:/^[^\x25]+/,modulo:/^\x25{2}/,placeholder:/^\x25(?:([1-9]\d*)\$|\(([^)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-gijostTuvxX])/,key:/^([a-z_][a-z_\d]*)/i,key_access:/^\.([a-z_][a-z_\d]*)/i,index_access:/^\[(\d+)\]/,sign:/^[+-]/};function r(t){return a(s(t),arguments)}function i(t,e){return r.apply(null,[t].concat(e||[]))}function a(t,n){var i,a,o,s,l,c,u,f,h,p=1,d=t.length,m='';for(a=0;a<d;a++)if("string"===typeof t[a])m+=t[a];else if("object"===typeof t[a]){if((s=t[a]).keys)for(i=n[p],o=0;o<s.keys.length;o++){if(void 0==i)throw new Error(r('[sprintf] Cannot access property '%s' of undefined value "%s"',s.keys[o],s.keys[o-1]));i=i[s.keys[o]]}else i=s.param_no?n[s.param_no]:n[p++];if(e.not_type.test(s.type)&&e.not_primitive.test(s.type)&&i instanceof Function&&(i=i()),e.numeric_arg.test(s.type)&&"number"!==typeof i&&isNaN(i))throw new TypeError(r('[sprintf] expecting number but found %T',i));switch(e.number.test(s.type)&&(f=i>=0),s.type){case"b":i=parseInt(i,10).toString(2);break;case"c":i=String.fromCharCode(parseInt(i,10));break;case"d":case"i":i=parseInt(i,10);break;case"j":i=JSON.stringify(i,null,s.width?parseInt(s.width):0);break;case"e":i=s.precision?parseFloat(i).toExponential(s.precision):parseFloat(i).toExponential();break;case"f":i=s.precision?parseFloat(i).toFixed(s.precision):parseFloat(i);break;case"g":i=s.precision?String(Number(i.toPrecision(s.precision))):parseFloat(i);break;case"o":i=(parseInt(i,10)>>>0).toString(8);break;case"s":i=String(i),i=s.precision?i.substring(0,s.precision):i;break;case"t":i=String(!!i),i=s.precision?i.substring(0,s.precision):i;break;case"T":i=Object.prototype.toString.call(i).slice(8,-1).toLowerCase(),i=s.precision?i.substring(0,s.precision):i;break;case"u":i=parseInt(i,10)>>>0;break;case"v":i=i.valueOf(),i=s.precision?i.substring(0,s.precision):i;break;case"x":i=(parseInt(i,10)>>>0).toString(16);break;case"X":i=(parseInt(i,10)>>>0).toString(16).toUpperCase()}e.json.test(s.type)?m+=i:(!e.number.test(s.type)||f&&!s.sign?h="":(h=f?"+":"-",i=i.toString().replace(e.sign,'')),c=s.pad_char?"0"===s.pad_char?"0":s.pad_char.charAt(1):" ",u=s.width-(h+i).length,l=s.width&&u>0?c.repeat(u):"",m+=s.align?h+i+l:"0"===c?h+l+i:l+h+i)}return m}var o=Object.create(null);function s(t){if(o[t])return o[t];for(var r,n=t,i=[],a=0;n;){if(null!==(r=e.text.exec(n)))i.push(r[0]);else if(null!==(r=e.modulo.exec(n)))i.push('%');else{if(null===(r=e.placeholder.exec(n)))throw new SyntaxError('[sprintf] unexpected placeholder');if(r[2]){a|=1;var s=[],l=r[2],c=[];if(null===(c=e.key.exec(l)))throw new SyntaxError('[sprintf] failed to parse named argument key');for(s.push(c[1]);""!==(l=l.substring(c[0].length));)if(null!==(c=e.key_access.exec(l)))s.push(c[1]);else{if(null===(c=e.index_access.exec(l)))throw new SyntaxError('[sprintf] failed to parse named argument key');s.push(c[1])}r[2]=s}else a|=2;if(3===a)throw new Error('[sprintf] mixing positional and named placeholders is not (yet) supported');i.push({placeholder:r[0],param_no:r[1],keys:r[2],sign:r[3],pad_char:r[4],align:r[5],width:r[6],precision:r[7],type:r[8]})}n=n.substring(r[0].length)}return o[t]=i}"undefined"!==typeof n&&(n.sprintf=r,n.vsprintf=i),"undefined"!==typeof window&&(window.sprintf=r,window.vsprintf=i,"function"===typeof t&&t.amd&&t((function(){return{sprintf:r,vsprintf:i}})))}()},{}],554:[function(t,e,r){e.exports=i;var n=t('events').EventEmitter;function i(){n.call(this)}t('inherits')(i,n),i.Readable=t('readable-stream/lib/_stream_readable.js'),i.Writable=t('readable-stream/lib/_stream_writable.js'),i.Duplex=t('readable-stream/lib/_stream_duplex.js'),i.Transform=t('readable-stream/lib/_stream_transform.js'),i.PassThrough=t('readable-stream/lib/_stream_passthrough.js'),i.finished=t('readable-stream/lib/internal/streams/end-of-stream.js'),i.pipeline=t('readable-stream/lib/internal/streams/pipeline.js'),i.Stream=i,i.prototype.pipe=function(t,e){var r=this;function i(e){t.writable&&!1===t.write(e)&&r.pause&&r.pause()}function a()[r.readable&&r.resume&&r.resume()]r.on('data',i),t.on('drain',a),t._isStdio||e&&!1===e.end||(r.on('end',s),r.on('close',l));var o=!1;function s(){o||(o=!0,t.end())}function l(){o||(o=!0,"function"===typeof t.destroy&&t.destroy())}function c(t){if(u(),0===n.listenerCount(this,'error'))throw t}function u(){r.removeListener('data',i),t.removeListener('drain',a),r.removeListener('end',s),r.removeListener('close',l),r.removeListener('error',c),t.removeListener('error',c),r.removeListener('end',u),r.removeListener('close',u),t.removeListener('close',u)}return r.on('error',c),t.on('error',c),r.on('end',u),r.on('close',u),t.on('close',u),t.emit('pipe',r),t}},{events:116,inherits:439,"readable-stream/lib/_stream_duplex.js":556,"readable-stream/lib/_stream_passthrough.js":557,"readable-stream/lib/_stream_readable.js":558,"readable-stream/lib/_stream_transform.js":559,"readable-stream/lib/_stream_writable.js":560,"readable-stream/lib/internal/streams/end-of-stream.js":564,"readable-stream/lib/internal/streams/pipeline.js":566}],555:[function(t,e,r){"use strict";function n(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}var i={};function a(t,e,r){function a(t,r,n){return"string"===typeof e?e:e(t,r,n)}r||(r=Error);var o=function(t){function e(e,r,n){return t.call(this,a(e,r,n))||this}return n(e,t),e}(r);o.prototype.name=r.name,o.prototype.code=t,i[t]=o}function o(t,e){if(Array.isArray(t)){var r=t.length;return t=t.map((function(t){return String(t)})),r>2?"one of '.concat(e,' ").concat(t.slice(0,r-1).join(', '),', or ')+t[r-1]:2===r?"one of '.concat(e,' ").concat(t[0],' or ').concat(t[1]):"of '.concat(e,' ").concat(t[0])}return'of '.concat(e,' ').concat(String(t))}function s(t,e,r){return t.substr(!r||r<0?0:+r,e.length)===e}function l(t,e,r){return(void 0===r||r>t.length)&&(r=t.length),t.substring(r-e.length,r)===e}function c(t,e,r){return"number"!==typeof r&&(r=0),!(r+e.length>t.length)&&-1!==t.indexOf(e,r)}a('ERR_INVALID_OPT_VALUE',(function(t,e){return'The value ''+e+'' is invalid for option "'+t+'"'}),TypeError),a('ERR_INVALID_ARG_TYPE',(function(t,e,r){var n,i;if("string"===typeof e&&s(e,'not ')?(n='must not be',e=e.replace(/^not /,'')):n='must be',l(t,' argument'))i='The '.concat(t,' ').concat(n,' ').concat(o(e,'type'));else{var a=c(t,'.')?"property":"argument";i='The ''.concat(t,'' ').concat(a,' ').concat(n,' ').concat(o(e,'type'))}return i+='. Received type '.concat(typeof r)}),TypeError),a('ERR_STREAM_PUSH_AFTER_EOF','stream.push() after EOF'),a('ERR_METHOD_NOT_IMPLEMENTED',(function(t){return"The '+t+' method is not implemented"})),a('ERR_STREAM_PREMATURE_CLOSE','Premature close'),a('ERR_STREAM_DESTROYED',(function(t){return"Cannot call '+t+' after a stream was destroyed"})),a('ERR_MULTIPLE_CALLBACK','Callback called multiple times'),a('ERR_STREAM_CANNOT_PIPE','Cannot pipe, not readable'),a('ERR_STREAM_WRITE_AFTER_END','write after end'),a('ERR_STREAM_NULL_VALUES','May not write null values to stream',TypeError),a('ERR_UNKNOWN_ENCODING',(function(t){return"Unknown encoding: "+t}),TypeError),a('ERR_STREAM_UNSHIFT_AFTER_END_EVENT','stream.unshift() after end event'),e.exports.codes=i},{}],556:[function(t,e,r){(function(r){(function(){"use strict";var n=Object.keys||function(t){var e=[];for(var r in t)e.push(r);return e};e.exports=c;var i=t('./_stream_readable'),a=t('./_stream_writable');t('inherits')(c,i);for(var o=n(a.prototype),s=0;s<o.length;s++){var l=o[s];c.prototype[l]||(c.prototype[l]=a.prototype[l])}function c(t){if(!(this instanceof c))return new c(t);i.call(this,t),a.call(this,t),this.allowHalfOpen=!0,t&&(!1===t.readable&&(this.readable=!1),!1===t.writable&&(this.writable=!1),!1===t.allowHalfOpen&&(this.allowHalfOpen=!1,this.once('end',u)))}function u(){this._writableState.ended||r.nextTick(f,this)}function f(t)[t.end()]Object.defineProperty(c.prototype,'writableHighWaterMark',{enumerable:!1,get:function(){return this._writableState.highWaterMark}}),Object.defineProperty(c.prototype,'writableBuffer',{enumerable:!1,get:function(){return this._writableState&&this._writableState.getBuffer()}}),Object.defineProperty(c.prototype,'writableLength',{enumerable:!1,get:function(){return this._writableState.length}}),Object.defineProperty(c.prototype,'destroyed',{enumerable:!1,get:function(){return void 0!==this._readableState&&void 0!==this._writableState&&this._readableState.destroyed&&this._writableState.destroyed},set:function(t){void 0!==this._readableState&&void 0!==this._writableState&&(this._readableState.destroyed=t,this._writableState.destroyed=t)}})}).call(this)}).call(this,t('_process'))},{"./_stream_readable":558,"./_stream_writable":560,_process:514,inherits:439}],557:[function(t,e,r){"use strict";e.exports=i;var n=t('./_stream_transform');function i(t){if(!(this instanceof i))return new i(t);n.call(this,t)}t('inherits')(i,n),i.prototype._transform=function(t,e,r){r(null,t)}},{"./_stream_transform":559,inherits:439}],558:[function(t,e,n){(function(r,n){(function(){"use strict";var i;e.exports=E,E.ReadableState=S,t('events').EventEmitter;var a=function(t,e){return t.listeners(e).length},o=t('./internal/streams/stream'),s=t('buffer').Buffer,l=n.Uint8Array||function(){};function c(t){return s.from(t)}function u(t){return s.isBuffer(t)||t instanceof l}var f,h=t('util');f=h&&h.debuglog?h.debuglog('stream'):function(){};var p,d,m,g=t('./internal/streams/buffer_list'),v=t('./internal/streams/destroy'),y=t('./internal/streams/state').getHighWaterMark,x=t('../errors').codes,b=x.ERR_INVALID_ARG_TYPE,_=x.ERR_STREAM_PUSH_AFTER_EOF,w=x.ERR_METHOD_NOT_IMPLEMENTED,T=x.ERR_STREAM_UNSHIFT_AFTER_END_EVENT;t('inherits')(E,o);var k=v.errorOrDestroy,M=["error",'close','destroy','pause',"resume"];function A(t,e,r){if("function"===typeof t.prependListener)return t.prependListener(e,r);t._events&&t._events[e]?Array.isArray(t._events[e])?t._events[e].unshift(r):t._events[e]=[r,t._events[e]]:t.on(e,r)}function S(e,r,n){i=i||t('./_stream_duplex'),e=e||{},"boolean"!==typeof n&&(n=r instanceof i),this.objectMode=!!e.objectMode,n&&(this.objectMode=this.objectMode||!!e.readableObjectMode),this.highWaterMark=y(this,e,'readableHighWaterMark',n),this.buffer=new g,this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.paused=!0,this.emitClose=!1!==e.emitClose,this.autoDestroy=!!e.autoDestroy,this.destroyed=!1,this.defaultEncoding=e.defaultEncoding||"utf8",this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,e.encoding&&(p||(p=t('string_decoder/').StringDecoder),this.decoder=new p(e.encoding),this.encoding=e.encoding)}function E(e){if(i=i||t('./_stream_duplex'),!(this instanceof E))return new E(e);var r=this instanceof i;this._readableState=new S(e,this,r),this.readable=!0,e&&("function"===typeof e.read&&(this._read=e.read),"function"===typeof e.destroy&&(this._destroy=e.destroy)),o.call(this)}function L(t,e,r,n,i){f('readableAddChunk',e);var a,o=t._readableState;if(null===e)o.reading=!1,D(t,o);else if(i||(a=P(o,e)),a)k(t,a);else if(o.objectMode||e&&e.length>0)if("string"===typeof e||o.objectMode||Object.getPrototypeOf(e)===s.prototype||(e=c(e)),n)o.endEmitted?k(t,new T):C(t,o,e,!0);else if(o.ended)k(t,new _);else{if(o.destroyed)return!1;o.reading=!1,o.decoder&&!r?(e=o.decoder.write(e),o.objectMode||0!==e.length?C(t,o,e,!1):B(t,o)):C(t,o,e,!1)}else n||(o.reading=!1,B(t,o));return!o.ended&&(o.length<o.highWaterMark||0===o.length)}function C(t,e,r,n){e.flowing&&0===e.length&&!e.sync?(e.awaitDrain=0,t.emit('data',r)):(e.length+=e.objectMode?1:r.length,n?e.buffer.unshift(r):e.buffer.push(r),e.needReadable&&R(t)),B(t,e)}function P(t,e){var r;return u(e)||"string"===typeof e||void 0===e||t.objectMode||(r=new b('chunk',["string",'Buffer',"Uint8Array"],e)),r}Object.defineProperty(E.prototype,'destroyed',{enumerable:!1,get:function(){return void 0!==this._readableState&&this._readableState.destroyed},set:function(t)[this._readableState&&(this._readableState.destroyed=t)]}),E.prototype.destroy=v.destroy,E.prototype._undestroy=v.undestroy,E.prototype._destroy=function(t,e)[e(t)],E.prototype.push=function(t,e){var r,n=this._readableState;return n.objectMode?r=!0:"string"===typeof t&&((e=e||n.defaultEncoding)!==n.encoding&&(t=s.from(t,e),e=''),r=!0),L(this,t,e,!1,r)},E.prototype.unshift=function(t){return L(this,t,null,!0,!1)},E.prototype.isPaused=function(){return!1===this._readableState.flowing},E.prototype.setEncoding=function(e){p||(p=t('string_decoder/').StringDecoder);var r=new p(e);this._readableState.decoder=r,this._readableState.encoding=this._readableState.decoder.encoding;for(var n=this._readableState.buffer.head,i='';null!==n;)i+=r.write(n.data),n=n.next;return this._readableState.buffer.clear(),""!==i&&this._readableState.buffer.push(i),this._readableState.length=i.length,this};var I=1073741824;function z(t){return t>=I?t=I:(t--,t|=t>>>1,t|=t>>>2,t|=t>>>4,t|=t>>>8,t|=t>>>16,t++),t}function O(t,e){return t<=0||0===e.length&&e.ended?0:e.objectMode?1:t!==t?e.flowing&&e.length?e.buffer.head.data.length:e.length:(t>e.highWaterMark&&(e.highWaterMark=z(t)),t<=e.length?t:e.ended?e.length:(e.needReadable=!0,0))}function D(t,e){if(f('onEofChunk'),!e.ended){if(e.decoder){var r=e.decoder.end();r&&r.length&&(e.buffer.push(r),e.length+=e.objectMode?1:r.length)}e.ended=!0,e.sync?R(t):(e.needReadable=!1,e.emittedReadable||(e.emittedReadable=!0,F(t)))}}function R(t){var e=t._readableState;f('emitReadable',e.needReadable,e.emittedReadable),e.needReadable=!1,e.emittedReadable||(f('emitReadable',e.flowing),e.emittedReadable=!0,r.nextTick(F,t))}function F(t){var e=t._readableState;f('emitReadable_',e.destroyed,e.length,e.ended),e.destroyed||!e.length&&!e.ended||(t.emit('readable'),e.emittedReadable=!1),e.needReadable=!e.flowing&&!e.ended&&e.length<=e.highWaterMark,G(t)}function B(t,e){e.readingMore||(e.readingMore=!0,r.nextTick(N,t,e))}function N(t,e){for(;!e.reading&&!e.ended&&(e.length<e.highWaterMark||e.flowing&&0===e.length);){var r=e.length;if(f('maybeReadMore read 0'),t.read(0),r===e.length)break}e.readingMore=!1}function j(t){return function(){var e=t._readableState;f('pipeOnDrain',e.awaitDrain),e.awaitDrain&&e.awaitDrain--,0===e.awaitDrain&&a(t,'data')&&(e.flowing=!0,G(t))}}function U(t){var e=t._readableState;e.readableListening=t.listenerCount('readable')>0,e.resumeScheduled&&!e.paused?e.flowing=!0:t.listenerCount('data')>0&&t.resume()}function V(t){f('readable nexttick read 0'),t.read(0)}function H(t,e){e.resumeScheduled||(e.resumeScheduled=!0,r.nextTick(q,t,e))}function q(t,e){f('resume',e.reading),e.reading||t.read(0),e.resumeScheduled=!1,t.emit('resume'),G(t),e.flowing&&!e.reading&&t.read(0)}function G(t){var e=t._readableState;for(f('flow',e.flowing);e.flowing&&null!==t.read(););}function Y(t,e){return 0===e.length?null:(e.objectMode?r=e.buffer.shift():!t||t>=e.length?(r=e.decoder?e.buffer.join(''):1===e.buffer.length?e.buffer.first():e.buffer.concat(e.length),e.buffer.clear()):r=e.buffer.consume(t,e.decoder),r);var r}function W(t){var e=t._readableState;f('endReadable',e.endEmitted),e.endEmitted||(e.ended=!0,r.nextTick(X,e,t))}function X(t,e){if(f('endReadableNT',t.endEmitted,t.length),!t.endEmitted&&0===t.length&&(t.endEmitted=!0,e.readable=!1,e.emit('end'),t.autoDestroy)){var r=e._writableState;(!r||r.autoDestroy&&r.finished)&&e.destroy()}}function Z(t,e){for(var r=0,n=t.length;r<n;r++)if(t[r]===e)return r;return-1}E.prototype.read=function(t){f('read',t),t=parseInt(t,10);var e=this._readableState,r=t;if(0!==t&&(e.emittedReadable=!1),0===t&&e.needReadable&&((0!==e.highWaterMark?e.length>=e.highWaterMark:e.length>0)||e.ended))return f('read: emitReadable',e.length,e.ended),0===e.length&&e.ended?W(this):R(this),null;if(0===(t=O(t,e))&&e.ended)return 0===e.length&&W(this),null;var n,i=e.needReadable;return f('need readable',i),(0===e.length||e.length-t<e.highWaterMark)&&f('length less than watermark',i=!0),e.ended||e.reading?f('reading or ended',i=!1):i&&(f('do read'),e.reading=!0,e.sync=!0,0===e.length&&(e.needReadable=!0),this._read(e.highWaterMark),e.sync=!1,e.reading||(t=O(r,e))),null===(n=t>0?Y(t,e):null)?(e.needReadable=e.length<=e.highWaterMark,t=0):(e.length-=t,e.awaitDrain=0),0===e.length&&(e.ended||(e.needReadable=!0),r!==t&&e.ended&&W(this)),null!==n&&this.emit('data',n),n},E.prototype._read=function(t){k(this,new w('_read()'))},E.prototype.pipe=function(t,e){var n=this,i=this._readableState;switch(i.pipesCount){case 0:i.pipes=t;break;case 1:i.pipes=[i.pipes,t];break;default:i.pipes.push(t)}i.pipesCount+=1,f('pipe count=%d opts=%j',i.pipesCount,e);var o=e&&!1===e.end||t===r.stdout||t===r.stderr?v:l;function s(t,e){f('onunpipe'),t===n&&e&&!1===e.hasUnpiped&&(e.hasUnpiped=!0,h())}function l(){f('onend'),t.end()}i.endEmitted?r.nextTick(o):n.once('end',o),t.on('unpipe',s);var c=j(n);t.on('drain',c);var u=!1;function h(){f('cleanup'),t.removeListener('close',m),t.removeListener('finish',g),t.removeListener('drain',c),t.removeListener('error',d),t.removeListener('unpipe',s),n.removeListener('end',l),n.removeListener('end',v),n.removeListener('data',p),u=!0,!i.awaitDrain||t._writableState&&!t._writableState.needDrain||c()}function p(e){f('ondata');var r=t.write(e);f('dest.write',r),!1===r&&((1===i.pipesCount&&i.pipes===t||i.pipesCount>1&&-1!==Z(i.pipes,t))&&!u&&(f('false write response, pause',i.awaitDrain),i.awaitDrain++),n.pause())}function d(e){f('onerror',e),v(),t.removeListener('error',d),0===a(t,'error')&&k(t,e)}function m(){t.removeListener('finish',g),v()}function g(){f('onfinish'),t.removeListener('close',m),v()}function v(){f('unpipe'),n.unpipe(t)}return n.on('data',p),A(t,'error',d),t.once('close',m),t.once('finish',g),t.emit('pipe',n),i.flowing||(f('pipe resume'),n.resume()),t},E.prototype.unpipe=function(t){var e=this._readableState,r={hasUnpiped:!1};if(0===e.pipesCount)return this;if(1===e.pipesCount)return t&&t!==e.pipes||(t||(t=e.pipes),e.pipes=null,e.pipesCount=0,e.flowing=!1,t&&t.emit('unpipe',this,r)),this;if(!t){var n=e.pipes,i=e.pipesCount;e.pipes=null,e.pipesCount=0,e.flowing=!1;for(var a=0;a<i;a++)n[a].emit('unpipe',this,{hasUnpiped:!1});return this}var o=Z(e.pipes,t);return-1===o||(e.pipes.splice(o,1),e.pipesCount-=1,1===e.pipesCount&&(e.pipes=e.pipes[0]),t.emit('unpipe',this,r)),this},E.prototype.on=function(t,e){var n=o.prototype.on.call(this,t,e),i=this._readableState;return"data"===t?(i.readableListening=this.listenerCount('readable')>0,!1!==i.flowing&&this.resume()):"readable"===t&&(i.endEmitted||i.readableListening||(i.readableListening=i.needReadable=!0,i.flowing=!1,i.emittedReadable=!1,f('on readable',i.length,i.reading),i.length?R(this):i.reading||r.nextTick(V,this))),n},E.prototype.addListener=E.prototype.on,E.prototype.removeListener=function(t,e){var n=o.prototype.removeListener.call(this,t,e);return"readable"===t&&r.nextTick(U,this),n},E.prototype.removeAllListeners=function(t){var e=o.prototype.removeAllListeners.apply(this,arguments);return"readable"!==t&&void 0!==t||r.nextTick(U,this),e},E.prototype.resume=function(){var t=this._readableState;return t.flowing||(f('resume'),t.flowing=!t.readableListening,H(this,t)),t.paused=!1,this},E.prototype.pause=function(){return f('call pause flowing=%j',this._readableState.flowing),!1!==this._readableState.flowing&&(f('pause'),this._readableState.flowing=!1,this.emit('pause')),this._readableState.paused=!0,this},E.prototype.wrap=function(t){var e=this,r=this._readableState,n=!1;for(var i in t.on('end',(function(){if(f('wrapped end'),r.decoder&&!r.ended){var t=r.decoder.end();t&&t.length&&e.push(t)}e.push(null)})),t.on('data',(function(i){f('wrapped data'),r.decoder&&(i=r.decoder.write(i)),(!r.objectMode||null!==i&&void 0!==i)&&(r.objectMode||i&&i.length)&&(e.push(i)||(n=!0,t.pause()))})),t)void 0===this[i]&&"function"===typeof t[i]&&(this[i]=function(e){return function(){return t[e].apply(t,arguments)}}(i));for(var a=0;a<M.length;a++)t.on(M[a],this.emit.bind(this,M[a]));return this._read=function(e){f('wrapped _read',e),n&&(n=!1,t.resume())},this},"function"===typeof Symbol&&(E.prototype[Symbol.asyncIterator]=function(){return void 0===d&&(d=t('./internal/streams/async_iterator')),d(this)}),Object.defineProperty(E.prototype,'readableHighWaterMark',{enumerable:!1,get:function(){return this._readableState.highWaterMark}}),Object.defineProperty(E.prototype,'readableBuffer',{enumerable:!1,get:function(){return this._readableState&&this._readableState.buffer}}),Object.defineProperty(E.prototype,'readableFlowing',{enumerable:!1,get:function(){return this._readableState.flowing},set:function(t)[this._readableState&&(this._readableState.flowing=t)]}),E._fromList=Y,Object.defineProperty(E.prototype,'readableLength',{enumerable:!1,get:function(){return this._readableState.length}}),"function"===typeof Symbol&&(E.from=function(e,r){return void 0===m&&(m=t('./internal/streams/from')),m(E,e,r)})}).call(this)}).call(this,t('_process'),"undefined"!==typeof r.g?r.g:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"../errors":555,"./_stream_duplex":556,"./internal/streams/async_iterator":561,"./internal/streams/buffer_list":562,"./internal/streams/destroy":563,"./internal/streams/from":565,"./internal/streams/state":567,"./internal/streams/stream":568,_process:514,buffer:117,events:116,inherits:439,"string_decoder/":569,util:115}],559:[function(t,e,r){"use strict";e.exports=u;var n=t('../errors').codes,i=n.ERR_METHOD_NOT_IMPLEMENTED,a=n.ERR_MULTIPLE_CALLBACK,o=n.ERR_TRANSFORM_ALREADY_TRANSFORMING,s=n.ERR_TRANSFORM_WITH_LENGTH_0,l=t('./_stream_duplex');function c(t,e){var r=this._transformState;r.transforming=!1;var n=r.writecb;if(null===n)return this.emit('error',new a);r.writechunk=null,r.writecb=null,null!=e&&this.push(e),n(t);var i=this._readableState;i.reading=!1,(i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark)}function u(t){if(!(this instanceof u))return new u(t);l.call(this,t),this._transformState={afterTransform:c.bind(this),needTransform:!1,transforming:!1,writecb:null,writechunk:null,writeencoding:null},this._readableState.needReadable=!0,this._readableState.sync=!1,t&&("function"===typeof t.transform&&(this._transform=t.transform),"function"===typeof t.flush&&(this._flush=t.flush)),this.on('prefinish',f)}function f(){var t=this;"function"!==typeof this._flush||this._readableState.destroyed?h(this,null,null):this._flush((function(e,r){h(t,e,r)}))}function h(t,e,r){if(e)return t.emit('error',e);if(null!=r&&t.push(r),t._writableState.length)throw new s;if(t._transformState.transforming)throw new o;return t.push(null)}t('inherits')(u,l),u.prototype.push=function(t,e){return this._transformState.needTransform=!1,l.prototype.push.call(this,t,e)},u.prototype._transform=function(t,e,r)[r(new i('_transform()'))],u.prototype._write=function(t,e,r){var n=this._transformState;if(n.writecb=r,n.writechunk=t,n.writeencoding=e,!n.transforming){var i=this._readableState;(n.needTransform||i.needReadable||i.length<i.highWaterMark)&&this._read(i.highWaterMark)}},u.prototype._read=function(t){var e=this._transformState;null===e.writechunk||e.transforming?e.needTransform=!0:(e.transforming=!0,this._transform(e.writechunk,e.writeencoding,e.afterTransform))},u.prototype._destroy=function(t,e){l.prototype._destroy.call(this,t,(function(t){e(t)}))}},{"../errors":555,"./_stream_duplex":556,inherits:439}],560:[function(t,e,n){(function(r,n){(function(){"use strict";function i(t){var e=this;this.next=null,this.entry=null,this.finish=function(){q(e,t)}}var a;e.exports=S,S.WritableState=A;var o={deprecate:t('util-deprecate')},s=t('./internal/streams/stream'),l=t('buffer').Buffer,c=n.Uint8Array||function(){};function u(t){return l.from(t)}function f(t){return l.isBuffer(t)||t instanceof c}var h,p=t('./internal/streams/destroy'),d=t('./internal/streams/state').getHighWaterMark,m=t('../errors').codes,g=m.ERR_INVALID_ARG_TYPE,v=m.ERR_METHOD_NOT_IMPLEMENTED,y=m.ERR_MULTIPLE_CALLBACK,x=m.ERR_STREAM_CANNOT_PIPE,b=m.ERR_STREAM_DESTROYED,_=m.ERR_STREAM_NULL_VALUES,w=m.ERR_STREAM_WRITE_AFTER_END,T=m.ERR_UNKNOWN_ENCODING,k=p.errorOrDestroy;function M(){}function A(e,r,n){a=a||t('./_stream_duplex'),e=e||{},"boolean"!==typeof n&&(n=r instanceof a),this.objectMode=!!e.objectMode,n&&(this.objectMode=this.objectMode||!!e.writableObjectMode),this.highWaterMark=d(this,e,'writableHighWaterMark',n),this.finalCalled=!1,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1,this.destroyed=!1;var o=!1===e.decodeStrings;this.decodeStrings=!o,this.defaultEncoding=e.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(t){D(r,t)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.emitClose=!1!==e.emitClose,this.autoDestroy=!!e.autoDestroy,this.bufferedRequestCount=0,this.corkedRequestsFree=new i(this)}function S(e){var r=this instanceof(a=a||t('./_stream_duplex'));if(!r&&!h.call(S,this))return new S(e);this._writableState=new A(e,this,r),this.writable=!0,e&&("function"===typeof e.write&&(this._write=e.write),"function"===typeof e.writev&&(this._writev=e.writev),"function"===typeof e.destroy&&(this._destroy=e.destroy),"function"===typeof e.final&&(this._final=e.final)),s.call(this)}function E(t,e){var n=new w;k(t,n),r.nextTick(e,n)}function L(t,e,n,i){var a;return null===n?a=new _:"string"===typeof n||e.objectMode||(a=new g('chunk',["string","Buffer"],n)),!a||(k(t,a),r.nextTick(i,a),!1)}function C(t,e,r){return t.objectMode||!1===t.decodeStrings||"string"!==typeof e||(e=l.from(e,r)),e}function P(t,e,r,n,i,a){if(!r){var o=C(e,n,i);n!==o&&(r=!0,i='buffer',n=o)}var s=e.objectMode?1:n.length;e.length+=s;var l=e.length<e.highWaterMark;if(l||(e.needDrain=!0),e.writing||e.corked){var c=e.lastBufferedRequest;e.lastBufferedRequest={chunk:n,encoding:i,isBuf:r,callback:a,next:null},c?c.next=e.lastBufferedRequest:e.bufferedRequest=e.lastBufferedRequest,e.bufferedRequestCount+=1}else I(t,e,!1,s,n,i,a);return l}function I(t,e,r,n,i,a,o){e.writelen=n,e.writecb=o,e.writing=!0,e.sync=!0,e.destroyed?e.onwrite(new b('write')):r?t._writev(i,e.onwrite):t._write(i,a,e.onwrite),e.sync=!1}function z(t,e,n,i,a){--e.pendingcb,n?(r.nextTick(a,i),r.nextTick(V,t,e),t._writableState.errorEmitted=!0,k(t,i)):(a(i),t._writableState.errorEmitted=!0,k(t,i),V(t,e))}function O(t){t.writing=!1,t.writecb=null,t.length-=t.writelen,t.writelen=0}function D(t,e){var n=t._writableState,i=n.sync,a=n.writecb;if("function"!==typeof a)throw new y;if(O(n),e)z(t,n,i,e,a);else{var o=N(n)||t.destroyed;o||n.corked||n.bufferProcessing||!n.bufferedRequest||B(t,n),i?r.nextTick(R,t,n,o,a):R(t,n,o,a)}}function R(t,e,r,n){r||F(t,e),e.pendingcb--,n(),V(t,e)}function F(t,e){0===e.length&&e.needDrain&&(e.needDrain=!1,t.emit('drain'))}function B(t,e){e.bufferProcessing=!0;var r=e.bufferedRequest;if(t._writev&&r&&r.next){var n=e.bufferedRequestCount,a=new Array(n),o=e.corkedRequestsFree;o.entry=r;for(var s=0,l=!0;r;)a[s]=r,r.isBuf||(l=!1),r=r.next,s+=1;a.allBuffers=l,I(t,e,!0,e.length,a,'',o.finish),e.pendingcb++,e.lastBufferedRequest=null,o.next?(e.corkedRequestsFree=o.next,o.next=null):e.corkedRequestsFree=new i(e),e.bufferedRequestCount=0}else{for(;r;){var c=r.chunk,u=r.encoding,f=r.callback;if(I(t,e,!1,e.objectMode?1:c.length,c,u,f),r=r.next,e.bufferedRequestCount--,e.writing)break}null===r&&(e.lastBufferedRequest=null)}e.bufferedRequest=r,e.bufferProcessing=!1}function N(t){return t.ending&&0===t.length&&null===t.bufferedRequest&&!t.finished&&!t.writing}function j(t,e){t._final((function(r){e.pendingcb--,r&&k(t,r),e.prefinished=!0,t.emit('prefinish'),V(t,e)}))}function U(t,e){e.prefinished||e.finalCalled||("function"!==typeof t._final||e.destroyed?(e.prefinished=!0,t.emit('prefinish')):(e.pendingcb++,e.finalCalled=!0,r.nextTick(j,t,e)))}function V(t,e){var r=N(e);if(r&&(U(t,e),0===e.pendingcb&&(e.finished=!0,t.emit('finish'),e.autoDestroy))){var n=t._readableState;(!n||n.autoDestroy&&n.endEmitted)&&t.destroy()}return r}function H(t,e,n){e.ending=!0,V(t,e),n&&(e.finished?r.nextTick(n):t.once('finish',n)),e.ended=!0,t.writable=!1}function q(t,e,r){var n=t.entry;for(t.entry=null;n;){var i=n.callback;e.pendingcb--,i(r),n=n.next}e.corkedRequestsFree.next=t}t('inherits')(S,s),A.prototype.getBuffer=function(){for(var t=this.bufferedRequest,e=[];t;)e.push(t),t=t.next;return e},function(){try{Object.defineProperty(A.prototype,'buffer',{get:o.deprecate((function(){return this.getBuffer()}),'_writableState.buffer is deprecated. Use _writableState.getBuffer instead.','DEP0003')})}catch(t){}}(),"function"===typeof Symbol&&Symbol.hasInstance&&"function"===typeof Function.prototype[Symbol.hasInstance]?(h=Function.prototype[Symbol.hasInstance],Object.defineProperty(S,Symbol.hasInstance,{value:function(t){return!!h.call(this,t)||this===S&&t&&t._writableState instanceof A}})):h=function(t){return t instanceof this},S.prototype.pipe=function(){k(this,new x)},S.prototype.write=function(t,e,r){var n=this._writableState,i=!1,a=!n.objectMode&&f(t);return a&&!l.isBuffer(t)&&(t=u(t)),"function"===typeof e&&(r=e,e=null),a?e="buffer":e||(e=n.defaultEncoding),"function"!==typeof r&&(r=M),n.ending?E(this,r):(a||L(this,n,t,r))&&(n.pendingcb++,i=P(this,n,a,t,e,r)),i},S.prototype.cork=function()[this._writableState.corked++],S.prototype.uncork=function(){var t=this._writableState;t.corked&&(t.corked--,t.writing||t.corked||t.bufferProcessing||!t.bufferedRequest||B(this,t))},S.prototype.setDefaultEncoding=function(t){if("string"===typeof t&&(t=t.toLowerCase()),!(["hex",'utf8','utf-8','ascii','binary','base64','ucs2','ucs-2','utf16le','utf-16le',"raw"].indexOf((t+"").toLowerCase())>-1))throw new T(t);return this._writableState.defaultEncoding=t,this},Object.defineProperty(S.prototype,'writableBuffer',{enumerable:!1,get:function(){return this._writableState&&this._writableState.getBuffer()}}),Object.defineProperty(S.prototype,'writableHighWaterMark',{enumerable:!1,get:function(){return this._writableState.highWaterMark}}),S.prototype._write=function(t,e,r)[r(new v('_write()'))],S.prototype._writev=null,S.prototype.end=function(t,e,r){var n=this._writableState;return"function"===typeof t?(r=t,t=null,e=null):"function"===typeof e&&(r=e,e=null),null!==t&&void 0!==t&&this.write(t,e),n.corked&&(n.corked=1,this.uncork()),n.ending||H(this,n,r),this},Object.defineProperty(S.prototype,'writableLength',{enumerable:!1,get:function(){return this._writableState.length}}),Object.defineProperty(S.prototype,'destroyed',{enumerable:!1,get:function(){return void 0!==this._writableState&&this._writableState.destroyed},set:function(t)[this._writableState&&(this._writableState.destroyed=t)]}),S.prototype.destroy=p.destroy,S.prototype._undestroy=p.undestroy,S.prototype._destroy=function(t,e)[e(t)]}).call(this)}).call(this,t('_process'),"undefined"!==typeof r.g?r.g:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"../errors":555,"./_stream_duplex":556,"./internal/streams/destroy":563,"./internal/streams/state":567,"./internal/streams/stream":568,_process:514,buffer:117,inherits:439,"util-deprecate":606}],561:[function(t,e,r){(function(r){(function(){"use strict";var n;function i(t,e,r){return e in t?Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var a=t('./end-of-stream'),o=Symbol('lastResolve'),s=Symbol('lastReject'),l=Symbol('error'),c=Symbol('ended'),u=Symbol('lastPromise'),f=Symbol('handlePromise'),h=Symbol('stream');function p(t,e){return{value:t,done:e}}function d(t){var e=t[o];if(null!==e){var r=t[h].read();null!==r&&(t[u]=null,t[o]=null,t[s]=null,e(p(r,!1)))}}function m(t){r.nextTick(d,t)}function g(t,e){return function(r,n){t.then((function(){e[c]?r(p(void 0,!0)):e[f](r,n)}),n)}}var v=Object.getPrototypeOf((function(){})),y=Object.setPrototypeOf((i(n={get stream(){return this[h]},next:function(){var t=this,e=this[l];if(null!==e)return Promise.reject(e);if(this[c])return Promise.resolve(p(void 0,!0));if(this[h].destroyed)return new Promise((function(e,n){r.nextTick((function(){t[l]?n(t[l]):e(p(void 0,!0))}))}));var n,i=this[u];if(i)n=new Promise(g(i,this));else{var a=this[h].read();if(null!==a)return Promise.resolve(p(a,!1));n=new Promise(this[f])}return this[u]=n,n}},Symbol.asyncIterator,(function(){return this})),i(n,'return',(function(){var t=this;return new Promise((function(e,r){t[h].destroy(null,(function(t){t?r(t):e(p(void 0,!0))}))}))})),n),v),x=function(t){var e,r=Object.create(y,(i(e={},h,{value:t,writable:!0}),i(e,o,{value:null,writable:!0}),i(e,s,{value:null,writable:!0}),i(e,l,{value:null,writable:!0}),i(e,c,{value:t._readableState.endEmitted,writable:!0}),i(e,f,{value:function(t,e){var n=r[h].read();n?(r[u]=null,r[o]=null,r[s]=null,t(p(n,!1))):(r[o]=t,r[s]=e)},writable:!0}),e));return r[u]=null,a(t,(function(t){if(t&&"ERR_STREAM_PREMATURE_CLOSE"!==t.code){var e=r[s];return null!==e&&(r[u]=null,r[o]=null,r[s]=null,e(t)),void(r[l]=t)}var n=r[o];null!==n&&(r[u]=null,r[o]=null,r[s]=null,n(p(void 0,!0))),r[c]=!0})),t.on('readable',m.bind(null,r)),r};e.exports=x}).call(this)}).call(this,t('_process'))},{"./end-of-stream":564,_process:514}],562:[function(t,e,r){"use strict";function n(t,e){var r=Object.keys(t);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(t);e&&(n=n.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),r.push.apply(r,n)}return r}function i(t){for(var e=1;e<arguments.length;e++){var r=null!=arguments[e]?arguments[e]:{};e%2?n(Object(r),!0).forEach((function(e){a(t,e,r[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(r)):n(Object(r)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(r,e))}))}return t}function a(t,e,r){return e in t?Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}function o(t,e){if(!(t instanceof e))throw new TypeError('Cannot call a class as a function')}function s(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}function l(t,e,r){return e&&s(t.prototype,e),r&&s(t,r),t}var c=t('buffer').Buffer,u=t('util').inspect,f=u&&u.custom||"inspect";function h(t,e,r){c.prototype.copy.call(t,e,r)}e.exports=function(){function t(){o(this,t),this.head=null,this.tail=null,this.length=0}return l(t,[{key:"push",value:function(t){var e={data:t,next:null};this.length>0?this.tail.next=e:this.head=e,this.tail=e,++this.length}},{key:"unshift",value:function(t){var e={data:t,next:this.head};0===this.length&&(this.tail=e),this.head=e,++this.length}},{key:"shift",value:function(){if(0!==this.length){var t=this.head.data;return 1===this.length?this.head=this.tail=null:this.head=this.head.next,--this.length,t}}},{key:"clear",value:function(){this.head=this.tail=null,this.length=0}},{key:"join",value:function(t){if(0===this.length)return'';for(var e=this.head,r=""+e.data;e=e.next;)r+=t+e.data;return r}},{key:"concat",value:function(t){if(0===this.length)return c.alloc(0);for(var e=c.allocUnsafe(t>>>0),r=this.head,n=0;r;)h(r.data,e,n),n+=r.data.length,r=r.next;return e}},{key:"consume",value:function(t,e){var r;return t<this.head.data.length?(r=this.head.data.slice(0,t),this.head.data=this.head.data.slice(t)):r=t===this.head.data.length?this.shift():e?this._getString(t):this._getBuffer(t),r}},{key:"first",value:function(){return this.head.data}},{key:"_getString",value:function(t){var e=this.head,r=1,n=e.data;for(t-=n.length;e=e.next;){var i=e.data,a=t>i.length?i.length:t;if(a===i.length?n+=i:n+=i.slice(0,t),0===(t-=a)){a===i.length?(++r,e.next?this.head=e.next:this.head=this.tail=null):(this.head=e,e.data=i.slice(a));break}++r}return this.length-=r,n}},{key:"_getBuffer",value:function(t){var e=c.allocUnsafe(t),r=this.head,n=1;for(r.data.copy(e),t-=r.data.length;r=r.next;){var i=r.data,a=t>i.length?i.length:t;if(i.copy(e,e.length-t,0,a),0===(t-=a)){a===i.length?(++n,r.next?this.head=r.next:this.head=this.tail=null):(this.head=r,r.data=i.slice(a));break}++n}return this.length-=n,e}},{key:f,value:function(t,e){return u(this,i({},e,{depth:0,customInspect:!1}))}}]),t}()},{buffer:117,util:115}],563:[function(t,e,r){(function(t){(function(){"use strict";function r(e,r){var a=this,s=this._readableState&&this._readableState.destroyed,l=this._writableState&&this._writableState.destroyed;return s||l?(r?r(e):e&&(this._writableState?this._writableState.errorEmitted||(this._writableState.errorEmitted=!0,t.nextTick(o,this,e)):t.nextTick(o,this,e)),this):(this._readableState&&(this._readableState.destroyed=!0),this._writableState&&(this._writableState.destroyed=!0),this._destroy(e||null,(function(e){!r&&e?a._writableState?a._writableState.errorEmitted?t.nextTick(i,a):(a._writableState.errorEmitted=!0,t.nextTick(n,a,e)):t.nextTick(n,a,e):r?(t.nextTick(i,a),r(e)):t.nextTick(i,a)})),this)}function n(t,e){o(t,e),i(t)}function i(t)[t._writableState&&!t._writableState.emitClose||t._readableState&&!t._readableState.emitClose||t.emit('close')]function a(){this._readableState&&(this._readableState.destroyed=!1,this._readableState.reading=!1,this._readableState.ended=!1,this._readableState.endEmitted=!1),this._writableState&&(this._writableState.destroyed=!1,this._writableState.ended=!1,this._writableState.ending=!1,this._writableState.finalCalled=!1,this._writableState.prefinished=!1,this._writableState.finished=!1,this._writableState.errorEmitted=!1)}function o(t,e){t.emit('error',e)}function s(t,e){var r=t._readableState,n=t._writableState;r&&r.autoDestroy||n&&n.autoDestroy?t.destroy(e):t.emit('error',e)}e.exports={destroy:r,undestroy:a,errorOrDestroy:s}}).call(this)}).call(this,t('_process'))},{_process:514}],564:[function(t,e,r){"use strict";var n=t('../../../errors').codes.ERR_STREAM_PREMATURE_CLOSE;function i(t){var e=!1;return function(){if(!e){e=!0;for(var r=arguments.length,n=new Array(r),i=0;i<r;i++)n[i]=arguments[i];t.apply(this,n)}}}function a(){}function o(t){return t.setHeader&&"function"===typeof t.abort}function s(t,e,r){if("function"===typeof e)return s(t,null,e);e||(e={}),r=i(r||a);var l=e.readable||!1!==e.readable&&t.readable,c=e.writable||!1!==e.writable&&t.writable,u=function()[t.writable||h()],f=t._writableState&&t._writableState.finished,h=function(){c=!1,f=!0,l||r.call(t)},p=t._readableState&&t._readableState.endEmitted,d=function(){l=!1,p=!0,c||r.call(t)},m=function(e){r.call(t,e)},g=function(){var e;return l&&!p?(t._readableState&&t._readableState.ended||(e=new n),r.call(t,e)):c&&!f?(t._writableState&&t._writableState.ended||(e=new n),r.call(t,e)):void 0},v=function(){t.req.on('finish',h)};return o(t)?(t.on('complete',h),t.on('abort',g),t.req?v():t.on('request',v)):c&&!t._writableState&&(t.on('end',u),t.on('close',u)),t.on('end',d),t.on('finish',h),!1!==e.error&&t.on('error',m),t.on('close',g),function(){t.removeListener('complete',h),t.removeListener('abort',g),t.removeListener('request',v),t.req&&t.req.removeListener('finish',h),t.removeListener('end',u),t.removeListener('close',u),t.removeListener('finish',h),t.removeListener('end',d),t.removeListener('error',m),t.removeListener('close',g)}}e.exports=s},{"../../../errors":555}],565:[function(t,e,r){e.exports=function(){throw new Error('Readable.from is not available in the browser')}},{}],566:[function(t,e,r){"use strict";var n;function i(t){var e=!1;return function(){e||(e=!0,t.apply(void 0,arguments))}}var a=t('../../../errors').codes,o=a.ERR_MISSING_ARGS,s=a.ERR_STREAM_DESTROYED;function l(t)[if(t)throw t]function c(t){return t.setHeader&&"function"===typeof t.abort}function u(e,r,a,o){o=i(o);var l=!1;e.on('close',(function(){l=!0})),void 0===n&&(n=t('./end-of-stream')),n(e,{readable:r,writable:a},(function(t){if(t)return o(t);l=!0,o()}));var u=!1;return function(t){if(!l&&!u)return u=!0,c(e)?e.abort():"function"===typeof e.destroy?e.destroy():void o(t||new s('pipe'))}}function f(t)[t()]function h(t,e){return t.pipe(e)}function p(t){return t.length?"function"!==typeof t[t.length-1]?l:t.pop():l}function d(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];var n,i=p(e);if(Array.isArray(e[0])&&(e=e[0]),e.length<2)throw new o('streams');var a=e.map((function(t,r){var o=r<e.length-1;return u(t,o,r>0,(function(t){n||(n=t),t&&a.forEach(f),o||(a.forEach(f),i(n))}))}));return e.reduce(h)}e.exports=d},{"../../../errors":555,"./end-of-stream":564}],567:[function(t,e,r){"use strict";var n=t('../../../errors').codes.ERR_INVALID_OPT_VALUE;function i(t,e,r){return null!=t.highWaterMark?t.highWaterMark:e?t[r]:null}function a(t,e,r,a){var o=i(e,a,r);if(null!=o){if(!isFinite(o)||Math.floor(o)!==o||o<0)throw new n(a?r:"highWaterMark",o);return Math.floor(o)}return t.objectMode?16:16384}e.exports={getHighWaterMark:a}},{"../../../errors":555}],568:[function(t,e,r)[e.exports=t('events').EventEmitter],{events:116}],569:[function(t,e,r){"use strict";var n=t('safe-buffer').Buffer,i=n.isEncoding||function(t){switch((t=""+t)&&t.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}};function a(t){if(!t)return'utf8';for(var e;;)switch(t){case"utf8":case"utf-8":return'utf8';case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return'utf16le';case"latin1":case"binary":return'latin1';case"base64":case"ascii":case"hex":return t;default:if(e)return;t=(""+t).toLowerCase(),e=!0}}function o(t){var e=a(t);if("string"!==typeof e&&(n.isEncoding===i||!i(t)))throw new Error("Unknown encoding: "+t);return e||t}function s(t){var e;switch(this.encoding=o(t),this.encoding){case"utf16le":this.text=d,this.end=m,e=4;break;case"utf8":this.fillLast=f,e=4;break;case"base64":this.text=g,this.end=v,e=3;break;default:return this.write=y,void(this.end=x)}this.lastNeed=0,this.lastTotal=0,this.lastChar=n.allocUnsafe(e)}function l(t){return t<=127?0:t>>5===6?2:t>>4===14?3:t>>3===30?4:t>>6===2?-1:-2}function c(t,e,r){var n=e.length-1;if(n<r)return 0;var i=l(e[n]);return i>=0?(i>0&&(t.lastNeed=i-1),i):--n<r||-2===i?0:(i=l(e[n]))>=0?(i>0&&(t.lastNeed=i-2),i):--n<r||-2===i?0:(i=l(e[n]))>=0?(i>0&&(2===i?i=0:t.lastNeed=i-3),i):0}function u(t,e,r){if(128!==(192&e[0]))return t.lastNeed=0,'\ufffd';if(t.lastNeed>1&&e.length>1){if(128!==(192&e[1]))return t.lastNeed=1,'\ufffd';if(t.lastNeed>2&&e.length>2&&128!==(192&e[2]))return t.lastNeed=2,"\ufffd"}}function f(t){var e=this.lastTotal-this.lastNeed,r=u(this,t,e);return void 0!==r?r:this.lastNeed<=t.length?(t.copy(this.lastChar,e,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(t.copy(this.lastChar,e,0,t.length),void(this.lastNeed-=t.length))}function h(t,e){var r=c(this,t,e);if(!this.lastNeed)return t.toString('utf8',e);this.lastTotal=r;var n=t.length-(r-this.lastNeed);return t.copy(this.lastChar,0,n),t.toString('utf8',e,n)}function p(t){var e=t&&t.length?this.write(t):"";return this.lastNeed?e+"\ufffd":e}function d(t,e){if((t.length-e)%2===0){var r=t.toString('utf16le',e);if(r){var n=r.charCodeAt(r.length-1);if(n>=55296&&n<=56319)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=t[t.length-2],this.lastChar[1]=t[t.length-1],r.slice(0,-1)}return r}return this.lastNeed=1,this.lastTotal=2,this.lastChar[0]=t[t.length-1],t.toString('utf16le',e,t.length-1)}function m(t){var e=t&&t.length?this.write(t):"";if(this.lastNeed){var r=this.lastTotal-this.lastNeed;return e+this.lastChar.toString('utf16le',0,r)}return e}function g(t,e){var r=(t.length-e)%3;return 0===r?t.toString('base64',e):(this.lastNeed=3-r,this.lastTotal=3,1===r?this.lastChar[0]=t[t.length-1]:(this.lastChar[0]=t[t.length-2],this.lastChar[1]=t[t.length-1]),t.toString('base64',e,t.length-r))}function v(t){var e=t&&t.length?this.write(t):"";return this.lastNeed?e+this.lastChar.toString('base64',0,3-this.lastNeed):e}function y(t){return t.toString(this.encoding)}function x(t){return t&&t.length?this.write(t):""}r.StringDecoder=s,s.prototype.write=function(t){if(0===t.length)return'';var e,r;if(this.lastNeed){if(void 0===(e=this.fillLast(t)))return'';r=this.lastNeed,this.lastNeed=0}else r=0;return r<t.length?e?e+this.text(t,r):this.text(t,r):e||""},s.prototype.end=p,s.prototype.text=h,s.prototype.fillLast=function(t){if(this.lastNeed<=t.length)return t.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal);t.copy(this.lastChar,this.lastTotal-this.lastNeed,0,t.length),this.lastNeed-=t.length}},{"safe-buffer":540}],570:[function(t,e,r){(function(r,n){(function(){var r=t('assert'),i=t('debug')('stream-parser');e.exports=c;var a=-1,o=0,s=1,l=2;function c(t){var e=t&&"function"==typeof t._transform,r=t&&"function"==typeof t._write;if(!e&&!r)throw new Error('must pass a Writable or Transform stream in');i('extending Parser into stream'),t._bytes=f,t._skipBytes=h,e&&(t._passthrough=p),e?t._transform=m:t._write=d}function u(t){i('initializing parser stream'),t._parserBytesLeft=0,t._parserBuffers=[],t._parserBuffered=0,t._parserState=a,t._parserCallback=null,"function"==typeof t.push&&(t._parserOutput=t.push.bind(t)),t._parserInit=!0}function f(t,e){r(!this._parserCallback,'there is already a 'callback' set!'),r(isFinite(t)&&t>0,'can only buffer a finite number of bytes > 0, got "'+t+'"'),this._parserInit||u(this),i('buffering %o bytes',t),this._parserBytesLeft=t,this._parserCallback=e,this._parserState=o}function h(t,e){r(!this._parserCallback,'there is already a 'callback' set!'),r(t>0,'can only skip > 0 bytes, got "'+t+'"'),this._parserInit||u(this),i('skipping %o bytes',t),this._parserBytesLeft=t,this._parserCallback=e,this._parserState=s}function p(t,e){r(!this._parserCallback,'There is already a 'callback' set!'),r(t>0,'can only pass through > 0 bytes, got "'+t+'"'),this._parserInit||u(this),i('passing through %o bytes',t),this._parserBytesLeft=t,this._parserCallback=e,this._parserState=l}function d(t,e,r){this._parserInit||u(this),i('write(%o bytes)',t.length),"function"==typeof e&&(r=e),y(this,t,null,r)}function m(t,e,r){this._parserInit||u(this),i('transform(%o bytes)',t.length),"function"!=typeof e&&(e=this._parserOutput),y(this,t,e,r)}function g(t,e,r,n){return t._parserBytesLeft<=0?n(new Error('got data but not currently parsing anything')):e.length<=t._parserBytesLeft?function(){return v(t,e,r,n)}:function(){var i=e.slice(0,t._parserBytesLeft);return v(t,i,r,(function(a){return a?n(a):e.length>i.length?function(){return g(t,e.slice(i.length),r,n)}:void 0}))}}function v(t,e,r,s){if(t._parserBytesLeft-=e.length,i('%o bytes left for stream piece',t._parserBytesLeft),t._parserState===o?(t._parserBuffers.push(e),t._parserBuffered+=e.length):t._parserState===l&&r(e),0!==t._parserBytesLeft)return s;var c=t._parserCallback;if(c&&t._parserState===o&&t._parserBuffers.length>1&&(e=n.concat(t._parserBuffers,t._parserBuffered)),t._parserState!==o&&(e=null),t._parserCallback=null,t._parserBuffered=0,t._parserState=a,t._parserBuffers.splice(0),c){var u=[];e&&u.push(e),r&&u.push(r);var f=c.length>u.length;f&&u.push(x(s));var h=c.apply(t,u);if(!f||s===h)return s}}var y=x(g);function x(t){return function(){for(var e=t.apply(this,arguments);"function"==typeof e;)e=e();return e}}}).call(this)}).call(this,t('_process'),t('buffer').Buffer)},{_process:514,assert:80,buffer:117,debug:571}],571:[function(t,e,r){(function(n){(function(){function i(){return!("undefined"===typeof window||!window.process||"renderer"!==window.process.type)||"undefined"!==typeof document&&document.documentElement&&document.documentElement.style&&document.documentElement.style.WebkitAppearance||"undefined"!==typeof window&&window.console&&(window.console.firebug||window.console.exception&&window.console.table)||"undefined"!==typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||"undefined"!==typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)}function a(t){var e=this.useColors;if(t[0]=(e?"%c":"")+this.namespace+(e?" %c":" ")+t[0]+(e?"%c ':' ")+"+"+r.humanize(this.diff),e){var n="color: "+this.color;t.splice(1,0,n,'color: inherit');var i=0,a=0;t[0].replace(/%[a-zA-Z%]/g,(function(t){"%%"!==t&&(i++,"%c"===t&&(a=i))})),t.splice(a,0,n)}}function o(){return"object"===typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)}function s(t){try{null==t?r.storage.removeItem('debug'):r.storage.debug=t}catch(e){}}function l(){var t;try{t=r.storage.debug}catch(e){}return!t&&"undefined"!==typeof n&&"env"in n&&(t=n.env.DEBUG),t}function c(){try{return window.localStorage}catch(t){}}(r=e.exports=t('./debug')).log=o,r.formatArgs=a,r.save=s,r.load=l,r.useColors=i,r.storage="undefined"!=typeof chrome&&"undefined"!=typeof chrome.storage?chrome.storage.local:c(),r.colors=["lightseagreen",'forestgreen','goldenrod','dodgerblue','darkorchid',"crimson"],r.formatters.j=function(t){try{return JSON.stringify(t)}catch(e){return"[UnexpectedJSONParseError]: '+e.message}},r.enable(l())}).call(this)}).call(this,t('_process'))},{'./debug":572,_process:514}],572:[function(t,e,r){var n;function i(t){var e,n=0;for(e in t)n=(n<<5)-n+t.charCodeAt(e),n|=0;return r.colors[Math.abs(n)%r.colors.length]}function a(t){function e(){if(e.enabled){var t=e,i=+new Date,a=i-(n||i);t.diff=a,t.prev=n,t.curr=i,n=i;for(var o=new Array(arguments.length),s=0;s<o.length;s++)o[s]=arguments[s];o[0]=r.coerce(o[0]),"string"!==typeof o[0]&&o.unshift('%O');var l=0;o[0]=o[0].replace(/%([a-zA-Z%])/g,(function(e,n){if("%%"===e)return e;l++;var i=r.formatters[n];if("function"===typeof i){var a=o[l];e=i.call(t,a),o.splice(l,1),l--}return e})),r.formatArgs.call(t,o),(e.log||r.log||console.log.bind(console)).apply(t,o)}}return e.namespace=t,e.enabled=r.enabled(t),e.useColors=r.useColors(),e.color=i(t),"function"===typeof r.init&&r.init(e),e}function o(t){r.save(t),r.names=[],r.skips=[];for(var e=("string"===typeof t?t:"").split(/[\s,]+/),n=e.length,i=0;i<n;i++)e[i]&&("-"===(t=e[i].replace(/\*/g,'.*?'))[0]?r.skips.push(new RegExp("^"+t.substr(1)+"$")):r.names.push(new RegExp("^"+t+"$")))}function s()[r.enable('')]function l(t){var e,n;for(e=0,n=r.skips.length;e<n;e++)if(r.skips[e].test(t))return!1;for(e=0,n=r.names.length;e<n;e++)if(r.names[e].test(t))return!0;return!1}function c(t){return t instanceof Error?t.stack||t.message:t}(r=e.exports=a.debug=a.default=a).coerce=c,r.disable=s,r.enable=o,r.enabled=l,r.humanize=t('ms'),r.names=[],r.skips=[],r.formatters={}},{ms:573}],573:[function(t,e,r){var n=1e3,i=60*n,a=60*i,o=24*a,s=365.25*o;function l(t){if(!((t=String(t)).length>100)){var e=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(t);if(e){var r=parseFloat(e[1]);switch((e[2]||"ms").toLowerCase()){case"years":case"year":case"yrs":case"yr":case"y":return r*s;case"days":case"day":case"d":return r*o;case"hours":case"hour":case"hrs":case"hr":case"h":return r*a;case"minutes":case"minute":case"mins":case"min":case"m":return r*i;case"seconds":case"second":case"secs":case"sec":case"s":return r*n;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return r;default:return}}}}function c(t){return t>=o?Math.round(t/o)+"d":t>=a?Math.round(t/a)+"h":t>=i?Math.round(t/i)+"m":t>=n?Math.round(t/n)+"s":t+"ms"}function u(t){return f(t,o,'day')||f(t,a,'hour')||f(t,i,'minute')||f(t,n,'second')||t+" ms"}function f(t,e,r){if(!(t<e))return t<1.5*e?Math.floor(t/e)+" '+r:Math.ceil(t/e)+' "+r+"s"}e.exports=function(t,e)[e=e||{];var r=typeof t;if("string"===r&&t.length>0)return l(t);if("number"===r&&!1===isNaN(t))return e.long?u(t):c(t);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(t))}},{}],574:[function(t,e,r){"use strict";var n=t('parenthesis');e.exports=function(t,e,r){if(null==t)throw Error('First argument should be a string');if(null==e)throw Error('Separator should be a string or a RegExp');r?("string"===typeof r||Array.isArray(r))&&(r={ignore:r}):r={},null==r.escape&&(r.escape=!0),null==r.ignore?r.ignore=["[]",'()','{}','<>','""','''','``','\u201c\u201d',"\xab\xbb"]:("string"===typeof r.ignore&&(r.ignore=[r.ignore]),r.ignore=r.ignore.map((function(t){return 1===t.length&&(t+=t),t})));var i=n.parse(t,{flat:!0,brackets:r.ignore}),a=i[0].split(e);if(r.escape){for(var o=[],s=0;s<a.length;s++){var l=a[s],c=a[s+1];"\\"===l[l.length-1]&&"\\"!==l[l.length-2]?(o.push(l+e+c),s++):o.push(l)}a=o}for(s=0;s<a.length;s++)i[0]=a[s],a[s]=n.stringify(i,{flat:!0});return a}},{parenthesis:480}],575:[function(t,e,r){"use strict";function n(t){for(var e=t.length,r=new Array(e),n=new Array(e),i=new Array(e),a=new Array(e),o=new Array(e),s=new Array(e),l=0;l<e;++l)r[l]=-1,n[l]=0,i[l]=!1,a[l]=0,o[l]=-1,s[l]=[];var c,u=0,f=[],h=[];function p(e){var l=[e],c=[e];for(r[e]=n[e]=u,i[e]=!0,u+=1;c.length>0;){e=c[c.length-1];var p=t[e];if(a[e]<p.length){for(var d=a[e];d<p.length;++d){var m=p[d];if(r[m]<0){r[m]=n[m]=u,i[m]=!0,u+=1,l.push(m),c.push(m);break}i[m]&&(n[e]=0|Math.min(n[e],n[m])),o[m]>=0&&s[e].push(o[m])}a[e]=d}else{if(n[e]===r[e]){var g=[],v=[],y=0;for(d=l.length-1;d>=0;--d){var x=l[d];if(i[x]=!1,g.push(x),v.push(s[x]),y+=s[x].length,o[x]=f.length,x===e){l.length=d;break}}f.push(g);var b=new Array(y);for(d=0;d<v.length;d++)for(var _=0;_<v[d].length;_++)b[--y]=v[d][_];h.push(b)}c.pop()}}}for(l=0;l<e;++l)r[l]<0&&p(l);for(l=0;l<h.length;l++){var d=h[l];if(0!==d.length){d.sort((function(t,e){return t-e})),c=[d[0]];for(var m=1;m<d.length;m++)d[m]!==d[m-1]&&c.push(d[m]);h[l]=c}}return{components:f,adjacencyList:h}}e.exports=n},{}],576:[function(t,e,r){"use strict";e.exports=c;var n=t('ndarray-extract-contour'),i=t('zero-crossings'),a={"2d":function(t,e,r){var n=t({order:e,scalarArguments:3,getters:"generic"===r?[0]:void 0,phase:function(t,e,r,n){return t>n|0},vertex:function(t,e,r,n,i,a,o,s,l,c,u,f,h){var p=(0|o)+(s<<1)+(l<<2)+(c<<3)|0;if(0!==p&&15!==p)switch(p){case 0:case 15:u.push([t-.5,e-.5]);break;case 1:u.push([t-.25-.25*(n+r-2*h)/(r-n),e-.25-.25*(i+r-2*h)/(r-i)]);break;case 2:u.push([t-.75-.25*(-n-r+2*h)/(n-r),e-.25-.25*(a+n-2*h)/(n-a)]);break;case 3:u.push([t-.5,e-.5-.5*(i+r+a+n-4*h)/(r-i+n-a)]);break;case 4:u.push([t-.25-.25*(a+i-2*h)/(i-a),e-.75-.25*(-i-r+2*h)/(i-r)]);break;case 5:u.push([t-.5-.5*(n+r+a+i-4*h)/(r-n+i-a),e-.5]);break;case 6:u.push([t-.5-.25*(-n-r+a+i)/(n-r+i-a),e-.5-.25*(-i-r+a+n)/(i-r+n-a)]);break;case 7:u.push([t-.75-.25*(a+i-2*h)/(i-a),e-.75-.25*(a+n-2*h)/(n-a)]);break;case 8:u.push([t-.75-.25*(-a-i+2*h)/(a-i),e-.75-.25*(-a-n+2*h)/(a-n)]);break;case 9:u.push([t-.5-.25*(n+r+-a-i)/(r-n+a-i),e-.5-.25*(i+r+-a-n)/(r-i+a-n)]);break;case 10:u.push([t-.5-.5*(-n-r-a-i+4*h)/(n-r+a-i),e-.5]);break;case 11:u.push([t-.25-.25*(-a-i+2*h)/(a-i),e-.75-.25*(i+r-2*h)/(r-i)]);break;case 12:u.push([t-.5,e-.5-.5*(-i-r-a-n+4*h)/(i-r+a-n)]);break;case 13:u.push([t-.75-.25*(n+r-2*h)/(r-n),e-.25-.25*(-a-n+2*h)/(a-n)]);break;case 14:u.push([t-.25-.25*(-n-r+2*h)/(n-r),e-.25-.25*(-i-r+2*h)/(i-r)])}},cell:function(t,e,r,n,i,a,o,s,l){i?s.push([t,e]):s.push([e,t])}});return function(t,e){var r=[],i=[];return n(t,r,i,e),{positions:r,cells:i}}}};function o(t,e){var r=t.length+"d",i=a[r];if(i)return i(n,t,e)}function s(t,e){for(var r=i(t,e),n=r.length,a=new Array(n),o=new Array(n),s=0;s<n;++s)a[s]=[r[s]],o[s]=[s];return{positions:a,cells:o}}var l={};function c(t,e){if(t.dimension<=0)return{positions:[],cells:[]};if(1===t.dimension)return s(t,e);var r=t.order.join()+"-"+t.dtype,n=l[r];return e=+e||0,n||(n=l[r]=o(t.order,t.dtype)),n(t,e)}},{"ndarray-extract-contour":464,"zero-crossings":631}],577:[function(t,e,r){"use strict";Object.defineProperty(r,'__esModule',{value:!0});var n=function(){function t(t,e){var r=[],n=!0,i=!1,a=void 0;try{for(var o,s=t[Symbol.iterator]();!(n=(o=s.next()).done)&&(r.push(o.value),!e||r.length!==e);n=!0);}catch(l){i=!0,a=l}finally{try{!n&&s.return&&s.return()}finally[if(i)throw a]}return r}return function(e,r){if(Array.isArray(e))return e;if(Symbol.iterator in Object(e))return t(e,r);throw new TypeError('Invalid attempt to destructure non-iterable instance')}}(),i=2*Math.PI,a=function(t,e,r,n,i,a,o){var s=t.x,l=t.y;return{x:n*(s*=e)-i*(l*=r)+a,y:i*s+n*l+o}},o=function(t,e){var r=1.5707963267948966===e?.551915024494:-1.5707963267948966===e?-.551915024494:4/3*Math.tan(e/4),n=Math.cos(t),i=Math.sin(t),a=Math.cos(t+e),o=Math.sin(t+e);return[x:n-i*r,y:i+n*r},{x:a+o*r,y:o-a*r},{x:a,y:o}],s=function(t,e,r,n){var i=t*r+e*n;return i>1&&(i=1),i<-1&&(i=-1),(t*n-e*r<0?-1:1)*Math.acos(i)},l=function(t,e,r,n,a,o,l,c,u,f,h,p){var d=Math.pow(a,2),m=Math.pow(o,2),g=Math.pow(h,2),v=Math.pow(p,2),y=d*m-d*v-m*g;y<0&&(y=0),y/=d*v+m*g;var x=(y=Math.sqrt(y)*(l===c?-1:1))*a/o*p,b=y*-o/a*h,_=f*x-u*b+(t+r)/2,w=u*x+f*b+(e+n)/2,T=(h-x)/a,k=(p-b)/o,M=(-h-x)/a,A=(-p-b)/o,S=s(1,0,T,k),E=s(T,k,M,A);return 0===c&&E>0&&(E-=i),1===c&&E<0&&(E+=i),[_,w,S,E]},c=function(t){var e=t.px,r=t.py,s=t.cx,c=t.cy,u=t.rx,f=t.ry,h=t.xAxisRotation,p=void 0===h?0:h,d=t.largeArcFlag,m=void 0===d?0:d,g=t.sweepFlag,v=void 0===g?0:g,y=[];if(0===u||0===f)return[];var x=Math.sin(p*i/360),b=Math.cos(p*i/360),_=b*(e-s)/2+x*(r-c)/2,w=-x*(e-s)/2+b*(r-c)/2;if(0===_&&0===w)return[];u=Math.abs(u),f=Math.abs(f);var T=Math.pow(_,2)/Math.pow(u,2)+Math.pow(w,2)/Math.pow(f,2);T>1&&(u*=Math.sqrt(T),f*=Math.sqrt(T));var k=l(e,r,s,c,u,f,m,v,x,b,_,w),M=n(k,4),A=M[0],S=M[1],E=M[2],L=M[3],C=Math.abs(L)/(i/4);Math.abs(1-C)<1e-7&&(C=1);var P=Math.max(Math.ceil(C),1);L/=P;for(var I=0;I<P;I++)y.push(o(E,L)),E+=L;return y.map((function(t){var e=a(t[0],u,f,b,x,A,S),r=e.x,n=e.y,i=a(t[1],u,f,b,x,A,S),o=i.x,s=i.y,l=a(t[2],u,f,b,x,A,S);return{x1:r,y1:n,x2:o,y2:s,x:l.x,y:l.y}}))};r.default=c,e.exports=r.default},{}],578:[function(t,e,r){"use strict";var n=t('parse-svg-path'),i=t('abs-svg-path'),a=t('normalize-svg-path'),o=t('is-svg-path'),s=t('assert');function l(t){if(Array.isArray(t)&&1===t.length&&"string"===typeof t[0]&&(t=t[0]),"string"===typeof t&&(s(o(t),'String is not an SVG path.'),t=n(t)),s(Array.isArray(t),'Argument should be a string or an array of path segments.'),t=i(t),!(t=a(t)).length)return[0,0,0,0];for(var e=[1/0,1/0,-1/0,-1/0],r=0,l=t.length;r<l;r++)for(var c=t[r].slice(1),u=0;u<c.length;u+=2)c[u+0]<e[0]&&(e[0]=c[u+0]),c[u+1]<e[1]&&(e[1]=c[u+1]),c[u+0]>e[2]&&(e[2]=c[u+0]),c[u+1]>e[3]&&(e[3]=c[u+1]);return e}e.exports=l},{"abs-svg-path":71,assert:80,"is-svg-path":449,"normalize-svg-path":579,"parse-svg-path":482}],579:[function(t,e,r){"use strict";e.exports=i;var n=t('svg-arc-to-cubic-bezier');function i(t){for(var e,r=[],i=0,s=0,l=0,c=0,u=null,f=null,h=0,p=0,d=0,m=t.length;d<m;d++){var g=t[d],v=g[0];switch(v){case"M":l=g[1],c=g[2];break;case"A":var y=n({px:h,py:p,cx:g[6],cy:g[7],rx:g[1],ry:g[2],xAxisRotation:g[3],largeArcFlag:g[4],sweepFlag:g[5]});if(!y.length)continue;for(var x,b=0;b<y.length;b++)g=["C",(x=y[b]).x1,x.y1,x.x2,x.y2,x.x,x.y],b<y.length-1&&r.push(g);break;case"S":var _=h,w=p;"C"!=e&&"S"!=e||(_+=_-i,w+=w-s),g=["C",_,w,g[1],g[2],g[3],g[4]];break;case"T":"Q"==e||"T"==e?(u=2*h-u,f=2*p-f):(u=h,f=p),g=o(h,p,u,f,g[1],g[2]);break;case"Q":u=g[1],f=g[2],g=o(h,p,g[1],g[2],g[3],g[4]);break;case"L":g=a(h,p,g[1],g[2]);break;case"H":g=a(h,p,g[1],p);break;case"V":g=a(h,p,h,g[1]);break;case"Z":g=a(h,p,l,c)}e=v,h=g[g.length-2],p=g[g.length-1],g.length>4?(i=g[g.length-4],s=g[g.length-3]):(i=h,s=p),r.push(g)}return r}function a(t,e,r,n){return["C",t,e,r,n,r,n]}function o(t,e,r,n,i,a){return["C",t/3+2/3*r,e/3+2/3*n,i/3+2/3*r,a/3+2/3*n,i,a]}},{"svg-arc-to-cubic-bezier":577}],580:[function(t,e,r){"use strict";var n,i=t('svg-path-bounds'),a=t('parse-svg-path'),o=t('draw-svg-path'),s=t('is-svg-path'),l=t('bitmap-sdf'),c=document.createElement('canvas'),u=c.getContext('2d');function f(t,e){if(!s(t))throw Error('Argument should be valid svg path string');var r,n;e||(e={}),e.shape?(r=e.shape[0],n=e.shape[1]):(r=c.width=e.w||e.width||200,n=c.height=e.h||e.height||200);var f=Math.min(r,n),p=e.stroke||0,d=e.viewbox||e.viewBox||i(t),m=[r/(d[2]-d[0]),n/(d[3]-d[1])],g=Math.min(m[0]||0,m[1]||0)/2;if(u.fillStyle='black',u.fillRect(0,0,r,n),u.fillStyle='white',p&&("number"!=typeof p&&(p=1),u.strokeStyle=p>0?"white":"black",u.lineWidth=Math.abs(p)),u.translate(.5*r,.5*n),u.scale(g,g),h()){var v=new Path2D(t);u.fill(v),p&&u.stroke(v)}else{var y=a(t);o(u,y),u.fill(),p&&u.stroke()}return u.setTransform(1,0,0,1,0,0),l(u,{cutoff:null!=e.cutoff?e.cutoff:.5,radius:null!=e.radius?e.radius:.5*f})}function h(){if(null!=n)return n;var t=document.createElement('canvas').getContext('2d');if(t.canvas.width=t.canvas.height=1,!window.Path2D)return n=!1;var e=new Path2D('M0,0h1v1h-1v-1Z');t.fillStyle='black',t.fill(e);var r=t.getImageData(0,0,1,1);return n=r&&r.data&&255===r.data[3]}e.exports=f},{"bitmap-sdf":105,"draw-svg-path":180,"is-svg-path":449,"parse-svg-path":482,"svg-path-bounds":578}],581:[function(t,e,r){(function(r){(function(){"use strict";e.exports=s;var n=t('vectorize-text'),i=window||r.global||{},a=i.__TEXT_CACHE||{};function o(t){for(var e=t.cells,r=t.positions,n=new Float32Array(6*e.length),i=0,a=0,o=0;o<e.length;++o)for(var s=e[o],l=0;l<3;++l){var c=r[s[l]];n[i++]=c[0],n[i++]=c[1]+1.4,a=Math.max(c[0],a)}return{data:n,shape:a}}function s(t,e,r)[r=r||{];var i=a[t];i||(i=a[t]={" ":{data:new Float32Array(0),shape:.2}});var l=i[e];if(!l)if(e.length<=1||!/\d/.test(e))l=i[e]=o(n(e,{triangles:!0,font:t,textAlign:r.textAlign||"left",textBaseline:"alphabetic",styletags:{breaklines:!0,bolds:!0,italics:!0,subscripts:!0,superscripts:!0}}));else{for(var c=e.split(/(\d|\s)/),u=new Array(c.length),f=0,h=0,p=0;p<c.length;++p)u[p]=s(t,c[p]),f+=u[p].data.length,h+=u[p].shape,p>0&&(h+=.02);var d=new Float32Array(f),m=0,g=-.5*h;for(p=0;p<u.length;++p){for(var v=u[p].data,y=0;y<v.length;y+=2)d[m++]=v[y]+g,d[m++]=v[y+1];g+=u[p].shape+.02}l=i[e]={data:d,shape:h}}return l}i.__TEXT_CACHE={}}).call(this)}).call(this,t('_process'))},{_process:514,"vectorize-text":607}],582:[function(t,e,r){(function(e,n){(function(){var i=t('process/browser.js').nextTick,a=Function.prototype.apply,o=Array.prototype.slice,s={},l=0;function c(t,e){this._id=t,this._clearFn=e}r.setTimeout=function(){return new c(a.call(setTimeout,window,arguments),clearTimeout)},r.setInterval=function(){return new c(a.call(setInterval,window,arguments),clearInterval)},r.clearTimeout=r.clearInterval=function(t)[t.close()],c.prototype.unref=c.prototype.ref=function(){},c.prototype.close=function(){this._clearFn.call(window,this._id)},r.enroll=function(t,e){clearTimeout(t._idleTimeoutId),t._idleTimeout=e},r.unenroll=function(t){clearTimeout(t._idleTimeoutId),t._idleTimeout=-1},r._unrefActive=r.active=function(t){clearTimeout(t._idleTimeoutId);var e=t._idleTimeout;e>=0&&(t._idleTimeoutId=setTimeout((function(){t._onTimeout&&t._onTimeout()}),e))},r.setImmediate="function"===typeof e?e:function(t){var e=l++,n=!(arguments.length<2)&&o.call(arguments,1);return s[e]=!0,i((function(){s[e]&&(n?t.apply(null,n):t.call(null),r.clearImmediate(e))})),e},r.clearImmediate="function"===typeof n?n:function(t)[delete s[t]]}).call(this)}).call(this,t('timers').setImmediate,t('timers').clearImmediate)},{"process/browser.js":514,timers:582}],583:[function(e,r,n){!function(e){var n=/^\s+/,i=/\s+$/,a=0,o=e.round,s=e.min,l=e.max,c=e.random;function u(t,e){if(e=e||{},(t=t||"")instanceof u)return t;if(!(this instanceof u))return new u(t,e);var r=f(t);this._originalInput=t,this._r=r.r,this._g=r.g,this._b=r.b,this._a=r.a,this._roundA=o(100*this._a)/100,this._format=e.format||r.format,this._gradientType=e.gradientType,this._r<1&&(this._r=o(this._r)),this._g<1&&(this._g=o(this._g)),this._b<1&&(this._b=o(this._b)),this._ok=r.ok,this._tc_id=a++}function f(t){var e={r:0,g:0,b:0},r=1,n=null,i=null,a=null,o=!1,c=!1;return"string"==typeof t&&(t=X(t)),"object"==typeof t&&(W(t.r)&&W(t.g)&&W(t.b)?(e=h(t.r,t.g,t.b),o=!0,c="%"===String(t.r).substr(-1)?"prgb":"rgb"):W(t.h)&&W(t.s)&&W(t.v)?(n=H(t.s),i=H(t.v),e=g(t.h,n,i),o=!0,c='hsv'):W(t.h)&&W(t.s)&&W(t.l)&&(n=H(t.s),a=H(t.l),e=d(t.h,n,a),o=!0,c='hsl'),t.hasOwnProperty('a')&&(r=t.a)),r=R(r),{ok:o,format:t.format||c,r:s(255,l(e.r,0)),g:s(255,l(e.g,0)),b:s(255,l(e.b,0)),a:r}}function h(t,e,r){return{r:255*F(t,255),g:255*F(e,255),b:255*F(r,255)}}function p(t,e,r){t=F(t,255),e=F(e,255),r=F(r,255);var n,i,a=l(t,e,r),o=s(t,e,r),c=(a+o)/2;if(a==o)n=i=0;else{var u=a-o;switch(i=c>.5?u/(2-a-o):u/(a+o),a){case t:n=(e-r)/u+(e<r?6:0);break;case e:n=(r-t)/u+2;break;case r:n=(t-e)/u+4}n/=6}return{h:n,s:i,l:c}}function d(t,e,r){var n,i,a;function o(t,e,r){return r<0&&(r+=1),r>1&&(r-=1),r<1/6?t+6*(e-t)*r:r<.5?e:r<2/3?t+(e-t)*(2/3-r)*6:t}if(t=F(t,360),e=F(e,100),r=F(r,100),0===e)n=i=a=r;else{var s=r<.5?r*(1+e):r+e-r*e,l=2*r-s;n=o(l,s,t+1/3),i=o(l,s,t),a=o(l,s,t-1/3)}return{r:255*n,g:255*i,b:255*a}}function m(t,e,r){t=F(t,255),e=F(e,255),r=F(r,255);var n,i,a=l(t,e,r),o=s(t,e,r),c=a,u=a-o;if(i=0===a?0:u/a,a==o)n=0;else{switch(a){case t:n=(e-r)/u+(e<r?6:0);break;case e:n=(r-t)/u+2;break;case r:n=(t-e)/u+4}n/=6}return{h:n,s:i,v:c}}function g(t,r,n){t=6*F(t,360),r=F(r,100),n=F(n,100);var i=e.floor(t),a=t-i,o=n*(1-r),s=n*(1-a*r),l=n*(1-(1-a)*r),c=i%6;return{r:255*[n,s,o,o,l,n][c],g:255*[l,n,n,s,o,o][c],b:255*[o,o,l,n,n,s][c]}}function v(t,e,r,n){var i=[V(o(t).toString(16)),V(o(e).toString(16)),V(o(r).toString(16))];return n&&i[0].charAt(0)==i[0].charAt(1)&&i[1].charAt(0)==i[1].charAt(1)&&i[2].charAt(0)==i[2].charAt(1)?i[0].charAt(0)+i[1].charAt(0)+i[2].charAt(0):i.join('')}function y(t,e,r,n,i){var a=[V(o(t).toString(16)),V(o(e).toString(16)),V(o(r).toString(16)),V(q(n))];return i&&a[0].charAt(0)==a[0].charAt(1)&&a[1].charAt(0)==a[1].charAt(1)&&a[2].charAt(0)==a[2].charAt(1)&&a[3].charAt(0)==a[3].charAt(1)?a[0].charAt(0)+a[1].charAt(0)+a[2].charAt(0)+a[3].charAt(0):a.join('')}function x(t,e,r,n){return[V(q(n)),V(o(t).toString(16)),V(o(e).toString(16)),V(o(r).toString(16))].join('')}function b(t,e){e=0===e?0:e||10;var r=u(t).toHsl();return r.s-=e/100,r.s=B(r.s),u(r)}function _(t,e){e=0===e?0:e||10;var r=u(t).toHsl();return r.s+=e/100,r.s=B(r.s),u(r)}function w(t){return u(t).desaturate(100)}function T(t,e){e=0===e?0:e||10;var r=u(t).toHsl();return r.l+=e/100,r.l=B(r.l),u(r)}function k(t,e){e=0===e?0:e||10;var r=u(t).toRgb();return r.r=l(0,s(255,r.r-o(-e/100*255))),r.g=l(0,s(255,r.g-o(-e/100*255))),r.b=l(0,s(255,r.b-o(-e/100*255))),u(r)}function M(t,e){e=0===e?0:e||10;var r=u(t).toHsl();return r.l-=e/100,r.l=B(r.l),u(r)}function A(t,e){var r=u(t).toHsl(),n=(r.h+e)%360;return r.h=n<0?360+n:n,u(r)}function S(t){var e=u(t).toHsl();return e.h=(e.h+180)%360,u(e)}function E(t){var e=u(t).toHsl(),r=e.h;return[u(t),u({h:(r+120)%360,s:e.s,l:e.l}),u({h:(r+240)%360,s:e.s,l:e.l})]}function L(t){var e=u(t).toHsl(),r=e.h;return[u(t),u({h:(r+90)%360,s:e.s,l:e.l}),u({h:(r+180)%360,s:e.s,l:e.l}),u({h:(r+270)%360,s:e.s,l:e.l})]}function C(t){var e=u(t).toHsl(),r=e.h;return[u(t),u({h:(r+72)%360,s:e.s,l:e.l}),u({h:(r+216)%360,s:e.s,l:e.l})]}function P(t,e,r){e=e||6,r=r||30;var n=u(t).toHsl(),i=360/r,a=[u(t)];for(n.h=(n.h-(i*e>>1)+720)%360;--e;)n.h=(n.h+i)%360,a.push(u(n));return a}function I(t,e){e=e||6;for(var r=u(t).toHsv(),n=r.h,i=r.s,a=r.v,o=[],s=1/e;e--;)o.push(u({h:n,s:i,v:a})),a=(a+s)%1;return o}u.prototype={isDark:function(){return this.getBrightness()<128},isLight:function(){return!this.isDark()},isValid:function(){return this._ok},getOriginalInput:function(){return this._originalInput},getFormat:function(){return this._format},getAlpha:function(){return this._a},getBrightness:function(){var t=this.toRgb();return(299*t.r+587*t.g+114*t.b)/1e3},getLuminance:function(){var t,r,n,i=this.toRgb();return t=i.r/255,r=i.g/255,n=i.b/255,.2126*(t<=.03928?t/12.92:e.pow((t+.055)/1.055,2.4))+.7152*(r<=.03928?r/12.92:e.pow((r+.055)/1.055,2.4))+.0722*(n<=.03928?n/12.92:e.pow((n+.055)/1.055,2.4))},setAlpha:function(t){return this._a=R(t),this._roundA=o(100*this._a)/100,this},toHsv:function(){var t=m(this._r,this._g,this._b);return{h:360*t.h,s:t.s,v:t.v,a:this._a}},toHsvString:function(){var t=m(this._r,this._g,this._b),e=o(360*t.h),r=o(100*t.s),n=o(100*t.v);return 1==this._a?"hsv('+e+', "+r+"%, "+n+"%)":"hsva('+e+', "+r+"%, "+n+"%, '+this._roundA+')"},toHsl:function(){var t=p(this._r,this._g,this._b);return{h:360*t.h,s:t.s,l:t.l,a:this._a}},toHslString:function(){var t=p(this._r,this._g,this._b),e=o(360*t.h),r=o(100*t.s),n=o(100*t.l);return 1==this._a?"hsl('+e+', "+r+"%, "+n+"%)":"hsla('+e+', "+r+"%, "+n+"%, '+this._roundA+')"},toHex:function(t){return v(this._r,this._g,this._b,t)},toHexString:function(t){return"#"+this.toHex(t)},toHex8:function(t){return y(this._r,this._g,this._b,this._a,t)},toHex8String:function(t){return"#"+this.toHex8(t)},toRgb:function(){return{r:o(this._r),g:o(this._g),b:o(this._b),a:this._a}},toRgbString:function(){return 1==this._a?"rgb('+o(this._r)+', '+o(this._g)+', '+o(this._b)+')":"rgba('+o(this._r)+', '+o(this._g)+', '+o(this._b)+', '+this._roundA+')"},toPercentageRgb:function(){return{r:o(100*F(this._r,255))+"%",g:o(100*F(this._g,255))+"%",b:o(100*F(this._b,255))+"%",a:this._a}},toPercentageRgbString:function(){return 1==this._a?"rgb("+o(100*F(this._r,255))+"%, "+o(100*F(this._g,255))+"%, "+o(100*F(this._b,255))+"%)":"rgba("+o(100*F(this._r,255))+"%, "+o(100*F(this._g,255))+"%, "+o(100*F(this._b,255))+"%, '+this._roundA+')"},toName:function(){return 0===this._a?"transparent":!(this._a<1)&&(O[v(this._r,this._g,this._b,!0)]||!1)},toFilter:function(t){var e="#"+x(this._r,this._g,this._b,this._a),r=e,n=this._gradientType?"GradientType = 1, ":"";if(t){var i=u(t);r="#"+x(i._r,i._g,i._b,i._a)}return"progid:DXImageTransform.Microsoft.gradient("+n+"startColorstr='+e+',endColorstr='+r+')"},toString:function(t){var e=!!t;t=t||this._format;var r=!1,n=this._a<1&&this._a>=0;return e||!n||"hex"!==t&&"hex6"!==t&&"hex3"!==t&&"hex4"!==t&&"hex8"!==t&&"name"!==t?("rgb"===t&&(r=this.toRgbString()),"prgb"===t&&(r=this.toPercentageRgbString()),"hex"!==t&&"hex6"!==t||(r=this.toHexString()),"hex3"===t&&(r=this.toHexString(!0)),"hex4"===t&&(r=this.toHex8String(!0)),"hex8"===t&&(r=this.toHex8String()),"name"===t&&(r=this.toName()),"hsl"===t&&(r=this.toHslString()),"hsv"===t&&(r=this.toHsvString()),r||this.toHexString()):"name"===t&&0===this._a?this.toName():this.toRgbString()},clone:function(){return u(this.toString())},_applyModification:function(t,e){var r=t.apply(null,[this].concat([].slice.call(e)));return this._r=r._r,this._g=r._g,this._b=r._b,this.setAlpha(r._a),this},lighten:function(){return this._applyModification(T,arguments)},brighten:function(){return this._applyModification(k,arguments)},darken:function(){return this._applyModification(M,arguments)},desaturate:function(){return this._applyModification(b,arguments)},saturate:function(){return this._applyModification(_,arguments)},greyscale:function(){return this._applyModification(w,arguments)},spin:function(){return this._applyModification(A,arguments)},_applyCombination:function(t,e){return t.apply(null,[this].concat([].slice.call(e)))},analogous:function(){return this._applyCombination(P,arguments)},complement:function(){return this._applyCombination(S,arguments)},monochromatic:function(){return this._applyCombination(I,arguments)},splitcomplement:function(){return this._applyCombination(C,arguments)},triad:function(){return this._applyCombination(E,arguments)},tetrad:function(){return this._applyCombination(L,arguments)}},u.fromRatio=function(t,e)[if("object"==typeof t){var r={];for(var n in t)t.hasOwnProperty(n)&&(r[n]="a"===n?t[n]:H(t[n]));t=r}return u(t,e)},u.equals=function(t,e){return!(!t||!e)&&u(t).toRgbString()==u(e).toRgbString()},u.random=function(){return u.fromRatio({r:c(),g:c(),b:c()})},u.mix=function(t,e,r){r=0===r?0:r||50;var n=u(t).toRgb(),i=u(e).toRgb(),a=r/100;return u({r:(i.r-n.r)*a+n.r,g:(i.g-n.g)*a+n.g,b:(i.b-n.b)*a+n.b,a:(i.a-n.a)*a+n.a})},u.readability=function(t,r){var n=u(t),i=u(r);return(e.max(n.getLuminance(),i.getLuminance())+.05)/(e.min(n.getLuminance(),i.getLuminance())+.05)},u.isReadable=function(t,e,r){var n,i,a=u.readability(t,e);switch(i=!1,(n=Z(r)).level+n.size){case"AAsmall":case"AAAlarge":i=a>=4.5;break;case"AAlarge":i=a>=3;break;case"AAAsmall":i=a>=7}return i},u.mostReadable=function(t,e,r){var n,i,a,o,s=null,l=0;i=(r=r||{}).includeFallbackColors,a=r.level,o=r.size;for(var c=0;c<e.length;c++)(n=u.readability(t,e[c]))>l&&(l=n,s=u(e[c]));return u.isReadable(t,s,{level:a,size:o})||!i?s:(r.includeFallbackColors=!1,u.mostReadable(t,["#fff","#000"],r))};var z=u.names={aliceblue:"f0f8ff",antiquewhite:"faebd7",aqua:"0ff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000",blanchedalmond:"ffebcd",blue:"00f",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",burntsienna:"ea7e5d",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"0ff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkgrey:"a9a9a9",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkslategrey:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dimgrey:"696969",dodgerblue:"1e90ff",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"f0f",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",grey:"808080",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgray:"d3d3d3",lightgreen:"90ee90",lightgrey:"d3d3d3",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslategray:"789",lightslategrey:"789",lightsteelblue:"b0c4de",lightyellow:"ffffe0",lime:"0f0",limegreen:"32cd32",linen:"faf0e6",magenta:"f0f",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370db",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"db7093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",rebeccapurple:"663399",red:"f00",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",slategrey:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",wheat:"f5deb3",white:"fff",whitesmoke:"f5f5f5",yellow:"ff0",yellowgreen:"9acd32"},O=u.hexNames=D(z);function D(t)[var e={];for(var r in t)t.hasOwnProperty(r)&&(e[t[r]]=r);return e}function R(t){return t=parseFloat(t),(isNaN(t)||t<0||t>1)&&(t=1),t}function F(t,r){j(t)&&(t='100%');var n=U(t);return t=s(r,l(0,parseFloat(t))),n&&(t=parseInt(t*r,10)/100),e.abs(t-r)<1e-6?1:t%r/parseFloat(r)}function B(t){return s(1,l(0,t))}function N(t){return parseInt(t,16)}function j(t){return"string"==typeof t&&-1!=t.indexOf('.')&&1===parseFloat(t)}function U(t){return"string"===typeof t&&-1!=t.indexOf('%')}function V(t){return 1==t.length?"0"+t:""+t}function H(t){return t<=1&&(t=100*t+"%"),t}function q(t){return e.round(255*parseFloat(t)).toString(16)}function G(t){return N(t)/255}var Y=function(){var t='(?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?)',e='[\\s|\\(]+('+t+')[,|\\s]+('+t+')[,|\\s]+('+t+')\\s*\\)?',r='[\\s|\\(]+('+t+')[,|\\s]+('+t+')[,|\\s]+('+t+')[,|\\s]+('+t+')\\s*\\)?';return{CSS_UNIT:new RegExp(t),rgb:new RegExp("rgb"+e),rgba:new RegExp("rgba"+r),hsl:new RegExp("hsl"+e),hsla:new RegExp("hsla"+r),hsv:new RegExp("hsv"+e),hsva:new RegExp("hsva"+r),hex3:/^#?([0-9a-fA-F]{1})([0-9a-fA-F][1])([0-9a-fA-F][1])$/,hex6:/^#?([0-9a-fA-F][2])([0-9a-fA-F][2])([0-9a-fA-F][2])$/,hex4:/^#?([0-9a-fA-F][1])([0-9a-fA-F][1])([0-9a-fA-F][1])([0-9a-fA-F][1])$/,hex8:/^#?([0-9a-fA-F][2])([0-9a-fA-F][2])([0-9a-fA-F][2])([0-9a-fA-F][2])$/}}();function W(t){return!!Y.CSS_UNIT.exec(t)}function X(t){t=t.replace(n,'').replace(i,'').toLowerCase();var e,r=!1;if(z[t])t=z[t],r=!0;else if("transparent"==t)return{r:0,g:0,b:0,a:0,format:"name"};return(e=Y.rgb.exec(t))?{r:e[1],g:e[2],b:e[3]}:(e=Y.rgba.exec(t))?{r:e[1],g:e[2],b:e[3],a:e[4]}:(e=Y.hsl.exec(t))?{h:e[1],s:e[2],l:e[3]}:(e=Y.hsla.exec(t))?{h:e[1],s:e[2],l:e[3],a:e[4]}:(e=Y.hsv.exec(t))?{h:e[1],s:e[2],v:e[3]}:(e=Y.hsva.exec(t))?{h:e[1],s:e[2],v:e[3],a:e[4]}:(e=Y.hex8.exec(t))?{r:N(e[1]),g:N(e[2]),b:N(e[3]),a:G(e[4]),format:r?"name":"hex8"}:(e=Y.hex6.exec(t))?{r:N(e[1]),g:N(e[2]),b:N(e[3]),format:r?"name":"hex"}:(e=Y.hex4.exec(t))?{r:N(e[1]+""+e[1]),g:N(e[2]+""+e[2]),b:N(e[3]+""+e[3]),a:G(e[4]+""+e[4]),format:r?"name":"hex8"}:!!(e=Y.hex3.exec(t))&&{r:N(e[1]+""+e[1]),g:N(e[2]+""+e[2]),b:N(e[3]+""+e[3]),format:r?"name":"hex"}}function Z(t){var e,r;return"AA"!==(e=((t=t||{level:"AA",size:"small"}).level||"AA").toUpperCase())&&"AAA"!==e&&(e='AA'),"small"!==(r=(t.size||"small").toLowerCase())&&"large"!==r&&(r='small'),{level:e,size:r}}"undefined"!==typeof r&&r.exports?r.exports=u:"function"===typeof t&&t.amd?t((function(){return u})):window.tinycolor=u}(Math)},{}],584:[function(t,e,r){"use strict";e.exports=a,e.exports.float32=e.exports.float=a,e.exports.fract32=e.exports.fract=i;var n=new Float32Array(1);function i(t,e){if(t.length){if(t instanceof Float32Array)return new Float32Array(t.length);e instanceof Float32Array||(e=a(t));for(var r=0,n=e.length;r<n;r++)e[r]=t[r]-e[r];return e}return a(t-a(t))}function a(t){return t.length?t instanceof Float32Array?t:new Float32Array(t):(n[0]=t,n[0])}},{}],585:[function(t,e,r){"use strict";var n=t('parse-unit');e.exports=s;var i=96;function a(t,e){var r=n(getComputedStyle(t).getPropertyValue(e));return r[0]*s(r[1],t)}function o(t,e){var r=document.createElement('div');r.style["font-size"]="128"+t,e.appendChild(r);var n=a(r,'font-size')/128;return e.removeChild(r),n}function s(t,e){switch(e=e||document.body,t=(t||"px").trim().toLowerCase(),e!==window&&e!==document||(e=document.body),t){case"%":return e.clientHeight/100;case"ch":case"ex":return o(t,e);case"em":return a(e,'font-size');case"rem":return a(document.body,'font-size');case"vw":return window.innerWidth/100;case"vh":return window.innerHeight/100;case"vmin":return Math.min(window.innerWidth,window.innerHeight)/100;case"vmax":return Math.max(window.innerWidth,window.innerHeight)/100;case"in":return i;case"cm":return i/2.54;case"mm":return i/25.4;case"pt":return i/72;case"pc":return i/6}return 1}},{"parse-unit":483}],586:[function(e,r,n){var i,a;i=this,a=function(t){"use strict";function e(t){return t}function r(t){if(null==t)return e;var r,n,i=t.scale[0],a=t.scale[1],o=t.translate[0],s=t.translate[1];return function(t,e){e||(r=n=0);var l=2,c=t.length,u=new Array(c);for(u[0]=(r+=t[0])*i+o,u[1]=(n+=t[1])*a+s;l<c;)u[l]=t[l],++l;return u}}function n(t){var e,n=r(t.transform),i=1/0,a=i,o=-i,s=-i;function l(t){(t=n(t))[0]<i&&(i=t[0]),t[0]>o&&(o=t[0]),t[1]<a&&(a=t[1]),t[1]>s&&(s=t[1])}function c(t){switch(t.type){case"GeometryCollection":t.geometries.forEach(c);break;case"Point":l(t.coordinates);break;case"MultiPoint":t.coordinates.forEach(l)}}for(e in t.arcs.forEach((function(t){for(var e,r=-1,l=t.length;++r<l;)(e=n(t[r],r))[0]<i&&(i=e[0]),e[0]>o&&(o=e[0]),e[1]<a&&(a=e[1]),e[1]>s&&(s=e[1])})),t.objects)c(t.objects[e]);return[i,a,o,s]}function i(t,e){for(var r,n=t.length,i=n-e;i<--n;)r=t[i],t[i++]=t[n],t[n]=r}function a(t,e){return"string"===typeof e&&(e=t.objects[e]),"GeometryCollection"===e.type?{type:"FeatureCollection",features:e.geometries.map((function(e){return o(t,e)}))}:o(t,e)}function o(t,e){var r=e.id,n=e.bbox,i=null==e.properties?{}:e.properties,a=s(t,e);return null==r&&null==n?{type:"Feature",properties:i,geometry:a}:null==n?{type:"Feature",id:r,properties:i,geometry:a}:{type:"Feature",id:r,bbox:n,properties:i,geometry:a}}function s(t,e){var n=r(t.transform),a=t.arcs;function o(t,e){e.length&&e.pop();for(var r=a[t<0?~t:t],o=0,s=r.length;o<s;++o)e.push(n(r[o],o));t<0&&i(e,s)}function s(t){return n(t)}function l(t){for(var e=[],r=0,n=t.length;r<n;++r)o(t[r],e);return e.length<2&&e.push(e[0]),e}function c(t){for(var e=l(t);e.length<4;)e.push(e[0]);return e}function u(t){return t.map(c)}function f(t){var e,r=t.type;switch(r){case"GeometryCollection":return{type:r,geometries:t.geometries.map(f)};case"Point":e=s(t.coordinates);break;case"MultiPoint":e=t.coordinates.map(s);break;case"LineString":e=l(t.arcs);break;case"MultiLineString":e=t.arcs.map(l);break;case"Polygon":e=u(t.arcs);break;case"MultiPolygon":e=t.arcs.map(u);break;default:return null}return{type:r,coordinates:e}}return f(e)}function l(t,e)[var r={],n={},i={},a=[],o=-1;function s(e){var r,n=t.arcs[e<0?~e:e],i=n[0];return t.transform?(r=[0,0],n.forEach((function(t){r[0]+=t[0],r[1]+=t[1]}))):r=n[n.length-1],e<0?[r,i]:[i,r]}function l(t,e){for(var n in t){var i=t[n];delete e[i.start],delete i.start,delete i.end,i.forEach((function(t){r[t<0?~t:t]=1})),a.push(i)}}return e.forEach((function(r,n){var i,a=t.arcs[r<0?~r:r];a.length<3&&!a[1][0]&&!a[1][1]&&(i=e[++o],e[o]=r,e[n]=i)})),e.forEach((function(t){var e,r,a=s(t),o=a[0],l=a[1];if(e=i[o])if(delete i[e.end],e.push(t),e.end=l,r=n[l]){delete n[r.start];var c=r===e?e:e.concat(r);n[c.start=e.start]=i[c.end=r.end]=c}else n[e.start]=i[e.end]=e;else if(e=n[l])if(delete n[e.start],e.unshift(t),e.start=o,r=i[o]){delete i[r.end];var u=r===e?e:r.concat(e);n[u.start=r.start]=i[u.end=e.end]=u}else n[e.start]=i[e.end]=e;else n[(e=[t]).start=o]=i[e.end=l]=e})),l(i,n),l(n,i),e.forEach((function(t){r[t<0?~t:t]||a.push([t])})),a}function c(t){return s(t,u.apply(this,arguments))}function u(t,e,r){var n,i,a;if(arguments.length>1)n=f(t,e,r);else for(i=0,n=new Array(a=t.arcs.length);i<a;++i)n[i]=i;return{type:"MultiLineString",arcs:l(t,n)}}function f(t,e,r){var n,i=[],a=[];function o(t){var e=t<0?~t:t;(a[e]||(a[e]=[])).push({i:t,g:n})}function s(t)[t.forEach(o)]function l(t)[t.forEach(s)]function c(t)[t.forEach(l)]function u(t){switch(n=t,t.type){case"GeometryCollection":t.geometries.forEach(u);break;case"LineString":s(t.arcs);break;case"MultiLineString":case"Polygon":l(t.arcs);break;case"MultiPolygon":c(t.arcs)}}return u(e),a.forEach(null==r?function(t)[i.push(t[0].i)]:function(t){r(t[0].g,t[t.length-1].g)&&i.push(t[0].i)}),i}function h(t){for(var e,r=-1,n=t.length,i=t[n-1],a=0;++r<n;)e=i,i=t[r],a+=e[0]*i[1]-e[1]*i[0];return Math.abs(a)}function p(t){return s(t,d.apply(this,arguments))}function d(t,e)[var r={],n=[],i=[];function a(t){switch(t.type){case"GeometryCollection":t.geometries.forEach(a);break;case"Polygon":o(t.arcs);break;case"MultiPolygon":t.arcs.forEach(o)}}function o(t){t.forEach((function(e){e.forEach((function(e){(r[e=e<0?~e:e]||(r[e]=[])).push(t)}))})),n.push(t)}function c(e){return h(s(t,{type:"Polygon",arcs:[e]}).coordinates[0])}return e.forEach(a),n.forEach((function(t){if(!t._){var e=[],n=[t];for(t._=1,i.push(e);t=n.pop();)e.push(t),t.forEach((function(t){t.forEach((function(t){r[t<0?~t:t].forEach((function(t){t._||(t._=1,n.push(t))}))}))}))}})),n.forEach((function(t)[delete t._])),{type:"MultiPolygon",arcs:i.map((function(e){var n,i=[];if(e.forEach((function(t){t.forEach((function(t){t.forEach((function(t){r[t<0?~t:t].length<2&&i.push(t)}))}))})),(n=(i=l(t,i)).length)>1)for(var a,o,s=1,u=c(i[0]);s<n;++s)(a=c(i[s]))>u&&(o=i[0],i[0]=i[s],i[s]=o,u=a);return i})).filter((function(t){return t.length>0}))}}function m(t,e){for(var r=0,n=t.length;r<n;){var i=r+n>>>1;t[i]<e?r=i+1:n=i}return r}function g(t)[var e={],r=t.map((function(){return[]}));function n(t,r){t.forEach((function(t){t<0&&(t=~t);var n=e[t];n?n.push(r):e[t]=[r]}))}function i(t,e){t.forEach((function(t){n(t,e)}))}function a(t,e){"GeometryCollection"===t.type?t.geometries.forEach((function(t){a(t,e)})):t.type in o&&o[t.type](t.arcs,e)}var o={LineString:n,MultiLineString:i,Polygon:i,MultiPolygon:function(t,e){t.forEach((function(t){i(t,e)}))}};for(var s in t.forEach(a),e)for(var l=e[s],c=l.length,u=0;u<c;++u)for(var f=u+1;f<c;++f){var h,p=l[u],d=l[f];(h=r[p])[s=m(h,d)]!==d&&h.splice(s,0,d),(h=r[d])[s=m(h,p)]!==p&&h.splice(s,0,p)}return r}function v(t){if(null==t)return e;var r,n,i=t.scale[0],a=t.scale[1],o=t.translate[0],s=t.translate[1];return function(t,e){e||(r=n=0);var l=2,c=t.length,u=new Array(c),f=Math.round((t[0]-o)/i),h=Math.round((t[1]-s)/a);for(u[0]=f-r,r=f,u[1]=h-n,n=h;l<c;)u[l]=t[l],++l;return u}}function y(t,e){if(t.transform)throw new Error('already quantized');if(e&&e.scale)l=t.bbox;else{if(!((r=Math.floor(e))>=2))throw new Error('n must be \u22652');var r,i=(l=t.bbox||n(t))[0],a=l[1],o=l[2],s=l[3];e={scale:[o-i?(o-i)/(r-1):1,s-a?(s-a)/(r-1):1],translate:[i,a]}}var l,c,u=v(e),f=t.objects,h={};function p(t){return u(t)}function d(t){var e;switch(t.type){case"GeometryCollection":e={type:"GeometryCollection",geometries:t.geometries.map(d)};break;case"Point":e={type:"Point",coordinates:p(t.coordinates)};break;case"MultiPoint":e={type:"MultiPoint",coordinates:t.coordinates.map(p)};break;default:return t}return null!=t.id&&(e.id=t.id),null!=t.bbox&&(e.bbox=t.bbox),null!=t.properties&&(e.properties=t.properties),e}function m(t){var e,r=0,n=1,i=t.length,a=new Array(i);for(a[0]=u(t[0],0);++r<i;)((e=u(t[r],r))[0]||e[1])&&(a[n++]=e);return 1===n&&(a[n++]=[0,0]),a.length=n,a}for(c in f)h[c]=d(f[c]);return{type:"Topology",bbox:l,transform:e,objects:h,arcs:t.arcs.map(m)}}t.bbox=n,t.feature=a,t.merge=p,t.mergeArcs=d,t.mesh=c,t.meshArcs=u,t.neighbors=g,t.quantize=y,t.transform=r,t.untransform=v,Object.defineProperty(t,'__esModule',{value:!0})},"object"===typeof n&&"undefined"!==typeof r?a(n):"function"===typeof t&&t.amd?t(["exports"],a):a((i=i||self).topojson=i.topojson||{})},{}],587:[function(t,e,r){"use strict";e.exports=m;var n=t('filtered-vector'),i=t('gl-mat4/invert'),a=t('gl-mat4/rotate'),o=t('gl-vec3/cross'),s=t('gl-vec3/normalize'),l=t('gl-vec3/dot');function c(t,e,r){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2))}function u(t){return Math.min(1,Math.max(-1,t))}function f(t){var e=Math.abs(t[0]),r=Math.abs(t[1]),n=Math.abs(t[2]),i=[0,0,0];e>Math.max(r,n)?i[2]=1:r>Math.max(e,n)?i[0]=1:i[1]=1;for(var a=0,o=0,l=0;l<3;++l)a+=t[l]*t[l],o+=i[l]*t[l];for(l=0;l<3;++l)i[l]-=o/a*t[l];return s(i,i),i}function h(t,e,r,i,a,o,s,l){this.center=n(r),this.up=n(i),this.right=n(a),this.radius=n([o]),this.angle=n([s,l]),this.angle.bounds=[[-1/0,-Math.PI/2],[1/0,Math.PI/2]],this.setDistanceLimits(t,e),this.computedCenter=this.center.curve(0),this.computedUp=this.up.curve(0),this.computedRight=this.right.curve(0),this.computedRadius=this.radius.curve(0),this.computedAngle=this.angle.curve(0),this.computedToward=[0,0,0],this.computedEye=[0,0,0],this.computedMatrix=new Array(16);for(var c=0;c<16;++c)this.computedMatrix[c]=.5;this.recalcMatrix(0)}var p=h.prototype;p.setDistanceLimits=function(t,e){t=t>0?Math.log(t):-1/0,e=e>0?Math.log(e):1/0,e=Math.max(e,t),this.radius.bounds[0][0]=t,this.radius.bounds[1][0]=e},p.getDistanceLimits=function(t){var e=this.radius.bounds[0];return t?(t[0]=Math.exp(e[0][0]),t[1]=Math.exp(e[1][0]),t):[Math.exp(e[0][0]),Math.exp(e[1][0])]},p.recalcMatrix=function(t){this.center.curve(t),this.up.curve(t),this.right.curve(t),this.radius.curve(t),this.angle.curve(t);for(var e=this.computedUp,r=this.computedRight,n=0,i=0,a=0;a<3;++a)i+=e[a]*r[a],n+=e[a]*e[a];var l=Math.sqrt(n),u=0;for(a=0;a<3;++a)r[a]-=e[a]*i/n,u+=r[a]*r[a],e[a]/=l;var f=Math.sqrt(u);for(a=0;a<3;++a)r[a]/=f;var h=this.computedToward;o(h,e,r),s(h,h);var p=Math.exp(this.computedRadius[0]),d=this.computedAngle[0],m=this.computedAngle[1],g=Math.cos(d),v=Math.sin(d),y=Math.cos(m),x=Math.sin(m),b=this.computedCenter,_=g*y,w=v*y,T=x,k=-g*x,M=-v*x,A=y,S=this.computedEye,E=this.computedMatrix;for(a=0;a<3;++a){var L=_*r[a]+w*h[a]+T*e[a];E[4*a+1]=k*r[a]+M*h[a]+A*e[a],E[4*a+2]=L,E[4*a+3]=0}var C=E[1],P=E[5],I=E[9],z=E[2],O=E[6],D=E[10],R=P*D-I*O,F=I*z-C*D,B=C*O-P*z,N=c(R,F,B);for(R/=N,F/=N,B/=N,E[0]=R,E[4]=F,E[8]=B,a=0;a<3;++a)S[a]=b[a]+E[2+4*a]*p;for(a=0;a<3;++a){u=0;for(var j=0;j<3;++j)u+=E[a+4*j]*S[j];E[12+a]=-u}E[15]=1},p.getMatrix=function(t,e){this.recalcMatrix(t);var r=this.computedMatrix;if(e){for(var n=0;n<16;++n)e[n]=r[n];return e}return r};var d=[0,0,0];function m(t)[var e=(t=t||{]).center||[0,0,0],r=t.up||[0,1,0],n=t.right||f(r),i=t.radius||1,a=t.theta||0,u=t.phi||0;if(e=[].slice.call(e,0,3),r=[].slice.call(r,0,3),s(r,r),n=[].slice.call(n,0,3),s(n,n),"eye"in t){var p=t.eye,d=[p[0]-e[0],p[1]-e[1],p[2]-e[2]];o(n,d,r),c(n[0],n[1],n[2])<1e-6?n=f(r):s(n,n),i=c(d[0],d[1],d[2]);var m=l(r,d)/i,g=l(n,d)/i;u=Math.acos(m),a=Math.acos(g)}return i=Math.log(i),new h(t.zoomMin,t.zoomMax,e,r,n,i,a,u)}p.rotate=function(t,e,r,n){if(this.angle.move(t,e,r),n){this.recalcMatrix(t);var i=this.computedMatrix;d[0]=i[2],d[1]=i[6],d[2]=i[10];for(var o=this.computedUp,s=this.computedRight,l=this.computedToward,c=0;c<3;++c)i[4*c]=o[c],i[4*c+1]=s[c],i[4*c+2]=l[c];for(a(i,i,n,d),c=0;c<3;++c)o[c]=i[4*c],s[c]=i[4*c+1];this.up.set(t,o[0],o[1],o[2]),this.right.set(t,s[0],s[1],s[2])}},p.pan=function(t,e,r,n){e=e||0,r=r||0,n=n||0,this.recalcMatrix(t);var i=this.computedMatrix,a=(Math.exp(this.computedRadius[0]),i[1]),o=i[5],s=i[9],l=c(a,o,s);a/=l,o/=l,s/=l;var u=i[0],f=i[4],h=i[8],p=u*a+f*o+h*s,d=c(u-=a*p,f-=o*p,h-=s*p),m=(u/=d)*e+a*r,g=(f/=d)*e+o*r,v=(h/=d)*e+s*r;this.center.move(t,m,g,v);var y=Math.exp(this.computedRadius[0]);y=Math.max(1e-4,y+n),this.radius.set(t,Math.log(y))},p.translate=function(t,e,r,n){this.center.move(t,e||0,r||0,n||0)},p.setMatrix=function(t,e,r,n){var a=1;"number"===typeof r&&(a=0|r),(a<0||a>3)&&(a=1);var o=(a+2)%3;e||(this.recalcMatrix(t),e=this.computedMatrix);var s=e[a],l=e[a+4],f=e[a+8];if(n){var h=Math.abs(s),p=Math.abs(l),d=Math.abs(f),m=Math.max(h,p,d);h===m?(s=s<0?-1:1,l=f=0):d===m?(f=f<0?-1:1,s=l=0):(l=l<0?-1:1,s=f=0)}else{var g=c(s,l,f);s/=g,l/=g,f/=g}var v,y,x=e[o],b=e[o+4],_=e[o+8],w=x*s+b*l+_*f,T=c(x-=s*w,b-=l*w,_-=f*w),k=l*(_/=T)-f*(b/=T),M=f*(x/=T)-s*_,A=s*b-l*x,S=c(k,M,A);if(k/=S,M/=S,A/=S,this.center.jump(t,q,G,Y),this.radius.idle(t),this.up.jump(t,s,l,f),this.right.jump(t,x,b,_),2===a){var E=e[1],L=e[5],C=e[9],P=E*x+L*b+C*_,I=E*k+L*M+C*A;v=R<0?-Math.PI/2:Math.PI/2,y=Math.atan2(I,P)}else{var z=e[2],O=e[6],D=e[10],R=z*s+O*l+D*f,F=z*x+O*b+D*_,B=z*k+O*M+D*A;v=Math.asin(u(R)),y=Math.atan2(B,F)}this.angle.jump(t,y,v),this.recalcMatrix(t);var N=e[2],j=e[6],U=e[10],V=this.computedMatrix;i(V,e);var H=V[15],q=V[12]/H,G=V[13]/H,Y=V[14]/H,W=Math.exp(this.computedRadius[0]);this.center.jump(t,q-N*W,G-j*W,Y-U*W)},p.lastT=function(){return Math.max(this.center.lastT(),this.up.lastT(),this.right.lastT(),this.radius.lastT(),this.angle.lastT())},p.idle=function(t){this.center.idle(t),this.up.idle(t),this.right.idle(t),this.radius.idle(t),this.angle.idle(t)},p.flush=function(t){this.center.flush(t),this.up.flush(t),this.right.flush(t),this.radius.flush(t),this.angle.flush(t)},p.setDistance=function(t,e){e>0&&this.radius.set(t,Math.log(e))},p.lookAt=function(t,e,r,n){this.recalcMatrix(t),e=e||this.computedEye,r=r||this.computedCenter;var i=(n=n||this.computedUp)[0],a=n[1],o=n[2],s=c(i,a,o);if(!(s<1e-6)){i/=s,a/=s,o/=s;var l=e[0]-r[0],f=e[1]-r[1],h=e[2]-r[2],p=c(l,f,h);if(!(p<1e-6)){l/=p,f/=p,h/=p;var d=this.computedRight,m=d[0],g=d[1],v=d[2],y=i*m+a*g+o*v,x=c(m-=y*i,g-=y*a,v-=y*o);if(!(x<.01&&(x=c(m=a*h-o*f,g=o*l-i*h,v=i*f-a*l))<1e-6)){m/=x,g/=x,v/=x,this.up.set(t,i,a,o),this.right.set(t,m,g,v),this.center.set(t,r[0],r[1],r[2]),this.radius.set(t,Math.log(p));var b=a*v-o*g,_=o*m-i*v,w=i*g-a*m,T=c(b,_,w),k=i*l+a*f+o*h,M=m*l+g*f+v*h,A=(b/=T)*l+(_/=T)*f+(w/=T)*h,S=Math.asin(u(k)),E=Math.atan2(A,M),L=this.angle._state,C=L[L.length-1],P=L[L.length-2];C%=2*Math.PI;var I=Math.abs(C+2*Math.PI-E),z=Math.abs(C-E),O=Math.abs(C-2*Math.PI-E);I<z&&(C+=2*Math.PI),O<z&&(C-=2*Math.PI),this.angle.jump(this.angle.lastT(),C,P),this.angle.set(t,E,S)}}}}},{"filtered-vector":247,"gl-mat4/invert":293,"gl-mat4/rotate":299,"gl-vec3/cross":360,"gl-vec3/dot":365,"gl-vec3/normalize":382}],588:[function(t,e,r){"use strict";e.exports=i;var n=+(Math.pow(2,27)+1);function i(t,e,r){var i=t*e,a=n*t,o=a-(a-t),s=t-o,l=n*e,c=l-(l-e),u=e-c,f=s*u-(i-o*c-s*c-o*u);return r?(r[0]=f,r[1]=i,r):[f,i]}},{}],589:[function(t,e,r){"use strict";function n(t,e,r){var n=t+e,i=n-t,a=e-i,o=t-(n-i);return r?(r[0]=o+a,r[1]=n,r):[o+a,n]}e.exports=n},{}],590:[function(t,e,r){"use strict";var n=t('../prototype/is');e.exports=function(t){if("function"!==typeof t)return!1;if(!hasOwnProperty.call(t,'length'))return!1;try{if("number"!==typeof t.length)return!1;if("function"!==typeof t.call)return!1;if("function"!==typeof t.apply)return!1}catch(e){return!1}return!n(t)}},{"../prototype/is":597}],591:[function(t,e,r){"use strict";var n=t('../value/is'),i=t('../object/is'),a=t('../string/coerce'),o=t('./to-short-string'),s=function(t,e){return t.replace('%v',o(e))};e.exports=function(t,e,r){if(!i(r))throw new TypeError(s(e,t));if(!n(t)){if("default"in r)return r.default;if(r.isOptional)return null}var o=a(r.errorMessage);throw n(o)||(o=e),new TypeError(s(o,t))}},{"../object/is":594,"../string/coerce":598,"../value/is":600,"./to-short-string":593}],592:[function(t,e,r){"use strict";e.exports=function(t){try{return t.toString()}catch(e){try{return String(t)}catch(r){return null}}}},{}],593:[function(t,e,r){"use strict";var n=t('./safe-to-string'),i=/[\n\r\u2028\u2029]/g;e.exports=function(t){var e=n(t);return null===e?"<Non-coercible to string value>":(e.length>100&&(e=e.slice(0,99)+"\u2026"),e=e.replace(i,(function(t){switch(t){case"\n":return'\\n';case"\r":return'\\r';case"\u2028":return'\\u2028';case"\u2029":return'\\u2029';default:throw new Error('Unexpected character')}})))}},{"./safe-to-string":592}],594:[function(t,e,r){"use strict";var n=t('../value/is'),i={object:!0,function:!0,undefined:!0};e.exports=function(t){return!!n(t)&&hasOwnProperty.call(i,typeof t)}},{"../value/is":600}],595:[function(t,e,r){"use strict";var n=t('../lib/resolve-exception'),i=t('./is');e.exports=function(t){return i(t)?t:n(t,'%v is not a plain function',arguments[1])}},{"../lib/resolve-exception":591,"./is":596}],596:[function(t,e,r){"use strict";var n=t('../function/is'),i=/^\s*class[\s{/}]/,a=Function.prototype.toString;e.exports=function(t){return!!n(t)&&!i.test(a.call(t))}},{"../function/is":590}],597:[function(t,e,r){"use strict";var n=t('../object/is');e.exports=function(t){if(!n(t))return!1;try{return!!t.constructor&&t.constructor.prototype===t}catch(e){return!1}}},{"../object/is":594}],598:[function(t,e,r){"use strict";var n=t('../value/is'),i=t('../object/is'),a=Object.prototype.toString;e.exports=function(t){if(!n(t))return null;if(i(t)){var e=t.toString;if("function"!==typeof e)return null;if(e===a)return null}try{return""+t}catch(r){return null}}},{"../object/is":594,"../value/is":600}],599:[function(t,e,r){"use strict";var n=t('../lib/resolve-exception'),i=t('./is');e.exports=function(t){return i(t)?t:n(t,'Cannot use %v',arguments[1])}},{"../lib/resolve-exception":591,"./is":600}],600:[function(t,e,r){"use strict";var n=void 0;e.exports=function(t){return t!==n&&null!==t}},{}],601:[function(t,e,n){(function(e){(function(){"use strict";var r=t('bit-twiddle'),i=t('dup'),a=t('buffer').Buffer;e.__TYPEDARRAY_POOL||(e.__TYPEDARRAY_POOL={UINT8:i([32,0]),UINT16:i([32,0]),UINT32:i([32,0]),BIGUINT64:i([32,0]),INT8:i([32,0]),INT16:i([32,0]),INT32:i([32,0]),BIGINT64:i([32,0]),FLOAT:i([32,0]),DOUBLE:i([32,0]),DATA:i([32,0]),UINT8C:i([32,0]),BUFFER:i([32,0])});var o="undefined"!==typeof Uint8ClampedArray,s="undefined"!==typeof BigUint64Array,l="undefined"!==typeof BigInt64Array,c=e.__TYPEDARRAY_POOL;c.UINT8C||(c.UINT8C=i([32,0])),c.BIGUINT64||(c.BIGUINT64=i([32,0])),c.BIGINT64||(c.BIGINT64=i([32,0])),c.BUFFER||(c.BUFFER=i([32,0]));var u=c.DATA,f=c.BUFFER;function h(t){if(t){var e=t.length||t.byteLength,n=r.log2(e);u[n].push(t)}}function p(t)[h(t.buffer)]function d(t){t=r.nextPow2(t);var e=r.log2(t),n=u[e];return n.length>0?n.pop():new ArrayBuffer(t)}function m(t){return new Uint8Array(d(t),0,t)}function g(t){return new Uint16Array(d(2*t),0,t)}function v(t){return new Uint32Array(d(4*t),0,t)}function y(t){return new Int8Array(d(t),0,t)}function x(t){return new Int16Array(d(2*t),0,t)}function b(t){return new Int32Array(d(4*t),0,t)}function _(t){return new Float32Array(d(4*t),0,t)}function w(t){return new Float64Array(d(8*t),0,t)}function T(t){return o?new Uint8ClampedArray(d(t),0,t):m(t)}function k(t){return s?new BigUint64Array(d(8*t),0,t):null}function M(t){return l?new BigInt64Array(d(8*t),0,t):null}function A(t){return new DataView(d(t),0,t)}function S(t){t=r.nextPow2(t);var e=r.log2(t),n=f[e];return n.length>0?n.pop():new a(t)}n.free=function(t){if(a.isBuffer(t))f[r.log2(t.length)].push(t);else{if("[object ArrayBuffer]"!==Object.prototype.toString.call(t)&&(t=t.buffer),!t)return;var e=t.length||t.byteLength,n=0|r.log2(e);u[n].push(t)}},n.freeUint8=n.freeUint16=n.freeUint32=n.freeBigUint64=n.freeInt8=n.freeInt16=n.freeInt32=n.freeBigInt64=n.freeFloat32=n.freeFloat=n.freeFloat64=n.freeDouble=n.freeUint8Clamped=n.freeDataView=p,n.freeArrayBuffer=h,n.freeBuffer=function(t)[f[r.log2(t.length)].push(t)],n.malloc=function(t,e){if(void 0===e||"arraybuffer"===e)return d(t);switch(e){case"uint8":return m(t);case"uint16":return g(t);case"uint32":return v(t);case"int8":return y(t);case"int16":return x(t);case"int32":return b(t);case"float":case"float32":return _(t);case"double":case"float64":return w(t);case"uint8_clamped":return T(t);case"bigint64":return M(t);case"biguint64":return k(t);case"buffer":return S(t);case"data":case"dataview":return A(t);default:return null}return null},n.mallocArrayBuffer=d,n.mallocUint8=m,n.mallocUint16=g,n.mallocUint32=v,n.mallocInt8=y,n.mallocInt16=x,n.mallocInt32=b,n.mallocFloat32=n.mallocFloat=_,n.mallocFloat64=n.mallocDouble=w,n.mallocUint8Clamped=T,n.mallocBigUint64=k,n.mallocBigInt64=M,n.mallocDataView=A,n.mallocBuffer=S,n.clearCache=function(){for(var t=0;t<32;++t)c.UINT8[t].length=0,c.UINT16[t].length=0,c.UINT32[t].length=0,c.INT8[t].length=0,c.INT16[t].length=0,c.INT32[t].length=0,c.FLOAT[t].length=0,c.DOUBLE[t].length=0,c.BIGUINT64[t].length=0,c.BIGINT64[t].length=0,c.UINT8C[t].length=0,u[t].length=0,f[t].length=0}}).call(this)}).call(this,"undefined"!==typeof r.g?r.g:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"bit-twiddle":104,buffer:117,dup:182}],602:[function(t,e,r){"use strict";function n(t){this.roots=new Array(t),this.ranks=new Array(t);for(var e=0;e<t;++e)this.roots[e]=e,this.ranks[e]=0}e.exports=n;var i=n.prototype;Object.defineProperty(i,'length',{get:function(){return this.roots.length}}),i.makeSet=function(){var t=this.roots.length;return this.roots.push(t),this.ranks.push(0),t},i.find=function(t){for(var e=t,r=this.roots;r[t]!==t;)t=r[t];for(;r[e]!==t;){var n=r[e];r[e]=t,e=n}return t},i.link=function(t,e){var r=this.find(t),n=this.find(e);if(r!==n){var i=this.ranks,a=this.roots,o=i[r],s=i[n];o<s?a[r]=n:s<o?a[n]=r:(a[n]=r,++i[r])}}},{}],603:[function(t,e,r){"use strict";function n(t,e){for(var r=1,n=t.length,i=t[0],a=t[0],o=1;o<n;++o)if(a=i,e(i=t[o],a)){if(o===r){r++;continue}t[r++]=i}return t.length=r,t}function i(t){for(var e=1,r=t.length,n=t[0],i=t[0],a=1;a<r;++a,i=n)if(i=n,(n=t[a])!==i){if(a===e){e++;continue}t[e++]=n}return t.length=e,t}function a(t,e,r){return 0===t.length?t:e?(r||t.sort(e),n(t,e)):(r||t.sort(),i(t))}e.exports=a},{}],604:[function(t,e,r){var n=/[\'\"]/;e.exports=function(t){return t?(n.test(t.charAt(0))&&(t=t.substr(1)),n.test(t.charAt(t.length-1))&&(t=t.substr(0,t.length-1)),t):""}},{}],605:[function(t,e,r){"use strict";e.exports=function(t,e,r){Array.isArray(r)||(r=[].slice.call(arguments,2));for(var n=0,i=r.length;n<i;n++){var a=r[n];for(var o in a)if((void 0===e[o]||Array.isArray(e[o])||t[o]!==e[o])&&o in e){var s;if(!0===a[o])s=e[o];else{if(!1===a[o])continue;if("function"===typeof a[o]&&void 0===(s=a[o](e[o],t,e)))continue}t[o]=s}}return t}},{}],606:[function(t,e,n){(function(t){(function(){function r(t,e){if(n('noDeprecation'))return t;var r=!1;function i(){if(!r){if(n('throwDeprecation'))throw new Error(e);n('traceDeprecation')?console.trace(e):console.warn(e),r=!0}return t.apply(this,arguments)}return i}function n(e){try{if(!t.localStorage)return!1}catch(n){return!1}var r=t.localStorage[e];return null!=r&&"true"===String(r).toLowerCase()}e.exports=r}).call(this)}).call(this,"undefined"!==typeof r.g?r.g:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{}],607:[function(t,e,r){"use strict";e.exports=o;var n=t('./lib/vtext'),i=null,a=null;function o(t,e){return"object"===typeof e&&null!==e||(e={}),n(t,e.canvas||i,e.context||a,e)}"undefined"!==typeof document&&((i=document.createElement('canvas')).width=8192,i.height=1024,a=i.getContext('2d'))},{"./lib/vtext":608}],608:[function(t,e,r){e.exports=M,e.exports.processPixels=k;var n=t('surface-nets'),i=t('ndarray'),a=t('simplify-planar-graph'),o=t('clean-pslg'),s=t('cdt2d'),l=t('planar-graph-to-polyline'),c='b',u='b|',f='i',h='i|',p='sup',d='+',m='+1',g='sub',v='-',y='-1';function x(t,e,r,n){for(var i="<"+t+">",a="</"+t+">",o=i.length,s=a.length,l=e[0]===d||e[0]===v,c=0,u=-s;c>-1&&-1!==(c=r.indexOf(i,c))&&-1!==(u=r.indexOf(a,c+o))&&!(u<=c);){for(var f=c;f<u+s;++f)if(f<c+o||f>=u)n[f]=null,r=r.substr(0,f)+" "+r.substr(f+1);else if(null!==n[f]){var h=n[f].indexOf(e[0]);-1===h?n[f]+=e:l&&(n[f]=n[f].substr(0,h+1)+(1+parseInt(n[f][h+1]))+n[f].substr(h+2))}var p=c+o,m=r.substr(p,u-p).indexOf(i);c=-1!==m?m:u+s}return n}function b(t,e,r){for(var n=e.textAlign||"start",i=e.textBaseline||"alphabetic",a=[1<<30,1<<30],o=[0,0],s=t.length,l=0;l<s;++l)for(var c=t[l],u=0;u<2;++u)a[u]=0|Math.min(a[u],c[u]),o[u]=0|Math.max(o[u],c[u]);var f=0;switch(n){case"center":f=-.5*(a[0]+o[0]);break;case"right":case"end":f=-o[0];break;case"left":case"start":f=-a[0];break;default:throw new Error("vectorize-text: Unrecognized textAlign: '"+n+"'")}var h=0;switch(i){case"hanging":case"top":h=-a[1];break;case"middle":h=-.5*(a[1]+o[1]);break;case"alphabetic":case"ideographic":h=-3*r;break;case"bottom":h=-o[1];break;default:throw new Error("vectorize-text: Unrecoginized textBaseline: '"+i+"'")}var p=1/r;return"lineHeight"in e?p*=+e.lineHeight:"width"in e?p=e.width/(o[0]-a[0]):"height"in e&&(p=e.height/(o[1]-a[1])),t.map((function(t){return[p*(t[0]+f),p*(t[1]+h)]}))}function _(t,e,r,n,a,o){r=r.replace(/\n/g,''),r=!0===o.breaklines?r.replace(/\<br\>/g,'\n'):r.replace(/\<br\>/g,' ');var s='',l=[];for(T=0;T<r.length;++T)l[T]=s;!0===o.bolds&&(l=x(c,u,r,l)),!0===o.italics&&(l=x(f,h,r,l)),!0===o.superscripts&&(l=x(p,m,r,l)),!0===o.subscripts&&(l=x(g,y,r,l));var b=[],_='';for(T=0;T<r.length;++T)null!==l[T]&&(_+=r[T],b.push(l[T]));var w,T,k,M,A,S=_.split('\n'),E=S.length,L=Math.round(a*n),C=n,P=2*n,I=0,z=E*L+P;t.height<z&&(t.height=z),e.fillStyle='#000',e.fillRect(0,0,t.width,t.height),e.fillStyle='#fff';var O=0,D='';function R(){if(""!==D){var t=e.measureText(D).width;e.fillText(D,C+k,P+M),k+=t}}function F(){return Math.round(A)+"px "}function B(t,r){var n=""+e.font;if(!0===o.subscripts){var i=t.indexOf(v),a=r.indexOf(v),s=i>-1?parseInt(t[1+i]):0,l=a>-1?parseInt(r[1+a]):0;s!==l&&(n=n.replace(F(),'?px '),A*=Math.pow(.75,l-s),n=n.replace('?px ',F())),M+=.25*L*(l-s)}if(!0===o.superscripts){var c=t.indexOf(d),f=r.indexOf(d),p=c>-1?parseInt(t[1+c]):0,m=f>-1?parseInt(r[1+f]):0;p!==m&&(n=n.replace(F(),'?px '),A*=Math.pow(.75,m-p),n=n.replace('?px ',F())),M-=.25*L*(m-p)}if(!0===o.bolds){var g=t.indexOf(u)>-1,y=r.indexOf(u)>-1;!g&&y&&(n=x?n.replace('italic ','italic bold '):"bold "+n),g&&!y&&(n=n.replace('bold ',''))}if(!0===o.italics){var x=t.indexOf(h)>-1,b=r.indexOf(h)>-1;!x&&b&&(n="italic "+n),x&&!b&&(n=n.replace('italic ',''))}e.font=n}for(w=0;w<E;++w){var N=S[w]+"\n";for(k=0,M=w*L,A=n,D='',T=0;T<N.length;++T){var j=T+O<b.length?b[T+O]:b[b.length-1];s===j?D+=N[T]:(R(),D=N[T],void 0!==j&&(B(s,j),s=j))}R(),O+=N.length;var U=0|Math.round(k+2*C);I<U&&(I=U)}var V=I,H=P+L*E;return i(e.getImageData(0,0,V,H).data,[H,V,4]).pick(-1,-1,0).transpose(1,0)}function w(t,e){var r=n(t,128);return e?a(r.cells,r.positions,.25):{edges:r.cells,positions:r.positions}}function T(t,e,r,n){var i=w(t,n),a=b(i.positions,e,r),c=i.edges,u="ccw"===e.orientation;if(o(a,c),e.polygons||e.polygon||e.polyline){for(var f=l(c,a),h=new Array(f.length),p=0;p<f.length;++p){for(var d=f[p],m=new Array(d.length),g=0;g<d.length;++g){for(var v=d[g],y=new Array(v.length),x=0;x<v.length;++x)y[x]=a[v[x]].slice();u&&y.reverse(),m[g]=y}h[p]=m}return h}return e.triangles||e.triangulate||e.triangle?{cells:s(a,c,{delaunay:!1,exterior:!1,interior:!0}),positions:a}:{edges:c,positions:a}}function k(t,e,r){try{return T(t,e,r,!0)}catch(n){}try{return T(t,e,r,!1)}catch(n){}return e.polygons||e.polyline||e.polygon?[]:e.triangles||e.triangulate||e.triangle?{cells:[],positions:[]}:{edges:[],positions:[]}}function M(t,e,r,n){var i=64,a=1.25,o={breaklines:!1,bolds:!1,italics:!1,subscripts:!1,superscripts:!1};return n&&(n.size&&n.size>0&&(i=n.size),n.lineSpacing&&n.lineSpacing>0&&(a=n.lineSpacing),n.styletags&&n.styletags.breaklines&&(o.breaklines=!!n.styletags.breaklines),n.styletags&&n.styletags.bolds&&(o.bolds=!!n.styletags.bolds),n.styletags&&n.styletags.italics&&(o.italics=!!n.styletags.italics),n.styletags&&n.styletags.subscripts&&(o.subscripts=!!n.styletags.subscripts),n.styletags&&n.styletags.superscripts&&(o.superscripts=!!n.styletags.superscripts)),r.font=[n.fontStyle,n.fontVariant,n.fontWeight,i+"px",n.font].filter((function(t){return t})).join(' '),r.textAlign='start',r.textBaseline='alphabetic',r.direction='ltr',k(_(e,r,t,i,a,o),n,i)}},{cdt2d:118,"clean-pslg":127,ndarray:472,"planar-graph-to-polyline":488,"simplify-planar-graph":549,"surface-nets":576}],609:[function(t,e,r){!function(){"use strict";if("undefined"===typeof ses||!ses.ok||ses.ok()){"undefined"!==typeof ses&&(ses.weakMapPermitHostObjects=g);var t=!1;if("function"===typeof WeakMap){var r=WeakMap;if("undefined"!==typeof navigator&&/Firefox/.test(navigator.userAgent));else{var n=new r,i=Object.freeze({});if(n.set(i,1),1===n.get(i))return void(e.exports=WeakMap);t=!0}}Object.prototype.hasOwnProperty;var a=Object.getOwnPropertyNames,o=Object.defineProperty,s=Object.isExtensible,l='weakmap:',c=l+"ident:"+Math.random()+"___";if("undefined"!==typeof crypto&&"function"===typeof crypto.getRandomValues&&"function"===typeof ArrayBuffer&&"function"===typeof Uint8Array){var u=new ArrayBuffer(25),f=new Uint8Array(u);crypto.getRandomValues(f),c=l+"rand:"+Array.prototype.map.call(f,(function(t){return(t%36).toString(36)})).join('')+"___"}if(o(Object,'getOwnPropertyNames',{value:function(t){return a(t).filter(v)}}),"getPropertyNames"in Object){var h=Object.getPropertyNames;o(Object,'getPropertyNames',{value:function(t){return h(t).filter(v)}})}!function(){var t=Object.freeze;o(Object,'freeze',{value:function(e){return y(e),t(e)}});var e=Object.seal;o(Object,'seal',{value:function(t){return y(t),e(t)}});var r=Object.preventExtensions;o(Object,'preventExtensions',{value:function(t){return y(t),r(t)}})}();var p=!1,d=0,m=function(){this instanceof m||b();var t=[],e=[],r=d++;function n(n,i){var a,o=y(n);return o?r in o?o[r]:i:(a=t.indexOf(n))>=0?e[a]:i}function i(e){var n=y(e);return n?r in n:t.indexOf(e)>=0}function a(n,i){var a,o=y(n);return o?o[r]=i:(a=t.indexOf(n))>=0?e[a]=i:(a=t.length,e[a]=i,t[a]=n),this}function o(n){var i,a,o=y(n);return o?r in o&&delete o[r]:!((i=t.indexOf(n))<0)&&(a=t.length-1,t[i]=void 0,e[i]=e[a],t[i]=t[a],t.length=a,e.length=a,!0)}return Object.create(m.prototype,{get___:{value:x(n)},has___:{value:x(i)},set___:{value:x(a)},delete___:{value:x(o)}})};m.prototype=Object.create(Object.prototype,{get:{value:function(t,e){return this.get___(t,e)},writable:!0,configurable:!0},has:{value:function(t){return this.has___(t)},writable:!0,configurable:!0},set:{value:function(t,e){return this.set___(t,e)},writable:!0,configurable:!0},delete:{value:function(t){return this.delete___(t)},writable:!0,configurable:!0}}),"function"===typeof r?function(){function n(){this instanceof m||b();var e,n=new r,i=void 0,a=!1;function o(t,e){return i?n.has(t)?n.get(t):i.get___(t,e):n.get(t,e)}function s(t){return n.has(t)||!!i&&i.has___(t)}function l(t){var e=!!n.delete(t);return i&&i.delete___(t)||e}return e=t?function(t,e){return n.set(t,e),n.has(t)||(i||(i=new m),i.set(t,e)),this}:function(t,e){if(a)try{n.set(t,e)}catch(r){i||(i=new m),i.set___(t,e)}else n.set(t,e);return this},Object.create(m.prototype,{get___:{value:x(o)},has___:{value:x(s)},set___:{value:x(e)},delete___:{value:x(l)},permitHostObjects___:{value:x((function(t){if(t!==g)throw new Error('bogus call to permitHostObjects___');a=!0}))}})}t&&"undefined"!==typeof Proxy&&(Proxy=void 0),n.prototype=m.prototype,e.exports=n,Object.defineProperty(WeakMap.prototype,'constructor',{value:WeakMap,enumerable:!1,configurable:!0,writable:!0})}():("undefined"!==typeof Proxy&&(Proxy=void 0),e.exports=m)}function g(t)[t.permitHostObjects___&&t.permitHostObjects___(g)]function v(t){return!(t.substr(0,l.length)==l&&"___"===t.substr(t.length-3))}function y(t){if(t!==Object(t))throw new TypeError("Not an object: "+t);var e=t[c];if(e&&e.key===t)return e;if(s(t)){e={key:t};try{return o(t,c,{value:e,writable:!1,enumerable:!1,configurable:!1}),e}catch(r){return}}}function x(t){return t.prototype=null,Object.freeze(t)}function b(){p||"undefined"===typeof console||(p=!0,console.warn('WeakMap should be invoked as new WeakMap(), not WeakMap(). This will be an error in the future.'))}}()},{}],610:[function(t,e,r){var n=t('./hidden-store.js');function i(){var t={};return function(e){if(("object"!==typeof e||null===e)&&"function"!==typeof e)throw new Error('Weakmap-shim: Key must be object');var r=e.valueOf(t);return r&&r.identity===t?r:n(e,t)}}e.exports=i},{"./hidden-store.js":611}],611:[function(t,e,r){function n(t,e){var r={identity:e},n=t.valueOf;return Object.defineProperty(t,'valueOf',{value:function(t){return t!==e?n.apply(this,arguments):r},writable:!0}),r}e.exports=n},{}],612:[function(t,e,r){var n=t('./create-store.js');function i(){var t=n();return{get:function(e,r){var n=t(e);return n.hasOwnProperty('value')?n.value:r},set:function(e,r){return t(e).value=r,this},has:function(e){return"value"in t(e)},delete:function(e){return delete t(e).value}}}e.exports=i},{"./create-store.js":610}],613:[function(t,e,r){var n=t('get-canvas-context');e.exports=function(t){return n('webgl',t)}},{"get-canvas-context":252}],614:[function(t,e,r){var n=t('../main'),i=t('object-assign'),a=n.instance();function o(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}o.prototype=new n.baseCalendar,i(o.prototype,{name:"Chinese",jdEpoch:1721425.5,hasYearZero:!1,minMonth:0,firstMonth:0,minDay:1,regionalOptions:{"":{name:"Chinese",epochs:["BEC","EC"],monthNumbers:function(t,e){if("string"===typeof t){var r=t.match(l);return r?r[0]:""}var n=this._validateYear(t),i=t.month(),a=""+this.toChineseMonth(n,i);return e&&a.length<2&&(a="0"+a),this.isIntercalaryMonth(n,i)&&(a+='i'),a},monthNames:function(t){if("string"===typeof t){var e=t.match(c);return e?e[0]:""}var r=this._validateYear(t),n=t.month(),i=["\u4e00\u6708",'\u4e8c\u6708','\u4e09\u6708','\u56db\u6708','\u4e94\u6708','\u516d\u6708','\u4e03\u6708','\u516b\u6708','\u4e5d\u6708','\u5341\u6708','\u5341\u4e00\u6708',"\u5341\u4e8c\u6708"][this.toChineseMonth(r,n)-1];return this.isIntercalaryMonth(r,n)&&(i="\u95f0"+i),i},monthNamesShort:function(t){if("string"===typeof t){var e=t.match(u);return e?e[0]:""}var r=this._validateYear(t),n=t.month(),i=["\u4e00",'\u4e8c','\u4e09','\u56db','\u4e94','\u516d','\u4e03','\u516b','\u4e5d','\u5341','\u5341\u4e00',"\u5341\u4e8c"][this.toChineseMonth(r,n)-1];return this.isIntercalaryMonth(r,n)&&(i="\u95f0"+i),i},parseMonth:function(t,e){t=this._validateYear(t);var r,n=parseInt(e);if(isNaN(n))"\u95f0"===e[0]&&(r=!0,e=e.substring(1)),"\u6708"===e[e.length-1]&&(e=e.substring(0,e.length-1)),n=1+["\u4e00",'\u4e8c','\u4e09','\u56db','\u4e94','\u516d','\u4e03','\u516b','\u4e5d','\u5341','\u5341\u4e00',"\u5341\u4e8c"].indexOf(e);else{var i=e[e.length-1];r="i"===i||"I"===i}return this.toMonthIndex(t,n,r)},dayNames:["Sunday",'Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],dayNamesShort:["Sun",'Mon','Tue','Wed','Thu','Fri',"Sat"],dayNamesMin:["Su",'Mo','Tu','We','Th','Fr',"Sa"],digits:null,dateFormat:"yyyy/mm/dd",firstDay:1,isRTL:!1}},_validateYear:function(t,e){if(t.year&&(t=t.year()),"number"!==typeof t||t<1888||t>2111)throw e.replace(/\{0\}/,this.local.name);return t},toMonthIndex:function(t,e,r){var i=this.intercalaryMonth(t);if(r&&e!==i||e<1||e>12)throw n.local.invalidMonth.replace(/\{0\}/,this.local.name);return i?!r&&e<=i?e-1:e:e-1},toChineseMonth:function(t,e){t.year&&(e=(t=t.year()).month());var r=this.intercalaryMonth(t);if(e<0||e>(r?12:11))throw n.local.invalidMonth.replace(/\{0\}/,this.local.name);return r?e<r?e+1:e:e+1},intercalaryMonth:function(t){return t=this._validateYear(t),f[t-f[0]]>>13},isIntercalaryMonth:function(t,e){t.year&&(e=(t=t.year()).month());var r=this.intercalaryMonth(t);return!!r&&r===e},leapYear:function(t){return 0!==this.intercalaryMonth(t)},weekOfYear:function(t,e,r){var i,o=this._validateYear(t,n.local.invalidyear),s=h[o-h[0]],l=s>>9&4095,c=s>>5&15,u=31&s;(i=a.newDate(l,c,u)).add(4-(i.dayOfWeek()||7),'d');var f=this.toJD(t,e,r)-i.toJD();return 1+Math.floor(f/7)},monthsInYear:function(t){return this.leapYear(t)?13:12},daysInMonth:function(t,e){t.year&&(e=t.month(),t=t.year()),t=this._validateYear(t);var r=f[t-f[0]];if(e>(r>>13?12:11))throw n.local.invalidMonth.replace(/\{0\}/,this.local.name);return r&1<<12-e?30:29},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,s,r,n.local.invalidDate);t=this._validateYear(i.year()),e=i.month(),r=i.day();var o=this.isIntercalaryMonth(t,e),s=this.toChineseMonth(t,e),l=d(t,s,r,o);return a.toJD(l.year,l.month,l.day)},fromJD:function(t){var e=a.fromJD(t),r=p(e.year(),e.month(),e.day()),n=this.toMonthIndex(r.year,r.month,r.isIntercalary);return this.newDate(r.year,n,r.day)},fromString:function(t){var e=t.match(s),r=this._validateYear(+e[1]),n=+e[2],i=!!e[3],a=this.toMonthIndex(r,n,i),o=+e[4];return this.newDate(r,a,o)},add:function(t,e,r){var n=t.year(),i=t.month(),a=this.isIntercalaryMonth(n,i),s=this.toChineseMonth(n,i),l=Object.getPrototypeOf(o.prototype).add.call(this,t,e,r);if("y"===r){var c=l.year(),u=l.month(),f=this.isIntercalaryMonth(c,s),h=a&&f?this.toMonthIndex(c,s,!0):this.toMonthIndex(c,s,!1);h!==u&&l.month(h)}return l}});var s=/^\s*(-?\d\d\d\d|\d\d)[-/](\d?\d)([iI]?)[-/](\d?\d)/m,l=/^\d?\d[iI]?/m,c=/^\u95f0?\u5341?[\u4e00\u4e8c\u4e09\u56db\u4e94\u516d\u4e03\u516b\u4e5d]?\u6708/m,u=/^\u95f0?\u5341?[\u4e00\u4e8c\u4e09\u56db\u4e94\u516d\u4e03\u516b\u4e5d]?/m;n.calendars.chinese=o;var f=[1887,5780,5802,19157,2742,50359,1198,2646,46378,7466,3412,30122,5482,67949,2396,5294,43597,6732,6954,36181,2772,4954,18781,2396,54427,5274,6730,47781,5800,6868,21210,4790,59703,2350,5270,46667,3402,3496,38325,1388,4782,18735,2350,52374,6804,7498,44457,2906,1388,29294,4700,63789,6442,6804,56138,5802,2772,38235,1210,4698,22827,5418,63125,3476,5802,43701,2484,5302,27223,2646,70954,7466,3412,54698,5482,2412,38062,5294,2636,32038,6954,60245,2772,4826,43357,2394,5274,39501,6730,72357,5800,5844,53978,4790,2358,38039,5270,87627,3402,3496,54708,5484,4782,43311,2350,3222,27978,7498,68965,2904,5484,45677,4700,6444,39573,6804,6986,19285,2772,62811,1210,4698,47403,5418,5780,38570,5546,76469,2420,5302,51799,2646,5414,36501,3412,5546,18869,2412,54446,5276,6732,48422,6822,2900,28010,4826,92509,2394,5274,55883,6730,6820,47956,5812,2778,18779,2358,62615,5270,5450,46757,3492,5556,27318,4718,67887,2350,3222,52554,7498,3428,38252,5468,4700,31022,6444,64149,6804,6986,43861,2772,5338,35421,2650,70955,5418,5780,54954,5546,2740,38074,5302,2646,29991,3366,61011,3412,5546,43445,2412,5294,35406,6732,72998,6820,6996,52586,2778,2396,38045,5274,6698,23333,6820,64338,5812,2746,43355,2358,5270,39499,5450,79525,3492,5548],h=[1887,966732,967231,967733,968265,968766,969297,969798,970298,970829,971330,971830,972362,972863,973395,973896,974397,974928,975428,975929,976461,976962,977462,977994,978494,979026,979526,980026,980558,981059,981559,982091,982593,983124,983624,984124,984656,985157,985656,986189,986690,987191,987722,988222,988753,989254,989754,990286,990788,991288,991819,992319,992851,993352,993851,994383,994885,995385,995917,996418,996918,997450,997949,998481,998982,999483,1000014,1000515,1001016,1001548,1002047,1002578,1003080,1003580,1004111,1004613,1005113,1005645,1006146,1006645,1007177,1007678,1008209,1008710,1009211,1009743,1010243,1010743,1011275,1011775,1012306,1012807,1013308,1013840,1014341,1014841,1015373,1015874,1016404,1016905,1017405,1017937,1018438,1018939,1019471,1019972,1020471,1021002,1021503,1022035,1022535,1023036,1023568,1024069,1024568,1025100,1025601,1026102,1026633,1027133,1027666,1028167,1028666,1029198,1029699,1030199,1030730,1031231,1031763,1032264,1032764,1033296,1033797,1034297,1034828,1035329,1035830,1036362,1036861,1037393,1037894,1038394,1038925,1039427,1039927,1040459,1040959,1041491,1041992,1042492,1043023,1043524,1044024,1044556,1045057,1045558,1046090,1046590,1047121,1047622,1048122,1048654,1049154,1049655,1050187,1050689,1051219,1051720,1052220,1052751,1053252,1053752,1054284,1054786,1055285,1055817,1056317,1056849,1057349,1057850,1058382,1058883,1059383,1059915,1060415,1060947,1061447,1061947,1062479,1062981,1063480,1064012,1064514,1065014,1065545,1066045,1066577,1067078,1067578,1068110,1068611,1069112,1069642,1070142,1070674,1071175,1071675,1072207,1072709,1073209,1073740,1074241,1074741,1075273,1075773,1076305,1076807,1077308,1077839,1078340,1078840,1079372,1079871,1080403,1080904];function p(t,e,r,n){var i,a;if("object"===typeof t)i=t,a=e||{};else{if(!("number"===typeof t&&t>=1888&&t<=2111))throw new Error('Solar year outside range 1888-2111');if(!("number"===typeof e&&e>=1&&e<=12))throw new Error('Solar month outside range 1 - 12');if(!("number"===typeof r&&r>=1&&r<=31))throw new Error('Solar day outside range 1 - 31');i={year:t,month:e,day:r},a=n||{}}var o=h[i.year-h[0]],s=i.year<<9|i.month<<5|i.day;a.year=s>=o?i.year:i.year-1,o=h[a.year-h[0]];var l,c=new Date(o>>9&4095,(o>>5&15)-1,31&o),u=new Date(i.year,i.month-1,i.day);l=Math.round((u-c)/864e5);var p,d=f[a.year-f[0]];for(p=0;p<13;p++){var m=d&1<<12-p?30:29;if(l<m)break;l-=m}var g=d>>13;return!g||p<g?(a.isIntercalary=!1,a.month=1+p):p===g?(a.isIntercalary=!0,a.month=p):(a.isIntercalary=!1,a.month=p),a.day=1+l,a}function d(t,e,r,n,i){var a,o,s;if("object"===typeof t)o=t,a=e||{};else{var l;if(!("number"===typeof t&&t>=1888&&t<=2111))throw new Error('Lunar year outside range 1888-2111');if(!("number"===typeof e&&e>=1&&e<=12))throw new Error('Lunar month outside range 1 - 12');if(!("number"===typeof r&&r>=1&&r<=30))throw new Error('Lunar day outside range 1 - 30');"object"===typeof n?(l=!1,a=n):(l=!!n,a=i||{}),o={year:t,month:e,day:r,isIntercalary:l}}s=o.day-1;var c,u=f[o.year-f[0]],p=u>>13;c=p&&(o.month>p||o.isIntercalary)?o.month:o.month-1;for(var d=0;d<c;d++)s+=u&1<<12-d?30:29;var m=h[o.year-h[0]],g=new Date(m>>9&4095,(m>>5&15)-1,(31&m)+s);return a.year=g.getFullYear(),a.month=1+g.getMonth(),a.day=g.getDate(),a}},{"../main":628,"object-assign":476}],615:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Coptic",jdEpoch:1825029.5,daysPerMonth:[30,30,30,30,30,30,30,30,30,30,30,30,5],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Coptic",epochs:["BAM","AM"],monthNames:["Thout",'Paopi','Hathor','Koiak','Tobi','Meshir','Paremhat','Paremoude','Pashons','Paoni','Epip','Mesori',"Pi Kogi Enavot"],monthNamesShort:["Tho",'Pao','Hath','Koi','Tob','Mesh','Pat','Pad','Pash','Pao','Epi','Meso',"PiK"],dayNames:["Tkyriaka",'Pesnau','Pshoment','Peftoou','Ptiou','Psoou',"Psabbaton"],dayNamesShort:["Tky",'Pes','Psh','Pef','Pti','Pso',"Psa"],dayNamesMin:["Tk",'Pes','Psh','Pef','Pt','Pso',"Psa"],digits:null,dateFormat:"dd/mm/yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return(t=e.year()+(e.year()<0?1:0))%4===3||t%4===-1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear||n.regionalOptions[""].invalidYear),13},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(13===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return(t=i.year())<0&&t++,i.day()+30*(i.month()-1)+365*(t-1)+Math.floor(t/4)+this.jdEpoch-1},fromJD:function(t){var e=Math.floor(t)+.5-this.jdEpoch,r=Math.floor((e-Math.floor((e+366)/1461))/365)+1;r<=0&&r--,e=Math.floor(t)+.5-this.newDate(r,1,1).toJD();var n=Math.floor(e/30)+1,i=e-30*(n-1)+1;return this.newDate(r,n,i)}}),n.calendars.coptic=a},{"../main":628,"object-assign":476}],616:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Discworld",jdEpoch:1721425.5,daysPerMonth:[16,32,32,32,32,32,32,32,32,32,32,32,32],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Discworld",epochs:["BUC","UC"],monthNames:["Ick",'Offle','February','March','April','May','June','Grune','August','Spune','Sektober','Ember',"December"],monthNamesShort:["Ick",'Off','Feb','Mar','Apr','May','Jun','Gru','Aug','Spu','Sek','Emb',"Dec"],dayNames:["Sunday",'Octeday','Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],dayNamesShort:["Sun",'Oct','Mon','Tue','Wed','Thu','Fri',"Sat"],dayNamesMin:["Su",'Oc','Mo','Tu','We','Th','Fr',"Sa"],digits:null,dateFormat:"yyyy/mm/dd",firstDay:2,isRTL:!1}},leapYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),!1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),13},daysInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),400},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/8)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]},daysInWeek:function(){return 8},dayOfWeek:function(t,e,r){return(this._validate(t,e,r,n.local.invalidDate).day()+1)%8},weekDay:function(t,e,r){var n=this.dayOfWeek(t,e,r);return n>=2&&n<=6},extraInfo:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return{century:o[Math.floor((i.year()-1)/100)+1]||""}},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return t=i.year()+(i.year()<0?1:0),e=i.month(),(r=i.day())+(e>1?16:0)+(e>2?32*(e-2):0)+400*(t-1)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t+.5)-Math.floor(this.jdEpoch)-1;var e=Math.floor(t/400)+1;t-=400*(e-1),t+=t>15?16:0;var r=Math.floor(t/32)+1,n=t-32*(r-1)+1;return this.newDate(e<=0?e-1:e,r,n)}});var o={20:"Fruitbat",21:"Anchovy"};n.calendars.discworld=a},{"../main":628,"object-assign":476}],617:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Ethiopian",jdEpoch:1724220.5,daysPerMonth:[30,30,30,30,30,30,30,30,30,30,30,30,5],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Ethiopian",epochs:["BEE","EE"],monthNames:["Meskerem",'Tikemet','Hidar','Tahesas','Tir','Yekatit','Megabit','Miazia','Genbot','Sene','Hamle','Nehase',"Pagume"],monthNamesShort:["Mes",'Tik','Hid','Tah','Tir','Yek','Meg','Mia','Gen','Sen','Ham','Neh',"Pag"],dayNames:["Ehud",'Segno','Maksegno','Irob','Hamus','Arb',"Kidame"],dayNamesShort:["Ehu",'Seg','Mak','Iro','Ham','Arb',"Kid"],dayNamesMin:["Eh",'Se','Ma','Ir','Ha','Ar',"Ki"],digits:null,dateFormat:"dd/mm/yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return(t=e.year()+(e.year()<0?1:0))%4===3||t%4===-1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear||n.regionalOptions[""].invalidYear),13},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(13===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return(t=i.year())<0&&t++,i.day()+30*(i.month()-1)+365*(t-1)+Math.floor(t/4)+this.jdEpoch-1},fromJD:function(t){var e=Math.floor(t)+.5-this.jdEpoch,r=Math.floor((e-Math.floor((e+366)/1461))/365)+1;r<=0&&r--,e=Math.floor(t)+.5-this.newDate(r,1,1).toJD();var n=Math.floor(e/30)+1,i=e-30*(n-1)+1;return this.newDate(r,n,i)}}),n.calendars.ethiopian=a},{"../main":628,"object-assign":476}],618:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}function o(t,e){return t-e*Math.floor(t/e)}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Hebrew",jdEpoch:347995.5,daysPerMonth:[30,29,30,29,30,29,30,29,30,29,30,29,29],hasYearZero:!1,minMonth:1,firstMonth:7,minDay:1,regionalOptions:{"":{name:"Hebrew",epochs:["BAM","AM"],monthNames:["Nisan",'Iyar','Sivan','Tammuz','Av','Elul','Tishrei','Cheshvan','Kislev','Tevet','Shevat','Adar',"Adar II"],monthNamesShort:["Nis",'Iya','Siv','Tam','Av','Elu','Tis','Che','Kis','Tev','She','Ada',"Ad2"],dayNames:["Yom Rishon",'Yom Sheni','Yom Shlishi','Yom Revi'i','Yom Chamishi','Yom Shishi',"Yom Shabbat"],dayNamesShort:["Ris",'She','Shl','Rev','Cha','Shi',"Sha"],dayNamesMin:["Ri",'She','Shl','Re','Ch','Shi',"Sha"],digits:null,dateFormat:"dd/mm/yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return this._leapYear(e.year())},_leapYear:function(t){return o(7*(t=t<0?t+1:t)+1,19)<7},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),this._leapYear(t.year?t.year():t)?13:12},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){return t=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear).year(),this.toJD(-1===t?1:t+1,7,1)-this.toJD(t,7,1)},daysInMonth:function(t,e){return t.year&&(e=t.month(),t=t.year()),this._validate(t,e,this.minDay,n.local.invalidMonth),12===e&&this.leapYear(t)||8===e&&5===o(this.daysInYear(t),10)?30:9===e&&3===o(this.daysInYear(t),10)?29:this.daysPerMonth[e-1]},weekDay:function(t,e,r){return 6!==this.dayOfWeek(t,e,r)},extraInfo:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return{yearType:(this.leapYear(i)?"embolismic":"common")+" "+["deficient",'regular',"complete"][this.daysInYear(i)%10-3]}},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);t=i.year(),e=i.month(),r=i.day();var a=t<=0?t+1:t,o=this.jdEpoch+this._delay1(a)+this._delay2(a)+r+1;if(e<7){for(var s=7;s<=this.monthsInYear(t);s++)o+=this.daysInMonth(t,s);for(s=1;s<e;s++)o+=this.daysInMonth(t,s)}else for(s=7;s<e;s++)o+=this.daysInMonth(t,s);return o},_delay1:function(t){var e=Math.floor((235*t-234)/19),r=12084+13753*e,n=29*e+Math.floor(r/25920);return o(3*(n+1),7)<3&&n++,n},_delay2:function(t){var e=this._delay1(t-1),r=this._delay1(t);return this._delay1(t+1)-r===356?2:r-e===382?1:0},fromJD:function(t){t=Math.floor(t)+.5;for(var e=Math.floor(98496*(t-this.jdEpoch)/35975351)-1;t>=this.toJD(-1===e?1:e+1,7,1);)e++;for(var r=t<this.toJD(e,1,1)?7:1;t>this.toJD(e,r,this.daysInMonth(e,r));)r++;var n=t-this.toJD(e,r,1)+1;return this.newDate(e,r,n)}}),n.calendars.hebrew=a},{"../main":628,"object-assign":476}],619:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Islamic",jdEpoch:1948439.5,daysPerMonth:[30,29,30,29,30,29,30,29,30,29,30,29],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Islamic",epochs:["BH","AH"],monthNames:["Muharram",'Safar','Rabi' al-awwal','Rabi' al-thani','Jumada al-awwal','Jumada al-thani','Rajab','Sha'aban','Ramadan','Shawwal','Dhu al-Qi'dah',"Dhu al-Hijjah"],monthNamesShort:["Muh",'Saf','Rab1','Rab2','Jum1','Jum2','Raj','Sha'','Ram','Shaw','DhuQ',"DhuH"],dayNames:["Yawm al-ahad",'Yawm al-ithnayn','Yawm ath-thulaathaa'','Yawm al-arbi'aa'','Yawm al-kham\u012bs','Yawm al-jum'a',"Yawm as-sabt"],dayNamesShort:["Aha",'Ith','Thu','Arb','Kha','Jum',"Sab"],dayNamesMin:["Ah",'It','Th','Ar','Kh','Ju',"Sa"],digits:null,dateFormat:"yyyy/mm/dd",firstDay:6,isRTL:!1}},leapYear:function(t){return(11*this._validate(t,this.minMonth,this.minDay,n.local.invalidYear).year()+14)%30<11},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){return this.leapYear(t)?355:354},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return t=i.year(),e=i.month(),t=t<=0?t+1:t,(r=i.day())+Math.ceil(29.5*(e-1))+354*(t-1)+Math.floor((3+11*t)/30)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t)+.5;var e=Math.floor((30*(t-this.jdEpoch)+10646)/10631);e=e<=0?e-1:e;var r=Math.min(12,Math.ceil((t-29-this.toJD(e,1,1))/29.5)+1),n=t-this.toJD(e,r,1)+1;return this.newDate(e,r,n)}}),n.calendars.islamic=a},{"../main":628,"object-assign":476}],620:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Julian",jdEpoch:1721423.5,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Julian",epochs:["BC","AD"],monthNames:["January",'February','March','April','May','June','July','August','September','October','November',"December"],monthNamesShort:["Jan",'Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov',"Dec"],dayNames:["Sunday",'Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],dayNamesShort:["Sun",'Mon','Tue','Wed','Thu','Fri',"Sat"],dayNamesMin:["Su",'Mo','Tu','We','Th','Fr',"Sa"],digits:null,dateFormat:"mm/dd/yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return(t=e.year()<0?e.year()+1:e.year())%4===0},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(4-(n.dayOfWeek()||7),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return t=i.year(),e=i.month(),r=i.day(),t<0&&t++,e<=2&&(t--,e+=12),Math.floor(365.25*(t+4716))+Math.floor(30.6001*(e+1))+r-1524.5},fromJD:function(t){var e=Math.floor(t+.5)+1524,r=Math.floor((e-122.1)/365.25),n=Math.floor(365.25*r),i=Math.floor((e-n)/30.6001),a=i-Math.floor(i<14?1:13),o=r-Math.floor(a>2?4716:4715),s=e-n-Math.floor(30.6001*i);return o<=0&&o--,this.newDate(o,a,s)}}),n.calendars.julian=a},{"../main":628,"object-assign":476}],621:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}function o(t,e){return t-e*Math.floor(t/e)}function s(t,e){return o(t-1,e)+1}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Mayan",jdEpoch:584282.5,hasYearZero:!0,minMonth:0,firstMonth:0,minDay:0,regionalOptions:{"":{name:"Mayan",epochs:["",""],monthNames:["0",'1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16',"17"],monthNamesShort:["0",'1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16',"17"],dayNames:["0",'1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18',"19"],dayNamesShort:["0",'1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18',"19"],dayNamesMin:["0",'1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18',"19"],digits:null,dateFormat:"YYYY.m.d",firstDay:0,isRTL:!1,haabMonths:["Pop",'Uo','Zip','Zotz','Tzec','Xul','Yaxkin','Mol','Chen','Yax','Zac','Ceh','Mac','Kankin','Muan','Pax','Kayab','Cumku',"Uayeb"],tzolkinMonths:["Imix",'Ik','Akbal','Kan','Chicchan','Cimi','Manik','Lamat','Muluc','Oc','Chuen','Eb','Ben','Ix','Men','Cib','Caban','Etznab','Cauac',"Ahau"]}},leapYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),!1},formatYear:function(t){t=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear).year();var e=Math.floor(t/400);return t%=400,t+=t<0?400:0,e+"."+Math.floor(t/20)+"."+t%20},forYear:function(t){if((t=t.split('.')).length<3)throw"Invalid Mayan year";for(var e=0,r=0;r<t.length;r++){var n=parseInt(t[r],10);if(Math.abs(n)>19||r>0&&n<0)throw"Invalid Mayan year";e=20*e+n}return e},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),18},weekOfYear:function(t,e,r){return this._validate(t,e,r,n.local.invalidDate),0},daysInYear:function(t){return this._validate(t,this.minMonth,this.minDay,n.local.invalidYear),360},daysInMonth:function(t,e){return this._validate(t,e,this.minDay,n.local.invalidMonth),20},daysInWeek:function(){return 5},dayOfWeek:function(t,e,r){return this._validate(t,e,r,n.local.invalidDate).day()},weekDay:function(t,e,r){return this._validate(t,e,r,n.local.invalidDate),!0},extraInfo:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate).toJD(),a=this._toHaab(i),o=this._toTzolkin(i);return{haabMonthName:this.local.haabMonths[a[0]-1],haabMonth:a[0],haabDay:a[1],tzolkinDayName:this.local.tzolkinMonths[o[0]-1],tzolkinDay:o[0],tzolkinTrecena:o[1]}},_toHaab:function(t){var e=o(8+(t-=this.jdEpoch)+340,365);return[Math.floor(e/20)+1,o(e,20)]},_toTzolkin:function(t){return[s(20+(t-=this.jdEpoch),20),s(t+4,13)]},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return i.day()+20*i.month()+360*i.year()+this.jdEpoch},fromJD:function(t){t=Math.floor(t)+.5-this.jdEpoch;var e=Math.floor(t/360);t%=360,t+=t<0?360:0;var r=Math.floor(t/20),n=t%20;return this.newDate(e,r,n)}}),n.calendars.mayan=a},{"../main":628,"object-assign":476}],622:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar;var o=n.instance('gregorian');i(a.prototype,{name:"Nanakshahi",jdEpoch:2257673.5,daysPerMonth:[31,31,31,31,31,30,30,30,30,30,30,30],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Nanakshahi",epochs:["BN","AN"],monthNames:["Chet",'Vaisakh','Jeth','Harh','Sawan','Bhadon','Assu','Katak','Maghar','Poh','Magh',"Phagun"],monthNamesShort:["Che",'Vai','Jet','Har','Saw','Bha','Ass','Kat','Mgr','Poh','Mgh',"Pha"],dayNames:["Somvaar",'Mangalvar','Budhvaar','Veervaar','Shukarvaar','Sanicharvaar',"Etvaar"],dayNamesShort:["Som",'Mangal','Budh','Veer','Shukar','Sanichar',"Et"],dayNamesMin:["So",'Ma','Bu','Ve','Sh','Sa',"Et"],digits:null,dateFormat:"dd-mm-yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear||n.regionalOptions[""].invalidYear);return o.leapYear(e.year()+(e.year()<1?1:0)+1469)},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(1-(n.dayOfWeek()||7),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidMonth);(t=i.year())<0&&t++;for(var a=i.day(),s=1;s<i.month();s++)a+=this.daysPerMonth[s-1];return a+o.toJD(t+1468,3,13)},fromJD:function(t){t=Math.floor(t+.5);for(var e=Math.floor((t-(this.jdEpoch-1))/366);t>=this.toJD(e+1,1,1);)e++;for(var r=t-Math.floor(this.toJD(e,1,1)+.5)+1,n=1;r>this.daysInMonth(e,n);)r-=this.daysInMonth(e,n),n++;return this.newDate(e,n,r)}}),n.calendars.nanakshahi=a},{"../main":628,"object-assign":476}],623:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Nepali",jdEpoch:1700709.5,daysPerMonth:[31,31,32,32,31,30,30,29,30,29,30,30],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,daysPerYear:365,regionalOptions:{"":{name:"Nepali",epochs:["BBS","ABS"],monthNames:["Baisakh",'Jestha','Ashadh','Shrawan','Bhadra','Ashwin','Kartik','Mangsir','Paush','Mangh','Falgun',"Chaitra"],monthNamesShort:["Bai",'Je','As','Shra','Bha','Ash','Kar','Mang','Pau','Ma','Fal',"Chai"],dayNames:["Aaitabaar",'Sombaar','Manglbaar','Budhabaar','Bihibaar','Shukrabaar',"Shanibaar"],dayNamesShort:["Aaita",'Som','Mangl','Budha','Bihi','Shukra',"Shani"],dayNamesMin:["Aai",'So','Man','Bu','Bi','Shu',"Sha"],digits:null,dateFormat:"dd/mm/yyyy",firstDay:1,isRTL:!1}},leapYear:function(t){return this.daysInYear(t)!==this.daysPerYear},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){if(t=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear).year(),"undefined"===typeof this.NEPALI_CALENDAR_DATA[t])return this.daysPerYear;for(var e=0,r=this.minMonth;r<=12;r++)e+=this.NEPALI_CALENDAR_DATA[t][r];return e},daysInMonth:function(t,e){return t.year&&(e=t.month(),t=t.year()),this._validate(t,e,this.minDay,n.local.invalidMonth),"undefined"===typeof this.NEPALI_CALENDAR_DATA[t]?this.daysPerMonth[e-1]:this.NEPALI_CALENDAR_DATA[t][e]},weekDay:function(t,e,r){return 6!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);t=i.year(),e=i.month(),r=i.day();var a=n.instance(),o=0,s=e,l=t;this._createMissingCalendarData(t);var c=t-(s>9||9===s&&r>=this.NEPALI_CALENDAR_DATA[l][0]?56:57);for(9!==e&&(o=r,s--);9!==s;)s<=0&&(s=12,l--),o+=this.NEPALI_CALENDAR_DATA[l][s],s--;return 9===e?(o+=r-this.NEPALI_CALENDAR_DATA[l][0])<0&&(o+=a.daysInYear(c)):o+=this.NEPALI_CALENDAR_DATA[l][9]-this.NEPALI_CALENDAR_DATA[l][0],a.newDate(c,1,1).add(o,'d').toJD()},fromJD:function(t){var e=n.instance().fromJD(t),r=e.year(),i=e.dayOfYear(),a=r+56;this._createMissingCalendarData(a);for(var o=9,s=this.NEPALI_CALENDAR_DATA[a][0],l=this.NEPALI_CALENDAR_DATA[a][o]-s+1;i>l;)++o>12&&(o=1,a++),l+=this.NEPALI_CALENDAR_DATA[a][o];var c=this.NEPALI_CALENDAR_DATA[a][o]-(l-i);return this.newDate(a,o,c)},_createMissingCalendarData:function(t){var e=this.daysPerMonth.slice(0);e.unshift(17);for(var r=t-1;r<t+2;r++)"undefined"===typeof this.NEPALI_CALENDAR_DATA[r]&&(this.NEPALI_CALENDAR_DATA[r]=e)},NEPALI_CALENDAR_DATA:{1970:[18,31,31,32,31,31,31,30,29,30,29,30,30],1971:[18,31,31,32,31,32,30,30,29,30,29,30,30],1972:[17,31,32,31,32,31,30,30,30,29,29,30,30],1973:[19,30,32,31,32,31,30,30,30,29,30,29,31],1974:[19,31,31,32,30,31,31,30,29,30,29,30,30],1975:[18,31,31,32,32,30,31,30,29,30,29,30,30],1976:[17,31,32,31,32,31,30,30,30,29,29,30,31],1977:[18,31,32,31,32,31,31,29,30,29,30,29,31],1978:[18,31,31,32,31,31,31,30,29,30,29,30,30],1979:[18,31,31,32,32,31,30,30,29,30,29,30,30],1980:[17,31,32,31,32,31,30,30,30,29,29,30,31],1981:[18,31,31,31,32,31,31,29,30,30,29,30,30],1982:[18,31,31,32,31,31,31,30,29,30,29,30,30],1983:[18,31,31,32,32,31,30,30,29,30,29,30,30],1984:[17,31,32,31,32,31,30,30,30,29,29,30,31],1985:[18,31,31,31,32,31,31,29,30,30,29,30,30],1986:[18,31,31,32,31,31,31,30,29,30,29,30,30],1987:[18,31,32,31,32,31,30,30,29,30,29,30,30],1988:[17,31,32,31,32,31,30,30,30,29,29,30,31],1989:[18,31,31,31,32,31,31,30,29,30,29,30,30],1990:[18,31,31,32,31,31,31,30,29,30,29,30,30],1991:[18,31,32,31,32,31,30,30,29,30,29,30,30],1992:[17,31,32,31,32,31,30,30,30,29,30,29,31],1993:[18,31,31,31,32,31,31,30,29,30,29,30,30],1994:[18,31,31,32,31,31,31,30,29,30,29,30,30],1995:[17,31,32,31,32,31,30,30,30,29,29,30,30],1996:[17,31,32,31,32,31,30,30,30,29,30,29,31],1997:[18,31,31,32,31,31,31,30,29,30,29,30,30],1998:[18,31,31,32,31,31,31,30,29,30,29,30,30],1999:[17,31,32,31,32,31,30,30,30,29,29,30,31],2e3:[17,30,32,31,32,31,30,30,30,29,30,29,31],2001:[18,31,31,32,31,31,31,30,29,30,29,30,30],2002:[18,31,31,32,32,31,30,30,29,30,29,30,30],2003:[17,31,32,31,32,31,30,30,30,29,29,30,31],2004:[17,30,32,31,32,31,30,30,30,29,30,29,31],2005:[18,31,31,32,31,31,31,30,29,30,29,30,30],2006:[18,31,31,32,32,31,30,30,29,30,29,30,30],2007:[17,31,32,31,32,31,30,30,30,29,29,30,31],2008:[17,31,31,31,32,31,31,29,30,30,29,29,31],2009:[18,31,31,32,31,31,31,30,29,30,29,30,30],2010:[18,31,31,32,32,31,30,30,29,30,29,30,30],2011:[17,31,32,31,32,31,30,30,30,29,29,30,31],2012:[17,31,31,31,32,31,31,29,30,30,29,30,30],2013:[18,31,31,32,31,31,31,30,29,30,29,30,30],2014:[18,31,31,32,32,31,30,30,29,30,29,30,30],2015:[17,31,32,31,32,31,30,30,30,29,29,30,31],2016:[17,31,31,31,32,31,31,29,30,30,29,30,30],2017:[18,31,31,32,31,31,31,30,29,30,29,30,30],2018:[18,31,32,31,32,31,30,30,29,30,29,30,30],2019:[17,31,32,31,32,31,30,30,30,29,30,29,31],2020:[17,31,31,31,32,31,31,30,29,30,29,30,30],2021:[18,31,31,32,31,31,31,30,29,30,29,30,30],2022:[17,31,32,31,32,31,30,30,30,29,29,30,30],2023:[17,31,32,31,32,31,30,30,30,29,30,29,31],2024:[17,31,31,31,32,31,31,30,29,30,29,30,30],2025:[18,31,31,32,31,31,31,30,29,30,29,30,30],2026:[17,31,32,31,32,31,30,30,30,29,29,30,31],2027:[17,30,32,31,32,31,30,30,30,29,30,29,31],2028:[17,31,31,32,31,31,31,30,29,30,29,30,30],2029:[18,31,31,32,31,32,30,30,29,30,29,30,30],2030:[17,31,32,31,32,31,30,30,30,30,30,30,31],2031:[17,31,32,31,32,31,31,31,31,31,31,31,31],2032:[17,32,32,32,32,32,32,32,32,32,32,32,32],2033:[18,31,31,32,32,31,30,30,29,30,29,30,30],2034:[17,31,32,31,32,31,30,30,30,29,29,30,31],2035:[17,30,32,31,32,31,31,29,30,30,29,29,31],2036:[17,31,31,32,31,31,31,30,29,30,29,30,30],2037:[18,31,31,32,32,31,30,30,29,30,29,30,30],2038:[17,31,32,31,32,31,30,30,30,29,29,30,31],2039:[17,31,31,31,32,31,31,29,30,30,29,30,30],2040:[17,31,31,32,31,31,31,30,29,30,29,30,30],2041:[18,31,31,32,32,31,30,30,29,30,29,30,30],2042:[17,31,32,31,32,31,30,30,30,29,29,30,31],2043:[17,31,31,31,32,31,31,29,30,30,29,30,30],2044:[17,31,31,32,31,31,31,30,29,30,29,30,30],2045:[18,31,32,31,32,31,30,30,29,30,29,30,30],2046:[17,31,32,31,32,31,30,30,30,29,29,30,31],2047:[17,31,31,31,32,31,31,30,29,30,29,30,30],2048:[17,31,31,32,31,31,31,30,29,30,29,30,30],2049:[17,31,32,31,32,31,30,30,30,29,29,30,30],2050:[17,31,32,31,32,31,30,30,30,29,30,29,31],2051:[17,31,31,31,32,31,31,30,29,30,29,30,30],2052:[17,31,31,32,31,31,31,30,29,30,29,30,30],2053:[17,31,32,31,32,31,30,30,30,29,29,30,30],2054:[17,31,32,31,32,31,30,30,30,29,30,29,31],2055:[17,31,31,32,31,31,31,30,29,30,30,29,30],2056:[17,31,31,32,31,32,30,30,29,30,29,30,30],2057:[17,31,32,31,32,31,30,30,30,29,29,30,31],2058:[17,30,32,31,32,31,30,30,30,29,30,29,31],2059:[17,31,31,32,31,31,31,30,29,30,29,30,30],2060:[17,31,31,32,32,31,30,30,29,30,29,30,30],2061:[17,31,32,31,32,31,30,30,30,29,29,30,31],2062:[17,30,32,31,32,31,31,29,30,29,30,29,31],2063:[17,31,31,32,31,31,31,30,29,30,29,30,30],2064:[17,31,31,32,32,31,30,30,29,30,29,30,30],2065:[17,31,32,31,32,31,30,30,30,29,29,30,31],2066:[17,31,31,31,32,31,31,29,30,30,29,29,31],2067:[17,31,31,32,31,31,31,30,29,30,29,30,30],2068:[17,31,31,32,32,31,30,30,29,30,29,30,30],2069:[17,31,32,31,32,31,30,30,30,29,29,30,31],2070:[17,31,31,31,32,31,31,29,30,30,29,30,30],2071:[17,31,31,32,31,31,31,30,29,30,29,30,30],2072:[17,31,32,31,32,31,30,30,29,30,29,30,30],2073:[17,31,32,31,32,31,30,30,30,29,29,30,31],2074:[17,31,31,31,32,31,31,30,29,30,29,30,30],2075:[17,31,31,32,31,31,31,30,29,30,29,30,30],2076:[16,31,32,31,32,31,30,30,30,29,29,30,30],2077:[17,31,32,31,32,31,30,30,30,29,30,29,31],2078:[17,31,31,31,32,31,31,30,29,30,29,30,30],2079:[17,31,31,32,31,31,31,30,29,30,29,30,30],2080:[16,31,32,31,32,31,30,30,30,29,29,30,30],2081:[17,31,31,32,32,31,30,30,30,29,30,30,30],2082:[17,31,32,31,32,31,30,30,30,29,30,30,30],2083:[17,31,31,32,31,31,30,30,30,29,30,30,30],2084:[17,31,31,32,31,31,30,30,30,29,30,30,30],2085:[17,31,32,31,32,31,31,30,30,29,30,30,30],2086:[17,31,32,31,32,31,30,30,30,29,30,30,30],2087:[16,31,31,32,31,31,31,30,30,29,30,30,30],2088:[16,30,31,32,32,30,31,30,30,29,30,30,30],2089:[17,31,32,31,32,31,30,30,30,29,30,30,30],2090:[17,31,32,31,32,31,30,30,30,29,30,30,30],2091:[16,31,31,32,31,31,31,30,30,29,30,30,30],2092:[16,31,31,32,32,31,30,30,30,29,30,30,30],2093:[17,31,32,31,32,31,30,30,30,29,30,30,30],2094:[17,31,31,32,31,31,30,30,30,29,30,30,30],2095:[17,31,31,32,31,31,31,30,29,30,30,30,30],2096:[17,30,31,32,32,31,30,30,29,30,29,30,30],2097:[17,31,32,31,32,31,30,30,30,29,30,30,30],2098:[17,31,31,32,31,31,31,29,30,29,30,30,31],2099:[17,31,31,32,31,31,31,30,29,29,30,30,30],2100:[17,31,32,31,32,30,31,30,29,30,29,30,30]}}),n.calendars.nepali=a},{"../main":628,"object-assign":476}],624:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}function o(t,e){return t-e*Math.floor(t/e)}a.prototype=new n.baseCalendar,i(a.prototype,{name:"Persian",jdEpoch:1948320.5,daysPerMonth:[31,31,31,31,31,31,30,30,30,30,30,29],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Persian",epochs:["BP","AP"],monthNames:["Farvardin",'Ordibehesht','Khordad','Tir','Mordad','Shahrivar','Mehr','Aban','Azar','Day','Bahman',"Esfand"],monthNamesShort:["Far",'Ord','Kho','Tir','Mor','Sha','Meh','Aba','Aza','Day','Bah',"Esf"],dayNames:["Yekshambe",'Doshambe','Seshambe','Ch\xe6harshambe','Panjshambe','Jom'e',"Shambe"],dayNamesShort:["Yek",'Do','Se','Ch\xe6','Panj','Jom',"Sha"],dayNamesMin:["Ye",'Do','Se','Ch','Pa','Jo',"Sh"],digits:null,dateFormat:"yyyy/mm/dd",firstDay:6,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return 682*((e.year()-(e.year()>0?474:473))%2820+474+38)%2816<682},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-(n.dayOfWeek()+1)%7,'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);t=i.year(),e=i.month(),r=i.day();var a=t-(t>=0?474:473),s=474+o(a,2820);return r+(e<=7?31*(e-1):30*(e-1)+6)+Math.floor((682*s-110)/2816)+365*(s-1)+1029983*Math.floor(a/2820)+this.jdEpoch-1},fromJD:function(t){var e=(t=Math.floor(t)+.5)-this.toJD(475,1,1),r=Math.floor(e/1029983),n=o(e,1029983),i=2820;if(1029982!==n){var a=Math.floor(n/366),s=o(n,366);i=Math.floor((2134*a+2816*s+2815)/1028522)+a+1}var l=i+2820*r+474;l=l<=0?l-1:l;var c=t-this.toJD(l,1,1)+1,u=c<=186?Math.ceil(c/31):Math.ceil((c-6)/30),f=t-this.toJD(l,u,1)+1;return this.newDate(l,u,f)}}),n.calendars.persian=a,n.calendars.jalali=a},{"../main":628,"object-assign":476}],625:[function(t,e,r){var n=t('../main'),i=t('object-assign'),a=n.instance();function o(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}o.prototype=new n.baseCalendar,i(o.prototype,{name:"Taiwan",jdEpoch:2419402.5,yearsOffset:1911,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Taiwan",epochs:["BROC","ROC"],monthNames:["January",'February','March','April','May','June','July','August','September','October','November',"December"],monthNamesShort:["Jan",'Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov',"Dec"],dayNames:["Sunday",'Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],dayNamesShort:["Sun",'Mon','Tue','Wed','Thu','Fri',"Sat"],dayNamesMin:["Su",'Mo','Tu','We','Th','Fr',"Sa"],digits:null,dateFormat:"yyyy/mm/dd",firstDay:1,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return t=this._t2gYear(e.year()),a.leapYear(t)},weekOfYear:function(t,e,r){var i=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return t=this._t2gYear(i.year()),a.weekOfYear(t,i.month(),i.day())},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return t=this._t2gYear(i.year()),a.toJD(t,i.month(),i.day())},fromJD:function(t){var e=a.fromJD(t),r=this._g2tYear(e.year());return this.newDate(r,e.month(),e.day())},_t2gYear:function(t){return t+this.yearsOffset+(t>=-this.yearsOffset&&t<=-1?1:0)},_g2tYear:function(t){return t-this.yearsOffset-(t>=1&&t<=this.yearsOffset?1:0)}}),n.calendars.taiwan=o},{"../main":628,"object-assign":476}],626:[function(t,e,r){var n=t('../main'),i=t('object-assign'),a=n.instance();function o(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}o.prototype=new n.baseCalendar,i(o.prototype,{name:"Thai",jdEpoch:1523098.5,yearsOffset:543,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Thai",epochs:["BBE","BE"],monthNames:["January",'February','March','April','May','June','July','August','September','October','November',"December"],monthNamesShort:["Jan",'Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov',"Dec"],dayNames:["Sunday",'Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],dayNamesShort:["Sun",'Mon','Tue','Wed','Thu','Fri',"Sat"],dayNamesMin:["Su",'Mo','Tu','We','Th','Fr',"Sa"],digits:null,dateFormat:"dd/mm/yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return t=this._t2gYear(e.year()),a.leapYear(t)},weekOfYear:function(t,e,r){var i=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return t=this._t2gYear(i.year()),a.weekOfYear(t,i.month(),i.day())},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,n.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate);return t=this._t2gYear(i.year()),a.toJD(t,i.month(),i.day())},fromJD:function(t){var e=a.fromJD(t),r=this._g2tYear(e.year());return this.newDate(r,e.month(),e.day())},_t2gYear:function(t){return t-this.yearsOffset-(t>=1&&t<=this.yearsOffset?1:0)},_g2tYear:function(t){return t+this.yearsOffset+(t>=-this.yearsOffset&&t<=-1?1:0)}}),n.calendars.thai=o},{"../main":628,"object-assign":476}],627:[function(t,e,r){var n=t('../main'),i=t('object-assign');function a(t){this.local=this.regionalOptions[t||""]||this.regionalOptions[""]}a.prototype=new n.baseCalendar,i(a.prototype,{name:"UmmAlQura",hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Umm al-Qura",epochs:["BH","AH"],monthNames:["Al-Muharram",'Safar','Rabi' al-awwal','Rabi' Al-Thani','Jumada Al-Awwal','Jumada Al-Thani','Rajab','Sha'aban','Ramadan','Shawwal','Dhu al-Qi'dah',"Dhu al-Hijjah"],monthNamesShort:["Muh",'Saf','Rab1','Rab2','Jum1','Jum2','Raj','Sha'','Ram','Shaw','DhuQ',"DhuH"],dayNames:["Yawm al-Ahad",'Yawm al-Ithnain','Yawm al-Thal\u0101th\u0101\u2019','Yawm al-Arba\u2018\u0101\u2019','Yawm al-Kham\u012bs','Yawm al-Jum\u2018a',"Yawm al-Sabt"],dayNamesMin:["Ah",'Ith','Th','Ar','Kh','Ju',"Sa"],digits:null,dateFormat:"yyyy/mm/dd",firstDay:6,isRTL:!0}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,n.local.invalidYear);return 355===this.daysInYear(e.year())},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){for(var e=0,r=1;r<=12;r++)e+=this.daysInMonth(t,r);return e},daysInMonth:function(t,e){for(var r=this._validate(t,e,this.minDay,n.local.invalidMonth).toJD()-24e5+.5,i=0,a=0;a<o.length;a++){if(o[a]>r)return o[i]-o[i-1];i++}return 30},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var i=this._validate(t,e,r,n.local.invalidDate),a=12*(i.year()-1)+i.month()-15292;return i.day()+o[a-1]-1+24e5-.5},fromJD:function(t){for(var e=t-24e5+.5,r=0,n=0;n<o.length&&!(o[n]>e);n++)r++;var i=r+15292,a=Math.floor((i-1)/12),s=a+1,l=i-12*a,c=e-o[r-1]+1;return this.newDate(s,l,c)},isValid:function(t,e,r){var i=n.baseCalendar.prototype.isValid.apply(this,arguments);return i&&(i=(t=null!=t.year?t.year:t)>=1276&&t<=1500),i},_validate:function(t,e,r,i){var a=n.baseCalendar.prototype._validate.apply(this,arguments);if(a.year<1276||a.year>1500)throw i.replace(/\{0\}/,this.local.name);return a}}),n.calendars.ummalqura=a;var o=[20,50,79,109,138,168,197,227,256,286,315,345,374,404,433,463,492,522,551,581,611,641,670,700,729,759,788,818,847,877,906,936,965,995,1024,1054,1083,1113,1142,1172,1201,1231,1260,1290,1320,1350,1379,1409,1438,1468,1497,1527,1556,1586,1615,1645,1674,1704,1733,1763,1792,1822,1851,1881,1910,1940,1969,1999,2028,2058,2087,2117,2146,2176,2205,2235,2264,2294,2323,2353,2383,2413,2442,2472,2501,2531,2560,2590,2619,2649,2678,2708,2737,2767,2796,2826,2855,2885,2914,2944,2973,3003,3032,3062,3091,3121,3150,3180,3209,3239,3268,3298,3327,3357,3386,3416,3446,3476,3505,3535,3564,3594,3623,3653,3682,3712,3741,3771,3800,3830,3859,3889,3918,3948,3977,4007,4036,4066,4095,4125,4155,4185,4214,4244,4273,4303,4332,4362,4391,4421,4450,4480,4509,4539,4568,4598,4627,4657,4686,4716,4745,4775,4804,4834,4863,4893,4922,4952,4981,5011,5040,5070,5099,5129,5158,5188,5218,5248,5277,5307,5336,5366,5395,5425,5454,5484,5513,5543,5572,5602,5631,5661,5690,5720,5749,5779,5808,5838,5867,5897,5926,5956,5985,6015,6044,6074,6103,6133,6162,6192,6221,6251,6281,6311,6340,6370,6399,6429,6458,6488,6517,6547,6576,6606,6635,6665,6694,6724,6753,6783,6812,6842,6871,6901,6930,6960,6989,7019,7048,7078,7107,7137,7166,7196,7225,7255,7284,7314,7344,7374,7403,7433,7462,7492,7521,7551,7580,7610,7639,7669,7698,7728,7757,7787,7816,7846,7875,7905,7934,7964,7993,8023,8053,8083,8112,8142,8171,8201,8230,8260,8289,8319,8348,8378,8407,8437,8466,8496,8525,8555,8584,8614,8643,8673,8702,8732,8761,8791,8821,8850,8880,8909,8938,8968,8997,9027,9056,9086,9115,9145,9175,9205,9234,9264,9293,9322,9352,9381,9410,9440,9470,9499,9529,9559,9589,9618,9648,9677,9706,9736,9765,9794,9824,9853,9883,9913,9943,9972,10002,10032,10061,10090,10120,10149,10178,10208,10237,10267,10297,10326,10356,10386,10415,10445,10474,10504,10533,10562,10592,10621,10651,10680,10710,10740,10770,10799,10829,10858,10888,10917,10947,10976,11005,11035,11064,11094,11124,11153,11183,11213,11242,11272,11301,11331,11360,11389,11419,11448,11478,11507,11537,11567,11596,11626,11655,11685,11715,11744,11774,11803,11832,11862,11891,11921,11950,11980,12010,12039,12069,12099,12128,12158,12187,12216,12246,12275,12304,12334,12364,12393,12423,12453,12483,12512,12542,12571,12600,12630,12659,12688,12718,12747,12777,12807,12837,12866,12896,12926,12955,12984,13014,13043,13072,13102,13131,13161,13191,13220,13250,13280,13310,13339,13368,13398,13427,13456,13486,13515,13545,13574,13604,13634,13664,13693,13723,13752,13782,13811,13840,13870,13899,13929,13958,13988,14018,14047,14077,14107,14136,14166,14195,14224,14254,14283,14313,14342,14372,14401,14431,14461,14490,14520,14550,14579,14609,14638,14667,14697,14726,14756,14785,14815,14844,14874,14904,14933,14963,14993,15021,15051,15081,15110,15140,15169,15199,15228,15258,15287,15317,15347,15377,15406,15436,15465,15494,15524,15553,15582,15612,15641,15671,15701,15731,15760,15790,15820,15849,15878,15908,15937,15966,15996,16025,16055,16085,16114,16144,16174,16204,16233,16262,16292,16321,16350,16380,16409,16439,16468,16498,16528,16558,16587,16617,16646,16676,16705,16734,16764,16793,16823,16852,16882,16912,16941,16971,17001,17030,17060,17089,17118,17148,17177,17207,17236,17266,17295,17325,17355,17384,17414,17444,17473,17502,17532,17561,17591,17620,17650,17679,17709,17738,17768,17798,17827,17857,17886,17916,17945,17975,18004,18034,18063,18093,18122,18152,18181,18211,18241,18270,18300,18330,18359,18388,18418,18447,18476,18506,18535,18565,18595,18625,18654,18684,18714,18743,18772,18802,18831,18860,18890,18919,18949,18979,19008,19038,19068,19098,19127,19156,19186,19215,19244,19274,19303,19333,19362,19392,19422,19452,19481,19511,19540,19570,19599,19628,19658,19687,19717,19746,19776,19806,19836,19865,19895,19924,19954,19983,20012,20042,20071,20101,20130,20160,20190,20219,20249,20279,20308,20338,20367,20396,20426,20455,20485,20514,20544,20573,20603,20633,20662,20692,20721,20751,20780,20810,20839,20869,20898,20928,20957,20987,21016,21046,21076,21105,21135,21164,21194,21223,21253,21282,21312,21341,21371,21400,21430,21459,21489,21519,21548,21578,21607,21637,21666,21696,21725,21754,21784,21813,21843,21873,21902,21932,21962,21991,22021,22050,22080,22109,22138,22168,22197,22227,22256,22286,22316,22346,22375,22405,22434,22464,22493,22522,22552,22581,22611,22640,22670,22700,22730,22759,22789,22818,22848,22877,22906,22936,22965,22994,23024,23054,23083,23113,23143,23173,23202,23232,23261,23290,23320,23349,23379,23408,23438,23467,23497,23527,23556,23586,23616,23645,23674,23704,23733,23763,23792,23822,23851,23881,23910,23940,23970,23999,24029,24058,24088,24117,24147,24176,24206,24235,24265,24294,24324,24353,24383,24413,24442,24472,24501,24531,24560,24590,24619,24648,24678,24707,24737,24767,24796,24826,24856,24885,24915,24944,24974,25003,25032,25062,25091,25121,25150,25180,25210,25240,25269,25299,25328,25358,25387,25416,25446,25475,25505,25534,25564,25594,25624,25653,25683,25712,25742,25771,25800,25830,25859,25888,25918,25948,25977,26007,26037,26067,26096,26126,26155,26184,26214,26243,26272,26302,26332,26361,26391,26421,26451,26480,26510,26539,26568,26598,26627,26656,26686,26715,26745,26775,26805,26834,26864,26893,26923,26952,26982,27011,27041,27070,27099,27129,27159,27188,27218,27248,27277,27307,27336,27366,27395,27425,27454,27484,27513,27542,27572,27602,27631,27661,27691,27720,27750,27779,27809,27838,27868,27897,27926,27956,27985,28015,28045,28074,28104,28134,28163,28193,28222,28252,28281,28310,28340,28369,28399,28428,28458,28488,28517,28547,28577,28607,28636,28665,28695,28724,28754,28783,28813,28843,28872,28901,28931,28960,28990,29019,29049,29078,29108,29137,29167,29196,29226,29255,29285,29315,29345,29375,29404,29434,29463,29492,29522,29551,29580,29610,29640,29669,29699,29729,29759,29788,29818,29847,29876,29906,29935,29964,29994,30023,30053,30082,30112,30141,30171,30200,30230,30259,30289,30318,30348,30378,30408,30437,30467,30496,30526,30555,30585,30614,30644,30673,30703,30732,30762,30791,30821,30850,30880,30909,30939,30968,30998,31027,31057,31086,31116,31145,31175,31204,31234,31263,31293,31322,31352,31381,31411,31441,31471,31500,31530,31559,31589,31618,31648,31676,31706,31736,31766,31795,31825,31854,31884,31913,31943,31972,32002,32031,32061,32090,32120,32150,32180,32209,32239,32268,32298,32327,32357,32386,32416,32445,32475,32504,32534,32563,32593,32622,32652,32681,32711,32740,32770,32799,32829,32858,32888,32917,32947,32976,33006,33035,33065,33094,33124,33153,33183,33213,33243,33272,33302,33331,33361,33390,33420,33450,33479,33509,33539,33568,33598,33627,33657,33686,33716,33745,33775,33804,33834,33863,33893,33922,33952,33981,34011,34040,34069,34099,34128,34158,34187,34217,34247,34277,34306,34336,34365,34395,34424,34454,34483,34512,34542,34571,34601,34631,34660,34690,34719,34749,34778,34808,34837,34867,34896,34926,34955,34985,35015,35044,35074,35103,35133,35162,35192,35222,35251,35280,35310,35340,35370,35399,35429,35458,35488,35517,35547,35576,35605,35635,35665,35694,35723,35753,35782,35811,35841,35871,35901,35930,35960,35989,36019,36048,36078,36107,36136,36166,36195,36225,36254,36284,36314,36343,36373,36403,36433,36462,36492,36521,36551,36580,36610,36639,36669,36698,36728,36757,36786,36816,36845,36875,36904,36934,36963,36993,37022,37052,37081,37111,37141,37170,37200,37229,37259,37288,37318,37347,37377,37406,37436,37465,37495,37524,37554,37584,37613,37643,37672,37701,37731,37760,37790,37819,37849,37878,37908,37938,37967,37997,38027,38056,38085,38115,38144,38174,38203,38233,38262,38292,38322,38351,38381,38410,38440,38469,38499,38528,38558,38587,38617,38646,38676,38705,38735,38764,38794,38823,38853,38882,38912,38941,38971,39001,39030,39059,39089,39118,39148,39178,39208,39237,39267,39297,39326,39355,39385,39414,39444,39473,39503,39532,39562,39592,39621,39650,39680,39709,39739,39768,39798,39827,39857,39886,39916,39946,39975,40005,40035,40064,40094,40123,40153,40182,40212,40241,40271,40300,40330,40359,40389,40418,40448,40477,40507,40536,40566,40595,40625,40655,40685,40714,40744,40773,40803,40832,40862,40892,40921,40951,40980,41009,41039,41068,41098,41127,41157,41186,41216,41245,41275,41304,41334,41364,41393,41422,41452,41481,41511,41540,41570,41599,41629,41658,41688,41718,41748,41777,41807,41836,41865,41894,41924,41953,41983,42012,42042,42072,42102,42131,42161,42190,42220,42249,42279,42308,42337,42367,42397,42426,42456,42485,42515,42545,42574,42604,42633,42662,42692,42721,42751,42780,42810,42839,42869,42899,42929,42958,42988,43017,43046,43076,43105,43135,43164,43194,43223,43253,43283,43312,43342,43371,43401,43430,43460,43489,43519,43548,43578,43607,43637,43666,43696,43726,43755,43785,43814,43844,43873,43903,43932,43962,43991,44021,44050,44080,44109,44139,44169,44198,44228,44258,44287,44317,44346,44375,44405,44434,44464,44493,44523,44553,44582,44612,44641,44671,44700,44730,44759,44788,44818,44847,44877,44906,44936,44966,44996,45025,45055,45084,45114,45143,45172,45202,45231,45261,45290,45320,45350,45380,45409,45439,45468,45498,45527,45556,45586,45615,45644,45674,45704,45733,45763,45793,45823,45852,45882,45911,45940,45970,45999,46028,46058,46088,46117,46147,46177,46206,46236,46265,46295,46324,46354,46383,46413,46442,46472,46501,46531,46560,46590,46620,46649,46679,46708,46738,46767,46797,46826,46856,46885,46915,46944,46974,47003,47033,47063,47092,47122,47151,47181,47210,47240,47269,47298,47328,47357,47387,47417,47446,47476,47506,47535,47565,47594,47624,47653,47682,47712,47741,47771,47800,47830,47860,47890,47919,47949,47978,48008,48037,48066,48096,48125,48155,48184,48214,48244,48273,48303,48333,48362,48392,48421,48450,48480,48509,48538,48568,48598,48627,48657,48687,48717,48746,48776,48805,48834,48864,48893,48922,48952,48982,49011,49041,49071,49100,49130,49160,49189,49218,49248,49277,49306,49336,49365,49395,49425,49455,49484,49514,49543,49573,49602,49632,49661,49690,49720,49749,49779,49809,49838,49868,49898,49927,49957,49986,50016,50045,50075,50104,50133,50163,50192,50222,50252,50281,50311,50340,50370,50400,50429,50459,50488,50518,50547,50576,50606,50635,50665,50694,50724,50754,50784,50813,50843,50872,50902,50931,50960,50990,51019,51049,51078,51108,51138,51167,51197,51227,51256,51286,51315,51345,51374,51403,51433,51462,51492,51522,51552,51582,51611,51641,51670,51699,51729,51758,51787,51816,51846,51876,51906,51936,51965,51995,52025,52054,52083,52113,52142,52171,52200,52230,52260,52290,52319,52349,52379,52408,52438,52467,52497,52526,52555,52585,52614,52644,52673,52703,52733,52762,52792,52822,52851,52881,52910,52939,52969,52998,53028,53057,53087,53116,53146,53176,53205,53235,53264,53294,53324,53353,53383,53412,53441,53471,53500,53530,53559,53589,53619,53648,53678,53708,53737,53767,53796,53825,53855,53884,53913,53943,53973,54003,54032,54062,54092,54121,54151,54180,54209,54239,54268,54297,54327,54357,54387,54416,54446,54476,54505,54535,54564,54593,54623,54652,54681,54711,54741,54770,54800,54830,54859,54889,54919,54948,54977,55007,55036,55066,55095,55125,55154,55184,55213,55243,55273,55302,55332,55361,55391,55420,55450,55479,55508,55538,55567,55597,55627,55657,55686,55716,55745,55775,55804,55834,55863,55892,55922,55951,55981,56011,56040,56070,56100,56129,56159,56188,56218,56247,56276,56306,56335,56365,56394,56424,56454,56483,56513,56543,56572,56601,56631,56660,56690,56719,56749,56778,56808,56837,56867,56897,56926,56956,56985,57015,57044,57074,57103,57133,57162,57192,57221,57251,57280,57310,57340,57369,57399,57429,57458,57487,57517,57546,57576,57605,57634,57664,57694,57723,57753,57783,57813,57842,57871,57901,57930,57959,57989,58018,58048,58077,58107,58137,58167,58196,58226,58255,58285,58314,58343,58373,58402,58432,58461,58491,58521,58551,58580,58610,58639,58669,58698,58727,58757,58786,58816,58845,58875,58905,58934,58964,58994,59023,59053,59082,59111,59141,59170,59200,59229,59259,59288,59318,59348,59377,59407,59436,59466,59495,59525,59554,59584,59613,59643,59672,59702,59731,59761,59791,59820,59850,59879,59909,59939,59968,59997,60027,60056,60086,60115,60145,60174,60204,60234,60264,60293,60323,60352,60381,60411,60440,60469,60499,60528,60558,60588,60618,60648,60677,60707,60736,60765,60795,60824,60853,60883,60912,60942,60972,61002,61031,61061,61090,61120,61149,61179,61208,61237,61267,61296,61326,61356,61385,61415,61445,61474,61504,61533,61563,61592,61621,61651,61680,61710,61739,61769,61799,61828,61858,61888,61917,61947,61976,62006,62035,62064,62094,62123,62153,62182,62212,62242,62271,62301,62331,62360,62390,62419,62448,62478,62507,62537,62566,62596,62625,62655,62685,62715,62744,62774,62803,62832,62862,62891,62921,62950,62980,63009,63039,63069,63099,63128,63157,63187,63216,63246,63275,63305,63334,63363,63393,63423,63453,63482,63512,63541,63571,63600,63630,63659,63689,63718,63747,63777,63807,63836,63866,63895,63925,63955,63984,64014,64043,64073,64102,64131,64161,64190,64220,64249,64279,64309,64339,64368,64398,64427,64457,64486,64515,64545,64574,64603,64633,64663,64692,64722,64752,64782,64811,64841,64870,64899,64929,64958,64987,65017,65047,65076,65106,65136,65166,65195,65225,65254,65283,65313,65342,65371,65401,65431,65460,65490,65520,65549,65579,65608,65638,65667,65697,65726,65755,65785,65815,65844,65874,65903,65933,65963,65992,66022,66051,66081,66110,66140,66169,66199,66228,66258,66287,66317,66346,66376,66405,66435,66465,66494,66524,66553,66583,66612,66641,66671,66700,66730,66760,66789,66819,66849,66878,66908,66937,66967,66996,67025,67055,67084,67114,67143,67173,67203,67233,67262,67292,67321,67351,67380,67409,67439,67468,67497,67527,67557,67587,67617,67646,67676,67705,67735,67764,67793,67823,67852,67882,67911,67941,67971,68e3,68030,68060,68089,68119,68148,68177,68207,68236,68266,68295,68325,68354,68384,68414,68443,68473,68502,68532,68561,68591,68620,68650,68679,68708,68738,68768,68797,68827,68857,68886,68916,68946,68975,69004,69034,69063,69092,69122,69152,69181,69211,69240,69270,69300,69330,69359,69388,69418,69447,69476,69506,69535,69565,69595,69624,69654,69684,69713,69743,69772,69802,69831,69861,69890,69919,69949,69978,70008,70038,70067,70097,70126,70156,70186,70215,70245,70274,70303,70333,70362,70392,70421,70451,70481,70510,70540,70570,70599,70629,70658,70687,70717,70746,70776,70805,70835,70864,70894,70924,70954,70983,71013,71042,71071,71101,71130,71159,71189,71218,71248,71278,71308,71337,71367,71397,71426,71455,71485,71514,71543,71573,71602,71632,71662,71691,71721,71751,71781,71810,71839,71869,71898,71927,71957,71986,72016,72046,72075,72105,72135,72164,72194,72223,72253,72282,72311,72341,72370,72400,72429,72459,72489,72518,72548,72577,72607,72637,72666,72695,72725,72754,72784,72813,72843,72872,72902,72931,72961,72991,73020,73050,73080,73109,73139,73168,73197,73227,73256,73286,73315,73345,73375,73404,73434,73464,73493,73523,73552,73581,73611,73640,73669,73699,73729,73758,73788,73818,73848,73877,73907,73936,73965,73995,74024,74053,74083,74113,74142,74172,74202,74231,74261,74291,74320,74349,74379,74408,74437,74467,74497,74526,74556,74586,74615,74645,74675,74704,74733,74763,74792,74822,74851,74881,74910,74940,74969,74999,75029,75058,75088,75117,75147,75176,75206,75235,75264,75294,75323,75353,75383,75412,75442,75472,75501,75531,75560,75590,75619,75648,75678,75707,75737,75766,75796,75826,75856,75885,75915,75944,75974,76003,76032,76062,76091,76121,76150,76180,76210,76239,76269,76299,76328,76358,76387,76416,76446,76475,76505,76534,76564,76593,76623,76653,76682,76712,76741,76771,76801,76830,76859,76889,76918,76948,76977,77007,77036,77066,77096,77125,77155,77185,77214,77243,77273,77302,77332,77361,77390,77420,77450,77479,77509,77539,77569,77598,77627,77657,77686,77715,77745,77774,77804,77833,77863,77893,77923,77952,77982,78011,78041,78070,78099,78129,78158,78188,78217,78247,78277,78307,78336,78366,78395,78425,78454,78483,78513,78542,78572,78601,78631,78661,78690,78720,78750,78779,78808,78838,78867,78897,78926,78956,78985,79015,79044,79074,79104,79133,79163,79192,79222,79251,79281,79310,79340,79369,79399,79428,79458,79487,79517,79546,79576,79606,79635,79665,79695,79724,79753,79783,79812,79841,79871,79900,79930,79960,79990]},{"../main":628,"object-assign":476}],628:[function(t,e,r){var n=t('object-assign');function i(){this.regionalOptions=[],this.regionalOptions[""]={invalidCalendar:"Calendar {0} not found",invalidDate:"Invalid [0] date",invalidMonth:"Invalid [0] month",invalidYear:"Invalid [0] year",differentCalendars:"Cannot mix [0] and [1] dates"},this.local=this.regionalOptions[""],this.calendars={},this._localCals={}}function a(t,e,r,n){if(this._calendar=t,this._year=e,this._month=r,this._day=n,0===this._calendar._validateLevel&&!this._calendar.isValid(this._year,this._month,this._day))throw(c.local.invalidDate||c.regionalOptions[""].invalidDate).replace(/\{0\}/,this._calendar.local.name)}function o(t,e){return'000000'.substring(0,e-(t=""+t).length)+t}function s()[this.shortYearCutoff="+10"]function l(t)[this.local=this.regionalOptions[t]||this.regionalOptions[""]]n(i.prototype,{instance:function(t,e){t=(t||"gregorian").toLowerCase(),e=e||"";var r=this._localCals[t+"-"+e];if(!r&&this.calendars[t]&&(r=new this.calendars[t](e),this._localCals[t+"-"+e]=r),!r)throw(this.local.invalidCalendar||this.regionalOptions[""].invalidCalendar).replace(/\{0\}/,t);return r},newDate:function(t,e,r,n,i){return(n=(null!=t&&t.year?t.calendar():"string"===typeof n?this.instance(n,i):n)||this.instance()).newDate(t,e,r)},substituteDigits:function(t){return function(e){return(e+"").replace(/[0-9]/g,(function(e){return t[e]}))}},substituteChineseDigits:function(t,e){return function(r){for(var n='',i=0;r>0;){var a=r%10;n=(0===a?"":t[a]+e[i])+n,i++,r=Math.floor(r/10)}return 0===n.indexOf(t[1]+e[1])&&(n=n.substr(1)),n||t[0]}}}),n(a.prototype,{newDate:function(t,e,r){return this._calendar.newDate(null==t?this:t,e,r)},year:function(t){return 0===arguments.length?this._year:this.set(t,'y')},month:function(t){return 0===arguments.length?this._month:this.set(t,'m')},day:function(t){return 0===arguments.length?this._day:this.set(t,'d')},date:function(t,e,r){if(!this._calendar.isValid(t,e,r))throw(c.local.invalidDate||c.regionalOptions[""].invalidDate).replace(/\{0\}/,this._calendar.local.name);return this._year=t,this._month=e,this._day=r,this},leapYear:function(){return this._calendar.leapYear(this)},epoch:function(){return this._calendar.epoch(this)},formatYear:function(){return this._calendar.formatYear(this)},monthOfYear:function(){return this._calendar.monthOfYear(this)},weekOfYear:function(){return this._calendar.weekOfYear(this)},daysInYear:function(){return this._calendar.daysInYear(this)},dayOfYear:function(){return this._calendar.dayOfYear(this)},daysInMonth:function(){return this._calendar.daysInMonth(this)},dayOfWeek:function(){return this._calendar.dayOfWeek(this)},weekDay:function(){return this._calendar.weekDay(this)},extraInfo:function(){return this._calendar.extraInfo(this)},add:function(t,e){return this._calendar.add(this,t,e)},set:function(t,e){return this._calendar.set(this,t,e)},compareTo:function(t)[if(this._calendar.name!==t._calendar.name)throw(c.local.differentCalendars||c.regionalOptions[""].differentCalendars).replace(/\{0\]/,this._calendar.local.name).replace(/\[1\]/,t._calendar.local.name);var e=this._year!==t._year?this._year-t._year:this._month!==t._month?this.monthOfYear()-t.monthOfYear():this._day-t._day;return 0===e?0:e<0?-1:1},calendar:function(){return this._calendar},toJD:function(){return this._calendar.toJD(this)},fromJD:function(t){return this._calendar.fromJD(t)},toJSDate:function(){return this._calendar.toJSDate(this)},fromJSDate:function(t){return this._calendar.fromJSDate(t)},toString:function(){return(this.year()<0?"-":"")+o(Math.abs(this.year()),4)+"-"+o(this.month(),2)+"-"+o(this.day(),2)}}),n(s.prototype,{_validateLevel:0,newDate:function(t,e,r){return null==t?this.today():(t.year&&(this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate),r=t.day(),e=t.month(),t=t.year()),new a(this,t,e,r))},today:function(){return this.fromJSDate(new Date)},epoch:function(t){return this._validate(t,this.minMonth,this.minDay,c.local.invalidYear||c.regionalOptions[""].invalidYear).year()<0?this.local.epochs[0]:this.local.epochs[1]},formatYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,c.local.invalidYear||c.regionalOptions[""].invalidYear);return(e.year()<0?"-":"")+o(Math.abs(e.year()),4)},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,c.local.invalidYear||c.regionalOptions[""].invalidYear),12},monthOfYear:function(t,e){var r=this._validate(t,e,this.minDay,c.local.invalidMonth||c.regionalOptions[""].invalidMonth);return(r.month()+this.monthsInYear(r)-this.firstMonth)%this.monthsInYear(r)+this.minMonth},fromMonthOfYear:function(t,e){var r=(e+this.firstMonth-2*this.minMonth)%this.monthsInYear(t)+this.minMonth;return this._validate(t,r,this.minDay,c.local.invalidMonth||c.regionalOptions[""].invalidMonth),r},daysInYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,c.local.invalidYear||c.regionalOptions[""].invalidYear);return this.leapYear(e)?366:365},dayOfYear:function(t,e,r){var n=this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate);return n.toJD()-this.newDate(n.year(),this.fromMonthOfYear(n.year(),this.minMonth),this.minDay).toJD()+1},daysInWeek:function(){return 7},dayOfWeek:function(t,e,r){var n=this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate);return(Math.floor(this.toJD(n))+2)%this.daysInWeek()},extraInfo:function(t,e,r){return this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate),{}},add:function(t,e,r){return this._validate(t,this.minMonth,this.minDay,c.local.invalidDate||c.regionalOptions[""].invalidDate),this._correctAdd(t,this._add(t,e,r),e,r)},_add:function(t,e,r){if(this._validateLevel++,"d"===r||"w"===r){var n=t.toJD()+e*("w"===r?this.daysInWeek():1),i=t.calendar().fromJD(n);return this._validateLevel--,[i.year(),i.month(),i.day()]}try{var a=t.year()+("y"===r?e:0),o=t.monthOfYear()+("m"===r?e:0),s=(i=t.day(),function(t){for(;o<t.minMonth;)a--,o+=t.monthsInYear(a);for(var e=t.monthsInYear(a);o>e-1+t.minMonth;)a++,o-=e,e=t.monthsInYear(a)});"y"===r?(t.month()!==this.fromMonthOfYear(a,o)&&(o=this.newDate(a,t.month(),this.minDay).monthOfYear()),o=Math.min(o,this.monthsInYear(a)),i=Math.min(i,this.daysInMonth(a,this.fromMonthOfYear(a,o)))):"m"===r&&(s(this),i=Math.min(i,this.daysInMonth(a,this.fromMonthOfYear(a,o))));var l=[a,this.fromMonthOfYear(a,o),i];return this._validateLevel--,l}catch(c){throw this._validateLevel--,c}},_correctAdd:function(t,e,r,n){if(!this.hasYearZero&&("y"===n||"m"===n)&&(0===e[0]||t.year()>0!==e[0]>0)){var i={y:[1,1,"y"],m:[1,this.monthsInYear(-1),"m"],w:[this.daysInWeek(),this.daysInYear(-1),"d"],d:[1,this.daysInYear(-1),"d"]}[n],a=r<0?-1:1;e=this._add(t,r*i[0]+a*i[1],i[2])}return t.date(e[0],e[1],e[2])},set:function(t,e,r){this._validate(t,this.minMonth,this.minDay,c.local.invalidDate||c.regionalOptions[""].invalidDate);var n="y"===r?e:t.year(),i="m"===r?e:t.month(),a="d"===r?e:t.day();return"y"!==r&&"m"!==r||(a=Math.min(a,this.daysInMonth(n,i))),t.date(n,i,a)},isValid:function(t,e,r){this._validateLevel++;var n=this.hasYearZero||0!==t;if(n){var i=this.newDate(t,e,this.minDay);n=e>=this.minMonth&&e-this.minMonth<this.monthsInYear(i)&&r>=this.minDay&&r-this.minDay<this.daysInMonth(i)}return this._validateLevel--,n},toJSDate:function(t,e,r){var n=this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate);return c.instance().fromJD(this.toJD(n)).toJSDate()},fromJSDate:function(t){return this.fromJD(c.instance().fromJSDate(t).toJD())},_validate:function(t,e,r,n)[if(t.year){if(0===this._validateLevel&&this.name!==t.calendar().name)throw(c.local.differentCalendars||c.regionalOptions[""].differentCalendars).replace(/\{0\]/,this.local.name).replace(/\[1\]/,t.calendar().local.name);return t}try{if(this._validateLevel++,1===this._validateLevel&&!this.isValid(t,e,r))throw n.replace(/\{0\}/,this.local.name);var i=this.newDate(t,e,r);return this._validateLevel--,i}catch(a){throw this._validateLevel--,a}}}),l.prototype=new s,n(l.prototype,{name:"Gregorian",jdEpoch:1721425.5,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{"":{name:"Gregorian",epochs:["BCE","CE"],monthNames:["January",'February','March','April','May','June','July','August','September','October','November',"December"],monthNamesShort:["Jan",'Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov',"Dec"],dayNames:["Sunday",'Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],dayNamesShort:["Sun",'Mon','Tue','Wed','Thu','Fri',"Sat"],dayNamesMin:["Su",'Mo','Tu','We','Th','Fr',"Sa"],digits:null,dateFormat:"mm/dd/yyyy",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,c.local.invalidYear||c.regionalOptions[""].invalidYear);return(t=e.year()+(e.year()<0?1:0))%4===0&&(t%100!==0||t%400===0)},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(4-(n.dayOfWeek()||7),'d'),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,c.local.invalidMonth||c.regionalOptions[""].invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate);t=n.year(),e=n.month(),r=n.day(),t<0&&t++,e<3&&(e+=12,t--);var i=Math.floor(t/100),a=2-i+Math.floor(i/4);return Math.floor(365.25*(t+4716))+Math.floor(30.6001*(e+1))+r+a-1524.5},fromJD:function(t){var e=Math.floor(t+.5),r=Math.floor((e-1867216.25)/36524.25),n=1524+(r=e+1+r-Math.floor(r/4)),i=Math.floor((n-122.1)/365.25),a=Math.floor(365.25*i),o=Math.floor((n-a)/30.6001),s=n-a-Math.floor(30.6001*o),l=o-(o>13.5?13:1),c=i-(l>2.5?4716:4715);return c<=0&&c--,this.newDate(c,l,s)},toJSDate:function(t,e,r){var n=this._validate(t,e,r,c.local.invalidDate||c.regionalOptions[""].invalidDate),i=new Date(n.year(),n.month()-1,n.day());return i.setHours(0),i.setMinutes(0),i.setSeconds(0),i.setMilliseconds(0),i.setHours(i.getHours()>12?i.getHours()+2:0),i},fromJSDate:function(t){return this.newDate(t.getFullYear(),t.getMonth()+1,t.getDate())}});var c=e.exports=new i;c.cdate=a,c.baseCalendar=s,c.calendars.gregorian=l},{"object-assign":476}],629:[function(t,e,r){var n=t('object-assign'),i=t('./main');n(i.regionalOptions[""],{invalidArguments:"Invalid arguments",invalidFormat:"Cannot format a date from another calendar",missingNumberAt:"Missing number at position {0}",unknownNameAt:"Unknown name at position [0]",unexpectedLiteralAt:"Unexpected literal at position [0]",unexpectedText:"Additional text found at end"}),i.local=i.regionalOptions[""],n(i.cdate.prototype,{formatDate:function(t,e){return"string"!==typeof t&&(e=t,t=''),this._calendar.formatDate(t||"",this,e)}}),n(i.baseCalendar.prototype,{UNIX_EPOCH:i.instance().newDate(1970,1,1).toJD(),SECS_PER_DAY:86400,TICKS_EPOCH:i.instance().jdEpoch,TICKS_PER_DAY:864e9,ATOM:"yyyy-mm-dd",COOKIE:"D, dd M yyyy",FULL:"DD, MM d, yyyy",ISO_8601:"yyyy-mm-dd",JULIAN:"J",RFC_822:"D, d M yy",RFC_850:"DD, dd-M-yy",RFC_1036:"D, d M yy",RFC_1123:"D, d M yyyy",RFC_2822:"D, d M yyyy",RSS:"D, d M yy",TICKS:"!",TIMESTAMP:"@",W3C:"yyyy-mm-dd",formatDate:function(t,e,r){if("string"!==typeof t&&(r=e,e=t,t=''),!e)return'';if(e.calendar()!==this)throw i.local.invalidFormat||i.regionalOptions[""].invalidFormat;t=t||this.local.dateFormat;for(var n=(r=r||{}).dayNamesShort||this.local.dayNamesShort,a=r.dayNames||this.local.dayNames,o=r.monthNumbers||this.local.monthNumbers,s=r.monthNamesShort||this.local.monthNamesShort,l=r.monthNames||this.local.monthNames,c=(r.calculateWeek||this.local.calculateWeek,function(e,r){for(var n=1;x+n<t.length&&t.charAt(x+n)===e;)n++;return x+=n-1,Math.floor(n/(r||1))>1}),u=function(t,e,r,n){var i=""+e;if(c(t,n))for(;i.length<r;)i="0"+i;return i},f=function(t,e,r,n){return c(t)?n[e]:r[e]},h=this,p=function(t){return"function"===typeof o?o.call(h,t,c('m')):g(u('m',t.month(),2))},d=function(t,e){return e?"function"===typeof l?l.call(h,t):l[t.month()-h.minMonth]:"function"===typeof s?s.call(h,t):s[t.month()-h.minMonth]},m=this.local.digits,g=function(t){return r.localNumbers&&m?m(t):t},v='',y=!1,x=0;x<t.length;x++)if(y)"'"!==t.charAt(x)||c(''')?v+=t.charAt(x):y=!1;else switch(t.charAt(x)){case"d":v+=g(u('d',e.day(),2));break;case"D":v+=f('D',e.dayOfWeek(),n,a);break;case"o":v+=u('o',e.dayOfYear(),3);break;case"w":v+=u('w',e.weekOfYear(),2);break;case"m":v+=p(e);break;case"M":v+=d(e,c('M'));break;case"y":v+=c('y',2)?e.year():(e.year()%100<10?"0":"")+e.year()%100;break;case"Y":c('Y',2),v+=e.formatYear();break;case"J":v+=e.toJD();break;case"@":v+=(e.toJD()-this.UNIX_EPOCH)*this.SECS_PER_DAY;break;case"!":v+=(e.toJD()-this.TICKS_EPOCH)*this.TICKS_PER_DAY;break;case"'":c(''')?v+="'":y=!0;break;default:v+=t.charAt(x)}return v},parseDate:function(t,e,r){if(null==e)throw i.local.invalidArguments||i.regionalOptions[""].invalidArguments;if(""===(e="object"===typeof e?e.toString():e+""))return null;t=t||this.local.dateFormat;var n=(r=r||{}).shortYearCutoff||this.shortYearCutoff;n="string"!==typeof n?n:this.today().year()%100+parseInt(n,10);for(var a=r.dayNamesShort||this.local.dayNamesShort,o=r.dayNames||this.local.dayNames,s=r.parseMonth||this.local.parseMonth,l=r.monthNumbers||this.local.monthNumbers,c=r.monthNamesShort||this.local.monthNamesShort,u=r.monthNames||this.local.monthNames,f=-1,h=-1,p=-1,d=-1,m=-1,g=!1,v=!1,y=function(e,r){for(var n=1;A+n<t.length&&t.charAt(A+n)===e;)n++;return A+=n-1,Math.floor(n/(r||1))>1},x=function(t,r){var n=y(t,r),a=[2,3,n?4:2,n?4:2,10,11,20]["oyYJ@!".indexOf(t)+1],o=new RegExp("^-?\\d{1,"+a+"}"),s=e.substring(M).match(o);if(!s)throw(i.local.missingNumberAt||i.regionalOptions[""].missingNumberAt).replace(/\[0\]/,M);return M+=s[0].length,parseInt(s[0],10)},b=this,_=function(){if("function"===typeof l){y('m');var t=l.call(b,e.substring(M));return M+=t.length,t}return x('m')},w=function(t,r,n,a){for(var o=y(t,a)?n:r,s=0;s<o.length;s++)if(e.substr(M,o[s].length).toLowerCase()===o[s].toLowerCase())return M+=o[s].length,s+b.minMonth;throw(i.local.unknownNameAt||i.regionalOptions[""].unknownNameAt).replace(/\{0\}/,M)},T=function(){if("function"===typeof u){var t=y('M')?u.call(b,e.substring(M)):c.call(b,e.substring(M));return M+=t.length,t}return w('M',c,u)},k=function()[if(e.charAt(M)!==t.charAt(A))throw(i.local.unexpectedLiteralAt||i.regionalOptions[""].unexpectedLiteralAt).replace(/\{0\]/,M);M++},M=0,A=0;A<t.length;A++)if(v)"'"!==t.charAt(A)||y(''')?k():v=!1;else switch(t.charAt(A)){case"d":d=x('d');break;case"D":w('D',a,o);break;case"o":m=x('o');break;case"w":x('w');break;case"m":p=_();break;case"M":p=T();break;case"y":var S=A;g=!y('y',2),A=S,h=x('y',2);break;case"Y":h=x('Y',2);break;case"J":f=x('J')+.5,"."===e.charAt(M)&&(M++,x('J'));break;case"@":f=x('@')/this.SECS_PER_DAY+this.UNIX_EPOCH;break;case"!":f=x('!')/this.TICKS_PER_DAY+this.TICKS_EPOCH;break;case"*":M=e.length;break;case"'":y(''')?k():v=!0;break;default:k()}if(M<e.length)throw i.local.unexpectedText||i.regionalOptions[""].unexpectedText;if(-1===h?h=this.today().year():h<100&&g&&(h+=-1===n?1900:this.today().year()-this.today().year()%100-(h<=n?0:100)),"string"===typeof p&&(p=s.call(this,h,p)),m>-1){p=1,d=m;for(var E=this.daysInMonth(h,p);d>E;E=this.daysInMonth(h,p))p++,d-=E}return f>-1?this.fromJD(f):this.newDate(h,p,d)},determineDate:function(t,e,r,n,i){r&&"object"!==typeof r&&(i=n,n=r,r=null),"string"!==typeof n&&(i=n,n='');var a=this,o=function(t){try{return a.parseDate(n,t,i)}catch(l){}for(var e=((t=t.toLowerCase()).match(/^c/)&&r?r.newDate():null)||a.today(),o=/([+-]?[0-9]+)\s*(d|w|m|y)?/g,s=o.exec(t);s;)e.add(parseInt(s[1],10),s[2]||"d"),s=o.exec(t);return e};return e=e?e.newDate():null,t=null==t?e:"string"===typeof t?o(t):"number"===typeof t?isNaN(t)||t===1/0||t===-1/0?e:a.today().add(t,'d'):a.newDate(t)}})},{"./main":628,"object-assign":476}],630:[function(t,e,r){"use strict";function n(){return function(t,e,r,n,i,a){var o=t[0],s=r[0],l=[0],c=s;n|=0;var u=0,f=s;for(u=0;u<o;++u){var h=e[n]-a,p=e[n+c]-a;h>=0!==p>=0&&i.push(l[0]+.5+.5*(h+p)/(h-p)),n+=f,++l[0]}}}function i(){return n()}var a=i;function o(t)[var e={];return function(r,n,i){var a=r.dtype,o=r.order,s=[a,o.join()].join(),l=e[s];return l||(e[s]=l=t([a,o])),l(r.shape.slice(0),r.data,r.stride,0|r.offset,n,i)}}function s(t){return o(a.bind(void 0,t))}function l(t){return s({funcName:t.funcName})}e.exports=l({funcName:"zeroCrossings"})},{}],631:[function(t,e,r){"use strict";e.exports=i;var n=t('./lib/zc-core');function i(t,e){var r=[];return e=+e||0,n(t.hi(t.shape[0]-1),r,e),r}},{"./lib/zc-core":630}],632:[function(t,e,r){"use strict";e.exports=[path:"",backoff:0},{path:"M-2.4,-3V3L0.6,0Z",backoff:.6},{path:"M-3.7,-2.5V2.5L1.3,0Z",backoff:1.3},{path:"M-4.45,-3L-1.65,-0.2V0.2L-4.45,3L1.55,0Z",backoff:1.55},{path:"M-2.2,-2.2L-0.2,-0.2V0.2L-2.2,2.2L-1.4,3L1.6,0L-1.4,-3Z",backoff:1.6},{path:"M-4.4,-2.1L-0.6,-0.2V0.2L-4.4,2.1L-4,3L2,0L-4,-3Z",backoff:2},{path:"M2,0A2,2 0 1,1 0,-2A2,2 0 0,1 2,0Z",backoff:0,noRotate:!0},{path:"M2,2V-2H-2V2Z",backoff:0,noRotate:!0}],{}],633:[function(t,e,r){"use strict";var n=t('./arrow_paths'),i=t('../../plots/font_attributes'),a=t('../../plots/cartesian/constants'),o=t('../../plot_api/plot_template').templatedArray;t('../../constants/axis_placeable_objects'),e.exports=o('annotation',{visible:{valType:"boolean",dflt:!0,editType:"calc+arraydraw"},text:{valType:"string",editType:"calc+arraydraw"},textangle:{valType:"angle",dflt:0,editType:"calc+arraydraw"},font:i({editType:"calc+arraydraw",colorEditType:"arraydraw"}),width:{valType:"number",min:1,dflt:null,editType:"calc+arraydraw"},height:{valType:"number",min:1,dflt:null,editType:"calc+arraydraw"},opacity:{valType:"number",min:0,max:1,dflt:1,editType:"arraydraw"},align:{valType:"enumerated",values:["left",'center',"right"],dflt:"center",editType:"arraydraw"},valign:{valType:"enumerated",values:["top",'middle',"bottom"],dflt:"middle",editType:"arraydraw"},bgcolor:{valType:"color",dflt:"rgba(0,0,0,0)",editType:"arraydraw"},bordercolor:{valType:"color",dflt:"rgba(0,0,0,0)",editType:"arraydraw"},borderpad:{valType:"number",min:0,dflt:1,editType:"calc+arraydraw"},borderwidth:{valType:"number",min:0,dflt:1,editType:"calc+arraydraw"},showarrow:{valType:"boolean",dflt:!0,editType:"calc+arraydraw"},arrowcolor:{valType:"color",editType:"arraydraw"},arrowhead:{valType:"integer",min:0,max:n.length,dflt:1,editType:"arraydraw"},startarrowhead:{valType:"integer",min:0,max:n.length,dflt:1,editType:"arraydraw"},arrowside:{valType:"flaglist",flags:["end","start"],extras:["none"],dflt:"end",editType:"arraydraw"},arrowsize:{valType:"number",min:.3,dflt:1,editType:"calc+arraydraw"},startarrowsize:{valType:"number",min:.3,dflt:1,editType:"calc+arraydraw"},arrowwidth:{valType:"number",min:.1,editType:"calc+arraydraw"},standoff:{valType:"number",min:0,dflt:0,editType:"calc+arraydraw"},startstandoff:{valType:"number",min:0,dflt:0,editType:"calc+arraydraw"},ax:{valType:"any",editType:"calc+arraydraw"},ay:{valType:"any",editType:"calc+arraydraw"},axref:{valType:"enumerated",dflt:"pixel",values:["pixel",a.idRegex.x.toString()],editType:"calc"},ayref:{valType:"enumerated",dflt:"pixel",values:["pixel",a.idRegex.y.toString()],editType:"calc"},xref:{valType:"enumerated",values:["paper",a.idRegex.x.toString()],editType:"calc"},x:{valType:"any",editType:"calc+arraydraw"},xanchor:{valType:"enumerated",values:["auto",'left','center',"right"],dflt:"auto",editType:"calc+arraydraw"},xshift:{valType:"number",dflt:0,editType:"calc+arraydraw"},yref:{valType:"enumerated",values:["paper",a.idRegex.y.toString()],editType:"calc"},y:{valType:"any",editType:"calc+arraydraw"},yanchor:{valType:"enumerated",values:["auto",'top','middle',"bottom"],dflt:"auto",editType:"calc+arraydraw"},yshift:{valType:"number",dflt:0,editType:"calc+arraydraw"},clicktoshow:{valType:"enumerated",values:[!1,'onoff',"onout"],dflt:!1,editType:"arraydraw"},xclick:{valType:"any",editType:"arraydraw"},yclick:{valType:"any",editType:"arraydraw"},hovertext:{valType:"string",editType:"arraydraw"},hoverlabel:{bgcolor:{valType:"color",editType:"arraydraw"},bordercolor:{valType:"color",editType:"arraydraw"},font:i({editType:"arraydraw"}),editType:"arraydraw"},captureevents:{valType:"boolean",editType:"arraydraw"},editType:"calc",_deprecated:{ref:{valType:"string",editType:"calc"}}})},{"../../constants/axis_placeable_objects":756,"../../plot_api/plot_template":827,"../../plots/cartesian/constants":845,"../../plots/font_attributes":867,"./arrow_paths":632}],634:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('./draw').draw;function o(t){var e=t._fullLayout;n.filterVisible(e.annotations).forEach((function(e){var r=i.getFromId(t,e.xref),n=i.getFromId(t,e.yref),a=i.getRefType(e.xref),o=i.getRefType(e.yref);e._extremes={},"range"===a&&s(e,r),"range"===o&&s(e,n)}))}function s(t,e){var r,n=e._id,a=n.charAt(0),o=t[a],s=t["a"+a],l=t[a+"ref"],c=t["a"+a+"ref"],u=t["_"+a+"padplus"],f=t["_"+a+"padminus"],h={x:1,y:-1}[a]*t[a+"shift"],p=3*t.arrowsize*t.arrowwidth||0,d=p+h,m=p-h,g=3*t.startarrowsize*t.arrowwidth||0,v=g+h,y=g-h;if(c===l){var x=i.findExtremes(e,[e.r2c(o)],{ppadplus:d,ppadminus:m}),b=i.findExtremes(e,[e.r2c(s)],{ppadplus:Math.max(u,v),ppadminus:Math.max(f,y)});r={min:[x.min[0],b.min[0]],max:[x.max[0],b.max[0]]}}else v=s?v+s:v,y=s?y-s:y,r=i.findExtremes(e,[e.r2c(o)],{ppadplus:Math.max(u,d,v),ppadminus:Math.max(f,m,y)});t._extremes[n]=r}e.exports=function(t){var e=t._fullLayout;if(n.filterVisible(e.annotations).length&&t._fullData.length)return n.syncOrAsync([a,o],t)}},{"../../lib":787,"../../plots/cartesian/axes":838,"./draw":639}],635:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry'),a=t('../../plot_api/plot_template').arrayEditor;function o(t,e){var r=l(t,e);return r.on.length>0||r.explicitOff.length>0}function s(t,e){var r,o,s=l(t,e),c=s.on,u=s.off.concat(s.explicitOff),f={},h=t._fullLayout.annotations;if(c.length||u.length){for(r=0;r<c.length;r++)(o=a(t.layout,'annotations',h[c[r]])).modifyItem('visible',!0),n.extendFlat(f,o.getUpdateObj());for(r=0;r<u.length;r++)(o=a(t.layout,'annotations',h[u[r]])).modifyItem('visible',!1),n.extendFlat(f,o.getUpdateObj());return i.call('update',t,{},f)}}function l(t,e){var r,n,i,a,o,s,l,u=t._fullLayout.annotations,f=[],h=[],p=[],d=(e||[]).length;for(r=0;r<u.length;r++)if(a=(i=u[r]).clicktoshow){for(n=0;n<d;n++)if(s=(o=e[n]).xaxis,l=o.yaxis,s._id===i.xref&&l._id===i.yref&&s.d2r(o.x)===c(i._xclick,s)&&l.d2r(o.y)===c(i._yclick,l)){(i.visible?"onout"===a?h:p:f).push(r);break}n===d&&i.visible&&"onout"===a&&h.push(r)}return{on:f,off:h,explicitOff:p}}function c(t,e){return"log"===e.type?e.l2r(t):e.d2r(t)}e.exports={hasClickToShow:o,onClick:s}},{"../../lib":787,"../../plot_api/plot_template":827,"../../registry":915}],636:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../color');e.exports=function(t,e,r,a){a('opacity');var o=a('bgcolor'),s=a('bordercolor'),l=i.opacity(s);a('borderpad');var c=a('borderwidth'),u=a('showarrow');if(a('text',u?" ':r._dfltTitle.annotation),a('textangle'),n.coerceFont(a,'font',r.font),a('width'),a('align'),a('height')&&a('valign'),u){var f,h,p=a('arrowside');-1!==p.indexOf('end')&&(f=a('arrowhead'),h=a('arrowsize')),-1!==p.indexOf('start')&&(a('startarrowhead',f),a('startarrowsize',h)),a('arrowcolor',l?e.bordercolor:i.defaultLine),a('arrowwidth',2*(l&&c||1)),a('standoff'),a('startstandoff')}var d=a('hovertext'),m=r.hoverlabel||{};if(d){var g=a('hoverlabel.bgcolor',m.bgcolor||(i.opacity(o)?i.rgb(o):i.defaultLine)),v=a('hoverlabel.bordercolor',m.bordercolor||i.contrast(g));n.coerceFont(a,'hoverlabel.font',{family:m.font.family,size:m.font.size,color:m.font.color||v})}a('captureevents',!!d)}},{'../../lib":787,"../color":650}],637:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib/to_log_range');e.exports=function(t,e,r,a){e=e||{};var o="log"===r&&"linear"===e.type,s="linear"===r&&"log"===e.type;if(o||s)for(var l,c,u=t._fullLayout.annotations,f=e._id.charAt(0),h=0;h<u.length;h++)l=u[h],c="annotations["+h+"].",l[f+"ref"]===e._id&&p(f),l["a"+f+"ref"]===e._id&&p("a"+f);function p(t){var r=l[t],s=null;s=o?i(r,e.range):Math.pow(10,r),n(s)||(s=null),a(c+t,s)}}},{"../../lib/to_log_range":815,"fast-isnumeric":246}],638:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../../plots/array_container_defaults'),o=t('./common_defaults'),s=t('./attributes');function l(t,e,r){function a(r,i){return n.coerce(t,e,s,r,i)}var l=a('visible'),c=a('clicktoshow');if(l||c){o(t,e,r,a);for(var u=e.showarrow,f=["x","y"],h=[-10,-30],p={_fullLayout:r},d=0;d<2;d++){var m=f[d],g=i.coerceRef(t,e,p,m,'','paper');if("paper"!==g&&i.getFromId(p,g)._annIndices.push(e._index),i.coercePosition(e,p,a,g,m,.5),u){var v="a"+m,y=i.coerceRef(t,e,p,v,'pixel',["pixel","paper"]);"pixel"!==y&&y!==g&&(y=e[v]='pixel');var x="pixel"===y?h[d]:.4;i.coercePosition(e,p,a,y,v,x)}a(m+"anchor"),a(m+"shift")}if(n.noneOrAll(t,e,["x","y"]),u&&n.noneOrAll(t,e,["ax","ay"]),c){var b=a('xclick'),_=a('yclick');e._xclick=void 0===b?e.x:i.cleanPosition(b,p,e.xref),e._yclick=void 0===_?e.y:i.cleanPosition(_,p,e.yref)}}}e.exports=function(t,e){a(t,e,{name:"annotations",handleItemDefaults:l})}},{"../../lib":787,"../../plots/array_container_defaults":833,"../../plots/cartesian/axes":838,"./attributes":633,"./common_defaults":636}],639:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../plots/plots'),o=t('../../lib'),s=o.strTranslate,l=t('../../plots/cartesian/axes'),c=t('../color'),u=t('../drawing'),f=t('../fx'),h=t('../../lib/svg_text_utils'),p=t('../../lib/setcursor'),d=t('../dragelement'),m=t('../../plot_api/plot_template').arrayEditor,g=t('./draw_arrow_head');function v(t){var e=t._fullLayout;e._infolayer.selectAll('.annotation').remove();for(var r=0;r<e.annotations.length;r++)e.annotations[r].visible&&y(t,r);return a.previousPromises(t)}function y(t,e)[var r=t._fullLayout.annotations[e]||{],n=l.getFromId(t,r.xref),i=l.getFromId(t,r.yref);n&&n.setScale(),i&&i.setScale(),b(t,r,e,!1,n,i)}function x(t,e,r,n,i){var a=i[r],o=i[r+"ref"],s=-1!==r.indexOf('y'),c="domain"===l.getRefType(o),u=s?n.h:n.w;return t?c?a+(s?-e:e)/t._length:t.p2r(t.r2p(a)+e):a+(s?-e:e)/u}function b(t,e,r,a,v,y){var b,_,w=t._fullLayout,T=t._fullLayout._size,k=t._context.edits;a?(b="annotation-"+a,_=a+".annotations"):(b='annotation',_='annotations');var M=m(t.layout,_,e),A=M.modifyBase,S=M.modifyItem,E=M.getUpdateObj;w._infolayer.selectAll("."+b+'[data-index="'+r+'"]').remove();var L="clip"+w._uid+"_ann"+r;if(e._input&&!1!==e.visible){var C={x:{},y:{}},P=+e.textangle||0,I=w._infolayer.append('g').classed(b,!0).attr('data-index',String(r)).style('opacity',e.opacity),z=I.append('g').classed('annotation-text-g',!0),O=k[e.showarrow?"annotationTail":"annotationPosition"],D=e.captureevents||k.annotationText||O,R=z.append('g').style('pointer-events',D?"all":null).call(p,'pointer').on('click',(function(){t._dragging=!1,t.emit('plotly_clickannotation',Y(n.event))}));e.hovertext&&R.on('mouseover',(function(){var r=e.hoverlabel,n=r.font,i=this.getBoundingClientRect(),a=t.getBoundingClientRect();f.loneHover({x0:i.left-a.left,x1:i.right-a.left,y:(i.top+i.bottom)/2-a.top,text:e.hovertext,color:r.bgcolor,borderColor:r.bordercolor,fontFamily:n.family,fontSize:n.size,fontColor:n.color},{container:w._hoverlayer.node(),outerContainer:w._paper.node(),gd:t})})).on('mouseout',(function()[f.loneUnhover(w._hoverlayer.node())]));var F=e.borderwidth,B=e.borderpad,N=F+B,j=R.append('rect').attr('class','bg').style('stroke-width',F+"px").call(c.stroke,e.bordercolor).call(c.fill,e.bgcolor),U=e.width||e.height,V=w._topclips.selectAll("#"+L).data(U?[0]:[]);V.enter().append('clipPath').classed('annclip',!0).attr('id',L).append('rect'),V.exit().remove();var H=e.font,q=w._meta?o.templateString(e.text,w._meta):e.text,G=R.append('text').classed('annotation-text',!0).text(q);k.annotationText?G.call(h.makeEditable,{delegate:R,gd:t}).call(W).on('edit',(function(r){e.text=r,this.call(W),S('text',r),v&&v.autorange&&A(v._name+".autorange",!0),y&&y.autorange&&A(y._name+".autorange",!0),i.call('_guiRelayout',t,E())})):G.call(W)}else n.selectAll("#"+L).remove();function Y(t){var n={index:r,annotation:e._input,fullAnnotation:e,event:t};return a&&(n.subplotId=a),n}function W(r){return r.call(u.font,H).attr({"text-anchor":{left:"start",right:"end"}[e.align]||"middle"}),h.convertToTspans(r,t,X),r}function X(){var r=G.selectAll('a');1===r.size()&&r.text()===G.text()&&R.insert('a',':first-child').attr({"xlink:xlink:href":r.attr('xlink:href'),"xlink:xlink:show":r.attr('xlink:show')}).style({cursor:"pointer"}).node().appendChild(j.node());var n=R.select('.annotation-text-math-group'),f=!n.empty(),m=u.bBox((f?n:G).node()),b=m.width,_=m.height,M=e.width||b,D=e.height||_,B=Math.round(M+2*N),H=Math.round(D+2*N);function q(t,e){return"auto"===e&&(e=t<1/3?"left":t>2/3?"right":"center"),{center:0,middle:0,left:.5,bottom:-.5,right:-.5,top:.5}[e]}for(var W=!1,X=["x","y"],Z=0;Z<X.length;Z++){var J,K,Q,$,tt,et=X[Z],rt=e[et+"ref"]||et,nt=e["a"+et+"ref"],it={x:v,y:y}[et],at=(P+("x"===et?0:-90))*Math.PI/180,ot=B*Math.cos(at),st=H*Math.sin(at),lt=Math.abs(ot)+Math.abs(st),ct=e[et+"anchor"],ut=e[et+"shift"]*("x"===et?1:-1),ft=C[et],ht=l.getRefType(rt);if(it&&"domain"!==ht){var pt=it.r2fraction(e[et]);(pt<0||pt>1)&&(nt===rt?((pt=it.r2fraction(e["a"+et]))<0||pt>1)&&(W=!0):W=!0),J=it._offset+it.r2p(e[et]),$=.5}else{var dt="domain"===ht;"x"===et?(Q=e[et],J=dt?it._offset+it._length*Q:J=T.l+T.w*Q):(Q=1-e[et],J=dt?it._offset+it._length*Q:J=T.t+T.h*Q),$=e.showarrow?.5:Q}if(e.showarrow){ft.head=J;var mt=e["a"+et];if(tt=ot*q(.5,e.xanchor)-st*q(.5,e.yanchor),nt===rt){var gt=l.getRefType(nt);"domain"===gt?("y"===et&&(mt=1-mt),ft.tail=it._offset+it._length*mt):"paper"===gt?"y"===et?(mt=1-mt,ft.tail=T.t+T.h*mt):ft.tail=T.l+T.w*mt:ft.tail=it._offset+it.r2p(mt),K=tt}else ft.tail=J+mt,K=tt+mt;ft.text=ft.tail+tt;var vt=w["x"===et?"width":"height"];if("paper"===rt&&(ft.head=o.constrain(ft.head,1,vt-1)),"pixel"===nt){var yt=-Math.max(ft.tail-3,ft.text),xt=Math.min(ft.tail+3,ft.text)-vt;yt>0?(ft.tail+=yt,ft.text+=yt):xt>0&&(ft.tail-=xt,ft.text-=xt)}ft.tail+=ut,ft.head+=ut}else K=tt=lt*q($,ct),ft.text=J+tt;ft.text+=ut,tt+=ut,K+=ut,e["_"+et+"padplus"]=lt/2+K,e["_"+et+"padminus"]=lt/2-K,e["_"+et+"size"]=lt,e["_"+et+"shift"]=tt}if(W)R.remove();else{var bt=0,_t=0;if("left"!==e.align&&(bt=(M-b)*("center"===e.align?.5:1)),"top"!==e.valign&&(_t=(D-_)*("middle"===e.valign?.5:1)),f)n.select('svg').attr({x:N+bt-1,y:N+_t}).call(u.setClipUrl,U?L:null,t);else{var wt=N+_t-m.top,Tt=N+bt-m.left;G.call(h.positionText,Tt,wt).call(u.setClipUrl,U?L:null,t)}V.select('rect').call(u.setRect,N,N,M,D),j.call(u.setRect,F/2,F/2,B-F,H-F),R.call(u.setTranslate,Math.round(C.x.text-B/2),Math.round(C.y.text-H/2)),z.attr({transform:"rotate('+P+','+C.x.text+','+C.y.text+')"});var kt,Mt=function(r,n){I.selectAll('.annotation-arrow-g').remove();var l=C.x.head,f=C.y.head,h=C.x.tail+r,p=C.y.tail+n,m=C.x.text+r,b=C.y.text+n,_=o.rotationXYMatrix(P,m,b),w=o.apply2DTransform(_),M=o.apply2DTransform2(_),L=+j.attr('width'),O=+j.attr('height'),D=m-.5*L,F=D+L,B=b-.5*O,N=B+O,U=[[D,B,D,N],[D,N,F,N],[F,N,F,B],[F,B,D,B]].map(M);if(!U.reduce((function(t,e){return t^!!o.segmentsIntersect(l,f,l+1e6,f+1e6,e[0],e[1],e[2],e[3])}),!1)){U.forEach((function(t){var e=o.segmentsIntersect(h,p,l,f,t[0],t[1],t[2],t[3]);e&&(h=e.x,p=e.y)}));var V=e.arrowwidth,H=e.arrowcolor,q=e.arrowside,G=I.append('g').style({opacity:c.opacity(H)}).classed('annotation-arrow-g',!0),Y=G.append('path').attr('d',"M"+h+","+p+"L"+l+","+f).style('stroke-width',V+"px").call(c.stroke,c.rgb(H));if(g(Y,q,e),k.annotationPosition&&Y.node().parentNode&&!a){var W=l,X=f;if(e.standoff){var Z=Math.sqrt(Math.pow(l-h,2)+Math.pow(f-p,2));W+=e.standoff*(h-l)/Z,X+=e.standoff*(p-f)/Z}var J,K,Q=G.append('path').classed('annotation-arrow',!0).classed('anndrag',!0).classed('cursor-move',!0).attr({d:"M3,3H-3V-3H3ZM0,0L"+(h-W)+","+(p-X),transform:s(W,X)}).style('stroke-width',V+6+"px").call(c.stroke,'rgba(0,0,0,0)').call(c.fill,'rgba(0,0,0,0)');d.init({element:Q.node(),gd:t,prepFn:function(){var t=u.getTranslate(R);J=t.x,K=t.y,v&&v.autorange&&A(v._name+".autorange",!0),y&&y.autorange&&A(y._name+".autorange",!0)},moveFn:function(t,r){var n=w(J,K),i=n[0]+t,a=n[1]+r;R.call(u.setTranslate,i,a),S('x',x(v,t,'x',T,e)),S('y',x(y,r,'y',T,e)),e.axref===e.xref&&S('ax',x(v,t,'ax',T,e)),e.ayref===e.yref&&S('ay',x(y,r,'ay',T,e)),G.attr('transform',s(t,r)),z.attr({transform:"rotate('+P+','+i+','+a+')"})},doneFn:function(){i.call('_guiRelayout',t,E());var e=document.querySelector('.js-notes-box-panel');e&&e.redraw(e.selectedObj)}})}}};e.showarrow&&Mt(0,0),O&&d.init({element:R.node(),gd:t,prepFn:function(){kt=z.attr('transform')},moveFn:function(t,r){var n='pointer';if(e.showarrow)e.axref===e.xref?S('ax',x(v,t,'ax',T,e)):S('ax',e.ax+t),e.ayref===e.yref?S('ay',x(y,r,'ay',T.w,e)):S('ay',e.ay+r),Mt(t,r);else{if(a)return;var i,o;if(v)i=x(v,t,'x',T,e);else{var l=e._xsize/T.w,c=e.x+(e._xshift-e.xshift)/T.w-l/2;i=d.align(c+t/T.w,l,0,1,e.xanchor)}if(y)o=x(y,r,'y',T,e);else{var u=e._ysize/T.h,f=e.y-(e._yshift+e.yshift)/T.h-u/2;o=d.align(f-r/T.h,u,0,1,e.yanchor)}S('x',i),S('y',o),v&&y||(n=d.getCursor(v?.5:i,y?.5:o,e.xanchor,e.yanchor))}z.attr({transform:s(t,r)+kt}),p(R,n)},clickFn:function(r,n){e.captureevents&&t.emit('plotly_clickannotation',Y(n))},doneFn:function(){p(R),i.call('_guiRelayout',t,E());var e=document.querySelector('.js-notes-box-panel');e&&e.redraw(e.selectedObj)}})}}}e.exports={draw:v,drawOne:y,drawRaw:b}},{"../../lib":787,"../../lib/setcursor":808,"../../lib/svg_text_utils":813,"../../plot_api/plot_template":827,"../../plots/cartesian/axes":838,"../../plots/plots":901,"../../registry":915,"../color":650,"../dragelement":669,"../drawing":672,"../fx":690,"./draw_arrow_head":640,"@plotly/d3":58}],640:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../color'),a=t('./arrow_paths'),o=t('../../lib'),s=o.strScale,l=o.strRotate,c=o.strTranslate;e.exports=function(t,e,r){var o,u,f,h,p=t.node(),d=a[r.arrowhead||0],m=a[r.startarrowhead||0],g=(r.arrowwidth||1)*(r.arrowsize||1),v=(r.arrowwidth||1)*(r.startarrowsize||1),y=e.indexOf('start')>=0,x=e.indexOf('end')>=0,b=d.backoff*g+r.standoff,_=m.backoff*v+r.startstandoff;if("line"===p.nodeName){o={x:+t.attr('x1'),y:+t.attr('y1')},u={x:+t.attr('x2'),y:+t.attr('y2')};var w=o.x-u.x,T=o.y-u.y;if(h=(f=Math.atan2(T,w))+Math.PI,b&&_&&b+_>Math.sqrt(w*w+T*T))return void O();if(b){if(b*b>w*w+T*T)return void O();var k=b*Math.cos(f),M=b*Math.sin(f);u.x+=k,u.y+=M,t.attr({x2:u.x,y2:u.y})}if(_){if(_*_>w*w+T*T)return void O();var A=_*Math.cos(f),S=_*Math.sin(f);o.x-=A,o.y-=S,t.attr({x1:o.x,y1:o.y})}}else if("path"===p.nodeName){var E=p.getTotalLength(),L='';if(E<b+_)return void O();var C=p.getPointAtLength(0),P=p.getPointAtLength(.1);f=Math.atan2(C.y-P.y,C.x-P.x),o=p.getPointAtLength(Math.min(_,E)),L="0px,"+_+"px,";var I=p.getPointAtLength(E),z=p.getPointAtLength(E-.1);h=Math.atan2(I.y-z.y,I.x-z.x),u=p.getPointAtLength(Math.max(0,E-b)),L+=E-(L?_+b:b)+"px,"+E+"px",t.style('stroke-dasharray',L)}function O(){t.style('stroke-dasharray','0px,100px')}function D(e,a,o,u){e.path&&(e.noRotate&&(o=0),n.select(p.parentNode).append('path').attr({class:t.attr('class'),d:e.path,transform:c(a.x,a.y)+l(180*o/Math.PI)+s(u)}).style({fill:i.rgb(r.arrowcolor),"stroke-width":0}))}y&&D(m,o,f,v),x&&D(d,u,h,g)}},{"../../lib":787,"../color":650,"./arrow_paths":632,"@plotly/d3":58}],641:[function(t,e,r){"use strict";var n=t('./draw'),i=t('./click');e.exports={moduleType:"component",name:"annotations",layoutAttributes:t('./attributes'),supplyLayoutDefaults:t('./defaults'),includeBasePlot:t('../../plots/cartesian/include_components')('annotations'),calcAutorange:t('./calc_autorange'),draw:n.draw,drawOne:n.drawOne,drawRaw:n.drawRaw,hasClickToShow:i.hasClickToShow,onClick:i.onClick,convertCoords:t('./convert_coords')}},{"../../plots/cartesian/include_components":851,"./attributes":633,"./calc_autorange":634,"./click":635,"./convert_coords":637,"./defaults":638,"./draw":639}],642:[function(t,e,r){"use strict";var n=t('../annotations/attributes'),i=t('../../plot_api/edit_types').overrideAll,a=t('../../plot_api/plot_template').templatedArray;e.exports=i(a('annotation',{visible:n.visible,x:{valType:"any"},y:{valType:"any"},z:{valType:"any"},ax:{valType:"number"},ay:{valType:"number"},xanchor:n.xanchor,xshift:n.xshift,yanchor:n.yanchor,yshift:n.yshift,text:n.text,textangle:n.textangle,font:n.font,width:n.width,height:n.height,opacity:n.opacity,align:n.align,valign:n.valign,bgcolor:n.bgcolor,bordercolor:n.bordercolor,borderpad:n.borderpad,borderwidth:n.borderwidth,showarrow:n.showarrow,arrowcolor:n.arrowcolor,arrowhead:n.arrowhead,startarrowhead:n.startarrowhead,arrowside:n.arrowside,arrowsize:n.arrowsize,startarrowsize:n.startarrowsize,arrowwidth:n.arrowwidth,standoff:n.standoff,startstandoff:n.startstandoff,hovertext:n.hovertext,hoverlabel:n.hoverlabel,captureevents:n.captureevents}),'calc','from-root')},{"../../plot_api/edit_types":820,"../../plot_api/plot_template":827,"../annotations/attributes":633}],643:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes');function a(t,e){var r=e.fullSceneLayout.domain,a=e.fullLayout._size,o={pdata:null,type:"linear",autorange:!1,range:[-1/0,1/0]};t._xa={},n.extendFlat(t._xa,o),i.setConvert(t._xa),t._xa._offset=a.l+r.x[0]*a.w,t._xa.l2p=function(){return.5*(1+t._pdata[0]/t._pdata[3])*a.w*(r.x[1]-r.x[0])},t._ya={},n.extendFlat(t._ya,o),i.setConvert(t._ya),t._ya._offset=a.t+(1-r.y[1])*a.h,t._ya.l2p=function(){return.5*(1-t._pdata[1]/t._pdata[3])*a.h*(r.y[1]-r.y[0])}}e.exports=function(t){for(var e=t.fullSceneLayout.annotations,r=0;r<e.length;r++)a(e[r],t);t.fullLayout._infolayer.selectAll(".annotation-"+t.id).remove()}},{"../../lib":787,"../../plots/cartesian/axes":838}],644:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../../plots/array_container_defaults'),o=t('../annotations/common_defaults'),s=t('./attributes');function l(t,e,r,a){function l(r,i){return n.coerce(t,e,s,r,i)}function c(t){var n=t+"axis",a={_fullLayout:{}};return a._fullLayout[n]=r[n],i.coercePosition(e,a,l,t,t,.5)}l('visible')&&(o(t,e,a.fullLayout,l),c('x'),c('y'),c('z'),n.noneOrAll(t,e,["x",'y',"z"]),e.xref='x',e.yref='y',e.zref='z',l('xanchor'),l('yanchor'),l('xshift'),l('yshift'),e.showarrow&&(e.axref='pixel',e.ayref='pixel',l('ax',-10),l('ay',-30),n.noneOrAll(t,e,["ax","ay"])))}e.exports=function(t,e,r){a(t,e,{name:"annotations",handleItemDefaults:l,fullLayout:r.fullLayout})}},{"../../lib":787,"../../plots/array_container_defaults":833,"../../plots/cartesian/axes":838,"../annotations/common_defaults":636,"./attributes":642}],645:[function(t,e,r){"use strict";var n=t('../annotations/draw').drawRaw,i=t('../../plots/gl3d/project'),a=["x",'y',"z"];e.exports=function(t){for(var e=t.fullSceneLayout,r=t.dataScale,o=e.annotations,s=0;s<o.length;s++){for(var l=o[s],c=!1,u=0;u<3;u++){var f=a[u],h=l[f],p=e[f+"axis"].r2fraction(h);if(p<0||p>1){c=!0;break}}c?t.fullLayout._infolayer.select(".annotation-"+t.id+'[data-index="'+s+'"]').remove():(l._pdata=i(t.glplot.cameraParams,[e.xaxis.r2l(l.x)*r[0],e.yaxis.r2l(l.y)*r[1],e.zaxis.r2l(l.z)*r[2]]),n(t.graphDiv,l,s,t.id,l._xa,l._ya))}}},{"../../plots/gl3d/project":889,"../annotations/draw":639}],646:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib');function a(t,e){var r=n.subplotsRegistry.gl3d;if(r)for(var a=r.attrRegex,o=Object.keys(t),s=0;s<o.length;s++){var l=o[s];a.test(l)&&(t[l].annotations||[]).length&&(i.pushUnique(e._basePlotModules,r),i.pushUnique(e._subplots.gl3d,l))}}e.exports={moduleType:"component",name:"annotations3d",schema:{subplots:{scene:{annotations:t('./attributes')}}},layoutAttributes:t('./attributes'),handleDefaults:t('./defaults'),includeBasePlot:a,convert:t('./convert'),draw:t('./draw')}},{"../../lib":787,"../../registry":915,"./attributes":642,"./convert":643,"./defaults":644,"./draw":645}],647:[function(t,e,r){"use strict";e.exports=t('world-calendars/dist/main'),t('world-calendars/dist/plus'),t('world-calendars/dist/calendars/chinese'),t('world-calendars/dist/calendars/coptic'),t('world-calendars/dist/calendars/discworld'),t('world-calendars/dist/calendars/ethiopian'),t('world-calendars/dist/calendars/hebrew'),t('world-calendars/dist/calendars/islamic'),t('world-calendars/dist/calendars/julian'),t('world-calendars/dist/calendars/mayan'),t('world-calendars/dist/calendars/nanakshahi'),t('world-calendars/dist/calendars/nepali'),t('world-calendars/dist/calendars/persian'),t('world-calendars/dist/calendars/taiwan'),t('world-calendars/dist/calendars/thai'),t('world-calendars/dist/calendars/ummalqura')},{"world-calendars/dist/calendars/chinese":614,"world-calendars/dist/calendars/coptic":615,"world-calendars/dist/calendars/discworld":616,"world-calendars/dist/calendars/ethiopian":617,"world-calendars/dist/calendars/hebrew":618,"world-calendars/dist/calendars/islamic":619,"world-calendars/dist/calendars/julian":620,"world-calendars/dist/calendars/mayan":621,"world-calendars/dist/calendars/nanakshahi":622,"world-calendars/dist/calendars/nepali":623,"world-calendars/dist/calendars/persian":624,"world-calendars/dist/calendars/taiwan":625,"world-calendars/dist/calendars/thai":626,"world-calendars/dist/calendars/ummalqura":627,"world-calendars/dist/main":628,"world-calendars/dist/plus":629}],648:[function(t,e,r){"use strict";var n=t('./calendars'),i=t('../../lib'),a=t('../../constants/numerical'),o=a.EPOCHJD,s=a.ONEDAY,l={valType:"enumerated",values:i.sortObjectKeys(n.calendars),editType:"calc",dflt:"gregorian"},c=function(t,e,r,n)[var a={];return a[r]=l,i.coerce(t,e,a,r,n)},u=function(t,e,r,n){for(var i=0;i<r.length;i++)c(t,e,r[i]+"calendar",n.calendar)},f={chinese:"2000-01-01",coptic:"2000-01-01",discworld:"2000-01-01",ethiopian:"2000-01-01",hebrew:"5000-01-01",islamic:"1000-01-01",julian:"2000-01-01",mayan:"5000-01-01",nanakshahi:"1000-01-01",nepali:"2000-01-01",persian:"1000-01-01",jalali:"1000-01-01",taiwan:"1000-01-01",thai:"2000-01-01",ummalqura:"1400-01-01"},h={chinese:"2000-01-02",coptic:"2000-01-03",discworld:"2000-01-03",ethiopian:"2000-01-05",hebrew:"5000-01-01",islamic:"1000-01-02",julian:"2000-01-03",mayan:"5000-01-01",nanakshahi:"1000-01-05",nepali:"2000-01-05",persian:"1000-01-01",jalali:"1000-01-01",taiwan:"1000-01-04",thai:"2000-01-04",ummalqura:"1400-01-06"},p={chinese:["2000-01-01","2001-01-01"],coptic:["1700-01-01","1701-01-01"],discworld:["1800-01-01","1801-01-01"],ethiopian:["2000-01-01","2001-01-01"],hebrew:["5700-01-01","5701-01-01"],islamic:["1400-01-01","1401-01-01"],julian:["2000-01-01","2001-01-01"],mayan:["5200-01-01","5201-01-01"],nanakshahi:["0500-01-01","0501-01-01"],nepali:["2000-01-01","2001-01-01"],persian:["1400-01-01","1401-01-01"],jalali:["1400-01-01","1401-01-01"],taiwan:["0100-01-01","0101-01-01"],thai:["2500-01-01","2501-01-01"],ummalqura:["1400-01-01","1401-01-01"]},d='##',m={d:{0:"dd","-":"d"},e:{0:"d","-":"d"},a:{0:"D","-":"D"},A:{0:"DD","-":"DD"},j:{0:"oo","-":"o"},W:{0:"ww","-":"w"},m:{0:"mm","-":"m"},b:{0:"M","-":"M"},B:{0:"MM","-":"MM"},y:{0:"yy","-":"yy"},Y:{0:"yyyy","-":"yyyy"},U:d,w:d,c:{0:"D M d %X yyyy","-":"D M d %X yyyy"},x:{0:"mm/dd/yyyy","-":"mm/dd/yyyy"}};function g(t,e,r){for(var n,i,a,l,c,u=Math.floor((e+.05)/s)+o,f=y(r).fromJD(u),h=0;-1!==(h=t.indexOf('%',h));)"0"===(n=t.charAt(h+1))||"-"===n||"_"===n?(a=3,i=t.charAt(h+2),"_"===n&&(n='-')):(i=n,n='0',a=2),(l=m[i])?(c=l===d?d:f.formatDate(l[n]),t=t.substr(0,h)+c+t.substr(h+a),h+=c.length):h+=a;return t}var v={};function y(t){var e=v[t];return e||(e=v[t]=n.instance(t))}function x(t){return i.extendFlat({},l,{description:t})}function b(t){return"Sets the calendar system to use with `"+t+"` date data."}var _={xcalendar:x(b('x'))},w=i.extendFlat({},_,{ycalendar:x(b('y'))}),T=i.extendFlat({},w,{zcalendar:x(b('z'))}),k=x(["Sets the calendar system to use for `range` and `tick0`",'if this is a date axis. This does not set the calendar for','interpreting data on this axis, that's specified in the trace',"or via the global `layout.calendar`"].join(' '));e.exports={moduleType:"component",name:"calendars",schema:{traces:{scatter:w,bar:w,box:w,heatmap:w,contour:w,histogram:w,histogram2d:w,histogram2dcontour:w,scatter3d:T,surface:T,mesh3d:T,scattergl:w,ohlc:_,candlestick:_},layout:{calendar:x(["Sets the default calendar system to use for interpreting and","displaying dates throughout the plot."].join(' '))},subplots:{xaxis:{calendar:k},yaxis:{calendar:k},scene:{xaxis:{calendar:k},yaxis:{calendar:k},zaxis:{calendar:k}},polar:{radialaxis:{calendar:k}}},transforms:{filter:{valuecalendar:x(["WARNING: All transforms are deprecated and may be removed from the API in next major version.","Sets the calendar system to use for `value`, if it is a date."].join(' ')),targetcalendar:x(["WARNING: All transforms are deprecated and may be removed from the API in next major version.",'Sets the calendar system to use for `target`, if it is an','array of dates. If `target` is a string (eg *x*) we use the','corresponding trace attribute (eg `xcalendar`) if it exists,',"even if `targetcalendar` is provided."].join(' '))}}},layoutAttributes:l,handleDefaults:c,handleTraceDefaults:u,CANONICAL_SUNDAY:h,CANONICAL_TICK:f,DFLTRANGE:p,getCal:y,worldCalFmt:g}},{"../../constants/numerical":763,"../../lib":787,"./calendars":647}],649:[function(t,e,r){"use strict";r.defaults=["#1f77b4",'#ff7f0e','#2ca02c','#d62728','#9467bd','#8c564b','#e377c2','#7f7f7f','#bcbd22',"#17becf"],r.defaultLine='#444',r.lightLine='#eee',r.background='#fff',r.borderLine='#BEC8D9',r.lightFraction=1e3/11},{}],650:[function(t,e,r){"use strict";var n=t('tinycolor2'),i=t('fast-isnumeric'),a=t('../../lib/array').isTypedArray,o=e.exports={},s=t('./attributes');o.defaults=s.defaults;var l=o.defaultLine=s.defaultLine;o.lightLine=s.lightLine;var c=o.background=s.background;function u(t){if(i(t)||"string"!==typeof t)return t;var e=t.trim();if("rgb"!==e.substr(0,3))return t;var r=e.match(/^rgba?\s*\(([^()]*)\)$/);if(!r)return t;var n=r[1].trim().split(/\s*[\s,]\s*/),a="a"===e.charAt(3)&&4===n.length;if(!a&&3!==n.length)return t;for(var o=0;o<n.length;o++){if(!n[o].length)return t;if(n[o]=Number(n[o]),!(n[o]>=0))return t;if(3===o)n[o]>1&&(n[o]=1);else if(n[o]>=1)return t}var s=Math.round(255*n[0])+", '+Math.round(255*n[1])+', "+Math.round(255*n[2]);return a?"rgba('+s+', '+n[3]+')":"rgb('+s+')"}o.tinyRGB=function(t){var e=t.toRgb();return"rgb('+Math.round(e.r)+', '+Math.round(e.g)+', '+Math.round(e.b)+')"},o.rgb=function(t){return o.tinyRGB(n(t))},o.opacity=function(t){return t?n(t).getAlpha():0},o.addOpacity=function(t,e){var r=n(t).toRgb();return"rgba('+Math.round(r.r)+', '+Math.round(r.g)+', '+Math.round(r.b)+', '+e+')"},o.combine=function(t,e){var r=n(t).toRgb();if(1===r.a)return n(t).toRgbString();var i=n(e||c).toRgb(),a=1===i.a?i:{r:255*(1-i.a)+i.r*i.a,g:255*(1-i.a)+i.g*i.a,b:255*(1-i.a)+i.b*i.a},o={r:a.r*(1-r.a)+r.r*r.a,g:a.g*(1-r.a)+r.g*r.a,b:a.b*(1-r.a)+r.b*r.a};return n(o).toRgbString()},o.contrast=function(t,e,r){var i=n(t);return 1!==i.getAlpha()&&(i=n(o.combine(t,c))),(i.isDark()?e?i.lighten(e):c:r?i.darken(r):l).toString()},o.stroke=function(t,e){var r=n(e);t.style({stroke:o.tinyRGB(r),"stroke-opacity":r.getAlpha()})},o.fill=function(t,e){var r=n(e);t.style({fill:o.tinyRGB(r),"fill-opacity":r.getAlpha()})},o.clean=function(t){if(t&&"object"===typeof t){var e,r,n,i,s=Object.keys(t);for(e=0;e<s.length;e++)if(i=t[n=s[e]],"color"===n.substr(n.length-5))if(Array.isArray(i))for(r=0;r<i.length;r++)i[r]=u(i[r]);else t[n]=u(i);else if("colorscale"===n.substr(n.length-10)&&Array.isArray(i))for(r=0;r<i.length;r++)Array.isArray(i[r])&&(i[r][1]=u(i[r][1]));else if(Array.isArray(i)){var l=i[0];if(!Array.isArray(l)&&l&&"object"===typeof l)for(r=0;r<i.length;r++)o.clean(i[r])}else i&&"object"===typeof i&&!a(i)&&o.clean(i)}}},{"../../lib/array":769,"./attributes":649,"fast-isnumeric":246,tinycolor2:583}],651:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/layout_attributes'),i=t('../../plots/font_attributes'),a=t('../../lib/extend').extendFlat,o=t('../../plot_api/edit_types').overrideAll;e.exports=o({thicknessmode:{valType:"enumerated",values:["fraction","pixels"],dflt:"pixels"},thickness:{valType:"number",min:0,dflt:30},lenmode:{valType:"enumerated",values:["fraction","pixels"],dflt:"fraction"},len:{valType:"number",min:0,dflt:1},x:{valType:"number",dflt:1.02,min:-2,max:3},xanchor:{valType:"enumerated",values:["left",'center',"right"],dflt:"left"},xpad:{valType:"number",min:0,dflt:10},y:{valType:"number",dflt:.5,min:-2,max:3},yanchor:{valType:"enumerated",values:["top",'middle',"bottom"],dflt:"middle"},ypad:{valType:"number",min:0,dflt:10},outlinecolor:n.linecolor,outlinewidth:n.linewidth,bordercolor:n.linecolor,borderwidth:{valType:"number",min:0,dflt:0},bgcolor:{valType:"color",dflt:"rgba(0,0,0,0)"},tickmode:n.tickmode,nticks:n.nticks,tick0:n.tick0,dtick:n.dtick,tickvals:n.tickvals,ticktext:n.ticktext,ticks:a({},n.ticks,{dflt:""}),ticklabeloverflow:a({},n.ticklabeloverflow,{}),ticklabelposition:{valType:"enumerated",values:["outside",'inside','outside top','inside top','outside bottom',"inside bottom"],dflt:"outside"},ticklen:n.ticklen,tickwidth:n.tickwidth,tickcolor:n.tickcolor,showticklabels:n.showticklabels,tickfont:i({}),tickangle:n.tickangle,tickformat:n.tickformat,tickformatstops:n.tickformatstops,tickprefix:n.tickprefix,showtickprefix:n.showtickprefix,ticksuffix:n.ticksuffix,showticksuffix:n.showticksuffix,separatethousands:n.separatethousands,exponentformat:n.exponentformat,minexponent:n.minexponent,showexponent:n.showexponent,title:{text:{valType:"string"},font:i({}),side:{valType:"enumerated",values:["right",'top',"bottom"],dflt:"top"}},_deprecated:{title:{valType:"string"},titlefont:i({}),titleside:{valType:"enumerated",values:["right",'top',"bottom"],dflt:"top"}}},'colorbars','from-root')},{"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/cartesian/layout_attributes":853,"../../plots/font_attributes":867}],652:[function(t,e,r){"use strict";e.exports={cn:{colorbar:"colorbar",cbbg:"cbbg",cbfill:"cbfill",cbfills:"cbfills",cbline:"cbline",cblines:"cblines",cbaxis:"cbaxis",cbtitleunshift:"cbtitleunshift",cbtitle:"cbtitle",cboutline:"cboutline",crisp:"crisp",jsPlaceholder:"js-placeholder"}}},{}],653:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plot_api/plot_template'),a=t('../../plots/cartesian/tick_value_defaults'),o=t('../../plots/cartesian/tick_mark_defaults'),s=t('../../plots/cartesian/tick_label_defaults'),l=t('./attributes');e.exports=function(t,e,r){var c=i.newContainer(e,'colorbar'),u=t.colorbar||{};function f(t,e){return n.coerce(u,c,l,t,e)}var h=f('thicknessmode');f('thickness',"fraction"===h?30/(r.width-r.margin.l-r.margin.r):30);var p=f('lenmode');f('len',"fraction"===p?1:r.height-r.margin.t-r.margin.b),f('x'),f('xanchor'),f('xpad'),f('y'),f('yanchor'),f('ypad'),n.noneOrAll(u,c,["x","y"]),f('outlinecolor'),f('outlinewidth'),f('bordercolor'),f('borderwidth'),f('bgcolor');var d=f('ticklabelposition');f('ticklabeloverflow',-1!==d.indexOf('inside')?"hide past domain":"hide past div"),a(u,c,f,'linear');var m=r.font,g={outerTicks:!1,font:m};-1!==d.indexOf('inside')&&(g.bgColor='black'),s(u,c,f,'linear',g),o(u,c,f,'linear',g),f('title.text',r._dfltTitle.colorbar);var v=c.tickfont,y=n.extendFlat({},v,{color:m.color,size:n.bigFont(v.size)});n.coerceFont(f,'title.font',y),f('title.side')}},{"../../lib":787,"../../plot_api/plot_template":827,"../../plots/cartesian/tick_label_defaults":860,"../../plots/cartesian/tick_mark_defaults":861,"../../plots/cartesian/tick_value_defaults":862,"./attributes":651}],654:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('tinycolor2'),a=t('../../plots/plots'),o=t('../../registry'),s=t('../../plots/cartesian/axes'),l=t('../dragelement'),c=t('../../lib'),u=c.strTranslate,f=t('../../lib/extend').extendFlat,h=t('../../lib/setcursor'),p=t('../drawing'),d=t('../color'),m=t('../titles'),g=t('../../lib/svg_text_utils'),v=t('../colorscale/helpers').flipScale,y=t('../../plots/cartesian/axis_defaults'),x=t('../../plots/cartesian/position_defaults'),b=t('../../plots/cartesian/layout_attributes'),_=t('../../constants/alignment'),w=_.LINE_SPACING,T=_.FROM_TL,k=_.FROM_BR,M=t('./constants').cn;function A(t){var e=t._fullLayout._infolayer.selectAll("g."+M.colorbar).data(S(t),(function(t){return t._id}));e.enter().append('g').attr('class',(function(t){return t._id})).classed(M.colorbar,!0),e.each((function(e){var r=n.select(this);c.ensureSingle(r,'rect',M.cbbg),c.ensureSingle(r,'g',M.cbfills),c.ensureSingle(r,'g',M.cblines),c.ensureSingle(r,'g',M.cbaxis,(function(t){t.classed(M.crisp,!0)})),c.ensureSingle(r,'g',M.cbtitleunshift,(function(t){t.append('g').classed(M.cbtitle,!0)})),c.ensureSingle(r,'rect',M.cboutline);var i=E(r,e,t);i&&i.then&&(t._promises||[]).push(i),t._context.edits.colorbarPosition&&L(r,e,t)})),e.exit().each((function(e){a.autoMargin(t,e._id)})).remove(),e.order()}function S(t){var e,r,n,i,a=t._fullLayout,o=t.calcdata,s=[];function l(t){return f(t,{_fillcolor:null,_line:{color:null,width:null,dash:null},_levels:{start:null,end:null,size:null},_filllevels:null,_fillgradient:null,_zrange:null})}function c(){"function"===typeof i.calc?i.calc(t,n,e):(e._fillgradient=r.reversescale?v(r.colorscale):r.colorscale,e._zrange=[r[i.min],r[i.max]])}for(var u=0;u<o.length;u++){var h=o[u],p=(n=h[0].trace)._module.colorbar;if(!0===n.visible&&p)for(var d=Array.isArray(p),m=d?p:[p],g=0;g<m.length;g++){var y=(i=m[g]).container;(r=y?n[y]:n)&&r.showscale&&((e=l(r.colorbar))._id="cb"+n.uid+(d&&y?"-"+y:""),e._traceIndex=n.index,e._propPrefix=(y?y+".":"")+"colorbar.",e._meta=n._meta,c(),s.push(e))}}for(var x in a._colorAxes)if((r=a[x]).showscale){var b=a._colorAxes[x];(e=l(r.colorbar))._id="cb"+x,e._propPrefix=x+".colorbar.",e._meta=a._meta,i={min:"cmin",max:"cmax"},"heatmap"!==b[0]&&(n=b[1],i.calc=n._module.colorbar.calc),c(),s.push(e)}return s}function E(t,e,r){var o=r._fullLayout,l=o._size,h=e._fillcolor,v=e._line,y=e.title,x=y.side,b=e._zrange||n.extent(("function"===typeof h?h:v.color).domain()),_="function"===typeof v.color?v.color:function(){return v.color},A="function"===typeof h?h:function(){return h},S=e._levels,E=C(r,e,b),L=E.fill,I=E.line,z=Math.round(e.thickness*("fraction"===e.thicknessmode?l.w:1)),O=z/l.w,D=Math.round(e.len*("fraction"===e.lenmode?l.h:1)),R=D/l.h,F=e.xpad/l.w,B=(e.borderwidth+e.outlinewidth)/2,N=e.ypad/l.h,j=Math.round(e.x*l.w+e.xpad),U=e.x-O*({middle:.5,right:1}[e.xanchor]||0),V=e.y+R*(({top:-.5,bottom:.5}[e.yanchor]||0)-.5),H=Math.round(l.h*(1-V)),q=H-D;e._lenFrac=R,e._thickFrac=O,e._xLeftFrac=U,e._yBottomFrac=V;var G=e._axis=P(r,e,b);if(G.position=e.x+F+O,-1!==["top","bottom"].indexOf(x)&&(G.title.side=x,G.titlex=e.x+F,G.titley=V+("top"===y.side?R-N:N)),v.color&&"auto"===e.tickmode){G.tickmode='linear',G.tick0=S.start;var Y=S.size,W=c.constrain((H-q)/50,4,15)+1,X=(b[1]-b[0])/((e.nticks||W)*Y);if(X>1){var Z=Math.pow(10,Math.floor(Math.log(X)/Math.LN10));Y*=Z*c.roundUp(X/Z,[2,5,10]),(Math.abs(S.start)/S.size+1e-6)%1<2e-6&&(G.tick0=0)}G.dtick=Y}G.domain=[V+N,V+R-N],G.setScale(),t.attr('transform',u(Math.round(l.l),Math.round(l.t)));var J,K=t.select("."+M.cbtitleunshift).attr('transform',u(-Math.round(l.l),-Math.round(l.t))),Q=t.select("."+M.cbaxis),$=0;function tt(n,i){var a={propContainer:G,propName:e._propPrefix+"title",traceIndex:e._traceIndex,_meta:e._meta,placeholder:o._dfltTitle.colorbar,containerGroup:t.select("."+M.cbtitle)},s="h"===n.charAt(0)?n.substr(1):"h"+n;t.selectAll("."+s+",."+s+"-math-group").remove(),m.draw(r,n,f(a,i||{}))}function et(){if(-1!==["top","bottom"].indexOf(x)){var t,r=l.l+(e.x+F)*l.w,n=G.title.font.size;t="top"===x?(1-(V+R-N))*l.h+l.t+3+.75*n:(1-(V+N))*l.h+l.t-3-.25*n,tt(G._id+"title",{attributes:{x:r,y:t,"text-anchor":"start"}})}}function rt(){if(-1===["top","bottom"].indexOf(x)){var t=G.title.font.size,e=G._offset+G._length/2,i=l.l+(G.position||0)*l.w+("right"===G.side?10+t*(G.showticklabels?1:.5):-10-t*(G.showticklabels?.5:0));tt("h"+G._id+"title",{avoid:{selection:n.select(r).selectAll("g."+G._id+"tick"),side:x,offsetLeft:l.l,offsetTop:0,maxShift:o.width},attributes:{x:i,y:e,"text-anchor":"middle"},transform:{rotate:"-90",offset:0}})}}function nt(){if(-1!==["top","bottom"].indexOf(x)){var a=t.select("."+M.cbtitle),o=a.select('text'),f=[-e.outlinewidth/2,e.outlinewidth/2],h=a.select(".h"+G._id+"title-math-group").node(),d=15.6;if(o.node()&&(d=parseInt(o.node().style.fontSize,10)*w),h?($=p.bBox(h).height)>d&&(f[1]-=($-d)/2):o.node()&&!o.classed(M.jsPlaceholder)&&($=p.bBox(o.node()).height),$){if($+=5,"top"===x)G.domain[1]-=$/l.h,f[1]*=-1;else{G.domain[0]+=$/l.h;var m=g.lineCount(o);f[1]+=(1-m)*d}a.attr('transform',u(f[0],f[1])),G.setScale()}}t.selectAll("."+M.cbfills+",."+M.cblines).attr('transform',u(0,Math.round(l.h*(1-G.domain[1])))),Q.attr('transform',u(0,Math.round(-l.t)));var y=t.select("."+M.cbfills).selectAll("rect."+M.cbfill).attr('style','').data(L);y.enter().append('rect').classed(M.cbfill,!0).style('stroke','none'),y.exit().remove();var T=b.map(G.c2p).map(Math.round).sort((function(t,e){return t-e}));y.each((function(t,a){var o=[0===a?b[0]:(L[a]+L[a-1])/2,a===L.length-1?b[1]:(L[a]+L[a+1])/2].map(G.c2p).map(Math.round);o[1]=c.constrain(o[1]+(o[1]>o[0])?1:-1,T[0],T[1]);var s=n.select(this).attr({x:j,width:Math.max(z,2),y:n.min(o),height:Math.max(n.max(o)-n.min(o),2)});if(e._fillgradient)p.gradient(s,r,e._id,'vertical',e._fillgradient,'fill');else{var l=A(t).replace('e-','');s.attr('fill',i(l).toHexString())}}));var k=t.select("."+M.cblines).selectAll("path."+M.cbline).data(v.color&&v.width?I:[]);k.enter().append('path').classed(M.cbline,!0),k.exit().remove(),k.each((function(t){n.select(this).attr('d',"M"+j+","+(Math.round(G.c2p(t))+v.width/2%1)+"h"+z).call(p.lineGroupStyle,v.width,_(t),v.dash)})),Q.selectAll("g."+G._id+"tick,path").remove();var S=j+z+(e.outlinewidth||0)/2-("outside"===e.ticks?1:0),E=s.calcTicks(G),C=s.getTickSigns(G)[2];return s.drawTicks(r,G,{vals:"inside"===G.ticks?s.clipEnds(G,E):E,layer:Q,path:s.makeTickPath(G,S,C),transFn:s.makeTransTickFn(G)}),s.drawLabels(r,G,{vals:E,layer:Q,transFn:s.makeTransTickLabelFn(G),labelFns:s.makeLabelFns(G,S)})}function it(){var n=z+e.outlinewidth/2;if(-1===G.ticklabelposition.indexOf('inside')&&(n+=p.bBox(Q.node()).width),(J=K.select('text')).node()&&!J.classed(M.jsPlaceholder)){var i,o=K.select(".h"+G._id+"title-math-group").node();i=o&&-1!==["top","bottom"].indexOf(x)?p.bBox(o).width:p.bBox(K.node()).right-j-l.l,n=Math.max(n,i)}var s=2*e.xpad+n+e.borderwidth+e.outlinewidth/2,c=H-q;t.select("."+M.cbbg).attr({x:j-e.xpad-(e.borderwidth+e.outlinewidth)/2,y:q-B,width:Math.max(s,2),height:Math.max(c+2*B,2)}).call(d.fill,e.bgcolor).call(d.stroke,e.bordercolor).style('stroke-width',e.borderwidth),t.selectAll("."+M.cboutline).attr({x:j,y:q+e.ypad+("top"===x?$:0),width:Math.max(z,2),height:Math.max(c-2*e.ypad-$,2)}).call(d.stroke,e.outlinecolor).style({fill:"none","stroke-width":e.outlinewidth});var f=({center:.5,right:1}[e.xanchor]||0)*s;t.attr('transform',u(l.l-f,l.t));var h={},m=T[e.yanchor],g=k[e.yanchor];"pixels"===e.lenmode?(h.y=e.y,h.t=c*m,h.b=c*g):(h.t=h.b=0,h.yt=e.y+e.len*m,h.yb=e.y-e.len*g);var v=T[e.xanchor],y=k[e.xanchor];if("pixels"===e.thicknessmode)h.x=e.x,h.l=s*v,h.r=s*y;else{var b=s-z;h.l=b*v,h.r=b*y,h.xl=e.x-e.thickness*v,h.xr=e.x+e.thickness*y}a.autoMargin(r,e._id,h)}return c.syncOrAsync([a.previousPromises,et,nt,rt,a.previousPromises,it],r)}function L(t,e,r){var n,i,a,s=r._fullLayout._size;l.init({element:t.node(),gd:r,prepFn:function(){n=t.attr('transform'),h(t)},moveFn:function(r,o){t.attr('transform',n+u(r,o)),i=l.align(e._xLeftFrac+r/s.w,e._thickFrac,0,1,e.xanchor),a=l.align(e._yBottomFrac-o/s.h,e._lenFrac,0,1,e.yanchor);var c=l.getCursor(i,a,e.xanchor,e.yanchor);h(t,c)},doneFn:function(){if(h(t),void 0!==i&&void 0!==a){var n={};n[e._propPrefix+"x"]=i,n[e._propPrefix+"y"]=a,void 0!==e._traceIndex?o.call('_guiRestyle',r,n,e._traceIndex):o.call('_guiRelayout',r,n)}}})}function C(t,e,r){var n,i,a=e._levels,o=[],s=[],l=a.end+a.size/100,c=a.size,u=1.001*r[0]-.001*r[1],f=1.001*r[1]-.001*r[0];for(i=0;i<1e5&&(n=a.start+i*c,!(c>0?n>=l:n<=l));i++)n>u&&n<f&&o.push(n);if(e._fillgradient)s=[0];else if("function"===typeof e._fillcolor){var h=e._filllevels;if(h)for(l=h.end+h.size/100,c=h.size,i=0;i<1e5&&(n=h.start+i*c,!(c>0?n>=l:n<=l));i++)n>r[0]&&n<r[1]&&s.push(n);else(s=o.map((function(t){return t-a.size/2}))).push(s[s.length-1]+a.size)}else e._fillcolor&&"string"===typeof e._fillcolor&&(s=[0]);return a.size<0&&(o.reverse(),s.reverse()),{line:o,fill:s}}function P(t,e,r){var n=t._fullLayout,i={type:"linear",range:r,tickmode:e.tickmode,nticks:e.nticks,tick0:e.tick0,dtick:e.dtick,tickvals:e.tickvals,ticktext:e.ticktext,ticks:e.ticks,ticklen:e.ticklen,tickwidth:e.tickwidth,tickcolor:e.tickcolor,showticklabels:e.showticklabels,ticklabelposition:e.ticklabelposition,ticklabeloverflow:e.ticklabeloverflow,tickfont:e.tickfont,tickangle:e.tickangle,tickformat:e.tickformat,exponentformat:e.exponentformat,minexponent:e.minexponent,separatethousands:e.separatethousands,showexponent:e.showexponent,showtickprefix:e.showtickprefix,tickprefix:e.tickprefix,showticksuffix:e.showticksuffix,ticksuffix:e.ticksuffix,title:e.title,showline:!0,anchor:"free",side:"right",position:1},a={type:"linear",_id:"y"+e._id},o={letter:"y",font:n.font,noHover:!0,noTickson:!0,noTicklabelmode:!0,calendar:n.calendar};function s(t,e){return c.coerce(i,a,b,t,e)}return y(i,a,s,o,n),x(i,a,s,o),a}e.exports={draw:A}},{"../../constants/alignment":755,"../../lib":787,"../../lib/extend":777,"../../lib/setcursor":808,"../../lib/svg_text_utils":813,"../../plots/cartesian/axes":838,"../../plots/cartesian/axis_defaults":840,"../../plots/cartesian/layout_attributes":853,"../../plots/cartesian/position_defaults":856,"../../plots/plots":901,"../../registry":915,"../color":650,"../colorscale/helpers":661,"../dragelement":669,"../drawing":672,"../titles":748,"./constants":652,"@plotly/d3":58,tinycolor2:583}],655:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t){return n.isPlainObject(t.colorbar)}},{"../../lib":787}],656:[function(t,e,r){"use strict";e.exports={moduleType:"component",name:"colorbar",attributes:t('./attributes'),supplyDefaults:t('./defaults'),draw:t('./draw').draw,hasColorbar:t('./has_colorbar')}},{"./attributes":651,"./defaults":653,"./draw":654,"./has_colorbar":655}],657:[function(t,e,r){"use strict";var n=t('../colorbar/attributes'),i=t('../../lib/regex').counter,a=t('../../lib/sort_object_keys'),o=t('./scales.js').scales;function s(t){return"`"+t+"`"}a(o),e.exports=function(t,e){t=t||"";var r,a=(e=e||{}).cLetter||"c",l=("onlyIfNumerical"in e?e.onlyIfNumerical:Boolean(t),"noScale"in e?e.noScale:"marker.line"===t),c="showScaleDflt"in e?e.showScaleDflt:"z"===a,u="string"===typeof e.colorscaleDflt?o[e.colorscaleDflt]:null,f=e.editTypeOverride||"",h=t?t+".":"";"colorAttr"in e?(r=e.colorAttr,e.colorAttr):s(h+(r={z:"z",c:"color"}[a]));var p=a+"auto",d=a+"min",m=a+"max",g=a+"mid",v=(s(h+p),s(h+d),s(h+m),{});v[d]=v[m]=void 0;var y={};y[p]=!1;var x={};return"color"===r&&(x.color={valType:"color",arrayOk:!0,editType:f||"style"},e.anim&&(x.color.anim=!0)),x[p]={valType:"boolean",dflt:!0,editType:"calc",impliedEdits:v},x[d]={valType:"number",dflt:null,editType:f||"plot",impliedEdits:y},x[m]={valType:"number",dflt:null,editType:f||"plot",impliedEdits:y},x[g]={valType:"number",dflt:null,editType:"calc",impliedEdits:v},x.colorscale={valType:"colorscale",editType:"calc",dflt:u,impliedEdits:{autocolorscale:!1}},x.autocolorscale={valType:"boolean",dflt:!1!==e.autoColorDflt,editType:"calc",impliedEdits:{colorscale:void 0}},x.reversescale={valType:"boolean",dflt:!1,editType:"plot"},l||(x.showscale={valType:"boolean",dflt:c,editType:"calc"},x.colorbar=n),e.noColorAxis||(x.coloraxis={valType:"subplotid",regex:i('coloraxis'),dflt:null,editType:"calc"}),x}},{"../../lib/regex":804,"../../lib/sort_object_keys":810,"../colorbar/attributes":651,"./scales.js":665}],658:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('./helpers').extractOpts;e.exports=function(t,e,r){var o,s=t._fullLayout,l=r.vals,c=r.containerStr,u=c?i.nestedProperty(e,c).get():e,f=a(u),h=!1!==f.auto,p=f.min,d=f.max,m=f.mid,g=function(){return i.aggNums(Math.min,null,l)},v=function(){return i.aggNums(Math.max,null,l)};void 0===p?p=g():h&&(p=u._colorAx&&n(p)?Math.min(p,g()):g()),void 0===d?d=v():h&&(d=u._colorAx&&n(d)?Math.max(d,v()):v()),h&&void 0!==m&&(d-m>m-p?p=m-(d-m):d-m<m-p&&(d=m+(m-p))),p===d&&(p-=.5,d+=.5),f._sync('min',p),f._sync('max',d),f.autocolorscale&&(o=p*d<0?s.colorscale.diverging:p>=0?s.colorscale.sequential:s.colorscale.sequentialminus,f._sync('colorscale',o))}},{"../../lib":787,"./helpers":661,"fast-isnumeric":246}],659:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./helpers').hasColorscale,a=t('./helpers').extractOpts;e.exports=function(t,e){function r(t,e){var r=t["_"+e];void 0!==r&&(t[e]=r)}function o(t,i){var o=i.container?n.nestedProperty(t,i.container).get():t;if(o)if(o.coloraxis)o._colorAx=e[o.coloraxis];else{var s=a(o),l=s.auto;(l||void 0===s.min)&&r(o,i.min),(l||void 0===s.max)&&r(o,i.max),s.autocolorscale&&r(o,'colorscale')}}for(var s=0;s<t.length;s++){var l=t[s],c=l._module.colorbar;if(c)if(Array.isArray(c))for(var u=0;u<c.length;u++)o(l,c[u]);else o(l,c);i(l,'marker.line')&&o(l,{container:"marker.line",min:"cmin",max:"cmax"})}for(var f in e._colorAxes)o(e[f],{min:"cmin",max:"cmax"})}},{"../../lib":787,"./helpers":661}],660:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../colorbar/has_colorbar'),o=t('../colorbar/defaults'),s=t('./scales').isValid,l=t('../../registry').traceIs;function c(t,e){var r=e.slice(0,e.length-1);return e?i.nestedProperty(t,r).get()||{}:t}e.exports=function t(e,r,u,f,h){var p=h.prefix,d=h.cLetter,m="_module"in r,g=c(e,p),v=c(r,p),y=c(r._template||{},p)||{},x=function(){return delete e.coloraxis,delete r.coloraxis,t(e,r,u,f,h)};if(m)[var b=u._colorAxes||{],_=f(p+"coloraxis");if(_){var w=l(r,'contour')&&i.nestedProperty(r,'contours.coloring').get()||"heatmap",T=b[_];return void(T?(T[2].push(x),T[0]!==w&&(T[0]=!1,i.warn(["Ignoring coloraxis:",_,'setting',"as it is linked to incompatible colorscales."].join(' ')))):b[_]=[w,r,[x]])}}var k=g[d+"min"],M=g[d+"max"],A=n(k)&&n(M)&&k<M;f(p+d+"auto",!A)?f(p+d+"mid"):(f(p+d+"min"),f(p+d+"max"));var S,E,L=g.colorscale,C=y.colorscale;void 0!==L&&(S=!s(L)),void 0!==C&&(S=!s(C)),f(p+"autocolorscale",S),f(p+"colorscale"),f(p+"reversescale"),"marker.line."!==p&&(p&&m&&(E=a(g)),f(p+"showscale",E)&&(p&&y&&(v._template=y),o(g,v,u)))}},{"../../lib":787,"../../registry":915,"../colorbar/defaults":653,"../colorbar/has_colorbar":655,"./scales":665,"fast-isnumeric":246}],661:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('tinycolor2'),a=t('fast-isnumeric'),o=t('../../lib'),s=t('../color'),l=t('./scales').isValid;function c(t,e,r){var n=e?o.nestedProperty(t,e).get()||{}:t,i=n[r||"color"],s=!1;if(o.isArrayOrTypedArray(i))for(var c=0;c<i.length;c++)if(a(i[c])){s=!0;break}return o.isPlainObject(n)&&(s||!0===n.showscale||a(n.cmin)&&a(n.cmax)||l(n.colorscale)||o.isPlainObject(n.colorbar))}var u=["showscale",'autocolorscale','colorscale','reversescale',"colorbar"],f=["min",'max','mid',"auto"];function h(t){var e,r,n,i=t._colorAx,a=i||t,o={};for(r=0;r<u.length;r++)o[n=u[r]]=a[n];if(i)for(e='c',r=0;r<f.length;r++)o[n=f[r]]=a["c"+n];else{var s;for(r=0;r<f.length;r++)((s="c"+(n=f[r]))in a||(s="z"+n)in a)&&(o[n]=a[s]);e=s.charAt(0)}return o._sync=function(t,r){var n=-1!==f.indexOf(t)?e+t:t;a[n]=a["_"+n]=r},o}function p(t){for(var e=h(t),r=e.min,n=e.max,i=e.reversescale?d(e.colorscale):e.colorscale,a=i.length,o=new Array(a),s=new Array(a),l=0;l<a;l++){var c=i[l];o[l]=r+c[0]*(n-r),s[l]=c[1]}return{domain:o,range:s}}function d(t){for(var e=t.length,r=new Array(e),n=e-1,i=0;n>=0;n--,i++){var a=t[n];r[i]=[1-a[0],a[1]]}return r}function m(t,e)[e=e||{];for(var r=t.domain,o=t.range,l=o.length,c=new Array(l),u=0;u<l;u++){var f=i(o[u]).toRgb();c[u]=[f.r,f.g,f.b,f.a]}var h,p=n.scale.linear().domain(r).range(c).clamp(!0),d=e.noNumericCheck,m=e.returnArray;return(h=d&&m?p:d?function(t){return v(p(t))}:m?function(t){return a(t)?p(t):i(t).isValid()?t:s.defaultLine}:function(t){return a(t)?v(p(t)):i(t).isValid()?t:s.defaultLine}).domain=p.domain,h.range=function(){return o},h}function g(t,e){return m(p(t),e)}function v(t){var e={r:t[0],g:t[1],b:t[2],a:t[3]};return i(e).toRgbString()}e.exports={hasColorscale:c,extractOpts:h,extractScale:p,flipScale:d,makeColorScaleFunc:m,makeColorScaleFuncFromTrace:g}},{"../../lib":787,"../color":650,"./scales":665,"@plotly/d3":58,"fast-isnumeric":246,tinycolor2:583}],662:[function(t,e,r){"use strict";var n=t('./scales'),i=t('./helpers');e.exports={moduleType:"component",name:"colorscale",attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyLayoutDefaults:t('./layout_defaults'),handleDefaults:t('./defaults'),crossTraceDefaults:t('./cross_trace_defaults'),calc:t('./calc'),scales:n.scales,defaultScale:n.defaultScale,getScale:n.get,isValidScale:n.isValid,hasColorscale:i.hasColorscale,extractOpts:i.extractOpts,extractScale:i.extractScale,flipScale:i.flipScale,makeColorScaleFunc:i.makeColorScaleFunc,makeColorScaleFuncFromTrace:i.makeColorScaleFuncFromTrace}},{"./attributes":657,"./calc":658,"./cross_trace_defaults":659,"./defaults":660,"./helpers":661,"./layout_attributes":663,"./layout_defaults":664,"./scales":665}],663:[function(t,e,r){"use strict";var n=t('../../lib/extend').extendFlat,i=t('./attributes'),a=t('./scales').scales;e.exports={editType:"calc",colorscale:{editType:"calc",sequential:{valType:"colorscale",dflt:a.Reds,editType:"calc"},sequentialminus:{valType:"colorscale",dflt:a.Blues,editType:"calc"},diverging:{valType:"colorscale",dflt:a.RdBu,editType:"calc"}},coloraxis:n({_isSubplotObj:!0,editType:"calc"},i('',{colorAttr:"corresponding trace color array(s)",noColorAxis:!0,showScaleDflt:!0}))}},{"../../lib/extend":777,"./attributes":657,"./scales":665}],664:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plot_api/plot_template'),a=t('./layout_attributes'),o=t('./defaults');e.exports=function(t,e){function r(r,i){return n.coerce(t,e,a,r,i)}r('colorscale.sequential'),r('colorscale.sequentialminus'),r('colorscale.diverging');var s,l,c=e._colorAxes;function u(t,e){return n.coerce(s,l,a.coloraxis,t,e)}for(var f in c){var h=c[f];if(h[0])s=t[f]||{},(l=i.newContainer(e,f,'coloraxis'))._name=f,o(s,l,e,u,{prefix:"",cLetter:"c"});else{for(var p=0;p<h[2].length;p++)h[2][p]();delete e._colorAxes[f]}}}},{"../../lib":787,"../../plot_api/plot_template":827,"./defaults":660,"./layout_attributes":663}],665:[function(t,e,r){"use strict";var n=t('tinycolor2'),i={Greys:[[0,"rgb(0,0,0)"],[1,"rgb(255,255,255)"]],YlGnBu:[[0,"rgb(8,29,88)"],[.125,"rgb(37,52,148)"],[.25,"rgb(34,94,168)"],[.375,"rgb(29,145,192)"],[.5,"rgb(65,182,196)"],[.625,"rgb(127,205,187)"],[.75,"rgb(199,233,180)"],[.875,"rgb(237,248,217)"],[1,"rgb(255,255,217)"]],Greens:[[0,"rgb(0,68,27)"],[.125,"rgb(0,109,44)"],[.25,"rgb(35,139,69)"],[.375,"rgb(65,171,93)"],[.5,"rgb(116,196,118)"],[.625,"rgb(161,217,155)"],[.75,"rgb(199,233,192)"],[.875,"rgb(229,245,224)"],[1,"rgb(247,252,245)"]],YlOrRd:[[0,"rgb(128,0,38)"],[.125,"rgb(189,0,38)"],[.25,"rgb(227,26,28)"],[.375,"rgb(252,78,42)"],[.5,"rgb(253,141,60)"],[.625,"rgb(254,178,76)"],[.75,"rgb(254,217,118)"],[.875,"rgb(255,237,160)"],[1,"rgb(255,255,204)"]],Bluered:[[0,"rgb(0,0,255)"],[1,"rgb(255,0,0)"]],RdBu:[[0,"rgb(5,10,172)"],[.35,"rgb(106,137,247)"],[.5,"rgb(190,190,190)"],[.6,"rgb(220,170,132)"],[.7,"rgb(230,145,90)"],[1,"rgb(178,10,28)"]],Reds:[[0,"rgb(220,220,220)"],[.2,"rgb(245,195,157)"],[.4,"rgb(245,160,105)"],[1,"rgb(178,10,28)"]],Blues:[[0,"rgb(5,10,172)"],[.35,"rgb(40,60,190)"],[.5,"rgb(70,100,245)"],[.6,"rgb(90,120,245)"],[.7,"rgb(106,137,247)"],[1,"rgb(220,220,220)"]],Picnic:[[0,"rgb(0,0,255)"],[.1,"rgb(51,153,255)"],[.2,"rgb(102,204,255)"],[.3,"rgb(153,204,255)"],[.4,"rgb(204,204,255)"],[.5,"rgb(255,255,255)"],[.6,"rgb(255,204,255)"],[.7,"rgb(255,153,255)"],[.8,"rgb(255,102,204)"],[.9,"rgb(255,102,102)"],[1,"rgb(255,0,0)"]],Rainbow:[[0,"rgb(150,0,90)"],[.125,"rgb(0,0,200)"],[.25,"rgb(0,25,255)"],[.375,"rgb(0,152,255)"],[.5,"rgb(44,255,150)"],[.625,"rgb(151,255,0)"],[.75,"rgb(255,234,0)"],[.875,"rgb(255,111,0)"],[1,"rgb(255,0,0)"]],Portland:[[0,"rgb(12,51,131)"],[.25,"rgb(10,136,186)"],[.5,"rgb(242,211,56)"],[.75,"rgb(242,143,56)"],[1,"rgb(217,30,30)"]],Jet:[[0,"rgb(0,0,131)"],[.125,"rgb(0,60,170)"],[.375,"rgb(5,255,255)"],[.625,"rgb(255,255,0)"],[.875,"rgb(250,0,0)"],[1,"rgb(128,0,0)"]],Hot:[[0,"rgb(0,0,0)"],[.3,"rgb(230,0,0)"],[.6,"rgb(255,210,0)"],[1,"rgb(255,255,255)"]],Blackbody:[[0,"rgb(0,0,0)"],[.2,"rgb(230,0,0)"],[.4,"rgb(230,210,0)"],[.7,"rgb(255,255,255)"],[1,"rgb(160,200,255)"]],Earth:[[0,"rgb(0,0,130)"],[.1,"rgb(0,180,180)"],[.2,"rgb(40,210,40)"],[.4,"rgb(230,230,50)"],[.6,"rgb(120,70,20)"],[1,"rgb(255,255,255)"]],Electric:[[0,"rgb(0,0,0)"],[.15,"rgb(30,0,100)"],[.4,"rgb(120,0,100)"],[.6,"rgb(160,90,0)"],[.8,"rgb(230,200,0)"],[1,"rgb(255,250,220)"]],Viridis:[[0,"#440154"],[.06274509803921569,"#48186a"],[.12549019607843137,"#472d7b"],[.18823529411764706,"#424086"],[.25098039215686274,"#3b528b"],[.3137254901960784,"#33638d"],[.3764705882352941,"#2c728e"],[.4392156862745098,"#26828e"],[.5019607843137255,"#21918c"],[.5647058823529412,"#1fa088"],[.6274509803921569,"#28ae80"],[.6901960784313725,"#3fbc73"],[.7529411764705882,"#5ec962"],[.8156862745098039,"#84d44b"],[.8784313725490196,"#addc30"],[.9411764705882353,"#d8e219"],[1,"#fde725"]],Cividis:[[0,"rgb(0,32,76)"],[.058824,"rgb(0,42,102)"],[.117647,"rgb(0,52,110)"],[.176471,"rgb(39,63,108)"],[.235294,"rgb(60,74,107)"],[.294118,"rgb(76,85,107)"],[.352941,"rgb(91,95,109)"],[.411765,"rgb(104,106,112)"],[.470588,"rgb(117,117,117)"],[.529412,"rgb(131,129,120)"],[.588235,"rgb(146,140,120)"],[.647059,"rgb(161,152,118)"],[.705882,"rgb(176,165,114)"],[.764706,"rgb(192,177,109)"],[.823529,"rgb(209,191,102)"],[.882353,"rgb(225,204,92)"],[.941176,"rgb(243,219,79)"],[1,"rgb(255,233,69)"]]},a=i.RdBu;function o(t,e){if(e||(e=a),!t)return e;function r(){try{t=i[t]||JSON.parse(t)}catch(r)[t=e]}return"string"===typeof t&&(r(),"string"===typeof t&&r()),s(t)?t:e}function s(t){var e=0;if(!Array.isArray(t)||t.length<2)return!1;if(!t[0]||!t[t.length-1])return!1;if(0!==+t[0][0]||1!==+t[t.length-1][0])return!1;for(var r=0;r<t.length;r++){var i=t[r];if(2!==i.length||+i[0]<e||!n(i[1]).isValid())return!1;e=+i[0]}return!0}function l(t){return void 0!==i[t]||s(t)}e.exports={scales:i,defaultScale:a,get:o,isValid:l}},{tinycolor2:583}],666:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){var a=(t-r)/(n-r),o=a+e/(n-r),s=(a+o)/2;return"left"===i||"bottom"===i?a:"center"===i||"middle"===i?s:"right"===i||"top"===i?o:a<2/3-s?a:o>4/3-s?o:s}},{}],667:[function(t,e,r){"use strict";var n=t('../../lib'),i=[["sw-resize",'s-resize',"se-resize"],["w-resize",'move',"e-resize"],["nw-resize",'n-resize',"ne-resize"]];e.exports=function(t,e,r,a){return t="left"===r?0:"center"===r?1:"right"===r?2:n.constrain(Math.floor(3*t),0,2),e="bottom"===a?0:"middle"===a?1:"top"===a?2:n.constrain(Math.floor(3*e),0,2),i[e][t]}},{"../../lib":787}],668:[function(t,e,r){"use strict";r.selectMode=function(t){return"lasso"===t||"select"===t},r.drawMode=function(t){return"drawclosedpath"===t||"drawopenpath"===t||"drawline"===t||"drawrect"===t||"drawcircle"===t},r.openMode=function(t){return"drawline"===t||"drawopenpath"===t},r.rectMode=function(t){return"select"===t||"drawline"===t||"drawrect"===t||"drawcircle"===t},r.freeMode=function(t){return"lasso"===t||"drawclosedpath"===t||"drawopenpath"===t},r.selectingOrDrawing=function(t){return r.freeMode(t)||r.rectMode(t)}},{}],669:[function(t,e,r){"use strict";var n=t('mouse-event-offset'),i=t('has-hover'),a=t('has-passive-events'),o=t('../../lib').removeElement,s=t('../../plots/cartesian/constants'),l=e.exports={};l.align=t('./align'),l.getCursor=t('./cursor');var c=t('./unhover');function u(){var t=document.createElement('div');t.className='dragcover';var e=t.style;return e.position='fixed',e.left=0,e.right=0,e.top=0,e.bottom=0,e.zIndex=999999999,e.background='none',document.body.appendChild(t),t}function f(t){return n(t.changedTouches?t.changedTouches[0]:t,document.body)}l.unhover=c.wrapped,l.unhoverRaw=c.raw,l.init=function(t){var e,r,n,c,h,p,d,m,g=t.gd,v=1,y=g._context.doubleClickDelay,x=t.element;function b(t,e,r){return Math.abs(t)<r&&(t=0),Math.abs(e)<r&&(e=0),[t,e]}g._mouseDownTime||(g._mouseDownTime=0),x.style.pointerEvents='all',x.onmousedown=w,a?(x._ontouchstart&&x.removeEventListener('touchstart',x._ontouchstart),x._ontouchstart=w,x.addEventListener('touchstart',w,{passive:!1})):x.ontouchstart=w;var _=t.clampFn||b;function w(a){g._dragged=!1,g._dragging=!0;var o=f(a);e=o[0],r=o[1],d=a.target,p=a,m=2===a.buttons||a.ctrlKey,"undefined"===typeof a.clientX&&"undefined"===typeof a.clientY&&(a.clientX=e,a.clientY=r),(n=(new Date).getTime())-g._mouseDownTime<y?v+=1:(v=1,g._mouseDownTime=n),t.prepFn&&t.prepFn(a,e,r),i&&!m?(h=u()).style.cursor=window.getComputedStyle(x).cursor:i||(h=document,c=window.getComputedStyle(document.documentElement).cursor,document.documentElement.style.cursor=window.getComputedStyle(x).cursor),document.addEventListener('mouseup',k),document.addEventListener('touchend',k),!1!==t.dragmode&&(a.preventDefault(),document.addEventListener('mousemove',T),document.addEventListener('touchmove',T,{passive:!1}))}function T(n){n.preventDefault();var i=f(n),a=t.minDrag||s.MINDRAG,o=_(i[0]-e,i[1]-r,a),c=o[0],u=o[1];(c||u)&&(g._dragged=!0,l.unhover(g,n)),g._dragged&&t.moveFn&&!m&&(g._dragdata={element:x,dx:c,dy:u},t.moveFn(c,u))}function k(e){if(delete g._dragdata,!1!==t.dragmode&&(e.preventDefault(),document.removeEventListener('mousemove',T),document.removeEventListener('touchmove',T)),document.removeEventListener('mouseup',k),document.removeEventListener('touchend',k),i?o(h):c&&(h.documentElement.style.cursor=c,c=null),g._dragging){if(g._dragging=!1,(new Date).getTime()-g._mouseDownTime>y&&(v=Math.max(v-1,1)),g._dragged)t.doneFn&&t.doneFn();else if(t.clickFn&&t.clickFn(v,p),!m){var r;try{r=new MouseEvent('click',e)}catch(a){var n=f(e);(r=document.createEvent('MouseEvents')).initMouseEvent('click',e.bubbles,e.cancelable,e.view,e.detail,e.screenX,e.screenY,n[0],n[1],e.ctrlKey,e.altKey,e.shiftKey,e.metaKey,e.button,e.relatedTarget)}d.dispatchEvent(r)}g._dragging=!1,g._dragged=!1}else g._dragged=!1}},l.coverSlip=u},{"../../lib":787,"../../plots/cartesian/constants":845,"./align":666,"./cursor":667,"./unhover":670,"has-hover":435,"has-passive-events":436,"mouse-event-offset":460}],670:[function(t,e,r){"use strict";var n=t('../../lib/events'),i=t('../../lib/throttle'),a=t('../../lib/dom').getGraphDiv,o=t('../fx/constants'),s=e.exports={};s.wrapped=function(t,e,r){(t=a(t))._fullLayout&&i.clear(t._fullLayout._uid+o.HOVERID),s.raw(t,e,r)},s.raw=function(t,e){var r=t._fullLayout,i=t._hoverdata;e||(e={}),e.target&&!t._dragged&&!1===n.triggerHandler(t,'plotly_beforehover',e)||(r._hoverlayer.selectAll('g').remove(),r._hoverlayer.selectAll('line').remove(),r._hoverlayer.selectAll('circle').remove(),t._hoverdata=void 0,e.target&&i&&t.emit('plotly_unhover',{event:e,points:i}))}},{"../../lib/dom":775,"../../lib/events":776,"../../lib/throttle":814,"../fx/constants":684}],671:[function(t,e,r){"use strict";r.dash={valType:"string",values:["solid",'dot','dash','longdash','dashdot',"longdashdot"],dflt:"solid",editType:"style"},r.pattern={shape:{valType:"enumerated",values:["",'/','\\','x','-','|','+',"."],dflt:"",arrayOk:!0,editType:"style"},fillmode:{valType:"enumerated",values:["replace","overlay"],dflt:"replace",editType:"style"},bgcolor:{valType:"color",arrayOk:!0,editType:"style"},fgcolor:{valType:"color",arrayOk:!0,editType:"style"},fgopacity:{valType:"number",editType:"style",min:0,max:1},size:{valType:"number",min:0,dflt:8,arrayOk:!0,editType:"style"},solidity:{valType:"number",min:0,max:1,dflt:.3,arrayOk:!0,editType:"style"},editType:"style"}},{}],672:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=i.numberFormat,o=t('fast-isnumeric'),s=t('tinycolor2'),l=t('../../registry'),c=t('../color'),u=t('../colorscale'),f=i.strTranslate,h=t('../../lib/svg_text_utils'),p=t('../../constants/xmlns_namespaces'),d=t('../../constants/alignment').LINE_SPACING,m=t('../../constants/interactions').DESELECTDIM,g=t('../../traces/scatter/subtypes'),v=t('../../traces/scatter/make_bubble_size_func'),y=t('../../components/fx/helpers').appendArrayPointValue,x=e.exports={};x.font=function(t,e,r,n){i.isPlainObject(e)&&(n=e.color,r=e.size,e=e.family),e&&t.style('font-family',e),r+1&&t.style('font-size',r+"px"),n&&t.call(c.fill,n)},x.setPosition=function(t,e,r){t.attr('x',e).attr('y',r)},x.setSize=function(t,e,r){t.attr('width',e).attr('height',r)},x.setRect=function(t,e,r,n,i){t.call(x.setPosition,e,r).call(x.setSize,n,i)},x.translatePoint=function(t,e,r,n){var i=r.c2p(t.x),a=n.c2p(t.y);return!!(o(i)&&o(a)&&e.node())&&("text"===e.node().nodeName?e.attr('x',i).attr('y',a):e.attr('transform',f(i,a)),!0)},x.translatePoints=function(t,e,r){t.each((function(t){var i=n.select(this);x.translatePoint(t,i,e,r)}))},x.hideOutsideRangePoint=function(t,e,r,n,i,a){e.attr('display',r.isPtWithinRange(t,i)&&n.isPtWithinRange(t,a)?null:"none")},x.hideOutsideRangePoints=function(t,e){if(e._hasClipOnAxisFalse){var r=e.xaxis,i=e.yaxis;t.each((function(e){var a=e[0].trace,o=a.xcalendar,s=a.ycalendar,c=l.traceIs(a,'bar-like')?".bartext":".point,.textpoint";t.selectAll(c).each((function(t){x.hideOutsideRangePoint(t,n.select(this),r,i,o,s)}))}))}},x.crispRound=function(t,e,r){return e&&o(e)?t._context.staticPlot?e:e<1?1:Math.round(e):r||0},x.singleLineStyle=function(t,e,r,n,i){e.style('fill','none');var a=(((t||[])[0]||{}).trace||{}).line||{},o=r||a.width||0,s=i||a.dash||"";c.stroke(e,n||a.color),x.dashLine(e,s,o)},x.lineGroupStyle=function(t,e,r,i){t.style('fill','none').each((function(t){var a=(((t||[])[0]||{}).trace||{}).line||{},o=e||a.width||0,s=i||a.dash||"";n.select(this).call(c.stroke,r||a.color).call(x.dashLine,s,o)}))},x.dashLine=function(t,e,r){r=+r||0,e=x.dashStyle(e,r),t.style({"stroke-dasharray":e,"stroke-width":r+"px"})},x.dashStyle=function(t,e){e=+e||1;var r=Math.max(e,3);return"solid"===t?t="":"dot"===t?t=r+"px,"+r+"px":"dash"===t?t=3*r+"px,"+3*r+"px":"longdash"===t?t=5*r+"px,"+5*r+"px":"dashdot"===t?t=3*r+"px,"+r+"px,"+r+"px,"+r+"px":"longdashdot"===t&&(t=5*r+"px,"+2*r+"px,"+r+"px,"+2*r+"px"),t},x.singleFillStyle=function(t)[var e=(((n.select(t.node()).data()[0]||[])[0]||{]).trace||{}).fillcolor;e&&t.call(c.fill,e)},x.fillGroupStyle=function(t){t.style('stroke-width',0).each((function(t){var e=n.select(this);t[0].trace&&e.call(c.fill,t[0].trace.fillcolor)}))};var b=t('./symbol_defs');x.symbolNames=[],x.symbolFuncs=[],x.symbolNeedLines={},x.symbolNoDot={},x.symbolNoFill={},x.symbolList=[],Object.keys(b).forEach((function(t){var e=b[t],r=e.n;x.symbolList.push(r,String(r),t,r+100,String(r+100),t+"-open"),x.symbolNames[r]=t,x.symbolFuncs[r]=e.f,e.needLine&&(x.symbolNeedLines[r]=!0),e.noDot?x.symbolNoDot[r]=!0:x.symbolList.push(r+200,String(r+200),t+"-dot",r+300,String(r+300),t+"-open-dot"),e.noFill&&(x.symbolNoFill[r]=!0)}));var _=x.symbolNames.length,w='M0,0.5L0.5,0L0,-0.5L-0.5,0Z';function T(t,e){var r=t%100;return x.symbolFuncs[r](e)+(t>=200?w:"")}x.symbolNumber=function(t){if(o(t))t=+t;else if("string"===typeof t){var e=0;t.indexOf('-open')>0&&(e=100,t=t.replace('-open','')),t.indexOf('-dot')>0&&(e+=200,t=t.replace('-dot','')),(t=x.symbolNames.indexOf(t))>=0&&(t+=e)}return t%100>=_||t>=400?0:Math.floor(Math.max(t,0))};var k={x1:1,x2:0,y1:0,y2:0},M={x1:0,x2:0,y1:1,y2:0},A=a('~f'),S={radial:{node:"radialGradient"},radialreversed:{node:"radialGradient",reversed:!0},horizontal:{node:"linearGradient",attrs:k},horizontalreversed:{node:"linearGradient",attrs:k,reversed:!0},vertical:{node:"linearGradient",attrs:M},verticalreversed:{node:"linearGradient",attrs:M,reversed:!0}};x.gradient=function(t,e,r,a,o,l){for(var u=o.length,f=S[a],h=new Array(u),p=0;p<u;p++)f.reversed?h[u-1-p]=[A(100*(1-o[p][0])),o[p][1]]:h[p]=[A(100*o[p][0]),o[p][1]];var d=e._fullLayout,m="g"+d._uid+"-"+r,g=d._defs.select('.gradients').selectAll("#"+m).data([a+h.join(';')],i.identity);g.exit().remove(),g.enter().append(f.node).each((function(){var t=n.select(this);f.attrs&&t.attr(f.attrs),t.attr('id',m);var e=t.selectAll('stop').data(h);e.exit().remove(),e.enter().append('stop'),e.each((function(t){var e=s(t[1]);n.select(this).attr({offset:t[0]+"%","stop-color":c.tinyRGB(e),"stop-opacity":e.getAlpha()})}))})),t.style(l,B(m,e)).style(l+"-opacity",null);var v=function(t){return"."+t.attr('class').replace(/\s/g,'.')},y=v(n.select(t.node().parentNode))+">"+v(t);d._gradientUrlQueryParts[y]=1},x.pattern=function(t,e,r,a,o,s,l,u,f,h,p,d){var m="legend"===e;u&&("overlay"===f?(h=u,p=c.contrast(h)):(h=void 0,p=u));var g,v,y,x,b,_,w=r._fullLayout,T="p"+w._uid+"-"+a,k=function(t,e,r,n,i){return n+(i-n)*(t-e)/(r-e)},M={};switch(o){case"/":g=s*Math.sqrt(2),v=s*Math.sqrt(2),_='path',M={d:y="M-"+g/4+","+v/4+"l"+g/2+",-"+v/2+"M0,"+v+"L"+g+",0M"+g/4*3+","+v/4*5+"l"+g/2+",-"+v/2,opacity:d,stroke:p,"stroke-width":(x=l*s)+"px"};break;case"\\":g=s*Math.sqrt(2),v=s*Math.sqrt(2),_='path',M={d:y="M"+g/4*3+",-"+v/4+"l"+g/2+","+v/2+"M0,0L"+g+","+v+"M-"+g/4+","+v/4*3+"l"+g/2+","+v/2,opacity:d,stroke:p,"stroke-width":(x=l*s)+"px"};break;case"x":g=s*Math.sqrt(2),v=s*Math.sqrt(2),y="M-"+g/4+","+v/4+"l"+g/2+",-"+v/2+"M0,"+v+"L"+g+",0M"+g/4*3+","+v/4*5+"l"+g/2+",-"+v/2+"M"+g/4*3+",-"+v/4+"l"+g/2+","+v/2+"M0,0L"+g+","+v+"M-"+g/4+","+v/4*3+"l"+g/2+","+v/2,x=s-s*Math.sqrt(1-l),_='path',M={d:y,opacity:d,stroke:p,"stroke-width":x+"px"};break;case"|":_='path',_='path',M={d:y="M"+(g=s)/2+",0L"+g/2+","+(v=s),opacity:d,stroke:p,"stroke-width":(x=l*s)+"px"};break;case"-":_='path',_='path',M={d:y="M0,"+(v=s)/2+"L"+(g=s)+","+v/2,opacity:d,stroke:p,"stroke-width":(x=l*s)+"px"};break;case"+":_='path',y="M"+(g=s)/2+",0L"+g/2+","+(v=s)+"M0,"+v/2+"L"+g+","+v/2,x=s-s*Math.sqrt(1-l),_='path',M={d:y,opacity:d,stroke:p,"stroke-width":x+"px"};break;case".":g=s,v=s,b=l<Math.PI/4?Math.sqrt(l*s*s/Math.PI):k(l,Math.PI/4,1,s/2,s/Math.sqrt(2)),_='circle',M={cx:g/2,cy:v/2,r:b,opacity:d,fill:p}}var A=[o||"noSh",h||"noBg",p||"noFg",s,l].join(';'),S=w._defs.select('.patterns').selectAll("#"+T).data([A],i.identity);S.exit().remove(),S.enter().append('pattern').each((function(){var t=n.select(this);if(t.attr({id:T,width:g+"px",height:v+"px",patternUnits:"userSpaceOnUse",patternTransform:m?"scale(0.8)":""}),h){var e=t.selectAll('rect').data([0]);e.exit().remove(),e.enter().append('rect').attr({width:g+"px",height:v+"px",fill:h})}var r=t.selectAll(_).data([0]);r.exit().remove(),r.enter().append(_).attr(M)})),t.style('fill',B(T,r)).style('fill-opacity',null),t.classed('pattern_filled',!0);var E="."+n.select(t.node().parentNode).attr('class').replace(/\s/g,'.')+">.pattern_filled";w._patternUrlQueryParts[E]=1},x.initGradients=function(t){var e=t._fullLayout;i.ensureSingle(e._defs,'g','gradients').selectAll('linearGradient,radialGradient').remove(),e._gradientUrlQueryParts={}},x.initPatterns=function(t){var e=t._fullLayout;i.ensureSingle(e._defs,'g','patterns').selectAll('pattern').remove(),e._patternUrlQueryParts={}},x.getPatternAttr=function(t,e,r){return t&&i.isArrayOrTypedArray(t)?e<t.length?t[e]:r:t},x.pointStyle=function(t,e,r){if(t.size()){var i=x.makePointStyleFns(e);t.each((function(t){x.singlePointStyle(t,n.select(this),e,i,r)}))}},x.singlePointStyle=function(t,e,r,n,a){var o=r.marker,s=o.line;if(e.style('opacity',n.selectedOpacityFn?n.selectedOpacityFn(t):void 0===t.mo?o.opacity:t.mo),n.ms2mrc){var l;l="various"===t.ms||"various"===o.size?3:n.ms2mrc(t.ms),t.mrc=l,n.selectedSizeFn&&(l=t.mrc=n.selectedSizeFn(t));var u=x.symbolNumber(t.mx||o.symbol)||0;t.om=u%200>=100,e.attr('d',T(u,l))}var f,h,p,d=!1;if(t.so)p=s.outlierwidth,h=s.outliercolor,f=o.outliercolor;else[var m=(s||{]).width;p=(t.mlw+1||m+1||(t.trace?(t.trace.marker.line||{}).width:0)+1)-1||0,h="mlc"in t?t.mlcc=n.lineScale(t.mlc):i.isArrayOrTypedArray(s.color)?c.defaultLine:s.color,i.isArrayOrTypedArray(o.color)&&(f=c.defaultLine,d=!0),f="mc"in t?t.mcc=n.markerScale(t.mc):o.color||"rgba(0,0,0,0)",n.selectedColorFn&&(f=n.selectedColorFn(t))}if(t.om)e.call(c.stroke,f).style({"stroke-width":(p||1)+"px",fill:"none"});else{e.style('stroke-width',(t.isBlank?0:p)+"px");var g=o.gradient,v=t.mgt;v?d=!0:v=g&&g.type,i.isArrayOrTypedArray(v)&&(v=v[0],S[v]||(v=0));var y=o.pattern,b=y&&x.getPatternAttr(y.shape,t.i,'');if(v&&"none"!==v){var _=t.mgc;_?d=!0:_=g.color;var w=r.uid;d&&(w+="-"+t.i),x.gradient(e,a,w,v,[[0,_],[1,f]],'fill')}else if(b){var k=x.getPatternAttr(y.bgcolor,t.i,null),M=x.getPatternAttr(y.fgcolor,t.i,null),A=y.fgopacity,E=x.getPatternAttr(y.size,t.i,8),L=x.getPatternAttr(y.solidity,t.i,.3),C=t.mcc||i.isArrayOrTypedArray(y.shape)||i.isArrayOrTypedArray(y.bgcolor)||i.isArrayOrTypedArray(y.size)||i.isArrayOrTypedArray(y.solidity),P=r.uid;C&&(P+="-"+t.i),x.pattern(e,'point',a,P,b,E,L,t.mcc,y.fillmode,k,M,A)}else c.fill(e,f);p&&c.stroke(e,h)}},x.makePointStyleFns=function(t)[var e={],r=t.marker;return e.markerScale=x.tryColorscale(r,''),e.lineScale=x.tryColorscale(r,'line'),l.traceIs(t,'symbols')&&(e.ms2mrc=g.isBubble(t)?v(t):function(){return(r.size||6)/2}),t.selectedpoints&&i.extendFlat(e,x.makeSelectedPointStyleFns(t)),e},x.makeSelectedPointStyleFns=function(t)[var e={],r=t.selected||{},n=t.unselected||{},a=t.marker||{},o=r.marker||{},s=n.marker||{},c=a.opacity,u=o.opacity,f=s.opacity,h=void 0!==u,p=void 0!==f;(i.isArrayOrTypedArray(c)||h||p)&&(e.selectedOpacityFn=function(t){var e=void 0===t.mo?a.opacity:t.mo;return t.selected?h?u:e:p?f:m*e});var d=a.color,g=o.color,v=s.color;(g||v)&&(e.selectedColorFn=function(t){var e=t.mcc||d;return t.selected?g||e:v||e});var y=a.size,x=o.size,b=s.size,_=void 0!==x,w=void 0!==b;return l.traceIs(t,'symbols')&&(_||w)&&(e.selectedSizeFn=function(t){var e=t.mrc||y/2;return t.selected?_?x/2:e:w?b/2:e}),e},x.makeSelectedTextStyleFns=function(t)[var e={],r=t.selected||{},n=t.unselected||{},i=t.textfont||{},a=r.textfont||{},o=n.textfont||{},s=i.color,l=a.color,u=o.color;return e.selectedTextColorFn=function(t){var e=t.tc||s;return t.selected?l||e:u||(l?e:c.addOpacity(e,m))},e},x.selectedPointStyle=function(t,e){if(t.size()&&e.selectedpoints){var r=x.makeSelectedPointStyleFns(e),i=e.marker||{},a=[];r.selectedOpacityFn&&a.push((function(t,e){t.style('opacity',r.selectedOpacityFn(e))})),r.selectedColorFn&&a.push((function(t,e){c.fill(t,r.selectedColorFn(e))})),r.selectedSizeFn&&a.push((function(t,e){var n=e.mx||i.symbol||0,a=r.selectedSizeFn(e);t.attr('d',T(x.symbolNumber(n),a)),e.mrc2=a})),a.length&&t.each((function(t){for(var e=n.select(this),r=0;r<a.length;r++)a[r](e,t)}))}},x.tryColorscale=function(t,e){var r=e?i.nestedProperty(t,e).get():t;if(r){var n=r.color;if((r.colorscale||r._colorAx)&&i.isArrayOrTypedArray(n))return u.makeColorScaleFuncFromTrace(r)}return i.identity};var E={start:1,end:-1,middle:0,bottom:1,top:-1};function L(t,e,r,i){var a=n.select(t.node().parentNode),o=-1!==e.indexOf('top')?"top":-1!==e.indexOf('bottom')?"bottom":"middle",s=-1!==e.indexOf('left')?"end":-1!==e.indexOf('right')?"start":"middle",l=i?i/.8+1:0,c=(h.lineCount(t)-1)*d+1,u=E[s]*l,p=.75*r+E[o]*l+(E[o]-1)*c*r/2;t.attr('text-anchor',s),a.attr('transform',f(u,p))}function C(t,e){var r=t.ts||e.textfont.size;return o(r)&&r>0?r:0}x.textPointStyle=function(t,e,r){if(t.size()){var a;if(e.selectedpoints){var o=x.makeSelectedTextStyleFns(e);a=o.selectedTextColorFn}var s=e.texttemplate,l=r._fullLayout;t.each((function(t){var o=n.select(this),c=s?i.extractOption(t,e,'txt','texttemplate'):i.extractOption(t,e,'tx','text');if(c||0===c){if(s){var u=e._module.formatLabels,f=u?u(t,e,l):{},p={};y(p,e,t.i);var d=e._meta||{};c=i.texttemplateString(c,f,l._d3locale,p,t,d)}var m=t.tp||e.textposition,g=C(t,e),v=a?a(t):t.tc||e.textfont.color;o.call(x.font,t.tf||e.textfont.family,g,v).text(c).call(h.convertToTspans,r).call(L,m,g,t.mrc)}else o.remove()}))}},x.selectedTextStyle=function(t,e){if(t.size()&&e.selectedpoints){var r=x.makeSelectedTextStyleFns(e);t.each((function(t){var i=n.select(this),a=r.selectedTextColorFn(t),o=t.tp||e.textposition,s=C(t,e);c.fill(i,a),L(i,o,s,t.mrc2||t.mrc)}))}};var P=.5;function I(t,e,r,i){var a=t[0]-e[0],o=t[1]-e[1],s=r[0]-e[0],l=r[1]-e[1],c=Math.pow(a*a+o*o,P/2),u=Math.pow(s*s+l*l,P/2),f=(u*u*a-c*c*s)*i,h=(u*u*o-c*c*l)*i,p=3*u*(c+u),d=3*c*(c+u);return[[n.round(e[0]+(p&&f/p),2),n.round(e[1]+(p&&h/p),2)],[n.round(e[0]-(d&&f/d),2),n.round(e[1]-(d&&h/d),2)]]}x.smoothopen=function(t,e){if(t.length<3)return"M"+t.join('L');var r,n="M"+t[0],i=[];for(r=1;r<t.length-1;r++)i.push(I(t[r-1],t[r],t[r+1],e));for(n+="Q"+i[0][0]+" "+t[1],r=2;r<t.length-1;r++)n+="C"+i[r-2][1]+" '+i[r-1][0]+' "+t[r];return n+="Q"+i[t.length-3][1]+" "+t[t.length-1]},x.smoothclosed=function(t,e){if(t.length<3)return"M"+t.join('L')+"Z";var r,n="M"+t[0],i=t.length-1,a=[I(t[i],t[0],t[1],e)];for(r=1;r<i;r++)a.push(I(t[r-1],t[r],t[r+1],e));for(a.push(I(t[i-1],t[i],t[0],e)),r=1;r<=i;r++)n+="C"+a[r-1][1]+" '+a[r][0]+' "+t[r];return n+="C"+a[i][1]+" '+a[0][0]+' "+t[0]+"Z"};var z={hv:function(t,e){return"H"+n.round(e[0],2)+"V"+n.round(e[1],2)},vh:function(t,e){return"V"+n.round(e[1],2)+"H"+n.round(e[0],2)},hvh:function(t,e){return"H"+n.round((t[0]+e[0])/2,2)+"V"+n.round(e[1],2)+"H"+n.round(e[0],2)},vhv:function(t,e){return"V"+n.round((t[1]+e[1])/2,2)+"H"+n.round(e[0],2)+"V"+n.round(e[1],2)}},O=function(t,e){return"L"+n.round(e[0],2)+","+n.round(e[1],2)};x.steps=function(t){var e=z[t]||O;return function(t){for(var r="M"+n.round(t[0][0],2)+","+n.round(t[0][1],2),i=1;i<t.length;i++)r+=e(t[i-1],t[i]);return r}},x.makeTester=function(){var t=i.ensureSingleById(n.select('body'),'svg','js-plotly-tester',(function(t){t.attr(p.svgAttrs).style({position:"absolute",left:"-10000px",top:"-10000px",width:"9000px",height:"9000px","z-index":"1"})})),e=i.ensureSingle(t,'path','js-reference-point',(function(t){t.attr('d','M0,0H1V1H0Z').style({"stroke-width":0,fill:"black"})}));x.tester=t,x.testref=e},x.savedBBoxes={};var D=0,R=1e4;function F(t){var e=t.getAttribute('data-unformatted');if(null!==e)return e+t.getAttribute('data-math')+t.getAttribute('text-anchor')+t.getAttribute('style')}function B(t,e){if(!t)return null;var r=e._context,n=r._exportedPlot?"":r._baseUrl||"";return n?"url('"+n+"#"+t+"')":"url(#"+t+")"}x.bBox=function(t,e,r){var a,o,s;if(r||(r=F(t)),r){if(a=x.savedBBoxes[r])return i.extendFlat({},a)}else if(1===t.childNodes.length){var l=t.childNodes[0];if(r=F(l)){var c=+l.getAttribute('x')||0,u=+l.getAttribute('y')||0,f=l.getAttribute('transform');if(!f){var p=x.bBox(l,!1,r);return c&&(p.left+=c,p.right+=c),u&&(p.top+=u,p.bottom+=u),p}if(r+="~"+c+"~"+u+"~"+f,a=x.savedBBoxes[r])return i.extendFlat({},a)}}e?o=t:(s=x.tester.node(),o=t.cloneNode(!0),s.appendChild(o)),n.select(o).attr('transform',null).call(h.positionText,0,0);var d=o.getBoundingClientRect(),m=x.testref.node().getBoundingClientRect();e||s.removeChild(o);var g={height:d.height,width:d.width,left:d.left-m.left,top:d.top-m.top,right:d.right-m.left,bottom:d.bottom-m.top};return D>=R&&(x.savedBBoxes={},D=0),r&&(x.savedBBoxes[r]=g),D++,i.extendFlat({},g)},x.setClipUrl=function(t,e,r){t.attr('clip-path',B(e,r))},x.getTranslate=function(t){var e=/.*\btranslate\((-?\d*\.?\d*)[^-\d]*(-?\d*\.?\d*)[^\d].*/,r=(t[t.attr?"attr":"getAttribute"]('transform')||"").replace(e,(function(t,e,r){return[e,r].join(' ')})).split(' ');return{x:+r[0]||0,y:+r[1]||0}},x.setTranslate=function(t,e,r){var n=/(\btranslate\(.*?\);?)/,i=t.attr?"attr":"getAttribute",a=t.attr?"attr":"setAttribute",o=t[i]('transform')||"";return e=e||0,r=r||0,o=o.replace(n,'').trim(),o=(o+=f(e,r)).trim(),t[a]('transform',o),o},x.getScale=function(t){var e=/.*\bscale\((\d*\.?\d*)[^\d]*(\d*\.?\d*)[^\d].*/,r=(t[t.attr?"attr":"getAttribute"]('transform')||"").replace(e,(function(t,e,r){return[e,r].join(' ')})).split(' ');return{x:+r[0]||1,y:+r[1]||1}},x.setScale=function(t,e,r){var n=/(\bscale\(.*?\);?)/,i=t.attr?"attr":"getAttribute",a=t.attr?"attr":"setAttribute",o=t[i]('transform')||"";return e=e||1,r=r||1,o=o.replace(n,'').trim(),o=(o+='scale('+e+','+r+')').trim(),t[a]('transform',o),o};var N=/\s*sc.*/;x.setPointGroupScale=function(t,e,r){if(e=e||1,r=r||1,t){var n=1===e&&1===r?"":"scale('+e+','+r+')";t.each((function(){var t=(this.getAttribute('transform')||"").replace(N,'');t=(t+=n).trim(),this.setAttribute('transform',t)}))}};var j=/translate\([^)]*\)\s*$/;x.setTextPointsScale=function(t,e,r){t&&t.each((function(){var t,i=n.select(this),a=i.select('text');if(a.node()){var o=parseFloat(a.attr('x')||0),s=parseFloat(a.attr('y')||0),l=(i.attr('transform')||"").match(j);t=1===e&&1===r?[]:[f(o,s),'scale('+e+','+r+')',f(-o,-s)],l&&t.push(l),i.attr('transform',t.join(''))}}))}},{"../../components/fx/helpers":686,"../../constants/alignment":755,"../../constants/interactions":762,"../../constants/xmlns_namespaces":764,"../../lib":787,"../../lib/svg_text_utils":813,"../../registry":915,"../../traces/scatter/make_bubble_size_func":1219,"../../traces/scatter/subtypes":1227,"../color":650,"../colorscale":662,"./symbol_defs":673,"@plotly/d3":58,"fast-isnumeric":246,tinycolor2:583}],673:[function(t,e,r){"use strict";var n=t('@plotly/d3');e.exports={circle:{n:0,f:function(t){var e=n.round(t,2);return"M"+e+",0A"+e+",'+e+' 0 1,1 0,-"+e+"A"+e+",'+e+' 0 0,1 '+e+',0Z"}},square:{n:1,f:function(t){var e=n.round(t,2);return"M"+e+","+e+"H-"+e+"V-"+e+"H"+e+"Z"}},diamond:{n:2,f:function(t){var e=n.round(1.3*t,2);return"M"+e+",0L0,"+e+"L-"+e+",0L0,-"+e+"Z"}},cross:{n:3,f:function(t){var e=n.round(.4*t,2),r=n.round(1.2*t,2);return"M"+r+","+e+"H"+e+"V"+r+"H-"+e+"V"+e+"H-"+r+"V-"+e+"H-"+e+"V-"+r+"H"+e+"V-"+e+"H"+r+"Z"}},x:{n:4,f:function(t){var e=n.round(.8*t/Math.sqrt(2),2),r="l"+e+","+e,i="l"+e+",-"+e,a="l-"+e+",-"+e,o="l-"+e+","+e;return"M0,"+e+r+i+a+i+a+o+a+o+r+o+r+"Z"}},"triangle-up":{n:5,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return"M-"+e+","+n.round(t/2,2)+"H"+e+"L0,-"+n.round(t,2)+"Z"}},"triangle-down":{n:6,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return"M-"+e+",-"+n.round(t/2,2)+"H"+e+"L0,"+n.round(t,2)+"Z"}},"triangle-left":{n:7,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return"M"+n.round(t/2,2)+",-"+e+"V"+e+"L-"+n.round(t,2)+",0Z"}},"triangle-right":{n:8,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return"M-"+n.round(t/2,2)+",-"+e+"V"+e+"L"+n.round(t,2)+",0Z"}},"triangle-ne":{n:9,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return"M-"+r+",-"+e+"H"+e+"V"+r+"Z"}},"triangle-se":{n:10,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return"M"+e+",-"+r+"V"+e+"H-"+r+"Z"}},"triangle-sw":{n:11,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return"M"+r+","+e+"H-"+e+"V-"+r+"Z"}},"triangle-nw":{n:12,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return"M-"+e+","+r+"V-"+e+"H"+r+"Z"}},pentagon:{n:13,f:function(t){var e=n.round(.951*t,2),r=n.round(.588*t,2),i=n.round(-t,2),a=n.round(-.309*t,2);return"M"+e+","+a+"L"+r+","+n.round(.809*t,2)+"H-"+r+"L-"+e+","+a+"L0,"+i+"Z"}},hexagon:{n:14,f:function(t){var e=n.round(t,2),r=n.round(t/2,2),i=n.round(t*Math.sqrt(3)/2,2);return"M"+i+",-"+r+"V"+r+"L0,"+e+"L-"+i+","+r+"V-"+r+"L0,-"+e+"Z"}},hexagon2:{n:15,f:function(t){var e=n.round(t,2),r=n.round(t/2,2),i=n.round(t*Math.sqrt(3)/2,2);return"M-"+r+","+i+"H"+r+"L"+e+",0L"+r+",-"+i+"H-"+r+"L-"+e+",0Z"}},octagon:{n:16,f:function(t){var e=n.round(.924*t,2),r=n.round(.383*t,2);return"M-"+r+",-"+e+"H"+r+"L"+e+",-"+r+"V"+r+"L"+r+","+e+"H-"+r+"L-"+e+","+r+"V-"+r+"Z"}},star:{n:17,f:function(t){var e=1.4*t,r=n.round(.225*e,2),i=n.round(.951*e,2),a=n.round(.363*e,2),o=n.round(.588*e,2),s=n.round(-e,2),l=n.round(-.309*e,2),c=n.round(.118*e,2),u=n.round(.809*e,2);return"M"+r+","+l+"H"+i+"L"+a+","+c+"L"+o+","+u+"L0,"+n.round(.382*e,2)+"L-"+o+","+u+"L-"+a+","+c+"L-"+i+","+l+"H-"+r+"L0,"+s+"Z"}},hexagram:{n:18,f:function(t){var e=n.round(.66*t,2),r=n.round(.38*t,2),i=n.round(.76*t,2);return"M-"+i+",0l-"+r+",-"+e+"h"+i+"l"+r+",-"+e+"l"+r+","+e+"h"+i+"l-"+r+","+e+"l"+r+","+e+"h-"+i+"l-"+r+","+e+"l-"+r+",-"+e+"h-"+i+"Z"}},"star-triangle-up":{n:19,f:function(t){var e=n.round(t*Math.sqrt(3)*.8,2),r=n.round(.8*t,2),i=n.round(1.6*t,2),a=n.round(4*t,2),o='A '+a+','+a+' 0 0 1 ';return"M-"+e+",'+r+o+e+',"+r+o+"0,-"+i+o+"-"+e+","+r+"Z"}},"star-triangle-down":{n:20,f:function(t){var e=n.round(t*Math.sqrt(3)*.8,2),r=n.round(.8*t,2),i=n.round(1.6*t,2),a=n.round(4*t,2),o='A '+a+','+a+' 0 0 1 ';return"M"+e+",-"+r+o+"-"+e+",-"+r+o+"0,'+i+o+e+',-"+r+"Z"}},"star-square":{n:21,f:function(t){var e=n.round(1.1*t,2),r=n.round(2*t,2),i='A '+r+','+r+' 0 0 1 ';return"M-"+e+",-"+e+i+"-"+e+",'+e+i+e+','+e+i+e+',-"+e+i+"-"+e+",-"+e+"Z"}},"star-diamond":{n:22,f:function(t){var e=n.round(1.4*t,2),r=n.round(1.9*t,2),i='A '+r+','+r+' 0 0 1 ';return"M-"+e+",0"+i+"0,'+e+i+e+',0"+i+"0,-"+e+i+"-"+e+",0Z"}},"diamond-tall":{n:23,f:function(t){var e=n.round(.7*t,2),r=n.round(1.4*t,2);return"M0,"+r+"L"+e+",0L0,-"+r+"L-"+e+",0Z"}},"diamond-wide":{n:24,f:function(t){var e=n.round(1.4*t,2),r=n.round(.7*t,2);return"M0,"+r+"L"+e+",0L0,-"+r+"L-"+e+",0Z"}},hourglass:{n:25,f:function(t){var e=n.round(t,2);return"M"+e+","+e+"H-"+e+"L"+e+",-"+e+"H-"+e+"Z"},noDot:!0},bowtie:{n:26,f:function(t){var e=n.round(t,2);return"M"+e+","+e+"V-"+e+"L-"+e+","+e+"V-"+e+"Z"},noDot:!0},"circle-cross":{n:27,f:function(t){var e=n.round(t,2);return"M0,"+e+"V-"+e+"M"+e+",0H-"+e+"M"+e+",0A"+e+",'+e+' 0 1,1 0,-"+e+"A"+e+",'+e+' 0 0,1 '+e+',0Z"},needLine:!0,noDot:!0},"circle-x":{n:28,f:function(t){var e=n.round(t,2),r=n.round(t/Math.sqrt(2),2);return"M"+r+","+r+"L-"+r+",-"+r+"M"+r+",-"+r+"L-"+r+","+r+"M"+e+",0A"+e+",'+e+' 0 1,1 0,-"+e+"A"+e+",'+e+' 0 0,1 '+e+',0Z"},needLine:!0,noDot:!0},"square-cross":{n:29,f:function(t){var e=n.round(t,2);return"M0,"+e+"V-"+e+"M"+e+",0H-"+e+"M"+e+","+e+"H-"+e+"V-"+e+"H"+e+"Z"},needLine:!0,noDot:!0},"square-x":{n:30,f:function(t){var e=n.round(t,2);return"M"+e+","+e+"L-"+e+",-"+e+"M"+e+",-"+e+"L-"+e+","+e+"M"+e+","+e+"H-"+e+"V-"+e+"H"+e+"Z"},needLine:!0,noDot:!0},"diamond-cross":{n:31,f:function(t){var e=n.round(1.3*t,2);return"M"+e+",0L0,"+e+"L-"+e+",0L0,-"+e+"ZM0,-"+e+"V"+e+"M-"+e+",0H"+e},needLine:!0,noDot:!0},"diamond-x":{n:32,f:function(t){var e=n.round(1.3*t,2),r=n.round(.65*t,2);return"M"+e+",0L0,"+e+"L-"+e+",0L0,-"+e+"ZM-"+r+",-"+r+"L"+r+","+r+"M-"+r+","+r+"L"+r+",-"+r},needLine:!0,noDot:!0},"cross-thin":{n:33,f:function(t){var e=n.round(1.4*t,2);return"M0,"+e+"V-"+e+"M"+e+",0H-"+e},needLine:!0,noDot:!0,noFill:!0},"x-thin":{n:34,f:function(t){var e=n.round(t,2);return"M"+e+","+e+"L-"+e+",-"+e+"M"+e+",-"+e+"L-"+e+","+e},needLine:!0,noDot:!0,noFill:!0},asterisk:{n:35,f:function(t){var e=n.round(1.2*t,2),r=n.round(.85*t,2);return"M0,"+e+"V-"+e+"M"+e+",0H-"+e+"M"+r+","+r+"L-"+r+",-"+r+"M"+r+",-"+r+"L-"+r+","+r},needLine:!0,noDot:!0,noFill:!0},hash:{n:36,f:function(t){var e=n.round(t/2,2),r=n.round(t,2);return"M"+e+","+r+"V-"+r+"m-"+r+",0V"+r+"M"+r+","+e+"H-"+r+"m0,-"+r+"H"+r},needLine:!0,noFill:!0},"y-up":{n:37,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return"M-"+e+","+i+"L0,0M"+e+","+i+"L0,0M0,-"+r+"L0,0"},needLine:!0,noDot:!0,noFill:!0},"y-down":{n:38,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return"M-"+e+",-"+i+"L0,0M"+e+",-"+i+"L0,0M0,"+r+"L0,0"},needLine:!0,noDot:!0,noFill:!0},"y-left":{n:39,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return"M"+i+","+e+"L0,0M"+i+",-"+e+"L0,0M-"+r+",0L0,0"},needLine:!0,noDot:!0,noFill:!0},"y-right":{n:40,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return"M-"+i+","+e+"L0,0M-"+i+",-"+e+"L0,0M"+r+",0L0,0"},needLine:!0,noDot:!0,noFill:!0},"line-ew":{n:41,f:function(t){var e=n.round(1.4*t,2);return"M"+e+",0H-"+e},needLine:!0,noDot:!0,noFill:!0},"line-ns":{n:42,f:function(t){var e=n.round(1.4*t,2);return"M0,"+e+"V-"+e},needLine:!0,noDot:!0,noFill:!0},"line-ne":{n:43,f:function(t){var e=n.round(t,2);return"M"+e+",-"+e+"L-"+e+","+e},needLine:!0,noDot:!0,noFill:!0},"line-nw":{n:44,f:function(t){var e=n.round(t,2);return"M"+e+","+e+"L-"+e+",-"+e},needLine:!0,noDot:!0,noFill:!0},"arrow-up":{n:45,f:function(t){var e=n.round(t,2);return"M0,0L-"+e+","+n.round(2*t,2)+"H"+e+"Z"},noDot:!0},"arrow-down":{n:46,f:function(t){var e=n.round(t,2);return"M0,0L-"+e+",-"+n.round(2*t,2)+"H"+e+"Z"},noDot:!0},"arrow-left":{n:47,f:function(t){var e=n.round(2*t,2),r=n.round(t,2);return"M0,0L"+e+",-"+r+"V"+r+"Z"},noDot:!0},"arrow-right":{n:48,f:function(t){var e=n.round(2*t,2),r=n.round(t,2);return"M0,0L-"+e+",-"+r+"V"+r+"Z"},noDot:!0},"arrow-bar-up":{n:49,f:function(t){var e=n.round(t,2);return"M-"+e+",0H"+e+"M0,0L-"+e+","+n.round(2*t,2)+"H"+e+"Z"},needLine:!0,noDot:!0},"arrow-bar-down":{n:50,f:function(t){var e=n.round(t,2);return"M-"+e+",0H"+e+"M0,0L-"+e+",-"+n.round(2*t,2)+"H"+e+"Z"},needLine:!0,noDot:!0},"arrow-bar-left":{n:51,f:function(t){var e=n.round(2*t,2),r=n.round(t,2);return"M0,-"+r+"V"+r+"M0,0L"+e+",-"+r+"V"+r+"Z"},needLine:!0,noDot:!0},"arrow-bar-right":{n:52,f:function(t){var e=n.round(2*t,2),r=n.round(t,2);return"M0,-"+r+"V"+r+"M0,0L-"+e+",-"+r+"V"+r+"Z"},needLine:!0,noDot:!0}}},{"@plotly/d3":58}],674:[function(t,e,r){"use strict";e.exports={visible:{valType:"boolean",editType:"calc"},type:{valType:"enumerated",values:["percent",'constant','sqrt',"data"],editType:"calc"},symmetric:{valType:"boolean",editType:"calc"},array:{valType:"data_array",editType:"calc"},arrayminus:{valType:"data_array",editType:"calc"},value:{valType:"number",min:0,dflt:10,editType:"calc"},valueminus:{valType:"number",min:0,dflt:10,editType:"calc"},traceref:{valType:"integer",min:0,dflt:0,editType:"style"},tracerefminus:{valType:"integer",min:0,dflt:0,editType:"style"},copy_ystyle:{valType:"boolean",editType:"plot"},copy_zstyle:{valType:"boolean",editType:"style"},color:{valType:"color",editType:"style"},thickness:{valType:"number",min:0,dflt:2,editType:"style"},width:{valType:"number",min:0,editType:"plot"},editType:"calc",_deprecated:{opacity:{valType:"number",editType:"style"}}}},{}],675:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../registry'),a=t('../../plots/cartesian/axes'),o=t('../../lib'),s=t('./compute_error');function l(t,e,r,i){var l=e["error_"+i]||{},c=[];if(l.visible&&-1!==["linear","log"].indexOf(r.type)){for(var u=s(l),f=0;f<t.length;f++){var h=t[f],p=h.i;if(void 0===p)p=f;else if(null===p)continue;var d=h[i];if(n(r.c2l(d))){var m=u(d,p);if(n(m[0])&&n(m[1])){var g=h[i+"s"]=d-m[0],v=h[i+"h"]=d+m[1];c.push(g,v)}}}var y=r._id,x=e._extremes[y],b=a.findExtremes(r,c,o.extendFlat({tozero:x.opts.tozero},{padded:!0}));x.min=x.min.concat(b.min),x.max=x.max.concat(b.max)}}e.exports=function(t){for(var e=t.calcdata,r=0;r<e.length;r++){var n=e[r],o=n[0].trace;if(!0===o.visible&&i.traceIs(o,'errorBarsOK')){var s=a.getFromId(t,o.xaxis),c=a.getFromId(t,o.yaxis);l(n,o,s,'x'),l(n,o,c,'y')}}}},{"../../lib":787,"../../plots/cartesian/axes":838,"../../registry":915,"./compute_error":676,"fast-isnumeric":246}],676:[function(t,e,r){"use strict";function n(t,e){return"percent"===t?function(t){return Math.abs(t*e/100)}:"constant"===t?function(){return Math.abs(e)}:"sqrt"===t?function(t){return Math.sqrt(Math.abs(t))}:void 0}e.exports=function(t){var e=t.type,r=t.symmetric;if("data"===e){var i=t.array||[];if(r)return function(t,e){var r=+i[e];return[r,r]};var a=t.arrayminus||[];return function(t,e){var r=+i[e],n=+a[e];return isNaN(r)&&isNaN(n)?[NaN,NaN]:[n||0,r||0]}}var o=n(e,t.value),s=n(e,t.valueminus);return r||void 0===t.valueminus?function(t){var e=o(t);return[e,e]}:function(t){return[s(t),o(t)]}}},{}],677:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../registry'),a=t('../../lib'),o=t('../../plot_api/plot_template'),s=t('./attributes');e.exports=function(t,e,r,l){var c="error_"+l.axis,u=o.newContainer(e,c),f=t[c]||{};function h(t,e){return a.coerce(f,u,s,t,e)}if(!1!==h('visible',void 0!==f.array||void 0!==f.value||"sqrt"===f.type)){var p=h('type',"array"in f?"data":"percent"),d=!0;"sqrt"!==p&&(d=h('symmetric',!(("data"===p?"arrayminus":"valueminus")in f))),"data"===p?(h('array'),h('traceref'),d||(h('arrayminus'),h('tracerefminus'))):"percent"!==p&&"constant"!==p||(h('value'),d||h('valueminus'));var m="copy_"+l.inherit+"style";l.inherit&&(e["error_"+l.inherit]||{}).visible&&h(m,!(f.color||n(f.thickness)||n(f.width))),l.inherit&&u[m]||(h('color',r),h('thickness'),h('width',i.traceIs(e,'gl3d')?0:4))}}},{"../../lib":787,"../../plot_api/plot_template":827,"../../registry":915,"./attributes":674,"fast-isnumeric":246}],678:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plot_api/edit_types').overrideAll,a=t('./attributes'),o={error_x:n.extendFlat({},a),error_y:n.extendFlat({},a)};delete o.error_x.copy_zstyle,delete o.error_y.copy_zstyle,delete o.error_y.copy_ystyle;var s={error_x:n.extendFlat({},a),error_y:n.extendFlat({},a),error_z:n.extendFlat({},a)};function l(t,e,r)[(e.error_y||{]).visible&&(r.yerr=t.yh-t.y,e.error_y.symmetric||(r.yerrneg=t.y-t.ys)),(e.error_x||{}).visible&&(r.xerr=t.xh-t.x,e.error_x.symmetric||(r.xerrneg=t.x-t.xs))}delete s.error_x.copy_ystyle,delete s.error_y.copy_ystyle,delete s.error_z.copy_ystyle,delete s.error_z.copy_zstyle,e.exports={moduleType:"component",name:"errorbars",schema:{traces:{scatter:o,bar:o,histogram:o,scatter3d:i(s,'calc','nested'),scattergl:i(o,'calc','nested')}},supplyDefaults:t('./defaults'),calc:t('./calc'),makeComputeError:t('./compute_error'),plot:t('./plot'),style:t('./style'),hoverInfo:l}},{"../../lib":787,"../../plot_api/edit_types":820,"./attributes":674,"./calc":675,"./compute_error":676,"./defaults":677,"./plot":679,"./style":680}],679:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../drawing'),o=t('../../traces/scatter/subtypes');function s(t,e,r){var n={x:e.c2p(t.x),y:r.c2p(t.y)};return void 0!==t.yh&&(n.yh=r.c2p(t.yh),n.ys=r.c2p(t.ys),i(n.ys)||(n.noYS=!0,n.ys=r.c2p(t.ys,!0))),void 0!==t.xh&&(n.xh=e.c2p(t.xh),n.xs=e.c2p(t.xs),i(n.xs)||(n.noXS=!0,n.xs=e.c2p(t.xs,!0))),n}e.exports=function(t,e,r,l){var c=r.xaxis,u=r.yaxis,f=l&&l.duration>0;e.each((function(e){var h,p=e[0].trace,d=p.error_x||{},m=p.error_y||{};p.ids&&(h=function(t){return t.id});var g=o.hasMarkers(p)&&p.marker.maxdisplayed>0;m.visible||d.visible||(e=[]);var v=n.select(this).selectAll('g.errorbar').data(e,h);if(v.exit().remove(),e.length){d.visible||v.selectAll('path.xerror').remove(),m.visible||v.selectAll('path.yerror').remove(),v.style('opacity',1);var y=v.enter().append('g').classed('errorbar',!0);f&&y.style('opacity',0).transition().duration(l.duration).style('opacity',1),a.setClipUrl(v,r.layerClipId,t),v.each((function(t){var e=n.select(this),r=s(t,c,u);if(!g||t.vis){var a,o=e.select('path.yerror');if(m.visible&&i(r.x)&&i(r.yh)&&i(r.ys)){var h=m.width;a="M"+(r.x-h)+","+r.yh+"h"+2*h+"m-"+h+",0V"+r.ys,r.noYS||(a+="m-"+h+",0h"+2*h),o.size()?f&&(o=o.transition().duration(l.duration).ease(l.easing)):o=e.append('path').style('vector-effect','non-scaling-stroke').classed('yerror',!0),o.attr('d',a)}else o.remove();var p=e.select('path.xerror');if(d.visible&&i(r.y)&&i(r.xh)&&i(r.xs)){var v=(d.copy_ystyle?m:d).width;a="M"+r.xh+","+(r.y-v)+"v"+2*v+"m0,-"+v+"H"+r.xs,r.noXS||(a+="m0,-"+v+"v"+2*v),p.size()?f&&(p=p.transition().duration(l.duration).ease(l.easing)):p=e.append('path').style('vector-effect','non-scaling-stroke').classed('xerror',!0),p.attr('d',a)}else p.remove()}}))}}))}},{"../../traces/scatter/subtypes":1227,"../drawing":672,"@plotly/d3":58,"fast-isnumeric":246}],680:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../color');e.exports=function(t){t.each((function(t){var e=t[0].trace,r=e.error_y||{},a=e.error_x||{},o=n.select(this);o.selectAll('path.yerror').style('stroke-width',r.thickness+"px").call(i.stroke,r.color),a.copy_ystyle&&(a=r),o.selectAll('path.xerror').style('stroke-width',a.thickness+"px").call(i.stroke,a.color)}))}},{"../color":650,"@plotly/d3":58}],681:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('./layout_attributes').hoverlabel,a=t('../../lib/extend').extendFlat;e.exports={hoverlabel:{bgcolor:a({},i.bgcolor,{arrayOk:!0}),bordercolor:a({},i.bordercolor,{arrayOk:!0}),font:n({arrayOk:!0,editType:"none"}),align:a({},i.align,{arrayOk:!0}),namelength:a({},i.namelength,{arrayOk:!0}),editType:"none"}}},{"../../lib/extend":777,"../../plots/font_attributes":867,"./layout_attributes":691}],682:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry');function a(t,e,r,i){i=i||n.identity,Array.isArray(t)&&(e[0][r]=i(t))}e.exports=function(t){var e=t.calcdata,r=t._fullLayout;function o(t){return function(e){return n.coerceHoverinfo({hoverinfo:e},{_module:t._module},r)}}for(var s=0;s<e.length;s++){var l=e[s],c=l[0].trace;if(!i.traceIs(c,'pie-like')){var u=i.traceIs(c,'2dMap')?a:n.fillArray;u(c.hoverinfo,l,'hi',o(c)),c.hovertemplate&&u(c.hovertemplate,l,'ht'),c.hoverlabel&&(u(c.hoverlabel.bgcolor,l,'hbg'),u(c.hoverlabel.bordercolor,l,'hbc'),u(c.hoverlabel.font.size,l,'hts'),u(c.hoverlabel.font.color,l,'htc'),u(c.hoverlabel.font.family,l,'htf'),u(c.hoverlabel.namelength,l,'hnl'),u(c.hoverlabel.align,l,'hta'))}}}},{"../../lib":787,"../../registry":915}],683:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('./hover').hover;e.exports=function(t,e,r){var a=n.getComponentMethod('annotations','onClick')(t,t._hoverdata);function o(){t.emit('plotly_click',{points:t._hoverdata,event:e})}void 0!==r&&i(t,e,r,!0),t._hoverdata&&e&&e.target&&(a&&a.then?a.then(o):o(),e.stopImmediatePropagation&&e.stopImmediatePropagation())}},{"../../registry":915,"./hover":687}],684:[function(t,e,r){"use strict";e.exports={YANGLE:60,HOVERARROWSIZE:6,HOVERTEXTPAD:3,HOVERFONTSIZE:13,HOVERFONT:"Arial, sans-serif",HOVERMINTIME:50,HOVERID:"-hover"}},{}],685:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('./hoverlabel_defaults');e.exports=function(t,e,r,o){function s(r,a){return n.coerce(t,e,i,r,a)}var l=n.extendFlat({},o.hoverlabel);e.hovertemplate&&(l.namelength=-1),a(t,e,s,l)}},{"../../lib":787,"./attributes":681,"./hoverlabel_defaults":688}],686:[function(t,e,r){"use strict";var n=t('../../lib');r.getSubplot=function(t){return t.subplot||t.xaxis+t.yaxis||t.geo},r.isTraceInSubplots=function(t,e){if("splom"===t.type){for(var n=t.xaxes||[],i=t.yaxes||[],a=0;a<n.length;a++)for(var o=0;o<i.length;o++)if(-1!==e.indexOf(n[a]+i[o]))return!0;return!1}return-1!==e.indexOf(r.getSubplot(t))},r.flat=function(t,e){for(var r=new Array(t.length),n=0;n<t.length;n++)r[n]=e;return r},r.p2c=function(t,e){for(var r=new Array(t.length),n=0;n<t.length;n++)r[n]=t[n].p2c(e);return r},r.getDistanceFunction=function(t,e,n,i){return"closest"===t?i||r.quadrature(e,n):"x"===t.charAt(0)?e:n},r.getClosest=function(t,e,r){if(!1!==r.index)r.index>=0&&r.index<t.length?r.distance=0:r.index=!1;else for(var n=0;n<t.length;n++){var i=e(t[n]);i<=r.distance&&(r.index=n,r.distance=i)}return r},r.inbox=function(t,e,r){return t*e<0||0===t?r:1/0},r.quadrature=function(t,e){return function(r){var n=t(r),i=e(r);return Math.sqrt(n*n+i*i)}},r.makeEventData=function(t,e,n){var i="index"in t?t.index:t.pointNumber,a={data:e._input,fullData:e,curveNumber:e.index,pointNumber:i};if(e._indexToPoints){var o=e._indexToPoints[i];1===o.length?a.pointIndex=o[0]:a.pointIndices=o}else a.pointIndex=i;return e._module.eventData?a=e._module.eventData(a,t,e,n,i):("xVal"in t?a.x=t.xVal:"x"in t&&(a.x=t.x),"yVal"in t?a.y=t.yVal:"y"in t&&(a.y=t.y),t.xa&&(a.xaxis=t.xa),t.ya&&(a.yaxis=t.ya),void 0!==t.zLabelVal&&(a.z=t.zLabelVal)),r.appendArrayPointValue(a,e,i),a},r.appendArrayPointValue=function(t,e,r){var i=e._arrayAttrs;if(i)for(var s=0;s<i.length;s++){var l=i[s],c=a(l);if(void 0===t[c]){var u=o(n.nestedProperty(e,l).get(),r);void 0!==u&&(t[c]=u)}}},r.appendArrayMultiPointValues=function(t,e,r){var i=e._arrayAttrs;if(i)for(var s=0;s<i.length;s++){var l=i[s],c=a(l);if(void 0===t[c]){for(var u=n.nestedProperty(e,l).get(),f=new Array(r.length),h=0;h<r.length;h++)f[h]=o(u,r[h]);t[c]=f}}};var i={ids:"id",locations:"location",labels:"label",values:"value","marker.colors":"color",parents:"parent"};function a(t){return i[t]||t}function o(t,e){return Array.isArray(e)?Array.isArray(t)&&Array.isArray(t[e[0]])?t[e[0]][e[1]]:void 0:t[e]}var s={x:!0,y:!0},l={"x unified":!0,"y unified":!0};r.isUnifiedHover=function(t){return"string"===typeof t&&!!l[t]},r.isXYhover=function(t){return"string"===typeof t&&!!s[t]}},{"../../lib":787}],687:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('tinycolor2'),o=t('../../lib'),s=o.strTranslate,l=o.strRotate,c=t('../../lib/events'),u=t('../../lib/svg_text_utils'),f=t('../../lib/override_cursor'),h=t('../drawing'),p=t('../color'),d=t('../dragelement'),m=t('../../plots/cartesian/axes'),g=t('../../registry'),v=t('./helpers'),y=t('./constants'),x=t('../legend/defaults'),b=t('../legend/draw'),_=y.YANGLE,w=Math.PI*_/180,T=1/Math.sin(w),k=Math.cos(w),M=Math.sin(w),A=y.HOVERARROWSIZE,S=y.HOVERTEXTPAD,E={box:!0,ohlc:!0,violin:!0,candlestick:!0},L={scatter:!0,scattergl:!0,splom:!0};function C(t,e,r,a){r||(r='xy');var s=Array.isArray(r)?r:[r],l=t._fullLayout,u=l._plots||[],h=u[r],m=l._has('cartesian');if(h){var y=h.overlays.map((function(t){return t.id}));s=s.concat(y)}for(var x=s.length,b=new Array(x),_=new Array(x),w=!1,T=0;T<x;T++){var k=s[T];if(u[k])w=!0,b[T]=u[k].xaxis,_[T]=u[k].yaxis;else{if(!l[k]||!l[k]._subplot)return void o.warn("Unrecognized subplot: "+k);var M=l[k]._subplot;b[T]=M.xaxis,_[T]=M.yaxis}}var A=e.hovermode||l.hovermode;if(A&&!w&&(A='closest'),-1===["x",'y','closest','x unified',"y unified"].indexOf(A)||!t.calcdata||t.querySelector('.zoombox')||t._dragging)return d.unhoverRaw(t,e);var S=l.hoverdistance;-1===S&&(S=1/0);var C=l.spikedistance;-1===C&&(C=1/0);var I,O,U,Y,W,X,Z,J,K,Q,$,tt,et,rt=[],nt=[],it={hLinePoint:null,vLinePoint:null},at=!1;if(Array.isArray(e))for(A='array',U=0;U<e.length;U++)(W=t.calcdata[e[U].curveNumber||0])&&(X=W[0].trace,"skip"!==W[0].trace.hoverinfo&&(nt.push(W),"h"===X.orientation&&(at=!0)));else{for(Y=0;Y<t.calcdata.length;Y++)W=t.calcdata[Y],"skip"!==(X=W[0].trace).hoverinfo&&v.isTraceInSubplots(X,s)&&(nt.push(W),"h"===X.orientation&&(at=!0));var ot,st;if(e.target){if(!1===c.triggerHandler(t,'plotly_beforehover',e))return;var lt=e.composedPath&&e.composedPath()[0];lt||(lt=e.target);var ct=lt.getBoundingClientRect();ot=e.clientX-ct.left,st=e.clientY-ct.top,l._calcInverseTransform(t);var ut=o.apply3DTransform(l._invTransform)(ot,st);if(ot=ut[0],st=ut[1],ot<0||ot>b[0]._length||st<0||st>_[0]._length)return d.unhoverRaw(t,e)}else ot="xpx"in e?e.xpx:b[0]._length/2,st="ypx"in e?e.ypx:_[0]._length/2;if(e.pointerX=ot+b[0]._offset,e.pointerY=st+_[0]._offset,I="xval"in e?v.flat(s,e.xval):v.p2c(b,ot),O="yval"in e?v.flat(s,e.yval):v.p2c(_,st),!i(I[0])||!i(O[0]))return o.warn('Fx.hover failed',e,t),d.unhoverRaw(t,e)}var ft=1/0;function ht(t,r){for(Y=0;Y<nt.length;Y++)if((W=nt[Y])&&W[0]&&W[0].trace&&!0===(X=W[0].trace).visible&&0!==X._length&&-1===["carpet","contourcarpet"].indexOf(X._module.name)){if("splom"===X.type?Z=s[J=0]:(Z=v.getSubplot(X),J=s.indexOf(Z)),K=A,v.isUnifiedHover(K)&&(K=K.charAt(0)),tt={cd:W,trace:X,xa:b[J],ya:_[J],maxHoverDistance:S,maxSpikeDistance:C,index:!1,distance:Math.min(ft,S),spikeDistance:1/0,xSpike:void 0,ySpike:void 0,color:p.defaultLine,name:X.name,x0:void 0,x1:void 0,y0:void 0,y1:void 0,xLabelVal:void 0,yLabelVal:void 0,zLabelVal:void 0,text:void 0},l[Z]&&(tt.subplot=l[Z]._subplot),l._splomScenes&&l._splomScenes[X.uid]&&(tt.scene=l._splomScenes[X.uid]),et=rt.length,"array"===K){var n=e[Y];"pointNumber"in n?(tt.index=n.pointNumber,K='closest'):(K='',"xval"in n&&(Q=n.xval,K='x'),"yval"in n&&($=n.yval,K=K?"closest":"y"))}else void 0!==t&&void 0!==r?(Q=t,$=r):(Q=I[J],$=O[J]);if(0!==S)if(X._module&&X._module.hoverPoints){var a=X._module.hoverPoints(tt,Q,$,K,{finiteRange:!0,hoverLayer:l._hoverlayer});if(a)for(var c,u=0;u<a.length;u++)c=a[u],i(c.x0)&&i(c.y0)&&rt.push(F(c,A))}else o.log('Unrecognized trace type in hover:',X);if("closest"===A&&rt.length>et&&(rt.splice(0,et),ft=rt[0].distance),m&&0!==C&&0===rt.length){tt.distance=C,tt.index=!1;var f=X._module.hoverPoints(tt,Q,$,'closest',{hoverLayer:l._hoverlayer});if(f&&(f=f.filter((function(t){return t.spikeDistance<=C}))),f&&f.length){var h,d=f.filter((function(t){return t.xa.showspikes&&"hovered data"!==t.xa.spikesnap}));if(d.length){var g=d[0];i(g.x0)&&i(g.y0)&&(h=dt(g),(!it.vLinePoint||it.vLinePoint.spikeDistance>h.spikeDistance)&&(it.vLinePoint=h))}var y=f.filter((function(t){return t.ya.showspikes&&"hovered data"!==t.ya.spikesnap}));if(y.length){var x=y[0];i(x.x0)&&i(x.y0)&&(h=dt(x),(!it.hLinePoint||it.hLinePoint.spikeDistance>h.spikeDistance)&&(it.hLinePoint=h))}}}}}function pt(t,e,r){for(var n,i=null,a=1/0,o=0;o<t.length;o++)n=t[o].spikeDistance,r&&0===o&&(n=-1/0),n<=a&&n<=e&&(i=t[o],a=n);return i}function dt(t){return t?{xa:t.xa,ya:t.ya,x:void 0!==t.xSpike?t.xSpike:(t.x0+t.x1)/2,y:void 0!==t.ySpike?t.ySpike:(t.y0+t.y1)/2,distance:t.distance,spikeDistance:t.spikeDistance,curveNumber:t.trace.index,color:t.color,pointNumber:t.index}:null}ht();var mt={fullLayout:l,container:l._hoverlayer,event:e},gt=t._spikepoints,vt={vLinePoint:it.vLinePoint,hLinePoint:it.hLinePoint};t._spikepoints=vt;var yt=function(){rt.sort((function(t,e){return t.distance-e.distance})),rt=V(rt,A)};yt();var xt=A.charAt(0),bt=("x"===xt||"y"===xt)&&rt[0]&&L[rt[0].trace.type];if(m&&0!==C&&0!==rt.length){var _t=pt(rt.filter((function(t){return t.ya.showspikes})),C,bt);it.hLinePoint=dt(_t);var wt=pt(rt.filter((function(t){return t.xa.showspikes})),C,bt);it.vLinePoint=dt(wt)}if(0===rt.length){var Tt=d.unhoverRaw(t,e);return!m||null===it.hLinePoint&&null===it.vLinePoint||j(gt)&&B(t,it,mt),Tt}if(m&&j(gt)&&B(t,it,mt),v.isXYhover(K)&&0!==rt[0].length&&"splom"!==rt[0].trace.type){var kt=rt[0],Mt=(rt=E[kt.trace.type]?rt.filter((function(t){return t.trace.index===kt.trace.index})):[kt]).length;ht(H('x',kt,l),H('y',kt,l));var At,St=[],Et={},Lt=0,Ct=function(t){var e=E[t.trace.type]?P(t):t.trace.index;if(Et[e]){var r=Et[e]-1,n=St[r];r>0&&Math.abs(t.distance)<Math.abs(n.distance)&&(St[r]=t)}else Lt++,Et[e]=Lt,St.push(t)};for(At=0;At<Mt;At++)Ct(rt[At]);for(At=rt.length-1;At>Mt-1;At--)Ct(rt[At]);rt=St,yt()}var Pt=t._hoverdata,It=[],zt=q(t),Ot=G(t);for(U=0;U<rt.length;U++){var Dt=rt[U],Rt=v.makeEventData(Dt,Dt.trace,Dt.cd);if(!1!==Dt.hovertemplate){var Ft=!1;Dt.cd[Dt.index]&&Dt.cd[Dt.index].ht&&(Ft=Dt.cd[Dt.index].ht),Dt.hovertemplate=Ft||Dt.trace.hovertemplate||!1}if(Dt.xa&&Dt.ya){var Bt=Dt.x0+Dt.xa._offset,Nt=Dt.x1+Dt.xa._offset,jt=Dt.y0+Dt.ya._offset,Ut=Dt.y1+Dt.ya._offset,Vt=Math.min(Bt,Nt),Ht=Math.max(Bt,Nt),qt=Math.min(jt,Ut),Gt=Math.max(jt,Ut);Rt.bbox={x0:Vt+Ot,x1:Ht+Ot,y0:qt+zt,y1:Gt+zt}}Dt.eventData=[Rt],It.push(Rt)}t._hoverdata=It;var Yt="y"===A&&(nt.length>1||rt.length>1)||"closest"===A&&at&&rt.length>1,Wt=p.combine(l.plot_bgcolor||p.background,l.paper_bgcolor),Xt=z(rt,{gd:t,hovermode:A,rotateLabels:Yt,bgColor:Wt,container:l._hoverlayer,outerContainer:l._paper.node(),commonLabelOpts:l.hoverlabel,hoverdistance:l.hoverdistance});if(v.isUnifiedHover(A)||(D(Xt,Yt?"xa":"ya",l),R(Xt,Yt,l._invScaleX,l._invScaleY)),e.target&&e.target.tagName){var Zt=g.getComponentMethod('annotations','hasClickToShow')(t,It);f(n.select(e.target),Zt?"pointer":"")}e.target&&!a&&N(t,e,Pt)&&(Pt&&t.emit('plotly_unhover',{event:e,points:Pt}),t.emit('plotly_hover',{event:e,points:t._hoverdata,xaxes:b,yaxes:_,xvals:I,yvals:O}))}function P(t){return[t.trace.index,t.index,t.x0,t.y0,t.name,t.attr,t.xa?t.xa._id:"",t.ya?t.ya._id:""].join(',')}r.hover=function(t,e,r,n){t=o.getGraphDiv(t),o.throttle(t._fullLayout._uid+y.HOVERID,y.HOVERMINTIME,(function(){C(t,e,r,n)}))},r.loneHover=function(t,e){var r=!0;Array.isArray(t)||(r=!1,t=[t]);var i=e.gd,a=q(i),o=G(i),s=!1,l=z(t.map((function(t){var r=t._x0||t.x0||t.x||0,n=t._x1||t.x1||t.x||0,s=t._y0||t.y0||t.y||0,l=t._y1||t.y1||t.y||0,c=t.eventData;if(c){var u=Math.min(r,n),f=Math.max(r,n),h=Math.min(s,l),d=Math.max(s,l),m=t.trace;if(g.traceIs(m,'gl3d')){var v=i._fullLayout[m.scene]._scene.container,y=v.offsetLeft,x=v.offsetTop;u+=y,f+=y,h+=x,d+=x}c.bbox={x0:u+o,x1:f+o,y0:h+a,y1:d+a},e.inOut_bbox&&e.inOut_bbox.push(c.bbox)}else c=!1;return{color:t.color||p.defaultLine,x0:t.x0||t.x||0,x1:t.x1||t.x||0,y0:t.y0||t.y||0,y1:t.y1||t.y||0,xLabel:t.xLabel,yLabel:t.yLabel,zLabel:t.zLabel,text:t.text,name:t.name,idealAlign:t.idealAlign,borderColor:t.borderColor,fontFamily:t.fontFamily,fontSize:t.fontSize,fontColor:t.fontColor,nameLength:t.nameLength,textAlign:t.textAlign,trace:t.trace||{index:0,hoverinfo:""},xa:{_offset:0},ya:{_offset:0},index:0,hovertemplate:t.hovertemplate||!1,hovertemplateLabels:t.hovertemplateLabels||!1,eventData:c}})),{gd:i,hovermode:"closest",rotateLabels:s,bgColor:e.bgColor||p.background,container:n.select(e.container),outerContainer:e.outerContainer||e.container}),c=5,u=0,f=0;return l.sort((function(t,e){return t.y0-e.y0})).each((function(t,r){var n=t.y0-t.by/2;t.offset=n-c<u?u-n+c:0,u=n+t.by+t.offset,r===e.anchorIndex&&(f=t.offset)})).each((function(t)[t.offset-=f])),R(l,s,i._fullLayout._invScaleX,i._fullLayout._invScaleY),r?l:l.node()};var I=/<extra>([\s\S]*)<\/extra>/;function z(t,e){var r=e.gd,i=r._fullLayout,a=e.hovermode,c=e.rotateLabels,f=e.bgColor,d=e.container,m=e.outerContainer,w=e.commonLabelOpts||{},T=e.fontFamily||y.HOVERFONT,k=e.fontSize||y.HOVERFONTSIZE,M=t[0],E=M.xa,L=M.ya,C=a.charAt(0),I=M[C+"Label"],z=Y(r,m),D=z.top,R=z.width,F=z.height,B=void 0!==I&&M.distance<=e.hoverdistance&&("x"===a||"y"===a);if(B){var N,j,U=!0;for(N=0;N<t.length;N++)if(U&&void 0===t[N].zLabel&&(U=!1),j=t[N].hoverinfo||t[N].trace.hoverinfo){var V=Array.isArray(j)?j:j.split('+');if(-1===V.indexOf('all')&&-1===V.indexOf(a)){B=!1;break}}U&&(B=!1)}var H=d.selectAll('g.axistext').data(B?[0]:[]);if(H.enter().append('g').classed('axistext',!0),H.exit().remove(),H.each((function(){var t=n.select(this),e=o.ensureSingle(t,'path','',(function(t){t.style({"stroke-width":"1px"})})),l=o.ensureSingle(t,'text','',(function(t){t.attr('data-notex',1)})),c=w.bgcolor||p.defaultLine,f=w.bordercolor||p.contrast(c),d=p.contrast(c),m={family:w.font.family||T,size:w.font.size||k,color:w.font.color||d};e.style({fill:c,stroke:f}),l.text(I).call(h.font,m).call(u.positionText,0,0).call(u.convertToTspans,r),t.attr('transform','');var g,v,y=Y(r,l.node());if("x"===a){var x="top"===E.side?"-":"";l.attr('text-anchor','middle').call(u.positionText,0,"top"===E.side?D-y.bottom-A-S:D-y.top+A+S),g=E._offset+(M.x0+M.x1)/2,v=L._offset+("top"===E.side?0:L._length);var b=y.width/2+S;g<b?(g=b,e.attr('d',"M-"+(b-A)+",0L-"+(b-2*A)+","+x+A+"H"+(S+y.width/2)+"v"+x+(2*S+y.height)+"H-"+b+"V"+x+A+"Z")):g>i.width-b?(g=i.width-b,e.attr('d',"M"+(b-A)+",0L"+b+","+x+A+"v"+x+(2*S+y.height)+"H-"+b+"V"+x+A+"H"+(b-2*A)+"Z")):e.attr('d',"M0,0L"+A+","+x+A+"H"+(S+y.width/2)+"v"+x+(2*S+y.height)+"H-"+(S+y.width/2)+"V"+x+A+"H-"+A+"Z")}else{var _,C,P;"right"===L.side?(_='start',C=1,P='',g=E._offset+E._length):(_='end',C=-1,P='-',g=E._offset),v=L._offset+(M.y0+M.y1)/2,l.attr('text-anchor',_),e.attr('d',"M0,0L"+P+A+","+A+"V"+(S+y.height/2)+"h"+P+(2*S+y.width)+"V-"+(S+y.height/2)+"H"+P+A+"V-"+A+"Z");var z,O=y.height/2,R=D-y.top-O,F="clip"+i._uid+"commonlabel"+L._id;if(g<y.width+2*S+A){z="M-"+(A+S)+"-"+O+"h-"+(y.width-S)+"V"+O+"h"+(y.width-S)+"Z";var B=y.width-g+S;u.positionText(l,B,R),"end"===_&&l.selectAll('tspan').each((function(){var t=n.select(this),e=h.tester.append('text').text(t.text()).call(h.font,m),i=Y(r,e.node());Math.round(i.width)<Math.round(y.width)&&t.attr('x',B-i.width),e.remove()}))}else u.positionText(l,C*(S+A),R),z=null;var N=i._topclips.selectAll("#"+F).data(z?[0]:[]);N.enter().append('clipPath').attr('id',F).append('path'),N.exit().remove(),N.select('path').attr('d',z),h.setClipUrl(l,z?F:null,r)}t.attr('transform',s(g,v))})),v.isUnifiedHover(a)){if(d.selectAll('g.hovertext').remove(),0===t.length)return;var q=i.hoverlabel,G=q.font,W={showlegend:!0,legend:{title:{text:I,font:G},font:G,bgcolor:q.bgcolor,bordercolor:q.bordercolor,borderwidth:1,tracegroupgap:7,traceorder:i.legend?i.legend.traceorder:void 0,orientation:"v"}},X={};x(W,X,r._fullData);var Z=X.legend;Z.entries=[];for(var J=0;J<t.length;J++){var K=O(t[J],!0,a,i,I),Q=K[0],$=K[1],tt=t[J];tt.name=$,tt.text=""!==$?$+" : "+Q:Q;var et=tt.cd[tt.index];et&&(et.mc&&(tt.mc=et.mc),et.mcc&&(tt.mc=et.mcc),et.mlc&&(tt.mlc=et.mlc),et.mlcc&&(tt.mlc=et.mlcc),et.mlw&&(tt.mlw=et.mlw),et.mrc&&(tt.mrc=et.mrc),et.dir&&(tt.dir=et.dir)),tt._distinct=!0,Z.entries.push([tt])}Z.entries.sort((function(t,e){return t[0].trace.index-e[0].trace.index})),Z.layer=d,Z._inHover=!0,Z._groupTitleFont=G,b(r,Z);var rt,nt,it,at,ot=d.select('g.legend'),st=Y(r,ot.node()),lt=st.width+2*S,ct=st.height+2*S,ut=t[0],ft=(ut.x0+ut.x1)/2,ht=(ut.y0+ut.y1)/2,pt=!(g.traceIs(ut.trace,'bar-like')||g.traceIs(ut.trace,'box-violin'));"y"===C?pt?(nt=ht-S,rt=ht+S):(nt=Math.min.apply(null,t.map((function(t){return Math.min(t.y0,t.y1)}))),rt=Math.max.apply(null,t.map((function(t){return Math.max(t.y0,t.y1)})))):nt=rt=o.mean(t.map((function(t){return(t.y0+t.y1)/2})))-ct/2,"x"===C?pt?(it=ft+S,at=ft-S):(it=Math.max.apply(null,t.map((function(t){return Math.max(t.x0,t.x1)}))),at=Math.min.apply(null,t.map((function(t){return Math.min(t.x0,t.x1)})))):it=at=o.mean(t.map((function(t){return(t.x0+t.x1)/2})))-lt/2;var dt,mt,gt=E._offset,vt=L._offset;return at+=gt-lt,nt+=vt-ct,dt=(it+=gt)+lt<R&&it>=0?it:at+lt<R&&at>=0?at:gt+lt<R?gt:it-ft<ft-at+lt?R-lt:0,dt+=S,mt=(rt+=vt)+ct<F&&rt>=0?rt:nt+ct<F&&nt>=0?nt:vt+ct<F?vt:rt-ht<ht-nt+ct?F-ct:0,mt+=S,ot.attr('transform',s(dt-1,mt-1)),ot}var yt=d.selectAll('g.hovertext').data(t,(function(t){return P(t)}));return yt.enter().append('g').classed('hovertext',!0).each((function(){var t=n.select(this);t.append('rect').call(p.fill,p.addOpacity(f,.8)),t.append('text').classed('name',!0),t.append('path').style('stroke-width','1px'),t.append('text').classed('nums',!0).call(h.font,T,k)})),yt.exit().remove(),yt.each((function(t){var e=n.select(this).attr('transform',''),o=t.color;Array.isArray(o)&&(o=o[t.eventData[0].pointNumber]);var d=t.bgcolor||o,m=p.combine(p.opacity(d)?d:p.defaultLine,f),g=p.combine(p.opacity(o)?o:p.defaultLine,f),v=t.borderColor||p.contrast(m),y=O(t,B,a,i,I,e),x=y[0],b=y[1],w=e.select('text.nums').call(h.font,t.fontFamily||T,t.fontSize||k,t.fontColor||v).text(x).attr('data-notex',1).call(u.positionText,0,0).call(u.convertToTspans,r),M=e.select('text.name'),E=0,L=0;if(b&&b!==x){M.call(h.font,t.fontFamily||T,t.fontSize||k,g).text(b).attr('data-notex',1).call(u.positionText,0,0).call(u.convertToTspans,r);var C=Y(r,M.node());E=C.width+2*S,L=C.height+2*S}else M.remove(),e.select('rect').remove();e.select('path').style({fill:m,stroke:v});var P=t.xa._offset+(t.x0+t.x1)/2,z=t.ya._offset+(t.y0+t.y1)/2,N=Math.abs(t.x1-t.x0),j=Math.abs(t.y1-t.y0),U=Y(r,w.node()),V=U.width/i._invScaleX,H=U.height/i._invScaleY;t.ty0=(D-U.top)/i._invScaleY,t.bx=V+2*S,t.by=Math.max(H+2*S,L),t.anchor='start',t.txwidth=V,t.tx2width=E,t.offset=0;var q,G,W=(V+A+S+E)*i._invScaleX;if(c)t.pos=P,q=z+j/2+W<=F,G=z-j/2-W>=0,"top"!==t.idealAlign&&q||!G?q?(z+=j/2,t.anchor='start'):t.anchor="middle":(z-=j/2,t.anchor='end');else if(t.pos=z,q=P+N/2+W<=R,G=P-N/2-W>=0,"left"!==t.idealAlign&&q||!G)if(q)P+=N/2,t.anchor='start';else{t.anchor='middle';var X=W/2,Z=P+X-R,J=P-X;Z>0&&(P-=Z),J<0&&(P+=-J)}else P-=N/2,t.anchor='end';w.attr('text-anchor',t.anchor),E&&M.attr('text-anchor',t.anchor),e.attr('transform',s(P,z)+(c?l(_):""))})),yt}function O(t,e,r,n,i,a){var s='',l='';void 0!==t.nameOverride&&(t.name=t.nameOverride),t.name&&(t.trace._meta&&(t.name=o.templateString(t.name,t.trace._meta)),s=U(t.name,t.nameLength));var c=r.charAt(0),u="x"===c?"y":"x";void 0!==t.zLabel?(void 0!==t.xLabel&&(l+="x: "+t.xLabel+"<br>"),void 0!==t.yLabel&&(l+="y: "+t.yLabel+"<br>"),"choropleth"!==t.trace.type&&"choroplethmapbox"!==t.trace.type&&(l+=(l?"z: ":"")+t.zLabel)):e&&t[c+"Label"]===i?l=t[u+"Label"]||"":void 0===t.xLabel?void 0!==t.yLabel&&"scattercarpet"!==t.trace.type&&(l=t.yLabel):l=void 0===t.yLabel?t.xLabel:"('+t.xLabel+', '+t.yLabel+')",!t.text&&0!==t.text||Array.isArray(t.text)||(l+=(l?"<br>":"")+t.text),void 0!==t.extraText&&(l+=(l?"<br>":"")+t.extraText),a&&""===l&&!t.hovertemplate&&(""===s&&a.remove(),l=s);var f=t.hovertemplate||!1;if(f){var h=t.hovertemplateLabels||t;t[c+"Label"]!==i&&(h[c+"other"]=h[c+"Val"],h[c+"otherLabel"]=h[c+"Label"]),l=(l=o.hovertemplateString(f,h,n._d3locale,t.eventData[0]||{},t.trace._meta)).replace(I,(function(e,r){return s=U(r,t.nameLength),""}))}return[l,s]}function D(t,e,r){var n,i,a,o,s,l,c,u=0,f=1,h=t.size(),p=new Array(h),d=0;function m(t){var e=t[0],r=t[t.length-1];if(i=e.pmin-e.pos-e.dp+e.size,a=r.pos+r.dp+r.size-e.pmax,i>.01){for(s=t.length-1;s>=0;s--)t[s].dp+=i;n=!1}if(!(a<.01)){if(i<-.01){for(s=t.length-1;s>=0;s--)t[s].dp-=a;n=!1}if(n){var c=0;for(o=0;o<t.length;o++)(l=t[o]).pos+l.dp+l.size>e.pmax&&c++;for(o=t.length-1;o>=0&&!(c<=0);o--)(l=t[o]).pos>e.pmax-1&&(l.del=!0,c--);for(o=0;o<t.length&&!(c<=0);o++)if((l=t[o]).pos<e.pmin+1)for(l.del=!0,c--,a=2*l.size,s=t.length-1;s>=0;s--)t[s].dp-=a;for(o=t.length-1;o>=0&&!(c<=0);o--)(l=t[o]).pos+l.dp+l.size>e.pmax&&(l.del=!0,c--)}}}for(t.each((function(t){var n=t[e],i="x"===n._id.charAt(0),a=n.range;0===d&&a&&a[0]>a[1]!==i&&(f=-1),p[d++]=[datum:t,traceIndex:t.trace.index,dp:0,pos:t.pos,posref:t.posref,size:t.by*(i?T:1)/2,pmin:0,pmax:i?r.width:r.height]})),p.sort((function(t,e){return t[0].posref-e[0].posref||f*(e[0].traceIndex-t[0].traceIndex)}));!n&&u<=h;){for(u++,n=!0,o=0;o<p.length-1;){var g=p[o],v=p[o+1],y=g[g.length-1],x=v[0];if((i=y.pos+y.dp+y.size-x.pos-x.dp+x.size)>.01&&y.pmin===x.pmin&&y.pmax===x.pmax){for(s=v.length-1;s>=0;s--)v[s].dp+=i;for(g.push.apply(g,v),p.splice(o+1,1),c=0,s=g.length-1;s>=0;s--)c+=g[s].dp;for(a=c/g.length,s=g.length-1;s>=0;s--)g[s].dp-=a;n=!1}else o++}p.forEach(m)}for(o=p.length-1;o>=0;o--){var b=p[o];for(s=b.length-1;s>=0;s--){var _=b[s],w=_.datum;w.offset=_.dp,w.del=_.del}}}function R(t,e,r,i){var a=function(t){return t*r},o=function(t){return t*i};t.each((function(t){var r=n.select(this);if(t.del)return r.remove();var i=r.select('text.nums'),s=t.anchor,l="end"===s?-1:1,c={start:1,end:-1,middle:0}[s],f=c*(A+S),p=f+c*(t.txwidth+S),d=0,m=t.offset,g="middle"===s;g&&(f-=t.tx2width/2,p+=t.txwidth/2+S),e&&(m*=-M,d=t.offset*k),r.select('path').attr('d',g?"M-"+a(t.bx/2+t.tx2width/2)+","+o(m-t.by/2)+"h"+a(t.bx)+"v"+o(t.by)+"h-"+a(t.bx)+"Z":"M0,0L"+a(l*A+d)+","+o(A+m)+"v"+o(t.by/2-A)+"h"+a(l*t.bx)+"v-"+o(t.by)+"H"+a(l*A+d)+"V"+o(m-A)+"Z");var v=d+f,y=m+t.ty0-t.by/2+S,x=t.textAlign||"auto";"auto"!==x&&("left"===x&&"start"!==s?(i.attr('text-anchor','start'),v=g?-t.bx/2-t.tx2width/2+S:-t.bx-S):"right"===x&&"end"!==s&&(i.attr('text-anchor','end'),v=g?t.bx/2-t.tx2width/2-S:t.bx+S)),i.call(u.positionText,a(v),o(y)),t.tx2width&&(r.select('text.name').call(u.positionText,a(p+c*S+d),o(m+t.ty0-t.by/2+S)),r.select('rect').call(h.setRect,a(p+(c-1)*t.tx2width/2+d),o(m-t.by/2-1),a(t.tx2width),o(t.by+2)))}))}function F(t,e){var r=t.index,n=t.trace||{},a=t.cd[0],s=t.cd[r]||{};function l(t){return t||i(t)&&0===t}var c=Array.isArray(r)?function(t,e){var i=o.castOption(a,r,t);return l(i)?i:o.extractOption({},n,'',e)}:function(t,e){return o.extractOption(s,n,t,e)};function u(e,r,n){var i=c(r,n);l(i)&&(t[e]=i)}if(u('hoverinfo','hi','hoverinfo'),u('bgcolor','hbg','hoverlabel.bgcolor'),u('borderColor','hbc','hoverlabel.bordercolor'),u('fontFamily','htf','hoverlabel.font.family'),u('fontSize','hts','hoverlabel.font.size'),u('fontColor','htc','hoverlabel.font.color'),u('nameLength','hnl','hoverlabel.namelength'),u('textAlign','hta','hoverlabel.align'),t.posref="y"===e||"closest"===e&&"h"===n.orientation?t.xa._offset+(t.x0+t.x1)/2:t.ya._offset+(t.y0+t.y1)/2,t.x0=o.constrain(t.x0,0,t.xa._length),t.x1=o.constrain(t.x1,0,t.xa._length),t.y0=o.constrain(t.y0,0,t.ya._length),t.y1=o.constrain(t.y1,0,t.ya._length),void 0!==t.xLabelVal&&(t.xLabel="xLabel"in t?t.xLabel:m.hoverLabelText(t.xa,t.xLabelVal,n.xhoverformat),t.xVal=t.xa.c2d(t.xLabelVal)),void 0!==t.yLabelVal&&(t.yLabel="yLabel"in t?t.yLabel:m.hoverLabelText(t.ya,t.yLabelVal,n.yhoverformat),t.yVal=t.ya.c2d(t.yLabelVal)),void 0!==t.zLabelVal&&void 0===t.zLabel&&(t.zLabel=String(t.zLabelVal)),!isNaN(t.xerr)&&!("log"===t.xa.type&&t.xerr<=0)){var f=m.tickText(t.xa,t.xa.c2l(t.xerr),'hover').text;void 0!==t.xerrneg?t.xLabel+=" +"+f+" / -"+m.tickText(t.xa,t.xa.c2l(t.xerrneg),'hover').text:t.xLabel+=" \xb1 "+f,"x"===e&&(t.distance+=1)}if(!isNaN(t.yerr)&&!("log"===t.ya.type&&t.yerr<=0)){var h=m.tickText(t.ya,t.ya.c2l(t.yerr),'hover').text;void 0!==t.yerrneg?t.yLabel+=" +"+h+" / -"+m.tickText(t.ya,t.ya.c2l(t.yerrneg),'hover').text:t.yLabel+=" \xb1 "+h,"y"===e&&(t.distance+=1)}var p=t.hoverinfo||t.trace.hoverinfo;return p&&"all"!==p&&(-1===(p=Array.isArray(p)?p:p.split('+')).indexOf('x')&&(t.xLabel=void 0),-1===p.indexOf('y')&&(t.yLabel=void 0),-1===p.indexOf('z')&&(t.zLabel=void 0),-1===p.indexOf('text')&&(t.text=void 0),-1===p.indexOf('name')&&(t.name=void 0)),t}function B(t,e,r){var n,i,o=r.container,s=r.fullLayout,l=s._size,c=r.event,u=!!e.hLinePoint,f=!!e.vLinePoint;if(o.selectAll('.spikeline').remove(),f||u){var d=p.combine(s.plot_bgcolor,s.paper_bgcolor);if(u){var g,v,y=e.hLinePoint;n=y&&y.xa,"cursor"===(i=y&&y.ya).spikesnap?(g=c.pointerX,v=c.pointerY):(g=n._offset+y.x,v=i._offset+y.y);var x,b,_=a.readability(y.color,d)<1.5?p.contrast(d):y.color,w=i.spikemode,T=i.spikethickness,k=i.spikecolor||_,M=m.getPxPosition(t,i);if(-1!==w.indexOf('toaxis')||-1!==w.indexOf('across')){if(-1!==w.indexOf('toaxis')&&(x=M,b=g),-1!==w.indexOf('across')){var A=i._counterDomainMin,S=i._counterDomainMax;"free"===i.anchor&&(A=Math.min(A,i.position),S=Math.max(S,i.position)),x=l.l+A*l.w,b=l.l+S*l.w}o.insert('line',':first-child').attr({x1:x,x2:b,y1:v,y2:v,"stroke-width":T,stroke:k,"stroke-dasharray":h.dashStyle(i.spikedash,T)}).classed('spikeline',!0).classed('crisp',!0),o.insert('line',':first-child').attr({x1:x,x2:b,y1:v,y2:v,"stroke-width":T+2,stroke:d}).classed('spikeline',!0).classed('crisp',!0)}-1!==w.indexOf('marker')&&o.insert('circle',':first-child').attr({cx:M+("right"!==i.side?T:-T),cy:v,r:T,fill:k}).classed('spikeline',!0)}if(f){var E,L,C=e.vLinePoint;n=C&&C.xa,i=C&&C.ya,"cursor"===n.spikesnap?(E=c.pointerX,L=c.pointerY):(E=n._offset+C.x,L=i._offset+C.y);var P,I,z=a.readability(C.color,d)<1.5?p.contrast(d):C.color,O=n.spikemode,D=n.spikethickness,R=n.spikecolor||z,F=m.getPxPosition(t,n);if(-1!==O.indexOf('toaxis')||-1!==O.indexOf('across')){if(-1!==O.indexOf('toaxis')&&(P=F,I=L),-1!==O.indexOf('across')){var B=n._counterDomainMin,N=n._counterDomainMax;"free"===n.anchor&&(B=Math.min(B,n.position),N=Math.max(N,n.position)),P=l.t+(1-N)*l.h,I=l.t+(1-B)*l.h}o.insert('line',':first-child').attr({x1:E,x2:E,y1:P,y2:I,"stroke-width":D,stroke:R,"stroke-dasharray":h.dashStyle(n.spikedash,D)}).classed('spikeline',!0).classed('crisp',!0),o.insert('line',':first-child').attr({x1:E,x2:E,y1:P,y2:I,"stroke-width":D+2,stroke:d}).classed('spikeline',!0).classed('crisp',!0)}-1!==O.indexOf('marker')&&o.insert('circle',':first-child').attr({cx:E,cy:F-("top"!==n.side?D:-D),r:D,fill:R}).classed('spikeline',!0)}}}function N(t,e,r){if(!r||r.length!==t._hoverdata.length)return!0;for(var n=r.length-1;n>=0;n--){var i=r[n],a=t._hoverdata[n];if(i.curveNumber!==a.curveNumber||String(i.pointNumber)!==String(a.pointNumber)||String(i.pointNumbers)!==String(a.pointNumbers))return!0}return!1}function j(t,e){return!e||e.vLinePoint!==t._spikepoints.vLinePoint||e.hLinePoint!==t._spikepoints.hLinePoint}function U(t,e){return u.plainText(t||"",{len:e,allowedTags:["br",'sub','sup','b','i',"em"]})}function V(t,e){for(var r=e.charAt(0),n=[],i=[],a=[],o=0;o<t.length;o++){var s=t[o];g.traceIs(s.trace,'bar-like')||g.traceIs(s.trace,'box-violin')?a.push(s):s.trace[r+"period"]?i.push(s):n.push(s)}return n.concat(i).concat(a)}function H(t,e,r){var n=e[t+"a"],i=e[t+"Val"],a=e.cd[0];if("category"===n.type)i=n._categoriesMap[i];else if("date"===n.type){var o=e.trace[t+"periodalignment"];if(o){var s=e.cd[e.index],l=s[t+"Start"];void 0===l&&(l=s[t]);var c=s[t+"End"];void 0===c&&(c=s[t]);var u=c-l;"end"===o?i+=u:"middle"===o&&(i+=u/2)}i=n.d2c(i)}return a&&a.t&&a.t.posLetter===n._id&&("group"!==r.boxmode&&"group"!==r.violinmode||(i+=a.t.dPos)),i}function q(t){return t.offsetTop+t.clientTop}function G(t){return t.offsetLeft+t.clientLeft}function Y(t,e){var r=t._fullLayout,n=e.getBoundingClientRect(),i=n.x,a=n.y,s=i+n.width,l=a+n.height,c=o.apply3DTransform(r._invTransform)(i,a),u=o.apply3DTransform(r._invTransform)(s,l),f=c[0],h=c[1],p=u[0],d=u[1];return{x:f,y:h,width:p-f,height:d-h,top:Math.min(h,d),left:Math.min(f,p),right:Math.max(f,p),bottom:Math.max(h,d)}}},{"../../lib":787,"../../lib/events":776,"../../lib/override_cursor":798,"../../lib/svg_text_utils":813,"../../plots/cartesian/axes":838,"../../registry":915,"../color":650,"../dragelement":669,"../drawing":672,"../legend/defaults":702,"../legend/draw":703,"./constants":684,"./helpers":686,"@plotly/d3":58,"fast-isnumeric":246,tinycolor2:583}],688:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../color'),a=t('./helpers').isUnifiedHover;e.exports=function(t,e,r,o){function s(t){o.font[t]||(o.font[t]=e.legend?e.legend.font[t]:e.font[t])}o=o||{},e&&a(e.hovermode)&&(o.font||(o.font={}),s('size'),s('family'),s('color'),e.legend?(o.bgcolor||(o.bgcolor=i.combine(e.legend.bgcolor,e.paper_bgcolor)),o.bordercolor||(o.bordercolor=e.legend.bordercolor)):o.bgcolor||(o.bgcolor=e.paper_bgcolor)),r('hoverlabel.bgcolor',o.bgcolor),r('hoverlabel.bordercolor',o.bordercolor),r('hoverlabel.namelength',o.namelength),n.coerceFont(r,'hoverlabel.font',o.font),r('hoverlabel.align',o.align)}},{"../../lib":787,"../color":650,"./helpers":686}],689:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e){function r(r,a){return void 0!==e[r]?e[r]:n.coerce(t,e,i,r,a)}return r('clickmode'),r('hovermode')}},{"../../lib":787,"./layout_attributes":691}],690:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../dragelement'),o=t('./helpers'),s=t('./layout_attributes'),l=t('./hover');function c(t){var e=i.isD3Selection(t)?t:n.select(t);e.selectAll('g.hovertext').remove(),e.selectAll('.spikeline').remove()}function u(t,e,r){return i.castOption(t,e,"hoverlabel."+r)}function f(t,e,r){function n(r){return i.coerceHoverinfo({hoverinfo:r},{_module:t._module},e)}return i.castOption(t,r,'hoverinfo',n)}e.exports={moduleType:"component",name:"fx",constants:t('./constants'),schema:{layout:s},attributes:t('./attributes'),layoutAttributes:s,supplyLayoutGlobalDefaults:t('./layout_global_defaults'),supplyDefaults:t('./defaults'),supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc'),getDistanceFunction:o.getDistanceFunction,getClosest:o.getClosest,inbox:o.inbox,quadrature:o.quadrature,appendArrayPointValue:o.appendArrayPointValue,castHoverOption:u,castHoverinfo:f,hover:l.hover,unhover:a.unhover,loneHover:l.loneHover,loneUnhover:c,click:t('./click')}},{"../../lib":787,"../dragelement":669,"./attributes":681,"./calc":682,"./click":683,"./constants":684,"./defaults":685,"./helpers":686,"./hover":687,"./layout_attributes":691,"./layout_defaults":692,"./layout_global_defaults":693,"@plotly/d3":58}],691:[function(t,e,r){"use strict";var n=t('./constants'),i=t('../../plots/font_attributes')({editType:"none"});i.family.dflt=n.HOVERFONT,i.size.dflt=n.HOVERFONTSIZE,e.exports={clickmode:{valType:"flaglist",flags:["event","select"],dflt:"event",editType:"plot",extras:["none"]},dragmode:{valType:"enumerated",values:["zoom",'pan','select','lasso','drawclosedpath','drawopenpath','drawline','drawrect','drawcircle','orbit','turntable',!1],dflt:"zoom",editType:"modebar"},hovermode:{valType:"enumerated",values:["x",'y','closest',!1,'x unified',"y unified"],dflt:"closest",editType:"modebar"},hoverdistance:{valType:"integer",min:-1,dflt:20,editType:"none"},spikedistance:{valType:"integer",min:-1,dflt:-1,editType:"none"},hoverlabel:{bgcolor:{valType:"color",editType:"none"},bordercolor:{valType:"color",editType:"none"},font:i,align:{valType:"enumerated",values:["left",'right',"auto"],dflt:"auto",editType:"none"},namelength:{valType:"integer",min:-1,dflt:15,editType:"none"},editType:"none"},selectdirection:{valType:"enumerated",values:["h",'v','d',"any"],dflt:"any",editType:"none"}}},{"../../plots/font_attributes":867,"./constants":684}],692:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes'),a=t('./hovermode_defaults'),o=t('./hoverlabel_defaults');e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}a(t,e)&&(r('hoverdistance'),r('spikedistance')),"select"===r('dragmode')&&r('selectdirection');var s=e._has('mapbox'),l=e._has('geo'),c=e._basePlotModules.length;"zoom"===e.dragmode&&((s||l)&&1===c||s&&l&&2===c)&&(e.dragmode='pan'),o(t,e,r)}},{"../../lib":787,"./hoverlabel_defaults":688,"./hovermode_defaults":689,"./layout_attributes":691}],693:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./hoverlabel_defaults'),a=t('./layout_attributes');e.exports=function(t,e){function r(r,i){return n.coerce(t,e,a,r,i)}i(t,e,r)}},{"../../lib":787,"./hoverlabel_defaults":688,"./layout_attributes":691}],694:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../lib/regex').counter,a=t('../../plots/domain').attributes,o=t('../../plots/cartesian/constants').idRegex,s=t('../../plot_api/plot_template'),l={rows:{valType:"integer",min:1,editType:"plot"},roworder:{valType:"enumerated",values:["top to bottom","bottom to top"],dflt:"top to bottom",editType:"plot"},columns:{valType:"integer",min:1,editType:"plot"},subplots:{valType:"info_array",freeLength:!0,dimensions:2,items:{valType:"enumerated",values:[i('xy').toString(),""],editType:"plot"},editType:"plot"},xaxes:{valType:"info_array",freeLength:!0,items:{valType:"enumerated",values:[o.x.toString(),""],editType:"plot"},editType:"plot"},yaxes:{valType:"info_array",freeLength:!0,items:{valType:"enumerated",values:[o.y.toString(),""],editType:"plot"},editType:"plot"},pattern:{valType:"enumerated",values:["independent","coupled"],dflt:"coupled",editType:"plot"},xgap:{valType:"number",min:0,max:1,editType:"plot"},ygap:{valType:"number",min:0,max:1,editType:"plot"},domain:a({name:"grid",editType:"plot",noGridCell:!0},{}),xside:{valType:"enumerated",values:["bottom",'bottom plot','top plot',"top"],dflt:"bottom plot",editType:"plot"},yside:{valType:"enumerated",values:["left",'left plot','right plot',"right"],dflt:"left plot",editType:"plot"},editType:"plot"};function c(t,e,r){var n=e[r+"axes"],i=Object.keys((t._splomAxes||{})[r]||{});return Array.isArray(n)?n:i.length?i:void 0}function u(t,e)[var r=t.grid||{],i=c(e,r,'x'),a=c(e,r,'y');if(t.grid||i||a){var o,u,h=Array.isArray(r.subplots)&&Array.isArray(r.subplots[0]),p=Array.isArray(i),d=Array.isArray(a),m=p&&i!==r.xaxes&&d&&a!==r.yaxes;h?(o=r.subplots.length,u=r.subplots[0].length):(d&&(o=a.length),p&&(u=i.length));var g=s.newContainer(e,'grid'),v=k('rows',o),y=k('columns',u);if(v*y>1){h||p||d||"independent"===k('pattern')&&(h=!0),g._hasSubplotGrid=h;var x,b,_="top to bottom"===k('roworder'),w=h?.2:.1,T=h?.3:.1;m&&e._splomGridDflt&&(x=e._splomGridDflt.xside,b=e._splomGridDflt.yside),g._domains={x:f('x',k,w,x,y),y:f('y',k,T,b,v,_)}}else delete e.grid}function k(t,e){return n.coerce(r,g,l,t,e)}}function f(t,e,r,n,i,a){var o=e(t+"gap",r),s=e("domain."+t);e(t+"side",n);for(var l=new Array(i),c=s[0],u=(s[1]-c)/(i-o),f=u*(1-o),h=0;h<i;h++){var p=c+u*h;l[a?i-1-h:h]=[p,p+f]}return l}function h(t,e){var r=e.grid;if(r&&r._domains){var n,i,a,o,s,l,u,f=t.grid||{},h=e._subplots,d=r._hasSubplotGrid,m=r.rows,g=r.columns,v="independent"===r.pattern,y=r._axisMap={};if(d){var x=f.subplots||[];l=r.subplots=new Array(m);var b=1;for(n=0;n<m;n++){var _=l[n]=new Array(g),w=x[n]||[];for(i=0;i<g;i++)if(v?(s=1===b?"xy":"x"+b+"y"+b,b++):s=w[i],_[i]='',-1!==h.cartesian.indexOf(s)){if(u=s.indexOf('y'),a=s.slice(0,u),o=s.slice(u),void 0!==y[a]&&y[a]!==i||void 0!==y[o]&&y[o]!==n)continue;_[i]=s,y[a]=i,y[o]=n}}}else{var T=c(e,f,'x'),k=c(e,f,'y');r.xaxes=p(T,h.xaxis,g,y,'x'),r.yaxes=p(k,h.yaxis,m,y,'y')}var M=r._anchors={},A="top to bottom"===r.roworder;for(var S in y){var E,L,C,P=S.charAt(0),I=r[P+"side"];if(I.length<8)M[S]='free';else if("x"===P){if("t"===I.charAt(0)===A?(E=0,L=1,C=m):(E=m-1,L=-1,C=-1),d){var z=y[S];for(n=E;n!==C;n+=L)if((s=l[n][z])&&(u=s.indexOf('y'),s.slice(0,u)===S)){M[S]=s.slice(u);break}}else for(n=E;n!==C;n+=L)if(o=r.yaxes[n],-1!==h.cartesian.indexOf(S+o)){M[S]=o;break}}else if("l"===I.charAt(0)?(E=0,L=1,C=g):(E=g-1,L=-1,C=-1),d){var O=y[S];for(n=E;n!==C;n+=L)if((s=l[O][n])&&(u=s.indexOf('y'),s.slice(u)===S)){M[S]=s.slice(0,u);break}}else for(n=E;n!==C;n+=L)if(a=r.xaxes[n],-1!==h.cartesian.indexOf(a+S)){M[S]=a;break}}}}function p(t,e,r,n,i){var a,o=new Array(r);function s(t,r){-1!==e.indexOf(r)&&void 0===n[r]?(o[t]=r,n[r]=t):o[t]=""}if(Array.isArray(t))for(a=0;a<r;a++)s(a,t[a]);else for(s(0,i),a=1;a<r;a++)s(a,i+(a+1));return o}e.exports={moduleType:"component",name:"grid",schema:{layout:{grid:l}},layoutAttributes:l,sizeDefaults:u,contentDefaults:h}},{"../../lib":787,"../../lib/regex":804,"../../plot_api/plot_template":827,"../../plots/cartesian/constants":845,"../../plots/domain":866}],695:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/constants'),i=t('../../plot_api/plot_template').templatedArray;t('../../constants/axis_placeable_objects'),e.exports=i('image',{visible:{valType:"boolean",dflt:!0,editType:"arraydraw"},source:{valType:"string",editType:"arraydraw"},layer:{valType:"enumerated",values:["below","above"],dflt:"above",editType:"arraydraw"},sizex:{valType:"number",dflt:0,editType:"arraydraw"},sizey:{valType:"number",dflt:0,editType:"arraydraw"},sizing:{valType:"enumerated",values:["fill",'contain',"stretch"],dflt:"contain",editType:"arraydraw"},opacity:{valType:"number",min:0,max:1,dflt:1,editType:"arraydraw"},x:{valType:"any",dflt:0,editType:"arraydraw"},y:{valType:"any",dflt:0,editType:"arraydraw"},xanchor:{valType:"enumerated",values:["left",'center',"right"],dflt:"left",editType:"arraydraw"},yanchor:{valType:"enumerated",values:["top",'middle',"bottom"],dflt:"top",editType:"arraydraw"},xref:{valType:"enumerated",values:["paper",n.idRegex.x.toString()],dflt:"paper",editType:"arraydraw"},yref:{valType:"enumerated",values:["paper",n.idRegex.y.toString()],dflt:"paper",editType:"arraydraw"},editType:"arraydraw"})},{"../../constants/axis_placeable_objects":756,"../../plot_api/plot_template":827,"../../plots/cartesian/constants":845}],696:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib/to_log_range');e.exports=function(t,e,r,a){e=e||{};var o="log"===r&&"linear"===e.type,s="linear"===r&&"log"===e.type;if(o||s)for(var l,c,u=t._fullLayout.images,f=e._id.charAt(0),h=0;h<u.length;h++)if(c="images["+h+"].",(l=u[h])[f+"ref"]===e._id){var p=l[f],d=l["size"+f],m=null,g=null;if(o){m=i(p,e.range);var v=d/Math.pow(10,m)/2;g=2*Math.log(v+Math.sqrt(1+v*v))/Math.LN10}else g=(m=Math.pow(10,p))*(Math.pow(10,d/2)-Math.pow(10,-d/2));n(m)?n(g)||(g=null):(m=null,g=null),a(c+f,m),a(c+"size"+f,g)}}},{"../../lib/to_log_range":815,"fast-isnumeric":246}],697:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../../plots/array_container_defaults'),o=t('./attributes'),s='images';function l(t,e,r){function a(r,i){return n.coerce(t,e,o,r,i)}var s=a('source');if(!a('visible',!!s))return e;a('layer'),a('xanchor'),a('yanchor'),a('sizex'),a('sizey'),a('sizing'),a('opacity');for(var l={_fullLayout:r},c=["x","y"],u=0;u<2;u++){var f=c[u],h=i.coerceRef(t,e,l,f,'paper',void 0);"paper"!==h&&i.getFromId(l,h)._imgIndices.push(e._index),i.coercePosition(e,l,a,h,f,0)}return e}e.exports=function(t,e){a(t,e,{name:s,handleItemDefaults:l})}},{"../../lib":787,"../../plots/array_container_defaults":833,"../../plots/cartesian/axes":838,"./attributes":695}],698:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../drawing'),a=t('../../plots/cartesian/axes'),o=t('../../plots/cartesian/axis_ids'),s=t('../../constants/xmlns_namespaces');e.exports=function(t){var e,r,l=t._fullLayout,c=[],u={},f=[];for(r=0;r<l.images.length;r++){var h=l.images[r];if(h.visible)if("below"===h.layer&&"paper"!==h.xref&&"paper"!==h.yref){e=o.ref2id(h.xref)+o.ref2id(h.yref);var p=l._plots[e];if(!p){f.push(h);continue}p.mainplot&&(e=p.mainplot.id),u[e]||(u[e]=[]),u[e].push(h)}else"above"===h.layer?c.push(h):f.push(h)}var d={x:{left:{sizing:"xMin",offset:0},center:{sizing:"xMid",offset:-.5},right:{sizing:"xMax",offset:-1}},y:{top:{sizing:"YMin",offset:0},middle:{sizing:"YMid",offset:-.5},bottom:{sizing:"YMax",offset:-1}}};function m(e){var r=n.select(this);if(this._imgSrc!==e.source)if(r.attr('xmlns',s.svg),e.source&&"data:"===e.source.slice(0,5))r.attr('xlink:href',e.source),this._imgSrc=e.source;else{var i=new Promise(function(t){var n=new Image;function i(){r.remove(),t()}this.img=n,n.setAttribute('crossOrigin','anonymous'),n.onerror=i,n.onload=function(){var e=document.createElement('canvas');e.width=this.width,e.height=this.height,e.getContext('2d').drawImage(this,0,0);var n=e.toDataURL('image/png');r.attr('xlink:href',n),t()},r.on('error',i),n.src=e.source,this._imgSrc=e.source}.bind(this));t._promises.push(i)}}function g(e){var r,o,s=n.select(this),c=a.getFromId(t,e.xref),u=a.getFromId(t,e.yref),f="domain"===a.getRefType(e.xref),h="domain"===a.getRefType(e.yref),p=l._size;r=void 0!==c?"string"===typeof e.xref&&f?c._length*e.sizex:Math.abs(c.l2p(e.sizex)-c.l2p(0)):e.sizex*p.w,o=void 0!==u?"string"===typeof e.yref&&h?u._length*e.sizey:Math.abs(u.l2p(e.sizey)-u.l2p(0)):e.sizey*p.h;var m,g,v=r*d.x[e.xanchor].offset,y=o*d.y[e.yanchor].offset,x=d.x[e.xanchor].sizing+d.y[e.yanchor].sizing;switch(m=void 0!==c?"string"===typeof e.xref&&f?c._length*e.x+c._offset:c.r2p(e.x)+c._offset:e.x*p.w+p.l,m+=v,g=void 0!==u?"string"===typeof e.yref&&h?u._length*(1-e.y)+u._offset:u.r2p(e.y)+u._offset:p.h-e.y*p.h+p.t,g+=y,e.sizing){case"fill":x+=' slice';break;case"stretch":x="none"}s.attr({x:m,y:g,width:r,height:o,preserveAspectRatio:x,opacity:e.opacity});var b=(c&&"domain"!==a.getRefType(e.xref)?c._id:"")+(u&&"domain"!==a.getRefType(e.yref)?u._id:"");i.setClipUrl(s,b?"clip"+l._uid+b:null,t)}var v=l._imageLowerLayer.selectAll('image').data(f),y=l._imageUpperLayer.selectAll('image').data(c);v.enter().append('image'),y.enter().append('image'),v.exit().remove(),y.exit().remove(),v.each((function(t){m.bind(this)(t),g.bind(this)(t)})),y.each((function(t){m.bind(this)(t),g.bind(this)(t)}));var x=Object.keys(l._plots);for(r=0;r<x.length;r++){e=x[r];var b=l._plots[e];if(b.imagelayer){var _=b.imagelayer.selectAll('image').data(u[e]||[]);_.enter().append('image'),_.exit().remove(),_.each((function(t){m.bind(this)(t),g.bind(this)(t)}))}}}},{"../../constants/xmlns_namespaces":764,"../../plots/cartesian/axes":838,"../../plots/cartesian/axis_ids":842,"../drawing":672,"@plotly/d3":58}],699:[function(t,e,r){"use strict";e.exports={moduleType:"component",name:"images",layoutAttributes:t('./attributes'),supplyLayoutDefaults:t('./defaults'),includeBasePlot:t('../../plots/cartesian/include_components')('images'),draw:t('./draw'),convertCoords:t('./convert_coords')}},{"../../plots/cartesian/include_components":851,"./attributes":695,"./convert_coords":696,"./defaults":697,"./draw":698}],700:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('../color/attributes');e.exports={bgcolor:{valType:"color",editType:"legend"},bordercolor:{valType:"color",dflt:i.defaultLine,editType:"legend"},borderwidth:{valType:"number",min:0,dflt:0,editType:"legend"},font:n({editType:"legend"}),orientation:{valType:"enumerated",values:["v","h"],dflt:"v",editType:"legend"},traceorder:{valType:"flaglist",flags:["reversed","grouped"],extras:["normal"],editType:"legend"},tracegroupgap:{valType:"number",min:0,dflt:10,editType:"legend"},itemsizing:{valType:"enumerated",values:["trace","constant"],dflt:"trace",editType:"legend"},itemwidth:{valType:"number",min:30,dflt:30,editType:"legend"},itemclick:{valType:"enumerated",values:["toggle",'toggleothers',!1],dflt:"toggle",editType:"legend"},itemdoubleclick:{valType:"enumerated",values:["toggle",'toggleothers',!1],dflt:"toggleothers",editType:"legend"},groupclick:{valType:"enumerated",values:["toggleitem","togglegroup"],dflt:"togglegroup",editType:"legend"},x:{valType:"number",min:-2,max:3,editType:"legend"},xanchor:{valType:"enumerated",values:["auto",'left','center',"right"],dflt:"left",editType:"legend"},y:{valType:"number",min:-2,max:3,editType:"legend"},yanchor:{valType:"enumerated",values:["auto",'top','middle',"bottom"],editType:"legend"},uirevision:{valType:"any",editType:"none"},valign:{valType:"enumerated",values:["top",'middle',"bottom"],dflt:"middle",editType:"legend"},title:{text:{valType:"string",dflt:"",editType:"legend"},font:n({editType:"legend"}),side:{valType:"enumerated",values:["top",'left',"top left"],editType:"legend"},editType:"legend"},editType:"legend"}},{"../../plots/font_attributes":867,"../color/attributes":649}],701:[function(t,e,r){"use strict";e.exports={scrollBarWidth:6,scrollBarMinHeight:20,scrollBarColor:"#808BA4",scrollBarMargin:4,scrollBarEnterAttrs:{rx:20,ry:3,width:0,height:0},titlePad:2,itemGap:5}},{}],702:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../../plot_api/plot_template'),o=t('./attributes'),s=t('../../plots/layout_attributes'),l=t('./helpers');e.exports=function(t,e,r){for(var c=t.legend||{},u=0,f=!1,h='normal',p=0;p<r.length;p++){var d=r[p];d.visible&&((d.showlegend||d._dfltShowLegend&&!(d._module&&d._module.attributes&&d._module.attributes.showlegend&&!1===d._module.attributes.showlegend.dflt))&&(u++,d.showlegend&&(f=!0,(n.traceIs(d,'pie-like')||!0===d._input.showlegend)&&u++)),(n.traceIs(d,'bar')&&"stack"===e.barmode||-1!==["tonextx","tonexty"].indexOf(d.fill))&&(h=l.isGrouped({traceorder:h})?"grouped+reversed":"reversed"),void 0!==d.legendgroup&&""!==d.legendgroup&&(h=l.isReversed({traceorder:h})?"reversed+grouped":"grouped"))}var m=i.coerce(t,e,s,'showlegend',f&&u>1);if(!1!==m||c.uirevision){var g=a.newContainer(e,'legend');if(T('uirevision',e.uirevision),!1!==m){T('bgcolor',e.paper_bgcolor),T('bordercolor'),T('borderwidth');var v,y,x,b=i.coerceFont(T,'font',e.font),_="h"===T('orientation');if(_?(v=0,n.getComponentMethod('rangeslider','isVisible')(t.xaxis)?(y=1.1,x='bottom'):(y=-.1,x='top')):(v=1.02,y=1,x='auto'),T('traceorder',h),l.isGrouped(e.legend)&&T('tracegroupgap'),T('itemsizing'),T('itemwidth'),T('itemclick'),T('itemdoubleclick'),T('groupclick'),T('x',v),T('xanchor'),T('y',y),T('yanchor',x),T('valign'),i.noneOrAll(c,g,["x","y"]),T('title.text')){T('title.side',_?"left":"top");var w=i.extendFlat({},b,{size:i.bigFont(b.size)});i.coerceFont(T,'title.font',w)}}}function T(t,e){return i.coerce(c,g,o,t,e)}}},{"../../lib":787,"../../plot_api/plot_template":827,"../../plots/layout_attributes":892,"../../registry":915,"./attributes":700,"./helpers":706}],703:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../plots/plots'),o=t('../../registry'),s=t('../../lib/events'),l=t('../dragelement'),c=t('../drawing'),u=t('../color'),f=t('../../lib/svg_text_utils'),h=t('./handle_click'),p=t('./constants'),d=t('../../constants/alignment'),m=d.LINE_SPACING,g=d.FROM_TL,v=d.FROM_BR,y=t('./get_legend_data'),x=t('./style'),b=t('./helpers'),_=1;function w(t,e){var r,s=t._fullLayout,f="legend"+s._uid,h=e._inHover;if(h?(r=e.layer,f+='-hover'):r=s._infolayer,r){var d;if(t._legendMouseDownTime||(t._legendMouseDownTime=0),h){if(!e.entries)return;d=y(e.entries,e)}else{if(!t.calcdata)return;d=s.showlegend&&y(t.calcdata,e)}var m=s.hiddenlabels||[];if(!h&&(!s.showlegend||!d.length))return r.selectAll('.legend').remove(),s._topdefs.select("#"+f).remove(),a.autoMargin(t,'legend');var v=i.ensureSingle(r,'g','legend',(function(t){h||t.attr('pointer-events','all')})),b=i.ensureSingleById(s._topdefs,'clipPath',f,(function(t)[t.append('rect')])),w=i.ensureSingle(v,'rect','bg',(function(t){t.attr('shape-rendering','crispEdges')}));w.call(u.stroke,e.bordercolor).call(u.fill,e.bgcolor).style('stroke-width',e.borderwidth+"px");var M=i.ensureSingle(v,'g','scrollbox'),E=e.title;if(e._titleWidth=0,e._titleHeight=0,E.text){var L=i.ensureSingle(M,'text','legendtitletext');L.attr('text-anchor','start').call(c.font,E.font).text(E.text),S(L,M,t,e,_)}else M.selectAll('.legendtitletext').remove();var O=i.ensureSingle(v,'rect','scrollbar',(function(t){t.attr(p.scrollBarEnterAttrs).call(u.fill,p.scrollBarColor)})),D=M.selectAll('g.groups').data(d);D.enter().append('g').attr('class','groups'),D.exit().remove();var R=D.selectAll('g.traces').data(i.identity);R.enter().append('g').attr('class','traces'),R.exit().remove(),R.style('opacity',(function(t){var e=t[0].trace;return o.traceIs(e,'pie-like')?-1!==m.indexOf(t[0].label)?.5:1:"legendonly"===e.visible?.5:1})).each((function(){n.select(this).call(k,t,e)})).call(x,t,e).each((function(){h||n.select(this).call(A,t)})),i.syncOrAsync([a.previousPromises,function(){return C(t,D,R,e)},function(){if(h||!P(t)){var a,u,d,m,y=s._size,x=e.borderwidth,_=y.l+y.w*e.x-g[I(e)]*e._width,k=y.t+y.h*(1-e.y)-g[z(e)]*e._effHeight;if(!h&&s.margin.autoexpand){var A=_,S=k;_=i.constrain(_,0,s.width-e._width),k=i.constrain(k,0,s.height-e._effHeight),_!==A&&i.log('Constrain legend.x to make legend fit inside graph'),k!==S&&i.log('Constrain legend.y to make legend fit inside graph')}if(h||c.setTranslate(v,_,k),O.on('.drag',null),v.on('wheel',null),h||e._height<=e._maxHeight||t._context.staticPlot){var E=e._effHeight;h&&(E=e._height),w.attr({width:e._width-x,height:E-x,x:x/2,y:x/2}),c.setTranslate(M,0,0),b.select('rect').attr({width:e._width-2*x,height:E-2*x,x:x,y:x}),c.setClipUrl(M,f,t),c.setRect(O,0,0,0,0),delete e._scrollY}else{var L,C,D,R=Math.max(p.scrollBarMinHeight,e._effHeight*e._effHeight/e._height),F=e._effHeight-R-2*p.scrollBarMargin,B=e._height-e._effHeight,N=F/B,j=Math.min(e._scrollY||0,B);w.attr({width:e._width-2*x+p.scrollBarWidth+p.scrollBarMargin,height:e._effHeight-x,x:x/2,y:x/2}),b.select('rect').attr({width:e._width-2*x+p.scrollBarWidth+p.scrollBarMargin,height:e._effHeight-2*x,x:x,y:x+j}),c.setClipUrl(M,f,t),G(j,R,N),v.on('wheel',(function(){G(j=i.constrain(e._scrollY+n.event.deltaY/F*B,0,B),R,N),0!==j&&j!==B&&n.event.preventDefault()}));var U=function(t,e,r){var n=(r-e)/N+t;return i.constrain(n,0,B)},V=function(t,e,r){var n=(e-r)/N+t;return i.constrain(n,0,B)},H=n.behavior.drag().on('dragstart',(function(){var t=n.event.sourceEvent;L="touchstart"===t.type?t.changedTouches[0].clientY:t.clientY,D=j})).on('drag',(function(){var t=n.event.sourceEvent;2===t.buttons||t.ctrlKey||(C="touchmove"===t.type?t.changedTouches[0].clientY:t.clientY,G(j=U(D,L,C),R,N))}));O.call(H);var q=n.behavior.drag().on('dragstart',(function(){var t=n.event.sourceEvent;"touchstart"===t.type&&(L=t.changedTouches[0].clientY,D=j)})).on('drag',(function(){var t=n.event.sourceEvent;"touchmove"===t.type&&(C=t.changedTouches[0].clientY,G(j=V(D,L,C),R,N))}));M.call(q)}t._context.edits.legendPosition&&(v.classed('cursor-move',!0),l.init({element:v.node(),gd:t,prepFn:function(){var t=c.getTranslate(v);d=t.x,m=t.y},moveFn:function(t,r){var n=d+t,i=m+r;c.setTranslate(v,n,i),a=l.align(n,0,y.l,y.l+y.w,e.xanchor),u=l.align(i,0,y.t+y.h,y.t,e.yanchor)},doneFn:function(){void 0!==a&&void 0!==u&&o.call('_guiRelayout',t,{"legend.x":a,"legend.y":u})},clickFn:function(e,n){var i=r.selectAll('g.traces').filter((function(){var t=this.getBoundingClientRect();return n.clientX>=t.left&&n.clientX<=t.right&&n.clientY>=t.top&&n.clientY<=t.bottom}));i.size()>0&&T(t,v,i,e,n)}}))}function G(r,n,i){e._scrollY=t._fullLayout.legend._scrollY=r,c.setTranslate(M,0,-r),c.setRect(O,e._width,p.scrollBarMargin+r*i,p.scrollBarWidth,n),b.select('rect').attr('y',x+r)}}],t)}}function T(t,e,r,n,i){var a=r.data()[0][0].trace,l={event:i,node:r.node(),curveNumber:a.index,expandedIndex:a._expandedIndex,data:t.data,layout:t.layout,frames:t._transitionData._frames,config:t._context,fullData:t._fullData,fullLayout:t._fullLayout};a._group&&(l.group=a._group),o.traceIs(a,'pie-like')&&(l.label=r.datum()[0].label),!1!==s.triggerHandler(t,'plotly_legendclick',l)&&(1===n?e._clickTimeout=setTimeout((function(){t._fullLayout&&h(r,t,n)}),t._context.doubleClickDelay):2===n&&(e._clickTimeout&&clearTimeout(e._clickTimeout),t._legendMouseDownTime=0,!1!==s.triggerHandler(t,'plotly_legenddoubleclick',l)&&h(r,t,n)))}function k(t,e,r){var n,a,s=t.data()[0][0],l=s.trace,u=o.traceIs(l,'pie-like'),h=!r._inHover&&e._context.edits.legendText&&!u,d=r._maxNameLength;s.groupTitle?(n=s.groupTitle.text,a=s.groupTitle.font):(a=r.font,r.entries?n=s.text:(n=u?s.label:l.name,l._meta&&(n=i.templateString(n,l._meta))));var m=i.ensureSingle(t,'text','legendtext');m.attr('text-anchor','start').call(c.font,a).text(h?M(n,d):n);var g=r.itemwidth+2*p.itemGap;f.positionText(m,g,0),h?m.call(f.makeEditable,{gd:e,text:n}).call(S,t,e,r).on('edit',(function(n){this.text(M(n,d)).call(S,t,e,r);var a=s.trace._fullInput||{},c={};if(o.hasTransform(a,'groupby')){var u=o.getTransformIndices(a,'groupby'),f=u[u.length-1],h=i.keyedContainer(a,"transforms["+f+"].styles",'target','value.name');h.set(s.trace._group,n),c=h.constructUpdate()}else c.name=n;return o.call('_guiRestyle',e,c,l.index)})):S(m,t,e,r)}function M(t,e){var r=Math.max(4,e);if(t&&t.trim().length>=r/2)return t;for(var n=r-(t=t||"").length;n>0;n--)t+=' ';return t}function A(t,e){var r,a=e._context.doubleClickDelay,o=1,s=i.ensureSingle(t,'rect','legendtoggle',(function(t){e._context.staticPlot||t.style('cursor','pointer').attr('pointer-events','all'),t.call(u.fill,'rgba(0,0,0,0)')}));e._context.staticPlot||(s.on('mousedown',(function(){(r=(new Date).getTime())-e._legendMouseDownTime<a?o+=1:(o=1,e._legendMouseDownTime=r)})),s.on('mouseup',(function(){if(!e._dragged&&!e._editing){var r=e._fullLayout.legend;(new Date).getTime()-e._legendMouseDownTime>a&&(o=Math.max(o-1,1)),T(e,r,t,o,n.event)}})))}function S(t,e,r,n,i){n._inHover&&t.attr('data-notex',!0),f.convertToTspans(t,r,(function(){E(e,r,n,i)}))}function E(t,e,r,n){var i=t.data()[0][0];if(r._inHover||!i||i.trace.showlegend){var a=t.select('g[class*=math-group]'),o=a.node();r||(r=e._fullLayout.legend);var s,l,u=r.borderwidth,h=(n===_?r.title.font:i.groupTitle?i.groupTitle.font:r.font).size*m;if(o){var d=c.bBox(o);s=d.height,l=d.width,n===_?c.setTranslate(a,u,u+.75*s):c.setTranslate(a,0,.25*s)}else{var g=t.select(n===_?".legendtitletext":".legendtext"),v=f.lineCount(g),y=g.node();if(s=h*v,l=y?c.bBox(y).width:0,n===_)"left"===r.title.side&&(l+=2*p.itemGap),f.positionText(g,u+p.titlePad,u+h);else{var x=2*p.itemGap+r.itemwidth;i.groupTitle&&(x=p.itemGap,l-=r.itemwidth),f.positionText(g,x,-h*((v-1)/2-.3))}}n===_?(r._titleWidth=l,r._titleHeight=s):(i.lineHeight=h,i.height=Math.max(s,16)+3,i.width=l)}else t.remove()}function L(t){var e=0,r=0,n=t.title.side;return n&&(-1!==n.indexOf('left')&&(e=t._titleWidth),-1!==n.indexOf('top')&&(r=t._titleHeight)),[e,r]}function C(t,e,r,i){var a=t._fullLayout;i||(i=a.legend);var o=a._size,s=b.isVertical(i),l=b.isGrouped(i),u=i.borderwidth,f=2*u,h=p.itemGap,d=i.itemwidth+2*h,m=2*(u+h),g=z(i),v=i.y<0||0===i.y&&"top"===g,y=i.y>1||1===i.y&&"bottom"===g,x=i.tracegroupgap;i._maxHeight=Math.max(v||y?a.height/2:o.h,30);var _=0;i._width=0,i._height=0;var w=L(i);if(s)r.each((function(t){var e=t[0].height;c.setTranslate(this,u+w[0],u+w[1]+i._height+e/2+h),i._height+=e,i._width=Math.max(i._width,t[0].width)})),_=d+i._width,i._width+=h+d+f,i._height+=m,l&&(e.each((function(t,e){c.setTranslate(this,0,e*i.tracegroupgap)})),i._height+=(i._lgroupsLength-1)*i.tracegroupgap);else{var T=I(i),k=i.x<0||0===i.x&&"right"===T,M=i.x>1||1===i.x&&"left"===T,A=y||v,S=a.width/2;i._maxWidth=Math.max(k?A&&"left"===T?o.l+o.w:S:M?A&&"right"===T?o.r+o.w:S:o.w,2*d);var E=0,C=0;r.each((function(t){var e=t[0].width+d;E=Math.max(E,e),C+=e})),_=null;var P=0;if(l){var O=0,D=0,R=0;e.each((function(){var t=0,e=0;n.select(this).selectAll('g.traces').each((function(r){var n=r[0].height;c.setTranslate(this,w[0],w[1]+u+h+n/2+e),e+=n,t=Math.max(t,d+r[0].width)})),O=Math.max(O,e);var r=t+h;r+u+D>i._maxWidth&&(P=Math.max(P,D),D=0,R+=O+x,O=e),c.setTranslate(this,D,R),D+=r})),i._width=Math.max(P,D)+u,i._height=R+O+m}else{var F=r.size(),B=C+f+(F-1)*h<i._maxWidth,N=0,j=0,U=0,V=0;r.each((function(t){var e=t[0].height,r=d+t[0].width,n=(B?r:E)+h;n+u+j-h>=i._maxWidth&&(P=Math.max(P,V),j=0,U+=N,i._height+=N,N=0),c.setTranslate(this,w[0]+u+j,w[1]+u+U+e/2+h),V=j+r+h,j+=n,N=Math.max(N,e)})),B?(i._width=j+f,i._height=N+m):(i._width=Math.max(P,V)+f,i._height+=N+m)}}i._width=Math.ceil(Math.max(i._width+w[0],i._titleWidth+2*(u+p.titlePad))),i._height=Math.ceil(Math.max(i._height+w[1],i._titleHeight+2*(u+p.itemGap))),i._effHeight=Math.min(i._height,i._maxHeight);var H=t._context.edits,q=H.legendText||H.legendPosition;r.each((function(t){var e=n.select(this).select('.legendtoggle'),r=t[0].height,i=q?d:_||d+t[0].width;s||(i+=h/2),c.setRect(e,0,-r/2,i,r)}))}function P(t){var e=t._fullLayout.legend,r=I(e),n=z(e);return a.autoMargin(t,'legend',{x:e.x,y:e.y,l:e._width*g[r],r:e._width*v[r],b:e._effHeight*v[n],t:e._effHeight*g[n]})}function I(t){return i.isRightAnchor(t)?"right":i.isCenterAnchor(t)?"center":"left"}function z(t){return i.isBottomAnchor(t)?"bottom":i.isMiddleAnchor(t)?"middle":"top"}e.exports=function(t,e){return e||(e=t._fullLayout.legend||{}),w(t,e)}},{"../../constants/alignment":755,"../../lib":787,"../../lib/events":776,"../../lib/svg_text_utils":813,"../../plots/plots":901,"../../registry":915,"../color":650,"../dragelement":669,"../drawing":672,"./constants":701,"./get_legend_data":704,"./handle_click":705,"./helpers":706,"./style":708,"@plotly/d3":58}],704:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('./helpers');e.exports=function(t,e){var r,a,o=e._inHover,s=i.isGrouped(e),l=i.isReversed(e),c={},u=[],f=!1,h={},p=0,d=0;function m(t,r){if(""!==t&&i.isGrouped(e))-1===u.indexOf(t)?(u.push(t),f=!0,c[t]=[r]):c[t].push(r);else{var n="~~i"+p;u.push(n),c[n]=[r],p++}}for(r=0;r<t.length;r++){var g=t[r],v=g[0],y=v.trace,x=y.legendgroup;if(o||y.visible&&y.showlegend)if(n.traceIs(y,'pie-like'))for(h[x]||(h[x]={}),a=0;a<g.length;a++){var b=g[a].label;h[x][b]||(m(x,{label:b,color:g[a].color,i:g[a].i,trace:y,pts:g[a].pts}),h[x][b]=!0,d=Math.max(d,(b||"").length))}else m(x,v),d=Math.max(d,(y.name||"").length)}if(!u.length)return[];var _=!f||!s,w=[];for(r=0;r<u.length;r++){var T=c[u[r]];_?w.push(T[0]):w.push(T)}for(_&&(w=[w]),r=0;r<w.length;r++){var k=1/0;for(a=0;a<w[r].length;a++){var M=w[r][a].trace.legendrank;k>M&&(k=M)}w[r][0]._groupMinRank=k,w[r][0]._preGroupSort=r}var A=function(t,e){return t[0]._groupMinRank-e[0]._groupMinRank||t[0]._preGroupSort-e[0]._preGroupSort},S=function(t,e){return t.trace.legendrank-e.trace.legendrank||t._preSort-e._preSort};for(w.forEach((function(t,e)[t[0]._preGroupSort=e])),w.sort(A),r=0;r<w.length;r++){w[r].forEach((function(t,e){t._preSort=e})),w[r].sort(S);var E=w[r][0].trace,L=null;for(a=0;a<w[r].length;a++){var C=w[r][a].trace.legendgrouptitle;if(C&&C.text){L=C,o&&(C.font=e._groupTitleFont);break}}if(l&&w[r].reverse(),L){var P=!1;for(a=0;a<w[r].length;a++)if(n.traceIs(w[r][a].trace,'pie-like')){P=!0;break}w[r].unshift({i:-1,groupTitle:L,noClick:P,trace:{showlegend:E.showlegend,legendgroup:E.legendgroup,visible:"toggleitem"===e.groupclick||E.visible}})}for(a=0;a<w[r].length;a++)w[r][a]=[w[r][a]]}return e._lgroupsLength=w.length,e._maxNameLength=d,w}},{"../../registry":915,"./helpers":706}],705:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry'),a=!0;e.exports=function(t,e,r){var o=e._fullLayout;if(!e._dragged&&!e._editing){var s,l=o.legend.itemclick,c=o.legend.itemdoubleclick,u=o.legend.groupclick;if(1===r&&"toggle"===l&&"toggleothers"===c&&a&&e.data&&e._context.showTips?(n.notifier(n._(e,'Double-click on legend to isolate one trace'),'long'),a=!1):a=!1,1===r?s=l:2===r&&(s=c),s){var f="togglegroup"===u,h=o.hiddenlabels?o.hiddenlabels.slice():[],p=t.data()[0][0];if(!p.groupTitle||!p.noClick){var d,m,g,v,y,x=e._fullData,b=p.trace,_=b.legendgroup,w={},T=[],k=[],M=[];if(i.traceIs(b,'pie-like')){var A=p.label,S=h.indexOf(A);"toggle"===s?-1===S?h.push(A):h.splice(S,1):"toggleothers"===s&&(h=[],e.calcdata[0].forEach((function(t){A!==t.label&&h.push(t.label)})),e._fullLayout.hiddenlabels&&e._fullLayout.hiddenlabels.length===h.length&&-1===S&&(h=[])),i.call('_guiRelayout',e,'hiddenlabels',h)}else{var E,L=_&&_.length,C=[];if(L)for(d=0;d<x.length;d++)(E=x[d]).visible&&E.legendgroup===_&&C.push(d);if("toggle"===s){var P;switch(b.visible){case!0:P='legendonly';break;case!1:P=!1;break;case"legendonly":P=!0}if(L)if(f)for(d=0;d<x.length;d++)!1!==x[d].visible&&x[d].legendgroup===_&&j(x[d],P);else j(b,P);else j(b,P)}else if("toggleothers"===s){var I,z,O,D,R=!0;for(d=0;d<x.length;d++)if(I=x[d]===b,O=!0!==x[d].showlegend,!I&&!O&&!(z=L&&x[d].legendgroup===_)&&!0===x[d].visible&&!i.traceIs(x[d],'notLegendIsolatable')){R=!1;break}for(d=0;d<x.length;d++)if(!1!==x[d].visible&&!i.traceIs(x[d],'notLegendIsolatable'))switch(b.visible){case"legendonly":j(x[d],!0);break;case!0:D=!!R||"legendonly",I=x[d]===b,O=!0!==x[d].showlegend&&!x[d].legendgroup,z=I||L&&x[d].legendgroup===_,j(x[d],!(!z&&!O)||D)}}for(d=0;d<k.length;d++)if(g=k[d]){var F=g.constructUpdate(),B=Object.keys(F);for(m=0;m<B.length;m++)v=B[m],(w[v]=w[v]||[])[M[d]]=F[v]}for(y=Object.keys(w),d=0;d<y.length;d++)for(v=y[d],m=0;m<T.length;m++)w[v].hasOwnProperty(m)||(w[v][m]=void 0);i.call('_guiRestyle',e,w,T)}}}}function N(t,e,r){var n=T.indexOf(t),i=w[e];return i||(i=w[e]=[]),-1===T.indexOf(t)&&(T.push(t),n=T.length-1),i[n]=r,n}function j(t,e){if(!p.groupTitle||f){var r=t._fullInput;if(i.hasTransform(r,'groupby')){var a=k[r.index];if(!a){var o=i.getTransformIndices(r,'groupby'),s=o[o.length-1];a=n.keyedContainer(r,"transforms["+s+"].styles",'target','value.visible'),k[r.index]=a}var l=a.get(t._group);void 0===l&&(l=!0),!1!==l&&a.set(t._group,e),M[r.index]=N(r.index,'visible',!1!==r.visible)}else{var c=!1!==r.visible&&e;N(r.index,'visible',c)}}}}},{"../../lib":787,"../../registry":915}],706:[function(t,e,r){"use strict";r.isGrouped=function(t){return-1!==(t.traceorder||"").indexOf('grouped')},r.isVertical=function(t){return"h"!==t.orientation},r.isReversed=function(t){return-1!==(t.traceorder||"").indexOf('reversed')}},{}],707:[function(t,e,r){"use strict";e.exports={moduleType:"component",name:"legend",layoutAttributes:t('./attributes'),supplyLayoutDefaults:t('./defaults'),draw:t('./draw'),style:t('./style')}},{"./attributes":700,"./defaults":702,"./draw":703,"./style":708}],708:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../lib'),o=a.strTranslate,s=t('../drawing'),l=t('../color'),c=t('../colorscale/helpers').extractOpts,u=t('../../traces/scatter/subtypes'),f=t('../../traces/pie/style_one'),h=t('../../traces/pie/helpers').castOption,p=t('./constants'),d=12,m=5,g=2,v=10,y=5;function x(t,e){return(e?"radial":"horizontal")+(t?"":"reversed")}function b(t){var e=t[0].trace,r=e.contours,n=u.hasLines(e),i=u.hasMarkers(e),a=e.visible&&e.fill&&"none"!==e.fill,o=!1,s=!1;if(r){var l=r.coloring;"lines"===l?o=!0:n="none"===l||"heatmap"===l||r.showlines,"constraint"===r.type?a="="!==r._operation:"fill"!==l&&"heatmap"!==l||(s=!0)}return{showMarker:i,showLine:n,showFill:a,showGradientLine:o,showGradientFill:s,anyLine:n||o,anyFill:a||s}}function _(t,e,r){return t&&a.isArrayOrTypedArray(t)?e:t>r?r:t}e.exports=function(t,e,r){var w=e._fullLayout;r||(r=w.legend);var T="constant"===r.itemsizing,k=r.itemwidth,M=(k+2*p.itemGap)/2,A=o(M,0),S=function(t,e,r,n){var i;if(t+1)i=t;else{if(!(e&&e.width>0))return 0;i=e.width}return T?n:Math.min(i,r)};function E(t){var r,i,o=b(t),l=o.showFill,f=o.showLine,h=o.showGradientLine,p=o.showGradientFill,d=o.anyFill,g=o.anyLine,y=t[0],_=y.trace,w=c(_),T=w.colorscale,M=w.reversescale,A=function(t){if(t.size()){var r="legendfill-"+_.uid;s.gradient(t,e,r,x(M),T,'fill')}},E=function(t){if(t.size()){var r="legendline-"+_.uid;s.lineGroupStyle(t),s.gradient(t,e,r,x(M),T,'stroke')}},L=u.hasMarkers(_)||!d?"M5,0":g?"M5,-2":"M5,-3",C=n.select(this),P=C.select('.legendfill').selectAll('path').data(l||p?[t]:[]);if(P.enter().append('path').classed('js-fill',!0),P.exit().remove(),P.attr('d',L+"h"+k+"v6h-"+k+"z").call(l?s.fillGroupStyle:A),f||h){var I=S(void 0,_.line,v,m);i=a.minExtend(_,{line:{width:I}}),r=[a.minExtend(y,{trace:i})]}var z=C.select('.legendlines').selectAll('path').data(f||h?[r]:[]);z.enter().append('path').classed('js-line',!0),z.exit().remove(),z.attr('d',L+(h?"l"+k+",0.0001":"h"+k)).call(f?s.lineGroupStyle:E)}function L(t){var r,i,o=b(t),l=o.anyFill,c=o.anyLine,f=o.showLine,h=o.showMarker,p=t[0],v=p.trace,y=!h&&!c&&!l&&u.hasText(v);function x(t,e,r,n){var i=a.nestedProperty(v,t).get(),o=a.isArrayOrTypedArray(i)&&e?e(i):i;if(T&&o&&void 0!==n&&(o=n),r){if(o<r[0])return r[0];if(o>r[1])return r[1]}return o}function _(t){return p._distinct&&p.index&&t[p.index]?t[p.index]:t[0]}if(h||y||f)[var w={],k={};if(h){w.mc=x('marker.color',_),w.mx=x('marker.symbol',_),w.mo=x('marker.opacity',a.mean,[.2,1]),w.mlc=x('marker.line.color',_),w.mlw=x('marker.line.width',a.mean,[0,5],g),k.marker={sizeref:1,sizemin:1,sizemode:"diameter"};var M=x('marker.size',a.mean,[2,16],d);w.ms=M,k.marker.size=M}f&&(k.line={width:x('line.width',_,[0,10],m)}),y&&(w.tx='Aa',w.tp=x('textposition',_),w.ts=10,w.tc=x('textfont.color',_),w.tf=x('textfont.family',_)),r=[a.minExtend(p,w)],(i=a.minExtend(v,k)).selectedpoints=null,i.texttemplate=null}var S=n.select(this).select('g.legendpoints'),E=S.selectAll('path.scatterpts').data(h?r:[]);E.enter().insert('path',':first-child').classed('scatterpts',!0).attr('transform',A),E.exit().remove(),E.call(s.pointStyle,i,e),h&&(r[0].mrc=3);var L=S.selectAll('g.pointtext').data(y?r:[]);L.enter().append('g').classed('pointtext',!0).append('text').attr('transform',A),L.exit().remove(),L.selectAll('text').call(s.textPointStyle,i,e)}function C(t){var e=t[0].trace,r="waterfall"===e.type;if(t[0]._distinct&&r){var i=t[0].trace[t[0].dir].marker;return t[0].mc=i.color,t[0].mlw=i.line.width,t[0].mlc=i.line.color,z(t,this,'waterfall')}var a=[];e.visible&&r&&(a=t[0].hasTotals?[["increasing","M-6,-6V6H0Z"],["totals","M6,6H0L-6,-6H-0Z"],["decreasing","M6,6V-6H0Z"]]:[["increasing","M-6,-6V6H6Z"],["decreasing","M6,6V-6H-6Z"]]);var o=n.select(this).select('g.legendpoints').selectAll('path.legendwaterfall').data(a);o.enter().append('path').classed('legendwaterfall',!0).attr('transform',A).style('stroke-miterlimit',1),o.exit().remove(),o.each((function(t){var r=n.select(this),i=e[t[0]].marker,a=S(void 0,i.line,y,g);r.attr('d',t[1]).style('stroke-width',a+"px").call(l.fill,i.color),a&&r.call(l.stroke,i.line.color)}))}function P(t){z(t,this)}function I(t){z(t,this,'funnel')}function z(t,a,o){var u=t[0].trace,f=u.marker||{},h=f.line||{},p=o?u.visible&&u.type===o:i.traceIs(u,'bar'),d=n.select(a).select('g.legendpoints').selectAll("path.legend"+o).data(p?[t]:[]);d.enter().append('path').classed("legend"+o,!0).attr('d','M6,6H-6V-6H6Z').attr('transform',A),d.exit().remove(),d.each((function(t){var i=n.select(this),a=t[0],o=S(a.mlw,f.line,y,g);i.style('stroke-width',o+"px");var p=a.mcc;if(!r._inHover&&"mc"in a){var d=c(f),m=d.mid;void 0===m&&(m=(d.max+d.min)/2),p=s.tryColorscale(f,'')(m)}var v=p||a.mc||f.color,x=f.pattern,b=x&&s.getPatternAttr(x.shape,0,'');if(b){var w=s.getPatternAttr(x.bgcolor,0,null),T=s.getPatternAttr(x.fgcolor,0,null),k=x.fgopacity,M=_(x.size,8,10),A=_(x.solidity,.5,1),E="legend-"+u.uid;i.call(s.pattern,'legend',e,E,b,M,A,p,x.fillmode,w,T,k)}else i.call(l.fill,v);o&&l.stroke(i,a.mlc||h.color)}))}function O(t){var r=t[0].trace,o=n.select(this).select('g.legendpoints').selectAll('path.legendbox').data(r.visible&&i.traceIs(r,'box-violin')?[t]:[]);o.enter().append('path').classed('legendbox',!0).attr('d','M6,6H-6V-6H6Z').attr('transform',A),o.exit().remove(),o.each((function(){var t=n.select(this);if("all"!==r.boxpoints&&"all"!==r.points||0!==l.opacity(r.fillcolor)||0!==l.opacity((r.line||{}).color)){var i=S(void 0,r.line,y,g);t.style('stroke-width',i+"px").call(l.fill,r.fillcolor),i&&l.stroke(t,r.line.color)}else{var c=a.minExtend(r,{marker:{size:T?d:a.constrain(r.marker.size,2,16),sizeref:1,sizemin:1,sizemode:"diameter"}});o.call(s.pointStyle,c,e)}}))}function D(t){var e=t[0].trace,r=n.select(this).select('g.legendpoints').selectAll('path.legendcandle').data(e.visible&&"candlestick"===e.type?[t,t]:[]);r.enter().append('path').classed('legendcandle',!0).attr('d',(function(t,e){return e?"M-15,0H-8M-8,6V-6H8Z":"M15,0H8M8,-6V6H-8Z"})).attr('transform',A).style('stroke-miterlimit',1),r.exit().remove(),r.each((function(t,r){var i=n.select(this),a=e[r?"increasing":"decreasing"],o=S(void 0,a.line,y,g);i.style('stroke-width',o+"px").call(l.fill,a.fillcolor),o&&l.stroke(i,a.line.color)}))}function R(t){var e=t[0].trace,r=n.select(this).select('g.legendpoints').selectAll('path.legendohlc').data(e.visible&&"ohlc"===e.type?[t,t]:[]);r.enter().append('path').classed('legendohlc',!0).attr('d',(function(t,e){return e?"M-15,0H0M-8,-6V0":"M15,0H0M8,6V0"})).attr('transform',A).style('stroke-miterlimit',1),r.exit().remove(),r.each((function(t,r){var i=n.select(this),a=e[r?"increasing":"decreasing"],o=S(void 0,a.line,y,g);i.style('fill','none').call(s.dashLine,a.line.dash,o),o&&l.stroke(i,a.line.color)}))}function F(t){N(t,this,'pie')}function B(t){N(t,this,'funnelarea')}function N(t,e,r){var o=t[0],s=o.trace,l=r?s.visible&&s.type===r:i.traceIs(s,r),c=n.select(e).select('g.legendpoints').selectAll("path.legend"+r).data(l?[t]:[]);if(c.enter().append('path').classed("legend"+r,!0).attr('d','M6,6H-6V-6H6Z').attr('transform',A),c.exit().remove(),c.size()){var u=(s.marker||{}).line,p=S(h(u.width,o.pts),u,y,g),d=a.minExtend(s,{marker:{line:{width:p}}});d.marker.line.color=u.color;var m=a.minExtend(o,{trace:d});f(c,m,d)}}function j(t){var r,i=t[0].trace,o=[];if(i.visible)switch(i.type){case"histogram2d":case"heatmap":o=[["M-15,-2V4H15V-2Z"]],r=!0;break;case"choropleth":case"choroplethmapbox":o=[["M-6,-6V6H6V-6Z"]],r=!0;break;case"densitymapbox":o=[["M-6,0 a6,6 0 1,0 12,0 a 6,6 0 1,0 -12,0"]],r='radial';break;case"cone":o=[["M-6,2 A2,2 0 0,0 -6,6 V6L6,4Z"],["M-6,-6 A2,2 0 0,0 -6,-2 L6,-4Z"],["M-6,-2 A2,2 0 0,0 -6,2 L6,0Z"]],r=!1;break;case"streamtube":o=[["M-6,2 A2,2 0 0,0 -6,6 H6 A2,2 0 0,1 6,2 Z"],["M-6,-6 A2,2 0 0,0 -6,-2 H6 A2,2 0 0,1 6,-6 Z"],["M-6,-2 A2,2 0 0,0 -6,2 H6 A2,2 0 0,1 6,-2 Z"]],r=!1;break;case"surface":o=[["M-6,-6 A2,3 0 0,0 -6,0 H6 A2,3 0 0,1 6,-6 Z"],["M-6,1 A2,3 0 0,1 -6,6 H6 A2,3 0 0,0 6,0 Z"]],r=!0;break;case"mesh3d":o=[["M-6,6H0L-6,-6Z"],["M6,6H0L6,-6Z"],["M-6,-6H6L0,6Z"]],r=!1;break;case"volume":o=[["M-6,6H0L-6,-6Z"],["M6,6H0L6,-6Z"],["M-6,-6H6L0,6Z"]],r=!0;break;case"isosurface":o=[["M-6,6H0L-6,-6Z"],["M6,6H0L6,-6Z"],["M-6,-6 A12,24 0 0,0 6,-6 L0,6Z"]],r=!1}var u=n.select(this).select('g.legendpoints').selectAll('path.legend3dandfriends').data(o);u.enter().append('path').classed('legend3dandfriends',!0).attr('transform',A).style('stroke-miterlimit',1),u.exit().remove(),u.each((function(t,o){var u,f=n.select(this),h=c(i),p=h.colorscale,d=h.reversescale,m=function(t){if(t.size()){var n="legendfill-"+i.uid;s.gradient(t,e,n,x(d,"radial"===r),p,'fill')}};if(p){if(!r){var g=p.length;u=0===o?p[d?g-1:0][1]:1===o?p[d?0:g-1][1]:p[Math.floor((g-1)/2)][1]}}else{var v=i.vertexcolor||i.facecolor||i.color;u=a.isArrayOrTypedArray(v)?v[o]||v[0]:v}f.attr('d',t[0]),u?f.call(l.fill,u):f.call(m)}))}t.each((function(t){var e=n.select(this),i=a.ensureSingle(e,'g','layers');i.style('opacity',t[0].trace.opacity);var s=r.valign,l=t[0].lineHeight,c=t[0].height;if("middle"!==s&&l&&c){var u={top:1,bottom:-1}[s]*(.5*(l-c+3));i.attr('transform',o(0,u))}else i.attr('transform',null);i.selectAll('g.legendfill').data([t]).enter().append('g').classed('legendfill',!0),i.selectAll('g.legendlines').data([t]).enter().append('g').classed('legendlines',!0);var f=i.selectAll('g.legendsymbols').data([t]);f.enter().append('g').classed('legendsymbols',!0),f.selectAll('g.legendpoints').data([t]).enter().append('g').classed('legendpoints',!0)})).each(j).each(C).each(I).each(P).each(O).each(B).each(F).each(E).each(L).each(D).each(R)}},{"../../lib":787,"../../registry":915,"../../traces/pie/helpers":1181,"../../traces/pie/style_one":1187,"../../traces/scatter/subtypes":1227,"../color":650,"../colorscale/helpers":661,"../drawing":672,"./constants":701,"@plotly/d3":58}],709:[function(t,e,r){"use strict";t('./constants'),e.exports={editType:"modebar",orientation:{valType:"enumerated",values:["v","h"],dflt:"h",editType:"modebar"},bgcolor:{valType:"color",editType:"modebar"},color:{valType:"color",editType:"modebar"},activecolor:{valType:"color",editType:"modebar"},uirevision:{valType:"any",editType:"none"},add:{valType:"string",arrayOk:!0,dflt:"",editType:"modebar"},remove:{valType:"string",arrayOk:!0,dflt:"",editType:"modebar"}}},{"./constants":711}],710:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../plots/plots'),a=t('../../plots/cartesian/axis_ids'),o=t('../../fonts/ploticon'),s=t('../shapes/draw').eraseActiveShape,l=t('../../lib'),c=l._,u=e.exports={};function f(t,e){var r,i,o=e.currentTarget,s=o.getAttribute('data-attr'),l=o.getAttribute('data-val')||!0,c=t._fullLayout,u={},f=a.list(t,null,!0),h=c._cartesianSpikesEnabled;if("zoom"===s){var p,d="in"===l?.5:2,m=(1+d)/2,g=(1-d)/2;for(i=0;i<f.length;i++)if(!(r=f[i]).fixedrange)if(p=r._name,"auto"===l)u[p+".autorange"]=!0;else if("reset"===l){if(void 0===r._rangeInitial)u[p+".autorange"]=!0;else{var v=r._rangeInitial.slice();u[p+".range[0]"]=v[0],u[p+".range[1]"]=v[1]}void 0!==r._showSpikeInitial&&(u[p+".showspikes"]=r._showSpikeInitial,"on"!==h||r._showSpikeInitial||(h='off'))}else{var y=[r.r2l(r.range[0]),r.r2l(r.range[1])],x=[m*y[0]+g*y[1],m*y[1]+g*y[0]];u[p+".range[0]"]=r.l2r(x[0]),u[p+".range[1]"]=r.l2r(x[1])}}else"hovermode"!==s||"x"!==l&&"y"!==l||(l=c._isHoriz?"y":"x",o.setAttribute('data-val',l)),u[s]=l;c._cartesianSpikesEnabled=h,n.call('_guiRelayout',t,u)}function h(t,e){for(var r=e.currentTarget,i=r.getAttribute('data-attr'),a=r.getAttribute('data-val')||!0,o=t._fullLayout._subplots.gl3d||[],s={},l=i.split('.'),c=0;c<o.length;c++)s[o[c]+"."+l[1]]=a;var u="pan"===a?a:"zoom";s.dragmode=u,n.call('_guiRelayout',t,s)}function p(t,e){for(var r=e.currentTarget.getAttribute('data-attr'),i="resetLastSave"===r,a="resetDefault"===r,o=t._fullLayout,s=o._subplots.gl3d||[],l={},c=0;c<s.length;c++){var u,f=s[c],h=f+".camera",p=f+".aspectratio",d=f+".aspectmode",m=o[f]._scene;i?(l[h+".up"]=m.viewInitial.up,l[h+".eye"]=m.viewInitial.eye,l[h+".center"]=m.viewInitial.center,u=!0):a&&(l[h+".up"]=null,l[h+".eye"]=null,l[h+".center"]=null,u=!0),u&&(l[p+".x"]=m.viewInitial.aspectratio.x,l[p+".y"]=m.viewInitial.aspectratio.y,l[p+".z"]=m.viewInitial.aspectratio.z,l[d]=m.viewInitial.aspectmode)}n.call('_guiRelayout',t,l)}function d(t,e){var r=e.currentTarget,n=r._previousVal,i=t._fullLayout,a=i._subplots.gl3d||[],o=["xaxis",'yaxis',"zaxis"],s={},l={};if(n)l=n,r._previousVal=null;else{for(var c=0;c<a.length;c++){var u=a[c],f=i[u],h=u+".hovermode";s[h]=f.hovermode,l[h]=!1;for(var p=0;p<3;p++){var d=o[p],m=u+"."+d+".showspikes";l[m]=!1,s[m]=f[d].showspikes}}r._previousVal=s}return l}function m(t,e){var r=d(t,e);n.call('_guiRelayout',t,r)}function g(t,e){for(var r=e.currentTarget,i=r.getAttribute('data-attr'),a=r.getAttribute('data-val')||!0,o=t._fullLayout,s=o._subplots.geo||[],l=0;l<s.length;l++){var c=s[l],u=o[c];if("zoom"===i){var f=u.projection.scale,h="in"===a?2*f:.5*f;n.call('_guiRelayout',t,c+".projection.scale",h)}}"reset"===i&&_(t,'geo')}function v(t){var e=t._fullLayout;return!e.hovermode&&(e._has('cartesian')?e._isHoriz?"y":"x":"closest")}function y(t){var e=v(t);n.call('_guiRelayout',t,'hovermode',e)}function x(t){for(var e="on"===t._fullLayout._cartesianSpikesEnabled,r=a.list(t,null,!0),n={},i=0;i<r.length;i++){var o=r[i];n[o._name+".showspikes"]=!!e||o._showSpikeInitial}return n}function b(t,e){for(var r=e.currentTarget.getAttribute('data-val'),i=t._fullLayout,a=i._subplots.mapbox||[],o=1.05,s={},l=0;l<a.length;l++){var c=a[l],u=i[c].zoom,f="in"===r?o*u:u/o;s[c+".zoom"]=f}n.call('_guiRelayout',t,s)}function _(t,e){for(var r=t._fullLayout,i=r._subplots[e]||[],a={},o=0;o<i.length;o++)for(var s=i[o],l=r[s]._subplot.viewInitial,c=Object.keys(l),u=0;u<c.length;u++){var f=c[u];a[s+"."+f]=l[f]}n.call('_guiRelayout',t,a)}u.toImage={name:"toImage",title:function(t){var e=(t._context.toImageButtonOptions||{}).format||"png";return c(t,"png"===e?"Download plot as a png":"Download plot")},icon:o.camera,click:function(t){var e=t._context.toImageButtonOptions,r={format:e.format||"png"};l.notifier(c(t,'Taking snapshot - this may take a few seconds'),'long'),"svg"!==r.format&&l.isIE()&&(l.notifier(c(t,'IE only supports svg.  Changing format to svg.'),'long'),r.format='svg'),["filename",'width','height',"scale"].forEach((function(t)[t in e&&(r[t]=e[t])])),n.call('downloadImage',t,r).then((function(e){l.notifier(c(t,'Snapshot succeeded')+" - "+e,'long')})).catch((function(){l.notifier(c(t,'Sorry, there was a problem downloading your snapshot!'),'long')}))}},u.sendDataToCloud={name:"sendDataToCloud",title:function(t){return c(t,'Edit in Chart Studio')},icon:o.disk,click:function(t)[i.sendDataToCloud(t)]},u.editInChartStudio={name:"editInChartStudio",title:function(t){return c(t,'Edit in Chart Studio')},icon:o.pencil,click:function(t)[i.sendDataToCloud(t)]},u.zoom2d={name:"zoom2d",_cat:"zoom",title:function(t){return c(t,'Zoom')},attr:"dragmode",val:"zoom",icon:o.zoombox,click:f},u.pan2d={name:"pan2d",_cat:"pan",title:function(t){return c(t,'Pan')},attr:"dragmode",val:"pan",icon:o.pan,click:f},u.select2d={name:"select2d",_cat:"select",title:function(t){return c(t,'Box Select')},attr:"dragmode",val:"select",icon:o.selectbox,click:f},u.lasso2d={name:"lasso2d",_cat:"lasso",title:function(t){return c(t,'Lasso Select')},attr:"dragmode",val:"lasso",icon:o.lasso,click:f},u.drawclosedpath={name:"drawclosedpath",title:function(t){return c(t,'Draw closed freeform')},attr:"dragmode",val:"drawclosedpath",icon:o.drawclosedpath,click:f},u.drawopenpath={name:"drawopenpath",title:function(t){return c(t,'Draw open freeform')},attr:"dragmode",val:"drawopenpath",icon:o.drawopenpath,click:f},u.drawline={name:"drawline",title:function(t){return c(t,'Draw line')},attr:"dragmode",val:"drawline",icon:o.drawline,click:f},u.drawrect={name:"drawrect",title:function(t){return c(t,'Draw rectangle')},attr:"dragmode",val:"drawrect",icon:o.drawrect,click:f},u.drawcircle={name:"drawcircle",title:function(t){return c(t,'Draw circle')},attr:"dragmode",val:"drawcircle",icon:o.drawcircle,click:f},u.eraseshape={name:"eraseshape",title:function(t){return c(t,'Erase active shape')},icon:o.eraseshape,click:s},u.zoomIn2d={name:"zoomIn2d",_cat:"zoomin",title:function(t){return c(t,'Zoom in')},attr:"zoom",val:"in",icon:o.zoom_plus,click:f},u.zoomOut2d={name:"zoomOut2d",_cat:"zoomout",title:function(t){return c(t,'Zoom out')},attr:"zoom",val:"out",icon:o.zoom_minus,click:f},u.autoScale2d={name:"autoScale2d",_cat:"autoscale",title:function(t){return c(t,'Autoscale')},attr:"zoom",val:"auto",icon:o.autoscale,click:f},u.resetScale2d={name:"resetScale2d",_cat:"resetscale",title:function(t){return c(t,'Reset axes')},attr:"zoom",val:"reset",icon:o.home,click:f},u.hoverClosestCartesian={name:"hoverClosestCartesian",_cat:"hoverclosest",title:function(t){return c(t,'Show closest data on hover')},attr:"hovermode",val:"closest",icon:o.tooltip_basic,gravity:"ne",click:f},u.hoverCompareCartesian={name:"hoverCompareCartesian",_cat:"hoverCompare",title:function(t){return c(t,'Compare data on hover')},attr:"hovermode",val:function(t){return t._fullLayout._isHoriz?"y":"x"},icon:o.tooltip_compare,gravity:"ne",click:f},u.zoom3d={name:"zoom3d",_cat:"zoom",title:function(t){return c(t,'Zoom')},attr:"scene.dragmode",val:"zoom",icon:o.zoombox,click:h},u.pan3d={name:"pan3d",_cat:"pan",title:function(t){return c(t,'Pan')},attr:"scene.dragmode",val:"pan",icon:o.pan,click:h},u.orbitRotation={name:"orbitRotation",title:function(t){return c(t,'Orbital rotation')},attr:"scene.dragmode",val:"orbit",icon:o["3d_rotate"],click:h},u.tableRotation={name:"tableRotation",title:function(t){return c(t,'Turntable rotation')},attr:"scene.dragmode",val:"turntable",icon:o["z-axis"],click:h},u.resetCameraDefault3d={name:"resetCameraDefault3d",_cat:"resetCameraDefault",title:function(t){return c(t,'Reset camera to default')},attr:"resetDefault",icon:o.home,click:p},u.resetCameraLastSave3d={name:"resetCameraLastSave3d",_cat:"resetCameraLastSave",title:function(t){return c(t,'Reset camera to last save')},attr:"resetLastSave",icon:o.movie,click:p},u.hoverClosest3d={name:"hoverClosest3d",_cat:"hoverclosest",title:function(t){return c(t,'Toggle show closest data on hover')},attr:"hovermode",val:null,toggle:!0,icon:o.tooltip_basic,gravity:"ne",click:m},u.zoomInGeo={name:"zoomInGeo",_cat:"zoomin",title:function(t){return c(t,'Zoom in')},attr:"zoom",val:"in",icon:o.zoom_plus,click:g},u.zoomOutGeo={name:"zoomOutGeo",_cat:"zoomout",title:function(t){return c(t,'Zoom out')},attr:"zoom",val:"out",icon:o.zoom_minus,click:g},u.resetGeo={name:"resetGeo",_cat:"reset",title:function(t){return c(t,'Reset')},attr:"reset",val:null,icon:o.autoscale,click:g},u.hoverClosestGeo={name:"hoverClosestGeo",_cat:"hoverclosest",title:function(t){return c(t,'Toggle show closest data on hover')},attr:"hovermode",val:null,toggle:!0,icon:o.tooltip_basic,gravity:"ne",click:y},u.hoverClosestGl2d={name:"hoverClosestGl2d",_cat:"hoverclosest",title:function(t){return c(t,'Toggle show closest data on hover')},attr:"hovermode",val:null,toggle:!0,icon:o.tooltip_basic,gravity:"ne",click:y},u.hoverClosestPie={name:"hoverClosestPie",_cat:"hoverclosest",title:function(t){return c(t,'Toggle show closest data on hover')},attr:"hovermode",val:"closest",icon:o.tooltip_basic,gravity:"ne",click:y},u.resetViewSankey={name:"resetSankeyGroup",title:function(t){return c(t,'Reset view')},icon:o.home,click:function(t){for(var e={"node.groups":[],"node.x":[],"node.y":[]},r=0;r<t._fullData.length;r++){var i=t._fullData[r]._viewInitial;e["node.groups"].push(i.node.groups.slice()),e["node.x"].push(i.node.x.slice()),e["node.y"].push(i.node.y.slice())}n.call('restyle',t,e)}},u.toggleHover={name:"toggleHover",title:function(t){return c(t,'Toggle show closest data on hover')},attr:"hovermode",val:null,toggle:!0,icon:o.tooltip_basic,gravity:"ne",click:function(t,e){var r=d(t,e);r.hovermode=v(t),n.call('_guiRelayout',t,r)}},u.resetViews={name:"resetViews",title:function(t){return c(t,'Reset views')},icon:o.home,click:function(t,e){var r=e.currentTarget;r.setAttribute('data-attr','zoom'),r.setAttribute('data-val','reset'),f(t,e),r.setAttribute('data-attr','resetLastSave'),p(t,e),_(t,'geo'),_(t,'mapbox')}},u.toggleSpikelines={name:"toggleSpikelines",title:function(t){return c(t,'Toggle Spike Lines')},icon:o.spikeline,attr:"_cartesianSpikesEnabled",val:"on",click:function(t){var e=t._fullLayout,r=e._cartesianSpikesEnabled;e._cartesianSpikesEnabled="on"===r?"off":"on",n.call('_guiRelayout',t,x(t))}},u.resetViewMapbox={name:"resetViewMapbox",_cat:"resetView",title:function(t){return c(t,'Reset view')},attr:"reset",icon:o.home,click:function(t){_(t,'mapbox')}},u.zoomInMapbox={name:"zoomInMapbox",_cat:"zoomin",title:function(t){return c(t,'Zoom in')},attr:"zoom",val:"in",icon:o.zoom_plus,click:b},u.zoomOutMapbox={name:"zoomOutMapbox",_cat:"zoomout",title:function(t){return c(t,'Zoom out')},attr:"zoom",val:"out",icon:o.zoom_minus,click:b}},{"../../fonts/ploticon":766,"../../lib":787,"../../plots/cartesian/axis_ids":842,"../../plots/plots":901,"../../registry":915,"../shapes/draw":734}],711:[function(t,e,r){"use strict";var n=t('./buttons'),i=Object.keys(n),a=["drawline",'drawopenpath','drawclosedpath','drawcircle','drawrect',"eraseshape"],o=["v1hovermode",'hoverclosest','hovercompare','togglehover',"togglespikelines"].concat(a),s=[],l=function(t){if(-1===o.indexOf(t._cat||t.name)){var e=t.name,r=(t._cat||t.name).toLowerCase();-1===s.indexOf(e)&&s.push(e),-1===s.indexOf(r)&&s.push(r)}};i.forEach((function(t)[l(n[t])])),s.sort(),e.exports={DRAW_MODES:a,backButtons:o,foreButtons:s}},{"./buttons":710}],712:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../color'),a=t('../../plot_api/plot_template'),o=t('./attributes');e.exports=function(t,e){var r=t.modebar||{},s=a.newContainer(e,'modebar');function l(t,e){return n.coerce(r,s,o,t,e)}l('orientation'),l('bgcolor',i.addOpacity(e.paper_bgcolor,.5));var c=i.contrast(i.rgb(e.modebar.bgcolor));l('color',i.addOpacity(c,.3)),l('activecolor',i.addOpacity(c,.7)),l('uirevision',e.uirevision),l('add'),l('remove')}},{"../../lib":787,"../../plot_api/plot_template":827,"../color":650,"./attributes":709}],713:[function(t,e,r){"use strict";e.exports={moduleType:"component",name:"modebar",layoutAttributes:t('./attributes'),supplyLayoutDefaults:t('./defaults'),manage:t('./manage')}},{"./attributes":709,"./defaults":712,"./manage":714}],714:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axis_ids'),i=t('../../traces/scatter/subtypes'),a=t('../../registry'),o=t('../fx/helpers').isUnifiedHover,s=t('./modebar'),l=t('./buttons'),c=t('./constants').DRAW_MODES;function u(t){var e=t._fullLayout,r=t._fullData,n=t._context;function i(t,e){if("string"===typeof e){if(e.toLowerCase()===t.toLowerCase())return!0}else{var r=e.name,n=e._cat||e.name;if(r===t||n===t.toLowerCase())return!0}return!1}var a=e.modebar.add;"string"===typeof a&&(a=[a]);var s=e.modebar.remove;"string"===typeof s&&(s=[s]);var u=n.modeBarButtonsToAdd.concat(a.filter((function(t){for(var e=0;e<n.modeBarButtonsToRemove.length;e++)if(i(t,n.modeBarButtonsToRemove[e]))return!1;return!0}))),m=n.modeBarButtonsToRemove.concat(s.filter((function(t){for(var e=0;e<n.modeBarButtonsToAdd.length;e++)if(i(t,n.modeBarButtonsToAdd[e]))return!1;return!0}))),g=e._has('cartesian'),v=e._has('gl3d'),y=e._has('geo'),x=e._has('pie'),b=e._has('funnelarea'),_=e._has('gl2d'),w=e._has('ternary'),T=e._has('mapbox'),k=e._has('polar'),M=e._has('sankey'),A=f(e),S=o(e.hovermode),E=[];function L(t){if(t.length){for(var e=[],r=0;r<t.length;r++){for(var n=t[r],i=l[n],a=i.name.toLowerCase(),o=(i._cat||i.name).toLowerCase(),s=!1,c=0;c<m.length;c++){var u=m[c].toLowerCase();if(u===a||u===o){s=!0;break}}s||e.push(l[n])}E.push(e)}}var C=["toImage"];n.showEditInChartStudio?C.push('editInChartStudio'):n.showSendToCloud&&C.push('sendDataToCloud'),L(C);var P=[],I=[],z=[],O=[];(g||_||x||b||w)+y+v+T+k>1?(I=["toggleHover"],z=["resetViews"]):y?(P=["zoomInGeo","zoomOutGeo"],I=["hoverClosestGeo"],z=["resetGeo"]):v?(I=["hoverClosest3d"],z=["resetCameraDefault3d","resetCameraLastSave3d"]):T?(P=["zoomInMapbox","zoomOutMapbox"],I=["toggleHover"],z=["resetViewMapbox"]):_?I=["hoverClosestGl2d"]:x?I=["hoverClosestPie"]:M?(I=["hoverClosestCartesian","hoverCompareCartesian"],z=["resetViewSankey"]):I=["toggleHover"],g&&(I=["toggleSpikelines",'hoverClosestCartesian',"hoverCompareCartesian"]),(p(r)||S)&&(I=[]),!g&&!_||A||(P=["zoomIn2d",'zoomOut2d',"autoScale2d"],"resetViews"!==z[0]&&(z=["resetScale2d"])),v?O=["zoom3d",'pan3d','orbitRotation',"tableRotation"]:(g||_)&&!A||w?O=["zoom2d","pan2d"]:T||y?O=["pan2d"]:k&&(O=["zoom2d"]),h(r)&&O.push('select2d','lasso2d');var D=[],R=function(t)[-1===D.indexOf(t)&&-1!==I.indexOf(t)&&D.push(t)];if(Array.isArray(u)){for(var F=[],B=0;B<u.length;B++){var N=u[B];"string"===typeof N?(N=N.toLowerCase(),-1!==c.indexOf(N)?(e._has('mapbox')||e._has('cartesian'))&&O.push(N):"togglespikelines"===N?R('toggleSpikelines'):"togglehover"===N?R('toggleHover'):"hovercompare"===N?R('hoverCompareCartesian'):"hoverclosest"===N?(R('hoverClosestCartesian'),R('hoverClosestGeo'),R('hoverClosest3d'),R('hoverClosestGl2d'),R('hoverClosestPie')):"v1hovermode"===N&&(R('toggleHover'),R('hoverClosestCartesian'),R('hoverCompareCartesian'),R('hoverClosestGeo'),R('hoverClosest3d'),R('hoverClosestGl2d'),R('hoverClosestPie'))):F.push(N)}u=F}return L(O),L(P.concat(z)),L(D),d(E,u)}function f(t){for(var e=n.list({_fullLayout:t},null,!0),r=0;r<e.length;r++)if(!e[r].fixedrange)return!1;return!0}function h(t){for(var e=!1,r=0;r<t.length&&!e;r++){var n=t[r];n._module&&n._module.selectPoints&&(a.traceIs(n,'scatter-like')?(i.hasMarkers(n)||i.hasText(n))&&(e=!0):a.traceIs(n,'box-violin')&&"all"!==n.boxpoints&&"all"!==n.points||(e=!0))}return e}function p(t){for(var e=0;e<t.length;e++)if(!a.traceIs(t[e],'noHover'))return!1;return!0}function d(t,e){if(e.length)if(Array.isArray(e[0]))for(var r=0;r<e.length;r++)t.push(e[r]);else t.push(e);return t}function m(t){for(var e=0;e<t.length;e++)for(var r=t[e],n=0;n<r.length;n++){var i=r[n];if("string"===typeof i){if(void 0===l[i])throw new Error(["*modeBarButtons* configuration options","invalid button name"].join(' '));t[e][n]=l[i]}}return t}e.exports=function(t){var e=t._fullLayout,r=t._context,n=e._modeBar;if(r.displayModeBar||r.watermark){if(!Array.isArray(r.modeBarButtonsToRemove))throw new Error(["*modeBarButtonsToRemove* configuration options","must be an array."].join(' '));if(!Array.isArray(r.modeBarButtonsToAdd))throw new Error(["*modeBarButtonsToAdd* configuration options","must be an array."].join(' '));var i,a=r.modeBarButtons;i=Array.isArray(a)&&a.length?m(a):!r.displayModeBar&&r.watermark?[]:u(t),n?n.update(t,i):e._modeBar=s(t,i)}else n&&(n.destroy(),delete e._modeBar)}},{"../../plots/cartesian/axis_ids":842,"../../registry":915,"../../traces/scatter/subtypes":1227,"../fx/helpers":686,"./buttons":710,"./constants":711,"./modebar":715}],715:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../../lib'),o=t('../../fonts/ploticon'),s=new DOMParser;function l(t){this.container=t.container,this.element=document.createElement('div'),this.update(t.graphInfo,t.buttons),this.container.appendChild(this.element)}var c=l.prototype;function u(t,e){var r=t._fullLayout,i=new l({graphInfo:t,container:r._modebardiv.node(),buttons:e});return r._privateplot&&n.select(i.element).append('span').classed('badge-private float--left',!0).text('PRIVATE'),i}c.update=function(t,e){this.graphInfo=t;var r=this.graphInfo._context,n=this.graphInfo._fullLayout,i="modebar-"+n._uid;this.element.setAttribute('id',i),this._uid=i,this.element.className='modebar',"hover"===r.displayModeBar&&(this.element.className+=' modebar--hover ease-bg'),"v"===n.modebar.orientation&&(this.element.className+=' vertical',e=e.reverse());var o=n.modebar,s="hover"===r.displayModeBar?".js-plotly-plot .plotly:hover ":"";a.deleteRelatedStyleRule(i),a.addRelatedStyleRule(i,s+"#"+i+" .modebar-group","background-color: "+o.bgcolor),a.addRelatedStyleRule(i,"#"+i+" .modebar-btn .icon path","fill: "+o.color),a.addRelatedStyleRule(i,"#"+i+" .modebar-btn:hover .icon path","fill: "+o.activecolor),a.addRelatedStyleRule(i,"#"+i+" .modebar-btn.active .icon path",'fill: '+o.activecolor);var l=!this.hasButtons(e),c=this.hasLogo!==r.displaylogo,u=this.locale!==r.locale;if(this.locale=r.locale,(l||c||u)&&(this.removeAllButtons(),this.updateButtons(e),r.watermark||r.displaylogo)){var f=this.getLogo();r.watermark&&(f.className=f.className+' watermark'),"v"===n.modebar.orientation?this.element.insertBefore(f,this.element.childNodes[0]):this.element.appendChild(f),this.hasLogo=!0}this.updateActiveButton()},c.updateButtons=function(t){var e=this;this.buttons=t,this.buttonElements=[],this.buttonsNames=[],this.buttons.forEach((function(t){var r=e.createGroup();t.forEach((function(t){var n=t.name;if(!n)throw new Error('must provide button 'name' in button config');if(-1!==e.buttonsNames.indexOf(n))throw new Error("button name '"+n+"' is taken");e.buttonsNames.push(n);var i=e.createButton(t);e.buttonElements.push(i),r.appendChild(i)})),e.element.appendChild(r)}))},c.createGroup=function(){var t=document.createElement('div');return t.className='modebar-group',t},c.createButton=function(t){var e=this,r=document.createElement('a');r.setAttribute('rel','tooltip'),r.className='modebar-btn';var i=t.title;void 0===i?i=t.name:"function"===typeof i&&(i=i(this.graphInfo)),(i||0===i)&&r.setAttribute('data-title',i),void 0!==t.attr&&r.setAttribute('data-attr',t.attr);var a=t.val;if(void 0!==a&&("function"===typeof a&&(a=a(this.graphInfo)),r.setAttribute('data-val',a)),"function"!==typeof t.click)throw new Error('must provide button 'click' function in button config');r.addEventListener('click',(function(r){t.click(e.graphInfo,r),e.updateActiveButton(r.currentTarget)})),r.setAttribute('data-toggle',t.toggle||!1),t.toggle&&n.select(r).classed('active',!0);var s=t.icon;return"function"===typeof s?r.appendChild(s()):r.appendChild(this.createIcon(s||o.question)),r.setAttribute('data-gravity',t.gravity||"n"),r},c.createIcon=function(t){var e,r=i(t.height)?Number(t.height):t.ascent-t.descent,n='http://www.w3.org/2000/svg';if(t.path){(e=document.createElementNS(n,'svg')).setAttribute('viewBox',[0,0,t.width,r].join(' ')),e.setAttribute('class','icon');var a=document.createElementNS(n,'path');a.setAttribute('d',t.path),t.transform?a.setAttribute('transform',t.transform):void 0!==t.ascent&&a.setAttribute('transform','matrix(1 0 0 -1 0 '+t.ascent+')'),e.appendChild(a)}return t.svg&&(e=s.parseFromString(t.svg,'application/xml').childNodes[0]),e.setAttribute('height','1em'),e.setAttribute('width','1em'),e},c.updateActiveButton=function(t){var e=this.graphInfo._fullLayout,r=void 0!==t?t.getAttribute('data-attr'):null;this.buttonElements.forEach((function(t){var i=t.getAttribute('data-val')||!0,o=t.getAttribute('data-attr'),s="true"===t.getAttribute('data-toggle'),l=n.select(t);if(s)o===r&&l.classed('active',!l.classed('active'));else{var c=null===o?o:a.nestedProperty(e,o).get();l.classed('active',c===i)}}))},c.hasButtons=function(t){var e=this.buttons;if(!e)return!1;if(t.length!==e.length)return!1;for(var r=0;r<t.length;++r){if(t[r].length!==e[r].length)return!1;for(var n=0;n<t[r].length;n++)if(t[r][n].name!==e[r][n].name)return!1}return!0},c.getLogo=function(){var t=this.createGroup(),e=document.createElement('a');return e.href='https://plotly.com/',e.target='_blank',e.setAttribute('data-title',a._(this.graphInfo,'Produced with Plotly')),e.className='modebar-btn plotlyjsicon modebar-btn--logo',e.appendChild(this.createIcon(o.newplotlylogo)),t.appendChild(e),t},c.removeAllButtons=function(){for(;this.element.firstChild;)this.element.removeChild(this.element.firstChild);this.hasLogo=!1},c.destroy=function(){a.removeElement(this.container.querySelector('.modebar')),a.deleteRelatedStyleRule(this._uid)},e.exports=u},{"../../fonts/ploticon":766,"../../lib":787,"@plotly/d3":58,"fast-isnumeric":246}],716:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('../color/attributes'),a=(0,t('../../plot_api/plot_template').templatedArray)('button',{visible:{valType:"boolean",dflt:!0,editType:"plot"},step:{valType:"enumerated",values:["month",'year','day','hour','minute','second',"all"],dflt:"month",editType:"plot"},stepmode:{valType:"enumerated",values:["backward","todate"],dflt:"backward",editType:"plot"},count:{valType:"number",min:0,dflt:1,editType:"plot"},label:{valType:"string",editType:"plot"},editType:"plot"});e.exports={visible:{valType:"boolean",editType:"plot"},buttons:a,x:{valType:"number",min:-2,max:3,editType:"plot"},xanchor:{valType:"enumerated",values:["auto",'left','center',"right"],dflt:"left",editType:"plot"},y:{valType:"number",min:-2,max:3,editType:"plot"},yanchor:{valType:"enumerated",values:["auto",'top','middle',"bottom"],dflt:"bottom",editType:"plot"},font:n({editType:"plot"}),bgcolor:{valType:"color",dflt:i.lightLine,editType:"plot"},activecolor:{valType:"color",editType:"plot"},bordercolor:{valType:"color",dflt:i.defaultLine,editType:"plot"},borderwidth:{valType:"number",min:0,dflt:0,editType:"plot"},editType:"plot"}},{"../../plot_api/plot_template":827,"../../plots/font_attributes":867,"../color/attributes":649}],717:[function(t,e,r){"use strict";e.exports={yPad:.02,minButtonWidth:30,rx:3,ry:3,lightAmount:25,darkAmount:10}},{}],718:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../color'),a=t('../../plot_api/plot_template'),o=t('../../plots/array_container_defaults'),s=t('./attributes'),l=t('./constants');function c(t,e,r,i){var a=i.calendar;function o(r,i){return n.coerce(t,e,s.buttons,r,i)}if(o('visible')){var l=o('step');"all"!==l&&(!a||"gregorian"===a||"month"!==l&&"year"!==l?o('stepmode'):e.stepmode='backward',o('count')),o('label')}}function u(t,e,r){for(var n=r.filter((function(r){return e[r].anchor===t._id})),i=0,a=0;a<n.length;a++){var o=e[n[a]].domain;o&&(i=Math.max(o[1],i))}return[t.domain[0],i+l.yPad]}e.exports=function(t,e,r,f,h)[var p=t.rangeselector||{],d=a.newContainer(e,'rangeselector');function m(t,e){return n.coerce(p,d,s,t,e)}if(m('visible',o(p,d,{name:"buttons",handleItemDefaults:c,calendar:h}).length>0)){var g=u(e,r,f);m('x',g[0]),m('y',g[1]),n.noneOrAll(t,e,["x","y"]),m('xanchor'),m('yanchor'),n.coerceFont(m,'font',r.font);var v=m('bgcolor');m('activecolor',i.contrast(v,l.lightAmount,l.darkAmount)),m('bordercolor'),m('borderwidth')}}},{"../../lib":787,"../../plot_api/plot_template":827,"../../plots/array_container_defaults":833,"../color":650,"./attributes":716,"./constants":717}],719:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../plots/plots'),o=t('../color'),s=t('../drawing'),l=t('../../lib'),c=l.strTranslate,u=t('../../lib/svg_text_utils'),f=t('../../plots/cartesian/axis_ids'),h=t('../../constants/alignment'),p=h.LINE_SPACING,d=h.FROM_TL,m=h.FROM_BR,g=t('./constants'),v=t('./get_update_object');function y(t){for(var e=f.list(t,'x',!0),r=[],n=0;n<e.length;n++){var i=e[n];i.rangeselector&&i.rangeselector.visible&&r.push(i)}return r}function x(t){return t._id}function b(t,e,r){if("all"===e.step)return!0===t.autorange;var n=Object.keys(r);return t.range[0]===r[n[0]]&&t.range[1]===r[n[1]]}function _(t,e,r){var n=l.ensureSingle(t,'rect','selector-rect',(function(t){t.attr('shape-rendering','crispEdges')}));n.attr({rx:g.rx,ry:g.ry}),n.call(o.stroke,e.bordercolor).call(o.fill,w(e,r)).style('stroke-width',e.borderwidth+"px")}function w(t,e){return e._isActive||e._isHovered?t.activecolor:t.bgcolor}function T(t,e,r,n){function i(t){u.convertToTspans(t,n)}l.ensureSingle(t,'text','selector-text',(function(t){t.attr('text-anchor','middle')})).call(s.font,e.font).text(k(r,n._fullLayout._meta)).call(i)}function k(t,e){return t.label?e?l.templateString(t.label,e):t.label:"all"===t.step?"all":t.count+t.step.charAt(0)}function M(t,e,r,i,o){var f=0,h=0,v=r.borderwidth;e.each((function(){var t=n.select(this).select('.selector-text'),e=r.font.size*p,i=Math.max(e*u.lineCount(t),16)+3;h=Math.max(h,i)})),e.each((function(){var t=n.select(this),e=t.select('.selector-rect'),i=t.select('.selector-text'),a=i.node()&&s.bBox(i.node()).width,o=r.font.size*p,l=u.lineCount(i),d=Math.max(a+10,g.minButtonWidth);t.attr('transform',c(v+f,v)),e.attr({x:0,y:0,width:d,height:h}),u.positionText(i,d/2,h/2-(l-1)*o/2+3),f+=d+5}));var y=t._fullLayout._size,x=y.l+y.w*r.x,b=y.t+y.h*(1-r.y),_='left';l.isRightAnchor(r)&&(x-=f,_='right'),l.isCenterAnchor(r)&&(x-=f/2,_='center');var w='top';l.isBottomAnchor(r)&&(b-=h,w='bottom'),l.isMiddleAnchor(r)&&(b-=h/2,w='middle'),f=Math.ceil(f),h=Math.ceil(h),x=Math.round(x),b=Math.round(b),a.autoMargin(t,i+"-range-selector",{x:r.x,y:r.y,l:f*d[_],r:f*m[_],b:h*m[w],t:h*d[w]}),o.attr('transform',c(x,b))}e.exports=function(t){var e=t._fullLayout._infolayer.selectAll('.rangeselector').data(y(t),x);e.enter().append('g').classed('rangeselector',!0),e.exit().remove(),e.style({cursor:"pointer","pointer-events":"all"}),e.each((function(e){var r=n.select(this),a=e,o=a.rangeselector,s=r.selectAll('g.button').data(l.filterVisible(o.buttons));s.enter().append('g').classed('button',!0),s.exit().remove(),s.each((function(e){var r=n.select(this),s=v(a,e);e._isActive=b(a,e,s),r.call(_,o,e),r.call(T,o,e,t),r.on('click',(function(){t._dragged||i.call('_guiRelayout',t,s)})),r.on('mouseover',(function(){e._isHovered=!0,r.call(_,o,e)})),r.on('mouseout',(function(){e._isHovered=!1,r.call(_,o,e)}))})),M(t,s,o,a._name,r)}))}},{"../../constants/alignment":755,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/cartesian/axis_ids":842,"../../plots/plots":901,"../../registry":915,"../color":650,"../drawing":672,"./constants":717,"./get_update_object":720,"@plotly/d3":58}],720:[function(t,e,r){"use strict";var n=t('d3-time'),i=t('../../lib').titleCase;function a(t,e){var r,a=t.range,o=new Date(t.r2l(a[1])),s=e.step,l=n["utc"+i(s)],c=e.count;switch(e.stepmode){case"backward":r=t.l2r(+l.offset(o,-c));break;case"todate":var u=l.offset(o,-c);r=t.l2r(+l.ceil(u))}return[r,a[1]]}e.exports=function(t,e){var r=t._name,n={};if("all"===e.step)n[r+".autorange"]=!0;else{var i=a(t,e);n[r+".range[0]"]=i[0],n[r+".range[1]"]=i[1]}return n}},{"../../lib":787,"d3-time":174}],721:[function(t,e,r){"use strict";e.exports={moduleType:"component",name:"rangeselector",schema:{subplots:{xaxis:{rangeselector:t('./attributes')}}},layoutAttributes:t('./attributes'),handleDefaults:t('./defaults'),draw:t('./draw')}},{"./attributes":716,"./defaults":718,"./draw":719}],722:[function(t,e,r){"use strict";var n=t('../color/attributes');e.exports={bgcolor:{valType:"color",dflt:n.background,editType:"plot"},bordercolor:{valType:"color",dflt:n.defaultLine,editType:"plot"},borderwidth:{valType:"integer",dflt:0,min:0,editType:"plot"},autorange:{valType:"boolean",dflt:!0,editType:"calc",impliedEdits:{"range[0]":void 0,"range[1]":void 0}},range:{valType:"info_array",items:[{valType:"any",editType:"calc",impliedEdits:{"^autorange":!1}},{valType:"any",editType:"calc",impliedEdits:{"^autorange":!1}}],editType:"calc",impliedEdits:{autorange:!1}},thickness:{valType:"number",dflt:.15,min:0,max:1,editType:"plot"},visible:{valType:"boolean",dflt:!0,editType:"calc"},editType:"calc"}},{"../color/attributes":649}],723:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axis_ids').list,i=t('../../plots/cartesian/autorange').getAutoRange,a=t('./constants');e.exports=function(t){for(var e=n(t,'x',!0),r=0;r<e.length;r++){var o=e[r],s=o[a.name];s&&s.visible&&s.autorange&&(s._input.autorange=!0,s._input.range=s.range=i(t,o))}}},{"../../plots/cartesian/autorange":837,"../../plots/cartesian/axis_ids":842,"./constants":724}],724:[function(t,e,r){"use strict";e.exports={name:"rangeslider",containerClassName:"rangeslider-container",bgClassName:"rangeslider-bg",rangePlotClassName:"rangeslider-rangeplot",maskMinClassName:"rangeslider-mask-min",maskMaxClassName:"rangeslider-mask-max",slideBoxClassName:"rangeslider-slidebox",grabberMinClassName:"rangeslider-grabber-min",grabAreaMinClassName:"rangeslider-grabarea-min",handleMinClassName:"rangeslider-handle-min",grabberMaxClassName:"rangeslider-grabber-max",grabAreaMaxClassName:"rangeslider-grabarea-max",handleMaxClassName:"rangeslider-handle-max",maskMinOppAxisClassName:"rangeslider-mask-min-opp-axis",maskMaxOppAxisClassName:"rangeslider-mask-max-opp-axis",maskColor:"rgba(0,0,0,0.4)",maskOppAxisColor:"rgba(0,0,0,0.2)",slideBoxFill:"transparent",slideBoxCursor:"ew-resize",grabAreaFill:"transparent",grabAreaCursor:"col-resize",grabAreaWidth:10,handleWidth:4,handleRadius:1,handleStrokeWidth:1,extraPad:15}},{}],725:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plot_api/plot_template'),a=t('../../plots/cartesian/axis_ids'),o=t('./attributes'),s=t('./oppaxis_attributes');e.exports=function(t,e,r){var l=t[r],c=e[r];if(l.rangeslider||e._requestRangeslider[c._id]){n.isPlainObject(l.rangeslider)||(l.rangeslider={});var u,f,h=l.rangeslider,p=i.newContainer(c,'rangeslider');if(_('visible')){_('bgcolor',e.plot_bgcolor),_('bordercolor'),_('borderwidth'),_('thickness'),_('autorange',!c.isValidRange(h.range)),_('range');var d=e._subplots;if(d)for(var m=d.cartesian.filter((function(t){return t.substr(0,t.indexOf('y'))===a.name2id(r)})).map((function(t){return t.substr(t.indexOf('y'),t.length)})),g=n.simpleMap(m,a.id2name),v=0;v<g.length;v++){var y=g[v];u=h[y]||{},f=i.newContainer(p,y,'yaxis');var x,b=e[y];u.range&&b.isValidRange(u.range)&&(x='fixed'),"match"!==w('rangemode',x)&&w('range',b.range.slice())}p._input=h}}function _(t,e){return n.coerce(h,p,o,t,e)}function w(t,e){return n.coerce(u,f,s,t,e)}}},{"../../lib":787,"../../plot_api/plot_template":827,"../../plots/cartesian/axis_ids":842,"./attributes":722,"./oppaxis_attributes":729}],726:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../plots/plots'),o=t('../../lib'),s=o.strTranslate,l=t('../drawing'),c=t('../color'),u=t('../titles'),f=t('../../plots/cartesian'),h=t('../../plots/cartesian/axis_ids'),p=t('../dragelement'),d=t('../../lib/setcursor'),m=t('./constants');function g(t,e,r,i){if(!e._context.staticPlot){var a=t.select("rect."+m.slideBoxClassName).node(),s=t.select("rect."+m.grabAreaMinClassName).node(),l=t.select("rect."+m.grabAreaMaxClassName).node();t.on('mousedown',c),t.on('touchstart',c)}function c(){var c=n.event,u=c.target,f=c.clientX||c.touches[0].clientX,h=f-t.node().getBoundingClientRect().left,m=i.d2p(r._rl[0]),g=i.d2p(r._rl[1]),y=p.coverSlip();function x(o){var c,p,x,b=+(o.clientX||o.touches[0].clientX)-f;switch(u){case a:x='ew-resize',c=m+b,p=g+b;break;case s:x='col-resize',c=m+b,p=g;break;case l:x='col-resize',c=m,p=g+b;break;default:x='ew-resize',c=h,p=h+b}if(p<c){var _=p;p=c,c=_}i._pixelMin=c,i._pixelMax=p,d(n.select(y),x),v(t,e,r,i)}function b(){y.removeEventListener('mousemove',x),y.removeEventListener('mouseup',b),this.removeEventListener('touchmove',x),this.removeEventListener('touchend',b),o.removeElement(y)}this.addEventListener('touchmove',x),this.addEventListener('touchend',b),y.addEventListener('mousemove',x),y.addEventListener('mouseup',b)}}function v(t,e,r,n){function a(t){return r.l2r(o.constrain(t,n._rl[0],n._rl[1]))}var s=a(n.p2d(n._pixelMin)),l=a(n.p2d(n._pixelMax));window.requestAnimationFrame((function(){i.call('_guiRelayout',e,r._name+".range",[s,l])}))}function y(t,e,r,n,i,a){var l=m.handleWidth/2;function c(t){return o.constrain(t,0,n._width)}function u(t){return o.constrain(t,0,n._height)}function f(t){return o.constrain(t,-l,n._width+l)}var h=c(n.d2p(r._rl[0])),p=c(n.d2p(r._rl[1]));if(t.select("rect."+m.slideBoxClassName).attr('x',h).attr('width',p-h),t.select("rect."+m.maskMinClassName).attr('width',h),t.select("rect."+m.maskMaxClassName).attr('x',p).attr('width',n._width-p),"match"!==a.rangemode){var d=n._height-u(n.d2pOppAxis(i._rl[1])),g=n._height-u(n.d2pOppAxis(i._rl[0]));t.select("rect."+m.maskMinOppAxisClassName).attr('x',h).attr('height',d).attr('width',p-h),t.select("rect."+m.maskMaxOppAxisClassName).attr('x',h).attr('y',g).attr('height',n._height-g).attr('width',p-h),t.select("rect."+m.slideBoxClassName).attr('y',d).attr('height',g-d)}var v=.5,y=Math.round(f(h-l))-v,x=Math.round(f(p-l))+v;t.select("g."+m.grabberMinClassName).attr('transform',s(y,v)),t.select("g."+m.grabberMaxClassName).attr('transform',s(x,v))}function x(t,e,r,n){var i=o.ensureSingle(t,'rect',m.bgClassName,(function(t){t.attr({x:0,y:0,"shape-rendering":"crispEdges"})})),a=n.borderwidth%2===0?n.borderwidth:n.borderwidth-1,c=-n._offsetShift,u=l.crispRound(e,n.borderwidth);i.attr({width:n._width+a,height:n._height+a,transform:s(c,c),fill:n.bgcolor,stroke:n.bordercolor,"stroke-width":u})}function b(t,e,r,n){var i=e._fullLayout;o.ensureSingleById(i._topdefs,'clipPath',n._clipId,(function(t){t.append('rect').attr({x:0,y:0})})).select('rect').attr({width:n._width,height:n._height})}function _(t,e,r,i){var s,c=e.calcdata,u=t.selectAll("g."+m.rangePlotClassName).data(r._subplotsWith,o.identity);u.enter().append('g').attr('class',(function(t){return m.rangePlotClassName+" "+t})).call(l.setClipUrl,i._clipId,e),u.order(),u.exit().remove(),u.each((function(t,o){var l=n.select(this),u=0===o,p=h.getFromId(e,t,'y'),d=p._name,m=i[d],g={data:[],layout:{xaxis:{type:r.type,domain:[0,1],range:i.range.slice(),calendar:r.calendar},width:i._width,height:i._height,margin:{t:0,b:0,l:0,r:0}},_context:e._context};r.rangebreaks&&(g.layout.xaxis.rangebreaks=r.rangebreaks),g.layout[d]={type:p.type,domain:[0,1],range:"match"!==m.rangemode?m.range.slice():p.range.slice(),calendar:p.calendar},p.rangebreaks&&(g.layout[d].rangebreaks=p.rangebreaks),a.supplyDefaults(g);var v=g._fullLayout.xaxis,y=g._fullLayout[d];v.clearCalc(),v.setScale(),y.clearCalc(),y.setScale();var x={id:t,plotgroup:l,xaxis:v,yaxis:y,isRangePlot:!0};u?s=x:(x.mainplot='xy',x.mainplotinfo=s),f.rangePlot(e,x,w(c,t))}))}function w(t,e){for(var r=[],n=0;n<t.length;n++){var i=t[n],a=i[0].trace;a.xaxis+a.yaxis===e&&r.push(i)}return r}function T(t,e,r,n,i){o.ensureSingle(t,'rect',m.maskMinClassName,(function(t){t.attr({x:0,y:0,"shape-rendering":"crispEdges"})})).attr('height',n._height).call(c.fill,m.maskColor),o.ensureSingle(t,'rect',m.maskMaxClassName,(function(t){t.attr({y:0,"shape-rendering":"crispEdges"})})).attr('height',n._height).call(c.fill,m.maskColor),"match"!==i.rangemode&&(o.ensureSingle(t,'rect',m.maskMinOppAxisClassName,(function(t){t.attr({y:0,"shape-rendering":"crispEdges"})})).attr('width',n._width).call(c.fill,m.maskOppAxisColor),o.ensureSingle(t,'rect',m.maskMaxOppAxisClassName,(function(t){t.attr({y:0,"shape-rendering":"crispEdges"})})).attr('width',n._width).style('border-top',m.maskOppBorder).call(c.fill,m.maskOppAxisColor))}function k(t,e,r,n){e._context.staticPlot||o.ensureSingle(t,'rect',m.slideBoxClassName,(function(t){t.attr({y:0,cursor:m.slideBoxCursor,"shape-rendering":"crispEdges"})})).attr({height:n._height,fill:m.slideBoxFill})}function M(t,e,r,n){var i=o.ensureSingle(t,'g',m.grabberMinClassName),a=o.ensureSingle(t,'g',m.grabberMaxClassName),s={x:0,width:m.handleWidth,rx:m.handleRadius,fill:c.background,stroke:c.defaultLine,"stroke-width":m.handleStrokeWidth,"shape-rendering":"crispEdges"},l={y:Math.round(n._height/4),height:Math.round(n._height/2)};o.ensureSingle(i,'rect',m.handleMinClassName,(function(t)[t.attr(s)])).attr(l),o.ensureSingle(a,'rect',m.handleMaxClassName,(function(t)[t.attr(s)])).attr(l);var u={width:m.grabAreaWidth,x:0,y:0,fill:m.grabAreaFill,cursor:e._context.staticPlot?void 0:m.grabAreaCursor};o.ensureSingle(i,'rect',m.grabAreaMinClassName,(function(t)[t.attr(u)])).attr('height',n._height),o.ensureSingle(a,'rect',m.grabAreaMaxClassName,(function(t)[t.attr(u)])).attr('height',n._height)}e.exports=function(t){for(var e=t._fullLayout,r=e._rangeSliderData,i=0;i<r.length;i++){var a=r[i][m.name];a._clipId=a._id+"-"+e._uid}function l(t){return t._name}var c=e._infolayer.selectAll("g."+m.containerClassName).data(r,l);c.exit().each((function(t){var r=t[m.name];e._topdefs.select("#"+r._clipId).remove()})).remove(),0!==r.length&&(c.enter().append('g').classed(m.containerClassName,!0).attr('pointer-events','all'),c.each((function(r){var i=n.select(this),a=r[m.name],l=e[h.id2name(r.anchor)],c=a[h.id2name(r.anchor)];if(a.range){var f,p=o.simpleMap(a.range,r.r2l),d=o.simpleMap(r.range,r.r2l);f=d[0]<d[1]?[Math.min(p[0],d[0]),Math.max(p[1],d[1])]:[Math.max(p[0],d[0]),Math.min(p[1],d[1])],a.range=a._input.range=o.simpleMap(f,r.l2r)}r.cleanRange('rangeslider.range');var v=e._size,w=r.domain;a._width=v.w*(w[1]-w[0]);var A=Math.round(v.l+v.w*w[0]),S=Math.round(v.t+v.h*(1-r._counterDomainMin)+("bottom"===r.side?r._depth:0)+a._offsetShift+m.extraPad);i.attr('transform',s(A,S)),a._rl=o.simpleMap(a.range,r.r2l);var E=a._rl[0],L=a._rl[1],C=L-E;if(a.p2d=function(t){return t/a._width*C+E},a.d2p=function(t){return(t-E)/C*a._width},r.rangebreaks){var P=r.locateBreaks(E,L);if(P.length){var I,z,O=0;for(I=0;I<P.length;I++)O+=(z=P[I]).max-z.min;var D=a._width/(L-E-O),R=[-D*E];for(I=0;I<P.length;I++)z=P[I],R.push(R[R.length-1]-D*(z.max-z.min));for(a.d2p=function(t){for(var e=R[0],r=0;r<P.length;r++){var n=P[r];if(t>=n.max)e=R[r+1];else if(t<n.min)break}return e+D*t},I=0;I<P.length;I++)(z=P[I]).pmin=a.d2p(z.min),z.pmax=a.d2p(z.max);a.p2d=function(t){for(var e=R[0],r=0;r<P.length;r++){var n=P[r];if(t>=n.pmax)e=R[r+1];else if(t<n.pmin)break}return(t-e)/D}}}if("match"!==c.rangemode){var F=l.r2l(c.range[0]),B=l.r2l(c.range[1])-F;a.d2pOppAxis=function(t){return(t-F)/B*a._height}}i.call(x,t,r,a).call(b,t,r,a).call(_,t,r,a).call(T,t,r,a,c).call(k,t,r,a).call(M,t,r,a),g(i,t,r,a),y(i,t,r,a,l,c),"bottom"===r.side&&u.draw(t,r._id+"title",{propContainer:r,propName:r._name+".title",placeholder:e._dfltTitle.x,attributes:{x:r._offset+r._length/2,y:S+a._height+a._offsetShift+10+1.5*r.title.font.size,"text-anchor":"middle"}})})))}},{"../../lib":787,"../../lib/setcursor":808,"../../plots/cartesian":852,"../../plots/cartesian/axis_ids":842,"../../plots/plots":901,"../../registry":915,"../color":650,"../dragelement":669,"../drawing":672,"../titles":748,"./constants":724,"@plotly/d3":58}],727:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axis_ids'),i=t('../../lib/svg_text_utils'),a=t('./constants'),o=t('../../constants/alignment').LINE_SPACING,s=a.name;function l(t){var e=t&&t[s];return e&&e.visible}r.isVisible=l,r.makeData=function(t){var e=n.list({_fullLayout:t},'x',!0),r=t.margin,i=[];if(!t._has('gl2d'))for(var a=0;a<e.length;a++){var o=e[a];if(l(o)){i.push(o);var c=o[s];c._id=s+o._id,c._height=(t.height-r.b-r.t)*c.thickness,c._offsetShift=Math.floor(c.borderwidth/2)}}t._rangeSliderData=i},r.autoMarginOpts=function(t,e){var r=t._fullLayout,n=e[s],l=e._id.charAt(0),c=0,u=0;return"bottom"===e.side&&(c=e._depth,e.title.text!==r._dfltTitle[l]&&(u=1.5*e.title.font.size+10+n._offsetShift,u+=(e.title.text.match(i.BR_TAG_ALL)||[]).length*e.title.font.size*o)),{x:0,y:e._counterDomainMin,l:0,r:0,t:0,b:n._height+c+Math.max(r.margin.b,u),pad:a.extraPad+2*n._offsetShift}}},{"../../constants/alignment":755,"../../lib/svg_text_utils":813,"../../plots/cartesian/axis_ids":842,"./constants":724}],728:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('./oppaxis_attributes'),o=t('./helpers');e.exports={moduleType:"component",name:"rangeslider",schema:{subplots:{xaxis:{rangeslider:n.extendFlat({},i,{yaxis:a})}}},layoutAttributes:t('./attributes'),handleDefaults:t('./defaults'),calcAutorange:t('./calc_autorange'),draw:t('./draw'),isVisible:o.isVisible,makeData:o.makeData,autoMarginOpts:o.autoMarginOpts}},{"../../lib":787,"./attributes":722,"./calc_autorange":723,"./defaults":725,"./draw":726,"./helpers":727,"./oppaxis_attributes":729}],729:[function(t,e,r){"use strict";e.exports={_isSubplotObj:!0,rangemode:{valType:"enumerated",values:["auto",'fixed',"match"],dflt:"match",editType:"calc"},range:{valType:"info_array",items:[{valType:"any",editType:"plot"},{valType:"any",editType:"plot"}],editType:"plot"},editType:"calc"}},{}],730:[function(t,e,r){"use strict";var n=t('../annotations/attributes'),i=t('../../traces/scatter/attributes').line,a=t('../drawing/attributes').dash,o=t('../../lib/extend').extendFlat,s=t('../../plot_api/plot_template').templatedArray;t('../../constants/axis_placeable_objects'),e.exports=s('shape',{visible:{valType:"boolean",dflt:!0,editType:"calc+arraydraw"},type:{valType:"enumerated",values:["circle",'rect','path',"line"],editType:"calc+arraydraw"},layer:{valType:"enumerated",values:["below","above"],dflt:"above",editType:"arraydraw"},xref:o({},n.xref,{}),xsizemode:{valType:"enumerated",values:["scaled","pixel"],dflt:"scaled",editType:"calc+arraydraw"},xanchor:{valType:"any",editType:"calc+arraydraw"},x0:{valType:"any",editType:"calc+arraydraw"},x1:{valType:"any",editType:"calc+arraydraw"},yref:o({},n.yref,{}),ysizemode:{valType:"enumerated",values:["scaled","pixel"],dflt:"scaled",editType:"calc+arraydraw"},yanchor:{valType:"any",editType:"calc+arraydraw"},y0:{valType:"any",editType:"calc+arraydraw"},y1:{valType:"any",editType:"calc+arraydraw"},path:{valType:"string",editType:"calc+arraydraw"},opacity:{valType:"number",min:0,max:1,dflt:1,editType:"arraydraw"},line:{color:o({},i.color,{editType:"arraydraw"}),width:o({},i.width,{editType:"calc+arraydraw"}),dash:o({},a,{editType:"arraydraw"}),editType:"calc+arraydraw"},fillcolor:{valType:"color",dflt:"rgba(0,0,0,0)",editType:"arraydraw"},fillrule:{valType:"enumerated",values:["evenodd","nonzero"],dflt:"evenodd",editType:"arraydraw"},editable:{valType:"boolean",dflt:!1,editType:"calc+arraydraw"},editType:"arraydraw"})},{"../../constants/axis_placeable_objects":756,"../../lib/extend":777,"../../plot_api/plot_template":827,"../../traces/scatter/attributes":1202,"../annotations/attributes":633,"../drawing/attributes":671}],731:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('./constants'),o=t('./helpers');function s(t){return c(t.line.width,t.xsizemode,t.x0,t.x1,t.path,!1)}function l(t){return c(t.line.width,t.ysizemode,t.y0,t.y1,t.path,!0)}function c(t,e,r,i,s,l){var c=t/2,u=l;if("pixel"===e){var f=s?o.extractPathCoords(s,l?a.paramIsY:a.paramIsX):[r,i],h=n.aggNums(Math.max,null,f),p=n.aggNums(Math.min,null,f),d=p<0?Math.abs(p)+c:c,m=h>0?h+c:c;return{ppad:c,ppadplus:u?d:m,ppadminus:u?m:d}}return{ppad:c}}function u(t,e,r,n,i){var s="category"===t.type||"multicategory"===t.type?t.r2c:t.d2c;if(void 0!==e)return[s(e),s(r)];if(n){var l,c,u,f,h=1/0,p=-1/0,d=n.match(a.segmentRE);for("date"===t.type&&(s=o.decodeDate(s)),l=0;l<d.length;l++)void 0!==(c=i[d[l].charAt(0)].drawn)&&(!(u=d[l].substr(1).match(a.paramRE))||u.length<c||((f=s(u[c]))<h&&(h=f),f>p&&(p=f)));return p>=h?[h,p]:void 0}}e.exports=function(t){var e=t._fullLayout,r=n.filterVisible(e.shapes);if(r.length&&t._fullData.length)for(var o=0;o<r.length;o++){var c,f,h=r[o];h._extremes={};var p=i.getRefType(h.xref),d=i.getRefType(h.yref);if("paper"!==h.xref&&"domain"!==p){var m="pixel"===h.xsizemode?h.xanchor:h.x0,g="pixel"===h.xsizemode?h.xanchor:h.x1;(f=u(c=i.getFromId(t,h.xref),m,g,h.path,a.paramIsX))&&(h._extremes[c._id]=i.findExtremes(c,f,s(h)))}if("paper"!==h.yref&&"domain"!==d){var v="pixel"===h.ysizemode?h.yanchor:h.y0,y="pixel"===h.ysizemode?h.yanchor:h.y1;(f=u(c=i.getFromId(t,h.yref),v,y,h.path,a.paramIsY))&&(h._extremes[c._id]=i.findExtremes(c,f,l(h)))}}}},{"../../lib":787,"../../plots/cartesian/axes":838,"./constants":732,"./helpers":741}],732:[function(t,e,r){"use strict";e.exports={segmentRE:/[MLHVQCTSZ][^MLHVQCTSZ]*/g,paramRE:/[^\s,]+/g,paramIsX:{M:{0:!0,drawn:0},L:{0:!0,drawn:0},H:{0:!0,drawn:0},V:{},Q:{0:!0,2:!0,drawn:2},C:{0:!0,2:!0,4:!0,drawn:4},T:{0:!0,drawn:0},S:{0:!0,2:!0,drawn:2},Z:{}},paramIsY:{M:{1:!0,drawn:1},L:{1:!0,drawn:1},H:{},V:{0:!0,drawn:0},Q:{1:!0,3:!0,drawn:3},C:{1:!0,3:!0,5:!0,drawn:5},T:{1:!0,drawn:1},S:{1:!0,3:!0,drawn:5},Z:{}},numParams:{M:2,L:2,H:1,V:1,Q:4,C:6,T:2,S:4,Z:0}}},{}],733:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../../plots/array_container_defaults'),o=t('./attributes'),s=t('./helpers');function l(t,e,r){function a(r,i){return n.coerce(t,e,o,r,i)}if(a('visible')){var l=a('path'),c=a('type',l?"path":"rect");"path"!==e.type&&delete e.path,a('editable'),a('layer'),a('opacity'),a('fillcolor'),a('fillrule'),a('line.width')&&(a('line.color'),a('line.dash'));for(var u=a('xsizemode'),f=a('ysizemode'),h=["x","y"],p=0;p<2;p++){var d,m,g,v=h[p],y=v+"anchor",x="x"===v?u:f,b={_fullLayout:r},_=i.coerceRef(t,e,b,v,void 0,'paper');if("range"===i.getRefType(_)?((d=i.getFromId(b,_))._shapeIndices.push(e._index),g=s.rangeToShapePosition(d),m=s.shapePositionToRange(d)):m=g=n.identity,"path"!==c){var w=.25,T=.75,k=v+"0",M=v+"1",A=t[k],S=t[M];t[k]=m(t[k],!0),t[M]=m(t[M],!0),"pixel"===x?(a(k,0),a(M,10)):(i.coercePosition(e,b,a,_,k,w),i.coercePosition(e,b,a,_,M,T)),e[k]=g(e[k]),e[M]=g(e[M]),t[k]=A,t[M]=S}if("pixel"===x){var E=t[y];t[y]=m(t[y],!0),i.coercePosition(e,b,a,_,y,.25),e[y]=g(e[y]),t[y]=E}}"path"===c?a('path'):n.noneOrAll(t,e,["x0",'x1','y0',"y1"])}}e.exports=function(t,e){a(t,e,{name:"shapes",handleItemDefaults:l})}},{"../../lib":787,"../../plots/array_container_defaults":833,"../../plots/cartesian/axes":838,"./attributes":730,"./helpers":741}],734:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../../plots/cartesian/axes'),o=t('./draw_newshape/helpers').readPaths,s=t('./draw_newshape/display_outlines'),l=t('../../plots/cartesian/handle_outline').clearOutlineControllers,c=t('../color'),u=t('../drawing'),f=t('../../plot_api/plot_template').arrayEditor,h=t('../dragelement'),p=t('../../lib/setcursor'),d=t('./constants'),m=t('./helpers');function g(t){var e=t._fullLayout;for(var r in e._shapeUpperLayer.selectAll('path').remove(),e._shapeLowerLayer.selectAll('path').remove(),e._plots){var n=e._plots[r].shapelayer;n&&n.selectAll('path').remove()}for(var i=0;i<e.shapes.length;i++)e.shapes[i].visible&&x(t,i)}function v(t){return!!t._fullLayout._drawing}function y(t){return!t._context.edits.shapePosition}function x(t,e){t._fullLayout._paperdiv.selectAll('.shapelayer [data-index="'+e+'"]').remove();var r=m.makeOptionsAndPlotinfo(t,e),n=r.options,i=r.plotinfo;function a(r){var a=w(t,n),l={"data-index":e,"fill-rule":n.fillrule,d:a},h=n.opacity,p=n.fillcolor,d=n.line.width?n.line.color:"rgba(0,0,0,0)",m=n.line.width,g=n.line.dash;m||!0!==n.editable||(m=5,g='solid');var v="Z"!==a[a.length-1],x=y(t)&&n.editable&&t._fullLayout._activeShapeIndex===e;x&&(p=v?"rgba(0,0,0,0)":t._fullLayout.activeshape.fillcolor,h=t._fullLayout.activeshape.opacity);var T,k=r.append('path').attr(l).style('opacity',h).call(c.stroke,d).call(c.fill,p).call(u.dashLine,g,m);if(b(k,t,n),(x||t._context.edits.shapePosition)&&(T=f(t.layout,'shapes',n)),x){k.style({cursor:"move"});var A={element:k.node(),plotinfo:i,gd:t,editHelpers:T,isActiveShape:!0},S=o(a,t);s(S,k,A)}else t._context.edits.shapePosition?_(t,k,n,e,r,T):!0===n.editable&&k.style('pointer-events',v||c.opacity(p)*h<=.5?"stroke":"all");k.node().addEventListener('click',(function(){return M(t,k)}))}n._input&&!1!==n.visible&&("below"!==n.layer?a(t._fullLayout._shapeUpperLayer):"paper"===n.xref||"paper"===n.yref?a(t._fullLayout._shapeLowerLayer):i._hadPlotinfo?a((i.mainplotinfo||i).shapelayer):a(t._fullLayout._shapeLowerLayer))}function b(t,e,r){var n=(r.xref+r.yref).replace(/paper/g,'').replace(/[xyz][1-9]* *domain/g,'');u.setClipUrl(t,n?"clip"+e._fullLayout._uid+n:null,e)}function _(t,e,r,o,s,l){var c,f,g,y,x,_,T,M,A,S,E,L,C,P,I,z,O=10,D=10,R="pixel"===r.xsizemode,F="pixel"===r.ysizemode,B="line"===r.type,N="path"===r.type,j=l.modifyItem,U=a.getFromId(t,r.xref),V=a.getRefType(r.xref),H=a.getFromId(t,r.yref),q=a.getRefType(r.yref),G=m.getDataToPixel(t,U,!1,V),Y=m.getDataToPixel(t,H,!0,q),W=m.getPixelToData(t,U,!1,V),X=m.getPixelToData(t,H,!0,q),Z=K(),J={element:Z.node(),gd:t,prepFn:tt,doneFn:et,clickFn:rt};function K(){return B?Q():e}function Q(){var t=10,n=Math.max(r.line.width,t),i=s.append('g').attr('data-index',o);i.append('path').attr('d',e.attr('d')).style({cursor:"move","stroke-width":n,"stroke-opacity":"0"});var a={"fill-opacity":"0"},l=Math.max(n/2,t);return i.append('circle').attr({"data-line-point":"start-point",cx:R?G(r.xanchor)+r.x0:G(r.x0),cy:F?Y(r.yanchor)-r.y0:Y(r.y0),r:l}).style(a).classed('cursor-grab',!0),i.append('circle').attr({"data-line-point":"end-point",cx:R?G(r.xanchor)+r.x1:G(r.x1),cy:F?Y(r.yanchor)-r.y1:Y(r.y1),r:l}).style(a).classed('cursor-grab',!0),i}function $(r){if(v(t))z=null;else if(B)z="path"===r.target.tagName?"move":"start-point"===r.target.attributes["data-line-point"].value?"resize-over-start-point":"resize-over-end-point";else{var n=J.element.getBoundingClientRect(),i=n.right-n.left,a=n.bottom-n.top,o=r.clientX-n.left,s=r.clientY-n.top,l=!N&&i>O&&a>D&&!r.shiftKey?h.getCursor(o/i,1-s/a):"move";p(e,l),z=l.split('-')[0]}}function tt(n){v(t)||(R&&(x=G(r.xanchor)),F&&(_=Y(r.yanchor)),"path"===r.type?I=r.path:(c=R?r.x0:G(r.x0),f=F?r.y0:Y(r.y0),g=R?r.x1:G(r.x1),y=F?r.y1:Y(r.y1)),c<g?(A=c,C='x0',S=g,P='x1'):(A=g,C='x1',S=c,P='x0'),!F&&f<y||F&&f>y?(T=f,E='y0',M=y,L='y1'):(T=y,E='y1',M=f,L='y0'),$(n),at(s,r),st(e,r,t),J.moveFn="move"===z?nt:it,J.altKey=n.altKey)}function et(){v(t)||(p(e),ot(s),b(e,t,r),n.call('_guiRelayout',t,l.getUpdateObj()))}function rt()[v(t)||ot(s)]function nt(n,i){if("path"===r.type){var a=function(t){return t},o=a,l=a;R?j('xanchor',r.xanchor=W(x+n)):(o=function(t){return W(G(t)+n)},U&&"date"===U.type&&(o=m.encodeDate(o))),F?j('yanchor',r.yanchor=X(_+i)):(l=function(t){return X(Y(t)+i)},H&&"date"===H.type&&(l=m.encodeDate(l))),j('path',r.path=k(I,o,l))}else R?j('xanchor',r.xanchor=W(x+n)):(j('x0',r.x0=W(c+n)),j('x1',r.x1=W(g+n))),F?j('yanchor',r.yanchor=X(_+i)):(j('y0',r.y0=X(f+i)),j('y1',r.y1=X(y+i)));e.attr('d',w(t,r)),at(s,r)}function it(n,i){if(N){var a=function(t){return t},o=a,l=a;R?j('xanchor',r.xanchor=W(x+n)):(o=function(t){return W(G(t)+n)},U&&"date"===U.type&&(o=m.encodeDate(o))),F?j('yanchor',r.yanchor=X(_+i)):(l=function(t){return X(Y(t)+i)},H&&"date"===H.type&&(l=m.encodeDate(l))),j('path',r.path=k(I,o,l))}else if(B){if("resize-over-start-point"===z){var u=c+n,h=F?f-i:f+i;j('x0',r.x0=R?u:W(u)),j('y0',r.y0=F?h:X(h))}else if("resize-over-end-point"===z){var p=g+n,d=F?y-i:y+i;j('x1',r.x1=R?p:W(p)),j('y1',r.y1=F?d:X(d))}}else{var v=function(t){return-1!==z.indexOf(t)},b=v('n'),V=v('s'),q=v('w'),Z=v('e'),J=b?T+i:T,K=V?M+i:M,Q=q?A+n:A,$=Z?S+n:S;F&&(b&&(J=T-i),V&&(K=M-i)),(!F&&K-J>D||F&&J-K>D)&&(j(E,r[E]=F?J:X(J)),j(L,r[L]=F?K:X(K))),$-Q>O&&(j(C,r[C]=R?Q:W(Q)),j(P,r[P]=R?$:W($)))}e.attr('d',w(t,r)),at(s,r)}function at(t,e){function r(){var r="path"!==e.type,n=t.selectAll('.visual-cue').data([0]),a=1;n.enter().append('path').attr({fill:"#fff","fill-rule":"evenodd",stroke:"#000","stroke-width":a}).classed('visual-cue',!0);var o=G(R?e.xanchor:i.midRange(r?[e.x0,e.x1]:m.extractPathCoords(e.path,d.paramIsX))),s=Y(F?e.yanchor:i.midRange(r?[e.y0,e.y1]:m.extractPathCoords(e.path,d.paramIsY)));if(o=m.roundPositionForSharpStrokeRendering(o,a),s=m.roundPositionForSharpStrokeRendering(s,a),R&&F){var l="M"+(o-1-a)+","+(s-1-a)+"h-8v2h8 v8h2v-8 h8v-2h-8 v-8h-2 Z";n.attr('d',l)}else if(R){var c="M"+(o-1-a)+","+(s-9-a)+"v18 h2 v-18 Z";n.attr('d',c)}else{var u="M"+(o-9-a)+","+(s-1-a)+"h18 v2 h-18 Z";n.attr('d',u)}}(R||F)&&r()}function ot(t)[t.selectAll('.visual-cue').remove()]function st(t,e,r){var n=e.xref,i=e.yref,o=a.getFromId(r,n),s=a.getFromId(r,i),l='';"paper"===n||o.autorange||(l+=n),"paper"===i||s.autorange||(l+=i),u.setClipUrl(t,l?"clip"+r._fullLayout._uid+l:null,r)}h.init(J),Z.node().onmousemove=$}function w(t,e){var r,n,i,o,s,l,c,u,f=e.type,h=a.getRefType(e.xref),p=a.getRefType(e.yref),d=a.getFromId(t,e.xref),g=a.getFromId(t,e.yref),v=t._fullLayout._size;if(d?"domain"===h?n=function(t){return d._offset+d._length*t}:(r=m.shapePositionToRange(d),n=function(t){return d._offset+d.r2p(r(t,!0))}):n=function(t){return v.l+v.w*t},g?"domain"===p?o=function(t){return g._offset+g._length*(1-t)}:(i=m.shapePositionToRange(g),o=function(t){return g._offset+g.r2p(i(t,!0))}):o=function(t){return v.t+v.h*(1-t)},"path"===f)return d&&"date"===d.type&&(n=m.decodeDate(n)),g&&"date"===g.type&&(o=m.decodeDate(o)),T(e,n,o);if("pixel"===e.xsizemode){var y=n(e.xanchor);s=y+e.x0,l=y+e.x1}else s=n(e.x0),l=n(e.x1);if("pixel"===e.ysizemode){var x=o(e.yanchor);c=x-e.y0,u=x-e.y1}else c=o(e.y0),u=o(e.y1);if("line"===f)return"M"+s+","+c+"L"+l+","+u;if("rect"===f)return"M"+s+","+c+"H"+l+"V"+u+"H"+s+"Z";var b=(s+l)/2,_=(c+u)/2,w=Math.abs(b-s),k=Math.abs(_-c),M="A"+w+",'+k,A=b+w+',"+_;return"M"+A+M+" 0 1,1 '+b+','+(_-k)+M+' 0 0,1 "+A+"Z"}function T(t,e,r){var n=t.path,a=t.xsizemode,o=t.ysizemode,s=t.xanchor,l=t.yanchor;return n.replace(d.segmentRE,(function(t){var n=0,c=t.charAt(0),u=d.paramIsX[c],f=d.paramIsY[c],h=d.numParams[c],p=t.substr(1).replace(d.paramRE,(function(t){return u[n]?t="pixel"===a?e(s)+Number(t):e(t):f[n]&&(t="pixel"===o?r(l)-Number(t):r(t)),++n>h&&(t='X'),t}));return n>h&&(p=p.replace(/[\s,]*X.*/,''),i.log("Ignoring extra params in segment '+t)),c+p}))}function k(t,e,r){return t.replace(d.segmentRE,(function(t){var n=0,i=t.charAt(0),a=d.paramIsX[i],o=d.paramIsY[i],s=d.numParams[i];return i+t.substr(1).replace(d.paramRE,(function(t){return n>=s||(a[n]?t=e(t):o[n]&&(t=r(t)),n++),t}))}))}function M(t,e){if(y(t)){var r=+e.node().getAttribute('data-index');if(r>=0){if(r===t._fullLayout._activeShapeIndex)return void A(t);t._fullLayout._activeShapeIndex=r,t._fullLayout._deactivateShape=A,g(t)}}}function A(t){y(t)&&t._fullLayout._activeShapeIndex>=0&&(l(t),delete t._fullLayout._activeShapeIndex,g(t))}function S(t){if(y(t)){l(t);var e=t._fullLayout._activeShapeIndex,r=(t.layout||{}).shapes||[];if(e<r.length){for(var i=[],a=0;a<r.length;a++)a!==e&&i.push(r[a]);delete t._fullLayout._activeShapeIndex,n.call('_guiRelayout',t,{shapes:i})}}}e.exports={draw:g,drawOne:x,eraseActiveShape:S}},{'../../lib":787,"../../lib/setcursor":808,"../../plot_api/plot_template":827,"../../plots/cartesian/axes":838,"../../plots/cartesian/handle_outline":849,"../../registry":915,"../color":650,"../dragelement":669,"../drawing":672,"./constants":732,"./draw_newshape/display_outlines":738,"./draw_newshape/helpers":739,"./helpers":741}],735:[function(t,e,r){"use strict";var n=t('../../drawing/attributes').dash,i=t('../../../lib/extend').extendFlat;e.exports={newshape:{line:{color:{valType:"color",editType:"none"},width:{valType:"number",min:0,dflt:4,editType:"none"},dash:i({},n,{dflt:"solid",editType:"none"}),editType:"none"},fillcolor:{valType:"color",dflt:"rgba(0,0,0,0)",editType:"none"},fillrule:{valType:"enumerated",values:["evenodd","nonzero"],dflt:"evenodd",editType:"none"},opacity:{valType:"number",min:0,max:1,dflt:1,editType:"none"},layer:{valType:"enumerated",values:["below","above"],dflt:"above",editType:"none"},drawdirection:{valType:"enumerated",values:["ortho",'horizontal','vertical',"diagonal"],dflt:"diagonal",editType:"none"},editType:"none"},activeshape:{fillcolor:{valType:"color",dflt:"rgb(255,0,255)",editType:"none"},opacity:{valType:"number",min:0,max:1,dflt:.5,editType:"none"},editType:"none"}}},{"../../../lib/extend":777,"../../drawing/attributes":671}],736:[function(t,e,r){"use strict";var n=32;e.exports={CIRCLE_SIDES:n,i000:0,i090:n/4,i180:n/2,i270:n/4*3,cos45:Math.cos(Math.PI/4),sin45:Math.sin(Math.PI/4),SQRT2:Math.sqrt(2)}},{}],737:[function(t,e,r){"use strict";var n=t('../../color');e.exports=function(t,e,r){if(r('newshape.drawdirection'),r('newshape.layer'),r('newshape.fillcolor'),r('newshape.fillrule'),r('newshape.opacity'),r('newshape.line.width')){var i=(t||{}).plot_bgcolor||"#FFF";r('newshape.line.color',n.contrast(i)),r('newshape.line.dash')}r('activeshape.fillcolor'),r('activeshape.opacity')}},{"../../color":650}],738:[function(t,e,r){"use strict";var n=t('../../dragelement'),i=t('../../dragelement/helpers').drawMode,a=t('../../../registry'),o=t('./constants'),s=o.i000,l=o.i090,c=o.i180,u=o.i270,f=t('../../../plots/cartesian/handle_outline').clearOutlineControllers,h=t('./helpers'),p=h.pointsShapeRectangle,d=h.pointsShapeEllipse,m=h.writePaths,g=t('./newshapes');function v(t,e){for(var r=0;r<e.length;r++){var n=e[r];t[r]=[];for(var i=0;i<n.length;i++){t[r][i]=[];for(var a=0;a<n[i].length;a++)t[r][i][a]=n[i][a]}}return t}e.exports=function t(e,r,o,h){h||(h=0);var y=o.gd;function x(){t(e,r,o,h++),d(e[0])&&b({redrawing:!0})}function b(t){o.isActiveShape=!1;var e=g(r,o);Object.keys(e).length&&a.call((t||{}).redrawing?"relayout":"_guiRelayout",y,e)}var _,w,T,k,M,A=o.isActiveShape,S=y._fullLayout._zoomlayer,E=o.dragmode;function L(t){T=+t.srcElement.getAttribute('data-i'),k=+t.srcElement.getAttribute('data-j'),_[T][k].moveFn=C}function C(t,r){if(e.length){var n=M[T][k][1],i=M[T][k][2],a=e[T],o=a.length;if(p(a)){for(var s=0;s<o;s++)if(s!==k){var l=a[s];l[1]===a[k][1]&&(l[1]=n+t),l[2]===a[k][2]&&(l[2]=i+r)}if(a[k][1]=n+t,a[k][2]=i+r,!p(a))for(var c=0;c<o;c++)for(var u=0;u<a[c].length;u++)a[c][u]=M[T][c][u]}else a[k][1]=n+t,a[k][2]=i+r;x()}}function P()[b()]function I(){if(e.length&&e[T]&&e[T].length){for(var t=[],r=0;r<e[T].length;r++)r!==k&&t.push(e[T][r]);t.length>1&&(2!==t.length||"Z"!==t[1][0])&&(0===k&&(t[0][0]='M'),e[T]=t,x(),b())}}function z(t,r){if(2===t){T=+r.srcElement.getAttribute('data-i'),k=+r.srcElement.getAttribute('data-j');var n=e[T];p(n)||d(n)||I()}}function O(t){_=[];for(var r=0;r<e.length;r++){var i=e[r],a=!p(i)&&d(i);_[r]=[];for(var o=0;o<i.length;o++)if("Z"!==i[o][0]&&(!a||o===s||o===l||o===c||o===u)){var f=i[o][1],h=i[o][2],m=t.append('circle').classed('cursor-grab',!0).attr('data-i',r).attr('data-j',o).attr('cx',f).attr('cy',h).attr('r',4).style({"mix-blend-mode":"luminosity",fill:"black",stroke:"white","stroke-width":1});_[r][o]={element:m.node(),gd:y,prepFn:L,doneFn:P,clickFn:z},n.init(_[r][o])}}}function D(t,r){if(e.length)for(var n=0;n<e.length;n++)for(var i=0;i<e[n].length;i++)for(var a=0;a+2<e[n][i].length;a+=2)e[n][i][a+1]=M[n][i][a+1]+t,e[n][i][a+2]=M[n][i][a+2]+r}function R(t,e){D(t,e),x()}function F(t){(T=+t.srcElement.getAttribute('data-i'))||(T=0),w[T].moveFn=R}function B()[b()]function N(){if(w=[],e.length){var t=0;w[t]={element:r[0][0],gd:y,prepFn:F,doneFn:B},n.init(w[t])}}i(E)?y._fullLayout._drawing=!0:y._fullLayout._activeShapeIndex>=0&&f(y),r.attr('d',m(e)),A&&!h&&(M=v([],e),O(S.append('g').attr('class','outline-controllers')),N())}},{"../../../plots/cartesian/handle_outline":849,"../../../registry":915,"../../dragelement":669,"../../dragelement/helpers":668,"./constants":736,"./helpers":739,"./newshapes":740}],739:[function(t,e,r){"use strict";var n=t('parse-svg-path'),i=t('./constants'),a=i.CIRCLE_SIDES,o=i.SQRT2,s=t('../../../plots/cartesian/helpers'),l=s.p2r,c=s.r2p,u=[0,3,4,5,6,1,2],f=[0,3,4,1,2];function h(t,e){return Math.abs(t-e)<=1e-6}function p(t,e){var r=e[1]-t[1],n=e[2]-t[2];return Math.sqrt(r*r+n*n)}r.writePaths=function(t){var e=t.length;if(!e)return'M0,0Z';for(var r='',n=0;n<e;n++)for(var i=t[n].length,a=0;a<i;a++){var o=t[n][a][0];if("Z"===o)r+='Z';else for(var s=t[n][a].length,l=0;l<s;l++){var c=l;"Q"===o||"S"===o?c=f[l]:"C"===o&&(c=u[l]),r+=t[n][a][c],l>0&&l<s-1&&(r+=',')}}return r},r.readPaths=function(t,e,r,i){var o,s,u,f=n(t),h=[],p=-1,d=function(){p++,h[p]=[]},m=0,g=0,v=function(){s=m,u=g};v();for(var y=0;y<f.length;y++){var x,b,_,w,T=[],k=f[y][0],M=k;switch(k){case"M":d(),m=+f[y][1],g=+f[y][2],T.push([M,m,g]),v();break;case"Q":case"S":x=+f[y][1],_=+f[y][2],m=+f[y][3],g=+f[y][4],T.push([M,m,g,x,_]);break;case"C":x=+f[y][1],_=+f[y][2],b=+f[y][3],w=+f[y][4],m=+f[y][5],g=+f[y][6],T.push([M,m,g,x,_,b,w]);break;case"T":case"L":m=+f[y][1],g=+f[y][2],T.push([M,m,g]);break;case"H":M='L',m=+f[y][1],T.push([M,m,g]);break;case"V":M='L',g=+f[y][1],T.push([M,m,g]);break;case"A":M='L';var A=+f[y][1],S=+f[y][2];+f[y][4]||(A=-A,S=-S);var E=m-A,L=g;for(o=1;o<=a/2;o++){var C=2*Math.PI*o/a;T.push([M,E+A*Math.cos(C),L+S*Math.sin(C)])}break;case"Z":m===s&&g===u||(m=s,g=u,T.push([M,m,g]))}for(var P=(r||{}).domain,I=e._fullLayout._size,z=r&&"pixel"===r.xsizemode,O=r&&"pixel"===r.ysizemode,D=!1===i,R=0;R<T.length;R++){for(o=0;o+2<7;o+=2){var F=T[R][o+1],B=T[R][o+2];void 0!==F&&void 0!==B&&(m=F,g=B,r&&(r.xaxis&&r.xaxis.p2r?(D&&(F-=r.xaxis._offset),F=z?c(r.xaxis,r.xanchor)+F:l(r.xaxis,F)):(D&&(F-=I.l),P?F=P.x[0]+F/I.w:F/=I.w),r.yaxis&&r.yaxis.p2r?(D&&(B-=r.yaxis._offset),B=O?c(r.yaxis,r.yanchor)-B:l(r.yaxis,B)):(D&&(B-=I.t),B=P?P.y[1]-B/I.h:1-B/I.h)),T[R][o+1]=F,T[R][o+2]=B)}h[p].push(T[R].slice())}}return h},r.pointsShapeRectangle=function(t){if(5!==t.length)return!1;for(var e=1;e<3;e++){if(!h(t[0][e]-t[1][e],t[3][e]-t[2][e]))return!1;if(!h(t[0][e]-t[3][e],t[1][e]-t[2][e]))return!1}return!(!h(t[0][1],t[1][1])&&!h(t[0][1],t[3][1]))&&!!(p(t[0],t[1])*p(t[0],t[3]))},r.pointsShapeEllipse=function(t){var e=t.length;if(e!==a+1)return!1;e=a;for(var r=0;r<e;r++){var n=(2*e-r)%e,i=(e/2+n)%e,o=(e/2+r)%e;if(!h(p(t[r],t[o]),p(t[n],t[i])))return!1}return!0},r.handleEllipse=function(t,e,n){if(!t)return[e,n];var i=r.ellipseOver({x0:e[0],y0:e[1],x1:n[0],y1:n[1]}),s=(i.x1+i.x0)/2,l=(i.y1+i.y0)/2,c=(i.x1-i.x0)/2,u=(i.y1-i.y0)/2;c||(c=u/=o),u||(u=c/=o);for(var f=[],h=0;h<a;h++){var p=2*h*Math.PI/a;f.push([s+c*Math.cos(p),l+u*Math.sin(p)])}return f},r.ellipseOver=function(t){var e=t.x0,r=t.y0,n=t.x1,i=t.y1,a=n-e,s=i-r,l=((e-=a)+n)/2,c=((r-=s)+i)/2;return{x0:l-(a*=o),y0:c-(s*=o),x1:l+a,y1:c+s}}},{"../../../plots/cartesian/helpers":850,"./constants":736,"parse-svg-path":482}],740:[function(t,e,r){"use strict";var n=t('../../dragelement/helpers'),i=n.drawMode,a=n.openMode,o=t('./constants'),s=o.i000,l=o.i090,c=o.i180,u=o.i270,f=o.cos45,h=o.sin45,p=t('../../../plots/cartesian/helpers'),d=p.p2r,m=p.r2p,g=t('../../../plots/cartesian/handle_outline').clearSelect,v=t('./helpers'),y=v.readPaths,x=v.writePaths,b=v.ellipseOver;function _(t,e,r){var n="date"===e.type,i="date"===r.type;if(!n&&!i)return t;for(var a=0;a<t.length;a++)for(var o=0;o<t[a].length;o++)for(var s=0;s+2<t[a][o].length;s+=2)n&&(t[a][o][s+1]=t[a][o][s+1].replace(' ','_')),i&&(t[a][o][s+2]=t[a][o][s+2].replace(' ','_'));return t}e.exports=function(t,e){if(t.length){var r=t[0][0];if(r){var n=r.getAttribute('d'),o=e.gd,p=o._fullLayout.newshape,v=e.plotinfo,w=v.xaxis,T=v.yaxis,k=!!v.domain||!v.xaxis,M=!!v.domain||!v.yaxis,A=e.isActiveShape,S=e.dragmode,E=(o.layout||{}).shapes||[];if(!i(S)&&void 0!==A){var L=o._fullLayout._activeShapeIndex;if(L<E.length)switch(o._fullLayout.shapes[L].type){case"rect":S='drawrect';break;case"circle":S='drawcircle';break;case"line":S='drawline';break;case"path":var C=E[L].path||"";S="Z"===C[C.length-1]?"drawclosedpath":"drawopenpath"}}var P,I=a(S),z=y(n,o,v,A),O={editable:!0,xref:k?"paper":w._id,yref:M?"paper":T._id,layer:p.layer,opacity:p.opacity,line:{color:p.line.color,width:p.line.width,dash:p.line.dash}};if(I||(O.fillcolor=p.fillcolor,O.fillrule=p.fillrule),1===z.length&&(P=z[0]),P&&"drawrect"===S)O.type='rect',O.x0=P[0][1],O.y0=P[0][2],O.x1=P[2][1],O.y1=P[2][2];else if(P&&"drawline"===S)O.type='line',O.x0=P[0][1],O.y0=P[0][2],O.x1=P[1][1],O.y1=P[1][2];else if(P&&"drawcircle"===S){O.type='circle';var D=P[s][1],R=P[l][1],F=P[c][1],B=P[u][1],N=P[s][2],j=P[l][2],U=P[c][2],V=P[u][2],H=v.xaxis&&("date"===v.xaxis.type||"log"===v.xaxis.type),q=v.yaxis&&("date"===v.yaxis.type||"log"===v.yaxis.type);H&&(D=m(v.xaxis,D),R=m(v.xaxis,R),F=m(v.xaxis,F),B=m(v.xaxis,B)),q&&(N=m(v.yaxis,N),j=m(v.yaxis,j),U=m(v.yaxis,U),V=m(v.yaxis,V));var G=(R+B)/2,Y=(N+U)/2,W=b({x0:G,y0:Y,x1:G+(B-R+F-D)/2*f,y1:Y+(V-j+U-N)/2*h});H&&(W.x0=d(v.xaxis,W.x0),W.x1=d(v.xaxis,W.x1)),q&&(W.y0=d(v.yaxis,W.y0),W.y1=d(v.yaxis,W.y1)),O.x0=W.x0,O.y0=W.y0,O.x1=W.x1,O.y1=W.y1}else O.type='path',w&&T&&_(z,w,T),O.path=x(z),P=null;g(o);for(var X=e.editHelpers,Z=(X||{}).modifyItem,J=[],K=0;K<E.length;K++){var Q=o._fullLayout.shapes[K];if(J[K]=Q._input,void 0!==A&&K===o._fullLayout._activeShapeIndex){var $=O;switch(Q.type){case"line":case"rect":case"circle":Z('x0',$.x0),Z('x1',$.x1),Z('y0',$.y0),Z('y1',$.y1);break;case"path":Z('path',$.path)}}}return void 0===A?(J.push(O),J):X?X.getUpdateObj():{}}}}},{"../../../plots/cartesian/handle_outline":849,"../../../plots/cartesian/helpers":850,"../../dragelement/helpers":668,"./constants":736,"./helpers":739}],741:[function(t,e,r){"use strict";var n=t('./constants'),i=t('../../lib');r.rangeToShapePosition=function(t){return"log"===t.type?t.r2d:function(t){return t}},r.shapePositionToRange=function(t){return"log"===t.type?t.d2r:function(t){return t}},r.decodeDate=function(t){return function(e){return e.replace&&(e=e.replace('_',' ')),t(e)}},r.encodeDate=function(t){return function(e){return t(e).replace(' ','_')}},r.extractPathCoords=function(t,e){var r=[];return t.match(n.segmentRE).forEach((function(t){var a=e[t.charAt(0)].drawn;if(void 0!==a){var o=t.substr(1).match(n.paramRE);!o||o.length<a||r.push(i.cleanNumber(o[a]))}})),r},r.getDataToPixel=function(t,e,n,i){var a,o=t._fullLayout._size;if(e)if("domain"===i)a=function(t){return e._length*(n?1-t:t)+e._offset};else{var s=r.shapePositionToRange(e);a=function(t){return e._offset+e.r2p(s(t,!0))},"date"===e.type&&(a=r.decodeDate(a))}else a=n?function(t){return o.t+o.h*(1-t)}:function(t){return o.l+o.w*t};return a},r.getPixelToData=function(t,e,n,i){var a,o=t._fullLayout._size;if(e)if("domain"===i)a=function(t){var r=(t-e._offset)/e._length;return n?1-r:r};else{var s=r.rangeToShapePosition(e);a=function(t){return s(e.p2r(t-e._offset))}}else a=n?function(t){return 1-(t-o.t)/o.h}:function(t){return(t-o.l)/o.w};return a},r.roundPositionForSharpStrokeRendering=function(t,e){var r=1===Math.round(e%2),n=Math.round(t);return r?n+.5:n},r.makeOptionsAndPlotinfo=function(t,e)[var r=t._fullLayout.shapes[e]||{],n=t._fullLayout._plots[r.xref+r.yref];return n?n._hadPlotinfo=!0:(n={},r.xref&&"paper"!==r.xref&&(n.xaxis=t._fullLayout[r.xref+"axis"]),r.yref&&"paper"!==r.yref&&(n.yaxis=t._fullLayout[r.yref+"axis"])),n.xsizemode=r.xsizemode,n.ysizemode=r.ysizemode,n.xanchor=r.xanchor,n.yanchor=r.yanchor,{options:r,plotinfo:n}}},{"../../lib":787,"./constants":732}],742:[function(t,e,r){"use strict";var n=t('./draw');e.exports={moduleType:"component",name:"shapes",layoutAttributes:t('./attributes'),supplyLayoutDefaults:t('./defaults'),supplyDrawNewShapeDefaults:t('./draw_newshape/defaults'),includeBasePlot:t('../../plots/cartesian/include_components')('shapes'),calcAutorange:t('./calc_autorange'),draw:n.draw,drawOne:n.drawOne}},{"../../plots/cartesian/include_components":851,"./attributes":730,"./calc_autorange":731,"./defaults":733,"./draw":734,"./draw_newshape/defaults":737}],743:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('../../plots/pad_attributes'),a=t('../../lib/extend').extendDeepAll,o=t('../../plot_api/edit_types').overrideAll,s=t('../../plots/animation_attributes'),l=t('../../plot_api/plot_template').templatedArray,c=t('./constants'),u=l('step',{visible:{valType:"boolean",dflt:!0},method:{valType:"enumerated",values:["restyle",'relayout','animate','update',"skip"],dflt:"restyle"},args:{valType:"info_array",freeLength:!0,items:[valType:"any"},{valType:"any"},{valType:"any"}],label:{valType:"string"},value:{valType:"string"},execute:{valType:"boolean",dflt:!0}});e.exports=o(l('slider',{visible:{valType:"boolean",dflt:!0},active:{valType:"number",min:0,dflt:0},steps:u,lenmode:{valType:"enumerated",values:["fraction","pixels"],dflt:"fraction"},len:{valType:"number",min:0,dflt:1},x:{valType:"number",min:-2,max:3,dflt:0},pad:a(i({editType:"arraydraw"}),{},{t:{dflt:20}}),xanchor:{valType:"enumerated",values:["auto",'left','center',"right"],dflt:"left"},y:{valType:"number",min:-2,max:3,dflt:0},yanchor:{valType:"enumerated",values:["auto",'top','middle',"bottom"],dflt:"top"},transition:{duration:{valType:"number",min:0,dflt:150},easing:{valType:"enumerated",values:s.transition.easing.values,dflt:"cubic-in-out"}},currentvalue:{visible:{valType:"boolean",dflt:!0},xanchor:{valType:"enumerated",values:["left",'center',"right"],dflt:"left"},offset:{valType:"number",dflt:10},prefix:{valType:"string"},suffix:{valType:"string"},font:n({})},font:n({}),activebgcolor:{valType:"color",dflt:c.gripBgActiveColor},bgcolor:{valType:"color",dflt:c.railBgColor},bordercolor:{valType:"color",dflt:c.railBorderColor},borderwidth:{valType:"number",min:0,dflt:c.railBorderWidth},ticklen:{valType:"number",min:0,dflt:c.tickLength},tickcolor:{valType:"color",dflt:c.tickColor},tickwidth:{valType:"number",min:0,dflt:1},minorticklen:{valType:"number",min:0,dflt:c.minorTickLength}}),'arraydraw','from-root')},{"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plot_api/plot_template":827,"../../plots/animation_attributes":832,"../../plots/font_attributes":867,"../../plots/pad_attributes":900,"./constants":744}],744:[function(t,e,r){"use strict";e.exports={name:"sliders",containerClassName:"slider-container",groupClassName:"slider-group",inputAreaClass:"slider-input-area",railRectClass:"slider-rail-rect",railTouchRectClass:"slider-rail-touch-rect",gripRectClass:"slider-grip-rect",tickRectClass:"slider-tick-rect",inputProxyClass:"slider-input-proxy",labelsClass:"slider-labels",labelGroupClass:"slider-label-group",labelClass:"slider-label",currentValueClass:"slider-current-value",railHeight:5,menuIndexAttrName:"slider-active-index",autoMarginIdRoot:"slider-",minWidth:30,minHeight:30,textPadX:40,arrowOffsetX:4,railRadius:2,railWidth:5,railBorder:4,railBorderWidth:1,railBorderColor:"#bec8d9",railBgColor:"#f8fafc",railInset:8,stepInset:10,gripRadius:10,gripWidth:20,gripHeight:20,gripBorder:20,gripBorderWidth:1,gripBorderColor:"#bec8d9",gripBgColor:"#f6f8fa",gripBgActiveColor:"#dbdde0",labelPadding:8,labelOffset:0,tickWidth:1,tickColor:"#333",tickOffset:25,tickLength:7,minorTickOffset:25,minorTickColor:"#333",minorTickLength:4,currentValuePadding:8,currentValueInset:0}},{}],745:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/array_container_defaults'),a=t('./attributes'),o=t('./constants').name,s=a.steps;function l(t,e,r){function o(r,i){return n.coerce(t,e,a,r,i)}for(var s=i(t,e,{name:"steps",handleItemDefaults:c}),l=0,u=0;u<s.length;u++)s[u].visible&&l++;if(l<2?e.visible=!1:o('visible')){e._stepCount=l;var f=e._visibleSteps=n.filterVisible(s);(s[o('active')]||{}).visible||(e.active=f[0]._index),o('x'),o('y'),n.noneOrAll(t,e,["x","y"]),o('xanchor'),o('yanchor'),o('len'),o('lenmode'),o('pad.t'),o('pad.r'),o('pad.b'),o('pad.l'),n.coerceFont(o,'font',r.font),o('currentvalue.visible')&&(o('currentvalue.xanchor'),o('currentvalue.prefix'),o('currentvalue.suffix'),o('currentvalue.offset'),n.coerceFont(o,'currentvalue.font',e.font)),o('transition.duration'),o('transition.easing'),o('bgcolor'),o('activebgcolor'),o('bordercolor'),o('borderwidth'),o('ticklen'),o('tickwidth'),o('tickcolor'),o('minorticklen')}}function c(t,e){function r(r,i){return n.coerce(t,e,s,r,i)}if("skip"===t.method||Array.isArray(t.args)?r('visible'):e.visible=!1){r('method'),r('args');var i=r('label',"step-"+e._index);r('value',i),r('execute')}}e.exports=function(t,e){i(t,e,{name:o,handleItemDefaults:l})}},{"../../lib":787,"../../plots/array_container_defaults":833,"./attributes":743,"./constants":744}],746:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../plots/plots'),a=t('../color'),o=t('../drawing'),s=t('../../lib'),l=s.strTranslate,c=t('../../lib/svg_text_utils'),u=t('../../plot_api/plot_template').arrayEditor,f=t('./constants'),h=t('../../constants/alignment'),p=h.LINE_SPACING,d=h.FROM_TL,m=h.FROM_BR;function g(t){return f.autoMarginIdRoot+t._index}function v(t,e){for(var r=t[f.name],n=[],i=0;i<r.length;i++){var a=r[i];a.visible&&(a._gd=e,n.push(a))}return n}function y(t){return t._index}function x(t,e){var r=o.tester.selectAll("g."+f.labelGroupClass).data(e._visibleSteps);r.enter().append('g').classed(f.labelGroupClass,!0);var a=0,l=0;r.each((function(t){var r=T(n.select(this),{step:t},e).node();if(r){var i=o.bBox(r);l=Math.max(l,i.height),a=Math.max(a,i.width)}})),r.remove();var u=e._dims={};u.inputAreaWidth=Math.max(f.railWidth,f.gripHeight);var h=t._fullLayout._size;u.lx=h.l+h.w*e.x,u.ly=h.t+h.h*(1-e.y),"fraction"===e.lenmode?u.outerLength=Math.round(h.w*e.len):u.outerLength=e.len,u.inputAreaStart=0,u.inputAreaLength=Math.round(u.outerLength-e.pad.l-e.pad.r);var p=(u.inputAreaLength-2*f.stepInset)/(e._stepCount-1),v=a+f.labelPadding;if(u.labelStride=Math.max(1,Math.ceil(v/p)),u.labelHeight=l,u.currentValueMaxWidth=0,u.currentValueHeight=0,u.currentValueTotalHeight=0,u.currentValueMaxLines=1,e.currentvalue.visible){var y=o.tester.append('g');r.each((function(t){var r=_(y,e,t.label),n=r.node()&&o.bBox(r.node())||{width:0,height:0},i=c.lineCount(r);u.currentValueMaxWidth=Math.max(u.currentValueMaxWidth,Math.ceil(n.width)),u.currentValueHeight=Math.max(u.currentValueHeight,Math.ceil(n.height)),u.currentValueMaxLines=Math.max(u.currentValueMaxLines,i)})),u.currentValueTotalHeight=u.currentValueHeight+e.currentvalue.offset,y.remove()}u.height=u.currentValueTotalHeight+f.tickOffset+e.ticklen+f.labelOffset+u.labelHeight+e.pad.t+e.pad.b;var x='left';s.isRightAnchor(e)&&(u.lx-=u.outerLength,x='right'),s.isCenterAnchor(e)&&(u.lx-=u.outerLength/2,x='center');var b='top';s.isBottomAnchor(e)&&(u.ly-=u.height,b='bottom'),s.isMiddleAnchor(e)&&(u.ly-=u.height/2,b='middle'),u.outerLength=Math.ceil(u.outerLength),u.height=Math.ceil(u.height),u.lx=Math.round(u.lx),u.ly=Math.round(u.ly);var w={y:e.y,b:u.height*m[b],t:u.height*d[b]};"fraction"===e.lenmode?(w.l=0,w.xl=e.x-e.len*d[x],w.r=0,w.xr=e.x+e.len*m[x]):(w.x=e.x,w.l=u.outerLength*d[x],w.r=u.outerLength*m[x]),i.autoMargin(t,g(e),w)}function b(t,e,r)[(r.steps[r.active]||{]).visible||(r.active=r._visibleSteps[0]._index),e.call(_,r).call(O,r).call(k,r).call(E,r).call(z,t,r).call(w,t,r);var n=r._dims;o.setTranslate(e,n.lx+r.pad.l,n.ly+r.pad.t),e.call(C,r,!1),e.call(_,r)}function _(t,e,r){if(e.currentvalue.visible){var n,i,a=e._dims;switch(e.currentvalue.xanchor){case"right":n=a.inputAreaLength-f.currentValueInset-a.currentValueMaxWidth,i='left';break;case"center":n=.5*a.inputAreaLength,i='middle';break;default:n=f.currentValueInset,i="left"}var l=s.ensureSingle(t,'text',f.labelClass,(function(t){t.attr({"text-anchor":i,"data-notex":1})})),u=e.currentvalue.prefix?e.currentvalue.prefix:"";if("string"===typeof r)u+=r;else{var h=e.steps[e.active].label,d=e._gd._fullLayout._meta;d&&(h=s.templateString(h,d)),u+=h}e.currentvalue.suffix&&(u+=e.currentvalue.suffix),l.call(o.font,e.currentvalue.font).text(u).call(c.convertToTspans,e._gd);var m=c.lineCount(l),g=(a.currentValueMaxLines+1-m)*e.currentvalue.font.size*p;return c.positionText(l,n,g),l}}function w(t,e,r){s.ensureSingle(t,'rect',f.gripRectClass,(function(n){n.call(S,e,t,r).style('pointer-events','all')})).attr({width:f.gripWidth,height:f.gripHeight,rx:f.gripRadius,ry:f.gripRadius}).call(a.stroke,r.bordercolor).call(a.fill,r.bgcolor).style('stroke-width',r.borderwidth+"px")}function T(t,e,r){var n=s.ensureSingle(t,'text',f.labelClass,(function(t){t.attr({"text-anchor":"middle","data-notex":1})})),i=e.step.label,a=r._gd._fullLayout._meta;return a&&(i=s.templateString(i,a)),n.call(o.font,r.font).text(i).call(c.convertToTspans,r._gd),n}function k(t,e){var r=s.ensureSingle(t,'g',f.labelsClass),i=e._dims,a=r.selectAll("g."+f.labelGroupClass).data(i.labelSteps);a.enter().append('g').classed(f.labelGroupClass,!0),a.exit().remove(),a.each((function(t){var r=n.select(this);r.call(T,t,e),o.setTranslate(r,P(e,t.fraction),f.tickOffset+e.ticklen+e.font.size*p+f.labelOffset+i.currentValueTotalHeight)}))}function M(t,e,r,n,i){var a=Math.round(n*(r._stepCount-1)),o=r._visibleSteps[a]._index;o!==r.active&&A(t,e,r,o,!0,i)}function A(t,e,r,n,a,o){var s=r.active;r.active=n,u(t.layout,f.name,r).applyUpdate('active',n);var l=r.steps[r.active];e.call(C,r,o),e.call(_,r),t.emit('plotly_sliderchange',{slider:r,step:r.steps[r.active],interaction:a,previousActive:s}),l&&l.method&&a&&(e._nextMethod?(e._nextMethod.step=l,e._nextMethod.doCallback=a,e._nextMethod.doTransition=o):(e._nextMethod={step:l,doCallback:a,doTransition:o},e._nextMethodRaf=window.requestAnimationFrame((function(){var r=e._nextMethod.step;r.method&&(r.execute&&i.executeAPICommand(t,r.method,r.args),e._nextMethod=null,e._nextMethodRaf=null)}))))}function S(t,e,r){var i=r.node(),o=n.select(e);function s(){return r.data()[0]}function l(){var t=s();e.emit('plotly_sliderstart',{slider:t});var l=r.select("."+f.gripRectClass);n.event.stopPropagation(),n.event.preventDefault(),l.call(a.fill,t.activebgcolor);var c=I(t,n.mouse(i)[0]);function u(){var t=s(),a=I(t,n.mouse(i)[0]);M(e,r,t,a,!1)}function h(){var t=s();t._dragging=!1,l.call(a.fill,t.bgcolor),o.on('mouseup',null),o.on('mousemove',null),o.on('touchend',null),o.on('touchmove',null),e.emit('plotly_sliderend',{slider:t,step:t.steps[t.active]})}M(e,r,t,c,!0),t._dragging=!0,o.on('mousemove',u),o.on('touchmove',u),o.on('mouseup',h),o.on('touchend',h)}t.on('mousedown',l),t.on('touchstart',l)}function E(t,e){var r=t.selectAll("rect."+f.tickRectClass).data(e._visibleSteps),i=e._dims;r.enter().append('rect').classed(f.tickRectClass,!0),r.exit().remove(),r.attr({width:e.tickwidth+"px","shape-rendering":"crispEdges"}),r.each((function(t,r){var s=r%i.labelStride===0,l=n.select(this);l.attr({height:s?e.ticklen:e.minorticklen}).call(a.fill,e.tickcolor),o.setTranslate(l,P(e,r/(e._stepCount-1))-.5*e.tickwidth,(s?f.tickOffset:f.minorTickOffset)+i.currentValueTotalHeight)}))}function L(t){var e=t._dims;e.labelSteps=[];for(var r=t._stepCount,n=0;n<r;n+=e.labelStride)e.labelSteps.push({fraction:n/(r-1),step:t._visibleSteps[n]})}function C(t,e,r){for(var n=t.select("rect."+f.gripRectClass),i=0,a=0;a<e._stepCount;a++)if(e._visibleSteps[a]._index===e.active){i=a;break}var o=P(e,i/(e._stepCount-1));if(!e._invokingCommand){var s=n;r&&e.transition.duration>0&&(s=s.transition().duration(e.transition.duration).ease(e.transition.easing)),s.attr('transform',l(o-.5*f.gripWidth,e._dims.currentValueTotalHeight))}}function P(t,e){var r=t._dims;return r.inputAreaStart+f.stepInset+(r.inputAreaLength-2*f.stepInset)*Math.min(1,Math.max(0,e))}function I(t,e){var r=t._dims;return Math.min(1,Math.max(0,(e-f.stepInset-r.inputAreaStart)/(r.inputAreaLength-2*f.stepInset-2*r.inputAreaStart)))}function z(t,e,r){var n=r._dims,i=s.ensureSingle(t,'rect',f.railTouchRectClass,(function(n){n.call(S,e,t,r).style('pointer-events','all')}));i.attr({width:n.inputAreaLength,height:Math.max(n.inputAreaWidth,f.tickOffset+r.ticklen+n.labelHeight)}).call(a.fill,r.bgcolor).attr('opacity',0),o.setTranslate(i,0,n.currentValueTotalHeight)}function O(t,e){var r=e._dims,n=r.inputAreaLength-2*f.railInset,i=s.ensureSingle(t,'rect',f.railRectClass);i.attr({width:n,height:f.railWidth,rx:f.railRadius,ry:f.railRadius,"shape-rendering":"crispEdges"}).call(a.stroke,e.bordercolor).call(a.fill,e.bgcolor).style('stroke-width',e.borderwidth+"px"),o.setTranslate(i,f.railInset,.5*(r.inputAreaWidth-f.railWidth)+r.currentValueTotalHeight)}e.exports=function(t){var e=t._fullLayout,r=v(e,t),a=e._infolayer.selectAll("g."+f.containerClassName).data(r.length>0?[0]:[]);function o(e){e._commandObserver&&(e._commandObserver.remove(),delete e._commandObserver),i.autoMargin(t,g(e))}if(a.enter().append('g').classed(f.containerClassName,!0).style('cursor','ew-resize'),a.exit().each((function()[n.select(this).selectAll("g."+f.groupClassName).each(o)])).remove(),0!==r.length){var s=a.selectAll("g."+f.groupClassName).data(r,y);s.enter().append('g').classed(f.groupClassName,!0),s.exit().each(o).remove();for(var l=0;l<r.length;l++){var c=r[l];x(t,c)}s.each((function(e){var r=n.select(this);L(e),i.manageCommandObserver(t,e,e._visibleSteps,(function(e){var n=r.data()[0];n.active!==e.index&&(n._dragging||A(t,r,n,e.index,!1,!0))})),b(t,n.select(this),e)}))}}},{"../../constants/alignment":755,"../../lib":787,"../../lib/svg_text_utils":813,"../../plot_api/plot_template":827,"../../plots/plots":901,"../color":650,"../drawing":672,"./constants":744,"@plotly/d3":58}],747:[function(t,e,r){"use strict";var n=t('./constants');e.exports={moduleType:"component",name:n.name,layoutAttributes:t('./attributes'),supplyLayoutDefaults:t('./defaults'),draw:t('./draw')}},{"./attributes":743,"./constants":744,"./defaults":745,"./draw":746}],748:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../../plots/plots'),o=t('../../registry'),s=t('../../lib'),l=s.strTranslate,c=t('../drawing'),u=t('../color'),f=t('../../lib/svg_text_utils'),h=t('../../constants/interactions'),p=t('../../constants/alignment').OPPOSITE_SIDE,d=/ [XY][0-9]* /;function m(t,e,r){var m,g=r.propContainer,v=r.propName,y=r.placeholder,x=r.traceIndex,b=r.avoid||{},_=r.attributes,w=r.transform,T=r.containerGroup,k=t._fullLayout,M=1,A=!1,S=g.title,E=(S&&S.text?S.text:"").trim(),L=S&&S.font?S.font:{},C=L.family,P=L.size,I=L.color;"title.text"===v?m="titleText":-1!==v.indexOf('axis')?m="axisTitleText":v.indexOf(!0)&&(m='colorbarTitleText');var z=t._context.edits[m];""===E?M=0:E.replace(d,' % ')===y.replace(d,' % ')&&(M=.2,A=!0,z||(E='')),r._meta?E=s.templateString(E,r._meta):k._meta&&(E=s.templateString(E,k._meta));var O=E||z;T||(T=s.ensureSingle(k._infolayer,'g',"g-"+e));var D=T.selectAll('text').data(O?[0]:[]);if(D.enter().append('text'),D.text(E).attr('class',e),D.exit().remove(),!O)return T;function R(t){s.syncOrAsync([F,B],t)}function F(e){var r;return w?(r='',w.rotate&&(r+='rotate('+[w.rotate,_.x,_.y]+')'),w.offset&&(r+=l(0,w.offset))):r=null,e.attr('transform',r),e.style({"font-family":C,"font-size":n.round(P,2)+"px",fill:u.rgb(I),opacity:M*u.opacity(I),"font-weight":a.fontWeight}).attr(_).call(f.convertToTspans,t),a.previousPromises(t)}function B(t){var e=n.select(t.node().parentNode);if(b&&b.selection&&b.side&&E){e.attr('transform',null);var r=p[b.side],a="left"===b.side||"top"===b.side?-1:1,o=i(b.pad)?b.pad:2,u=c.bBox(e.node()),f={left:0,top:0,right:k.width,bottom:k.height},h=b.maxShift||a*(f[b.side]-u[b.side]),d=0;if(h<0)d=h;else{var m=b.offsetLeft||0,g=b.offsetTop||0;u.left-=m,u.right-=m,u.top-=g,u.bottom-=g,b.selection.each((function(){var t=c.bBox(this);s.bBoxIntersect(u,t,o)&&(d=Math.max(d,a*(t[b.side]-u[r])+o))})),d=Math.min(h,d)}if(d>0||h<0){var v={left:[-d,0],right:[d,0],top:[0,-d],bottom:[0,d]}[b.side];e.attr('transform',l(v[0],v[1]))}}}function N(){M=0,A=!0,D.text(y).on('mouseover.opacity',(function(){n.select(this).transition().duration(h.SHOW_PLACEHOLDER).style('opacity',1)})).on('mouseout.opacity',(function(){n.select(this).transition().duration(h.HIDE_PLACEHOLDER).style('opacity',0)}))}return D.call(R),z&&(E?D.on('.opacity',null):N(),D.call(f.makeEditable,{gd:t}).on('edit',(function(e){void 0!==x?o.call('_guiRestyle',t,v,e,x):o.call('_guiRelayout',t,v,e)})).on('cancel',(function()[this.text(this.attr('data-unformatted')).call(R)])).on('input',(function(t){this.text(t||" ').call(f.positionText,_.x,_.y)}))),D.classed('js-placeholder',A),T}e.exports={draw:m}},{'../../constants/alignment":755,"../../constants/interactions":762,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/plots":901,"../../registry":915,"../color":650,"../drawing":672,"@plotly/d3":58,"fast-isnumeric":246}],749:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('../color/attributes'),a=t('../../lib/extend').extendFlat,o=t('../../plot_api/edit_types').overrideAll,s=t('../../plots/pad_attributes'),l=t('../../plot_api/plot_template').templatedArray,c=l('button',{visible:{valType:"boolean"},method:{valType:"enumerated",values:["restyle",'relayout','animate','update',"skip"],dflt:"restyle"},args:{valType:"info_array",freeLength:!0,items:[valType:"any"},{valType:"any"},{valType:"any"}],args2:{valType:"info_array",freeLength:!0,items:[valType:"any"},{valType:"any"},{valType:"any"}],label:{valType:"string",dflt:""},execute:{valType:"boolean",dflt:!0}});e.exports=o(l('updatemenu',{_arrayAttrRegexps:[/^updatemenus\[(0|[1-9][0-9]+)\]\.buttons/],visible:{valType:"boolean"},type:{valType:"enumerated",values:["dropdown","buttons"],dflt:"dropdown"},direction:{valType:"enumerated",values:["left",'right','up',"down"],dflt:"down"},active:{valType:"integer",min:-1,dflt:0},showactive:{valType:"boolean",dflt:!0},buttons:c,x:{valType:"number",min:-2,max:3,dflt:-.05},xanchor:{valType:"enumerated",values:["auto",'left','center',"right"],dflt:"right"},y:{valType:"number",min:-2,max:3,dflt:1},yanchor:{valType:"enumerated",values:["auto",'top','middle',"bottom"],dflt:"top"},pad:a(s({editType:"arraydraw"}),{}),font:n({}),bgcolor:{valType:"color"},bordercolor:{valType:"color",dflt:i.borderLine},borderwidth:{valType:"number",min:0,dflt:1,editType:"arraydraw"}}),'arraydraw','from-root')},{"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plot_api/plot_template":827,"../../plots/font_attributes":867,"../../plots/pad_attributes":900,"../color/attributes":649}],750:[function(t,e,r){"use strict";e.exports={name:"updatemenus",containerClassName:"updatemenu-container",headerGroupClassName:"updatemenu-header-group",headerClassName:"updatemenu-header",headerArrowClassName:"updatemenu-header-arrow",dropdownButtonGroupClassName:"updatemenu-dropdown-button-group",dropdownButtonClassName:"updatemenu-dropdown-button",buttonClassName:"updatemenu-button",itemRectClassName:"updatemenu-item-rect",itemTextClassName:"updatemenu-item-text",menuIndexAttrName:"updatemenu-active-index",autoMarginIdRoot:"updatemenu-",blankHeaderOpts:{label:"  "},minWidth:30,minHeight:30,textPadX:24,arrowPadX:16,rx:2,ry:2,textOffsetX:12,textOffsetY:3,arrowOffsetX:4,gapButtonHeader:5,gapButton:2,activeColor:"#F4FAFF",hoverColor:"#F4FAFF",arrowSymbol:{left:"\u25c4",right:"\u25ba",up:"\u25b2",down:"\u25bc"}}},{}],751:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/array_container_defaults'),a=t('./attributes'),o=t('./constants').name,s=a.buttons;function l(t,e,r){function o(r,i){return n.coerce(t,e,a,r,i)}o('visible',i(t,e,{name:"buttons",handleItemDefaults:c}).length>0)&&(o('active'),o('direction'),o('type'),o('showactive'),o('x'),o('y'),n.noneOrAll(t,e,["x","y"]),o('xanchor'),o('yanchor'),o('pad.t'),o('pad.r'),o('pad.b'),o('pad.l'),n.coerceFont(o,'font',r.font),o('bgcolor',r.paper_bgcolor),o('bordercolor'),o('borderwidth'))}function c(t,e){function r(r,i){return n.coerce(t,e,s,r,i)}r('visible',"skip"===t.method||Array.isArray(t.args))&&(r('method'),r('args'),r('args2'),r('label'),r('execute'))}e.exports=function(t,e){i(t,e,{name:o,handleItemDefaults:l})}},{"../../lib":787,"../../plots/array_container_defaults":833,"./attributes":749,"./constants":750}],752:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../plots/plots'),a=t('../color'),o=t('../drawing'),s=t('../../lib'),l=t('../../lib/svg_text_utils'),c=t('../../plot_api/plot_template').arrayEditor,u=t('../../constants/alignment').LINE_SPACING,f=t('./constants'),h=t('./scrollbox');function p(t){return t._index}function d(t){return-1===+t.attr(f.menuIndexAttrName)}function m(t,e){return+t.attr(f.menuIndexAttrName)===e._index}function g(t,e,r,n,i,a,o,s){e.active=o,c(t.layout,f.name,e).applyUpdate('active',o),"buttons"===e.type?y(t,n,null,null,e):"dropdown"===e.type&&(i.attr(f.menuIndexAttrName,'-1'),v(t,n,i,a,e),s||y(t,n,i,a,e))}function v(t,e,r,n,i){var a=s.ensureSingle(e,'g',f.headerClassName,(function(t){t.style('pointer-events','all')})),l=i._dims,c=i.active,u=i.buttons[c]||f.blankHeaderOpts,h={y:i.pad.t,yPad:0,x:i.pad.l,xPad:0,index:0},p={width:l.headerWidth,height:l.headerHeight};a.call(_,i,u,t).call(L,i,h,p),s.ensureSingle(e,'text',f.headerArrowClassName,(function(t){t.attr('text-anchor','end').call(o.font,i.font).text(f.arrowSymbol[i.direction])})).attr({x:l.headerWidth-f.arrowOffsetX+i.pad.l,y:l.headerHeight/2+f.textOffsetY+i.pad.t}),a.on('click',(function(){r.call(C,String(m(r,i)?-1:i._index)),y(t,e,r,n,i)})),a.on('mouseover',(function()[a.call(M)])),a.on('mouseout',(function(){a.call(A,i)})),o.setTranslate(e,l.lx,l.ly)}function y(t,e,r,a,o){r||(r=e).attr('pointer-events','all');var l=d(r)&&"buttons"!==o.type?[]:o.buttons,c="dropdown"===o.type?f.dropdownButtonClassName:f.buttonClassName,u=r.selectAll("g."+c).data(s.filterVisible(l)),h=u.enter().append('g').classed(c,!0),p=u.exit();"dropdown"===o.type?(h.attr('opacity','0').transition().attr('opacity','1'),p.transition().attr('opacity','0').remove()):p.remove();var m=0,v=0,y=o._dims,w=-1!==["up","down"].indexOf(o.direction);"dropdown"===o.type&&(w?v=y.headerHeight+f.gapButtonHeader:m=y.headerWidth+f.gapButtonHeader),"dropdown"===o.type&&"up"===o.direction&&(v=-f.gapButtonHeader+f.gapButton-y.openHeight),"dropdown"===o.type&&"left"===o.direction&&(m=-f.gapButtonHeader+f.gapButton-y.openWidth);var T={x:y.lx+m+o.pad.l,y:y.ly+v+o.pad.t,yPad:f.gapButton,xPad:f.gapButton,index:0},S={l:T.x+o.borderwidth,t:T.y+o.borderwidth};u.each((function(s,l){var c=n.select(this);c.call(_,o,s,t).call(L,o,T),c.on('click',(function(){n.event.defaultPrevented||(s.execute&&(s.args2&&o.active===l?(g(t,o,s,e,r,a,-1),i.executeAPICommand(t,s.method,s.args2)):(g(t,o,s,e,r,a,l),i.executeAPICommand(t,s.method,s.args))),t.emit('plotly_buttonclicked',{menu:o,button:s,active:o.active}))})),c.on('mouseover',(function()[c.call(M)])),c.on('mouseout',(function(){c.call(A,o),u.call(k,o)}))})),u.call(k,o),w?(S.w=Math.max(y.openWidth,y.headerWidth),S.h=T.y-S.t):(S.w=T.x-S.l,S.h=Math.max(y.openHeight,y.headerHeight)),S.direction=o.direction,a&&(u.size()?x(t,e,r,a,o,S):b(a))}function x(t,e,r,n,i,a){var o,s,l,c=i.direction,u="up"===c||"down"===c,h=i._dims,p=i.active;if(u)for(s=0,l=0;l<p;l++)s+=h.heights[l]+f.gapButton;else for(o=0,l=0;l<p;l++)o+=h.widths[l]+f.gapButton;n.enable(a,o,s),n.hbar&&n.hbar.attr('opacity','0').transition().attr('opacity','1'),n.vbar&&n.vbar.attr('opacity','0').transition().attr('opacity','1')}function b(t){var e=!!t.hbar,r=!!t.vbar;e&&t.hbar.transition().attr('opacity','0').each('end',(function(){e=!1,r||t.disable()})),r&&t.vbar.transition().attr('opacity','0').each('end',(function(){r=!1,e||t.disable()}))}function _(t,e,r,n){t.call(w,e).call(T,e,r,n)}function w(t,e){s.ensureSingle(t,'rect',f.itemRectClassName,(function(t){t.attr({rx:f.rx,ry:f.ry,"shape-rendering":"crispEdges"})})).call(a.stroke,e.bordercolor).call(a.fill,e.bgcolor).style('stroke-width',e.borderwidth+"px")}function T(t,e,r,n){var i=s.ensureSingle(t,'text',f.itemTextClassName,(function(t){t.attr({"text-anchor":"start","data-notex":1})})),a=r.label,c=n._fullLayout._meta;c&&(a=s.templateString(a,c)),i.call(o.font,e.font).text(a).call(l.convertToTspans,n)}function k(t,e){var r=e.active;t.each((function(t,i){var o=n.select(this);i===r&&e.showactive&&o.select("rect."+f.itemRectClassName).call(a.fill,f.activeColor)}))}function M(t){t.select("rect."+f.itemRectClassName).call(a.fill,f.hoverColor)}function A(t,e){t.select("rect."+f.itemRectClassName).call(a.fill,e.bgcolor)}function S(t,e){var r=e._dims={width1:0,height1:0,heights:[],widths:[],totalWidth:0,totalHeight:0,openWidth:0,openHeight:0,lx:0,ly:0},a=o.tester.selectAll("g."+f.dropdownButtonClassName).data(s.filterVisible(e.buttons));a.enter().append('g').classed(f.dropdownButtonClassName,!0);var c=-1!==["up","down"].indexOf(e.direction);a.each((function(i,a){var s=n.select(this);s.call(_,e,i,t);var h=s.select("."+f.itemTextClassName),p=h.node()&&o.bBox(h.node()).width,d=Math.max(p+f.textPadX,f.minWidth),m=e.font.size*u,g=l.lineCount(h),v=Math.max(m*g,f.minHeight)+f.textOffsetY;v=Math.ceil(v),d=Math.ceil(d),r.widths[a]=d,r.heights[a]=v,r.height1=Math.max(r.height1,v),r.width1=Math.max(r.width1,d),c?(r.totalWidth=Math.max(r.totalWidth,d),r.openWidth=r.totalWidth,r.totalHeight+=v+f.gapButton,r.openHeight+=v+f.gapButton):(r.totalWidth+=d+f.gapButton,r.openWidth+=d+f.gapButton,r.totalHeight=Math.max(r.totalHeight,v),r.openHeight=r.totalHeight)})),c?r.totalHeight-=f.gapButton:r.totalWidth-=f.gapButton,r.headerWidth=r.width1+f.arrowPadX,r.headerHeight=r.height1,"dropdown"===e.type&&(c?(r.width1+=f.arrowPadX,r.totalHeight=r.height1):r.totalWidth=r.width1,r.totalWidth+=f.arrowPadX),a.remove();var h=r.totalWidth+e.pad.l+e.pad.r,p=r.totalHeight+e.pad.t+e.pad.b,d=t._fullLayout._size;r.lx=d.l+d.w*e.x,r.ly=d.t+d.h*(1-e.y);var m='left';s.isRightAnchor(e)&&(r.lx-=h,m='right'),s.isCenterAnchor(e)&&(r.lx-=h/2,m='center');var g='top';s.isBottomAnchor(e)&&(r.ly-=p,g='bottom'),s.isMiddleAnchor(e)&&(r.ly-=p/2,g='middle'),r.totalWidth=Math.ceil(r.totalWidth),r.totalHeight=Math.ceil(r.totalHeight),r.lx=Math.round(r.lx),r.ly=Math.round(r.ly),i.autoMargin(t,E(e),{x:e.x,y:e.y,l:h*({right:1,center:.5}[m]||0),r:h*({left:1,center:.5}[m]||0),b:p*({top:1,middle:.5}[g]||0),t:p*({bottom:1,middle:.5}[g]||0)})}function E(t){return f.autoMarginIdRoot+t._index}function L(t,e,r,n)[n=n||{];var i=t.select("."+f.itemRectClassName),a=t.select("."+f.itemTextClassName),s=e.borderwidth,c=r.index,h=e._dims;o.setTranslate(t,s+r.x,s+r.y);var p=-1!==["up","down"].indexOf(e.direction),d=n.height||(p?h.heights[c]:h.height1);i.attr({x:0,y:0,width:n.width||(p?h.width1:h.widths[c]),height:d});var m=e.font.size*u,g=(l.lineCount(a)-1)*m/2;l.positionText(a,f.textOffsetX,d/2-g+f.textOffsetY),p?r.y+=h.heights[c]+r.yPad:r.x+=h.widths[c]+r.xPad,r.index++}function C(t,e){t.attr(f.menuIndexAttrName,e||"-1").selectAll("g."+f.dropdownButtonClassName).remove()}e.exports=function(t){var e=t._fullLayout,r=s.filterVisible(e[f.name]);function a(e){i.autoMargin(t,E(e))}var o=e._menulayer.selectAll("g."+f.containerClassName).data(r.length>0?[0]:[]);if(o.enter().append('g').classed(f.containerClassName,!0).style('cursor','pointer'),o.exit().each((function()[n.select(this).selectAll("g."+f.headerGroupClassName).each(a)])).remove(),0!==r.length){var l=o.selectAll("g."+f.headerGroupClassName).data(r,p);l.enter().append('g').classed(f.headerGroupClassName,!0);for(var c=s.ensureSingle(o,'g',f.dropdownButtonGroupClassName,(function(t){t.style('pointer-events','all')})),u=0;u<r.length;u++){var d=r[u];S(t,d)}var x="updatemenus"+e._uid,b=new h(t,c,x);l.enter().size()&&(c.node().parentNode.appendChild(c.node()),c.call(C)),l.exit().each((function(t){c.call(C),a(t)})).remove(),l.each((function(e){var r=n.select(this),a="dropdown"===e.type?c:null;i.manageCommandObserver(t,e,e.buttons,(function(n){g(t,e,e.buttons[n.index],r,a,b,n.index,!0)})),"dropdown"===e.type?(v(t,r,c,b,e),m(c,e)&&y(t,r,c,b,e)):y(t,r,null,null,e)}))}}},{"../../constants/alignment":755,"../../lib":787,"../../lib/svg_text_utils":813,"../../plot_api/plot_template":827,"../../plots/plots":901,"../color":650,"../drawing":672,"./constants":750,"./scrollbox":754,"@plotly/d3":58}],753:[function(t,e,r){arguments[4][747][0].apply(r,arguments)},{"./attributes":749,"./constants":750,"./defaults":751,"./draw":752,dup:747}],754:[function(t,e,r){"use strict";e.exports=s;var n=t('@plotly/d3'),i=t('../color'),a=t('../drawing'),o=t('../../lib');function s(t,e,r){this.gd=t,this.container=e,this.id=r,this.position=null,this.translateX=null,this.translateY=null,this.hbar=null,this.vbar=null,this.bg=this.container.selectAll('rect.scrollbox-bg').data([0]),this.bg.exit().on('.drag',null).on('wheel',null).remove(),this.bg.enter().append('rect').classed('scrollbox-bg',!0).style('pointer-events','all').attr({opacity:0,x:0,y:0,width:0,height:0})}s.barWidth=2,s.barLength=20,s.barRadius=2,s.barPad=1,s.barColor='#808BA4',s.prototype.enable=function(t,e,r){var o=this.gd._fullLayout,l=o.width,c=o.height;this.position=t;var u,f,h,p,d=this.position.l,m=this.position.w,g=this.position.t,v=this.position.h,y=this.position.direction,x="down"===y,b="left"===y,_="up"===y,w=m,T=v;x||b||"right"===y||_||(this.position.direction='down',x=!0),x||_?(f=(u=d)+w,x?(h=g,T=(p=Math.min(h+T,c))-h):T=(p=g+T)-(h=Math.max(p-T,0))):(p=(h=g)+T,b?w=(f=d+w)-(u=Math.max(f-w,0)):(u=d,w=(f=Math.min(u+w,l))-u)),this._box={l:u,t:h,w:w,h:T};var k=m>w,M=s.barLength+2*s.barPad,A=s.barWidth+2*s.barPad,S=d,E=g+v;E+A>c&&(E=c-A);var L=this.container.selectAll('rect.scrollbar-horizontal').data(k?[0]:[]);L.exit().on('.drag',null).remove(),L.enter().append('rect').classed('scrollbar-horizontal',!0).call(i.fill,s.barColor),k?(this.hbar=L.attr({rx:s.barRadius,ry:s.barRadius,x:S,y:E,width:M,height:A}),this._hbarXMin=S+M/2,this._hbarTranslateMax=w-M):(delete this.hbar,delete this._hbarXMin,delete this._hbarTranslateMax);var C=v>T,P=s.barWidth+2*s.barPad,I=s.barLength+2*s.barPad,z=d+m,O=g;z+P>l&&(z=l-P);var D=this.container.selectAll('rect.scrollbar-vertical').data(C?[0]:[]);D.exit().on('.drag',null).remove(),D.enter().append('rect').classed('scrollbar-vertical',!0).call(i.fill,s.barColor),C?(this.vbar=D.attr({rx:s.barRadius,ry:s.barRadius,x:z,y:O,width:P,height:I}),this._vbarYMin=O+I/2,this._vbarTranslateMax=T-I):(delete this.vbar,delete this._vbarYMin,delete this._vbarTranslateMax);var R=this.id,F=u-.5,B=C?f+P+.5:f+.5,N=h-.5,j=k?p+A+.5:p+.5,U=o._topdefs.selectAll("#"+R).data(k||C?[0]:[]);if(U.exit().remove(),U.enter().append('clipPath').attr('id',R).append('rect'),k||C?(this._clipRect=U.select('rect').attr({x:Math.floor(F),y:Math.floor(N),width:Math.ceil(B)-Math.floor(F),height:Math.ceil(j)-Math.floor(N)}),this.container.call(a.setClipUrl,R,this.gd),this.bg.attr({x:d,y:g,width:m,height:v})):(this.bg.attr({width:0,height:0}),this.container.on('wheel',null).on('.drag',null).call(a.setClipUrl,null),delete this._clipRect),k||C){var V=n.behavior.drag().on('dragstart',(function(){n.event.sourceEvent.preventDefault()})).on('drag',this._onBoxDrag.bind(this));this.container.on('wheel',null).on('wheel',this._onBoxWheel.bind(this)).on('.drag',null).call(V);var H=n.behavior.drag().on('dragstart',(function(){n.event.sourceEvent.preventDefault(),n.event.sourceEvent.stopPropagation()})).on('drag',this._onBarDrag.bind(this));k&&this.hbar.on('.drag',null).call(H),C&&this.vbar.on('.drag',null).call(H)}this.setTranslate(e,r)},s.prototype.disable=function(){(this.hbar||this.vbar)&&(this.bg.attr({width:0,height:0}),this.container.on('wheel',null).on('.drag',null).call(a.setClipUrl,null),delete this._clipRect),this.hbar&&(this.hbar.on('.drag',null),this.hbar.remove(),delete this.hbar,delete this._hbarXMin,delete this._hbarTranslateMax),this.vbar&&(this.vbar.on('.drag',null),this.vbar.remove(),delete this.vbar,delete this._vbarYMin,delete this._vbarTranslateMax)},s.prototype._onBoxDrag=function(){var t=this.translateX,e=this.translateY;this.hbar&&(t-=n.event.dx),this.vbar&&(e-=n.event.dy),this.setTranslate(t,e)},s.prototype._onBoxWheel=function(){var t=this.translateX,e=this.translateY;this.hbar&&(t+=n.event.deltaY),this.vbar&&(e+=n.event.deltaY),this.setTranslate(t,e)},s.prototype._onBarDrag=function(){var t=this.translateX,e=this.translateY;if(this.hbar){var r=t+this._hbarXMin,i=r+this._hbarTranslateMax;t=(o.constrain(n.event.x,r,i)-r)/(i-r)*(this.position.w-this._box.w)}if(this.vbar){var a=e+this._vbarYMin,s=a+this._vbarTranslateMax;e=(o.constrain(n.event.y,a,s)-a)/(s-a)*(this.position.h-this._box.h)}this.setTranslate(t,e)},s.prototype.setTranslate=function(t,e){var r=this.position.w-this._box.w,n=this.position.h-this._box.h;if(t=o.constrain(t||0,0,r),e=o.constrain(e||0,0,n),this.translateX=t,this.translateY=e,this.container.call(a.setTranslate,this._box.l-this.position.l-t,this._box.t-this.position.t-e),this._clipRect&&this._clipRect.attr({x:Math.floor(this.position.l+t-.5),y:Math.floor(this.position.t+e-.5)}),this.hbar){var i=t/r;this.hbar.call(a.setTranslate,t+i*this._hbarTranslateMax,e)}if(this.vbar){var s=e/n;this.vbar.call(a.setTranslate,t,e+s*this._vbarTranslateMax)}}},{"../../lib":787,"../color":650,"../drawing":672,"@plotly/d3":58}],755:[function(t,e,r){"use strict";e.exports={FROM_BL:{left:0,center:.5,right:1,bottom:0,middle:.5,top:1},FROM_TL:{left:0,center:.5,right:1,bottom:1,middle:.5,top:0},FROM_BR:{left:1,center:.5,right:0,bottom:0,middle:.5,top:1},LINE_SPACING:1.3,CAP_SHIFT:.7,MID_SHIFT:.35,OPPOSITE_SIDE:{left:"right",right:"left",top:"bottom",bottom:"top"}}},{}],756:[function(t,e,r){"use strict";e.exports={axisRefDescription:function(t,e,r){return["If set to a",t,"axis id (e.g. *"+t+"* or","*"+t+"2*), the `"+t+"` position refers to a",t,"coordinate. If set to *paper*, the `"+t+"`",'position refers to the distance from the',e,'of the plotting','area in normalized coordinates where *0* (*1*) corresponds to the',e,'('+r+'). If set to a',t,'axis ID followed by','*domain* (separated by a space), the position behaves like for','*paper*, but refers to the distance in fractions of the domain','length from the',e,'of the domain of that axis: e.g.,',"*"+t+"2 domain* refers to the domain of the second",t,' axis and a',t,'position of 0.5 refers to the','point between the',e,'and the',r,'of the domain of the','second',t,"axis."].join(' ')}}},{}],757:[function(t,e,r){"use strict";e.exports={INCREASING:{COLOR:"#3D9970",SYMBOL:"\u25b2"},DECREASING:{COLOR:"#FF4136",SYMBOL:"\u25bc"}}},{}],758:[function(t,e,r){"use strict";e.exports={FORMAT_LINK:"https://github.com/d3/d3-format/tree/v1.4.5#d3-format",DATE_FORMAT_LINK:"https://github.com/d3/d3-time-format/tree/v2.2.3#locale_format"}},{}],759:[function(t,e,r){"use strict";e.exports={COMPARISON_OPS:["=",'!=','<','>=','>',"<="],COMPARISON_OPS2:["=",'<','>=','>',"<="],INTERVAL_OPS:["[]",'()','[)','(]','][',')(',"](',')["],SET_OPS:["{}","}{"],CONSTRAINT_REDUCTION:{"=":"=","<":"<","<=":"<",">":">",">=":">","[]":"[]","()":"[]","[)":"[]","(]":"[]","][":"][",")(":"][","](":"][",")[":"]["}}},{}],760:[function(t,e,r){"use strict";e.exports={solid:[[],0],dot:[[.5,1],200],dash:[[.5,1],50],longdash:[[.5,1],10],dashdot:[[.5,.625,.875,1],50],longdashdot:[[.5,.7,.8,1],10]}},{}],761:[function(t,e,r){"use strict";e.exports={circle:"\u25cf","circle-open":"\u25cb",square:"\u25a0","square-open":"\u25a1",diamond:"\u25c6","diamond-open":"\u25c7",cross:"+",x:"\u274c"}},{}],762:[function(t,e,r){"use strict";e.exports={SHOW_PLACEHOLDER:100,HIDE_PLACEHOLDER:1e3,DESELECTDIM:.2}},{}],763:[function(t,e,r){"use strict";e.exports={BADNUM:void 0,FP_SAFE:1e-4*Number.MAX_VALUE,ONEMAXYEAR:316224e5,ONEAVGYEAR:315576e5,ONEMINYEAR:31536e6,ONEMAXQUARTER:79488e5,ONEAVGQUARTER:78894e5,ONEMINQUARTER:76896e5,ONEMAXMONTH:26784e5,ONEAVGMONTH:26298e5,ONEMINMONTH:24192e5,ONEWEEK:6048e5,ONEDAY:864e5,ONEHOUR:36e5,ONEMIN:6e4,ONESEC:1e3,EPOCHJD:2440587.5,ALMOST_EQUAL:.999999,LOG_CLIP:10,MINUS_SIGN:"\u2212"}},{}],764:[function(t,e,r){"use strict";r.xmlns='http://www.w3.org/2000/xmlns/',r.svg='http://www.w3.org/2000/svg',r.xlink='http://www.w3.org/1999/xlink',r.svgAttrs={xmlns:r.svg,"xmlns:xlink":r.xlink}},{}],765:[function(t,e,r){"use strict";r.version=t('./version').version,t('native-promise-only'),t('../build/plotcss');for(var n=t('./registry'),i=r.register=n.register,a=t('./plot_api'),o=Object.keys(a),s=0;s<o.length;s++){var l=o[s];"_"!==l.charAt(0)&&(r[l]=a[l]),i({moduleType:"apiMethod",name:l,fn:a[l]})}i(t('./traces/scatter')),i([t('./components/legend'),t('./components/fx'),t('./components/annotations'),t('./components/annotations3d'),t('./components/shapes'),t('./components/images'),t('./components/updatemenus'),t('./components/sliders'),t('./components/rangeslider'),t('./components/rangeselector'),t('./components/grid'),t('./components/errorbars'),t('./components/colorscale'),t('./components/colorbar'),t('./components/modebar')]),i([t('./locale-en'),t('./locale-en-us')]),window.PlotlyLocales&&Array.isArray(window.PlotlyLocales)&&(i(window.PlotlyLocales),delete window.PlotlyLocales),r.Icons=t('./fonts/ploticon');var c=t('./components/fx'),u=t('./plots/plots');r.Plots={resize:u.resize,graphJson:u.graphJson,sendDataToCloud:u.sendDataToCloud},r.Fx={hover:c.hover,unhover:c.unhover,loneHover:c.loneHover,loneUnhover:c.loneUnhover},r.Snapshot=t('./snapshot'),r.PlotSchema=t('./plot_api/plot_schema')},{"../build/plotcss":1,"./components/annotations":641,"./components/annotations3d":646,"./components/colorbar":656,"./components/colorscale":662,"./components/errorbars":678,"./components/fx":690,"./components/grid":694,"./components/images":699,"./components/legend":707,"./components/modebar":713,"./components/rangeselector":721,"./components/rangeslider":728,"./components/shapes":742,"./components/sliders":747,"./components/updatemenus":753,"./fonts/ploticon":766,"./locale-en":818,"./locale-en-us":817,"./plot_api":822,"./plot_api/plot_schema":826,"./plots/plots":901,"./registry":915,"./snapshot":920,"./traces/scatter":1214,"./version":1388,"native-promise-only":463}],766:[function(t,e,r){"use strict";e.exports={undo:{width:857.1,height:1e3,path:"m857 350q0-87-34-166t-91-137-137-92-166-34q-96 0-183 41t-147 114q-4 6-4 13t5 11l76 77q6 5 14 5 9-1 13-7 41-53 100-82t126-29q58 0 110 23t92 61 61 91 22 111-22 111-61 91-92 61-110 23q-55 0-105-20t-90-57l77-77q17-16 8-38-10-23-33-23h-250q-15 0-25 11t-11 25v250q0 24 22 33 22 10 39-8l72-72q60 57 137 88t159 31q87 0 166-34t137-92 91-137 34-166z",transform:"matrix(1 0 0 -1 0 850)"},home:{width:928.6,height:1e3,path:"m786 296v-267q0-15-11-26t-25-10h-214v214h-143v-214h-214q-15 0-25 10t-11 26v267q0 1 0 2t0 2l321 264 321-264q1-1 1-4z m124 39l-34-41q-5-5-12-6h-2q-7 0-12 3l-386 322-386-322q-7-4-13-4-7 2-12 7l-35 41q-4 5-3 13t6 12l401 334q18 15 42 15t43-15l136-114v109q0 8 5 13t13 5h107q8 0 13-5t5-13v-227l122-102q5-5 6-12t-4-13z",transform:"matrix(1 0 0 -1 0 850)"},"camera-retro":{width:1e3,height:1e3,path:"m518 386q0 8-5 13t-13 5q-37 0-63-27t-26-63q0-8 5-13t13-5 12 5 5 13q0 23 16 38t38 16q8 0 13 5t5 13z m125-73q0-59-42-101t-101-42-101 42-42 101 42 101 101 42 101-42 42-101z m-572-320h858v71h-858v-71z m643 320q0 89-62 152t-152 62-151-62-63-152 63-151 151-63 152 63 62 151z m-571 358h214v72h-214v-72z m-72-107h858v143h-462l-36-71h-360v-72z m929 143v-714q0-30-21-51t-50-21h-858q-29 0-50 21t-21 51v714q0 30 21 51t50 21h858q29 0 50-21t21-51z",transform:"matrix(1 0 0 -1 0 850)"},zoombox:{width:1e3,height:1e3,path:"m1000-25l-250 251c40 63 63 138 63 218 0 224-182 406-407 406-224 0-406-182-406-406s183-406 407-406c80 0 155 22 218 62l250-250 125 125z m-812 250l0 438 437 0 0-438-437 0z m62 375l313 0 0-312-313 0 0 312z",transform:"matrix(1 0 0 -1 0 850)"},pan:{width:1e3,height:1e3,path:"m1000 350l-187 188 0-125-250 0 0 250 125 0-188 187-187-187 125 0 0-250-250 0 0 125-188-188 186-187 0 125 252 0 0-250-125 0 187-188 188 188-125 0 0 250 250 0 0-126 187 188z",transform:"matrix(1 0 0 -1 0 850)"},zoom_plus:{width:875,height:1e3,path:"m1 787l0-875 875 0 0 875-875 0z m687-500l-187 0 0-187-125 0 0 187-188 0 0 125 188 0 0 187 125 0 0-187 187 0 0-125z",transform:"matrix(1 0 0 -1 0 850)"},zoom_minus:{width:875,height:1e3,path:"m0 788l0-876 875 0 0 876-875 0z m688-500l-500 0 0 125 500 0 0-125z",transform:"matrix(1 0 0 -1 0 850)"},autoscale:{width:1e3,height:1e3,path:"m250 850l-187 0-63 0 0-62 0-188 63 0 0 188 187 0 0 62z m688 0l-188 0 0-62 188 0 0-188 62 0 0 188 0 62-62 0z m-875-938l0 188-63 0 0-188 0-62 63 0 187 0 0 62-187 0z m875 188l0-188-188 0 0-62 188 0 62 0 0 62 0 188-62 0z m-125 188l-1 0-93-94-156 156 156 156 92-93 2 0 0 250-250 0 0-2 93-92-156-156-156 156 94 92 0 2-250 0 0-250 0 0 93 93 157-156-157-156-93 94 0 0 0-250 250 0 0 0-94 93 156 157 156-157-93-93 0 0 250 0 0 250z",transform:"matrix(1 0 0 -1 0 850)"},tooltip_basic:{width:1500,height:1e3,path:"m375 725l0 0-375-375 375-374 0-1 1125 0 0 750-1125 0z",transform:"matrix(1 0 0 -1 0 850)"},tooltip_compare:{width:1125,height:1e3,path:"m187 786l0 2-187-188 188-187 0 0 937 0 0 373-938 0z m0-499l0 1-187-188 188-188 0 0 937 0 0 376-938-1z",transform:"matrix(1 0 0 -1 0 850)"},plotlylogo:{width:1542,height:1e3,path:"m0-10h182v-140h-182v140z m228 146h183v-286h-183v286z m225 714h182v-1000h-182v1000z m225-285h182v-715h-182v715z m225 142h183v-857h-183v857z m231-428h182v-429h-182v429z m225-291h183v-138h-183v138z",transform:"matrix(1 0 0 -1 0 850)"},"z-axis":{width:1e3,height:1e3,path:"m833 5l-17 108v41l-130-65 130-66c0 0 0 38 0 39 0-1 36-14 39-25 4-15-6-22-16-30-15-12-39-16-56-20-90-22-187-23-279-23-261 0-341 34-353 59 3 60 228 110 228 110-140-8-351-35-351-116 0-120 293-142 474-142 155 0 477 22 477 142 0 50-74 79-163 96z m-374 94c-58-5-99-21-99-40 0-24 65-43 144-43 79 0 143 19 143 43 0 19-42 34-98 40v216h87l-132 135-133-135h88v-216z m167 515h-136v1c16 16 31 34 46 52l84 109v54h-230v-71h124v-1c-16-17-28-32-44-51l-89-114v-51h245v72z",transform:"matrix(1 0 0 -1 0 850)"},"3d_rotate":{width:1e3,height:1e3,path:"m922 660c-5 4-9 7-14 11-359 263-580-31-580-31l-102 28 58-400c0 1 1 1 2 2 118 108 351 249 351 249s-62 27-100 42c88 83 222 183 347 122 16-8 30-17 44-27-2 1-4 2-6 4z m36-329c0 0 64 229-88 296-62 27-124 14-175-11 157-78 225-208 249-266 8-19 11-31 11-31 2 5 6 15 11 32-5-13-8-20-8-20z m-775-239c70-31 117-50 198-32-121 80-199 346-199 346l-96-15-58-12c0 0 55-226 155-287z m603 133l-317-139c0 0 4-4 19-14 7-5 24-15 24-15s-177-147-389 4c235-287 536-112 536-112l31-22 100 299-4-1z m-298-153c6-4 14-9 24-15 0 0-17 10-24 15z",transform:"matrix(1 0 0 -1 0 850)"},camera:{width:1e3,height:1e3,path:"m500 450c-83 0-150-67-150-150 0-83 67-150 150-150 83 0 150 67 150 150 0 83-67 150-150 150z m400 150h-120c-16 0-34 13-39 29l-31 93c-6 15-23 28-40 28h-340c-16 0-34-13-39-28l-31-94c-6-15-23-28-40-28h-120c-55 0-100-45-100-100v-450c0-55 45-100 100-100h800c55 0 100 45 100 100v450c0 55-45 100-100 100z m-400-550c-138 0-250 112-250 250 0 138 112 250 250 250 138 0 250-112 250-250 0-138-112-250-250-250z m365 380c-19 0-35 16-35 35 0 19 16 35 35 35 19 0 35-16 35-35 0-19-16-35-35-35z",transform:"matrix(1 0 0 -1 0 850)"},movie:{width:1e3,height:1e3,path:"m938 413l-188-125c0 37-17 71-44 94 64 38 107 107 107 187 0 121-98 219-219 219-121 0-219-98-219-219 0-61 25-117 66-156h-115c30 33 49 76 49 125 0 103-84 187-187 187s-188-84-188-187c0-57 26-107 65-141-38-22-65-62-65-109v-250c0-70 56-126 125-126h500c69 0 125 56 125 126l188-126c34 0 62 28 62 63v375c0 35-28 63-62 63z m-750 0c-69 0-125 56-125 125s56 125 125 125 125-56 125-125-56-125-125-125z m406-1c-87 0-157 70-157 157 0 86 70 156 157 156s156-70 156-156-70-157-156-157z",transform:"matrix(1 0 0 -1 0 850)"},question:{width:857.1,height:1e3,path:"m500 82v107q0 8-5 13t-13 5h-107q-8 0-13-5t-5-13v-107q0-8 5-13t13-5h107q8 0 13 5t5 13z m143 375q0 49-31 91t-77 65-95 23q-136 0-207-119-9-14 4-24l74-55q4-4 10-4 9 0 14 7 30 38 48 51 19 14 48 14 27 0 48-15t21-33q0-21-11-34t-38-25q-35-16-65-48t-29-70v-20q0-8 5-13t13-5h107q8 0 13 5t5 13q0 10 12 27t30 28q18 10 28 16t25 19 25 27 16 34 7 45z m214-107q0-117-57-215t-156-156-215-58-216 58-155 156-58 215 58 215 155 156 216 58 215-58 156-156 57-215z",transform:"matrix(1 0 0 -1 0 850)"},disk:{width:857.1,height:1e3,path:"m214-7h429v214h-429v-214z m500 0h72v500q0 8-6 21t-11 20l-157 156q-5 6-19 12t-22 5v-232q0-22-15-38t-38-16h-322q-22 0-37 16t-16 38v232h-72v-714h72v232q0 22 16 38t37 16h465q22 0 38-16t15-38v-232z m-214 518v178q0 8-5 13t-13 5h-107q-7 0-13-5t-5-13v-178q0-8 5-13t13-5h107q7 0 13 5t5 13z m357-18v-518q0-22-15-38t-38-16h-750q-23 0-38 16t-16 38v750q0 22 16 38t38 16h517q23 0 50-12t42-26l156-157q16-15 27-42t11-49z",transform:"matrix(1 0 0 -1 0 850)"},drawopenpath:{width:70,height:70,path:"M33.21,85.65a7.31,7.31,0,0,1-2.59-.48c-8.16-3.11-9.27-19.8-9.88-41.3-.1-3.58-.19-6.68-.35-9-.15-2.1-.67-3.48-1.43-3.79-2.13-.88-7.91,2.32-12,5.86L3,32.38c1.87-1.64,11.55-9.66,18.27-6.9,2.13.87,4.75,3.14,5.17,9,.17,2.43.26,5.59.36,9.25a224.17,224.17,0,0,0,1.5,23.4c1.54,10.76,4,12.22,4.48,12.4.84.32,2.79-.46,5.76-3.59L43,80.07C41.53,81.57,37.68,85.64,33.21,85.65ZM74.81,69a11.34,11.34,0,0,0,6.09-6.72L87.26,44.5,74.72,32,56.9,38.35c-2.37.86-5.57,3.42-6.61,6L38.65,72.14l8.42,8.43ZM55,46.27a7.91,7.91,0,0,1,3.64-3.17l14.8-5.3,8,8L76.11,60.6l-.06.19a6.37,6.37,0,0,1-3,3.43L48.25,74.59,44.62,71Zm16.57,7.82A6.9,6.9,0,1,0,64.64,61,6.91,6.91,0,0,0,71.54,54.09Zm-4.05,0a2.85,2.85,0,1,1-2.85-2.85A2.86,2.86,0,0,1,67.49,54.09Zm-4.13,5.22L60.5,56.45,44.26,72.7l2.86,2.86ZM97.83,35.67,84.14,22l-8.57,8.57L89.26,44.24Zm-13.69-8,8,8-2.85,2.85-8-8Z",transform:"matrix(1 0 0 1 -15 -15)"},drawclosedpath:{width:90,height:90,path:"M88.41,21.12a26.56,26.56,0,0,0-36.18,0l-2.07,2-2.07-2a26.57,26.57,0,0,0-36.18,0,23.74,23.74,0,0,0,0,34.8L48,90.12a3.22,3.22,0,0,0,4.42,0l36-34.21a23.73,23.73,0,0,0,0-34.79ZM84,51.24,50.16,83.35,16.35,51.25a17.28,17.28,0,0,1,0-25.47,20,20,0,0,1,27.3,0l4.29,4.07a3.23,3.23,0,0,0,4.44,0l4.29-4.07a20,20,0,0,1,27.3,0,17.27,17.27,0,0,1,0,25.46ZM66.76,47.68h-33v6.91h33ZM53.35,35H46.44V68h6.91Z",transform:"matrix(1 0 0 1 -5 -5)"},lasso:{width:1031,height:1e3,path:"m1018 538c-36 207-290 336-568 286-277-48-473-256-436-463 10-57 36-108 76-151-13-66 11-137 68-183 34-28 75-41 114-42l-55-70 0 0c-2-1-3-2-4-3-10-14-8-34 5-45 14-11 34-8 45 4 1 1 2 3 2 5l0 0 113 140c16 11 31 24 45 40 4 3 6 7 8 11 48-3 100 0 151 9 278 48 473 255 436 462z m-624-379c-80 14-149 48-197 96 42 42 109 47 156 9 33-26 47-66 41-105z m-187-74c-19 16-33 37-39 60 50-32 109-55 174-68-42-25-95-24-135 8z m360 75c-34-7-69-9-102-8 8 62-16 128-68 170-73 59-175 54-244-5-9 20-16 40-20 61-28 159 121 317 333 354s407-60 434-217c28-159-121-318-333-355z",transform:"matrix(1 0 0 -1 0 850)"},selectbox:{width:1e3,height:1e3,path:"m0 850l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-285l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z",transform:"matrix(1 0 0 -1 0 850)"},drawline:{width:70,height:70,path:"M60.64,62.3a11.29,11.29,0,0,0,6.09-6.72l6.35-17.72L60.54,25.31l-17.82,6.4c-2.36.86-5.57,3.41-6.6,6L24.48,65.5l8.42,8.42ZM40.79,39.63a7.89,7.89,0,0,1,3.65-3.17l14.79-5.31,8,8L61.94,54l-.06.19a6.44,6.44,0,0,1-3,3.43L34.07,68l-3.62-3.63Zm16.57,7.81a6.9,6.9,0,1,0-6.89,6.9A6.9,6.9,0,0,0,57.36,47.44Zm-4,0a2.86,2.86,0,1,1-2.85-2.85A2.86,2.86,0,0,1,53.32,47.44Zm-4.13,5.22L46.33,49.8,30.08,66.05l2.86,2.86ZM83.65,29,70,15.34,61.4,23.9,75.09,37.59ZM70,21.06l8,8-2.84,2.85-8-8ZM87,80.49H10.67V87H87Z",transform:"matrix(1 0 0 1 -15 -15)"},drawrect:{width:80,height:80,path:"M78,22V79H21V22H78m9-9H12V88H87V13ZM68,46.22H31V54H68ZM53,32H45.22V69H53Z",transform:"matrix(1 0 0 1 -10 -10)"},drawcircle:{width:80,height:80,path:"M50,84.72C26.84,84.72,8,69.28,8,50.3S26.84,15.87,50,15.87,92,31.31,92,50.3,73.16,84.72,50,84.72Zm0-60.59c-18.6,0-33.74,11.74-33.74,26.17S31.4,76.46,50,76.46,83.74,64.72,83.74,50.3,68.6,24.13,50,24.13Zm17.15,22h-34v7.11h34Zm-13.8-13H46.24v34h7.11Z",transform:"matrix(1 0 0 1 -10 -10)"},eraseshape:{width:80,height:80,path:"M82.77,78H31.85L6,49.57,31.85,21.14H82.77a8.72,8.72,0,0,1,8.65,8.77V69.24A8.72,8.72,0,0,1,82.77,78ZM35.46,69.84H82.77a.57.57,0,0,0,.49-.6V29.91a.57.57,0,0,0-.49-.61H35.46L17,49.57Zm32.68-34.7-24,24,5,5,24-24Zm-19,.53-5,5,24,24,5-5Z",transform:"matrix(1 0 0 1 -10 -10)"},spikeline:{width:1e3,height:1e3,path:"M512 409c0-57-46-104-103-104-57 0-104 47-104 104 0 57 47 103 104 103 57 0 103-46 103-103z m-327-39l92 0 0 92-92 0z m-185 0l92 0 0 92-92 0z m370-186l92 0 0 93-92 0z m0-184l92 0 0 92-92 0z",transform:"matrix(1.5 0 0 -1.5 0 850)"},pencil:{width:1792,height:1792,path:"M491 1536l91-91-235-235-91 91v107h128v128h107zm523-928q0-22-22-22-10 0-17 7l-542 542q-7 7-7 17 0 22 22 22 10 0 17-7l542-542q7-7 7-17zm-54-192l416 416-832 832h-416v-416zm683 96q0 53-37 90l-166 166-416-416 166-165q36-38 90-38 53 0 91 38l235 234q37 39 37 91z",transform:"matrix(1 0 0 1 0 1)"},newplotlylogo:{name:"newplotlylogo",svg:"<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 132 132'><defs><style>.cls-1 {fill: #3f4f75;} .cls-2 {fill: #80cfbe;} .cls-3 {fill: #fff;}</style></defs><title>plotly-logomark</title><g id='symbol'><rect class='cls-1' width='132' height='132' rx='6' ry='6'/><circle class='cls-2' cx='78' cy='54' r='6'/><circle class='cls-2' cx='102' cy='30' r='6'/><circle class='cls-2' cx='78' cy='30' r='6'/><circle class='cls-2' cx='54' cy='30' r='6'/><circle class='cls-2' cx='30' cy='30' r='6'/><circle class='cls-2' cx='30' cy='54' r='6'/><path class='cls-3' d='M30,72a6,6,0,0,0-6,6v24a6,6,0,0,0,12,0V78A6,6,0,0,0,30,72Z'/><path class='cls-3' d='M78,72a6,6,0,0,0-6,6v24a6,6,0,0,0,12,0V78A6,6,0,0,0,78,72Z'/><path class='cls-3' d='M54,48a6,6,0,0,0-6,6v48a6,6,0,0,0,12,0V54A6,6,0,0,0,54,48Z'/><path class='cls-3' d='M102,48a6,6,0,0,0-6,6v48a6,6,0,0,0,12,0V54A6,6,0,0,0,102,48Z'/></g></svg>"}}},{}],767:[function(t,e,r){"use strict";r.isLeftAnchor=function(t){return"left"===t.xanchor||"auto"===t.xanchor&&t.x<=1/3},r.isCenterAnchor=function(t){return"center"===t.xanchor||"auto"===t.xanchor&&t.x>1/3&&t.x<2/3},r.isRightAnchor=function(t){return"right"===t.xanchor||"auto"===t.xanchor&&t.x>=2/3},r.isTopAnchor=function(t){return"top"===t.yanchor||"auto"===t.yanchor&&t.y>=2/3},r.isMiddleAnchor=function(t){return"middle"===t.yanchor||"auto"===t.yanchor&&t.y>1/3&&t.y<2/3},r.isBottomAnchor=function(t){return"bottom"===t.yanchor||"auto"===t.yanchor&&t.y<=1/3}},{}],768:[function(t,e,r){"use strict";var n=t('./mod'),i=n.mod,a=n.modHalf,o=Math.PI,s=2*o;function l(t){return t/180*o}function c(t){return t/o*180}function u(t){return Math.abs(t[1]-t[0])>s-1e-14}function f(t,e){return a(e-t,s)}function h(t,e){return Math.abs(f(t,e))}function p(t,e){if(u(e))return!0;var r,n;e[0]<e[1]?(r=e[0],n=e[1]):(r=e[1],n=e[0]),(r=i(r,s))>(n=i(n,s))&&(n+=s);var a=i(t,s),o=a+s;return a>=r&&a<=n||o>=r&&o<=n}function d(t,e,r,n){return!!p(e,n)&&(r[0]<r[1]?(i=r[0],a=r[1]):(i=r[1],a=r[0]),t>=i&&t<=a);var i,a}function m(t,e,r,n,i,a,l){i=i||0,a=a||0;var c,f,h,p,d,m=u([r,n]);function g(t,e){return[t*Math.cos(e)+i,a-t*Math.sin(e)]}m?(c=0,f=o,h=s):r<n?(c=r,h=n):(c=n,h=r),t<e?(p=t,d=e):(p=e,d=t);var v,y=Math.abs(h-c)<=o?0:1;function x(t,e,r){return"A"+[t,t]+" '+[0,y,r]+' "+g(t,e)}return m?v=null===p?"M"+g(d,c)+x(d,f,0)+x(d,h,0)+"Z":"M"+g(p,c)+x(p,f,0)+x(p,h,0)+"ZM"+g(d,c)+x(d,f,1)+x(d,h,1)+"Z":null===p?(v="M"+g(d,c)+x(d,h,0),l&&(v+='L0,0Z')):v="M"+g(p,c)+"L"+g(d,c)+x(d,h,0)+"L"+g(p,h)+x(p,c,1)+"Z",v}function g(t,e,r,n,i){return m(null,t,e,r,n,i,0)}function v(t,e,r,n,i){return m(null,t,e,r,n,i,1)}function y(t,e,r,n,i,a){return m(t,e,r,n,i,a,1)}e.exports={deg2rad:l,rad2deg:c,angleDelta:f,angleDist:h,isFullCircle:u,isAngleInsideSector:p,isPtInsideSector:d,pathArc:g,pathSector:v,pathAnnulus:y}},{"./mod":794}],769:[function(t,e,r){"use strict";var n=Array.isArray,i=ArrayBuffer,a=DataView;function o(t){return i.isView(t)&&!(t instanceof a)}function s(t){return n(t)||o(t)}function l(t){return!s(t[0])}function c(t,e,r){if(s(t)){if(s(t[0])){for(var n=r,i=0;i<t.length;i++)n=e(n,t[i].length);return n}return t.length}return 0}r.isTypedArray=o,r.isArrayOrTypedArray=s,r.isArray1D=l,r.ensureArray=function(t,e){return n(t)||(t=[]),t.length=e,t},r.concat=function(){var t,e,r,i,a,o,s,l,c=[],u=!0,f=0;for(r=0;r<arguments.length;r++)(o=(i=arguments[r]).length)&&(e?c.push(i):(e=i,a=o),n(i)?t=!1:(u=!1,f?t!==i.constructor&&(t=!1):t=i.constructor),f+=o);if(!f)return[];if(!c.length)return e;if(u)return e.concat.apply(e,c);if(t){for((s=new t(f)).set(e),r=0;r<c.length;r++)i=c[r],s.set(i,a),a+=i.length;return s}for(s=new Array(f),l=0;l<e.length;l++)s[l]=e[l];for(r=0;r<c.length;r++){for(i=c[r],l=0;l<i.length;l++)s[a+l]=i[l];a+=l}return s},r.maxRowLength=function(t){return c(t,Math.max,0)},r.minRowLength=function(t){return c(t,Math.min,1/0)}},{}],770:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../constants/numerical').BADNUM,a=/^['"%,$#\s']+|[, ]|['"%,$#\s']+$/g;e.exports=function(t){return"string"===typeof t&&(t=t.replace(a,'')),n(t)?Number(t):i}},{"../constants/numerical":763,"fast-isnumeric":246}],771:[function(t,e,r){"use strict";e.exports=function(t){var e=t._fullLayout;e._glcanvas&&e._glcanvas.size()&&e._glcanvas.each((function(t){t.regl&&t.regl.clear({color:!0,depth:!0})}))}},{}],772:[function(t,e,r){"use strict";e.exports=function(t){t._responsiveChartHandler&&(window.removeEventListener('resize',t._responsiveChartHandler),delete t._responsiveChartHandler)}},{}],773:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('tinycolor2'),a=t('../plots/attributes'),o=t('../components/colorscale/scales'),s=t('../components/color'),l=t('../constants/interactions').DESELECTDIM,c=t('./nested_property'),u=t('./regex').counter,f=t('./mod').modHalf,h=t('./array').isArrayOrTypedArray;function p(t,e){var n=r.valObjectMeta[e.valType];if(e.arrayOk&&h(t))return!0;if(n.validateFunction)return n.validateFunction(t,e);var i={},a=i,o={set:function(t){a=t}};return n.coerceFunction(t,o,i,e),a!==i}r.valObjectMeta={data_array:{coerceFunction:function(t,e,r){h(t)?e.set(t):void 0!==r&&e.set(r)}},enumerated:{coerceFunction:function(t,e,r,n){n.coerceNumber&&(t=+t),-1===n.values.indexOf(t)?e.set(r):e.set(t)},validateFunction:function(t,e){e.coerceNumber&&(t=+t);for(var r=e.values,n=0;n<r.length;n++){var i=String(r[n]);if("/"===i.charAt(0)&&"/"===i.charAt(i.length-1)){if(new RegExp(i.substr(1,i.length-2)).test(t))return!0}else if(t===r[n])return!0}return!1}},boolean:{coerceFunction:function(t,e,r){!0===t||!1===t?e.set(t):e.set(r)}},number:{coerceFunction:function(t,e,r,i){!n(t)||void 0!==i.min&&t<i.min||void 0!==i.max&&t>i.max?e.set(r):e.set(+t)}},integer:{coerceFunction:function(t,e,r,i){t%1||!n(t)||void 0!==i.min&&t<i.min||void 0!==i.max&&t>i.max?e.set(r):e.set(+t)}},string:{coerceFunction:function(t,e,r,n){if("string"!==typeof t){var i="number"===typeof t;!0!==n.strict&&i?e.set(String(t)):e.set(r)}else n.noBlank&&!t?e.set(r):e.set(t)}},color:{coerceFunction:function(t,e,r){i(t).isValid()?e.set(t):e.set(r)}},colorlist:{coerceFunction:function(t,e,r){function n(t){return i(t).isValid()}Array.isArray(t)&&t.length&&t.every(n)?e.set(t):e.set(r)}},colorscale:{coerceFunction:function(t,e,r){e.set(o.get(t,r))}},angle:{coerceFunction:function(t,e,r){"auto"===t?e.set('auto'):n(t)?e.set(f(+t,360)):e.set(r)}},subplotid:{coerceFunction:function(t,e,r,n){var i=n.regex||u(r);"string"===typeof t&&i.test(t)?e.set(t):e.set(r)},validateFunction:function(t,e){var r=e.dflt;return t===r||"string"===typeof t&&!!u(r).test(t)}},flaglist:{coerceFunction:function(t,e,r,n){if("string"===typeof t)if(-1===(n.extras||[]).indexOf(t)){for(var i=t.split('+'),a=0;a<i.length;){var o=i[a];-1===n.flags.indexOf(o)||i.indexOf(o)<a?i.splice(a,1):a++}i.length?e.set(i.join('+')):e.set(r)}else e.set(t);else e.set(r)}},any:{coerceFunction:function(t,e,r){void 0===t?e.set(r):e.set(t)}},info_array:{coerceFunction:function(t,e,n,i){function a(t,e,n){var i,a={set:function(t){i=t}};return void 0===n&&(n=e.dflt),r.valObjectMeta[e.valType].coerceFunction(t,a,n,e),i}var o=2===i.dimensions||"1-2"===i.dimensions&&Array.isArray(t)&&Array.isArray(t[0]);if(Array.isArray(t)){var s,l,c,u,f,h,p=i.items,d=[],m=Array.isArray(p),g=m&&o&&Array.isArray(p[0]),v=o&&m&&!g,y=m&&!v?p.length:t.length;if(n=Array.isArray(n)?n:[],o)for(s=0;s<y;s++)for(d[s]=[],c=Array.isArray(t[s])?t[s]:[],f=v?p.length:m?p[s].length:c.length,l=0;l<f;l++)u=v?p[l]:m?p[s][l]:p,void 0!==(h=a(c[l],u,(n[s]||[])[l]))&&(d[s][l]=h);else for(s=0;s<y;s++)void 0!==(h=a(t[s],m?p[s]:p,n[s]))&&(d[s]=h);e.set(d)}else e.set(n)},validateFunction:function(t,e){if(!Array.isArray(t))return!1;var r=e.items,n=Array.isArray(r),i=2===e.dimensions;if(!e.freeLength&&t.length!==r.length)return!1;for(var a=0;a<t.length;a++)if(i){if(!Array.isArray(t[a])||!e.freeLength&&t[a].length!==r[a].length)return!1;for(var o=0;o<t[a].length;o++)if(!p(t[a][o],n?r[a][o]:r))return!1}else if(!p(t[a],n?r[a]:r))return!1;return!0}}},r.coerce=function(t,e,n,i,a){var o=c(n,i).get(),s=c(t,i),l=c(e,i),u=s.get(),f=e._template;if(void 0===u&&f&&(u=c(f,i).get(),f=0),void 0===a&&(a=o.dflt),o.arrayOk&&h(u))return l.set(u),u;var d=r.valObjectMeta[o.valType].coerceFunction;d(u,l,a,o);var m=l.get();return f&&m===a&&!p(u,o)&&(d(u=c(f,i).get(),l,a,o),m=l.get()),m},r.coerce2=function(t,e,n,i,a){var o=c(t,i),s=r.coerce(t,e,n,i,a),l=o.get();return void 0!==l&&null!==l&&s},r.coerceFont=function(t,e,r)[var n={];return r=r||{},n.family=t(e+".family",r.family),n.size=t(e+".size",r.size),n.color=t(e+".color",r.color),n},r.coercePattern=function(t,e,r,n){if(t(e+".shape")){t(e+".solidity"),t(e+".size");var i="overlay"===t(e+".fillmode");if(!n){var a=t(e+".bgcolor",i?r:void 0);t(e+".fgcolor",i?s.contrast(a):r)}t(e+".fgopacity",i?.5:1)}},r.coerceHoverinfo=function(t,e,n){var i,o=e._module.attributes,s=o.hoverinfo?o:a,l=s.hoverinfo;if(1===n._dataLength){var c="all"===l.dflt?l.flags.slice():l.dflt.split('+');c.splice(c.indexOf('name'),1),i=c.join('+')}return r.coerce(t,e,s,'hoverinfo',i)},r.coerceSelectionMarkerOpacity=function(t,e){if(t.marker){var r,n,i=t.marker.opacity;void 0!==i&&(h(i)||t.selected||t.unselected||(r=i,n=l*i),e('selected.marker.opacity',r),e('unselected.marker.opacity',n))}},r.validate=p},{"../components/color":650,"../components/colorscale/scales":665,"../constants/interactions":762,"../plots/attributes":834,"./array":769,"./mod":794,"./nested_property":795,"./regex":804,"fast-isnumeric":246,tinycolor2:583}],774:[function(t,e,r){"use strict";var n,i,a=t('d3-time-format').timeFormat,o=t('fast-isnumeric'),s=t('./loggers'),l=t('./mod').mod,c=t('../constants/numerical'),u=c.BADNUM,f=c.ONEDAY,h=c.ONEHOUR,p=c.ONEMIN,d=c.ONESEC,m=c.EPOCHJD,g=t('../registry'),v=t('d3-time-format').utcFormat,y=/^\s*(-?\d\d\d\d|\d\d)(-(\d?\d)(-(\d?\d)([ Tt]([01]?\d|2[0-3])(:([0-5]\d)(:([0-5]\d(\.\d+)?))?(Z|z|[+\-]\d\d(:?\d\d)?)?)?)?)?)?\s*$/m,x=/^\s*(-?\d\d\d\d|\d\d)(-(\d?\di?)(-(\d?\d)([ Tt]([01]?\d|2[0-3])(:([0-5]\d)(:([0-5]\d(\.\d+)?))?(Z|z|[+\-]\d\d(:?\d\d)?)?)?)?)?)?\s*$/m,b=(new Date).getFullYear()-70;function _(t){return t&&g.componentsRegistry.calendars&&"string"===typeof t&&"gregorian"!==t}function w(t,e){return _(t)?e?g.getComponentMethod('calendars','CANONICAL_SUNDAY')[t]:g.getComponentMethod('calendars','CANONICAL_TICK')[t]:e?"2000-01-02":"2000-01-01"}function T(t,e){return String(t+Math.pow(10,e)).substr(1)}r.dateTick0=function(t,e){var n=w(t,!!e);if(e<2)return n;var i=r.dateTime2ms(n,t);return i+=f*(e-1),r.ms2DateTime(i,0,t)},r.dfltRange=function(t){return _(t)?g.getComponentMethod('calendars','DFLTRANGE')[t]:["2000-01-01","2001-01-01"]},r.isJSDate=function(t){return"object"===typeof t&&null!==t&&"function"===typeof t.getTime},r.dateTime2ms=function(t,e){if(r.isJSDate(t)){var a=t.getTimezoneOffset()*p,o=(t.getUTCMinutes()-t.getMinutes())*p+(t.getUTCSeconds()-t.getSeconds())*d+(t.getUTCMilliseconds()-t.getMilliseconds());if(o){var s=3*p;a=a-s/2+l(o-a+s/2,s)}return(t=Number(t)-a)>=n&&t<=i?t:u}if("string"!==typeof t&&"number"!==typeof t)return u;t=String(t);var c=_(e),v=t.charAt(0);!c||"G"!==v&&"g"!==v||(t=t.substr(1),e='');var w=c&&"chinese"===e.substr(0,7),T=t.match(w?x:y);if(!T)return u;var k=T[1],M=T[3]||"1",A=Number(T[5]||1),S=Number(T[7]||0),E=Number(T[9]||0),L=Number(T[11]||0);if(c){if(2===k.length)return u;var C;k=Number(k);try{var P=g.getComponentMethod('calendars','getCal')(e);if(w){var I="i"===M.charAt(M.length-1);M=parseInt(M,10),C=P.newDate(k,P.toMonthIndex(k,M,I),A)}else C=P.newDate(k,Number(M),A)}catch(O){return u}return C?(C.toJD()-m)*f+S*h+E*p+L*d:u}k=2===k.length?(Number(k)+2e3-b)%100+b:Number(k),M-=1;var z=new Date(Date.UTC(2e3,M,A,S,E));return z.setUTCFullYear(k),z.getUTCMonth()!==M||z.getUTCDate()!==A?u:z.getTime()+L*d},n=r.MIN_MS=r.dateTime2ms('-9999'),i=r.MAX_MS=r.dateTime2ms('9999-12-31 23:59:59.9999'),r.isDateTime=function(t,e){return r.dateTime2ms(t,e)!==u};var k=90*f,M=3*h,A=5*p;function S(t,e,r,n,i){if((e||r||n||i)&&(t+=" "+T(e,2)+":"+T(r,2),(n||i)&&(t+=":"+T(n,2),i))){for(var a=4;i%10===0;)a-=1,i/=10;t+="."+T(i,a)}return t}r.ms2DateTime=function(t,e,r){if("number"!==typeof t||!(t>=n&&t<=i))return u;e||(e=0);var a,o,s,c,y,x,b=Math.floor(10*l(t+.05,1)),w=Math.round(t-b/10);if(_(r)){var T=Math.floor(w/f)+m,E=Math.floor(l(t,f));try{a=g.getComponentMethod('calendars','getCal')(r).fromJD(T).formatDate('yyyy-mm-dd')}catch(L)[a=v('G%Y-%m-%d')(new Date(w))]if("-"===a.charAt(0))for(;a.length<11;)a="-0"+a.substr(1);else for(;a.length<10;)a="0"+a;o=e<k?Math.floor(E/h):0,s=e<k?Math.floor(E%h/p):0,c=e<M?Math.floor(E%p/d):0,y=e<A?E%d*10+b:0}else x=new Date(w),a=v('%Y-%m-%d')(x),o=e<k?x.getUTCHours():0,s=e<k?x.getUTCMinutes():0,c=e<M?x.getUTCSeconds():0,y=e<A?10*x.getUTCMilliseconds()+b:0;return S(a,o,s,c,y)},r.ms2DateTimeLocal=function(t){if(!(t>=n+f&&t<=i-f))return u;var e=Math.floor(10*l(t+.05,1)),r=new Date(Math.round(t-e/10));return S(a('%Y-%m-%d')(r),r.getHours(),r.getMinutes(),r.getSeconds(),10*r.getUTCMilliseconds()+e)},r.cleanDate=function(t,e,n){if(t===u)return e;if(r.isJSDate(t)||"number"===typeof t&&isFinite(t)){if(_(n))return s.error('JS Dates and milliseconds are incompatible with world calendars',t),e;if(!(t=r.ms2DateTimeLocal(+t))&&void 0!==e)return e}else if(!r.isDateTime(t,n))return s.error('unrecognized date',t),e;return t};var E=/%\d?f/g,L=/%h/g,C={1:"1",2:"1",3:"2",4:"2"};function P(t,e,r,n){t=t.replace(E,(function(t){var r=Math.min(+t.charAt(1)||6,6);return(e/1e3%1+2).toFixed(r).substr(2).replace(/0+$/,'')||"0"}));var i=new Date(Math.floor(e+.05));if(t=t.replace(L,(function(){return C[r('%q')(i)]})),_(n))try{t=g.getComponentMethod('calendars','worldCalFmt')(t,e,n)}catch(a){return"Invalid"}return r(t)(i)}var I=[59,59.9,59.99,59.999,59.9999];function z(t,e){var r=l(t+.05,f),n=T(Math.floor(r/h),2)+":"+T(l(Math.floor(r/p),60),2);if("M"!==e){o(e)||(e=0);var i=(100+Math.min(l(t/d,60),I[e])).toFixed(e).substr(1);e>0&&(i=i.replace(/0+$/,'').replace(/[\.]$/,'')),n+=":"+i}return n}r.formatDate=function(t,e,r,n,i,a){if(i=_(i)&&i,!e)if("y"===r)e=a.year;else if("m"===r)e=a.month;else{if("d"!==r)return z(t,r)+"\n"+P(a.dayMonthYear,t,n,i);e=a.dayMonth+"\n"+a.year}return P(e,t,n,i)};var O=3*f;r.incrementMonth=function(t,e,r){r=_(r)&&r;var n=l(t,f);if(t=Math.round(t-n),r)try{var i=Math.round(t/f)+m,a=g.getComponentMethod('calendars','getCal')(r),o=a.fromJD(i);return e%12?a.add(o,e,'m'):a.add(o,e/12,'y'),(o.toJD()-m)*f+n}catch(u)[s.error("invalid ms '+t+' in calendar '+r)]var c=new Date(t+O);return c.setUTCMonth(c.getUTCMonth()+e)+n-O},r.findExactDates=function(t,e){for(var r,n,i=0,a=0,s=0,l=0,c=_(e)&&g.getComponentMethod('calendars','getCal')(e),u=0;u<t.length;u++)if(n=t[u],o(n)){if(!(n%f))if(c)try{1===(r=c.fromJD(n/f+m)).day()?1===r.month()?i++:a++:s++}catch(p){}else 1===(r=new Date(n)).getUTCDate()?0===r.getUTCMonth()?i++:a++:s++}else l++;s+=a+=i;var h=t.length-l;return{exactYears:i/h,exactMonths:a/h,exactDays:s/h}}},{'../constants/numerical":763,"../registry":915,"./loggers":791,"./mod":794,"d3-time-format":172,"fast-isnumeric":246}],775:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('./loggers'),a=t('./matrix'),o=t('gl-mat4');function s(t){var e;if("string"===typeof t){if(null===(e=document.getElementById(t)))throw new Error("No DOM element with id '"+t+"' exists on the page.");return e}if(null===t||void 0===t)throw new Error('DOM element provided is null or undefined');return t}function l(t){var e=n.select(t);return e.node()instanceof HTMLElement&&e.size()&&e.classed('js-plotly-plot')}function c(t){var e=t&&t.parentNode;e&&e.removeChild(t)}function u(t,e){f('global',t,e)}function f(t,e,r){var n="plotly.js-style-"+t,a=document.getElementById(n);a||((a=document.createElement('style')).setAttribute('id',n),a.appendChild(document.createTextNode('')),document.head.appendChild(a));var o=a.sheet;o.insertRule?o.insertRule(e+"{"+r+"}",0):o.addRule?o.addRule(e,r,0):i.warn('addStyleRule failed')}function h(t){var e="plotly.js-style-"+t,r=document.getElementById(e);r&&c(r)}function p(t){var e=m(t),r=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1];return e.forEach((function(t){var e=d(t);if(e){var n=a.convertCssMatrix(e);r=o.multiply(r,r,n)}})),r}function d(t){var e=window.getComputedStyle(t,null),r=e.getPropertyValue('-webkit-transform')||e.getPropertyValue('-moz-transform')||e.getPropertyValue('-ms-transform')||e.getPropertyValue('-o-transform')||e.getPropertyValue('transform');return"none"===r?null:r.replace('matrix','').replace('3d','').slice(1,-1).split(',').map((function(t){return+t}))}function m(t){for(var e=[];g(t);)e.push(t),t=t.parentNode;return e}function g(t){return t&&(t instanceof Element||t instanceof HTMLElement)}function v(t,e){return t&&e&&t.x===e.x&&t.y===e.y&&t.top===e.top&&t.left===e.left&&t.right===e.right&&t.bottom===e.bottom}e.exports={getGraphDiv:s,isPlotDiv:l,removeElement:c,addStyleRule:u,addRelatedStyleRule:f,deleteRelatedStyleRule:h,getFullTransformMatrix:p,getElementTransformMatrix:d,getElementAndAncestors:m,equalDomRects:v}},{"./loggers":791,"./matrix":793,"@plotly/d3":58,"gl-mat4":292}],776:[function(t,e,r){"use strict";var n=t('events').EventEmitter,i={init:function(t){if(t._ev instanceof n)return t;var e=new n,r=new n;return t._ev=e,t._internalEv=r,t.on=e.on.bind(e),t.once=e.once.bind(e),t.removeListener=e.removeListener.bind(e),t.removeAllListeners=e.removeAllListeners.bind(e),t._internalOn=r.on.bind(r),t._internalOnce=r.once.bind(r),t._removeInternalListener=r.removeListener.bind(r),t._removeAllInternalListeners=r.removeAllListeners.bind(r),t.emit=function(n,i){"undefined"!==typeof jQuery&&jQuery(t).trigger(n,i),e.emit(n,i),r.emit(n,i)},t},triggerHandler:function(t,e,r){var n,i;"undefined"!==typeof jQuery&&(n=jQuery(t).triggerHandler(e,r));var a=t._ev;if(!a)return n;var o,s=a._events[e];if(!s)return n;function l(t){return t.listener?(a.removeListener(e,t.listener),t.fired?void 0:(t.fired=!0,t.listener.apply(a,[r]))):t.apply(a,[r])}for(s=Array.isArray(s)?s:[s],o=0;o<s.length-1;o++)l(s[o]);return i=l(s[o]),void 0!==n?n:i},purge:function(t){return delete t._ev,delete t.on,delete t.once,delete t.removeListener,delete t.removeAllListeners,delete t.emit,delete t._ev,delete t._internalEv,delete t._internalOn,delete t._internalOnce,delete t._removeInternalListener,delete t._removeAllInternalListeners,t}};e.exports=i},{events:116}],777:[function(t,e,r){"use strict";var n=t('./is_plain_object.js'),i=Array.isArray;function a(t,e){var r,n;for(r=0;r<t.length;r++){if(null!==(n=t[r])&&"object"===typeof n)return!1;void 0!==n&&(e[r]=n)}return!0}function o(t,e,r,s){var l,c,u,f,h,p,d=t[0],m=t.length;if(2===m&&i(d)&&i(t[1])&&0===d.length){if(a(t[1],d))return d;d.splice(0,d.length)}for(var g=1;g<m;g++)for(c in l=t[g])u=d[c],f=l[c],s&&i(f)?d[c]=f:e&&f&&(n(f)||(h=i(f)))?(h?(h=!1,p=u&&i(u)?u:[]):p=u&&n(u)?u:{},d[c]=o([p,f],e,r,s)):("undefined"!==typeof f||r)&&(d[c]=f);return d}r.extendFlat=function(){return o(arguments,!1,!1,!1)},r.extendDeep=function(){return o(arguments,!0,!1,!1)},r.extendDeepAll=function(){return o(arguments,!0,!0,!1)},r.extendDeepNoArrays=function(){return o(arguments,!0,!1,!0)}},{"./is_plain_object.js":788}],778:[function(t,e,r){"use strict";e.exports=function(t){for(var e={},r=[],n=0,i=0;i<t.length;i++){var a=t[i];1!==e[a]&&(e[a]=1,r[n++]=a)}return r}},{}],779:[function(t,e,r){"use strict";function n(t){return!0===t.visible}function i(t){var e=t[0].trace;return!0===e.visible&&0!==e._length}function a(t){return Array.isArray(t)&&Array.isArray(t[0])&&t[0][0]&&t[0][0].trace}e.exports=function(t){for(var e=a(t)?i:n,r=[],o=0;o<t.length;o++){var s=t[o];e(s)&&r.push(s)}return r}},{}],780:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('country-regex'),a=t('@turf/area'),o=t('@turf/centroid'),s=t('@turf/bbox'),l=t('./identity'),c=t('./loggers'),u=t('./is_plain_object'),f=t('./nested_property'),h=t('./polygon'),p=Object.keys(i),d={"ISO-3":l,"USA-states":l,"country names":m};function m(t){for(var e=0;e<p.length;e++){var r=p[e];if(new RegExp(i[r]).test(t.trim().toLowerCase()))return r}return c.log('Unrecognized country name: '+t+'.'),!1}function g(t,e,r){if(!e||"string"!==typeof e)return!1;var n,i,a,o=d[t](e);if(o){if("USA-states"===t)for(n=[],a=0;a<r.length;a++)(i=r[a]).properties&&i.properties.gu&&"USA"===i.properties.gu&&n.push(i);else n=r;for(a=0;a<n.length;a++)if((i=n[a]).id===o)return i;c.log(["Location with id",o,"does not have a matching topojson feature at this resolution."].join(' '))}return!1}function v(t){var e,r,n,i,a=t.geometry,o=a.coordinates,s=t.id,l=[];function c(t){for(var e=0;e<t.length-1;e++)if(t[e][0]>0&&t[e+1][0]<0)return e;return null}switch(e="RUS"===s||"FJI"===s?function(t){var e;if(null===c(t))e=t;else for(e=new Array(t.length),i=0;i<t.length;i++)e[i]=[t[i][0]<0?t[i][0]+360:t[i][0],t[i][1]];l.push(h.tester(e))}:"ATA"===s?function(t){var e=c(t);if(null===e)return l.push(h.tester(t));var r=new Array(t.length+1),n=0;for(i=0;i<t.length;i++)i>e?r[n++]=[t[i][0]+360,t[i][1]]:i===e?(r[n++]=t[i],r[n++]=[t[i][0],-90]):r[n++]=t[i];var a=h.tester(r);a.pts.pop(),l.push(a)}:function(t)[l.push(h.tester(t))],a.type){case"MultiPolygon":for(r=0;r<o.length;r++)for(n=0;n<o[r].length;n++)e(o[r][n]);break;case"Polygon":for(r=0;r<o.length;r++)e(o[r])}return l}function y(t){var e=t.geojson,r=window.PlotlyGeoAssets||{},n="string"===typeof e?r[e]:e;return u(n)?n:(c.error("Oops ... something went wrong when fetching "+e),!1)}function x(t){var e=t[0].trace,r=y(e);if(!r)return!1;var n,i={},a=[];for(n=0;n<e._length;n++){var o=t[n];(o.loc||0===o.loc)&&(i[o.loc]=o)}function s(t){var r=f(t,e.featureidkey||"id").get(),n=i[r];if(n){var o=t.geometry;if("Polygon"===o.type||"MultiPolygon"===o.type){var s={type:"Feature",id:r,geometry:o,properties:{}};s.properties.ct=b(s),n.fIn=t,n.fOut=s,a.push(s)}else c.log(["Location",n.loc,'does not have a valid GeoJSON geometry.','Traces with locationmode *geojson-id* only support',"*Polygon* and *MultiPolygon* geometries."].join(' '))}delete i[r]}switch(r.type){case"FeatureCollection":var l=r.features;for(n=0;n<l.length;n++)s(l[n]);break;case"Feature":s(r);break;default:return c.warn(["Invalid GeoJSON type",(r.type||"none")+".",'Traces with locationmode *geojson-id* only support',"*FeatureCollection* and *Feature* types."].join(' ')),!1}for(var u in i)c.log(["Location *"+u+"*",'does not have a matching feature with id-key',"*"+e.featureidkey+"*."].join(' '));return a}function b(t){var e,r=t.geometry;if("MultiPolygon"===r.type)for(var n=r.coordinates,i=0,s=0;s<n.length;s++){var l={type:"Polygon",coordinates:n[s]},c=a.default(l);c>i&&(i=c,e=l)}else e=r;return o.default(e).geometry.coordinates}function _(t)[var e=window.PlotlyGeoAssets||{],r=[];function i(t){return new Promise((function(r,i){n.json(t,(function(n,a){if(n){delete e[t];var o=404===n.status?'GeoJSON at URL ''+t+'' does not exist.':"Unexpected error while fetching from "+t;return i(new Error(o))}return e[t]=a,r(a)}))}))}function a(t){return new Promise((function(r,n){var i=0,a=setInterval((function(){return e[t]&&"pending"!==e[t]?(clearInterval(a),r(e[t])):i>100?(clearInterval(a),n("Unexpected error while fetching from "+t)):void i++}),50)}))}for(var o=0;o<t.length;o++){var s=t[o][0].trace.geojson;"string"===typeof s&&(e[s]?"pending"===e[s]&&r.push(a(s)):(e[s]='pending',r.push(i(s))))}return r}function w(t){return s.default(t)}e.exports={locationToFeature:g,feature2polygons:v,getTraceGeojson:y,extractTraceFeature:x,fetchTraceGeoData:_,computeBbox:w}},{"./identity":785,"./is_plain_object":788,"./loggers":791,"./nested_property":795,"./polygon":799,"@plotly/d3":58,"@turf/area":61,"@turf/bbox":64,"@turf/centroid":67,"country-regex":145}],781:[function(t,e,r){"use strict";var n=t('../constants/numerical').BADNUM;r.calcTraceToLineCoords=function(t){for(var e=t[0].trace.connectgaps,r=[],i=[],a=0;a<t.length;a++){var o=t[a].lonlat;o[0]!==n?i.push(o):!e&&i.length>0&&(r.push(i),i=[])}return i.length>0&&r.push(i),r},r.makeLine=function(t){return 1===t.length?{type:"LineString",coordinates:t[0]}:{type:"MultiLineString",coordinates:t}},r.makePolygon=function(t){if(1===t.length)return{type:"Polygon",coordinates:t};for(var e=new Array(t.length),r=0;r<t.length;r++)e[r]=[t[r]];return{type:"MultiPolygon",coordinates:e}},r.makeBlank=function(){return{type:"Point",coordinates:[]}}},{"../constants/numerical":763}],782:[function(t,e,r){"use strict";var n,i,a,o=t('./mod').mod;function s(t,e,r,n,i,a,o,s){var l=r-t,c=i-t,u=o-i,f=n-e,h=a-e,p=s-a,d=l*p-u*f;if(0===d)return null;var m=(c*p-u*h)/d,g=(c*f-l*h)/d;return g<0||g>1||m<0||m>1?null:{x:t+l*m,y:e+f*m}}function l(t,e,r,n,i){var a=n*t+i*e;if(a<0)return n*n+i*i;if(a>r){var o=n-t,s=i-e;return o*o+s*s}var l=n*e-i*t;return l*l/r}r.segmentsIntersect=s,r.segmentDistance=function(t,e,r,n,i,a,o,c){if(s(t,e,r,n,i,a,o,c))return 0;var u=r-t,f=n-e,h=o-i,p=c-a,d=u*u+f*f,m=h*h+p*p,g=Math.min(l(u,f,d,i-t,a-e),l(u,f,d,o-t,c-e),l(h,p,m,t-i,e-a),l(h,p,m,r-i,n-a));return Math.sqrt(g)},r.getTextLocation=function(t,e,r,s)[if(t===i&&s===a||(n={],i=t,a=s),n[r])return n[r];var l=t.getPointAtLength(o(r-s/2,e)),c=t.getPointAtLength(o(r+s/2,e)),u=Math.atan((c.y-l.y)/(c.x-l.x)),f=t.getPointAtLength(o(r,e)),h={x:(4*f.x+l.x+c.x)/6,y:(4*f.y+l.y+c.y)/6,theta:u};return n[r]=h,h},r.clearLocationCache=function()[i=null],r.getVisibleSegment=function(t,e,r){var n,i,a=e.left,o=e.right,s=e.top,l=e.bottom,c=0,u=t.getTotalLength(),f=u;function h(e){var r=t.getPointAtLength(e);0===e?n=r:e===u&&(i=r);var c=r.x<a?a-r.x:r.x>o?r.x-o:0,f=r.y<s?s-r.y:r.y>l?r.y-l:0;return Math.sqrt(c*c+f*f)}for(var p=h(c);p;){if((c+=p+r)>f)return;p=h(c)}for(p=h(f);p;){if(c>(f-=p+r))return;p=h(f)}return{min:c,max:f,len:f-c,total:u,isClosed:0===c&&f===u&&Math.abs(n.x-i.x)<.1&&Math.abs(n.y-i.y)<.1}},r.findPointOnPath=function(t,e,r,n){for(var i,a,o,s=(n=n||{}).pathLength||t.getTotalLength(),l=n.tolerance||.001,c=n.iterationLimit||30,u=t.getPointAtLength(0)[r]>t.getPointAtLength(s)[r]?-1:1,f=0,h=0,p=s;f<c;){if(i=(h+p)/2,o=(a=t.getPointAtLength(i))[r]-e,Math.abs(o)<l)return a;u*o>0?p=i:h=i,f++}return a}},{"./mod":794}],783:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('tinycolor2'),a=t('color-normalize'),o=t('../components/colorscale'),s=t('../components/color/attributes').defaultLine,l=t('./array').isArrayOrTypedArray,c=a(s),u=1;function f(t,e){var r=t;return r[3]*=e,r}function h(t){if(n(t))return c;var e=a(t);return e.length?e:c}function p(t){return n(t)?t:u}function d(t,e,r){var n,i,s,d,m,g=t.color,v=l(g),y=l(e),x=o.extractOpts(t),b=[];if(n=void 0!==x.colorscale?o.makeColorScaleFuncFromTrace(t):h,i=v?function(t,e){return void 0===t[e]?c:a(n(t[e]))}:h,s=y?function(t,e){return void 0===t[e]?u:p(t[e])}:p,v||y)for(var _=0;_<r;_++)d=i(g,_),m=s(e,_),b[_]=f(d,m);else b=f(a(g),e);return b}function m(t){var e=o.extractOpts(t),r=e.colorscale;return e.reversescale&&(r=o.flipScale(e.colorscale)),r.map((function(t){var e=t[0],r=i(t[1]).toRgb();return{index:e,rgb:[r.r,r.g,r.b,r.a]}}))}e.exports={formatColor:d,parseColorScale:m}},{"../components/color/attributes":649,"../components/colorscale":662,"./array":769,"color-normalize":131,"fast-isnumeric":246,tinycolor2:583}],784:[function(t,e,r){"use strict";var n=t('./identity');function i(t){return[t]}e.exports={keyFun:function(t){return t.key},repeat:i,descend:n,wrap:i,unwrap:function(t){return t[0]}}},{"./identity":785}],785:[function(t,e,r){"use strict";e.exports=function(t){return t}},{}],786:[function(t,e,r){"use strict";e.exports=function(t,e){if(!e)return t;var r=1/Math.abs(e),n=r>1?(r*t+r*e)/r:t+e,i=String(n).length;if(i>16){var a=String(e).length;if(i>=String(t).length+a){var o=parseFloat(n).toPrecision(12);-1===o.indexOf('e+')&&(n=+o)}}return n}},{}],787:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-time-format').utcFormat,a=t('d3-format').format,o=t('fast-isnumeric'),s=t('../constants/numerical'),l=s.FP_SAFE,c=-l,u=s.BADNUM,f=e.exports={};f.adjustFormat=function(t){return!t||/^\d[.]\df/.test(t)||/[.]\d%/.test(t)?t:"0.f"===t?"~f":/^\d%/.test(t)?"~%":/^\ds/.test(t)?"~s":!/^[~,.0$]/.test(t)&&/[&fps]/.test(t)?"~"+t:t};var h={};f.warnBadFormat=function(t){var e=String(t);h[e]||(h[e]=1,f.warn('encountered bad format: "'+e+'"'))},f.noFormat=function(t){return String(t)},f.numberFormat=function(t){var e;try{e=a(f.adjustFormat(t))}catch(r){return f.warnBadFormat(t),f.noFormat}return e},f.nestedProperty=t('./nested_property'),f.keyedContainer=t('./keyed_container'),f.relativeAttr=t('./relative_attr'),f.isPlainObject=t('./is_plain_object'),f.toLogRange=t('./to_log_range'),f.relinkPrivateKeys=t('./relink_private');var p=t('./array');f.isTypedArray=p.isTypedArray,f.isArrayOrTypedArray=p.isArrayOrTypedArray,f.isArray1D=p.isArray1D,f.ensureArray=p.ensureArray,f.concat=p.concat,f.maxRowLength=p.maxRowLength,f.minRowLength=p.minRowLength;var d=t('./mod');f.mod=d.mod,f.modHalf=d.modHalf;var m=t('./coerce');f.valObjectMeta=m.valObjectMeta,f.coerce=m.coerce,f.coerce2=m.coerce2,f.coerceFont=m.coerceFont,f.coercePattern=m.coercePattern,f.coerceHoverinfo=m.coerceHoverinfo,f.coerceSelectionMarkerOpacity=m.coerceSelectionMarkerOpacity,f.validate=m.validate;var g=t('./dates');f.dateTime2ms=g.dateTime2ms,f.isDateTime=g.isDateTime,f.ms2DateTime=g.ms2DateTime,f.ms2DateTimeLocal=g.ms2DateTimeLocal,f.cleanDate=g.cleanDate,f.isJSDate=g.isJSDate,f.formatDate=g.formatDate,f.incrementMonth=g.incrementMonth,f.dateTick0=g.dateTick0,f.dfltRange=g.dfltRange,f.findExactDates=g.findExactDates,f.MIN_MS=g.MIN_MS,f.MAX_MS=g.MAX_MS;var v=t('./search');f.findBin=v.findBin,f.sorterAsc=v.sorterAsc,f.sorterDes=v.sorterDes,f.distinctVals=v.distinctVals,f.roundUp=v.roundUp,f.sort=v.sort,f.findIndexOfMin=v.findIndexOfMin,f.sortObjectKeys=t('./sort_object_keys');var y=t('./stats');f.aggNums=y.aggNums,f.len=y.len,f.mean=y.mean,f.median=y.median,f.midRange=y.midRange,f.variance=y.variance,f.stdev=y.stdev,f.interp=y.interp;var x=t('./matrix');f.init2dArray=x.init2dArray,f.transposeRagged=x.transposeRagged,f.dot=x.dot,f.translationMatrix=x.translationMatrix,f.rotationMatrix=x.rotationMatrix,f.rotationXYMatrix=x.rotationXYMatrix,f.apply3DTransform=x.apply3DTransform,f.apply2DTransform=x.apply2DTransform,f.apply2DTransform2=x.apply2DTransform2,f.convertCssMatrix=x.convertCssMatrix,f.inverseTransformMatrix=x.inverseTransformMatrix;var b=t('./angles');f.deg2rad=b.deg2rad,f.rad2deg=b.rad2deg,f.angleDelta=b.angleDelta,f.angleDist=b.angleDist,f.isFullCircle=b.isFullCircle,f.isAngleInsideSector=b.isAngleInsideSector,f.isPtInsideSector=b.isPtInsideSector,f.pathArc=b.pathArc,f.pathSector=b.pathSector,f.pathAnnulus=b.pathAnnulus;var _=t('./anchor_utils');f.isLeftAnchor=_.isLeftAnchor,f.isCenterAnchor=_.isCenterAnchor,f.isRightAnchor=_.isRightAnchor,f.isTopAnchor=_.isTopAnchor,f.isMiddleAnchor=_.isMiddleAnchor,f.isBottomAnchor=_.isBottomAnchor;var w=t('./geometry2d');f.segmentsIntersect=w.segmentsIntersect,f.segmentDistance=w.segmentDistance,f.getTextLocation=w.getTextLocation,f.clearLocationCache=w.clearLocationCache,f.getVisibleSegment=w.getVisibleSegment,f.findPointOnPath=w.findPointOnPath;var T=t('./extend');f.extendFlat=T.extendFlat,f.extendDeep=T.extendDeep,f.extendDeepAll=T.extendDeepAll,f.extendDeepNoArrays=T.extendDeepNoArrays;var k=t('./loggers');f.log=k.log,f.warn=k.warn,f.error=k.error;var M=t('./regex');f.counterRegex=M.counter;var A=t('./throttle');f.throttle=A.throttle,f.throttleDone=A.done,f.clearThrottle=A.clear;var S=t('./dom');function E(t)[var e={];for(var r in t)for(var n=t[r],i=0;i<n.length;i++)e[n[i]]=+r;return e}f.getGraphDiv=S.getGraphDiv,f.isPlotDiv=S.isPlotDiv,f.removeElement=S.removeElement,f.addStyleRule=S.addStyleRule,f.addRelatedStyleRule=S.addRelatedStyleRule,f.deleteRelatedStyleRule=S.deleteRelatedStyleRule,f.getFullTransformMatrix=S.getFullTransformMatrix,f.getElementTransformMatrix=S.getElementTransformMatrix,f.getElementAndAncestors=S.getElementAndAncestors,f.equalDomRects=S.equalDomRects,f.clearResponsive=t('./clear_responsive'),f.preserveDrawingBuffer=t('./preserve_drawing_buffer'),f.makeTraceGroups=t('./make_trace_groups'),f._=t('./localize'),f.notifier=t('./notifier'),f.filterUnique=t('./filter_unique'),f.filterVisible=t('./filter_visible'),f.pushUnique=t('./push_unique'),f.increment=t('./increment'),f.cleanNumber=t('./clean_number'),f.ensureNumber=function(t){return o(t)?(t=Number(t))>l||t<c?u:t:u},f.isIndex=function(t,e){return!(void 0!==e&&t>=e)&&o(t)&&t>=0&&t%1===0},f.noop=t('./noop'),f.identity=t('./identity'),f.repeat=function(t,e){for(var r=new Array(e),n=0;n<e;n++)r[n]=t;return r},f.swapAttrs=function(t,e,r,n){r||(r='x'),n||(n='y');for(var i=0;i<e.length;i++){var a=e[i],o=f.nestedProperty(t,a.replace('?',r)),s=f.nestedProperty(t,a.replace('?',n)),l=o.get();o.set(s.get()),s.set(l)}},f.raiseToTop=function(t)[t.parentNode.appendChild(t)],f.cancelTransition=function(t){return t.transition().duration(0)},f.constrain=function(t,e,r){return e>r?Math.max(r,Math.min(e,t)):Math.max(e,Math.min(r,t))},f.bBoxIntersect=function(t,e,r){return r=r||0,t.left<=e.right+r&&e.left<=t.right+r&&t.top<=e.bottom+r&&e.top<=t.bottom+r},f.simpleMap=function(t,e,r,n,i){for(var a=t.length,o=new Array(a),s=0;s<a;s++)o[s]=e(t[s],r,n,i);return o},f.randstr=function t(e,r,n,i){if(n||(n=16),void 0===r&&(r=24),r<=0)return'0';var a,o,s=Math.log(Math.pow(2,r))/Math.log(n),l='';for(a=2;s===1/0;a*=2)s=Math.log(Math.pow(2,r/a))/Math.log(n)*a;var c=s-Math.floor(s);for(a=0;a<Math.floor(s);a++)l=Math.floor(Math.random()*n).toString(n)+l;c&&(o=Math.pow(n,c),l=Math.floor(Math.random()*o).toString(n)+l);var u=parseInt(l,n);return e&&e[l]||u!==1/0&&u>=Math.pow(2,r)?i>10?(f.warn('randstr failed uniqueness'),l):t(e,r,n,(i||0)+1):l},f.OptionControl=function(t,e)[t||(t={]),e||(e='opt');var r={optionList:[],_newoption:function(n){n[e]=t,r[n.name]=n,r.optionList.push(n)}};return r["_"+e]=t,r},f.smooth=function(t,e){if((e=Math.round(e)||0)<2)return t;var r,n,i,a,o=t.length,s=2*o,l=2*e-1,c=new Array(l),u=new Array(o);for(r=0;r<l;r++)c[r]=(1-Math.cos(Math.PI*(r+1)/e))/(2*e);for(r=0;r<o;r++){for(a=0,n=0;n<l;n++)(i=r+n+1-e)<-o?i-=s*Math.round(i/s):i>=s&&(i-=s*Math.floor(i/s)),i<0?i=-1-i:i>=o&&(i=s-1-i),a+=t[i]*c[n];u[r]=a}return u},f.syncOrAsync=function(t,e,r){var n;function i(){return f.syncOrAsync(t,e,r)}for(;t.length;)if((n=(0,t.splice(0,1)[0])(e))&&n.then)return n.then(i);return r&&r(e)},f.stripTrailingSlash=function(t){return"/"===t.substr(-1)?t.substr(0,t.length-1):t},f.noneOrAll=function(t,e,r){if(t){var n,i,a=!1,o=!0;for(n=0;n<r.length;n++)void 0!==(i=t[r[n]])&&null!==i?a=!0:o=!1;if(a&&!o)for(n=0;n<r.length;n++)t[r[n]]=e[r[n]]}},f.mergeArray=function(t,e,r,n){var i="function"===typeof n;if(f.isArrayOrTypedArray(t))for(var a=Math.min(t.length,e.length),o=0;o<a;o++){var s=t[o];e[o][r]=i?n(s):s}},f.mergeArrayCastPositive=function(t,e,r){return f.mergeArray(t,e,r,(function(t){var e=+t;return isFinite(e)&&e>0?e:0}))},f.fillArray=function(t,e,r,n){if(n=n||f.identity,f.isArrayOrTypedArray(t))for(var i=0;i<e.length;i++)e[i][r]=n(t[i])},f.castOption=function(t,e,r,n){n=n||f.identity;var i=f.nestedProperty(t,r).get();return f.isArrayOrTypedArray(i)?Array.isArray(e)&&f.isArrayOrTypedArray(i[e[0]])?n(i[e[0]][e[1]]):n(i[e]):i},f.extractOption=function(t,e,r,n){if(r in t)return t[r];var i=f.nestedProperty(e,n).get();return Array.isArray(i)?void 0:i},f.tagSelected=function(t,e,r){var n,i=e.selectedpoints,a=e._indexToPoints;function o(e){return void 0!==e&&e<t.length}a&&(n=E(a));for(var s=0;s<i.length;s++){var l=i[s];if(f.isIndex(l)||f.isArrayOrTypedArray(l)&&f.isIndex(l[0])&&f.isIndex(l[1])){var c=n?n[l]:l,u=r?r[c]:c;o(u)&&(t[u].selected=1)}}},f.selIndices2selPoints=function(t){var e=t.selectedpoints,r=t._indexToPoints;if(r){for(var n=E(r),i=[],a=0;a<e.length;a++){var o=e[a];if(f.isIndex(o)){var s=n[o];f.isIndex(s)&&i.push(s)}}return i}return e},f.getTargetArray=function(t,e){var r=e.target;if("string"===typeof r&&r){var n=f.nestedProperty(t,r).get();return!!Array.isArray(n)&&n}return!!Array.isArray(r)&&r},f.minExtend=function(t,e)[var r={];"object"!==typeof e&&(e={});var n,i,a,o=3,s=Object.keys(t);for(n=0;n<s.length;n++)a=t[i=s[n]],"_"!==i.charAt(0)&&"function"!==typeof a&&("module"===i?r[i]=a:Array.isArray(a)?r[i]="colorscale"===i?a.slice():a.slice(0,o):f.isTypedArray(a)?r[i]=a.subarray(0,o):r[i]=a&&"object"===typeof a?f.minExtend(t[i],e[i]):a);for(s=Object.keys(e),n=0;n<s.length;n++)"object"===typeof(a=e[i=s[n]])&&i in r&&"object"===typeof r[i]||(r[i]=a);return r},f.titleCase=function(t){return t.charAt(0).toUpperCase()+t.substr(1)},f.containsAny=function(t,e){for(var r=0;r<e.length;r++)if(-1!==t.indexOf(e[r]))return!0;return!1},f.isIE=function(){return"undefined"!==typeof window.navigator.msSaveBlob};var L=/Version\/[\d\.]+.*Safari/;f.isSafari=function(){return L.test(window.navigator.userAgent)};var C=/iPad|iPhone|iPod/;f.isIOS=function(){return C.test(window.navigator.userAgent)};var P=/Firefox\/(\d+)\.\d+/;f.getFirefoxVersion=function(){var t=P.exec(window.navigator.userAgent);if(t&&2===t.length){var e=parseInt(t[1]);if(!isNaN(e))return e}return null},f.isD3Selection=function(t){return t instanceof n.selection},f.ensureSingle=function(t,e,r,n){var i=t.select(e+(r?"."+r:""));if(i.size())return i;var a=t.append(e);return r&&a.classed(r,!0),n&&a.call(n),a},f.ensureSingleById=function(t,e,r,n){var i=t.select(e+"#"+r);if(i.size())return i;var a=t.append(e).attr('id',r);return n&&a.call(n),a},f.objectFromPath=function(t,e){for(var r,n=t.split('.'),i=r={},a=0;a<n.length;a++){var o=n[a],s=null,l=n[a].match(/(.*)\[([0-9]+)\]/);l?(o=l[1],s=l[2],r=r[o]=[],a===n.length-1?r[s]=e:r[s]={},r=r[s]):(a===n.length-1?r[o]=e:r[o]={},r=r[o])}return i};var I=/^([^\[\.]+)\.(.+)?/,z=/^([^\.]+)\[([0-9]+)\](\.)?(.+)?/;f.expandObjectPaths=function(t){var e,r,n,i,a,o,s;if("object"===typeof t&&!Array.isArray(t))for(r in t)t.hasOwnProperty(r)&&((e=r.match(I))?(i=t[r],n=e[1],delete t[r],t[n]=f.extendDeepNoArrays(t[n]||{},f.objectFromPath(r,f.expandObjectPaths(i))[n])):(e=r.match(z))?(i=t[r],n=e[1],a=parseInt(e[2]),delete t[r],t[n]=t[n]||[],"."===e[3]?(s=e[4],o=t[n][a]=t[n][a]||{},f.extendDeepNoArrays(o,f.objectFromPath(s,f.expandObjectPaths(i)))):t[n][a]=f.expandObjectPaths(i)):t[r]=f.expandObjectPaths(t[r]));return t},f.numSeparate=function(t,e,r){if(r||(r=!1),"string"!==typeof e||0===e.length)throw new Error('Separator string required for formatting!');"number"===typeof t&&(t=String(t));var n=/(\d+)(\d{3})/,i=e.charAt(0),a=e.charAt(1),o=t.split('.'),s=o[0],l=o.length>1?i+o[1]:"";if(a&&(o.length>1||s.length>4||r))for(;n.test(s);)s=s.replace(n,"$1"+a+"$2");return s+l},f.TEMPLATE_STRING_REGEX=/%[([^\s%{]:]*)([:|\|][^}]*)?}/g;var O=/^\w*$/;f.templateString=function(t,e)[var r={];return t.replace(f.TEMPLATE_STRING_REGEX,(function(t,n){var i;return O.test(n)?i=e[n]:(r[n]=r[n]||f.nestedProperty(e,n).get,i=r[n]()),f.isValidTextValue(i)?i:""}))};var D={max:10,count:0,name:"hovertemplate"};f.hovertemplateString=function(){return B.apply(D,arguments)};var R={max:10,count:0,name:"texttemplate"};f.texttemplateString=function(){return B.apply(R,arguments)};var F=/^[:|\|]/;function B(t,e,r){var n=this,a=arguments;e||(e={});var o={};return t.replace(f.TEMPLATE_STRING_REGEX,(function(t,s,l){var c,u,h,p="_xother"===s||"_yother"===s,d="_xother_"===s||"_yother_"===s,m="xother_"===s||"yother_"===s,g="xother"===s||"yother"===s||p||m||d,v=s;if((p||d)&&(v=v.substring(1)),(m||d)&&(v=v.substring(0,v.length-1)),g){if(void 0===(c=e[v]))return""}else for(h=3;h<a.length;h++)if(u=a[h]){if(u.hasOwnProperty(v)){c=u[v];break}if(O.test(v)||(c=f.nestedProperty(u,v).get(),(c=o[v]||f.nestedProperty(u,v).get())&&(o[v]=c)),void 0!==c)break}if(void 0===c&&n)return n.count<n.max&&(f.warn("Variable '"+v+"' in '+n.name+' could not be found!"),c=t),n.count===n.max&&f.warn('Too many '+n.name+' warnings - additional warnings will be suppressed'),n.count++,t;if(l){var y;if(":"===l[0]&&(c=(y=r?r.numberFormat:f.numberFormat)(l.replace(F,''))(c)),"|"===l[0]){y=r?r.timeFormat:i;var x=f.dateTime2ms(c);c=f.formatDate(x,l.replace(F,''),!1,y)}}else{var b=v+"Label";e.hasOwnProperty(b)&&(c=e[b])}return g&&(c='('+c+')',(p||d)&&(c=' '+c),(m||d)&&(c+=' ')),c}))}var N=48,j=57;f.subplotSort=function(t,e){for(var r=Math.min(t.length,e.length)+1,n=0,i=0,a=0;a<r;a++){var o=t.charCodeAt(a)||0,s=e.charCodeAt(a)||0,l=o>=N&&o<=j,c=s>=N&&s<=j;if(l&&(n=10*n+o-N),c&&(i=10*i+s-N),!l||!c){if(n!==i)return n-i;if(o!==s)return o-s}}return i-n};var U=2e9;f.seedPseudoRandom=function()[U=2e9],f.pseudoRandom=function(){var t=U;return U=(69069*U+1)%4294967296,Math.abs(U-t)<429496729?f.pseudoRandom():U/4294967296},f.fillText=function(t,e,r){var n=Array.isArray(r)?function(t){r.push(t)}:function(t)[r.text=t],i=f.extractOption(t,e,'htx','hovertext');if(f.isValidTextValue(i))return n(i);var a=f.extractOption(t,e,'tx','text');return f.isValidTextValue(a)?n(a):void 0},f.isValidTextValue=function(t){return t||0===t},f.formatPercent=function(t,e){e=e||0;for(var r=(Math.round(100*t*Math.pow(10,e))*Math.pow(.1,e)).toFixed(e)+"%",n=0;n<e;n++)-1!==r.indexOf('.')&&(r=(r=r.replace('0%','%')).replace('.%','%'));return r},f.isHidden=function(t){var e=window.getComputedStyle(t).display;return!e||"none"===e},f.strTranslate=function(t,e){return t||e?"translate('+t+','+e+')":""},f.strRotate=function(t){return t?"rotate('+t+')":""},f.strScale=function(t){return 1!==t?"scale('+t+')":""},f.getTextTransform=function(t){var e=t.noCenter,r=t.textX,n=t.textY,i=t.targetX,a=t.targetY,o=t.anchorX||0,s=t.anchorY||0,l=t.rotate,c=t.scale;return c?c>1&&(c=1):c=0,f.strTranslate(i-c*(r+o),a-c*(n+s))+f.strScale(c)+(l?"rotate("+l+(e?"":" '+r+' '+n)+')":"")},f.ensureUniformFontSize=function(t,e)[var r=f.extendFlat({],e);return r.size=Math.max(e.size,t._fullLayout.uniformtext.minsize||0),r},f.join2=function(t,e,r){var n=t.length;return n>1?t.slice(0,-1).join(e)+r+t[n-1]:t.join(e)},f.bigFont=function(t){return Math.round(1.2*t)};var V=f.getFirefoxVersion(),H=null!==V&&V<86;f.getPositionFromD3Event=function(){return H?[n.event.layerX,n.event.layerY]:[n.event.offsetX,n.event.offsetY]}},{"../constants/numerical":763,"./anchor_utils":767,"./angles":768,"./array":769,"./clean_number":770,"./clear_responsive":772,"./coerce":773,"./dates":774,"./dom":775,"./extend":777,"./filter_unique":778,"./filter_visible":779,"./geometry2d":782,"./identity":785,"./increment":786,"./is_plain_object":788,"./keyed_container":789,"./localize":790,"./loggers":791,"./make_trace_groups":792,"./matrix":793,"./mod":794,"./nested_property":795,"./noop":796,"./notifier":797,"./preserve_drawing_buffer":801,"./push_unique":802,"./regex":804,"./relative_attr":805,"./relink_private":806,"./search":807,"./sort_object_keys":810,"./stats":811,"./throttle":814,"./to_log_range":815,"@plotly/d3":58,"d3-format":164,"d3-time-format":172,"fast-isnumeric":246}],788:[function(t,e,r){"use strict";e.exports=function(t){return window&&window.process&&window.process.versions?"[object Object]"===Object.prototype.toString.call(t):"[object Object]"===Object.prototype.toString.call(t)&&Object.getPrototypeOf(t).hasOwnProperty('hasOwnProperty')}},{}],789:[function(t,e,r){"use strict";var n=t('./nested_property'),i=/^\w*$/,a=0,o=1,s=2,l=3,c=4;e.exports=function(t,e,r,u){var f,h,p;r=r||"name",u=u||"value";var d={};e&&e.length?(p=n(t,e),h=p.get()):h=t,e=e||"";var m={};if(h)for(f=0;f<h.length;f++)m[h[f][r]]=f;var g=i.test(u),v={set:function(t,e){var i=null===e?c:a;if(!h){if(!p||i===c)return;h=[],p.set(h)}var o=m[t];if(void 0===o){if(i===c)return;i|=l,o=h.length,m[t]=o}else e!==(g?h[o][u]:n(h[o],u).get())&&(i|=s);var f=h[o]=h[o]||{};return f[r]=t,g?f[u]=e:n(f,u).set(e),null!==e&&(i&=~c),d[o]=d[o]|i,v},get:function(t){if(h){var e=m[t];return void 0===e?void 0:g?h[e][u]:n(h[e],u).get()}},rename:function(t,e){var n=m[t];return void 0===n||(d[n]=d[n]|o,m[e]=n,delete m[t],h[n][r]=e),v},remove:function(t){var e=m[t];if(void 0===e)return v;var i=h[e];if(Object.keys(i).length>2)return d[e]=d[e]|s,v.set(t,null);if(g){for(f=e;f<h.length;f++)d[f]=d[f]|l;for(f=e;f<h.length;f++)m[h[f][r]]--;h.splice(e,1),delete m[t]}else n(i,u).set(null),d[e]=d[e]|s|c;return v},constructUpdate:function(){for(var t,i,a={},l=Object.keys(d),f=0;f<l.length;f++)i=l[f],t=e+"["+i+"]",h[i]?(d[i]&o&&(a[t+"."+r]=h[i][r]),d[i]&s&&(a[t+"."+u]=g?d[i]&c?null:h[i][u]:d[i]&c?null:n(h[i],u).get())):a[t]=null;return a}};return v}},{"./nested_property":795}],790:[function(t,e,r){"use strict";var n=t('../registry');e.exports=function(t,e){for(var r=t._context.locale,i=0;i<2;i++){for(var a=t._context.locales,o=0;o<2;o++){var s=(a[r]||{}).dictionary;if(s){var l=s[e];if(l)return l}a=n.localeRegistry}var c=r.split('-')[0];if(c===r)break;r=c}return e}},{"../registry":915}],791:[function(t,e,r){"use strict";var n=t('../plot_api/plot_config').dfltConfig,i=t('./notifier'),a=e.exports={};a.log=function(){var t;if(n.logging>1){var e=["LOG:"];for(t=0;t<arguments.length;t++)e.push(arguments[t]);console.trace.apply(console,e)}if(n.notifyOnLogging>1){var r=[];for(t=0;t<arguments.length;t++)r.push(arguments[t]);i(r.join('<br>'),'long')}},a.warn=function(){var t;if(n.logging>0){var e=["WARN:"];for(t=0;t<arguments.length;t++)e.push(arguments[t]);console.trace.apply(console,e)}if(n.notifyOnLogging>0){var r=[];for(t=0;t<arguments.length;t++)r.push(arguments[t]);i(r.join('<br>'),'stick')}},a.error=function(){var t;if(n.logging>0){var e=["ERROR:"];for(t=0;t<arguments.length;t++)e.push(arguments[t]);console.error.apply(console,e)}if(n.notifyOnLogging>0){var r=[];for(t=0;t<arguments.length;t++)r.push(arguments[t]);i(r.join('<br>'),'stick')}}},{"../plot_api/plot_config":825,"./notifier":797}],792:[function(t,e,r){"use strict";var n=t('@plotly/d3');e.exports=function(t,e,r){var i=t.selectAll("g."+r.replace(/\s/g,'.')).data(e,(function(t){return t[0].trace.uid}));i.exit().remove(),i.enter().append('g').attr('class',r),i.order();var a=t.classed('rangeplot')?"nodeRangePlot3":"node3";return i.each((function(t)[t[0][a]=n.select(this)])),i}},{"@plotly/d3":58}],793:[function(t,e,r){"use strict";var n=t('gl-mat4');r.init2dArray=function(t,e){for(var r=new Array(t),n=0;n<t;n++)r[n]=new Array(e);return r},r.transposeRagged=function(t){var e,r,n=0,i=t.length;for(e=0;e<i;e++)n=Math.max(n,t[e].length);var a=new Array(n);for(e=0;e<n;e++)for(a[e]=new Array(i),r=0;r<i;r++)a[e][r]=t[r][e];return a},r.dot=function(t,e){if(!t.length||!e.length||t.length!==e.length)return null;var n,i,a=t.length;if(t[0].length)for(n=new Array(a),i=0;i<a;i++)n[i]=r.dot(t[i],e);else if(e[0].length){var o=r.transposeRagged(e);for(n=new Array(o.length),i=0;i<o.length;i++)n[i]=r.dot(t,o[i])}else for(n=0,i=0;i<a;i++)n+=t[i]*e[i];return n},r.translationMatrix=function(t,e){return[[1,0,t],[0,1,e],[0,0,1]]},r.rotationMatrix=function(t){var e=t*Math.PI/180;return[[Math.cos(e),-Math.sin(e),0],[Math.sin(e),Math.cos(e),0],[0,0,1]]},r.rotationXYMatrix=function(t,e,n){return r.dot(r.dot(r.translationMatrix(e,n),r.rotationMatrix(t)),r.translationMatrix(-e,-n))},r.apply3DTransform=function(t){return function(){var e=arguments,n=1===arguments.length?e[0]:[e[0],e[1],e[2]||0];return r.dot(t,[n[0],n[1],n[2],1]).slice(0,3)}},r.apply2DTransform=function(t){return function(){var e=arguments;3===e.length&&(e=e[0]);var n=1===arguments.length?e[0]:[e[0],e[1]];return r.dot(t,[n[0],n[1],1]).slice(0,2)}},r.apply2DTransform2=function(t){var e=r.apply2DTransform(t);return function(t){return e(t.slice(0,2)).concat(e(t.slice(2,4)))}},r.convertCssMatrix=function(t){if(t){var e=t.length;if(16===e)return t;if(6===e)return[t[0],t[1],0,0,t[2],t[3],0,0,0,0,1,0,t[4],t[5],0,1]}return[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]},r.inverseTransformMatrix=function(t){var e=[];return n.invert(e,t),[[e[0],e[1],e[2],e[3]],[e[4],e[5],e[6],e[7]],[e[8],e[9],e[10],e[11]],[e[12],e[13],e[14],e[15]]]}},{"gl-mat4":292}],794:[function(t,e,r){"use strict";function n(t,e){var r=t%e;return r<0?r+e:r}function i(t,e){return Math.abs(t)>e/2?t-Math.round(t/e)*e:t}e.exports={mod:n,modHalf:i}},{}],795:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('./array').isArrayOrTypedArray;function a(t,e){return function(){var r,n,o,s,l,c=t;for(s=0;s<e.length-1;s++){if(-1===(r=e[s])){for(n=!0,o=[],l=0;l<c.length;l++)o[l]=a(c[l],e.slice(s+1))(),o[l]!==o[0]&&(n=!1);return n?o[0]:o}if("number"===typeof r&&!i(c))return;if("object"!==typeof(c=c[r])||null===c)return}if("object"===typeof c&&null!==c&&null!==(o=c[e[s]]))return o}}e.exports=function(t,e){if(n(e))e=String(e);else if("string"!==typeof e||"[-1]"===e.substr(e.length-4))throw"bad property string";for(var r,i,o,s=0,c=e.split('.');s<c.length;){if(r=String(c[s]).match(/^([^\[\]]*)((\[\-?[0-9]*\])+)$/)){if(r[1])c[s]=r[1];else{if(0!==s)throw"bad property string";c.splice(0,1)}for(i=r[2].substr(1,r[2].length-2).split(']['),o=0;o<i.length;o++)s++,c.splice(s,0,Number(i[o]))}s++}return"object"!==typeof t?h(t,e,c):{set:l(t,c,e),get:a(t,c),astr:e,parts:c,obj:t}};var o=/(^|\.)args\[/;function s(t,e){return void 0===t||null===t&&!e.match(o)}function l(t,e,r){return function(n){var a,o,l=t,h='',p=[[t,h]],d=s(n,r);for(o=0;o<e.length-1;o++){if("number"===typeof(a=e[o])&&!i(l))throw"array index but container is not an array";if(-1===a){if(d=!u(l,e.slice(o+1),n,r))break;return}if(!f(l,a,e[o+1],d))break;if("object"!==typeof(l=l[a])||null===l)throw"container is not an object";h=c(h,a),p.push([l,h])}if(d){if(o===e.length-1&&(delete l[e[o]],Array.isArray(l)&&+e[o]===l.length-1))for(;l.length&&void 0===l[l.length-1];)l.pop()}else l[e[o]]=n}}function c(t,e){var r=e;return n(e)?r="["+e+"]":t&&(r="."+e),t+r}function u(t,e,r,n){var a,o=i(r),c=!0,u=r,h=n.replace('-1',0),p=!o&&s(r,h),d=e[0];for(a=0;a<t.length;a++)h=n.replace('-1',a),o&&(p=s(u=r[a%r.length],h)),p&&(c=!1),f(t,a,d,p)&&l(t[a],e,n.replace('-1',a))(u);return c}function f(t,e,r,n){if(void 0===t[e]){if(n)return!1;t[e]="number"===typeof r?[]:{}}return!0}function h(t,e,r){return{set:function(){throw"bad container"},get:function(){},astr:e,parts:r,obj:t}}},{"./array":769,"fast-isnumeric":246}],796:[function(t,e,r){"use strict";e.exports=function(){}},{}],797:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=[];e.exports=function(t,e){if(-1===a.indexOf(t)){a.push(t);var r=1e3;i(e)?r=e:"long"===e&&(r=3e3);var o=n.select('body').selectAll('.plotly-notifier').data([0]);o.enter().append('div').classed('plotly-notifier',!0),o.selectAll('.notifier-note').data(a).enter().append('div').classed('notifier-note',!0).style('opacity',0).each((function(t){var i=n.select(this);i.append('button').classed('notifier-close',!0).html('&times;').on('click',(function(){i.transition().call(s)}));for(var a=i.append('p'),o=t.split(/<br\s*\/?>/g),l=0;l<o.length;l++)l&&a.append('br'),a.append('span').text(o[l]);"stick"===e?i.transition().duration(350).style('opacity',1):i.transition().duration(700).style('opacity',1).transition().delay(r).call(s)}))}function s(t){t.duration(700).style('opacity',0).each('end',(function(t){var e=a.indexOf(t);-1!==e&&a.splice(e,1),n.select(this).remove()}))}}},{"@plotly/d3":58,"fast-isnumeric":246}],798:[function(t,e,r){"use strict";var n=t('./setcursor'),i='data-savedcursor',a='!!';e.exports=function(t,e){var r=t.attr(i);if(e){if(!r){for(var o=(t.attr('class')||"").split(' '),s=0;s<o.length;s++){var l=o[s];0===l.indexOf('cursor-')&&t.attr(i,l.substr(7)).classed(l,!1)}t.attr(i)||t.attr(i,a)}n(t,e)}else r&&(t.attr(i,null),r===a?n(t):n(t,r))}},{"./setcursor":808}],799:[function(t,e,r){"use strict";var n=t('./matrix').dot,i=t('../constants/numerical').BADNUM,a=e.exports={};a.tester=function(t){var e,r=t.slice(),n=r[0][0],a=n,o=r[0][1],s=o;for(r.push(r[0]),e=1;e<r.length;e++)n=Math.min(n,r[e][0]),a=Math.max(a,r[e][0]),o=Math.min(o,r[e][1]),s=Math.max(s,r[e][1]);var l,c=!1;function u(t,e){var r=t[0],c=t[1];return!(r===i||r<n||r>a||c===i||c<o||c>s)&&(!e||!l(t))}function f(t,e){var l=t[0],c=t[1];if(l===i||l<n||l>a||c===i||c<o||c>s)return!1;var u,f,h,p,d,m=r.length,g=r[0][0],v=r[0][1],y=0;for(u=1;u<m;u++)if(f=g,h=v,g=r[u][0],v=r[u][1],!(l<(p=Math.min(f,g))||l>Math.max(f,g)||c>Math.max(h,v)))if(c<Math.min(h,v))l!==p&&y++;else{if(c===(d=g===f?c:h+(l-f)*(v-h)/(g-f)))return 1!==u||!e;c<=d&&l!==p&&y++}return y%2===1}5===r.length&&(r[0][0]===r[1][0]?r[2][0]===r[3][0]&&r[0][1]===r[3][1]&&r[1][1]===r[2][1]&&(c=!0,l=function(t){return t[0]===r[0][0]}):r[0][1]===r[1][1]&&r[2][1]===r[3][1]&&r[0][0]===r[3][0]&&r[1][0]===r[2][0]&&(c=!0,l=function(t){return t[1]===r[0][1]}));var h=!0,p=r[0];for(e=1;e<r.length;e++)if(p[0]!==r[e][0]||p[1]!==r[e][1]){h=!1;break}return{xmin:n,xmax:a,ymin:o,ymax:s,pts:r,contains:c?u:f,isRect:c,degenerate:h}},a.isSegmentBent=function(t,e,r,i){var a,o,s,l=t[e],c=[t[r][0]-l[0],t[r][1]-l[1]],u=n(c,c),f=Math.sqrt(u),h=[-c[1]/f,c[0]/f];for(a=e+1;a<r;a++)if(o=[t[a][0]-l[0],t[a][1]-l[1]],(s=n(o,c))<0||s>u||Math.abs(n(o,h))>i)return!0;return!1},a.filter=function(t,e){var r=[t[0]],n=0,i=0;function o(o){t.push(o);var s=r.length,l=n;r.splice(i+1);for(var c=l+1;c<t.length;c++)(c===t.length-1||a.isSegmentBent(t,l,c+1,e))&&(r.push(t[c]),r.length<s-2&&(n=c,i=r.length-1),l=c)}return t.length>1&&o(t.pop()),{addPt:o,raw:t,filtered:r}}},{"../constants/numerical":763,"./matrix":793}],800:[function(t,e,n){(function(r){(function(){"use strict";var n=t('./show_no_webgl_msg'),i=t('regl');e.exports=function(t,e){var a=t._fullLayout,o=!0;return a._glcanvas.each((function(n){if(!n.regl&&(!n.pick||a._has('parcoords'))){try{n.regl=i({canvas:this,attributes:{antialias:!n.pick,preserveDrawingBuffer:!0},pixelRatio:t._context.plotGlPixelRatio||r.devicePixelRatio,extensions:e||[]})}catch(s)[o=!1]n.regl||(o=!1),o&&this.addEventListener('webglcontextlost',(function(e){t&&t.emit&&t.emit('plotly_webglcontextlost',{event:e,layer:n.key})}),!1)}})),o||n({container:a._glcontainer.node()}),o}}).call(this)}).call(this,"undefined"!==typeof r.g?r.g:"undefined"!==typeof self?self:"undefined"!==typeof window?window:{})},{"./show_no_webgl_msg":809,regl:526}],801:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('is-mobile');function a(){var t;return"undefined"!==typeof navigator&&(t=navigator.userAgent),t&&t.headers&&"string"===typeof t.headers["user-agent"]&&(t=t.headers["user-agent"]),t}e.exports=function(t){var e;if("string"!==typeof(e=t&&t.hasOwnProperty('userAgent')?t.userAgent:a()))return!0;var r=i({ua:{headers:{"user-agent":e}},tablet:!0,featureDetect:!1});if(!r)for(var o=e.split(' '),s=1;s<o.length;s++)if(-1!==o[s].indexOf('Safari'))for(var l=s-1;l>-1;l--){var c=o[l];if("Version/"===c.substr(0,8)){var u=c.substr(8).split('.')[0];if(n(u)&&(u=+u),u>=13)return!0}}return r}},{"fast-isnumeric":246,"is-mobile":445}],802:[function(t,e,r){"use strict";e.exports=function(t,e){if(e instanceof RegExp){for(var r=e.toString(),n=0;n<t.length;n++)if(t[n]instanceof RegExp&&t[n].toString()===r)return t;t.push(e)}else!e&&0!==e||-1!==t.indexOf(e)||t.push(e);return t}},{}],803:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plot_api/plot_config').dfltConfig;function a(t,e){for(var r,i=[],a=0;a<e.length;a++)r=e[a],i[a]=r===t?r:"object"===typeof r?Array.isArray(r)?n.extendDeep([],r):n.extendDeepAll({},r):r;return i}var o={add:function(t,e,r,n,a){var o,s;t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},s=t.undoQueue.index,t.autoplay?t.undoQueue.inSequence||(t.autoplay=!1):(!t.undoQueue.sequence||t.undoQueue.beginSequence?(o={undo:{calls:[],args:[]},redo:{calls:[],args:[]}},t.undoQueue.queue.splice(s,t.undoQueue.queue.length-s,o),t.undoQueue.index+=1):o=t.undoQueue.queue[s-1],t.undoQueue.beginSequence=!1,o&&(o.undo.calls.unshift(e),o.undo.args.unshift(r),o.redo.calls.push(n),o.redo.args.push(a)),t.undoQueue.queue.length>i.queueLength&&(t.undoQueue.queue.shift(),t.undoQueue.index--))},startSequence:function(t){t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},t.undoQueue.sequence=!0,t.undoQueue.beginSequence=!0},stopSequence:function(t){t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},t.undoQueue.sequence=!1,t.undoQueue.beginSequence=!1},undo:function(t){var e,r;if(!(void 0===t.undoQueue||isNaN(t.undoQueue.index)||t.undoQueue.index<=0)){for(t.undoQueue.index--,e=t.undoQueue.queue[t.undoQueue.index],t.undoQueue.inSequence=!0,r=0;r<e.undo.calls.length;r++)o.plotDo(t,e.undo.calls[r],e.undo.args[r]);t.undoQueue.inSequence=!1,t.autoplay=!1}},redo:function(t){var e,r;if(!(void 0===t.undoQueue||isNaN(t.undoQueue.index)||t.undoQueue.index>=t.undoQueue.queue.length)){for(e=t.undoQueue.queue[t.undoQueue.index],t.undoQueue.inSequence=!0,r=0;r<e.redo.calls.length;r++)o.plotDo(t,e.redo.calls[r],e.redo.args[r]);t.undoQueue.inSequence=!1,t.autoplay=!1,t.undoQueue.index++}},plotDo:function(t,e,r){t.autoplay=!0,r=a(t,r),e.apply(null,r)}};e.exports=o},{"../lib":787,"../plot_api/plot_config":825}],804:[function(t,e,r){"use strict";r.counter=function(t,e,r,n){var i=(e||"")+(r?"":"$"),a=!1===n?"":"^";return"xy"===t?new RegExp(a+"x([2-9]|[1-9][0-9]+)?y([2-9]|[1-9][0-9]+)?"+i):new RegExp(a+t+"([2-9]|[1-9][0-9]+)?"+i)}},{}],805:[function(t,e,r){"use strict";var n=/^(.*)(\.[^\.\[\]]+|\[\d\])$/,i=/^[^\.\[\]]+$/;e.exports=function(t,e){for(;e;){var r=t.match(n);if(r)t=r[1];else{if(!t.match(i))throw new Error("bad relativeAttr call:"+[t,e]);t=""}if("^"!==e.charAt(0))break;e=e.slice(1)}return t&&"["!==e.charAt(0)?t+"."+e:t+e}},{}],806:[function(t,e,r){"use strict";var n=t('./array').isArrayOrTypedArray,i=t('./is_plain_object');e.exports=function t(e,r){for(var a in r){var o=r[a],s=e[a];if(s!==o)if("_"===a.charAt(0)||"function"===typeof o){if(a in e)continue;e[a]=o}else if(n(o)&&n(s)&&i(o[0])){if("customdata"===a||"ids"===a)continue;for(var l=Math.min(o.length,s.length),c=0;c<l;c++)s[c]!==o[c]&&i(o[c])&&i(s[c])&&t(s[c],o[c])}else i(o)&&i(s)&&(t(s,o),Object.keys(s).length||delete e[a])}}},{"./array":769,"./is_plain_object":788}],807:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('./loggers'),a=t('./identity'),o=t('../constants/numerical').BADNUM,s=1e-9;function l(t,e){return t<e}function c(t,e){return t<=e}function u(t,e){return t>e}function f(t,e){return t>=e}r.findBin=function(t,e,r){if(n(e.start))return r?Math.ceil((t-e.start)/e.size-s)-1:Math.floor((t-e.start)/e.size+s);var a,o,h=0,p=e.length,d=0,m=p>1?(e[p-1]-e[0])/(p-1):1;for(o=m>=0?r?l:c:r?f:u,t+=m*s*(r?-1:1)*(m>=0?1:-1);h<p&&d++<100;)o(e[a=Math.floor((h+p)/2)],t)?h=a+1:p=a;return d>90&&i.log('Long binary search...'),h-1},r.sorterAsc=function(t,e){return t-e},r.sorterDes=function(t,e){return e-t},r.distinctVals=function(t){var e,n=t.slice();for(n.sort(r.sorterAsc),e=n.length-1;e>-1&&n[e]===o;e--);for(var i,a=n[e]-n[0]||1,s=a/(e||1)/1e4,l=[],c=0;c<=e;c++){var u=n[c],f=u-i;void 0===i?(l.push(u),i=u):f>s&&(a=Math.min(a,f),l.push(u),i=u)}return{vals:l,minDiff:a}},r.roundUp=function(t,e,r){for(var n,i=0,a=e.length-1,o=0,s=r?0:1,l=r?1:0,c=r?Math.ceil:Math.floor;i<a&&o++<100;)e[n=c((i+a)/2)]<=t?i=n+s:a=n-l;return e[i]},r.sort=function(t,e){for(var r=0,n=0,i=1;i<t.length;i++){var a=e(t[i],t[i-1]);if(a<0?r=1:a>0&&(n=1),r&&n)return t.sort(e)}return n?t:t.reverse()},r.findIndexOfMin=function(t,e){e=e||a;for(var r,n=1/0,i=0;i<t.length;i++){var o=e(t[i]);o<n&&(n=o,r=i)}return r}},{"../constants/numerical":763,"./identity":785,"./loggers":791,"fast-isnumeric":246}],808:[function(t,e,r){"use strict";e.exports=function(t,e){(t.attr('class')||"").split(' ').forEach((function(e){0===e.indexOf('cursor-')&&t.classed(e,!1)})),e&&t.classed("cursor-"+e,!0)}},{}],809:[function(t,e,r){"use strict";var n=t('../components/color'),i=function(){};e.exports=function(t){for(var e in t)"function"===typeof t[e]&&(t[e]=i);t.destroy=function(){t.container.parentNode.removeChild(t.container)};var r=document.createElement('div');r.className='no-webgl',r.style.cursor='pointer',r.style.fontSize='24px',r.style.color=n.defaults[0],r.style.position='absolute',r.style.left=r.style.top='0px',r.style.width=r.style.height='100%',r.style["background-color"]=n.lightLine,r.style["z-index"]=30;var a=document.createElement('p');return a.textContent='WebGL is not supported by your browser - visit https://get.webgl.org for more info',a.style.position='relative',a.style.top='50%',a.style.left='50%',a.style.height='30%',a.style.width='50%',a.style.margin='-15% 0 0 -25%',r.appendChild(a),t.container.appendChild(r),t.container.style.background='#FFFFFF',t.container.onclick=function(){window.open('https://get.webgl.org')},!1}},{"../components/color":650}],810:[function(t,e,r){"use strict";e.exports=function(t){return Object.keys(t).sort()}},{}],811:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('./array').isArrayOrTypedArray;r.aggNums=function(t,e,a,o){var s,l;if((!o||o>a.length)&&(o=a.length),n(e)||(e=!1),i(a[0])){for(l=new Array(o),s=0;s<o;s++)l[s]=r.aggNums(t,e,a[s]);a=l}for(s=0;s<o;s++)n(e)?n(a[s])&&(e=t(+e,+a[s])):e=a[s];return e},r.len=function(t){return r.aggNums((function(t){return t+1}),0,t)},r.mean=function(t,e){return e||(e=r.len(t)),r.aggNums((function(t,e){return t+e}),0,t)/e},r.midRange=function(t){if(void 0!==t&&0!==t.length)return(r.aggNums(Math.max,null,t)+r.aggNums(Math.min,null,t))/2},r.variance=function(t,e,i){return e||(e=r.len(t)),n(i)||(i=r.mean(t,e)),r.aggNums((function(t,e){return t+Math.pow(e-i,2)}),0,t)/e},r.stdev=function(t,e,n){return Math.sqrt(r.variance(t,e,n))},r.median=function(t){var e=t.slice().sort();return r.interp(e,.5)},r.interp=function(t,e){if(!n(e))throw"n should be a finite number";if((e=e*t.length-.5)<0)return t[0];if(e>t.length-1)return t[t.length-1];var r=e%1;return r*t[Math.ceil(e)]+(1-r)*t[Math.floor(e)]}},{"./array":769,"fast-isnumeric":246}],812:[function(t,e,r){"use strict";var n=t('color-normalize');function i(t){return t?n(t):[0,0,0,1]}e.exports=i},{"color-normalize":131}],813:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../lib'),a=i.strTranslate,o=t('../constants/xmlns_namespaces'),s=t('../constants/alignment').LINE_SPACING;function l(t,e){return t.node().getBoundingClientRect()[e]}var c=/([^$]*)([$]+[^$]*[$]+)([^$]*)/;r.convertToTspans=function(t,e,i){var o=t.text(),s=!t.attr('data-notex')&&"undefined"!==typeof MathJax&&o.match(c),u=n.select(t.node().parentNode);if(!u.empty()){var f=t.attr('class')?t.attr('class').split(' ')[0]:"text";return f+='-math',u.selectAll("svg."+f).remove(),u.selectAll("g."+f+"-group").remove(),t.style('display',null).attr({"data-unformatted":o,"data-math":"N"}),s?(e&&e._promises||[]).push(new Promise((function(e){t.style('display','none');var r=parseInt(t.node().style.fontSize,10),n={fontSize:r};p(s[2],n,(function(n,s,c){u.selectAll("svg."+f).remove(),u.selectAll("g."+f+"-group").remove();var p=n&&n.select('svg');if(!p||!p.node())return h(),void e();var d=u.append('g').classed(f+"-group",!0).attr({"pointer-events":"none","data-unformatted":o,"data-math":"Y"});d.node().appendChild(p.node()),s&&s.node()&&p.node().insertBefore(s.node().cloneNode(!0),p.node().firstChild),p.attr({class:f,height:c.height,preserveAspectRatio:"xMinYMin meet"}).style({overflow:"visible","pointer-events":"none"});var m=t.node().style.fill||"black",g=p.select('g');g.attr({fill:m,stroke:m});var v=l(g,'width'),y=l(g,'height'),x=+t.attr('x')-v*{start:0,middle:.5,end:1}[t.attr('text-anchor')||"start"],b=-(r||l(t,'height'))/4;"y"===f[0]?(d.attr({transform:"rotate('+[-90,+t.attr('x'),+t.attr('y')]+')"+a(-v/2,b-y/2)}),p.attr({x:+t.attr('x'),y:+t.attr('y')})):"l"===f[0]?p.attr({x:t.attr('x'),y:b-y/2}):"a"===f[0]&&0!==f.indexOf('atitle')?p.attr({x:0,y:b}):p.attr({x:x,y:+t.attr('y')+b-y/2}),i&&i.call(t,d),e(d)}))}))):h(),t}function h(){u.empty()||(f=t.attr('class')+"-math",u.select("svg."+f).remove()),t.text('').style('white-space','pre'),z(t.node(),o)&&t.style('pointer-events','all'),r.positionText(t),i&&i.call(t)}};var u=/(<|&lt;|&#60;)/g,f=/(>|&gt;|&#62;)/g;function h(t){return t.replace(u,'\\lt ').replace(f,'\\gt ')}function p(t,e,r){var a,o,s,l;MathJax.Hub.Queue((function(){return o=i.extendDeepAll({},MathJax.Hub.config),s=MathJax.Hub.processSectionDelay,void 0!==MathJax.Hub.processSectionDelay&&(MathJax.Hub.processSectionDelay=0),MathJax.Hub.Config({messageStyle:"none",tex2jax:{inlineMath:[["$","$"],["\\(","\\)"]]},displayAlign:"left"})}),(function(){if("SVG"!==(a=MathJax.Hub.config.menuSettings.renderer))return MathJax.Hub.setRenderer('SVG')}),(function()[var r="math-output-"+i.randstr({],64);return l=n.select('body').append('div').attr({id:r}).style({visibility:"hidden",position:"absolute"}).style({"font-size":e.fontSize+"px"}).text(h(t)),MathJax.Hub.Typeset(l.node())}),(function(){var e=n.select('body').select('#MathJax_SVG_glyphs');if(l.select('.MathJax_SVG').empty()||!l.select('svg').node())i.log('There was an error in the tex syntax.',t),r();else{var o=l.select('svg').node().getBoundingClientRect();r(l.select('.MathJax_SVG'),e,o)}if(l.remove(),"SVG"!==a)return MathJax.Hub.setRenderer(a)}),(function(){return void 0!==s&&(MathJax.Hub.processSectionDelay=s),MathJax.Hub.Config(o)}))}var d={sup:"font-size:70%",sub:"font-size:70%",b:"font-weight:bold",i:"font-style:italic",a:"cursor:pointer",span:"",em:"font-style:italic;font-weight:bold"},m={sub:"0.3em",sup:"-0.6em"},g={sub:"-0.21em",sup:"0.42em"},v='\u200b',y=["http:",'https:','mailto:','',void 0,":"],x=r.NEWLINES=/(\r\n?|\n)/g,b=/(<[^<>]*>)/,_=/<(\/?)([^ >]*)(\s+(.*))?>/i,w=/<br(\s+.*)?>/i;r.BR_TAG_ALL=/<br(\s+.*)?>/gi;var T=/(^|[\s"'])style\s*=\s*("([^"]*);?"|'([^']*);?')/i,k=/(^|[\s"'])href\s*=\s*("([^"]*)"|'([^']*)')/i,M=/(^|[\s"'])target\s*=\s*("([^"\s]*)"|'([^'\s]*)')/i,A=/(^|[\s"'])popup\s*=\s*("([\w=,]*)"|'([\w=,]*)')/i;function S(t,e){if(!t)return null;var r=t.match(e),n=r&&(r[3]||r[4]);return n&&P(n)}var E=/(^|;)\s*color:/;r.plainText=function(t,e)[for(var r=void 0!==(e=e||{]).len&&-1!==e.len?e.len:1/0,n=void 0!==e.allowedTags?e.allowedTags:["br"],i='...',a=i.length,o=t.split(b),s=[],l='',c=0,u=0;u<o.length;u++){var f=o[u],h=f.match(_),p=h&&h[2].toLowerCase();if(p)-1!==n.indexOf(p)&&(s.push(f),l=p);else{var d=f.length;if(c+d<r)s.push(f),c+=d;else if(c<r){var m=r-c;l&&("br"!==l||m<=a||d<=a)&&s.pop(),r>a?s.push(f.substr(0,m-a)+i):s.push(f.substr(0,m));break}l=""}}return s.join('')};var L={mu:"\u03bc",amp:"&",lt:"<",gt:">",nbsp:"\xa0",times:"\xd7",plusmn:"\xb1",deg:"\xb0"},C=/&(#\d+|#x[\da-fA-F]+|[a-z]+);/g;function P(t){return t.replace(C,(function(t,e){return("#"===e.charAt(0)?I("x"===e.charAt(1)?parseInt(e.substr(2),16):parseInt(e.substr(1),10)):L[e])||t}))}function I(t){if(!(t>1114111)){var e=String.fromCodePoint;if(e)return e(t);var r=String.fromCharCode;return t<=65535?r(t):r(55232+(t>>10),t%1024+56320)}}function z(t,e){e=e.replace(x,' ');var r,a=!1,l=[],c=-1;function u(){c++;var e=document.createElementNS(o.svg,'tspan');n.select(e).attr({class:"line",dy:c*s+"em"}),t.appendChild(e),r=e;var i=l;if(l=[node:e],i.length>1)for(var a=1;a<i.length;a++)f(i[a])}function f(t){var e,i=t.type,a={};if("a"===i){e='a';var s=t.target,c=t.href,u=t.popup;c&&(a={"xlink:xlink:show":"_blank"===s||"_"!==s.charAt(0)?"new":"replace",target:s,"xlink:xlink:href":c},u&&(a.onclick='window.open(this.href.baseVal,this.target.baseVal,''+u+'');return false;'))}else e='tspan';t.style&&(a.style=t.style);var f=document.createElementNS(o.svg,e);if("sup"===i||"sub"===i){h(r,v),r.appendChild(f);var p=document.createElementNS(o.svg,'tspan');h(p,v),n.select(p).attr('dy',g[i]),a.dy=m[i],r.appendChild(f),r.appendChild(p)}else r.appendChild(f);n.select(f).attr(a),r=t.node=f,l.push(t)}function h(t,e)[t.appendChild(document.createTextNode(e))]function p(t){if(1!==l.length){var n=l.pop();t!==n.type&&i.log("Start tag <"+n.type+"> doesnt match end tag <"+t+">. Pretending it did match.",e),r=l[l.length-1].node}else i.log("Ignoring unexpected end tag </"+t+">.",e)}w.test(e)?u():(r=t,l=[node:t]);for(var y=e.split(b),L=0;L<y.length;L++){var C=y[L],I=C.match(_),z=I&&I[2].toLowerCase(),D=d[z];if("br"===z)u();else if(void 0===D)h(r,P(C));else if(I[1])p(z);else{var R=I[4],F={type:z},B=S(R,T);if(B?(B=B.replace(E,'$1 fill:'),D&&(B+=";"+D)):D&&(B=D),B&&(F.style=B),"a"===z){a=!0;var N=S(R,k);if(N){var j=O(N);j&&(F.href=j,F.target=S(R,M)||"_blank",F.popup=S(R,A))}}f(F)}}return a}function O(t){var e=encodeURI(decodeURI(t)),r=document.createElement('a'),n=document.createElement('a');r.href=t,n.href=e;var i=r.protocol,a=n.protocol;return-1!==y.indexOf(i)&&-1!==y.indexOf(a)?e:""}function D(t,e,r){var n,a,o,s=r.horizontalAlign,l=r.verticalAlign||"top",c=t.node().getBoundingClientRect(),u=e.node().getBoundingClientRect();return a="bottom"===l?function(){return c.bottom-n.height}:"middle"===l?function(){return c.top+(c.height-n.height)/2}:function(){return c.top},o="right"===s?function(){return c.right-n.width}:"center"===s?function(){return c.left+(c.width-n.width)/2}:function(){return c.left},function(){n=this.node().getBoundingClientRect();var t=o()-u.left,e=a()-u.top,s=r.gd||{};if(r.gd){s._fullLayout._calcInverseTransform(s);var l=i.apply3DTransform(s._fullLayout._invTransform)(t,e);t=l[0],e=l[1]}return this.style({top:e+"px",left:t+"px","z-index":1e3}),this}}r.convertEntities=P,r.sanitizeHTML=function(t){t=t.replace(x,' ');for(var e=document.createElement('p'),r=e,i=[],a=t.split(b),o=0;o<a.length;o++){var s=a[o],l=s.match(_),c=l&&l[2].toLowerCase();if(c in d)if(l[1])i.length&&(r=i.pop());else{var u=l[4],f=S(u,T),h=f?{style:f}:{};if("a"===c){var p=S(u,k);if(p){var m=O(p);if(m){h.href=m;var g=S(u,M);g&&(h.target=g)}}}var v=document.createElement(c);r.appendChild(v),n.select(v).attr(h),r=v,i.push(v)}else r.appendChild(document.createTextNode(P(s)))}return e.innerHTML},r.lineCount=function(t){return t.selectAll('tspan.line').size()||1},r.positionText=function(t,e,r){return t.each((function(){var t=n.select(this);function i(e,r){return void 0===r?null===(r=t.attr(e))&&(t.attr(e,0),r=0):t.attr(e,r),r}var a=i('x',e),o=i('y',r);"text"===this.nodeName&&t.selectAll('tspan.line').attr({x:a,y:o})}))};var R='1px ';r.makeTextShadow=function(t){return R+R+R+t+", -"+R+"-"+R+R+t+", "+R+"-"+R+R+t+", -"+R+R+R+t},r.makeEditable=function(t,e){var r=e.gd,i=e.delegate,a=n.dispatch('edit','input','cancel'),o=i||t;if(t.style({"pointer-events":i?"none":"all"}),1!==t.size())throw new Error('boo');function s(){c(),t.style({opacity:0});var e,r=o.attr('class');(e=r?"."+r.split(' ')[0]+"-math-group":"[class*=-math-group]")&&n.select(t.node().parentNode).select(e).style({opacity:0})}function l(t){var e=t.node(),r=document.createRange();r.selectNodeContents(e);var n=window.getSelection();n.removeAllRanges(),n.addRange(r),e.focus()}function c(){var i=n.select(r).select('.svg-container'),o=i.append('div'),s=t.node().style,c=parseFloat(s.fontSize||12),u=e.text;void 0===u&&(u=t.attr('data-unformatted')),o.classed('plugin-editable editable',!0).style({position:"absolute","font-family":s.fontFamily||"Arial","font-size":c,color:e.fill||s.fill||"black",opacity:1,"background-color":e.background||"transparent",outline:"#ffffff33 1px solid",margin:[-c/8+1,0,0,-1].join('px ')+"px",padding:"0","box-sizing":"border-box"}).attr({contenteditable:!0}).text(u).call(D(t,i,e)).on('blur',(function(){r._editing=!1,t.text(this.textContent).style({opacity:1});var e,i=n.select(this).attr('class');(e=i?"."+i.split(' ')[0]+"-math-group":"[class*=-math-group]")&&n.select(t.node().parentNode).select(e).style({opacity:0});var o=this.textContent;n.select(this).transition().duration(0).remove(),n.select(document).on('mouseup',null),a.edit.call(t,o)})).on('focus',(function(){var t=this;r._editing=!0,n.select(document).on('mouseup',(function(){if(n.event.target===t)return!1;document.activeElement===o.node()&&o.node().blur()}))})).on('keyup',(function(){27===n.event.which?(r._editing=!1,t.style({opacity:1}),n.select(this).style({opacity:0}).on('blur',(function(){return!1})).transition().remove(),a.cancel.call(t,this.textContent)):(a.input.call(t,this.textContent),n.select(this).call(D(t,i,e)))})).on('keydown',(function()[13===n.event.which&&this.blur()])).call(l)}return e.immediate?s():o.on('click',s),n.rebind(t,a,'on')}},{"../constants/alignment":755,"../constants/xmlns_namespaces":764,"../lib":787,"@plotly/d3":58}],814:[function(t,e,r){"use strict";var n={};function i(t){t&&null!==t.timer&&(clearTimeout(t.timer),t.timer=null)}r.throttle=function(t,e,r){var a=n[t],o=Date.now();if(!a){for(var s in n)n[s].ts<o-6e4&&delete n[s];a=n[t]={ts:0,timer:null}}function l(){r(),a.ts=Date.now(),a.onDone&&(a.onDone(),a.onDone=null)}i(a),o>a.ts+e?l():a.timer=setTimeout((function(){l(),a.timer=null}),e)},r.done=function(t){var e=n[t];return e&&e.timer?new Promise((function(t){var r=e.onDone;e.onDone=function(){r&&r(),t(),e.onDone=null}})):Promise.resolve()},r.clear=function(t){if(t)i(n[t]),delete n[t];else for(var e in n)r.clear(e)}},{}],815:[function(t,e,r){"use strict";var n=t('fast-isnumeric');e.exports=function(t,e){if(t>0)return Math.log(t)/Math.LN10;var r=Math.log(Math.min(e[0],e[1]))/Math.LN10;return n(r)||(r=Math.log(Math.max(e[0],e[1]))/Math.LN10-6),r}},{"fast-isnumeric":246}],816:[function(t,e,r){"use strict";var n=e.exports={},i=t('../plots/geo/constants').locationmodeToLayer,a=t('topojson-client').feature;n.getTopojsonName=function(t){return[t.scope.replace(/ /g,'-'),'_',t.resolution.toString(),"m"].join('')},n.getTopojsonPath=function(t,e){return t+e+".json"},n.getTopojsonFeatures=function(t,e){var r=i[t.locationmode],n=e.objects[r];return a(e,n).features}},{"../plots/geo/constants":869,"topojson-client":586}],817:[function(t,e,r){"use strict";e.exports={moduleType:"locale",name:"en-US",dictionary:{"Click to enter Colorscale title":"Click to enter Colorscale title"},format:{date:"%m/%d/%Y"}}},{}],818:[function(t,e,r){"use strict";e.exports={moduleType:"locale",name:"en",dictionary:{"Click to enter Colorscale title":"Click to enter Colourscale title"},format:{days:["Sunday",'Monday','Tuesday','Wednesday','Thursday','Friday',"Saturday"],shortDays:["Sun",'Mon','Tue','Wed','Thu','Fri',"Sat"],months:["January",'February','March','April','May','June','July','August','September','October','November',"December"],shortMonths:["Jan",'Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov',"Dec"],periods:["AM","PM"],dateTime:"%a %b %e %X %Y",date:"%d/%m/%Y",time:"%H:%M:%S",decimal:".",thousands:",",grouping:[3],currency:["$",""],year:"%Y",month:"%b %Y",dayMonth:"%b %-d",dayMonthYear:"%b %-d, %Y"}}},{}],819:[function(t,e,r){"use strict";var n=t('../registry');e.exports=function(t){for(var e,r,i=n.layoutArrayContainers,a=n.layoutArrayRegexes,o=t.split('[')[0],s=0;s<a.length;s++)if((r=t.match(a[s]))&&0===r.index){e=r[0];break}if(e||(e=i[i.indexOf(o)]),!e)return!1;var l=t.substr(e.length);return l?!!(r=l.match(/^\[(0|[1-9][0-9]*)\](\.(.+))?$/))&&{array:e,index:Number(r[1]),property:r[3]||""}:{array:e,index:"",property:""}}},{"../registry":915}],820:[function(t,e,r){"use strict";var n=t('../lib'),i=n.extendFlat,a=n.isPlainObject,o={valType:"flaglist",extras:["none"],flags:["calc",'clearAxisTypes','plot','style','markerSize',"colorbars"]},s={valType:"flaglist",extras:["none"],flags:["calc",'plot','legend','ticks','axrange','layoutstyle','modebar','camera','arraydraw',"colorbars"]},l=o.flags.slice().concat(["fullReplot"]),c=s.flags.slice().concat('layoutReplot');function u(t)[for(var e={],r=0;r<t.length;r++)e[t[r]]=!1;return e}function f(t,e,r)[var n=i({],t);for(var o in n){var s=n[o];a(s)&&(n[o]=h(s,e,r,o))}return"from-root"===r&&(n.editType=e),n}function h(t,e,r,n)[if(t.valType){var a=i({],t);if(a.editType=e,Array.isArray(t.items)){a.items=new Array(t.items.length);for(var o=0;o<t.items.length;o++)a.items[o]=h(t.items[o],e,'from-root')}return a}return f(t,e,"_"===n.charAt(0)?"nested":"from-root")}e.exports={traces:o,layout:s,traceFlags:function(){return u(l)},layoutFlags:function(){return u(c)},update:function(t,e){var r=e.editType;if(r&&"none"!==r)for(var n=r.split('+'),i=0;i<n.length;i++)t[n[i]]=!0},overrideAll:f}},{"../lib":787}],821:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('gl-mat4/fromQuat'),a=t('../registry'),o=t('../lib'),s=t('../plots/plots'),l=t('../plots/cartesian/axis_ids'),c=t('../components/color'),u=l.cleanId,f=l.getFromTrace,h=a.traceIs;function p(t,e){var r=t[e],n=e.charAt(0);r&&"paper"!==r&&(t[e]=u(r,n,!0))}function d(t){function e(e,r){var n=t[e],i=t.title&&t.title[r];n&&!i&&(t.title||(t.title={}),t.title[r]=t[e],delete t[e])}t&&("string"!==typeof t.title&&"number"!==typeof t.title||(t.title={text:t.title}),e('titlefont','font'),e('titleposition','position'),e('titleside','side'),e('titleoffset','offset'))}function m(t){if(!o.isPlainObject(t))return!1;var e=t.name;return delete t.name,delete t.showlegend,("string"===typeof e||"number"===typeof e)&&String(e)}function g(t,e,r,n){if(r&&!n)return t;if(n&&!r)return e;if(!t.trim())return e;if(!e.trim())return t;var i,a=Math.min(t.length,e.length);for(i=0;i<a&&t.charAt(i)===e.charAt(i);i++);return t.substr(0,i).trim()}function v(t){var e='middle',r='center';return"string"===typeof t&&(-1!==t.indexOf('top')?e="top":-1!==t.indexOf('bottom')&&(e='bottom'),-1!==t.indexOf('left')?r="left":-1!==t.indexOf('right')&&(r='right')),e+" "+r}function y(t,e){return e in t&&"object"===typeof t[e]&&0===Object.keys(t[e]).length}r.clearPromiseQueue=function(t){Array.isArray(t._promises)&&t._promises.length>0&&o.log('Clearing previous rejected promises from queue.'),t._promises=[]},r.cleanLayout=function(t){var e,n;t||(t={}),t.xaxis1&&(t.xaxis||(t.xaxis=t.xaxis1),delete t.xaxis1),t.yaxis1&&(t.yaxis||(t.yaxis=t.yaxis1),delete t.yaxis1),t.scene1&&(t.scene||(t.scene=t.scene1),delete t.scene1);var a=(s.subplotsRegistry.cartesian||{}).attrRegex,l=(s.subplotsRegistry.polar||{}).attrRegex,f=(s.subplotsRegistry.ternary||{}).attrRegex,h=(s.subplotsRegistry.gl3d||{}).attrRegex,m=Object.keys(t);for(e=0;e<m.length;e++){var g=m[e];if(a&&a.test(g)){var v=t[g];v.anchor&&"free"!==v.anchor&&(v.anchor=u(v.anchor)),v.overlaying&&(v.overlaying=u(v.overlaying)),v.type||(v.isdate?v.type="date":v.islog?v.type="log":!1===v.isdate&&!1===v.islog&&(v.type='linear')),"withzero"!==v.autorange&&"tozero"!==v.autorange||(v.autorange=!0,v.rangemode='tozero'),delete v.islog,delete v.isdate,delete v.categories,y(v,'domain')&&delete v.domain,void 0!==v.autotick&&(void 0===v.tickmode&&(v.tickmode=v.autotick?"auto":"linear"),delete v.autotick),d(v)}else if(l&&l.test(g))d(t[g].radialaxis);else if(f&&f.test(g)){var x=t[g];d(x.aaxis),d(x.baxis),d(x.caxis)}else if(h&&h.test(g)){var b=t[g],_=b.cameraposition;if(Array.isArray(_)&&4===_[0].length){var w=_[0],T=_[1],k=_[2],M=i([],w),A=[];for(n=0;n<3;++n)A[n]=T[n]+k*M[2+4*n];b.camera={eye:{x:A[0],y:A[1],z:A[2]},center:{x:T[0],y:T[1],z:T[2]},up:{x:0,y:0,z:1}},delete b.cameraposition}d(b.xaxis),d(b.yaxis),d(b.zaxis)}}var S=Array.isArray(t.annotations)?t.annotations.length:0;for(e=0;e<S;e++){var E=t.annotations[e];o.isPlainObject(E)&&(E.ref&&("paper"===E.ref?(E.xref='paper',E.yref='paper'):"data"===E.ref&&(E.xref='x',E.yref='y'),delete E.ref),p(E,'xref'),p(E,'yref'))}var L=Array.isArray(t.shapes)?t.shapes.length:0;for(e=0;e<L;e++){var C=t.shapes[e];o.isPlainObject(C)&&(p(C,'xref'),p(C,'yref'))}var P=Array.isArray(t.images)?t.images.length:0;for(e=0;e<P;e++){var I=t.images[e];o.isPlainObject(I)&&(p(I,'xref'),p(I,'yref'))}var z=t.legend;return z&&(z.x>3?(z.x=1.02,z.xanchor='left'):z.x<-2&&(z.x=-.02,z.xanchor='right'),z.y>3?(z.y=1.02,z.yanchor='bottom'):z.y<-2&&(z.y=-.02,z.yanchor='top')),d(t),"rotate"===t.dragmode&&(t.dragmode='orbit'),c.clean(t),t.template&&t.template.layout&&r.cleanLayout(t.template.layout),t},r.cleanData=function(t){for(var e=0;e<t.length;e++){var n,i=t[e];if("histogramy"===i.type&&"xbins"in i&&!("ybins"in i)&&(i.ybins=i.xbins,delete i.xbins),i.error_y&&"opacity"in i.error_y){var l=c.defaults,f=i.error_y.color||(h(i,'bar')?c.defaultLine:l[e%l.length]);i.error_y.color=c.addOpacity(c.rgb(f),c.opacity(f)*i.error_y.opacity),delete i.error_y.opacity}if("bardir"in i&&("h"!==i.bardir||!h(i,'bar')&&"histogram"!==i.type.substr(0,9)||(i.orientation='h',r.swapXYData(i)),delete i.bardir),"histogramy"===i.type&&r.swapXYData(i),"histogramx"!==i.type&&"histogramy"!==i.type||(i.type='histogram'),"scl"in i&&!("colorscale"in i)&&(i.colorscale=i.scl,delete i.scl),"reversescl"in i&&!("reversescale"in i)&&(i.reversescale=i.reversescl,delete i.reversescl),i.xaxis&&(i.xaxis=u(i.xaxis,'x')),i.yaxis&&(i.yaxis=u(i.yaxis,'y')),h(i,'gl3d')&&i.scene&&(i.scene=s.subplotsRegistry.gl3d.cleanId(i.scene)),!h(i,'pie-like')&&!h(i,'bar-like'))if(Array.isArray(i.textposition))for(n=0;n<i.textposition.length;n++)i.textposition[n]=v(i.textposition[n]);else i.textposition&&(i.textposition=v(i.textposition));var p=a.getModule(i);if(p&&p.colorbar){var x=p.colorbar.container,b=x?i[x]:i;b&&b.colorscale&&("YIGnBu"===b.colorscale&&(b.colorscale='YlGnBu'),"YIOrRd"===b.colorscale&&(b.colorscale='YlOrRd'))}if("surface"===i.type&&o.isPlainObject(i.contours)){var _=["x",'y',"z"];for(n=0;n<_.length;n++){var w=i.contours[_[n]];o.isPlainObject(w)&&(w.highlightColor&&(w.highlightcolor=w.highlightColor,delete w.highlightColor),w.highlightWidth&&(w.highlightwidth=w.highlightWidth,delete w.highlightWidth))}}if("candlestick"===i.type||"ohlc"===i.type)[var T=!1!==(i.increasing||{]).showlegend,k=!1!==(i.decreasing||{}).showlegend,M=m(i.increasing),A=m(i.decreasing);if(!1!==M&&!1!==A){var S=g(M,A,T,k);S&&(i.name=S)}else!M&&!A||i.name||(i.name=M||A)}if(Array.isArray(i.transforms)){var E=i.transforms;for(n=0;n<E.length;n++){var L=E[n];if(o.isPlainObject(L))switch(L.type){case"filter":L.filtersrc&&(L.target=L.filtersrc,delete L.filtersrc),L.calendar&&(L.valuecalendar||(L.valuecalendar=L.calendar),delete L.calendar);break;case"groupby":if(L.styles=L.styles||L.style,L.styles&&!Array.isArray(L.styles)){var C=L.styles,P=Object.keys(C);L.styles=[];for(var I=0;I<P.length;I++)L.styles.push({target:P[I],value:C[P[I]]})}}}}y(i,'line')&&delete i.line,"marker"in i&&(y(i.marker,'line')&&delete i.marker.line,y(i,'marker')&&delete i.marker),c.clean(i),i.autobinx&&(delete i.autobinx,delete i.xbins),i.autobiny&&(delete i.autobiny,delete i.ybins),d(i),i.colorbar&&d(i.colorbar),i.marker&&i.marker.colorbar&&d(i.marker.colorbar),i.line&&i.line.colorbar&&d(i.line.colorbar),i.aaxis&&d(i.aaxis),i.baxis&&d(i.baxis)}},r.swapXYData=function(t){var e;if(o.swapAttrs(t,["?",'?0','d?','?bins','nbins?','autobin?','?src',"error_?"]),Array.isArray(t.z)&&Array.isArray(t.z[0])&&(t.transpose?delete t.transpose:t.transpose=!0),t.error_x&&t.error_y){var r=t.error_y,n="copy_ystyle"in r?r.copy_ystyle:!(r.color||r.thickness||r.width);o.swapAttrs(t,["error_?.copy_ystyle"]),n&&o.swapAttrs(t,["error_?.color",'error_?.thickness',"error_?.width"])}if("string"===typeof t.hoverinfo){var i=t.hoverinfo.split('+');for(e=0;e<i.length;e++)"x"===i[e]?i[e]="y":"y"===i[e]&&(i[e]='x');t.hoverinfo=i.join('+')}},r.coerceTraceIndices=function(t,e){if(n(e))return[e];if(!Array.isArray(e)||!e.length)return t.data.map((function(t,e){return e}));if(Array.isArray(e)){for(var r=[],i=0;i<e.length;i++)o.isIndex(e[i],t.data.length)?r.push(e[i]):o.warn('trace index (',e[i],') is not a number or is out of bounds');return r}return e},r.manageArrayContainers=function(t,e,r){var i=t.obj,a=t.parts,s=a.length,l=a[s-1],c=n(l);if(c&&null===e){var u=a.slice(0,s-1).join('.');o.nestedProperty(i,u).get().splice(l,1)}else c&&void 0===t.get()?(void 0===t.get()&&(r[t.astr]=null),t.set(e)):t.set(e)};var x=/(\.[^\[\]\.]+|\[[^\[\]\.]+\])$/;function b(t){var e=t.search(x);if(e>0)return t.substr(0,e)}r.hasParent=function(t,e){for(var r=b(e);r;){if(r in t)return!0;r=b(r)}return!1};var _=["x",'y',"z"];r.clearAxisTypes=function(t,e,r){for(var n=0;n<e.length;n++)for(var i=t._fullData[n],a=0;a<3;a++){var s=f(t,i,_[a]);if(s&&"log"!==s.type){var l=s._name,c=s._id.substr(1);if("scene"===c.substr(0,5)){if(void 0!==r[c])continue;l=c+"."+l}var u=l+".type";void 0===r[l]&&void 0===r[u]&&o.nestedProperty(t.layout,u).set(null)}}}},{"../components/color":650,"../lib":787,"../plots/cartesian/axis_ids":842,"../plots/plots":901,"../registry":915,"fast-isnumeric":246,"gl-mat4/fromQuat":282}],822:[function(t,e,r){"use strict";var n=t('./plot_api');r._doPlot=n._doPlot,r.newPlot=n.newPlot,r.restyle=n.restyle,r.relayout=n.relayout,r.redraw=n.redraw,r.update=n.update,r._guiRestyle=n._guiRestyle,r._guiRelayout=n._guiRelayout,r._guiUpdate=n._guiUpdate,r._storeDirectGUIEdit=n._storeDirectGUIEdit,r.react=n.react,r.extendTraces=n.extendTraces,r.prependTraces=n.prependTraces,r.addTraces=n.addTraces,r.deleteTraces=n.deleteTraces,r.moveTraces=n.moveTraces,r.purge=n.purge,r.addFrames=n.addFrames,r.deleteFrames=n.deleteFrames,r.animate=n.animate,r.setPlotConfig=n.setPlotConfig,r.toImage=t('./to_image'),r.validate=t('./validate'),r.downloadImage=t('../snapshot/download');var i=t('./template_api');r.makeTemplate=i.makeTemplate,r.validateTemplate=i.validateTemplate},{"../snapshot/download":917,"./plot_api":824,"./template_api":829,"./to_image":830,"./validate":831}],823:[function(t,e,r){"use strict";var n=t('../lib/is_plain_object'),i=t('../lib/noop'),a=t('../lib/loggers'),o=t('../lib/search').sorterAsc,s=t('../registry');r.containerArrayMatch=t('./container_array_match');var l=r.isAddVal=function(t){return"add"===t||n(t)},c=r.isRemoveVal=function(t){return null===t||"remove"===t};r.applyContainerArrayChanges=function(t,e,r,n,u){var f=e.astr,h=s.getComponentMethod(f,'supplyLayoutDefaults'),p=s.getComponentMethod(f,'draw'),d=s.getComponentMethod(f,'drawOne'),m=n.replot||n.recalc||h===i||p===i,g=t.layout,v=t._fullLayout;if(r[""]){Object.keys(r).length>1&&a.warn('Full array edits are incompatible with other edits',f);var y=r[""][""];if(c(y))e.set(null);else{if(!Array.isArray(y))return a.warn('Unrecognized full array edit value',f,y),!0;e.set(y)}return!m&&(h(g,v),p(t),!0)}var x,b,_,w,T,k,M,A,S=Object.keys(r).map(Number).sort(o),E=e.get(),L=E||[],C=u(v,f).get(),P=[],I=-1,z=L.length;for(x=0;x<S.length;x++)if(w=r[_=S[x]],T=Object.keys(w),k=w[""],M=l(k),_<0||_>L.length-(M?0:1))a.warn('index out of range',f,_);else if(void 0!==k)T.length>1&&a.warn('Insertion & removal are incompatible with edits to the same index.',f,_),c(k)?P.push(_):M?("add"===k&&(k={}),L.splice(_,0,k),C&&C.splice(_,0,{})):a.warn('Unrecognized full object edit value',f,_,k),-1===I&&(I=_);else for(b=0;b<T.length;b++)A=f+"["+_+"].",u(L[_],T[b],A).set(w[T[b]]);for(x=P.length-1;x>=0;x--)L.splice(P[x],1),C&&C.splice(P[x],1);if(L.length?E||e.set(L):e.set(null),m)return!1;if(h(g,v),d!==i){var O;if(-1===I)O=S;else{for(z=Math.max(L.length,z),O=[],x=0;x<S.length&&!((_=S[x])>=I);x++)O.push(_);for(x=I;x<z;x++)O.push(x)}for(x=0;x<O.length;x++)d(t,O[x])}else p(t);return!0}},{"../lib/is_plain_object":788,"../lib/loggers":791,"../lib/noop":796,"../lib/search":807,"../registry":915,"./container_array_match":819}],824:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('has-hover'),o=t('../lib'),s=o.nestedProperty,l=t('../lib/events'),c=t('../lib/queue'),u=t('../registry'),f=t('./plot_schema'),h=t('../plots/plots'),p=t('../plots/cartesian/axes'),d=t('../components/drawing'),m=t('../components/color'),g=t('../plots/cartesian/graph_interact').initInteractions,v=t('../constants/xmlns_namespaces'),y=t('../plots/cartesian/select').clearSelect,x=t('./plot_config').dfltConfig,b=t('./manage_arrays'),_=t('./helpers'),w=t('./subroutines'),T=t('./edit_types'),k=t('../plots/cartesian/constants').AX_NAME_PATTERN,M=0,A=5;function S(t,e,i,a){var s;if(t=o.getGraphDiv(t),l.init(t),o.isPlainObject(e)){var c=e;e=c.data,i=c.layout,a=c.config,s=c.frames}if(!1===l.triggerHandler(t,'plotly_beforeplot',[e,i,a]))return Promise.reject();function f(){if(s)return r.addFrames(t,s)}e||i||o.isPlotDiv(t)||o.warn('Calling _doPlot as if redrawing but this container doesn't yet have a plot.',t),I(t,a),i||(i={}),n.select(t).classed('js-plotly-plot',!0),d.makeTester(),Array.isArray(t._promises)||(t._promises=[]);var m=0===(t.data||[]).length&&Array.isArray(e);Array.isArray(e)&&(_.cleanData(e),m?t.data=e:t.data.push.apply(t.data,e),t.empty=!1),t.layout&&!m||(t.layout=_.cleanLayout(i)),h.supplyDefaults(t);var v=t._fullLayout,y=v._has('cartesian');v._replotting=!0,(m||v._shouldCreateBgLayer)&&(Lt(t),v._shouldCreateBgLayer&&delete v._shouldCreateBgLayer),d.initGradients(t),d.initPatterns(t),m&&p.saveShowSpikeInitial(t);var x=!t.calcdata||t.calcdata.length!==(t._fullData||[]).length;x&&h.doCalcdata(t);for(var b=0;b<t.calcdata.length;b++)t.calcdata[b][0].trace=t._fullData[b];t._context.responsive?t._responsiveChartHandler||(t._responsiveChartHandler=function()[o.isHidden(t)||h.resize(t)],window.addEventListener('resize',t._responsiveChartHandler)):o.clearResponsive(t);var T=o.extendFlat({},v._size),k=0;function M(){for(var e=v._basePlotModules,r=0;r<e.length;r++)e[r].drawFramework&&e[r].drawFramework(t);!v._glcanvas&&v._has('gl')&&(v._glcanvas=v._glcontainer.selectAll('.gl-canvas').data([{key:"contextLayer",context:!0,pick:!1},{key:"focusLayer",context:!1,pick:!1},{key:"pickLayer",context:!1,pick:!0}],(function(t){return t.key})),v._glcanvas.enter().append('canvas').attr('class',(function(t){return"gl-canvas gl-canvas-"+t.key.replace('Layer','')})).style({position:"absolute",top:0,left:0,overflow:"visible","pointer-events":"none"}));var n=t._context.plotGlPixelRatio;if(v._glcanvas){v._glcanvas.attr('width',v.width*n).attr('height',v.height*n).style('width',v.width+"px").style('height',v.height+"px");var i=v._glcanvas.data()[0].regl;if(i&&(Math.floor(v.width*n)!==i._gl.drawingBufferWidth||Math.floor(v.height*n)!==i._gl.drawingBufferHeight)){var a='WebGL context buffer and canvas dimensions do not match due to browser/WebGL bug.';if(!k)return o.log(a+" Clearing graph and plotting again."),h.cleanPlot([],{},t._fullData,v),h.supplyDefaults(t),v=t._fullLayout,h.doCalcdata(t),k++,M();o.error(a)}}return"h"===v.modebar.orientation?v._modebardiv.style('height',null).style('width','100%'):v._modebardiv.style('width',null).style('height',v.height+"px"),h.previousPromises(t)}function A(){if(h.clearAutoMarginIds(t),w.drawMarginPushers(t),p.allowAutoMargin(t),v._has('pie'))for(var e=t._fullData,r=0;r<e.length;r++){var n=e[r];"pie"===n.type&&n.automargin&&h.allowAutoMargin(t,"pie."+n.uid+".automargin")}return h.doAutoMargin(t),h.previousPromises(t)}function S(){if(h.didMarginChange(T,v._size))return o.syncOrAsync([A,w.layoutStyles],t)}function L(){if(x)return o.syncOrAsync([u.getComponentMethod('shapes','calcAutorange'),u.getComponentMethod('annotations','calcAutorange'),C],t);C()}function C(){t._transitioning||(w.doAutoRangeAndConstraints(t),m&&p.saveRangeInitial(t),u.getComponentMethod('rangeslider','calcAutorange')(t))}function P(){return p.draw(t,m?"":"redraw")}var z=[h.previousPromises,f,M,A,S];function O(t){t._fullLayout._insideTickLabelsAutorange&&m&&p.saveRangeInitial(t,!0)}y&&z.push(L),z.push(w.layoutStyles),y&&z.push(P,(function(t){t._fullLayout._insideTickLabelsAutorange&&et(t,t._fullLayout._insideTickLabelsAutorange).then((function(){t._fullLayout._insideTickLabelsAutorange=void 0}))})),z.push(w.drawData,w.finalDraw,g,h.addLinks,h.rehover,h.redrag,h.doAutoMargin,O,h.previousPromises);var D=o.syncOrAsync(z,t);return D&&D.then||(D=Promise.resolve()),D.then((function(){return E(t),t}))}function E(t){var e=t._fullLayout;e._redrawFromAutoMarginCount?e._redrawFromAutoMarginCount--:t.emit('plotly_afterplot')}function L(t){return o.extendFlat(x,t)}function C(t,e){try{t._fullLayout._paper.style('background',e)}catch(r)[o.error(r)]}function P(t,e){C(t,m.combine(e,'white'))}function I(t,e)[if(!t._context){t._context=o.extendDeep({],x);var r=n.select('base');t._context._baseUrl=r.size()&&r.attr('href')?window.location.href.split('#')[0]:""}var i,s,l,c=t._context;if(e){for(s=Object.keys(e),i=0;i<s.length;i++)"editable"!==(l=s[i])&&"edits"!==l&&l in c&&("setBackground"===l&&"opaque"===e[l]?c[l]=P:c[l]=e[l]);e.plot3dPixelRatio&&!c.plotGlPixelRatio&&(c.plotGlPixelRatio=c.plot3dPixelRatio);var u=e.editable;if(void 0!==u)for(c.editable=u,s=Object.keys(c.edits),i=0;i<s.length;i++)c.edits[s[i]]=u;if(e.edits)for(s=Object.keys(e.edits),i=0;i<s.length;i++)(l=s[i])in c.edits&&(c.edits[l]=e.edits[l]);c._exportedPlot=e._exportedPlot}c.staticPlot&&(c.editable=!1,c.edits={},c.autosizable=!1,c.scrollZoom=!1,c.doubleClick=!1,c.showTips=!1,c.showLink=!1,c.displayModeBar=!1),"hover"!==c.displayModeBar||a||(c.displayModeBar=!0),"transparent"!==c.setBackground&&"function"===typeof c.setBackground||(c.setBackground=C),c._hasZeroHeight=c._hasZeroHeight||0===t.clientHeight,c._hasZeroWidth=c._hasZeroWidth||0===t.clientWidth;var f=c.scrollZoom,h=c._scrollZoom={};if(!0===f)h.cartesian=1,h.gl3d=1,h.geo=1,h.mapbox=1;else if("string"===typeof f){var p=f.split('+');for(i=0;i<p.length;i++)h[p[i]]=1}else!1!==f&&(h.gl3d=1,h.geo=1,h.mapbox=1)}function z(t){if(t=o.getGraphDiv(t),!o.isPlotDiv(t))throw new Error('This element is not a Plotly plot: '+t);return _.cleanData(t.data),_.cleanLayout(t.layout),t.calcdata=void 0,r._doPlot(t).then((function(){return t.emit('plotly_redraw'),t}))}function O(t,e,n,i){return t=o.getGraphDiv(t),h.cleanPlot([],{},t._fullData||[],t._fullLayout||{}),h.purge(t),r._doPlot(t,e,n,i)}function D(t,e){var r,n,i=e+1,a=[];for(r=0;r<t.length;r++)(n=t[r])<0?a.push(i+n):a.push(n);return a}function R(t,e,r){var n,i;for(n=0;n<e.length;n++){if((i=e[n])!==parseInt(i,10))throw new Error('all values in '+r+' must be integers');if(i>=t.data.length||i<-t.data.length)throw new Error(r+' must be valid indices for gd.data.');if(e.indexOf(i,n+1)>-1||i>=0&&e.indexOf(-t.data.length+i)>-1||i<0&&e.indexOf(t.data.length+i)>-1)throw new Error('each index in '+r+' must be unique.')}}function F(t,e,r){if(!Array.isArray(t.data))throw new Error('gd.data must be an array.');if("undefined"===typeof e)throw new Error('currentIndices is a required argument.');if(Array.isArray(e)||(e=[e]),R(t,e,'currentIndices'),"undefined"===typeof r||Array.isArray(r)||(r=[r]),"undefined"!==typeof r&&R(t,r,'newIndices'),"undefined"!==typeof r&&e.length!==r.length)throw new Error('current and new indices must be of equal length.')}function B(t,e,r){var n,i;if(!Array.isArray(t.data))throw new Error('gd.data must be an array.');if("undefined"===typeof e)throw new Error('traces must be defined.');for(Array.isArray(e)||(e=[e]),n=0;n<e.length;n++)if("object"!==typeof(i=e[n])||Array.isArray(i)||null===i)throw new Error('all values in traces array must be non-array objects');if("undefined"===typeof r||Array.isArray(r)||(r=[r]),"undefined"!==typeof r&&r.length!==e.length)throw new Error('if indices is specified, traces.length must equal indices.length')}function N(t,e,r,n){var i=o.isPlainObject(n);if(!Array.isArray(t.data))throw new Error('gd.data must be an array');if(!o.isPlainObject(e))throw new Error('update must be a key:value object');if("undefined"===typeof r)throw new Error('indices must be an integer or array of integers');for(var a in R(t,r,'indices'),e){if(!Array.isArray(e[a])||e[a].length!==r.length)throw new Error('attribute '+a+' must be an array of length equal to indices array length');if(i&&(!(a in n)||!Array.isArray(n[a])||n[a].length!==e[a].length))throw new Error('when maxPoints is set as a key:value object it must contain a 1:1 corrispondence with the keys and number of traces in the update object')}}function j(t,e,r,n){var a,l,c,u,f,h=o.isPlainObject(n),p=[];for(var d in Array.isArray(r)||(r=[r]),r=D(r,t.data.length-1),e)for(var m=0;m<r.length;m++){if(a=t.data[r[m]],l=(c=s(a,d)).get(),u=e[d][m],!o.isArrayOrTypedArray(u))throw new Error('attribute: '+d+' index: '+m+' must be an array');if(!o.isArrayOrTypedArray(l))throw new Error("cannot extend missing or non-array attribute: "+d);if(l.constructor!==u.constructor)throw new Error("cannot extend array with an array of a different type: "+d);f=h?n[d][m]:n,i(f)||(f=-1),p.push({prop:c,target:l,insert:u,maxp:Math.floor(f)})}return p}function U(t,e,r,n,i){N(t,e,r,n);for(var a=j(t,e,r,n),o={},s={},l=0;l<a.length;l++){var c=a[l].prop,u=a[l].maxp,f=i(a[l].target,a[l].insert,u);c.set(f[0]),Array.isArray(o[c.astr])||(o[c.astr]=[]),o[c.astr].push(f[1]),Array.isArray(s[c.astr])||(s[c.astr]=[]),s[c.astr].push(a[l].target.length)}return{update:o,maxPoints:s}}function V(t,e){var r=new t.constructor(t.length+e.length);return r.set(t),r.set(e,t.length),r}function H(t,e,n,i){function a(t,e,r){var n,i;if(o.isTypedArray(t))if(r<0){var a=new t.constructor(0),s=V(t,e);r<0?(n=s,i=a):(n=a,i=s)}else if(n=new t.constructor(r),i=new t.constructor(t.length+e.length-r),r===e.length)n.set(e),i.set(t);else if(r<e.length){var l=e.length-r;n.set(e.subarray(l)),i.set(t),i.set(e.subarray(0,l),t.length)}else{var c=r-e.length,u=t.length-c;n.set(t.subarray(u)),n.set(e,c),i.set(t.subarray(0,u))}else n=t.concat(e),i=r>=0&&r<n.length?n.splice(0,n.length-r):[];return[n,i]}var s=U(t=o.getGraphDiv(t),e,n,i,a),l=r.redraw(t),u=[t,s.update,n,s.maxPoints];return c.add(t,r.prependTraces,u,H,arguments),l}function q(t,e,n,i){function a(t,e,r){var n,i;if(o.isTypedArray(t))if(r<=0){var a=new t.constructor(0),s=V(e,t);r<0?(n=s,i=a):(n=a,i=s)}else if(n=new t.constructor(r),i=new t.constructor(t.length+e.length-r),r===e.length)n.set(e),i.set(t);else if(r<e.length){var l=e.length-r;n.set(e.subarray(0,l)),i.set(e.subarray(l)),i.set(t,l)}else{var c=r-e.length;n.set(e),n.set(t.subarray(0,c),e.length),i.set(t.subarray(c))}else n=e.concat(t),i=r>=0&&r<n.length?n.splice(r,n.length):[];return[n,i]}var s=U(t=o.getGraphDiv(t),e,n,i,a),l=r.redraw(t),u=[t,s.update,n,s.maxPoints];return c.add(t,r.extendTraces,u,q,arguments),l}function G(t,e,n){t=o.getGraphDiv(t);var i,a,s=[],l=r.deleteTraces,u=G,f=[t,s],h=[t,e];for(B(t,e,n),Array.isArray(e)||(e=[e]),e=e.map((function(t){return o.extendFlat({},t)})),_.cleanData(e),i=0;i<e.length;i++)t.data.push(e[i]);for(i=0;i<e.length;i++)s.push(-e.length+i);if("undefined"===typeof n)return a=r.redraw(t),c.add(t,l,f,u,h),a;Array.isArray(n)||(n=[n]);try{F(t,s,n)}catch(p){throw t.data.splice(t.data.length-e.length,e.length),p}return c.startSequence(t),c.add(t,l,f,u,h),a=r.moveTraces(t,s,n),c.stopSequence(t),a}function Y(t,e){t=o.getGraphDiv(t);var n,i,a=[],s=r.addTraces,l=Y,u=[t,a,e],f=[t,e];if("undefined"===typeof e)throw new Error('indices must be an integer or array of integers.');for(Array.isArray(e)||(e=[e]),R(t,e,'indices'),(e=D(e,t.data.length-1)).sort(o.sorterDes),n=0;n<e.length;n+=1)i=t.data.splice(e[n],1)[0],a.push(i);var h=r.redraw(t);return c.add(t,s,u,l,f),h}function W(t,e,n){var i,a=[],s=[],l=W,u=W,f=[t=o.getGraphDiv(t),n,e],h=[t,e,n];if(F(t,e,n),e=Array.isArray(e)?e:[e],"undefined"===typeof n)for(n=[],i=0;i<e.length;i++)n.push(-e.length+i);for(n=Array.isArray(n)?n:[n],e=D(e,t.data.length-1),n=D(n,t.data.length-1),i=0;i<t.data.length;i++)-1===e.indexOf(i)&&a.push(t.data[i]);for(i=0;i<e.length;i++)s.push({newIndex:n[i],trace:t.data[e[i]]});for(s.sort((function(t,e){return t.newIndex-e.newIndex})),i=0;i<s.length;i+=1)a.splice(s[i].newIndex,0,s[i].trace);t.data=a;var p=r.redraw(t);return c.add(t,l,f,u,h),p}function X(t,e,n,i){t=o.getGraphDiv(t),_.clearPromiseQueue(t);var a={};if("string"===typeof e)a[e]=n;else{if(!o.isPlainObject(e))return o.warn('Restyle fail.',e,n,i),Promise.reject();a=o.extendFlat({},e),void 0===i&&(i=n)}Object.keys(a).length&&(t.changed=!0);var s=_.coerceTraceIndices(t,i),l=$(t,a,s),u=l.flags;u.calc&&(t.calcdata=void 0),u.clearAxisTypes&&_.clearAxisTypes(t,s,{});var f=[];u.fullReplot?f.push(r._doPlot):(f.push(h.previousPromises),h.supplyDefaults(t),u.markerSize&&(h.doCalcdata(t),nt(f)),u.style&&f.push(w.doTraceStyle),u.colorbars&&f.push(w.doColorBars),f.push(E)),f.push(h.rehover,h.redrag),c.add(t,X,[t,l.undoit,l.traces],X,[t,l.redoit,l.traces]);var p=o.syncOrAsync(f,t);return p&&p.then||(p=Promise.resolve()),p.then((function(){return t.emit('plotly_restyle',l.eventData),t}))}function Z(t){return void 0===t?null:t}function J(t,e){return e?function(e,r,n){var i=s(e,r),a=i.set;return i.set=function(e){K((n||"")+r,i.get(),e,t),a(e)},i}:s}function K(t,e,r,n){if(Array.isArray(e)||Array.isArray(r))for(var i=Array.isArray(e)?e:[],a=Array.isArray(r)?r:[],s=Math.max(i.length,a.length),l=0;l<s;l++)K(t+"["+l+"]",i[l],a[l],n);else if(o.isPlainObject(e)||o.isPlainObject(r)){var c=o.isPlainObject(e)?e:{},u=o.isPlainObject(r)?r:{},f=o.extendFlat({},c,u);for(var h in f)K(t+"."+h,c[h],u[h],n)}else void 0===n[t]&&(n[t]=Z(e))}function Q(t,e,r){for(var n in r)K(n,s(t,n).get(),r[n],e)}function $(t,e,r){var n,i=t._fullLayout,a=t._fullData,l=t.data,c=i._guiEditing,d=J(i._preGUI,c),m=o.extendDeepAll({},e);tt(e);var g,v=T.traceFlags(),y={},x={};function b(){return r.map((function(){}))}function w(t){var e=p.id2name(t);-1===g.indexOf(e)&&g.push(e)}function k(t){return"LAYOUT"+t+".autorange"}function M(t){return"LAYOUT"+t+".range"}function A(t){for(var e=t;e<a.length;e++)if(a[e]._input===l[t])return a[e]}function S(n,a,o){if(Array.isArray(n))n.forEach((function(t){S(t,a,o)}));else if(!(n in e)&&!_.hasParent(e,n)){var s;if("LAYOUT"===n.substr(0,6))s=d(t.layout,n.replace('LAYOUT',''));else{var u=r[o];s=J(i._tracePreGUI[A(u)._fullInput.uid],c)(l[u],n)}n in x||(x[n]=b()),void 0===x[n][o]&&(x[n][o]=Z(s.get())),void 0!==a&&s.set(a)}}function E(t){return function(e){return a[e][t]}}function L(t){return function(e,n){return!1===e?a[r[n]][t]:null}}for(var C in e){if(_.hasParent(e,C))throw new Error('cannot set '+C+' and a parent attribute simultaneously');var P,I,z,O,D,R,F=e[C];if("autobinx"!==C&&"autobiny"!==C||(C=C.charAt(C.length-1)+"bins",F=Array.isArray(F)?F.map(L(C)):!1===F?r.map(E(C)):null),y[C]=F,"LAYOUT"!==C.substr(0,6)){for(x[C]=b(),n=0;n<r.length;n++)if(P=l[r[n]],I=A(r[n]),O=(z=J(i._tracePreGUI[I._fullInput.uid],c)(P,C)).get(),void 0!==(D=Array.isArray(F)?F[n%F.length]:F)){var B=z.parts[z.parts.length-1],N=C.substr(0,C.length-B.length-1),j=N?N+".":"",U=N?s(I,N).get():I;if((R=f.getTraceValObject(I,z.parts))&&R.impliedEdits&&null!==D)for(var V in R.impliedEdits)S(o.relativeAttr(C,V),R.impliedEdits[V],n);else if("thicknessmode"!==B&&"lenmode"!==B||O===D||"fraction"!==D&&"pixels"!==D||!U){if("type"===C&&("pie"===D!==("pie"===O)||"funnelarea"===D!==("funnelarea"===O))){var H='x',q='y';"bar"!==D&&"bar"!==O||"h"!==P.orientation||(H='y',q='x'),o.swapAttrs(P,["?","?src"],'labels',H),o.swapAttrs(P,["d?","?0"],'label',H),o.swapAttrs(P,["?","?src"],'values',q),"pie"===O||"funnelarea"===O?(s(P,'marker.color').set(s(P,'marker.colors').get()),i._pielayer.selectAll('g.trace').remove()):u.traceIs(P,'cartesian')&&s(P,'marker.colors').set(s(P,'marker.color').get())}}else{var G=i._size,Y=U.orient,W="top"===Y||"bottom"===Y;if("thicknessmode"===B){var X=W?G.h:G.w;S(j+"thickness",U.thickness*("fraction"===D?1/X:X),n)}else{var K=W?G.w:G.h;S(j+"len",U.len*("fraction"===D?1/K:K),n)}}if(x[C][n]=Z(O),-1!==["swapxy",'swapxyaxes','orientation',"orientationaxes"].indexOf(C)){if("orientation"===C){z.set(D);var Q=P.x&&!P.y?"h":"v";if((z.get()||Q)===I.orientation)continue}else"orientationaxes"===C&&(P.orientation={v:"h",h:"v"}[I.orientation]);_.swapXYData(P),v.calc=v.clearAxisTypes=!0}else-1!==h.dataArrayContainers.indexOf(z.parts[0])?(_.manageArrayContainers(z,D,x),v.calc=!0):(R?R.arrayOk&&!u.traceIs(I,'regl')&&(o.isArrayOrTypedArray(D)||o.isArrayOrTypedArray(O))?v.calc=!0:T.update(v,R):v.calc=!0,z.set(D))}if(-1!==["swapxyaxes","orientationaxes"].indexOf(C)&&p.swap(t,r),"orientationaxes"===C){var $=s(t.layout,'hovermode'),et=$.get();"x"===et?$.set('y'):"y"===et?$.set('x'):"x unified"===et?$.set('y unified'):"y unified"===et&&$.set('x unified')}if(-1!==["orientation","type"].indexOf(C)){for(g=[],n=0;n<r.length;n++){var rt=l[r[n]];u.traceIs(rt,'cartesian')&&(w(rt.xaxis||"x"),w(rt.yaxis||"y"))}S(g.map(k),!0,0),S(g.map(M),[0,1],0)}}else z=d(t.layout,C.replace('LAYOUT','')),x[C]=[Z(z.get())],z.set(Array.isArray(F)?F[0]:F),v.calc=!0}return(v.calc||v.plot)&&(v.fullReplot=!0),{flags:v,undoit:x,redoit:y,traces:r,eventData:o.extendDeepNoArrays([],[m,r])}}function tt(t){var e,r,n,i=o.counterRegex('axis','.title',!1,!1),a=/colorbar\.title$/,s=Object.keys(t);for(e=0;e<s.length;e++)r=s[e],n=t[r],"title"!==r&&!i.test(r)&&!a.test(r)||"string"!==typeof n&&"number"!==typeof n?r.indexOf('titlefont')>-1?l(r,r.replace('titlefont','title.font')):r.indexOf('titleposition')>-1?l(r,r.replace('titleposition','title.position')):r.indexOf('titleside')>-1?l(r,r.replace('titleside','title.side')):r.indexOf('titleoffset')>-1&&l(r,r.replace('titleoffset','title.offset')):l(r,r.replace('title','title.text'));function l(e,r){t[r]=t[e],delete t[e]}}function et(t,e,r){t=o.getGraphDiv(t),_.clearPromiseQueue(t);var n={};if("string"===typeof e)n[e]=r;else{if(!o.isPlainObject(e))return o.warn('Relayout fail.',e,r),Promise.reject();n=o.extendFlat({},e)}Object.keys(n).length&&(t.changed=!0);var i=st(t,n),a=i.flags;a.calc&&(t.calcdata=void 0);var s=[h.previousPromises];a.layoutReplot?s.push(w.layoutReplot):Object.keys(n).length&&(rt(t,a,i)||h.supplyDefaults(t),a.legend&&s.push(w.doLegend),a.layoutstyle&&s.push(w.layoutStyles),a.axrange&&nt(s,i.rangesAltered),a.ticks&&s.push(w.doTicksRelayout),a.modebar&&s.push(w.doModeBar),a.camera&&s.push(w.doCamera),a.colorbars&&s.push(w.doColorBars),s.push(E)),s.push(h.rehover,h.redrag),c.add(t,et,[t,i.undoit],et,[t,i.redoit]);var l=o.syncOrAsync(s,t);return l&&l.then||(l=Promise.resolve(t)),l.then((function(){return t.emit('plotly_relayout',i.eventData),t}))}function rt(t,e,r){var n=t._fullLayout;if(!e.axrange)return!1;for(var i in e)if("axrange"!==i&&e[i])return!1;for(var a in r.rangesAltered){var o=p.id2name(a),s=t.layout[o],l=n[o];if(l.autorange=s.autorange,s.range&&(l.range=s.range.slice()),l.cleanRange(),l._matchGroup)for(var c in l._matchGroup)if(c!==a){var u=n[p.id2name(c)];u.autorange=l.autorange,u.range=l.range.slice(),u._input.range=l.range.slice()}}return!0}function nt(t,e){var r=e?function(t){var r=[],n=!0;for(var i in e){var a=p.getFromId(t,i);if(r.push(i),-1!==(a.ticklabelposition||"").indexOf('inside')&&a._anchorAxis&&r.push(a._anchorAxis._id),a._matchGroup)for(var o in a._matchGroup)e[o]||r.push(o);a.automargin&&(n=!1)}return p.draw(t,r,{skipTitle:n})}:function(t){return p.draw(t,'redraw')};t.push(y,w.doAutoRangeAndConstraints,r,w.drawData,w.finalDraw)}var it=/^[xyz]axis[0-9]*\.range(\[[0|1]\])?$/,at=/^[xyz]axis[0-9]*\.autorange$/,ot=/^[xyz]axis[0-9]*\.domain(\[[0|1]\])?$/;function st(t,e){var r,n,i,a=t.layout,l=t._fullLayout,c=l._guiEditing,h=J(l._preGUI,c),d=Object.keys(e),m=p.list(t),g=o.extendDeepAll({},e),v={};for(tt(e),d=Object.keys(e),n=0;n<d.length;n++)if(0===d[n].indexOf('allaxes')){for(i=0;i<m.length;i++){var y=m[i]._id.substr(1),x=-1!==y.indexOf('scene')?y+".":"",w=d[n].replace('allaxes',x+m[i]._name);e[w]||(e[w]=e[d[n]])}delete e[d[n]]}var M=T.layoutFlags(),A={},S={};function E(t,r){if(Array.isArray(t))t.forEach((function(t){E(t,r)}));else if(!(t in e)&&!_.hasParent(e,t)){var n=h(a,t);t in S||(S[t]=Z(n.get())),void 0!==r&&n.set(r)}}var L,C={};function P(t){var e=p.name2id(t.split('.')[0]);return C[e]=1,e}for(var I in e){if(_.hasParent(e,I))throw new Error('cannot set '+I+' and a parent attribute simultaneously');for(var z=h(a,I),O=e[I],D=z.parts.length-1;D>0&&"string"!==typeof z.parts[D];)D--;var R=z.parts[D],F=z.parts[D-1]+"."+R,B=z.parts.slice(0,D).join('.'),N=s(t.layout,B).get(),j=s(l,B).get(),U=z.get();if(void 0!==O){A[I]=O,S[I]="reverse"===R?O:Z(U);var V=f.getLayoutValObject(l,z.parts);if(V&&V.impliedEdits&&null!==O)for(var H in V.impliedEdits)E(o.relativeAttr(I,H),V.impliedEdits[H]);if(-1!==["width","height"].indexOf(I))if(O){E('autosize',null);var q="height"===I?"width":"height";E(q,l[q])}else l[I]=t._initialAutoSize[I];else if("autosize"===I)E('width',O?null:l.width),E('height',O?null:l.height);else if(F.match(it))P(F),s(l,B+"._inputRange").set(null);else if(F.match(at)){P(F),s(l,B+"._inputRange").set(null);var G=s(l,B).get();G._inputDomain&&(G._input.domain=G._inputDomain.slice())}else F.match(ot)&&s(l,B+"._inputDomain").set(null);if("type"===R){L=N;var Y="linear"===j.type&&"log"===O,W="log"===j.type&&"linear"===O;if(Y||W){if(L&&L.range)if(j.autorange)Y&&(L.range=L.range[1]>L.range[0]?[1,2]:[2,1]);else{var X=L.range[0],K=L.range[1];Y?(X<=0&&K<=0&&E(B+".autorange",!0),X<=0?X=K/1e6:K<=0&&(K=X/1e6),E(B+".range[0]",Math.log(X)/Math.LN10),E(B+".range[1]",Math.log(K)/Math.LN10)):(E(B+".range[0]",Math.pow(10,X)),E(B+".range[1]",Math.pow(10,K)))}else E(B+".autorange",!0);Array.isArray(l._subplots.polar)&&l._subplots.polar.length&&l[z.parts[0]]&&"radialaxis"===z.parts[1]&&delete l[z.parts[0]]._subplot.viewInitial["radialaxis.range"],u.getComponentMethod('annotations','convertCoords')(t,j,O,E),u.getComponentMethod('images','convertCoords')(t,j,O,E)}else E(B+".autorange",!0),E(B+".range",null);s(l,B+"._inputRange").set(null)}else if(R.match(k)){var Q=s(l,I).get(),$=(O||{}).type;$&&"-"!==$||($='linear'),u.getComponentMethod('annotations','convertCoords')(t,Q,$,E),u.getComponentMethod('images','convertCoords')(t,Q,$,E)}var et=b.containerArrayMatch(I);if(et){r=et.array,n=et.index;var rt=et.property,nt=V||{editType:"calc"};""!==n&&""===rt&&(b.isAddVal(O)?S[I]=null:b.isRemoveVal(O)?S[I]=(s(a,r).get()||[])[n]:o.warn('unrecognized full object value',e)),T.update(M,nt),v[r]||(v[r]={});var st=v[r][n];st||(st=v[r][n]={}),st[rt]=O,delete e[I]}else"reverse"===R?(N.range?N.range.reverse():(E(B+".autorange",!0),N.range=[1,0]),j.autorange?M.calc=!0:M.plot=!0):(l._has('scatter-like')&&l._has('regl')&&"dragmode"===I&&("lasso"===O||"select"===O)&&"lasso"!==U&&"select"!==U||l._has('gl2d')?M.plot=!0:V?T.update(M,V):M.calc=!0,z.set(O))}}for(r in v)b.applyContainerArrayChanges(t,h(a,r),v[r],M,h)||(M.plot=!0);for(var ct in C){var ut=(L=p.getFromId(t,ct))&&L._constraintGroup;if(ut)for(var ft in M.calc=!0,ut)C[ft]||(p.getFromId(t,ft)._constraintShrinkable=!0)}return(lt(t)||e.height||e.width)&&(M.plot=!0),(M.plot||M.calc)&&(M.layoutReplot=!0),{flags:M,rangesAltered:C,undoit:S,redoit:A,eventData:g}}function lt(t){var e=t._fullLayout,r=e.width,n=e.height;return t.layout.autosize&&h.plotAutoSize(t,t.layout,e),e.width!==r||e.height!==n}function ct(t,e,n,i){t=o.getGraphDiv(t),_.clearPromiseQueue(t),o.isPlainObject(e)||(e={}),o.isPlainObject(n)||(n={}),Object.keys(e).length&&(t.changed=!0),Object.keys(n).length&&(t.changed=!0);var a=_.coerceTraceIndices(t,i),s=$(t,o.extendFlat({},e),a),l=s.flags,u=st(t,o.extendFlat({},n)),f=u.flags;(l.calc||f.calc)&&(t.calcdata=void 0),l.clearAxisTypes&&_.clearAxisTypes(t,a,n);var p=[];f.layoutReplot?p.push(w.layoutReplot):l.fullReplot?p.push(r._doPlot):(p.push(h.previousPromises),rt(t,f,u)||h.supplyDefaults(t),l.style&&p.push(w.doTraceStyle),(l.colorbars||f.colorbars)&&p.push(w.doColorBars),f.legend&&p.push(w.doLegend),f.layoutstyle&&p.push(w.layoutStyles),f.axrange&&nt(p,u.rangesAltered),f.ticks&&p.push(w.doTicksRelayout),f.modebar&&p.push(w.doModeBar),f.camera&&p.push(w.doCamera),p.push(E)),p.push(h.rehover,h.redrag),c.add(t,ct,[t,s.undoit,u.undoit,s.traces],ct,[t,s.redoit,u.redoit,s.traces]);var d=o.syncOrAsync(p,t);return d&&d.then||(d=Promise.resolve(t)),d.then((function(){return t.emit('plotly_update',{data:s.eventData,layout:u.eventData}),t}))}function ut(t){return function(e){e._fullLayout._guiEditing=!0;var r=t.apply(null,arguments);return e._fullLayout._guiEditing=!1,r}}var ft=[{pattern:/^hiddenlabels/,attr:"legend.uirevision"},{pattern:/^((x|y)axis\d*)\.((auto)?range|title\.text)/},{pattern:/axis\d*\.showspikes$/,attr:"modebar.uirevision"},{pattern:/(hover|drag)mode$/,attr:"modebar.uirevision"},{pattern:/^(scene\d*)\.camera/},{pattern:/^(geo\d*)\.(projection|center|fitbounds)/},{pattern:/^(ternary\d*\.[abc]axis)\.(min|title\.text)$/},{pattern:/^(polar\d*\.radialaxis)\.((auto)?range|angle|title\.text)/},{pattern:/^(polar\d*\.angularaxis)\.rotation/},{pattern:/^(mapbox\d*)\.(center|zoom|bearing|pitch)/},{pattern:/^legend\.(x|y)$/,attr:"editrevision"},{pattern:/^(shapes|annotations)/,attr:"editrevision"},{pattern:/^title\.text$/,attr:"editrevision"}],ht=[{pattern:/^selectedpoints$/,attr:"selectionrevision"},{pattern:/(^|value\.)visible$/,attr:"legend.uirevision"},{pattern:/^dimensions\[\d+\]\.constraintrange/},{pattern:/^node\.(x|y|groups)/},{pattern:/^level$/},{pattern:/(^|value\.)name$/},{pattern:/colorbar\.title\.text$/},{pattern:/colorbar\.(x|y)$/,attr:"editrevision"}];function pt(t,e){for(var r=0;r<e.length;r++){var n=e[r],i=t.match(n.pattern);if(i)return{head:i[1],attr:n.attr}}}function dt(t,e){var r=s(e,t).get();if(void 0!==r)return r;var n=t.split('.');for(n.pop();n.length>1;)if(n.pop(),void 0!==(r=s(e,n.join('.')+".uirevision").get()))return r;return e.uirevision}function mt(t,e){for(var r=0;r<e.length;r++)if(e[r]._fullInput.uid===t)return r;return-1}function gt(t,e,r){for(var n=0;n<e.length;n++)if(e[n].uid===t)return n;return!e[r]||e[r].uid?-1:r}function vt(t,e){var r=o.isPlainObject(t),n=Array.isArray(t);return r||n?(r&&o.isPlainObject(e)||n&&Array.isArray(e))&&JSON.stringify(t)===JSON.stringify(e):t===e}function yt(t,e,r,n){var i,a,l,c,u,f,h,p,d=n._preGUI,m=[],g={};for(i in d){if(u=pt(i,ft)){if(a=u.attr||u.head+".uirevision",(c=(l=s(n,a).get())&&dt(a,e))&&c===l&&(null===(f=d[i])&&(f=void 0),vt(p=(h=s(e,i)).get(),f))){void 0===p&&"autorange"===i.substr(i.length-9)&&m.push(i.substr(0,i.length-10)),h.set(Z(s(n,i).get()));continue}}else o.warn("unrecognized GUI edit: "+i);delete d[i],"range["===i.substr(i.length-8,6)&&(g[i.substr(0,i.length-9)]=1)}for(var v=0;v<m.length;v++){var y=m[v];if(g[y]){var x=s(e,y).get();x&&delete x.autorange}}var b=n._tracePreGUI;for(var _ in b){var w,T=b[_],k=null;for(i in T){if(!k){var M=mt(_,r);if(M<0){delete b[_];break}var A=gt(_,t,(w=r[M]._fullInput).index);if(A<0){delete b[_];break}k=t[A]}if(u=pt(i,ht)){if(u.attr?c=(l=s(n,u.attr).get())&&dt(u.attr,e):(l=w.uirevision,void 0===(c=k.uirevision)&&(c=e.uirevision)),c&&c===l&&(null===(f=T[i])&&(f=void 0),vt(p=(h=s(k,i)).get(),f))){h.set(Z(s(w,i).get()));continue}}else o.warn("unrecognized GUI edit: '+i+' in trace uid "+_);delete T[i]}}}function xt(t,e,n,i){var a,s;function l(){return r.addFrames(t,a)}t=o.getGraphDiv(t),_.clearPromiseQueue(t);var c=t._fullData,f=t._fullLayout;if(o.isPlotDiv(t)&&c&&f){if(o.isPlainObject(e)){var p=e;e=p.data,n=p.layout,i=p.config,a=p.frames}var d=!1;if(i)[var m=o.extendDeep({],t._context);t._context=void 0,I(t,i),d=Tt(m,t._context)}t.data=e||[],_.cleanData(t.data),t.layout=n||{},_.cleanLayout(t.layout),yt(t.data,t.layout,c,f),h.supplyDefaults(t,{skipUpdateCalc:!0});var g=t._fullData,v=t._fullLayout,y=void 0===v.datarevision,x=v.transition,b=_t(t,f,v,y,x),T=b.newDataRevision,k=bt(t,c,g,y,x,T);if(lt(t)&&(b.layoutReplot=!0),k.calc||b.calc){t.calcdata=void 0;for(var M=Object.getOwnPropertyNames(v),A=0;A<M.length;A++){var S=M[A],L=S.substring(0,5);if("xaxis"===L||"yaxis"===L){var C=v[S]._emptyCategories;C&&C()}}}else h.supplyDefaultsUpdateCalc(t.calcdata,g);var P=[];if(a&&(t._transitionData={},h.createTransitionData(t),P.push(l)),v.transition&&!d&&(k.anim||b.anim))b.ticks&&P.push(w.doTicksRelayout),h.doCalcdata(t),w.doAutoRangeAndConstraints(t),P.push((function(){return h.transitionFromReact(t,k,b,f)}));else if(k.fullReplot||b.layoutReplot||d)t._fullLayout._skipDefaults=!0,P.push(r._doPlot);else{for(var z in b.arrays){var O=b.arrays[z];if(O.length){var D=u.getComponentMethod(z,'drawOne');if(D!==o.noop)for(var R=0;R<O.length;R++)D(t,O[R]);else{var F=u.getComponentMethod(z,'draw');if(F===o.noop)throw new Error("cannot draw components: "+z);F(t)}}}P.push(h.previousPromises),k.style&&P.push(w.doTraceStyle),(k.colorbars||b.colorbars)&&P.push(w.doColorBars),b.legend&&P.push(w.doLegend),b.layoutstyle&&P.push(w.layoutStyles),b.axrange&&nt(P),b.ticks&&P.push(w.doTicksRelayout),b.modebar&&P.push(w.doModeBar),b.camera&&P.push(w.doCamera),P.push(E)}P.push(h.rehover,h.redrag),(s=o.syncOrAsync(P,t))&&s.then||(s=Promise.resolve(t))}else s=r.newPlot(t,e,n,i);return s.then((function(){return t.emit('plotly_react',{data:e,layout:n}),t}))}function bt(t,e,r,n,i,a){var o=e.length===r.length;if(!i&&!o)return{fullReplot:!0,calc:!0};var s,l,c=T.traceFlags();function u(t){var e=f.getTraceValObject(l,t);return!l._module.animatable&&e.anim&&(e.anim=!1),e}c.arrays={},c.nChanges=0,c.nChangesAnim=0;var p={getValObject:u,flags:c,immutable:n,transition:i,newDataRevision:a,gd:t},d={};for(s=0;s<e.length;s++)if(r[s]){if(l=r[s]._fullInput,h.hasMakesDataTransform(l)&&(l=r[s]),d[l.uid])continue;d[l.uid]=1,wt(e[s]._fullInput,l,[],p)}return(c.calc||c.plot)&&(c.fullReplot=!0),i&&c.nChanges&&c.nChangesAnim&&(c.anim=c.nChanges===c.nChangesAnim&&o?"all":"some"),c}function _t(t,e,r,n,i){var a=T.layoutFlags();function o(t){return f.getLayoutValObject(r,t)}return a.arrays={},a.rangesAltered={},a.nChanges=0,a.nChangesAnim=0,wt(e,r,[],{getValObject:o,flags:a,immutable:n,transition:i,gd:t}),(a.plot||a.calc)&&(a.layoutReplot=!0),i&&a.nChanges&&a.nChangesAnim&&(a.anim=a.nChanges===a.nChangesAnim?"all":"some"),a}function wt(t,e,r,n){var i,a,l,c=n.getValObject,u=n.flags,f=n.immutable,h=n.inArray,p=n.arrayIndex;function d(){var t=i.editType;h&&-1!==t.indexOf('arraydraw')?o.pushUnique(u.arrays[h],p):(T.update(u,i),"none"!==t&&u.nChanges++,n.transition&&i.anim&&u.nChangesAnim++,(it.test(l)||at.test(l))&&(u.rangesAltered[r[0]]=1),ot.test(l)&&s(e,'_inputDomain').set(null),"datarevision"===a&&(u.newDataRevision=1))}function m(t){return"data_array"===t.valType||t.arrayOk}for(a in t){if(u.calc&&!n.transition)return;var g=t[a],v=e[a],y=r.concat(a);if(l=y.join('.'),"_"!==a.charAt(0)&&"function"!==typeof g&&g!==v){if(("tick0"===a||"dtick"===a)&&"geo"!==r[0]){var x=e.tickmode;if("auto"===x||"array"===x||!x)continue}if(("range"!==a||!e.autorange)&&("zmin"!==a&&"zmax"!==a||"contourcarpet"!==e.type)&&(i=c(y))&&(!i._compareAsJSON||JSON.stringify(g)!==JSON.stringify(v))){var b,_=i.valType,w=m(i),k=Array.isArray(g),M=Array.isArray(v);if(k&&M){var A="_input_"+a,S=t[A],E=e[A];if(Array.isArray(S)&&S===E)continue}if(void 0===v)w&&k?u.calc=!0:d();else if(i._isLinkedToArray){var L=[],C=!1;h||(u.arrays[a]=L);var P=Math.min(g.length,v.length),I=Math.max(g.length,v.length);if(P!==I){if("arraydraw"!==i.editType){d();continue}C=!0}for(b=0;b<P;b++)wt(g[b],v[b],y.concat(b),o.extendFlat({inArray:a,arrayIndex:b},n));if(C)for(b=P;b<I;b++)L.push(b)}else!_&&o.isPlainObject(g)?wt(g,v,y,n):w?k&&M?(f&&(u.calc=!0),(f||n.newDataRevision)&&d()):k!==M?u.calc=!0:d():k&&M&&g.length===v.length&&String(g)===String(v)||d()}}}for(a in e)if(!(a in t)&&"_"!==a.charAt(0)&&"function"!==typeof e[a]){if(m(i=c(r.concat(a)))&&Array.isArray(e[a]))return void(u.calc=!0);d()}}function Tt(t,e){var r;for(r in t)if("_"!==r.charAt(0)){var n=t[r],i=e[r];if(n!==i)if(o.isPlainObject(n)&&o.isPlainObject(i)){if(Tt(n,i))return!0}else{if(!Array.isArray(n)||!Array.isArray(i))return!0;if(n.length!==i.length)return!0;for(var a=0;a<n.length;a++)if(n[a]!==i[a]){if(!o.isPlainObject(n[a])||!o.isPlainObject(i[a]))return!0;if(Tt(n[a],i[a]))return!0}}}}function kt(t,e,r){if(t=o.getGraphDiv(t),!o.isPlotDiv(t))throw new Error('This element is not a Plotly plot: '+t+'. It's likely that you've failed to create a plot before animating it. For more details, see https://plotly.com/javascript/animations/');var n=t._transitionData;n._frameQueue||(n._frameQueue=[]);var i=(r=h.supplyAnimationDefaults(r)).transition,a=r.frame;function s(t){return Array.isArray(i)?t>=i.length?i[0]:i[t]:i}function l(t){return Array.isArray(a)?t>=a.length?a[0]:a[t]:a}function c(t,e){var r=0;return function(){if(t&&++r===e)return t()}}return void 0===n._frameWaitingCnt&&(n._frameWaitingCnt=0),new Promise((function(a,u){function f(){if(0!==n._frameQueue.length){for(;n._frameQueue.length;){var e=n._frameQueue.pop();e.onInterrupt&&e.onInterrupt()}t.emit('plotly_animationinterrupted',[])}}function p(e){if(0!==e.length){for(var i=0;i<e.length;i++){var o;o="byname"===e[i].type?h.computeFrame(t,e[i].name):e[i].data;var f=l(i),p=s(i);p.duration=Math.min(p.duration,f.duration);var d={frame:o,name:e[i].name,frameOpts:f,transitionOpts:p};i===e.length-1&&(d.onComplete=c(a,2),d.onInterrupt=u),n._frameQueue.push(d)}"immediate"===r.mode&&(n._lastFrameAt=-1/0),n._animationRaf||g()}}function d(){t.emit('plotly_animated'),window.cancelAnimationFrame(n._animationRaf),n._animationRaf=null}function m(){n._currentFrame&&n._currentFrame.onComplete&&n._currentFrame.onComplete();var e=n._currentFrame=n._frameQueue.shift();if(e){var r=e.name?e.name.toString():null;t._fullLayout._currentFrame=r,n._lastFrameAt=Date.now(),n._timeToNext=e.frameOpts.duration,h.transition(t,e.frame.data,e.frame.layout,_.coerceTraceIndices(t,e.frame.traces),e.frameOpts,e.transitionOpts).then((function(){e.onComplete&&e.onComplete()})),t.emit('plotly_animatingframe',{name:r,frame:e.frame,animation:{frame:e.frameOpts,transition:e.transitionOpts}})}else d()}function g(){t.emit('plotly_animating'),n._lastFrameAt=-1/0,n._timeToNext=0,n._runningTransitions=0,n._currentFrame=null;var e=function(){n._animationRaf=window.requestAnimationFrame(e),Date.now()-n._lastFrameAt>n._timeToNext&&m()};e()}var v,y,x=0;function b(t){return Array.isArray(i)?x>=i.length?t.transitionOpts=i[x]:t.transitionOpts=i[0]:t.transitionOpts=i,x++,t}var w=[],T=void 0===e||null===e,k=Array.isArray(e);if(T||k||!o.isPlainObject(e)){if(T||-1!==["string","number"].indexOf(typeof e))for(v=0;v<n._frames.length;v++)(y=n._frames[v])&&(T||String(y.group)===String(e))&&w.push({type:"byname",name:String(y.name),data:b({name:y.name})});else if(k)for(v=0;v<e.length;v++){var M=e[v];-1!==["number","string"].indexOf(typeof M)?(M=String(M),w.push({type:"byname",name:M,data:b({name:M})})):o.isPlainObject(M)&&w.push({type:"object",data:b(o.extendFlat({},M))})}}else w.push({type:"object",data:b(o.extendFlat({},e))});for(v=0;v<w.length;v++)if("byname"===(y=w[v]).type&&!n._frameHash[y.data.name])return o.warn('animate failure: frame not found: "'+y.data.name+'"'),void u();-1!==["next","immediate"].indexOf(r.mode)&&f(),"reverse"===r.direction&&w.reverse();var A=t._fullLayout._currentFrame;if(A&&r.fromcurrent){var S=-1;for(v=0;v<w.length;v++)if("byname"===(y=w[v]).type&&y.name===A){S=v;break}if(S>0&&S<w.length-1){var E=[];for(v=0;v<w.length;v++)y=w[v],("byname"!==w[v].type||v>S)&&E.push(y);w=E}}w.length>0?p(w):(t.emit('plotly_animated'),a())}))}function Mt(t,e,r){if(t=o.getGraphDiv(t),null===e||void 0===e)return Promise.resolve();if(!o.isPlotDiv(t))throw new Error('This element is not a Plotly plot: '+t+'. It's likely that you've failed to create a plot before adding frames. For more details, see https://plotly.com/javascript/animations/');var n,i,a,s,l=t._transitionData._frames,u=t._transitionData._frameHash;if(!Array.isArray(e))throw new Error("addFrames failure: frameList must be an Array of frame definitions"+e);var f=l.length+2*e.length,p=[],d={};for(n=e.length-1;n>=0;n--)if(o.isPlainObject(e[n])){var m=e[n].name,g=(u[m]||d[m]||{}).name,v=e[n].name,y=u[g]||d[g];g&&v&&"number"===typeof v&&y&&M<A&&(M++,o.warn('addFrames: overwriting frame ''+(u[g]||d[g]).name+'' with a frame whose name of type 'number' also equates to ''+g+''. This is valid but may potentially lead to unexpected behavior since all plotly.js frame names are stored internally as strings.'),M===A&&o.warn('addFrames: This API call has yielded too many of these warnings. For the rest of this call, further warnings about numeric frame names will be suppressed.')),d[m]={name:m},p.push({frame:h.supplyFrameDefaults(e[n]),index:r&&void 0!==r[n]&&null!==r[n]?r[n]:f+n})}p.sort((function(t,e){return t.index>e.index?-1:t.index<e.index?1:0}));var x=[],b=[],_=l.length;for(n=p.length-1;n>=0;n--){if("number"===typeof(i=p[n].frame).name&&o.warn('Warning: addFrames accepts frames with numeric names, but the numbers areimplicitly cast to strings'),!i.name)for(;u[i.name="frame "+t._transitionData._counter++];);if(u[i.name]){for(a=0;a<l.length&&(l[a]||{}).name!==i.name;a++);x.push({type:"replace",index:a,value:i}),b.unshift({type:"replace",index:a,value:l[a]})}else s=Math.max(0,Math.min(p[n].index,_)),x.push({type:"insert",index:s,value:i}),b.unshift({type:"delete",index:s}),_++}var w=h.modifyFrames,T=h.modifyFrames,k=[t,b],S=[t,x];return c&&c.add(t,w,k,T,S),h.modifyFrames(t,x)}function At(t,e){if(t=o.getGraphDiv(t),!o.isPlotDiv(t))throw new Error("This element is not a Plotly plot: "+t);var r,n,i=t._transitionData._frames,a=[],s=[];if(!e)for(e=[],r=0;r<i.length;r++)e.push(r);for((e=e.slice()).sort(),r=e.length-1;r>=0;r--)n=e[r],a.push({type:"delete",index:n}),s.unshift({type:"insert",index:n,value:i[n]});var l=h.modifyFrames,u=h.modifyFrames,f=[t,s],p=[t,a];return c&&c.add(t,l,f,u,p),h.modifyFrames(t,a)}function St(t)[var e=(t=o.getGraphDiv(t))._fullLayout||{],r=t._fullData||[];return h.cleanPlot([],{},r,e),h.purge(t),l.purge(t),e._container&&e._container.remove(),delete t._context,t}function Et(t){var e=t._fullLayout,r=t.getBoundingClientRect();if(!o.equalDomRects(r,e._lastBBox)){var n=e._invTransform=o.inverseTransformMatrix(o.getFullTransformMatrix(t));e._invScaleX=Math.sqrt(n[0][0]*n[0][0]+n[0][1]*n[0][1]+n[0][2]*n[0][2]),e._invScaleY=Math.sqrt(n[1][0]*n[1][0]+n[1][1]*n[1][1]+n[1][2]*n[1][2]),e._lastBBox=r}}function Lt(t){var e=n.select(t),r=t._fullLayout;if(r._calcInverseTransform=Et,r._calcInverseTransform(t),r._container=e.selectAll('.plot-container').data([0]),r._container.enter().insert('div',':first-child').classed('plot-container',!0).classed('plotly',!0),r._paperdiv=r._container.selectAll('.svg-container').data([0]),r._paperdiv.enter().append('div').classed('user-select-none',!0).classed('svg-container',!0).style('position','relative'),r._glcontainer=r._paperdiv.selectAll('.gl-container').data([{}]),r._glcontainer.enter().append('div').classed('gl-container',!0),r._paperdiv.selectAll('.main-svg').remove(),r._paperdiv.select('.modebar-container').remove(),r._paper=r._paperdiv.insert('svg',':first-child').classed('main-svg',!0),r._toppaper=r._paperdiv.append('svg').classed('main-svg',!0),r._modebardiv=r._paperdiv.append('div'),delete r._modeBar,r._hoverpaper=r._paperdiv.append('svg').classed('main-svg',!0),!r._uid)[var i={];n.selectAll('defs').each((function()[this.id&&(i[this.id.split('-')[1]]=1)])),r._uid=o.randstr(i)}r._paperdiv.selectAll('.main-svg').attr(v.svgAttrs),r._defs=r._paper.append('defs').attr('id',"defs-"+r._uid),r._clips=r._defs.append('g').classed('clips',!0),r._topdefs=r._toppaper.append('defs').attr('id',"topdefs-"+r._uid),r._topclips=r._topdefs.append('g').classed('clips',!0),r._bgLayer=r._paper.append('g').classed('bglayer',!0),r._draggers=r._paper.append('g').classed('draglayer',!0);var a=r._paper.append('g').classed('layer-below',!0);r._imageLowerLayer=a.append('g').classed('imagelayer',!0),r._shapeLowerLayer=a.append('g').classed('shapelayer',!0),r._cartesianlayer=r._paper.append('g').classed('cartesianlayer',!0),r._polarlayer=r._paper.append('g').classed('polarlayer',!0),r._ternarylayer=r._paper.append('g').classed('ternarylayer',!0),r._geolayer=r._paper.append('g').classed('geolayer',!0),r._funnelarealayer=r._paper.append('g').classed('funnelarealayer',!0),r._pielayer=r._paper.append('g').classed('pielayer',!0),r._iciclelayer=r._paper.append('g').classed('iciclelayer',!0),r._treemaplayer=r._paper.append('g').classed('treemaplayer',!0),r._sunburstlayer=r._paper.append('g').classed('sunburstlayer',!0),r._indicatorlayer=r._toppaper.append('g').classed('indicatorlayer',!0),r._glimages=r._paper.append('g').classed('glimages',!0);var s=r._toppaper.append('g').classed('layer-above',!0);r._imageUpperLayer=s.append('g').classed('imagelayer',!0),r._shapeUpperLayer=s.append('g').classed('shapelayer',!0),r._infolayer=r._toppaper.append('g').classed('infolayer',!0),r._menulayer=r._toppaper.append('g').classed('menulayer',!0),r._zoomlayer=r._toppaper.append('g').classed('zoomlayer',!0),r._hoverlayer=r._hoverpaper.append('g').classed('hoverlayer',!0),r._modebardiv.classed('modebar-container',!0).style('position','absolute').style('top','0px').style('right','0px'),t.emit('plotly_framework')}r.animate=kt,r.addFrames=Mt,r.deleteFrames=At,r.addTraces=G,r.deleteTraces=Y,r.extendTraces=H,r.moveTraces=W,r.prependTraces=q,r.newPlot=O,r._doPlot=S,r.purge=St,r.react=xt,r.redraw=z,r.relayout=et,r.restyle=X,r.setPlotConfig=L,r.update=ct,r._guiRelayout=ut(et),r._guiRestyle=ut(X),r._guiUpdate=ut(ct),r._storeDirectGUIEdit=Q},{"../components/color":650,"../components/drawing":672,"../constants/xmlns_namespaces":764,"../lib":787,"../lib/events":776,"../lib/queue":803,"../plots/cartesian/axes":838,"../plots/cartesian/constants":845,"../plots/cartesian/graph_interact":848,"../plots/cartesian/select":858,"../plots/plots":901,"../registry":915,"./edit_types":820,"./helpers":821,"./manage_arrays":823,"./plot_config":825,"./plot_schema":826,"./subroutines":828,"@plotly/d3":58,"fast-isnumeric":246,"has-hover":435}],825:[function(t,e,r){"use strict";var n={staticPlot:{valType:"boolean",dflt:!1},plotlyServerURL:{valType:"string",dflt:""},editable:{valType:"boolean",dflt:!1},edits:{annotationPosition:{valType:"boolean",dflt:!1},annotationTail:{valType:"boolean",dflt:!1},annotationText:{valType:"boolean",dflt:!1},axisTitleText:{valType:"boolean",dflt:!1},colorbarPosition:{valType:"boolean",dflt:!1},colorbarTitleText:{valType:"boolean",dflt:!1},legendPosition:{valType:"boolean",dflt:!1},legendText:{valType:"boolean",dflt:!1},shapePosition:{valType:"boolean",dflt:!1},titleText:{valType:"boolean",dflt:!1}},autosizable:{valType:"boolean",dflt:!1},responsive:{valType:"boolean",dflt:!1},fillFrame:{valType:"boolean",dflt:!1},frameMargins:{valType:"number",dflt:0,min:0,max:.5},scrollZoom:{valType:"flaglist",flags:["cartesian",'gl3d','geo',"mapbox"],extras:[!0,!1],dflt:"gl3d+geo+mapbox"},doubleClick:{valType:"enumerated",values:[!1,'reset','autosize',"reset+autosize"],dflt:"reset+autosize"},doubleClickDelay:{valType:"number",dflt:300,min:0},showAxisDragHandles:{valType:"boolean",dflt:!0},showAxisRangeEntryBoxes:{valType:"boolean",dflt:!0},showTips:{valType:"boolean",dflt:!0},showLink:{valType:"boolean",dflt:!1},linkText:{valType:"string",dflt:"Edit chart",noBlank:!0},sendData:{valType:"boolean",dflt:!0},showSources:{valType:"any",dflt:!1},displayModeBar:{valType:"enumerated",values:["hover",!0,!1],dflt:"hover"},showSendToCloud:{valType:"boolean",dflt:!1},showEditInChartStudio:{valType:"boolean",dflt:!1},modeBarButtonsToRemove:{valType:"any",dflt:[]},modeBarButtonsToAdd:{valType:"any",dflt:[]},modeBarButtons:{valType:"any",dflt:!1},toImageButtonOptions:{valType:"any",dflt:{}},displaylogo:{valType:"boolean",dflt:!0},watermark:{valType:"boolean",dflt:!1},plotGlPixelRatio:{valType:"number",dflt:2,min:1,max:4},setBackground:{valType:"any",dflt:"transparent"},topojsonURL:{valType:"string",noBlank:!0,dflt:"https://cdn.plot.ly/"},mapboxAccessToken:{valType:"string",dflt:null},logging:{valType:"integer",min:0,max:2,dflt:1},notifyOnLogging:{valType:"integer",min:0,max:2,dflt:0},queueLength:{valType:"integer",min:0,dflt:0},globalTransforms:{valType:"any",dflt:[]},locale:{valType:"string",dflt:"en-US"},locales:{valType:"any",dflt:{}}},i={};function a(t,e){for(var r in t){var n=t[r];n.valType?e[r]=n.dflt:(e[r]||(e[r]={}),a(n,e[r]))}}a(n,i),e.exports={configAttributes:n,dfltConfig:i}},{}],826:[function(t,e,r){"use strict";var n=t('../registry'),i=t('../lib'),a=t('../plots/attributes'),o=t('../plots/layout_attributes'),s=t('../plots/frame_attributes'),l=t('../plots/animation_attributes'),c=t('./plot_config').configAttributes,u=t('./edit_types'),f=i.extendDeepAll,h=i.isPlainObject,p=i.isArrayOrTypedArray,d=i.nestedProperty,m=i.valObjectMeta,g='_isSubplotObj',v='_isLinkedToArray',y='_deprecated',x=[g,v,'_arrayAttrRegexps',y];function b(t,e){var r,i,a,s,l=t._basePlotModules;if(l){var c;for(r=0;r<l.length;r++){if((a=l[r]).attrRegex&&a.attrRegex.test(e)){if(a.layoutAttrOverrides)return a.layoutAttrOverrides;!c&&a.layoutAttributes&&(c=a.layoutAttributes)}var u=a.baseLayoutAttrOverrides;if(u&&e in u)return u[e]}if(c)return c}var f=t._modules;if(f)for(r=0;r<f.length;r++)if((s=f[r].layoutAttributes)&&e in s)return s[e];for(i in n.componentsRegistry){if("colorscale"===(a=n.componentsRegistry[i]).name&&0===e.indexOf('coloraxis'))return a.layoutAttributes[e];if(!a.schema&&e===a.name)return a.layoutAttributes}return e in o&&o[e]}function _(t,e,r){if(!t)return!1;if(t._isLinkedToArray)if(w(e[r]))r++;else if(r<e.length)return!1;for(;r<e.length;r++){var n=t[e[r]];if(!h(n))break;if(t=n,r===e.length-1)break;if(t._isLinkedToArray){if(!w(e[++r]))return!1}else if("info_array"===t.valType){var i=e[++r];if(!w(i))return!1;var a=t.items;if(Array.isArray(a)){if(i>=a.length)return!1;if(2===t.dimensions){if(r++,e.length===r)return t;var o=e[r];if(!w(o))return!1;t=a[i][o]}else t=a[i]}else t=a}}return t}function w(t){return t===Math.round(t)&&t>=0}function T(t){var e,i;i=(e=n.modules[t]._module).basePlotModule;var o={type:null},s=f({},a),l=f({},e.attributes);r.crawl(l,(function(t,e,r,n,i){d(s,i).set(void 0),void 0===t&&d(l,i).set(void 0)})),f(o,s),n.traceIs(t,'noOpacity')&&delete o.opacity,n.traceIs(t,'showLegend')||(delete o.showlegend,delete o.legendgroup),n.traceIs(t,'noHover')&&(delete o.hoverinfo,delete o.hoverlabel),e.selectPoints||delete o.selectedpoints,f(o,l),i.attributes&&f(o,i.attributes),o.type=t;var c={meta:e.meta||{},categories:e.categories||{},animatable:Boolean(e.animatable),type:t,attributes:S(o)};if(e.layoutAttributes)[var u={];f(u,e.layoutAttributes),c.layoutAttributes=S(u)}return e.animatable||r.crawl(c,(function(t)[r.isValObject(t)&&"anim"in t&&delete t.anim])),c}function k(){var t,e,r={};for(t in f(r,o),n.subplotsRegistry)if((e=n.subplotsRegistry[t]).layoutAttributes)if(Array.isArray(e.attr))for(var i=0;i<e.attr.length;i++)P(r,e,e.attr[i]);else P(r,e,"subplot"===e.attr?e.name:e.attr);for(t in n.componentsRegistry){var a=(e=n.componentsRegistry[t]).schema;if(a&&(a.subplots||a.layout)){var s=a.subplots;if(s&&s.xaxis&&!s.yaxis)for(var l in s.xaxis)delete r.yaxis[l]}else"colorscale"===e.name?f(r,e.layoutAttributes):e.layoutAttributes&&I(r,e.layoutAttributes,e.name)}return{layoutAttributes:S(r)}}function M(t){var e=n.transformsRegistry[t],r=f({},e.attributes);return Object.keys(n.componentsRegistry).forEach((function(e){var i=n.componentsRegistry[e];i.schema&&i.schema.transforms&&i.schema.transforms[t]&&Object.keys(i.schema.transforms[t]).forEach((function(e){I(r,i.schema.transforms[t][e],e)}))})),{attributes:S(r)}}function A(){var t={frames:f({},s)};return S(t),t.frames}function S(t){return E(t),L(t),C(t),t}function E(t){function e(t){return{valType:"string",editType:"none"}}function n(t,n,i){r.isValObject(t)?!0!==t.arrayOk&&"data_array"!==t.valType||(i[n+"src"]=e(n)):h(t)&&(t.role='object')}r.crawl(t,n)}function L(t){function e(t,e,r){if(t){var n=t[v];n&&(delete t[v],r[e]={items:{}},r[e].items[n]=t,r[e].role='object')}}r.crawl(t,e)}function C(t){function e(t){for(var r in t)if(h(t[r]))e(t[r]);else if(Array.isArray(t[r]))for(var n=0;n<t[r].length;n++)e(t[r][n]);else t[r]instanceof RegExp&&(t[r]=t[r].toString())}e(t)}function P(t,e,r){var n=d(t,r),i=f({},e.layoutAttributes);i[g]=!0,n.set(i)}function I(t,e,r){var n=d(t,r);n.set(f(n.get()||{},e))}r.IS_SUBPLOT_OBJ=g,r.IS_LINKED_TO_ARRAY=v,r.DEPRECATED=y,r.UNDERSCORE_ATTRS=x,r.get=function()[var t={];n.allTypes.forEach((function(e)[t[e]=T(e)]));var e={};return Object.keys(n.transformsRegistry).forEach((function(t)[e[t]=M(t)])),{defs:{valObjects:m,metaKeys:x.concat(["description",'role','editType',"impliedEdits"]),editType:{traces:u.traces,layout:u.layout},impliedEdits:{}},traces:t,layout:k(),transforms:e,frames:A(),animation:S(l),config:S(c)}},r.crawl=function(t,e,n,i){var a=n||0;i=i||"",Object.keys(t).forEach((function(n){var o=t[n];if(-1===x.indexOf(n)){var s=(i?i+".":"")+n;e(o,n,t,a,s),r.isValObject(o)||h(o)&&"impliedEdits"!==n&&r.crawl(o,e,a+1,s)}}))},r.isValObject=function(t){return t&&void 0!==t.valType},r.findArrayAttributes=function(t){var e,n,i=[],o=[],s=[];function l(t,r,n,i){o=o.slice(0,i).concat([r]),s=s.slice(0,i).concat([t&&t._isLinkedToArray]),t&&("data_array"===t.valType||!0===t.arrayOk)&&("colorbar"!==o[i-1]||"ticktext"!==r&&"tickvals"!==r)&&c(e,0,'')}function c(t,e,r){var a=t[o[e]],l=r+o[e];if(e===o.length-1)p(a)&&i.push(n+l);else if(s[e]){if(Array.isArray(a))for(var u=0;u<a.length;u++)h(a[u])&&c(a[u],e+1,l+"["+u+"].")}else h(a)&&c(a,e+1,l+".")}e=t,n='',r.crawl(a,l),t._module&&t._module.attributes&&r.crawl(t._module.attributes,l);var u=t.transforms;if(u)for(var f=0;f<u.length;f++){var d=u[f],m=d._module;m&&(n="transforms["+f+"].",e=d,r.crawl(m.attributes,l))}return i},r.getTraceValObject=function(t,e){var r,i,o=e[0],s=1;if("transforms"===o){if(1===e.length)return a.transforms;var l=t.transforms;if(!Array.isArray(l)||!l.length)return!1;var c=e[1];if(!w(c)||c>=l.length)return!1;i=(r=(n.transformsRegistry[l[c].type]||{}).attributes)&&r[e[2]],s=3}else{var u=t._module;if(u||(u=(n.modules[t.type||a.type.dflt]||{})._module),!u)return!1;if(!(i=(r=u.attributes)&&r[o])){var f=u.basePlotModule;f&&f.attributes&&(i=f.attributes[o])}i||(i=a[o])}return _(i,e,s)},r.getLayoutValObject=function(t,e){return _(b(t,e[0]),e,1)}},{"../lib":787,"../plots/animation_attributes":832,"../plots/attributes":834,"../plots/frame_attributes":868,"../plots/layout_attributes":892,"../registry":915,"./edit_types":820,"./plot_config":825}],827:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plots/attributes'),a='templateitemname',o={name:{valType:"string",editType:"none"}};function s(t){return t&&"string"===typeof t}function l(t){var e=t.length-1;return"s"!==t.charAt(e)&&n.warn("bad argument to arrayDefaultKey: "+t),t.substr(0,t.length-1)+"defaults"}o[a]={valType:"string",editType:"calc"},r.templatedArray=function(t,e){return e._isLinkedToArray=t,e.name=o.name,e[a]=o[a],e},r.traceTemplater=function(t){var e,r,a={};for(e in t)r=t[e],Array.isArray(r)&&r.length&&(a[e]=0);function o(o){var s={type:e=n.coerce(o,{},i,'type'),_template:null};if(e in a){r=t[e];var l=a[e]%r.length;a[e]++,s._template=r[l]}return s}return{newTrace:o}},r.newContainer=function(t,e,r){var i=t._template,a=i&&(i[e]||r&&i[r]);return n.isPlainObject(a)||(a=null),t[e]={_template:a}},r.arrayTemplater=function(t,e,r){var n=t._template,i=n&&n[l(e)],o=n&&n[e];Array.isArray(o)&&o.length||(o=[]);var c={};function u(t){var e={name:t.name,_input:t},n=e[a]=t[a];if(!s(n))return e._template=i,e;for(var l=0;l<o.length;l++){var u=o[l];if(u.name===n)return c[n]=1,e._template=u,e}return e[r]=t[r]||!1,e._template=!1,e}function f(){for(var t=[],e=0;e<o.length;e++){var r=o[e],n=r.name;if(s(n)&&!c[n]){var i={_template:r,name:n,_input:{_templateitemname:n}};i[a]=r[a],t.push(i),c[n]=1}}return t}return{newItem:u,defaultItems:f}},r.arrayDefaultKey=l,r.arrayEditor=function(t,e,r){var i=(n.nestedProperty(t,e).get()||[]).length,o=r._index,s=o>=i&&(r._input||{})._templateitemname;s&&(o=i);var l,c=e+"["+o+"]";function u()[l={],s&&(l[c]={},l[c][a]=s)}function f(t,e)[l[t]=e]function h(t,e){s?n.nestedProperty(l[c],t).set(e):l[c+"."+t]=e}function p(){var t=l;return u(),t}function d(e,r){e&&h(e,r);var i=p();for(var a in i)n.nestedProperty(t,a).set(i[a])}return u(),{modifyBase:f,modifyItem:h,getUpdateObj:p,applyUpdate:d}}},{"../lib":787,"../plots/attributes":834}],828:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../registry'),a=t('../plots/plots'),o=t('../lib'),s=t('../lib/clear_gl_canvases'),l=t('../components/color'),c=t('../components/drawing'),u=t('../components/titles'),f=t('../components/modebar'),h=t('../plots/cartesian/axes'),p=t('../constants/alignment'),d=t('../plots/cartesian/constraints'),m=d.enforce,g=d.clean,v=t('../plots/cartesian/autorange').doAutoRange,y='start',x='middle',b='end';function _(t,e,r){for(var n=0;n<r.length;n++){var i=r[n][0],a=r[n][1];if(!(i[0]>=t[1]||i[1]<=t[0])&&a[0]<e[1]&&a[1]>e[0])return!0}return!1}function w(t){var e,i,s,u,d,m,g=t._fullLayout,v=g._size,y=v.p,x=h.list(t,'',!0);if(g._paperdiv.style({width:t._context.responsive&&g.autosize&&!t._context._hasZeroWidth&&!t.layout.width?"100%":g.width+"px",height:t._context.responsive&&g.autosize&&!t._context._hasZeroHeight&&!t.layout.height?"100%":g.height+"px"}).selectAll('.main-svg').call(c.setSize,g.width,g.height),t._context.setBackground(t,g.paper_bgcolor),r.drawMainTitle(t),f.manage(t),!g._has('cartesian'))return a.previousPromises(t);function b(t,e,r){var n=t._lw/2;return"x"===t._id.charAt(0)?e?"top"===r?e._offset-y-n:e._offset+e._length+y+n:v.t+v.h*(1-(t.position||0))+n%1:e?"right"===r?e._offset+e._length+y+n:e._offset-y-n:v.l+v.w*(t.position||0)+n%1}for(e=0;e<x.length;e++){var w=(u=x[e])._anchorAxis;u._linepositions={},u._lw=c.crispRound(t,u.linewidth,1),u._mainLinePosition=b(u,w,u.side),u._mainMirrorPosition=u.mirror&&w?b(u,w,p.OPPOSITE_SIDE[u.side]):null}var k=[],A=[],S=[],E=1===l.opacity(g.paper_bgcolor)&&1===l.opacity(g.plot_bgcolor)&&g.paper_bgcolor===g.plot_bgcolor;for(i in g._plots)if((s=g._plots[i]).mainplot)s.bg&&s.bg.remove(),s.bg=void 0;else{var L=s.xaxis.domain,C=s.yaxis.domain,P=s.plotgroup;if(_(L,C,S)){var I=P.node(),z=s.bg=o.ensureSingle(P,'rect','bg');I.insertBefore(z.node(),I.childNodes[0]),A.push(i)}else P.select('rect.bg').remove(),S.push([L,C]),E||(k.push(i),A.push(i))}var O,D,R,F,B,N,j,U,V,H,q,G,Y,W=g._bgLayer.selectAll('.bg').data(k);for(W.enter().append('rect').classed('bg',!0),W.exit().remove(),W.each((function(t)[g._plots[t].bg=n.select(this)])),e=0;e<A.length;e++)s=g._plots[A[e]],d=s.xaxis,m=s.yaxis,s.bg&&void 0!==d._offset&&void 0!==m._offset&&s.bg.call(c.setRect,d._offset-y,m._offset-y,d._length+2*y,m._length+2*y).call(l.fill,g.plot_bgcolor).style('stroke-width',0);if(!g._hasOnlyLargeSploms)for(i in g._plots){s=g._plots[i],d=s.xaxis,m=s.yaxis;var X,Z,J=s.clipId="clip"+g._uid+i+"plot",K=o.ensureSingleById(g._clips,'clipPath',J,(function(t){t.classed('plotclip',!0).append('rect')}));s.clipRect=K.select('rect').attr({width:d._length,height:m._length}),c.setTranslate(s.plot,d._offset,m._offset),s._hasClipOnAxisFalse?(X=null,Z=J):(X=J,Z=null),c.setClipUrl(s.plot,X,t),s.layerClipId=Z}function Q(t){return"M"+O+","+t+"H"+D}function $(t){return"M"+d._offset+","+t+"h"+d._length}function tt(t){return"M"+t+","+U+"V"+j}function et(t){return"M"+t+","+m._offset+"v"+m._length}function rt(t,e,r){if(!t.showline||i!==t._mainSubplot)return'';if(!t._anchorAxis)return r(t._mainLinePosition);var n=e(t._mainLinePosition);return t.mirror&&(n+=e(t._mainMirrorPosition)),n}for(i in g._plots){s=g._plots[i],d=s.xaxis,m=s.yaxis;var nt='M0,0';T(d,i)&&(B=M(d,'left',m,x),O=d._offset-(B?y+B:0),N=M(d,'right',m,x),D=d._offset+d._length+(N?y+N:0),R=b(d,m,'bottom'),F=b(d,m,'top'),!(Y=!d._anchorAxis||i!==d._mainSubplot)||"allticks"!==d.mirror&&"all"!==d.mirror||(d._linepositions[i]=[R,F]),nt=rt(d,Q,$),Y&&d.showline&&("all"===d.mirror||"allticks"===d.mirror)&&(nt+=Q(R)+Q(F)),s.xlines.style('stroke-width',d._lw+"px").call(l.stroke,d.showline?d.linecolor:"rgba(0,0,0,0)")),s.xlines.attr('d',nt);var it='M0,0';T(m,i)&&(q=M(m,'bottom',d,x),j=m._offset+m._length+(q?y:0),G=M(m,'top',d,x),U=m._offset-(G?y:0),V=b(m,d,'left'),H=b(m,d,'right'),!(Y=!m._anchorAxis||i!==m._mainSubplot)||"allticks"!==m.mirror&&"all"!==m.mirror||(m._linepositions[i]=[V,H]),it=rt(m,tt,et),Y&&m.showline&&("all"===m.mirror||"allticks"===m.mirror)&&(it+=tt(V)+tt(H)),s.ylines.style('stroke-width',m._lw+"px").call(l.stroke,m.showline?m.linecolor:"rgba(0,0,0,0)")),s.ylines.attr('d',it)}return h.makeClipPaths(t),a.previousPromises(t)}function T(t,e){return(t.ticks||t.showline)&&(e===t._mainSubplot||"all"===t.mirror||"allticks"===t.mirror)}function k(t,e,r){if(!r.showline||!r._lw)return!1;if("all"===r.mirror||"allticks"===r.mirror)return!0;var n=r._anchorAxis;if(!n)return!1;var i=p.FROM_BL[e];return r.side===e?n.domain[i]===t.domain[i]:r.mirror&&n.domain[1-i]===t.domain[1-i]}function M(t,e,r,n){if(k(t,e,r))return r._lw;for(var i=0;i<n.length;i++){var a=n[i];if(a._mainAxis===r._mainAxis&&k(t,e,a))return a._lw}return 0}function A(t,e){var r=t.title,n=t._size,i=0;return e===y?i=r.pad.l:e===b&&(i=-r.pad.r),"paper"===r.xref?n.l+n.w*r.x+i:t.width*r.x+i}function S(t,e){var r=t.title,n=t._size,i=0;return"0em"!==e&&e?e===p.CAP_SHIFT+"em"&&(i=r.pad.t):i=-r.pad.b,"auto"===r.y?n.t/2:"paper"===r.yref?n.t+n.h-n.h*r.y+i:t.height-t.height*r.y+i}function E(t){var e=t.title,r=x;return o.isRightAnchor(e)?r=b:o.isLeftAnchor(e)&&(r=y),r}function L(t){var e=t.title,r='0em';return o.isTopAnchor(e)?r=p.CAP_SHIFT+"em":o.isMiddleAnchor(e)&&(r=p.MID_SHIFT+"em"),r}r.layoutStyles=function(t){return o.syncOrAsync([a.doAutoMargin,w],t)},r.drawMainTitle=function(t){var e=t._fullLayout,r=E(e),n=L(e);u.draw(t,'gtitle',{propContainer:e,propName:"title.text",placeholder:e._dfltTitle.plot,attributes:{x:A(e,r),y:S(e,n),"text-anchor":r,dy:n}})},r.doTraceStyle=function(t){var e,n=t.calcdata,o=[];for(e=0;e<n.length;e++){var l=n[e],c=l[0]||{},u=c.trace||{},f=u._module||{},h=f.arraysToCalcdata;h&&h(l,u);var p=f.editStyle;p&&o.push({fn:p,cd0:c})}if(o.length){for(e=0;e<o.length;e++){var d=o[e];d.fn(t,d.cd0)}s(t),r.redrawReglTraces(t)}return a.style(t),i.getComponentMethod('legend','draw')(t),a.previousPromises(t)},r.doColorBars=function(t){return i.getComponentMethod('colorbar','draw')(t),a.previousPromises(t)},r.layoutReplot=function(t){var e=t.layout;return t.layout=void 0,i.call('_doPlot',t,'',e)},r.doLegend=function(t){return i.getComponentMethod('legend','draw')(t),a.previousPromises(t)},r.doTicksRelayout=function(t){return h.draw(t,'redraw'),t._fullLayout._hasOnlyLargeSploms&&(i.subplotsRegistry.splom.updateGrid(t),s(t),r.redrawReglTraces(t)),r.drawMainTitle(t),a.previousPromises(t)},r.doModeBar=function(t){var e=t._fullLayout;f.manage(t);for(var r=0;r<e._basePlotModules.length;r++){var n=e._basePlotModules[r].updateFx;n&&n(t)}return a.previousPromises(t)},r.doCamera=function(t){for(var e=t._fullLayout,r=e._subplots.gl3d,n=0;n<r.length;n++){var i=e[r[n]];i._scene.setViewport(i)}},r.drawData=function(t){var e=t._fullLayout;s(t);for(var n=e._basePlotModules,o=0;o<n.length;o++)n[o].plot(t);return r.redrawReglTraces(t),a.style(t),i.getComponentMethod('shapes','draw')(t),i.getComponentMethod('annotations','draw')(t),i.getComponentMethod('images','draw')(t),e._replotting=!1,a.previousPromises(t)},r.redrawReglTraces=function(t){var e=t._fullLayout;if(e._has('regl')){var r,n,i=t._fullData,a=[],s=[];for(e._hasOnlyLargeSploms&&e._splomGrid.draw(),r=0;r<i.length;r++){var l=i[r];!0===l.visible&&0!==l._length&&("splom"===l.type?e._splomScenes[l.uid].draw():"scattergl"===l.type?o.pushUnique(a,l.xaxis+l.yaxis):"scatterpolargl"===l.type&&o.pushUnique(s,l.subplot))}for(r=0;r<a.length;r++)(n=e._plots[a[r]])._scene&&n._scene.draw();for(r=0;r<s.length;r++)(n=e[s[r]]._subplot)._scene&&n._scene.draw()}},r.doAutoRangeAndConstraints=function(t){for(var e,r=h.list(t,'',!0),n={},i=0;i<r.length;i++)if(!n[(e=r[i])._id]){n[e._id]=1,g(t,e),v(t,e);var a=e._matchGroup;if(a)for(var o in a){var s=h.getFromId(t,o);v(t,s,e.range),n[o]=1}}m(t)},r.finalDraw=function(t){i.getComponentMethod('rangeslider','draw')(t),i.getComponentMethod('rangeselector','draw')(t)},r.drawMarginPushers=function(t){i.getComponentMethod('legend','draw')(t),i.getComponentMethod('rangeselector','draw')(t),i.getComponentMethod('sliders','draw')(t),i.getComponentMethod('updatemenus','draw')(t),i.getComponentMethod('colorbar','draw')(t)}},{"../components/color":650,"../components/drawing":672,"../components/modebar":713,"../components/titles":748,"../constants/alignment":755,"../lib":787,"../lib/clear_gl_canvases":771,"../plots/cartesian/autorange":837,"../plots/cartesian/axes":838,"../plots/cartesian/constraints":846,"../plots/plots":901,"../registry":915,"@plotly/d3":58}],829:[function(t,e,r){"use strict";var n=t('../lib'),i=n.isPlainObject,a=t('./plot_schema'),o=t('../plots/plots'),s=t('../plots/attributes'),l=t('./plot_template'),c=t('./plot_config').dfltConfig;function u(t,e){t=n.extendDeep({},t);var r,a,o=Object.keys(t).sort();function s(e,r,n){if(i(r)&&i(e))u(e,r);else if(Array.isArray(r)&&Array.isArray(e)){var o=l.arrayTemplater({_template:t},n);for(a=0;a<r.length;a++){var s=r[a],c=o.newItem(s)._template;c&&u(c,s)}var f=o.defaultItems();for(a=0;a<f.length;a++)r.push(f[a]._template);for(a=0;a<r.length;a++)delete r[a].templateitemname}}for(r=0;r<o.length;r++){var c=o[r],h=t[c];if(c in e?s(h,e[c],c):e[c]=h,f(c)===c)for(var p in e){var d=f(p);p===d||d!==c||p in t||s(h,e[p],c)}}}function f(t){return t.replace(/[0-9]+$/,'')}function h(t,e,r,a,o){var s=o&&r(o);for(var c in t){var u=t[c],p=m(t,c,a),d=m(t,c,o),g=r(d);if(!g){var v=f(c);v!==c&&(g=r(d=m(t,v,o)))}if((!s||s!==g)&&!(!g||g._noTemplating||"data_array"===g.valType||g.arrayOk&&Array.isArray(u)))if(!g.valType&&i(u))h(u,e,r,p,d);else if(g._isLinkedToArray&&Array.isArray(u))for(var y=!1,x=0,b={},_=0;_<u.length;_++){var w=u[_];if(i(w)){var T=w.name;if(T)b[T]||(h(w,e,r,m(u,x,p),m(u,x,d)),x++,b[T]=1);else if(!y){var k=m(t,l.arrayDefaultKey(c),a),M=m(u,x,p);h(w,e,r,M,m(u,x,d));var A=n.nestedProperty(e,M);n.nestedProperty(e,k).set(A.get()),A.set(null),y=!0}}}else n.nestedProperty(e,p).set(u)}}function p(t,e){return a.getLayoutValObject(t,n.nestedProperty({},e).parts)}function d(t,e){return a.getTraceValObject(t,n.nestedProperty({},e).parts)}function m(t,e,r){return r?Array.isArray(t)?r+"["+e+"]":r+"."+e:e}function g(t){for(var e=0;e<t.length;e++)if(i(t[e]))return!0}function v(t){var e;switch(t.code){case"data":e='The template has no key data.';break;case"layout":e='The template has no key layout.';break;case"missing":e=t.path?"There are no templates for item '+t.path+' with name "+t.templateitemname:"There are no templates for trace '+t.index+', of type '+t.traceType+'.";break;case"unused":e=t.path?"The template item at '+t.path+' was not used in constructing the plot.":t.dataCount?"Some of the templates of type '+t.traceType+' were not used. The template has '+t.templateCount+' traces, the data only has '+t.dataCount+' of this type.":"The template has '+t.templateCount+' traces of type '+t.traceType+' but there are none in the data.";break;case"reused":e="Some of the templates of type '+t.traceType+' were used more than once. The template has '+t.templateCount+' traces, the data has '+t.dataCount+' of this type."}return t.msg=e,t}r.makeTemplate=function(t){t=n.isPlainObject(t)?t:n.getGraphDiv(t),t=n.extendDeep({_context:c},{data:t.data,layout:t.layout}),o.supplyDefaults(t);var e=t.data||[],r=t.layout||{};r._basePlotModules=t._fullLayout._basePlotModules,r._modules=t._fullLayout._modules;var a={data:{},layout:{}};e.forEach((function(t)[var e={];h(t,e,d.bind(null,t));var r=n.coerce(t,{},s,'type'),i=a.data[r];i||(i=a.data[r]=[]),i.push(e)})),h(r,a.layout,p.bind(null,r)),delete a.layout.template;var l=r.template;if(i(l)){var f,m,g,v,y,x,b=l.layout;i(b)&&u(b,a.layout);var _=l.data;if(i(_)){for(m in a.data)if(g=_[m],Array.isArray(g)){for(x=(y=a.data[m]).length,v=g.length,f=0;f<x;f++)u(g[f%v],y[f]);for(f=x;f<v;f++)y.push(n.extendDeep({},g[f]))}for(m in _)m in a.data||(a.data[m]=n.extendDeep([],_[m]))}}return a},r.validateTemplate=function(t,e)[var r=n.extendDeep({],{_context:c,data:t.data,layout:t.layout}),a=r.layout||{};i(e)||(e=a.template||{});var s=e.layout,l=e.data,u=[];r.layout=a,r.layout.template=e,o.supplyDefaults(r);var h=r._fullLayout,p=r._fullData,d={};function y(t,e){for(var r in t)if("_"!==r.charAt(0)&&i(t[r])){var n,a=f(r),o=[];for(n=0;n<e.length;n++)o.push(m(t,r,e[n])),a!==r&&o.push(m(t,a,e[n]));for(n=0;n<o.length;n++)d[o[n]]=1;y(t[r],o)}}function x(t,e){for(var r in t)if(-1===r.indexOf('defaults')&&i(t[r])){var n=m(t,r,e);d[n]?x(t[r],n):u.push({code:"unused",path:n})}}if(i(s)?(y(h,["layout"]),x(s,'layout')):u.push({code:"layout"}),i(l)){for(var b,_={},w=0;w<p.length;w++){var T=p[w];_[b=T.type]=(_[b]||0)+1,T._fullInput._template||u.push({code:"missing",index:T._fullInput.index,traceType:b})}for(b in l){var k=l[b].length,M=_[b]||0;k>M?u.push({code:"unused",traceType:b,templateCount:k,dataCount:M}):M>k&&u.push({code:"reused",traceType:b,templateCount:k,dataCount:M})}}else u.push({code:"data"});function A(t,e){for(var r in t)if("_"!==r.charAt(0)){var n=t[r],a=m(t,r,e);i(n)?(Array.isArray(t)&&!1===n._template&&n.templateitemname&&u.push({code:"missing",path:a,templateitemname:n.templateitemname}),A(n,a)):Array.isArray(n)&&g(n)&&A(n,a)}}if(A({data:p,layout:h},''),u.length)return u.map(v)}},{"../lib":787,"../plots/attributes":834,"../plots/plots":901,"./plot_config":825,"./plot_schema":826,"./plot_template":827}],830:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('./plot_api'),a=t('../plots/plots'),o=t('../lib'),s=t('../snapshot/helpers'),l=t('../snapshot/tosvg'),c=t('../snapshot/svgtoimg'),u=t('../version').version,f={format:{valType:"enumerated",values:["png",'jpeg','webp','svg',"full-json"],dflt:"png"},width:{valType:"number",min:1},height:{valType:"number",min:1},scale:{valType:"number",min:0,dflt:1},setBackground:{valType:"any",dflt:!1},imageDataOnly:{valType:"boolean",dflt:!1}};function h(t,e){var r,h,p,d;function m(t){return!(t in e)||o.validate(e[t],f[t])}if(e=e||{},o.isPlainObject(t)?(r=t.data||[],h=t.layout||{},p=t.config||{},d={}):(t=o.getGraphDiv(t),r=o.extendDeep([],t.data),h=o.extendDeep({},t.layout),p=t._context,d=t._fullLayout||{}),!m('width')&&null!==e.width||!m('height')&&null!==e.height)throw new Error('Height and width should be pixel values.');if(!m('format'))throw new Error('Export format is not '+o.join2(f.format.values,', ',' or ')+'.');var g={};function v(t,r){return o.coerce(e,g,f,t,r)}var y=v('format'),x=v('width'),b=v('height'),_=v('scale'),w=v('setBackground'),T=v('imageDataOnly'),k=document.createElement('div');k.style.position='absolute',k.style.left='-5000px',document.body.appendChild(k);var M=o.extendFlat({},h);x?M.width=x:null===e.width&&n(d.width)&&(M.width=d.width),b?M.height=b:null===e.height&&n(d.height)&&(M.height=d.height);var A=o.extendFlat({},p,{_exportedPlot:!0,staticPlot:!0,setBackground:w}),S=s.getRedrawFunc(k);function E(){return new Promise((function(t){setTimeout(t,s.getDelay(k._fullLayout))}))}function L(){return new Promise((function(t,e){var r=l(k,y,_),n=k._fullLayout.width,f=k._fullLayout.height;function h(){i.purge(k),document.body.removeChild(k)}if("full-json"===y){var p=a.graphJson(k,!1,'keepdata','object',!0,!0);return p.version=u,p=JSON.stringify(p),h(),t(T?p:s.encodeJSON(p))}if(h(),"svg"===y)return t(T?r:s.encodeSVG(r));var d=document.createElement('canvas');d.id=o.randstr(),c({format:y,width:n,height:f,scale:_,canvas:d,svg:r,promise:!0}).then(t).catch(e)}))}function C(t){return T?t.replace(s.IMAGE_URL_PREFIX,''):t}return new Promise((function(t,e){i.newPlot(k,r,M,A).then(S).then(E).then(L).then((function(e){t(C(e))})).catch((function(t)[e(t)]))}))}e.exports=h},{"../lib":787,"../plots/plots":901,"../snapshot/helpers":919,"../snapshot/svgtoimg":921,"../snapshot/tosvg":923,"../version":1388,"./plot_api":824,"fast-isnumeric":246}],831:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plots/plots'),a=t('./plot_schema'),o=t('./plot_config').dfltConfig,s=n.isPlainObject,l=Array.isArray,c=n.isArrayOrTypedArray;function u(t,e,r,i,a,o){o=o||[];for(var f=Object.keys(t),h=0;h<f.length;h++){var p=f[h];if("transforms"!==p){var v=o.slice();v.push(p);var y=t[p],x=e[p],b=g(r,p),_=(b||{}).valType,w="info_array"===_,T="colorscale"===_,k=(b||{}).items;if(m(r,p))if(s(y)&&s(x)&&"any"!==_)u(y,x,b,i,a,v);else if(w&&l(y)){y.length>x.length&&i.push(d('unused',a,v.concat(x.length)));var M,A,S,E,L,C=x.length,P=Array.isArray(k);if(P&&(C=Math.min(C,k.length)),2===b.dimensions)for(A=0;A<C;A++)if(l(y[A])){y[A].length>x[A].length&&i.push(d('unused',a,v.concat(A,x[A].length)));var I=x[A].length;for(M=0;M<(P?Math.min(I,k[A].length):I);M++)S=P?k[A][M]:k,E=y[A][M],L=x[A][M],n.validate(E,S)?L!==E&&L!==+E&&i.push(d('dynamic',a,v.concat(A,M),E,L)):i.push(d('value',a,v.concat(A,M),E))}else i.push(d('array',a,v.concat(A),y[A]));else for(A=0;A<C;A++)S=P?k[A]:k,E=y[A],L=x[A],n.validate(E,S)?L!==E&&L!==+E&&i.push(d('dynamic',a,v.concat(A),E,L)):i.push(d('value',a,v.concat(A),E))}else if(b.items&&!w&&l(y)){var z,O,D=k[Object.keys(k)[0]],R=[];for(z=0;z<x.length;z++){var F=x[z]._index||z;if((O=v.slice()).push(F),s(y[F])&&s(x[z])){R.push(F);var B=y[F],N=x[z];s(B)&&!1!==B.visible&&!1===N.visible?i.push(d('invisible',a,O)):u(B,N,D,i,a,O)}}for(z=0;z<y.length;z++)(O=v.slice()).push(z),s(y[z])?-1===R.indexOf(z)&&i.push(d('unused',a,O)):i.push(d('object',a,O,y[z]))}else!s(y)&&s(x)?i.push(d('object',a,v,y)):c(y)||!c(x)||w||T?p in e?n.validate(y,b)?"enumerated"===b.valType&&(b.coerceNumber&&y!==+x||y!==x)&&i.push(d('dynamic',a,v,y,x)):i.push(d('value',a,v,y)):i.push(d('unused',a,v,y)):i.push(d('array',a,v,y));else i.push(d('schema',a,v))}}return i}function f(t,e){for(var r=t.layout.layoutAttributes,i=0;i<e.length;i++){var a=e[i],o=t.traces[a.type],s=o.layoutAttributes;s&&(a.subplot?n.extendFlat(r[o.attributes.subplot.dflt],s):n.extendFlat(r,s))}return r}e.exports=function(t,e){void 0===t&&(t=[]),void 0===e&&(e={});var r,c,h=a.get(),p=[],m={_context:n.extendFlat({},o)};l(t)?(m.data=n.extendDeep([],t),r=t):(m.data=[],r=[],p.push(d('array','data'))),s(e)?(m.layout=n.extendDeep({},e),c=e):(m.layout={},c={},arguments.length>1&&p.push(d('object','layout'))),i.supplyDefaults(m);for(var g=m._fullData,v=r.length,y=0;y<v;y++){var x=r[y],b=["data",y];if(s(x)){var _=g[y],w=_.type,T=h.traces[w].attributes;T.type={valType:"enumerated",values:[w]},!1===_.visible&&!1!==x.visible&&p.push(d('invisible',b)),u(x,_,T,p,b);var k=x.transforms,M=_.transforms;if(k){l(k)||p.push(d('array',b,["transforms"])),b.push('transforms');for(var A=0;A<k.length;A++){var S=["transforms",A],E=k[A].type;if(s(k[A])){var L=h.transforms[E]?h.transforms[E].attributes:{};L.type={valType:"enumerated",values:Object.keys(h.transforms)},u(k[A],M[A],L,p,b,S)}else p.push(d('object',b,S))}}}else p.push(d('object',b))}return u(c,m._fullLayout,f(h,g),p,'layout'),0===p.length?void 0:p};var h={object:function(t,e){return("layout"===t&&""===e?"The layout argument":"data"===t[0]&&""===e?"Trace '+t[1]+' in the data argument":p(t)+"key '+e)+' must be linked to an object container"},array:function(t,e){return("data"===t?"The data argument":p(t)+"key '+e)+' must be linked to an array container"},schema:function(t,e){return p(t)+"key '+e+' is not part of the schema"},unused:function(t,e,r){var n=s(r)?"container":"key";return p(t)+n+" '+e+' did not get coerced"},dynamic:function(t,e,r,n){return[p(t)+"key",e,"(set to '"+r+"')",'got reset to',"'"+n+"'","during defaults."].join(' ')},invisible:function(t,e){return(e?p(t)+"item "+e:"Trace '+t[1])+' got defaulted to be not visible"},value:function(t,e,r){return[p(t)+"key "+e,"is set to an invalid value ('+r+')"].join(' ')}};function p(t){return l(t)?"In data trace '+t[1]+', ":"In '+t+', "}function d(t,e,r,i,a){var o,s;r=r||"",l(e)?(o=e[0],s=e[1]):(o=e,s=null);var c=x(r),u=h[t](e,c,i,a);return n.log(u),{code:t,container:o,trace:s,path:r,astr:c,msg:u}}function m(t,e){var r=y(e),n=r.keyMinusId,i=r.id;return!!(n in t&&t[n]._isSubplotObj&&i)||e in t}function g(t,e){return e in t?t[e]:t[y(e).keyMinusId]}var v=n.counterRegex('([a-z]+)');function y(t){var e=t.match(v);return{keyMinusId:e&&e[1],id:e&&e[2]}}function x(t){if(!l(t))return String(t);for(var e='',r=0;r<t.length;r++){var n=t[r];"number"===typeof n?e=e.substr(0,e.length-1)+"["+n+"]":e+=n,r<t.length-1&&(e+='.')}return e}},{"../lib":787,"../plots/plots":901,"./plot_config":825,"./plot_schema":826}],832:[function(t,e,r){"use strict";e.exports={mode:{valType:"enumerated",dflt:"afterall",values:["immediate",'next',"afterall"]},direction:{valType:"enumerated",values:["forward","reverse"],dflt:"forward"},fromcurrent:{valType:"boolean",dflt:!1},frame:{duration:{valType:"number",min:0,dflt:500},redraw:{valType:"boolean",dflt:!0}},transition:{duration:{valType:"number",min:0,dflt:500,editType:"none"},easing:{valType:"enumerated",dflt:"cubic-in-out",values:["linear",'quad','cubic','sin','exp','circle','elastic','back','bounce','linear-in','quad-in','cubic-in','sin-in','exp-in','circle-in','elastic-in','back-in','bounce-in','linear-out','quad-out','cubic-out','sin-out','exp-out','circle-out','elastic-out','back-out','bounce-out','linear-in-out','quad-in-out','cubic-in-out','sin-in-out','exp-in-out','circle-in-out','elastic-in-out','back-in-out',"bounce-in-out"],editType:"none"},ordering:{valType:"enumerated",values:["layout first","traces first"],dflt:"layout first",editType:"none"}}}},{}],833:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plot_api/plot_template');e.exports=function(t,e,r){var a,o,s=r.name,l=r.inclusionAttr||"visible",c=e[s],u=n.isArrayOrTypedArray(t[s])?t[s]:[],f=e[s]=[],h=i.arrayTemplater(e,s,l);for(a=0;a<u.length;a++){var p=u[a];n.isPlainObject(p)?o=h.newItem(p):(o=h.newItem({}))[l]=!1,o._index=a,!1!==o[l]&&r.handleItemDefaults(p,o,e,r),f.push(o)}var d=h.defaultItems();for(a=0;a<d.length;a++)(o=d[a])._index=f.length,r.handleItemDefaults({},o,e,r,{}),f.push(o);if(n.isArrayOrTypedArray(c)){var m=Math.min(c.length,f.length);for(a=0;a<m;a++)n.relinkPrivateKeys(f[a],c[a])}return f}},{"../lib":787,"../plot_api/plot_template":827}],834:[function(t,e,r){"use strict";var n=t('./font_attributes'),i=t('../components/fx/attributes');e.exports={type:{valType:"enumerated",values:[],dflt:"scatter",editType:"calc+clearAxisTypes",_noTemplating:!0},visible:{valType:"enumerated",values:[!0,!1,"legendonly"],dflt:!0,editType:"calc"},showlegend:{valType:"boolean",dflt:!0,editType:"style"},legendgroup:{valType:"string",dflt:"",editType:"style"},legendgrouptitle:{text:{valType:"string",dflt:"",editType:"style"},font:n({editType:"style"}),editType:"style"},legendrank:{valType:"number",dflt:1e3,editType:"style"},opacity:{valType:"number",min:0,max:1,dflt:1,editType:"style"},name:{valType:"string",editType:"style"},uid:{valType:"string",editType:"plot",anim:!0},ids:{valType:"data_array",editType:"calc",anim:!0},customdata:{valType:"data_array",editType:"calc"},meta:{valType:"any",arrayOk:!0,editType:"plot"},selectedpoints:{valType:"any",editType:"calc"},hoverinfo:{valType:"flaglist",flags:["x",'y','z','text',"name"],extras:["all",'none',"skip"],arrayOk:!0,dflt:"all",editType:"none"},hoverlabel:i.hoverlabel,stream:{token:{valType:"string",noBlank:!0,strict:!0,editType:"calc"},maxpoints:{valType:"number",min:0,max:1e4,dflt:500,editType:"calc"},editType:"calc"},transforms:{_isLinkedToArray:"transform",editType:"calc"},uirevision:{valType:"any",editType:"none"}}},{"../components/fx/attributes":681,"./font_attributes":867}],835:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=i.dateTime2ms,o=i.incrementMonth,s=t('../../constants/numerical').ONEAVGMONTH;e.exports=function(t,e,r,i){if("date"!==e.type)return{vals:i};var l=t[r+"periodalignment"];if(!l)return{vals:i};var c,u=t[r+"period"];if(n(u)){if((u=+u)<=0)return{vals:i}}else if("string"===typeof u&&"M"===u.charAt(0)){var f=+u.substring(1);if(!(f>0&&Math.round(f)===f))return{vals:i};c=f}for(var h=e.calendar,p="start"===l,d="end"===l,m=t[r+"period0"],g=a(m,h)||0,v=[],y=[],x=[],b=i.length,_=0;_<b;_++){var w,T,k,M=i[_];if(c){for(w=Math.round((M-g)/(c*s)),k=o(g,c*w,h);k>M;)k=o(k,-c,h);for(;k<=M;)k=o(k,c,h);T=o(k,-c,h)}else{for(k=g+(w=Math.round((M-g)/u))*u;k>M;)k-=u;for(;k<=M;)k+=u;T=k-u}v[_]=p?T:d?k:(T+k)/2,y[_]=T,x[_]=k}return{vals:v,starts:y,ends:x}}},{"../../constants/numerical":763,"../../lib":787,"fast-isnumeric":246}],836:[function(t,e,r){"use strict";e.exports={xaxis:{valType:"subplotid",dflt:"x",editType:"calc+clearAxisTypes"},yaxis:{valType:"subplotid",dflt:"y",editType:"calc+clearAxisTypes"}}},{}],837:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../../lib'),o=t('../../constants/numerical').FP_SAFE,s=t('../../registry'),l=t('../../components/drawing'),c=t('./axis_ids'),u=c.getFromId,f=c.isLinked;function h(t,e){var r,n,i=[],o=t._fullLayout,s=d(o,e,0),l=d(o,e,1),c=v(t,e),u=c.min,f=c.max;if(0===u.length||0===f.length)return a.simpleMap(e.range,e.r2l);var h=u[0].val,m=f[0].val;for(r=1;r<u.length&&h===m;r++)h=Math.min(h,u[r].val);for(r=1;r<f.length&&h===m;r++)m=Math.max(m,f[r].val);var g=!1;if(e.range){var y=a.simpleMap(e.range,e.r2l);g=y[1]<y[0]}"reversed"===e.autorange&&(g=!0,e.autorange=!0);var x,b,_,w,T,k,M=e.rangemode,A="tozero"===M,S="nonnegative"===M,E=e._length,L=E/10,C=0;for(r=0;r<u.length;r++)for(x=u[r],n=0;n<f.length;n++)(k=(b=f[n]).val-x.val-p(e,x.val,b.val))>0&&((T=E-s(x)-l(b))>L?k/T>C&&(_=x,w=b,C=k/T):k/E>C&&(_={val:x.val,nopad:1},w={val:b.val,nopad:1},C=k/E));function P(t,e){return Math.max(t,l(e))}if(h===m){var I=h-1,z=h+1;if(A)if(0===h)i=[0,1];else{var O=(h>0?f:u).reduce(P,0),D=h/(1-Math.min(.5,O/E));i=h>0?[0,D]:[D,0]}else i=S?[Math.max(0,I),Math.max(1,z)]:[I,z]}else A?(_.val>=0&&(_={val:0,nopad:1}),w.val<=0&&(w={val:0,nopad:1})):S&&(_.val-C*s(_)<0&&(_={val:0,nopad:1}),w.val<=0&&(w={val:1,nopad:1})),C=(w.val-_.val-p(e,x.val,b.val))/(E-s(_)-l(w)),i=[_.val-C*s(_),w.val+C*l(w)];return g&&i.reverse(),a.simpleMap(i,e.l2r||Number)}function p(t,e,r){var n=0;if(t.rangebreaks)for(var i=t.locateBreaks(e,r),a=0;a<i.length;a++){var o=i[a];n+=o.max-o.min}return n}function d(t,e,r){var n=.05*e._length,i=e._anchorAxis||{};if(-1!==(e.ticklabelposition||"").indexOf('inside')||-1!==(i.ticklabelposition||"").indexOf('inside')){var o="reversed"===e.autorange;if(!o){var s=a.simpleMap(e.range,e.r2l);o=s[1]<s[0]}o&&(r=!r)}var l=0;return f(t,e._id)||(l=g(t,e,r)),n=Math.max(l,n),"domain"===e.constrain&&e._inputDomain&&(n*=(e._inputDomain[1]-e._inputDomain[0])/(e.domain[1]-e.domain[0])),function(t){return t.nopad?0:t.pad+(t.extrapad?n:l)}}e.exports={getAutoRange:h,makePadFn:d,doAutoRange:y,findExtremes:x,concatExtremes:v};var m=3;function g(t,e,r){var i=0,o="x"===e._id.charAt(0);for(var s in t._plots){var c=t._plots[s];if(e._id===c.xaxis._id||e._id===c.yaxis._id){var u=(o?c.yaxis:c.xaxis)||{};if(-1!==(u.ticklabelposition||"").indexOf('inside')&&(!r&&("left"===u.side||"bottom"===u.side)||r&&("top"===u.side||"right"===u.side))){if(u._vals){var f=a.deg2rad(u._tickAngles[u._id+"tick"]||0),h=Math.abs(Math.cos(f)),p=Math.abs(Math.sin(f));if(!u._vals[0].bb){var d=u._id+"tick";u._selections[d].each((function(t){var e=n.select(this);e.select('.text-math-group').empty()&&(t.bb=l.bBox(e.node()))}))}for(var g=0;g<u._vals.length;g++){var v=u._vals[g].bb;if(v){var y=2*m+v.width,x=2*m+v.height;i=Math.max(i,o?Math.max(y*h,x*p):Math.max(x*h,y*p))}}}"inside"===u.ticks&&"inside"===u.ticklabelposition&&(i+=u.ticklen||0)}}}return i}function v(t,e,r){var n,i,a,o=e._id,s=t._fullData,l=t._fullLayout,c=[],f=[];function h(t,e){for(n=0;n<e.length;n++){var r=t[e[n]],s=(r._extremes||{})[o];if(!0===r.visible&&s){for(i=0;i<s.min.length;i++)a=s.min[i],b(c,a.val,a.pad,{extrapad:a.extrapad});for(i=0;i<s.max.length;i++)a=s.max[i],_(f,a.val,a.pad,{extrapad:a.extrapad})}}}if(h(s,e._traceIndices),h(l.annotations||[],e._annIndices||[]),h(l.shapes||[],e._shapeIndices||[]),e._matchGroup&&!r)for(var p in e._matchGroup)if(p!==e._id){var d=u(t,p),m=v(t,d,!0),g=e._length/d._length;for(i=0;i<m.min.length;i++)a=m.min[i],b(c,a.val,a.pad*g,{extrapad:a.extrapad});for(i=0;i<m.max.length;i++)a=m.max[i],_(f,a.val,a.pad*g,{extrapad:a.extrapad})}return{min:c,max:f}}function y(t,e,r){if(e.setScale(),e.autorange){e.range=r?r.slice():h(t,e),e._r=e.range.slice(),e._rl=a.simpleMap(e._r,e.r2l);var n=e._input,i={};i[e._attr+".range"]=e.range,i[e._attr+".autorange"]=e.autorange,s.call('_storeDirectGUIEdit',t.layout,t._fullLayout._preGUI,i),n.range=e.range.slice(),n.autorange=e.autorange}var o=e._anchorAxis;if(o&&o.rangeslider){var l=o.rangeslider[e._name];l&&"auto"===l.rangemode&&(l.range=h(t,e)),o._input.rangeslider[e._name]=a.extendFlat({},l)}}function x(t,e,r)[r||(r={]),t._m||t.setScale();var n,a,s,l,c,u,f,h,p,d=[],m=[],g=e.length,v=r.padded||!1,y=r.tozero&&("linear"===t.type||"-"===t.type),x="log"===t.type,w=!1,k=r.vpadLinearized||!1;function M(t){if(Array.isArray(t))return w=!0,function(e){return Math.max(Number(t[e]||0),0)};var e=Math.max(Number(t||0),0);return function(){return e}}var A=M((t._m>0?r.ppadplus:r.ppadminus)||r.ppad||0),S=M((t._m>0?r.ppadminus:r.ppadplus)||r.ppad||0),E=M(r.vpadplus||r.vpad),L=M(r.vpadminus||r.vpad);if(!w){if(h=1/0,p=-1/0,x)for(n=0;n<g;n++)(a=e[n])<h&&a>0&&(h=a),a>p&&a<o&&(p=a);else for(n=0;n<g;n++)(a=e[n])<h&&a>-o&&(h=a),a>p&&a<o&&(p=a);e=[h,p],g=2}var C={tozero:y,extrapad:v};function P(r){s=e[r],i(s)&&(u=A(r),f=S(r),k?(l=t.c2l(s)-L(r),c=t.c2l(s)+E(r)):(h=s-L(r),p=s+E(r),x&&h<p/10&&(h=p/10),l=t.c2l(h),c=t.c2l(p)),y&&(l=Math.min(0,l),c=Math.max(0,c)),T(l)&&b(d,l,f,C),T(c)&&_(m,c,u,C))}var I=Math.min(6,g);for(n=0;n<I;n++)P(n);for(n=g-1;n>=I;n--)P(n);return{min:d,max:m,opts:r}}function b(t,e,r,n){w(t,e,r,n,k)}function _(t,e,r,n){w(t,e,r,n,M)}function w(t,e,r,n,i){for(var a=n.tozero,o=n.extrapad,s=!0,l=0;l<t.length&&s;l++){var c=t[l];if(i(c.val,e)&&c.pad>=r&&(c.extrapad||!o)){s=!1;break}i(e,c.val)&&c.pad<=r&&(o||!c.extrapad)&&(t.splice(l,1),l--)}if(s){var u=a&&0===e;t.push({val:e,pad:u?0:r,extrapad:!u&&o})}}function T(t){return i(t)&&Math.abs(t)<o}function k(t,e){return t<=e}function M(t,e){return t>=e}},{"../../components/drawing":672,"../../constants/numerical":763,"../../lib":787,"../../registry":915,"./axis_ids":842,"@plotly/d3":58,"fast-isnumeric":246}],838:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../../plots/plots'),o=t('../../registry'),s=t('../../lib'),l=s.strTranslate,c=t('../../lib/svg_text_utils'),u=t('../../components/titles'),f=t('../../components/color'),h=t('../../components/drawing'),p=t('./layout_attributes'),d=t('./clean_ticks'),m=t('../../constants/numerical'),g=m.ONEMAXYEAR,v=m.ONEAVGYEAR,y=m.ONEMINYEAR,x=m.ONEMAXQUARTER,b=m.ONEAVGQUARTER,_=m.ONEMINQUARTER,w=m.ONEMAXMONTH,T=m.ONEAVGMONTH,k=m.ONEMINMONTH,M=m.ONEWEEK,A=m.ONEDAY,S=A/2,E=m.ONEHOUR,L=m.ONEMIN,C=m.ONESEC,P=m.MINUS_SIGN,I=m.BADNUM,z={K:"zeroline"},O={K:"gridline",L:"path"},D={K:"tick",L:"path"},R={K:"tick",L:"text"},F=t('../../constants/alignment'),B=F.MID_SHIFT,N=F.CAP_SHIFT,j=F.LINE_SPACING,U=F.OPPOSITE_SIDE,V=3,H=e.exports={};H.setConvert=t('./set_convert');var q=t('./axis_autotype'),G=t('./axis_ids'),Y=G.idSort,W=G.isLinked;H.id2name=G.id2name,H.name2id=G.name2id,H.cleanId=G.cleanId,H.list=G.list,H.listIds=G.listIds,H.getFromId=G.getFromId,H.getFromTrace=G.getFromTrace;var X=t('./autorange');H.getAutoRange=X.getAutoRange,H.findExtremes=X.findExtremes;var Z=1e-4;function J(t){var e=(t[1]-t[0])*Z;return[t[0]-e,t[1]+e]}H.coerceRef=function(t,e,r,n,i,a){var o=n.charAt(n.length-1),l=r._fullLayout._subplots[o+"axis"],c=n+"ref",u={};return i||(i=l[0]||("string"===typeof a?a:a[0])),a||(a=i),l=l.concat(l.map((function(t){return t+" domain"}))),u[c]={valType:"enumerated",values:l.concat(a?"string"===typeof a?[a]:a:[]),dflt:i},s.coerce(t,e,u,c)},H.getRefType=function(t){return void 0===t?t:"paper"===t?"paper":"pixel"===t?"pixel":/( domain)$/.test(t)?"domain":"range"},H.coercePosition=function(t,e,r,n,i,a){var o,l;if("range"!==H.getRefType(n))o=s.ensureNumber,l=r(i,a);else{var c=H.getFromId(e,n);l=r(i,a=c.fraction2r(a)),o=c.cleanPos}t[i]=o(l)},H.cleanPosition=function(t,e,r){return("paper"===r||"pixel"===r?s.ensureNumber:H.getFromId(e,r).cleanPos)(t)},H.redrawComponents=function(t,e){e=e||H.listIds(t);var r=t._fullLayout;function n(n,i,a,s){for(var l=o.getComponentMethod(n,i),c={},u=0;u<e.length;u++)for(var f=r[H.id2name(e[u])][a],h=0;h<f.length;h++){var p=f[h];if(!c[p]&&(l(t,p),c[p]=1,s))return}}n('annotations','drawOne','_annIndices'),n('shapes','drawOne','_shapeIndices'),n('images','draw','_imgIndices',!0)};var K=H.getDataConversions=function(t,e,r,n){var i,a="x"===r||"y"===r||"z"===r?r:n;if(Array.isArray(a)){if(i={type:q(n,void 0,{autotypenumbers:t._fullLayout.autotypenumbers}),_categories:[]},H.setConvert(i),"category"===i.type)for(var o=0;o<n.length;o++)i.d2c(n[o])}else i=H.getFromTrace(t,e,a);return i?{d2c:i.d2c,c2d:i.c2d}:"ids"===a?{d2c:$,c2d:$}:{d2c:Q,c2d:Q}};function Q(t){return+t}function $(t){return String(t)}function tt(t,e,r,n,a){var o=0,s=0,l=0,c=0;function u(e){return(1+100*(e-t)/r.dtick)%100<2}for(var f=0;f<e.length;f++)e[f]%1===0?l++:i(e[f])||c++,u(e[f])&&o++,u(e[f]+r.dtick/2)&&s++;var h=e.length-c;if(l===h&&"date"!==r.type)r.dtick<1?t=n-.5*r.dtick:(t-=.5)+r.dtick<n&&(t+=r.dtick);else if(s<.1*h&&(o>.3*h||u(n)||u(a))){var p=r.dtick/2;t+=t+p<n?p:-p}return t}function et(t,e,r,n,i){var a=s.findExactDates(e,i),o=.8;if(a.exactDays>o){var l=Number(r.substr(1));a.exactYears>o&&l%12===0?t=H.tickIncrement(t,'M6','reverse')+1.5*A:a.exactMonths>o?t=H.tickIncrement(t,'M1','reverse')+15.5*A:t-=S;var c=H.tickIncrement(t,r);if(c<=n)return c}return t}function rt(t){return+t.substring(1)}function nt(t){var e;function r(){return!(i(t.dtick)||"M"!==t.dtick.charAt(0))}var n=r(),a=H.getTickFormat(t);if(a){var o=t._dtickInit!==t.dtick;/%[fLQsSMX]/.test(a)||(/%[HI]/.test(a)?(e=E,o&&!n&&t.dtick<E&&(t.dtick=E)):/%p/.test(a)?(e=S,o&&!n&&t.dtick<S&&(t.dtick=S)):/%[Aadejuwx]/.test(a)?(e=A,o&&!n&&t.dtick<A&&(t.dtick=A)):/%[UVW]/.test(a)?(e=M,o&&!n&&t.dtick<M&&(t.dtick=M)):/%[Bbm]/.test(a)?(e=T,o&&(n?rt(t.dtick)<1:t.dtick<k)&&(t.dtick='M1')):/%[q]/.test(a)?(e=b,o&&(n?rt(t.dtick)<3:t.dtick<_)&&(t.dtick='M3')):/%[Yy]/.test(a)&&(e=v,o&&(n?rt(t.dtick)<12:t.dtick<y)&&(t.dtick='M12')))}(n=r())&&t.tick0===t._dowTick0&&(t.tick0=t._rawTick0),t._definedDelta=e}function it(t,e,r){for(var n=0;n<t.length;n++){var i=t[n].value,a=n,o=n+1;n<t.length-1?(a=n,o=n+1):n>0?(a=n-1,o=n):(a=n,o=n);var s,l=t[a].value,c=t[o].value,u=Math.abs(c-l),f=r||u,h=0;f>=y?h=u>=y&&u<=g?u:v:r===b&&f>=_?h=u>=_&&u<=x?u:b:f>=k?h=u>=k&&u<=w?u:T:r===M&&f>=M?h=M:f>=A?h=A:r===S&&f>=S?h=S:r===E&&f>=E&&(h=E),h>=u&&(h=u,s=!0);var p=i+h;if(e.rangebreaks&&h>0){for(var d=84,m=0,L=0;L<d;L++){var C=(L+.5)/d;e.maskBreaks(i*(1-C)+C*p)!==I&&m++}(h*=m/d)||(t[n].drop=!0),s&&u>M&&(h=u)}(h>0||0===n)&&(t[n].periodX=i+h/2)}}function at(t){var e=t.tickvals,r=t.ticktext,n=new Array(e.length),i=J(s.simpleMap(t.range,t.r2l)),a=Math.min(i[0],i[1]),o=Math.max(i[0],i[1]),l=0;Array.isArray(r)||(r=[]);var c="category"===t.type?t.d2l_noadd:t.d2l;"log"===t.type&&"L"!==String(t.dtick).charAt(0)&&(t.dtick="L"+Math.pow(10,Math.floor(Math.min(t.range[0],t.range[1]))-1));for(var u=0;u<e.length;u++){var f=c(e[u]);f>a&&f<o&&(void 0===r[u]?n[l]=H.tickText(t,f):n[l]=mt(t,f,String(r[u])),l++)}return l<e.length&&n.splice(l,e.length-l),t.rangebreaks&&(n=n.filter((function(e){return t.maskBreaks(e.x)!==I}))),n}H.getDataToCoordFunc=function(t,e,r,n){return K(t,e,r,n).d2c},H.counterLetter=function(t){var e=t.charAt(0);return"x"===e?"y":"y"===e?"x":void 0},H.minDtick=function(t,e,r,n){-1===["log",'category',"multicategory"].indexOf(t.type)&&n?void 0===t._minDtick?(t._minDtick=e,t._forceTick0=r):t._minDtick&&((t._minDtick/e+1e-6)%1<2e-6&&((r-t._forceTick0)/e%1+1.000001)%1<2e-6?(t._minDtick=e,t._forceTick0=r):((e/t._minDtick+1e-6)%1>2e-6||((r-t._forceTick0)/t._minDtick%1+1.000001)%1>2e-6)&&(t._minDtick=0)):t._minDtick=0},H.saveRangeInitial=function(t,e){for(var r=H.list(t,'',!0),n=!1,i=0;i<r.length;i++){var a=r[i],o=void 0===a._rangeInitial,s=o||!(a.range[0]===a._rangeInitial[0]&&a.range[1]===a._rangeInitial[1]);(o&&!1===a.autorange||e&&s)&&(a._rangeInitial=a.range.slice(),n=!0)}return n},H.saveShowSpikeInitial=function(t,e){for(var r=H.list(t,'',!0),n=!1,i='on',a=0;a<r.length;a++){var o=r[a],s=void 0===o._showSpikeInitial,l=s||!(o.showspikes===o._showspikes);(s||e&&l)&&(o._showSpikeInitial=o.showspikes,n=!0),"on"!==i||o.showspikes||(i='off')}return t._fullLayout._cartesianSpikesEnabled=i,n},H.autoBin=function(t,e,r,n,a,o){var l,c=s.aggNums(Math.min,null,t),u=s.aggNums(Math.max,null,t);if("category"===e.type||"multicategory"===e.type)return{start:c-.5,end:u+.5,size:Math.max(1,Math.round(o)||1),_dataSpan:u-c};if(a||(a=e.calendar),l="log"===e.type?{type:"linear",range:[c,u]}:{type:e.type,range:s.simpleMap([c,u],e.c2r,0,a),calendar:a},H.setConvert(l),o=o&&d.dtick(o,l.type))l.dtick=o,l.tick0=d.tick0(void 0,l.type,a);else{var f;if(r)f=(u-c)/r;else{var h=s.distinctVals(t),p=Math.pow(10,Math.floor(Math.log(h.minDiff)/Math.LN10)),m=p*s.roundUp(h.minDiff/p,[.9,1.9,4.9,9.9],!0);f=Math.max(m,2*s.stdev(t)/Math.pow(t.length,n?.25:.4)),i(f)||(f=1)}H.autoTicks(l,f)}var g,v=l.dtick,y=H.tickIncrement(H.tickFirst(l),v,'reverse',a);if("number"===typeof v)g=(y=tt(y,t,l,c,u))+(1+Math.floor((u-y)/v))*v;else for("M"===l.dtick.charAt(0)&&(y=et(y,t,v,c,a)),g=y;g<=u;)g=H.tickIncrement(g,v,!1,a);return{start:e.c2r(y,0,a),end:e.c2r(g,0,a),size:v,_dataSpan:u-c}},H.prepTicks=function(t,e){var r=s.simpleMap(t.range,t.r2l,void 0,void 0,e);if(t._dtickInit=t.dtick,t._tick0Init=t.tick0,"auto"===t.tickmode||!t.dtick){var n,i=t.nticks;i||("category"===t.type||"multicategory"===t.type?(n=t.tickfont?s.bigFont(t.tickfont.size||12):15,i=t._length/n):(n="y"===t._id.charAt(0)?40:80,i=s.constrain(t._length/n,4,9)+1),"radialaxis"===t._name&&(i*=2)),"array"===t.tickmode&&(i*=100),t._roughDTick=Math.abs(r[1]-r[0])/i,H.autoTicks(t,t._roughDTick),t._minDtick>0&&t.dtick<2*t._minDtick&&(t.dtick=t._minDtick,t.tick0=t.l2r(t._forceTick0))}"period"===t.ticklabelmode&&nt(t),t.tick0||(t.tick0="date"===t.type?"2000-01-01":0),"date"===t.type&&t.dtick<.1&&(t.dtick=.1),dt(t)},H.calcTicks=function(t,e){H.prepTicks(t,e);var r=s.simpleMap(t.range,t.r2l,void 0,void 0,e);if("array"===t.tickmode)return at(t);var n=J(r),a=n[0],o=n[1],l=r[1]<r[0],c=Math.min(r[0],r[1]),u=Math.max(r[0],r[1]),f="log"===t.type&&!(i(t.dtick)||"L"===t.dtick.charAt(0)),h="period"===t.ticklabelmode;if(t._tmin=H.tickFirst(t,e),t._tmin<a!==l)return[];"category"!==t.type&&"multicategory"!==t.type||(o=l?Math.max(-.5,o):Math.min(t._categories.length-.5,o));var p=t._tmin;t.rangebreaks&&t._tick0Init!==t.tick0&&(p=Zt(p,t),l||(p=H.tickIncrement(p,t.dtick,!l,t.calendar))),h&&(p=H.tickIncrement(p,t.dtick,!l,t.calendar));for(var d,m=Math.max(1e3,t._length||0),g=[],v=null;l?p>=o:p<=o;p=H.tickIncrement(p,t.dtick,l,t.calendar)){if(t.rangebreaks&&!l){if(p<a)continue;if(t.maskBreaks(p)===I&&Zt(p,t)>=u)break}if(g.length>m||p===v)break;v=p;var y=!1;f&&p!==(0|p)&&(y=!0),g.push({minor:y,value:p})}if(h&&it(g,t,t._definedDelta),t.rangebreaks){var x="y"===t._id.charAt(0),b=1;"auto"===t.tickmode&&(b=t.tickfont?t.tickfont.size:12);var _=NaN;for(d=g.length-1;d>-1;d--)if(g[d].drop)g.splice(d,1);else{g[d].value=Zt(g[d].value,t);var w=t.c2p(g[d].value);(x?_>w-b:_<w+b)?g.splice(l?d+1:d,1):_=w}}Xt(t)&&360===Math.abs(r[1]-r[0])&&g.pop(),t._tmax=(g[g.length-1]||{}).value,t._prevDateHead='',t._inCalcTicks=!0;var T,k,M=[];for(d=0;d<g.length;d++){var A=g[d].minor,S=g[d].value;T=H.tickText(t,S,!1,A),void 0!==(k=g[d].periodX)&&(T.periodX=k,(k>u||k<c)&&(k>u&&(T.periodX=u),k<c&&(T.periodX=c),T.text=' ',t._prevDateHead='')),M.push(T)}return t._inCalcTicks=!1,M};var ot=[2,5,10],st=[1,2,3,6,12],lt=[1,2,5,10,15,30],ct=[1,2,3,7,14],ut=[-.046,0,.301,.477,.602,.699,.778,.845,.903,.954,1],ft=[-.301,0,.301,.699,1],ht=[15,30,45,90,180];function pt(t,e,r){return e*s.roundUp(t/e,r)}function dt(t){var e=t.dtick;if(t._tickexponent=0,i(e)||"string"===typeof e||(e=1),"category"!==t.type&&"multicategory"!==t.type||(t._tickround=null),"date"===t.type){var r=t.r2l(t.tick0),n=t.l2r(r).replace(/(^-|i)/g,''),a=n.length;if("M"===String(e).charAt(0))a>10||"01-01"!==n.substr(5)?t._tickround="d":t._tickround=+e.substr(1)%12===0?"y":"m";else if(e>=A&&a<=10||e>=15*A)t._tickround='d';else if(e>=L&&a<=16||e>=E)t._tickround='M';else if(e>=C&&a<=19||e>=L)t._tickround='S';else{var o=t.l2r(r+e).replace(/^-/,'').length;t._tickround=Math.max(a,o)-20,t._tickround<0&&(t._tickround=4)}}else if(i(e)||"L"===e.charAt(0)){var s=t.range.map(t.r2d||Number);i(e)||(e=Number(e.substr(1))),t._tickround=2-Math.floor(Math.log(e)/Math.LN10+.01);var l=Math.max(Math.abs(s[0]),Math.abs(s[1])),c=Math.floor(Math.log(l)/Math.LN10+.01),u=void 0===t.minexponent?3:t.minexponent;Math.abs(c)>u&&(kt(t.exponentformat)&&!Mt(c)?t._tickexponent=3*Math.round((c-1)/3):t._tickexponent=c)}else t._tickround=null}function mt(t,e,r)[var n=t.tickfont||{];return{x:e,dx:0,dy:0,text:r||"",fontSize:n.size,font:n.family,fontColor:n.color}}function gt(t,e,r,n){var a=t._tickround,o=r&&t.hoverformat||H.getTickFormat(t);n&&(a=i(a)?4:{y:"m",m:"d",d:"M",M:"S",S:4}[a]);var l,c=s.formatDate(e.x,o,a,t._dateFormat,t.calendar,t._extraFormat),u=c.indexOf('\n');if(-1!==u&&(l=c.substr(u+1),c=c.substr(0,u)),n&&("00:00:00"===c||"00:00"===c?(c=l,l=''):8===c.length&&(c=c.replace(/:00$/,''))),l)if(r)"d"===a?c+=", '+l:c=l+(c?', "+c:"");else if(t._inCalcTicks&&t._prevDateHead===l){var f=Jt(t),h=t._realSide||t.side;(!f&&"top"===h||f&&"bottom"===h)&&(c+='<br> ')}else t._prevDateHead=l,c+="<br>"+l;e.text=c}function vt(t,e,r,n,a){var o=t.dtick,l=e.x,c=t.tickformat,u="string"===typeof o&&o.charAt(0);if("never"===a&&(a=''),n&&"L"!==u&&(o='L3',u='L'),c||"L"===u)e.text=At(Math.pow(10,l),t,a,n);else if(i(o)||"D"===u&&s.mod(l+.01,1)<.1){var f=Math.round(l),h=Math.abs(f),p=t.exponentformat;"power"===p||kt(p)&&Mt(f)?(e.text=0===f?1:1===f?"10":"10<sup>"+(f>1?"":P)+h+"</sup>",e.fontSize*=1.25):("e"===p||"E"===p)&&h>2?e.text="1"+p+(f>0?"+":P)+h:(e.text=At(Math.pow(10,l),t,'','fakehover'),"D1"===o&&"y"===t._id.charAt(0)&&(e.dy-=e.fontSize/6))}else{if("D"!==u)throw"unrecognized dtick "+String(o);e.text=String(Math.round(Math.pow(10,s.mod(l,1)))),e.fontSize*=.75}if("D1"===t.dtick){var d=String(e.text).charAt(0);"0"!==d&&"1"!==d||("y"===t._id.charAt(0)?e.dx-=e.fontSize/4:(e.dy+=e.fontSize/2,e.dx+=(t.range[1]>t.range[0]?1:-1)*e.fontSize*(l<0?.5:.25)))}}function yt(t,e){var r=t._categories[Math.round(e.x)];void 0===r&&(r=''),e.text=String(r)}function xt(t,e,r){var n=Math.round(e.x),i=t._categories[n]||[],a=void 0===i[1]?"":String(i[1]),o=void 0===i[0]?"":String(i[0]);r?e.text=o+" - "+a:(e.text=a,e.text2=o)}function bt(t,e,r,n,i){"never"===i?i="":"all"===t.showexponent&&Math.abs(e.x/t.dtick)<1e-6&&(i='hide'),e.text=At(e.x,t,i,n)}function _t(t,e,r,n,i){if("radians"!==t.thetaunit||r)e.text=At(e.x,t,i,n);else{var a=e.x/180;if(0===a)e.text='0';else{var o=wt(a);if(o[1]>=100)e.text=At(s.deg2rad(e.x),t,i,n);else{var l=e.x<0;1===o[1]?1===o[0]?e.text="\u03c0":e.text=o[0]+"\u03c0":e.text=["<sup>",o[0],'</sup>','\u2044','<sub>',o[1],'</sub>',"\u03c0"].join(''),l&&(e.text=P+e.text)}}}}function wt(t){function e(t,e){return Math.abs(t-e)<=1e-6}function r(t,n){return e(n,0)?t:r(n,t%n)}function n(t){for(var r=1;!e(Math.round(t*r)/r,t);)r*=10;return r}var i=n(t),a=t*i,o=Math.abs(r(a,i));return[Math.round(a/o),Math.round(i/o)]}H.autoTicks=function(t,e){var r;function n(t){return Math.pow(t,Math.floor(Math.log(e)/Math.LN10))}if("date"===t.type){t.tick0=s.dateTick0(t.calendar,0);var a=2*e;if(a>v)e/=v,r=n(10),t.dtick="M"+12*pt(e,r,ot);else if(a>T)e/=T,t.dtick="M"+pt(e,1,st);else if(a>A){t.dtick=pt(e,A,t._hasDayOfWeekBreaks?[1,2,7,14]:ct);var o=H.getTickFormat(t),l="period"===t.ticklabelmode;l&&(t._rawTick0=t.tick0),/%[uVW]/.test(o)?t.tick0=s.dateTick0(t.calendar,2):t.tick0=s.dateTick0(t.calendar,1),l&&(t._dowTick0=t.tick0)}else a>E?t.dtick=pt(e,E,st):a>L?t.dtick=pt(e,L,lt):a>C?t.dtick=pt(e,C,lt):(r=n(10),t.dtick=pt(e,r,ot))}else if("log"===t.type){t.tick0=0;var c=s.simpleMap(t.range,t.r2l);if(e>.7)t.dtick=Math.ceil(e);else if(Math.abs(c[1]-c[0])<1){var u=1.5*Math.abs((c[1]-c[0])/e);e=Math.abs(Math.pow(10,c[1])-Math.pow(10,c[0]))/u,r=n(10),t.dtick="L"+pt(e,r,ot)}else t.dtick=e>.3?"D2":"D1"}else"category"===t.type||"multicategory"===t.type?(t.tick0=0,t.dtick=Math.ceil(Math.max(e,1))):Xt(t)?(t.tick0=0,r=1,t.dtick=pt(e,r,ht)):(t.tick0=0,r=n(10),t.dtick=pt(e,r,ot));if(0===t.dtick&&(t.dtick=1),!i(t.dtick)&&"string"!==typeof t.dtick){var f=t.dtick;throw t.dtick=1,"ax.dtick error: "+String(f)}},H.tickIncrement=function(t,e,r,a){var o=r?-1:1;if(i(e))return s.increment(t,o*e);var l=e.charAt(0),c=o*Number(e.substr(1));if("M"===l)return s.incrementMonth(t,c,a);if("L"===l)return Math.log(Math.pow(10,t)+c)/Math.LN10;if("D"===l){var u="D2"===e?ft:ut,f=t+.01*o,h=s.roundUp(s.mod(f,1),u,r);return Math.floor(f)+Math.log(n.round(Math.pow(10,h),1))/Math.LN10}throw"unrecognized dtick "+String(e)},H.tickFirst=function(t,e){var r=t.r2l||Number,a=s.simpleMap(t.range,r,void 0,void 0,e),o=a[1]<a[0],l=o?Math.floor:Math.ceil,c=J(a)[0],u=t.dtick,f=r(t.tick0);if(i(u)){var h=l((c-f)/u)*u+f;return"category"!==t.type&&"multicategory"!==t.type||(h=s.constrain(h,0,t._categories.length-1)),h}var p=u.charAt(0),d=Number(u.substr(1));if("M"===p){for(var m,g,v,y=0,x=f;y<10;){if(((m=H.tickIncrement(x,u,o,t.calendar))-c)*(x-c)<=0)return o?Math.min(x,m):Math.max(x,m);g=(c-(x+m)/2)/(m-x),v=p+(Math.abs(Math.round(g))||1)*d,x=H.tickIncrement(x,v,g<0?!o:o,t.calendar),y++}return s.error('tickFirst did not converge',t),x}if("L"===p)return Math.log(l((Math.pow(10,c)-f)/d)*d+f)/Math.LN10;if("D"===p){var b="D2"===u?ft:ut,_=s.roundUp(s.mod(c,1),b,o);return Math.floor(c)+Math.log(n.round(Math.pow(10,_),1))/Math.LN10}throw"unrecognized dtick "+String(u)},H.tickText=function(t,e,r,n){var i,a=mt(t,e),o="array"===t.tickmode,l=r||o,c=t.type,u="category"===c?t.d2l_noadd:t.d2l;if(o&&Array.isArray(t.ticktext)){var f=s.simpleMap(t.range,t.r2l),h=(Math.abs(f[1]-f[0])-(t._lBreaks||0))/1e4;for(i=0;i<t.ticktext.length&&!(Math.abs(e-u(t.tickvals[i]))<h);i++);if(i<t.ticktext.length)return a.text=String(t.ticktext[i]),a}function p(n){if(void 0===n)return!0;if(r)return"none"===n;var i={first:t._tmin,last:t._tmax}[n];return"all"!==n&&e!==i}var d=r?"never":"none"!==t.exponentformat&&p(t.showexponent)?"hide":"";if("date"===c?gt(t,a,r,l):"log"===c?vt(t,a,r,l,d):"category"===c?yt(t,a):"multicategory"===c?xt(t,a,r):Xt(t)?_t(t,a,r,l,d):bt(t,a,r,l,d),n||(t.tickprefix&&!p(t.showtickprefix)&&(a.text=t.tickprefix+a.text),t.ticksuffix&&!p(t.showticksuffix)&&(a.text+=t.ticksuffix)),"boundaries"===t.tickson||t.showdividers){var m=function(e){var r=t.l2p(e);return r>=0&&r<=t._length?e:null};a.xbnd=[m(a.x-.5),m(a.x+t.dtick-.5)]}return a},H.hoverLabelText=function(t,e,r)[r&&(t=s.extendFlat({],t,{hoverformat:r}));var n=Array.isArray(e)?e[0]:e,i=Array.isArray(e)?e[1]:void 0;if(void 0!==i&&i!==n)return H.hoverLabelText(t,n,r)+" - "+H.hoverLabelText(t,i,r);var a="log"===t.type&&n<=0,o=H.tickText(t,t.c2l(a?-n:n),'hover').text;return a?0===n?"0":P+o:o};var Tt=["f",'p','n','\u03bc','m','','k','M','G',"T"];function kt(t){return"SI"===t||"B"===t}function Mt(t){return t>14||t<-15}function At(t,e,r,n){var a=t<0,o=e._tickround,l=r||e.exponentformat||"B",c=e._tickexponent,u=H.getTickFormat(e),f=e.separatethousands;if(n){var h={exponentformat:l,minexponent:e.minexponent,dtick:"none"===e.showexponent?e.dtick:i(t)&&Math.abs(t)||1,range:"none"===e.showexponent?e.range.map(e.r2d):[0,t||1]};dt(h),o=(Number(h._tickround)||0)+4,c=h._tickexponent,e.hoverformat&&(u=e.hoverformat)}if(u)return e._numFormat(u)(t).replace(/-/g,P);var p,d=Math.pow(10,-o)/2;if("none"===l&&(c=0),(t=Math.abs(t))<d)t='0',a=!1;else{if(t+=d,c&&(t*=Math.pow(10,-c),o+=c),0===o)t=String(Math.floor(t));else if(o<0){t=(t=String(Math.round(t))).substr(0,t.length+o);for(var m=o;m<0;m++)t+="0"}else{var g=(t=String(t)).indexOf('.')+1;g&&(t=t.substr(0,g+o).replace(/\.?0+$/,''))}t=s.numSeparate(t,e._separators,f)}return c&&"hide"!==l&&(kt(l)&&Mt(c)&&(l='power'),p=c<0?P+-c:"power"!==l?"+"+c:String(c),"e"===l||"E"===l?t+=l+p:"power"===l?t+="\xd710<sup>"+p+"</sup>":"B"===l&&9===c?t+="B":kt(l)&&(t+=Tt[c/3+5])),a?P+t:t}function St(t,e){var r,n=[],i=function(t,e){var r=t.xbnd[e];null!==r&&n.push(s.extendFlat({},t,{x:r}))};if(e.length){for(r=0;r<e.length;r++)i(e[r],0);i(e[r-1],1)}return n}function Et(t,e){for(var r=[],n={},i=0;i<e.length;i++){var a=e[i];n[a.text2]?n[a.text2].push(a.x):n[a.text2]=[a.x]}for(var o in n)r.push(mt(t,s.interp(n[o],.5),o));return r}function Lt(t,e){var r,n,i=[],a=e.length&&e[e.length-1].x<e[0].x,o=function(t,e){var r=t.xbnd[e];null!==r&&i.push(s.extendFlat({},t,{x:r}))};if(t.showdividers&&e.length){for(r=0;r<e.length;r++){var l=e[r];l.text2!==n&&o(l,a?1:0),n=l.text2}o(e[r-1],a?0:1)}return i}function Ct(t,e){var r,n,i,a;return t._selections[e].size()?(r=1/0,n=-1/0,i=1/0,a=-1/0,t._selections[e].each((function(){var t=jt(this),e=h.bBox(t.node().parentNode);r=Math.min(r,e.top),n=Math.max(n,e.bottom),i=Math.min(i,e.left),a=Math.max(a,e.right)}))):(r=0,n=0,i=0,a=0),{top:r,bottom:n,left:i,right:a,height:n-r,width:a-i}}function Pt(t){return void 0!==t.periodX?t.periodX:t.x}function It(t){var e=t.ticklabelposition||"",r=function(t){return-1!==e.indexOf(t)},n=r('top'),i=r('left'),a=r('right'),o=r('bottom'),s=r('inside'),l=o||i||n||a;if(!l&&!s)return[0,0];var c=t.side,u=l?(t.tickwidth||0)/2:0,f=V,h=t.tickfont?t.tickfont.size:12;return(o||n)&&(u+=h*N,f+=(t.linewidth||0)/2),(i||a)&&(u+=(t.linewidth||0)/2,f+=V),s&&"top"===c&&(f-=h*(1-N)),(i||n)&&(u=-u),"bottom"!==c&&"right"!==c||(f=-f),[l?u:0,s?f:0]}function zt(t){return[t.text,t.x,t.axInfo,t.font,t.fontSize,t.fontColor].join('_')}function Ot(t,e,r){var n=e._id+"divider",i=r.vals,a=r.layer.selectAll("path."+n).data(i,zt);a.exit().remove(),a.enter().insert('path',':first-child').classed(n,1).classed('crisp',1).call(f.stroke,e.dividercolor).style('stroke-width',h.crispRound(t,e.dividerwidth,1)+"px"),a.attr('transform',r.transFn).attr('d',r.path)}function Dt(t){var e=t.title.font.size,r=(t.title.text.match(c.BR_TAG_ALL)||[]).length;return t.title.hasOwnProperty('standoff')?r?e*(N+r*j):e*N:r?e*(r+1)*j:e}function Rt(t,e){var r,n=t._fullLayout,i=e._id,a=i.charAt(0),o=e.title.font.size;if(e.title.hasOwnProperty('standoff'))r=e._depth+e.title.standoff+Dt(e);else{var s=Jt(e);if("multicategory"===e.type)r=e._depth;else{var l=1.5*o;s&&(l=.5*o,"outside"===e.ticks&&(l+=e.ticklen)),r=10+l+(e.linewidth?e.linewidth-1:0)}s||(r+="x"===a?"top"===e.side?o*(e.showticklabels?1:0):o*(e.showticklabels?1.5:.5):"right"===e.side?o*(e.showticklabels?1:.5):o*(e.showticklabels?.5:0))}var c,f,p,d,m=H.getPxPosition(t,e);if("x"===a?(f=e._offset+e._length/2,p="top"===e.side?m-r:m+r):(p=e._offset+e._length/2,f="right"===e.side?m+r:m-r,c={rotate:"-90",offset:0}),"multicategory"!==e.type){var g=e._selections[e._id+"tick"];if(d={selection:g,side:e.side},g&&g.node()&&g.node().parentNode){var v=h.getTranslate(g.node().parentNode);d.offsetLeft=v.x,d.offsetTop=v.y}e.title.hasOwnProperty('standoff')&&(d.pad=0)}return u.draw(t,i+"title",{propContainer:e,propName:e._name+".title.text",placeholder:n._dfltTitle[a],avoid:d,transform:c,attributes:{x:f,y:p,"text-anchor":"middle"}})}function Ft(t,e){var r=t.l2p(e);return r>1&&r<t._length-1}function Bt(t,e,r,n){var i=r._mainAxis;if(i){var a=t._fullLayout,o=e._id.charAt(0),s=H.counterLetter(e._id),l=e._offset+(Math.abs(n[0])<Math.abs(n[1])===("x"===o)?0:e._length),c=a._plots[r._mainSubplot];if(!(c.mainplotinfo||c).overlays.length)return p(r,l);for(var u=H.list(t,s),f=0;f<u.length;f++){var h=u[f];if(h._mainAxis===i&&p(h,l))return!0}}function p(t){if(!t.showline||!t.linewidth)return!1;var r=Math.max((t.linewidth+e.zerolinewidth)/2,1);function n(t){return"number"===typeof t&&Math.abs(t-l)<r}if(n(t._mainLinePosition)||n(t._mainMirrorPosition))return!0;var i=t._linepositions||{};for(var a in i)if(n(i[a][0])||n(i[a][1]))return!0}}function Nt(t,e){for(var r=t._fullData,n=e._mainSubplot,i=e._id.charAt(0),a=0;a<r.length;a++){var s=r[a];if(!0===s.visible&&s.xaxis+s.yaxis===n){if(o.traceIs(s,'bar-like')&&s.orientation==={x:"h",y:"v"}[i])return!0;if(s.fill&&s.fill.charAt(s.fill.length-1)===i)return!0}}return!1}function jt(t){var e=n.select(t),r=e.select('.text-math-group');return r.empty()?e.select('text'):r}function Ut(t){return t._id+".automargin"}function Vt(t){return Ut(t)+".mirror"}function Ht(t){return t._id+".rangeslider"}function qt(t,e){var r,n,i=[];for(r=0;r<e.length;r++){var a=[],o=t._fullData[e[r]].xaxis,s=t._fullData[e[r]].yaxis;if(o&&s){for(n=0;n<i.length;n++)-1===i[n].x.indexOf(o)&&-1===i[n].y.indexOf(s)||a.push(n);if(a.length){var l,c=i[a[0]];if(a.length>1)for(n=1;n<a.length;n++)l=i[a[n]],Gt(c.x,l.x),Gt(c.y,l.y);Gt(c.x,[o]),Gt(c.y,[s])}else i.push({x:[o],y:[s]})}}return i}function Gt(t,e){for(var r=0;r<e.length;r++)-1===t.indexOf(e[r])&&t.push(e[r])}function Yt(t,e,r){var n,i,a=[],o=[],l=t.layout;for(n=0;n<e.length;n++)a.push(H.getFromId(t,e[n]));for(n=0;n<r.length;n++)o.push(H.getFromId(t,r[n]));var c=Object.keys(p),u=["anchor",'domain','overlaying','position','side','tickangle',"editType"],f=["linear","log"];for(n=0;n<c.length;n++){var h=c[n],d=a[0][h],m=o[0][h],g=!0,v=!1,y=!1;if("_"!==h.charAt(0)&&"function"!==typeof d&&-1===u.indexOf(h)){for(i=1;i<a.length&&g;i++){var x=a[i][h];"type"===h&&-1!==f.indexOf(d)&&-1!==f.indexOf(x)&&d!==x?v=!0:x!==d&&(g=!1)}for(i=1;i<o.length&&g;i++){var b=o[i][h];"type"===h&&-1!==f.indexOf(m)&&-1!==f.indexOf(b)&&m!==b?y=!0:o[i][h]!==m&&(g=!1)}g&&(v&&(l[a[0]._name].type='linear'),y&&(l[o[0]._name].type='linear'),Wt(l,h,a,o,t._fullLayout._dfltTitle))}}for(n=0;n<t._fullLayout.annotations.length;n++){var _=t._fullLayout.annotations[n];-1!==e.indexOf(_.xref)&&-1!==r.indexOf(_.yref)&&s.swapAttrs(l.annotations[n],["?"])}}function Wt(t,e,r,n,i){var a,o=s.nestedProperty,l=o(t[r[0]._name],e).get(),c=o(t[n[0]._name],e).get();for("title"===e&&(l&&l.text===i.x&&(l.text=i.y),c&&c.text===i.y&&(c.text=i.x)),a=0;a<r.length;a++)o(t,r[a]._name+"."+e).set(c);for(a=0;a<n.length;a++)o(t,n[a]._name+"."+e).set(l)}function Xt(t){return"angularaxis"===t._id}function Zt(t,e){for(var r=e._rangebreaks.length,n=0;n<r;n++){var i=e._rangebreaks[n];if(t>=i.min&&t<i.max)return i.max}return t}function Jt(t){return-1!==(t.ticklabelposition||"").indexOf('inside')}function Kt(t,e)[Jt(t._anchorAxis||{])&&t._hideCounterAxisInsideTickLabels&&t._hideCounterAxisInsideTickLabels(e)}H.getTickFormat=function(t){var e,r,n;function i(t){return"string"!==typeof t?t:Number(t.replace('M',''))*T}function a(t,e){var r=["L","D"];if(typeof t===typeof e){if("number"===typeof t)return t-e;var n=r.indexOf(t.charAt(0)),i=r.indexOf(e.charAt(0));return n===i?Number(t.replace(/(L|D)/g,''))-Number(e.replace(/(L|D)/g,'')):n-i}return"number"===typeof t?1:-1}function o(t,e,r){var n=r||function(t){return t},i=e[0],a=e[1];return(!i&&"number"!==typeof i||n(i)<=n(t))&&(!a&&"number"!==typeof a||n(a)>=n(t))}function s(t,e){var r=null===e[0],n=null===e[1],i=a(t,e[0])>=0,o=a(t,e[1])<=0;return(r||i)&&(n||o)}if(t.tickformatstops&&t.tickformatstops.length>0)switch(t.type){case"date":case"linear":for(e=0;e<t.tickformatstops.length;e++)if((n=t.tickformatstops[e]).enabled&&o(t.dtick,n.dtickrange,i)){r=n;break}break;case"log":for(e=0;e<t.tickformatstops.length;e++)if((n=t.tickformatstops[e]).enabled&&s(t.dtick,n.dtickrange)){r=n;break}}return r?r.value:t.tickformat},H.getSubplots=function(t,e){var r=t._fullLayout._subplots,n=r.cartesian.concat(r.gl2d||[]),i=e?H.findSubplotsWithAxis(n,e):n;return i.sort((function(t,e){var r=t.substr(1).split('y'),n=e.substr(1).split('y');return r[0]===n[0]?+r[1]-+n[1]:+r[0]-+n[0]})),i},H.findSubplotsWithAxis=function(t,e){for(var r=new RegExp("x"===e._id.charAt(0)?"^"+e._id+"y":e._id+"$"),n=[],i=0;i<t.length;i++){var a=t[i];r.test(a)&&n.push(a)}return n},H.makeClipPaths=function(t){var e=t._fullLayout;if(!e._hasOnlyLargeSploms){var r,i,a={_offset:0,_length:e.width,_id:""},o={_offset:0,_length:e.height,_id:""},s=H.list(t,'x',!0),l=H.list(t,'y',!0),c=[];for(r=0;r<s.length;r++)for(c.push({x:s[r],y:o}),i=0;i<l.length;i++)0===r&&c.push({x:a,y:l[i]}),c.push({x:s[r],y:l[i]});var u=e._clips.selectAll('.axesclip').data(c,(function(t){return t.x._id+t.y._id}));u.enter().append('clipPath').classed('axesclip',!0).attr('id',(function(t){return"clip"+e._uid+t.x._id+t.y._id})).append('rect'),u.exit().remove(),u.each((function(t){n.select(this).select('rect').attr({x:t.x._offset||0,y:t.y._offset||0,width:t.x._length||1,height:t.y._length||1})}))}},H.draw=function(t,e,r){var n=t._fullLayout;"redraw"===e&&n._paper.selectAll('g.subplot').each((function(t){var e=t[0],r=n._plots[e];if(r){var i=r.xaxis,a=r.yaxis;r.xaxislayer.selectAll("."+i._id+"tick").remove(),r.yaxislayer.selectAll("."+a._id+"tick").remove(),r.xaxislayer.selectAll("."+i._id+"tick2").remove(),r.yaxislayer.selectAll("."+a._id+"tick2").remove(),r.xaxislayer.selectAll("."+i._id+"divider").remove(),r.yaxislayer.selectAll("."+a._id+"divider").remove(),r.gridlayer&&r.gridlayer.selectAll('path').remove(),r.zerolinelayer&&r.zerolinelayer.selectAll('path').remove(),n._infolayer.select(".g-"+i._id+"title").remove(),n._infolayer.select(".g-"+a._id+"title").remove()}}));var i=e&&"redraw"!==e?e:H.listIds(t);return s.syncOrAsync(i.map((function(e){return function(){if(e){var n=H.getFromId(t,e),i=H.drawOne(t,n,r);return n._r=n.range.slice(),n._rl=s.simpleMap(n._r,n.r2l),i}}})))},H.drawOne=function(t,e,r){var n,i,l;r=r||{},e.setScale();var c=t._fullLayout,u=e._id,f=u.charAt(0),h=H.counterLetter(u),p=c._plots[e._mainSubplot];if(p){var d=p[f+"axislayer"],m=e._mainLinePosition,g=e._mainMirrorPosition,v=e._vals=H.calcTicks(e),y=[e.mirror,m,g].join('_');for(n=0;n<v.length;n++)v[n].axInfo=y;e._selections={},e._tickAngles&&(e._prevTickAngles=e._tickAngles),e._tickAngles={},e._depth=null;var x={};if(e.visible){var b,_,w=H.makeTransTickFn(e),T=H.makeTransTickLabelFn(e),k="inside"===e.ticks,M="outside"===e.ticks;if("boundaries"===e.tickson){var A=St(e,v);_=H.clipEnds(e,A),b=k?_:A}else _=H.clipEnds(e,v),b=k&&"period"!==e.ticklabelmode?_:v;var S=e._gridVals=_,E=Lt(e,v);if(!c._hasOnlyLargeSploms){var L=e._subplotsWith,C={};for(n=0;n<L.length;n++){i=L[n];var P=(l=c._plots[i])[h+"axis"],I=P._mainAxis._id;if(!C[I]){C[I]=1;var z="x"===f?"M0,"+P._offset+"v"+P._length:"M"+P._offset+",0h"+P._length;H.drawGrid(t,e,{vals:S,counterAxis:P,layer:l.gridlayer.select("."+u),path:z,transFn:w}),H.drawZeroLine(t,e,{counterAxis:P,layer:l.zerolinelayer,path:z,transFn:w})}}}var O=H.getTickSigns(e),D=[];if(e.ticks){var R,F,B,N=H.makeTickPath(e,m,O[2]);if(e._anchorAxis&&e.mirror&&!0!==e.mirror?(R=H.makeTickPath(e,g,O[3]),F=N+R):(R='',F=N),e.showdividers&&M&&"boundaries"===e.tickson){var V={};for(n=0;n<E.length;n++)V[E[n].x]=1;B=function(t){return V[t.x]?R:F}}else B=F;H.drawTicks(t,e,{vals:b,layer:d,path:B,transFn:w}),"allticks"===e.mirror&&(D=Object.keys(e._linepositions||{}))}for(n=0;n<D.length;n++){i=D[n],l=c._plots[i];var q=e._linepositions[i]||[],G=H.makeTickPath(e,q[0],O[0])+H.makeTickPath(e,q[1],O[1]);H.drawTicks(t,e,{vals:b,layer:l[f+"axislayer"],path:G,transFn:w})}var Y=[];if(Y.push((function(){return H.drawLabels(t,e,{vals:v,layer:d,plotinfo:l,transFn:T,labelFns:H.makeLabelFns(e,m)})})),"multicategory"===e.type){var W={x:2,y:10}[f];Y.push((function(){var r={x:"height",y:"width"}[f],n=Z()[r]+W+(e._tickAngles[u+"tick"]?e.tickfont.size*j:0);return H.drawLabels(t,e,{vals:Et(e,v),layer:d,cls:u+"tick2",repositionOnUpdate:!0,secondary:!0,transFn:w,labelFns:H.makeLabelFns(e,m+n*O[4])})})),Y.push((function(){return e._depth=O[4]*(Z('tick2')[e.side]-m),Ot(t,e,{vals:E,layer:d,path:H.makeTickPath(e,m,O[4],e._depth),transFn:w})}))}else e.title.hasOwnProperty('standoff')&&Y.push((function()[e._depth=O[4]*(Z()[e.side]-m)]));var X=o.getComponentMethod('rangeslider','isVisible')(e);return Y.push((function(){var r,n,i,s,l=e.side.charAt(0),u=U[e.side].charAt(0),p=H.getPxPosition(t,e),d=M?e.ticklen:0;if((e.automargin||X)&&("multicategory"===e.type?r=Z('tick2'):(r=Z(),"x"===f&&"b"===l&&(e._depth=Math.max(r.width>0?r.bottom-p:0,d)))),e.automargin){n={x:0,y:0,r:0,l:0,t:0,b:0};var m=[0,1];if("x"===f){if("b"===l?n[l]=e._depth:(n[l]=e._depth=Math.max(r.width>0?p-r.top:0,d),m.reverse()),r.width>0){var g=r.right-(e._offset+e._length);g>0&&(n.xr=1,n.r=g);var v=e._offset-r.left;v>0&&(n.xl=0,n.l=v)}}else if("l"===l?n[l]=e._depth=Math.max(r.height>0?p-r.left:0,d):(n[l]=e._depth=Math.max(r.height>0?r.right-p:0,d),m.reverse()),r.height>0){var y=r.bottom-(e._offset+e._length);y>0&&(n.yb=0,n.b=y);var x=e._offset-r.top;x>0&&(n.yt=1,n.t=x)}n[h]="free"===e.anchor?e.position:e._anchorAxis.domain[m[0]],e.title.text!==c._dfltTitle[f]&&(n[l]+=Dt(e)+(e.title.standoff||0)),e.mirror&&"free"!==e.anchor&&((i={x:0,y:0,r:0,l:0,t:0,b:0})[u]=e.linewidth,e.mirror&&!0!==e.mirror&&(i[u]+=d),!0===e.mirror||"ticks"===e.mirror?i[h]=e._anchorAxis.domain[m[1]]:"all"!==e.mirror&&"allticks"!==e.mirror||(i[h]=[e._counterDomainMin,e._counterDomainMax][m[1]]))}X&&(s=o.getComponentMethod('rangeslider','autoMarginOpts')(t,e)),a.autoMargin(t,Ut(e),n),a.autoMargin(t,Vt(e),i),a.autoMargin(t,Ht(e),s)})),r.skipTitle||X&&"bottom"===e.side||Y.push((function(){return Rt(t,e)})),s.syncOrAsync(Y)}}function Z(t){var r=u+(t||"tick");return x[r]||(x[r]=Ct(e,r)),x[r]}},H.getTickSigns=function(t){var e=t._id.charAt(0),r={x:"top",y:"right"}[e],n=t.side===r?1:-1,i=[-1,1,n,-n];return"inside"!==t.ticks===("x"===e)&&(i=i.map((function(t){return-t}))),t.side&&i.push({l:-1,t:-1,r:1,b:1}[t.side.charAt(0)]),i},H.makeTransTickFn=function(t){return"x"===t._id.charAt(0)?function(e){return l(t._offset+t.l2p(e.x),0)}:function(e){return l(0,t._offset+t.l2p(e.x))}},H.makeTransTickLabelFn=function(t){var e=It(t),r=e[0],n=e[1];return"x"===t._id.charAt(0)?function(e){return l(r+t._offset+t.l2p(Pt(e)),n)}:function(e){return l(n,r+t._offset+t.l2p(Pt(e)))}},H.makeTickPath=function(t,e,r,n){n=void 0!==n?n:t.ticklen;var i=t._id.charAt(0),a=(t.linewidth||1)/2;return"x"===i?"M0,"+(e+a*r)+"v"+n*r:"M"+(e+a*r)+",0h"+n*r},H.makeLabelFns=function(t,e,r){var n=t.ticklabelposition||"",a=function(t){return-1!==n.indexOf(t)},o=a('top'),l=a('left'),c=a('right'),u=a('bottom')||l||o||c,f=a('inside'),h="inside"===n&&"inside"===t.ticks||!f&&"outside"===t.ticks&&"boundaries"!==t.tickson,p=0,d=0,m=h?t.ticklen:0;if(f?m*=-1:u&&(m=0),h&&(p+=m,r)){var g=s.deg2rad(r);p=m*Math.cos(g)+1,d=m*Math.sin(g)}t.showticklabels&&(h||t.showline)&&(p+=.2*t.tickfont.size);var v,y,x,b,_,w={labelStandoff:p+=(t.linewidth||1)/2*(f?-1:1),labelShift:d},T=0,k=t.side,M=t._id.charAt(0),A=t.tickangle;if("x"===M)b=(_=!f&&"bottom"===k||f&&"top"===k)?1:-1,f&&(b*=-1),v=d*b,y=e+p*b,x=_?1:-.2,90===Math.abs(A)&&(f?x+=B:x=-90===A&&"bottom"===k?N:90===A&&"top"===k?B:.5,T=B/2*(A/90)),w.xFn=function(t){return t.dx+v+T*t.fontSize},w.yFn=function(t){return t.dy+y+t.fontSize*x},w.anchorFn=function(t,e){if(u){if(l)return'end';if(c)return"start"}return i(e)&&0!==e&&180!==e?e*b<0!==f?"end":"start":"middle"},w.heightFn=function(e,r,n){return r<-60||r>60?-.5*n:"top"===t.side!==f?-n:0};else if("y"===M){if(b=(_=!f&&"left"===k||f&&"right"===k)?1:-1,f&&(b*=-1),v=p,y=d*b,x=0,f||90!==Math.abs(A)||(x=-90===A&&"left"===k||90===A&&"right"===k?N:.5),f){var S=i(A)?+A:0;if(0!==S){var E=s.deg2rad(S);T=Math.abs(Math.sin(E))*N*b,x=0}}w.xFn=function(t){return t.dx+e-(v+t.fontSize*x)*b+T*t.fontSize},w.yFn=function(t){return t.dy+y+t.fontSize*B},w.anchorFn=function(t,e){return i(e)&&90===Math.abs(e)?"middle":_?"end":"start"},w.heightFn=function(e,r,n){return"right"===t.side&&(r*=-1),r<-30?-n:r<30?-.5*n:0}}return w},H.drawTicks=function(t,e,r)[r=r||{];var n=e._id+"tick",i=r.vals;"period"===e.ticklabelmode&&(i=i.slice()).shift();var a=r.layer.selectAll("path."+n).data(e.ticks?i:[],zt);a.exit().remove(),a.enter().append('path').classed(n,1).classed('ticks',1).classed('crisp',!1!==r.crisp).call(f.stroke,e.tickcolor).style('stroke-width',h.crispRound(t,e.tickwidth,1)+"px").attr('d',r.path).style('display',null),Kt(e,[D]),a.attr('transform',r.transFn)},H.drawGrid=function(t,e,r)[r=r||{];var n=e._id+"grid",i=r.vals,a=r.counterAxis;if(!1===e.showgrid)i=[];else if(a&&H.shouldShowZeroLine(t,e,a))for(var o="array"===e.tickmode,s=0;s<i.length;s++){var l=i[s].x;if(o?!l:Math.abs(l)<e.dtick/100){if(i=i.slice(0,s).concat(i.slice(s+1)),!o)break;s--}}var c=r.layer.selectAll("path."+n).data(i,zt);c.exit().remove(),c.enter().append('path').classed(n,1).classed('crisp',!1!==r.crisp),e._gw=h.crispRound(t,e.gridwidth,1),c.attr('transform',r.transFn).attr('d',r.path).call(f.stroke,e.gridcolor||"#ddd").style('stroke-width',e._gw+"px").style('display',null),Kt(e,[O]),"function"===typeof r.path&&c.attr('d',r.path)},H.drawZeroLine=function(t,e,r){r=r||r;var n=e._id+"zl",i=H.shouldShowZeroLine(t,e,r.counterAxis),a=r.layer.selectAll("path."+n).data(i?[x:0,id:e._id]:[]);a.exit().remove(),a.enter().append('path').classed(n,1).classed('zl',1).classed('crisp',!1!==r.crisp).each((function(){r.layer.selectAll('path').sort((function(t,e){return Y(t.id,e.id)}))})),a.attr('transform',r.transFn).attr('d',r.path).call(f.stroke,e.zerolinecolor||f.defaultLine).style('stroke-width',h.crispRound(t,e.zerolinewidth,e._gw||1)+"px").style('display',null),Kt(e,[z])},H.drawLabels=function(t,e,r)[r=r||{];var a=t._fullLayout,o=e._id,u=o.charAt(0),f=r.cls||o+"tick",p=r.vals,d=r.labelFns,m=r.secondary?0:e.tickangle,g=(e._prevTickAngles||{})[f],v=r.layer.selectAll("g."+f).data(e.showticklabels?p:[],zt),y=[];function x(t,a){t.each((function(t){var o=n.select(this),s=o.select('.text-math-group'),u=d.anchorFn(t,a),f=r.transFn.call(o.node(),t)+(i(a)&&0!==+a?" rotate('+a+','+d.xFn(t)+','+(d.yFn(t)-t.fontSize/2)+')":""),p=c.lineCount(o),m=j*t.fontSize,g=d.heightFn(t,i(a)?+a:0,(p-1)*m);if(g&&(f+=l(0,g)),s.empty()){var v=o.select('text');v.attr({transform:f,"text-anchor":u}),v.style('opacity',1),e._adjustTickLabelsOverflow&&e._adjustTickLabelsOverflow()}else{var y=h.bBox(s.node()).width*{end:-.5,start:.5}[u];s.attr('transform',f+l(y,0))}}))}function b(){return y.length&&Promise.all(y)}v.enter().append('g').classed(f,1).append('text').attr('text-anchor','middle').each((function(e){var r=n.select(this),i=t._promises.length;r.call(c.positionText,d.xFn(e),d.yFn(e)).call(h.font,e.font,e.fontSize,e.fontColor).text(e.text).call(c.convertToTspans,t),t._promises[i]?y.push(t._promises.pop().then((function(){x(r,m)}))):x(r,m)})),Kt(e,[R]),v.exit().remove(),r.repositionOnUpdate&&v.each((function(t){n.select(this).select('text').call(c.positionText,d.xFn(t),d.yFn(t))})),e._adjustTickLabelsOverflow=function(){var r=e.ticklabeloverflow;if(r&&"allow"!==r){var i=-1!==r.indexOf('hide'),o="x"===e._id.charAt(0),l=0,c=o?t._fullLayout.width:t._fullLayout.height;if(-1!==r.indexOf('domain')){var u=s.simpleMap(e.range,e.r2l);l=e.l2p(u[0])+e._offset,c=e.l2p(u[1])+e._offset}var f=Math.min(l,c),p=Math.max(l,c),d=e.side,m=1/0,g=-1/0;for(var y in v.each((function(t){var r=n.select(this);if(r.select('.text-math-group').empty()){var a=h.bBox(r.node()),s=0;o?(a.right>p||a.left<f)&&(s=1):(a.bottom>p||a.top+(e.tickangle?0:t.fontSize/4)<f)&&(s=1);var l=r.select('text');s?i&&l.style('opacity',0):(l.style('opacity',1),m="bottom"===d||"right"===d?Math.min(m,o?a.top:a.left):-1/0,g="top"===d||"left"===d?Math.max(g,o?a.bottom:a.right):1/0)}})),a._plots){var x=a._plots[y];if(e._id===x.xaxis._id||e._id===x.yaxis._id){var b=o?x.yaxis:x.xaxis;b&&(b["_visibleLabelMin_"+e._id]=m,b["_visibleLabelMax_"+e._id]=g)}}}},e._hideCounterAxisInsideTickLabels=function(t){var r="x"===e._id.charAt(0),i=[];for(var o in a._plots){var s=a._plots[o];e._id!==s.xaxis._id&&e._id!==s.yaxis._id||i.push(r?s.yaxis:s.xaxis)}i.forEach((function(r,i){r&&Jt(r)&&(t||[z,O,D,R]).forEach((function(t){var o="tick"===t.K&&"text"===t.L&&"period"===e.ticklabelmode,s=a._plots[e._mainSubplot];(t.K===z.K?s.zerolinelayer.selectAll("."+e._id+"zl"):t.K===O.K?s.gridlayer.selectAll("."+e._id):s[e._id.charAt(0)+"axislayer"]).each((function(){var a=n.select(this);t.L&&(a=a.selectAll(t.L)),a.each((function(a){var s=e.l2p(o?Pt(a):a.x)+e._offset,l=n.select(this);s<e["_visibleLabelMax_"+r._id]&&s>e["_visibleLabelMin_"+r._id]?l.style('display','none'):"tick"!==t.K||i||l.style('display',null)}))}))}))}))},x(v,g+1?g:m);var _=null;function w(){if(x(v,m),p.length&&"x"===u&&!i(m)&&("log"!==e.type||"D"!==String(e.dtick).charAt(0))){_=0;var t,n=0,a=[];if(v.each((function(t){n=Math.max(n,t.fontSize);var r=e.l2p(t.x),i=jt(this),o=h.bBox(i.node());a.push({top:0,bottom:10,height:10,left:r-o.width/2,right:r+o.width/2+2,width:o.width+2})})),"boundaries"!==e.tickson&&!e.showdividers||r.secondary){var o=p.length,l=Math.abs((p[o-1].x-p[0].x)*e._m)/(o-1),c=e.ticklabelposition||"",f=function(t){return-1!==c.indexOf(t)},d=f('top'),g=f('left'),y=f('right'),b=f('bottom')||g||d||y?(e.tickwidth||0)+2*V:0,w=l<2.5*n||"multicategory"===e.type;for(t=0;t<a.length-1;t++)if(s.bBoxIntersect(a[t],a[t+1],b)){_=w?90:30;break}}else{var T=2;for(e.ticks&&(T+=e.tickwidth/2),t=0;t<a.length;t++){var k=p[t].xbnd,M=a[t];if(null!==k[0]&&M.left-e.l2p(k[0])<T||null!==k[1]&&e.l2p(k[1])-M.right<T){_=90;break}}}_&&x(v,_)}}e._selections&&(e._selections[f]=v);var T=[b];e.automargin&&a._redrawFromAutoMarginCount&&90===g?(_=90,T.push((function(){x(v,g)}))):T.push(w),e._tickAngles&&T.push((function(){e._tickAngles[f]=null===_?i(m)?m:0:_}));var k=e._anchorAxis;k&&k.autorange&&Jt(e)&&!W(a,e._id)&&(a._insideTickLabelsAutorange||(a._insideTickLabelsAutorange={}),a._insideTickLabelsAutorange[k._name+".autorange"]=k.autorange,T.push((function(){v.each((function(t,r){var n=jt(this);n.select('.text-math-group').empty()&&(e._vals[r].bb=h.bBox(n.node()))}))})));var M=s.syncOrAsync(T);return M&&M.then&&t._promises.push(M),M},H.getPxPosition=function(t,e){var r,n=t._fullLayout._size,i=e._id.charAt(0),a=e.side;return"free"!==e.anchor?r=e._anchorAxis:"x"===i?r={_offset:n.t+(1-(e.position||0))*n.h,_length:0}:"y"===i&&(r={_offset:n.l+(e.position||0)*n.w,_length:0}),"top"===a||"left"===a?r._offset:"bottom"===a||"right"===a?r._offset+r._length:void 0},H.shouldShowZeroLine=function(t,e,r){var n=s.simpleMap(e.range,e.r2l);return n[0]*n[1]<=0&&e.zeroline&&("linear"===e.type||"-"===e.type)&&!(e.rangebreaks&&e.maskBreaks(0)===I)&&(Ft(e,0)||!Bt(t,e,r,n)||Nt(t,e))},H.clipEnds=function(t,e){return e.filter((function(e){return Ft(t,e.x)}))},H.allowAutoMargin=function(t){for(var e=H.list(t,'',!0),r=0;r<e.length;r++){var n=e[r];n.automargin&&(a.allowAutoMargin(t,Ut(n)),n.mirror&&a.allowAutoMargin(t,Vt(n))),o.getComponentMethod('rangeslider','isVisible')(n)&&a.allowAutoMargin(t,Ht(n))}},H.swap=function(t,e){for(var r=qt(t,e),n=0;n<r.length;n++)Yt(t,r[n].x,r[n].y)}},{"../../components/color":650,"../../components/drawing":672,"../../components/titles":748,"../../constants/alignment":755,"../../constants/numerical":763,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/plots":901,"../../registry":915,"./autorange":837,"./axis_autotype":839,"./axis_ids":842,"./clean_ticks":844,"./layout_attributes":853,"./set_convert":859,"@plotly/d3":58,"fast-isnumeric":246}],839:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../constants/numerical').BADNUM,o=i.isArrayOrTypedArray,s=i.isDateTime,l=i.cleanNumber,c=Math.round;function u(t,e){return e?n(t):"number"===typeof t}function f(t,e){for(var r=t.length,n=0;n<r;n++)if(u(t[n],e))return!0;return!1}function h(t,e){for(var r=t.length,i=p(r),a=0,o=0,l={},u=0;u<r;u+=i){var f=t[c(u)],h=String(f);l[h]||(l[h]=1,s(f,e)&&a++,n(f)&&o++)}return a>2*o}function p(t){return Math.max(1,(t-1)/1e3)}function d(t,e){for(var r=t.length,n=p(r),i=0,o=0,s={},u=0;u<r;u+=n){var f=t[c(u)],h=String(f);if(!s[h]){s[h]=1;var d=typeof f;"boolean"===d?o++:(e?l(f)!==a:"number"===d)?i++:"string"===d&&o++}}return o>2*i}function m(t){return o(t[0])&&o(t[1])}e.exports=function(t,e,r){var n=t,i=r.noMultiCategory;if(o(n)&&!n.length)return'-';if(!i&&m(n))return'multicategory';if(i&&Array.isArray(n[0])){for(var a=[],s=0;s<n.length;s++)if(o(n[s]))for(var l=0;l<n[s].length;l++)a.push(n[s][l]);n=a}if(h(n,e))return'date';var c="strict"!==r.autotypenumbers;return d(n,c)?"category":f(n,c)?"linear":"-"}},{"../../constants/numerical":763,"../../lib":787,"fast-isnumeric":246}],840:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../registry'),a=t('../../lib'),o=t('../array_container_defaults'),s=t('./layout_attributes'),l=t('./tick_value_defaults'),c=t('./tick_mark_defaults'),u=t('./tick_label_defaults'),f=t('./category_order_defaults'),h=t('./line_grid_defaults'),p=t('./set_convert'),d=t('./constants').WEEKDAY_PATTERN,m=t('./constants').HOUR_PATTERN;function g(t,e,r){function i(r,n){return a.coerce(t,e,s.rangebreaks,r,n)}if(i('enabled')){var o=i('bounds');if(o&&o.length>=2){var l,c,u='';if(2===o.length)for(l=0;l<2;l++)if(c=y(o[l])){u=d;break}var f=i('pattern',u);if(f===d)for(l=0;l<2;l++)(c=y(o[l]))&&(e.bounds[l]=o[l]=c-1);if(f)for(l=0;l<2;l++)switch(c=o[l],f){case d:if(!n(c))return void(e.enabled=!1);if((c=+c)!==Math.floor(c)||c<0||c>=7)return void(e.enabled=!1);e.bounds[l]=o[l]=c;break;case m:if(!n(c))return void(e.enabled=!1);if((c=+c)<0||c>24)return void(e.enabled=!1);e.bounds[l]=o[l]=c}if(!1===r.autorange){var h=r.range;if(h[0]<h[1]){if(o[0]<h[0]&&o[1]>h[1])return void(e.enabled=!1)}else if(o[0]>h[0]&&o[1]<h[1])return void(e.enabled=!1)}}else{var p=i('values');if(!p||!p.length)return void(e.enabled=!1);i('dvalue')}}}e.exports=function(t,e,r,n,m){var v,y=n.letter,x=n.font||{},b=n.splomStash||{},_=r('visible',!n.visibleDflt),w=e._template||{},T=e.type||w.type||"-";"date"===T&&(i.getComponentMethod('calendars','handleDefaults')(t,e,'calendar',n.calendar),n.noTicklabelmode||(v=r('ticklabelmode')));var k='';n.noTicklabelposition&&"multicategory"!==T||(k=a.coerce(t,e,{ticklabelposition:{valType:"enumerated",dflt:"outside",values:"period"===v?["outside","inside"]:"x"===y?["outside",'inside','outside left','inside left','outside right',"inside right"]:["outside",'inside','outside top','inside top','outside bottom',"inside bottom"]}},'ticklabelposition')),n.noTicklabeloverflow||r('ticklabeloverflow',-1!==k.indexOf('inside')?"hide past domain":"category"===T||"multicategory"===T?"allow":"hide past div"),p(e,m);var M=!e.isValidRange(t.range);M&&n.reverseDflt&&(M='reversed'),!r('autorange',M)||"linear"!==T&&"-"!==T||r('rangemode'),r('range'),e.cleanRange(),f(t,e,r,n),"category"===T||n.noHover||r('hoverformat');var A=r('color'),S=A!==s.color.dflt?A:x.color,E=b.label||m._dfltTitle[y];if(u(t,e,r,T,n,{pass:1}),!_)return e;r('title.text',E),a.coerceFont(r,'title.font',{family:x.family,size:a.bigFont(x.size),color:S}),l(t,e,r,T),u(t,e,r,T,n,{pass:2}),c(t,e,r,n),h(t,e,r,{dfltColor:A,bgColor:n.bgColor,showGrid:n.showGrid,attributes:s}),(e.showline||e.ticks)&&r('mirror'),n.automargin&&r('automargin');var L,C="multicategory"===T;if(n.noTickson||"category"!==T&&!C||!e.ticks&&!e.showgrid||(C&&(L='boundaries'),"boundaries"===r('tickson',L)&&delete e.ticklabelposition),C&&r('showdividers')&&(r('dividercolor'),r('dividerwidth')),"date"===T)if(o(t,e,{name:"rangebreaks",inclusionAttr:"enabled",handleItemDefaults:g}),e.rangebreaks.length){for(var P=0;P<e.rangebreaks.length;P++)if(e.rangebreaks[P].pattern===d){e._hasDayOfWeekBreaks=!0;break}if(p(e,m),m._has('scattergl')||m._has('splom'))for(var I=0;I<n.data.length;I++){var z=n.data[I];"scattergl"!==z.type&&"splom"!==z.type||(z.visible=!1,a.warn(z.type+" traces do not work on axes with rangebreaks. Setting trace '+z.index+' to `visible: false`."))}}else delete e.rangebreaks;return e};var v={sun:1,mon:2,tue:3,wed:4,thu:5,fri:6,sat:7};function y(t){if("string"===typeof t)return v[t.substr(0,3).toLowerCase()]}},{"../../lib":787,"../../registry":915,"../array_container_defaults":833,"./category_order_defaults":843,"./constants":845,"./layout_attributes":853,"./line_grid_defaults":855,"./set_convert":859,"./tick_label_defaults":860,"./tick_mark_defaults":861,"./tick_value_defaults":862,"fast-isnumeric":246}],841:[function(t,e,r){"use strict";var n=t('../../constants/docs'),i=n.FORMAT_LINK,a=n.DATE_FORMAT_LINK;function o(t,e){return{valType:"string",dflt:"",editType:"none",description:(e?s:l)('hover text',t)+["By default the values are formatted using "+(e?"generic number format":"`"+t+"axis.hoverformat`")+"."].join(' ')}}function s(t,e){return["Sets the '+t+' formatting rule"+(e?"for `"+e+"` ":""),'using d3 formatting mini-languages',"which are very similar to those in Python. For numbers, see: '+i+'."].join(' ')}function l(t,e){return s(t,e)+[" And for dates see: '+a+'.",'We add two items to d3's date formatter:','*%h* for half of the year as a decimal number as well as','*%{n}f* for fractional seconds','with n digits. For example, *2016-10-13 09:15:23.456* with tickformat',"*%H~%M~%S.%2f* would display *09~15~23.46*"].join(' ')}e.exports={axisHoverFormat:o,descriptionOnlyNumbers:s,descriptionWithDates:l}},{"../../constants/docs":758}],842:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('./constants');function a(t,e){if(e&&e.length)for(var r=0;r<e.length;r++)if(e[r][t])return!0;return!1}r.id2name=function(t){if("string"===typeof t&&t.match(i.AX_ID_PATTERN)){var e=t.split(' ')[0].substr(1);return"1"===e&&(e=''),t.charAt(0)+"axis"+e}},r.name2id=function(t){if(t.match(i.AX_NAME_PATTERN)){var e=t.substr(5);return"1"===e&&(e=''),t.charAt(0)+e}},r.cleanId=function(t,e,r){var n=/( domain)$/.test(t);if("string"===typeof t&&t.match(i.AX_ID_PATTERN)&&(!e||t.charAt(0)===e)&&(!n||r)){var a=t.split(' ')[0].substr(1).replace(/^0+/,'');return"1"===a&&(a=''),t.charAt(0)+a+(n&&r?" domain":"")}},r.list=function(t,e,n){var i=t._fullLayout;if(!i)return[];var a,o=r.listIds(t,e),s=new Array(o.length);for(a=0;a<o.length;a++){var l=o[a];s[a]=i[l.charAt(0)+"axis"+l.substr(1)]}if(!n){var c=i._subplots.gl3d||[];for(a=0;a<c.length;a++){var u=i[c[a]];e?s.push(u[e+"axis"]):s.push(u.xaxis,u.yaxis,u.zaxis)}}return s},r.listIds=function(t,e){var r=t._fullLayout;if(!r)return[];var n=r._subplots;return e?n[e+"axis"]:n.xaxis.concat(n.yaxis)},r.getFromId=function(t,e,n){var i=t._fullLayout;return e=void 0===e||"string"!==typeof e?e:e.replace(' domain',''),"x"===n?e=e.replace(/y[0-9]*/,''):"y"===n&&(e=e.replace(/x[0-9]*/,'')),i[r.id2name(e)]},r.getFromTrace=function(t,e,i){var a=t._fullLayout,o=null;if(n.traceIs(e,'gl3d')){var s=e.scene;"scene"===s.substr(0,5)&&(o=a[s][i+"axis"])}else o=r.getFromId(t,e[i+"axis"]||i);return o},r.idSort=function(t,e){var r=t.charAt(0),n=e.charAt(0);return r!==n?r>n?1:-1:+(t.substr(1)||1)-+(e.substr(1)||1)},r.ref2id=function(t){return!!/^[xyz]/.test(t)&&t.split(' ')[0]},r.isLinked=function(t,e){return a(e,t._axisMatchGroups)||a(e,t._axisConstraintGroups)}},{"../../registry":915,"./constants":845}],843:[function(t,e,r){"use strict";function n(t,e){var r,n,i,a=e.dataAttr||t._id.charAt(0),o={};if(e.axData)r=e.axData;else for(r=[],n=0;n<e.data.length;n++){var s=e.data[n];s[a+"axis"]===t._id&&r.push(s)}for(n=0;n<r.length;n++){var l=r[n][a];for(i=0;i<l.length;i++){var c=l[i];null!==c&&void 0!==c&&(o[c]=1)}}return Object.keys(o)}e.exports=function(t,e,r,i){if("category"===e.type){var a,o=t.categoryarray,s=Array.isArray(o)&&o.length>0;s&&(a='array');var l,c=r('categoryorder',a);"array"===c&&(l=r('categoryarray')),s||"array"!==c||(c=e.categoryorder='trace'),"trace"===c?e._initialCategories=[]:"array"===c?e._initialCategories=l.slice():(l=n(e,i).sort(),"category ascending"===c?e._initialCategories=l:"category descending"===c&&(e._initialCategories=l.reverse()))}}},{}],844:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../constants/numerical'),o=a.ONEDAY,s=a.ONEWEEK;r.dtick=function(t,e){var r="log"===e,i="date"===e,a="category"===e,s=i?o:1;if(!t)return s;if(n(t))return(t=Number(t))<=0?s:a?Math.max(1,Math.round(t)):i?Math.max(.1,t):t;if("string"!==typeof t||!i&&!r)return s;var l=t.charAt(0),c=t.substr(1);return(c=n(c)?Number(c):0)<=0||!(i&&"M"===l&&c===Math.round(c)||r&&"L"===l||r&&"D"===l&&(1===c||2===c))?s:t},r.tick0=function(t,e,r,a){return"date"===e?i.cleanDate(t,i.dateTick0(r,a%s===0?1:0)):"D1"!==a&&"D2"!==a?n(t)?Number(t):0:void 0}},{"../../constants/numerical":763,"../../lib":787,"fast-isnumeric":246}],845:[function(t,e,r){"use strict";var n=t('../../lib/regex').counter;e.exports={idRegex:{x:n('x','( domain)?'),y:n('y','( domain)?')},attrRegex:n('[xy]axis'),xAxisMatch:n('xaxis'),yAxisMatch:n('yaxis'),AX_ID_PATTERN:/^[xyz][0-9]*( domain)?$/,AX_NAME_PATTERN:/^[xyz]axis[0-9]*$/,SUBPLOT_PATTERN:/^x([0-9]*)y([0-9]*)$/,HOUR_PATTERN:"hour",WEEKDAY_PATTERN:"day of week",MINDRAG:8,MINSELECT:12,MINZOOM:20,DRAGGERSIZE:20,BENDPX:1.5,REDRAWDELAY:50,SELECTDELAY:100,SELECTID:"-select",DFLTRANGEX:[-1,6],DFLTRANGEY:[-1,4],traceLayerClasses:["imagelayer",'heatmaplayer','contourcarpetlayer','contourlayer','funnellayer','waterfalllayer','barlayer','carpetlayer','violinlayer','boxlayer','ohlclayer','scattercarpetlayer',"scatterlayer"],clipOnAxisFalseQuery:[".scatterlayer",'.barlayer','.funnellayer',".waterfalllayer"],layerValue2layerClass:{"above traces":"above","below traces":"below"}}},{"../../lib/regex":804}],846:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./autorange'),a=t('./axis_ids').id2name,o=t('./layout_attributes'),s=t('./scale_zoom'),l=t('./set_convert'),c=t('../../constants/numerical').ALMOST_EQUAL,u=t('../../constants/alignment').FROM_BL;function f(t,e,r){var i=r.axIds,s=r.layoutOut,l=r.hasImage,c=s._axisConstraintGroups,u=s._axisMatchGroups,f=e._id,m=f.charAt(0),g=((s._splomAxes||{})[m]||{})[f]||{},v=e._id,y="x"===v.charAt(0);function x(r,i){return n.coerce(t,e,o,r,i)}e._matchGroup=null,e._constraintGroup=null,x('constrain',l?"domain":"range"),n.coerce(t,e,{constraintoward:{valType:"enumerated",values:y?["left",'center',"right"]:["bottom",'middle',"top"],dflt:y?"center":"middle"}},'constraintoward');var b,_,w=e.type,T=[];for(b=0;b<i.length;b++)(_=i[b])!==v&&s[a(_)].type===w&&T.push(_);var k=p(c,v);if(k){var M=[];for(b=0;b<T.length;b++)k[_=T[b]]||M.push(_);T=M}var A,S,E=T.length;E&&(t.matches||g.matches)&&(A=n.coerce(t,e,{matches:{valType:"enumerated",values:T,dflt:-1!==T.indexOf(g.matches)?g.matches:void 0}},'matches'));var L=l&&!y?e.anchor:void 0;if(E&&!A&&(t.scaleanchor||L)&&(S=n.coerce(t,e,{scaleanchor:{valType:"enumerated",values:T}},'scaleanchor',L)),A){e._matchGroup=d(u,v,A,1);var C=s[a(A)],P=h(s,e)/h(s,C);y!==("x"===A.charAt(0))&&(P=(y?"x":"y")+P),d(c,v,A,P)}else t.matches&&-1!==i.indexOf(t.matches)&&n.warn("ignored "+e._name+'.matches: ''+t.matches+'' to avoid an infinite loop');if(S){var I=x('scaleratio');I||(I=e.scaleratio=1),d(c,v,S,I)}else t.scaleanchor&&-1!==i.indexOf(t.scaleanchor)&&n.warn("ignored "+e._name+'.scaleanchor: ''+t.scaleanchor+'' to avoid either an infinite loop and possibly inconsistent scaleratios, or because this axis declares a *matches* constraint.')}function h(t,e){var r=e.domain;return r||(r=t[a(e.overlaying)].domain),r[1]-r[0]}function p(t,e){for(var r=0;r<t.length;r++)if(t[r][e])return t[r];return null}function d(t,e,r,n){var i,a,o,s,l,c=p(t,e);null===c?((c={})[e]=1,l=t.length,t.push(c)):l=t.indexOf(c);var u=Object.keys(c);for(i=0;i<t.length;i++)if(o=t[i],i!==l&&o[r]){var f=o[r];for(a=0;a<u.length;a++)o[s=u[a]]=m(f,m(n,c[s]));return void t.splice(l,1)}if(1!==n)for(a=0;a<u.length;a++){var h=u[a];c[h]=m(n,c[h])}c[r]=1}function m(t,e){var r,n,i='',a='';"string"===typeof t&&(r=(i=t.match(/^[xy]*/)[0]).length,t=+t.substr(r)),"string"===typeof e&&(n=(a=e.match(/^[xy]*/)[0]).length,e=+e.substr(n));var o=t*e;return r||n?r&&n&&i.charAt(0)!==a.charAt(0)?r===n?o:(r>n?i.substr(n):a.substr(r))+o:i+a+t*e:o}function g(t,e){for(var r=e._size,n=r.h/r.w,i={},a=Object.keys(t),o=0;o<a.length;o++){var s=a[o],l=t[s];if("string"===typeof l){var c=l.match(/^[xy]*/)[0],u=c.length;l=+l.substr(u);for(var f="y"===c.charAt(0)?n:1/n,h=0;h<u;h++)l*=f}i[s]=l}return i}function v(t,e){var r=t._inputDomain,n=u[t.constraintoward],i=r[0]+(r[1]-r[0])*n;t.domain=t._input.domain=[i+(r[0]-i)/e,i+(r[1]-i)/e],t.setScale()}r.handleDefaults=function(t,e,r){var i,o,s,c,u,h,p,d,m=r.axIds,g=r.axHasImage,v=e._axisConstraintGroups=[],y=e._axisMatchGroups=[];for(i=0;i<m.length;i++)f(u=t[c=a(m[i])],h=e[c],{axIds:m,layoutOut:e,hasImage:g[c]});function x(t,r){for(i=0;i<t.length;i++)for(s in o=t[i])e[a(s)][r]=o}for(x(y,'_matchGroup'),i=0;i<v.length;i++)for(s in o=v[i])if((h=e[a(s)]).fixedrange){for(var b in o){var _=a(b);!1===(t[_]||{}).fixedrange&&n.warn('fixedrange was specified as false for axis '+_+' but was overridden because another axis in its constraint group has fixedrange true'),e[_].fixedrange=!0}break}for(i=0;i<v.length;){for(s in o=v[i]){(h=e[a(s)])._matchGroup&&Object.keys(h._matchGroup).length===Object.keys(o).length&&(v.splice(i,1),i--);break}i++}x(v,'_constraintGroup');var w=["constrain",'range','autorange','rangemode','rangebreaks','categoryorder',"categoryarray"],T=!1,k=!1;function M(){d=h[p],"rangebreaks"===p&&(k=h._hasDayOfWeekBreaks)}for(i=0;i<y.length;i++){o=y[i];for(var A=0;A<w.length;A++){var S;for(s in p=w[A],d=null,o)if(u=t[c=a(s)],h=e[c],p in h){if(!h.matches&&(S=h,p in u)){M();break}null===d&&p in u&&M()}if("range"===p&&d&&(T=!0),"autorange"===p&&null===d&&T&&(d=!1),null===d&&p in S&&(d=S[p]),null!==d)for(s in o)(h=e[a(s)])[p]="range"===p?d.slice():d,"rangebreaks"===p&&(h._hasDayOfWeekBreaks=k,l(h,e))}}},r.enforce=function(t){var e,r,n,o,l,u,f,h,p=t._fullLayout,d=p._axisConstraintGroups||[];for(e=0;e<d.length;e++){n=g(d[e],p);var m=Object.keys(n),y=1/0,x=0,b=1/0,_={},w={},T=!1;for(r=0;r<m.length;r++)w[o=m[r]]=l=p[a(o)],l._inputDomain?l.domain=l._inputDomain.slice():l._inputDomain=l.domain.slice(),l._inputRange||(l._inputRange=l.range.slice()),l.setScale(),_[o]=u=Math.abs(l._m)/n[o],y=Math.min(y,u),"domain"!==l.constrain&&l._constraintShrinkable||(b=Math.min(b,u)),delete l._constraintShrinkable,x=Math.max(x,u),"domain"===l.constrain&&(T=!0);if(!(y>c*x)||T)for(r=0;r<m.length;r++)if(u=_[o=m[r]],f=(l=w[o]).constrain,u!==b||"domain"===f)if(h=u/b,"range"===f)s(l,h);else{var k=l._inputDomain,M=(l.domain[1]-l.domain[0])/(k[1]-k[0]),A=(l.r2l(l.range[1])-l.r2l(l.range[0]))/(l.r2l(l._inputRange[1])-l.r2l(l._inputRange[0]));if((h/=M)*A<1){l.domain=l._input.domain=k.slice(),s(l,h);continue}if(A<1&&(l.range=l._input.range=l._inputRange.slice(),h*=A),l.autorange){var S=l.r2l(l.range[0]),E=l.r2l(l.range[1]),L=(S+E)/2,C=L,P=L,I=Math.abs(E-L),z=L-I*h*1.0001,O=L+I*h*1.0001,D=i.makePadFn(p,l,0),R=i.makePadFn(p,l,1);v(l,h);var F,B,N=Math.abs(l._m),j=i.concatExtremes(t,l),U=j.min,V=j.max;for(B=0;B<U.length;B++)(F=U[B].val-D(U[B])/N)>z&&F<C&&(C=F);for(B=0;B<V.length;B++)(F=V[B].val+R(V[B])/N)<O&&F>P&&(P=F);h/=(P-C)/(2*I),C=l.l2r(C),P=l.l2r(P),l.range=l._input.range=S<E?[C,P]:[P,C]}v(l,h)}}},r.getAxisGroup=function(t,e){for(var r=t._axisMatchGroups,n=0;n<r.length;n++)if(r[n][e])return"g"+n;return e},r.clean=function(t,e){if(e._inputDomain){for(var r=!1,n=e._id,i=t._fullLayout._axisConstraintGroups,a=0;a<i.length;a++)if(i[a][n]){r=!0;break}r&&"domain"===e.constrain||(e._input.domain=e.domain=e._inputDomain,delete e._inputDomain)}}},{"../../constants/alignment":755,"../../constants/numerical":763,"../../lib":787,"./autorange":837,"./axis_ids":842,"./layout_attributes":853,"./scale_zoom":857,"./set_convert":859}],847:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=i.numberFormat,o=t('tinycolor2'),s=t('has-passive-events'),l=t('../../registry'),c=i.strTranslate,u=t('../../lib/svg_text_utils'),f=t('../../components/color'),h=t('../../components/drawing'),p=t('../../components/fx'),d=t('./axes'),m=t('../../lib/setcursor'),g=t('../../components/dragelement'),v=t('../../components/dragelement/helpers'),y=v.selectingOrDrawing,x=v.freeMode,b=t('../../constants/alignment').FROM_TL,_=t('../../lib/clear_gl_canvases'),w=t('../../plot_api/subroutines').redrawReglTraces,T=t('../plots'),k=t('./axis_ids').getFromId,M=t('./select').prepSelect,A=t('./select').clearSelect,S=t('./select').selectOnClick,E=t('./scale_zoom'),L=t('./constants'),C=L.MINDRAG,P=L.MINZOOM,I=!0;function z(t,e,r,a,s,c,f,m){var v,I,z,O,G,tt,et,rt,nt,it,at,ot,st,lt,ct,ut,ft,ht,pt,dt,mt,gt,vt,yt=t._fullLayout._zoomlayer,xt=f+m==='nsew',bt=1===(f+m).length;function _t(){if(v=e.xaxis,I=e.yaxis,nt=v._length,it=I._length,et=v._offset,rt=I._offset,(z={})[v._id]=v,(O={})[I._id]=I,f&&m)for(var r=e.overlays,n=0;n<r.length;n++){var i=r[n].xaxis;z[i._id]=i;var a=r[n].yaxis;O[a._id]=a}G=$(z),tt=$(O),st=R(G,m),lt=R(tt,f),ct=!lt&&!st,ot=K(t,t._fullLayout._axisMatchGroups,z,O);var o=(at=K(t,t._fullLayout._axisConstraintGroups,z,O,ot)).isSubplotConstrained||ot.isSubplotConstrained;ut=m||o,ft=f||o;var s=t._fullLayout;ht=s._has('scattergl'),pt=s._has('splom'),dt=s._has('svg')}_t();var wt=U(lt+st,t._fullLayout.dragmode,xt),Tt=D(e,f+m+"drag",wt,r,a,s,c);if(ct&&!xt)return Tt.onmousedown=null,Tt.style.pointerEvents='none',Tt;var kt,Mt,At,St,Et,Lt,Ct,Pt,It,zt,Ot={element:Tt,gd:t,plotinfo:e};function Dt(){Ot.plotinfo.selection=!1,A(t)}function Rt(t,r){var i=Ot.gd;if(i._fullLayout._activeShapeIndex>=0)i._fullLayout._deactivateShape(i);else{var a=i._fullLayout.clickmode;if(Y(i),2!==t||bt||Zt(),xt)a.indexOf('select')>-1&&S(r,i,G,tt,e.id,Ot),a.indexOf('event')>-1&&p.click(i,r,e.id);else if(1===t&&bt){var o=f?I:v,s="s"===f||"w"===m?0:1,c=o._name+".range["+s+"]",h=F(o,s),d='left',g='middle';if(o.fixedrange)return;f?(g="n"===f?"top":"bottom","right"===o.side&&(d='right')):"e"===m&&(d='right'),i._context.showAxisRangeEntryBoxes&&n.select(Tt).call(u.makeEditable,{gd:i,immediate:!0,background:i._fullLayout.paper_bgcolor,text:String(h),fill:o.tickfont?o.tickfont.color:"#444",horizontalAlign:d,verticalAlign:g}).on('edit',(function(t){var e=o.d2r(t);void 0!==e&&l.call('_guiRelayout',i,c,e)}))}}}function Ft(e,r,n){var a=Tt.getBoundingClientRect();kt=r-a.left,Mt=n-a.top,t._fullLayout._calcInverseTransform(t);var s=i.apply3DTransform(t._fullLayout._invTransform)(kt,Mt);kt=s[0],Mt=s[1],At={l:kt,r:kt,w:0,t:Mt,b:Mt,h:0},St=t._hmpixcount?t._hmlumcount/t._hmpixcount:o(t._fullLayout.plot_bgcolor).getLuminance(),Lt=!1,Ct='xy',zt=!1,Pt=V(yt,St,et,rt,Et="M0,0H"+nt+"V"+it+"H0V0"),It=H(yt,et,rt)}function Bt(e,r){if(t._transitioningWithDuration)return!1;var n=Math.max(0,Math.min(nt,gt*e+kt)),i=Math.max(0,Math.min(it,vt*r+Mt)),a=Math.abs(n-kt),o=Math.abs(i-Mt);function s(){Ct='',At.r=At.l,At.t=At.b,It.attr('d','M0,0Z')}if(At.l=Math.min(kt,n),At.r=Math.max(kt,n),At.t=Math.min(Mt,i),At.b=Math.max(Mt,i),at.isSubplotConstrained)a>P||o>P?(Ct='xy',a/nt>o/it?(o=a*it/nt,Mt>i?At.t=Mt-o:At.b=Mt+o):(a=o*nt/it,kt>n?At.l=kt-a:At.r=kt+a),It.attr('d',J(At))):s();else if(ot.isSubplotConstrained)if(a>P||o>P){Ct='xy';var l=Math.min(At.l/nt,(it-At.b)/it),c=Math.max(At.r/nt,(it-At.t)/it);At.l=l*nt,At.r=c*nt,At.b=(1-l)*it,At.t=(1-c)*it,It.attr('d',J(At))}else s();else!lt||o<Math.min(Math.max(.6*a,C),P)?a<C||!st?s():(At.t=0,At.b=it,Ct='x',It.attr('d',X(At,Mt))):!st||a<Math.min(.6*o,P)?(At.l=0,At.r=nt,Ct='y',It.attr('d',Z(At,kt))):(Ct='xy',It.attr('d',J(At)));At.w=At.r-At.l,At.h=At.b-At.t,Ct&&(zt=!0),t._dragged=zt,q(Pt,It,At,Et,Lt,St),Nt(),t.emit('plotly_relayouting',mt),Lt=!0}function Nt()[mt={],"xy"!==Ct&&"x"!==Ct||(B(G,At.l/nt,At.r/nt,mt,at.xaxes),Wt('x',mt)),"xy"!==Ct&&"y"!==Ct||(B(tt,(it-At.b)/it,(it-At.t)/it,mt,at.yaxes),Wt('y',mt))}function jt(){Nt(),Y(t),Jt(),W(t)}Ot.prepFn=function(e,r,n){var i=Ot.dragmode,a=t._fullLayout.dragmode;a!==i&&(Ot.dragmode=a),_t(),gt=t._fullLayout._invScaleX,vt=t._fullLayout._invScaleY,ct||(xt?e.shiftKey?"pan"===a?a="zoom":y(a)||(a='pan'):e.ctrlKey&&(a='pan'):a='pan'),x(a)?Ot.minDrag=1:Ot.minDrag=void 0,y(a)?(Ot.xaxes=G,Ot.yaxes=tt,M(e,r,n,Ot,a)):(Ot.clickFn=Rt,y(i)&&Dt(),ct||("zoom"===a?(Ot.moveFn=Bt,Ot.doneFn=jt,Ot.minDrag=1,Ft(e,r,n)):"pan"===a&&(Ot.moveFn=Yt,Ot.doneFn=Jt))),t._fullLayout._redrag=function(){var e=t._dragdata;if(e&&e.element===Tt){var r=t._fullLayout.dragmode;y(r)||(_t(),Kt([0,0,nt,it]),Ot.moveFn(e.dx,e.dy))}}},g.init(Ot);var Ut=[0,0,nt,it],Vt=null,Ht=L.REDRAWDELAY,qt=e.mainplot?t._fullLayout._plots[e.mainplot]:e;function Gt(e){if(t._context._scrollZoom.cartesian||t._fullLayout._enablescrollzoom){if(Dt(),t._transitioningWithDuration)return e.preventDefault(),void e.stopPropagation();_t(),clearTimeout(Vt);var r=-e.deltaY;if(isFinite(r)||(r=e.wheelDelta/10),isFinite(r)){var n,a=Math.exp(-Math.min(Math.max(r,-20),20)/200),o=qt.draglayer.select('.nsewdrag').node().getBoundingClientRect(),s=(e.clientX-o.left)/o.width,l=(o.bottom-e.clientY)/o.height;if(ut){for(m||(s=.5),n=0;n<G.length;n++)c(G[n],s,a);Wt('x'),Ut[2]*=a,Ut[0]+=Ut[2]*s*(1/a-1)}if(ft){for(f||(l=.5),n=0;n<tt.length;n++)c(tt[n],l,a);Wt('y'),Ut[3]*=a,Ut[1]+=Ut[3]*(1-l)*(1/a-1)}Kt(Ut),Xt(),t.emit('plotly_relayouting',mt),Vt=setTimeout((function(){t._fullLayout&&(Ut=[0,0,nt,it],Jt())}),Ht),e.preventDefault()}else i.log('Did not find wheel motion attributes: ',e)}function c(t,e,r){if(!t.fixedrange){var n=i.simpleMap(t.range,t.r2l),a=n[0]+(n[1]-n[0])*e;t.range=n.map(o)}function o(e){return t.l2r(a+(e-a)*r)}}}function Yt(e,r){if(e*=gt,r*=vt,!t._transitioningWithDuration){if(t._fullLayout._replotting=!0,"ew"===st||"ns"===lt){var n=st?-e:0,i=lt?-r:0;if(ot.isSubplotConstrained){if(st&&lt){var a=(e/nt-r/it)/2;n=-(e=a*nt),i=-(r=-a*it)}lt?n=-i*nt/it:i=-n*it/nt}return st&&(N(G,e),Wt('x')),lt&&(N(tt,r),Wt('y')),Kt([n,i,nt,it]),Xt(),void t.emit('plotly_relayouting',mt)}var o,s,l="w"===st===("n"===lt)?1:-1;if(st&&lt&&(at.isSubplotConstrained||ot.isSubplotConstrained)){var c=(e/nt+l*r/it)/2;e=c*nt,r=l*c*it}if("w"===st?e=p(G,0,e):"e"===st?e=p(G,1,-e):st||(e=0),"n"===lt?r=p(tt,1,r):"s"===lt?r=p(tt,0,-r):lt||(r=0),o="w"===st?e:0,s="n"===lt?r:0,at.isSubplotConstrained&&!ot.isSubplotConstrained||ot.isSubplotConstrained&&st&&lt&&l>0){var u;if(ot.isSubplotConstrained||!st&&1===lt.length){for(u=0;u<G.length;u++)G[u].range=G[u]._r.slice(),E(G[u],1-r/it);o=(e=r*nt/it)/2}if(ot.isSubplotConstrained||!lt&&1===st.length){for(u=0;u<tt.length;u++)tt[u].range=tt[u]._r.slice(),E(tt[u],1-e/nt);s=(r=e*it/nt)/2}}ot.isSubplotConstrained&&lt||Wt('x'),ot.isSubplotConstrained&&st||Wt('y');var f=nt-e,h=it-r;!ot.isSubplotConstrained||st&&lt||(st?(s=o?0:e*it/nt,h=f*it/nt):(o=s?0:r*nt/it,f=h*nt/it)),Kt([o,s,f,h]),Xt(),t.emit('plotly_relayouting',mt)}function p(t,e,r){for(var n,i,a=1-e,o=0;o<t.length;o++){var s=t[o];if(!s.fixedrange){n=s,i=s._rl[a]+(s._rl[e]-s._rl[a])/j(r/s._length);var l=s.l2r(i);!1!==l&&void 0!==l&&(s.range[e]=l)}}return n._length*(n._rl[e]-i)/(n._rl[e]-n._rl[a])}}function Wt(t,e){for(var r=ot.isSubplotConstrained?{x:tt,y:G}[t]:ot[t+"axes"],n=ot.isSubplotConstrained?{x:G,y:tt}[t]:[],i=0;i<r.length;i++){var a=r[i],o=a._id,s=ot.xLinks[o]||ot.yLinks[o],l=n[0]||z[s]||O[s];l&&(e?(e[a._name+".range[0]"]=e[l._name+".range[0]"],e[a._name+".range[1]"]=e[l._name+".range[1]"]):a.range=l.range.slice())}}function Xt(){var e,r=[];function n(t){for(e=0;e<t.length;e++)t[e].fixedrange||r.push(t[e]._id)}for(ut&&(n(G),n(at.xaxes),n(ot.xaxes)),ft&&(n(tt),n(at.yaxes),n(ot.yaxes)),mt={},e=0;e<r.length;e++){var i=r[e],a=k(t,i);d.drawOne(t,a,{skipTitle:!0}),mt[a._name+".range[0]"]=a.range[0],mt[a._name+".range[1]"]=a.range[1]}d.redrawComponents(t,r)}function Zt(){if(!t._transitioningWithDuration){var e=t._context.doubleClick,r=[];st&&(r=r.concat(G)),lt&&(r=r.concat(tt)),ot.xaxes&&(r=r.concat(ot.xaxes)),ot.yaxes&&(r=r.concat(ot.yaxes));var n,i,a,o={};if("reset+autosize"===e)for(e='autosize',i=0;i<r.length;i++)if((n=r[i])._rangeInitial&&(n.range[0]!==n._rangeInitial[0]||n.range[1]!==n._rangeInitial[1])||!n._rangeInitial&&!n.autorange){e='reset';break}if("autosize"===e)for(i=0;i<r.length;i++)(n=r[i]).fixedrange||(o[n._name+".autorange"]=!0);else if("reset"===e)for((st||at.isSubplotConstrained)&&(r=r.concat(at.xaxes)),lt&&!at.isSubplotConstrained&&(r=r.concat(at.yaxes)),at.isSubplotConstrained&&(st?lt||(r=r.concat(tt)):r=r.concat(G)),i=0;i<r.length;i++)(n=r[i]).fixedrange||(n._rangeInitial?(a=n._rangeInitial,o[n._name+".range[0]"]=a[0],o[n._name+".range[1]"]=a[1]):o[n._name+".autorange"]=!0);t.emit('plotly_doubleclick',null),l.call('_guiRelayout',t,o)}}function Jt(){Kt([0,0,nt,it]),i.syncOrAsync([T.previousPromises,function(){t._fullLayout._replotting=!1,l.call('_guiRelayout',t,mt)}],t)}function Kt(e){var r,n,a,o,s=t._fullLayout,c=s._plots,u=s._subplots.cartesian;if(pt&&l.subplotsRegistry.splom.drag(t),ht)for(r=0;r<u.length;r++)if(a=(n=c[u[r]]).xaxis,o=n.yaxis,n._scene){var p=i.simpleMap(a.range,a.r2l),d=i.simpleMap(o.range,o.r2l);n._scene.update({range:[p[0],d[0],p[1],d[1]]})}if((pt||ht)&&(_(t),w(t)),dt){var g=e[2]/v._length,y=e[3]/I._length;for(r=0;r<u.length;r++){a=(n=c[u[r]]).xaxis,o=n.yaxis;var x,b,T,k,M=(ut||ot.isSubplotConstrained)&&!a.fixedrange&&z[a._id],A=(ft||ot.isSubplotConstrained)&&!o.fixedrange&&O[o._id];if(M?(x=g,T=m||ot.isSubplotConstrained?e[0]:te(a,x)):ot.xaHash[a._id]?(x=g,T=e[0]*a._length/v._length):ot.yaHash[a._id]?(x=y,T="ns"===lt?-e[1]*a._length/I._length:te(a,x,{n:"top",s:"bottom"}[lt])):T=$t(a,x=Qt(a,g,y)),A?(b=y,k=f||ot.isSubplotConstrained?e[1]:te(o,b)):ot.yaHash[o._id]?(b=y,k=e[1]*o._length/I._length):ot.xaHash[o._id]?(b=g,k="ew"===st?-e[0]*o._length/v._length:te(o,b,{e:"right",w:"left"}[st])):k=$t(o,b=Qt(o,g,y)),x||b){x||(x=1),b||(b=1);var S=a._offset-T/x,E=o._offset-k/b;n.clipRect.call(h.setTranslate,T,k).call(h.setScale,x,b),n.plot.call(h.setTranslate,S,E).call(h.setScale,1/x,1/b),x===n.xScaleFactor&&b===n.yScaleFactor||(h.setPointGroupScale(n.zoomScalePts,x,b),h.setTextPointsScale(n.zoomScaleTxt,x,b)),h.hideOutsideRangePoints(n.clipOnAxisFalseTraces,n),n.xScaleFactor=x,n.yScaleFactor=b}}}}function Qt(t,e,r){return t.fixedrange?0:ut&&at.xaHash[t._id]?e:ft&&(at.isSubplotConstrained?at.xaHash:at.yaHash)[t._id]?r:0}function $t(t,e){return e?(t.range=t._r.slice(),E(t,e),te(t,e)):0}function te(t,e,r){return t._length*(1-e)*b[r||t.constraintoward||"middle"]}return f.length*m.length!==1&&Q(Tt,Gt),Tt}function O(t,e,r,n){var a=i.ensureSingle(t.draglayer,e,r,(function(e){e.classed('drag',!0).style({fill:"transparent","stroke-width":0}).attr('data-subplot',t.id)}));return a.call(m,n),a.node()}function D(t,e,r,i,a,o,s){var l=O(t,'rect',e,r);return n.select(l).call(h.setRect,i,a,o,s),l}function R(t,e){for(var r=0;r<t.length;r++)if(!t[r].fixedrange)return e;return""}function F(t,e){var r,n=t.range[e],i=Math.abs(n-t.range[1-e]);return"date"===t.type?n:"log"===t.type?(r=Math.ceil(Math.max(0,-Math.log(i)/Math.LN10))+3,a("."+r+"g")(Math.pow(10,n))):(r=Math.floor(Math.log(Math.abs(n))/Math.LN10)-Math.floor(Math.log(i)/Math.LN10)+4,a("."+String(r)+"g")(n))}function B(t,e,r,n,i){for(var a=0;a<t.length;a++){var o=t[a];if(!o.fixedrange)if(o.rangebreaks){var s="y"===o._id.charAt(0),l=s?1-e:e,c=s?1-r:r;n[o._name+".range[0]"]=o.l2r(o.p2l(l*o._length)),n[o._name+".range[1]"]=o.l2r(o.p2l(c*o._length))}else{var u=o._rl[0],f=o._rl[1]-u;n[o._name+".range[0]"]=o.l2r(u+f*e),n[o._name+".range[1]"]=o.l2r(u+f*r)}}if(i&&i.length){var h=(e+(1-r))/2;B(i,h,1-h,n,[])}}function N(t,e){for(var r=0;r<t.length;r++){var n=t[r];if(!n.fixedrange)if(n.rangebreaks){var i=0,a=n._length,o=(n.p2l(i+e)-n.p2l(i)+(n.p2l(a+e)-n.p2l(a)))/2;n.range=[n.l2r(n._rl[0]-o),n.l2r(n._rl[1]-o)]}else n.range=[n.l2r(n._rl[0]-e/n._m),n.l2r(n._rl[1]-e/n._m)]}}function j(t){return 1-(t>=0?Math.min(t,.9):1/(1/Math.max(t,-.3)+3.222))}function U(t,e,r){return t?"nsew"===t?r?"":"pan"===e?"move":"crosshair":t.toLowerCase()+"-resize":"pointer"}function V(t,e,r,n,i){return t.append('path').attr('class','zoombox').style({fill:e>.2?"rgba(0,0,0,0)":"rgba(255,255,255,0)","stroke-width":0}).attr('transform',c(r,n)).attr('d',i+"Z")}function H(t,e,r){return t.append('path').attr('class','zoombox-corners').style({fill:f.background,stroke:f.defaultLine,"stroke-width":1,opacity:0}).attr('transform',c(e,r)).attr('d','M0,0Z')}function q(t,e,r,n,i,a){t.attr('d',n+"M"+r.l+","+r.t+"v"+r.h+"h"+r.w+"v-"+r.h+"h-"+r.w+"Z"),G(t,e,i,a)}function G(t,e,r,n){r||(t.transition().style('fill',n>.2?"rgba(0,0,0,0.4)":"rgba(255,255,255,0.3)").duration(200),e.transition().style('opacity',1).duration(200))}function Y(t){n.select(t).selectAll('.zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners').remove()}function W(t){I&&t.data&&t._context.showTips&&(i.notifier(i._(t,'Double-click to zoom back out'),'long'),I=!1)}function X(t,e){return"M"+(t.l-.5)+","+(e-P-.5)+"h-3v"+(2*P+1)+"h3ZM"+(t.r+.5)+","+(e-P-.5)+"h3v"+(2*P+1)+"h-3Z"}function Z(t,e){return"M"+(e-P-.5)+","+(t.t-.5)+"v-3h"+(2*P+1)+"v3ZM"+(e-P-.5)+","+(t.b+.5)+"v3h"+(2*P+1)+"v-3Z"}function J(t){var e=Math.floor(Math.min(t.b-t.t,t.r-t.l,P)/2);return"M"+(t.l-3.5)+","+(t.t-.5+e)+"h3v"+-e+"h"+e+"v-3h-"+(e+3)+"ZM"+(t.r+3.5)+","+(t.t-.5+e)+"h-3v"+-e+"h"+-e+"v-3h"+(e+3)+"ZM"+(t.r+3.5)+","+(t.b+.5-e)+"h-3v"+e+"h"+-e+"v3h"+(e+3)+"ZM"+(t.l-3.5)+","+(t.b+.5-e)+"h3v"+e+"h"+e+"v3h-"+(e+3)+"Z"}function K(t,e,r,n,a){for(var o,s,l,c,u=!1,f={},h={},p=(a||{}).xaHash,d=(a||{}).yaHash,m=0;m<e.length;m++){var g=e[m];for(o in r)if(g[o]){for(l in g)a&&(p[l]||d[l])||("x"===l.charAt(0)?r:n)[l]||(f[l]=o);for(s in n)a&&(p[s]||d[s])||!g[s]||(u=!0)}for(s in n)if(g[s])for(c in g)a&&(p[c]||d[c])||("x"===c.charAt(0)?r:n)[c]||(h[c]=s)}u&&(i.extendFlat(f,h),h={});var v={},y=[];for(l in f){var x=k(t,l);y.push(x),v[x._id]=x}var b={},_=[];for(c in h){var w=k(t,c);_.push(w),b[w._id]=w}return{xaHash:v,yaHash:b,xaxes:y,yaxes:_,xLinks:f,yLinks:h,isSubplotConstrained:u}}function Q(t,e){if(s){var r=void 0!==t.onwheel?"wheel":"mousewheel";t._onwheel&&t.removeEventListener(r,t._onwheel),t._onwheel=e,t.addEventListener(r,e,{passive:!1})}else void 0!==t.onwheel?t.onwheel=e:void 0!==t.onmousewheel?t.onmousewheel=e:t.isAddedWheelEvent||(t.isAddedWheelEvent=!0,t.addEventListener('wheel',e,{passive:!1}))}function $(t){var e=[];for(var r in t)e.push(t[r]);return e}e.exports={makeDragBox:z,makeDragger:O,makeRectDragger:D,makeZoombox:V,makeCorners:H,updateZoombox:q,xyCorners:J,transitionZoombox:G,removeZoombox:Y,showDoubleClickNotifier:W,attachWheelEventHandler:Q}},{"../../components/color":650,"../../components/dragelement":669,"../../components/dragelement/helpers":668,"../../components/drawing":672,"../../components/fx":690,"../../constants/alignment":755,"../../lib":787,"../../lib/clear_gl_canvases":771,"../../lib/setcursor":808,"../../lib/svg_text_utils":813,"../../plot_api/subroutines":828,"../../registry":915,"../plots":901,"./axes":838,"./axis_ids":842,"./constants":845,"./scale_zoom":857,"./select":858,"@plotly/d3":58,"has-passive-events":436,tinycolor2:583}],848:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/fx'),a=t('../../components/dragelement'),o=t('../../lib/setcursor'),s=t('./dragbox').makeDragBox,l=t('./constants').DRAGGERSIZE;r.initInteractions=function(t){var e=t._fullLayout;if(t._context.staticPlot)n.select(t).selectAll('.drag').remove();else if(e._has('cartesian')||e._has('splom')){Object.keys(e._plots||{}).sort((function(t,r){if((e._plots[t].mainplot&&!0)===(e._plots[r].mainplot&&!0)){var n=t.split('y'),i=r.split('y');return n[0]===i[0]?Number(n[1]||1)-Number(i[1]||1):Number(n[0]||1)-Number(i[0]||1)}return e._plots[t].mainplot?1:-1})).forEach((function(r){var n=e._plots[r],o=n.xaxis,c=n.yaxis;if(!n.mainplot){var u=s(t,n,o._offset,c._offset,o._length,c._length,'ns','ew');u.onmousemove=function(e){t._fullLayout._rehover=function(){t._fullLayout._hoversubplot===r&&t._fullLayout._plots[r]&&i.hover(t,e,r)},i.hover(t,e,r),t._fullLayout._lasthover=u,t._fullLayout._hoversubplot=r},u.onmouseout=function(e){t._dragging||(t._fullLayout._hoversubplot=null,a.unhover(t,e))},t._context.showAxisDragHandles&&(s(t,n,o._offset-l,c._offset-l,l,l,'n','w'),s(t,n,o._offset+o._length,c._offset-l,l,l,'n','e'),s(t,n,o._offset-l,c._offset+c._length,l,l,'s','w'),s(t,n,o._offset+o._length,c._offset+c._length,l,l,'s','e'))}if(t._context.showAxisDragHandles){if(r===o._mainSubplot){var f=o._mainLinePosition;"top"===o.side&&(f-=l),s(t,n,o._offset+.1*o._length,f,.8*o._length,l,'','ew'),s(t,n,o._offset,f,.1*o._length,l,'','w'),s(t,n,o._offset+.9*o._length,f,.1*o._length,l,'','e')}if(r===c._mainSubplot){var h=c._mainLinePosition;"right"!==c.side&&(h-=l),s(t,n,h,c._offset+.1*c._length,l,.8*c._length,'ns',''),s(t,n,h,c._offset+.9*c._length,l,.1*c._length,'s',''),s(t,n,h,c._offset,l,.1*c._length,'n','')}}}));var o=e._hoverlayer.node();o.onmousemove=function(r){r.target=t._fullLayout._lasthover,i.hover(t,r,e._hoversubplot)},o.onclick=function(e){e.target=t._fullLayout._lasthover,i.click(t,e)},o.onmousedown=function(e)[t._fullLayout._lasthover.onmousedown(e)],r.updateFx(t)}},r.updateFx=function(t){var e=t._fullLayout,r="pan"===e.dragmode?"move":"crosshair";o(e._draggers,r)}},{"../../components/dragelement":669,"../../components/fx":690,"../../lib/setcursor":808,"./constants":845,"./dragbox":847,"@plotly/d3":58}],849:[function(t,e,r){"use strict";function n(t){var e=t._fullLayout._zoomlayer;e&&e.selectAll('.outline-controllers').remove()}function i(t){var e=t._fullLayout._zoomlayer;e&&e.selectAll('.select-outline').remove(),t._fullLayout._drawing=!1}e.exports={clearOutlineControllers:n,clearSelect:i}},{}],850:[function(t,e,r){"use strict";var n=t('../../lib').strTranslate;function i(t,e){switch(t.type){case"log":return t.p2d(e);case"date":return t.p2r(e,0,t.calendar);default:return t.p2r(e)}}function a(t,e){switch(t.type){case"log":return t.d2p(e);case"date":return t.r2p(e,0,t.calendar);default:return t.r2p(e)}}function o(t){var e="y"===t._id.charAt(0)?1:0;return function(r){return i(t,r[e])}}function s(t){return n(t.xaxis._offset,t.yaxis._offset)}e.exports={p2r:i,r2p:a,axValue:o,getTransform:s}},{"../../lib":787}],851:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('./axis_ids');e.exports=function(t){return function(e,r){var o=e[t];if(Array.isArray(o))for(var s=n.subplotsRegistry.cartesian,l=s.idRegex,c=r._subplots,u=c.xaxis,f=c.yaxis,h=c.cartesian,p=r._has('cartesian')||r._has('gl2d'),d=0;d<o.length;d++){var m=o[d];if(i.isPlainObject(m)){var g=a.cleanId(m.xref,'x',!1),v=a.cleanId(m.yref,'y',!1),y=l.x.test(g),x=l.y.test(v);if(y||x){p||i.pushUnique(r._basePlotModules,s);var b=!1;y&&-1===u.indexOf(g)&&(u.push(g),b=!0),x&&-1===f.indexOf(v)&&(f.push(v),b=!0),b&&y&&x&&h.push(g+v)}}}}}},{"../../lib":787,"../../registry":915,"./axis_ids":842}],852:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../lib'),o=t('../plots'),s=t('../../components/drawing'),l=t('../get_data').getModuleCalcData,c=t('./axis_ids'),u=t('./constants'),f=t('../../constants/xmlns_namespaces'),h=a.ensureSingle;function p(t,e,r){return a.ensureSingle(t,e,r,(function(t){t.datum(r)}))}function d(t,e,r,a,o){for(var c,f,h,p=u.traceLayerClasses,d=t._fullLayout,m=d._modules,g=[],v=[],y=0;y<m.length;y++){var x=(c=m[y]).name,b=i.modules[x].categories;if(b.svg){var _=c.layerName||x+"layer",w=c.plot;h=(f=l(r,w))[0],r=f[1],h.length&&g.push({i:p.indexOf(_),className:_,plotMethod:w,cdModule:h}),b.zoomScale&&v.push("."+_)}}g.sort((function(t,e){return t.i-e.i}));var T=e.plot.selectAll('g.mlayer').data(g,(function(t){return t.className}));if(T.enter().append('g').attr('class',(function(t){return t.className})).classed('mlayer',!0).classed('rangeplot',e.isRangePlot),T.exit().remove(),T.order(),T.each((function(r){var i=n.select(this),l=r.className;r.plotMethod(t,e,r.cdModule,i,a,o),-1===u.clipOnAxisFalseQuery.indexOf("."+l)&&s.setClipUrl(i,e.layerClipId,t)})),d._has('scattergl')&&(c=i.getModule('scattergl'),h=l(r,c)[0],c.plot(t,e,h)),!t._context.staticPlot&&(e._hasClipOnAxisFalse&&(e.clipOnAxisFalseTraces=e.plot.selectAll(u.clipOnAxisFalseQuery.join(',')).selectAll('.trace')),v.length)){var k=e.plot.selectAll(v.join(',')).selectAll('.trace');e.zoomScalePts=k.selectAll('path.point'),e.zoomScaleTxt=k.selectAll('.textpoint')}}function m(t){var e,r,n,i,a,o,s=t._fullLayout,l=s._subplots.cartesian,c=l.length,u=[],f=[];for(e=0;e<c;e++){n=l[e],a=(i=s._plots[n]).xaxis,o=i.yaxis;var h=a._mainAxis,p=o._mainAxis,d=h._id+p._id,m=s._plots[d];i.overlays=[],d!==n&&m?(i.mainplot=d,i.mainplotinfo=m,f.push(n)):(i.mainplot=void 0,i.mainplotinfo=void 0,u.push(n))}for(e=0;e<f.length;e++)n=f[e],(i=s._plots[n]).mainplotinfo.overlays.push(i);var g=u.concat(f),v=new Array(c);for(e=0;e<c;e++){n=g[e],a=(i=s._plots[n]).xaxis,o=i.yaxis;var y=[n,a.layer,o.layer,a.overlaying||"",o.overlaying||""];for(r=0;r<i.overlays.length;r++)y.push(i.overlays[r].id);v[e]=y}return v}function g(t,e){var r=e.plotgroup,n=e.id,i=u.layerValue2layerClass[e.xaxis.layer],a=u.layerValue2layerClass[e.yaxis.layer],o=t._fullLayout._hasOnlyLargeSploms;if(e.mainplot){var s=e.mainplotinfo,l=s.plotgroup,f=n+"-x",d=n+"-y";e.gridlayer=s.gridlayer,e.zerolinelayer=s.zerolinelayer,h(s.overlinesBelow,'path',f),h(s.overlinesBelow,'path',d),h(s.overaxesBelow,'g',f),h(s.overaxesBelow,'g',d),e.plot=h(s.overplot,'g',n),h(s.overlinesAbove,'path',f),h(s.overlinesAbove,'path',d),h(s.overaxesAbove,'g',f),h(s.overaxesAbove,'g',d),e.xlines=l.select(".overlines-"+i).select("."+f),e.ylines=l.select(".overlines-"+a).select("."+d),e.xaxislayer=l.select(".overaxes-"+i).select("."+f),e.yaxislayer=l.select(".overaxes-"+a).select("."+d)}else if(o)e.xlines=h(r,'path','xlines-above'),e.ylines=h(r,'path','ylines-above'),e.xaxislayer=h(r,'g','xaxislayer-above'),e.yaxislayer=h(r,'g','yaxislayer-above');else{var m=h(r,'g','layer-subplot');e.shapelayer=h(m,'g','shapelayer'),e.imagelayer=h(m,'g','imagelayer'),e.gridlayer=h(r,'g','gridlayer'),e.zerolinelayer=h(r,'g','zerolinelayer'),h(r,'path','xlines-below'),h(r,'path','ylines-below'),e.overlinesBelow=h(r,'g','overlines-below'),h(r,'g','xaxislayer-below'),h(r,'g','yaxislayer-below'),e.overaxesBelow=h(r,'g','overaxes-below'),e.plot=h(r,'g','plot'),e.overplot=h(r,'g','overplot'),e.xlines=h(r,'path','xlines-above'),e.ylines=h(r,'path','ylines-above'),e.overlinesAbove=h(r,'g','overlines-above'),h(r,'g','xaxislayer-above'),h(r,'g','yaxislayer-above'),e.overaxesAbove=h(r,'g','overaxes-above'),e.xlines=r.select(".xlines-"+i),e.ylines=r.select(".ylines-"+a),e.xaxislayer=r.select(".xaxislayer-"+i),e.yaxislayer=r.select(".yaxislayer-"+a)}o||(p(e.gridlayer,'g',e.xaxis._id),p(e.gridlayer,'g',e.yaxis._id),e.gridlayer.selectAll('g').map((function(t){return t[0]})).sort(c.idSort)),e.xlines.style('fill','none').classed('crisp',!0),e.ylines.style('fill','none').classed('crisp',!0)}function v(t,e)[if(t){var r={];for(var i in t.each((function(t){var i=t[0];n.select(this).remove(),y(i,e),r[i]=!0})),e._plots)for(var a=e._plots[i].overlays||[],o=0;o<a.length;o++){var s=a[o];r[s.id]&&s.plot.selectAll('.trace').remove()}}}function y(t,e){e._draggers.selectAll("g."+t).remove(),e._defs.select("#clip"+e._uid+t+"plot").remove()}r.name='cartesian',r.attr=["xaxis","yaxis"],r.idRoot=["x","y"],r.idRegex=u.idRegex,r.attrRegex=u.attrRegex,r.attributes=t('./attributes'),r.layoutAttributes=t('./layout_attributes'),r.supplyLayoutDefaults=t('./layout_defaults'),r.transitionAxes=t('./transition_axes'),r.finalizeSubplots=function(t,e){var r,n,i,o=e._subplots,s=o.xaxis,l=o.yaxis,f=o.cartesian,h=f.concat(o.gl2d||[]),p={},d={};for(r=0;r<h.length;r++){var m=h[r].split('y');p[m[0]]=1,d["y"+m[1]]=1}for(r=0;r<s.length;r++)p[n=s[r]]||(i=(t[c.id2name(n)]||{}).anchor,u.idRegex.y.test(i)||(i='y'),f.push(n+i),h.push(n+i),d[i]||(d[i]=1,a.pushUnique(l,i)));for(r=0;r<l.length;r++)d[i=l[r]]||(n=(t[c.id2name(i)]||{}).anchor,u.idRegex.x.test(n)||(n='x'),f.push(n+i),h.push(n+i),p[n]||(p[n]=1,a.pushUnique(s,n)));if(!h.length){for(var g in n='',i='',t)u.attrRegex.test(g)&&("x"===g.charAt(0)?(!n||+g.substr(5)<+n.substr(5))&&(n=g):(!i||+g.substr(5)<+i.substr(5))&&(i=g));n=n?c.name2id(n):"x",i=i?c.name2id(i):"y",s.push(n),l.push(i),f.push(n+i)}},r.plot=function(t,e,r,n){var i,a=t._fullLayout,o=a._subplots.cartesian,s=t.calcdata;if(!Array.isArray(e))for(e=[],i=0;i<s.length;i++)e.push(i);for(i=0;i<o.length;i++){for(var l,c=o[i],u=a._plots[c],f=[],h=0;h<s.length;h++){var p=s[h],m=p[0].trace;m.xaxis+m.yaxis===c&&((-1!==e.indexOf(m.index)||m.carpet)&&(l&&l[0].trace.xaxis+l[0].trace.yaxis===c&&-1!==["tonextx",'tonexty',"tonext"].indexOf(m.fill)&&-1===f.indexOf(l)&&f.push(l),f.push(p)),l=p)}d(t,u,f,r,n)}},r.clean=function(t,e,r,n){var i,a,o,s=n._plots||{},l=e._plots||{},u=n._subplots||{};if(n._hasOnlyLargeSploms&&!e._hasOnlyLargeSploms)for(o in s)(i=s[o]).plotgroup&&i.plotgroup.remove();var f=n._has&&n._has('gl'),h=e._has&&e._has('gl');if(f&&!h)for(o in s)(i=s[o])._scene&&i._scene.destroy();if(u.xaxis&&u.yaxis){var p=c.listIds({_fullLayout:n});for(a=0;a<p.length;a++){var d=p[a];e[c.id2name(d)]||n._infolayer.selectAll(".g-"+d+"title").remove()}}var m=n._has&&n._has('cartesian'),g=e._has&&e._has('cartesian');if(m&&!g)v(n._cartesianlayer.selectAll('.subplot'),n),n._defs.selectAll('.axesclip').remove(),delete n._axisConstraintGroups,delete n._axisMatchGroups;else if(u.cartesian)for(a=0;a<u.cartesian.length;a++){var x=u.cartesian[a];if(!l[x]){var b="."+x+",."+x+"-x,."+x+"-y";n._cartesianlayer.selectAll(b).remove(),y(x,n)}}},r.drawFramework=function(t){var e=t._fullLayout,r=m(t),i=e._cartesianlayer.selectAll('.subplot').data(r,String);i.enter().append('g').attr('class',(function(t){return"subplot "+t[0]})),i.order(),i.exit().call(v,e),i.each((function(r){var i=r[0],a=e._plots[i];a.plotgroup=n.select(this),g(t,a),a.draglayer=h(e._draggers,'g',i)}))},r.rangePlot=function(t,e,r){g(t,e),d(t,e,r),o.style(t)},r.toSVG=function(t){var e=t._fullLayout._glimages,r=n.select(t).selectAll('.svg-container');function i(){var t=this,r=t.toDataURL('image/png');e.append('svg:image').attr({xmlns:f.svg,"xlink:href":r,preserveAspectRatio:"none",x:0,y:0,width:t.style.width,height:t.style.height})}r.filter((function(t,e){return e===r.size()-1})).selectAll('.gl-canvas-context, .gl-canvas-focus').each(i)},r.updateFx=t('./graph_interact').updateFx},{"../../components/drawing":672,"../../constants/xmlns_namespaces":764,"../../lib":787,"../../registry":915,"../get_data":875,"../plots":901,"./attributes":836,"./axis_ids":842,"./constants":845,"./graph_interact":848,"./layout_attributes":853,"./layout_defaults":854,"./transition_axes":863,"@plotly/d3":58}],853:[function(t,e,r){"use strict";var n=t('../font_attributes'),i=t('../../components/color/attributes'),a=t('../../components/drawing/attributes').dash,o=t('../../lib/extend').extendFlat,s=t('../../plot_api/plot_template').templatedArray,l=t('../../plots/cartesian/axis_format_attributes').descriptionWithDates,c=t('../../constants/numerical').ONEDAY,u=t('./constants'),f=u.HOUR_PATTERN,h=u.WEEKDAY_PATTERN;e.exports={visible:{valType:"boolean",editType:"plot"},color:{valType:"color",dflt:i.defaultLine,editType:"ticks"},title:{text:{valType:"string",editType:"ticks"},font:n({editType:"ticks"}),standoff:{valType:"number",min:0,editType:"ticks"},editType:"ticks"},type:{valType:"enumerated",values:["-",'linear','log','date','category',"multicategory"],dflt:"-",editType:"calc",_noTemplating:!0},autotypenumbers:{valType:"enumerated",values:["convert types","strict"],dflt:"convert types",editType:"calc"},autorange:{valType:"enumerated",values:[!0,!1,"reversed"],dflt:!0,editType:"axrange",impliedEdits:{"range[0]":void 0,"range[1]":void 0}},rangemode:{valType:"enumerated",values:["normal",'tozero',"nonnegative"],dflt:"normal",editType:"plot"},range:{valType:"info_array",items:[{valType:"any",editType:"axrange",impliedEdits:{"^autorange":!1},anim:!0},{valType:"any",editType:"axrange",impliedEdits:{"^autorange":!1},anim:!0}],editType:"axrange",impliedEdits:{autorange:!1},anim:!0},fixedrange:{valType:"boolean",dflt:!1,editType:"calc"},scaleanchor:{valType:"enumerated",values:[u.idRegex.x.toString(),u.idRegex.y.toString()],editType:"plot"},scaleratio:{valType:"number",min:0,dflt:1,editType:"plot"},constrain:{valType:"enumerated",values:["range","domain"],editType:"plot"},constraintoward:{valType:"enumerated",values:["left",'center','right','top','middle',"bottom"],editType:"plot"},matches:{valType:"enumerated",values:[u.idRegex.x.toString(),u.idRegex.y.toString()],editType:"calc"},rangebreaks:s('rangebreak',{enabled:{valType:"boolean",dflt:!0,editType:"calc"},bounds:{valType:"info_array",items:[{valType:"any",editType:"calc"},{valType:"any",editType:"calc"}],editType:"calc"},pattern:{valType:"enumerated",values:[h,f,""],editType:"calc"},values:{valType:"info_array",freeLength:!0,editType:"calc",items:{valType:"any",editType:"calc"}},dvalue:{valType:"number",editType:"calc",min:0,dflt:c},editType:"calc"}),tickmode:{valType:"enumerated",values:["auto",'linear',"array"],editType:"ticks",impliedEdits:{tick0:void 0,dtick:void 0}},nticks:{valType:"integer",min:0,dflt:0,editType:"ticks"},tick0:{valType:"any",editType:"ticks",impliedEdits:{tickmode:"linear"}},dtick:{valType:"any",editType:"ticks",impliedEdits:{tickmode:"linear"}},tickvals:{valType:"data_array",editType:"ticks"},ticktext:{valType:"data_array",editType:"ticks"},ticks:{valType:"enumerated",values:["outside",'inside',""],editType:"ticks"},tickson:{valType:"enumerated",values:["labels","boundaries"],dflt:"labels",editType:"ticks"},ticklabelmode:{valType:"enumerated",values:["instant","period"],dflt:"instant",editType:"ticks"},ticklabelposition:{valType:"enumerated",values:["outside",'inside','outside top','inside top','outside left','inside left','outside right','inside right','outside bottom',"inside bottom"],dflt:"outside",editType:"calc"},ticklabeloverflow:{valType:"enumerated",values:["allow",'hide past div',"hide past domain"],editType:"calc"},mirror:{valType:"enumerated",values:[!0,'ticks',!1,'all',"allticks"],dflt:!1,editType:"ticks+layoutstyle"},ticklen:{valType:"number",min:0,dflt:5,editType:"ticks"},tickwidth:{valType:"number",min:0,dflt:1,editType:"ticks"},tickcolor:{valType:"color",dflt:i.defaultLine,editType:"ticks"},showticklabels:{valType:"boolean",dflt:!0,editType:"ticks"},automargin:{valType:"boolean",dflt:!1,editType:"ticks"},showspikes:{valType:"boolean",dflt:!1,editType:"modebar"},spikecolor:{valType:"color",dflt:null,editType:"none"},spikethickness:{valType:"number",dflt:3,editType:"none"},spikedash:o({},a,{dflt:"dash",editType:"none"}),spikemode:{valType:"flaglist",flags:["toaxis",'across',"marker"],dflt:"toaxis",editType:"none"},spikesnap:{valType:"enumerated",values:["data",'cursor',"hovered data"],dflt:"hovered data",editType:"none"},tickfont:n({editType:"ticks"}),tickangle:{valType:"angle",dflt:"auto",editType:"ticks"},tickprefix:{valType:"string",dflt:"",editType:"ticks"},showtickprefix:{valType:"enumerated",values:["all",'first','last',"none"],dflt:"all",editType:"ticks"},ticksuffix:{valType:"string",dflt:"",editType:"ticks"},showticksuffix:{valType:"enumerated",values:["all",'first','last',"none"],dflt:"all",editType:"ticks"},showexponent:{valType:"enumerated",values:["all",'first','last',"none"],dflt:"all",editType:"ticks"},exponentformat:{valType:"enumerated",values:["none",'e','E','power','SI',"B"],dflt:"B",editType:"ticks"},minexponent:{valType:"number",dflt:3,min:0,editType:"ticks"},separatethousands:{valType:"boolean",dflt:!1,editType:"ticks"},tickformat:{valType:"string",dflt:"",editType:"ticks",description:l('tick label')},tickformatstops:s('tickformatstop',{enabled:{valType:"boolean",dflt:!0,editType:"ticks"},dtickrange:{valType:"info_array",items:[{valType:"any",editType:"ticks"},{valType:"any",editType:"ticks"}],editType:"ticks"},value:{valType:"string",dflt:"",editType:"ticks"},editType:"ticks"}),hoverformat:{valType:"string",dflt:"",editType:"none",description:l('hover text')},showline:{valType:"boolean",dflt:!1,editType:"ticks+layoutstyle"},linecolor:{valType:"color",dflt:i.defaultLine,editType:"layoutstyle"},linewidth:{valType:"number",min:0,dflt:1,editType:"ticks+layoutstyle"},showgrid:{valType:"boolean",editType:"ticks"},gridcolor:{valType:"color",dflt:i.lightLine,editType:"ticks"},gridwidth:{valType:"number",min:0,dflt:1,editType:"ticks"},zeroline:{valType:"boolean",editType:"ticks"},zerolinecolor:{valType:"color",dflt:i.defaultLine,editType:"ticks"},zerolinewidth:{valType:"number",dflt:1,editType:"ticks"},showdividers:{valType:"boolean",dflt:!0,editType:"ticks"},dividercolor:{valType:"color",dflt:i.defaultLine,editType:"ticks"},dividerwidth:{valType:"number",dflt:1,editType:"ticks"},anchor:{valType:"enumerated",values:["free",u.idRegex.x.toString(),u.idRegex.y.toString()],editType:"plot"},side:{valType:"enumerated",values:["top",'bottom','left',"right"],editType:"plot"},overlaying:{valType:"enumerated",values:["free",u.idRegex.x.toString(),u.idRegex.y.toString()],editType:"plot"},layer:{valType:"enumerated",values:["above traces","below traces"],dflt:"above traces",editType:"plot"},domain:{valType:"info_array",items:[{valType:"number",min:0,max:1,editType:"plot"},{valType:"number",min:0,max:1,editType:"plot"}],dflt:[0,1],editType:"plot"},position:{valType:"number",min:0,max:1,dflt:0,editType:"plot"},categoryorder:{valType:"enumerated",values:["trace",'category ascending','category descending','array','total ascending','total descending','min ascending','min descending','max ascending','max descending','sum ascending','sum descending','mean ascending','mean descending','median ascending',"median descending"],dflt:"trace",editType:"calc"},categoryarray:{valType:"data_array",editType:"calc"},uirevision:{valType:"any",editType:"none"},editType:"calc",_deprecated:{autotick:{valType:"boolean",editType:"ticks"},title:{valType:"string",editType:"ticks"},titlefont:n({editType:"ticks"})}}},{"../../components/color/attributes":649,"../../components/drawing/attributes":671,"../../constants/numerical":763,"../../lib/extend":777,"../../plot_api/plot_template":827,"../../plots/cartesian/axis_format_attributes":841,"../font_attributes":867,"./constants":845}],854:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../../components/fx/helpers').isUnifiedHover,o=t('../../components/fx/hovermode_defaults'),s=t('../../plot_api/plot_template'),l=t('../layout_attributes'),c=t('./layout_attributes'),u=t('./type_defaults'),f=t('./axis_defaults'),h=t('./constraints'),p=t('./position_defaults'),d=t('./axis_ids'),m=d.id2name,g=d.name2id,v=t('./constants').AX_ID_PATTERN,y=t('../../registry'),x=y.traceIs,b=y.getComponentMethod;function _(t,e,r){Array.isArray(t[e])?t[e].push(r):t[e]=[r]}e.exports=function(t,e,r){var y,w,T=e.autotypenumbers,k={},M={},A={},S={},E={},L={},C={},P={},I={},z={};for(y=0;y<r.length;y++){var O=r[y];if(x(O,'cartesian')||x(O,'gl2d')){var D,R;if(O.xaxis)D=m(O.xaxis),_(k,D,O);else if(O.xaxes)for(w=0;w<O.xaxes.length;w++)_(k,m(O.xaxes[w]),O);if(O.yaxis)R=m(O.yaxis),_(k,R,O);else if(O.yaxes)for(w=0;w<O.yaxes.length;w++)_(k,m(O.yaxes[w]),O);"funnel"===O.type?"h"===O.orientation?(D&&(M[D]=!0),R&&(C[R]=!0)):R&&(A[R]=!0):"image"===O.type?(R&&(P[R]=!0),D&&(P[D]=!0)):(R&&(E[R]=!0,L[R]=!0),x(O,'carpet')&&("carpet"!==O.type||O._cheater)||D&&(S[D]=!0)),"carpet"===O.type&&O._cheater&&D&&(M[D]=!0),x(O,'2dMap')&&(I[D]=!0,I[R]=!0),x(O,'oriented')&&(z["h"===O.orientation?R:D]=!0)}}var F=e._subplots,B=F.xaxis,N=F.yaxis,j=n.simpleMap(B,m),U=n.simpleMap(N,m),V=j.concat(U),H=i.background;B.length&&N.length&&(H=n.coerce(t,e,l,'plot_bgcolor'));var q,G,Y,W,X,Z=i.combine(H,e.paper_bgcolor);function J(){var t=k[q]||[];X._traceIndices=t.map((function(t){return t._expandedIndex})),X._annIndices=[],X._shapeIndices=[],X._imgIndices=[],X._subplotsWith=[],X._counterAxes=[],X._name=X._attr=q,X._id=G}function K(t,e){return n.coerce(W,X,c,t,e)}function Q(t,e){return n.coerce2(W,X,c,t,e)}function $(t){return"x"===t?N:B}function tt(e,r){for(var n="x"===e?j:U,i=[],a=0;a<n.length;a++){var o=n[a];o===r||(t[o]||{}).overlaying||i.push(g(o))}return i}var et={x:$('x'),y:$('y')},rt=et.x.concat(et.y),nt={},it=[];function at(){var t=W.matches;v.test(t)&&-1===rt.indexOf(t)&&(nt[t]=W.type,it=Object.keys(nt))}var ot=o(t,e),st=a(ot);for(y=0;y<V.length;y++){q=V[y],G=g(q),Y=q.charAt(0),n.isPlainObject(t[q])||(t[q]={}),W=t[q],X=s.newContainer(e,q,Y+"axis"),J();var lt="x"===Y&&!S[q]&&M[q]||"y"===Y&&!E[q]&&A[q],ct="y"===Y&&(!L[q]&&C[q]||P[q]),ut={letter:Y,font:e.font,outerTicks:I[q],showGrid:!z[q],data:k[q]||[],bgColor:Z,calendar:e.calendar,automargin:!0,visibleDflt:lt,reverseDflt:ct,autotypenumbersDflt:T,splomStash:((e._splomAxes||{})[Y]||{})[G]};K('uirevision',e.uirevision),u(W,X,K,ut),f(W,X,K,ut,e);var ft=st&&Y===ot.charAt(0),ht=Q('spikecolor',st?X.color:void 0),pt=Q('spikethickness',st?1.5:void 0),dt=Q('spikedash',st?"dot":void 0),mt=Q('spikemode',st?"across":void 0),gt=Q('spikesnap');K('showspikes',!!ft||!!ht||!!pt||!!dt||!!mt||!!gt)||(delete X.spikecolor,delete X.spikethickness,delete X.spikedash,delete X.spikemode,delete X.spikesnap),p(W,X,K,{letter:Y,counterAxes:et[Y],overlayableAxes:tt(Y,q),grid:e.grid}),K('title.standoff'),at(),X._input=W}for(y=0;y<it.length;){G=it[y++],Y=(q=m(G)).charAt(0),n.isPlainObject(t[q])||(t[q]={}),W=t[q],X=s.newContainer(e,q,Y+"axis"),J();var vt={letter:Y,font:e.font,outerTicks:I[q],showGrid:!z[q],data:[],bgColor:Z,calendar:e.calendar,automargin:!0,visibleDflt:!1,reverseDflt:!1,autotypenumbersDflt:T,splomStash:((e._splomAxes||{})[Y]||{})[G]};K('uirevision',e.uirevision),X.type=nt[G]||"linear",f(W,X,K,vt,e),p(W,X,K,{letter:Y,counterAxes:et[Y],overlayableAxes:tt(Y,q),grid:e.grid}),K('fixedrange'),at(),X._input=W}var yt=b('rangeslider','handleDefaults'),xt=b('rangeselector','handleDefaults');for(y=0;y<j.length;y++)q=j[y],W=t[q],X=e[q],yt(t,e,q),"date"===X.type&&xt(W,X,e,U,X.calendar),K('fixedrange');for(y=0;y<U.length;y++){q=U[y],W=t[q],X=e[q];var bt=e[m(X.anchor)];K('fixedrange',b('rangeslider','isVisible')(bt))}h.handleDefaults(t,e,{axIds:rt.concat(it).sort(d.idSort),axHasImage:P})}},{"../../components/color":650,"../../components/fx/helpers":686,"../../components/fx/hovermode_defaults":689,"../../lib":787,"../../plot_api/plot_template":827,"../../registry":915,"../layout_attributes":892,"./axis_defaults":840,"./axis_ids":842,"./constants":845,"./constraints":846,"./layout_attributes":853,"./position_defaults":856,"./type_defaults":864}],855:[function(t,e,r){"use strict";var n=t('tinycolor2').mix,i=t('../../components/color/attributes').lightFraction,a=t('../../lib');e.exports=function(t,e,r,o){var s=(o=o||{}).dfltColor;function l(r,n){return a.coerce2(t,e,o.attributes,r,n)}var c=l('linecolor',s),u=l('linewidth');r('showline',o.showLine||!!c||!!u)||(delete e.linecolor,delete e.linewidth);var f=l('gridcolor',n(s,o.bgColor,o.blend||i).toRgbString()),h=l('gridwidth');if(r('showgrid',o.showGrid||!!f||!!h)||(delete e.gridcolor,delete e.gridwidth),!o.noZeroLine){var p=l('zerolinecolor',s),d=l('zerolinewidth');r('zeroline',o.showGrid||!!p||!!d)||(delete e.zerolinecolor,delete e.zerolinewidth)}}},{"../../components/color/attributes":649,"../../lib":787,tinycolor2:583}],856:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib');e.exports=function(t,e,r,a){var o,s,l,c,u=a.counterAxes||[],f=a.overlayableAxes||[],h=a.letter,p=a.grid;p&&(s=p._domains[h][p._axisMap[e._id]],o=p._anchors[e._id],s&&(l=p[h+"side"].split(' ')[0],c=p.domain[h]["right"===l||"top"===l?1:0])),s=s||[0,1],o=o||(n(t.position)?"free":u[0]||"free"),l=l||("x"===h?"bottom":"left"),c=c||0,"free"===i.coerce(t,e,{anchor:{valType:"enumerated",values:["free"].concat(u),dflt:o}},'anchor')&&r('position',c),i.coerce(t,e,{side:{valType:"enumerated",values:"x"===h?["bottom","top"]:["left","right"],dflt:l}},'side');var d=!1;if(f.length&&(d=i.coerce(t,e,{overlaying:{valType:"enumerated",values:[!1].concat(f),dflt:!1}},'overlaying')),!d){var m=r('domain',s);m[0]>m[1]-1/4096&&(e.domain=s),i.noneOrAll(t.domain,e.domain,s)}return r('layer'),e}},{"../../lib":787,"fast-isnumeric":246}],857:[function(t,e,r){"use strict";var n=t('../../constants/alignment').FROM_BL;e.exports=function(t,e,r){void 0===r&&(r=n[t.constraintoward||"center"]);var i=[t.r2l(t.range[0]),t.r2l(t.range[1])],a=i[0]+(i[1]-i[0])*r;t.range=t._input.range=[t.l2r(a+(i[0]-a)*e),t.l2r(a+(i[1]-a)*e)],t.setScale()}},{"../../constants/alignment":755}],858:[function(t,e,r){"use strict";var n=t('polybooljs'),i=t('../../registry'),a=t('../../components/drawing').dashStyle,o=t('../../components/color'),s=t('../../components/fx'),l=t('../../components/fx/helpers').makeEventData,c=t('../../components/dragelement/helpers'),u=c.freeMode,f=c.rectMode,h=c.drawMode,p=c.openMode,d=c.selectMode,m=t('../../components/shapes/draw_newshape/display_outlines'),g=t('../../components/shapes/draw_newshape/helpers').handleEllipse,v=t('../../components/shapes/draw_newshape/newshapes'),y=t('../../lib'),x=t('../../lib/polygon'),b=t('../../lib/throttle'),_=t('./axis_ids').getFromId,w=t('../../lib/clear_gl_canvases'),T=t('../../plot_api/subroutines').redrawReglTraces,k=t('./constants'),M=k.MINSELECT,A=x.filter,S=x.tester,E=t('./handle_outline').clearSelect,L=t('./helpers'),C=L.p2r,P=L.axValue,I=L.getTransform;function z(t,e,r,n,i){var l=u(i),c=f(i),v=p(i),x=h(i),_=d(i),w="drawcircle"===i,T="drawline"===i||w,E=n.gd,L=E._fullLayout,z=L._zoomlayer,D=n.element.getBoundingClientRect(),R=n.plotinfo,F=I(R),V=e-D.left,H=r-D.top;L._calcInverseTransform(E);var q=y.apply3DTransform(L._invTransform)(V,H);V=q[0],H=q[1];var G,Y,K,Q,$,tt,et,rt=L._invScaleX,nt=L._invScaleY,it=V,at=H,ot="M"+V+","+H,st=n.xaxes[0]._length,lt=n.yaxes[0]._length,ct=n.xaxes.concat(n.yaxes),ut=t.altKey&&!(h(i)&&v);N(t,E,n),l&&(G=A([[V,H]],k.BENDPX));var ft=z.selectAll("path.select-outline-"+R.id).data(x?[0]:[1,2]),ht=L.newshape;ft.enter().append('path').attr('class',(function(t){return"select-outline select-outline-"+t+" select-outline-"+R.id})).style(x?{opacity:ht.opacity/2,fill:v?void 0:ht.fillcolor,stroke:ht.line.color,"stroke-dasharray":a(ht.line.dash,ht.line.width),"stroke-width":ht.line.width+"px"}:{}).attr('fill-rule',ht.fillrule).classed('cursor-move',!!x).attr('transform',F).attr('d',ot+"Z");var pt,dt=z.append('path').attr('class','zoombox-corners').style({fill:o.background,stroke:o.defaultLine,"stroke-width":1}).attr('transform',F).attr('d','M0,0Z'),mt=L._uid+k.SELECTID,gt=[],vt=U(E,n.xaxes,n.yaxes,n.subplot);function yt(t,e){return t-e}pt=R.fillRangeItems?R.fillRangeItems:c?function(t,e)[var r=t.range={];for($=0;$<ct.length;$++){var n=ct[$],i=n._id.charAt(0);r[n._id]=[C(n,e[i+"min"]),C(n,e[i+"max"])].sort(yt)}}:function(t,e,r)[var n=t.lassoPoints={];for($=0;$<ct.length;$++){var i=ct[$];n[i._id]=r.filtered.map(P(i))}},n.moveFn=function(t,e){it=Math.max(0,Math.min(st,rt*t+V)),at=Math.max(0,Math.min(lt,nt*e+H));var r=Math.abs(it-V),i=Math.abs(at-H);if(c){var a,o,s;if(_){var u=L.selectdirection;switch(a="any"===u?i<Math.min(.6*r,M)?"h":r<Math.min(.6*i,M)?"v":"d":u){case"h":o=w?lt/2:0,s=lt;break;case"v":o=w?st/2:0,s=st}}if(x)switch(L.newshape.drawdirection){case"vertical":a='h',o=w?lt/2:0,s=lt;break;case"horizontal":a='v',o=w?st/2:0,s=st;break;case"ortho":r<i?(a='h',o=H,s=at):(a='v',o=V,s=it);break;default:a="d"}"h"===a?((Q=T?g(w,[it,o],[it,s]):[[V,o],[V,s],[it,s],[it,o]]).xmin=T?it:Math.min(V,it),Q.xmax=T?it:Math.max(V,it),Q.ymin=Math.min(o,s),Q.ymax=Math.max(o,s),dt.attr('d',"M"+Q.xmin+","+(H-M)+"h-4v"+2*M+"h4ZM"+(Q.xmax-1)+","+(H-M)+"h4v"+2*M+"h-4Z")):"v"===a?((Q=T?g(w,[o,at],[s,at]):[[o,H],[o,at],[s,at],[s,H]]).xmin=Math.min(o,s),Q.xmax=Math.max(o,s),Q.ymin=T?at:Math.min(H,at),Q.ymax=T?at:Math.max(H,at),dt.attr('d',"M"+(V-M)+","+Q.ymin+"v-4h"+2*M+"v4ZM"+(V-M)+","+(Q.ymax-1)+"v4h"+2*M+"v-4Z")):"d"===a&&((Q=T?g(w,[V,H],[it,at]):[[V,H],[V,at],[it,at],[it,H]]).xmin=Math.min(V,it),Q.xmax=Math.max(V,it),Q.ymin=Math.min(H,at),Q.ymax=Math.max(H,at),dt.attr('d','M0,0Z'))}else l&&(G.addPt([it,at]),Q=G.filtered);n.selectionDefs&&n.selectionDefs.length?(K=X(n.mergedPolygons,Q,ut),Q.subtract=ut,Y=B(n.selectionDefs.concat([Q]))):(K=[Q],Y=S(Q)),m(J(K,v),ft,n),_&&b.throttle(mt,k.SELECTDELAY,(function(){var t;gt=[];var e,r=[];for($=0;$<vt.length;$++)if(e=(tt=vt[$])._module.selectPoints(tt,Y),r.push(e),t=Z(e,tt),gt.length)for(var i=0;i<t.length;i++)gt.push(t[i]);else gt=t;W(E,vt,et={points:gt}),pt(et,Q,G),n.gd.emit('plotly_selecting',et)}))},n.clickFn=function(t,e){if(dt.remove(),E._fullLayout._activeShapeIndex>=0)E._fullLayout._deactivateShape(E);else if(!x){var r=L.clickmode;b.done(mt).then((function(){if(b.clear(mt),2===t){for(ft.remove(),$=0;$<vt.length;$++)(tt=vt[$])._module.selectPoints(tt,!1);W(E,vt),j(n),E.emit('plotly_deselect',null)}else r.indexOf('select')>-1&&O(e,E,n.xaxes,n.yaxes,n.subplot,n,ft),"event"===r&&E.emit('plotly_selected',void 0);s.click(E,e)})).catch(y.error)}},n.doneFn=function(){dt.remove(),b.done(mt).then((function(){b.clear(mt),n.gd.emit('plotly_selected',et),Q&&n.selectionDefs&&(Q.subtract=ut,n.selectionDefs.push(Q),n.mergedPolygons.length=0,[].push.apply(n.mergedPolygons,K)),n.doneFnCompleted&&n.doneFnCompleted(gt)})).catch(y.error),x&&j(n)}}function O(t,e,r,n,i,a,o){var s,l,c,u,f,h,d,g,v,y=e._hoverdata,x=e._fullLayout.clickmode.indexOf('event')>-1,b=[];if(V(y)){N(t,e,a);var _=H(y,s=U(e,r,n,i));if(_.pointNumbers.length>0?G(s,_):Y(s)&&(h=q(_))){for(o&&o.remove(),v=0;v<s.length;v++)(l=s[v])._module.selectPoints(l,!1);W(e,s),j(a),x&&e.emit('plotly_deselect',null)}else{for(d=t.shiftKey&&(void 0!==h?h:q(_)),c=D(_.pointNumber,_.searchInfo,d),u=B(a.selectionDefs.concat([c])),v=0;v<s.length;v++)if(f=Z(s[v]._module.selectPoints(s[v],u),s[v]),b.length)for(var w=0;w<f.length;w++)b.push(f[w]);else b=f;if(W(e,s,g={points:b}),c&&a&&a.selectionDefs.push(c),o){var T=a.mergedPolygons,k=p(a.dragmode);m(J(T,k),o,a)}x&&e.emit('plotly_selected',g)}}}function D(t,e,r){return{pointNumber:t,searchInfo:e,subtract:r}}function R(t){return"pointNumber"in t&&"searchInfo"in t}function F(t){return{xmin:0,xmax:0,ymin:0,ymax:0,pts:[],contains:function(e,r,n,i){var a=t.searchInfo.cd[0].trace._expandedIndex;return i.cd[0].trace._expandedIndex===a&&n===t.pointNumber},isRect:!1,degenerate:!1,subtract:t.subtract}}function B(t){for(var e=[],r=R(t[0])?0:t[0][0][0],n=r,i=R(t[0])?0:t[0][0][1],a=i,o=0;o<t.length;o++)if(R(t[o]))e.push(F(t[o]));else{var s=x.tester(t[o]);s.subtract=t[o].subtract,e.push(s),r=Math.min(r,s.xmin),n=Math.max(n,s.xmax),i=Math.min(i,s.ymin),a=Math.max(a,s.ymax)}function l(t,r,n,i){for(var a=!1,o=0;o<e.length;o++)e[o].contains(t,r,n,i)&&(a=!1===e[o].subtract);return a}return{xmin:r,xmax:n,ymin:i,ymax:a,pts:[],contains:l,isRect:!1,degenerate:!1}}function N(t,e,r){e._fullLayout._drawing=!1;var n=e._fullLayout,i=r.plotinfo,a=r.dragmode,o=n._lastSelectedSubplot&&n._lastSelectedSubplot===i.id,s=(t.shiftKey||t.altKey)&&!(h(a)&&p(a));o&&s&&i.selection&&i.selection.selectionDefs&&!r.selectionDefs?(r.selectionDefs=i.selection.selectionDefs,r.mergedPolygons=i.selection.mergedPolygons):s&&i.selection||j(r),o||(E(e),n._lastSelectedSubplot=i.id)}function j(t){var e=t.dragmode,r=t.plotinfo,n=t.gd;if(n._fullLayout._activeShapeIndex>=0&&n._fullLayout._deactivateShape(n),h(e)){var a=n._fullLayout._zoomlayer.selectAll(".select-outline-"+r.id);if(a&&n._fullLayout._drawing){var o=v(a,t);o&&i.call('_guiRelayout',n,{shapes:o}),n._fullLayout._drawing=!1}}r.selection={},r.selection.selectionDefs=t.selectionDefs=[],r.selection.mergedPolygons=t.mergedPolygons=[]}function U(t,e,r,n){var i,a,o,s=[],l=e.map((function(t){return t._id})),c=r.map((function(t){return t._id}));for(o=0;o<t.calcdata.length;o++)if(!0===(a=(i=t.calcdata[o])[0].trace).visible&&a._module&&a._module.selectPoints)if(!n||a.subplot!==n&&a.geo!==n)if("splom"===a.type&&a._xaxes[l[0]]&&a._yaxes[c[0]]){var u=h(a._module,i,e[0],r[0]);u.scene=t._fullLayout._splomScenes[a.uid],s.push(u)}else if("sankey"===a.type){var f=h(a._module,i,e[0],r[0]);s.push(f)}else{if(-1===l.indexOf(a.xaxis))continue;if(-1===c.indexOf(a.yaxis))continue;s.push(h(a._module,i,_(t,a.xaxis),_(t,a.yaxis)))}else s.push(h(a._module,i,e[0],r[0]));return s;function h(t,e,r,n){return{_module:t,cd:e,xaxis:r,yaxis:n}}}function V(t){return t&&Array.isArray(t)&&!0!==t[0].hoverOnBox}function H(t,e){var r,n,i=t[0],a=-1,o=[];for(n=0;n<e.length;n++)if(r=e[n],i.fullData._expandedIndex===r.cd[0].trace._expandedIndex){if(!0===i.hoverOnBox)break;void 0!==i.pointNumber?a=i.pointNumber:void 0!==i.binNumber&&(a=i.binNumber,o=i.pointNumbers);break}return{pointNumber:a,pointNumbers:o,searchInfo:r}}function q(t){var e=t.searchInfo.cd[0].trace,r=t.pointNumber,n=t.pointNumbers,i=n.length>0?n[0]:r;return!!e.selectedpoints&&e.selectedpoints.indexOf(i)>-1}function G(t,e){var r,n,i,a=[];for(i=0;i<t.length;i++)(r=t[i]).cd[0].trace.selectedpoints&&r.cd[0].trace.selectedpoints.length>0&&a.push(r);if(1===a.length&&a[0]===e.searchInfo&&(n=e.searchInfo.cd[0].trace).selectedpoints.length===e.pointNumbers.length){for(i=0;i<e.pointNumbers.length;i++)if(n.selectedpoints.indexOf(e.pointNumbers[i])<0)return!1;return!0}return!1}function Y(t){var e,r,n=0;for(r=0;r<t.length;r++)if((e=t[r].cd[0].trace).selectedpoints){if(e.selectedpoints.length>1)return!1;if((n+=e.selectedpoints.length)>1)return!1}return 1===n}function W(t,e,r){var n,a,o,s;for(n=0;n<e.length;n++){var l=e[n].cd[0].trace._fullInput,c=t._fullLayout._tracePreGUI[l.uid]||{};void 0===c.selectedpoints&&(c.selectedpoints=l._input.selectedpoints||null)}if(r){var u=r.points||[];for(n=0;n<e.length;n++)(s=e[n].cd[0].trace)._input.selectedpoints=s._fullInput.selectedpoints=[],s._fullInput!==s&&(s.selectedpoints=[]);for(n=0;n<u.length;n++){var f=u[n],h=f.data,p=f.fullData;f.pointIndices?([].push.apply(h.selectedpoints,f.pointIndices),s._fullInput!==s&&[].push.apply(p.selectedpoints,f.pointIndices)):(h.selectedpoints.push(f.pointIndex),s._fullInput!==s&&p.selectedpoints.push(f.pointIndex))}}else for(n=0;n<e.length;n++)delete(s=e[n].cd[0].trace).selectedpoints,delete s._input.selectedpoints,s._fullInput!==s&&delete s._fullInput.selectedpoints;var d=!1;for(n=0;n<e.length;n++){s=(o=(a=e[n]).cd)[0].trace,i.traceIs(s,'regl')&&(d=!0);var m=a._module,g=m.styleOnSelect||m.style;g&&(g(t,o,o[0].node3),o[0].nodeRangePlot3&&g(t,o,o[0].nodeRangePlot3))}d&&(w(t),T(t))}function X(t,e,r){return r?n.difference({regions:t,inverted:!1},{regions:[e],inverted:!1}).regions:n.union({regions:t,inverted:!1},{regions:[e],inverted:!1}).regions}function Z(t,e){if(Array.isArray(t))for(var r=e.cd,n=e.cd[0].trace,i=0;i<t.length;i++)t[i]=l(t[i],n,r);return t}function J(t,e){for(var r=[],n=0;n<t.length;n++){r[n]=[];for(var i=0;i<t[n].length;i++){r[n][i]=[],r[n][i][0]=i?"L":"M";for(var a=0;a<t[n][i].length;a++)r[n][i].push(t[n][i][a])}e||r[n].push(["Z",r[n][0][1],r[n][0][2]])}return r}e.exports={prepSelect:z,clearSelect:E,clearSelectionsCache:j,selectOnClick:O}},{"../../components/color":650,"../../components/dragelement/helpers":668,"../../components/drawing":672,"../../components/fx":690,"../../components/fx/helpers":686,"../../components/shapes/draw_newshape/display_outlines":738,"../../components/shapes/draw_newshape/helpers":739,"../../components/shapes/draw_newshape/newshapes":740,"../../lib":787,"../../lib/clear_gl_canvases":771,"../../lib/polygon":799,"../../lib/throttle":814,"../../plot_api/subroutines":828,"../../registry":915,"./axis_ids":842,"./constants":845,"./handle_outline":849,"./helpers":850,polybooljs:490}],859:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-time-format').utcFormat,a=t('../../lib'),o=a.numberFormat,s=t('fast-isnumeric'),l=a.cleanNumber,c=a.ms2DateTime,u=a.dateTime2ms,f=a.ensureNumber,h=a.isArrayOrTypedArray,p=t('../../constants/numerical'),d=p.FP_SAFE,m=p.BADNUM,g=p.LOG_CLIP,v=p.ONEWEEK,y=p.ONEDAY,x=p.ONEHOUR,b=p.ONEMIN,_=p.ONESEC,w=t('./axis_ids'),T=t('./constants'),k=T.HOUR_PATTERN,M=T.WEEKDAY_PATTERN;function A(t){return Math.pow(10,t)}function S(t){return null!==t&&void 0!==t}e.exports=function(t,e)[e=e||{];var r=t._id||"x",p=r.charAt(0);function E(e,r){if(e>0)return Math.log(e)/Math.LN10;if(e<=0&&r&&t.range&&2===t.range.length){var n=t.range[0],i=t.range[1];return.5*(n+i-2*g*Math.abs(n-i))}return m}function L(e,r,n,i)[if((i||{]).msUTC&&s(e))return+e;var o=u(e,n||t.calendar);if(o===m){if(!s(e))return m;e=+e;var l=Math.floor(10*a.mod(e+.05,1)),c=Math.round(e-l/10);o=u(new Date(c))+l/10}return o}function C(e,r,n){return c(e,r,n||t.calendar)}function P(e){return t._categories[Math.round(e)]}function I(e)[if(S(e)){if(void 0===t._categoriesMap&&(t._categoriesMap={]),void 0!==t._categoriesMap[e])return t._categoriesMap[e];t._categories.push("number"===typeof e?String(e):e);var r=t._categories.length-1;return t._categoriesMap[e]=r,r}return m}function z(t,e){for(var r=new Array(e),n=0;n<e;n++){var i=(t[0]||[])[n],a=(t[1]||[])[n];r[n]=O([i,a])}return r}function O(e){if(t._categoriesMap)return t._categoriesMap[e]}function D(t){var e=O(t);return void 0!==e?e:s(t)?+t:void 0}function R(t){return s(t)?+t:O(t)}function F(t,e,r){return n.round(r+e*t,2)}function B(t,e,r){return(t-r)/e}var N=function(e){return s(e)?F(e,t._m,t._b):m},j=function(e){return B(e,t._m,t._b)};if(t.rangebreaks){var U="y"===p;N=function(e){if(!s(e))return m;var r=t._rangebreaks.length;if(!r)return F(e,t._m,t._b);var n=U;t.range[0]>t.range[1]&&(n=!n);for(var i=n?-1:1,a=i*e,o=0,l=0;l<r;l++){var c=i*t._rangebreaks[l].min,u=i*t._rangebreaks[l].max;if(a<c)break;if(!(a>u)){o=a<(c+u)/2?l:l+1;break}o=l+1}var f=t._B[o]||0;return isFinite(f)?F(e,t._m2,f):0},j=function(e){var r=t._rangebreaks.length;if(!r)return B(e,t._m,t._b);for(var n=0,i=0;i<r&&!(e<t._rangebreaks[i].pmin);i++)e>t._rangebreaks[i].pmax&&(n=i+1);return B(e,t._m2,t._B[n])}}t.c2l="log"===t.type?E:f,t.l2c="log"===t.type?A:f,t.l2p=N,t.p2l=j,t.c2p="log"===t.type?function(t,e){return N(E(t,e))}:N,t.p2c="log"===t.type?function(t){return A(j(t))}:j,-1!==["linear","-"].indexOf(t.type)?(t.d2r=t.r2d=t.d2c=t.r2c=t.d2l=t.r2l=l,t.c2d=t.c2r=t.l2d=t.l2r=f,t.d2p=t.r2p=function(e){return t.l2p(l(e))},t.p2d=t.p2r=j,t.cleanPos=f):"log"===t.type?(t.d2r=t.d2l=function(t,e){return E(l(t),e)},t.r2d=t.r2c=function(t){return A(l(t))},t.d2c=t.r2l=l,t.c2d=t.l2r=f,t.c2r=E,t.l2d=A,t.d2p=function(e,r){return t.l2p(t.d2r(e,r))},t.p2d=function(t){return A(j(t))},t.r2p=function(e){return t.l2p(l(e))},t.p2r=j,t.cleanPos=f):"date"===t.type?(t.d2r=t.r2d=a.identity,t.d2c=t.r2c=t.d2l=t.r2l=L,t.c2d=t.c2r=t.l2d=t.l2r=C,t.d2p=t.r2p=function(e,r,n){return t.l2p(L(e,0,n))},t.p2d=t.p2r=function(t,e,r){return C(j(t),e,r)},t.cleanPos=function(e){return a.cleanDate(e,m,t.calendar)}):"category"===t.type?(t.d2c=t.d2l=I,t.r2d=t.c2d=t.l2d=P,t.d2r=t.d2l_noadd=D,t.r2c=function(e){var r=R(e);return void 0!==r?r:t.fraction2r(.5)},t.l2r=t.c2r=f,t.r2l=R,t.d2p=function(e){return t.l2p(t.r2c(e))},t.p2d=function(t){return P(j(t))},t.r2p=t.d2p,t.p2r=j,t.cleanPos=function(t){return"string"===typeof t&&""!==t?t:f(t)}):"multicategory"===t.type&&(t.r2d=t.c2d=t.l2d=P,t.d2r=t.d2l_noadd=D,t.r2c=function(e){var r=D(e);return void 0!==r?r:t.fraction2r(.5)},t.r2c_just_indices=O,t.l2r=t.c2r=f,t.r2l=D,t.d2p=function(e){return t.l2p(t.r2c(e))},t.p2d=function(t){return P(j(t))},t.r2p=t.d2p,t.p2r=j,t.cleanPos=function(t){return Array.isArray(t)||"string"===typeof t&&""!==t?t:f(t)},t.setupMultiCategory=function(n){var i,o,s=t._traceIndices,l=t._matchGroup;if(l&&0===t._categories.length)for(var c in l)if(c!==r){var u=e[w.id2name(c)];s=s.concat(u._traceIndices)}var f=[[0,{}],[0,{}]],d=[];for(i=0;i<s.length;i++){var m=n[s[i]];if(p in m){var g=m[p],v=m._length||a.minRowLength(g);if(h(g[0])&&h(g[1]))for(o=0;o<v;o++){var y=g[0][o],x=g[1][o];S(y)&&S(x)&&(d.push([y,x]),y in f[0][1]||(f[0][1][y]=f[0][0]++),x in f[1][1]||(f[1][1][x]=f[1][0]++))}}}for(d.sort((function(t,e){var r=f[0][1],n=r[t[0]]-r[e[0]];if(n)return n;var i=f[1][1];return i[t[1]]-i[e[1]]})),i=0;i<d.length;i++)I(d[i])}),t.fraction2r=function(e){var r=t.r2l(t.range[0]),n=t.r2l(t.range[1]);return t.l2r(r+e*(n-r))},t.r2fraction=function(e){var r=t.r2l(t.range[0]),n=t.r2l(t.range[1]);return(t.r2l(e)-r)/(n-r)},t.cleanRange=function(e,r)[r||(r={]),e||(e='range');var n,i,o=a.nestedProperty(t,e).get();if(i=(i="date"===t.type?a.dfltRange(t.calendar):"y"===p?T.DFLTRANGEY:r.dfltRange||T.DFLTRANGEX).slice(),"tozero"!==t.rangemode&&"nonnegative"!==t.rangemode||(i[0]=0),o&&2===o.length)for("date"!==t.type||t.autorange||(o[0]=a.cleanDate(o[0],m,t.calendar),o[1]=a.cleanDate(o[1],m,t.calendar)),n=0;n<2;n++)if("date"===t.type){if(!a.isDateTime(o[n],t.calendar)){t[e]=i;break}if(t.r2l(o[0])===t.r2l(o[1])){var l=a.constrain(t.r2l(o[0]),a.MIN_MS+1e3,a.MAX_MS-1e3);o[0]=t.l2r(l-1e3),o[1]=t.l2r(l+1e3);break}}else{if(!s(o[n])){if(!s(o[1-n])){t[e]=i;break}o[n]=o[1-n]*(n?10:.1)}if(o[n]<-d?o[n]=-d:o[n]>d&&(o[n]=d),o[0]===o[1]){var c=Math.max(1,Math.abs(1e-6*o[0]));o[0]-=c,o[1]+=c}}else a.nestedProperty(t,e).set(i)},t.setScale=function(r){var n=e._size;if(t.overlaying){var i=w.getFromId({_fullLayout:e},t.overlaying);t.domain=i.domain}var a=r&&t._r?"_r":"range",o=t.calendar;t.cleanRange(a);var s,l,c=t.r2l(t[a][0],o),u=t.r2l(t[a][1],o),f="y"===p;if(f?(t._offset=n.t+(1-t.domain[1])*n.h,t._length=n.h*(t.domain[1]-t.domain[0]),t._m=t._length/(c-u),t._b=-t._m*u):(t._offset=n.l+t.domain[0]*n.w,t._length=n.w*(t.domain[1]-t.domain[0]),t._m=t._length/(u-c),t._b=-t._m*c),t._rangebreaks=[],t._lBreaks=0,t._m2=0,t._B=[],t.rangebreaks&&(t._rangebreaks=t.locateBreaks(Math.min(c,u),Math.max(c,u)),t._rangebreaks.length)){for(s=0;s<t._rangebreaks.length;s++)l=t._rangebreaks[s],t._lBreaks+=Math.abs(l.max-l.min);var h=f;c>u&&(h=!h),h&&t._rangebreaks.reverse();var d=h?-1:1;for(t._m2=d*t._length/(Math.abs(u-c)-t._lBreaks),t._B.push(-t._m2*(f?u:c)),s=0;s<t._rangebreaks.length;s++)l=t._rangebreaks[s],t._B.push(t._B[t._B.length-1]-d*t._m2*(l.max-l.min));for(s=0;s<t._rangebreaks.length;s++)(l=t._rangebreaks[s]).pmin=N(l.min),l.pmax=N(l.max)}if(!isFinite(t._m)||!isFinite(t._b)||t._length<0)throw e._replotting=!1,new Error('Something went wrong with axis scaling')},t.maskBreaks=function(e){var r,n,i,o,s,c=t.rangebreaks||[];c._cachedPatterns||(c._cachedPatterns=c.map((function(e){return e.enabled&&e.bounds?a.simpleMap(e.bounds,e.pattern?l:t.d2c):null}))),c._cachedValues||(c._cachedValues=c.map((function(e){return e.enabled&&e.values?a.simpleMap(e.values,t.d2c).sort(a.sorterAsc):null})));for(var u=0;u<c.length;u++){var f=c[u];if(f.enabled)if(f.bounds){var h=f.pattern;switch(n=(r=c._cachedPatterns[u])[0],i=r[1],h){case M:o=(s=new Date(e)).getUTCDay(),n>i&&(i+=7,o<n&&(o+=7));break;case k:o=(s=new Date(e)).getUTCHours()+(s.getUTCMinutes()/60+s.getUTCSeconds()/3600+s.getUTCMilliseconds()/36e5),n>i&&(i+=24,o<n&&(o+=24));break;case"":o=e}if(o>=n&&o<i)return m}else for(var p=c._cachedValues[u],d=0;d<p.length;d++)if(i=(n=p[d])+f.dvalue,e>=n&&e<i)return m}return e},t.locateBreaks=function(e,r){var n,i,o,s,c=[];if(!t.rangebreaks)return c;var u=t.rangebreaks.slice().sort((function(t,e){return t.pattern===M&&e.pattern===k?-1:e.pattern===M&&t.pattern===k?1:0})),f=function(t,n){if((t=a.constrain(t,e,r))!==(n=a.constrain(n,e,r))){for(var i=!0,o=0;o<c.length;o++){var s=c[o];t<s.max&&n>=s.min&&(t<s.min&&(s.min=t),n>s.max&&(s.max=n),i=!1)}i&&c.push({min:t,max:n})}};for(n=0;n<u.length;n++){var h=u[n];if(h.enabled)if(h.bounds){var p=e,d=r;h.pattern&&(p=Math.floor(p)),o=(i=a.simpleMap(h.bounds,h.pattern?l:t.r2l))[0],s=i[1];var m,g,w=new Date(p);switch(h.pattern){case M:g=v,m=(s-o+(s<o?7:0))*y,p+=o*y-(w.getUTCDay()*y+w.getUTCHours()*x+w.getUTCMinutes()*b+w.getUTCSeconds()*_+w.getUTCMilliseconds());break;case k:g=y,m=(s-o+(s<o?24:0))*x,p+=o*x-(w.getUTCHours()*x+w.getUTCMinutes()*b+w.getUTCSeconds()*_+w.getUTCMilliseconds());break;default:p=Math.min(i[0],i[1]),m=g=(d=Math.max(i[0],i[1]))-p}for(var T=p;T<d;T+=g)f(T,T+m)}else for(var A=a.simpleMap(h.values,t.d2c),S=0;S<A.length;S++)f(o=A[S],s=o+h.dvalue)}return c.sort((function(t,e){return t.min-e.min})),c},t.makeCalcdata=function(e,r,n){var i,o,s,l,c=t.type,u="date"===c&&e[r+"calendar"];if(r in e){if(i=e[r],l=e._length||a.minRowLength(i),a.isTypedArray(i)&&("linear"===c||"log"===c)){if(l===i.length)return i;if(i.subarray)return i.subarray(0,l)}if("multicategory"===c)return z(i,l);for(o=new Array(l),s=0;s<l;s++)o[s]=t.d2c(i[s],0,u,n)}else{var f=r+"0"in e?t.d2c(e[r+"0"],0,u):0,h=e["d"+r]?Number(e["d"+r]):1;for(i=e[{x:"y",y:"x"}[r]],l=e._length||i.length,o=new Array(l),s=0;s<l;s++)o[s]=f+s*h}if(t.rangebreaks)for(s=0;s<l;s++)o[s]=t.maskBreaks(o[s]);return o},t.isValidRange=function(e){return Array.isArray(e)&&2===e.length&&s(t.r2l(e[0]))&&s(t.r2l(e[1]))},t.isPtWithinRange=function(e,r){var n=t.c2l(e[p],null,r),i=t.r2l(t.range[0]),a=t.r2l(t.range[1]);return i<a?i<=n&&n<=a:a<=n&&n<=i},t._emptyCategories=function(){t._categories=[],t._categoriesMap={}},t.clearCalc=function(){var r=t._matchGroup;if(r){var n=null,i=null;for(var a in r){var o=e[w.id2name(a)];if(o._categories){n=o._categories,i=o._categoriesMap;break}}n&&i?(t._categories=n,t._categoriesMap=i):t._emptyCategories()}else t._emptyCategories();if(t._initialCategories)for(var s=0;s<t._initialCategories.length;s++)I(t._initialCategories[s])},t.sortByInitialCategories=function(){var n=[];if(t._emptyCategories(),t._initialCategories)for(var i=0;i<t._initialCategories.length;i++)I(t._initialCategories[i]);n=n.concat(t._traceIndices);var a=t._matchGroup;for(var o in a)if(r!==o){var s=e[w.id2name(o)];s._categories=t._categories,s._categoriesMap=t._categoriesMap,n=n.concat(s._traceIndices)}return n};var V=e._d3locale;"date"===t.type&&(t._dateFormat=V?V.timeFormat:i,t._extraFormat=e._extraFormat),t._separators=e.separators,t._numFormat=V?V.numberFormat:o,delete t._minDtick,delete t._forceTick0}},{"../../constants/numerical":763,"../../lib":787,"./axis_ids":842,"./constants":845,"@plotly/d3":58,"d3-time-format":172,"fast-isnumeric":246}],860:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color').contrast,a=t('./layout_attributes'),o=t('../array_container_defaults');function s(t,e,r,n,i){var a=c(t);r('tickprefix')&&r('showtickprefix',a),r('ticksuffix',i.tickSuffixDflt)&&r('showticksuffix',a)}function l(t,e,r,s,l){var f=c(t);if(r('tickprefix')&&r('showtickprefix',f),r('ticksuffix',l.tickSuffixDflt)&&r('showticksuffix',f),r('showticklabels')){var h=l.font||{},p=e.color,d=-1!==(e.ticklabelposition||"").indexOf('inside')?i(l.bgColor):p&&p!==a.color.dflt?p:h.color;if(n.coerceFont(r,'tickfont',{family:h.family,size:h.size,color:d}),r('tickangle'),"category"!==s){var m=r('tickformat');o(t,e,{name:"tickformatstops",inclusionAttr:"enabled",handleItemDefaults:u}),e.tickformatstops.length||delete e.tickformatstops,m||"date"===s||(r('showexponent',f),r('exponentformat'),r('minexponent'),r('separatethousands'))}}}function c(t){var e=["showexponent",'showtickprefix',"showticksuffix"].filter((function(e){return void 0!==t[e]})),r=function(r){return t[r]===t[e[0]]};if(e.every(r)||1===e.length)return t[e[0]]}function u(t,e){function r(r,i){return n.coerce(t,e,a.tickformatstops,r,i)}r('enabled')&&(r('dtickrange'),r('value'))}e.exports=function(t,e,r,n,i,a){a&&1!==a.pass||s(t,e,r,n,i),a&&2!==a.pass||l(t,e,r,n,i)}},{"../../components/color":650,"../../lib":787,"../array_container_defaults":833,"./layout_attributes":853}],861:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e,r,a){var o=n.coerce2(t,e,i,'ticklen'),s=n.coerce2(t,e,i,'tickwidth'),l=n.coerce2(t,e,i,'tickcolor',e.color);r('ticks',a.outerTicks||o||s||l?"outside":"")||(delete e.ticklen,delete e.tickwidth,delete e.tickcolor)}},{"../../lib":787,"./layout_attributes":853}],862:[function(t,e,r){"use strict";var n=t('./clean_ticks'),i=t('../../lib').isArrayOrTypedArray;e.exports=function(t,e,r,a){function o(r){var n=t[r];return void 0!==n?n:(e._template||{})[r]}var s=o('tick0'),l=o('dtick'),c=o('tickvals'),u=r('tickmode',i(c)?"array":l?"linear":"auto");if("auto"===u)r('nticks');else if("linear"===u){var f=e.dtick=n.dtick(l,a);e.tick0=n.tick0(s,a,e.calendar,f)}else"multicategory"!==a&&(void 0===r('tickvals')?e.tickmode="auto":r('ticktext'))}},{"../../lib":787,"./clean_ticks":844}],863:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../lib'),o=t('../../components/drawing'),s=t('./axes');e.exports=function(t,e,r,l){var c=t._fullLayout;if(0!==e.length){var u,f,h,p;l&&(u=l());var d=n.ease(r.easing);return t._transitionData._interruptCallbacks.push((function(){return window.cancelAnimationFrame(p),p=null,y()})),f=Date.now(),p=window.requestAnimationFrame(x),Promise.resolve()}function m(t){var e=t.xaxis,r=t.yaxis;c._defs.select("#"+t.clipId+"> rect").call(o.setTranslate,0,0).call(o.setScale,1,1),t.plot.call(o.setTranslate,e._offset,r._offset).call(o.setScale,1,1);var n=t.plot.selectAll('.scatterlayer .trace');n.selectAll('.point').call(o.setPointGroupScale,1,1),n.selectAll('.textpoint').call(o.setTextPointsScale,1,1),n.call(o.hideOutsideRangePoints,t)}function g(e,r){var n=e.plotinfo,i=n.xaxis,l=n.yaxis,c=i._length,u=l._length,f=!!e.xr1,h=!!e.yr1,p=[];if(f){var d=a.simpleMap(e.xr0,i.r2l),m=a.simpleMap(e.xr1,i.r2l),g=d[1]-d[0],v=m[1]-m[0];p[0]=(d[0]*(1-r)+r*m[0]-d[0])/(d[1]-d[0])*c,p[2]=c*(1-r+r*v/g),i.range[0]=i.l2r(d[0]*(1-r)+r*m[0]),i.range[1]=i.l2r(d[1]*(1-r)+r*m[1])}else p[0]=0,p[2]=c;if(h){var y=a.simpleMap(e.yr0,l.r2l),x=a.simpleMap(e.yr1,l.r2l),b=y[1]-y[0],_=x[1]-x[0];p[1]=(y[1]*(1-r)+r*x[1]-y[1])/(y[0]-y[1])*u,p[3]=u*(1-r+r*_/b),l.range[0]=i.l2r(y[0]*(1-r)+r*x[0]),l.range[1]=l.l2r(y[1]*(1-r)+r*x[1])}else p[1]=0,p[3]=u;s.drawOne(t,i,{skipTitle:!0}),s.drawOne(t,l,{skipTitle:!0}),s.redrawComponents(t,[i._id,l._id]);var w=f?c/p[2]:1,T=h?u/p[3]:1,k=f?p[0]:0,M=h?p[1]:0,A=f?p[0]/p[2]*c:0,S=h?p[1]/p[3]*u:0,E=i._offset-A,L=l._offset-S;n.clipRect.call(o.setTranslate,k,M).call(o.setScale,1/w,1/T),n.plot.call(o.setTranslate,E,L).call(o.setScale,w,T),o.setPointGroupScale(n.zoomScalePts,1/w,1/T),o.setTextPointsScale(n.zoomScaleTxt,1/w,1/T)}function v()[for(var r={],n=0;n<e.length;n++){var a=e[n],o=a.plotinfo.xaxis,s=a.plotinfo.yaxis;a.xr1&&(r[o._name+".range"]=a.xr1.slice()),a.yr1&&(r[s._name+".range"]=a.yr1.slice())}return u&&u(),i.call('relayout',t,r).then((function(){for(var t=0;t<e.length;t++)m(e[t].plotinfo)}))}function y()[for(var r={],n=0;n<e.length;n++){var a=e[n],o=a.plotinfo.xaxis,s=a.plotinfo.yaxis;a.xr0&&(r[o._name+".range"]=a.xr0.slice()),a.yr0&&(r[s._name+".range"]=a.yr0.slice())}return i.call('relayout',t,r).then((function(){for(var t=0;t<e.length;t++)m(e[t].plotinfo)}))}function x(){h=Date.now();for(var t=Math.min(1,(h-f)/r.duration),n=d(t),i=0;i<e.length;i++)g(e[i],n);h-f>r.duration?(v(),p=window.cancelAnimationFrame(x)):p=window.requestAnimationFrame(x)}s.redrawComponents(t)}},{"../../components/drawing":672,"../../lib":787,"../../registry":915,"./axes":838,"@plotly/d3":58}],864:[function(t,e,r){"use strict";var n=t('../../registry').traceIs,i=t('./axis_autotype');function a(t,e){if("-"===t.type){var r,a=t._id,c=a.charAt(0);-1!==a.indexOf('scene')&&(a=c);var u=o(e,a,c);if(u)if("histogram"!==u.type||c!=={v:"y",h:"x"}[u.orientation||"v"]){var f=c+"calendar",h=u[f],p={noMultiCategory:!n(u,'cartesian')||n(u,'noMultiCategory')};if("box"===u.type&&u._hasPreCompStats&&c==={h:"x",v:"y"}[u.orientation||"v"]&&(p.noMultiCategory=!0),p.autotypenumbers=t.autotypenumbers,l(u,c)){var d=s(u),m=[];for(r=0;r<e.length;r++){var g=e[r];n(g,'box-violin')&&(g[c+"axis"]||c)===a&&(void 0!==g[d]?m.push(g[d][0]):void 0!==g.name?m.push(g.name):m.push('text'),g[f]!==h&&(h=void 0))}t.type=i(m,h,p)}else if("splom"===u.type){var v=u.dimensions[u._axesDim[a]];v.visible&&(t.type=i(v.values,h,p))}else t.type=i(u[c]||[u[c+"0"]],h,p)}else t.type="linear"}}function o(t,e,r){for(var n=0;n<t.length;n++){var i=t[n];if("splom"===i.type&&i._length>0&&(i["_"+r+"axes"]||{})[e])return i;if((i[r+"axis"]||r)===e){if(l(i,r))return i;if((i[r]||[]).length||i[r+"0"])return i}}}function s(t){return{v:"x",h:"y"}[t.orientation||"v"]}function l(t,e){var r=s(t),i=n(t,'box-violin'),a=n(t._fullInput||{},'candlestick');return i&&!a&&e===r&&void 0===t[r]&&void 0===t[r+"0"]}e.exports=function(t,e,r,n){r('autotypenumbers',n.autotypenumbersDflt),"-"===r('type',(n.splomStash||{}).type)&&(a(e,n.data),"-"===e.type?e.type="linear":t.type=e.type)}},{"../../registry":915,"./axis_autotype":839}],865:[function(t,e,r){"use strict";var n=t('../registry'),i=t('../lib');function a(t,e,r){var n,a,o,s=!1;if("data"===e.type)n=t._fullData[null!==e.traces?e.traces[0]:0];else{if("layout"!==e.type)return!1;n=t._fullLayout}return a=i.nestedProperty(n,e.prop).get(),(o=r[e.type]=r[e.type]||{}).hasOwnProperty(e.prop)&&o[e.prop]!==a&&(s=!0),o[e.prop]=a,{changed:s,value:a}}function o(t,e){return Array.isArray(e[0])&&1===e[0].length&&-1!==["string","number"].indexOf(typeof e[0][0])?[type:"layout",prop:"_currentFrame",value:e[0][0].toString()]:[]}function s(t,e){var r=[],n=e[0],a={};if("string"===typeof n)a[n]=e[1];else{if(!i.isPlainObject(n))return r;a=n}return c(a,(function(t,e,n){r.push({type:"layout",prop:t,value:n})}),'',0),r}function l(t,e){var r,n,a,o,s=[];if(n=e[0],a=e[1],r=e[2],o={},"string"===typeof n)o[n]=a;else{if(!i.isPlainObject(n))return s;o=n,void 0===r&&(r=a)}return void 0===r&&(r=null),c(o,(function(e,n,i){var a,o;if(Array.isArray(i)){o=i.slice();var l=Math.min(o.length,t.data.length);r&&(l=Math.min(l,r.length)),a=[];for(var c=0;c<l;c++)a[c]=r?r[c]:c}else o=i,a=r?r.slice():null;if(null===a)Array.isArray(o)&&(o=o[0]);else if(Array.isArray(a)){if(!Array.isArray(o)){var u=o;o=[];for(var f=0;f<a.length;f++)o[f]=u}o.length=Math.min(a.length,o.length)}s.push({type:"data",prop:e,traces:a,value:o})}),'',0),s}function c(t,e,r,n){Object.keys(t).forEach((function(a){var o=t[a];if("_"!==a[0]){var s=r+(n>0?".":"")+a;i.isPlainObject(o)?c(o,e,s,n+1):e(s,a,o)}}))}r.manageCommandObserver=function(t,e,n,o)[var s={],l=!0;e&&e._commandObserver&&(s=e._commandObserver),s.cache||(s.cache={}),s.lookupTable={};var c=r.hasSimpleAPICommandBindings(t,n,s.lookupTable);if(e&&e._commandObserver){if(c)return s;if(e._commandObserver.remove)return e._commandObserver.remove(),e._commandObserver=null,s}if(c){a(t,c,s.cache),s.check=function(){if(l){var e=a(t,c,s.cache);return e.changed&&o&&void 0!==s.lookupTable[e.value]&&(s.disable(),Promise.resolve(o({value:e.value,type:c.type,prop:c.prop,traces:c.traces,index:s.lookupTable[e.value]})).then(s.enable,s.enable)),e.changed}};for(var u=["plotly_relayout",'plotly_redraw','plotly_restyle','plotly_update','plotly_animatingframe',"plotly_afterplot"],f=0;f<u.length;f++)t._internalOn(u[f],s.check);s.remove=function(){for(var e=0;e<u.length;e++)t._removeInternalListener(u[e],s.check)}}else i.log('Unable to automatically bind plot updates to API command'),s.lookupTable={},s.remove=function(){};return s.disable=function()[l=!1],s.enable=function()[l=!0],e&&(e._commandObserver=s),s},r.hasSimpleAPICommandBindings=function(t,e,n){var i,a,o=e.length;for(i=0;i<o;i++){var s,l=e[i],c=l.method,u=l.args;if(Array.isArray(u)||(u=[]),!c)return!1;var f=r.computeAPICommandBindings(t,c,u);if(1!==f.length)return!1;if(a){if((s=f[0]).type!==a.type)return!1;if(s.prop!==a.prop)return!1;if(Array.isArray(a.traces)){if(!Array.isArray(s.traces))return!1;s.traces.sort();for(var h=0;h<a.traces.length;h++)if(a.traces[h]!==s.traces[h])return!1}else if(s.prop!==a.prop)return!1}else a=f[0],Array.isArray(a.traces)&&a.traces.sort();var p=(s=f[0]).value;if(Array.isArray(p)){if(1!==p.length)return!1;p=p[0]}n&&(n[p]=i)}return a},r.executeAPICommand=function(t,e,r){if("skip"===e)return Promise.resolve();var a=n.apiMethodRegistry[e],o=[t];Array.isArray(r)||(r=[]);for(var s=0;s<r.length;s++)o.push(r[s]);return a.apply(null,o).catch((function(t){return i.warn("API call to Plotly."+e+" rejected.",t),Promise.reject(t)}))},r.computeAPICommandBindings=function(t,e,r){var n;switch(Array.isArray(r)||(r=[]),e){case"restyle":n=l(t,r);break;case"relayout":n=s(t,r);break;case"update":n=l(t,[r[0],r[2]]).concat(s(t,[r[1]]));break;case"animate":n=o(t,r);break;default:n=[]}return n}},{"../lib":787,"../registry":915}],866:[function(t,e,r){"use strict";var n=t('../lib/extend').extendFlat;r.attributes=function(t,e){e=e||{};var r={valType:"info_array",editType:(t=t||{}).editType,items:[{valType:"number",min:0,max:1,editType:t.editType},{valType:"number",min:0,max:1,editType:t.editType}],dflt:[0,1]},i=(t.name&&t.name,t.trace,e.description&&e.description,{x:n({},r,{}),y:n({},r,{}),editType:t.editType});return t.noGridCell||(i.row={valType:"integer",min:0,dflt:0,editType:t.editType},i.column={valType:"integer",min:0,dflt:0,editType:t.editType}),i},r.defaults=function(t,e,r,n){var i=n&&n.x||[0,1],a=n&&n.y||[0,1],o=e.grid;if(o){var s=r('domain.column');void 0!==s&&(s<o.columns?i=o._domains.x[s]:delete t.domain.column);var l=r('domain.row');void 0!==l&&(l<o.rows?a=o._domains.y[l]:delete t.domain.row)}var c=r('domain.x',i),u=r('domain.y',a);c[0]<c[1]||(t.domain.x=i.slice()),u[0]<u[1]||(t.domain.y=a.slice())}},{"../lib/extend":777}],867:[function(t,e,r){"use strict";e.exports=function(t){var e=t.editType,r=t.colorEditType;void 0===r&&(r=e);var n={family:{valType:"string",noBlank:!0,strict:!0,editType:e},size:{valType:"number",min:1,editType:e},color:{valType:"color",editType:r},editType:e};return t.arrayOk&&(n.family.arrayOk=!0,n.size.arrayOk=!0,n.color.arrayOk=!0),n}},{}],868:[function(t,e,r){"use strict";e.exports={_isLinkedToArray:"frames_entry",group:{valType:"string"},name:{valType:"string"},traces:{valType:"any"},baseframe:{valType:"string"},data:{valType:"any"},layout:{valType:"any"}}},{}],869:[function(t,e,r){"use strict";r.projNames={airy:"airy",aitoff:"aitoff","albers usa":"albersUsa",albers:"albers",august:"august","azimuthal equal area":"azimuthalEqualArea","azimuthal equidistant":"azimuthalEquidistant",baker:"baker",bertin1953:"bertin1953",boggs:"boggs",bonne:"bonne",bottomley:"bottomley",bromley:"bromley",collignon:"collignon","conic conformal":"conicConformal","conic equal area":"conicEqualArea","conic equidistant":"conicEquidistant",craig:"craig",craster:"craster","cylindrical equal area":"cylindricalEqualArea","cylindrical stereographic":"cylindricalStereographic",eckert1:"eckert1",eckert2:"eckert2",eckert3:"eckert3",eckert4:"eckert4",eckert5:"eckert5",eckert6:"eckert6",eisenlohr:"eisenlohr",equirectangular:"equirectangular",fahey:"fahey","foucaut sinusoidal":"foucautSinusoidal",foucaut:"foucaut",ginzburg4:"ginzburg4",ginzburg5:"ginzburg5",ginzburg6:"ginzburg6",ginzburg8:"ginzburg8",ginzburg9:"ginzburg9",gnomonic:"gnomonic","gringorten quincuncial":"gringortenQuincuncial",gringorten:"gringorten",guyou:"guyou",hammer:"hammer",hill:"hill",homolosine:"homolosine",hufnagel:"hufnagel",hyperelliptical:"hyperelliptical",kavrayskiy7:"kavrayskiy7",lagrange:"lagrange",larrivee:"larrivee",laskowski:"laskowski",loximuthal:"loximuthal",mercator:"mercator",miller:"miller",mollweide:"mollweide","mt flat polar parabolic":"mtFlatPolarParabolic","mt flat polar quartic":"mtFlatPolarQuartic","mt flat polar sinusoidal":"mtFlatPolarSinusoidal","natural earth":"naturalEarth","natural earth1":"naturalEarth1","natural earth2":"naturalEarth2","nell hammer":"nellHammer",nicolosi:"nicolosi",orthographic:"orthographic",patterson:"patterson","peirce quincuncial":"peirceQuincuncial",polyconic:"polyconic","rectangular polyconic":"rectangularPolyconic",robinson:"robinson",satellite:"satellite","sinu mollweide":"sinuMollweide",sinusoidal:"sinusoidal",stereographic:"stereographic",times:"times","transverse mercator":"transverseMercator","van der grinten":"vanDerGrinten","van der grinten2":"vanDerGrinten2","van der grinten3":"vanDerGrinten3","van der grinten4":"vanDerGrinten4",wagner4:"wagner4",wagner6:"wagner6",wiechel:"wiechel","winkel tripel":"winkel3",winkel3:"winkel3"},r.axesNames=["lonaxis","lataxis"],r.lonaxisSpan={orthographic:180,"azimuthal equal area":360,"azimuthal equidistant":360,"conic conformal":180,gnomonic:160,stereographic:180,"transverse mercator":180,"*":360},r.lataxisSpan={"conic conformal":150,stereographic:179.5,"*":180},r.scopeDefaults={world:{lonaxisRange:[-180,180],lataxisRange:[-90,90],projType:"equirectangular",projRotate:[0,0,0]},usa:{lonaxisRange:[-180,-50],lataxisRange:[15,80],projType:"albers usa"},europe:{lonaxisRange:[-30,60],lataxisRange:[30,85],projType:"conic conformal",projRotate:[15,0,0],projParallels:[0,60]},asia:{lonaxisRange:[22,160],lataxisRange:[-15,55],projType:"mercator",projRotate:[0,0,0]},africa:{lonaxisRange:[-30,60],lataxisRange:[-40,40],projType:"mercator",projRotate:[0,0,0]},"north america":{lonaxisRange:[-180,-45],lataxisRange:[5,85],projType:"conic conformal",projRotate:[-100,0,0],projParallels:[29.5,45.5]},"south america":{lonaxisRange:[-100,-30],lataxisRange:[-60,15],projType:"mercator",projRotate:[0,0,0]}},r.clipPad=.001,r.precision=.1,r.landColor='#F0DC82',r.waterColor='#3399FF',r.locationmodeToLayer={"ISO-3":"countries","USA-states":"subunits","country names":"countries"},r.sphereSVG={type:"Sphere"},r.fillLayers={ocean:1,land:1,lakes:1},r.lineLayers={subunits:1,countries:1,coastlines:1,rivers:1,frame:1},r.layers=["bg",'ocean','land','lakes','subunits','countries','coastlines','rivers','lataxis','lonaxis','frame','backplot',"frontplot"],r.layersForChoropleth=["bg",'ocean','land','subunits','countries','coastlines','lataxis','lonaxis','frame','backplot','rivers','lakes',"frontplot"],r.layerNameToAdjective={ocean:"ocean",land:"land",lakes:"lake",subunits:"subunit",countries:"country",coastlines:"coastline",rivers:"river",frame:"frame"}},{}],870:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-geo'),a=i.geoPath,o=i.geoDistance,s=t('d3-geo-projection'),l=t('../../registry'),c=t('../../lib'),u=c.strTranslate,f=t('../../components/color'),h=t('../../components/drawing'),p=t('../../components/fx'),d=t('../plots'),m=t('../cartesian/axes'),g=t('../cartesian/autorange').getAutoRange,v=t('../../components/dragelement'),y=t('../cartesian/select').prepSelect,x=t('../cartesian/select').clearSelect,b=t('../cartesian/select').selectOnClick,_=t('./zoom'),w=t('./constants'),T=t('../../lib/geo_location_utils'),k=t('../../lib/topojson_utils'),M=t('topojson-client').feature;function A(t){this.id=t.id,this.graphDiv=t.graphDiv,this.container=t.container,this.topojsonURL=t.topojsonURL,this.isStatic=t.staticPlot,this.topojsonName=null,this.topojson=null,this.projection=null,this.scope=null,this.viewInitial=null,this.fitScale=null,this.bounds=null,this.midPt=null,this.hasChoropleth=!1,this.traceHash={},this.layers={},this.basePaths={},this.dataPaths={},this.dataPoints={},this.clipDef=null,this.clipRect=null,this.bgRect=null,this.makeFramework()}var S=A.prototype;function E(t){var e=t.projection,r=e.type,n=w.projNames[r];n="geo"+c.titleCase(n);for(var l=(i[n]||s[n])(),u=t._isSatellite?180*Math.acos(1/e.distance)/Math.PI:t._isClipped?w.lonaxisSpan[r]/2:null,f=["center",'rotate','parallels',"clipExtent"],h=function(t){return t?l:[]},p=0;p<f.length;p++){var d=f[p];"function"!==typeof l[d]&&(l[d]=h)}return l.isLonLatOverEdges=function(t){if(null===l(t))return!0;if(u){var e=l.rotate();return o(t,[-e[0],-e[1]])>u*Math.PI/180}return!1},l.getPath=function(){return a().projection(l)},l.getBounds=function(t){return l.getPath().bounds(t)},l.precision(w.precision),t._isSatellite&&l.tilt(e.tilt).distance(e.distance),u&&l.clipAngle(u-w.clipPad),l}function L(t,e,r){var n,i,a,o=1e-6,s=2.5,l=e[t],c=w.scopeDefaults[e.scope];"lonaxis"===t?(n=c.lonaxisRange,i=c.lataxisRange,a=function(t,e){return[t,e]}):"lataxis"===t&&(n=c.lataxisRange,i=c.lonaxisRange,a=function(t,e){return[e,t]});var u={type:"linear",range:[n[0],n[1]-o],tick0:l.tick0,dtick:l.dtick};m.setConvert(u,r);var f=m.calcTicks(u);e.isScoped||"lonaxis"!==t||f.pop();for(var h=f.length,p=new Array(h),d=0;d<h;d++)for(var g=f[d].x,v=p[d]=[],y=i[0];y<i[1]+s;y+=s)v.push(a(g,y));return{type:"MultiLineString",coordinates:p}}function C(t,e){var r=w.clipPad,n=t[0]+r,i=t[1]-r,a=e[0]+r,o=e[1]-r;n>0&&i<0&&(i+=360);var s=(i-n)/4;return{type:"Polygon",coordinates:[[[n,a],[n,o],[n+s,o],[n+2*s,o],[n+3*s,o],[i,o],[i,a],[i-s,a],[i-2*s,a],[i-3*s,a],[n,a]]]}}e.exports=function(t){return new A(t)},S.plot=function(t,e,r){var n=this,i=e[this.id],a=[],o=!1;for(var s in w.layerNameToAdjective)if("frame"!==s&&i["show"+s]){o=!0;break}for(var l=0;l<t.length;l++)if(t[0][0].trace.locationmode){o=!0;break}if(o){var c=k.getTopojsonName(i);null!==n.topojson&&c===n.topojsonName||(n.topojsonName=c,void 0===PlotlyGeoAssets.topojson[n.topojsonName]&&a.push(n.fetchTopojson()))}a=a.concat(T.fetchTraceGeoData(t)),r.push(new Promise((function(r,i){Promise.all(a).then((function(){n.topojson=PlotlyGeoAssets.topojson[n.topojsonName],n.update(t,e),r()})).catch(i)})))},S.fetchTopojson=function(){var t=this,e=k.getTopojsonPath(t.topojsonURL,t.topojsonName);return new Promise((function(r,i){n.json(e,(function(n,a){if(n)return 404===n.status?i(new Error(["plotly.js could not find topojson file at",e,'.','Make sure the *topojsonURL* plot config option',"is set properly."].join(' '))):i(new Error(["unexpected error while fetching topojson file at",e].join(' ')));PlotlyGeoAssets.topojson[t.topojsonName]=a,r()}))}))},S.update=function(t,e){var r=e[this.id];this.hasChoropleth=!1;for(var n=0;n<t.length;n++){var i=t[n],a=i[0].trace;"choropleth"===a.type&&(this.hasChoropleth=!0),!0===a.visible&&a._length>0&&a._module.calcGeoJSON(i,e)}if(!this.updateProjection(t,e)){this.viewInitial&&this.scope===r.scope||this.saveViewInitial(r),this.scope=r.scope,this.updateBaseLayers(e,r),this.updateDims(e,r),this.updateFx(e,r),d.generalUpdatePerTraceModule(this.graphDiv,this,t,r);var o=this.layers.frontplot.select('.scatterlayer');this.dataPoints.point=o.selectAll('.point'),this.dataPoints.text=o.selectAll('text'),this.dataPaths.line=o.selectAll('.js-line');var s=this.layers.backplot.select('.choroplethlayer');this.dataPaths.choropleth=s.selectAll('path'),this.render()}},S.updateProjection=function(t,e){var r=this.graphDiv,n=e[this.id],i=e._size,a=n.domain,o=n.projection,s=n.lonaxis,l=n.lataxis,u=s._ax,f=l._ax,h=this.projection=E(n),p=[[i.l+i.w*a.x[0],i.t+i.h*(1-a.y[1])],[i.l+i.w*a.x[1],i.t+i.h*(1-a.y[0])]],d=n.center||{},m=o.rotation||{},v=s.range||[],y=l.range||[];if(n.fitbounds){u._length=p[1][0]-p[0][0],f._length=p[1][1]-p[0][1],u.range=g(r,u),f.range=g(r,f);var x=(u.range[0]+u.range[1])/2,b=(f.range[0]+f.range[1])/2;if(n._isScoped)d={lon:x,lat:b};else if(n._isClipped){d={lon:x,lat:b},m={lon:x,lat:b,roll:m.roll};var _=o.type,T=w.lonaxisSpan[_]/2||180,k=w.lataxisSpan[_]/2||90;v=[x-T,x+T],y=[b-k,b+k]}else d={lon:x,lat:b},m={lon:x,lat:m.lat,roll:m.roll}}h.center([d.lon-m.lon,d.lat-m.lat]).rotate([-m.lon,-m.lat,m.roll]).parallels(o.parallels);var M=C(v,y);h.fitExtent(p,M);var A=this.bounds=h.getBounds(M),S=this.fitScale=h.scale(),L=h.translate();if(n.fitbounds){var P=h.getBounds(C(u.range,f.range)),I=Math.min((A[1][0]-A[0][0])/(P[1][0]-P[0][0]),(A[1][1]-A[0][1])/(P[1][1]-P[0][1]));isFinite(I)?h.scale(I*S):c.warn("Something went wrong during"+this.id+"fitbounds computations.")}else h.scale(o.scale*S);var z=this.midPt=[(A[0][0]+A[1][0])/2,(A[0][1]+A[1][1])/2];if(h.translate([L[0]+(z[0]-L[0]),L[1]+(z[1]-L[1])]).clipExtent(A),n._isAlbersUsa){var O=h([d.lon,d.lat]),D=h.translate();h.translate([D[0]-(O[0]-D[0]),D[1]-(O[1]-D[1])])}},S.updateBaseLayers=function(t,e){var r=this,i=r.topojson,a=r.layers,o=r.basePaths;function s(t){return"lonaxis"===t||"lataxis"===t}function l(t){return Boolean(w.lineLayers[t])}function c(t){return Boolean(w.fillLayers[t])}var u=(this.hasChoropleth?w.layersForChoropleth:w.layers).filter((function(t){return l(t)||c(t)?e["show"+t]:!s(t)||e[t].showgrid})),p=r.framework.selectAll('.layer').data(u,String);p.exit().each((function(t){delete a[t],delete o[t],n.select(this).remove()})),p.enter().append('g').attr('class',(function(t){return"layer "+t})).each((function(t){var e=a[t]=n.select(this);"bg"===t?r.bgRect=e.append('rect').style('pointer-events','all'):s(t)?o[t]=e.append('path').style('fill','none'):"backplot"===t?e.append('g').classed('choroplethlayer',!0):"frontplot"===t?e.append('g').classed('scatterlayer',!0):l(t)?o[t]=e.append('path').style('fill','none').style('stroke-miterlimit',2):c(t)&&(o[t]=e.append('path').style('stroke','none'))})),p.order(),p.each((function(r){var n=o[r],a=w.layerNameToAdjective[r];"frame"===r?n.datum(w.sphereSVG):l(r)||c(r)?n.datum(M(i,i.objects[r])):s(r)&&n.datum(L(r,e,t)).call(f.stroke,e[r].gridcolor).call(h.dashLine,'',e[r].gridwidth),l(r)?n.call(f.stroke,e[a+"color"]).call(h.dashLine,'',e[a+"width"]):c(r)&&n.call(f.fill,e[a+"color"])}))},S.updateDims=function(t,e){var r=this.bounds,n=(e.framewidth||0)/2,i=r[0][0]-n,a=r[0][1]-n,o=r[1][0]-i+n,s=r[1][1]-a+n;h.setRect(this.clipRect,i,a,o,s),this.bgRect.call(h.setRect,i,a,o,s).call(f.fill,e.bgcolor),this.xaxis._offset=i,this.xaxis._length=o,this.yaxis._offset=a,this.yaxis._length=s},S.updateFx=function(t,e){var r=this,i=r.graphDiv,a=r.bgRect,o=t.dragmode,s=t.clickmode;if(!r.isStatic){var u;"select"===o?u=function(t,e){(t.range={})[r.id]=[d([e.xmin,e.ymin]),d([e.xmax,e.ymax])]}:"lasso"===o&&(u=function(t,e,n)[(t.lassoPoints={])[r.id]=n.filtered.map(d)});var f={element:r.bgRect.node(),gd:i,plotinfo:{id:r.id,xaxis:r.xaxis,yaxis:r.yaxis,fillRangeItems:u},xaxes:[r.xaxis],yaxes:[r.yaxis],subplot:r.id,clickFn:function(t)[2===t&&x(i)]};"pan"===o?(a.node().onmousedown=null,a.call(_(r,e)),a.on('dblclick.zoom',h),i._context._scrollZoom.geo||a.on('wheel.zoom',null)):"select"!==o&&"lasso"!==o||(a.on('.zoom',null),f.prepFn=function(t,e,r){y(t,e,r,f,o)},v.init(f)),a.on('mousemove',(function(){var t=r.projection.invert(c.getPositionFromD3Event());if(!t)return v.unhover(i,n.event);r.xaxis.p2c=function(){return t[0]},r.yaxis.p2c=function(){return t[1]},p.hover(i,n.event,r.id)})),a.on('mouseout',(function(){i._dragging||v.unhover(i,n.event)})),a.on('click',(function(){"select"!==o&&"lasso"!==o&&(s.indexOf('select')>-1&&b(n.event,i,[r.xaxis],[r.yaxis],r.id,f),s.indexOf('event')>-1&&p.click(i,n.event))}))}function h(){var t=r.viewInitial,e={};for(var n in t)e[r.id+"."+n]=t[n];l.call('_guiRelayout',i,e),i.emit('plotly_doubleclick',null)}function d(t){return r.projection.invert([t[0]+r.xaxis._offset,t[1]+r.yaxis._offset])}},S.makeFramework=function(){var t=this,e=t.graphDiv,r=e._fullLayout,i="clip"+r._uid+t.id;t.clipDef=r._clips.append('clipPath').attr('id',i),t.clipRect=t.clipDef.append('rect'),t.framework=n.select(t.container).append('g').attr('class',"geo "+t.id).call(h.setClipUrl,i,e),t.project=function(e){var r=t.projection(e);return r?[r[0]-t.xaxis._offset,r[1]-t.yaxis._offset]:[null,null]},t.xaxis={_id:"x",c2p:function(e){return t.project(e)[0]}},t.yaxis={_id:"y",c2p:function(e){return t.project(e)[1]}},t.mockAxis={type:"linear",showexponent:"all",exponentformat:"B"},m.setConvert(t.mockAxis,r)},S.saveViewInitial=function(t){var e,r=t.center||{},n=t.projection,i=n.rotation||{};this.viewInitial={fitbounds:t.fitbounds,"projection.scale":n.scale},e=t._isScoped?{"center.lon":r.lon,"center.lat":r.lat}:t._isClipped?{"projection.rotation.lon":i.lon,"projection.rotation.lat":i.lat}:{"center.lon":r.lon,"center.lat":r.lat,"projection.rotation.lon":i.lon},c.extendFlat(this.viewInitial,e)},S.render=function(){var t,e=this.projection,r=e.getPath();function n(t){var r=e(t.lonlat);return r?u(r[0],r[1]):null}function i(t){return e.isLonLatOverEdges(t.lonlat)?"none":null}for(t in this.basePaths)this.basePaths[t].attr('d',r);for(t in this.dataPaths)this.dataPaths[t].attr('d',(function(t){return r(t.geojson)}));for(t in this.dataPoints)this.dataPoints[t].attr('display',i).attr('transform',n)}},{"../../components/color":650,"../../components/dragelement":669,"../../components/drawing":672,"../../components/fx":690,"../../lib":787,"../../lib/geo_location_utils":780,"../../lib/topojson_utils":816,"../../registry":915,"../cartesian/autorange":837,"../cartesian/axes":838,"../cartesian/select":858,"../plots":901,"./constants":869,"./zoom":874,"@plotly/d3":58,"d3-geo":166,"d3-geo-projection":165,"topojson-client":586}],871:[function(t,e,r){"use strict";var n=t('../../plots/get_data').getSubplotCalcData,i=t('../../lib').counterRegex,a=t('./geo'),o='geo',s=i(o),l={};function c(t){for(var e=t._fullLayout,r=t.calcdata,i=e._subplots[o],s=0;s<i.length;s++){var l=i[s],c=n(r,o,l),u=e[l]._subplot;u||(u=a({id:l,graphDiv:t,container:e._geolayer.node(),topojsonURL:t._context.topojsonURL,staticPlot:t._context.staticPlot}),e[l]._subplot=u),u.plot(c,e,t._promises)}}function u(t,e,r,n){for(var i=n._subplots[o]||[],a=0;a<i.length;a++){var s=i[a],l=n[s]._subplot;!e[s]&&l&&(l.framework.remove(),l.clipDef.remove())}}function f(t){for(var e=t._fullLayout,r=e._subplots[o],n=0;n<r.length;n++){var i=e[r[n]];i._subplot.updateFx(e,i)}}l[o]={valType:"subplotid",dflt:o,editType:"calc"},e.exports={attr:o,name:o,idRoot:o,idRegex:s,attrRegex:s,attributes:l,layoutAttributes:t('./layout_attributes'),supplyLayoutDefaults:t('./layout_defaults'),plot:c,updateFx:f,clean:u}},{"../../lib":787,"../../plots/get_data":875,"./geo":870,"./layout_attributes":872,"./layout_defaults":873}],872:[function(t,e,r){"use strict";var n=t('../../components/color/attributes'),i=t('../domain').attributes,a=t('./constants'),o=t('../../plot_api/edit_types').overrideAll,s=t('../../lib/sort_object_keys'),l={range:{valType:"info_array",items:[valType:"number"},{valType:"number"}],showgrid:{valType:"boolean",dflt:!1},tick0:{valType:"number",dflt:0},dtick:{valType:"number"},gridcolor:{valType:"color",dflt:n.lightLine},gridwidth:{valType:"number",min:0,dflt:1}};(e.exports=o({domain:i({name:"geo"},{}),fitbounds:{valType:"enumerated",values:[!1,'locations',"geojson"],dflt:!1,editType:"plot"},resolution:{valType:"enumerated",values:[110,50],dflt:110,coerceNumber:!0},scope:{valType:"enumerated",values:s(a.scopeDefaults),dflt:"world"},projection:{type:{valType:"enumerated",values:s(a.projNames)},rotation:{lon:{valType:"number"},lat:{valType:"number"},roll:{valType:"number"}},tilt:{valType:"number",dflt:0},distance:{valType:"number",min:1.001,dflt:2},parallels:{valType:"info_array",items:[valType:"number"},{valType:"number"}],scale:{valType:"number",min:0,dflt:1}},center:{lon:{valType:"number"},lat:{valType:"number"}},visible:{valType:"boolean",dflt:!0},showcoastlines:{valType:"boolean"},coastlinecolor:{valType:"color",dflt:n.defaultLine},coastlinewidth:{valType:"number",min:0,dflt:1},showland:{valType:"boolean",dflt:!1},landcolor:{valType:"color",dflt:a.landColor},showocean:{valType:"boolean",dflt:!1},oceancolor:{valType:"color",dflt:a.waterColor},showlakes:{valType:"boolean",dflt:!1},lakecolor:{valType:"color",dflt:a.waterColor},showrivers:{valType:"boolean",dflt:!1},rivercolor:{valType:"color",dflt:a.waterColor},riverwidth:{valType:"number",min:0,dflt:1},showcountries:{valType:"boolean"},countrycolor:{valType:"color",dflt:n.defaultLine},countrywidth:{valType:"number",min:0,dflt:1},showsubunits:{valType:"boolean"},subunitcolor:{valType:"color",dflt:n.defaultLine},subunitwidth:{valType:"number",min:0,dflt:1},showframe:{valType:"boolean"},framecolor:{valType:"color",dflt:n.defaultLine},framewidth:{valType:"number",min:0,dflt:1},bgcolor:{valType:"color",dflt:n.background},lonaxis:l,lataxis:l},'plot','from-root')).uirevision={valType:"any",editType:"none"}},{"../../components/color/attributes":649,"../../lib/sort_object_keys":810,"../../plot_api/edit_types":820,"../domain":866,"./constants":869}],873:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../subplot_defaults'),a=t('../get_data').getSubplotData,o=t('./constants'),s=t('./layout_attributes'),l=o.axesNames;function c(t,e,r,i){var s=a(i.fullData,'geo',i.id).map((function(t){return t._expandedIndex})),c=r('resolution'),u=r('scope'),f=o.scopeDefaults[u],h=r('projection.type',f.projType),p=e._isAlbersUsa="albers usa"===h;p&&(u=e.scope='usa');var d=e._isScoped="world"!==u,m=e._isSatellite="satellite"===h,g=e._isConic=-1!==h.indexOf('conic')||"albers"===h,v=e._isClipped=!!o.lonaxisSpan[h];if(!1===t.visible)[var y=n.extendDeep({],e._template);y.showcoastlines=!1,y.showcountries=!1,y.showframe=!1,y.showlakes=!1,y.showland=!1,y.showocean=!1,y.showrivers=!1,y.showsubunits=!1,y.lonaxis&&(y.lonaxis.showgrid=!1),y.lataxis&&(y.lataxis.showgrid=!1),e._template=y}for(var x=r('visible'),b=0;b<l.length;b++){var _,w=l[b],T=[30,10][b];if(d)_=f[w+"Range"];else{var k=o[w+"Span"],M=(k[h]||k["*"])/2,A=r("projection.rotation."+w.substr(0,3),f.projRotate[b]);_=[A-M,A+M]}var S=r(w+".range",_);r(w+".tick0"),r(w+".dtick",T),r(w+".showgrid",!!x&&void 0)&&(r(w+".gridcolor"),r(w+".gridwidth")),e[w]._ax={type:"linear",_id:w.slice(0,3),_traceIndices:s,setScale:n.identity,c2l:n.identity,r2l:n.identity,autorange:!0,range:S.slice(),_m:1,_input:{}}}var E=e.lonaxis.range,L=e.lataxis.range,C=E[0],P=E[1];C>0&&P<0&&(P+=360);var I,z,O,D=(C+P)/2;if(!p){var R=d?f.projRotate:[D,0,0];I=r('projection.rotation.lon',R[0]),r('projection.rotation.lat',R[1]),r('projection.rotation.roll',R[2]),r('showcoastlines',!d&&x)&&(r('coastlinecolor'),r('coastlinewidth')),r('showocean',!!x&&void 0)&&r('oceancolor')}p?(z=-96.6,O=38.7):(z=d?D:I,O=(L[0]+L[1])/2),r('center.lon',z),r('center.lat',O),m&&(r('projection.tilt'),r('projection.distance')),g&&r('projection.parallels',f.projParallels||[0,60]),r('projection.scale'),r('showland',!!x&&void 0)&&r('landcolor'),r('showlakes',!!x&&void 0)&&r('lakecolor'),r('showrivers',!!x&&void 0)&&(r('rivercolor'),r('riverwidth')),r('showcountries',d&&"usa"!==u&&x)&&(r('countrycolor'),r('countrywidth')),("usa"===u||"north america"===u&&50===c)&&(r('showsubunits',x),r('subunitcolor'),r('subunitwidth')),d||r('showframe',x)&&(r('framecolor'),r('framewidth')),r('bgcolor'),r('fitbounds')&&(delete e.projection.scale,d?(delete e.center.lon,delete e.center.lat):v?(delete e.center.lon,delete e.center.lat,delete e.projection.rotation.lon,delete e.projection.rotation.lat,delete e.lonaxis.range,delete e.lataxis.range):(delete e.center.lon,delete e.center.lat,delete e.projection.rotation.lon))}e.exports=function(t,e,r){i(t,e,r,{type:"geo",attributes:s,handleDefaults:c,fullData:r,partition:"y"})}},{"../../lib":787,"../get_data":875,"../subplot_defaults":909,"./constants":869,"./layout_attributes":872}],874:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../registry'),o=Math.PI/180,s=180/Math.PI,l={cursor:"pointer"},c={cursor:"auto"};function u(t,e){var r=t.projection;return(e._isScoped?p:e._isClipped?m:d)(t,r)}function f(t,e){return n.behavior.zoom().translate(e.translate()).scale(e.scale())}function h(t,e,r){var n=t.id,o=t.graphDiv,s=o.layout,l=s[n],c=o._fullLayout,u=c[n],f={},h={};function p(t,e){f[n+"."+t]=i.nestedProperty(l,t).get(),a.call('_storeDirectGUIEdit',s,c._preGUI,f);var r=i.nestedProperty(u,t);r.get()!==e&&(r.set(e),i.nestedProperty(l,t).set(e),h[n+"."+t]=e)}r(p),p('projection.scale',e.scale()/t.fitScale),p('fitbounds',!1),o.emit('plotly_relayout',h)}function p(t,e){var r=f(t,e);function i(){n.select(this).style(l)}function a(){e.scale(n.event.scale).translate(n.event.translate),t.render();var r=e.invert(t.midPt);t.graphDiv.emit('plotly_relayouting',{"geo.projection.scale":e.scale()/t.fitScale,"geo.center.lon":r[0],"geo.center.lat":r[1]})}function o(r){var n=e.invert(t.midPt);r('center.lon',n[0]),r('center.lat',n[1])}function s(){n.select(this).style(c),h(t,e,o)}return r.on('zoomstart',i).on('zoom',a).on('zoomend',s),r}function d(t,e){var r,i,a,o,s,u,p,d,m,g=f(t,e),v=2;function y(t){return e.invert(t)}function x(t){var r=y(t);if(!r)return!0;var n=e(r);return Math.abs(n[0]-t[0])>v||Math.abs(n[1]-t[1])>v}function b(){n.select(this).style(l),r=n.mouse(this),i=e.rotate(),a=e.translate(),o=i,s=y(r)}function _(){if(u=n.mouse(this),x(r))return g.scale(e.scale()),void g.translate(e.translate());e.scale(n.event.scale),e.translate([a[0],n.event.translate[1]]),s?y(u)&&(d=y(u),p=[o[0]+(d[0]-s[0]),i[1],i[2]],e.rotate(p),o=p):s=y(r=u),m=!0,t.render();var l=e.rotate(),c=e.invert(t.midPt);t.graphDiv.emit('plotly_relayouting',{"geo.projection.scale":e.scale()/t.fitScale,"geo.center.lon":c[0],"geo.center.lat":c[1],"geo.projection.rotation.lon":-l[0]})}function w(){n.select(this).style(c),m&&h(t,e,T)}function T(r){var n=e.rotate(),i=e.invert(t.midPt);r('projection.rotation.lon',-n[0]),r('center.lon',i[0]),r('center.lat',i[1])}return g.on('zoomstart',b).on('zoom',_).on('zoomend',w),g}function m(t,e){var r,i={r:e.rotate(),k:e.scale()},a=f(t,e),o=E(a,'zoomstart','zoom','zoomend'),s=0,u=a.on;function p(t){s++||t({type:"zoomstart"})}function d(t){t({type:"zoom"})}function m(t){--s||t({type:"zoomend"})}function _(t){var r=e.rotate();t('projection.rotation.lon',-r[0]),t('projection.rotation.lat',-r[1])}return a.on('zoomstart',(function(){n.select(this).style(l);var t=n.mouse(this),s=e.rotate(),c=s,f=e.translate(),h=v(s);r=g(e,t),u.call(a,'zoom',(function(){var a=n.mouse(this);if(e.scale(i.k=n.event.scale),r){if(g(e,a)){e.rotate(s).translate(f);var l=g(e,a),u=x(r,l),p=k(y(h,u)),m=i.r=b(p,r,c);isFinite(m[0])&&isFinite(m[1])&&isFinite(m[2])||(m=c),e.rotate(m),c=m}}else r=g(e,t=a);d(o.of(this,arguments))})),p(o.of(this,arguments))})).on('zoomend',(function(){n.select(this).style(c),u.call(a,'zoom',null),m(o.of(this,arguments)),h(t,e,_)})).on('zoom.redraw',(function(){t.render();var r=e.rotate();t.graphDiv.emit('plotly_relayouting',{"geo.projection.scale":e.scale()/t.fitScale,"geo.projection.rotation.lon":-r[0],"geo.projection.rotation.lat":-r[1]})})),n.rebind(a,o,'on')}function g(t,e){var r=t.invert(e);return r&&isFinite(r[0])&&isFinite(r[1])&&M(r)}function v(t){var e=.5*t[0]*o,r=.5*t[1]*o,n=.5*t[2]*o,i=Math.sin(e),a=Math.cos(e),s=Math.sin(r),l=Math.cos(r),c=Math.sin(n),u=Math.cos(n);return[a*l*u+i*s*c,i*l*u-a*s*c,a*s*u+i*l*c,a*l*c-i*s*u]}function y(t,e){var r=t[0],n=t[1],i=t[2],a=t[3],o=e[0],s=e[1],l=e[2],c=e[3];return[r*o-n*s-i*l-a*c,r*s+n*o+i*c-a*l,r*l-n*c+i*o+a*s,r*c+n*l-i*s+a*o]}function x(t,e){if(t&&e){var r=S(t,e),n=Math.sqrt(A(r,r)),i=.5*Math.acos(Math.max(-1,Math.min(1,A(t,e)))),a=Math.sin(i)/n;return n&&[Math.cos(i),r[2]*a,-r[1]*a,r[0]*a]}}function b(t,e,r){var n=T(e,2,t[0]);n=T(n,1,t[1]),n=T(n,0,t[2]-r[2]);var i,a,o=e[0],l=e[1],c=e[2],u=n[0],f=n[1],h=n[2],p=Math.atan2(l,o)*s,d=Math.sqrt(o*o+l*l);Math.abs(f)>d?(a=(f>0?90:-90)-p,i=0):(a=Math.asin(f/d)*s-p,i=Math.sqrt(d*d-f*f));var m=180-a-2*p,g=(Math.atan2(h,u)-Math.atan2(c,i))*s,v=(Math.atan2(h,u)-Math.atan2(c,-i))*s;return _(r[0],r[1],a,g)<=_(r[0],r[1],m,v)?[a,g,r[2]]:[m,v,r[2]]}function _(t,e,r,n){var i=w(r-t),a=w(n-e);return Math.sqrt(i*i+a*a)}function w(t){return(t%360+540)%360-180}function T(t,e,r){var n=r*o,i=t.slice(),a=0===e?1:0,s=2===e?1:2,l=Math.cos(n),c=Math.sin(n);return i[a]=t[a]*l-t[s]*c,i[s]=t[s]*l+t[a]*c,i}function k(t){return[Math.atan2(2*(t[0]*t[1]+t[2]*t[3]),1-2*(t[1]*t[1]+t[2]*t[2]))*s,Math.asin(Math.max(-1,Math.min(1,2*(t[0]*t[2]-t[3]*t[1]))))*s,Math.atan2(2*(t[0]*t[3]+t[1]*t[2]),1-2*(t[2]*t[2]+t[3]*t[3]))*s]}function M(t){var e=t[0]*o,r=t[1]*o,n=Math.cos(r);return[n*Math.cos(e),n*Math.sin(e),Math.sin(r)]}function A(t,e){for(var r=0,n=0,i=t.length;n<i;++n)r+=t[n]*e[n];return r}function S(t,e){return[t[1]*e[2]-t[2]*e[1],t[2]*e[0]-t[0]*e[2],t[0]*e[1]-t[1]*e[0]]}function E(t){for(var e=0,r=arguments.length,i=[];++e<r;)i.push(arguments[e]);var a=n.dispatch.apply(null,i);return a.of=function(e,r){return function(i){var o;try{o=i.sourceEvent=n.event,i.target=t,n.event=i,a[i.type].apply(e,r)}finally[n.event=o]}},a}e.exports=u},{"../../lib":787,"../../registry":915,"@plotly/d3":58}],875:[function(t,e,r){"use strict";var n=t('../registry'),i=t('./cartesian/constants').SUBPLOT_PATTERN;r.getSubplotCalcData=function(t,e,r){var i=n.subplotsRegistry[e];if(!i)return[];for(var a=i.attr,o=[],s=0;s<t.length;s++){var l=t[s];l[0].trace[a]===r&&o.push(l)}return o},r.getModuleCalcData=function(t,e){var r,i=[],a=[];if(!(r="string"===typeof e?n.getModule(e).plot:"function"===typeof e?e:e.plot))return[i,t];for(var o=0;o<t.length;o++){var s=t[o],l=s[0].trace;!0===l.visible&&0!==l._length&&(l._module.plot===r?i.push(s):a.push(s))}return[i,a]},r.getSubplotData=function(t,e,r){if(!n.subplotsRegistry[e])return[];var a,o,s,l=n.subplotsRegistry[e].attr,c=[];if("gl2d"===e){var u=r.match(i);o="x"+u[1],s="y"+u[2]}for(var f=0;f<t.length;f++)a=t[f],"gl2d"===e&&n.traceIs(a,'gl2d')?a[l[0]]===o&&a[l[1]]===s&&c.push(a):a[l]===r&&c.push(a);return c}},{"../registry":915,"./cartesian/constants":845}],876:[function(t,e,r){"use strict";var n=t('mouse-change'),i=t('mouse-wheel'),a=t('mouse-event-offset'),o=t('../cartesian/constants'),s=t('has-passive-events');function l(t,e){this.element=t,this.plot=e,this.mouseListener=null,this.wheelListener=null,this.lastInputTime=Date.now(),this.lastPos=[0,0],this.boxEnabled=!1,this.boxInited=!1,this.boxStart=[0,0],this.boxEnd=[0,0],this.dragStart=[0,0]}function c(t){var e=t.mouseContainer,r=t.glplot,c=new l(e,r);function u(){t.xaxis.autorange=!1,t.yaxis.autorange=!1}function f(){for(var e=t.graphDiv._fullLayout._axisConstraintGroups,r=t.xaxis._id,n=t.yaxis._id,i=0;i<e.length;i++)if(-1!==e[i][r]){if(-1!==e[i][n])return!0;break}return!1}function h(e,n,i){var a,s,l=t.calcDataBox(),h=r.viewBox,p=c.lastPos[0],d=c.lastPos[1],m=o.MINDRAG*r.pixelRatio,g=o.MINZOOM*r.pixelRatio;function v(e,r,n){var i=Math.min(r,n),a=Math.max(r,n);i!==a?(l[e]=i,l[e+2]=a,c.dataBox=l,t.setRanges(l)):(t.selectBox.selectBox=[0,0,1,1],t.glplot.setDirty())}switch(n*=r.pixelRatio,i*=r.pixelRatio,i=h[3]-h[1]-i,t.fullLayout.dragmode){case"zoom":if(e){var y=n/(h[2]-h[0])*(l[2]-l[0])+l[0],x=i/(h[3]-h[1])*(l[3]-l[1])+l[1];c.boxInited||(c.boxStart[0]=y,c.boxStart[1]=x,c.dragStart[0]=n,c.dragStart[1]=i),c.boxEnd[0]=y,c.boxEnd[1]=x,c.boxInited=!0,c.boxEnabled||c.boxStart[0]===c.boxEnd[0]&&c.boxStart[1]===c.boxEnd[1]||(c.boxEnabled=!0);var b=Math.abs(c.dragStart[0]-n)<g,_=Math.abs(c.dragStart[1]-i)<g;if(!f()||b&&_)b&&(c.boxEnd[0]=c.boxStart[0]),_&&(c.boxEnd[1]=c.boxStart[1]);else{a=c.boxEnd[0]-c.boxStart[0],s=c.boxEnd[1]-c.boxStart[1];var w=(l[3]-l[1])/(l[2]-l[0]);Math.abs(a*w)>Math.abs(s)?(c.boxEnd[1]=c.boxStart[1]+Math.abs(a)*w*(s>=0?1:-1),c.boxEnd[1]<l[1]?(c.boxEnd[1]=l[1],c.boxEnd[0]=c.boxStart[0]+(l[1]-c.boxStart[1])/Math.abs(w)):c.boxEnd[1]>l[3]&&(c.boxEnd[1]=l[3],c.boxEnd[0]=c.boxStart[0]+(l[3]-c.boxStart[1])/Math.abs(w))):(c.boxEnd[0]=c.boxStart[0]+Math.abs(s)/w*(a>=0?1:-1),c.boxEnd[0]<l[0]?(c.boxEnd[0]=l[0],c.boxEnd[1]=c.boxStart[1]+(l[0]-c.boxStart[0])*Math.abs(w)):c.boxEnd[0]>l[2]&&(c.boxEnd[0]=l[2],c.boxEnd[1]=c.boxStart[1]+(l[2]-c.boxStart[0])*Math.abs(w)))}}else c.boxEnabled?(a=c.boxStart[0]!==c.boxEnd[0],s=c.boxStart[1]!==c.boxEnd[1],a||s?(a&&(v(0,c.boxStart[0],c.boxEnd[0]),t.xaxis.autorange=!1),s&&(v(1,c.boxStart[1],c.boxEnd[1]),t.yaxis.autorange=!1),t.relayoutCallback()):t.glplot.setDirty(),c.boxEnabled=!1,c.boxInited=!1):c.boxInited&&(c.boxInited=!1);break;case"pan":c.boxEnabled=!1,c.boxInited=!1,e?(c.panning||(c.dragStart[0]=n,c.dragStart[1]=i),Math.abs(c.dragStart[0]-n)<m&&(n=c.dragStart[0]),Math.abs(c.dragStart[1]-i)<m&&(i=c.dragStart[1]),a=(p-n)*(l[2]-l[0])/(r.viewBox[2]-r.viewBox[0]),s=(d-i)*(l[3]-l[1])/(r.viewBox[3]-r.viewBox[1]),l[0]+=a,l[2]+=a,l[1]+=s,l[3]+=s,t.setRanges(l),c.panning=!0,c.lastInputTime=Date.now(),u(),t.cameraChanged(),t.handleAnnotations()):c.panning&&(c.panning=!1,t.relayoutCallback())}c.lastPos[0]=n,c.lastPos[1]=i}return c.mouseListener=n(e,h),e.addEventListener('touchstart',(function(t){var r=a(t.changedTouches[0],e);h(0,r[0],r[1]),h(1,r[0],r[1]),t.preventDefault()}),!!s&&{passive:!1}),e.addEventListener('touchmove',(function(t){t.preventDefault();var r=a(t.changedTouches[0],e);h(1,r[0],r[1]),t.preventDefault()}),!!s&&{passive:!1}),e.addEventListener('touchend',(function(t){h(0,c.lastPos[0],c.lastPos[1]),t.preventDefault()}),!!s&&{passive:!1}),c.wheelListener=i(e,(function(e,n){if(!t.scrollZoom)return!1;var i=t.calcDataBox(),a=r.viewBox,o=c.lastPos[0],s=c.lastPos[1],l=Math.exp(5*n/(a[3]-a[1])),f=o/(a[2]-a[0])*(i[2]-i[0])+i[0],h=s/(a[3]-a[1])*(i[3]-i[1])+i[1];return i[0]=(i[0]-f)*l+f,i[2]=(i[2]-f)*l+f,i[1]=(i[1]-h)*l+h,i[3]=(i[3]-h)*l+h,t.setRanges(i),c.lastInputTime=Date.now(),u(),t.cameraChanged(),t.handleAnnotations(),t.relayoutCallback(),!0}),!0),c}e.exports=c},{"../cartesian/constants":845,"has-passive-events":436,"mouse-change":459,"mouse-event-offset":460,"mouse-wheel":462}],877:[function(t,e,r){"use strict";var n=t('../cartesian/axes'),i=t('../../lib/str2rgbarray');function a(t){this.scene=t,this.gl=t.gl,this.pixelRatio=t.pixelRatio,this.screenBox=[0,0,1,1],this.viewBox=[0,0,1,1],this.dataBox=[-1,-1,1,1],this.borderLineEnable=[!1,!1,!1,!1],this.borderLineWidth=[1,1,1,1],this.borderLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.ticks=[[],[]],this.tickEnable=[!0,!0,!1,!1],this.tickPad=[15,15,15,15],this.tickAngle=[0,0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickMarkLength=[0,0,0,0],this.tickMarkWidth=[0,0,0,0],this.tickMarkColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labels=["x","y"],this.labelEnable=[!0,!0,!1,!1],this.labelAngle=[0,Math.PI/2,0,3*Math.PI/2],this.labelPad=[15,15,15,15],this.labelSize=[12,12],this.labelFont=["sans-serif","sans-serif"],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.title='',this.titleEnable=!0,this.titleCenter=[0,0,0,0],this.titleAngle=0,this.titleColor=[0,0,0,1],this.titleFont='sans-serif',this.titleSize=18,this.gridLineEnable=[!0,!0],this.gridLineColor=[[0,0,0,.5],[0,0,0,.5]],this.gridLineWidth=[1,1],this.zeroLineEnable=[!0,!0],this.zeroLineWidth=[1,1],this.zeroLineColor=[[0,0,0,1],[0,0,0,1]],this.borderColor=[0,0,0,0],this.backgroundColor=[0,0,0,0],this.static=this.scene.staticPlot}var o=a.prototype,s=["xaxis","yaxis"];function l(t){return new a(t)}o.merge=function(t){var e,r,n,a,o,l,c,u,f,h,p;for(this.titleEnable=!1,this.backgroundColor=i(t.plot_bgcolor),h=0;h<2;++h){var d=(e=s[h]).charAt(0);for(n=(r=t[this.scene[e]._name]).title.text===this.scene.fullLayout._dfltTitle[d]?"":r.title.text,p=0;p<=2;p+=2)this.labelEnable[h+p]=!1,this.labels[h+p]=n,this.labelColor[h+p]=i(r.title.font.color),this.labelFont[h+p]=r.title.font.family,this.labelSize[h+p]=r.title.font.size,this.labelPad[h+p]=this.getLabelPad(e,r),this.tickEnable[h+p]=!1,this.tickColor[h+p]=i((r.tickfont||{}).color),this.tickAngle[h+p]="auto"===r.tickangle?0:Math.PI*-r.tickangle/180,this.tickPad[h+p]=this.getTickPad(r),this.tickMarkLength[h+p]=0,this.tickMarkWidth[h+p]=r.tickwidth||0,this.tickMarkColor[h+p]=i(r.tickcolor),this.borderLineEnable[h+p]=!1,this.borderLineColor[h+p]=i(r.linecolor),this.borderLineWidth[h+p]=r.linewidth||0;c=this.hasSharedAxis(r),o=this.hasAxisInDfltPos(e,r)&&!c,l=this.hasAxisInAltrPos(e,r)&&!c,a=r.mirror||!1,u=c?-1!==String(a).indexOf('all'):!!a,f=c?"allticks"===a:-1!==String(a).indexOf('ticks'),o?this.labelEnable[h]=!0:l&&(this.labelEnable[h+2]=!0),o?this.tickEnable[h]=r.showticklabels:l&&(this.tickEnable[h+2]=r.showticklabels),(o||u)&&(this.borderLineEnable[h]=r.showline),(l||u)&&(this.borderLineEnable[h+2]=r.showline),(o||f)&&(this.tickMarkLength[h]=this.getTickMarkLength(r)),(l||f)&&(this.tickMarkLength[h+2]=this.getTickMarkLength(r)),this.gridLineEnable[h]=r.showgrid,this.gridLineColor[h]=i(r.gridcolor),this.gridLineWidth[h]=r.gridwidth,this.zeroLineEnable[h]=r.zeroline,this.zeroLineColor[h]=i(r.zerolinecolor),this.zeroLineWidth[h]=r.zerolinewidth}},o.hasSharedAxis=function(t){var e=this.scene,r=e.fullLayout._subplots.gl2d;return 0!==n.findSubplotsWithAxis(r,t).indexOf(e.id)},o.hasAxisInDfltPos=function(t,e){var r=e.side;return"xaxis"===t?"bottom"===r:"yaxis"===t?"left"===r:void 0},o.hasAxisInAltrPos=function(t,e){var r=e.side;return"xaxis"===t?"top"===r:"yaxis"===t?"right"===r:void 0},o.getLabelPad=function(t,e){var r=1.5,n=e.title.font.size,i=e.showticklabels;return"xaxis"===t?"top"===e.side?n*(r+(i?1:0))-10:n*(r+(i?.5:0))-10:"yaxis"===t?"right"===e.side?10+n*(r+(i?1:.5)):10+n*(r+(i?.5:0)):void 0},o.getTickPad=function(t){return"outside"===t.ticks?10+t.ticklen:15},o.getTickMarkLength=function(t){if(!t.ticks)return 0;var e=t.ticklen;return"inside"===t.ticks?-e:e},e.exports=l},{"../../lib/str2rgbarray":812,"../cartesian/axes":838}],878:[function(t,e,r){"use strict";var n=t('../../plot_api/edit_types').overrideAll,i=t('./scene2d'),a=t('../layout_attributes'),o=t('../../constants/xmlns_namespaces'),s=t('../cartesian/constants'),l=t('../cartesian'),c=t('../../components/fx/layout_attributes'),u=t('../get_data').getSubplotData;r.name='gl2d',r.attr=["xaxis","yaxis"],r.idRoot=["x","y"],r.idRegex=s.idRegex,r.attrRegex=s.attrRegex,r.attributes=t('../cartesian/attributes'),r.supplyLayoutDefaults=function(t,e,r){e._has('cartesian')||l.supplyLayoutDefaults(t,e,r)},r.layoutAttrOverrides=n(l.layoutAttributes,'plot','from-root'),r.baseLayoutAttrOverrides=n({plot_bgcolor:a.plot_bgcolor,hoverlabel:c.hoverlabel},'plot','nested'),r.plot=function(t){for(var e=t._fullLayout,r=t._fullData,n=e._subplots.gl2d,a=0;a<n.length;a++){var o=n[a],s=e._plots[o],l=u(r,'gl2d',o),c=s._scene2d;void 0===c&&(c=new i({id:o,graphDiv:t,container:t.querySelector('.gl-container'),staticPlot:t._context.staticPlot,plotGlPixelRatio:t._context.plotGlPixelRatio},e),s._scene2d=c),c.plot(l,t.calcdata,e,t.layout)}},r.clean=function(t,e,r,n){for(var i=n._subplots.gl2d||[],a=0;a<i.length;a++){var o=i[a],s=n._plots[o];s._scene2d&&0===u(t,'gl2d',o).length&&(s._scene2d.destroy(),delete n._plots[o])}l.clean.apply(this,arguments)},r.drawFramework=function(t)[t._context.staticPlot||l.drawFramework(t)],r.toSVG=function(t){for(var e=t._fullLayout,r=e._subplots.gl2d,n=0;n<r.length;n++){var i=e._plots[r[n]]._scene2d,a=i.toImage('png');e._glimages.append('svg:image').attr({xmlns:o.svg,"xlink:href":a,x:0,y:0,width:"100%",height:"100%",preserveAspectRatio:"none"}),i.destroy()}},r.updateFx=function(t){for(var e=t._fullLayout,r=e._subplots.gl2d,n=0;n<r.length;n++)e._plots[r[n]]._scene2d.updateFx(e.dragmode)}},{"../../components/fx/layout_attributes":691,"../../constants/xmlns_namespaces":764,"../../plot_api/edit_types":820,"../cartesian":852,"../cartesian/attributes":836,"../cartesian/constants":845,"../get_data":875,"../layout_attributes":892,"./scene2d":879}],879:[function(t,e,r){"use strict";var n,i,a=t('../../registry'),o=t('../../plots/cartesian/axes'),s=t('../../components/fx'),l=t('gl-plot2d'),c=t('gl-spikes2d'),u=t('gl-select-box'),f=t('webgl-context'),h=t('./convert'),p=t('./camera'),d=t('../../lib/show_no_webgl_msg'),m=t('../cartesian/constraints'),g=m.enforce,v=m.clean,y=t('../cartesian/autorange').doAutoRange,x=t('../../components/dragelement/helpers'),b=x.drawMode,_=x.selectMode,w=["xaxis","yaxis"],T=t('../cartesian/constants').SUBPLOT_PATTERN;function k(t,e){this.container=t.container,this.graphDiv=t.graphDiv,this.pixelRatio=t.plotGlPixelRatio||window.devicePixelRatio,this.id=t.id,this.staticPlot=!!t.staticPlot,this.scrollZoom=this.graphDiv._context._scrollZoom.cartesian,this.fullData=null,this.updateRefs(e),this.makeFramework(),this.stopped||(this.glplotOptions=h(this),this.glplotOptions.merge(e),this.glplot=l(this.glplotOptions),this.camera=p(this),this.traces={},this.spikes=c(this.glplot),this.selectBox=u(this.glplot,{innerFill:!1,outerFill:!0}),this.lastButtonState=0,this.pickResult=null,this.isMouseOver=!0,this.stopped=!1,this.redraw=this.draw.bind(this),this.redraw())}e.exports=k;var M=k.prototype;function A(t,e){for(var r=0;r<2;++r){var n=t[r],i=e[r];if(n.length!==i.length)return!0;for(var a=0;a<n.length;++a)if(n[a].x!==i[a].x)return!0}return!1}M.makeFramework=function(){if(this.staticPlot){if(!i&&(n=document.createElement('canvas'),!(i=f({canvas:n,preserveDrawingBuffer:!1,premultipliedAlpha:!0,antialias:!0}))))throw new Error('Error creating static canvas/context for image server');this.canvas=n,this.gl=i}else{var t=this.container.querySelector('.gl-canvas-focus'),e=f({canvas:t,preserveDrawingBuffer:!0,premultipliedAlpha:!0});if(!e)return d(this),void(this.stopped=!0);this.canvas=t,this.gl=e}var r=this.canvas;r.style.width='100%',r.style.height='100%',r.style.position='absolute',r.style.top='0px',r.style.left='0px',r.style["pointer-events"]='none',this.updateSize(r);var a=this.svgContainer=document.createElementNS('http://www.w3.org/2000/svg','svg');a.style.position='absolute',a.style.top=a.style.left='0px',a.style.width=a.style.height='100%',a.style["z-index"]=20,a.style["pointer-events"]='none';var o=this.mouseContainer=document.createElement('div');o.style.position='absolute',o.style["pointer-events"]='auto',this.pickCanvas=this.container.querySelector('.gl-canvas-pick');var s=this.container;s.appendChild(a),s.appendChild(o);var l=this;o.addEventListener('mouseout',(function(){l.isMouseOver=!1,l.unhover()})),o.addEventListener('mouseover',(function()[l.isMouseOver=!0]))},M.toImage=function(t){t||(t='png'),this.stopped=!0,this.staticPlot&&this.container.appendChild(n),this.updateSize(this.canvas);var e=this.glplot.gl,r=e.drawingBufferWidth,i=e.drawingBufferHeight;e.clearColor(1,1,1,0),e.clear(e.COLOR_BUFFER_BIT|e.DEPTH_BUFFER_BIT),this.glplot.setDirty(),this.glplot.draw(),e.bindFramebuffer(e.FRAMEBUFFER,null);var a=new Uint8Array(r*i*4);e.readPixels(0,0,r,i,e.RGBA,e.UNSIGNED_BYTE,a);for(var o=0,s=i-1;o<s;++o,--s)for(var l=0;l<r;++l)for(var c=0;c<4;++c){var u=a[4*(r*o+l)+c];a[4*(r*o+l)+c]=a[4*(r*s+l)+c],a[4*(r*s+l)+c]=u}var f=document.createElement('canvas');f.width=r,f.height=i;var h,p=f.getContext('2d'),d=p.createImageData(r,i);switch(d.data.set(a),p.putImageData(d,0,0),t){case"jpeg":h=f.toDataURL('image/jpeg');break;case"webp":h=f.toDataURL('image/webp');break;default:h=f.toDataURL('image/png')}return this.staticPlot&&this.container.removeChild(n),h},M.updateSize=function(t){t||(t=this.canvas);var e=this.pixelRatio,r=this.fullLayout,n=r.width,i=r.height,a=0|Math.ceil(e*n),o=0|Math.ceil(e*i);return t.width===a&&t.height===o||(t.width=a,t.height=o),t},M.computeTickMarks=function(){this.xaxis.setScale(),this.yaxis.setScale();for(var t=[o.calcTicks(this.xaxis),o.calcTicks(this.yaxis)],e=0;e<2;++e)for(var r=0;r<t[e].length;++r)t[e][r].text=t[e][r].text+"";return t},M.updateRefs=function(t){this.fullLayout=t;var e=this.id.match(T),r="xaxis"+e[1],n="yaxis"+e[2];this.xaxis=this.fullLayout[r],this.yaxis=this.fullLayout[n]},M.relayoutCallback=function(){var t=this.graphDiv,e=this.xaxis,r=this.yaxis,n=t.layout,i={},o=i[e._name+".range"]=e.range.slice(),s=i[r._name+".range"]=r.range.slice();i[e._name+".autorange"]=e.autorange,i[r._name+".autorange"]=r.autorange,a.call('_storeDirectGUIEdit',t.layout,t._fullLayout._preGUI,i);var l=n[e._name];l.range=o,l.autorange=e.autorange;var c=n[r._name];c.range=s,c.autorange=r.autorange,i.lastInputTime=this.camera.lastInputTime,t.emit('plotly_relayout',i)},M.cameraChanged=function(){var t=this.camera;this.glplot.setDataBox(this.calcDataBox());var e=this.computeTickMarks();A(e,this.glplotOptions.ticks)&&(this.glplotOptions.ticks=e,this.glplotOptions.dataBox=t.dataBox,this.glplot.update(this.glplotOptions),this.handleAnnotations())},M.handleAnnotations=function(){for(var t=this.graphDiv,e=this.fullLayout.annotations,r=0;r<e.length;r++){var n=e[r];n.xref===this.xaxis._id&&n.yref===this.yaxis._id&&a.getComponentMethod('annotations','drawOne')(t,r)}},M.destroy=function(){if(this.glplot){var t=this.traces;t&&Object.keys(t).map((function(e){t[e].dispose(),delete t[e]})),this.glplot.dispose(),this.container.removeChild(this.svgContainer),this.container.removeChild(this.mouseContainer),this.fullData=null,this.glplot=null,this.stopped=!0,this.camera.mouseListener.enabled=!1,this.mouseContainer.removeEventListener('wheel',this.camera.wheelListener),this.camera=null}},M.plot=function(t,e,r){var n=this.glplot;this.updateRefs(r),this.xaxis.clearCalc(),this.yaxis.clearCalc(),this.updateTraces(t,e),this.updateFx(r.dragmode);var i=r.width,a=r.height;this.updateSize(this.canvas);var o=this.glplotOptions;o.merge(r),o.screenBox=[0,0,i,a];var s={_fullLayout:{_axisConstraintGroups:r._axisConstraintGroups,xaxis:this.xaxis,yaxis:this.yaxis,_size:r._size}};v(s,this.xaxis),v(s,this.yaxis);var l,c,u=r._size,f=this.xaxis.domain,h=this.yaxis.domain;for(o.viewBox=[u.l+f[0]*u.w,u.b+h[0]*u.h,i-u.r-(1-f[1])*u.w,a-u.t-(1-h[1])*u.h],this.mouseContainer.style.width=u.w*(f[1]-f[0])+"px",this.mouseContainer.style.height=u.h*(h[1]-h[0])+"px",this.mouseContainer.height=u.h*(h[1]-h[0]),this.mouseContainer.style.left=u.l+f[0]*u.w+"px",this.mouseContainer.style.top=u.t+(1-h[1])*u.h+"px",c=0;c<2;++c)(l=this[w[c]])._length=o.viewBox[c+2]-o.viewBox[c],y(this.graphDiv,l),l.setScale();g(s),o.ticks=this.computeTickMarks(),o.dataBox=this.calcDataBox(),o.merge(r),n.update(o),this.glplot.draw()},M.calcDataBox=function(){var t=this.xaxis,e=this.yaxis,r=t.range,n=e.range,i=t.r2l,a=e.r2l;return[i(r[0]),a(n[0]),i(r[1]),a(n[1])]},M.setRanges=function(t){var e=this.xaxis,r=this.yaxis,n=e.l2r,i=r.l2r;e.range=[n(t[0]),n(t[2])],r.range=[i(t[1]),i(t[3])]},M.updateTraces=function(t,e){var r,n,i,a=Object.keys(this.traces);this.fullData=t;t:for(r=0;r<a.length;r++){var o=a[r],s=this.traces[o];for(n=0;n<t.length;n++)if((i=t[n]).uid===o&&i.type===s.type)continue t;s.dispose(),delete this.traces[o]}for(r=0;r<t.length;r++){i=t[r];var l=e[r],c=this.traces[i.uid];c?c.update(i,l):(c=i._module.plot(this,i,l),this.traces[i.uid]=c)}this.glplot.objects.sort((function(t,e){return t._trace.index-e._trace.index}))},M.updateFx=function(t){_(t)||b(t)?(this.pickCanvas.style["pointer-events"]='none',this.mouseContainer.style["pointer-events"]='none'):(this.pickCanvas.style["pointer-events"]='auto',this.mouseContainer.style["pointer-events"]='auto'),this.mouseContainer.style.cursor="pan"===t?"move":"zoom"===t?"crosshair":null},M.emitPointAction=function(t,e){for(var r,n=t.trace.uid,i=t.pointIndex,a=0;a<this.fullData.length;a++)this.fullData[a].uid===n&&(r=this.fullData[a]);var o={x:t.traceCoord[0],y:t.traceCoord[1],curveNumber:r.index,pointNumber:i,data:r._input,fullData:this.fullData,xaxis:this.xaxis,yaxis:this.yaxis};s.appendArrayPointValue(o,r,i),this.graphDiv.emit(e,{points:[o]})},M.draw=function(){if(!this.stopped){requestAnimationFrame(this.redraw);var t=this.glplot,e=this.camera,r=e.mouseListener,n=1===this.lastButtonState&&0===r.buttons,i=this.fullLayout;this.lastButtonState=r.buttons,this.cameraChanged();var a,o=r.x*t.pixelRatio,l=this.canvas.height-t.pixelRatio*r.y;if(e.boxEnabled&&"zoom"===i.dragmode){this.selectBox.enabled=!0;for(var c=this.selectBox.selectBox=[Math.min(e.boxStart[0],e.boxEnd[0]),Math.min(e.boxStart[1],e.boxEnd[1]),Math.max(e.boxStart[0],e.boxEnd[0]),Math.max(e.boxStart[1],e.boxEnd[1])],u=0;u<2;u++)e.boxStart[u]===e.boxEnd[u]&&(c[u]=t.dataBox[u],c[u+2]=t.dataBox[u+2]);t.setDirty()}else if(!e.panning&&this.isMouseOver){this.selectBox.enabled=!1;var f=i._size,h=this.xaxis.domain,p=this.yaxis.domain,d=(a=t.pick(o/t.pixelRatio+f.l+h[0]*f.w,l/t.pixelRatio-(f.t+(1-p[1])*f.h)))&&a.object._trace.handlePick(a);if(d&&n&&this.emitPointAction(d,'plotly_click'),a&&"skip"!==a.object._trace.hoverinfo&&i.hovermode&&d&&(!this.lastPickResult||this.lastPickResult.traceUid!==d.trace.uid||this.lastPickResult.dataCoord[0]!==d.dataCoord[0]||this.lastPickResult.dataCoord[1]!==d.dataCoord[1])){var m=d;this.lastPickResult={traceUid:d.trace?d.trace.uid:null,dataCoord:d.dataCoord.slice()},this.spikes.update({center:a.dataCoord}),m.screenCoord=[((t.viewBox[2]-t.viewBox[0])*(a.dataCoord[0]-t.dataBox[0])/(t.dataBox[2]-t.dataBox[0])+t.viewBox[0])/t.pixelRatio,(this.canvas.height-(t.viewBox[3]-t.viewBox[1])*(a.dataCoord[1]-t.dataBox[1])/(t.dataBox[3]-t.dataBox[1])-t.viewBox[1])/t.pixelRatio],this.emitPointAction(d,'plotly_hover');var g=this.fullData[m.trace.index]||{},v=m.pointIndex,y=s.castHoverinfo(g,i,v);if(y&&"all"!==y){var x=y.split('+');-1===x.indexOf('x')&&(m.traceCoord[0]=void 0),-1===x.indexOf('y')&&(m.traceCoord[1]=void 0),-1===x.indexOf('z')&&(m.traceCoord[2]=void 0),-1===x.indexOf('text')&&(m.textLabel=void 0),-1===x.indexOf('name')&&(m.name=void 0)}s.loneHover({x:m.screenCoord[0],y:m.screenCoord[1],xLabel:this.hoverFormatter('xaxis',m.traceCoord[0]),yLabel:this.hoverFormatter('yaxis',m.traceCoord[1]),zLabel:m.traceCoord[2],text:m.textLabel,name:m.name,color:s.castHoverOption(g,v,'bgcolor')||m.color,borderColor:s.castHoverOption(g,v,'bordercolor'),fontFamily:s.castHoverOption(g,v,'font.family'),fontSize:s.castHoverOption(g,v,'font.size'),fontColor:s.castHoverOption(g,v,'font.color'),nameLength:s.castHoverOption(g,v,'namelength'),textAlign:s.castHoverOption(g,v,'align')},{container:this.svgContainer,gd:this.graphDiv})}}a||this.unhover(),t.draw()}},M.unhover=function()[this.lastPickResult&&(this.spikes.update({]),this.lastPickResult=null,this.graphDiv.emit('plotly_unhover'),s.loneUnhover(this.svgContainer))},M.hoverFormatter=function(t,e){if(void 0!==e){var r=this[t];return o.tickText(r,r.c2l(e),'hover').text}}},{"../../components/dragelement/helpers":668,"../../components/fx":690,"../../lib/show_no_webgl_msg":809,"../../plots/cartesian/axes":838,"../../registry":915,"../cartesian/autorange":837,"../cartesian/constants":845,"../cartesian/constraints":846,"./camera":876,"./convert":877,"gl-plot2d":316,"gl-select-box":330,"gl-spikes2d":339,"webgl-context":613}],880:[function(t,e,r){"use strict";var n=t('../../plot_api/edit_types').overrideAll,i=t('../../components/fx/layout_attributes'),a=t('./scene'),o=t('../get_data').getSubplotData,s=t('../../lib'),l=t('../../constants/xmlns_namespaces'),c='gl3d',u='scene';r.name=c,r.attr=u,r.idRoot=u,r.idRegex=r.attrRegex=s.counterRegex('scene'),r.attributes=t('./layout/attributes'),r.layoutAttributes=t('./layout/layout_attributes'),r.baseLayoutAttrOverrides=n({hoverlabel:i.hoverlabel},'plot','nested'),r.supplyLayoutDefaults=t('./layout/defaults'),r.plot=function(t){for(var e=t._fullLayout,r=t._fullData,n=e._subplots[c],i=0;i<n.length;i++){var s=n[i],l=o(r,c,s),u=e[s],f=u.camera,h=u._scene;h||(h=new a({id:s,graphDiv:t,container:t.querySelector('.gl-container'),staticPlot:t._context.staticPlot,plotGlPixelRatio:t._context.plotGlPixelRatio,camera:f},e),u._scene=h),h.viewInitial||(h.viewInitial={up:{x:f.up.x,y:f.up.y,z:f.up.z},eye:{x:f.eye.x,y:f.eye.y,z:f.eye.z},center:{x:f.center.x,y:f.center.y,z:f.center.z}}),h.plot(l,e,t.layout)}},r.clean=function(t,e,r,n){for(var i=n._subplots[c]||[],a=0;a<i.length;a++){var o=i[a];!e[o]&&n[o]._scene&&(n[o]._scene.destroy(),n._infolayer&&n._infolayer.selectAll(".annotation-"+o).remove())}},r.toSVG=function(t){for(var e=t._fullLayout,r=e._subplots[c],n=e._size,i=0;i<r.length;i++){var a=e[r[i]],o=a.domain,s=a._scene,u=s.toImage('png');e._glimages.append('svg:image').attr({xmlns:l.svg,"xlink:href":u,x:n.l+n.w*o.x[0],y:n.t+n.h*(1-o.y[1]),width:n.w*(o.x[1]-o.x[0]),height:n.h*(o.y[1]-o.y[0]),preserveAspectRatio:"none"}),s.destroy()}},r.cleanId=function(t){if(t.match(/^scene[0-9]*$/)){var e=t.substr(5);return"1"===e&&(e=''),u+e}},r.updateFx=function(t){for(var e=t._fullLayout,r=e._subplots[c],n=0;n<r.length;n++)e[r[n]]._scene.updateFx(e.dragmode,e.hovermode)}},{"../../components/fx/layout_attributes":691,"../../constants/xmlns_namespaces":764,"../../lib":787,"../../plot_api/edit_types":820,"../get_data":875,"./layout/attributes":881,"./layout/defaults":885,"./layout/layout_attributes":886,"./scene":890}],881:[function(t,e,r){"use strict";e.exports={scene:{valType:"subplotid",dflt:"scene",editType:"calc+clearAxisTypes"}}},{}],882:[function(t,e,r){"use strict";var n=t('../../../components/color'),i=t('../../cartesian/layout_attributes'),a=t('../../../lib/extend').extendFlat,o=t('../../../plot_api/edit_types').overrideAll;e.exports=o({visible:i.visible,showspikes:{valType:"boolean",dflt:!0},spikesides:{valType:"boolean",dflt:!0},spikethickness:{valType:"number",min:0,dflt:2},spikecolor:{valType:"color",dflt:n.defaultLine},showbackground:{valType:"boolean",dflt:!1},backgroundcolor:{valType:"color",dflt:"rgba(204, 204, 204, 0.5)"},showaxeslabels:{valType:"boolean",dflt:!0},color:i.color,categoryorder:i.categoryorder,categoryarray:i.categoryarray,title:{text:i.title.text,font:i.title.font},type:a({},i.type,{values:["-",'linear','log','date',"category"]}),autotypenumbers:i.autotypenumbers,autorange:i.autorange,rangemode:i.rangemode,range:a({},i.range,{items:[{valType:"any",editType:"plot",impliedEdits:{"^autorange":!1}},{valType:"any",editType:"plot",impliedEdits:{"^autorange":!1}}],anim:!1}),tickmode:i.tickmode,nticks:i.nticks,tick0:i.tick0,dtick:i.dtick,tickvals:i.tickvals,ticktext:i.ticktext,ticks:i.ticks,mirror:i.mirror,ticklen:i.ticklen,tickwidth:i.tickwidth,tickcolor:i.tickcolor,showticklabels:i.showticklabels,tickfont:i.tickfont,tickangle:i.tickangle,tickprefix:i.tickprefix,showtickprefix:i.showtickprefix,ticksuffix:i.ticksuffix,showticksuffix:i.showticksuffix,showexponent:i.showexponent,exponentformat:i.exponentformat,minexponent:i.minexponent,separatethousands:i.separatethousands,tickformat:i.tickformat,tickformatstops:i.tickformatstops,hoverformat:i.hoverformat,showline:i.showline,linecolor:i.linecolor,linewidth:i.linewidth,showgrid:i.showgrid,gridcolor:a({},i.gridcolor,{dflt:"rgb(204, 204, 204)"}),gridwidth:i.gridwidth,zeroline:i.zeroline,zerolinecolor:i.zerolinecolor,zerolinewidth:i.zerolinewidth,_deprecated:{title:i._deprecated.title,titlefont:i._deprecated.titlefont}},'plot','from-root')},{"../../../components/color":650,"../../../lib/extend":777,"../../../plot_api/edit_types":820,"../../cartesian/layout_attributes":853}],883:[function(t,e,r){"use strict";var n=t('tinycolor2').mix,i=t('../../../lib'),a=t('../../../plot_api/plot_template'),o=t('./axis_attributes'),s=t('../../cartesian/type_defaults'),l=t('../../cartesian/axis_defaults'),c=["xaxis",'yaxis',"zaxis"],u=13600/187;e.exports=function(t,e,r){var f,h;function p(t,e){return i.coerce(f,h,o,t,e)}for(var d=0;d<c.length;d++){var m=c[d];f=t[m]||{},(h=a.newContainer(e,m))._id=m[0]+r.scene,h._name=m,s(f,h,p,r),l(f,h,p,{font:r.font,letter:m[0],data:r.data,showGrid:!0,noTickson:!0,noTicklabelmode:!0,noTicklabelposition:!0,noTicklabeloverflow:!0,bgColor:r.bgColor,calendar:r.calendar},r.fullLayout),p('gridcolor',n(h.color,r.bgColor,u).toRgbString()),p('title.text',m[0]),h.setScale=i.noop,p('showspikes')&&(p('spikesides'),p('spikethickness'),p('spikecolor',h.color)),p('showaxeslabels'),p('showbackground')&&p('backgroundcolor')}}},{"../../../lib":787,"../../../plot_api/plot_template":827,"../../cartesian/axis_defaults":840,"../../cartesian/type_defaults":864,"./axis_attributes":882,tinycolor2:583}],884:[function(t,e,r){"use strict";var n=t('../../../lib/str2rgbarray'),i=t('../../../lib'),a=["xaxis",'yaxis',"zaxis"];function o(){this.bounds=[[-10,-10,-10],[10,10,10]],this.ticks=[[],[],[]],this.tickEnable=[!0,!0,!0],this.tickFont=["sans-serif",'sans-serif',"sans-serif"],this.tickSize=[12,12,12],this.tickAngle=[0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[18,18,18],this.labels=["x",'y',"z"],this.labelEnable=[!0,!0,!0],this.labelFont=["Open Sans",'Open Sans',"Open Sans"],this.labelSize=[20,20,20],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[30,30,30],this.lineEnable=[!0,!0,!0],this.lineMirror=[!1,!1,!1],this.lineWidth=[1,1,1],this.lineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.lineTickEnable=[!0,!0,!0],this.lineTickMirror=[!1,!1,!1],this.lineTickLength=[10,10,10],this.lineTickWidth=[1,1,1],this.lineTickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.gridEnable=[!0,!0,!0],this.gridWidth=[1,1,1],this.gridColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroEnable=[!0,!0,!0],this.zeroLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroLineWidth=[2,2,2],this.backgroundEnable=[!0,!0,!0],this.backgroundColor=[[.8,.8,.8,.5],[.8,.8,.8,.5],[.8,.8,.8,.5]],this._defaultTickPad=this.tickPad.slice(),this._defaultLabelPad=this.labelPad.slice(),this._defaultLineTickLength=this.lineTickLength.slice()}function s(t,e){var r=new o;return r.merge(t,e),r}o.prototype.merge=function(t,e){for(var r=this,o=0;o<3;++o){var s=e[a[o]];s.visible?(r.labels[o]=t._meta?i.templateString(s.title.text,t._meta):s.title.text,"font"in s.title&&(s.title.font.color&&(r.labelColor[o]=n(s.title.font.color)),s.title.font.family&&(r.labelFont[o]=s.title.font.family),s.title.font.size&&(r.labelSize[o]=s.title.font.size)),"showline"in s&&(r.lineEnable[o]=s.showline),"linecolor"in s&&(r.lineColor[o]=n(s.linecolor)),"linewidth"in s&&(r.lineWidth[o]=s.linewidth),"showgrid"in s&&(r.gridEnable[o]=s.showgrid),"gridcolor"in s&&(r.gridColor[o]=n(s.gridcolor)),"gridwidth"in s&&(r.gridWidth[o]=s.gridwidth),"log"===s.type?r.zeroEnable[o]=!1:"zeroline"in s&&(r.zeroEnable[o]=s.zeroline),"zerolinecolor"in s&&(r.zeroLineColor[o]=n(s.zerolinecolor)),"zerolinewidth"in s&&(r.zeroLineWidth[o]=s.zerolinewidth),"ticks"in s&&s.ticks?r.lineTickEnable[o]=!0:r.lineTickEnable[o]=!1,"ticklen"in s&&(r.lineTickLength[o]=r._defaultLineTickLength[o]=s.ticklen),"tickcolor"in s&&(r.lineTickColor[o]=n(s.tickcolor)),"tickwidth"in s&&(r.lineTickWidth[o]=s.tickwidth),"tickangle"in s&&(r.tickAngle[o]="auto"===s.tickangle?-3600:Math.PI*-s.tickangle/180),"showticklabels"in s&&(r.tickEnable[o]=s.showticklabels),"tickfont"in s&&(s.tickfont.color&&(r.tickColor[o]=n(s.tickfont.color)),s.tickfont.family&&(r.tickFont[o]=s.tickfont.family),s.tickfont.size&&(r.tickSize[o]=s.tickfont.size)),"mirror"in s?-1!==["ticks",'all',"allticks"].indexOf(s.mirror)?(r.lineTickMirror[o]=!0,r.lineMirror[o]=!0):!0===s.mirror?(r.lineTickMirror[o]=!1,r.lineMirror[o]=!0):(r.lineTickMirror[o]=!1,r.lineMirror[o]=!1):r.lineMirror[o]=!1,"showbackground"in s&&!1!==s.showbackground?(r.backgroundEnable[o]=!0,r.backgroundColor[o]=n(s.backgroundcolor)):r.backgroundEnable[o]=!1):(r.tickEnable[o]=!1,r.labelEnable[o]=!1,r.lineEnable[o]=!1,r.lineTickEnable[o]=!1,r.gridEnable[o]=!1,r.zeroEnable[o]=!1,r.backgroundEnable[o]=!1)}},e.exports=s},{"../../../lib":787,"../../../lib/str2rgbarray":812}],885:[function(t,e,r){"use strict";var n=t('../../../lib'),i=t('../../../components/color'),a=t('../../../registry'),o=t('../../subplot_defaults'),s=t('./axis_defaults'),l=t('./layout_attributes'),c=t('../../get_data').getSubplotData,u='gl3d';function f(t,e,r,n){for(var o=r('bgcolor'),l=i.combine(o,n.paper_bgcolor),f=["up",'center',"eye"],h=0;h<f.length;h++)r("camera."+f[h]+".x"),r("camera."+f[h]+".y"),r("camera."+f[h]+".z");r('camera.projection.type');var p=!!r('aspectratio.x')&&!!r('aspectratio.y')&&!!r('aspectratio.z'),d=r('aspectmode',p?"manual":"auto");p||(t.aspectratio=e.aspectratio={x:1,y:1,z:1},"manual"===d&&(e.aspectmode='auto'),t.aspectmode=e.aspectmode);var m=c(n.fullData,u,n.id);s(t,e,{font:n.font,scene:n.id,data:m,bgColor:l,calendar:n.calendar,autotypenumbersDflt:n.autotypenumbersDflt,fullLayout:n.fullLayout}),a.getComponentMethod('annotations3d','handleDefaults')(t,e,n);var g=n.getDfltFromLayout('dragmode');if(!1!==g&&!g)if(g='orbit',t.camera&&t.camera.up){var v=t.camera.up.x,y=t.camera.up.y,x=t.camera.up.z;0!==x&&(v&&y&&x?x/Math.sqrt(v*v+y*y+x*x)>.999&&(g='turntable'):g='turntable')}else g='turntable';r('dragmode',g),r('hovermode',n.getDfltFromLayout('hovermode'))}e.exports=function(t,e,r){var i=e._basePlotModules.length>1;function a(e){if(!i)return n.validate(t[e],l[e])?t[e]:void 0}o(t,e,r,{type:u,attributes:l,handleDefaults:f,fullLayout:e,font:e.font,fullData:r,getDfltFromLayout:a,autotypenumbersDflt:e.autotypenumbers,paper_bgcolor:e.paper_bgcolor,calendar:e.calendar})}},{"../../../components/color":650,"../../../lib":787,"../../../registry":915,"../../get_data":875,"../../subplot_defaults":909,"./axis_defaults":883,"./layout_attributes":886}],886:[function(t,e,r){"use strict";var n=t('./axis_attributes'),i=t('../../domain').attributes,a=t('../../../lib/extend').extendFlat,o=t('../../../lib').counterRegex;function s(t,e,r){return{x:{valType:"number",dflt:t,editType:"camera"},y:{valType:"number",dflt:e,editType:"camera"},z:{valType:"number",dflt:r,editType:"camera"},editType:"camera"}}e.exports={_arrayAttrRegexps:[o('scene','.annotations',!0)],bgcolor:{valType:"color",dflt:"rgba(0,0,0,0)",editType:"plot"},camera:{up:a(s(0,0,1),{}),center:a(s(0,0,0),{}),eye:a(s(1.25,1.25,1.25),{}),projection:{type:{valType:"enumerated",values:["perspective","orthographic"],dflt:"perspective",editType:"calc"},editType:"calc"},editType:"camera"},domain:i({name:"scene",editType:"plot"}),aspectmode:{valType:"enumerated",values:["auto",'cube','data',"manual"],dflt:"auto",editType:"plot",impliedEdits:{"aspectratio.x":void 0,"aspectratio.y":void 0,"aspectratio.z":void 0}},aspectratio:{x:{valType:"number",min:0,editType:"plot",impliedEdits:{"^aspectmode":"manual"}},y:{valType:"number",min:0,editType:"plot",impliedEdits:{"^aspectmode":"manual"}},z:{valType:"number",min:0,editType:"plot",impliedEdits:{"^aspectmode":"manual"}},editType:"plot",impliedEdits:{aspectmode:"manual"}},xaxis:n,yaxis:n,zaxis:n,dragmode:{valType:"enumerated",values:["orbit",'turntable','zoom','pan',!1],editType:"plot"},hovermode:{valType:"enumerated",values:["closest",!1],dflt:"closest",editType:"modebar"},uirevision:{valType:"any",editType:"none"},editType:"plot",_deprecated:{cameraposition:{valType:"info_array",editType:"camera"}}}},{"../../../lib":787,"../../../lib/extend":777,"../../domain":866,"./axis_attributes":882}],887:[function(t,e,r){"use strict";var n=t('../../../lib/str2rgbarray'),i=["xaxis",'yaxis',"zaxis"];function a(){this.enabled=[!0,!0,!0],this.colors=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.drawSides=[!0,!0,!0],this.lineWidth=[1,1,1]}function o(t){var e=new a;return e.merge(t),e}a.prototype.merge=function(t){for(var e=0;e<3;++e){var r=t[i[e]];r.visible?(this.enabled[e]=r.showspikes,this.colors[e]=n(r.spikecolor),this.drawSides[e]=r.spikesides,this.lineWidth[e]=r.spikethickness):(this.enabled[e]=!1,this.drawSides[e]=!1)}},e.exports=o},{"../../../lib/str2rgbarray":812}],888:[function(t,e,r){"use strict";e.exports=l;var n=t('../../cartesian/axes'),i=t('../../../lib'),a=["xaxis",'yaxis',"zaxis"],o=[0,0,0];function s(t){for(var e=new Array(3),r=0;r<3;++r){for(var n=t[r],i=new Array(n.length),a=0;a<n.length;++a)i[a]=n[a].x;e[r]=i}return e}function l(t){for(var e=t.axesOptions,r=t.glplot.axesPixels,l=t.fullSceneLayout,c=[[],[],[]],u=0;u<3;++u){var f=l[a[u]];if(f._length=(r[u].hi-r[u].lo)*r[u].pixelsPerDataUnit/t.dataScale[u],Math.abs(f._length)===1/0||isNaN(f._length))c[u]=[];else{f._input_range=f.range.slice(),f.range[0]=r[u].lo/t.dataScale[u],f.range[1]=r[u].hi/t.dataScale[u],f._m=1/(t.dataScale[u]*r[u].pixelsPerDataUnit),f.range[0]===f.range[1]&&(f.range[0]-=1,f.range[1]+=1);var h=f.tickmode;if("auto"===f.tickmode){f.tickmode='linear';var p=f.nticks||i.constrain(f._length/40,4,9);n.autoTicks(f,Math.abs(f.range[1]-f.range[0])/p)}for(var d=n.calcTicks(f,{msUTC:!0}),m=0;m<d.length;++m)d[m].x=d[m].x*t.dataScale[u],"date"===f.type&&(d[m].text=d[m].text.replace(/\<br\>/g,' '));c[u]=d,f.tickmode=h}}for(e.ticks=c,u=0;u<3;++u)for(o[u]=.5*(t.glplot.bounds[0][u]+t.glplot.bounds[1][u]),m=0;m<2;++m)e.bounds[m][u]=t.glplot.bounds[m][u];t.contourLevels=s(c)}},{"../../../lib":787,"../../cartesian/axes":838}],889:[function(t,e,r){"use strict";function n(t,e){var r,n,i=[0,0,0,0];for(r=0;r<4;++r)for(n=0;n<4;++n)i[n]+=t[4*r+n]*e[r];return i}function i(t,e){return n(t.projection,n(t.view,n(t.model,[e[0],e[1],e[2],1])))}e.exports=i},{}],890:[function(t,e,r){"use strict";var n,i,a=t('gl-plot3d'),o=a.createCamera,s=a.createScene,l=t('webgl-context'),c=t('has-passive-events'),u=t('../../registry'),f=t('../../lib'),h=f.preserveDrawingBuffer(),p=t('../../plots/cartesian/axes'),d=t('../../components/fx'),m=t('../../lib/str2rgbarray'),g=t('../../lib/show_no_webgl_msg'),v=t('./project'),y=t('./layout/convert'),x=t('./layout/spikes'),b=t('./layout/tick_marks');function _(t,e){var r=document.createElement('div'),n=t.container;this.graphDiv=t.graphDiv;var i=document.createElementNS('http://www.w3.org/2000/svg','svg');i.style.position='absolute',i.style.top=i.style.left='0px',i.style.width=i.style.height='100%',i.style["z-index"]=20,i.style["pointer-events"]='none',r.appendChild(i),this.svgContainer=i,r.id=t.id,r.style.position='absolute',r.style.top=r.style.left='0px',r.style.width=r.style.height='100%',n.appendChild(r),this.fullLayout=e,this.id=t.id||"scene",this.fullSceneLayout=e[this.id],this.plotArgs=[[],{},{}],this.axesOptions=y(e,e[this.id]),this.spikeOptions=x(e[this.id]),this.container=r,this.staticMode=!!t.staticPlot,this.pixelRatio=this.pixelRatio||t.plotGlPixelRatio||2,this.dataScale=[1,1,1],this.contourLevels=[[],[],[]],this.convertAnnotations=u.getComponentMethod('annotations3d','convert'),this.drawAnnotations=u.getComponentMethod('annotations3d','draw'),this.initializeGLPlot()}var w=_.prototype;w.prepareOptions=function(){var t=this,e={canvas:t.canvas,gl:t.gl,glOptions:{preserveDrawingBuffer:h,premultipliedAlpha:!0,antialias:!0},container:t.container,axes:t.axesOptions,spikes:t.spikeOptions,pickRadius:10,snapToData:!0,autoScale:!0,autoBounds:!1,cameraObject:t.camera,pixelRatio:t.pixelRatio};if(t.staticMode){if(!i&&(n=document.createElement('canvas'),!(i=l({canvas:n,preserveDrawingBuffer:!0,premultipliedAlpha:!0,antialias:!0}))))throw new Error('error creating static canvas/context for image server');e.gl=i,e.canvas=n}return e};var T=!0;w.tryCreatePlot=function(){var t=this,e=t.prepareOptions(),r=!0;try{t.glplot=s(e)}catch(n){if(t.staticMode||!T||h)r=!1;else{f.warn(["webgl setup failed possibly due to",'false preserveDrawingBuffer config.','The mobile/tablet device may not be detected by is-mobile module.',"Enabling preserveDrawingBuffer in second attempt to create webgl scene..."].join(' '));try{h=e.glOptions.preserveDrawingBuffer=!0,t.glplot=s(e)}catch(n){h=e.glOptions.preserveDrawingBuffer=!1,r=!1}}}return T=!1,r},w.initializeGLCamera=function(){var t=this,e=t.fullSceneLayout.camera,r="orthographic"===e.projection.type;t.camera=o(t.container,{center:[e.center.x,e.center.y,e.center.z],eye:[e.eye.x,e.eye.y,e.eye.z],up:[e.up.x,e.up.y,e.up.z],_ortho:r,zoomMin:.01,zoomMax:100,mode:"orbit"})},w.initializeGLPlot=function(){var t=this;if(t.initializeGLCamera(),!t.tryCreatePlot())return g(t);t.traces={},t.make4thDimension();var e=t.graphDiv,r=e.layout,n=function()[var e={];return t.isCameraChanged(r)&&(e[t.id+".camera"]=t.getCamera()),t.isAspectChanged(r)&&(e[t.id+".aspectratio"]=t.glplot.getAspectratio(),"manual"!==r[t.id].aspectmode&&(t.fullSceneLayout.aspectmode=r[t.id].aspectmode=e[t.id+".aspectmode"]='manual')),e},i=function(t){if(!1!==t.fullSceneLayout.dragmode){var e=n();t.saveLayout(r),t.graphDiv.emit('plotly_relayout',e)}};return t.glplot.canvas&&(t.glplot.canvas.addEventListener('mouseup',(function()[i(t)])),t.glplot.canvas.addEventListener('wheel',(function(r){if(e._context._scrollZoom.gl3d){if(t.camera._ortho){var n=r.deltaX>r.deltaY?1.1:1/1.1,a=t.glplot.getAspectratio();t.glplot.setAspectratio({x:n*a.x,y:n*a.y,z:n*a.z})}i(t)}}),!!c&&{passive:!1}),t.glplot.canvas.addEventListener('mousemove',(function(){if(!1!==t.fullSceneLayout.dragmode&&0!==t.camera.mouseListener.buttons){var e=n();t.graphDiv.emit('plotly_relayouting',e)}})),t.staticMode||t.glplot.canvas.addEventListener('webglcontextlost',(function(r){e&&e.emit&&e.emit('plotly_webglcontextlost',{event:r,layer:t.id})}),!1)),t.glplot.oncontextloss=function()[t.recoverContext()],t.glplot.onrender=function()[t.render()],!0},w.render=function(){var t,e=this,r=e.graphDiv,n=e.svgContainer,i=e.container.getBoundingClientRect();r._fullLayout._calcInverseTransform(r);var a=r._fullLayout._invScaleX,o=r._fullLayout._invScaleY,s=i.width*a,l=i.height*o;n.setAttributeNS(null,'viewBox',"0 0 '+s+' "+l),n.setAttributeNS(null,'width',s),n.setAttributeNS(null,'height',l),b(e),e.glplot.axes.update(e.axesOptions);for(var c,u=Object.keys(e.traces),h=null,m=e.glplot.selection,g=0;g<u.length;++g)"skip"!==(t=e.traces[u[g]]).data.hoverinfo&&t.handlePick(m)&&(h=t),t.setContourLevels&&t.setContourLevels();function y(t,r,n){var i=e.fullSceneLayout[t+"axis"];return"log"!==i.type&&(r=i.d2l(r)),p.hoverLabelText(i,r,n)}if(null!==h){var x=v(e.glplot.cameraParams,m.dataCoordinate);t=h.data;var _,w=r._fullData[t.index],T=m.index,k={xLabel:y('x',m.traceCoordinate[0],t.xhoverformat),yLabel:y('y',m.traceCoordinate[1],t.yhoverformat),zLabel:y('z',m.traceCoordinate[2],t.zhoverformat)},M=d.castHoverinfo(w,e.fullLayout,T),A=(M||"").split('+'),S=M&&"all"===M;w.hovertemplate||S||(-1===A.indexOf('x')&&(k.xLabel=void 0),-1===A.indexOf('y')&&(k.yLabel=void 0),-1===A.indexOf('z')&&(k.zLabel=void 0),-1===A.indexOf('text')&&(m.textLabel=void 0),-1===A.indexOf('name')&&(h.name=void 0));var E=[];"cone"===t.type||"streamtube"===t.type?(k.uLabel=y('x',m.traceCoordinate[3],t.uhoverformat),(S||-1!==A.indexOf('u'))&&E.push("u: "+k.uLabel),k.vLabel=y('y',m.traceCoordinate[4],t.vhoverformat),(S||-1!==A.indexOf('v'))&&E.push("v: "+k.vLabel),k.wLabel=y('z',m.traceCoordinate[5],t.whoverformat),(S||-1!==A.indexOf('w'))&&E.push("w: "+k.wLabel),k.normLabel=m.traceCoordinate[6].toPrecision(3),(S||-1!==A.indexOf('norm'))&&E.push("norm: "+k.normLabel),"streamtube"===t.type&&(k.divergenceLabel=m.traceCoordinate[7].toPrecision(3),(S||-1!==A.indexOf('divergence'))&&E.push("divergence: "+k.divergenceLabel)),m.textLabel&&E.push(m.textLabel),_=E.join('<br>')):"isosurface"===t.type||"volume"===t.type?(k.valueLabel=p.hoverLabelText(e._mockAxis,e._mockAxis.d2l(m.traceCoordinate[3]),t.valuehoverformat),E.push("value: "+k.valueLabel),m.textLabel&&E.push(m.textLabel),_=E.join('<br>')):_=m.textLabel;var L={x:m.traceCoordinate[0],y:m.traceCoordinate[1],z:m.traceCoordinate[2],data:w._input,fullData:w,curveNumber:w.index,pointNumber:T};d.appendArrayPointValue(L,w,T),t._module.eventData&&(L=w._module.eventData(L,m,w,{},T));var C={points:[L]};if(e.fullSceneLayout.hovermode){var P=[];d.loneHover({trace:w,x:(.5+.5*x[0]/x[3])*s,y:(.5-.5*x[1]/x[3])*l,xLabel:k.xLabel,yLabel:k.yLabel,zLabel:k.zLabel,text:_,name:h.name,color:d.castHoverOption(w,T,'bgcolor')||h.color,borderColor:d.castHoverOption(w,T,'bordercolor'),fontFamily:d.castHoverOption(w,T,'font.family'),fontSize:d.castHoverOption(w,T,'font.size'),fontColor:d.castHoverOption(w,T,'font.color'),nameLength:d.castHoverOption(w,T,'namelength'),textAlign:d.castHoverOption(w,T,'align'),hovertemplate:f.castOption(w,T,'hovertemplate'),hovertemplateLabels:f.extendFlat({},L,k),eventData:[L]},{container:n,gd:r,inOut_bbox:P}),L.bbox=P[0]}m.buttons&&m.distance<5?r.emit('plotly_click',C):r.emit('plotly_hover',C),c=C}else d.loneUnhover(n),r.emit('plotly_unhover',c);e.drawAnnotations(e)},w.recoverContext=function(){var t=this;t.glplot.dispose();var e=function(){t.glplot.gl.isContextLost()?requestAnimationFrame(e):t.initializeGLPlot()?t.plot.apply(t,t.plotArgs):f.error('Catastrophic and unrecoverable WebGL error. Context lost.')};requestAnimationFrame(e)};var k=["xaxis",'yaxis',"zaxis"];function M(t,e,r){for(var n=t.fullSceneLayout,i=0;i<3;i++){var a=k[i],o=a.charAt(0),s=n[a],l=e[o],c=e[o+"calendar"],u=e["_"+o+"length"];if(f.isArrayOrTypedArray(l))for(var h,p=0;p<(u||l.length);p++)if(f.isArrayOrTypedArray(l[p]))for(var d=0;d<l[p].length;++d)h=s.d2l(l[p][d],0,c),!isNaN(h)&&isFinite(h)&&(r[0][i]=Math.min(r[0][i],h),r[1][i]=Math.max(r[1][i],h));else h=s.d2l(l[p],0,c),!isNaN(h)&&isFinite(h)&&(r[0][i]=Math.min(r[0][i],h),r[1][i]=Math.max(r[1][i],h));else r[0][i]=Math.min(r[0][i],0),r[1][i]=Math.max(r[1][i],u-1)}}function A(t,e){for(var r=t.fullSceneLayout,n=r.annotations||[],i=0;i<3;i++)for(var a=k[i],o=a.charAt(0),s=r[a],l=0;l<n.length;l++){var c=n[l];if(c.visible){var u=s.r2l(c[o]);!isNaN(u)&&isFinite(u)&&(e[0][i]=Math.min(e[0][i],u),e[1][i]=Math.max(e[1][i],u))}}}function S(t){return[[t.eye.x,t.eye.y,t.eye.z],[t.center.x,t.center.y,t.center.z],[t.up.x,t.up.y,t.up.z]]}function E(t){return{up:{x:t.up[0],y:t.up[1],z:t.up[2]},center:{x:t.center[0],y:t.center[1],z:t.center[2]},eye:{x:t.eye[0],y:t.eye[1],z:t.eye[2]},projection:{type:!0===t._ortho?"orthographic":"perspective"}}}function L(t,e,r){for(var n=0,i=r-1;n<i;++n,--i)for(var a=0;a<e;++a)for(var o=0;o<4;++o){var s=4*(e*n+a)+o,l=4*(e*i+a)+o,c=t[s];t[s]=t[l],t[l]=c}}function C(t,e,r){for(var n=0;n<r;++n)for(var i=0;i<e;++i){var a=4*(e*n+i),o=t[a+3];if(o>0)for(var s=255/o,l=0;l<3;++l)t[a+l]=Math.min(s*t[a+l],255)}}w.plot=function(t,e,r){var n=this;if(n.plotArgs=[t,e,r],!n.glplot.contextLost){var i,a,o,s,l,c,u=e[n.id],f=r[n.id];n.fullLayout=e,n.fullSceneLayout=u,n.axesOptions.merge(e,u),n.spikeOptions.merge(u),n.setViewport(u),n.updateFx(u.dragmode,u.hovermode),n.camera.enableWheel=n.graphDiv._context._scrollZoom.gl3d,n.glplot.setClearColor(m(u.bgcolor)),n.setConvert(l),t?Array.isArray(t)||(t=[t]):t=[];var h=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]];for(o=0;o<t.length;++o)!0===(i=t[o]).visible&&0!==i._length&&M(this,i,h);A(this,h);var p=[1,1,1];for(s=0;s<3;++s)h[1][s]===h[0][s]?p[s]=1:p[s]=1/(h[1][s]-h[0][s]);for(n.dataScale=p,n.convertAnnotations(this),o=0;o<t.length;++o)!0===(i=t[o]).visible&&0!==i._length&&((a=n.traces[i.uid])?a.data.type===i.type?a.update(i):(a.dispose(),a=i._module.plot(this,i),n.traces[i.uid]=a):(a=i._module.plot(this,i),n.traces[i.uid]=a),a.name=i.name);var d=Object.keys(n.traces);t:for(o=0;o<d.length;++o){for(s=0;s<t.length;++s)if(t[s].uid===d[o]&&!0===t[s].visible&&0!==t[s]._length)continue t;(a=n.traces[d[o]]).dispose(),delete n.traces[d[o]]}n.glplot.objects.sort((function(t,e){return t._trace.data.index-e._trace.data.index}));var g,v=[[0,0,0],[0,0,0]],y=[],x={};for(o=0;o<3;++o){if((c=(l=u[k[o]]).type)in x?(x[c].acc*=p[o],x[c].count+=1):x[c]={acc:p[o],count:1},l.autorange){v[0][o]=1/0,v[1][o]=-1/0;var b=n.glplot.objects,_=n.fullSceneLayout.annotations||[],w=l._name.charAt(0);for(s=0;s<b.length;s++){var T=b[s],S=T.bounds,E=T._trace.data._pad||0;"ErrorBars"===T.constructor.name&&l._lowerLogErrorBound?v[0][o]=Math.min(v[0][o],l._lowerLogErrorBound):v[0][o]=Math.min(v[0][o],S[0][o]/p[o]-E),v[1][o]=Math.max(v[1][o],S[1][o]/p[o]+E)}for(s=0;s<_.length;s++){var L=_[s];if(L.visible){var C=l.r2l(L[w]);v[0][o]=Math.min(v[0][o],C),v[1][o]=Math.max(v[1][o],C)}}if("rangemode"in l&&"tozero"===l.rangemode&&(v[0][o]=Math.min(v[0][o],0),v[1][o]=Math.max(v[1][o],0)),v[0][o]>v[1][o])v[0][o]=-1,v[1][o]=1;else{var P=v[1][o]-v[0][o];v[0][o]-=P/32,v[1][o]+=P/32}if("reversed"===l.autorange){var I=v[0][o];v[0][o]=v[1][o],v[1][o]=I}}else{var z=l.range;v[0][o]=l.r2l(z[0]),v[1][o]=l.r2l(z[1])}v[0][o]===v[1][o]&&(v[0][o]-=1,v[1][o]+=1),y[o]=v[1][o]-v[0][o],n.glplot.setBounds(o,{min:v[0][o]*p[o],max:v[1][o]*p[o]})}var O=u.aspectmode;if("cube"===O)g=[1,1,1];else if("manual"===O){var D=u.aspectratio;g=[D.x,D.y,D.z]}else{if("auto"!==O&&"data"!==O)throw new Error('scene.js aspectRatio was not one of the enumerated types');var R=[1,1,1];for(o=0;o<3;++o){var F=x[c=(l=u[k[o]]).type];R[o]=Math.pow(F.acc,1/F.count)/p[o]}g="data"===O||Math.max.apply(null,R)/Math.min.apply(null,R)<=4?R:[1,1,1]}u.aspectratio.x=f.aspectratio.x=g[0],u.aspectratio.y=f.aspectratio.y=g[1],u.aspectratio.z=f.aspectratio.z=g[2],n.glplot.setAspectratio(u.aspectratio),n.viewInitial.aspectratio||(n.viewInitial.aspectratio={x:u.aspectratio.x,y:u.aspectratio.y,z:u.aspectratio.z}),n.viewInitial.aspectmode||(n.viewInitial.aspectmode=u.aspectmode);var B=u.domain||null,N=e._size||null;if(B&&N){var j=n.container.style;j.position='absolute',j.left=N.l+B.x[0]*N.w+"px",j.top=N.t+(1-B.y[1])*N.h+"px",j.width=N.w*(B.x[1]-B.x[0])+"px",j.height=N.h*(B.y[1]-B.y[0])+"px"}n.glplot.redraw()}},w.destroy=function(){var t=this;t.glplot&&(t.camera.mouseListener.enabled=!1,t.container.removeEventListener('wheel',t.camera.wheelListener),t.camera=null,t.glplot.dispose(),t.container.parentNode.removeChild(t.container),t.glplot=null)},w.getCamera=function(){var t=this;return t.camera.view.recalcMatrix(t.camera.view.lastT()),E(t.camera)},w.setViewport=function(t){var e=this,r=t.camera;e.camera.lookAt.apply(this,S(r)),e.glplot.setAspectratio(t.aspectratio),"orthographic"===r.projection.type!==e.camera._ortho&&(e.glplot.redraw(),e.glplot.clearRGBA(),e.glplot.dispose(),e.initializeGLPlot())},w.isCameraChanged=function(t){var e=this,r=e.getCamera(),n=f.nestedProperty(t,e.id+".camera").get();function i(t,e,r,n){var i=["up",'center',"eye"],a=["x",'y',"z"];return e[i[r]]&&t[i[r]][a[n]]===e[i[r]][a[n]]}var a=!1;if(void 0===n)a=!0;else{for(var o=0;o<3;o++)for(var s=0;s<3;s++)if(!i(r,n,o,s)){a=!0;break}(!n.projection||r.projection&&r.projection.type!==n.projection.type)&&(a=!0)}return a},w.isAspectChanged=function(t){var e=this,r=e.glplot.getAspectratio(),n=f.nestedProperty(t,e.id+".aspectratio").get();return void 0===n||n.x!==r.x||n.y!==r.y||n.z!==r.z},w.saveLayout=function(t){var e,r,n,i,a,o,s=this,l=s.fullLayout,c=s.isCameraChanged(t),h=s.isAspectChanged(t),p=c||h;if(p){var d={};c&&(e=s.getCamera(),n=(r=f.nestedProperty(t,s.id+".camera")).get(),d[s.id+".camera"]=n),h&&(i=s.glplot.getAspectratio(),o=(a=f.nestedProperty(t,s.id+".aspectratio")).get(),d[s.id+".aspectratio"]=o),u.call('_storeDirectGUIEdit',t,l._preGUI,d),c&&(r.set(e),f.nestedProperty(l,s.id+".camera").set(e)),h&&(a.set(i),f.nestedProperty(l,s.id+".aspectratio").set(i),s.glplot.redraw())}return p},w.updateFx=function(t,e){var r=this,n=r.camera;if(n)if("orbit"===t)n.mode='orbit',n.keyBindingMode='rotate';else if("turntable"===t){n.up=[0,0,1],n.mode='turntable',n.keyBindingMode='rotate';var i=r.graphDiv,a=i._fullLayout,o=r.fullSceneLayout.camera,s=o.up.x,l=o.up.y,c=o.up.z;if(c/Math.sqrt(s*s+l*l+c*c)<.999){var h=r.id+".camera.up",p={x:0,y:0,z:1},d={};d[h]=p;var m=i.layout;u.call('_storeDirectGUIEdit',m,a._preGUI,d),o.up=p,f.nestedProperty(m,h).set(p)}}else n.keyBindingMode=t;r.fullSceneLayout.hovermode=e},w.toImage=function(t){var e=this;t||(t='png'),e.staticMode&&e.container.appendChild(n),e.glplot.redraw();var r=e.glplot.gl,i=r.drawingBufferWidth,a=r.drawingBufferHeight;r.bindFramebuffer(r.FRAMEBUFFER,null);var o=new Uint8Array(i*a*4);r.readPixels(0,0,i,a,r.RGBA,r.UNSIGNED_BYTE,o),L(o,i,a),C(o,i,a);var s=document.createElement('canvas');s.width=i,s.height=a;var l,c=s.getContext('2d'),u=c.createImageData(i,a);switch(u.data.set(o),c.putImageData(u,0,0),t){case"jpeg":l=s.toDataURL('image/jpeg');break;case"webp":l=s.toDataURL('image/webp');break;default:l=s.toDataURL('image/png')}return e.staticMode&&e.container.removeChild(n),l},w.setConvert=function(){for(var t=this,e=0;e<3;e++){var r=t.fullSceneLayout[k[e]];p.setConvert(r,t.fullLayout),r.setScale=f.noop}},w.make4thDimension=function(){var t=this,e=t.graphDiv._fullLayout;t._mockAxis={type:"linear",showexponent:"all",exponentformat:"B"},p.setConvert(t._mockAxis,e)},e.exports=_},{"../../components/fx":690,"../../lib":787,"../../lib/show_no_webgl_msg":809,"../../lib/str2rgbarray":812,"../../plots/cartesian/axes":838,"../../registry":915,"./layout/convert":884,"./layout/spikes":887,"./layout/tick_marks":888,"./project":889,"gl-plot3d":319,"has-passive-events":436,"webgl-context":613}],891:[function(t,e,r){"use strict";e.exports=function(t,e,r,n){n=n||t.length;for(var i=new Array(n),a=0;a<n;a++)i[a]=[t[a],e[a],r[a]];return i}},{}],892:[function(t,e,r){"use strict";var n=t('./font_attributes'),i=t('./animation_attributes'),a=t('../components/color/attributes'),o=t('../components/shapes/draw_newshape/attributes'),s=t('./pad_attributes'),l=t('../lib/extend').extendFlat,c=n({editType:"calc"});c.family.dflt='"Open Sans", verdana, arial, sans-serif',c.size.dflt=12,c.color.dflt=a.defaultLine,e.exports={font:c,title:{text:{valType:"string",editType:"layoutstyle"},font:n({editType:"layoutstyle"}),xref:{valType:"enumerated",dflt:"container",values:["container","paper"],editType:"layoutstyle"},yref:{valType:"enumerated",dflt:"container",values:["container","paper"],editType:"layoutstyle"},x:{valType:"number",min:0,max:1,dflt:.5,editType:"layoutstyle"},y:{valType:"number",min:0,max:1,dflt:"auto",editType:"layoutstyle"},xanchor:{valType:"enumerated",dflt:"auto",values:["auto",'left','center',"right"],editType:"layoutstyle"},yanchor:{valType:"enumerated",dflt:"auto",values:["auto",'top','middle',"bottom"],editType:"layoutstyle"},pad:l(s({editType:"layoutstyle"}),{}),editType:"layoutstyle"},uniformtext:{mode:{valType:"enumerated",values:[!1,'hide',"show"],dflt:!1,editType:"plot"},minsize:{valType:"number",min:0,dflt:0,editType:"plot"},editType:"plot"},autosize:{valType:"boolean",dflt:!1,editType:"none"},width:{valType:"number",min:10,dflt:700,editType:"plot"},height:{valType:"number",min:10,dflt:450,editType:"plot"},margin:{l:{valType:"number",min:0,dflt:80,editType:"plot"},r:{valType:"number",min:0,dflt:80,editType:"plot"},t:{valType:"number",min:0,dflt:100,editType:"plot"},b:{valType:"number",min:0,dflt:80,editType:"plot"},pad:{valType:"number",min:0,dflt:0,editType:"plot"},autoexpand:{valType:"boolean",dflt:!0,editType:"plot"},editType:"plot"},computed:{valType:"any",editType:"none"},paper_bgcolor:{valType:"color",dflt:a.background,editType:"plot"},plot_bgcolor:{valType:"color",dflt:a.background,editType:"layoutstyle"},autotypenumbers:{valType:"enumerated",values:["convert types","strict"],dflt:"convert types",editType:"calc"},separators:{valType:"string",editType:"plot"},hidesources:{valType:"boolean",dflt:!1,editType:"plot"},showlegend:{valType:"boolean",editType:"legend"},colorway:{valType:"colorlist",dflt:a.defaults,editType:"calc"},datarevision:{valType:"any",editType:"calc"},uirevision:{valType:"any",editType:"none"},editrevision:{valType:"any",editType:"none"},selectionrevision:{valType:"any",editType:"none"},template:{valType:"any",editType:"calc"},newshape:o.newshape,activeshape:o.activeshape,meta:{valType:"any",arrayOk:!0,editType:"plot"},transition:l({},i.transition,{editType:"none"}),_deprecated:{title:{valType:"string",editType:"layoutstyle"},titlefont:n({editType:"layoutstyle"})}}},{"../components/color/attributes":649,"../components/shapes/draw_newshape/attributes":735,"../lib/extend":777,"./animation_attributes":832,"./font_attributes":867,"./pad_attributes":900}],893:[function(t,e,r){"use strict";var n=t('../../lib/sort_object_keys'),i='1.10.1',a='\xa9 <a target='_blank' href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',o=['\xa9 <a target='_blank' href="https://carto.com/">Carto</a>',a].join(' '),s=['Map tiles by <a target='_blank' href="https://stamen.com">Stamen Design</a>','under <a target='_blank' href="https://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>','|','Data by <a target='_blank' href="https://openstreetmap.org">OpenStreetMap</a> contributors','under <a target='_blank' href="https://www.openstreetmap.org/copyright">ODbL</a>'].join(' '),l={"open-street-map":{id:"osm",version:8,sources:{"plotly-osm-tiles":{type:"raster",attribution:a,tiles:["https://a.tile.openstreetmap.org/{z}/[x]/[y].png","https://b.tile.openstreetmap.org/[z]/[x]/[y].png"],tileSize:256}},layers:[id:"plotly-osm-tiles",type:"raster",source:"plotly-osm-tiles",minzoom:0,maxzoom:22]},"white-bg":{id:"white-bg",version:8,sources:{},layers:[id:"white-bg",type:"background",paint:{"background-color":"#FFFFFF"},minzoom:0,maxzoom:22}],"carto-positron":{id:"carto-positron",version:8,sources:{"plotly-carto-positron":{type:"raster",attribution:o,tiles:["https://cartodb-basemaps-c.global.ssl.fastly.net/light_all/{z}/[x]/[y].png"],tileSize:256}},layers:[id:"plotly-carto-positron",type:"raster",source:"plotly-carto-positron",minzoom:0,maxzoom:22]},"carto-darkmatter":{id:"carto-darkmatter",version:8,sources:{"plotly-carto-darkmatter":{type:"raster",attribution:o,tiles:["https://cartodb-basemaps-c.global.ssl.fastly.net/dark_all/{z}/[x]/[y].png"],tileSize:256}},layers:[id:"plotly-carto-darkmatter",type:"raster",source:"plotly-carto-darkmatter",minzoom:0,maxzoom:22]},"stamen-terrain":{id:"stamen-terrain",version:8,sources:{"plotly-stamen-terrain":{type:"raster",attribution:s,tiles:["https://stamen-tiles.a.ssl.fastly.net/terrain/{z}/[x]/[y].png"],tileSize:256}},layers:[id:"plotly-stamen-terrain",type:"raster",source:"plotly-stamen-terrain",minzoom:0,maxzoom:22]},"stamen-toner":{id:"stamen-toner",version:8,sources:{"plotly-stamen-toner":{type:"raster",attribution:s,tiles:["https://stamen-tiles.a.ssl.fastly.net/toner/{z}/[x]/[y].png"],tileSize:256}},layers:[id:"plotly-stamen-toner",type:"raster",source:"plotly-stamen-toner",minzoom:0,maxzoom:22]},"stamen-watercolor":{id:"stamen-watercolor",version:8,sources:{"plotly-stamen-watercolor":{type:"raster",attribution:['Map tiles by <a target='_blank' href="https://stamen.com">Stamen Design</a>','under <a target='_blank' href="https://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>','|','Data by <a target='_blank' href="https://openstreetmap.org">OpenStreetMap</a> contributors','under <a target='_blank' href="https://creativecommons.org/licenses/by-sa/3.0">CC BY SA</a>'].join(' '),tiles:["https://stamen-tiles.a.ssl.fastly.net/watercolor/{z}/[x]/[y].png"],tileSize:256}},layers:[id:"plotly-stamen-watercolor",type:"raster",source:"plotly-stamen-watercolor",minzoom:0,maxzoom:22]}},c=n(l);e.exports={requiredVersion:i,styleUrlPrefix:"mapbox://styles/mapbox/",styleUrlSuffix:"v9",styleValuesMapbox:["basic",'streets','outdoors','light','dark','satellite',"satellite-streets"],styleValueDflt:"basic",stylesNonMapbox:l,styleValuesNonMapbox:c,traceLayerPrefix:"plotly-trace-layer-",layoutLayerPrefix:"plotly-layout-layer-",wrongVersionErrorMsg:["Your custom plotly.js bundle is not using the correct mapbox-gl version","Please install mapbox-gl@"+i+"."].join('\n'),noAccessTokenErrorMsg:["Missing Mapbox access token.",'Mapbox trace type require a Mapbox access token to be registered.','For example:','  Plotly.newPlot(gd, data, layout, { mapboxAccessToken: 'my-access-token' });',"More info here: https://www.mapbox.com/help/define-access-token/"].join('\n'),missingStyleErrorMsg:["No valid mapbox style found, please set `mapbox.style` to one of:",c.join(', '),"or register a Mapbox access token to use a Mapbox-served style."].join('\n'),multipleTokensErrorMsg:["Set multiple mapbox access token across different mapbox subplot,","using first token found as mapbox-gl does not allow multipleaccess tokens on the same page."].join('\n'),mapOnErrorMsg:"Mapbox error.",mapboxLogo:{path0:"m 10.5,1.24 c -5.11,0 -9.25,4.15 -9.25,9.25 0,5.1 4.15,9.25 9.25,9.25 5.1,0 9.25,-4.15 9.25,-9.25 0,-5.11 -4.14,-9.25 -9.25,-9.25 z m 4.39,11.53 c -1.93,1.93 -4.78,2.31 -6.7,2.31 -0.7,0 -1.41,-0.05 -2.1,-0.16 0,0 -1.02,-5.64 2.14,-8.81 0.83,-0.83 1.95,-1.28 3.13,-1.28 1.27,0 2.49,0.51 3.39,1.42 1.84,1.84 1.89,4.75 0.14,6.52 z",path1:"M 10.5,-0.01 C 4.7,-0.01 0,4.7 0,10.49 c 0,5.79 4.7,10.5 10.5,10.5 5.8,0 10.5,-4.7 10.5,-10.5 C 20.99,4.7 16.3,-0.01 10.5,-0.01 Z m 0,19.75 c -5.11,0 -9.25,-4.15 -9.25,-9.25 0,-5.1 4.14,-9.26 9.25,-9.26 5.11,0 9.25,4.15 9.25,9.25 0,5.13 -4.14,9.26 -9.25,9.26 z",path2:"M 14.74,6.25 C 12.9,4.41 9.98,4.35 8.23,6.1 5.07,9.27 6.09,14.91 6.09,14.91 c 0,0 5.64,1.02 8.81,-2.14 C 16.64,11 16.59,8.09 14.74,6.25 Z m -2.27,4.09 -0.91,1.87 -0.9,-1.87 -1.86,-0.91 1.86,-0.9 0.9,-1.87 0.91,1.87 1.86,0.9 z",polygon:"11.56,12.21 10.66,10.34 8.8,9.43 10.66,8.53 11.56,6.66 12.47,8.53 14.33,9.43 12.47,10.34"},styleRules:{map:"overflow:hidden;position:relative;","missing-css":"display:none;",canary:"background-color:salmon;","ctrl-bottom-left":"position: absolute; pointer-events: none; z-index: 2; bottom: 0; left: 0;","ctrl-bottom-right":"position: absolute; pointer-events: none; z-index: 2; right: 0; bottom: 0;",ctrl:"clear: both; pointer-events: auto; transform: translate(0, 0);","ctrl-attrib.mapboxgl-compact .mapboxgl-ctrl-attrib-inner":"display: none;","ctrl-attrib.mapboxgl-compact:hover .mapboxgl-ctrl-attrib-inner":"display: block; margin-top:2px","ctrl-attrib.mapboxgl-compact:hover":"padding: 2px 24px 2px 4px; visibility: visible; margin-top: 6px;","ctrl-attrib.mapboxgl-compact::after":'content: ''; cursor: pointer; position: absolute; background-image: url(\'data:image/svg+xml;charset=utf-8,%3Csvg viewBox='0 0 20 20' xmlns="http://www.w3.org/2000/svg"%3E %3Cpath fill='%23333333' fill-rule='evenodd' d="M4,10a6,6 0 1,0 12,0a6,6 0 1,0 -12,0 M9,7a1,1 0 1,0 2,0a1,1 0 1,0 -2,0 M9,10a1,1 0 1,1 2,0l0,3a1,1 0 1,1 -2,0"/%3E %3C/svg%3E\'); background-color: rgba(255, 255, 255, 0.5); width: 24px; height: 24px; box-sizing: border-box; border-radius: 12px;',"ctrl-attrib.mapboxgl-compact":"min-height: 20px; padding: 0; margin: 10px; position: relative; background-color: #fff; border-radius: 3px 12px 12px 3px;","ctrl-bottom-right > .mapboxgl-ctrl-attrib.mapboxgl-compact::after":"bottom: 0; right: 0","ctrl-bottom-left > .mapboxgl-ctrl-attrib.mapboxgl-compact::after":"bottom: 0; left: 0","ctrl-bottom-left .mapboxgl-ctrl":"margin: 0 0 10px 10px; float: left;","ctrl-bottom-right .mapboxgl-ctrl":"margin: 0 10px 10px 0; float: right;","ctrl-attrib":"color: rgba(0, 0, 0, 0.75); text-decoration: none; font-size: 12px","ctrl-attrib a":"color: rgba(0, 0, 0, 0.75); text-decoration: none; font-size: 12px","ctrl-attrib a:hover":"color: inherit; text-decoration: underline;","ctrl-attrib .mapbox-improve-map":"font-weight: bold; margin-left: 2px;","attrib-empty":"display: none;","ctrl-logo":'display:block; width: 21px; height: 21px; background-image: url(\'data:image/svg+xml;charset=utf-8,%3C?xml version='1.0' encoding="utf-8"?%3E %3Csvg version='1.1' id='Layer_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 21 21' style='enable-background:new 0 0 21 21;' xml:space="preserve"%3E%3Cg transform="translate(0,0.01)"%3E%3Cpath d='m 10.5,1.24 c -5.11,0 -9.25,4.15 -9.25,9.25 0,5.1 4.15,9.25 9.25,9.25 5.1,0 9.25,-4.15 9.25,-9.25 0,-5.11 -4.14,-9.25 -9.25,-9.25 z m 4.39,11.53 c -1.93,1.93 -4.78,2.31 -6.7,2.31 -0.7,0 -1.41,-0.05 -2.1,-0.16 0,0 -1.02,-5.64 2.14,-8.81 0.83,-0.83 1.95,-1.28 3.13,-1.28 1.27,0 2.49,0.51 3.39,1.42 1.84,1.84 1.89,4.75 0.14,6.52 z' style='opacity:0.9;fill:%23ffffff;enable-background:new' class="st0"/%3E%3Cpath d='M 10.5,-0.01 C 4.7,-0.01 0,4.7 0,10.49 c 0,5.79 4.7,10.5 10.5,10.5 5.8,0 10.5,-4.7 10.5,-10.5 C 20.99,4.7 16.3,-0.01 10.5,-0.01 Z m 0,19.75 c -5.11,0 -9.25,-4.15 -9.25,-9.25 0,-5.1 4.14,-9.26 9.25,-9.26 5.11,0 9.25,4.15 9.25,9.25 0,5.13 -4.14,9.26 -9.25,9.26 z' style='opacity:0.35;enable-background:new' class="st1"/%3E%3Cpath d='M 14.74,6.25 C 12.9,4.41 9.98,4.35 8.23,6.1 5.07,9.27 6.09,14.91 6.09,14.91 c 0,0 5.64,1.02 8.81,-2.14 C 16.64,11 16.59,8.09 14.74,6.25 Z m -2.27,4.09 -0.91,1.87 -0.9,-1.87 -1.86,-0.91 1.86,-0.9 0.9,-1.87 0.91,1.87 1.86,0.9 z' style='opacity:0.35;enable-background:new' class="st1"/%3E%3Cpolygon points='11.56,12.21 10.66,10.34 8.8,9.43 10.66,8.53 11.56,6.66 12.47,8.53 14.33,9.43 12.47,10.34 ' style='opacity:0.9;fill:%23ffffff;enable-background:new' class="st0"/%3E%3C/g%3E%3C/svg%3E\')'}}},{"../../lib/sort_object_keys":810}],894:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){var r=t.split(' '),i=r[0],a=r[1],o=n.isArrayOrTypedArray(e)?n.mean(e):e,s=.5+o/100,l=1.5+o/100,c=["",""],u=[0,0];switch(i){case"top":c[0]='top',u[1]=-l;break;case"bottom":c[0]='bottom',u[1]=l}switch(a){case"left":c[1]='right',u[0]=-s;break;case"right":c[1]='left',u[0]=s}return{anchor:c[0]&&c[1]?c.join('-'):c[0]?c[0]:c[1]?c[1]:"center",offset:u}}},{"../../lib":787}],895:[function(t,e,r){"use strict";var n=t('mapbox-gl/dist/mapbox-gl-unminified'),i=t('../../lib'),a=i.strTranslate,o=i.strScale,s=t('../../plots/get_data').getSubplotCalcData,l=t('../../constants/xmlns_namespaces'),c=t('@plotly/d3'),u=t('../../components/drawing'),f=t('../../lib/svg_text_utils'),h=t('./mapbox'),p='mapbox',d=r.constants=t('./constants');function m(t,e){var r=t._fullLayout;if(""===t._context.mapboxAccessToken)return'';for(var n=[],a=[],o=!1,s=!1,l=0;l<e.length;l++){var c=r[e[l]],u=c.accesstoken;g(c.style)&&(u?i.pushUnique(n,u):(g(c._input.style)&&(i.error('Uses Mapbox map style, but did not set an access token.'),o=!0),s=!0)),u&&i.pushUnique(a,u)}if(s){var f=o?d.noAccessTokenErrorMsg:d.missingStyleErrorMsg;throw i.error(f),new Error(f)}return n.length?(n.length>1&&i.warn(d.multipleTokensErrorMsg),n[0]):(a.length&&i.log(["Listed mapbox access token(s)",a.join(','),"but did not use a Mapbox map style, ignoring token(s)."].join(' ')),'')}function g(t){return"string"===typeof t&&(-1!==d.styleValuesMapbox.indexOf(t)||0===t.indexOf('mapbox://'))}r.name=p,r.attr='subplot',r.idRoot=p,r.idRegex=r.attrRegex=i.counterRegex(p),r.attributes={subplot:{valType:"subplotid",dflt:"mapbox",editType:"calc"}},r.layoutAttributes=t('./layout_attributes'),r.supplyLayoutDefaults=t('./layout_defaults'),r.plot=function(t){var e=t._fullLayout,r=t.calcdata,a=e._subplots[p];if(n.version!==d.requiredVersion)throw new Error(d.wrongVersionErrorMsg);var o=m(t,a);n.accessToken=o;for(var l=0;l<a.length;l++){var c=a[l],u=s(r,p,c),f=e[c],g=f._subplot;g||(g=new h(t,c),e[c]._subplot=g),g.viewInitial||(g.viewInitial={center:i.extendFlat({},f.center),zoom:f.zoom,bearing:f.bearing,pitch:f.pitch}),g.plot(u,e,t._promises)}},r.clean=function(t,e,r,n){for(var i=n._subplots[p]||[],a=0;a<i.length;a++){var o=i[a];!e[o]&&n[o]._subplot&&n[o]._subplot.destroy()}},r.toSVG=function(t){for(var e=t._fullLayout,r=e._subplots[p],n=e._size,i=0;i<r.length;i++){var s=e[r[i]],h=s.domain,m=s._subplot.toImage('png');e._glimages.append('svg:image').attr({xmlns:l.svg,"xlink:href":m,x:n.l+n.w*h.x[0],y:n.t+n.h*(1-h.y[1]),width:n.w*(h.x[1]-h.x[0]),height:n.h*(h.y[1]-h.y[0]),preserveAspectRatio:"none"});var g=c.select(s._subplot.div);if(null!==g.select('.mapboxgl-ctrl-logo').node().offsetParent){var v=e._glimages.append('g');v.attr('transform',a(n.l+n.w*h.x[0]+10,n.t+n.h*(1-h.y[0])-31)),v.append('path').attr('d',d.mapboxLogo.path0).style({opacity:.9,fill:"#ffffff","enable-background":"new"}),v.append('path').attr('d',d.mapboxLogo.path1).style('opacity',.35).style('enable-background','new'),v.append('path').attr('d',d.mapboxLogo.path2).style('opacity',.35).style('enable-background','new'),v.append('polygon').attr('points',d.mapboxLogo.polygon).style({opacity:.9,fill:"#ffffff","enable-background":"new"})}var y=g.select('.mapboxgl-ctrl-attrib').text().replace('Improve this map',''),x=e._glimages.append('g'),b=x.append('text');b.text(y).classed('static-attribution',!0).attr({"font-size":12,"font-family":"Arial",color:"rgba(0, 0, 0, 0.75)","text-anchor":"end","data-unformatted":y});var _=u.bBox(b.node()),w=n.w*(h.x[1]-h.x[0]);if(_.width>w/2){var T=y.split('|').join('<br>');b.text(T).attr('data-unformatted',T).call(f.convertToTspans,t),_=u.bBox(b.node())}b.attr('transform',a(-3,8-_.height)),x.insert('rect','.static-attribution').attr({x:-_.width-6,y:-_.height-3,width:_.width+6,height:_.height+3,fill:"rgba(255, 255, 255, 0.75)"});var k=1;_.width+6>w&&(k=w/(_.width+6));var M=[n.l+n.w*h.x[1],n.t+n.h*(1-h.y[0])];x.attr('transform',a(M[0],M[1])+o(k))}},r.updateFx=function(t){for(var e=t._fullLayout,r=e._subplots[p],n=0;n<r.length;n++)e[r[n]]._subplot.updateFx(e)}},{"../../components/drawing":672,"../../constants/xmlns_namespaces":764,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/get_data":875,"./constants":893,"./layout_attributes":897,"./layout_defaults":898,"./mapbox":899,"@plotly/d3":58,"mapbox-gl/dist/mapbox-gl-unminified":451}],896:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../lib/svg_text_utils').sanitizeHTML,a=t('./convert_text_opts'),o=t('./constants');function s(t,e){this.subplot=t,this.uid=t.uid+"-"+e,this.index=e,this.idSource="source-"+this.uid,this.idLayer=o.layoutLayerPrefix+this.uid,this.sourceType=null,this.source=null,this.layerType=null,this.below=null,this.visible=!1}var l=s.prototype;function c(t){if(!t.visible)return!1;var e=t.source;if(Array.isArray(e)&&e.length>0){for(var r=0;r<e.length;r++)if("string"!==typeof e[r]||0===e[r].length)return!1;return!0}return n.isPlainObject(e)||"string"===typeof e&&e.length>0}function u(t)[var e={],r={};switch(t.type){case"circle":n.extendFlat(r,{"circle-radius":t.circle.radius,"circle-color":t.color,"circle-opacity":t.opacity});break;case"line":n.extendFlat(r,{"line-width":t.line.width,"line-color":t.color,"line-opacity":t.opacity,"line-dasharray":t.line.dash});break;case"fill":n.extendFlat(r,{"fill-color":t.color,"fill-outline-color":t.fill.outlinecolor,"fill-opacity":t.opacity});break;case"symbol":var i=t.symbol,o=a(i.textposition,i.iconsize);n.extendFlat(e,{"icon-image":i.icon+"-15","icon-size":i.iconsize/10,"text-field":i.text,"text-size":i.textfont.size,"text-anchor":o.anchor,"text-offset":o.offset,"symbol-placement":i.placement}),n.extendFlat(r,{"icon-color":t.color,"text-color":i.textfont.color,"text-opacity":t.opacity});break;case"raster":n.extendFlat(r,{"raster-fade-duration":0,"raster-opacity":t.opacity})}return{layout:e,paint:r}}function f(t){var e,r=t.sourcetype,n=t.source,a={type:r};return"geojson"===r?e="data":"vector"===r?e="string"===typeof n?"url":"tiles":"raster"===r?(e='tiles',a.tileSize=256):"image"===r&&(e='url',a.coordinates=t.coordinates),a[e]=n,t.sourceattribution&&(a.attribution=i(t.sourceattribution)),a}l.update=function(t){this.visible?this.needsNewImage(t)?this.updateImage(t):this.needsNewSource(t)?(this.removeLayer(),this.updateSource(t),this.updateLayer(t)):this.needsNewLayer(t)?this.updateLayer(t):this.updateStyle(t):(this.updateSource(t),this.updateLayer(t)),this.visible=c(t)},l.needsNewImage=function(t){return this.subplot.map.getSource(this.idSource)&&"image"===this.sourceType&&"image"===t.sourcetype&&(this.source!==t.source||JSON.stringify(this.coordinates)!==JSON.stringify(t.coordinates))},l.needsNewSource=function(t){return this.sourceType!==t.sourcetype||JSON.stringify(this.source)!==JSON.stringify(t.source)||this.layerType!==t.type},l.needsNewLayer=function(t){return this.layerType!==t.type||this.below!==this.subplot.belowLookup["layout-"+this.index]},l.lookupBelow=function(){return this.subplot.belowLookup["layout-"+this.index]},l.updateImage=function(t){this.subplot.map.getSource(this.idSource).updateImage({url:t.source,coordinates:t.coordinates});var e=this.findFollowingMapboxLayerId(this.lookupBelow());null!==e&&this.subplot.map.moveLayer(this.idLayer,e)},l.updateSource=function(t){var e=this.subplot.map;if(e.getSource(this.idSource)&&e.removeSource(this.idSource),this.sourceType=t.sourcetype,this.source=t.source,c(t)){var r=f(t);e.addSource(this.idSource,r)}},l.findFollowingMapboxLayerId=function(t){if("traces"===t)for(var e=this.subplot.getMapLayers(),r=0;r<e.length;r++){var n=e[r].id;if("string"===typeof n&&0===n.indexOf(o.traceLayerPrefix)){t=n;break}}return t},l.updateLayer=function(t){var e=this.subplot,r=u(t),n=this.lookupBelow(),i=this.findFollowingMapboxLayerId(n);this.removeLayer(),c(t)&&e.addLayer({id:this.idLayer,source:this.idSource,"source-layer":t.sourcelayer||"",type:t.type,minzoom:t.minzoom,maxzoom:t.maxzoom,layout:r.layout,paint:r.paint},i),this.layerType=t.type,this.below=n},l.updateStyle=function(t){if(c(t)){var e=u(t);this.subplot.setOptions(this.idLayer,'setLayoutProperty',e.layout),this.subplot.setOptions(this.idLayer,'setPaintProperty',e.paint)}},l.removeLayer=function(){var t=this.subplot.map;t.getLayer(this.idLayer)&&t.removeLayer(this.idLayer)},l.dispose=function(){var t=this.subplot.map;t.getLayer(this.idLayer)&&t.removeLayer(this.idLayer),t.getSource(this.idSource)&&t.removeSource(this.idSource)},e.exports=function(t,e,r){var n=new s(t,e);return n.update(r),n}},{"../../lib":787,"../../lib/svg_text_utils":813,"./constants":893,"./convert_text_opts":894}],897:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color').defaultLine,a=t('../domain').attributes,o=t('../font_attributes'),s=t('../../traces/scatter/attributes').textposition,l=t('../../plot_api/edit_types').overrideAll,c=t('../../plot_api/plot_template').templatedArray,u=t('./constants'),f=o({});f.family.dflt='Open Sans Regular, Arial Unicode MS Regular',(e.exports=l({_arrayAttrRegexps:[n.counterRegex('mapbox','.layers',!0)],domain:a({name:"mapbox"}),accesstoken:{valType:"string",noBlank:!0,strict:!0},style:{valType:"any",values:u.styleValuesMapbox.concat(u.styleValuesNonMapbox),dflt:u.styleValueDflt},center:{lon:{valType:"number",dflt:0},lat:{valType:"number",dflt:0}},zoom:{valType:"number",dflt:1},bearing:{valType:"number",dflt:0},pitch:{valType:"number",dflt:0},layers:c('layer',{visible:{valType:"boolean",dflt:!0},sourcetype:{valType:"enumerated",values:["geojson",'vector','raster',"image"],dflt:"geojson"},source:{valType:"any"},sourcelayer:{valType:"string",dflt:""},sourceattribution:{valType:"string"},type:{valType:"enumerated",values:["circle",'line','fill','symbol',"raster"],dflt:"circle"},coordinates:{valType:"any"},below:{valType:"string"},color:{valType:"color",dflt:i},opacity:{valType:"number",min:0,max:1,dflt:1},minzoom:{valType:"number",min:0,max:24,dflt:0},maxzoom:{valType:"number",min:0,max:24,dflt:24},circle:{radius:{valType:"number",dflt:15}},line:{width:{valType:"number",dflt:2},dash:{valType:"data_array"}},fill:{outlinecolor:{valType:"color",dflt:i}},symbol:{icon:{valType:"string",dflt:"marker"},iconsize:{valType:"number",dflt:10},text:{valType:"string",dflt:""},placement:{valType:"enumerated",values:["point",'line',"line-center"],dflt:"point"},textfont:f,textposition:n.extendFlat({},s,{arrayOk:!1})}})},'plot','from-root')).uirevision={valType:"any",editType:"none"}},{"../../components/color":650,"../../lib":787,"../../plot_api/edit_types":820,"../../plot_api/plot_template":827,"../../traces/scatter/attributes":1202,"../domain":866,"../font_attributes":867,"./constants":893}],898:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../subplot_defaults'),a=t('../array_container_defaults'),o=t('./layout_attributes');function s(t,e,r,n){r('accesstoken',n.accessToken),r('style'),r('center.lon'),r('center.lat'),r('zoom'),r('bearing'),r('pitch'),a(t,e,{name:"layers",handleItemDefaults:l}),e._input=t}function l(t,e){function r(r,i){return n.coerce(t,e,o.layers,r,i)}if(r('visible')){var i,a=r('sourcetype'),s="raster"===a||"image"===a;r('source'),r('sourceattribution'),"vector"===a&&r('sourcelayer'),"image"===a&&r('coordinates'),s&&(i='raster');var l=r('type',i);s&&"raster"!==l&&(l=e.type='raster',n.log('Source types *raster* and *image* must drawn *raster* layer type.')),r('below'),r('color'),r('opacity'),r('minzoom'),r('maxzoom'),"circle"===l&&r('circle.radius'),"line"===l&&(r('line.width'),r('line.dash')),"fill"===l&&r('fill.outlinecolor'),"symbol"===l&&(r('symbol.icon'),r('symbol.iconsize'),r('symbol.text'),n.coerceFont(r,'symbol.textfont'),r('symbol.textposition'),r('symbol.placement'))}}e.exports=function(t,e,r){i(t,e,r,{type:"mapbox",attributes:o,handleDefaults:s,partition:"y",accessToken:e._mapboxAccessToken})}},{"../../lib":787,"../array_container_defaults":833,"../subplot_defaults":909,"./layout_attributes":897}],899:[function(t,e,r){"use strict";var n=t('mapbox-gl/dist/mapbox-gl-unminified'),i=t('../../lib'),a=t('../../lib/geo_location_utils'),o=t('../../registry'),s=t('../cartesian/axes'),l=t('../../components/dragelement'),c=t('../../components/fx'),u=t('../../components/dragelement/helpers'),f=u.rectMode,h=u.drawMode,p=u.selectMode,d=t('../cartesian/select').prepSelect,m=t('../cartesian/select').clearSelect,g=t('../cartesian/select').clearSelectionsCache,v=t('../cartesian/select').selectOnClick,y=t('./constants'),x=t('./layers');function b(t,e){this.id=e,this.gd=t;var r=t._fullLayout,n=t._context;this.container=r._glcontainer.node(),this.isStatic=n.staticPlot,this.uid=r._uid+"-"+this.id,this.div=null,this.xaxis=null,this.yaxis=null,this.createFramework(r),this.map=null,this.accessToken=null,this.styleObj=null,this.traceHash={},this.layerList=[],this.belowLookup={},this.dragging=!1,this.wheeling=!1}var _=b.prototype;_.plot=function(t,e,r){var n,i=this,a=e[i.id];i.map&&a.accesstoken!==i.accessToken&&(i.map.remove(),i.map=null,i.styleObj=null,i.traceHash={},i.layerList=[]),n=i.map?new Promise((function(r,n){i.updateMap(t,e,r,n)})):new Promise((function(r,n){i.createMap(t,e,r,n)})),r.push(n)},_.createMap=function(t,e,r,i){var o=this,s=e[o.id],l=o.styleObj=T(s.style);o.accessToken=s.accesstoken;var c=o.map=new n.Map({container:o.div,style:l.style,center:M(s.center),zoom:s.zoom,bearing:s.bearing,pitch:s.pitch,interactive:!o.isStatic,preserveDrawingBuffer:o.isStatic,doubleClickZoom:!1,boxZoom:!1,attributionControl:!1}).addControl(new n.AttributionControl({compact:!0}));c._canvas.style.left='0px',c._canvas.style.top='0px',o.rejectOnError(i),o.isStatic||o.initFx(t,e);var u=[];u.push(new Promise((function(t){c.once('load',t)}))),u=u.concat(a.fetchTraceGeoData(t)),Promise.all(u).then((function(){o.fillBelowLookup(t,e),o.updateData(t),o.updateLayout(e),o.resolveOnRender(r)})).catch(i)},_.updateMap=function(t,e,r,n){var i=this,o=i.map,s=e[this.id];i.rejectOnError(n);var l=[],c=T(s.style);JSON.stringify(i.styleObj)!==JSON.stringify(c)&&(i.styleObj=c,o.setStyle(c.style),i.traceHash={},l.push(new Promise((function(t){o.once('styledata',t)})))),l=l.concat(a.fetchTraceGeoData(t)),Promise.all(l).then((function(){i.fillBelowLookup(t,e),i.updateData(t),i.updateLayout(e),i.resolveOnRender(r)})).catch(n)},_.fillBelowLookup=function(t,e){var r,n,i=e[this.id].layers,a=this.belowLookup={},o=!1;for(r=0;r<t.length;r++){var s=t[r][0].trace,l=s._module;"string"===typeof s.below?n=s.below:l.getBelow&&(n=l.getBelow(s,this)),""===n&&(o=!0),a["trace-"+s.uid]=n||""}for(r=0;r<i.length;r++){var c=i[r];n="string"===typeof c.below?c.below:o?"traces":"",a["layout-"+r]=n}var u,f,h={};for(u in a)h[n=a[u]]?h[n].push(u):h[n]=[u];for(n in h){var p=h[n];if(p.length>1)for(r=0;r<p.length;r++)0===(u=p[r]).indexOf('trace-')?(f=u.split('trace-')[1],this.traceHash[f]&&(this.traceHash[f].below=null)):0===u.indexOf('layout-')&&(f=u.split('layout-')[1],this.layerList[f]&&(this.layerList[f].below=null))}};var w={choroplethmapbox:0,densitymapbox:1,scattermapbox:2};function T(t)[var e={];return i.isPlainObject(t)?(e.id=t.id,e.style=t):"string"===typeof t?(e.id=t,-1!==y.styleValuesMapbox.indexOf(t)?e.style=k(t):y.stylesNonMapbox[t]?e.style=y.stylesNonMapbox[t]:e.style=t):(e.id=y.styleValueDflt,e.style=k(y.styleValueDflt)),e.transition={duration:0,delay:0},e}function k(t){return y.styleUrlPrefix+t+"-"+y.styleUrlSuffix}function M(t){return[t.lon,t.lat]}_.updateData=function(t){var e,r,n,i,a=this.traceHash,o=t.slice().sort((function(t,e){return w[t[0].trace.type]-w[e[0].trace.type]}));for(n=0;n<o.length;n++){var s=o[n],l=!1;(e=a[(r=s[0].trace).uid])&&(e.type===r.type?(e.update(s),l=!0):e.dispose()),!l&&r._module&&(a[r.uid]=r._module.plot(this,s))}var c=Object.keys(a);t:for(n=0;n<c.length;n++){var u=c[n];for(i=0;i<t.length;i++)if(u===(r=t[i][0].trace).uid)continue t;(e=a[u]).dispose(),delete a[u]}},_.updateLayout=function(t){var e=this.map,r=t[this.id];this.dragging||this.wheeling||(e.setCenter(M(r.center)),e.setZoom(r.zoom),e.setBearing(r.bearing),e.setPitch(r.pitch)),this.updateLayers(t),this.updateFramework(t),this.updateFx(t),this.map.resize(),this.gd._context._scrollZoom.mapbox?e.scrollZoom.enable():e.scrollZoom.disable()},_.resolveOnRender=function(t){var e=this.map;e.on('render',(function r(){e.loaded()&&(e.off('render',r),setTimeout(t,10))}))},_.rejectOnError=function(t){var e=this.map;function r(){t(new Error(y.mapOnErrorMsg))}e.once('error',r),e.once('style.error',r),e.once('source.error',r),e.once('tile.error',r),e.once('layer.error',r)},_.createFramework=function(t){var e=this,r=e.div=document.createElement('div');r.id=e.uid,r.style.position='absolute',e.container.appendChild(r),e.xaxis={_id:"x",c2p:function(t){return e.project(t).x}},e.yaxis={_id:"y",c2p:function(t){return e.project(t).y}},e.updateFramework(t),e.mockAxis={type:"linear",showexponent:"all",exponentformat:"B"},s.setConvert(e.mockAxis,t)},_.initFx=function(t,e){var r=this,n=r.gd,i=r.map;function a(){c.loneUnhover(e._hoverlayer)}function s(){var t=r.getView();n.emit('plotly_relayouting',r.getViewEditsWithDerived(t))}i.on('moveend',(function(t){if(r.map){var e=n._fullLayout;if(t.originalEvent||r.wheeling){var i=e[r.id];o.call('_storeDirectGUIEdit',n.layout,e._preGUI,r.getViewEdits(i));var a=r.getView();i._input.center=i.center=a.center,i._input.zoom=i.zoom=a.zoom,i._input.bearing=i.bearing=a.bearing,i._input.pitch=i.pitch=a.pitch,n.emit('plotly_relayout',r.getViewEditsWithDerived(a))}t.originalEvent&&"mouseup"===t.originalEvent.type?r.dragging=!1:r.wheeling&&(r.wheeling=!1),e._rehover&&e._rehover()}})),i.on('wheel',(function()[r.wheeling=!0])),i.on('mousemove',(function(t){var e=r.div.getBoundingClientRect(),a=[t.originalEvent.offsetX,t.originalEvent.offsetY];t.target.getBoundingClientRect=function(){return e},r.xaxis.p2c=function(){return i.unproject(a).lng},r.yaxis.p2c=function(){return i.unproject(a).lat},n._fullLayout._rehover=function(){n._fullLayout._hoversubplot===r.id&&n._fullLayout[r.id]&&c.hover(n,t,r.id)},c.hover(n,t,r.id),n._fullLayout._hoversubplot=r.id})),i.on('dragstart',(function(){r.dragging=!0,a()})),i.on('zoomstart',a),i.on('mouseout',(function()[n._fullLayout._hoversubplot=null])),i.on('drag',s),i.on('zoom',s),i.on('dblclick',(function(){var t=n._fullLayout[r.id];o.call('_storeDirectGUIEdit',n.layout,n._fullLayout._preGUI,r.getViewEdits(t));var e=r.viewInitial;i.setCenter(M(e.center)),i.setZoom(e.zoom),i.setBearing(e.bearing),i.setPitch(e.pitch);var a=r.getView();t._input.center=t.center=a.center,t._input.zoom=t.zoom=a.zoom,t._input.bearing=t.bearing=a.bearing,t._input.pitch=t.pitch=a.pitch,n.emit('plotly_doubleclick',null),n.emit('plotly_relayout',r.getViewEditsWithDerived(a))})),r.clearSelect=function(){g(r.dragOptions),m(r.dragOptions.gd)},r.onClickInPanFn=function(t){return function(e){var i=n._fullLayout.clickmode;i.indexOf('select')>-1&&v(e.originalEvent,n,[r.xaxis],[r.yaxis],r.id,t),i.indexOf('event')>-1&&c.click(n,e.originalEvent)}}},_.updateFx=function(t){var e=this,r=e.map,n=e.gd;if(!e.isStatic){var a,o=t.dragmode;a=f(o)?function(t,r){(t.range={})[e.id]=[c([r.xmin,r.ymin]),c([r.xmax,r.ymax])]}:function(t,r,n)[(t.lassoPoints={])[e.id]=n.filtered.map(c)};var s=e.dragOptions;e.dragOptions=i.extendDeep(s||{},{dragmode:t.dragmode,element:e.div,gd:n,plotinfo:{id:e.id,domain:t[e.id].domain,xaxis:e.xaxis,yaxis:e.yaxis,fillRangeItems:a},xaxes:[e.xaxis],yaxes:[e.yaxis],subplot:e.id}),r.off('click',e.onClickInPanHandler),p(o)||h(o)?(r.dragPan.disable(),r.on('zoomstart',e.clearSelect),e.dragOptions.prepFn=function(t,r,n){d(t,r,n,e.dragOptions,o)},l.init(e.dragOptions)):(r.dragPan.enable(),r.off('zoomstart',e.clearSelect),e.div.onmousedown=null,e.onClickInPanHandler=e.onClickInPanFn(e.dragOptions),r.on('click',e.onClickInPanHandler))}function c(t){var r=e.map.unproject(t);return[r.lng,r.lat]}},_.updateFramework=function(t){var e=t[this.id].domain,r=t._size,n=this.div.style;n.width=r.w*(e.x[1]-e.x[0])+"px",n.height=r.h*(e.y[1]-e.y[0])+"px",n.left=r.l+e.x[0]*r.w+"px",n.top=r.t+(1-e.y[1])*r.h+"px",this.xaxis._offset=r.l+e.x[0]*r.w,this.xaxis._length=r.w*(e.x[1]-e.x[0]),this.yaxis._offset=r.t+(1-e.y[1])*r.h,this.yaxis._length=r.h*(e.y[1]-e.y[0])},_.updateLayers=function(t){var e,r=t[this.id].layers,n=this.layerList;if(r.length!==n.length){for(e=0;e<n.length;e++)n[e].dispose();for(n=this.layerList=[],e=0;e<r.length;e++)n.push(x(this,e,r[e]))}else for(e=0;e<r.length;e++)n[e].update(r[e])},_.destroy=function(){this.map&&(this.map.remove(),this.map=null,this.container.removeChild(this.div))},_.toImage=function(){return this.map.stop(),this.map.getCanvas().toDataURL()},_.setOptions=function(t,e,r){for(var n in r)this.map[e](t,n,r[n])},_.getMapLayers=function(){return this.map.getStyle().layers},_.addLayer=function(t,e){var r=this.map;if("string"===typeof e){if(""===e)return void r.addLayer(t,e);for(var n=this.getMapLayers(),a=0;a<n.length;a++)if(e===n[a].id)return void r.addLayer(t,e);i.warn(["Trying to add layer with *below* value",e,'referencing a layer that does not exist',"or that does not yet exist."].join(' '))}r.addLayer(t)},_.project=function(t){return this.map.project(new n.LngLat(t[0],t[1]))},_.getView=function(){var t=this.map,e=t.getCenter(),r={lon:e.lng,lat:e.lat},n=t.getCanvas(),i=n.width,a=n.height;return{center:r,zoom:t.getZoom(),bearing:t.getBearing(),pitch:t.getPitch(),_derived:{coordinates:[t.unproject([0,0]).toArray(),t.unproject([i,0]).toArray(),t.unproject([i,a]).toArray(),t.unproject([0,a]).toArray()]}}},_.getViewEdits=function(t){for(var e=this.id,r=["center",'zoom','bearing',"pitch"],n={},i=0;i<r.length;i++){var a=r[i];n[e+"."+a]=t[a]}return n},_.getViewEditsWithDerived=function(t){var e=this.id,r=this.getViewEdits(t);return r[e+"._derived"]=t._derived,r},e.exports=b},{"../../components/dragelement":669,"../../components/dragelement/helpers":668,"../../components/fx":690,"../../lib":787,"../../lib/geo_location_utils":780,"../../registry":915,"../cartesian/axes":838,"../cartesian/select":858,"./constants":893,"./layers":896,"mapbox-gl/dist/mapbox-gl-unminified":451}],900:[function(t,e,r){"use strict";e.exports=function(t){var e=t.editType;return{t:{valType:"number",dflt:0,editType:e},r:{valType:"number",dflt:0,editType:e},b:{valType:"number",dflt:0,editType:e},l:{valType:"number",dflt:0,editType:e},editType:e}}},{}],901:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-time-format').timeFormatLocale,a=t('d3-format').formatLocale,o=t('fast-isnumeric'),s=t('../registry'),l=t('../plot_api/plot_schema'),c=t('../plot_api/plot_template'),u=t('../lib'),f=t('../components/color'),h=t('../constants/numerical').BADNUM,p=t('./cartesian/axis_ids'),d=t('./cartesian/handle_outline').clearSelect,m=t('./animation_attributes'),g=t('./frame_attributes'),v=t('../plots/get_data').getModuleCalcData,y=u.relinkPrivateKeys,x=u._,b=e.exports={};u.extendFlat(b,s),b.attributes=t('./attributes'),b.attributes.type.values=b.allTypes,b.fontAttrs=t('./font_attributes'),b.layoutAttributes=t('./layout_attributes'),b.fontWeight='normal';var _=b.transformsRegistry,w=t('./command');function T(t,e){e.text('');var r=e.append('a').attr({"xlink:xlink:href":"#",class:"link--impt link--embedview","font-weight":"bold"}).text(t._context.linkText+" "+String.fromCharCode(187));if(t._context.sendData)r.on('click',(function()[b.sendDataToCloud(t)]));else{var n=window.location.pathname.split('/'),i=window.location.search;r.attr({"xlink:xlink:show":"new","xlink:xlink:href":"/"+n[2].split('.')[0]+"/"+n[1]+i})}}b.executeAPICommand=w.executeAPICommand,b.computeAPICommandBindings=w.computeAPICommandBindings,b.manageCommandObserver=w.manageCommandObserver,b.hasSimpleAPICommandBindings=w.hasSimpleAPICommandBindings,b.redrawText=function(t){return t=u.getGraphDiv(t),new Promise((function(e){setTimeout((function(){t._fullLayout&&(s.getComponentMethod('annotations','draw')(t),s.getComponentMethod('legend','draw')(t),s.getComponentMethod('colorbar','draw')(t),e(b.previousPromises(t)))}),300)}))},b.resize=function(t){var e;t=u.getGraphDiv(t);var r=new Promise((function(r,n){t&&!u.isHidden(t)||n(new Error('Resize must be passed a displayed plot div element.')),t._redrawTimer&&clearTimeout(t._redrawTimer),t._resolveResize&&(e=t._resolveResize),t._resolveResize=r,t._redrawTimer=setTimeout((function(){if(!t.layout||t.layout.width&&t.layout.height||u.isHidden(t))r(t);else{delete t.layout.width,delete t.layout.height;var e=t.changed;t.autoplay=!0,s.call('relayout',t,{autosize:!0}).then((function(){t.changed=e,t._resolveResize===r&&(delete t._resolveResize,r(t))}))}}),100)}));return e&&e(r),r},b.previousPromises=function(t){if((t._promises||[]).length)return Promise.all(t._promises).then((function(){t._promises=[]}))},b.addLinks=function(t){if(t._context.showLink||t._context.showSources){var e=t._fullLayout,r=u.ensureSingle(e._paper,'text','js-plot-link-container',(function(t){t.style({"font-family":'"Open Sans", Arial, sans-serif',"font-size":"12px",fill:f.defaultLine,"pointer-events":"all"}).each((function(){var t=n.select(this);t.append('tspan').classed('js-link-to-tool',!0),t.append('tspan').classed('js-link-spacer',!0),t.append('tspan').classed('js-sourcelinks',!0)}))})),i=r.node(),a={y:e._paper.attr('height')-9};document.body.contains(i)&&i.getComputedTextLength()>=e.width-20?(a["text-anchor"]='start',a.x=5):(a["text-anchor"]='end',a.x=e._paper.attr('width')-7),r.attr(a);var o=r.select('.js-link-to-tool'),s=r.select('.js-link-spacer'),l=r.select('.js-sourcelinks');t._context.showSources&&t._context.showSources(t),t._context.showLink&&T(t,o),s.text(o.text()&&l.text()?" - ":"")}},b.sendDataToCloud=function(t)[var e=(window.PLOTLYENV||{]).BASE_URL||t._context.plotlyServerURL;if(e){t.emit('plotly_beforeexport');var r=n.select(t).append('div').attr('id','hiddenform').style('display','none'),i=r.append('form').attr({action:e+"/external",method:"post",target:"_blank"});return i.append('input').attr({type:"text",name:"data"}).node().value=b.graphJson(t,!1,'keepdata'),i.node().submit(),r.remove(),t.emit('plotly_afterexport'),!1}};var k=["days",'shortDays','months','shortMonths','periods','dateTime','date','time','decimal','thousands','grouping',"currency"],M=["year",'month','dayMonth',"dayMonthYear"];function A(t,e){var r,n,i=e.length,a=[];for(r=0;r<t.length;r++){var o=t[r]._fullInput;o!==n&&a.push(o),n=o}var s=a.length,l=new Array(i),c={};function f(t,e){l[e]=t,c[t]=1}function h(t,e){if(t&&"string"===typeof t&&!c[t])return f(t,e),!0}for(r=0;r<i;r++){var p=e[r].uid;"number"===typeof p&&(p=String(p)),h(p,r)||r<s&&h(a[r].uid,r)||f(u.randstr(c),r)}return l}function S(){var t,e,r=s.collectableSubplotTypes,n={};if(!r){r=[];var i=s.subplotsRegistry;for(var a in i){var o=i[a].attr;if(o&&(r.push(a),Array.isArray(o)))for(e=0;e<o.length;e++)u.pushUnique(r,o[e])}}for(t=0;t<r.length;t++)n[r[t]]=[];return n}function E(t,e){var r=t._context.locale;r||(r='en-US');var n=!1,i={};function a(t){for(var r=!0,a=0;a<e.length;a++){var o=e[a];i[o]||(t[o]?i[o]=t[o]:r=!1)}r&&(n=!0)}for(var o=0;o<2;o++){for(var l=t._context.locales,c=0;c<2;c++){var u=(l[r]||{}).format;if(u&&(a(u),n))break;l=s.localeRegistry}var f=r.split('-')[0];if(n||f===r)break;r=f}return n||a(s.localeRegistry.en.format),i}function L(t,e){return t.decimal=e.charAt(0),t.thousands=e.charAt(1),{numberFormat:function(e){try{e=a(t).format(u.adjustFormat(e))}catch(r){return u.warnBadFormat(e),u.noFormat}return e},timeFormat:i(t).utcFormat}}function C(t,e){var r,n=[];e.meta&&(r=e._meta={meta:e.meta,layout:{meta:e.meta}});for(var i=0;i<t.length;i++){var a=t[i];a.meta?n[a.index]=a._meta={meta:a.meta}:e.meta&&(a._meta={meta:e.meta}),e.meta&&(a._meta.layout={meta:e.meta})}n.length&&(r||(r=e._meta={}),r.data=n)}function P(t,e){var r={_fullLayout:e},n="x"===t._id.charAt(0),i=t._mainAxis._anchorAxis,a='',o='',s='';if(i&&(s=i._mainAxis._id,a=n?t._id+s:s+t._id),!a||!e._plots[a]){a='';for(var l=t._counterAxes,c=0;c<l.length;c++){var u=l[c],f=n?t._id+u:u+t._id;o||(o=f);var h=p.getFromId(r,u);if(s&&h.overlaying===s){a=f;break}}}return a||o}function I(t){var e=t.transforms;if(Array.isArray(e)&&e.length)for(var r=0;r<e.length;r++){var n=e[r],i=n._module||_[n.type];if(i&&i.makesData)return!0}return!1}function z(t,e,r,n){for(var i=t.transforms,a=[t],o=0;o<i.length;o++){var s=i[o],l=_[s.type];l&&l.transform&&(a=l.transform(a,{transform:s,fullTrace:t,fullData:e,layout:r,fullLayout:n,transformIndex:o}))}return a}function O(t){return"string"===typeof t&&"px"===t.substr(t.length-2)&&parseFloat(t)}function D(t){var e=t.margin;if(!t._size){var r=t._size={l:Math.round(e.l),r:Math.round(e.r),t:Math.round(e.t),b:Math.round(e.b),p:Math.round(e.pad)};r.w=Math.round(t.width)-r.l-r.r,r.h=Math.round(t.height)-r.t-r.b}t._pushmargin||(t._pushmargin={}),t._pushmarginIds||(t._pushmarginIds={})}b.supplyDefaults=function(t,e){var r=e&&e.skipUpdateCalc,n=t._fullLayout||{};if(n._skipDefaults)delete n._skipDefaults;else{var i,a=t._fullLayout={},o=t.layout||{},l=t._fullData||[],c=t._fullData=[],f=t.data||[],h=t.calcdata||[],p=t._context||{};t._transitionData||b.createTransitionData(t),a._dfltTitle={plot:x(t,'Click to enter Plot title'),x:x(t,'Click to enter X axis title'),y:x(t,'Click to enter Y axis title'),colorbar:x(t,'Click to enter Colorscale title'),annotation:x(t,'new text')},a._traceWord=x(t,'trace');var m=E(t,k);if(a._mapboxAccessToken=p.mapboxAccessToken,n._initialAutoSizeIsDone){var g=n.width,v=n.height;b.supplyLayoutGlobalDefaults(o,a,m),o.width||(a.width=g),o.height||(a.height=v),b.sanitizeMargins(a)}else{b.supplyLayoutGlobalDefaults(o,a,m);var _=!o.width||!o.height,w=a.autosize,T=p.autosizable;_&&(w||T)?b.plotAutoSize(t,o,a):_&&b.sanitizeMargins(a),!w&&_&&(o.width=a.width,o.height=a.height)}a._d3locale=L(m,a.separators),a._extraFormat=E(t,M),a._initialAutoSizeIsDone=!0,a._dataLength=f.length,a._modules=[],a._visibleModules=[],a._basePlotModules=[];var P=a._subplots=S(),I=a._splomAxes={x:{},y:{}},z=a._splomSubplots={};a._splomGridDflt={},a._scatterStackOpts={},a._firstScatter={},a._alignmentOpts={},a._colorAxes={},a._requestRangeslider={},a._traceUids=A(l,f),a._globalTransforms=(t._context||{}).globalTransforms,b.supplyDataDefaults(f,c,o,a);var O=Object.keys(I.x),R=Object.keys(I.y);if(O.length>1&&R.length>1){for(s.getComponentMethod('grid','sizeDefaults')(o,a),i=0;i<O.length;i++)u.pushUnique(P.xaxis,O[i]);for(i=0;i<R.length;i++)u.pushUnique(P.yaxis,R[i]);for(var F in z)u.pushUnique(P.cartesian,F)}if(a._has=b._hasPlotType.bind(a),l.length===c.length)for(i=0;i<c.length;i++)y(c[i],l[i]);b.supplyLayoutModuleDefaults(o,a,c,t._transitionData);var B=a._visibleModules,N=[];for(i=0;i<B.length;i++){var j=B[i].crossTraceDefaults;j&&u.pushUnique(N,j)}for(i=0;i<N.length;i++)N[i](c,a);a._hasOnlyLargeSploms=1===a._basePlotModules.length&&"splom"===a._basePlotModules[0].name&&O.length>15&&R.length>15&&0===a.shapes.length&&0===a.images.length,b.linkSubplots(c,a,l,n),b.cleanPlot(c,a,l,n);var U=!(!n._has||!n._has('gl2d')),V=!(!a._has||!a._has('gl2d')),H=!(!n._has||!n._has('cartesian'))||U,q=!(!a._has||!a._has('cartesian'))||V;H&&!q?n._bgLayer.remove():q&&!H&&(a._shouldCreateBgLayer=!0),n._zoomlayer&&!t._dragging&&d({_fullLayout:n}),C(c,a),y(a,n),s.getComponentMethod('colorscale','crossTraceDefaults')(c,a),a._preGUI||(a._preGUI={}),a._tracePreGUI||(a._tracePreGUI={});var G,Y=a._tracePreGUI,W={};for(G in Y)W[G]='old';for(i=0;i<c.length;i++)W[G=c[i]._fullInput.uid]||(Y[G]={}),W[G]='new';for(G in W)"old"===W[G]&&delete Y[G];D(a),s.getComponentMethod('rangeslider','makeData')(a),r||h.length!==c.length||b.supplyDefaultsUpdateCalc(h,c)}},b.supplyDefaultsUpdateCalc=function(t,e){for(var r=0;r<e.length;r++){var n=e[r],i=(t[r]||[])[0];if(i&&i.trace){var a=i.trace;if(a._hasCalcTransform){var o,s,l,c=a._arrayAttrs;for(o=0;o<c.length;o++)s=c[o],l=u.nestedProperty(a,s).get().slice(),u.nestedProperty(n,s).set(l)}i.trace=n}}},b.createTransitionData=function(t)[t._transitionData||(t._transitionData={]),t._transitionData._frames||(t._transitionData._frames=[]),t._transitionData._frameHash||(t._transitionData._frameHash={}),t._transitionData._counter||(t._transitionData._counter=0),t._transitionData._interruptCallbacks||(t._transitionData._interruptCallbacks=[])},b._hasPlotType=function(t){var e,r=this._basePlotModules||[];for(e=0;e<r.length;e++)if(r[e].name===t)return!0;var n=this._modules||[];for(e=0;e<n.length;e++){var i=n[e].name;if(i===t)return!0;var a=s.modules[i];if(a&&a.categories[t])return!0}return!1},b.cleanPlot=function(t,e,r,n){var i,a,o=n._basePlotModules||[];for(i=0;i<o.length;i++){var s=o[i];s.clean&&s.clean(t,e,r,n)}var l=n._has&&n._has('gl'),c=e._has&&e._has('gl');l&&!c&&void 0!==n._glcontainer&&(n._glcontainer.selectAll('.gl-canvas').remove(),n._glcontainer.selectAll('.no-webgl').remove(),n._glcanvas=null);var u=!!n._infolayer;t:for(i=0;i<r.length;i++){var f=r[i].uid;for(a=0;a<t.length;a++)if(f===t[a].uid)continue t;u&&n._infolayer.select(".cb"+f).remove()}},b.linkSubplots=function(t,e,r,n){var i,a,o=n._plots||{},l=e._plots={},c=e._subplots,f={_fullData:t,_fullLayout:e},h=c.cartesian.concat(c.gl2d||[]);for(i=0;i<h.length;i++){var d,m=h[i],g=o[m],v=p.getFromId(f,m,'x'),y=p.getFromId(f,m,'y');for(g?d=l[m]=g:(d=l[m]={}).id=m,v._counterAxes.push(y._id),y._counterAxes.push(v._id),v._subplotsWith.push(m),y._subplotsWith.push(m),d.xaxis=v,d.yaxis=y,d._hasClipOnAxisFalse=!1,a=0;a<t.length;a++){var x=t[a];if(x.xaxis===d.xaxis._id&&x.yaxis===d.yaxis._id&&!1===x.cliponaxis){d._hasClipOnAxisFalse=!0;break}}}var b,_=p.list(f,null,!0);for(i=0;i<_.length;i++){var w=null;(b=_[i]).overlaying&&(w=p.getFromId(f,b.overlaying))&&w.overlaying&&(b.overlaying=!1,w=null),b._mainAxis=w||b,w&&(b.domain=w.domain.slice()),b._anchorAxis="free"===b.anchor?null:p.getFromId(f,b.anchor)}for(i=0;i<_.length;i++)if((b=_[i])._counterAxes.sort(p.idSort),b._subplotsWith.sort(u.subplotSort),b._mainSubplot=P(b,e),b._counterAxes.length&&(b.spikemode&&-1!==b.spikemode.indexOf('across')||b.automargin&&b.mirror&&"free"!==b.anchor||s.getComponentMethod('rangeslider','isVisible')(b))){var T=1,k=0;for(a=0;a<b._counterAxes.length;a++){var M=p.getFromId(f,b._counterAxes[a]);T=Math.min(T,M.domain[0]),k=Math.max(k,M.domain[1])}T<k&&(b._counterDomainMin=T,b._counterDomainMax=k)}},b.clearExpandedTraceDefaultColors=function(t){var e,r,n;function i(t,n,i,a){r[a]=n,r.length=a+1,"color"===t.valType&&void 0===t.dflt&&e.push(r.join('.'))}for(r=[],(e=t._module._colorAttrs)||(t._module._colorAttrs=e=[],l.crawl(t._module.attributes,i)),n=0;n<e.length;n++)u.nestedProperty(t,"_input."+e[n]).get()||u.nestedProperty(t,e[n]).set(null)},b.supplyDataDefaults=function(t,e,r,n){var i,a,o,l=n._modules,f=n._visibleModules,h=n._basePlotModules,p=0,d=0;function m(t){e.push(t);var r=t._module;r&&(u.pushUnique(l,r),!0===t.visible&&u.pushUnique(f,r),u.pushUnique(h,t._module.basePlotModule),p++,!1!==t._input.visible&&d++)}n._transformModules=[];var g={},v=[],x=(r.template||{}).data||{},_=c.traceTemplater(x);for(i=0;i<t.length;i++){if(o=t[i],(a=_.newTrace(o)).uid=n._traceUids[i],b.supplyTraceDefaults(o,a,d,n,i),a.index=i,a._input=o,a._expandedIndex=p,a.transforms&&a.transforms.length)for(var w=!1!==o.visible&&!1===a.visible,T=z(a,e,r,n),k=0;k<T.length;k++){var M=T[k],A={_template:a._template,type:a.type,uid:a.uid+k};w&&!1===M.visible&&delete M.visible,b.supplyTraceDefaults(M,A,p,n,i),y(A,M),A.index=i,A._input=o,A._fullInput=a,A._expandedIndex=p,A._expandedInput=M,m(A)}else a._fullInput=a,a._expandedInput=a,m(a);s.traceIs(a,'carpetAxis')&&(g[a.carpet]=a),s.traceIs(a,'carpetDependent')&&v.push(i)}for(i=0;i<v.length;i++)if((a=e[v[i]]).visible){var S=g[a.carpet];a._carpet=S,S&&S.visible?(a.xaxis=S.xaxis,a.yaxis=S.yaxis):a.visible=!1}},b.supplyAnimationDefaults=function(t){var e;t=t||{};var r={};function n(e,n){return u.coerce(t||{},r,m,e,n)}if(n('mode'),n('direction'),n('fromcurrent'),Array.isArray(t.frame))for(r.frame=[],e=0;e<t.frame.length;e++)r.frame[e]=b.supplyAnimationFrameDefaults(t.frame[e]||{});else r.frame=b.supplyAnimationFrameDefaults(t.frame||{});if(Array.isArray(t.transition))for(r.transition=[],e=0;e<t.transition.length;e++)r.transition[e]=b.supplyAnimationTransitionDefaults(t.transition[e]||{});else r.transition=b.supplyAnimationTransitionDefaults(t.transition||{});return r},b.supplyAnimationFrameDefaults=function(t)[var e={];function r(r,n){return u.coerce(t||{},e,m.frame,r,n)}return r('duration'),r('redraw'),e},b.supplyAnimationTransitionDefaults=function(t)[var e={];function r(r,n){return u.coerce(t||{},e,m.transition,r,n)}return r('duration'),r('easing'),e},b.supplyFrameDefaults=function(t)[var e={];function r(r,n){return u.coerce(t,e,g,r,n)}return r('group'),r('name'),r('traces'),r('baseframe'),r('data'),r('layout'),e},b.supplyTraceDefaults=function(t,e,r,n,i){var a,o=n.colorway||f.defaults,l=o[r%o.length];function c(r,n){return u.coerce(t,e,b.attributes,r,n)}var h=c('visible');c('type'),c('name',n._traceWord+" "+i),c('uirevision',n.uirevision);var p=b.getModule(e);if(e._module=p,p){var d=p.basePlotModule,m=d.attr,g=d.attributes;if(m&&g){var v=n._subplots,y='';if(h||"gl2d"!==d.name){if(Array.isArray(m))for(a=0;a<m.length;a++){var x=m[a],_=u.coerce(t,e,g,x);v[x]&&u.pushUnique(v[x],_),y+=_}else y=u.coerce(t,e,g,m);v[d.name]&&u.pushUnique(v[d.name],y)}}}return h&&(c('customdata'),c('ids'),c('meta'),s.traceIs(e,'showLegend')?(u.coerce(t,e,p.attributes.showlegend?p.attributes:b.attributes,'showlegend'),c('legendgroup'),c('legendgrouptitle.text')&&u.coerceFont(c,'legendgrouptitle.font',u.extendFlat({},n.font,{size:Math.round(1.1*n.font.size)})),c('legendrank'),e._dfltShowLegend=!0):e._dfltShowLegend=!1,p&&p.supplyDefaults(t,e,l,n),s.traceIs(e,'noOpacity')||c('opacity'),s.traceIs(e,'notLegendIsolatable')&&(e.visible=!!e.visible),s.traceIs(e,'noHover')||(e.hovertemplate||u.coerceHoverinfo(t,e,n),"parcats"!==e.type&&s.getComponentMethod('fx','supplyDefaults')(t,e,l,n)),p&&p.selectPoints&&c('selectedpoints'),b.supplyTransformDefaults(t,e,n)),e},b.hasMakesDataTransform=I,b.supplyTransformDefaults=function(t,e,r){if(e._length||I(t)){var n=r._globalTransforms||[],i=r._transformModules||[];if(Array.isArray(t.transforms)||0!==n.length)for(var a=t.transforms||[],o=n.concat(a),s=e.transforms=[],l=0;l<o.length;l++){var c,f=o[l],h=f.type,p=_[h],d=!(f._module&&f._module===p),m=p&&"function"===typeof p.transform;p||u.warn('Unrecognized transform type '+h+'.'),p&&p.supplyDefaults&&(d||m)?((c=p.supplyDefaults(f,e,r,t)).type=h,c._module=p,u.pushUnique(i,p)):c=u.extendFlat({},f),s.push(c)}}},b.supplyLayoutGlobalDefaults=function(t,e,r){function n(r,n){return u.coerce(t,e,b.layoutAttributes,r,n)}var i=t.template;u.isPlainObject(i)&&(e.template=i,e._template=i.layout,e._dataTemplate=i.data),n('autotypenumbers');var a=u.coerceFont(n,'font');n('title.text',e._dfltTitle.plot),u.coerceFont(n,'title.font',{family:a.family,size:Math.round(1.4*a.size),color:a.color}),n('title.xref'),n('title.yref'),n('title.x'),n('title.y'),n('title.xanchor'),n('title.yanchor'),n('title.pad.t'),n('title.pad.r'),n('title.pad.b'),n('title.pad.l'),n('uniformtext.mode')&&n('uniformtext.minsize'),n('autosize',!(t.width&&t.height)),n('width'),n('height'),n('margin.l'),n('margin.r'),n('margin.t'),n('margin.b'),n('margin.pad'),n('margin.autoexpand'),t.width&&t.height&&b.sanitizeMargins(e),s.getComponentMethod('grid','sizeDefaults')(t,e),n('paper_bgcolor'),n('separators',r.decimal+r.thousands),n('hidesources'),n('colorway'),n('datarevision');var o=n('uirevision');n('editrevision',o),n('selectionrevision',o),s.getComponentMethod('modebar','supplyLayoutDefaults')(t,e),s.getComponentMethod('shapes','supplyDrawNewShapeDefaults')(t,e,n),n('meta'),u.isPlainObject(t.transition)&&(n('transition.duration'),n('transition.easing'),n('transition.ordering')),s.getComponentMethod('calendars','handleDefaults')(t,e,'calendar'),s.getComponentMethod('fx','supplyLayoutGlobalDefaults')(t,e,n)},b.plotAutoSize=function(t,e,r){var n,i,a=t._context||{},s=a.frameMargins,l=u.isPlotDiv(t);if(l&&t.emit('plotly_autosize'),a.fillFrame)n=window.innerWidth,i=window.innerHeight,document.body.style.overflow='hidden';else{var c=l?window.getComputedStyle(t):{};if(n=O(c.width)||O(c.maxWidth)||r.width,i=O(c.height)||O(c.maxHeight)||r.height,o(s)&&s>0){var f=1-2*s;n=Math.round(f*n),i=Math.round(f*i)}}var h=b.layoutAttributes.width.min,p=b.layoutAttributes.height.min;n<h&&(n=h),i<p&&(i=p);var d=!e.width&&Math.abs(r.width-n)>1,m=!e.height&&Math.abs(r.height-i)>1;(m||d)&&(d&&(r.width=n),m&&(r.height=i)),t._initialAutoSize||(t._initialAutoSize={width:n,height:i}),b.sanitizeMargins(r)},b.supplyLayoutModuleDefaults=function(t,e,r,n){var i,a,o,l=s.componentsRegistry,c=e._basePlotModules,f=s.subplotsRegistry.cartesian;for(i in l)(o=l[i]).includeBasePlot&&o.includeBasePlot(t,e);for(var h in c.length||c.push(f),e._has('cartesian')&&(s.getComponentMethod('grid','contentDefaults')(t,e),f.finalizeSubplots(t,e)),e._subplots)e._subplots[h].sort(u.subplotSort);for(a=0;a<c.length;a++)(o=c[a]).supplyLayoutDefaults&&o.supplyLayoutDefaults(t,e,r);var p=e._modules;for(a=0;a<p.length;a++)(o=p[a]).supplyLayoutDefaults&&o.supplyLayoutDefaults(t,e,r);var d=e._transformModules;for(a=0;a<d.length;a++)(o=d[a]).supplyLayoutDefaults&&o.supplyLayoutDefaults(t,e,r,n);for(i in l)(o=l[i]).supplyLayoutDefaults&&o.supplyLayoutDefaults(t,e,r)},b.purge=function(t)[var e=t._fullLayout||{];void 0!==e._glcontainer&&(e._glcontainer.selectAll('.gl-canvas').remove(),e._glcontainer.remove(),e._glcanvas=null),e._modeBar&&e._modeBar.destroy(),t._transitionData&&(t._transitionData._interruptCallbacks&&(t._transitionData._interruptCallbacks.length=0),t._transitionData._animationRaf&&window.cancelAnimationFrame(t._transitionData._animationRaf)),u.clearThrottle(),u.clearResponsive(t),delete t.data,delete t.layout,delete t._fullData,delete t._fullLayout,delete t.calcdata,delete t.empty,delete t.fid,delete t.undoqueue,delete t.undonum,delete t.autoplay,delete t.changed,delete t._promises,delete t._redrawTimer,delete t._hmlumcount,delete t._hmpixcount,delete t._transitionData,delete t._transitioning,delete t._initialAutoSize,delete t._transitioningWithDuration,delete t._dragging,delete t._dragged,delete t._dragdata,delete t._hoverdata,delete t._snapshotInProgress,delete t._editing,delete t._mouseDownTime,delete t._legendMouseDownTime,t.removeAllListeners&&t.removeAllListeners()},b.style=function(t){var e,r=t._fullLayout._visibleModules,n=[];for(e=0;e<r.length;e++){var i=r[e];i.style&&u.pushUnique(n,i.style)}for(e=0;e<n.length;e++)n[e](t)},b.sanitizeMargins=function(t){if(t&&t.margin){var e,r=t.width,n=t.height,i=t.margin,a=r-(i.l+i.r),o=n-(i.t+i.b);a<0&&(e=(r-1)/(i.l+i.r),i.l=Math.floor(e*i.l),i.r=Math.floor(e*i.r)),o<0&&(e=(n-1)/(i.t+i.b),i.t=Math.floor(e*i.t),i.b=Math.floor(e*i.b))}},b.clearAutoMarginIds=function(t)[t._fullLayout._pushmarginIds={]},b.allowAutoMargin=function(t,e)[t._fullLayout._pushmarginIds[e]=1];var R=2,F=2,B=64,N=64;function j(t){var e=p.list(t,'',!0);["_adjustTickLabelsOverflow","_hideCounterAxisInsideTickLabels"].forEach((function(t){for(var r=0;r<e.length;r++){var n=e[r][t];n&&n()}}))}b.autoMargin=function(t,e,r){var n=t._fullLayout,i=n.width,a=n.height,o=n.margin,s=u.constrain(i-o.l-o.r,R,B),l=u.constrain(a-o.t-o.b,F,N),c=Math.max(0,i-s),f=Math.max(0,a-l),h=n._pushmargin,p=n._pushmarginIds;if(!1!==o.autoexpand){if(r){var d=r.pad;if(void 0===d&&(d=Math.min(12,o.l,o.r,o.t,o.b)),c){var m=(r.l+r.r)/c;m>1&&(r.l/=m,r.r/=m)}if(f){var g=(r.t+r.b)/f;g>1&&(r.t/=g,r.b/=g)}var v=void 0!==r.xl?r.xl:r.x,y=void 0!==r.xr?r.xr:r.x,x=void 0!==r.yt?r.yt:r.y,_=void 0!==r.yb?r.yb:r.y;h[e]={l:{val:v,size:r.l+d},r:{val:y,size:r.r+d},b:{val:_,size:r.b+d},t:{val:x,size:r.t+d}},p[e]=1}else delete h[e],delete p[e];if(!n._replotting)return b.doAutoMargin(t)}},b.doAutoMargin=function(t){var e=t._fullLayout,r=e.width,n=e.height;e._size||(e._size={}),D(e);var i=e._size,a=e.margin,l=u.extendFlat({},i),c=a.l,f=a.r,h=a.t,p=a.b,d=e._pushmargin,m=e._pushmarginIds;if(!1!==e.margin.autoexpand){for(var g in d)m[g]||delete d[g];for(var v in d.base={l:{val:0,size:c},r:{val:1,size:f},t:{val:1,size:h},b:{val:0,size:p}},d)[var y=d[v].l||{],x=d[v].b||{},_=y.val,w=y.size,T=x.val,k=x.size;for(var M in d){if(o(w)&&d[M].r){var A=d[M].r.val,S=d[M].r.size;if(A>_){var E=(w*A+(S-r)*_)/(A-_),L=(S*(1-_)+(w-r)*(1-A))/(A-_);E+L>c+f&&(c=E,f=L)}}if(o(k)&&d[M].t){var C=d[M].t.val,P=d[M].t.size;if(C>T){var I=(k*C+(P-n)*T)/(C-T),z=(P*(1-T)+(k-n)*(1-C))/(C-T);I+z>p+h&&(p=I,h=z)}}}}}var O=u.constrain(r-a.l-a.r,R,B),U=u.constrain(n-a.t-a.b,F,N),V=Math.max(0,r-O),H=Math.max(0,n-U);if(V){var q=(c+f)/V;q>1&&(c/=q,f/=q)}if(H){var G=(p+h)/H;G>1&&(p/=G,h/=G)}if(i.l=Math.round(c),i.r=Math.round(f),i.t=Math.round(h),i.b=Math.round(p),i.p=Math.round(a.pad),i.w=Math.round(r)-i.l-i.r,i.h=Math.round(n)-i.t-i.b,!e._replotting&&b.didMarginChange(l,i)){"_redrawFromAutoMarginCount"in e?e._redrawFromAutoMarginCount++:e._redrawFromAutoMarginCount=1;var Y=3*(1+Object.keys(m).length);if(e._redrawFromAutoMarginCount<Y)return s.call('_doPlot',t);e._size=l,u.warn('Too many auto-margin redraws.')}j(t)};var U=["l",'r','t','b','p','w',"h"];function V(t,e,r){var n=!1;function i(t){var e=Promise.resolve();if(!t)return e;for(;t.length;)e=e.then(t.shift());return e}function a(t){if(t)for(;t.length;)t.shift()}function o(){return t.emit('plotly_transitioning',[]),new Promise((function(i){t._transitioning=!0,e.duration>0&&(t._transitioningWithDuration=!0),t._transitionData._interruptCallbacks.push((function(){n=!0})),r.redraw&&t._transitionData._interruptCallbacks.push((function(){return s.call('redraw',t)})),t._transitionData._interruptCallbacks.push((function(){t.emit('plotly_transitioninterrupted',[])}));var a=0,o=0;function c(){return a++,function(){o++,n||o!==a||l(i)}}r.runFn(c),setTimeout(c())}))}function l(e){if(t._transitionData)return a(t._transitionData._interruptCallbacks),Promise.resolve().then((function(){if(r.redraw)return s.call('redraw',t)})).then((function(){t._transitioning=!1,t._transitioningWithDuration=!1,t.emit('plotly_transitioned',[])})).then(e)}function c(){if(t._transitionData)return t._transitioning=!1,i(t._transitionData._interruptCallbacks)}var f=[b.previousPromises,c,r.prepareFn,b.rehover,o],h=u.syncOrAsync(f,t);return h&&h.then||(h=Promise.resolve()),h.then((function(){return t}))}b.didMarginChange=function(t,e){for(var r=0;r<U.length;r++){var n=U[r],i=t[n],a=e[n];if(!o(i)||Math.abs(a-i)>1)return!0}return!1},b.graphJson=function(t,e,r,n,i,a){(i&&e&&!t._fullData||i&&!e&&!t._fullLayout)&&b.supplyDefaults(t);var o=i?t._fullData:t.data,s=i?t._fullLayout:t.layout,l=(t._transitionData||{})._frames;function c(t,e){if("function"===typeof t)return e?"_function_":null;if(u.isPlainObject(t)){var n,i={};return Object.keys(t).sort().forEach((function(a){if(-1===["_","["].indexOf(a.charAt(0)))if("function"!==typeof t[a]){if("keepdata"===r){if("src"===a.substr(a.length-3))return}else if("keepstream"===r){if("string"===typeof(n=t[a+"src"])&&n.indexOf(':')>0&&!u.isPlainObject(t.stream))return}else if("keepall"!==r&&"string"===typeof(n=t[a+"src"])&&n.indexOf(':')>0)return;i[a]=c(t[a],e)}else e&&(i[a]='_function')})),i}return Array.isArray(t)?t.map((function(t){return c(t,e)})):u.isTypedArray(t)?u.simpleMap(t,u.identity):u.isJSDate(t)?u.ms2DateTimeLocal(+t):t}var f={data:(o||[]).map((function(t){var r=c(t);return e&&delete r.fit,r}))};if(!e&&(f.layout=c(s),i)){var h=s._size;f.layout.computed={margin:{b:h.b,l:h.l,r:h.r,t:h.t}}}return l&&(f.frames=c(l)),a&&(f.config=c(t._context,!0)),"object"===n?f:JSON.stringify(f)},b.modifyFrames=function(t,e){var r,n,i,a=t._transitionData._frames,o=t._transitionData._frameHash;for(r=0;r<e.length;r++)switch((n=e[r]).type){case"replace":i=n.value;var s=(a[n.index]||{}).name,l=i.name;a[n.index]=o[l]=i,l!==s&&(delete o[s],o[l]=i);break;case"insert":o[(i=n.value).name]=i,a.splice(n.index,0,i);break;case"delete":delete o[(i=a[n.index]).name],a.splice(n.index,1)}return Promise.resolve()},b.computeFrame=function(t,e){var r,n,i,a,o=t._transitionData._frameHash;if(!e)throw new Error('computeFrame must be given a string frame name');var s=o[e.toString()];if(!s)return!1;for(var l=[s],c=[s.name];s.baseframe&&(s=o[s.baseframe.toString()])&&-1===c.indexOf(s.name);)l.push(s),c.push(s.name);for(var u={};s=l.pop();)if(s.layout&&(u.layout=b.extendLayout(u.layout,s.layout)),s.data){if(u.data||(u.data=[]),!(n=s.traces))for(n=[],r=0;r<s.data.length;r++)n[r]=r;for(u.traces||(u.traces=[]),r=0;r<s.data.length;r++)void 0!==(i=n[r])&&null!==i&&(-1===(a=u.traces.indexOf(i))&&(a=u.data.length,u.traces[a]=i),u.data[a]=b.extendTrace(u.data[a],s.data[r]))}return u},b.recomputeFrameHash=function(t)[for(var e=t._transitionData._frameHash={],r=t._transitionData._frames,n=0;n<r.length;n++){var i=r[n];i&&i.name&&(e[i.name]=i)}},b.extendObjectWithContainers=function(t,e,r){var n,i,a,o,s,l,c,f=u.extendDeepNoArrays({},e||{}),h=u.expandObjectPaths(f),p={};if(r&&r.length)for(a=0;a<r.length;a++)void 0===(i=(n=u.nestedProperty(h,r[a])).get())?u.nestedProperty(p,r[a]).set(null):(n.set(null),u.nestedProperty(p,r[a]).set(i));if(t=u.extendDeepNoArrays(t||{},h),r&&r.length)for(a=0;a<r.length;a++)if(l=u.nestedProperty(p,r[a]).get()){for(c=(s=u.nestedProperty(t,r[a])).get(),Array.isArray(c)||(c=[],s.set(c)),o=0;o<l.length;o++){var d=l[o];c[o]=null===d?null:b.extendObjectWithContainers(c[o],d)}s.set(c)}return t},b.dataArrayContainers=["transforms","dimensions"],b.layoutArrayContainers=s.layoutArrayContainers,b.extendTrace=function(t,e){return b.extendObjectWithContainers(t,e,b.dataArrayContainers)},b.extendLayout=function(t,e){return b.extendObjectWithContainers(t,e,b.layoutArrayContainers)},b.transition=function(t,e,r,n,i,a){var o={redraw:i.redraw},s={},l=[];return o.prepareFn=function(){for(var i=Array.isArray(e)?e.length:0,a=n.slice(0,i),o=0;o<a.length;o++){var c=a[o],f=t._fullData[c]._module;if(f){if(f.animatable){var h=f.basePlotModule.name;s[h]||(s[h]=[]),s[h].push(c)}t.data[a[o]]=b.extendTrace(t.data[a[o]],e[o])}}var p=u.expandObjectPaths(u.extendDeepNoArrays({},r)),d=/^[xy]axis[0-9]*$/;for(var m in p)d.test(m)&&delete p[m].range;b.extendLayout(t.layout,p),delete t.calcdata,b.supplyDefaults(t),b.doCalcdata(t);var g=u.expandObjectPaths(r);if(g){var v=t._fullLayout._plots;for(var y in v){var x=v[y],_=x.xaxis,w=x.yaxis,T=_.range.slice(),k=w.range.slice(),M=null,A=null,S=null,E=null;Array.isArray(g[_._name+".range"])?M=g[_._name+".range"].slice():Array.isArray((g[_._name]||{}).range)&&(M=g[_._name].range.slice()),Array.isArray(g[w._name+".range"])?A=g[w._name+".range"].slice():Array.isArray((g[w._name]||{}).range)&&(A=g[w._name].range.slice()),T&&M&&(_.r2l(T[0])!==_.r2l(M[0])||_.r2l(T[1])!==_.r2l(M[1]))&&(S={xr0:T,xr1:M}),k&&A&&(w.r2l(k[0])!==w.r2l(A[0])||w.r2l(k[1])!==w.r2l(A[1]))&&(E={yr0:k,yr1:A}),(S||E)&&l.push(u.extendFlat({plotinfo:x},S,E))}}return Promise.resolve()},o.runFn=function(e){var n,i,o=t._fullLayout._basePlotModules,c=l.length;if(r)for(i=0;i<o.length;i++)o[i].transitionAxes&&o[i].transitionAxes(t,l,a,e);for(var f in c?((n=u.extendFlat({},a)).duration=0,delete s.cartesian):n=a,s){var h=s[f];t._fullData[h[0]]._module.basePlotModule.plot(t,h,n,e)}},V(t,a,o)},b.transitionFromReact=function(t,e,r,n){var i=t._fullLayout,a=i.transition,o={},s=[];return o.prepareFn=function(){var t=i._plots;for(var a in o.redraw=!1,"some"===e.anim&&(o.redraw=!0),"some"===r.anim&&(o.redraw=!0),t){var l=t[a],c=l.xaxis,f=l.yaxis,h=n[c._name].range.slice(),p=n[f._name].range.slice(),d=c.range.slice(),m=f.range.slice();c.setScale(),f.setScale();var g=null,v=null;c.r2l(h[0])===c.r2l(d[0])&&c.r2l(h[1])===c.r2l(d[1])||(g={xr0:h,xr1:d}),f.r2l(p[0])===f.r2l(m[0])&&f.r2l(p[1])===f.r2l(m[1])||(v={yr0:p,yr1:m}),(g||v)&&s.push(u.extendFlat({plotinfo:l},g,v))}return Promise.resolve()},o.runFn=function(r){for(var n,i,o,l=t._fullData,c=t._fullLayout._basePlotModules,f=[],h=0;h<l.length;h++)f.push(h);function p(){if(t._fullLayout)for(var e=0;e<c.length;e++)c[e].transitionAxes&&c[e].transitionAxes(t,s,n,r)}function d(){if(t._fullLayout)for(var e=0;e<c.length;e++)c[e].plot(t,o,i,r)}s.length&&e.anim?"traces first"===a.ordering?(n=u.extendFlat({},a,{duration:0}),o=f,i=a,setTimeout(p,a.duration),d()):(n=a,o=null,i=u.extendFlat({},a,{duration:0}),setTimeout(d,n.duration),p()):s.length?(n=a,p()):e.anim&&(o=f,i=a,d())},V(t,a,o)},b.doCalcdata=function(t,e){var r,n,i,a,o=p.list(t),c=t._fullData,u=t._fullLayout,f=new Array(c.length),d=(t.calcdata||[]).slice();for(t.calcdata=f,u._numBoxes=0,u._numViolins=0,u._violinScaleGroupStats={},t._hmpixcount=0,t._hmlumcount=0,u._piecolormap={},u._sunburstcolormap={},u._treemapcolormap={},u._iciclecolormap={},u._funnelareacolormap={},i=0;i<c.length;i++)Array.isArray(e)&&-1===e.indexOf(i)&&(f[i]=d[i]);for(i=0;i<c.length;i++)(r=c[i])._arrayAttrs=l.findArrayAttributes(r),r._extremes={};var m=u._subplots.polar||[];for(i=0;i<m.length;i++)o.push(u[m[i]].radialaxis,u[m[i]].angularaxis);for(var g in u._colorAxes){var v=u[g];!1!==v.cauto&&(delete v.cmin,delete v.cmax)}var y=!1;function x(e){if(r=c[e],n=r._module,!0===r.visible&&r.transforms){if(n&&n.calc){var i=n.calc(t,r);i[0]&&i[0].t&&i[0].t._scene&&delete i[0].t._scene.dirty}for(a=0;a<r.transforms.length;a++){var o=r.transforms[a];(n=_[o.type])&&n.calcTransform&&(r._hasCalcTransform=!0,y=!0,n.calcTransform(t,r,o))}}}function b(e,i){if(r=c[e],!!(n=r._module).isContainer===i){var o=[];if(!0===r.visible&&0!==r._length){delete r._indexToPoints;var s=r.transforms||[];for(a=s.length-1;a>=0;a--)if(s[a].enabled){r._indexToPoints=s[a]._indexToPoints;break}n&&n.calc&&(o=n.calc(t,r))}Array.isArray(o)&&o[0]||(o=[x:h,y:h]),o[0].t||(o[0].t={}),o[0].trace=r,f[e]=o}}for(G(o,c,u),i=0;i<c.length;i++)b(i,!0);for(i=0;i<c.length;i++)x(i);for(y&&G(o,c,u),i=0;i<c.length;i++)b(i,!0);for(i=0;i<c.length;i++)b(i,!1);Y(t);var w=q(o,t);if(w.length){for(u._numBoxes=0,u._numViolins=0,i=0;i<w.length;i++)b(w[i],!0);for(i=0;i<w.length;i++)b(w[i],!1);Y(t)}s.getComponentMethod('fx','calc')(t),s.getComponentMethod('errorbars','calc')(t)};var H=/(total|sum|min|max|mean|median) (ascending|descending)/;function q(t,e){var r,n,i,a,o,l=[];function c(t,r,n){var i=r._id.charAt(0);if("histogram2dcontour"===t){var a=r._counterAxes[0],o=p.getFromId(e,a),s="x"===i||"x"===a&&"category"===o.type,l="y"===i||"y"===a&&"category"===o.type;return function(t,e){return 0===t||0===e||s&&t===n[e].length-1||l&&e===n.length-1?-1:("y"===i?e:t)-1}}return function(t,e){return"y"===i?e:t}}var f={min:function(t){return u.aggNums(Math.min,null,t)},max:function(t){return u.aggNums(Math.max,null,t)},sum:function(t){return u.aggNums((function(t,e){return t+e}),null,t)},total:function(t){return u.aggNums((function(t,e){return t+e}),null,t)},mean:function(t){return u.mean(t)},median:function(t){return u.median(t)}};for(r=0;r<t.length;r++){var h=t[r];if("category"===h.type){var d=h.categoryorder.match(H);if(d){var m=d[1],g=d[2],v=h._id.charAt(0),y="x"===v,x=[];for(n=0;n<h._categories.length;n++)x.push([h._categories[n],[]]);for(n=0;n<h._traceIndices.length;n++){var b=h._traceIndices[n],_=e._fullData[b];if(!0===_.visible){var w=_.type;s.traceIs(_,'histogram')&&(delete _._xautoBinFinished,delete _._yautoBinFinished);var T="splom"===w,k="scattergl"===w,M=e.calcdata[b];for(i=0;i<M.length;i++){var A,S,E=M[i];if(T){var L=_._axesDim[h._id];if(!y){var C=_._diag[L][0];C&&(h=e._fullLayout[p.id2name(C)])}var P=E.trace.dimensions[L].values;for(a=0;a<P.length;a++)for(A=h._categoriesMap[P[a]],o=0;o<E.trace.dimensions.length;o++)if(o!==L){var I=E.trace.dimensions[o];x[A][1].push(I.values[a])}}else if(k){for(a=0;a<E.t.x.length;a++)y?(A=E.t.x[a],S=E.t.y[a]):(A=E.t.y[a],S=E.t.x[a]),x[A][1].push(S);E.t&&E.t._scene&&delete E.t._scene.dirty}else if(E.hasOwnProperty('z')){S=E.z;var z=c(_.type,h,S);for(a=0;a<S.length;a++)for(o=0;o<S[a].length;o++)(A=z(o,a))+1&&x[A][1].push(S[a][o])}else for(void 0===(A=E.p)&&(A=E[v]),void 0===(S=E.s)&&(S=E.v),void 0===S&&(S=y?E.y:E.x),Array.isArray(S)||(S=void 0===S?[]:[S]),a=0;a<S.length;a++)x[A][1].push(S[a])}}}h._categoriesValue=x;var O=[];for(n=0;n<x.length;n++)O.push([x[n][0],f[m](x[n][1])]);O.sort((function(t,e){return t[1]-e[1]})),h._categoriesAggregatedValue=O,h._initialCategories=O.map((function(t){return t[0]})),"descending"===g&&h._initialCategories.reverse(),l=l.concat(h.sortByInitialCategories())}}}return l}function G(t,e,r)[var n={];function i(t){t.clearCalc(),"multicategory"===t.type&&t.setupMultiCategory(e),n[t._id]=1}u.simpleMap(t,i);for(var a=r._axisMatchGroups||[],o=0;o<a.length;o++)for(var s in a[o])n[s]||i(r[p.id2name(s)])}function Y(t){var e,r,n,i=t._fullLayout,a=i._visibleModules,o={};for(r=0;r<a.length;r++){var s=a[r],l=s.crossTraceCalc;if(l){var c=s.basePlotModule.name;o[c]?u.pushUnique(o[c],l):o[c]=[l]}}for(n in o){var f=o[n],h=i._subplots[n];if(Array.isArray(h))for(e=0;e<h.length;e++){var p=h[e],d="cartesian"===n?i._plots[p]:i[p];for(r=0;r<f.length;r++)f[r](t,d,p)}else for(r=0;r<f.length;r++)f[r](t)}}b.rehover=function(t)[t._fullLayout._rehover&&t._fullLayout._rehover()],b.redrag=function(t)[t._fullLayout._redrag&&t._fullLayout._redrag()],b.generalUpdatePerTraceModule=function(t,e,r,n){var i,a=e.traceHash,o={};for(i=0;i<r.length;i++){var s=r[i],l=s[0].trace;l.visible&&(o[l.type]=o[l.type]||[],o[l.type].push(s))}for(var c in a)if(!o[c]){var f=a[c][0];f[0].trace.visible=!1,o[c]=[f]}for(var h in o){var p=o[h];p[0][0].trace._module.plot(t,e,u.filterVisible(p),n)}e.traceHash=o},b.plotBasePlot=function(t,e,r,n,i){var a=s.getModule(t),o=v(e.calcdata,a)[0];a.plot(e,o,n,i)},b.cleanBasePlot=function(t,e,r,n,i){var a=i._has&&i._has(t),o=r._has&&r._has(t);a&&!o&&i["_"+t+"layer"].selectAll('g.trace').remove()}},{"../components/color":650,"../constants/numerical":763,"../lib":787,"../plot_api/plot_schema":826,"../plot_api/plot_template":827,"../plots/get_data":875,"../registry":915,"./animation_attributes":832,"./attributes":834,"./cartesian/axis_ids":842,"./cartesian/handle_outline":849,"./command":865,"./font_attributes":867,"./frame_attributes":868,"./layout_attributes":892,"@plotly/d3":58,"d3-format":164,"d3-time-format":172,"fast-isnumeric":246}],902:[function(t,e,r){"use strict";e.exports={attr:"subplot",name:"polar",axisNames:["angularaxis","radialaxis"],axisName2dataArray:{angularaxis:"theta",radialaxis:"r"},layerNames:["draglayer",'plotbg','backplot','angular-grid','radial-grid','frontplot','angular-line','radial-line','angular-axis',"radial-axis"],radialDragBoxSize:50,angularDragBoxSize:30,cornerLen:25,cornerHalfWidth:2,MINDRAG:8,MINZOOM:20,OFFEDGE:20}},{}],903:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../lib/polygon').tester,a=n.findIndexOfMin,o=n.isAngleInsideSector,s=n.angleDelta,l=n.angleDist;function c(t,e,r,n,a){if(!o(e,n))return!1;var s,l;r[0]<r[1]?(s=r[0],l=r[1]):(s=r[1],l=r[0]);var c=i(d(s,n[0],n[1],a)),u=i(d(l,n[0],n[1],a)),f=[t*Math.cos(e),t*Math.sin(e)];return u.contains(f)&&!c.contains(f)}function u(t,e,r,n){var i,a,o=n[0],s=n[1],l=v(Math.sin(e)-Math.sin(t)),c=v(Math.cos(e)-Math.cos(t)),u=Math.tan(r),f=v(1/u),h=l/c,p=s-h*o;return f?l&&c?a=u*(i=p/(u-h)):c?(i=s*f,a=s):(i=o,a=o*u):l&&c?(i=0,a=p):c?(i=0,a=s):i=a=NaN,[i,a]}function f(t,e,r,n){var i=-e*r,a=e*e+1,o=2*(e*i-r),s=i*i+r*r-t*t,l=Math.sqrt(o*o-4*a*s),c=(-o+l)/(2*a),u=(-o-l)/(2*a);return[[c,e*c+i+n],[u,e*u+i+n]]}function h(t,e){var r,n=e.length,i=new Array(n+1);for(r=0;r<n;r++){var a=e[r];i[r]=[t*Math.cos(a),t*Math.sin(a)]}return i[r]=i[0].slice(),i}function p(t,e,r,i){var s,c,f=i.length,h=[];function p(e){return[t*Math.cos(e),t*Math.sin(e)]}function d(t,e,r){return u(t,e,r,p(t))}function m(t){return n.mod(t,f)}function g(t){return o(t,[e,r])}var v=a(i,(function(t){return g(t)?l(t,e):1/0})),y=d(i[v],i[m(v-1)],e);for(h.push(y),s=v,c=0;c<f;s++,c++){var x=i[m(s)];if(!g(x))break;h.push(p(x))}var b=a(i,(function(t){return g(t)?l(t,r):1/0})),_=d(i[b],i[m(b+1)],r);return h.push(_),h.push([0,0]),h.push(h[0].slice()),h}function d(t,e,r,i){return n.isFullCircle([e,r])?h(t,i):p(t,e,r,i)}function m(t,e,r,n){for(var i=1/0,a=1/0,o=d(t,e,r,n),s=0;s<o.length;s++){var l=o[s];i=Math.min(i,l[0]),a=Math.min(a,-l[1])}return[i,a]}function g(t,e){var r=a(e,(function(e){var r=s(e,t);return r>0?r:1/0})),i=n.mod(r+1,e.length);return[e[r],e[i]]}function v(t){return Math.abs(t)>1e-10?t:0}function y(t,e,r){e=e||0,r=r||0;for(var n=t.length,i=new Array(n),a=0;a<n;a++){var o=t[a];i[a]=[e+o[0],r-o[1]]}return i}function x(t,e,r,n,i,a){return"M"+y(d(t,e,r,n),i,a).join('L')}function b(t,e,r,n,i,a,o){var s,l;t<e?(s=t,l=e):(s=e,l=t);var c=y(d(s,r,n,i),a,o);return"M"+y(d(l,r,n,i),a,o).reverse().join('L')+"M"+c.join('L')}e.exports={isPtInsidePolygon:c,findPolygonOffset:m,findEnclosingVertexAngles:g,findIntersectionXY:u,findXYatLength:f,clampTiny:v,pathPolygon:x,pathPolygonAnnulus:b}},{"../../lib":787,"../../lib/polygon":799}],904:[function(t,e,r){"use strict";var n=t('../get_data').getSubplotCalcData,i=t('../../lib').counterRegex,a=t('./polar'),o=t('./constants'),s=o.attr,l=o.name,c=i(l),u={};function f(t){for(var e=t._fullLayout,r=t.calcdata,i=e._subplots[l],o=0;o<i.length;o++){var s=i[o],c=n(r,l,s),u=e[s]._subplot;u||(u=a(t,s),e[s]._subplot=u),u.plot(c,e,t._promises)}}function h(t,e,r,n){for(var i=n._subplots[l]||[],a=n._has&&n._has('gl'),o=e._has&&e._has('gl'),s=a&&!o,c=0;c<i.length;c++){var u=i[c],f=n[u]._subplot;if(!e[u]&&f)for(var h in f.framework.remove(),f.layers["radial-axis-title"].remove(),f.clipPaths)f.clipPaths[h].remove();s&&f._scene&&(f._scene.destroy(),f._scene=null)}}u[s]={valType:"subplotid",dflt:l,editType:"calc"},e.exports={attr:s,name:l,idRoot:l,idRegex:c,attrRegex:c,attributes:u,layoutAttributes:t('./layout_attributes'),supplyLayoutDefaults:t('./layout_defaults'),plot:f,clean:h,toSVG:t('../cartesian').toSVG}},{"../../lib":787,"../cartesian":852,"../get_data":875,"./constants":902,"./layout_attributes":905,"./layout_defaults":906,"./polar":907}],905:[function(t,e,r){"use strict";var n=t('../../components/color/attributes'),i=t('../cartesian/layout_attributes'),a=t('../domain').attributes,o=t('../../lib').extendFlat,s=t('../../plot_api/edit_types').overrideAll,l=s({color:i.color,showline:o({},i.showline,{dflt:!0}),linecolor:i.linecolor,linewidth:i.linewidth,showgrid:o({},i.showgrid,{dflt:!0}),gridcolor:i.gridcolor,gridwidth:i.gridwidth},'plot','from-root'),c=s({tickmode:i.tickmode,nticks:i.nticks,tick0:i.tick0,dtick:i.dtick,tickvals:i.tickvals,ticktext:i.ticktext,ticks:i.ticks,ticklen:i.ticklen,tickwidth:i.tickwidth,tickcolor:i.tickcolor,showticklabels:i.showticklabels,showtickprefix:i.showtickprefix,tickprefix:i.tickprefix,showticksuffix:i.showticksuffix,ticksuffix:i.ticksuffix,showexponent:i.showexponent,exponentformat:i.exponentformat,minexponent:i.minexponent,separatethousands:i.separatethousands,tickfont:i.tickfont,tickangle:i.tickangle,tickformat:i.tickformat,tickformatstops:i.tickformatstops,layer:i.layer},'plot','from-root'),u={visible:o({},i.visible,{dflt:!0}),type:o({},i.type,{values:["-",'linear','log','date',"category"]}),autotypenumbers:i.autotypenumbers,autorange:o({},i.autorange,{editType:"plot"}),rangemode:{valType:"enumerated",values:["tozero",'nonnegative',"normal"],dflt:"tozero",editType:"calc"},range:o({},i.range,{items:[{valType:"any",editType:"plot",impliedEdits:{"^autorange":!1}},{valType:"any",editType:"plot",impliedEdits:{"^autorange":!1}}],editType:"plot"}),categoryorder:i.categoryorder,categoryarray:i.categoryarray,angle:{valType:"angle",editType:"plot"},side:{valType:"enumerated",values:["clockwise","counterclockwise"],dflt:"clockwise",editType:"plot"},title:{text:o({},i.title.text,{editType:"plot",dflt:""}),font:o({},i.title.font,{editType:"plot"}),editType:"plot"},hoverformat:i.hoverformat,uirevision:{valType:"any",editType:"none"},editType:"calc",_deprecated:{title:i._deprecated.title,titlefont:i._deprecated.titlefont}};o(u,l,c);var f={visible:o({},i.visible,{dflt:!0}),type:{valType:"enumerated",values:["-",'linear',"category"],dflt:"-",editType:"calc",_noTemplating:!0},autotypenumbers:i.autotypenumbers,categoryorder:i.categoryorder,categoryarray:i.categoryarray,thetaunit:{valType:"enumerated",values:["radians","degrees"],dflt:"degrees",editType:"calc"},period:{valType:"number",editType:"calc",min:0},direction:{valType:"enumerated",values:["counterclockwise","clockwise"],dflt:"counterclockwise",editType:"calc"},rotation:{valType:"angle",editType:"calc"},hoverformat:i.hoverformat,uirevision:{valType:"any",editType:"none"},editType:"calc"};o(f,l,c),e.exports={domain:a({name:"polar",editType:"plot"}),sector:{valType:"info_array",items:[{valType:"number",editType:"plot"},{valType:"number",editType:"plot"}],dflt:[0,360],editType:"plot"},hole:{valType:"number",min:0,max:1,dflt:0,editType:"plot"},bgcolor:{valType:"color",editType:"plot",dflt:n.background},radialaxis:u,angularaxis:f,gridshape:{valType:"enumerated",values:["circular","linear"],dflt:"circular",editType:"plot"},uirevision:{valType:"any",editType:"none"},editType:"calc"}},{"../../components/color/attributes":649,"../../lib":787,"../../plot_api/edit_types":820,"../cartesian/layout_attributes":853,"../domain":866}],906:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../../plot_api/plot_template'),o=t('../subplot_defaults'),s=t('../get_data').getSubplotData,l=t('../cartesian/tick_value_defaults'),c=t('../cartesian/tick_mark_defaults'),u=t('../cartesian/tick_label_defaults'),f=t('../cartesian/category_order_defaults'),h=t('../cartesian/line_grid_defaults'),p=t('../cartesian/axis_autotype'),d=t('./layout_attributes'),m=t('./set_convert'),g=t('./constants'),v=g.axisNames;function y(t,e,r,o){var p=r('bgcolor');o.bgColor=i.combine(p,o.paper_bgcolor);var y=r('sector');r('hole');var b,_=s(o.fullData,g.name,o.id),w=o.layoutOut;function T(t,e){return r(b+"."+t,e)}for(var k=0;k<v.length;k++){b=v[k],n.isPlainObject(t[b])||(t[b]={});var M=t[b],A=a.newContainer(e,b);A._id=A._name=b,A._attr=o.id+"."+b,A._traceIndices=_.map((function(t){return t._expandedIndex}));var S=g.axisName2dataArray[b],E=x(M,A,T,_,S,o);f(M,A,T,{axData:_,dataAttr:S});var L,C,P=T('visible');switch(m(A,e,w),T('uirevision',e.uirevision),P&&(C=(L=T('color'))===M.color?L:o.font.color),A._m=1,b){case"radialaxis":var I=T('autorange',!A.isValidRange(M.range));M.autorange=I,!I||"linear"!==E&&"-"!==E||T('rangemode'),"reversed"===I&&(A._m=-1),T('range'),A.cleanRange('range',{dfltRange:[0,1]}),P&&(T('side'),T('angle',y[0]),T('title.text'),n.coerceFont(T,'title.font',{family:o.font.family,size:n.bigFont(o.font.size),color:C}));break;case"angularaxis":if("date"===E){n.log('Polar plots do not support date angular axes yet.');for(var z=0;z<_.length;z++)_[z].visible=!1;E=M.type=A.type="linear"}T("linear"===E?"thetaunit":"period");var O=T('direction');T('rotation',{counterclockwise:0,clockwise:90}[O])}P&&(l(M,A,T,A.type),u(M,A,T,A.type,{tickSuffixDflt:"degrees"===A.thetaunit?"\xb0":void 0}),c(M,A,T,{outerTicks:!0}),T('showticklabels')&&(n.coerceFont(T,'tickfont',{family:o.font.family,size:o.font.size,color:C}),T('tickangle'),T('tickformat')),h(M,A,T,{dfltColor:L,bgColor:o.bgColor,blend:60,showLine:!0,showGrid:!0,noZeroLine:!0,attributes:d[b]}),T('layer')),"category"!==E&&T('hoverformat'),A._input=M}"category"===e.angularaxis.type&&r('gridshape')}function x(t,e,r,n,i,a){var o=r('autotypenumbers',a.autotypenumbersDflt);if("-"===r('type')){for(var s,l=0;l<n.length;l++)if(n[l].visible){s=n[l];break}s&&s[i]&&(e.type=p(s[i],'gregorian',{noMultiCategory:!0,autotypenumbers:o})),"-"===e.type?e.type="linear":t.type=e.type}return e.type}e.exports=function(t,e,r){o(t,e,r,{type:g.name,attributes:d,handleDefaults:y,font:e.font,autotypenumbersDflt:e.autotypenumbers,paper_bgcolor:e.paper_bgcolor,fullData:r,layoutOut:e})}},{"../../components/color":650,"../../lib":787,"../../plot_api/plot_template":827,"../cartesian/axis_autotype":839,"../cartesian/category_order_defaults":843,"../cartesian/line_grid_defaults":855,"../cartesian/tick_label_defaults":860,"../cartesian/tick_mark_defaults":861,"../cartesian/tick_value_defaults":862,"../get_data":875,"../subplot_defaults":909,"./constants":902,"./layout_attributes":905,"./set_convert":908}],907:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('tinycolor2'),a=t('../../registry'),o=t('../../lib'),s=o.strRotate,l=o.strTranslate,c=t('../../components/color'),u=t('../../components/drawing'),f=t('../plots'),h=t('../../plots/cartesian/axes'),p=t('../cartesian/set_convert'),d=t('./set_convert'),m=t('../cartesian/autorange').doAutoRange,g=t('../cartesian/dragbox'),v=t('../../components/dragelement'),y=t('../../components/fx'),x=t('../../components/titles'),b=t('../cartesian/select').prepSelect,_=t('../cartesian/select').selectOnClick,w=t('../cartesian/select').clearSelect,T=t('../../lib/setcursor'),k=t('../../lib/clear_gl_canvases'),M=t('../../plot_api/subroutines').redrawReglTraces,A=t('../../constants/alignment').MID_SHIFT,S=t('./constants'),E=t('./helpers'),L=o._,C=o.mod,P=o.deg2rad,I=o.rad2deg;function z(t,e){this.id=e,this.gd=t,this._hasClipOnAxisFalse=null,this.vangles=null,this.radialAxisAngle=null,this.traceHash={},this.layers={},this.clipPaths={},this.clipIds={},this.viewInitial={};var r=t._fullLayout,n="clip"+r._uid+e;this.clipIds.forTraces=n+"-for-traces",this.clipPaths.forTraces=r._clips.append('clipPath').attr('id',this.clipIds.forTraces),this.clipPaths.forTraces.append('path'),this.framework=r._polarlayer.append('g').attr('class',e),this.radialTickLayout=null,this.angularTickLayout=null}var O=z.prototype;function D(t){var e=t.ticks+String(t.ticklen)+String(t.showticklabels);return"side"in t&&(e+=t.side),e}function R(t){var e,r=t[0],n=t[1]-r,i=C(r,360),a=i+n,o=Math.cos(P(i)),s=Math.sin(P(i)),l=Math.cos(P(a)),c=Math.sin(P(a));return e=i<=90&&a>=90||i>90&&a>=450?1:s<=0&&c<=0?0:Math.max(s,c),[i<=180&&a>=180||i>180&&a>=540?-1:o>=0&&l>=0?0:Math.min(o,l),i<=270&&a>=270||i>270&&a>=630?-1:s>=0&&c>=0?0:Math.min(s,c),a>=360?1:o<=0&&l<=0?0:Math.max(o,l),e]}function F(t,e){var r=function(e){return o.angleDist(t,e)};return e[o.findIndexOfMin(e,r)]}function B(t,e,r){return e?(t.attr('display',null),t.attr(r)):t&&t.attr('display','none'),t}e.exports=function(t,e){return new z(t,e)},O.plot=function(t,e){var r=this,n=e[r.id];r._hasClipOnAxisFalse=!1;for(var i=0;i<t.length;i++)if(!1===t[i][0].trace.cliponaxis){r._hasClipOnAxisFalse=!0;break}r.updateLayers(e,n),r.updateLayout(e,n),f.generalUpdatePerTraceModule(r.gd,r,t,n),r.updateFx(e,n)},O.updateLayers=function(t,e){var r=this,i=r.layers,a=e.radialaxis,o=e.angularaxis,s=S.layerNames,l=s.indexOf('frontplot'),c=s.slice(0,l),u="below traces"===o.layer,f="below traces"===a.layer;u&&c.push('angular-line'),f&&c.push('radial-line'),u&&c.push('angular-axis'),f&&c.push('radial-axis'),c.push('frontplot'),u||c.push('angular-line'),f||c.push('radial-line'),u||c.push('angular-axis'),f||c.push('radial-axis');var h=r.framework.selectAll('.polarsublayer').data(c,String);h.enter().append('g').attr('class',(function(t){return"polarsublayer "+t})).each((function(t){var e=i[t]=n.select(this);switch(t){case"frontplot":e.append('g').classed('barlayer',!0),e.append('g').classed('scatterlayer',!0);break;case"backplot":e.append('g').classed('maplayer',!0);break;case"plotbg":i.bg=e.append('path');break;case"radial-grid":case"angular-grid":e.style('fill','none');break;case"radial-line":e.append('line').style('fill','none');break;case"angular-line":e.append('path').style('fill','none')}})),h.order()},O.updateLayout=function(t,e){var r=this,n=r.layers,i=t._size,a=e.radialaxis,o=e.angularaxis,s=e.domain.x,f=e.domain.y;r.xOffset=i.l+i.w*s[0],r.yOffset=i.t+i.h*(1-f[1]);var h=r.xLength=i.w*(s[1]-s[0]),p=r.yLength=i.h*(f[1]-f[0]),d=e.sector;r.sectorInRad=d.map(P);var m,g,v,y,x,b=r.sectorBBox=R(d),_=b[2]-b[0],w=b[3]-b[1],T=p/h,k=Math.abs(w/_);T>k?(m=h,x=(p-(g=h*k))/i.h/2,v=[s[0],s[1]],y=[f[0]+x,f[1]-x]):(g=p,x=(h-(m=p/k))/i.w/2,v=[s[0]+x,s[1]-x],y=[f[0],f[1]]),r.xLength2=m,r.yLength2=g,r.xDomain2=v,r.yDomain2=y;var M=r.xOffset2=i.l+i.w*v[0],A=r.yOffset2=i.t+i.h*(1-y[1]),S=r.radius=m/_,E=r.innerRadius=e.hole*S,L=r.cx=M-S*b[0],C=r.cy=A+S*b[3],I=r.cxx=L-M,z=r.cyy=C-A;r.radialAxis=r.mockAxis(t,e,a,{_id:"x",side:{counterclockwise:"top",clockwise:"bottom"}[a.side],_realSide:a.side,domain:[E/i.w,S/i.w]}),r.angularAxis=r.mockAxis(t,e,o,{side:"right",domain:[0,Math.PI],autorange:!1}),r.doAutoRange(t,e),r.updateAngularAxis(t,e),r.updateRadialAxis(t,e),r.updateRadialAxisTitle(t,e),r.xaxis=r.mockCartesianAxis(t,e,{_id:"x",domain:v}),r.yaxis=r.mockCartesianAxis(t,e,{_id:"y",domain:y});var O=r.pathSubplot();r.clipPaths.forTraces.select('path').attr('d',O).attr('transform',l(I,z)),n.frontplot.attr('transform',l(M,A)).call(u.setClipUrl,r._hasClipOnAxisFalse?null:r.clipIds.forTraces,r.gd),n.bg.attr('d',O).attr('transform',l(L,C)).call(c.fill,e.bgcolor)},O.mockAxis=function(t,e,r,n)[var i=o.extendFlat({],r,n);return d(i,e,t),i},O.mockCartesianAxis=function(t,e,r){var n=this,i=r._id,a=o.extendFlat({type:"linear"},r);p(a,t);var s={x:[0,2],y:[1,3]};return a.setRange=function(){var t=n.sectorBBox,r=s[i],o=n.radialAxis._rl,l=(o[1]-o[0])/(1-e.hole);a.range=[t[r[0]]*l,t[r[1]]*l]},a.isPtWithinRange="x"===i?function(t){return n.isPtInside(t)}:function(){return!0},a.setRange(),a.setScale(),a},O.doAutoRange=function(t,e){var r=this.gd,n=this.radialAxis,i=e.radialaxis;n.setScale(),m(r,n);var a=n.range;i.range=a.slice(),i._input.range=a.slice(),n._rl=[n.r2l(a[0],null,'gregorian'),n.r2l(a[1],null,'gregorian')]},O.updateRadialAxis=function(t,e){var r=this,n=r.gd,i=r.layers,a=r.radius,u=r.innerRadius,f=r.cx,p=r.cy,d=e.radialaxis,m=C(e.sector[0],360),g=r.radialAxis,v=u<a;r.fillViewInitialKey('radialaxis.angle',d.angle),r.fillViewInitialKey('radialaxis.range',g.range.slice()),g.setGeometry(),"auto"===g.tickangle&&m>90&&m<=270&&(g.tickangle=180);var y=function(t){return l(g.l2p(t.x)+u,0)},x=function(t){return r.pathArc(g.r2p(t.x)+u)},b=D(d);if(r.radialTickLayout!==b&&(i["radial-axis"].selectAll('.xtick').remove(),r.radialTickLayout=b),v){g.setScale();var _=h.calcTicks(g),w=h.clipEnds(g,_),T=h.getTickSigns(g)[2];h.drawTicks(n,g,{vals:_,layer:i["radial-axis"],path:h.makeTickPath(g,0,T),transFn:y,crisp:!1}),h.drawGrid(n,g,{vals:w,layer:i["radial-grid"],path:x,transFn:o.noop,crisp:!1}),h.drawLabels(n,g,{vals:_,layer:i["radial-axis"],transFn:y,labelFns:h.makeLabelFns(g,0)})}var k=r.radialAxisAngle=r.vangles?I(F(P(d.angle),r.vangles)):d.angle,M=l(f,p),A=M+s(-k);B(i["radial-axis"],v&&(d.showticklabels||d.ticks),{transform:A}),B(i["radial-grid"],v&&d.showgrid,{transform:M}),B(i["radial-line"].select('line'),v&&d.showline,{x1:u,y1:0,x2:a,y2:0,transform:A}).attr('stroke-width',d.linewidth).call(c.stroke,d.linecolor)},O.updateRadialAxisTitle=function(t,e,r){var n=this,i=n.gd,a=n.radius,o=n.cx,s=n.cy,l=e.radialaxis,c=n.id+"title",f=void 0!==r?r:n.radialAxisAngle,h=P(f),p=Math.cos(h),d=Math.sin(h),m=0;if(l.title){var g=u.bBox(n.layers["radial-axis"].node()).height,v=l.title.font.size;m="counterclockwise"===l.side?-g-.4*v:g+.8*v}n.layers["radial-axis-title"]=x.draw(i,c,{propContainer:l,propName:n.id+".radialaxis.title",placeholder:L(i,'Click to enter radial axis title'),attributes:{x:o+a/2*p+m*d,y:s-a/2*d+m*p,"text-anchor":"middle"},transform:{rotate:-f}})},O.updateAngularAxis=function(t,e){var r=this,n=r.gd,i=r.layers,a=r.radius,u=r.innerRadius,f=r.cx,p=r.cy,d=e.angularaxis,m=r.angularAxis;r.fillViewInitialKey('angularaxis.rotation',d.rotation),m.setGeometry(),m.setScale();var g=function(t){return m.t2g(t.x)};"linear"===m.type&&"radians"===m.thetaunit&&(m.tick0=I(m.tick0),m.dtick=I(m.dtick));var v=function(t){return l(f+a*Math.cos(t),p-a*Math.sin(t))},y=function(t){return v(g(t))},x=function(t){var e=g(t);return v(e)+s(-I(e))},b=function(t){var e=g(t),r=Math.cos(e),n=Math.sin(e);return"M"+[f+u*r,p-u*n]+"L"+[f+a*r,p-a*n]},_=h.makeLabelFns(m,0).labelStandoff,w={xFn:function(t){var e=g(t);return Math.cos(e)*_},yFn:function(t){var e=g(t),r=Math.sin(e)>0?.2:1;return-Math.sin(e)*(_+t.fontSize*r)+Math.abs(Math.cos(e))*(t.fontSize*A)},anchorFn:function(t){var e=g(t),r=Math.cos(e);return Math.abs(r)<.1?"middle":r>0?"start":"end"},heightFn:function(t,e,r){var n=g(t);return-.5*(1+Math.sin(n))*r}},T=D(d);r.angularTickLayout!==T&&(i["angular-axis"].selectAll("."+m._id+"tick").remove(),r.angularTickLayout=T);var k,M=h.calcTicks(m);if("linear"===e.gridshape?(k=M.map(g),o.angleDelta(k[0],k[1])<0&&(k=k.slice().reverse())):k=null,r.vangles=k,"category"===m.type&&(M=M.filter((function(t){return o.isAngleInsideSector(g(t),r.sectorInRad)}))),m.visible){var S="inside"===m.ticks?-1:1,E=(m.linewidth||1)/2;h.drawTicks(n,m,{vals:M,layer:i["angular-axis"],path:"M"+S*E+",0h"+S*m.ticklen,transFn:x,crisp:!1}),h.drawGrid(n,m,{vals:M,layer:i["angular-grid"],path:b,transFn:o.noop,crisp:!1}),h.drawLabels(n,m,{vals:M,layer:i["angular-axis"],repositionOnUpdate:!0,transFn:y,labelFns:w})}B(i["angular-line"].select('path'),d.showline,{d:r.pathSubplot(),transform:l(f,p)}).attr('stroke-width',d.linewidth).call(c.stroke,d.linecolor)},O.updateFx=function(t,e){this.gd._context.staticPlot||(this.updateAngularDrag(t),this.updateRadialDrag(t,e,0),this.updateRadialDrag(t,e,1),this.updateMainDrag(t))},O.updateMainDrag=function(t){var e,r,s=this,c=s.gd,u=s.layers,f=t._zoomlayer,h=S.MINZOOM,p=S.OFFEDGE,d=s.radius,m=s.innerRadius,x=s.cx,T=s.cy,k=s.cxx,M=s.cyy,A=s.sectorInRad,L=s.vangles,C=s.radialAxis,P=E.clampTiny,I=E.findXYatLength,z=E.findEnclosingVertexAngles,O=S.cornerHalfWidth,D=S.cornerLen/2,R=g.makeDragger(u,'path','maindrag','crosshair');n.select(R).attr('d',s.pathSubplot()).attr('transform',l(x,T));var F,B,N,j,U,V,H,q,G,Y={element:R,gd:c,subplot:s.id,plotinfo:{id:s.id,xaxis:s.xaxis,yaxis:s.yaxis},xaxes:[s.xaxis],yaxes:[s.yaxis]};function W(t,e){return Math.sqrt(t*t+e*e)}function X(t,e){return W(t-k,e-M)}function Z(t,e){return Math.atan2(M-e,t-k)}function J(t,e){return[t*Math.cos(e),t*Math.sin(-e)]}function K(t,e){if(0===t)return s.pathSector(2*O);var r=D/t,n=e-r,i=e+r,a=Math.max(0,Math.min(t,d)),o=a-O,l=a+O;return"M"+J(o,n)+"A"+[o,o]+" 0,0,0 "+J(o,i)+"L"+J(l,i)+"A"+[l,l]+" 0,0,1 "+J(l,n)+"Z"}function Q(t,e,r){if(0===t)return s.pathSector(2*O);var n,i,a=J(t,e),o=J(t,r),l=P((a[0]+o[0])/2),c=P((a[1]+o[1])/2);if(l&&c){var u=c/l,f=-1/u,h=I(O,u,l,c);n=I(D,f,h[0][0],h[0][1]),i=I(D,f,h[1][0],h[1][1])}else{var p,d;c?(p=D,d=O):(p=O,d=D),n=[[l-p,c-d],[l+p,c-d]],i=[[l-p,c+d],[l+p,c+d]]}return"M"+n.join('L')+"L"+i.reverse().join('L')+"Z"}function $(){N=null,j=null,U=s.pathSubplot(),V=!1;var t=c._fullLayout[s.id];H=i(t.bgcolor).getLuminance(),(q=g.makeZoombox(f,H,x,T,U)).attr('fill-rule','evenodd'),G=g.makeCorners(f,x,T),w(c)}function tt(t,e){return e=Math.max(Math.min(e,d),m),t<p?t=0:d-t<p?t=d:e<p?e=0:d-e<p&&(e=d),Math.abs(e-t)>h?(t<e?(N=t,j=e):(N=e,j=t),!0):(N=null,j=null,!1)}function et(t,e){t=t||U,e=e||"M0,0Z",q.attr('d',t),G.attr('d',e),g.transitionZoombox(q,G,V,H),V=!0;var r={};ot(r),c.emit('plotly_relayouting',r)}function rt(t,n){var i,a,o=F+(t*=e),l=B+(n*=r),c=X(F,B),u=Math.min(X(o,l),d),f=Z(F,B);tt(c,u)&&(i=U+s.pathSector(j),N&&(i+=s.pathSector(N)),a=K(N,f)+K(j,f)),et(i,a)}function nt(t,e,r,n){var i=E.findIntersectionXY(r,n,r,[t-k,M-e]);return W(i[0],i[1])}function it(t,e){var r,n,i=F+t,a=B+e,o=Z(F,B),l=Z(i,a),c=z(o,L),u=z(l,L);tt(nt(F,B,c[0],c[1]),Math.min(nt(i,a,u[0],u[1]),d))&&(r=U+s.pathSector(j),N&&(r+=s.pathSector(N)),n=[Q(N,c[0],c[1]),Q(j,c[0],c[1])].join(' ')),et(r,n)}function at(){if(g.removeZoombox(c),null!==N&&null!==j){var t={};ot(t),g.showDoubleClickNotifier(c),a.call('_guiRelayout',c,t)}}function ot(t){var e=C._rl,r=(e[1]-e[0])/(1-m/d)/d,n=[e[0]+(N-m)*r,e[0]+(j-m)*r];t[s.id+".radialaxis.range"]=n}function st(t,e){var r=c._fullLayout.clickmode;if(g.removeZoombox(c),2===t){var n={};for(var i in s.viewInitial)n[s.id+"."+i]=s.viewInitial[i];c.emit('plotly_doubleclick',null),a.call('_guiRelayout',c,n)}r.indexOf('select')>-1&&1===t&&_(e,c,[s.xaxis],[s.yaxis],s.id,Y),r.indexOf('event')>-1&&y.click(c,e,s.id)}Y.prepFn=function(t,n,i){var a=c._fullLayout.dragmode,s=R.getBoundingClientRect();c._fullLayout._calcInverseTransform(c);var l=c._fullLayout._invTransform;e=c._fullLayout._invScaleX,r=c._fullLayout._invScaleY;var u=o.apply3DTransform(l)(n-s.left,i-s.top);if(F=u[0],B=u[1],L){var f=E.findPolygonOffset(d,A[0],A[1],L);F+=k+f[0],B+=M+f[1]}switch(a){case"zoom":Y.moveFn=L?it:rt,Y.clickFn=st,Y.doneFn=at,$(t,n,i);break;case"select":case"lasso":b(t,n,i,Y,a)}},R.onmousemove=function(t){y.hover(c,t,s.id),c._fullLayout._lasthover=R,c._fullLayout._hoversubplot=s.id},R.onmouseout=function(t){c._dragging||v.unhover(c,t)},v.init(Y)},O.updateRadialDrag=function(t,e,r){var i=this,c=i.gd,u=i.layers,f=i.radius,h=i.innerRadius,p=i.cx,d=i.cy,m=i.radialAxis,y=S.radialDragBoxSize,x=y/2;if(m.visible){var b,_,T,A=P(i.radialAxisAngle),E=m._rl,L=E[0],C=E[1],z=E[r],O=.75*(E[1]-E[0])/(1-e.hole)/f;r?(b=p+(f+x)*Math.cos(A),_=d-(f+x)*Math.sin(A),T='radialdrag'):(b=p+(h-x)*Math.cos(A),_=d-(h-x)*Math.sin(A),T='radialdrag-inner');var D,R,N,j=g.makeRectDragger(u,T,'crosshair',-x,-x,y,y),U={element:j,gd:c};B(n.select(j),m.visible&&h<f,{transform:l(b,_)}),U.prepFn=function(){D=null,R=null,N=null,U.moveFn=V,U.doneFn=q,w(c)},U.clampFn=function(t,e){return Math.sqrt(t*t+e*e)<S.MINDRAG&&(t=0,e=0),[t,e]},v.init(U)}function V(t,e){if(D)D(t,e);else{var r=[t,-e],n=[Math.cos(A),Math.sin(A)],i=Math.abs(o.dot(r,n)/Math.sqrt(o.dot(r,r)));isNaN(i)||(D=i<.5?G:Y)}var a={};H(a),c.emit('plotly_relayouting',a)}function H(t){null!==R?t[i.id+".radialaxis.angle"]=R:null!==N&&(t[i.id+".radialaxis.range["+r+"]"]=N)}function q(){null!==R?a.call('_guiRelayout',c,i.id+".radialaxis.angle",R):null!==N&&a.call('_guiRelayout',c,i.id+".radialaxis.range["+r+"]",N)}function G(t,e){if(0!==r){var n=b+t,a=_+e;R=Math.atan2(d-a,n-p),i.vangles&&(R=F(R,i.vangles)),R=I(R);var o=l(p,d)+s(-R);u["radial-axis"].attr('transform',o),u["radial-line"].select('line').attr('transform',o);var c=i.gd._fullLayout,f=c[i.id];i.updateRadialAxisTitle(c,f,R)}}function Y(t,e){var n=o.dot([t,-e],[Math.cos(A),Math.sin(A)]);if(N=z-O*n,O>0===(r?N>L:N<C)){var s=c._fullLayout,l=s[i.id];m.range[r]=N,m._rl[r]=N,i.updateRadialAxis(s,l),i.xaxis.setRange(),i.xaxis.setScale(),i.yaxis.setRange(),i.yaxis.setScale();var u=!1;for(var f in i.traceHash){var h=i.traceHash[f],p=o.filterVisible(h);h[0][0].trace._module.plot(c,i,p,l),a.traceIs(f,'gl')&&p.length&&(u=!0)}u&&(k(c),M(c))}else N=null}},O.updateAngularDrag=function(t){var e=this,r=e.gd,i=e.layers,c=e.radius,f=e.angularAxis,h=e.cx,p=e.cy,d=e.cxx,m=e.cyy,y=S.angularDragBoxSize,x=g.makeDragger(i,'path','angulardrag','move'),b={element:x,gd:r};function _(t,e){return Math.atan2(m+y-e,t-d-y)}n.select(x).attr('d',e.pathAnnulus(c,c+y)).attr('transform',l(h,p)).call(T,'move');var A,E,L,C,P,z,O=i.frontplot.select('.scatterlayer').selectAll('.trace'),D=O.selectAll('.point'),R=O.selectAll('.textpoint');function F(c,g){var v=e.gd._fullLayout,y=v[e.id],x=_(A+c*t._invScaleX,E+g*t._invScaleY),b=I(x-z);if(C=L+b,i.frontplot.attr('transform',l(e.xOffset2,e.yOffset2)+s([-b,d,m])),e.vangles){P=e.radialAxisAngle+b;var w=l(h,p)+s(-b),T=l(h,p)+s(-P);i.bg.attr('transform',w),i["radial-grid"].attr('transform',w),i["radial-axis"].attr('transform',T),i["radial-line"].select('line').attr('transform',T),e.updateRadialAxisTitle(v,y,P)}else e.clipPaths.forTraces.select('path').attr('transform',l(d,m)+s(b));D.each((function(){var t=n.select(this),e=u.getTranslate(t);t.attr('transform',l(e.x,e.y)+s([b]))})),R.each((function(){var t=n.select(this),e=t.select('text'),r=u.getTranslate(t);t.attr('transform',s([b,e.attr('x'),e.attr('y')])+l(r.x,r.y))})),f.rotation=o.modHalf(C,360),e.updateAngularAxis(v,y),e._hasClipOnAxisFalse&&!o.isFullCircle(e.sectorInRad)&&O.call(u.hideOutsideRangePoints,e);var S=!1;for(var F in e.traceHash)if(a.traceIs(F,'gl')){var N=e.traceHash[F],j=o.filterVisible(N);N[0][0].trace._module.plot(r,e,j,y),j.length&&(S=!0)}S&&(k(r),M(r));var U={};B(U),r.emit('plotly_relayouting',U)}function B(t){t[e.id+".angularaxis.rotation"]=C,e.vangles&&(t[e.id+".radialaxis.angle"]=P)}function N(){R.select('text').attr('transform',null);var t={};B(t),a.call('_guiRelayout',r,t)}b.prepFn=function(n,i,a){var s=t[e.id];L=s.angularaxis.rotation;var l=x.getBoundingClientRect();A=i-l.left,E=a-l.top,r._fullLayout._calcInverseTransform(r);var c=o.apply3DTransform(t._invTransform)(A,E);A=c[0],E=c[1],z=_(A,E),b.moveFn=F,b.doneFn=N,w(r)},e.vangles&&!o.isFullCircle(e.sectorInRad)&&(b.prepFn=o.noop,T(n.select(x),null)),v.init(b)},O.isPtInside=function(t){var e=this.sectorInRad,r=this.vangles,n=this.angularAxis.c2g(t.theta),i=this.radialAxis,a=i.c2l(t.r),s=i._rl;return(r?E.isPtInsidePolygon:o.isPtInsideSector)(a,n,s,e,r)},O.pathArc=function(t){var e=this.sectorInRad,r=this.vangles;return(r?E.pathPolygon:o.pathArc)(t,e[0],e[1],r)},O.pathSector=function(t){var e=this.sectorInRad,r=this.vangles;return(r?E.pathPolygon:o.pathSector)(t,e[0],e[1],r)},O.pathAnnulus=function(t,e){var r=this.sectorInRad,n=this.vangles;return(n?E.pathPolygonAnnulus:o.pathAnnulus)(t,e,r[0],r[1],n)},O.pathSubplot=function(){var t=this.innerRadius,e=this.radius;return t?this.pathAnnulus(t,e):this.pathSector(e)},O.fillViewInitialKey=function(t,e)[t in this.viewInitial||(this.viewInitial[t]=e)]},{"../../components/color":650,"../../components/dragelement":669,"../../components/drawing":672,"../../components/fx":690,"../../components/titles":748,"../../constants/alignment":755,"../../lib":787,"../../lib/clear_gl_canvases":771,"../../lib/setcursor":808,"../../plot_api/subroutines":828,"../../plots/cartesian/axes":838,"../../registry":915,"../cartesian/autorange":837,"../cartesian/dragbox":847,"../cartesian/select":858,"../cartesian/set_convert":859,"../plots":901,"./constants":902,"./helpers":903,"./set_convert":908,"@plotly/d3":58,tinycolor2:583}],908:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../cartesian/set_convert'),a=n.deg2rad,o=n.rad2deg;function s(t,e){var r=e._subplot;t.setGeometry=function(){var e=t._rl[0],n=t._rl[1],i=r.innerRadius,a=(r.radius-i)/(n-e),o=i/a,s=e>n?function(t){return t<=0}:function(t){return t>=0};t.c2g=function(r){var n=t.c2l(r)-e;return(s(n)?n:0)+o},t.g2c=function(r){return t.l2c(r+e-o)},t.g2p=function(t){return t*a},t.c2p=function(e){return t.g2p(t.c2g(e))}}}function l(t,e){return"degrees"===e?a(t):t}function c(t,e){return"degrees"===e?o(t):t}function u(t,e){var r=t.type;if("linear"===r){var i=t.d2c,s=t.c2d;t.d2c=function(t,e){return l(i(t),e)},t.c2d=function(t,e){return s(c(t,e))}}t.makeCalcdata=function(e,i){var a,o,s=e[i],l=e._length,c=function(r){return t.d2c(r,e.thetaunit)};if(s){if(n.isTypedArray(s)&&"linear"===r){if(l===s.length)return s;if(s.subarray)return s.subarray(0,l)}for(a=new Array(l),o=0;o<l;o++)a[o]=c(s[o])}else{var u=i+"0",f="d"+i,h=u in e?c(e[u]):0,p=e[f]?c(e[f]):(t.period||2*Math.PI)/l;for(a=new Array(l),o=0;o<l;o++)a[o]=h+o*p}return a},t.setGeometry=function(){var i,s,l,c,u=e.sector,f=u.map(a),h={clockwise:-1,counterclockwise:1}[t.direction],p=a(t.rotation),d=function(t){return h*t+p},m=function(t){return(t-p)/h};switch(r){case"linear":s=i=n.identity,c=a,l=o,t.range=n.isFullCircle(f)?[u[0],u[0]+360]:f.map(m).map(o);break;case"category":var g=t._categories.length,v=t.period?Math.max(t.period,g):g;0===v&&(v=1),s=c=function(t){return 2*t*Math.PI/v},i=l=function(t){return t*v/Math.PI/2},t.range=[0,v]}t.c2g=function(t){return d(s(t))},t.g2c=function(t){return i(m(t))},t.t2g=function(t){return d(c(t))},t.g2t=function(t){return l(m(t))}}}e.exports=function(t,e,r){switch(i(t,r),t._id){case"x":case"radialaxis":s(t,e);break;case"angularaxis":u(t,e)}}},{"../../lib":787,"../cartesian/set_convert":859}],909:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plot_api/plot_template'),a=t('./domain').defaults;e.exports=function(t,e,r,o){var s,l,c=o.type,u=o.attributes,f=o.handleDefaults,h=o.partition||"x",p=e._subplots[c],d=p.length,m=d&&p[0].replace(/\d+$/,'');function g(t,e){return n.coerce(s,l,u,t,e)}for(var v=0;v<d;v++){var y=p[v];s=t[y]?t[y]:t[y]={},l=i.newContainer(e,y,m),g('uirevision',e.uirevision);var x={};x[h]=[v/d,(v+1)/d],a(l,e,g,x),o.id=y,f(s,l,g,o)}}},{"../lib":787,"../plot_api/plot_template":827,"./domain":866}],910:[function(t,e,r){"use strict";var n=t('../constants/docs');function i(t){var e=t.description?" "+t.description:"",r=t.keys||[];if(r.length>0){for(var n=[],i=0;i<r.length;i++)n[i]="`"+r[i]+"`";e+='Finally, the template string has access to ',e=1===r.length?"variable "+n[0]:"variables '+n.slice(0,-1).join(', ')+' and '+n.slice(-1)+'."}return e}n.FORMAT_LINK,n.DATE_FORMAT_LINK,r.hovertemplateAttrs=function(t,e)[t=t||{],i(e=e||{});var r={valType:"string",dflt:"",editType:t.editType||"none"};return!1!==t.arrayOk&&(r.arrayOk=!0),r},r.texttemplateAttrs=function(t,e)[t=t||{],i(e=e||{});var r={valType:"string",dflt:"",editType:t.editType||"calc"};return!1!==t.arrayOk&&(r.arrayOk=!0),r}},{"../constants/docs":758}],911:[function(t,e,r){"use strict";var n=t('./ternary'),i=t('../../plots/get_data').getSubplotCalcData,a=t('../../lib').counterRegex,o='ternary';r.name=o;var s=r.attr='subplot';r.idRoot=o,r.idRegex=r.attrRegex=a(o),(r.attributes={})[s]={valType:"subplotid",dflt:"ternary",editType:"calc"},r.layoutAttributes=t('./layout_attributes'),r.supplyLayoutDefaults=t('./layout_defaults'),r.plot=function(t){for(var e=t._fullLayout,r=t.calcdata,a=e._subplots[o],s=0;s<a.length;s++){var l=a[s],c=i(r,o,l),u=e[l]._subplot;u||(u=new n({id:l,graphDiv:t,container:e._ternarylayer.node()},e),e[l]._subplot=u),u.plot(c,e,t._promises)}},r.clean=function(t,e,r,n){for(var i=n._subplots[o]||[],a=0;a<i.length;a++){var s=i[a],l=n[s]._subplot;!e[s]&&l&&(l.plotContainer.remove(),l.clipDef.remove(),l.clipDefRelative.remove(),l.layers["a-title"].remove(),l.layers["b-title"].remove(),l.layers["c-title"].remove())}}},{"../../lib":787,"../../plots/get_data":875,"./layout_attributes":912,"./layout_defaults":913,"./ternary":914}],912:[function(t,e,r){"use strict";var n=t('../../components/color/attributes'),i=t('../domain').attributes,a=t('../cartesian/layout_attributes'),o=t('../../plot_api/edit_types').overrideAll,s=t('../../lib/extend').extendFlat,l={title:{text:a.title.text,font:a.title.font},color:a.color,tickmode:a.tickmode,nticks:s({},a.nticks,{dflt:6,min:1}),tick0:a.tick0,dtick:a.dtick,tickvals:a.tickvals,ticktext:a.ticktext,ticks:a.ticks,ticklen:a.ticklen,tickwidth:a.tickwidth,tickcolor:a.tickcolor,showticklabels:a.showticklabels,showtickprefix:a.showtickprefix,tickprefix:a.tickprefix,showticksuffix:a.showticksuffix,ticksuffix:a.ticksuffix,showexponent:a.showexponent,exponentformat:a.exponentformat,minexponent:a.minexponent,separatethousands:a.separatethousands,tickfont:a.tickfont,tickangle:a.tickangle,tickformat:a.tickformat,tickformatstops:a.tickformatstops,hoverformat:a.hoverformat,showline:s({},a.showline,{dflt:!0}),linecolor:a.linecolor,linewidth:a.linewidth,showgrid:s({},a.showgrid,{dflt:!0}),gridcolor:a.gridcolor,gridwidth:a.gridwidth,layer:a.layer,min:{valType:"number",dflt:0,min:0},_deprecated:{title:a._deprecated.title,titlefont:a._deprecated.titlefont}},c=e.exports=o({domain:i({name:"ternary"}),bgcolor:{valType:"color",dflt:n.background},sum:{valType:"number",dflt:1,min:0},aaxis:l,baxis:l,caxis:l},'plot','from-root');c.uirevision={valType:"any",editType:"none"},c.aaxis.uirevision=c.baxis.uirevision=c.caxis.uirevision={valType:"any",editType:"none"}},{"../../components/color/attributes":649,"../../lib/extend":777,"../../plot_api/edit_types":820,"../cartesian/layout_attributes":853,"../domain":866}],913:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('../../plot_api/plot_template'),a=t('../../lib'),o=t('../subplot_defaults'),s=t('../cartesian/tick_label_defaults'),l=t('../cartesian/tick_mark_defaults'),c=t('../cartesian/tick_value_defaults'),u=t('../cartesian/line_grid_defaults'),f=t('./layout_attributes'),h=["aaxis",'baxis',"caxis"];function p(t,e,r,a){var o,s,l,c=r('bgcolor'),u=r('sum');a.bgColor=n.combine(c,a.paper_bgcolor);for(var f=0;f<h.length;f++)s=t[o=h[f]]||{},(l=i.newContainer(e,o))._name=o,d(s,l,a,e);var p=e.aaxis,m=e.baxis,g=e.caxis;p.min+m.min+g.min>=u&&(p.min=0,m.min=0,g.min=0,t.aaxis&&delete t.aaxis.min,t.baxis&&delete t.baxis.min,t.caxis&&delete t.caxis.min)}function d(t,e,r,n){var i=f[e._name];function o(r,n){return a.coerce(t,e,i,r,n)}o('uirevision',n.uirevision),e.type='linear';var h=o('color'),p=h!==i.color.dflt?h:r.font.color,d=e._name.charAt(0).toUpperCase(),m="Component "+d,g=o('title.text',m);e._hovertitle=g===m?g:d,a.coerceFont(o,'title.font',{family:r.font.family,size:a.bigFont(r.font.size),color:p}),o('min'),c(t,e,o,'linear'),s(t,e,o,'linear',{}),l(t,e,o,{outerTicks:!0}),o('showticklabels')&&(a.coerceFont(o,'tickfont',{family:r.font.family,size:r.font.size,color:p}),o('tickangle'),o('tickformat')),u(t,e,o,{dfltColor:h,bgColor:r.bgColor,blend:60,showLine:!0,showGrid:!0,noZeroLine:!0,attributes:i}),o('hoverformat'),o('layer')}e.exports=function(t,e,r){o(t,e,r,{type:"ternary",attributes:f,handleDefaults:p,font:e.font,paper_bgcolor:e.paper_bgcolor})}},{"../../components/color":650,"../../lib":787,"../../plot_api/plot_template":827,"../cartesian/line_grid_defaults":855,"../cartesian/tick_label_defaults":860,"../cartesian/tick_mark_defaults":861,"../cartesian/tick_value_defaults":862,"../subplot_defaults":909,"./layout_attributes":912}],914:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('tinycolor2'),a=t('../../registry'),o=t('../../lib'),s=o.strTranslate,l=o._,c=t('../../components/color'),u=t('../../components/drawing'),f=t('../cartesian/set_convert'),h=t('../../lib/extend').extendFlat,p=t('../plots'),d=t('../cartesian/axes'),m=t('../../components/dragelement'),g=t('../../components/fx'),v=t('../../components/dragelement/helpers'),y=v.freeMode,x=v.rectMode,b=t('../../components/titles'),_=t('../cartesian/select').prepSelect,w=t('../cartesian/select').selectOnClick,T=t('../cartesian/select').clearSelect,k=t('../cartesian/select').clearSelectionsCache,M=t('../cartesian/constants');function A(t,e){this.id=t.id,this.graphDiv=t.graphDiv,this.init(e),this.makeFramework(e),this.aTickLayout=null,this.bTickLayout=null,this.cTickLayout=null}e.exports=A;var S=A.prototype;S.init=function(t){this.container=t._ternarylayer,this.defs=t._defs,this.layoutId=t._uid,this.traceHash={},this.layers={}},S.plot=function(t,e){var r=this,n=e[r.id],i=e._size;r._hasClipOnAxisFalse=!1;for(var a=0;a<t.length;a++)if(!1===t[a][0].trace.cliponaxis){r._hasClipOnAxisFalse=!0;break}r.updateLayers(n),r.adjustLayout(n,i),p.generalUpdatePerTraceModule(r.graphDiv,r,t,n),r.layers.plotbg.select('path').call(c.fill,n.bgcolor)},S.makeFramework=function(t){var e=this,r=e.graphDiv,n=t[e.id],i=e.clipId="clip"+e.layoutId+e.id,a=e.clipIdRelative="clip-relative"+e.layoutId+e.id;e.clipDef=o.ensureSingleById(t._clips,'clipPath',i,(function(t){t.append('path').attr('d','M0,0Z')})),e.clipDefRelative=o.ensureSingleById(t._clips,'clipPath',a,(function(t){t.append('path').attr('d','M0,0Z')})),e.plotContainer=o.ensureSingle(e.container,'g',e.id),e.updateLayers(n),u.setClipUrl(e.layers.backplot,i,r),u.setClipUrl(e.layers.grids,i,r)},S.updateLayers=function(t){var e=this,r=e.layers,i=["draglayer",'plotbg','backplot',"grids"];"below traces"===t.aaxis.layer&&i.push('aaxis','aline'),"below traces"===t.baxis.layer&&i.push('baxis','bline'),"below traces"===t.caxis.layer&&i.push('caxis','cline'),i.push('frontplot'),"above traces"===t.aaxis.layer&&i.push('aaxis','aline'),"above traces"===t.baxis.layer&&i.push('baxis','bline'),"above traces"===t.caxis.layer&&i.push('caxis','cline');var a=e.plotContainer.selectAll('g.toplevel').data(i,String),o=["agrid",'bgrid',"cgrid"];a.enter().append('g').attr('class',(function(t){return"toplevel "+t})).each((function(t){var e=n.select(this);r[t]=e,"frontplot"===t?e.append('g').classed('scatterlayer',!0):"backplot"===t?e.append('g').classed('maplayer',!0):"plotbg"===t?e.append('path').attr('d','M0,0Z'):"aline"===t||"bline"===t||"cline"===t?e.append('path'):"grids"===t&&o.forEach((function(t){r[t]=e.append('g').classed("grid "+t,!0)}))})),a.order()};var E=Math.sqrt(4/3);function L(t){return t.ticks+String(t.ticklen)+String(t.showticklabels)}S.adjustLayout=function(t,e){var r,n,i,a,o,l,p=this,d=t.domain,m=(d.x[0]+d.x[1])/2,g=(d.y[0]+d.y[1])/2,v=d.x[1]-d.x[0],y=d.y[1]-d.y[0],x=v*e.w,b=y*e.h,_=t.sum,w=t.aaxis.min,T=t.baxis.min,k=t.caxis.min;x>E*b?i=(a=b)*E:a=(i=x)/E,o=v*i/x,l=y*a/b,r=e.l+e.w*m-i/2,n=e.t+e.h*(1-g)-a/2,p.x0=r,p.y0=n,p.w=i,p.h=a,p.sum=_,p.xaxis={type:"linear",range:[w+2*k-_,_-w-2*T],domain:[m-o/2,m+o/2],_id:"x"},f(p.xaxis,p.graphDiv._fullLayout),p.xaxis.setScale(),p.xaxis.isPtWithinRange=function(t){return t.a>=p.aaxis.range[0]&&t.a<=p.aaxis.range[1]&&t.b>=p.baxis.range[1]&&t.b<=p.baxis.range[0]&&t.c>=p.caxis.range[1]&&t.c<=p.caxis.range[0]},p.yaxis={type:"linear",range:[w,_-T-k],domain:[g-l/2,g+l/2],_id:"y"},f(p.yaxis,p.graphDiv._fullLayout),p.yaxis.setScale(),p.yaxis.isPtWithinRange=function(){return!0};var M=p.yaxis.domain[0],A=p.aaxis=h({},t.aaxis,{range:[w,_-T-k],side:"left",tickangle:(+t.aaxis.tickangle||0)-30,domain:[M,M+l*E],anchor:"free",position:0,_id:"y",_length:i});f(A,p.graphDiv._fullLayout),A.setScale();var S=p.baxis=h({},t.baxis,{range:[_-w-k,T],side:"bottom",domain:p.xaxis.domain,anchor:"free",position:0,_id:"x",_length:i});f(S,p.graphDiv._fullLayout),S.setScale();var L=p.caxis=h({},t.caxis,{range:[_-w-T,k],side:"right",tickangle:(+t.caxis.tickangle||0)+30,domain:[M,M+l*E],anchor:"free",position:0,_id:"y",_length:i});f(L,p.graphDiv._fullLayout),L.setScale();var C="M"+r+","+(n+a)+"h"+i+"l-"+i/2+",-"+a+"Z";p.clipDef.select('path').attr('d',C),p.layers.plotbg.select('path').attr('d',C);var P="M0,"+a+"h"+i+"l-"+i/2+",-"+a+"Z";p.clipDefRelative.select('path').attr('d',P);var I=s(r,n);p.plotContainer.selectAll('.scatterlayer,.maplayer').attr('transform',I),p.clipDefRelative.select('path').attr('transform',null);var z=s(r-S._offset,n+a);p.layers.baxis.attr('transform',z),p.layers.bgrid.attr('transform',z);var O=s(r+i/2,n)+"rotate(30)"+s(0,-A._offset);p.layers.aaxis.attr('transform',O),p.layers.agrid.attr('transform',O);var D=s(r+i/2,n)+"rotate(-30)"+s(0,-L._offset);p.layers.caxis.attr('transform',D),p.layers.cgrid.attr('transform',D),p.drawAxes(!0),p.layers.aline.select('path').attr('d',A.showline?"M"+r+","+(n+a)+"l"+i/2+",-"+a:"M0,0").call(c.stroke,A.linecolor||"#000").style('stroke-width',(A.linewidth||0)+"px"),p.layers.bline.select('path').attr('d',S.showline?"M"+r+","+(n+a)+"h"+i:"M0,0").call(c.stroke,S.linecolor||"#000").style('stroke-width',(S.linewidth||0)+"px"),p.layers.cline.select('path').attr('d',L.showline?"M"+(r+i/2)+","+n+"l"+i/2+","+a:"M0,0").call(c.stroke,L.linecolor||"#000").style('stroke-width',(L.linewidth||0)+"px"),p.graphDiv._context.staticPlot||p.initInteractions(),u.setClipUrl(p.layers.frontplot,p._hasClipOnAxisFalse?null:p.clipId,p.graphDiv)},S.drawAxes=function(t){var e=this,r=e.graphDiv,n=e.id.substr(7)+"title",i=e.layers,a=e.aaxis,o=e.baxis,s=e.caxis;if(e.drawAx(a),e.drawAx(o),e.drawAx(s),t){var c=Math.max(a.showticklabels?a.tickfont.size/2:0,(s.showticklabels?.75*s.tickfont.size:0)+("outside"===s.ticks?.87*s.ticklen:0)),u=(o.showticklabels?o.tickfont.size:0)+("outside"===o.ticks?o.ticklen:0)+3;i["a-title"]=b.draw(r,"a"+n,{propContainer:a,propName:e.id+".aaxis.title",placeholder:l(r,'Click to enter Component A title'),attributes:{x:e.x0+e.w/2,y:e.y0-a.title.font.size/3-c,"text-anchor":"middle"}}),i["b-title"]=b.draw(r,"b"+n,{propContainer:o,propName:e.id+".baxis.title",placeholder:l(r,'Click to enter Component B title'),attributes:{x:e.x0-u,y:e.y0+e.h+.83*o.title.font.size+u,"text-anchor":"middle"}}),i["c-title"]=b.draw(r,"c"+n,{propContainer:s,propName:e.id+".caxis.title",placeholder:l(r,'Click to enter Component C title'),attributes:{x:e.x0+e.w+u,y:e.y0+e.h+.83*s.title.font.size+u,"text-anchor":"middle"}})}},S.drawAx=function(t){var e=this,r=e.graphDiv,n=t._name,i=n.charAt(0),a=t._id,s=e.layers[n],l=30,c=i+"tickLayout",u=L(t);e[c]!==u&&(s.selectAll("."+a+"tick").remove(),e[c]=u),t.setScale();var f=d.calcTicks(t),h=d.clipEnds(t,f),p=d.makeTransTickFn(t),m=d.getTickSigns(t)[2],g=o.deg2rad(l),v=m*(t.linewidth||1)/2,y=m*t.ticklen,x=e.w,b=e.h,_="b"===i?"M0,"+v+"l"+Math.sin(g)*y+","+Math.cos(g)*y:"M"+v+",0l"+Math.cos(g)*y+","+-Math.sin(g)*y,w={a:"M0,0l"+b+",-"+x/2,b:"M0,0l-"+x/2+",-"+b,c:"M0,0l-"+b+","+x/2}[i];d.drawTicks(r,t,{vals:"inside"===t.ticks?h:f,layer:s,path:_,transFn:p,crisp:!1}),d.drawGrid(r,t,{vals:h,layer:e.layers[i+"grid"],path:w,transFn:p,crisp:!1}),d.drawLabels(r,t,{vals:f,layer:s,transFn:p,labelFns:d.makeLabelFns(t,0,l)})};var C=M.MINZOOM/2+.87,P="m-0.87,.5h"+C+"v3h-"+(C+5.2)+"l"+(C/2+2.6)+",-"+(.87*C+4.5)+"l2.6,1.5l-"+C/2+","+.87*C+"Z",I="m0.87,.5h-"+C+"v3h"+(C+5.2)+"l-"+(C/2+2.6)+",-"+(.87*C+4.5)+"l-2.6,1.5l"+C/2+","+.87*C+"Z",z="m0,1l"+C/2+","+.87*C+"l2.6,-1.5l-"+(C/2+2.6)+",-"+(.87*C+4.5)+"l-"+(C/2+2.6)+","+(.87*C+4.5)+"l2.6,1.5l"+C/2+",-"+.87*C+"Z",O='m0.5,0.5h5v-2h-5v-5h-2v5h-5v2h5v5h2Z',D=!0;function R(t){n.select(t).selectAll('.zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners').remove()}S.clearSelect=function(){k(this.dragOptions),T(this.dragOptions.gd)},S.initInteractions=function(){var t,e,r,n,f,h,p,d,v,b,T,k,A=this,S=A.layers.plotbg.select('path').node(),L=A.graphDiv,C=L._fullLayout._zoomlayer;function F(t){var e={};return e[A.id+".aaxis.min"]=t.a,e[A.id+".baxis.min"]=t.b,e[A.id+".caxis.min"]=t.c,e}function B(t,e){var r=L._fullLayout.clickmode;R(L),2===t&&(L.emit('plotly_doubleclick',null),a.call('_guiRelayout',L,F({a:0,b:0,c:0}))),r.indexOf('select')>-1&&1===t&&w(e,L,[A.xaxis],[A.yaxis],A.id,A.dragOptions),r.indexOf('event')>-1&&g.click(L,e,A.id)}function N(t,e,a){var l=S.getBoundingClientRect();r=e-l.left,n=a-l.top,L._fullLayout._calcInverseTransform(L);var u=L._fullLayout._invTransform,m=o.apply3DTransform(u)(r,n);r=m[0],n=m[1],f={a:A.aaxis.range[0],b:A.baxis.range[1],c:A.caxis.range[1]},p=f,h=A.aaxis.range[1]-f.a,d=i(A.graphDiv._fullLayout[A.id].bgcolor).getLuminance(),v="M0,"+A.h+"L"+A.w/2+", 0L"+A.w+","+A.h+"Z",b=!1,T=C.append('path').attr('class','zoombox').attr('transform',s(A.x0,A.y0)).style({fill:d>.2?"rgba(0,0,0,0)":"rgba(255,255,255,0)","stroke-width":0}).attr('d',v),k=C.append('path').attr('class','zoombox-corners').attr('transform',s(A.x0,A.y0)).style({fill:c.background,stroke:c.defaultLine,"stroke-width":1,opacity:0}).attr('d','M0,0Z'),A.clearSelect(L)}function j(t,e){return 1-e/A.h}function U(t,e){return 1-(t+(A.h-e)/Math.sqrt(3))/A.w}function V(t,e){return(t-(A.h-e)/Math.sqrt(3))/A.w}function H(i,a){var o=r+i*t,s=n+a*e,l=Math.max(0,Math.min(1,j(r,n),j(o,s))),c=Math.max(0,Math.min(1,U(r,n),U(o,s))),u=Math.max(0,Math.min(1,V(r,n),V(o,s))),m=(l/2+u)*A.w,g=(1-l/2-c)*A.w,y=(m+g)/2,x=g-m,_=(1-l)*A.h,w=_-x/E;x<M.MINZOOM?(p=f,T.attr('d',v),k.attr('d','M0,0Z')):(p={a:f.a+l*h,b:f.b+c*h,c:f.c+u*h},T.attr('d',v+"M"+m+","+_+"H"+g+"L"+y+","+w+"L"+m+","+_+"Z"),k.attr('d',"M"+r+","+n+O+"M"+m+","+_+P+"M"+g+","+_+I+"M"+y+","+w+z)),b||(T.transition().style('fill',d>.2?"rgba(0,0,0,0.4)":"rgba(255,255,255,0.3)").duration(200),k.transition().style('opacity',1).duration(200),b=!0),L.emit('plotly_relayouting',F(p))}function q(){R(L),p!==f&&(a.call('_guiRelayout',L,F(p)),D&&L.data&&L._context.showTips&&(o.notifier(l(L,'Double-click to zoom back out'),'long'),D=!1))}function G(){f={a:A.aaxis.range[0],b:A.baxis.range[1],c:A.caxis.range[1]},p=f}function Y(t,e){var r=t/A.xaxis._m,n=e/A.yaxis._m,i=[(p={a:f.a-n,b:f.b+(r+n)/2,c:f.c-(r-n)/2}).a,p.b,p.c].sort(o.sorterAsc),a={a:i.indexOf(p.a),b:i.indexOf(p.b),c:i.indexOf(p.c)};i[0]<0&&(i[1]+i[0]/2<0?(i[2]+=i[0]+i[1],i[0]=i[1]=0):(i[2]+=i[0]/2,i[1]+=i[0]/2,i[0]=0),p={a:i[a.a],b:i[a.b],c:i[a.c]},e=(f.a-p.a)*A.yaxis._m,t=(f.c-p.c-f.b+p.b)*A.xaxis._m);var l=s(A.x0+t,A.y0+e);A.plotContainer.selectAll('.scatterlayer,.maplayer').attr('transform',l);var c=s(-t,-e);A.clipDefRelative.select('path').attr('transform',c),A.aaxis.range=[p.a,A.sum-p.b-p.c],A.baxis.range=[A.sum-p.a-p.c,p.b],A.caxis.range=[A.sum-p.a-p.b,p.c],A.drawAxes(!1),A._hasClipOnAxisFalse&&A.plotContainer.select('.scatterlayer').selectAll('.trace').call(u.hideOutsideRangePoints,A),L.emit('plotly_relayouting',F(p))}function W(){a.call('_guiRelayout',L,F(p))}this.dragOptions={element:S,gd:L,plotinfo:{id:A.id,domain:L._fullLayout[A.id].domain,xaxis:A.xaxis,yaxis:A.yaxis},subplot:A.id,prepFn:function(r,n,i){A.dragOptions.xaxes=[A.xaxis],A.dragOptions.yaxes=[A.yaxis],t=L._fullLayout._invScaleX,e=L._fullLayout._invScaleY;var a=A.dragOptions.dragmode=L._fullLayout.dragmode;y(a)?A.dragOptions.minDrag=1:A.dragOptions.minDrag=void 0,"zoom"===a?(A.dragOptions.moveFn=H,A.dragOptions.clickFn=B,A.dragOptions.doneFn=q,N(r,n,i)):"pan"===a?(A.dragOptions.moveFn=Y,A.dragOptions.clickFn=B,A.dragOptions.doneFn=W,G(),A.clearSelect(L)):(x(a)||y(a))&&_(r,n,i,A.dragOptions,a)}},S.onmousemove=function(t){g.hover(L,t,A.id),L._fullLayout._lasthover=S,L._fullLayout._hoversubplot=A.id},S.onmouseout=function(t){L._dragging||m.unhover(L,t)},m.init(this.dragOptions)}},{"../../components/color":650,"../../components/dragelement":669,"../../components/dragelement/helpers":668,"../../components/drawing":672,"../../components/fx":690,"../../components/titles":748,"../../lib":787,"../../lib/extend":777,"../../registry":915,"../cartesian/axes":838,"../cartesian/constants":845,"../cartesian/select":858,"../cartesian/set_convert":859,"../plots":901,"@plotly/d3":58,tinycolor2:583}],915:[function(t,e,r){"use strict";var n=t('./lib/loggers'),i=t('./lib/noop'),a=t('./lib/push_unique'),o=t('./lib/is_plain_object'),s=t('./lib/dom').addStyleRule,l=t('./lib/extend'),c=t('./plots/attributes'),u=t('./plots/layout_attributes'),f=l.extendFlat,h=l.extendDeepAll;function p(t){var e=t.name,i=t.categories,a=t.meta;if(r.modules[e])n.log('Type '+e+' already registered');else{r.subplotsRegistry[t.basePlotModule.name]||d(t.basePlotModule);for(var o={},l=0;l<i.length;l++)o[i[l]]=!0,r.allCategories[i[l]]=!0;for(var c in r.modules[e]={_module:t,categories:o},a&&Object.keys(a).length&&(r.modules[e].meta=a),r.allTypes.push(e),r.componentsRegistry)x(c,e);t.layoutAttributes&&f(r.traceLayoutAttributes,t.layoutAttributes);var u=t.basePlotModule,h=u.name;if("mapbox"===h){var p=u.constants.styleRules;for(var m in p)s(".js-plotly-plot .plotly .mapboxgl-"+m,p[m])}"geo"!==h&&"mapbox"!==h||void 0===typeof window||void 0!==window.PlotlyGeoAssets||(window.PlotlyGeoAssets={topojson:{}})}}function d(t){var e=t.name;if(r.subplotsRegistry[e])n.log('Plot type '+e+' already registered.');else for(var i in y(t),r.subplotsRegistry[e]=t,r.componentsRegistry)_(i,t.name)}function m(t){if("string"!==typeof t.name)throw new Error('Component module *name* must be a string.');var e=t.name;for(var n in r.componentsRegistry[e]=t,t.layoutAttributes&&(t.layoutAttributes._isLinkedToArray&&a(r.layoutArrayContainers,e),y(t)),r.modules)x(e,n);for(var i in r.subplotsRegistry)_(e,i);for(var o in r.transformsRegistry)b(e,o);t.schema&&t.schema.layout&&h(u,t.schema.layout)}function g(t){if("string"!==typeof t.name)throw new Error('Transform module *name* must be a string.');var e="Transform module "+t.name,i="function"===typeof t.transform,a="function"===typeof t.calcTransform;if(!i&&!a)throw new Error(e+" is missing a *transform* or *calcTransform* method.");for(var s in i&&a&&n.log([e+" has both a *transform* and *calcTransform* methods.",'Please note that all *transform* methods are executed',"before all *calcTransform* methods."].join(' ')),o(t.attributes)||n.log(e+" registered without an *attributes* object."),"function"!==typeof t.supplyDefaults&&n.log(e+" registered without a *supplyDefaults* method."),r.transformsRegistry[t.name]=t,r.componentsRegistry)b(s,t.name)}function v(t){var e=t.name,n=e.split('-')[0],i=t.dictionary,a=t.format,o=i&&Object.keys(i).length,s=a&&Object.keys(a).length,l=r.localeRegistry,c=l[e];if(c||(l[e]=c={}),n!==e){var u=l[n];u||(l[n]=u={}),o&&u.dictionary===c.dictionary&&(u.dictionary=i),s&&u.format===c.format&&(u.format=a)}o&&(c.dictionary=i),s&&(c.format=a)}function y(t){if(t.layoutAttributes){var e=t.layoutAttributes._arrayAttrRegexps;if(e)for(var n=0;n<e.length;n++)a(r.layoutArrayRegexes,e[n])}}function x(t,e){var n=r.componentsRegistry[t].schema;if(n&&n.traces){var i=n.traces[e];i&&h(r.modules[e]._module.attributes,i)}}function b(t,e){var n=r.componentsRegistry[t].schema;if(n&&n.transforms){var i=n.transforms[e];i&&h(r.transformsRegistry[e].attributes,i)}}function _(t,e){var n=r.componentsRegistry[t].schema;if(n&&n.subplots){var i=r.subplotsRegistry[e],a=i.layoutAttributes,o="subplot"===i.attr?i.name:i.attr;Array.isArray(o)&&(o=o[0]);var s=n.subplots[o];a&&s&&h(a,s)}}function w(t){return"object"===typeof t&&(t=t.type),t}r.modules={},r.allCategories={},r.allTypes=[],r.subplotsRegistry={},r.transformsRegistry={},r.componentsRegistry={},r.layoutArrayContainers=[],r.layoutArrayRegexes=[],r.traceLayoutAttributes={},r.localeRegistry={},r.apiMethodRegistry={},r.collectableSubplotTypes=null,r.register=function(t){if(r.collectableSubplotTypes=null,!t)throw new Error('No argument passed to Plotly.register.');t&&!Array.isArray(t)&&(t=[t]);for(var e=0;e<t.length;e++){var n=t[e];if(!n)throw new Error('Invalid module was attempted to be registered!');switch(n.moduleType){case"trace":p(n);break;case"transform":g(n);break;case"component":m(n);break;case"locale":v(n);break;case"apiMethod":var i=n.name;r.apiMethodRegistry[i]=n.fn;break;default:throw new Error('Invalid module was attempted to be registered!')}}},r.getModule=function(t){var e=r.modules[w(t)];return!!e&&e._module},r.traceIs=function(t,e){if("various"===(t=w(t)))return!1;var i=r.modules[t];return i||(t&&n.log('Unrecognized trace type '+t+'.'),i=r.modules[c.type.dflt]),!!i.categories[e]},r.getTransformIndices=function(t,e){for(var r=[],n=t.transforms||[],i=0;i<n.length;i++)n[i].type===e&&r.push(i);return r},r.hasTransform=function(t,e){for(var r=t.transforms||[],n=0;n<r.length;n++)if(r[n].type===e)return!0;return!1},r.getComponentMethod=function(t,e){var n=r.componentsRegistry[t];return n&&n[e]||i},r.call=function(){var t=arguments[0],e=[].slice.call(arguments,1);return r.apiMethodRegistry[t].apply(null,e)}},{"./lib/dom":775,"./lib/extend":777,"./lib/is_plain_object":788,"./lib/loggers":791,"./lib/noop":796,"./lib/push_unique":802,"./plots/attributes":834,"./plots/layout_attributes":892}],916:[function(t,e,r){"use strict";var n=t('../registry'),i=t('../lib'),a=i.extendFlat,o=i.extendDeep;function s(t){var e;switch(t){case"themes__thumb":e={autosize:!0,width:150,height:150,title:{text:""},showlegend:!1,margin:{l:5,r:5,t:5,b:5,pad:0},annotations:[]};break;case"thumbnail":e={title:{text:""},hidesources:!0,showlegend:!1,borderwidth:0,bordercolor:"",margin:{l:1,r:1,t:1,b:1,pad:0},annotations:[]};break;default:e={}}return e}function l(t){return["xaxis",'yaxis',"zaxis"].indexOf(t.slice(0,5))>-1}e.exports=function(t,e){var r,i=t.data,c=t.layout,u=o([],i),f=o({},c,s(e.tileClass)),h=t._context||{};if(e.width&&(f.width=e.width),e.height&&(f.height=e.height),"thumbnail"===e.tileClass||"themes__thumb"===e.tileClass){f.annotations=[];var p=Object.keys(f);for(r=0;r<p.length;r++)l(p[r])&&(f[p[r]].title={text:""});for(r=0;r<u.length;r++){var d=u[r];d.showscale=!1,d.marker&&(d.marker.showscale=!1),n.traceIs(d,'pie-like')&&(d.textposition='none')}}if(Array.isArray(e.annotations))for(r=0;r<e.annotations.length;r++)f.annotations.push(e.annotations[r]);var m=Object.keys(f).filter((function(t){return t.match(/^scene\d*$/)}));if(m.length)[var g={];for("thumbnail"===e.tileClass&&(g={title:{text:""},showaxeslabels:!1,showticklabels:!1,linetickenable:!1}),r=0;r<m.length;r++){var v=f[m[r]];v.xaxis||(v.xaxis={}),v.yaxis||(v.yaxis={}),v.zaxis||(v.zaxis={}),a(v.xaxis,g),a(v.yaxis,g),a(v.zaxis,g),v._scene=null}}var y=document.createElement('div');e.tileClass&&(y.className=e.tileClass);var x={gd:y,td:y,layout:f,data:u,config:{staticPlot:void 0===e.staticPlot||e.staticPlot,plotGlPixelRatio:void 0===e.plotGlPixelRatio?2:e.plotGlPixelRatio,displaylogo:e.displaylogo||!1,showLink:e.showLink||!1,showTips:e.showTips||!1,mapboxAccessToken:h.mapboxAccessToken}};return"transparent"!==e.setBackground&&(x.config.setBackground=e.setBackground||"opaque"),x.gd.defaultLayout=s(e.tileClass),x}},{"../lib":787,"../registry":915}],917:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plot_api/to_image'),a=t('./filesaver'),o=t('./helpers');function s(t,e){var r;return n.isPlainObject(t)||(r=n.getGraphDiv(t)),(e=e||{}).format=e.format||"png",e.width=e.width||null,e.height=e.height||null,e.imageDataOnly=!0,new Promise((function(s,l){r&&r._snapshotInProgress&&l(new Error('Snapshotting already in progress.')),n.isIE()&&"svg"!==e.format&&l(new Error(o.MSG_IE_BAD_FORMAT)),r&&(r._snapshotInProgress=!0);var c=i(t,e),u=e.filename||t.fn||"newplot";u+="."+e.format.replace('-','.'),c.then((function(t){return r&&(r._snapshotInProgress=!1),a(t,u,e.format)})).then((function(t)[s(t)])).catch((function(t){r&&(r._snapshotInProgress=!1),l(t)}))}))}e.exports=s},{"../lib":787,"../plot_api/to_image":830,"./filesaver":918,"./helpers":919}],918:[function(t,e,r){"use strict";var n=t('../lib'),i=t('./helpers');function a(t,e,r){var a=document.createElement('a'),o="download"in a;return new Promise((function(s,l){var c,u;if(n.isIE())return c=i.createBlob(t,'svg'),window.navigator.msSaveBlob(c,e),c=null,s(e);if(o)return c=i.createBlob(t,r),u=i.createObjectURL(c),a.href=u,a.download=e,document.body.appendChild(a),a.click(),document.body.removeChild(a),i.revokeObjectURL(u),c=null,s(e);if(n.isSafari()){var f="svg"===r?",':';base64,';return i.octetStream(f+encodeURIComponent(t)),s(e)}l(new Error('download error'))}))}e.exports=a},{'../lib":787,"./helpers":919}],919:[function(t,e,r){"use strict";var n=t('../registry');r.getDelay=function(t){return t._has&&(t._has('gl3d')||t._has('gl2d')||t._has('mapbox'))?500:0},r.getRedrawFunc=function(t){return function(){n.getComponentMethod('colorbar','draw')(t)}},r.encodeSVG=function(t){return"data:image/svg+xml,"+encodeURIComponent(t)},r.encodeJSON=function(t){return"data:application/json,"+encodeURIComponent(t)};var i=window.URL||window.webkitURL;function a(t){for(var e=t.length,r=new ArrayBuffer(e),n=new Uint8Array(r),i=0;i<e;i++)n[i]=t.charCodeAt(i);return r}r.createObjectURL=function(t){return i.createObjectURL(t)},r.revokeObjectURL=function(t){return i.revokeObjectURL(t)},r.createBlob=function(t,e){if("svg"===e)return new window.Blob([t],{type:"image/svg+xml;charset=utf-8"});if("full-json"===e)return new window.Blob([t],{type:"application/json;charset=utf-8"});var r=a(window.atob(t));return new window.Blob([r],{type:"image/"+e})},r.octetStream=function(t){document.location.href="data:application/octet-stream"+t},r.IMAGE_URL_PREFIX=/^data:image\/\w+;base64,/,r.MSG_IE_BAD_FORMAT="Sorry IE does not support downloading from canvas. Try {format:'svg'} instead."},{"../registry":915}],920:[function(t,e,r){"use strict";var n=t('./helpers'),i={getDelay:n.getDelay,getRedrawFunc:n.getRedrawFunc,clone:t('./cloneplot'),toSVG:t('./tosvg'),svgToImg:t('./svgtoimg'),toImage:t('./toimage'),downloadImage:t('./download')};e.exports=i},{"./cloneplot":916,"./download":917,"./helpers":919,"./svgtoimg":921,"./toimage":922,"./tosvg":923}],921:[function(t,e,r){"use strict";var n=t('../lib'),i=t('events').EventEmitter,a=t('./helpers');function o(t){var e=t.emitter||new i,r=new Promise((function(i,o){var s=window.Image,l=t.svg,c=t.format||"png";if(n.isIE()&&"svg"!==c){var u=new Error(a.MSG_IE_BAD_FORMAT);return o(u),t.promise?r:e.emit('error',u)}var f,h,p=t.canvas,d=t.scale||1,m=t.width||300,g=t.height||150,v=d*m,y=d*g,x=p.getContext('2d'),b=new s;"svg"===c||n.isSafari()?h=a.encodeSVG(l):(f=a.createBlob(l,'svg'),h=a.createObjectURL(f)),p.width=v,p.height=y,b.onload=function(){var r;switch(f=null,a.revokeObjectURL(h),"svg"!==c&&x.drawImage(b,0,0,v,y),c){case"jpeg":r=p.toDataURL('image/jpeg');break;case"png":r=p.toDataURL('image/png');break;case"webp":r=p.toDataURL('image/webp');break;case"svg":r=h;break;default:var n='Image format is not jpeg, png, svg or webp.';if(o(new Error(n)),!t.promise)return e.emit('error',n)}i(r),t.promise||e.emit('success',r)},b.onerror=function(r){if(f=null,a.revokeObjectURL(h),o(r),!t.promise)return e.emit('error',r)},b.src=h}));return t.promise?r:e}e.exports=o},{"../lib":787,"./helpers":919,events:116}],922:[function(t,e,r){"use strict";var n=t('events').EventEmitter,i=t('../registry'),a=t('../lib'),o=t('./helpers'),s=t('./cloneplot'),l=t('./tosvg'),c=t('./svgtoimg');function u(t,e){var r=new n,u=s(t,{format:"png"}),f=u.gd;function h(){var t=o.getDelay(f._fullLayout);setTimeout((function(){var t=l(f),n=document.createElement('canvas');n.id=a.randstr(),(r=c({format:e.format,width:f._fullLayout.width,height:f._fullLayout.height,canvas:n,emitter:r,svg:t})).clean=function()[f&&document.body.removeChild(f)]}),t)}f.style.position='absolute',f.style.left='-5000px',document.body.appendChild(f);var p=o.getRedrawFunc(f);return i.call('_doPlot',f,u.data,u.layout,u.config).then(p).then(h).catch((function(t){r.emit('error',t)})),r}e.exports=u},{"../lib":787,"../registry":915,"./cloneplot":916,"./helpers":919,"./svgtoimg":921,"./tosvg":923,events:116}],923:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../lib'),a=t('../components/drawing'),o=t('../components/color'),s=t('../constants/xmlns_namespaces'),l=/"/g,c='TOBESTRIPPED',u=new RegExp('(''+c+')|('+c+'')','g');function f(t){var e=n.select('body').append('div').style({display:"none"}).html(''),r=t.replace(/(&[^;]*;)/gi,(function(t){return"&lt;"===t?"&#60;":"&rt;"===t?"&#62;":-1!==t.indexOf('<')||-1!==t.indexOf('>')?"":e.html(t).text()}));return e.remove(),r}function h(t){return t.replace(/&(?!\w+;|\#[0-9]+;| \#x[0-9A-F]+;)/g,'&amp;')}e.exports=function(t,e,r){var p,d,m=t._fullLayout,g=m._paper,v=m._toppaper,y=m.width,x=m.height;g.insert('rect',':first-child').call(a.setRect,0,0,y,x).call(o.fill,m.paper_bgcolor);var b=m._basePlotModules||[];for(p=0;p<b.length;p++){var _=b[p];_.toSVG&&_.toSVG(t)}if(v){var w=v.node().childNodes,T=Array.prototype.slice.call(w);for(p=0;p<T.length;p++){var k=T[p];k.childNodes.length&&g.node().appendChild(k)}}m._draggers&&m._draggers.remove(),g.node().style.background='',g.selectAll('text').attr({"data-unformatted":null,"data-math":null}).each((function(){var t=n.select(this);if("hidden"!==this.style.visibility&&"none"!==this.style.display){t.style({visibility:null,display:null});var e=this.style.fontFamily;e&&-1!==e.indexOf('"')&&t.style('font-family',e.replace(l,c))}else t.remove()}));var M=[];if(m._gradientUrlQueryParts)for(d in m._gradientUrlQueryParts)M.push(d);if(m._patternUrlQueryParts)for(d in m._patternUrlQueryParts)M.push(d);M.length&&g.selectAll(M.join(',')).each((function(){var t=n.select(this),e=this.style.fill;e&&-1!==e.indexOf('url(')&&t.style('fill',e.replace(l,c));var r=this.style.stroke;r&&-1!==r.indexOf('url(')&&t.style('stroke',r.replace(l,c))})),"pdf"!==e&&"eps"!==e||g.selectAll('#MathJax_SVG_glyphs path').attr('stroke-width',0),g.node().setAttributeNS(s.xmlns,'xmlns',s.svg),g.node().setAttributeNS(s.xmlns,'xmlns:xlink',s.xlink),"svg"===e&&r&&(g.attr('width',r*y),g.attr('height',r*x),g.attr('viewBox',"0 0 '+y+' "+x));var A=(new window.XMLSerializer).serializeToString(g.node());return A=(A=h(A=f(A))).replace(u,'''),i.isIE()&&(A=(A=(A=A.replace(/"/gi,''')).replace(/(\('#)([^']*)('\))/gi,'('#$2')')).replace(/(\\')/gi,'"')),A}},{"../components/color":650,"../components/drawing":672,"../constants/xmlns_namespaces":764,"../lib":787,"@plotly/d3":58}],924:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){for(var r=0;r<t.length;r++)t[r].i=r;n.mergeArray(e.text,t,'tx'),n.mergeArray(e.hovertext,t,'htx');var i=e.marker;if(i){n.mergeArray(i.opacity,t,'mo',!0),n.mergeArray(i.color,t,'mc');var a=i.line;a&&(n.mergeArray(a.color,t,'mlc'),n.mergeArrayCastPositive(a.width,t,'mlw'))}}},{"../../lib":787}],925:[function(t,e,r){"use strict";var n=t('../scatter/attributes'),i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../../plots/template_attributes').texttemplateAttrs,s=t('../../components/colorscale/attributes'),l=t('../../plots/font_attributes'),c=t('./constants'),u=t('../../components/drawing/attributes').pattern,f=t('../../lib/extend').extendFlat,h=l({editType:"calc",arrayOk:!0,colorEditType:"style"}),p=f({},n.marker.line.width,{dflt:0}),d=f({width:p,editType:"calc"},s('marker.line')),m=f({line:d,editType:"calc"},s('marker'),{opacity:{valType:"number",arrayOk:!0,dflt:1,min:0,max:1,editType:"style"},pattern:u});e.exports={x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,xperiod:n.xperiod,yperiod:n.yperiod,xperiod0:n.xperiod0,yperiod0:n.yperiod0,xperiodalignment:n.xperiodalignment,yperiodalignment:n.yperiodalignment,xhoverformat:i('x'),yhoverformat:i('y'),text:n.text,texttemplate:o({editType:"plot"},{keys:c.eventDataKeys}),hovertext:n.hovertext,hovertemplate:a({},{keys:c.eventDataKeys}),textposition:{valType:"enumerated",values:["inside",'outside','auto',"none"],dflt:"auto",arrayOk:!0,editType:"calc"},insidetextanchor:{valType:"enumerated",values:["end",'middle',"start"],dflt:"end",editType:"plot"},textangle:{valType:"angle",dflt:"auto",editType:"plot"},textfont:f({},h,{}),insidetextfont:f({},h,{}),outsidetextfont:f({},h,{}),constraintext:{valType:"enumerated",values:["inside",'outside','both',"none"],dflt:"both",editType:"calc"},cliponaxis:f({},n.cliponaxis,{}),orientation:{valType:"enumerated",values:["v","h"],editType:"calc+clearAxisTypes"},base:{valType:"any",dflt:null,arrayOk:!0,editType:"calc"},offset:{valType:"number",dflt:null,arrayOk:!0,editType:"calc"},width:{valType:"number",dflt:null,min:0,arrayOk:!0,editType:"calc"},marker:m,offsetgroup:{valType:"string",dflt:"",editType:"calc"},alignmentgroup:{valType:"string",dflt:"",editType:"calc"},selected:{marker:{opacity:n.selected.marker.opacity,color:n.selected.marker.color,editType:"style"},textfont:n.selected.textfont,editType:"style"},unselected:{marker:{opacity:n.unselected.marker.opacity,color:n.unselected.marker.color,editType:"style"},textfont:n.unselected.textfont,editType:"style"},_deprecated:{bardir:{valType:"enumerated",editType:"calc",values:["v","h"]}}}},{"../../components/colorscale/attributes":657,"../../components/drawing/attributes":671,"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../../plots/font_attributes":867,"../../plots/template_attributes":910,"../scatter/attributes":1202,"./constants":927}],926:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../plots/cartesian/align_period'),a=t('../../components/colorscale/helpers').hasColorscale,o=t('../../components/colorscale/calc'),s=t('./arrays_to_calcdata'),l=t('../scatter/calc_selection');e.exports=function(t,e){var r,c,u,f,h,p,d=n.getFromId(t,e.xaxis||"x"),m=n.getFromId(t,e.yaxis||"y"),g={msUTC:!(!e.base&&0!==e.base)};"h"===e.orientation?(r=d.makeCalcdata(e,'x',g),u=m.makeCalcdata(e,'y'),f=i(e,m,'y',u),h=!!e.yperiodalignment,p='y'):(r=m.makeCalcdata(e,'y',g),u=d.makeCalcdata(e,'x'),f=i(e,d,'x',u),h=!!e.xperiodalignment,p='x'),c=f.vals;for(var v=Math.min(c.length,r.length),y=new Array(v),x=0;x<v;x++)y[x]={p:c[x],s:r[x]},h&&(y[x].orig_p=u[x],y[x][p+"End"]=f.ends[x],y[x][p+"Start"]=f.starts[x]),e.ids&&(y[x].id=String(e.ids[x]));return a(e,'marker')&&o(t,e,{vals:e.marker.color,containerStr:"marker",cLetter:"c"}),a(e,'marker.line')&&o(t,e,{vals:e.marker.line.color,containerStr:"marker.line",cLetter:"c"}),s(y,e),l(y,e),y}},{"../../components/colorscale/calc":658,"../../components/colorscale/helpers":661,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"../scatter/calc_selection":1204,"./arrays_to_calcdata":924}],927:[function(t,e,r){"use strict";e.exports={TEXTPAD:3,eventDataKeys:["value","label"]}},{}],928:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib').isArrayOrTypedArray,a=t('../../constants/numerical').BADNUM,o=t('../../registry'),s=t('../../plots/cartesian/axes'),l=t('../../plots/cartesian/constraints').getAxisGroup,c=t('./sieve.js');function u(t,e){for(var r=e.xaxis,n=e.yaxis,i=t._fullLayout,a=t._fullData,s=t.calcdata,l=[],c=[],u=0;u<a.length;u++){var h=a[u];if(!0===h.visible&&o.traceIs(h,'bar')&&h.xaxis===r._id&&h.yaxis===n._id&&("h"===h.orientation?l.push(s[u]):c.push(s[u]),h._computePh))for(var p=t.calcdata[u],d=0;d<p.length;d++)"function"===typeof p[d].ph0&&(p[d].ph0=p[d].ph0()),"function"===typeof p[d].ph1&&(p[d].ph1=p[d].ph1())}var m={xCat:"category"===r.type||"multicategory"===r.type,yCat:"category"===n.type||"multicategory"===n.type,mode:i.barmode,norm:i.barnorm,gap:i.bargap,groupgap:i.bargroupgap};f(t,r,n,c,m),f(t,n,r,l,m)}function f(t,e,r,n,i){if(n.length){var a,o,s,l;switch(h(r,n),i.mode){case"overlay":p(e,r,n,i);break;case"group":for(a=[],o=[],s=0;s<n.length;s++)void 0===(l=n[s])[0].trace.offset?o.push(l):a.push(l);o.length&&d(t,e,r,o,i),a.length&&p(e,r,a,i);break;case"stack":case"relative":for(a=[],o=[],s=0;s<n.length;s++)void 0===(l=n[s])[0].trace.base?o.push(l):a.push(l);o.length&&m(t,e,r,o,i),a.length&&p(e,r,a,i)}A(n,e)}}function h(t,e){var r,a;for(r=0;r<e.length;r++){var o,s=e[r],l=s[0].trace,c="funnel"===l.type?l._base:l.base,u="h"===l.orientation?l.xcalendar:l.ycalendar,f="category"===t.type||"multicategory"===t.type?function(){return null}:t.d2c;if(i(c)){for(a=0;a<Math.min(c.length,s.length);a++)o=f(c[a],0,u),n(o)?(s[a].b=+o,s[a].hasB=1):s[a].b=0;for(;a<s.length;a++)s[a].b=0}else{o=f(c,0,u);var h=n(o);for(o=h?o:0,a=0;a<s.length;a++)s[a].b=o,h&&(s[a].hasB=1)}}}function p(t,e,r,n){for(var i=0;i<r.length;i++){var a=r[i],o=new c([a],{posAxis:t,sepNegVal:!1,overlapNoMerge:!n.norm});g(t,o,n),n.norm?(T(o),M(e,o,n)):_(e,o)}}function d(t,e,r,n,i){var a=new c(n,{posAxis:e,sepNegVal:!1,overlapNoMerge:!i.norm});v(t,e,a,i),k(a,e),i.norm?(T(a),M(r,a,i)):_(r,a)}function m(t,e,r,n,i){var o=new c(n,{posAxis:e,sepNegVal:"relative"===i.mode,overlapNoMerge:!(i.norm||"stack"===i.mode||"relative"===i.mode)});g(e,o,i),w(r,o,i);for(var s=0;s<n.length;s++)for(var l=n[s],u=0;u<l.length;u++){var f=l[u];f.s!==a&&f.b+f.s===o.get(f.p,f.s)&&(f._outmost=!0)}i.norm&&M(r,o,i)}function g(t,e,r){for(var n=e.minDiff,i=e.traces,a=n*(1-r.gap),o=a*(1-(r.groupgap||0)),s=-o/2,l=0;l<i.length;l++){var c=i[l][0].t;c.barwidth=o,c.poffset=s,c.bargroupwidth=a,c.bardelta=n}e.binWidth=i[0][0].t.barwidth/100,y(e),x(t,e),b(t,e)}function v(t,e,r,n){for(var i=t._fullLayout,a=r.positions,o=r.distinctPositions,s=r.minDiff,c=r.traces,u=c.length,f=a.length!==o.length,h=s*(1-n.gap),p=l(i,e._id)+c[0][0].trace.orientation,d=i._alignmentOpts[p]||{},m=0;m<u;m++){var g,v,_=c[m],w=_[0].trace,T=d[w.alignmentgroup]||{},k=Object.keys(T.offsetGroups||{}).length,M=(g=k?h/k:f?h/u:h)*(1-(n.groupgap||0));v=k?((2*w._offsetIndex+1-k)*g-M)/2:f?((2*m+1-u)*g-M)/2:-M/2;var A=_[0].t;A.barwidth=M,A.poffset=v,A.bargroupwidth=h,A.bardelta=s}r.binWidth=c[0][0].t.barwidth/100,y(r),x(e,r),b(e,r,f)}function y(t){var e,r,a=t.traces;for(e=0;e<a.length;e++){var o,s=a[e],l=s[0],c=l.trace,u=l.t,f=c._offset||c.offset,h=u.poffset;if(i(f)){for(o=Array.prototype.slice.call(f,0,s.length),r=0;r<o.length;r++)n(o[r])||(o[r]=h);for(r=o.length;r<s.length;r++)o.push(h);u.poffset=o}else void 0!==f&&(u.poffset=f);var p=c._width||c.width,d=u.barwidth;if(i(p)){var m=Array.prototype.slice.call(p,0,s.length);for(r=0;r<m.length;r++)n(m[r])||(m[r]=d);for(r=m.length;r<s.length;r++)m.push(d);if(u.barwidth=m,void 0===f){for(o=[],r=0;r<s.length;r++)o.push(h+(d-m[r])/2);u.poffset=o}}else void 0!==p&&(u.barwidth=p,void 0===f&&(u.poffset=h+(d-p)/2))}}function x(t,e){for(var r=e.traces,n=S(t),i=0;i<r.length;i++)for(var a=r[i],o=a[0].t,s=o.poffset,l=Array.isArray(s),c=o.barwidth,u=Array.isArray(c),f=0;f<a.length;f++){var h=a[f],p=h.w=u?c[f]:c;h[n]=h.p+(l?s[f]:s)+p/2}}function b(t,e,r){var n=e.traces,i=e.minDiff/2;s.minDtick(t,e.minDiff,e.distinctPositions[0],r);for(var a=0;a<n.length;a++){var o,l,c,u,f=n[a],h=f[0],p=h.trace,d=[];for(u=0;u<f.length;u++)l=(o=f[u]).p-i,c=o.p+i,d.push(l,c);if(p.width||p.offset){var m=h.t,g=m.poffset,v=m.barwidth,y=Array.isArray(g),x=Array.isArray(v);for(u=0;u<f.length;u++){o=f[u];var b=y?g[u]:g,_=x?v[u]:v;c=(l=o.p+b)+_,d.push(l,c)}}p._extremes[t._id]=s.findExtremes(t,d,{padded:!1})}}function _(t,e){for(var r=e.traces,n=S(t),i=0;i<r.length;i++){for(var a=r[i],o=a[0].trace,l=[],c=!1,u=0;u<a.length;u++){var f=a[u],h=f.b,p=h+f.s;f[n]=p,l.push(p),f.hasB&&l.push(h),f.hasB&&f.b||(c=!0)}o._extremes[t._id]=s.findExtremes(t,l,{tozero:c,padded:!0})}}function w(t,e,r){var n,i,o,l,c,u,f=S(t),h=e.traces;for(l=0;l<h.length;l++)if("funnel"===(i=(n=h[l])[0].trace).type)for(c=0;c<n.length;c++)(u=n[c]).s!==a&&e.put(u.p,-.5*u.s);for(l=0;l<h.length;l++){o="funnel"===(i=(n=h[l])[0].trace).type;var p=[];for(c=0;c<n.length;c++)if((u=n[c]).s!==a){var d;d=o?u.s:u.s+u.b;var m=e.put(u.p,d),g=m+d;u.b=m,u[f]=g,r.norm||(p.push(g),u.hasB&&p.push(m))}r.norm||(i._extremes[t._id]=s.findExtremes(t,p,{tozero:!0,padded:!0}))}}function T(t){for(var e=t.traces,r=0;r<e.length;r++)for(var n=e[r],i=0;i<n.length;i++){var o=n[i];o.s!==a&&t.put(o.p,o.b+o.s)}}function k(t,e){for(var r=t.traces,n=0;n<r.length;n++){var i=r[n];if(void 0===i[0].trace.base)for(var o=new c([i],{posAxis:e,sepNegVal:!0,overlapNoMerge:!0}),s=0;s<i.length;s++){var l=i[s];if(l.p!==a){var u=o.put(l.p,l.b+l.s);u&&(l.b=u)}}}}function M(t,e,r){var i=e.traces,o=S(t),l="fraction"===r.norm?1:100,c=l/1e9,u=t.l2c(t.c2l(0)),f="stack"===r.mode?l:u;function h(e){return n(t.c2l(e))&&(e<u-c||e>f+c||!n(u))}for(var p=0;p<i.length;p++){for(var d=i[p],m=d[0].trace,g=[],v=!1,y=!1,x=0;x<d.length;x++){var b=d[x];if(b.s!==a){var _=Math.abs(l/e.get(b.p,b.s));b.b*=_,b.s*=_;var w=b.b,T=w+b.s;b[o]=T,g.push(T),y=y||h(T),b.hasB&&(g.push(w),y=y||h(w)),b.hasB&&b.b||(v=!0)}}m._extremes[t._id]=s.findExtremes(t,g,{tozero:v,padded:y})}}function A(t,e){var r,i,a,o=S(e),s={},l=1/0,c=-1/0;for(r=0;r<t.length;r++)for(a=t[r],i=0;i<a.length;i++){var u=a[i].p;n(u)&&(l=Math.min(l,u),c=Math.max(c,u))}var f=1e4/(c-l),h=s.round=function(t){return String(Math.round(f*(t-l)))};for(r=0;r<t.length;r++){(a=t[r])[0].t.extents=s;var p=a[0].t.poffset,d=Array.isArray(p);for(i=0;i<a.length;i++){var m=a[i],g=m[o]-m.w/2;if(n(g)){var v=m[o]+m.w/2,y=h(m.p);s[y]?s[y]=[Math.min(g,s[y][0]),Math.max(v,s[y][1])]:s[y]=[g,v]}m.p0=m.p+(d?p[i]:p),m.p1=m.p0+m.w,m.s0=m.b,m.s1=m.s0+m.s}}}function S(t){return t._id.charAt(0)}e.exports={crossTraceCalc:u,setGroupPositions:f}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/axes":838,"../../plots/cartesian/constraints":846,"../../registry":915,"./sieve.js":938,"fast-isnumeric":246}],929:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../../registry'),o=t('../scatter/xy_defaults'),s=t('../scatter/period_defaults'),l=t('./style_defaults'),c=t('../../plots/cartesian/constraints').getAxisGroup,u=t('./attributes'),f=n.coerceFont;function h(t,e,r,c){function f(r,i){return n.coerce(t,e,u,r,i)}if(o(t,e,c,f)){s(t,e,c,f),f('xhoverformat'),f('yhoverformat'),f('orientation',e.x&&!e.y?"h":"v"),f('base'),f('offset'),f('width'),f('text'),f('hovertext'),f('hovertemplate');var h=f('textposition');m(t,e,c,f,h,{moduleHasSelected:!0,moduleHasUnselected:!0,moduleHasConstrain:!0,moduleHasCliponaxis:!0,moduleHasTextangle:!0,moduleHasInsideanchor:!0}),l(t,e,f,r,c);var p=(e.marker.line||{}).color,d=a.getComponentMethod('errorbars','supplyDefaults');d(t,e,p||i.defaultLine,{axis:"y"}),d(t,e,p||i.defaultLine,{axis:"x",inherit:"y"}),n.coerceSelectionMarkerOpacity(e,f)}else e.visible=!1}function p(t,e,r,n){var i=e.orientation,a=e[{v:"x",h:"y"}[i]+"axis"],o=c(r,a)+i,s=r._alignmentOpts||{},l=n('alignmentgroup'),u=s[o];u||(u=s[o]={});var f=u[l];f?f.traces.push(e):f=u[l]={traces:[e],alignmentIndex:Object.keys(u).length,offsetGroups:{}};var h=n('offsetgroup'),p=f.offsetGroups,d=p[h];h&&(d||(d=p[h]={offsetIndex:Object.keys(p).length}),e._offsetIndex=d.offsetIndex)}function d(t,e){var r;function i(t){return n.coerce(r._input,r,u,t)}if("group"===e.barmode)for(var a=0;a<t.length;a++)"bar"===(r=t[a]).type&&p(r._input,r,e,i)}function m(t,e,r,i,a,o)[var s=!(!1===(o=o||{]).moduleHasSelected),l=!(!1===o.moduleHasUnselected),c=!(!1===o.moduleHasConstrain),u=!(!1===o.moduleHasCliponaxis),h=!(!1===o.moduleHasTextangle),p=!(!1===o.moduleHasInsideanchor),d=!!o.hasPathbar,m=Array.isArray(a)||"auto"===a,g=m||"inside"===a,v=m||"outside"===a;if(g||v){var y=f(i,'textfont',r.font),x=n.extendFlat({},y),b=!(t.textfont&&t.textfont.color);if(b&&delete x.color,f(i,'insidetextfont',x),d)[var _=n.extendFlat({],y);b&&delete _.color,f(i,'pathbar.textfont',_)}v&&f(i,'outsidetextfont',y),s&&i('selected.textfont.color'),l&&i('unselected.textfont.color'),c&&i('constraintext'),u&&i('cliponaxis'),h&&i('textangle'),i('texttemplate')}g&&p&&i('insidetextanchor')}e.exports={supplyDefaults:h,crossTraceDefaults:d,handleGroupingDefaults:p,handleText:m}},{"../../components/color":650,"../../lib":787,"../../plots/cartesian/constraints":846,"../../registry":915,"../scatter/period_defaults":1222,"../scatter/xy_defaults":1229,"./attributes":925,"./style_defaults":940}],930:[function(t,e,r){"use strict";e.exports=function(t,e,r){return t.x="xVal"in e?e.xVal:e.x,t.y="yVal"in e?e.yVal:e.y,e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),"h"===r.orientation?(t.label=t.y,t.value=t.x):(t.label=t.x,t.value=t.y),t}},{}],931:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('tinycolor2'),a=t('../../lib').isArrayOrTypedArray;r.coerceString=function(t,e,r){if("string"===typeof e){if(e||!t.noBlank)return e}else if(("number"===typeof e||!0===e)&&!t.strict)return String(e);return void 0!==r?r:t.dflt},r.coerceNumber=function(t,e,r){if(n(e)){e=+e;var i=t.min,a=t.max;if(!(void 0!==i&&e<i||void 0!==a&&e>a))return e}return void 0!==r?r:t.dflt},r.coerceColor=function(t,e,r){return i(e).isValid()?e:void 0!==r?r:t.dflt},r.coerceEnumerated=function(t,e,r){return t.coerceNumber&&(e=+e),-1!==t.values.indexOf(e)?e:void 0!==r?r:t.dflt},r.getValue=function(t,e){var r;return Array.isArray(t)?e<t.length&&(r=t[e]):r=t,r},r.getLineWidth=function(t,e){return 0<e.mlw?e.mlw:a(t.marker.line.width)?0:t.marker.line.width}},{"../../lib":787,"fast-isnumeric":246,tinycolor2:583}],932:[function(t,e,r){"use strict";var n=t('../../components/fx'),i=t('../../registry'),a=t('../../components/color'),o=t('../../lib').fillText,s=t('./helpers').getLineWidth,l=t('../../plots/cartesian/axes').hoverLabelText,c=t('../../constants/numerical').BADNUM;function u(t,e,r,n,a){var o=f(t,e,r,n,a);if(o){var s=o.cd,l=s[0].trace,c=s[o.index];return o.color=h(l,c),i.getComponentMethod('errorbars','hoverInfo')(c,l,o),[o]}}function f(t,e,r,i,a){var s,u,f,h,p,d,m,g=t.cd,v=g[0].trace,y=g[0].t,x="closest"===i,b="waterfall"===v.type,_=t.maxHoverDistance,w=t.maxSpikeDistance;"h"===v.orientation?(s=r,u=e,f='y',h='x',p=D,d=I):(s=e,u=r,f='x',h='y',d=D,p=I);var T=v[f+"period"],k=x||T;function M(t){return S(t,-1)}function A(t){return S(t,1)}function S(t,e){var r=t.w;return t[f]+e*r/2}function E(t){return t[f+"End"]-t[f+"Start"]}var L=x?M:T?function(t){return t.p-E(t)/2}:function(t){return Math.min(M(t),t.p-y.bardelta/2)},C=x?A:T?function(t){return t.p+E(t)/2}:function(t){return Math.max(A(t),t.p+y.bardelta/2)};function P(t,e,r){return a.finiteRange&&(r=0),n.inbox(t-s,e-s,r+Math.min(1,Math.abs(e-t)/m)-1)}function I(t){return P(L(t),C(t),_)}function z(t){return P(M(t),A(t),w)}function O(t){var e=t[h];if(b){var r=Math.abs(t.rawS)||0;u>0?e+=r:u<0&&(e-=r)}return e}function D(t){var e=u,r=t.b,i=O(t);return n.inbox(r-e,i-e,_+(i-e)/(i-r)-1)}function R(t){var e=u,r=t.b,i=O(t);return n.inbox(r-e,i-e,w+(i-e)/(i-r)-1)}var F=t[f+"a"],B=t[h+"a"];function N(t){return(p(t)+d(t))/2}m=Math.abs(F.r2c(F.range[1])-F.r2c(F.range[0]));var j=n.getDistanceFunction(i,p,d,N);if(n.getClosest(g,j,t),!1!==t.index&&g[t.index].p!==c){k||(L=function(t){return Math.min(M(t),t.p-y.bargroupwidth/2)},C=function(t){return Math.max(A(t),t.p+y.bargroupwidth/2)});var U=g[t.index],V=v.base?U.b+U.s:U.s;t[h+"0"]=t[h+"1"]=B.c2p(U[h],!0),t[h+"LabelVal"]=V;var H=y.extents[y.extents.round(U.p)];t[f+"0"]=F.c2p(x?L(U):H[0],!0),t[f+"1"]=F.c2p(x?C(U):H[1],!0);var q=void 0!==U.orig_p;return t[f+"LabelVal"]=q?U.orig_p:U.p,t.labelLabel=l(F,t[f+"LabelVal"],v[f+"hoverformat"]),t.valueLabel=l(B,t[h+"LabelVal"],v[h+"hoverformat"]),t.baseLabel=l(B,U.b,v[h+"hoverformat"]),t.spikeDistance=(R(U)+z(U))/2,t[f+"Spike"]=F.c2p(U.p,!0),o(U,v,t),t.hovertemplate=v.hovertemplate,t}}function h(t,e){var r=e.mcc||t.marker.color,n=e.mlcc||t.marker.line.color,i=s(t,e);return a.opacity(r)?r:a.opacity(n)&&i?n:void 0}e.exports={hoverPoints:u,hoverOnBars:f,getTraceColor:h}},{"../../components/color":650,"../../components/fx":690,"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/axes":838,"../../registry":915,"./helpers":931}],933:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults').supplyDefaults,crossTraceDefaults:t('./defaults').crossTraceDefaults,supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc'),crossTraceCalc:t('./cross_trace_calc').crossTraceCalc,colorbar:t('../scatter/marker_colorbar'),arraysToCalcdata:t('./arrays_to_calcdata'),plot:t('./plot').plot,style:t('./style').style,styleOnSelect:t('./style').styleOnSelect,hoverPoints:t('./hover').hoverPoints,eventData:t('./event_data'),selectPoints:t('./select'),moduleType:"trace",name:"bar",basePlotModule:t('../../plots/cartesian'),categories:["bar-like",'cartesian','svg','bar','oriented','errorBarsOK','showLegend',"zoomScale"],animatable:!0,meta:{}}},{"../../plots/cartesian":852,"../scatter/marker_colorbar":1220,"./arrays_to_calcdata":924,"./attributes":925,"./calc":926,"./cross_trace_calc":928,"./defaults":929,"./event_data":930,"./hover":932,"./layout_attributes":934,"./layout_defaults":935,"./plot":936,"./select":937,"./style":939}],934:[function(t,e,r){"use strict";e.exports={barmode:{valType:"enumerated",values:["stack",'group','overlay',"relative"],dflt:"group",editType:"calc"},barnorm:{valType:"enumerated",values:["",'fraction',"percent"],dflt:"",editType:"calc"},bargap:{valType:"number",min:0,max:1,editType:"calc"},bargroupgap:{valType:"number",min:0,max:1,dflt:0,editType:"calc"}}},{}],935:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../plots/cartesian/axes'),a=t('../../lib'),o=t('./layout_attributes');e.exports=function(t,e,r){function s(r,n){return a.coerce(t,e,o,r,n)}for(var l=!1,c=!1,u=!1,f={},h=s('barmode'),p=0;p<r.length;p++){var d=r[p];if(n.traceIs(d,'bar')&&d.visible){if(l=!0,"group"===h){var m=d.xaxis+d.yaxis;f[m]&&(u=!0),f[m]=!0}d.visible&&"histogram"===d.type&&"category"!==i.getFromId({_fullLayout:e},d["v"===d.orientation?"xaxis":"yaxis"]).type&&(c=!0)}}l?("overlay"!==h&&s('barnorm'),s('bargap',c&&!u?0:.2),s('bargroupgap')):delete e.barmode}},{"../../lib":787,"../../plots/cartesian/axes":838,"../../registry":915,"./layout_attributes":934}],936:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../../lib'),o=t('../../lib/svg_text_utils'),s=t('../../components/color'),l=t('../../components/drawing'),c=t('../../registry'),u=t('../../plots/cartesian/axes').tickText,f=t('./uniform_text'),h=f.recordMinTextSize,p=f.clearMinTextSize,d=t('./style'),m=t('./helpers'),g=t('./constants'),v=t('./attributes'),y=v.text,x=v.textposition,b=t('../../components/fx/helpers').appendArrayPointValue,_=g.TEXTPAD;function w(t){return t.id}function T(t){if(t.ids)return w}function k(t,e){return t<e?1:-1}function M(t,e,r,n){var i=[],a=[],o=n?e:r,s=n?r:e;return i[0]=o.c2p(t.s0,!0),a[0]=s.c2p(t.p0,!0),i[1]=o.c2p(t.s1,!0),a[1]=s.c2p(t.p1,!0),n?[i,a]:[a,i]}function A(t,e,r,n){var i;return!e.uniformtext.mode&&S(r)?(n&&(i=n()),t.transition().duration(r.duration).ease(r.easing).each('end',(function(){i&&i()})).each('interrupt',(function()[i&&i()]))):t}function S(t){return t&&t.duration>0}function E(t,e,r,o,u,f){var h=e.xaxis,d=e.yaxis,g=t._fullLayout;u||(u={mode:g.barmode,norm:g.barmode,gap:g.bargap,groupgap:g.bargroupgap},p('bar',g));var v=a.makeTraceGroups(o,r,'trace bars').each((function(r){var o=n.select(this),c=r[0].trace,p="waterfall"===c.type,v="funnel"===c.type,y="bar"===c.type||v,x=0;p&&c.connector.visible&&"between"===c.connector.mode&&(x=c.connector.line.width/2);var b="h"===c.orientation,_=S(u),w=a.ensureSingle(o,'g','points'),E=T(c),C=w.selectAll('g.point').data(a.identity,E);C.enter().append('g').classed('point',!0),C.exit().remove(),C.each((function(o,p){var v,w,T=n.select(this),S=M(o,h,d,b),E=S[0][0],C=S[0][1],P=S[1][0],I=S[1][1],z=0===(b?C-E:I-P);if(z&&y&&m.getLineWidth(c,o)&&(z=!1),z||(z=!i(E)||!i(C)||!i(P)||!i(I)),o.isBlank=z,z&&(b?C=E:I=P),x&&!z&&(b?(E-=k(E,C)*x,C+=k(E,C)*x):(P-=k(P,I)*x,I+=k(P,I)*x)),"waterfall"===c.type){if(!z){var O=c[o.dir].marker;v=O.line.width,w=O.color}}else v=m.getLineWidth(c,o),w=o.mc||c.marker.color;function D(t){var e=n.round(v/2%1,2);return 0===u.gap&&0===u.groupgap?n.round(Math.round(t)-e,2):t}function R(t,e,r){return r&&t===e?t:Math.abs(t-e)>=2?D(t):t>e?Math.ceil(t):Math.floor(t)}if(!t._context.staticPlot){var F=s.opacity(w)<1||v>.01?D:R;E=F(E,C,b),C=F(C,E,b),P=F(P,I,!b),I=F(I,P,!b)}var B=A(a.ensureSingle(T,'path'),g,u,f);if(B.style('vector-effect','non-scaling-stroke').attr('d',isNaN((C-E)*(I-P))||z&&t._context.staticPlot?"M0,0Z":"M"+E+","+P+"V"+I+"H"+C+"V"+P+"Z").call(l.setClipUrl,e.layerClipId,t),!g.uniformtext.mode&&_){var N=l.makePointStyleFns(c);l.singlePointStyle(o,B,c,N,t)}L(t,e,T,r,p,E,C,P,I,u,f),e.layerClipId&&l.hideOutsideRangePoint(o,T.select('text'),h,d,c.xcalendar,c.ycalendar)}));var P=!1===c.cliponaxis;l.setClipUrl(o,P?null:e.layerClipId,t)}));c.getComponentMethod('errorbars','plot')(t,v,e,u)}function L(t,e,r,n,i,s,c,u,f,p,m){var g,v=e.xaxis,y=e.yaxis,x=t._fullLayout;function b(e,r,n){return a.ensureSingle(e,'text').text(r).attr({class:"bartext bartext-"+g,"text-anchor":"middle","data-notex":1}).call(l.font,n).call(o.convertToTspans,t)}var w=n[0].trace,T="h"===w.orientation,k=O(x,n,i,v,y);g=D(w,i);var M="stack"===p.mode||"relative"===p.mode,S=n[i],E=!M||S._outmost;if(k&&"none"!==g&&(!S.isBlank&&s!==c&&u!==f||"auto"!==g&&"inside"!==g)){var L=x.font,C=d.getBarColor(n[i],w),P=d.getInsideTextFont(w,i,L,C),R=d.getOutsideTextFont(w,i,L),F=r.datum();T?"log"===v.type&&F.s0<=0&&(s=v.range[0]<v.range[1]?0:v._length):"log"===y.type&&F.s0<=0&&(u=y.range[0]<y.range[1]?y._length:0);var B,N,j,U,V,H=Math.abs(c-s)-2*_,q=Math.abs(f-u)-2*_;if("outside"===g&&(E||S.hasB||(g='inside')),"auto"===g&&(E?(g='inside',B=b(r,k,V=a.ensureUniformFontSize(t,P)),j=(N=l.bBox(B.node())).width,U=N.height,j>0&&U>0&&(j<=H&&U<=q||j<=q&&U<=H||(T?H>=j*(q/U):q>=U*(H/j)))?g="inside":(g='outside',B.remove(),B=null)):g='inside'),!B){var G=(B=b(r,k,V=a.ensureUniformFontSize(t,"outside"===g?R:P))).attr('transform');if(B.attr('transform',''),j=(N=l.bBox(B.node())).width,U=N.height,B.attr('transform',G),j<=0||U<=0)return void B.remove()}var Y,W=w.textangle;(Y="outside"===g?z(s,c,u,f,N,{isHorizontal:T,constrained:"both"===w.constraintext||"outside"===w.constraintext,angle:W}):I(s,c,u,f,N,{isHorizontal:T,constrained:"both"===w.constraintext||"inside"===w.constraintext,angle:W,anchor:w.insidetextanchor})).fontSize=V.size,h(w.type,Y,x),S.transform=Y,A(B,x,p,m).attr('transform',a.getTextTransform(Y))}else r.select('text').remove()}function C(t){return"auto"===t?0:t}function P(t,e){var r=Math.PI/180*e,n=Math.abs(Math.sin(r)),i=Math.abs(Math.cos(r));return{x:t.width*i+t.height*n,y:t.width*n+t.height*i}}function I(t,e,r,n,i,a){var o=!!a.isHorizontal,s=!!a.constrained,l=a.angle||0,c=a.anchor||"end",u="end"===c,f="start"===c,h=((a.leftToRight||0)+1)/2,p=1-h,d=i.width,m=i.height,g=Math.abs(e-t),v=Math.abs(n-r),y=g>2*_&&v>2*_?_:0;g-=2*y,v-=2*y;var x=C(l);"auto"!==l||d<=g&&m<=v||!(d>g||m>v)||(d>v||m>g)&&d<m===g<v||(x+=90);var b=P(i,x),w=1;s&&(w=Math.min(1,g/b.x,v/b.y));var T=i.left*p+i.right*h,M=(i.top+i.bottom)/2,A=(t+_)*p+(e-_)*h,S=(r+n)/2,E=0,L=0;if(f||u){var I=(o?b.x:b.y)/2,z=o?k(t,e):k(r,n);o?f?(A=t+z*y,E=-z*I):(A=e-z*y,E=z*I):f?(S=r+z*y,L=-z*I):(S=n-z*y,L=z*I)}return{textX:T,textY:M,targetX:A,targetY:S,anchorX:E,anchorY:L,scale:w,rotate:x}}function z(t,e,r,n,i,a){var o,s=!!a.isHorizontal,l=!!a.constrained,c=a.angle||0,u=i.width,f=i.height,h=Math.abs(e-t),p=Math.abs(n-r);o=s?p>2*_?_:0:h>2*_?_:0;var d=1;l&&(d=s?Math.min(1,p/f):Math.min(1,h/u));var m=C(c),g=P(i,m),v=(s?g.x:g.y)/2,y=(i.left+i.right)/2,x=(i.top+i.bottom)/2,b=(t+e)/2,w=(r+n)/2,T=0,M=0,A=s?k(e,t):k(r,n);return s?(b=e-A*o,T=A*v):(w=n+A*o,M=-A*v),{textX:y,textY:x,targetX:b,targetY:w,anchorX:T,anchorY:M,scale:d,rotate:m}}function O(t,e,r,n,i){var a,o=e[0].trace;return a=o.texttemplate?R(t,e,r,n,i):o.textinfo?F(e,r,n,i):m.getValue(o.text,r),m.coerceString(y,a)}function D(t,e){var r=m.getValue(t.textposition,e);return m.coerceEnumerated(x,r)}function R(t,e,r,n,i){var o=e[0].trace,s=a.castOption(o,r,'texttemplate');if(!s)return'';var l,c,f,h,p="waterfall"===o.type,d="funnel"===o.type;function m(t){return u(c,c.c2l(t),!0).text}function g(t){return u(h,h.c2l(t),!0).text}"h"===o.orientation?(l='y',c=i,f='x',h=n):(l='x',c=n,f='y',h=i);var v=e[r],y={};y.label=v.p,y.labelLabel=y[l+"Label"]=m(v.p);var x=a.castOption(o,v.i,'text');(0===x||x)&&(y.text=x),y.value=v.s,y.valueLabel=y[f+"Label"]=g(v.s);var _={};b(_,o,v.i),p&&(y.delta=+v.rawS||v.s,y.deltaLabel=g(y.delta),y.final=v.v,y.finalLabel=g(y.final),y.initial=y.final-y.delta,y.initialLabel=g(y.initial)),d&&(y.value=v.s,y.valueLabel=g(y.value),y.percentInitial=v.begR,y.percentInitialLabel=a.formatPercent(v.begR),y.percentPrevious=v.difR,y.percentPreviousLabel=a.formatPercent(v.difR),y.percentTotal=v.sumR,y.percenTotalLabel=a.formatPercent(v.sumR));var w=a.castOption(o,v.i,'customdata');return w&&(y.customdata=w),a.texttemplateString(s,y,t._d3locale,_,y,o._meta||{})}function F(t,e,r,n){var i=t[0].trace,o="h"===i.orientation,s="waterfall"===i.type,l="funnel"===i.type;function c(t){return u(o?n:r,t,!0).text}function f(t){return u(o?r:n,+t,!0).text}var h,p=i.textinfo,d=t[e],m=p.split('+'),g=[],v=function(t){return-1!==m.indexOf(t)};if(v('label')&&g.push(c(t[e].p)),v('text')&&(0===(h=a.castOption(i,d.i,'text'))||h)&&g.push(h),s){var y=+d.rawS||d.s,x=d.v,b=x-y;v('initial')&&g.push(f(b)),v('delta')&&g.push(f(y)),v('final')&&g.push(f(x))}if(l){v('value')&&g.push(f(d.s));var _=0;v('percent initial')&&_++,v('percent previous')&&_++,v('percent total')&&_++;var w=_>1;v('percent initial')&&(h=a.formatPercent(d.begR),w&&(h+=' of initial'),g.push(h)),v('percent previous')&&(h=a.formatPercent(d.difR),w&&(h+=' of previous'),g.push(h)),v('percent total')&&(h=a.formatPercent(d.sumR),w&&(h+=' of total'),g.push(h))}return g.join('<br>')}e.exports={plot:E,toMoveInsideBar:I}},{"../../components/color":650,"../../components/drawing":672,"../../components/fx/helpers":686,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/cartesian/axes":838,"../../registry":915,"./attributes":925,"./constants":927,"./helpers":931,"./style":939,"./uniform_text":941,"@plotly/d3":58,"fast-isnumeric":246}],937:[function(t,e,r){"use strict";function n(t,e,r,n,i){var a=e.c2p(n?t.s0:t.p0,!0),o=e.c2p(n?t.s1:t.p1,!0),s=r.c2p(n?t.p0:t.s0,!0),l=r.c2p(n?t.p1:t.s1,!0);return i?[(a+o)/2,(s+l)/2]:n?[o,(s+l)/2]:[(a+o)/2,l]}e.exports=function(t,e){var r,i=t.cd,a=t.xaxis,o=t.yaxis,s=i[0].trace,l="funnel"===s.type,c="h"===s.orientation,u=[];if(!1===e)for(r=0;r<i.length;r++)i[r].selected=0;else for(r=0;r<i.length;r++){var f=i[r],h="ct"in f?f.ct:n(f,a,o,c,l);e.contains(h,!1,r,t)?(u.push({pointNumber:r,x:a.c2d(f.x),y:o.c2d(f.y)}),f.selected=1):f.selected=0}return u}},{}],938:[function(t,e,r){"use strict";e.exports=a;var n=t('../../lib').distinctVals,i=t('../../constants/numerical').BADNUM;function a(t,e){this.traces=t,this.sepNegVal=e.sepNegVal,this.overlapNoMerge=e.overlapNoMerge;for(var r=1/0,a=[],o=0;o<t.length;o++){for(var s=t[o],l=0;l<s.length;l++){var c=s[l];c.p!==i&&a.push(c.p)}s[0]&&s[0].width1&&(r=Math.min(s[0].width1,r))}this.positions=a;var u=n(a);this.distinctPositions=u.vals,1===u.vals.length&&r!==1/0?this.minDiff=r:this.minDiff=Math.min(u.minDiff,r);var f=(e.posAxis||{}).type;"category"!==f&&"multicategory"!==f||(this.minDiff=1),this.binWidth=this.minDiff,this.bins={}}a.prototype.put=function(t,e){var r=this.getLabel(t,e),n=this.bins[r]||0;return this.bins[r]=n+e,n},a.prototype.get=function(t,e){var r=this.getLabel(t,e);return this.bins[r]||0},a.prototype.getLabel=function(t,e){return(e<0&&this.sepNegVal?"v":"^")+(this.overlapNoMerge?t:Math.round(t/this.binWidth))}},{"../../constants/numerical":763,"../../lib":787}],939:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../../components/drawing'),o=t('../../lib'),s=t('../../registry'),l=t('./uniform_text').resizeText,c=t('./attributes'),u=c.textfont,f=c.insidetextfont,h=c.outsidetextfont,p=t('./helpers');function d(t){var e=n.select(t).selectAll('g.barlayer').selectAll('g.trace');l(t,e,'bar');var r=e.size(),i=t._fullLayout;e.style('opacity',(function(t){return t[0].trace.opacity})).each((function(t){("stack"===i.barmode&&r>1||0===i.bargap&&0===i.bargroupgap&&!t[0].trace.marker.line.width)&&n.select(this).attr('shape-rendering','crispEdges')})),e.selectAll('g.points').each((function(e){m(n.select(this),e[0].trace,t)})),s.getComponentMethod('errorbars','style')(e)}function m(t,e,r){a.pointStyle(t.selectAll('path'),e,r),g(t,e,r)}function g(t,e,r){t.selectAll('text').each((function(t){var i=n.select(this),s=o.ensureUniformFontSize(r,b(i,t,e,r));a.font(i,s)}))}function v(t,e,r){var n=e[0].trace;n.selectedpoints?y(r,n,t):(m(r,n,t),s.getComponentMethod('errorbars','style')(r))}function y(t,e,r){a.selectedPointStyle(t.selectAll('path'),e),x(t.selectAll('text'),e,r)}function x(t,e,r){t.each((function(t){var i,s=n.select(this);if(t.selected){i=o.ensureUniformFontSize(r,b(s,t,e,r));var l=e.selected.textfont&&e.selected.textfont.color;l&&(i.color=l),a.font(s,i)}else a.selectedTextStyle(s,e)}))}function b(t,e,r,n){var i=n._fullLayout.font,a=r.textfont;if(t.classed('bartext-inside')){var o=M(e,r);a=w(r,e.i,i,o)}else t.classed('bartext-outside')&&(a=T(r,e.i,i));return a}function _(t,e,r){return k(u,t.textfont,e,r)}function w(t,e,r,n){var a=_(t,e,r);return(void 0===t._input.textfont||void 0===t._input.textfont.color||Array.isArray(t.textfont.color)&&void 0===t.textfont.color[e])&&(a={color:i.contrast(n),family:a.family,size:a.size}),k(f,t.insidetextfont,e,a)}function T(t,e,r){var n=_(t,e,r);return k(h,t.outsidetextfont,e,n)}function k(t,e,r,n)[e=e||{];var i=p.getValue(e.family,r),a=p.getValue(e.size,r),o=p.getValue(e.color,r);return{family:p.coerceString(t.family,i,n.family),size:p.coerceNumber(t.size,a,n.size),color:p.coerceColor(t.color,o,n.color)}}function M(t,e){return"waterfall"===e.type?e[t.dir].marker.color:t.mcc||t.mc||e.marker.color}e.exports={style:d,styleTextPoints:g,styleOnSelect:v,getInsideTextFont:w,getOutsideTextFont:T,getBarColor:M,resizeText:l}},{"../../components/color":650,"../../components/drawing":672,"../../lib":787,"../../registry":915,"./attributes":925,"./helpers":931,"./uniform_text":941,"@plotly/d3":58}],940:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('../../components/colorscale/helpers').hasColorscale,a=t('../../components/colorscale/defaults'),o=t('../../lib').coercePattern;e.exports=function(t,e,r,s,l){var c=r('marker.color',s),u=i(t,'marker');u&&a(t,e,l,r,{prefix:"marker.",cLetter:"c"}),r('marker.line.color',n.defaultLine),i(t,'marker.line')&&a(t,e,l,r,{prefix:"marker.line.",cLetter:"c"}),r('marker.line.width'),r('marker.opacity'),o(r,'marker.pattern',c,u),r('selected.marker.color'),r('unselected.marker.color')}},{"../../components/color":650,"../../components/colorscale/defaults":660,"../../components/colorscale/helpers":661,"../../lib":787}],941:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib');function a(t,e,r){var a=t._fullLayout,o=a["_"+r+"Text_minsize"];if(o){var s,l="hide"===a.uniformtext.mode;switch(r){case"funnelarea":case"pie":case"sunburst":s='g.slice';break;case"treemap":case"icicle":s='g.slice, g.pathbar';break;default:s="g.points > g.point"}e.selectAll(s).each((function(t){var e=t.transform;e&&(e.scale=l&&e.hide?0:o/e.fontSize,n.select(this).select('text').attr('transform',i.getTextTransform(e)))}))}}function o(t,e,r){if(r.uniformtext.mode){var n=l(t),i=r.uniformtext.minsize,a=e.scale*e.fontSize;e.hide=a<i,r[n]=r[n]||1/0,e.hide||(r[n]=Math.min(r[n],Math.max(a,i)))}}function s(t,e)[e[l(t)]=void 0]function l(t){return"_"+t+"Text_minsize"}e.exports={recordMinTextSize:o,clearMinTextSize:s,resizeText:a}},{"../../lib":787,"@plotly/d3":58}],942:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../lib/extend').extendFlat,a=t('../scatterpolar/attributes'),o=t('../bar/attributes');e.exports={r:a.r,theta:a.theta,r0:a.r0,dr:a.dr,theta0:a.theta0,dtheta:a.dtheta,thetaunit:a.thetaunit,base:i({},o.base,{}),offset:i({},o.offset,{}),width:i({},o.width,{}),text:i({},o.text,{}),hovertext:i({},o.hovertext,{}),marker:o.marker,hoverinfo:a.hoverinfo,hovertemplate:n(),selected:o.selected,unselected:o.unselected}},{"../../lib/extend":777,"../../plots/template_attributes":910,"../bar/attributes":925,"../scatterpolar/attributes":1276}],943:[function(t,e,r){"use strict";var n=t('../../components/colorscale/helpers').hasColorscale,i=t('../../components/colorscale/calc'),a=t('../bar/arrays_to_calcdata'),o=t('../bar/cross_trace_calc').setGroupPositions,s=t('../scatter/calc_selection'),l=t('../../registry').traceIs,c=t('../../lib').extendFlat;function u(t,e){for(var r=t._fullLayout,o=e.subplot,l=r[o].radialaxis,c=r[o].angularaxis,u=l.makeCalcdata(e,'r'),f=c.makeCalcdata(e,'theta'),h=e._length,p=new Array(h),d=u,m=f,g=0;g<h;g++)p[g]={p:m[g],s:d[g]};function v(t){var r=e[t];void 0!==r&&(e["_"+t]=Array.isArray(r)?c.makeCalcdata(e,t):c.d2c(r,e.thetaunit))}return"linear"===c.type&&(v('width'),v('offset')),n(e,'marker')&&i(t,e,{vals:e.marker.color,containerStr:"marker",cLetter:"c"}),n(e,'marker.line')&&i(t,e,{vals:e.marker.line.color,containerStr:"marker.line",cLetter:"c"}),a(p,e),s(p,e),p}function f(t,e,r){for(var n=t.calcdata,i=[],a=0;a<n.length;a++){var s=n[a],u=s[0].trace;!0===u.visible&&l(u,'bar')&&u.subplot===r&&i.push(s)}var f=c({},e.radialaxis,{_id:"x"}),h=e.angularaxis;o(t,h,f,i,{mode:e.barmode,norm:e.barnorm,gap:e.bargap,groupgap:e.bargroupgap})}e.exports={calc:u,crossTraceCalc:f}},{"../../components/colorscale/calc":658,"../../components/colorscale/helpers":661,"../../lib":787,"../../registry":915,"../bar/arrays_to_calcdata":924,"../bar/cross_trace_calc":928,"../scatter/calc_selection":1204}],944:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatterpolar/defaults').handleRThetaDefaults,a=t('../bar/style_defaults'),o=t('./attributes');e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}i(t,e,s,l)?(l('thetaunit'),l('base'),l('offset'),l('width'),l('text'),l('hovertext'),l('hovertemplate'),a(t,e,l,r,s),n.coerceSelectionMarkerOpacity(e,l)):e.visible=!1}},{"../../lib":787,"../bar/style_defaults":940,"../scatterpolar/defaults":1278,"./attributes":942}],945:[function(t,e,r){"use strict";var n=t('../../components/fx'),i=t('../../lib'),a=t('../bar/hover').getTraceColor,o=i.fillText,s=t('../scatterpolar/hover').makeHoverPointText,l=t('../../plots/polar/helpers').isPtInsidePolygon;e.exports=function(t,e,r){var c=t.cd,u=c[0].trace,f=t.subplot,h=f.radialAxis,p=f.angularAxis,d=f.vangles,m=d?l:i.isPtInsideSector,g=t.maxHoverDistance,v=p._period||2*Math.PI,y=Math.abs(h.g2p(Math.sqrt(e*e+r*r))),x=Math.atan2(r,e);h.range[0]>h.range[1]&&(x+=Math.PI);var b=function(t){return m(y,x,[t.rp0,t.rp1],[t.thetag0,t.thetag1],d)?g+Math.min(1,Math.abs(t.thetag1-t.thetag0)/v)-1+(t.rp1-y)/(t.rp1-t.rp0)-1:1/0};if(n.getClosest(c,b,t),!1!==t.index){var _=c[t.index];t.x0=t.x1=_.ct[0],t.y0=t.y1=_.ct[1];var w=i.extendFlat({},_,{r:_.s,theta:_.p});return o(_,u,t),s(w,u,f,t),t.hovertemplate=u.hovertemplate,t.color=a(u,_),t.xLabelVal=t.yLabelVal=void 0,_.s<0&&(t.idealAlign='left'),[t]}}},{"../../components/fx":690,"../../lib":787,"../../plots/polar/helpers":903,"../bar/hover":932,"../scatterpolar/hover":1280}],946:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"barpolar",basePlotModule:t('../../plots/polar'),categories:["polar",'bar',"showLegend"],attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults'),supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc').calc,crossTraceCalc:t('./calc').crossTraceCalc,plot:t('./plot'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('../scatterpolar/format_labels'),style:t('../bar/style').style,styleOnSelect:t('../bar/style').styleOnSelect,hoverPoints:t('./hover'),selectPoints:t('../bar/select'),meta:{}}},{"../../plots/polar":904,"../bar/select":937,"../bar/style":939,"../scatter/marker_colorbar":1220,"../scatterpolar/format_labels":1279,"./attributes":942,"./calc":943,"./defaults":944,"./hover":945,"./layout_attributes":947,"./layout_defaults":948,"./plot":949}],947:[function(t,e,r){"use strict";e.exports={barmode:{valType:"enumerated",values:["stack","overlay"],dflt:"stack",editType:"calc"},bargap:{valType:"number",dflt:.1,min:0,max:1,editType:"calc"}}},{}],948:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e,r){var a,o={};function s(r,o){return n.coerce(t[a]||{},e[a],i,r,o)}for(var l=0;l<r.length;l++){var c=r[l];"barpolar"===c.type&&!0===c.visible&&(o[a=c.subplot]||(s('barmode'),s('bargap'),o[a]=1))}}},{"../../lib":787,"./layout_attributes":947}],949:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('fast-isnumeric'),a=t('../../lib'),o=t('../../components/drawing'),s=t('../../plots/polar/helpers');function l(t){var e=t.cxx,r=t.cyy;return t.vangles?function(n,i,o,l){var c,u;a.angleDelta(o,l)>0?(c=o,u=l):(c=l,u=o);var f=[s.findEnclosingVertexAngles(c,t.vangles)[0],(c+u)/2,s.findEnclosingVertexAngles(u,t.vangles)[1]];return s.pathPolygonAnnulus(n,i,c,u,f,e,r)}:function(t,n,i,o){return a.pathAnnulus(t,n,i,o,e,r)}}e.exports=function(t,e,r){var s=e.xaxis,c=e.yaxis,u=e.radialAxis,f=e.angularAxis,h=l(e),p=e.layers.frontplot.select('g.barlayer');a.makeTraceGroups(p,r,'trace bars').each((function(){var r=n.select(this),l=a.ensureSingle(r,'g','points').selectAll('g.point').data(a.identity);l.enter().append('g').style('vector-effect','non-scaling-stroke').style('stroke-miterlimit',2).classed('point',!0),l.exit().remove(),l.each((function(t){var e,r=n.select(this),o=t.rp0=u.c2p(t.s0),l=t.rp1=u.c2p(t.s1),p=t.thetag0=f.c2g(t.p0),d=t.thetag1=f.c2g(t.p1);if(i(o)&&i(l)&&i(p)&&i(d)&&o!==l&&p!==d){var m=u.c2g(t.s1),g=(p+d)/2;t.ct=[s.c2p(m*Math.cos(g)),c.c2p(m*Math.sin(g))],e=h(o,l,p,d)}else e='M0,0Z';a.ensureSingle(r,'path').attr('d',e)})),o.setClipUrl(r,e._hasClipOnAxisFalse?e.clipIds.forTraces:null,t)}))}},{"../../components/drawing":672,"../../lib":787,"../../plots/polar/helpers":903,"@plotly/d3":58,"fast-isnumeric":246}],950:[function(t,e,r){"use strict";var n=t('../scatter/attributes'),i=t('../bar/attributes'),a=t('../../components/color/attributes'),o=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,s=t('../../plots/template_attributes').hovertemplateAttrs,l=t('../../lib/extend').extendFlat,c=n.marker,u=c.line;e.exports={y:{valType:"data_array",editType:"calc+clearAxisTypes"},x:{valType:"data_array",editType:"calc+clearAxisTypes"},x0:{valType:"any",editType:"calc+clearAxisTypes"},y0:{valType:"any",editType:"calc+clearAxisTypes"},dx:{valType:"number",editType:"calc"},dy:{valType:"number",editType:"calc"},xperiod:n.xperiod,yperiod:n.yperiod,xperiod0:n.xperiod0,yperiod0:n.yperiod0,xperiodalignment:n.xperiodalignment,yperiodalignment:n.yperiodalignment,xhoverformat:o('x'),yhoverformat:o('y'),name:{valType:"string",editType:"calc+clearAxisTypes"},q1:{valType:"data_array",editType:"calc+clearAxisTypes"},median:{valType:"data_array",editType:"calc+clearAxisTypes"},q3:{valType:"data_array",editType:"calc+clearAxisTypes"},lowerfence:{valType:"data_array",editType:"calc"},upperfence:{valType:"data_array",editType:"calc"},notched:{valType:"boolean",editType:"calc"},notchwidth:{valType:"number",min:0,max:.5,dflt:.25,editType:"calc"},notchspan:{valType:"data_array",editType:"calc"},boxpoints:{valType:"enumerated",values:["all",'outliers','suspectedoutliers',!1],editType:"calc"},jitter:{valType:"number",min:0,max:1,editType:"calc"},pointpos:{valType:"number",min:-2,max:2,editType:"calc"},boxmean:{valType:"enumerated",values:[!0,'sd',!1],editType:"calc"},mean:{valType:"data_array",editType:"calc"},sd:{valType:"data_array",editType:"calc"},orientation:{valType:"enumerated",values:["v","h"],editType:"calc+clearAxisTypes"},quartilemethod:{valType:"enumerated",values:["linear",'exclusive',"inclusive"],dflt:"linear",editType:"calc"},width:{valType:"number",min:0,dflt:0,editType:"calc"},marker:{outliercolor:{valType:"color",dflt:"rgba(0, 0, 0, 0)",editType:"style"},symbol:l({},c.symbol,{arrayOk:!1,editType:"plot"}),opacity:l({},c.opacity,{arrayOk:!1,dflt:1,editType:"style"}),size:l({},c.size,{arrayOk:!1,editType:"calc"}),color:l({},c.color,{arrayOk:!1,editType:"style"}),line:{color:l({},u.color,{arrayOk:!1,dflt:a.defaultLine,editType:"style"}),width:l({},u.width,{arrayOk:!1,dflt:0,editType:"style"}),outliercolor:{valType:"color",editType:"style"},outlierwidth:{valType:"number",min:0,dflt:1,editType:"style"},editType:"style"},editType:"plot"},line:{color:{valType:"color",editType:"style"},width:{valType:"number",min:0,dflt:2,editType:"style"},editType:"plot"},fillcolor:n.fillcolor,whiskerwidth:{valType:"number",min:0,max:1,dflt:.5,editType:"calc"},offsetgroup:i.offsetgroup,alignmentgroup:i.alignmentgroup,selected:{marker:n.selected.marker,editType:"style"},unselected:{marker:n.unselected.marker,editType:"style"},text:l({},n.text,{}),hovertext:l({},n.hovertext,{}),hovertemplate:s({}),hoveron:{valType:"flaglist",flags:["boxes","points"],dflt:"boxes+points",editType:"style"}}},{"../../components/color/attributes":649,"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../bar/attributes":925,"../scatter/attributes":1202}],951:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../plots/cartesian/axes'),a=t('../../plots/cartesian/align_period'),o=t('../../lib'),s=t('../../constants/numerical').BADNUM,l=o._;function c(t,e,r,i){var s,l=e+"0"in t;if(e in t||l&&"d"+e in t){var c=r.makeCalcdata(t,e);return[a(t,r,e,c).vals,c]}s=l?t[e+"0"]:"name"in t&&("category"===r.type||n(t.name)&&-1!==["linear","log"].indexOf(r.type)||o.isDateTime(t.name)&&"date"===r.type)?t.name:i;for(var u="multicategory"===r.type?r.r2c_just_indices(s):r.d2c(s,0,t[e+"calendar"]),f=t._length,h=new Array(f),p=0;p<f;p++)h[p]=u;return[h]}function u(t,e){for(var r=t.length,n=new Array(r+1),i=0;i<r;i++)n[i]=t[i]-e;return n[r]=t[r-1]+e,n}function f(t){for(var e=new Array(t),r=0;r<t;r++)e[r]=[];return e}e.exports=function(t,e){var r,a,h,w,T,k,M,A=t._fullLayout,S=i.getFromId(t,e.xaxis||"x"),E=i.getFromId(t,e.yaxis||"y"),L=[],C="violin"===e.type?"_numViolins":"_numBoxes";"h"===e.orientation?(h=S,w='x',T=E,k='y',M=!!e.yperiodalignment):(h=E,w='y',T=S,k='x',M=!!e.xperiodalignment);var P,I,z,O,D,R,F=c(e,k,T,A[C]),B=F[0],N=F[1],j=o.distinctVals(B,T),U=j.vals,V=j.minDiff/2,H="all"===(e.boxpoints||e.points)?o.identity:function(t){return t.v<P.lf||t.v>P.uf};if(e._hasPreCompStats){var q=e[w],G=function(t){return h.d2c((e[t]||[])[r])},Y=1/0,W=-1/0;for(r=0;r<e._length;r++){var X=B[r];if(n(X)){if((P={}).pos=P[k]=X,M&&N&&(P.orig_p=N[r]),P.q1=G('q1'),P.med=G('median'),P.q3=G('q3'),I=[],q&&o.isArrayOrTypedArray(q[r]))for(a=0;a<q[r].length;a++)(R=h.d2c(q[r][a]))!==s&&(p(D={v:R,i:[r,a]},e,[r,a]),I.push(D));if(P.pts=I.sort(m),O=(z=P[w]=I.map(g)).length,P.med!==s&&P.q1!==s&&P.q3!==s&&P.med>=P.q1&&P.q3>=P.med){var Z=G('lowerfence');P.lf=Z!==s&&Z<=P.q1?Z:v(P,z,O);var J=G('upperfence');P.uf=J!==s&&J>=P.q3?J:y(P,z,O);var K=G('mean');P.mean=K!==s?K:O?o.mean(z,O):(P.q1+P.q3)/2;var Q=G('sd');P.sd=K!==s&&Q>=0?Q:O?o.stdev(z,O,P.mean):P.q3-P.q1,P.lo=x(P),P.uo=b(P);var $=G('notchspan');$=$!==s&&$>0?$:_(P,O),P.ln=P.med-$,P.un=P.med+$;var tt=P.lf,et=P.uf;e.boxpoints&&z.length&&(tt=Math.min(tt,z[0]),et=Math.max(et,z[O-1])),e.notched&&(tt=Math.min(tt,P.ln),et=Math.max(et,P.un)),P.min=tt,P.max=et}else{var rt;o.warn(["Invalid input - make sure that q1 <= median <= q3","q1 = "+P.q1,"median = "+P.med,"q3 = "+P.q3].join('\n')),rt=P.med!==s?P.med:P.q1!==s?P.q3!==s?(P.q1+P.q3)/2:P.q1:P.q3!==s?P.q3:0,P.med=rt,P.q1=P.q3=rt,P.lf=P.uf=rt,P.mean=P.sd=rt,P.ln=P.un=rt,P.min=P.max=rt}Y=Math.min(Y,P.min),W=Math.max(W,P.max),P.pts2=I.filter(H),L.push(P)}}e._extremes[h._id]=i.findExtremes(h,[Y,W],{padded:!0})}else{var nt=h.makeCalcdata(e,w),it=u(U,V),at=U.length,ot=f(at);for(r=0;r<e._length;r++)if(R=nt[r],n(R)){var st=o.findBin(B[r],it);st>=0&&st<at&&(p(D={v:R,i:r},e,r),ot[st].push(D))}var lt=1/0,ct=-1/0,ut=e.quartilemethod,ft="exclusive"===ut,ht="inclusive"===ut;for(r=0;r<at;r++)if(ot[r].length>0){var pt,dt;(P={}).pos=P[k]=U[r],I=P.pts=ot[r].sort(m),O=(z=P[w]=I.map(g)).length,P.min=z[0],P.max=z[O-1],P.mean=o.mean(z,O),P.sd=o.stdev(z,O,P.mean),P.med=o.interp(z,.5),O%2&&(ft||ht)?(ft?(pt=z.slice(0,O/2),dt=z.slice(O/2+1)):ht&&(pt=z.slice(0,O/2+1),dt=z.slice(O/2)),P.q1=o.interp(pt,.5),P.q3=o.interp(dt,.5)):(P.q1=o.interp(z,.25),P.q3=o.interp(z,.75)),P.lf=v(P,z,O),P.uf=y(P,z,O),P.lo=x(P),P.uo=b(P);var mt=_(P,O);P.ln=P.med-mt,P.un=P.med+mt,lt=Math.min(lt,P.ln),ct=Math.max(ct,P.un),P.pts2=I.filter(H),L.push(P)}e._extremes[h._id]=i.findExtremes(h,e.notched?nt.concat([lt,ct]):nt,{padded:!0})}return d(L,e),L.length>0?(L[0].t={num:A[C],dPos:V,posLetter:k,valLetter:w,labels:{med:l(t,'median:'),min:l(t,'min:'),q1:l(t,'q1:'),q3:l(t,'q3:'),max:l(t,'max:'),mean:"sd"===e.boxmean?l(t,'mean \xb1 \u03c3:'):l(t,'mean:'),lf:l(t,'lower fence:'),uf:l(t,'upper fence:')}},A[C]++,L):[t:{empty:!0}}];var h={text:"tx",hovertext:"htx"};function p(t,e,r){for(var n in h)o.isArrayOrTypedArray(e[n])&&(Array.isArray(r)?o.isArrayOrTypedArray(e[n][r[0]])&&(t[h[n]]=e[n][r[0]][r[1]]):t[h[n]]=e[n][r])}function d(t,e){if(o.isArrayOrTypedArray(e.selectedpoints))for(var r=0;r<t.length;r++){for(var n=t[r].pts||[],i={},a=0;a<n.length;a++)i[n[a].i]=a;o.tagSelected(n,e,i)}}function m(t,e){return t.v-e.v}function g(t){return t.v}function v(t,e,r){return 0===r?t.q1:Math.min(t.q1,e[Math.min(o.findBin(2.5*t.q1-1.5*t.q3,e,!0)+1,r-1)])}function y(t,e,r){return 0===r?t.q3:Math.max(t.q3,e[Math.max(o.findBin(2.5*t.q3-1.5*t.q1,e),0)])}function x(t){return 4*t.q1-3*t.q3}function b(t){return 4*t.q3-3*t.q1}function _(t,e){return 0===e?0:1.57*(t.q3-t.q1)/Math.sqrt(e)}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"fast-isnumeric":246}],952:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib'),a=t('../../plots/cartesian/constraints').getAxisGroup,o=["v","h"];function s(t,e){for(var r=t.calcdata,n=e.xaxis,i=e.yaxis,a=0;a<o.length;a++){for(var s=o[a],c="h"===s?i:n,u=[],f=0;f<r.length;f++){var h=r[f],p=h[0].t,d=h[0].trace;!0!==d.visible||"box"!==d.type&&"candlestick"!==d.type||p.empty||(d.orientation||"v")!==s||d.xaxis!==n._id||d.yaxis!==i._id||u.push(f)}l('box',t,u,c)}}function l(t,e,r,o){var s,l,c,u=e.calcdata,f=e._fullLayout,h=o._id,p=h.charAt(0),d=[],m=0;for(s=0;s<r.length;s++)for(c=u[r[s]],l=0;l<c.length;l++)d.push(o.c2l(c[l].pos,!0)),m+=(c[l].pts2||[]).length;if(d.length){var g=i.distinctVals(d);"category"!==o.type&&"multicategory"!==o.type||(g.minDiff=1);var v=g.minDiff/2;n.minDtick(o,g.minDiff,g.vals[0],!0);var y=f["violin"===t?"_numViolins":"_numBoxes"],x="group"===f[t+"mode"]&&y>1,b=1-f[t+"gap"],_=1-f[t+"groupgap"];for(s=0;s<r.length;s++){var w,T,k,M,A,S,E=(c=u[r[s]])[0].trace,L=c[0].t,C=E.width,P=E.side;if(C)w=T=M=C/2,k=0;else if(w=v,x){var I=a(f,o._id)+E.orientation,z=(f._alignmentOpts[I]||{})[E.alignmentgroup]||{},O=Object.keys(z.offsetGroups||{}).length,D=O||y;T=w*b*_/D,k=2*w*(((O?E._offsetIndex:L.num)+.5)/D-.5)*b,M=w*b/D}else T=w*b*_,k=0,M=w;L.dPos=w,L.bPos=k,L.bdPos=T,L.wHover=M;var R,F,B,N,j,U,V=k+T,H=Boolean(C);if("positive"===P?(A=w*(C?1:.5),R=V,S=R=k):"negative"===P?(A=R=k,S=w*(C?1:.5),F=V):(A=S=w,R=F=V),(E.boxpoints||E.points)&&m>0){var q=E.pointpos,G=E.jitter,Y=E.marker.size/2,W=0;q+G>=0&&((W=V*(q+G))>A?(H=!0,j=Y,B=W):W>R&&(j=Y,B=A)),W<=A&&(B=A);var X=0;q-G<=0&&((X=-V*(q-G))>S?(H=!0,U=Y,N=X):X>F&&(U=Y,N=S)),X<=S&&(N=S)}else B=A,N=S;var Z=new Array(c.length);for(l=0;l<c.length;l++)Z[l]=c[l].pos;E._extremes[h]=n.findExtremes(o,Z,{padded:H,vpadminus:N,vpadplus:B,vpadLinearized:!0,ppadminus:{x:U,y:j}[p],ppadplus:{x:j,y:U}[p]})}}}e.exports={crossTraceCalc:s,setPositionOffset:l}},{"../../lib":787,"../../plots/cartesian/axes":838,"../../plots/cartesian/constraints":846}],953:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry'),a=t('../../components/color'),o=t('../scatter/period_defaults'),s=t('../bar/defaults').handleGroupingDefaults,l=t('../../plots/cartesian/axis_autotype'),c=t('./attributes');function u(t,e,r,i){function s(r,i){return n.coerce(t,e,c,r,i)}if(f(t,e,s,i),!1!==e.visible){o(t,e,i,s),s('xhoverformat'),s('yhoverformat');var l=e._hasPreCompStats;l&&(s('lowerfence'),s('upperfence')),s('line.color',(t.marker||{}).color||r),s('line.width'),s('fillcolor',a.addOpacity(e.line.color,.5));var u=!1;if(l){var p=s('mean'),d=s('sd');p&&p.length&&(u=!0,d&&d.length&&(u='sd'))}s('boxmean',u),s('whiskerwidth'),s('width'),s('quartilemethod');var m=!1;if(l){var g=s('notchspan');g&&g.length&&(m=!0)}else n.validate(t.notchwidth,c.notchwidth)&&(m=!0);s('notched',m)&&s('notchwidth'),h(t,e,s,{prefix:"box"})}}function f(t,e,r,a){function o(t){var e=0;return t&&t.length&&(e+=1,n.isArrayOrTypedArray(t[0])&&t[0].length&&(e+=1)),e}function s(e){return n.validate(t[e],c[e])}var u,f=r('y'),h=r('x');if("box"===e.type){var p=r('q1'),d=r('median'),m=r('q3');e._hasPreCompStats=p&&p.length&&d&&d.length&&m&&m.length,u=Math.min(n.minRowLength(p),n.minRowLength(d),n.minRowLength(m))}var g,v,y=o(f),x=o(h),b=y&&n.minRowLength(f),_=x&&n.minRowLength(h),w=a.calendar,T={autotypenumbers:a.autotypenumbers};if(e._hasPreCompStats)switch(String(x)+String(y)){case"00":var k=s('x0')||s('dx');g=!s('y0')&&!s('dy')||k?"v":"h",v=u;break;case"10":g='v',v=Math.min(u,_);break;case"20":g='h',v=Math.min(u,h.length);break;case"01":g='h',v=Math.min(u,b);break;case"02":g='v',v=Math.min(u,f.length);break;case"12":g='v',v=Math.min(u,_,f.length);break;case"21":g='h',v=Math.min(u,h.length,b);break;case"11":v=0;break;case"22":var M,A=!1;for(M=0;M<h.length;M++)if("category"===l(h[M],w,T)){A=!0;break}if(A)g='v',v=Math.min(u,_,f.length);else{for(M=0;M<f.length;M++)if("category"===l(f[M],w,T)){A=!0;break}A?(g='h',v=Math.min(u,h.length,b)):(g='v',v=Math.min(u,_,f.length))}}else y>0?(g='v',v=x>0?Math.min(_,b):Math.min(b)):x>0?(g='h',v=Math.min(_)):v=0;if(v){e._length=v;var S=r('orientation',g);e._hasPreCompStats?"v"===S&&0===x?(r('x0',0),r('dx',1)):"h"===S&&0===y&&(r('y0',0),r('dy',1)):"v"===S&&0===x?r('x0'):"h"===S&&0===y&&r('y0'),i.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x","y"],a)}else e.visible=!1}function h(t,e,r,i){var a=i.prefix,o=n.coerce2(t,e,c,'marker.outliercolor'),s=r('marker.line.outliercolor'),l='outliers';e._hasPreCompStats?l="all":(o||s)&&(l='suspectedoutliers');var u=r(a+"points",l);u?(r('jitter',"all"===u?.3:0),r('pointpos',"all"===u?-1.5:0),r('marker.symbol'),r('marker.opacity'),r('marker.size'),r('marker.color',e.line.color),r('marker.line.color'),r('marker.line.width'),"suspectedoutliers"===u&&(r('marker.line.outliercolor',e.marker.color),r('marker.line.outlierwidth')),r('selected.marker.color'),r('unselected.marker.color'),r('selected.marker.size'),r('unselected.marker.size'),r('text'),r('hovertext')):delete e.marker;var f=r('hoveron');"all"!==f&&-1===f.indexOf('points')||r('hovertemplate'),n.coerceSelectionMarkerOpacity(e,r)}function p(t,e){var r,i;function a(t){return n.coerce(i._input,i,c,t)}for(var o=0;o<t.length;o++){var l=(i=t[o]).type;"box"!==l&&"violin"!==l||(r=i._input,"group"===e[l+"mode"]&&s(r,i,e,a))}}e.exports={supplyDefaults:u,crossTraceDefaults:p,handleSampleDefaults:f,handlePointsDefaults:h}},{"../../components/color":650,"../../lib":787,"../../plots/cartesian/axis_autotype":839,"../../registry":915,"../bar/defaults":929,"../scatter/period_defaults":1222,"./attributes":950}],954:[function(t,e,r){"use strict";e.exports=function(t,e){return e.hoverOnBox&&(t.hoverOnBox=e.hoverOnBox),"xVal"in e&&(t.x=e.xVal),"yVal"in e&&(t.y=e.yVal),e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),t}},{}],955:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib'),a=t('../../components/fx'),o=t('../../components/color'),s=i.fillText;function l(t,e,r,n){var i,a=t.cd[0].trace.hoveron,o=[];return-1!==a.indexOf('boxes')&&(o=o.concat(c(t,e,r,n))),-1!==a.indexOf('points')&&(i=u(t,e,r)),"closest"===n?i?[i]:o:i?(o.push(i),o):o}function c(t,e,r,s){var l,c,u,f,h,p,d,m,g,v,y,x,b,_,w=t.cd,T=t.xa,k=t.ya,M=w[0].trace,A=w[0].t,S="violin"===M.type,E=[],L=A.bdPos,C=A.wHover,P=function(t){return u.c2l(t.pos)+A.bPos-u.c2l(p)};S&&"both"!==M.side?("positive"===M.side&&(g=function(t){var e=P(t);return a.inbox(e,e+C,v)},x=L,b=0),"negative"===M.side&&(g=function(t){var e=P(t);return a.inbox(e-C,e,v)},x=0,b=L)):(g=function(t){var e=P(t);return a.inbox(e-C,e+C,v)},x=b=L),_=S?function(t){return a.inbox(t.span[0]-h,t.span[1]-h,v)}:function(t){return a.inbox(t.min-h,t.max-h,v)},"h"===M.orientation?(h=e,p=r,d=_,m=g,l='y',u=k,c='x',f=T):(h=r,p=e,d=g,m=_,l='x',u=T,c='y',f=k);var I=Math.min(1,L/Math.abs(u.r2c(u.range[1])-u.r2c(u.range[0])));function z(t){return(d(t)+m(t))/2}v=t.maxHoverDistance-I,y=t.maxSpikeDistance-I;var O=a.getDistanceFunction(s,d,m,z);if(a.getClosest(w,O,t),!1===t.index)return[];var D=w[t.index],R=M.line.color,F=(M.marker||{}).color;o.opacity(R)&&M.line.width?t.color=R:o.opacity(F)&&M.boxpoints?t.color=F:t.color=M.fillcolor,t[l+"0"]=u.c2p(D.pos+A.bPos-b,!0),t[l+"1"]=u.c2p(D.pos+A.bPos+x,!0),t[l+"LabelVal"]=void 0!==D.orig_p?D.orig_p:D.pos;var B=l+"Spike";t.spikeDistance=z(D)*y/v,t[B]=u.c2p(D.pos,!0);var N={},j=["med",'q1','q3','min',"max"];(M.boxmean||(M.meanline||{}).visible)&&j.push('mean'),(M.boxpoints||M.points)&&j.push('lf','uf');for(var U=0;U<j.length;U++){var V=j[U];if(V in D&&!(D[V]in N)){N[D[V]]=!0;var H=D[V],q=f.c2p(H,!0),G=i.extendFlat({},t);G.attr=V,G[c+"0"]=G[c+"1"]=q,G[c+"LabelVal"]=H,G[c+"Label"]=(A.labels?A.labels[V]+" ":"")+n.hoverLabelText(f,H,M[c+"hoverformat"]),G.hoverOnBox=!0,"mean"===V&&"sd"in D&&"sd"===M.boxmean&&(G[c+"err"]=D.sd),t.name='',t.spikeDistance=void 0,t[B]=void 0,G.hovertemplate=!1,E.push(G)}}return E}function u(t,e,r){for(var n,o,l,c=t.cd,u=t.xa,f=t.ya,h=c[0].trace,p=u.c2p(e),d=f.c2p(r),m=function(t){var e=Math.max(3,t.mrc||0);return Math.max(Math.abs(u.c2p(t.x)-p)-e,1-3/e)},g=function(t){var e=Math.max(3,t.mrc||0);return Math.max(Math.abs(f.c2p(t.y)-d)-e,1-3/e)},v=a.quadrature(m,g),y=!1,x=0;x<c.length;x++){o=c[x];for(var b=0;b<(o.pts||[]).length;b++){var _=v(l=o.pts[b]);_<=t.distance&&(t.distance=_,y=[x,b])}}if(!y)return!1;l=(o=c[y[0]]).pts[y[1]];var w=u.c2p(l.x,!0),T=f.c2p(l.y,!0),k=l.mrc||1;n=i.extendFlat({},t,{index:l.i,color:(h.marker||{}).color,name:h.name,x0:w-k,x1:w+k,y0:T-k,y1:T+k,spikeDistance:t.distance,hovertemplate:h.hovertemplate});var M,A=o.orig_p,S=void 0!==A?A:o.pos;return"h"===h.orientation?(M=f,n.xLabelVal=l.x,n.yLabelVal=S):(M=u,n.xLabelVal=S,n.yLabelVal=l.y),n[M._id.charAt(0)+"Spike"]=M.c2p(o.pos,!0),s(l,h,n),n}e.exports={hoverPoints:l,hoverOnBoxes:c,hoverOnPoints:u}},{"../../components/color":650,"../../components/fx":690,"../../lib":787,"../../plots/cartesian/axes":838}],956:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults').supplyDefaults,crossTraceDefaults:t('./defaults').crossTraceDefaults,supplyLayoutDefaults:t('./layout_defaults').supplyLayoutDefaults,calc:t('./calc'),crossTraceCalc:t('./cross_trace_calc').crossTraceCalc,plot:t('./plot').plot,style:t('./style').style,styleOnSelect:t('./style').styleOnSelect,hoverPoints:t('./hover').hoverPoints,eventData:t('./event_data'),selectPoints:t('./select'),moduleType:"trace",name:"box",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','symbols','oriented','box-violin','showLegend','boxLayout',"zoomScale"],meta:{}}},{"../../plots/cartesian":852,"./attributes":950,"./calc":951,"./cross_trace_calc":952,"./defaults":953,"./event_data":954,"./hover":955,"./layout_attributes":957,"./layout_defaults":958,"./plot":959,"./select":960,"./style":961}],957:[function(t,e,r){"use strict";e.exports={boxmode:{valType:"enumerated",values:["group","overlay"],dflt:"overlay",editType:"calc"},boxgap:{valType:"number",min:0,max:1,dflt:.3,editType:"calc"},boxgroupgap:{valType:"number",min:0,max:1,dflt:.3,editType:"calc"}}},{}],958:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('./layout_attributes');function o(t,e,r,i,a){for(var o=a+"Layout",s=!1,l=0;l<r.length;l++){var c=r[l];if(n.traceIs(c,o)){s=!0;break}}s&&(i(a+"mode"),i(a+"gap"),i(a+"groupgap"))}function s(t,e,r){function n(r,n){return i.coerce(t,e,a,r,n)}o(t,e,r,n,'box')}e.exports={supplyLayoutDefaults:s,_supply:o}},{"../../lib":787,"../../registry":915,"./layout_attributes":957}],959:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=5,s=.01;function l(t,e,r,a){var o=e.xaxis,s=e.yaxis;i.makeTraceGroups(a,r,'trace boxes').each((function(t){var e,r,i=n.select(this),a=t[0],l=a.t,h=a.trace;l.wdPos=l.bdPos*h.whiskerwidth,!0!==h.visible||l.empty?i.remove():("h"===h.orientation?(e=s,r=o):(e=o,r=s),c(i,{pos:e,val:r},h,l),u(i,{x:o,y:s},h,l),f(i,{pos:e,val:r},h,l))}))}function c(t,e,r,a){var o,s,l="h"===r.orientation,c=e.val,u=e.pos,f=!!u.rangebreaks,h=a.bPos,p=a.wdPos||0,d=a.bPosPxOffset||0,m=r.whiskerwidth||0,g=r.notched||!1,v=g?1-2*r.notchwidth:1;Array.isArray(a.bdPos)?(o=a.bdPos[0],s=a.bdPos[1]):(o=a.bdPos,s=a.bdPos);var y=t.selectAll('path.box').data("violin"!==r.type||r.box.visible?i.identity:[]);y.enter().append('path').style('vector-effect','non-scaling-stroke').attr('class','box'),y.exit().remove(),y.each((function(t){if(t.empty)return'M0,0Z';var e=u.c2l(t.pos+h,!0),a=u.l2p(e-o)+d,y=u.l2p(e+s)+d,x=f?(a+y)/2:u.l2p(e)+d,b=r.whiskerwidth,_=f?a*b+(1-b)*x:u.l2p(e-p)+d,w=f?y*b+(1-b)*x:u.l2p(e+p)+d,T=u.l2p(e-o*v)+d,k=u.l2p(e+s*v)+d,M=c.c2p(t.q1,!0),A=c.c2p(t.q3,!0),S=i.constrain(c.c2p(t.med,!0),Math.min(M,A)+1,Math.max(M,A)-1),E=void 0===t.lf||!1===r.boxpoints,L=c.c2p(E?t.min:t.lf,!0),C=c.c2p(E?t.max:t.uf,!0),P=c.c2p(t.ln,!0),I=c.c2p(t.un,!0);l?n.select(this).attr('d',"M"+S+","+T+"V"+k+"M"+M+","+a+"V"+y+(g?"H"+P+"L"+S+","+k+"L"+I+","+y:"")+"H"+A+"V"+a+(g?"H"+I+"L"+S+","+T+"L"+P+","+a:"")+"ZM"+M+","+x+"H"+L+"M"+A+","+x+"H"+C+(0===m?"":"M"+L+","+_+"V"+w+"M"+C+","+_+"V"+w)):n.select(this).attr('d',"M"+T+","+S+"H"+k+"M"+a+","+M+"H"+y+(g?"V"+P+"L"+k+","+S+"L"+y+","+I:"")+"V"+A+"H"+a+(g?"V"+I+"L"+T+","+S+"L"+a+","+P:"")+"ZM"+x+","+M+"V"+L+"M"+x+","+A+"V"+C+(0===m?"":"M"+_+","+L+"H"+w+"M"+_+","+C+"H"+w))}))}function u(t,e,r,n){var l=e.x,c=e.y,u=n.bdPos,f=n.bPos,h=r.boxpoints||r.points;i.seedPseudoRandom();var p=function(t){return t.forEach((function(t){t.t=n,t.trace=r})),t},d=t.selectAll('g.points').data(h?p:[]);d.enter().append('g').attr('class','points'),d.exit().remove();var m=d.selectAll('path').data((function(t){var e,n,a=t.pts2,l=Math.max((t.max-t.min)/10,t.q3-t.q1),c=1e-9*l,p=l*s,d=[],m=0;if(r.jitter){if(0===l)for(m=1,d=new Array(a.length),e=0;e<a.length;e++)d[e]=1;else for(e=0;e<a.length;e++){var g=Math.max(0,e-o),v=a[g].v,y=Math.min(a.length-1,e+o),x=a[y].v;"all"!==h&&(a[e].v<t.lf?x=Math.min(x,t.lf):v=Math.max(v,t.uf));var b=Math.sqrt(p*(y-g)/(x-v+c))||0;b=i.constrain(Math.abs(b),0,1),d.push(b),m=Math.max(b,m)}n=2*r.jitter/(m||1)}for(e=0;e<a.length;e++){var _=a[e],w=_.v,T=r.jitter?n*d[e]*(i.pseudoRandom()-.5):0,k=t.pos+f+u*(r.pointpos+T);"h"===r.orientation?(_.y=k,_.x=w):(_.x=k,_.y=w),"suspectedoutliers"===h&&w<t.uo&&w>t.lo&&(_.so=!0)}return a}));m.enter().append('path').classed('point',!0),m.exit().remove(),m.call(a.translatePoints,l,c)}function f(t,e,r,a){var o,s,l=e.val,c=e.pos,u=!!c.rangebreaks,f=a.bPos,h=a.bPosPxOffset||0,p=r.boxmean||(r.meanline||{}).visible;Array.isArray(a.bdPos)?(o=a.bdPos[0],s=a.bdPos[1]):(o=a.bdPos,s=a.bdPos);var d=t.selectAll('path.mean').data("box"===r.type&&r.boxmean||"violin"===r.type&&r.box.visible&&r.meanline.visible?i.identity:[]);d.enter().append('path').attr('class','mean').style({fill:"none","vector-effect":"non-scaling-stroke"}),d.exit().remove(),d.each((function(t){var e=c.c2l(t.pos+f,!0),i=c.l2p(e-o)+h,a=c.l2p(e+s)+h,d=u?(i+a)/2:c.l2p(e)+h,m=l.c2p(t.mean,!0),g=l.c2p(t.mean-t.sd,!0),v=l.c2p(t.mean+t.sd,!0);"h"===r.orientation?n.select(this).attr('d',"M"+m+","+i+"V"+a+("sd"===p?"m0,0L"+g+","+d+"L"+m+","+i+"L"+v+","+d+"Z":"")):n.select(this).attr('d',"M"+i+","+m+"H"+a+("sd"===p?"m0,0L"+d+","+g+"L"+i+","+m+"L"+d+","+v+"Z":""))}))}e.exports={plot:l,plotBoxAndWhiskers:c,plotPoints:u,plotBoxMean:f}},{"../../components/drawing":672,"../../lib":787,"@plotly/d3":58}],960:[function(t,e,r){"use strict";e.exports=function(t,e){var r,n,i=t.cd,a=t.xaxis,o=t.yaxis,s=[];if(!1===e)for(r=0;r<i.length;r++)for(n=0;n<(i[r].pts||[]).length;n++)i[r].pts[n].selected=0;else for(r=0;r<i.length;r++)for(n=0;n<(i[r].pts||[]).length;n++){var l=i[r].pts[n],c=a.c2p(l.x),u=o.c2p(l.y);e.contains([c,u],null,l.i,t)?(s.push({pointNumber:l.i,x:a.c2d(l.x),y:o.c2d(l.y)}),l.selected=1):l.selected=0}return s}},{}],961:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../../components/drawing');function o(t,e,r){var o=r||n.select(t).selectAll('g.trace.boxes');o.style('opacity',(function(t){return t[0].trace.opacity})),o.each((function(e){var r=n.select(this),o=e[0].trace,s=o.line.width;function l(t,e,r,n){t.style('stroke-width',e+"px").call(i.stroke,r).call(i.fill,n)}var c=r.selectAll('path.box');if("candlestick"===o.type)c.each((function(t){if(!t.empty){var e=n.select(this),r=o[t.dir];l(e,r.line.width,r.line.color,r.fillcolor),e.style('opacity',o.selectedpoints&&!t.selected?.3:1)}}));else{l(c,s,o.line.color,o.fillcolor),r.selectAll('path.mean').style({"stroke-width":s,"stroke-dasharray":2*s+"px,"+s+"px"}).call(i.stroke,o.line.color);var u=r.selectAll('path.point');a.pointStyle(u,o,t)}}))}function s(t,e,r){var n=e[0].trace,i=r.selectAll('path.point');n.selectedpoints?a.selectedPointStyle(i,n):a.pointStyle(i,n,t)}e.exports={style:o,styleOnSelect:s}},{"../../components/color":650,"../../components/drawing":672,"@plotly/d3":58}],962:[function(t,e,r){"use strict";var n=t('../../lib').extendFlat,i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../ohlc/attributes'),o=t('../box/attributes');function s(t){return{line:{color:n({},o.line.color,{dflt:t}),width:o.line.width,editType:"style"},fillcolor:o.fillcolor,editType:"style"}}e.exports={xperiod:a.xperiod,xperiod0:a.xperiod0,xperiodalignment:a.xperiodalignment,xhoverformat:i('x'),yhoverformat:i('y'),x:a.x,open:a.open,high:a.high,low:a.low,close:a.close,line:{width:n({},o.line.width,{}),editType:"style"},increasing:s(a.increasing.line.color.dflt),decreasing:s(a.decreasing.line.color.dflt),text:a.text,hovertext:a.hovertext,whiskerwidth:n({},o.whiskerwidth,{dflt:0}),hoverlabel:a.hoverlabel}},{"../../lib":787,"../../plots/cartesian/axis_format_attributes":841,"../box/attributes":950,"../ohlc/attributes":1148}],963:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../../plots/cartesian/align_period'),o=t('../ohlc/calc').calcCommon;function s(t,e,r,n){return{min:r,q1:Math.min(t,n),med:n,q3:Math.max(t,n),max:e}}e.exports=function(t,e){var r=t._fullLayout,l=i.getFromId(t,e.xaxis),c=i.getFromId(t,e.yaxis),u=l.makeCalcdata(e,'x'),f=a(e,l,'x',u).vals,h=o(t,e,u,f,c,s);return h.length?(n.extendFlat(h[0].t,{num:r._numBoxes,dPos:n.distinctVals(f).minDiff/2,posLetter:"x",valLetter:"y"}),r._numBoxes++,h):[t:{empty:!0}}]},{"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"../ohlc/calc":1149}],964:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../ohlc/ohlc_defaults'),o=t('../scatter/period_defaults'),s=t('./attributes');function l(t,e,r,n){var a=r(n+".line.color");r(n+".line.width",e.line.width),r(n+".fillcolor",i.addOpacity(a,.5))}e.exports=function(t,e,r,i){function c(r,i){return n.coerce(t,e,s,r,i)}a(t,e,c,i)?(o(t,e,i,c,{x:!0}),c('xhoverformat'),c('yhoverformat'),c('line.width'),l(t,e,c,'increasing'),l(t,e,c,'decreasing'),c('text'),c('hovertext'),c('whiskerwidth'),i._requestRangeslider[e.xaxis]=!0):e.visible=!1}},{"../../components/color":650,"../../lib":787,"../ohlc/ohlc_defaults":1153,"../scatter/period_defaults":1222,"./attributes":962}],965:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"candlestick",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','showLegend','candlestick',"boxLayout"],meta:{},attributes:t('./attributes'),layoutAttributes:t('../box/layout_attributes'),supplyLayoutDefaults:t('../box/layout_defaults').supplyLayoutDefaults,crossTraceCalc:t('../box/cross_trace_calc').crossTraceCalc,supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('../box/plot').plot,layerName:"boxlayer",style:t('../box/style').style,hoverPoints:t('../ohlc/hover').hoverPoints,selectPoints:t('../ohlc/select')}},{"../../plots/cartesian":852,"../box/cross_trace_calc":952,"../box/layout_attributes":957,"../box/layout_defaults":958,"../box/plot":959,"../box/style":961,"../ohlc/hover":1151,"../ohlc/select":1155,"./attributes":962,"./calc":963,"./defaults":964}],966:[function(t,e,r){"use strict";var n=t('./axis_defaults'),i=t('../../plot_api/plot_template');function a(t,e,r,a){["aaxis","baxis"].forEach((function(o){var s=o.charAt(0),l=t[o]||{},c=i.newContainer(e,o),u={tickfont:"x",id:s+"axis",letter:s,font:e.font,name:o,data:t[s],calendar:e.calendar,dfltColor:a,bgColor:r.paper_bgcolor,autotypenumbersDflt:r.autotypenumbers,fullLayout:r};n(l,c,u),c._categories=c._categories||[],t[o]||"-"===l.type||(t[o]={type:l.type})}))}e.exports=function(t,e,r,n,i){n('a')||(n('da'),n('a0')),n('b')||(n('db'),n('b0')),a(t,e,r,i)}},{"../../plot_api/plot_template":827,"./axis_defaults":971}],967:[function(t,e,r){"use strict";var n=t('../../lib').isArrayOrTypedArray;function i(t,e){if(!n(t)||e>=10)return null;for(var r=1/0,a=-1/0,o=t.length,s=0;s<o;s++){var l=t[s];if(n(l)){var c=i(l,e+1);c&&(r=Math.min(c[0],r),a=Math.max(c[1],a))}else r=Math.min(l,r),a=Math.max(l,a)}return[r,a]}e.exports=function(t){return i(t,0)}},{"../../lib":787}],968:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('./axis_attributes'),a=t('../../components/color/attributes'),o=n({editType:"calc"});o.family.dflt='"Open Sans", verdana, arial, sans-serif',o.size.dflt=12,o.color.dflt=a.defaultLine,e.exports={carpet:{valType:"string",editType:"calc"},x:{valType:"data_array",editType:"calc+clearAxisTypes"},y:{valType:"data_array",editType:"calc+clearAxisTypes"},a:{valType:"data_array",editType:"calc"},a0:{valType:"number",dflt:0,editType:"calc"},da:{valType:"number",dflt:1,editType:"calc"},b:{valType:"data_array",editType:"calc"},b0:{valType:"number",dflt:0,editType:"calc"},db:{valType:"number",dflt:1,editType:"calc"},cheaterslope:{valType:"number",dflt:1,editType:"calc"},aaxis:i,baxis:i,font:o,color:{valType:"color",dflt:a.defaultLine,editType:"plot"},transforms:void 0}},{"../../components/color/attributes":649,"../../plots/font_attributes":867,"./axis_attributes":970}],969:[function(t,e,r){"use strict";var n=t('../../lib').isArrayOrTypedArray;e.exports=function(t,e,r,i){var a,o,s,l,c,u,f,h,p,d,m,g,v,y=n(r)?"a":"b",x=("a"===y?t.aaxis:t.baxis).smoothing,b="a"===y?t.a2i:t.b2j,_="a"===y?r:i,w="a"===y?i:r,T="a"===y?e.a.length:e.b.length,k="a"===y?e.b.length:e.a.length,M=Math.floor("a"===y?t.b2j(w):t.a2i(w)),A="a"===y?function(e){return t.evalxy([],e,M)}:function(e){return t.evalxy([],M,e)};x&&(s=Math.max(0,Math.min(k-2,M)),l=M-s,o="a"===y?function(e,r){return t.dxydi([],e,s,r,l)}:function(e,r){return t.dxydj([],s,e,l,r)});var S=b(_[0]),E=b(_[1]),L=S<E?1:-1,C=1e-8*(E-S),P=L>0?Math.floor:Math.ceil,I=L>0?Math.ceil:Math.floor,z=L>0?Math.min:Math.max,O=L>0?Math.max:Math.min,D=P(S+C),R=I(E-C),F=[[f=A(S)]];for(a=D;a*L<R*L;a+=L)c=[],m=O(S,a),v=(g=z(E,a+L))-m,u=Math.max(0,Math.min(T-2,Math.floor(.5*(m+g)))),h=A(g),x&&(p=o(u,m-u),d=o(u,g-u),c.push([f[0]+p[0]/3*v,f[1]+p[1]/3*v]),c.push([h[0]-d[0]/3*v,h[1]-d[1]/3*v])),c.push(h),F.push(c),f=h;return F}},{"../../lib":787}],970:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('../../components/color/attributes'),a=t('../../plots/cartesian/layout_attributes'),o=t('../../plots/cartesian/axis_format_attributes').descriptionWithDates,s=t('../../plot_api/edit_types').overrideAll;e.exports={color:{valType:"color",editType:"calc"},smoothing:{valType:"number",dflt:1,min:0,max:1.3,editType:"calc"},title:{text:{valType:"string",dflt:"",editType:"calc"},font:n({editType:"calc"}),offset:{valType:"number",dflt:10,editType:"calc"},editType:"calc"},type:{valType:"enumerated",values:["-",'linear','date',"category"],dflt:"-",editType:"calc"},autotypenumbers:a.autotypenumbers,autorange:{valType:"enumerated",values:[!0,!1,"reversed"],dflt:!0,editType:"calc"},rangemode:{valType:"enumerated",values:["normal",'tozero',"nonnegative"],dflt:"normal",editType:"calc"},range:{valType:"info_array",editType:"calc",items:[valType:"any",editType:"calc"},{valType:"any",editType:"calc"}],fixedrange:{valType:"boolean",dflt:!1,editType:"calc"},cheatertype:{valType:"enumerated",values:["index","value"],dflt:"value",editType:"calc"},tickmode:{valType:"enumerated",values:["linear","array"],dflt:"array",editType:"calc"},nticks:{valType:"integer",min:0,dflt:0,editType:"calc"},tickvals:{valType:"data_array",editType:"calc"},ticktext:{valType:"data_array",editType:"calc"},showticklabels:{valType:"enumerated",values:["start",'end','both',"none"],dflt:"start",editType:"calc"},tickfont:n({editType:"calc"}),tickangle:{valType:"angle",dflt:"auto",editType:"calc"},tickprefix:{valType:"string",dflt:"",editType:"calc"},showtickprefix:{valType:"enumerated",values:["all",'first','last',"none"],dflt:"all",editType:"calc"},ticksuffix:{valType:"string",dflt:"",editType:"calc"},showticksuffix:{valType:"enumerated",values:["all",'first','last',"none"],dflt:"all",editType:"calc"},showexponent:{valType:"enumerated",values:["all",'first','last',"none"],dflt:"all",editType:"calc"},exponentformat:{valType:"enumerated",values:["none",'e','E','power','SI',"B"],dflt:"B",editType:"calc"},minexponent:{valType:"number",dflt:3,min:0,editType:"calc"},separatethousands:{valType:"boolean",dflt:!1,editType:"calc"},tickformat:{valType:"string",dflt:"",editType:"calc",description:o('tick label')},tickformatstops:s(a.tickformatstops,'calc','from-root'),categoryorder:{valType:"enumerated",values:["trace",'category ascending','category descending',"array"],dflt:"trace",editType:"calc"},categoryarray:{valType:"data_array",editType:"calc"},labelpadding:{valType:"integer",dflt:10,editType:"calc"},labelprefix:{valType:"string",editType:"calc"},labelsuffix:{valType:"string",dflt:"",editType:"calc"},showline:{valType:"boolean",dflt:!1,editType:"calc"},linecolor:{valType:"color",dflt:i.defaultLine,editType:"calc"},linewidth:{valType:"number",min:0,dflt:1,editType:"calc"},gridcolor:{valType:"color",editType:"calc"},gridwidth:{valType:"number",min:0,dflt:1,editType:"calc"},showgrid:{valType:"boolean",dflt:!0,editType:"calc"},minorgridcount:{valType:"integer",min:0,dflt:0,editType:"calc"},minorgridwidth:{valType:"number",min:0,dflt:1,editType:"calc"},minorgridcolor:{valType:"color",dflt:i.lightLine,editType:"calc"},startline:{valType:"boolean",editType:"calc"},startlinecolor:{valType:"color",editType:"calc"},startlinewidth:{valType:"number",dflt:1,editType:"calc"},endline:{valType:"boolean",editType:"calc"},endlinewidth:{valType:"number",dflt:1,editType:"calc"},endlinecolor:{valType:"color",editType:"calc"},tick0:{valType:"number",min:0,dflt:0,editType:"calc"},dtick:{valType:"number",min:0,dflt:1,editType:"calc"},arraytick0:{valType:"integer",min:0,dflt:0,editType:"calc"},arraydtick:{valType:"integer",min:1,dflt:1,editType:"calc"},_deprecated:{title:{valType:"string",editType:"calc"},titlefont:n({editType:"calc"}),titleoffset:{valType:"number",dflt:10,editType:"calc"}},editType:"calc"}},{"../../components/color/attributes":649,"../../plot_api/edit_types":820,"../../plots/cartesian/axis_format_attributes":841,"../../plots/cartesian/layout_attributes":853,"../../plots/font_attributes":867}],971:[function(t,e,r){"use strict";var n=t('./attributes'),i=t('../../components/color').addOpacity,a=t('../../registry'),o=t('../../lib'),s=t('../../plots/cartesian/tick_value_defaults'),l=t('../../plots/cartesian/tick_label_defaults'),c=t('../../plots/cartesian/category_order_defaults'),u=t('../../plots/cartesian/set_convert'),f=t('../../plots/cartesian/axis_autotype');function h(t,e){if("-"===t.type){var r=t[t._id.charAt(0)+"calendar"];t.type=f(e,r,{autotypenumbers:t.autotypenumbers})}}e.exports=function(t,e,r){var f=r.letter,p=r.font||{},d=n[f+"axis"];function m(r,n){return o.coerce(t,e,d,r,n)}function g(r,n){return o.coerce2(t,e,d,r,n)}r.name&&(e._name=r.name,e._id=r.name),m('autotypenumbers',r.autotypenumbersDflt);var v=m('type');"-"===v&&(r.data&&h(e,r.data),"-"===e.type?e.type="linear":v=t.type=e.type),m('smoothing'),m('cheatertype'),m('showticklabels'),m('labelprefix',f+" = "),m('labelsuffix'),m('showtickprefix'),m('showticksuffix'),m('separatethousands'),m('tickformat'),m('exponentformat'),m('minexponent'),m('showexponent'),m('categoryorder'),m('tickmode'),m('tickvals'),m('ticktext'),m('tick0'),m('dtick'),"array"===e.tickmode&&(m('arraytick0'),m('arraydtick')),m('labelpadding'),e._hovertitle=f,"date"===v&&a.getComponentMethod('calendars','handleDefaults')(t,e,'calendar',r.calendar),u(e,r.fullLayout),e.c2p=o.identity;var y=m('color',r.dfltColor),x=y===t.color?y:p.color;m('title.text')&&(o.coerceFont(m,'title.font',{family:p.family,size:o.bigFont(p.size),color:x}),m('title.offset')),m('tickangle'),m('autorange',!e.isValidRange(t.range))&&m('rangemode'),m('range'),e.cleanRange(),m('fixedrange'),s(t,e,m,v),l(t,e,m,v,r),c(t,e,m,{data:r.data,dataAttr:f});var b=g('gridcolor',i(y,.3)),_=g('gridwidth'),w=m('showgrid');w||(delete e.gridcolor,delete e.gridwidth);var T=g('startlinecolor',y),k=g('startlinewidth',_);m('startline',e.showgrid||!!T||!!k)||(delete e.startlinecolor,delete e.startlinewidth);var M=g('endlinecolor',y),A=g('endlinewidth',_);return m('endline',e.showgrid||!!M||!!A)||(delete e.endlinecolor,delete e.endlinewidth),w?(m('minorgridcount'),m('minorgridwidth',_),m('minorgridcolor',i(b,.06)),e.minorgridcount||(delete e.minorgridwidth,delete e.minorgridcolor)):(delete e.gridcolor,delete e.gridWidth),"none"===e.showticklabels&&(delete e.tickfont,delete e.tickangle,delete e.showexponent,delete e.exponentformat,delete e.minexponent,delete e.tickformat,delete e.showticksuffix,delete e.showtickprefix),e.showticksuffix||delete e.ticksuffix,e.showtickprefix||delete e.tickprefix,m('tickmode'),e}},{"../../components/color":650,"../../lib":787,"../../plots/cartesian/axis_autotype":839,"../../plots/cartesian/category_order_defaults":843,"../../plots/cartesian/set_convert":859,"../../plots/cartesian/tick_label_defaults":860,"../../plots/cartesian/tick_value_defaults":862,"../../registry":915,"./attributes":968}],972:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib').isArray1D,a=t('./cheater_basis'),o=t('./array_minmax'),s=t('./calc_gridlines'),l=t('./calc_labels'),c=t('./calc_clippath'),u=t('../heatmap/clean_2d_array'),f=t('./smooth_fill_2d_array'),h=t('../heatmap/convert_column_xyz'),p=t('./set_convert');e.exports=function(t,e){var r=n.getFromId(t,e.xaxis),d=n.getFromId(t,e.yaxis),m=e.aaxis,g=e.baxis,v=e.x,y=e.y,x=[];v&&i(v)&&x.push('x'),y&&i(y)&&x.push('y'),x.length&&h(e,m,g,'a','b',x);var b=e._a=e._a||e.a,_=e._b=e._b||e.b;v=e._x||e.x,y=e._y||e.y;var w={};if(e._cheater){var T="index"===m.cheatertype?b.length:b,k="index"===g.cheatertype?_.length:_;v=a(T,k,e.cheaterslope)}e._x=v=u(v),e._y=y=u(y),f(v,b,_),f(y,b,_),p(e),e.setScale();var M=o(v),A=o(y),S=.5*(M[1]-M[0]),E=.5*(M[1]+M[0]),L=.5*(A[1]-A[0]),C=.5*(A[1]+A[0]),P=1.3;return M=[E-S*P,E+S*P],A=[C-L*P,C+L*P],e._extremes[r._id]=n.findExtremes(r,M,{padded:!0}),e._extremes[d._id]=n.findExtremes(d,A,{padded:!0}),s(e,'a','b'),s(e,'b','a'),l(e,m),l(e,g),w.clipsegments=c(e._xctrl,e._yctrl,m,g),w.x=v,w.y=y,w.a=b,w.b=_,[w]}},{"../../lib":787,"../../plots/cartesian/axes":838,"../heatmap/clean_2d_array":1071,"../heatmap/convert_column_xyz":1073,"./array_minmax":967,"./calc_clippath":973,"./calc_gridlines":974,"./calc_labels":975,"./cheater_basis":977,"./set_convert":990,"./smooth_fill_2d_array":991}],973:[function(t,e,r){"use strict";e.exports=function(t,e,r,n){var i,a,o,s=[],l=!!r.smoothing,c=!!n.smoothing,u=t[0].length-1,f=t.length-1;for(i=0,a=[],o=[];i<=u;i++)a[i]=t[0][i],o[i]=e[0][i];for(s.push({x:a,y:o,bicubic:l}),i=0,a=[],o=[];i<=f;i++)a[i]=t[i][u],o[i]=e[i][u];for(s.push({x:a,y:o,bicubic:c}),i=u,a=[],o=[];i>=0;i--)a[u-i]=t[f][i],o[u-i]=e[f][i];for(s.push({x:a,y:o,bicubic:l}),i=f,a=[],o=[];i>=0;i--)a[f-i]=t[i][0],o[f-i]=e[i][0];return s.push({x:a,y:o,bicubic:c}),s}},{}],974:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib/extend').extendFlat;e.exports=function(t,e,r){var a,o,s,l,c,u,f,h,p,d,m,g,v,y,x=t["_"+e],b=t[e+"axis"],_=b._gridlines=[],w=b._minorgridlines=[],T=b._boundarylines=[],k=t["_"+r],M=t[r+"axis"];"array"===b.tickmode&&(b.tickvals=x.slice());var A=t._xctrl,S=t._yctrl,E=A[0].length,L=A.length,C=t._a.length,P=t._b.length;n.prepTicks(b),"array"===b.tickmode&&delete b.tickvals;var I=b.smoothing?3:1;function z(n){var i,a,o,s,l,c,u,f,p,d,m,g,v=[],y=[],x={};if("b"===e)for(a=t.b2j(n),o=Math.floor(Math.max(0,Math.min(P-2,a))),s=a-o,x.length=P,x.crossLength=C,x.xy=function(e){return t.evalxy([],e,a)},x.dxy=function(e,r){return t.dxydi([],e,o,r,s)},i=0;i<C;i++)c=Math.min(C-2,i),u=i-c,f=t.evalxy([],i,a),M.smoothing&&i>0&&(p=t.dxydi([],i-1,o,0,s),v.push(l[0]+p[0]/3),y.push(l[1]+p[1]/3),d=t.dxydi([],i-1,o,1,s),v.push(f[0]-d[0]/3),y.push(f[1]-d[1]/3)),v.push(f[0]),y.push(f[1]),l=f;else for(i=t.a2i(n),c=Math.floor(Math.max(0,Math.min(C-2,i))),u=i-c,x.length=C,x.crossLength=P,x.xy=function(e){return t.evalxy([],i,e)},x.dxy=function(e,r){return t.dxydj([],c,e,u,r)},a=0;a<P;a++)o=Math.min(P-2,a),s=a-o,f=t.evalxy([],i,a),M.smoothing&&a>0&&(m=t.dxydj([],c,a-1,u,0),v.push(l[0]+m[0]/3),y.push(l[1]+m[1]/3),g=t.dxydj([],c,a-1,u,1),v.push(f[0]-g[0]/3),y.push(f[1]-g[1]/3)),v.push(f[0]),y.push(f[1]),l=f;return x.axisLetter=e,x.axis=b,x.crossAxis=M,x.value=n,x.constvar=r,x.index=h,x.x=v,x.y=y,x.smoothing=M.smoothing,x}function O(n){var i,a,o,s,l,c=[],u=[],f={};if(f.length=x.length,f.crossLength=k.length,"b"===e)for(o=Math.max(0,Math.min(P-2,n)),l=Math.min(1,Math.max(0,n-o)),f.xy=function(e){return t.evalxy([],e,n)},f.dxy=function(e,r){return t.dxydi([],e,o,r,l)},i=0;i<E;i++)c[i]=A[n*I][i],u[i]=S[n*I][i];else for(a=Math.max(0,Math.min(C-2,n)),s=Math.min(1,Math.max(0,n-a)),f.xy=function(e){return t.evalxy([],n,e)},f.dxy=function(e,r){return t.dxydj([],a,e,s,r)},i=0;i<L;i++)c[i]=A[i][n*I],u[i]=S[i][n*I];return f.axisLetter=e,f.axis=b,f.crossAxis=M,f.value=x[n],f.constvar=r,f.index=n,f.x=c,f.y=u,f.smoothing=M.smoothing,f}if("array"===b.tickmode){for(l=5e-15,u=(c=[Math.floor((x.length-1-b.arraytick0)/b.arraydtick*(1+l)),Math.ceil(-b.arraytick0/b.arraydtick/(1+l))].sort((function(t,e){return t-e})))[0]-1,f=c[1]+1,h=u;h<f;h++)(o=b.arraytick0+b.arraydtick*h)<0||o>x.length-1||_.push(i(O(o),{color:b.gridcolor,width:b.gridwidth}));for(h=u;h<f;h++)if(s=b.arraytick0+b.arraydtick*h,m=Math.min(s+b.arraydtick,x.length-1),!(s<0||s>x.length-1)&&!(m<0||m>x.length-1))for(g=x[s],v=x[m],a=0;a<b.minorgridcount;a++)(y=m-s)<=0||(d=g+(v-g)*(a+1)/(b.minorgridcount+1)*(b.arraydtick/y))<x[0]||d>x[x.length-1]||w.push(i(z(d),{color:b.minorgridcolor,width:b.minorgridwidth}));b.startline&&T.push(i(O(0),{color:b.startlinecolor,width:b.startlinewidth})),b.endline&&T.push(i(O(x.length-1),{color:b.endlinecolor,width:b.endlinewidth}))}else{for(l=5e-15,u=(c=[Math.floor((x[x.length-1]-b.tick0)/b.dtick*(1+l)),Math.ceil((x[0]-b.tick0)/b.dtick/(1+l))].sort((function(t,e){return t-e})))[0],f=c[1],h=u;h<=f;h++)p=b.tick0+b.dtick*h,_.push(i(z(p),{color:b.gridcolor,width:b.gridwidth}));for(h=u-1;h<f+1;h++)for(p=b.tick0+b.dtick*h,a=0;a<b.minorgridcount;a++)(d=p+b.dtick*(a+1)/(b.minorgridcount+1))<x[0]||d>x[x.length-1]||w.push(i(z(d),{color:b.minorgridcolor,width:b.minorgridwidth}));b.startline&&T.push(i(z(x[0]),{color:b.startlinecolor,width:b.startlinewidth})),b.endline&&T.push(i(z(x[x.length-1]),{color:b.endlinecolor,width:b.endlinewidth}))}}},{"../../lib/extend":777,"../../plots/cartesian/axes":838}],975:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib/extend').extendFlat;e.exports=function(t,e){var r,a,o,s,l,c=e._labels=[],u=e._gridlines;for(r=0;r<u.length;r++)l=u[r],-1!==["start","both"].indexOf(e.showticklabels)&&(a=n.tickText(e,l.value),i(a,{prefix:o,suffix:s,endAnchor:!0,xy:l.xy(0),dxy:l.dxy(0,0),axis:l.axis,length:l.crossAxis.length,font:l.axis.tickfont,isFirst:0===r,isLast:r===u.length-1}),c.push(a)),-1!==["end","both"].indexOf(e.showticklabels)&&(a=n.tickText(e,l.value),i(a,{endAnchor:!1,xy:l.xy(l.crossLength-1),dxy:l.dxy(l.crossLength-2,1),axis:l.axis,length:l.crossAxis.length,font:l.axis.tickfont,isFirst:0===r,isLast:r===u.length-1}),c.push(a))}},{"../../lib/extend":777,"../../plots/cartesian/axes":838}],976:[function(t,e,r){"use strict";var n=.5;e.exports=function(t,e,r,i){var a=t[0]-e[0],o=t[1]-e[1],s=r[0]-e[0],l=r[1]-e[1],c=Math.pow(a*a+o*o,n/2),u=Math.pow(s*s+l*l,n/2),f=(u*u*a-c*c*s)*i,h=(u*u*o-c*c*l)*i,p=u*(c+u)*3,d=c*(c+u)*3;return[[e[0]+(p&&f/p),e[1]+(p&&h/p)],[e[0]-(d&&f/d),e[1]-(d&&h/d)]]}},{}],977:[function(t,e,r){"use strict";var n=t('../../lib').isArrayOrTypedArray;e.exports=function(t,e,r){var i,a,o,s,l,c,u=[],f=n(t)?t.length:t,h=n(e)?e.length:e,p=n(t)?t:null,d=n(e)?e:null;p&&(o=(p.length-1)/(p[p.length-1]-p[0])/(f-1)),d&&(s=(d.length-1)/(d[d.length-1]-d[0])/(h-1));var m=1/0,g=-1/0;for(a=0;a<h;a++)for(u[a]=[],l=d?(d[a]-d[0])*s:a/(h-1),i=0;i<f;i++)c=(p?(p[i]-p[0])*o:i/(f-1))-l*r,m=Math.min(c,m),g=Math.max(c,g),u[a][i]=c;var v=1/(g-m),y=-m*v;for(a=0;a<h;a++)for(i=0;i<f;i++)u[a][i]=v*u[a][i]+y;return u}},{"../../lib":787}],978:[function(t,e,r){"use strict";var n=t('./catmull_rom'),i=t('../../lib').ensureArray;function a(t,e,r){var n=-.5*r[0]+1.5*e[0],i=-.5*r[1]+1.5*e[1];return[(2*n+t[0])/3,(2*i+t[1])/3]}e.exports=function(t,e,r,o,s,l){var c,u,f,h,p,d,m,g,v,y,x=r[0].length,b=r.length,_=s?3*x-2:x,w=l?3*b-2:b;for(t=i(t,w),e=i(e,w),f=0;f<w;f++)t[f]=i(t[f],_),e[f]=i(e[f],_);for(u=0,h=0;u<b;u++,h+=l?3:1)for(p=t[h],d=e[h],m=r[u],g=o[u],c=0,f=0;c<x;c++,f+=s?3:1)p[f]=m[c],d[f]=g[c];if(s)for(u=0,h=0;u<b;u++,h+=l?3:1){for(c=1,f=3;c<x-1;c++,f+=3)v=n([r[u][c-1],o[u][c-1]],[r[u][c],o[u][c]],[r[u][c+1],o[u][c+1]],s),t[h][f-1]=v[0][0],e[h][f-1]=v[0][1],t[h][f+1]=v[1][0],e[h][f+1]=v[1][1];y=a([t[h][0],e[h][0]],[t[h][2],e[h][2]],[t[h][3],e[h][3]]),t[h][1]=y[0],e[h][1]=y[1],y=a([t[h][_-1],e[h][_-1]],[t[h][_-3],e[h][_-3]],[t[h][_-4],e[h][_-4]]),t[h][_-2]=y[0],e[h][_-2]=y[1]}if(l)for(f=0;f<_;f++){for(h=3;h<w-3;h+=3)v=n([t[h-3][f],e[h-3][f]],[t[h][f],e[h][f]],[t[h+3][f],e[h+3][f]],l),t[h-1][f]=v[0][0],e[h-1][f]=v[0][1],t[h+1][f]=v[1][0],e[h+1][f]=v[1][1];y=a([t[0][f],e[0][f]],[t[2][f],e[2][f]],[t[3][f],e[3][f]]),t[1][f]=y[0],e[1][f]=y[1],y=a([t[w-1][f],e[w-1][f]],[t[w-3][f],e[w-3][f]],[t[w-4][f],e[w-4][f]]),t[w-2][f]=y[0],e[w-2][f]=y[1]}if(s&&l)for(h=1;h<w;h+=(h+1)%3===0?2:1){for(f=3;f<_-3;f+=3)v=n([t[h][f-3],e[h][f-3]],[t[h][f],e[h][f]],[t[h][f+3],e[h][f+3]],s),t[h][f-1]=.5*(t[h][f-1]+v[0][0]),e[h][f-1]=.5*(e[h][f-1]+v[0][1]),t[h][f+1]=.5*(t[h][f+1]+v[1][0]),e[h][f+1]=.5*(e[h][f+1]+v[1][1]);y=a([t[h][0],e[h][0]],[t[h][2],e[h][2]],[t[h][3],e[h][3]]),t[h][1]=.5*(t[h][1]+y[0]),e[h][1]=.5*(e[h][1]+y[1]),y=a([t[h][_-1],e[h][_-1]],[t[h][_-3],e[h][_-3]],[t[h][_-4],e[h][_-4]]),t[h][_-2]=.5*(t[h][_-2]+y[0]),e[h][_-2]=.5*(e[h][_-2]+y[1])}return[t,e]}},{"../../lib":787,"./catmull_rom":976}],979:[function(t,e,r){"use strict";e.exports={RELATIVE_CULL_TOLERANCE:1e-6}},{}],980:[function(t,e,r){"use strict";e.exports=function(t,e,r){return e&&r?function(e,r,n,i,a){var o,s,l,c,u,f;e||(e=[]),r*=3,n*=3;var h=i*i,p=1-i,d=p*p,m=p*i*2,g=-3*d,v=3*(d-m),y=3*(m-h),x=3*h,b=a*a,_=b*a,w=1-a,T=w*w,k=T*w;for(f=0;f<t.length;f++)o=g*(u=t[f])[n][r]+v*u[n][r+1]+y*u[n][r+2]+x*u[n][r+3],s=g*u[n+1][r]+v*u[n+1][r+1]+y*u[n+1][r+2]+x*u[n+1][r+3],l=g*u[n+2][r]+v*u[n+2][r+1]+y*u[n+2][r+2]+x*u[n+2][r+3],c=g*u[n+3][r]+v*u[n+3][r+1]+y*u[n+3][r+2]+x*u[n+3][r+3],e[f]=k*o+3*(T*a*s+w*b*l)+_*c;return e}:e?function(e,r,n,i,a){var o,s,l,c;e||(e=[]),r*=3;var u=i*i,f=1-i,h=f*f,p=f*i*2,d=-3*h,m=3*(h-p),g=3*(p-u),v=3*u,y=1-a;for(l=0;l<t.length;l++)o=d*(c=t[l])[n][r]+m*c[n][r+1]+g*c[n][r+2]+v*c[n][r+3],s=d*c[n+1][r]+m*c[n+1][r+1]+g*c[n+1][r+2]+v*c[n+1][r+3],e[l]=y*o+a*s;return e}:r?function(e,r,n,i,a){var o,s,l,c,u,f;e||(e=[]),n*=3;var h=a*a,p=h*a,d=1-a,m=d*d,g=m*d;for(u=0;u<t.length;u++)o=(f=t[u])[n][r+1]-f[n][r],s=f[n+1][r+1]-f[n+1][r],l=f[n+2][r+1]-f[n+2][r],c=f[n+3][r+1]-f[n+3][r],e[u]=g*o+3*(m*a*s+d*h*l)+p*c;return e}:function(e,r,n,i,a){var o,s,l,c;e||(e=[]);var u=1-a;for(l=0;l<t.length;l++)o=(c=t[l])[n][r+1]-c[n][r],s=c[n+1][r+1]-c[n+1][r],e[l]=u*o+a*s;return e}}},{}],981:[function(t,e,r){"use strict";e.exports=function(t,e,r){return e&&r?function(e,r,n,i,a){var o,s,l,c,u,f;e||(e=[]),r*=3,n*=3;var h=i*i,p=h*i,d=1-i,m=d*d,g=m*d,v=a*a,y=1-a,x=y*y,b=y*a*2,_=-3*x,w=3*(x-b),T=3*(b-v),k=3*v;for(f=0;f<t.length;f++)o=_*(u=t[f])[n][r]+w*u[n+1][r]+T*u[n+2][r]+k*u[n+3][r],s=_*u[n][r+1]+w*u[n+1][r+1]+T*u[n+2][r+1]+k*u[n+3][r+1],l=_*u[n][r+2]+w*u[n+1][r+2]+T*u[n+2][r+2]+k*u[n+3][r+2],c=_*u[n][r+3]+w*u[n+1][r+3]+T*u[n+2][r+3]+k*u[n+3][r+3],e[f]=g*o+3*(m*i*s+d*h*l)+p*c;return e}:e?function(e,r,n,i,a){var o,s,l,c,u,f;e||(e=[]),r*=3;var h=a*a,p=h*a,d=1-a,m=d*d,g=m*d;for(u=0;u<t.length;u++)o=(f=t[u])[n+1][r]-f[n][r],s=f[n+1][r+1]-f[n][r+1],l=f[n+1][r+2]-f[n][r+2],c=f[n+1][r+3]-f[n][r+3],e[u]=g*o+3*(m*a*s+d*h*l)+p*c;return e}:r?function(e,r,n,i,a){var o,s,l,c;e||(e=[]),n*=3;var u=1-i,f=a*a,h=1-a,p=h*h,d=h*a*2,m=-3*p,g=3*(p-d),v=3*(d-f),y=3*f;for(l=0;l<t.length;l++)o=m*(c=t[l])[n][r]+g*c[n+1][r]+v*c[n+2][r]+y*c[n+3][r],s=m*c[n][r+1]+g*c[n+1][r+1]+v*c[n+2][r+1]+y*c[n+3][r+1],e[l]=u*o+i*s;return e}:function(e,r,n,i,a){var o,s,l,c;e||(e=[]);var u=1-i;for(l=0;l<t.length;l++)o=(c=t[l])[n+1][r]-c[n][r],s=c[n+1][r+1]-c[n][r+1],e[l]=u*o+i*s;return e}}},{}],982:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){var a=e-2,o=r-2;return n&&i?function(e,r,n){var i,s,l,c,u,f;e||(e=[]);var h=Math.max(0,Math.min(Math.floor(r),a)),p=Math.max(0,Math.min(Math.floor(n),o)),d=Math.max(0,Math.min(1,r-h)),m=Math.max(0,Math.min(1,n-p));h*=3,p*=3;var g=d*d,v=g*d,y=1-d,x=y*y,b=x*y,_=m*m,w=_*m,T=1-m,k=T*T,M=k*T;for(f=0;f<t.length;f++)i=b*(u=t[f])[p][h]+3*(x*d*u[p][h+1]+y*g*u[p][h+2])+v*u[p][h+3],s=b*u[p+1][h]+3*(x*d*u[p+1][h+1]+y*g*u[p+1][h+2])+v*u[p+1][h+3],l=b*u[p+2][h]+3*(x*d*u[p+2][h+1]+y*g*u[p+2][h+2])+v*u[p+2][h+3],c=b*u[p+3][h]+3*(x*d*u[p+3][h+1]+y*g*u[p+3][h+2])+v*u[p+3][h+3],e[f]=M*i+3*(k*m*s+T*_*l)+w*c;return e}:n?function(e,r,n){e||(e=[]);var i,s,l,c,u,f,h=Math.max(0,Math.min(Math.floor(r),a)),p=Math.max(0,Math.min(Math.floor(n),o)),d=Math.max(0,Math.min(1,r-h)),m=Math.max(0,Math.min(1,n-p));h*=3;var g=d*d,v=g*d,y=1-d,x=y*y,b=x*y,_=1-m;for(u=0;u<t.length;u++)i=_*(f=t[u])[p][h]+m*f[p+1][h],s=_*f[p][h+1]+m*f[p+1][h+1],l=_*f[p][h+2]+m*f[p+1][h+1],c=_*f[p][h+3]+m*f[p+1][h+1],e[u]=b*i+3*(x*d*s+y*g*l)+v*c;return e}:i?function(e,r,n){e||(e=[]);var i,s,l,c,u,f,h=Math.max(0,Math.min(Math.floor(r),a)),p=Math.max(0,Math.min(Math.floor(n),o)),d=Math.max(0,Math.min(1,r-h)),m=Math.max(0,Math.min(1,n-p));p*=3;var g=m*m,v=g*m,y=1-m,x=y*y,b=x*y,_=1-d;for(u=0;u<t.length;u++)i=_*(f=t[u])[p][h]+d*f[p][h+1],s=_*f[p+1][h]+d*f[p+1][h+1],l=_*f[p+2][h]+d*f[p+2][h+1],c=_*f[p+3][h]+d*f[p+3][h+1],e[u]=b*i+3*(x*m*s+y*g*l)+v*c;return e}:function(e,r,n){e||(e=[]);var i,s,l,c,u=Math.max(0,Math.min(Math.floor(r),a)),f=Math.max(0,Math.min(Math.floor(n),o)),h=Math.max(0,Math.min(1,r-u)),p=Math.max(0,Math.min(1,n-f)),d=1-p,m=1-h;for(l=0;l<t.length;l++)i=m*(c=t[l])[f][u]+h*c[f][u+1],s=m*c[f+1][u]+h*c[f+1][u+1],e[l]=d*i+p*s;return e}}},{}],983:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./xy_defaults'),a=t('./ab_defaults'),o=t('./attributes'),s=t('../../components/color/attributes');e.exports=function(t,e,r,l){function c(r,i){return n.coerce(t,e,o,r,i)}e._clipPathId="clip"+e.uid+"carpet";var u=c('color',s.defaultLine);n.coerceFont(c,'font'),c('carpet'),a(t,e,l,c,u),e.a&&e.b?(e.a.length<3&&(e.aaxis.smoothing=0),e.b.length<3&&(e.baxis.smoothing=0),i(t,e,c)||(e.visible=!1),e._cheater&&c('cheaterslope')):e.visible=!1}},{"../../components/color/attributes":649,"../../lib":787,"./ab_defaults":966,"./attributes":968,"./xy_defaults":992}],984:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),plot:t('./plot'),calc:t('./calc'),animatable:!0,isContainer:!0,moduleType:"trace",name:"carpet",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','carpet','carpetAxis','notLegendIsolatable','noMultiCategory','noHover',"noSortingByValue"],meta:{}}},{"../../plots/cartesian":852,"./attributes":968,"./calc":972,"./defaults":983,"./plot":989}],985:[function(t,e,r){"use strict";e.exports=function(t,e){for(var r,n=t._fullData.length,i=0;i<n;i++){var a=t._fullData[i];if(a.index!==e.index&&"carpet"===a.type&&(r||(r=a),a.carpet===e.carpet))return a}return r}},{}],986:[function(t,e,r){"use strict";e.exports=function(t,e,r){if(0===t.length)return'';var n,i=[],a=r?3:1;for(n=0;n<t.length;n+=a)i.push(t[n]+",'+e[n]),r&&n<t.length-a&&(i.push('C'),i.push([t[n+1]+','+e[n+1],t[n+2]+','+e[n+2]+' '].join(' ")));return i.join(r?"":"L")}},{}],987:[function(t,e,r){"use strict";var n=t('../../lib').isArrayOrTypedArray;e.exports=function(t,e,r){var i;for(n(t)?t.length>e.length&&(t=t.slice(0,e.length)):t=[],i=0;i<e.length;i++)t[i]=r(e[i]);return t}},{"../../lib":787}],988:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i,a){var o=i[0]*t.dpdx(e),s=i[1]*t.dpdy(r),l=1,c=1;if(a){var u=Math.sqrt(i[0]*i[0]+i[1]*i[1]),f=Math.sqrt(a[0]*a[0]+a[1]*a[1]),h=(i[0]*a[0]+i[1]*a[1])/u/f;c=Math.max(0,h)}var p=180*Math.atan2(s,o)/Math.PI;return p<-90?(p+=180,l=-l):p>90&&(p-=180,l=-l),{angle:p,flip:l,p:t.c2p(n,e,r),offsetMultplier:c}}},{}],989:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('./map_1d_array'),o=t('./makepath'),s=t('./orient_text'),l=t('../../lib/svg_text_utils'),c=t('../../lib'),u=c.strRotate,f=c.strTranslate,h=t('../../constants/alignment');function p(t,e,r,n,i){var s,l,u,f,h=r.select("#"+t._clipPathId);h.size()||(h=r.append('clipPath').classed('carpetclip',!0));var p=c.ensureSingle(h,'path','carpetboundary'),d=e.clipsegments,m=[];for(f=0;f<d.length;f++)s=d[f],l=a([],s.x,n.c2p),u=a([],s.y,i.c2p),m.push(o(l,u,s.bicubic));var g="M"+m.join('L')+"Z";h.attr('id',t._clipPathId),p.attr('d',g)}function d(t,e,r,i,s,l){var c="const-"+s+"-lines",u=r.selectAll("."+c).data(l);u.enter().append('path').classed(c,!0).style('vector-effect','non-scaling-stroke'),u.each((function(r){var i=r,s=i.x,l=i.y,c=a([],s,t.c2p),u=a([],l,e.c2p),f="M"+o(c,u,i.smoothing);n.select(this).attr('d',f).style('stroke-width',i.width).style('stroke',i.color).style('fill','none')})),u.exit().remove()}function m(t,e,r,a,o,c,h,p){var d=c.selectAll("text."+p).data(h);d.enter().append('text').classed(p,!0);var m=0,g={};return d.each((function(o,c){var h;if("auto"===o.axis.tickangle)h=s(a,e,r,o.xy,o.dxy);else{var p=(o.axis.tickangle+180)*Math.PI/180;h=s(a,e,r,o.xy,[Math.cos(p),Math.sin(p)])}c||(g={angle:h.angle,flip:h.flip});var d=(o.endAnchor?-1:1)*h.flip,v=n.select(this).attr({"text-anchor":d>0?"start":"end","data-notex":1}).call(i.font,o.font).text(o.text).call(l.convertToTspans,t),y=i.bBox(this);v.attr('transform',f(h.p[0],h.p[1])+u(h.angle)+f(o.axis.labelpadding*d,.3*y.height)),m=Math.max(m,y.width+o.axis.labelpadding)})),d.exit().remove(),g.maxExtent=m,g}function g(t,e,r,n,i,a,o,l){var u,f,h,p,d=c.aggNums(Math.min,null,r.a),m=c.aggNums(Math.max,null,r.a),g=c.aggNums(Math.min,null,r.b),v=c.aggNums(Math.max,null,r.b);u=.5*(d+m),f=g,h=r.ab2xy(u,f,!0),p=r.dxyda_rough(u,f),void 0===o.angle&&c.extendFlat(o,s(r,i,a,h,r.dxydb_rough(u,f))),x(t,e,r,n,h,p,r.aaxis,i,a,o,'a-title'),u=d,f=.5*(g+v),h=r.ab2xy(u,f,!0),p=r.dxydb_rough(u,f),void 0===l.angle&&c.extendFlat(l,s(r,i,a,h,r.dxyda_rough(u,f))),x(t,e,r,n,h,p,r.baxis,i,a,l,'b-title')}e.exports=function(t,e,r,i){var a=e.xaxis,o=e.yaxis,s=t._fullLayout._clips;c.makeTraceGroups(i,r,'trace').each((function(e){var r=n.select(this),i=e[0],l=i.trace,u=l.aaxis,f=l.baxis,h=c.ensureSingle(r,'g','minorlayer'),v=c.ensureSingle(r,'g','majorlayer'),y=c.ensureSingle(r,'g','boundarylayer'),x=c.ensureSingle(r,'g','labellayer');r.style('opacity',l.opacity),d(a,o,v,u,'a',u._gridlines,!0),d(a,o,v,f,'b',f._gridlines,!0),d(a,o,h,u,'a',u._minorgridlines,!0),d(a,o,h,f,'b',f._minorgridlines,!0),d(a,o,y,u,'a-boundary',u._boundarylines),d(a,o,y,f,'b-boundary',f._boundarylines);var b=m(t,a,o,l,i,x,u._labels,'a-label'),_=m(t,a,o,l,i,x,f._labels,'b-label');g(t,x,l,i,a,o,b,_),p(l,i,s,a,o)}))};var v=h.LINE_SPACING,y=(1-h.MID_SHIFT)/v+1;function x(t,e,r,a,o,c,h,p,d,m,g){var x=[];h.title.text&&x.push(h.title.text);var b=e.selectAll("text."+g).data(x),_=m.maxExtent;b.enter().append('text').classed(g,!0),b.each((function(){var e=s(r,p,d,o,c);-1===["start","both"].indexOf(h.showticklabels)&&(_=0);var a=h.title.font.size;_+=a+h.title.offset;var g=(m.angle+(m.flip<0?180:0)-e.angle+450)%360,x=g>90&&g<270,b=n.select(this);b.text(h.title.text).call(l.convertToTspans,t),x&&(_=(-l.lineCount(b)+y)*v*a-_),b.attr('transform',f(e.p[0],e.p[1])+u(e.angle)+f(0,_)).attr('text-anchor','middle').call(i.font,h.title.font)})),b.exit().remove()}},{"../../components/drawing":672,"../../constants/alignment":755,"../../lib":787,"../../lib/svg_text_utils":813,"./makepath":986,"./map_1d_array":987,"./orient_text":988,"@plotly/d3":58}],990:[function(t,e,r){"use strict";var n=t('./constants'),i=t('../../lib/search').findBin,a=t('./compute_control_points'),o=t('./create_spline_evaluator'),s=t('./create_i_derivative_evaluator'),l=t('./create_j_derivative_evaluator');e.exports=function(t){var e=t._a,r=t._b,c=e.length,u=r.length,f=t.aaxis,h=t.baxis,p=e[0],d=e[c-1],m=r[0],g=r[u-1],v=e[e.length-1]-e[0],y=r[r.length-1]-r[0],x=v*n.RELATIVE_CULL_TOLERANCE,b=y*n.RELATIVE_CULL_TOLERANCE;p-=x,d+=x,m-=b,g+=b,t.isVisible=function(t,e){return t>p&&t<d&&e>m&&e<g},t.isOccluded=function(t,e){return t<p||t>d||e<m||e>g},t.setScale=function(){var e=t._x,r=t._y,n=a(t._xctrl,t._yctrl,e,r,f.smoothing,h.smoothing);t._xctrl=n[0],t._yctrl=n[1],t.evalxy=o([t._xctrl,t._yctrl],c,u,f.smoothing,h.smoothing),t.dxydi=s([t._xctrl,t._yctrl],f.smoothing,h.smoothing),t.dxydj=l([t._xctrl,t._yctrl],f.smoothing,h.smoothing)},t.i2a=function(t){var r=Math.max(0,Math.floor(t[0]),c-2),n=t[0]-r;return(1-n)*e[r]+n*e[r+1]},t.j2b=function(t){var e=Math.max(0,Math.floor(t[1]),c-2),n=t[1]-e;return(1-n)*r[e]+n*r[e+1]},t.ij2ab=function(e){return[t.i2a(e[0]),t.j2b(e[1])]},t.a2i=function(t){var r=Math.max(0,Math.min(i(t,e),c-2)),n=e[r],a=e[r+1];return Math.max(0,Math.min(c-1,r+(t-n)/(a-n)))},t.b2j=function(t){var e=Math.max(0,Math.min(i(t,r),u-2)),n=r[e],a=r[e+1];return Math.max(0,Math.min(u-1,e+(t-n)/(a-n)))},t.ab2ij=function(e){return[t.a2i(e[0]),t.b2j(e[1])]},t.i2c=function(e,r){return t.evalxy([],e,r)},t.ab2xy=function(n,i,a){if(!a&&(n<e[0]||n>e[c-1]|i<r[0]||i>r[u-1]))return[!1,!1];var o=t.a2i(n),s=t.b2j(i),l=t.evalxy([],o,s);if(a){var f,h,p,d,m=0,g=0,v=[];n<e[0]?(f=0,h=0,m=(n-e[0])/(e[1]-e[0])):n>e[c-1]?(f=c-2,h=1,m=(n-e[c-1])/(e[c-1]-e[c-2])):h=o-(f=Math.max(0,Math.min(c-2,Math.floor(o)))),i<r[0]?(p=0,d=0,g=(i-r[0])/(r[1]-r[0])):i>r[u-1]?(p=u-2,d=1,g=(i-r[u-1])/(r[u-1]-r[u-2])):d=s-(p=Math.max(0,Math.min(u-2,Math.floor(s)))),m&&(t.dxydi(v,f,p,h,d),l[0]+=v[0]*m,l[1]+=v[1]*m),g&&(t.dxydj(v,f,p,h,d),l[0]+=v[0]*g,l[1]+=v[1]*g)}return l},t.c2p=function(t,e,r){return[e.c2p(t[0]),r.c2p(t[1])]},t.p2x=function(t,e,r){return[e.p2c(t[0]),r.p2c(t[1])]},t.dadi=function(t){var r=Math.max(0,Math.min(e.length-2,t));return e[r+1]-e[r]},t.dbdj=function(t){var e=Math.max(0,Math.min(r.length-2,t));return r[e+1]-r[e]},t.dxyda=function(e,r,n,i){var a=t.dxydi(null,e,r,n,i),o=t.dadi(e,n);return[a[0]/o,a[1]/o]},t.dxydb=function(e,r,n,i){var a=t.dxydj(null,e,r,n,i),o=t.dbdj(r,i);return[a[0]/o,a[1]/o]},t.dxyda_rough=function(e,r,n){var i=v*(n||.1),a=t.ab2xy(e+i,r,!0),o=t.ab2xy(e-i,r,!0);return[.5*(a[0]-o[0])/i,.5*(a[1]-o[1])/i]},t.dxydb_rough=function(e,r,n){var i=y*(n||.1),a=t.ab2xy(e,r+i,!0),o=t.ab2xy(e,r-i,!0);return[.5*(a[0]-o[0])/i,.5*(a[1]-o[1])/i]},t.dpdx=function(t){return t._m},t.dpdy=function(t){return t._m}}},{"../../lib/search":807,"./compute_control_points":978,"./constants":979,"./create_i_derivative_evaluator":980,"./create_j_derivative_evaluator":981,"./create_spline_evaluator":982}],991:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e,r){var i,a,o,s=[],l=[],c=t[0].length,u=t.length;function f(e,r){var n,i=0,a=0;return e>0&&void 0!==(n=t[r][e-1])&&(a++,i+=n),e<c-1&&void 0!==(n=t[r][e+1])&&(a++,i+=n),r>0&&void 0!==(n=t[r-1][e])&&(a++,i+=n),r<u-1&&void 0!==(n=t[r+1][e])&&(a++,i+=n),i/Math.max(1,a)}var h,p,d,m,g,v,y,x,b,_,w,T=0;for(i=0;i<c;i++)for(a=0;a<u;a++)void 0===t[a][i]&&(s.push(i),l.push(a),t[a][i]=f(i,a)),T=Math.max(T,Math.abs(t[a][i]));if(!s.length)return t;var k=1e-5,M=0,A=100,S=0,E=s.length;do{for(M=0,o=0;o<E;o++){i=s[o],a=l[o];var L,C,P,I,z,O,D=0,R=0;0===i?(P=e[z=Math.min(c-1,2)],I=e[1],L=t[a][z],R+=(C=t[a][1])+(C-L)*(e[0]-I)/(I-P),D++):i===c-1&&(P=e[z=Math.max(0,c-3)],I=e[c-2],L=t[a][z],R+=(C=t[a][c-2])+(C-L)*(e[c-1]-I)/(I-P),D++),(0===i||i===c-1)&&a>0&&a<u-1&&(h=r[a+1]-r[a],R+=((p=r[a]-r[a-1])*t[a+1][i]+h*t[a-1][i])/(p+h),D++),0===a?(P=r[O=Math.min(u-1,2)],I=r[1],L=t[O][i],R+=(C=t[1][i])+(C-L)*(r[0]-I)/(I-P),D++):a===u-1&&(P=r[O=Math.max(0,u-3)],I=r[u-2],L=t[O][i],R+=(C=t[u-2][i])+(C-L)*(r[u-1]-I)/(I-P),D++),(0===a||a===u-1)&&i>0&&i<c-1&&(h=e[i+1]-e[i],R+=((p=e[i]-e[i-1])*t[a][i+1]+h*t[a][i-1])/(p+h),D++),D?R/=D:(d=e[i+1]-e[i],m=e[i]-e[i-1],x=(g=r[a+1]-r[a])*(v=r[a]-r[a-1])*(g+v),R=((y=d*m*(d+m))*(v*t[a+1][i]+g*t[a-1][i])+x*(m*t[a][i+1]+d*t[a][i-1]))/(x*(m+d)+y*(v+g))),M+=(_=(b=R-t[a][i])/T)*_,w=D?0:.85,t[a][i]+=b*(1+w)}M=Math.sqrt(M)}while(S++<A&&M>k);return n.log('Smoother converged to',M,'after',S,'iterations'),t}},{"../../lib":787}],992:[function(t,e,r){"use strict";var n=t('../../lib').isArray1D;e.exports=function(t,e,r){var i=r('x'),a=i&&i.length,o=r('y'),s=o&&o.length;if(!a&&!s)return!1;if(e._cheater=!i,a&&!n(i)||s&&!n(o))e._length=null;else{var l=a?i.length:1/0;s&&(l=Math.min(l,o.length)),e.a&&e.a.length&&(l=Math.min(l,e.a.length)),e.b&&e.b.length&&(l=Math.min(l,e.b.length)),e._length=l}return!0}},{"../../lib":787}],993:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../scattergeo/attributes'),a=t('../../components/colorscale/attributes'),o=t('../../plots/attributes'),s=t('../../components/color/attributes').defaultLine,l=t('../../lib/extend').extendFlat,c=i.marker.line;e.exports=l({locations:{valType:"data_array",editType:"calc"},locationmode:i.locationmode,z:{valType:"data_array",editType:"calc"},geojson:l({},i.geojson,{}),featureidkey:i.featureidkey,text:l({},i.text,{}),hovertext:l({},i.hovertext,{}),marker:{line:{color:l({},c.color,{dflt:s}),width:l({},c.width,{dflt:1}),editType:"calc"},opacity:{valType:"number",arrayOk:!0,min:0,max:1,dflt:1,editType:"style"},editType:"calc"},selected:{marker:{opacity:i.selected.marker.opacity,editType:"plot"},editType:"plot"},unselected:{marker:{opacity:i.unselected.marker.opacity,editType:"plot"},editType:"plot"},hoverinfo:l({},o.hoverinfo,{editType:"calc",flags:["location",'z','text',"name"]}),hovertemplate:n(),showlegend:l({},o.showlegend,{dflt:!1})},a('',{cLetter:"z",editTypeOverride:"calc"}))},{"../../components/color/attributes":649,"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"../scattergeo/attributes":1244}],994:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../constants/numerical').BADNUM,a=t('../../components/colorscale/calc'),o=t('../scatter/arrays_to_calcdata'),s=t('../scatter/calc_selection');function l(t){return t&&"string"===typeof t}e.exports=function(t,e){var r,c=e._length,u=new Array(c);r=e.geojson?function(t){return l(t)||n(t)}:l;for(var f=0;f<c;f++)[var h=u[f]={],p=e.locations[f],d=e.z[f];r(p)&&n(d)?(h.loc=p,h.z=d):(h.loc=null,h.z=i),h.index=f}return o(u,e),a(t,e,{vals:e.z,containerStr:"",cLetter:"z"}),s(u,e),u}},{"../../components/colorscale/calc":658,"../../constants/numerical":763,"../scatter/arrays_to_calcdata":1201,"../scatter/calc_selection":1204,"fast-isnumeric":246}],995:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/defaults'),a=t('./attributes');e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l=s('locations'),c=s('z');if(l&&l.length&&n.isArrayOrTypedArray(c)&&c.length){e._length=Math.min(l.length,c.length);var u,f=s('geojson');("string"===typeof f&&""!==f||n.isPlainObject(f))&&(u='geojson-id'),"geojson-id"===s('locationmode',u)&&s('featureidkey'),s('text'),s('hovertext'),s('hovertemplate'),s('marker.line.width')&&s('marker.line.color'),s('marker.opacity'),i(t,e,o,s,{prefix:"",cLetter:"z"}),n.coerceSelectionMarkerOpacity(e,s)}else e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"./attributes":993}],996:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){t.location=e.location,t.z=e.z;var a=n[i];return a.fIn&&a.fIn.properties&&(t.properties=a.fIn.properties),t.ct=a.ct,t}},{}],997:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('./attributes'),a=t('../../lib').fillText;function o(t,e,r){if(!e.hovertemplate){var n=r.hi||e.hoverinfo,o=String(r.loc),s="all"===n?i.hoverinfo.flags:n.split('+'),l=-1!==s.indexOf('name'),c=-1!==s.indexOf('location'),u=-1!==s.indexOf('z'),f=-1!==s.indexOf('text'),h=[];!l&&c?t.nameOverride=o:(l&&(t.nameOverride=e.name),c&&h.push(o)),u&&h.push(t.zLabel),f&&a(r,e,h),t.extraText=h.join('<br>')}}e.exports=function(t,e,r){var i,a,s,l,c=t.cd,u=c[0].trace,f=t.subplot,h=[e,r],p=[e+360,r];for(a=0;a<c.length;a++)if(l=!1,(i=c[a])._polygons){for(s=0;s<i._polygons.length;s++)i._polygons[s].contains(h)&&(l=!l),i._polygons[s].contains(p)&&(l=!l);if(l)break}if(l&&i)return t.x0=t.x1=t.xa.c2p(i.ct),t.y0=t.y1=t.ya.c2p(i.ct),t.index=i.index,t.location=i.loc,t.z=i.z,t.zLabel=n.tickText(f.mockAxis,f.mockAxis.c2l(i.z),'hover').text,t.hovertemplate=i.hovertemplate,o(t,u,i),[t]}},{"../../lib":787,"../../plots/cartesian/axes":838,"./attributes":993}],998:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../heatmap/colorbar'),calc:t('./calc'),calcGeoJSON:t('./plot').calcGeoJSON,plot:t('./plot').plot,style:t('./style').style,styleOnSelect:t('./style').styleOnSelect,hoverPoints:t('./hover'),eventData:t('./event_data'),selectPoints:t('./select'),moduleType:"trace",name:"choropleth",basePlotModule:t('../../plots/geo'),categories:["geo",'noOpacity',"showLegend"],meta:{}}},{"../../plots/geo":871,"../heatmap/colorbar":1072,"./attributes":993,"./calc":994,"./defaults":995,"./event_data":996,"./hover":997,"./plot":999,"./select":1e3,"./style":1001}],999:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../lib/geo_location_utils'),o=t('../../lib/topojson_utils').getTopojsonFeatures,s=t('../../plots/cartesian/autorange').findExtremes,l=t('./style').style;function c(t,e,r){var a=e.layers.backplot.select('.choroplethlayer');i.makeTraceGroups(a,r,'trace choropleth').each((function(e){var r=n.select(this).selectAll('path.choroplethlocation').data(i.identity);r.enter().append('path').classed('choroplethlocation',!0),r.exit().remove(),l(t,e)}))}function u(t,e){for(var r=t[0].trace,n=e[r.geo],i=n._subplot,l=r.locationmode,c=r._length,u="geojson-id"===l?a.extractTraceFeature(t):o(r,i.topojson),f=[],h=[],p=0;p<c;p++){var d=t[p],m="geojson-id"===l?d.fOut:a.locationToFeature(l,d.loc,u);if(m){d.geojson=m,d.ct=m.properties.ct,d._polygons=a.feature2polygons(m);var g=a.computeBbox(m);f.push(g[0],g[2]),h.push(g[1],g[3])}else d.geojson=null}if("geojson"===n.fitbounds&&"geojson-id"===l){var v=a.computeBbox(a.getTraceGeojson(r));f=[v[0],v[2]],h=[v[1],v[3]]}var y={padded:!0};r._extremes.lon=s(n.lonaxis._ax,f,y),r._extremes.lat=s(n.lataxis._ax,h,y)}e.exports={calcGeoJSON:u,plot:c}},{"../../lib":787,"../../lib/geo_location_utils":780,"../../lib/topojson_utils":816,"../../plots/cartesian/autorange":837,"./style":1001,"@plotly/d3":58}],1e3:[function(t,e,r){"use strict";e.exports=function(t,e){var r,n,i,a,o,s=t.cd,l=t.xaxis,c=t.yaxis,u=[];if(!1===e)for(r=0;r<s.length;r++)s[r].selected=0;else for(r=0;r<s.length;r++)(i=(n=s[r]).ct)&&(a=l.c2p(i),o=c.c2p(i),e.contains([a,o],null,r,t)?(u.push({pointNumber:r,lon:i[0],lat:i[1]}),n.selected=1):n.selected=0);return u}},{}],1001:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../../components/drawing'),o=t('../../components/colorscale');function s(t,e){e&&l(t,e)}function l(t,e){var r=e[0].trace,s=e[0].node3.selectAll('.choroplethlocation'),l=r.marker||{},c=l.line||{},u=o.makeColorScaleFuncFromTrace(r);s.each((function(t){n.select(this).attr('fill',u(t.z)).call(i.stroke,t.mlc||c.color).call(a.dashLine,'',t.mlw||c.width||0).style('opacity',l.opacity)})),a.selectedPointStyle(s,r,t)}function c(t,e){var r=e[0].node3,n=e[0].trace;n.selectedpoints?a.selectedPointStyle(r.selectAll('.choroplethlocation'),n,t):l(t,e)}e.exports={style:s,styleOnSelect:c}},{"../../components/color":650,"../../components/colorscale":662,"../../components/drawing":672,"@plotly/d3":58}],1002:[function(t,e,r){"use strict";var n=t('../choropleth/attributes'),i=t('../../components/colorscale/attributes'),a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../../plots/attributes'),s=t('../../lib/extend').extendFlat;e.exports=s({locations:{valType:"data_array",editType:"calc"},z:{valType:"data_array",editType:"calc"},geojson:{valType:"any",editType:"calc"},featureidkey:s({},n.featureidkey,{}),below:{valType:"string",editType:"plot"},text:n.text,hovertext:n.hovertext,marker:{line:{color:s({},n.marker.line.color,{editType:"plot"}),width:s({},n.marker.line.width,{editType:"plot"}),editType:"calc"},opacity:s({},n.marker.opacity,{editType:"plot"}),editType:"calc"},selected:{marker:{opacity:s({},n.selected.marker.opacity,{editType:"plot"}),editType:"plot"},editType:"plot"},unselected:{marker:{opacity:s({},n.unselected.marker.opacity,{editType:"plot"}),editType:"plot"},editType:"plot"},hoverinfo:n.hoverinfo,hovertemplate:a({},{keys:["properties"]}),showlegend:s({},o.showlegend,{dflt:!1})},i('',{cLetter:"z",editTypeOverride:"calc"}))},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"../choropleth/attributes":993}],1003:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../components/colorscale'),o=t('../../components/drawing'),s=t('../../lib/geojson_utils').makeBlank,l=t('../../lib/geo_location_utils');function c(t){var e=t[0].trace,r=!0===e.visible&&0!==e._length,o={layout:{visibility:"none"},paint:{}},c={layout:{visibility:"none"},paint:{}},f=e._opts={fill:o,line:c,geojson:s()};if(!r)return f;var h=l.extractTraceFeature(t);if(!h)return f;var p,d,m,g=a.makeColorScaleFuncFromTrace(e),v=e.marker,y=v.line||{};i.isArrayOrTypedArray(v.opacity)&&(p=function(t){var e=t.mo;return n(e)?+i.constrain(e,0,1):0}),i.isArrayOrTypedArray(y.color)&&(d=function(t){return t.mlc}),i.isArrayOrTypedArray(y.width)&&(m=function(t){return t.mlw});for(var x=0;x<t.length;x++){var b=t[x],_=b.fOut;if(_){var w=_.properties;w.fc=g(b.z),p&&(w.mo=p(b)),d&&(w.mlc=d(b)),m&&(w.mlw=m(b)),b.ct=w.ct,b._polygons=l.feature2polygons(_)}}var T=p?{type:"identity",property:"mo"}:v.opacity;return i.extendFlat(o.paint,{"fill-color":{type:"identity",property:"fc"},"fill-opacity":T}),i.extendFlat(c.paint,{"line-color":d?{type:"identity",property:"mlc"}:y.color,"line-width":m?{type:"identity",property:"mlw"}:y.width,"line-opacity":T}),o.layout.visibility='visible',c.layout.visibility='visible',f.geojson={type:"FeatureCollection",features:h},u(t),f}function u(t){var e,r=t[0].trace,n=r._opts;if(r.selectedpoints){for(var a=o.makeSelectedPointStyleFns(r),s=0;s<t.length;s++){var l=t[s];l.fOut&&(l.fOut.properties.mo2=a.selectedOpacityFn(l))}e={type:"identity",property:"mo2"}}else e=i.isArrayOrTypedArray(r.marker.opacity)?{type:"identity",property:"mo"}:r.marker.opacity;return i.extendFlat(n.fill.paint,{"fill-opacity":e}),i.extendFlat(n.line.paint,{"line-opacity":e}),n}e.exports={convert:c,convertOnSelect:u}},{"../../components/colorscale":662,"../../components/drawing":672,"../../lib":787,"../../lib/geo_location_utils":780,"../../lib/geojson_utils":781,"fast-isnumeric":246}],1004:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/defaults'),a=t('./attributes');e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l=s('locations'),c=s('z'),u=s('geojson');n.isArrayOrTypedArray(l)&&l.length&&n.isArrayOrTypedArray(c)&&c.length&&("string"===typeof u&&""!==u||n.isPlainObject(u))?(s('featureidkey'),e._length=Math.min(l.length,c.length),s('below'),s('text'),s('hovertext'),s('hovertemplate'),s('marker.line.width')&&s('marker.line.color'),s('marker.opacity'),i(t,e,o,s,{prefix:"",cLetter:"z"}),n.coerceSelectionMarkerOpacity(e,s)):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"./attributes":1002}],1005:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../heatmap/colorbar'),calc:t('../choropleth/calc'),plot:t('./plot'),hoverPoints:t('../choropleth/hover'),eventData:t('../choropleth/event_data'),selectPoints:t('../choropleth/select'),styleOnSelect:function(t,e){e&&e[0].trace._glTrace.updateOnSelect(e)},getBelow:function(t,e){for(var r=e.getMapLayers(),n=r.length-2;n>=0;n--){var i=r[n].id;if("string"===typeof i&&0===i.indexOf('water'))for(var a=n+1;a<r.length;a++)if("string"===typeof(i=r[a].id)&&-1===i.indexOf('plotly-'))return i}},moduleType:"trace",name:"choroplethmapbox",basePlotModule:t('../../plots/mapbox'),categories:["mapbox",'gl','noOpacity',"showLegend"],meta:{hr_name:"choropleth_mapbox"}}},{"../../plots/mapbox":895,"../choropleth/calc":994,"../choropleth/event_data":996,"../choropleth/hover":997,"../choropleth/select":1e3,"../heatmap/colorbar":1072,"./attributes":1002,"./defaults":1004,"./plot":1006}],1006:[function(t,e,r){"use strict";var n=t('./convert').convert,i=t('./convert').convertOnSelect,a=t('../../plots/mapbox/constants').traceLayerPrefix;function o(t,e){this.type='choroplethmapbox',this.subplot=t,this.uid=e,this.sourceId="source-"+e,this.layerList=[["fill",a+e+"-fill"],["line",a+e+"-line"]],this.below=null}var s=o.prototype;s.update=function(t)[this._update(n(t))],s.updateOnSelect=function(t)[this._update(i(t))],s._update=function(t){var e=this.subplot,r=this.layerList,n=e.belowLookup["trace-"+this.uid];e.map.getSource(this.sourceId).setData(t.geojson),n!==this.below&&(this._removeLayers(),this._addLayers(t,n),this.below=n);for(var i=0;i<r.length;i++){var a=r[i],o=a[0],s=a[1],l=t[o];e.setOptions(s,'setLayoutProperty',l.layout),"visible"===l.layout.visibility&&e.setOptions(s,'setPaintProperty',l.paint)}},s._addLayers=function(t,e){for(var r=this.subplot,n=this.layerList,i=this.sourceId,a=0;a<n.length;a++){var o=n[a],s=o[0],l=t[s];r.addLayer({type:s,id:o[1],source:i,layout:l.layout,paint:l.paint},e)}},s._removeLayers=function(){for(var t=this.subplot.map,e=this.layerList,r=e.length-1;r>=0;r--)t.removeLayer(e[r][1])},s.dispose=function(){var t=this.subplot.map;this._removeLayers(),t.removeSource(this.sourceId)},e.exports=function(t,e){var r=e[0].trace,i=new o(t,r.uid),a=i.sourceId,s=n(e),l=i.below=t.belowLookup["trace-"+r.uid];return t.map.addSource(a,{type:"geojson",data:s.geojson}),i._addLayers(s,l),e[0].trace._glTrace=i,i}},{"../../plots/mapbox/constants":893,"./convert":1003}],1007:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../mesh3d/attributes'),s=t('../../plots/attributes'),l=t('../../lib/extend').extendFlat,c={x:{valType:"data_array",editType:"calc+clearAxisTypes"},y:{valType:"data_array",editType:"calc+clearAxisTypes"},z:{valType:"data_array",editType:"calc+clearAxisTypes"},u:{valType:"data_array",editType:"calc"},v:{valType:"data_array",editType:"calc"},w:{valType:"data_array",editType:"calc"},sizemode:{valType:"enumerated",values:["scaled","absolute"],editType:"calc",dflt:"scaled"},sizeref:{valType:"number",editType:"calc",min:0},anchor:{valType:"enumerated",editType:"calc",values:["tip",'tail','cm',"center"],dflt:"cm"},text:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},hovertext:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},hovertemplate:a({editType:"calc"},{keys:["norm"]}),uhoverformat:i('u',1),vhoverformat:i('v',1),whoverformat:i('w',1),xhoverformat:i('x'),yhoverformat:i('y'),zhoverformat:i('z'),showlegend:l({},s.showlegend,{dflt:!1})};l(c,n('',{colorAttr:"u/v/w norm",showScaleDflt:!0,editTypeOverride:"calc"})),["opacity",'lightposition',"lighting"].forEach((function(t)[c[t]=o[t]])),c.hoverinfo=l({},s.hoverinfo,{editType:"calc",flags:["x",'y','z','u','v','w','norm','text',"name"],dflt:"x+y+z+norm+text+name"}),c.transforms=void 0,e.exports=c},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../mesh3d/attributes":1143}],1008:[function(t,e,r){"use strict";var n=t('../../components/colorscale/calc');e.exports=function(t,e){for(var r=e.u,i=e.v,a=e.w,o=Math.min(e.x.length,e.y.length,e.z.length,r.length,i.length,a.length),s=-1/0,l=1/0,c=0;c<o;c++){var u=r[c],f=i[c],h=a[c],p=Math.sqrt(u*u+f*f+h*h);s=Math.max(s,p),l=Math.min(l,p)}e._len=o,e._normMax=s,n(t,e,{vals:[l,s],containerStr:"",cLetter:"c"})}},{"../../components/colorscale/calc":658}],1009:[function(t,e,r){"use strict";var n=t('gl-cone3d'),i=t('gl-cone3d').createConeMesh,a=t('../../lib').simpleMap,o=t('../../lib/gl_format_color').parseColorScale,s=t('../../components/colorscale').extractOpts,l=t('../../plots/gl3d/zip3');function c(t,e){this.scene=t,this.uid=e,this.mesh=null,this.data=null}var u=c.prototype;u.handlePick=function(t){if(t.object===this.mesh){var e=t.index=t.data.index,r=this.data.x[e],n=this.data.y[e],i=this.data.z[e],a=this.data.u[e],o=this.data.v[e],s=this.data.w[e];t.traceCoordinate=[r,n,i,a,o,s,Math.sqrt(a*a+o*o+s*s)];var l=this.data.hovertext||this.data.text;return Array.isArray(l)&&void 0!==l[e]?t.textLabel=l[e]:l&&(t.textLabel=l),!0}};var f={xaxis:0,yaxis:1,zaxis:2},h={tip:1,tail:0,cm:.25,center:.5},p={tip:1,tail:1,cm:.75,center:.5};function d(t,e){var r=t.fullSceneLayout,i=t.dataScale,c={};function u(t,e){var n=r[e],o=i[f[e]];return a(t,(function(t){return n.d2l(t)*o}))}c.vectors=l(u(e.u,'xaxis'),u(e.v,'yaxis'),u(e.w,'zaxis'),e._len),c.positions=l(u(e.x,'xaxis'),u(e.y,'yaxis'),u(e.z,'zaxis'),e._len);var d=s(e);c.colormap=o(e),c.vertexIntensityBounds=[d.min/e._normMax,d.max/e._normMax],c.coneOffset=h[e.anchor],"scaled"===e.sizemode?c.coneSize=e.sizeref||.5:c.coneSize=e.sizeref&&e._normMax?e.sizeref/e._normMax:.5;var m=n(c),g=e.lightposition;return m.lightPosition=[g.x,g.y,g.z],m.ambient=e.lighting.ambient,m.diffuse=e.lighting.diffuse,m.specular=e.lighting.specular,m.roughness=e.lighting.roughness,m.fresnel=e.lighting.fresnel,m.opacity=e.opacity,e._pad=p[e.anchor]*m.vectorScale*m.coneScale*e._normMax,m}function m(t,e){var r=t.glplot.gl,n=d(t,e),a=i(r,n),o=new c(t,e.uid);return o.mesh=a,o.data=e,a._trace=o,t.glplot.add(a),o}u.update=function(t){this.data=t;var e=d(this.scene,t);this.mesh.update(e)},u.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()},e.exports=m},{"../../components/colorscale":662,"../../lib":787,"../../lib/gl_format_color":783,"../../plots/gl3d/zip3":891,"gl-cone3d":262}],1010:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/defaults'),a=t('./attributes');e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l=s('u'),c=s('v'),u=s('w'),f=s('x'),h=s('y'),p=s('z');l&&l.length&&c&&c.length&&u&&u.length&&f&&f.length&&h&&h.length&&p&&p.length?(s('sizeref'),s('sizemode'),s('anchor'),s('lighting.ambient'),s('lighting.diffuse'),s('lighting.specular'),s('lighting.roughness'),s('lighting.fresnel'),s('lightposition.x'),s('lightposition.y'),s('lightposition.z'),i(t,e,o,s,{prefix:"",cLetter:"c"}),s('text'),s('hovertext'),s('hovertemplate'),s('uhoverformat'),s('vhoverformat'),s('whoverformat'),s('xhoverformat'),s('yhoverformat'),s('zhoverformat'),e._length=null):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"./attributes":1007}],1011:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"cone",basePlotModule:t('../../plots/gl3d'),categories:["gl3d","showLegend"],attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:{min:"cmin",max:"cmax"},calc:t('./calc'),plot:t('./convert'),eventData:function(t,e){return t.norm=e.traceCoordinate[6],t},meta:{}}},{"../../plots/gl3d":880,"./attributes":1007,"./calc":1008,"./convert":1009,"./defaults":1010}],1012:[function(t,e,r){"use strict";var n=t('../heatmap/attributes'),i=t('../scatter/attributes'),a=t('../../plots/cartesian/axis_format_attributes'),o=a.axisHoverFormat,s=a.descriptionOnlyNumbers,l=t('../../components/colorscale/attributes'),c=t('../../components/drawing/attributes').dash,u=t('../../plots/font_attributes'),f=t('../../lib/extend').extendFlat,h=t('../../constants/filter_ops'),p=h.COMPARISON_OPS2,d=h.INTERVAL_OPS,m=i.line;e.exports=f({z:n.z,x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,xperiod:n.xperiod,yperiod:n.yperiod,xperiod0:i.xperiod0,yperiod0:i.yperiod0,xperiodalignment:n.xperiodalignment,yperiodalignment:n.yperiodalignment,text:n.text,hovertext:n.hovertext,transpose:n.transpose,xtype:n.xtype,ytype:n.ytype,xhoverformat:o('x'),yhoverformat:o('y'),zhoverformat:o('z',1),hovertemplate:n.hovertemplate,hoverongaps:n.hoverongaps,connectgaps:f({},n.connectgaps,{}),fillcolor:{valType:"color",editType:"calc"},autocontour:{valType:"boolean",dflt:!0,editType:"calc",impliedEdits:{"contours.start":void 0,"contours.end":void 0,"contours.size":void 0}},ncontours:{valType:"integer",dflt:15,min:1,editType:"calc"},contours:{type:{valType:"enumerated",values:["levels","constraint"],dflt:"levels",editType:"calc"},start:{valType:"number",dflt:null,editType:"plot",impliedEdits:{"^autocontour":!1}},end:{valType:"number",dflt:null,editType:"plot",impliedEdits:{"^autocontour":!1}},size:{valType:"number",dflt:null,min:0,editType:"plot",impliedEdits:{"^autocontour":!1}},coloring:{valType:"enumerated",values:["fill",'heatmap','lines',"none"],dflt:"fill",editType:"calc"},showlines:{valType:"boolean",dflt:!0,editType:"plot"},showlabels:{valType:"boolean",dflt:!1,editType:"plot"},labelfont:u({editType:"plot",colorEditType:"style"}),labelformat:{valType:"string",dflt:"",editType:"plot",description:s('contour label')},operation:{valType:"enumerated",values:[].concat(p).concat(d),dflt:"=",editType:"calc"},value:{valType:"any",dflt:0,editType:"calc"},editType:"calc",impliedEdits:{autocontour:!1}},line:{color:f({},m.color,{editType:"style+colorbars"}),width:{valType:"number",min:0,editType:"style+colorbars"},dash:c,smoothing:f({},m.smoothing,{}),editType:"plot"}},l('',{cLetter:"z",autoColorDflt:!1,editTypeOverride:"calc"}))},{"../../components/colorscale/attributes":657,"../../components/drawing/attributes":671,"../../constants/filter_ops":759,"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../../plots/font_attributes":867,"../heatmap/attributes":1069,"../scatter/attributes":1202}],1013:[function(t,e,r){"use strict";var n=t('../../components/colorscale'),i=t('../heatmap/calc'),a=t('./set_contours'),o=t('./end_plus');e.exports=function(t,e){var r=i(t,e),s=r[0].z;a(e,s);var l,c=e.contours,u=n.extractOpts(e);if("heatmap"===c.coloring&&u.auto&&!1===e.autocontour){var f=c.start,h=o(c),p=c.size||1,d=Math.floor((h-f)/p)+1;isFinite(p)||(p=1,d=1);var m=f-p/2;l=[m,m+d*p]}else l=s;return n.calc(t,e,{vals:l,cLetter:"z"}),r}},{"../../components/colorscale":662,"../heatmap/calc":1070,"./end_plus":1023,"./set_contours":1031}],1014:[function(t,e,r){"use strict";e.exports=function(t,e){var r,n=t[0],i=n.z;switch(e.type){case"levels":var a=Math.min(i[0][0],i[0][1]);for(r=0;r<t.length;r++){var o=t[r];o.prefixBoundary=!o.edgepaths.length&&(a>o.level||o.starts.length&&a===o.level)}break;case"constraint":if(n.prefixBoundary=!1,n.edgepaths.length)return;var s=n.x.length,l=n.y.length,c=-1/0,u=1/0;for(r=0;r<l;r++)u=Math.min(u,i[r][0]),u=Math.min(u,i[r][s-1]),c=Math.max(c,i[r][0]),c=Math.max(c,i[r][s-1]);for(r=1;r<s-1;r++)u=Math.min(u,i[0][r]),u=Math.min(u,i[l-1][r]),c=Math.max(c,i[0][r]),c=Math.max(c,i[l-1][r]);var f,h,p=e.value;switch(e._operation){case">":p>c&&(n.prefixBoundary=!0);break;case"<":(p<u||n.starts.length&&p===u)&&(n.prefixBoundary=!0);break;case"[]":f=Math.min(p[0],p[1]),((h=Math.max(p[0],p[1]))<u||f>c||n.starts.length&&h===u)&&(n.prefixBoundary=!0);break;case"][":f=Math.min(p[0],p[1]),h=Math.max(p[0],p[1]),f<u&&h>c&&(n.prefixBoundary=!0)}}}},{}],1015:[function(t,e,r){"use strict";var n=t('../../components/colorscale'),i=t('./make_color_map'),a=t('./end_plus');function o(t,e,r){var o=e.contours,s=e.line,l=o.size||1,c=o.coloring,u=i(e,{isColorbar:!0});if("heatmap"===c){var f=n.extractOpts(e);r._fillgradient=f.reversescale?n.flipScale(f.colorscale):f.colorscale,r._zrange=[f.min,f.max]}else"fill"===c&&(r._fillcolor=u);r._line={color:"lines"===c?u:s.color,width:!1!==o.showlines?s.width:0,dash:s.dash},r._levels={start:o.start,end:a(o),size:l}}e.exports={min:"zmin",max:"zmax",calc:o}},{"../../components/colorscale":662,"./end_plus":1023,"./make_color_map":1028}],1016:[function(t,e,r){"use strict";e.exports={BOTTOMSTART:[1,9,13,104,713],TOPSTART:[4,6,7,104,713],LEFTSTART:[8,12,14,208,1114],RIGHTSTART:[2,3,11,208,1114],NEWDELTA:[null,[-1,0],[0,-1],[-1,0],[1,0],null,[0,-1],[-1,0],[0,1],[0,1],null,[0,1],[1,0],[1,0],[0,-1]],CHOOSESADDLE:{104:[4,1],208:[2,8],713:[7,13],1114:[11,14]},SADDLEREMAINDER:{1:4,2:8,4:1,7:13,8:2,11:14,13:7,14:11},LABELDISTANCE:2,LABELINCREASE:10,LABELMIN:3,LABELMAX:10,LABELOPTIMIZER:{EDGECOST:1,ANGLECOST:1,NEIGHBORCOST:5,SAMELEVELFACTOR:10,SAMELEVELDISTANCE:5,MAXCOST:100,INITIALSEARCHPOINTS:10,ITERATIONS:5}}},{}],1017:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('./label_defaults'),a=t('../../components/color'),o=a.addOpacity,s=a.opacity,l=t('../../constants/filter_ops'),c=l.CONSTRAINT_REDUCTION,u=l.COMPARISON_OPS2;function f(t,e){var r;-1===u.indexOf(e.operation)?(t('contours.value',[0,1]),Array.isArray(e.value)?e.value.length>2?e.value=e.value.slice(2):0===e.length?e.value=[0,1]:e.length<2?(r=parseFloat(e.value[0]),e.value=[r,r+1]):e.value=[parseFloat(e.value[0]),parseFloat(e.value[1])]:n(e.value)&&(r=parseFloat(e.value),e.value=[r,r+1])):(t('contours.value',0),n(e.value)||(Array.isArray(e.value)?e.value=parseFloat(e.value[0]):e.value=0))}e.exports=function(t,e,r,n,a,l){var u,h,p,d=e.contours,m=r('contours.operation');d._operation=c[m],f(r,d),"='===m?u=d.showlines=!0:(u=r('contours.showlines'),p=r('fillcolor',o((t.line||{}).color||a,.5))),u&&(h=r('line.color',p&&s(p)?o(e.fillcolor,1):a),r('line.width',2),r('line.dash')),r('line.smoothing'),i(r,n,h,l)}},{'../../components/color":650,"../../constants/filter_ops":759,"./label_defaults":1027,"fast-isnumeric":246}],1018:[function(t,e,r){"use strict";var n=t('../../constants/filter_ops'),i=t('fast-isnumeric');function a(t,e){var r,a=Array.isArray(e);function o(t){return i(t)?+t:null}return-1!==n.COMPARISON_OPS2.indexOf(t)?r=o(a?e[0]:e):-1!==n.INTERVAL_OPS.indexOf(t)?r=a?[o(e[0]),o(e[1])]:[o(e),o(e)]:-1!==n.SET_OPS.indexOf(t)&&(r=a?e.map(o):[o(e)]),r}function o(t){return function(e){e=a(t,e);var r=Math.min(e[0],e[1]),n=Math.max(e[0],e[1]);return{start:r,end:n,size:n-r}}}function s(t){return function(e){return{start:e=a(t,e),end:1/0,size:1/0}}}e.exports={"[]":o('[]'),"][":o(']['),">":s('>'),"<":s('<'),"=':s('=')}},{'../../constants/filter_ops":759,"fast-isnumeric":246}],1019:[function(t,e,r){"use strict";e.exports=function(t,e,r,n){var i=n('contours.start'),a=n('contours.end'),o=!1===i||!1===a,s=r('contours.size');!(o?e.autocontour=!0:r('autocontour',!1))&&s||r('ncontours')}},{}],1020:[function(t,e,r){"use strict";var n=t('../../lib');function i(t){return n.extendFlat({},t,{edgepaths:n.extendDeep([],t.edgepaths),paths:n.extendDeep([],t.paths),starts:n.extendDeep([],t.starts)})}e.exports=function(t,e){var r,a,o,s=function(t){return t.reverse()},l=function(t){return t};switch(e){case"=":case"<":return t;case">":for(1!==t.length&&n.warn('Contour data invalid for the specified inequality operation.'),a=t[0],r=0;r<a.edgepaths.length;r++)a.edgepaths[r]=s(a.edgepaths[r]);for(r=0;r<a.paths.length;r++)a.paths[r]=s(a.paths[r]);for(r=0;r<a.starts.length;r++)a.starts[r]=s(a.starts[r]);return t;case"][":var c=s;s=l,l=c;case"[]":for(2!==t.length&&n.warn('Contour data invalid for the specified inequality range operation.'),a=i(t[0]),o=i(t[1]),r=0;r<a.edgepaths.length;r++)a.edgepaths[r]=s(a.edgepaths[r]);for(r=0;r<a.paths.length;r++)a.paths[r]=s(a.paths[r]);for(r=0;r<a.starts.length;r++)a.starts[r]=s(a.starts[r]);for(;o.edgepaths.length;)a.edgepaths.push(l(o.edgepaths.shift()));for(;o.paths.length;)a.paths.push(l(o.paths.shift()));for(;o.starts.length;)a.starts.push(l(o.starts.shift()));return[a]}}},{"../../lib":787}],1021:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../heatmap/xyz_defaults'),a=t('../scatter/period_defaults'),o=t('./constraint_defaults'),s=t('./contours_defaults'),l=t('./style_defaults'),c=t('./attributes');e.exports=function(t,e,r,u){function f(r,i){return n.coerce(t,e,c,r,i)}function h(r){return n.coerce2(t,e,c,r)}if(i(t,e,f,u)){a(t,e,u,f),f('xhoverformat'),f('yhoverformat'),f('text'),f('hovertext'),f('hovertemplate'),f('hoverongaps');var p="constraint"===f('contours.type');f('connectgaps',n.isArray1D(e.z)),p?o(t,e,f,u,r):(s(t,e,f,h),l(t,e,f,u))}else e.visible=!1}},{"../../lib":787,"../heatmap/xyz_defaults":1083,"../scatter/period_defaults":1222,"./attributes":1012,"./constraint_defaults":1017,"./contours_defaults":1019,"./style_defaults":1033}],1022:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./constraint_mapping'),a=t('./end_plus');e.exports=function(t,e,r){for(var o="constraint"===t.type?i[t._operation](t.value):t,s=o.size,l=[],c=a(o),u=r.trace._carpetTrace,f=u?{xaxis:u.aaxis,yaxis:u.baxis,x:r.a,y:r.b}:{xaxis:e.xaxis,yaxis:e.yaxis,x:r.x,y:r.y},h=o.start;h<c;h+=s)if(l.push(n.extendFlat({level:h,crossings:{},starts:[],edgepaths:[],paths:[],z:r.z,smoothing:r.trace.line.smoothing},f)),l.length>1e3){n.warn('Too many contours, clipping at 1000',t);break}return l}},{"../../lib":787,"./constraint_mapping":1018,"./end_plus":1023}],1023:[function(t,e,r){"use strict";e.exports=function(t){return t.end+t.size/1e6}},{}],1024:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./constants');function a(t,e,r,n){return Math.abs(t[0]-e[0])<r&&Math.abs(t[1]-e[1])<n}function o(t,e){var r=t[2]-e[2],n=t[3]-e[3];return Math.sqrt(r*r+n*n)}function s(t,e,r,s,u){var f,h=e.join(','),p=t.crossings[h],d=l(p,r,e),m=[c(t,e,[-d[0],-d[1]])],g=t.z.length,v=t.z[0].length,y=e.slice(),x=d.slice();for(f=0;f<1e4;f++){if(p>20?(p=i.CHOOSESADDLE[p][(d[0]||d[1])<0?0:1],t.crossings[h]=i.SADDLEREMAINDER[p]):delete t.crossings[h],!(d=i.NEWDELTA[p])){n.log('Found bad marching index:',p,e,t.level);break}m.push(c(t,e,d)),e[0]+=d[0],e[1]+=d[1],h=e.join(','),a(m[m.length-1],m[m.length-2],s,u)&&m.pop();var b=d[0]&&(e[0]<0||e[0]>v-2)||d[1]&&(e[1]<0||e[1]>g-2);if(e[0]===y[0]&&e[1]===y[1]&&d[0]===x[0]&&d[1]===x[1]||r&&b)break;p=t.crossings[h]}1e4===f&&n.log('Infinite loop in contour?');var _,w,T,k,M,A,S,E,L,C,P,I=a(m[0],m[m.length-1],s,u),z=0,O=.2*t.smoothing,D=[],R=0;for(f=1;f<m.length;f++)z+=S=o(m[f],m[f-1]),D.push(S);var F=z/D.length*O;function B(t){return m[t%m.length]}for(f=m.length-2;f>=R;f--)if((_=D[f])<F){for(T=0,w=f-1;w>=R&&_+D[w]<F;w--)_+=D[w];if(I&&f===m.length-2)for(T=0;T<w&&_+D[T]<F;T++)_+=D[T];M=f-w+T+1,A=Math.floor((f+w+T+2)/2),k=I||f!==m.length-2?I||-1!==w?M%2?B(A):[(B(A)[0]+B(A+1)[0])/2,(B(A)[1]+B(A+1)[1])/2]:m[0]:m[m.length-1],m.splice(w+1,f-w+1,k),f=w+1,T&&(R=T),I&&(f===m.length-2?m[T]=m[m.length-1]:0===f&&(m[m.length-1]=m[0]))}for(m.splice(0,R),f=0;f<m.length;f++)m[f].length=2;if(!(m.length<2))if(I)m.pop(),t.paths.push(m);else{r||n.log('Unclosed interior contour?',t.level,y.join(','),m.join('L'));var N=!1;for(E=0;E<t.edgepaths.length;E++)if(C=t.edgepaths[E],!N&&a(C[0],m[m.length-1],s,u)){m.pop(),N=!0;var j=!1;for(L=0;L<t.edgepaths.length;L++)if(a((P=t.edgepaths[L])[P.length-1],m[0],s,u)){j=!0,m.shift(),t.edgepaths.splice(E,1),L===E?t.paths.push(m.concat(P)):(L>E&&L--,t.edgepaths[L]=P.concat(m,C));break}j||(t.edgepaths[E]=m.concat(C))}for(E=0;E<t.edgepaths.length&&!N;E++)a((C=t.edgepaths[E])[C.length-1],m[0],s,u)&&(m.shift(),t.edgepaths[E]=C.concat(m),N=!0);N||t.edgepaths.push(m)}}function l(t,e,r){var n=0,a=0;return t>20&&e?208===t||1114===t?n=0===r[0]?1:-1:a=0===r[1]?1:-1:-1!==i.BOTTOMSTART.indexOf(t)?a=1:-1!==i.LEFTSTART.indexOf(t)?n=1:-1!==i.TOPSTART.indexOf(t)?a=-1:n=-1,[n,a]}function c(t,e,r){var n=e[0]+Math.max(r[0],0),i=e[1]+Math.max(r[1],0),a=t.z[i][n],o=t.xaxis,s=t.yaxis;if(r[1]){var l=(t.level-a)/(t.z[i][n+1]-a);return[o.c2p((1-l)*t.x[n]+l*t.x[n+1],!0),s.c2p(t.y[i],!0),n+l,i]}var c=(t.level-a)/(t.z[i+1][n]-a);return[o.c2p(t.x[n],!0),s.c2p((1-c)*t.y[i]+c*t.y[i+1],!0),n,i+c]}e.exports=function(t,e,r){var i,a,o,l;for(e=e||.01,r=r||.01,a=0;a<t.length;a++){for(o=t[a],l=0;l<o.starts.length;l++)s(o,o.starts[l],'edge',e,r);for(i=0;Object.keys(o.crossings).length&&i<1e4;)i++,s(o,Object.keys(o.crossings)[0].split(',').map(Number),void 0,e,r);1e4===i&&n.log('Infinite loop in contour?')}}},{"../../lib":787,"./constants":1016}],1025:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('../heatmap/hover');e.exports=function(t,e,r,a,o){o||(o={}),o.isContour=!0;var s=i(t,e,r,a,o);return s&&s.forEach((function(t){var e=t.trace;"constraint"===e.contours.type&&(e.fillcolor&&n.opacity(e.fillcolor)?t.color=n.addOpacity(e.fillcolor,1):e.contours.showlines&&n.opacity(e.line.color)&&(t.color=n.addOpacity(e.line.color,1)))})),s}},{"../../components/color":650,"../heatmap/hover":1076}],1026:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot').plot,style:t('./style'),colorbar:t('./colorbar'),hoverPoints:t('./hover'),moduleType:"trace",name:"contour",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','2dMap','contour',"showLegend"],meta:{}}},{"../../plots/cartesian":852,"./attributes":1012,"./calc":1013,"./colorbar":1015,"./defaults":1021,"./hover":1025,"./plot":1030,"./style":1032}],1027:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e,r,i){if(i||(i={}),t('contours.showlabels')){var a=e.font;n.coerceFont(t,'contours.labelfont',{family:a.family,size:a.size,color:r}),t('contours.labelformat')}!1!==i.hasHover&&t('zhoverformat')}},{"../../lib":787}],1028:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/colorscale'),a=t('./end_plus');e.exports=function(t){var e=t.contours,r=e.start,o=a(e),s=e.size||1,l=Math.floor((o-r)/s)+1,c="lines"===e.coloring?0:1,u=i.extractOpts(t);isFinite(s)||(s=1,l=1);var f,h,p=u.reversescale?i.flipScale(u.colorscale):u.colorscale,d=p.length,m=new Array(d),g=new Array(d);if("heatmap"===e.coloring){var v=u.min,y=u.max;for(h=0;h<d;h++)f=p[h],m[h]=f[0]*(y-v)+v,g[h]=f[1];var x=n.extent([v,y,e.start,e.start+s*(l-1)]),b=x[v<y?0:1],_=x[v<y?1:0];b!==v&&(m.splice(0,0,b),g.splice(0,0,g[0])),_!==y&&(m.push(_),g.push(g[g.length-1]))}else for(h=0;h<d;h++)f=p[h],m[h]=(f[0]*(l+c-1)-c/2)*s+r,g[h]=f[1];return i.makeColorScaleFunc({domain:m,range:g},{noNumericCheck:!0})}},{"../../components/colorscale":662,"./end_plus":1023,"@plotly/d3":58}],1029:[function(t,e,r){"use strict";var n=t('./constants');function i(t,e){var r=(e[0][0]>t?0:1)+(e[0][1]>t?0:2)+(e[1][1]>t?0:4)+(e[1][0]>t?0:8);return 5===r||10===r?t>(e[0][0]+e[0][1]+e[1][0]+e[1][1])/4?5===r?713:1114:5===r?104:208:15===r?0:r}e.exports=function(t){var e,r,a,o,s,l,c,u,f,h=t[0].z,p=h.length,d=h[0].length,m=2===p||2===d;for(r=0;r<p-1;r++)for(o=[],0===r&&(o=o.concat(n.BOTTOMSTART)),r===p-2&&(o=o.concat(n.TOPSTART)),e=0;e<d-1;e++)for(a=o.slice(),0===e&&(a=a.concat(n.LEFTSTART)),e===d-2&&(a=a.concat(n.RIGHTSTART)),s=e+",'+r,l=[[h[r][e],h[r][e+1]],[h[r+1][e],h[r+1][e+1]]],f=0;f<t.length;f++)(c=i((u=t[f]).level,l))&&(u.crossings[s]=c,-1!==a.indexOf(c)&&(u.starts.push([e,r]),m&&-1!==a.indexOf(c,a.indexOf(c)+1)&&u.starts.push([e,r])))}},{'./constants":1016}],1030:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../../components/colorscale'),s=t('../../lib/svg_text_utils'),l=t('../../plots/cartesian/axes'),c=t('../../plots/cartesian/set_convert'),u=t('../heatmap/plot'),f=t('./make_crossings'),h=t('./find_all_paths'),p=t('./empty_pathinfo'),d=t('./convert_to_constraints'),m=t('./close_boundaries'),g=t('./constants'),v=g.LABELOPTIMIZER;function y(t,e,r){var n=i.ensureSingle(t,'g','contourbg').selectAll('path').data("fill"===r.coloring?[0]:[]);n.enter().append('path'),n.exit().remove(),n.attr('d',"M"+e.join('L')+"Z").style('stroke','none')}function x(t,e,r,a){var o="fill"===a.coloring||"constraint"===a.type&&"="!==a._operation,s="M"+r.join('L')+"Z";o&&m(e,a);var l=i.ensureSingle(t,'g','contourfill').selectAll('path').data(o?e:[]);l.enter().append('path'),l.exit().remove(),l.each((function(t){var e=(t.prefixBoundary?s:"")+b(t,r);e?n.select(this).attr('d',e).style('stroke','none'):n.select(this).remove()}))}function b(t,e){var r,n,o,s,l,c,u='',f=0,h=t.edgepaths.map((function(t,e){return e})),p=!0;function d(t){return Math.abs(t[1]-e[0][1])<.01}function m(t){return Math.abs(t[1]-e[2][1])<.01}function g(t){return Math.abs(t[0]-e[0][0])<.01}function v(t){return Math.abs(t[0]-e[2][0])<.01}for(;h.length;){for(c=a.smoothopen(t.edgepaths[f],t.smoothing),u+=p?c:c.replace(/^M/,'L'),h.splice(h.indexOf(f),1),r=t.edgepaths[f][t.edgepaths[f].length-1],s=-1,o=0;o<4;o++){if(!r){i.log('Missing end?',f,t);break}for(d(r)&&!v(r)?n=e[1]:g(r)?n=e[0]:m(r)?n=e[3]:v(r)&&(n=e[2]),l=0;l<t.edgepaths.length;l++){var y=t.edgepaths[l][0];Math.abs(r[0]-n[0])<.01?Math.abs(r[0]-y[0])<.01&&(y[1]-r[1])*(n[1]-y[1])>=0&&(n=y,s=l):Math.abs(r[1]-n[1])<.01?Math.abs(r[1]-y[1])<.01&&(y[0]-r[0])*(n[0]-y[0])>=0&&(n=y,s=l):i.log('endpt to newendpt is not vert. or horz.',r,n,y)}if(r=n,s>=0)break;u+="L"+n}if(s===t.edgepaths.length){i.log('unclosed perimeter path');break}f=s,(p=-1===h.indexOf(f))&&(f=h[0],u+='Z')}for(f=0;f<t.paths.length;f++)u+=a.smoothclosed(t.paths[f],t.smoothing);return u}function _(t,e,o,s,l){var c=i.ensureSingle(t,'g','contourlines'),u=!1!==l.showlines,f=l.showlabels,h=u&&f,p=r.createLines(c,u||f,e),d=r.createLineClip(c,h,o,s.trace.uid),m=t.selectAll('g.contourlabels').data(f?[0]:[]);if(m.exit().remove(),m.enter().append('g').classed('contourlabels',!0),f){var v=[],y=[];i.clearLocationCache();var x=r.labelFormatter(o,s),b=a.tester.append('text').attr('data-notex',1).call(a.font,l.labelfont),_=e[0].xaxis,w=e[0].yaxis,T=_._length,k=w._length,M=_.range,A=w.range,S=i.aggNums(Math.min,null,s.x),E=i.aggNums(Math.max,null,s.x),L=i.aggNums(Math.min,null,s.y),C=i.aggNums(Math.max,null,s.y),P=Math.max(_.c2p(S,!0),0),I=Math.min(_.c2p(E,!0),T),z=Math.max(w.c2p(C,!0),0),O=Math.min(w.c2p(L,!0),k),D={};M[0]<M[1]?(D.left=P,D.right=I):(D.left=I,D.right=P),A[0]<A[1]?(D.top=z,D.bottom=O):(D.top=O,D.bottom=z),D.middle=(D.top+D.bottom)/2,D.center=(D.left+D.right)/2,v.push([[D.left,D.top],[D.right,D.top],[D.right,D.bottom],[D.left,D.bottom]]);var R=Math.sqrt(T*T+k*k),F=g.LABELDISTANCE*R/Math.max(1,e.length/g.LABELINCREASE);p.each((function(t){var e=r.calcTextOpts(t.level,x,b,o);n.select(this).selectAll('path').each((function(){var t=this,n=i.getVisibleSegment(t,D,e.height/2);if(n&&!(n.len<(e.width+e.height)*g.LABELMIN))for(var a=Math.min(Math.ceil(n.len/F),g.LABELMAX),o=0;o<a;o++){var s=r.findBestTextLocation(t,n,e,y,D);if(!s)break;r.addLabelData(s,e,y,v)}}))})),b.remove(),r.drawLabels(m,y,o,d,h?v:null)}f&&!u&&p.remove()}function w(t,e,r,n){var a=e.width/2,o=e.height/2,s=t.x,l=t.y,c=t.theta,u=Math.cos(c)*a,f=Math.sin(c)*a,h=(s>n.center?n.right-s:s-n.left)/(u+Math.abs(Math.sin(c)*o)),p=(l>n.middle?n.bottom-l:l-n.top)/(Math.abs(f)+Math.cos(c)*o);if(h<1||p<1)return 1/0;var d=v.EDGECOST*(1/(h-1)+1/(p-1));d+=v.ANGLECOST*c*c;for(var m=s-u,g=l-f,y=s+u,x=l+f,b=0;b<r.length;b++){var _=r[b],w=Math.cos(_.theta)*_.width/2,T=Math.sin(_.theta)*_.width/2,k=2*i.segmentDistance(m,g,y,x,_.x-w,_.y-T,_.x+w,_.y+T)/(e.height+_.height),M=_.level===e.level,A=M?v.SAMELEVELDISTANCE:1;if(k<=A)return 1/0;d+=v.NEIGHBORCOST*(M?v.SAMELEVELFACTOR:1)/(k-A)}return d}function T(t,e,r,n,o){var s=n.trace,l=r._fullLayout._clips,c="clip"+s.uid,u=l.selectAll("#"+c).data(s.connectgaps?[]:[0]);if(u.enter().append('clipPath').classed('contourclip',!0).attr('id',c),u.exit().remove(),!1===s.connectgaps){var p={level:.9,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:e.xaxis,yaxis:e.yaxis,x:n.x,y:n.y,z:k(n),smoothing:0};f([p]),h([p]),m([p],{type:"levels"}),i.ensureSingle(u,'path','').attr('d',(p.prefixBoundary?"M"+o.join('L')+"Z":"")+b(p,o))}else c=null;a.setClipUrl(t,c,r)}function k(t){var e,r,n=t.trace._emptypoints,i=[],a=t.z.length,o=t.z[0].length,s=[];for(e=0;e<o;e++)s.push(1);for(e=0;e<a;e++)i.push(s.slice());for(e=0;e<n.length;e++)i[(r=n[e])[0]][r[1]]=0;return t.zmask=i,i}r.plot=function(t,e,r,a){var o=e.xaxis,s=e.yaxis;i.makeTraceGroups(a,r,'contour').each((function(r){var a=n.select(this),l=r[0],c=l.trace,m=l.x,g=l.y,v=c.contours,b=p(v,e,l),w=i.ensureSingle(a,'g','heatmapcoloring'),k=[];"heatmap"===v.coloring&&(k=[r]),u(t,e,k,w),f(b),h(b);var M=o.c2p(m[0],!0),A=o.c2p(m[m.length-1],!0),S=s.c2p(g[0],!0),E=s.c2p(g[g.length-1],!0),L=[[M,E],[A,E],[A,S],[M,S]],C=b;"constraint"===v.type&&(C=d(b,v._operation)),y(a,L,v),x(a,C,L,v),_(a,b,t,l,v),T(a,e,t,l,L)}))},r.createLines=function(t,e,r){var n=r[0].smoothing,i=t.selectAll('g.contourlevel').data(e?r:[]);if(i.exit().remove(),i.enter().append('g').classed('contourlevel',!0),e){var o=i.selectAll('path.openline').data((function(t){return t.pedgepaths||t.edgepaths}));o.exit().remove(),o.enter().append('path').classed('openline',!0),o.attr('d',(function(t){return a.smoothopen(t,n)})).style('stroke-miterlimit',1).style('vector-effect','non-scaling-stroke');var s=i.selectAll('path.closedline').data((function(t){return t.ppaths||t.paths}));s.exit().remove(),s.enter().append('path').classed('closedline',!0),s.attr('d',(function(t){return a.smoothclosed(t,n)})).style('stroke-miterlimit',1).style('vector-effect','non-scaling-stroke')}return i},r.createLineClip=function(t,e,r,n){var i=e?"clipline"+n:null,o=r._fullLayout._clips.selectAll("#"+i).data(e?[0]:[]);return o.exit().remove(),o.enter().append('clipPath').classed('contourlineclip',!0).attr('id',i),a.setClipUrl(t,i,r),o},r.labelFormatter=function(t,e){var r=t._fullLayout,n=e.trace,i=n.contours,a={type:"linear",_id:"ycontour",showexponent:"all",exponentformat:"B"};if(i.labelformat)a.tickformat=i.labelformat,c(a,r);else{var s=o.extractOpts(n);if(s&&s.colorbar&&s.colorbar._axis)a=s.colorbar._axis;else{if("constraint"===i.type){var u=i.value;Array.isArray(u)?a.range=[u[0],u[u.length-1]]:a.range=[u,u]}else a.range=[i.start,i.end],a.nticks=(i.end-i.start)/i.size;a.range[0]===a.range[1]&&(a.range[1]+=a.range[0]||1),a.nticks||(a.nticks=1e3),c(a,r),l.prepTicks(a),a._tmin=null,a._tmax=null}}return function(t){return l.tickText(a,t).text}},r.calcTextOpts=function(t,e,r,n){var i=e(t);r.text(i).call(s.convertToTspans,n);var o=r.node(),l=a.bBox(o,!0);return{text:i,width:l.width,height:l.height,fontSize:+o.style["font-size"].replace('px',''),level:t,dy:(l.top+l.bottom)/2}},r.findBestTextLocation=function(t,e,r,n,a){var o,s,l,c,u,f=r.width;e.isClosed?(s=e.len/v.INITIALSEARCHPOINTS,o=e.min+s/2,l=e.max):(s=(e.len-f)/(v.INITIALSEARCHPOINTS+1),o=e.min+s+f/2,l=e.max-(s+f)/2);for(var h=1/0,p=0;p<v.ITERATIONS;p++){for(var d=o;d<l;d+=s){var m=i.getTextLocation(t,e.total,d,f),g=w(m,r,n,a);g<h&&(h=g,u=m,c=d)}if(h>2*v.MAXCOST)break;p&&(s/=2),l=(o=c-s/2)+1.5*s}if(h<=v.MAXCOST)return u},r.addLabelData=function(t,e,r,n){var i=e.fontSize,a=e.width+i/3,o=Math.max(0,e.height-i/3),s=t.x,l=t.y,c=t.theta,u=Math.sin(c),f=Math.cos(c),h=function(t,e){return[s+t*f-e*u,l+t*u+e*f]},p=[h(-a/2,-o/2),h(-a/2,o/2),h(a/2,o/2),h(a/2,-o/2)];r.push({text:e.text,x:s,y:l,dy:e.dy,theta:c,level:e.level,width:a,height:o}),n.push(p)},r.drawLabels=function(t,e,r,a,o){var l=t.selectAll('text').data(e,(function(t){return t.text+",'+t.x+','+t.y+',"+t.theta}));if(l.exit().remove(),l.enter().append('text').attr({"data-notex":1,"text-anchor":"middle"}).each((function(t){var e=t.x+Math.sin(t.theta)*t.dy,i=t.y-Math.cos(t.theta)*t.dy;n.select(this).text(t.text).attr({x:e,y:i,transform:"rotate('+180*t.theta/Math.PI+' '+e+' '+i+')"}).call(s.convertToTspans,r)})),o){for(var c='',u=0;u<o.length;u++)c+="M"+o[u].join('L')+"Z";i.ensureSingle(a,'path','').attr('d',c)}}},{"../../components/colorscale":662,"../../components/drawing":672,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/cartesian/axes":838,"../../plots/cartesian/set_convert":859,"../heatmap/plot":1080,"./close_boundaries":1014,"./constants":1016,"./convert_to_constraints":1020,"./empty_pathinfo":1022,"./find_all_paths":1024,"./make_crossings":1029,"@plotly/d3":58}],1031:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib');function a(t,e,r){var i={type:"linear",range:[t,e]};return n.autoTicks(i,(e-t)/(r||15)),i}e.exports=function(t,e){var r=t.contours;if(t.autocontour){var o=t.zmin,s=t.zmax;(t.zauto||void 0===o)&&(o=i.aggNums(Math.min,null,e)),(t.zauto||void 0===s)&&(s=i.aggNums(Math.max,null,e));var l=a(o,s,t.ncontours);r.size=l.dtick,r.start=n.tickFirst(l),l.range.reverse(),r.end=n.tickFirst(l),r.start===o&&(r.start+=r.size),r.end===s&&(r.end-=r.size),r.start>r.end&&(r.start=r.end=(r.start+r.end)/2),t._input.contours||(t._input.contours={}),i.extendFlat(t._input.contours,{start:r.start,end:r.end,size:r.size}),t._input.autocontour=!0}else if("constraint"!==r.type){var c,u=r.start,f=r.end,h=t._input.contours;u>f&&(r.start=h.start=f,f=r.end=h.end=u,u=r.start),r.size>0||(c=u===f?1:a(u,f,t.ncontours).dtick,h.size=r.size=c)}}},{"../../lib":787,"../../plots/cartesian/axes":838}],1032:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../heatmap/style'),o=t('./make_color_map');e.exports=function(t){var e=n.select(t).selectAll('g.contour');e.style('opacity',(function(t){return t[0].trace.opacity})),e.each((function(t){var e=n.select(this),r=t[0].trace,a=r.contours,s=r.line,l=a.size||1,c=a.start,u="constraint"===a.type,f=!u&&"lines"===a.coloring,h=!u&&"fill"===a.coloring,p=f||h?o(r):null;e.selectAll('g.contourlevel').each((function(t){n.select(this).selectAll('path').call(i.lineGroupStyle,s.width,f?p(t.level):s.color,s.dash)}));var d=a.labelfont;if(e.selectAll('g.contourlabels text').each((function(t){i.font(n.select(this),{family:d.family,size:d.size,color:d.color||(f?p(t.level):s.color)})})),u)e.selectAll('g.contourfill path').style('fill',r.fillcolor);else if(h){var m;e.selectAll('g.contourfill path').style('fill',(function(t){return void 0===m&&(m=t.level),p(t.level+.5*l)})),void 0===m&&(m=c),e.selectAll('g.contourbg path').style('fill',p(m-.5*l))}})),a(t)}},{"../../components/drawing":672,"../heatmap/style":1081,"./make_color_map":1028,"@plotly/d3":58}],1033:[function(t,e,r){"use strict";var n=t('../../components/colorscale/defaults'),i=t('./label_defaults');e.exports=function(t,e,r,a,o){var s,l=r('contours.coloring'),c='';"fill"===l&&(s=r('contours.showlines')),!1!==s&&("lines"!==l&&(c=r('line.color','#000')),r('line.width',.5),r('line.dash')),"none"!==l&&(!0!==t.showlegend&&(e.showlegend=!1),e._dfltShowLegend=!1,n(t,e,a,r,{prefix:"",cLetter:"z"})),r('line.smoothing'),i(r,a,c,o)}},{"../../components/colorscale/defaults":660,"./label_defaults":1027}],1034:[function(t,e,r){"use strict";var n=t('../heatmap/attributes'),i=t('../contour/attributes'),a=t('../../components/colorscale/attributes'),o=t('../../lib/extend').extendFlat,s=i.contours;e.exports=o({carpet:{valType:"string",editType:"calc"},z:n.z,a:n.x,a0:n.x0,da:n.dx,b:n.y,b0:n.y0,db:n.dy,text:n.text,hovertext:n.hovertext,transpose:n.transpose,atype:n.xtype,btype:n.ytype,fillcolor:i.fillcolor,autocontour:i.autocontour,ncontours:i.ncontours,contours:{type:s.type,start:s.start,end:s.end,size:s.size,coloring:{valType:"enumerated",values:["fill",'lines',"none"],dflt:"fill",editType:"calc"},showlines:s.showlines,showlabels:s.showlabels,labelfont:s.labelfont,labelformat:s.labelformat,operation:s.operation,value:s.value,editType:"calc",impliedEdits:{autocontour:!1}},line:{color:i.line.color,width:i.line.width,dash:i.line.dash,smoothing:i.line.smoothing,editType:"plot"},transforms:void 0},a('',{cLetter:"z",autoColorDflt:!1}))},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../contour/attributes":1012,"../heatmap/attributes":1069}],1035:[function(t,e,r){"use strict";var n=t('../../components/colorscale/calc'),i=t('../../lib'),a=t('../heatmap/convert_column_xyz'),o=t('../heatmap/clean_2d_array'),s=t('../heatmap/interp2d'),l=t('../heatmap/find_empties'),c=t('../heatmap/make_bound_array'),u=t('./defaults'),f=t('../carpet/lookup_carpetid'),h=t('../contour/set_contours');function p(t,e){var r,u,f,h,p,d,m,g=e._carpetTrace,v=g.aaxis,y=g.baxis;v._minDtick=0,y._minDtick=0,i.isArray1D(e.z)&&a(e,v,y,'a','b',["z"]),r=e._a=e._a||e.a,h=e._b=e._b||e.b,r=r?v.makeCalcdata(e,'_a'):[],h=h?y.makeCalcdata(e,'_b'):[],u=e.a0||0,f=e.da||1,p=e.b0||0,d=e.db||1,m=e._z=o(e._z||e.z,e.transpose),e._emptypoints=l(m),s(m,e._emptypoints);var x=i.maxRowLength(m),b="scaled"===e.xtype?"":r,_=c(e,b,u,f,x,v),w="scaled"===e.ytype?"":h,T={a:_,b:c(e,w,p,d,m.length,y),z:m};return"levels"===e.contours.type&&"none"!==e.contours.coloring&&n(t,e,{vals:m,containerStr:"",cLetter:"z"}),[T]}e.exports=function(t,e){var r=e._carpetTrace=f(t,e);if(r&&r.visible&&"legendonly"!==r.visible){if(!e.a||!e.b){var n=t.data[r.index],i=t.data[e.index];i.a||(i.a=n.a),i.b||(i.b=n.b),u(i,e,e._defaultColor,t._fullLayout)}var a=p(t,e);return h(e,e._z),a}}},{"../../components/colorscale/calc":658,"../../lib":787,"../carpet/lookup_carpetid":985,"../contour/set_contours":1031,"../heatmap/clean_2d_array":1071,"../heatmap/convert_column_xyz":1073,"../heatmap/find_empties":1075,"../heatmap/interp2d":1078,"../heatmap/make_bound_array":1079,"./defaults":1036}],1036:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../heatmap/xyz_defaults'),a=t('./attributes'),o=t('../contour/constraint_defaults'),s=t('../contour/contours_defaults'),l=t('../contour/style_defaults');e.exports=function(t,e,r,c){function u(r,i){return n.coerce(t,e,a,r,i)}function f(r){return n.coerce2(t,e,a,r)}if(u('carpet'),t.a&&t.b){if(!i(t,e,u,c,'a','b'))return void(e.visible=!1);u('text'),"constraint"===u('contours.type')?o(t,e,u,c,r,{hasHover:!1}):(s(t,e,u,f),l(t,e,u,c,{hasHover:!1}))}else e._defaultColor=r,e._length=null}},{"../../lib":787,"../contour/constraint_defaults":1017,"../contour/contours_defaults":1019,"../contour/style_defaults":1033,"../heatmap/xyz_defaults":1083,"./attributes":1034}],1037:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../contour/colorbar'),calc:t('./calc'),plot:t('./plot'),style:t('../contour/style'),moduleType:"trace",name:"contourcarpet",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','carpet','contour','symbols','showLegend','hasLines','carpetDependent','noHover',"noSortingByValue"],meta:{}}},{"../../plots/cartesian":852,"../contour/colorbar":1015,"../contour/style":1032,"./attributes":1034,"./calc":1035,"./defaults":1036,"./plot":1038}],1038:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../carpet/map_1d_array'),a=t('../carpet/makepath'),o=t('../../components/drawing'),s=t('../../lib'),l=t('../contour/make_crossings'),c=t('../contour/find_all_paths'),u=t('../contour/plot'),f=t('../contour/constants'),h=t('../contour/convert_to_constraints'),p=t('../contour/empty_pathinfo'),d=t('../contour/close_boundaries'),m=t('../carpet/lookup_carpetid'),g=t('../carpet/axis_aligned_line');function v(t,e){var r,n,i,a,o,s,l,c,u;for(r=0;r<t.length;r++){for(o=(a=t[r]).pedgepaths=[],s=a.ppaths=[],n=0;n<a.edgepaths.length;n++){for(u=a.edgepaths[n],l=[],i=0;i<u.length;i++)l[i]=e(u[i]);o.push(l)}for(n=0;n<a.paths.length;n++){for(u=a.paths[n],c=[],i=0;i<u.length;i++)c[i]=e(u[i]);s.push(c)}}}function y(t,e,r,i,a,l,c){var h=s.ensureSingle(t,'g','contourlines'),p=!1!==a.showlines,d=a.showlabels,m=p&&d,g=u.createLines(h,p||d,e),v=u.createLineClip(h,m,r,i.trace.uid),y=t.selectAll('g.contourlabels').data(d?[0]:[]);if(y.exit().remove(),y.enter().append('g').classed('contourlabels',!0),d){var b=l.xaxis,_=l.yaxis,w=b._length,T=_._length,k=[[[0,0],[w,0],[w,T],[0,T]]],M=[];s.clearLocationCache();var A=u.labelFormatter(r,i),S=o.tester.append('text').attr('data-notex',1).call(o.font,a.labelfont),E={left:0,right:w,center:w/2,top:0,bottom:T,middle:T/2},L=Math.sqrt(w*w+T*T),C=f.LABELDISTANCE*L/Math.max(1,e.length/f.LABELINCREASE);g.each((function(t){var e=u.calcTextOpts(t.level,A,S,r);n.select(this).selectAll('path').each((function(r){var n=this,i=s.getVisibleSegment(n,E,e.height/2);if(i&&(x(n,r,t,i,c,e.height),!(i.len<(e.width+e.height)*f.LABELMIN)))for(var a=Math.min(Math.ceil(i.len/C),f.LABELMAX),o=0;o<a;o++){var l=u.findBestTextLocation(n,i,e,M,E);if(!l)break;u.addLabelData(l,e,M,k)}}))})),S.remove(),u.drawLabels(y,M,r,v,m?k:null)}d&&!p&&g.remove()}function x(t,e,r,n,i,a){for(var o,s=0;s<r.pedgepaths.length;s++)e===r.pedgepaths[s]&&(o=r.edgepaths[s]);if(o){var l=i.a[0],c=i.a[i.a.length-1],u=i.b[0],f=i.b[i.b.length-1],h=b(t,0,1),p=b(t,n.total,n.total-1),d=g(o[0],h),m=n.total-g(o[o.length-1],p);n.min<d&&(n.min=d),n.max>m&&(n.max=m),n.len=n.max-n.min}function g(t,e){var r,n=0,o=.1;return(Math.abs(t[0]-l)<o||Math.abs(t[0]-c)<o)&&(r=_(i.dxydb_rough(t[0],t[1],o)),n=Math.max(n,a*w(e,r)/2)),(Math.abs(t[1]-u)<o||Math.abs(t[1]-f)<o)&&(r=_(i.dxyda_rough(t[0],t[1],o)),n=Math.max(n,a*w(e,r)/2)),n}}function b(t,e,r){var n=t.getPointAtLength(e),i=t.getPointAtLength(r),a=i.x-n.x,o=i.y-n.y,s=Math.sqrt(a*a+o*o);return[a/s,o/s]}function _(t){var e=Math.sqrt(t[0]*t[0]+t[1]*t[1]);return[t[0]/e,t[1]/e]}function w(t,e){var r=Math.abs(t[0]*e[0]+t[1]*e[1]);return Math.sqrt(1-r*r)/r}function T(t,e,r,n,o,l){var c,u,f,h,p=s.ensureSingle(t,'g','contourbg').selectAll('path').data("fill"!==l||o?[]:[0]);p.enter().append('path'),p.exit().remove();var d=[];for(h=0;h<e.length;h++)c=e[h],u=i([],c.x,r.c2p),f=i([],c.y,n.c2p),d.push(a(u,f,c.bicubic));p.attr('d',"M"+d.join('L')+"Z").style('stroke','none')}function k(t,e,r,i,a,o,l,c,u,f,h){var p="fill"===f;p&&d(a,t.contours);var m=s.ensureSingle(e,'g','contourfill').selectAll('path').data(p?a:[]);m.enter().append('path'),m.exit().remove(),m.each((function(e){var a=(e.prefixBoundary?h:"")+M(t,e,o,l,c,u,r,i);a?n.select(this).attr('d',a).style('stroke','none'):n.select(this).remove()}))}function M(t,e,r,n,i,a,l,c){var u,f,h,p,d,m,v,y='',x=e.edgepaths.map((function(t,e){return e})),b=!0,_=1e-4*Math.abs(r[0][0]-r[2][0]),w=1e-4*Math.abs(r[0][1]-r[2][1]);function T(t){return Math.abs(t[1]-r[0][1])<w}function k(t){return Math.abs(t[1]-r[2][1])<w}function M(t){return Math.abs(t[0]-r[0][0])<_}function A(t){return Math.abs(t[0]-r[2][0])<_}function S(t,e){var r,n,o,s,u='';for(T(t)&&!A(t)||k(t)&&!M(t)?(s=i.aaxis,o=g(i,a,[t[0],e[0]],.5*(t[1]+e[1]))):(s=i.baxis,o=g(i,a,.5*(t[0]+e[0]),[t[1],e[1]])),r=1;r<o.length;r++)for(u+=s.smoothing?"C":"L",n=0;n<o[r].length;n++){var f=o[r][n];u+=[l.c2p(f[0]),c.c2p(f[1])]+" "}return u}for(u=0,f=null;x.length;){var E=e.edgepaths[u][0];for(f&&(y+=S(f,E)),v=o.smoothopen(e.edgepaths[u].map(n),e.smoothing),y+=b?v:v.replace(/^M/,'L'),x.splice(x.indexOf(u),1),f=e.edgepaths[u][e.edgepaths[u].length-1],d=-1,p=0;p<4;p++){if(!f){s.log('Missing end?',u,e);break}for(T(f)&&!A(f)?h=r[1]:M(f)?h=r[0]:k(f)?h=r[3]:A(f)&&(h=r[2]),m=0;m<e.edgepaths.length;m++){var L=e.edgepaths[m][0];Math.abs(f[0]-h[0])<_?Math.abs(f[0]-L[0])<_&&(L[1]-f[1])*(h[1]-L[1])>=0&&(h=L,d=m):Math.abs(f[1]-h[1])<w?Math.abs(f[1]-L[1])<w&&(L[0]-f[0])*(h[0]-L[0])>=0&&(h=L,d=m):s.log('endpt to newendpt is not vert. or horz.',f,h,L)}if(d>=0)break;y+=S(f,h),f=h}if(d===e.edgepaths.length){s.log('unclosed perimeter path');break}u=d,(b=-1===x.indexOf(u))&&(u=x[0],y+=S(f,h)+"Z",f=null)}for(u=0;u<e.paths.length;u++)y+=o.smoothclosed(e.paths[u].map(n),e.smoothing);return y}e.exports=function(t,e,r,u){var f=e.xaxis,d=e.yaxis;s.makeTraceGroups(u,r,'contour').each((function(r){var s=n.select(this),u=r[0],g=u.trace,x=g._carpetTrace=m(t,g),b=t.calcdata[x.index][0];if(x.visible&&"legendonly"!==x.visible){var _=u.a,w=u.b,M=g.contours,A=p(M,e,u),S="constraint"===M.type,E=M._operation,L=S?"="===E?"lines":"fill":M.coloring,C=[[_[0],w[w.length-1]],[_[_.length-1],w[w.length-1]],[_[_.length-1],w[0]],[_[0],w[0]]];l(A);var P=1e-8*(_[_.length-1]-_[0]),I=1e-8*(w[w.length-1]-w[0]);c(A,P,I);var z,O,D,R,F=A;"constraint"===M.type&&(F=h(A,E)),v(A,j);var B=[];for(R=b.clipsegments.length-1;R>=0;R--)z=b.clipsegments[R],O=i([],z.x,f.c2p),D=i([],z.y,d.c2p),O.reverse(),D.reverse(),B.push(a(O,D,z.bicubic));var N="M"+B.join('L')+"Z";T(s,b.clipsegments,f,d,S,L),k(g,s,f,d,F,C,j,x,b,L,N),y(s,A,t,u,M,e,x),o.setClipUrl(s,x._clipPathId,t)}function j(t){var e=x.ab2xy(t[0],t[1],!0);return[f.c2p(e[0]),d.c2p(e[1])]}}))}},{"../../components/drawing":672,"../../lib":787,"../carpet/axis_aligned_line":969,"../carpet/lookup_carpetid":985,"../carpet/makepath":986,"../carpet/map_1d_array":987,"../contour/close_boundaries":1014,"../contour/constants":1016,"../contour/convert_to_constraints":1020,"../contour/empty_pathinfo":1022,"../contour/find_all_paths":1024,"../contour/make_crossings":1029,"../contour/plot":1030,"@plotly/d3":58}],1039:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../../plots/template_attributes').hovertemplateAttrs,a=t('../../plots/attributes'),o=t('../scattermapbox/attributes'),s=t('../../lib/extend').extendFlat;e.exports=s({lon:o.lon,lat:o.lat,z:{valType:"data_array",editType:"calc"},radius:{valType:"number",editType:"plot",arrayOk:!0,min:1,dflt:30},below:{valType:"string",editType:"plot"},text:o.text,hovertext:o.hovertext,hoverinfo:s({},a.hoverinfo,{flags:["lon",'lat','z','text',"name"]}),hovertemplate:i(),showlegend:s({},a.showlegend,{dflt:!1})},n('',{cLetter:"z",editTypeOverride:"calc"}))},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"../scattermapbox/attributes":1267}],1040:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib').isArrayOrTypedArray,a=t('../../constants/numerical').BADNUM,o=t('../../components/colorscale/calc'),s=t('../../lib')._;e.exports=function(t,e){for(var r=e._length,l=new Array(r),c=e.z,u=i(c)&&c.length,f=0;f<r;f++){var h=l[f]={},p=e.lon[f],d=e.lat[f];if(h.lonlat=n(p)&&n(d)?[+p,+d]:[a,a],u){var m=c[f];h.z=n(m)?m:a}}return o(t,e,{vals:u?c:[0,1],containerStr:"",cLetter:"z"}),r&&(l[0].t={labels:{lat:s(t,'lat:')+" ',lon:s(t,'lon:')+' '}}),l}},{'../../components/colorscale/calc":658,"../../constants/numerical":763,"../../lib":787,"fast-isnumeric":246}],1041:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../components/color'),o=t('../../components/colorscale'),s=t('../../constants/numerical').BADNUM,l=t('../../lib/geojson_utils').makeBlank;e.exports=function(t){var e=t[0].trace,r=!0===e.visible&&0!==e._length,c={layout:{visibility:"none"},paint:{}},u=e._opts={heatmap:c,geojson:l()};if(!r)return u;var f,h=[],p=e.z,d=e.radius,m=i.isArrayOrTypedArray(p)&&p.length,g=i.isArrayOrTypedArray(d);for(f=0;f<t.length;f++){var v=t[f],y=v.lonlat;if(y[0]!==s){var x={};if(m){var b=v.z;x.z=b!==s?b:0}g&&(x.r=n(d[f])&&d[f]>0?+d[f]:0),h.push({type:"Feature",geometry:{type:"Point",coordinates:y},properties:x})}}var _=o.extractOpts(e),w=_.reversescale?o.flipScale(_.colorscale):_.colorscale,T=w[0][1],k=["interpolate",["linear"],["heatmap-density"],0,a.opacity(T)<1?T:a.addOpacity(T,0)];for(f=1;f<w.length;f++)k.push(w[f][0],w[f][1]);var M=["interpolate",["linear"],["get","z"],_.min,0,_.max,1];return i.extendFlat(u.heatmap.paint,{"heatmap-weight":m?M:1/(_.max-_.min),"heatmap-color":k,"heatmap-radius":g?{type:"identity",property:"r"}:e.radius,"heatmap-opacity":e.opacity}),u.geojson={type:"FeatureCollection",features:h},u.heatmap.layout.visibility='visible',u}},{"../../components/color":650,"../../components/colorscale":662,"../../constants/numerical":763,"../../lib":787,"../../lib/geojson_utils":781,"fast-isnumeric":246}],1042:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/defaults'),a=t('./attributes');e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l=s('lon')||[],c=s('lat')||[],u=Math.min(l.length,c.length);u?(e._length=u,s('z'),s('radius'),s('below'),s('text'),s('hovertext'),s('hovertemplate'),i(t,e,o,s,{prefix:"",cLetter:"z"})):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"./attributes":1039}],1043:[function(t,e,r){"use strict";e.exports=function(t,e){return t.lon=e.lon,t.lat=e.lat,t.z=e.z,t}},{}],1044:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../scattermapbox/hover').hoverPoints,a=t('../scattermapbox/hover').getExtraText;e.exports=function(t,e,r){var o=i(t,e,r);if(o){var s=o[0],l=s.cd,c=l[0].trace,u=l[s.index];if(delete s.color,"z"in u){var f=s.subplot.mockAxis;s.z=u.z,s.zLabel=n.tickText(f,f.c2l(u.z),'hover').text}return s.extraText=a(c,u,l[0].t.labels),[s]}}},{"../../plots/cartesian/axes":838,"../scattermapbox/hover":1272}],1045:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../heatmap/colorbar'),formatLabels:t('../scattermapbox/format_labels'),calc:t('./calc'),plot:t('./plot'),hoverPoints:t('./hover'),eventData:t('./event_data'),getBelow:function(t,e){for(var r=e.getMapLayers(),n=0;n<r.length;n++){var i=r[n],a=i.id;if("symbol"===i.type&&"string"===typeof a&&-1===a.indexOf('plotly-'))return a}},moduleType:"trace",name:"densitymapbox",basePlotModule:t('../../plots/mapbox'),categories:["mapbox",'gl',"showLegend"],meta:{hr_name:"density_mapbox"}}},{"../../plots/mapbox":895,"../heatmap/colorbar":1072,"../scattermapbox/format_labels":1271,"./attributes":1039,"./calc":1040,"./defaults":1042,"./event_data":1043,"./hover":1044,"./plot":1046}],1046:[function(t,e,r){"use strict";var n=t('./convert'),i=t('../../plots/mapbox/constants').traceLayerPrefix;function a(t,e){this.type='densitymapbox',this.subplot=t,this.uid=e,this.sourceId="source-"+e,this.layerList=[["heatmap",i+e+"-heatmap"]],this.below=null}var o=a.prototype;o.update=function(t){var e=this.subplot,r=this.layerList,i=n(t),a=e.belowLookup["trace-"+this.uid];e.map.getSource(this.sourceId).setData(i.geojson),a!==this.below&&(this._removeLayers(),this._addLayers(i,a),this.below=a);for(var o=0;o<r.length;o++){var s=r[o],l=s[0],c=s[1],u=i[l];e.setOptions(c,'setLayoutProperty',u.layout),"visible"===u.layout.visibility&&e.setOptions(c,'setPaintProperty',u.paint)}},o._addLayers=function(t,e){for(var r=this.subplot,n=this.layerList,i=this.sourceId,a=0;a<n.length;a++){var o=n[a],s=o[0],l=t[s];r.addLayer({type:s,id:o[1],source:i,layout:l.layout,paint:l.paint},e)}},o._removeLayers=function(){for(var t=this.subplot.map,e=this.layerList,r=e.length-1;r>=0;r--)t.removeLayer(e[r][1])},o.dispose=function(){var t=this.subplot.map;this._removeLayers(),t.removeSource(this.sourceId)},e.exports=function(t,e){var r=e[0].trace,i=new a(t,r.uid),o=i.sourceId,s=n(e),l=i.below=t.belowLookup["trace-"+r.uid];return t.map.addSource(o,{type:"geojson",data:s.geojson}),i._addLayers(s,l),i}},{"../../plots/mapbox/constants":893,"./convert":1041}],1047:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){for(var r=0;r<t.length;r++)t[r].i=r;n.mergeArray(e.text,t,'tx'),n.mergeArray(e.hovertext,t,'htx');var i=e.marker;if(i){n.mergeArray(i.opacity,t,'mo'),n.mergeArray(i.color,t,'mc');var a=i.line;a&&(n.mergeArray(a.color,t,'mlc'),n.mergeArrayCastPositive(a.width,t,'mlw'))}}},{"../../lib":787}],1048:[function(t,e,r){"use strict";var n=t('../bar/attributes'),i=t('../scatter/attributes').line,a=t('../../plots/attributes'),o=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,s=t('../../plots/template_attributes').hovertemplateAttrs,l=t('../../plots/template_attributes').texttemplateAttrs,c=t('./constants'),u=t('../../lib/extend').extendFlat,f=t('../../components/color');function h(){var t=u({},n.marker);return delete t.pattern,t}e.exports={x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,xperiod:n.xperiod,yperiod:n.yperiod,xperiod0:n.xperiod0,yperiod0:n.yperiod0,xperiodalignment:n.xperiodalignment,yperiodalignment:n.yperiodalignment,xhoverformat:o('x'),yhoverformat:o('y'),hovertext:n.hovertext,hovertemplate:s({},{keys:c.eventDataKeys}),hoverinfo:u({},a.hoverinfo,{flags:["name",'x','y','text','percent initial','percent previous',"percent total"]}),textinfo:{valType:"flaglist",flags:["label",'text','percent initial','percent previous','percent total',"value"],extras:["none"],editType:"plot",arrayOk:!1},texttemplate:l({editType:"plot"},{keys:c.eventDataKeys.concat(["label","value"])}),text:n.text,textposition:n.textposition,insidetextanchor:u({},n.insidetextanchor,{dflt:"middle"}),textangle:u({},n.textangle,{dflt:0}),textfont:n.textfont,insidetextfont:n.insidetextfont,outsidetextfont:n.outsidetextfont,constraintext:n.constraintext,cliponaxis:n.cliponaxis,orientation:u({},n.orientation,{}),offset:u({},n.offset,{arrayOk:!1}),width:u({},n.width,{arrayOk:!1}),marker:h(),connector:{fillcolor:{valType:"color",editType:"style"},line:{color:u({},i.color,{dflt:f.defaultLine}),width:u({},i.width,{dflt:0,editType:"plot"}),dash:i.dash,editType:"style"},visible:{valType:"boolean",dflt:!0,editType:"plot"},editType:"plot"},offsetgroup:n.offsetgroup,alignmentgroup:n.alignmentgroup}},{"../../components/color":650,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../bar/attributes":925,"../scatter/attributes":1202,"./constants":1050}],1049:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../plots/cartesian/align_period'),a=t('./arrays_to_calcdata'),o=t('../scatter/calc_selection'),s=t('../../constants/numerical').BADNUM;function l(t){return t===s?0:t}e.exports=function(t,e){var r,c,u,f,h,p,d,m,g=n.getFromId(t,e.xaxis||"x"),v=n.getFromId(t,e.yaxis||"y");"h"===e.orientation?(r=g.makeCalcdata(e,'x'),u=v.makeCalcdata(e,'y'),f=i(e,v,'y',u),h=!!e.yperiodalignment,p='y'):(r=v.makeCalcdata(e,'y'),u=g.makeCalcdata(e,'x'),f=i(e,g,'x',u),h=!!e.xperiodalignment,p='x'),c=f.vals;var y,x=Math.min(c.length,r.length),b=new Array(x);for(e._base=[],d=0;d<x;d++){r[d]<0&&(r[d]=s);var _=!1;r[d]!==s&&d+1<x&&r[d+1]!==s&&(_=!0),m=b[d]={p:c[d],s:r[d],cNext:_},e._base[d]=-.5*m.s,h&&(b[d].orig_p=u[d],b[d][p+"End"]=f.ends[d],b[d][p+"Start"]=f.starts[d]),e.ids&&(m.id=String(e.ids[d])),0===d&&(b[0].vTotal=0),b[0].vTotal+=l(m.s),m.begR=l(m.s)/l(b[0].s)}for(d=0;d<x;d++)(m=b[d]).s!==s&&(m.sumR=m.s/b[0].vTotal,m.difR=void 0!==y?m.s/y:1,y=m.s);return a(b,e),o(b,e),b}},{"../../constants/numerical":763,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"../scatter/calc_selection":1204,"./arrays_to_calcdata":1047}],1050:[function(t,e,r){"use strict";e.exports={eventDataKeys:["percentInitial",'percentPrevious',"percentTotal"]}},{}],1051:[function(t,e,r){"use strict";var n=t('../bar/cross_trace_calc').setGroupPositions;e.exports=function(t,e){var r,i,a=t._fullLayout,o=t._fullData,s=t.calcdata,l=e.xaxis,c=e.yaxis,u=[],f=[],h=[];for(i=0;i<o.length;i++){var p=o[i],d="h"===p.orientation;!0===p.visible&&p.xaxis===l._id&&p.yaxis===c._id&&"funnel"===p.type&&(r=s[i],d?h.push(r):f.push(r),u.push(r))}var m={mode:a.funnelmode,norm:a.funnelnorm,gap:a.funnelgap,groupgap:a.funnelgroupgap};for(n(t,l,c,f,m),n(t,c,l,h,m),i=0;i<u.length;i++){r=u[i];for(var g=0;g<r.length;g++)g+1<r.length&&(r[g].nextP0=r[g+1].p0,r[g].nextS0=r[g+1].s0,r[g].nextP1=r[g+1].p1,r[g].nextS1=r[g+1].s1)}}},{"../bar/cross_trace_calc":928}],1052:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../bar/defaults').handleGroupingDefaults,a=t('../bar/defaults').handleText,o=t('../scatter/xy_defaults'),s=t('../scatter/period_defaults'),l=t('./attributes'),c=t('../../components/color');function u(t,e,r,i){function u(r,i){return n.coerce(t,e,l,r,i)}if(o(t,e,i,u)){s(t,e,i,u),u('xhoverformat'),u('yhoverformat'),u('orientation',e.y&&!e.x?"v":"h"),u('offset'),u('width');var h=u('text');u('hovertext'),u('hovertemplate');var p=u('textposition');a(t,e,i,u,p,{moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!0,moduleHasCliponaxis:!0,moduleHasTextangle:!0,moduleHasInsideanchor:!0}),"none"===e.textposition||e.texttemplate||u('textinfo',Array.isArray(h)?"text+value":"value");var d=u('marker.color',r);u('marker.line.color',c.defaultLine),u('marker.line.width'),u('connector.visible')&&(u('connector.fillcolor',f(d)),u('connector.line.width')&&(u('connector.line.color'),u('connector.line.dash')))}else e.visible=!1}function f(t){var e=n.isArrayOrTypedArray(t)?"#000":t;return c.addOpacity(e,.5*c.opacity(e))}function h(t,e){var r,a;function o(t){return n.coerce(a._input,a,l,t)}if("group"===e.funnelmode)for(var s=0;s<t.length;s++)r=(a=t[s])._input,i(r,a,e,o)}e.exports={supplyDefaults:u,crossTraceDefaults:h}},{"../../components/color":650,"../../lib":787,"../bar/defaults":929,"../scatter/period_defaults":1222,"../scatter/xy_defaults":1229,"./attributes":1048}],1053:[function(t,e,r){"use strict";e.exports=function(t,e){return t.x="xVal"in e?e.xVal:e.x,t.y="yVal"in e?e.yVal:e.y,"percentInitial"in e&&(t.percentInitial=e.percentInitial),"percentPrevious"in e&&(t.percentPrevious=e.percentPrevious),"percentTotal"in e&&(t.percentTotal=e.percentTotal),e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),t}},{}],1054:[function(t,e,r){"use strict";var n=t('../../components/color').opacity,i=t('../bar/hover').hoverOnBars,a=t('../../lib').formatPercent;function o(t,e){var r=t.marker,i=e.mc||r.color,a=e.mlc||r.line.color,o=e.mlw||r.line.width;return n(i)?i:n(a)&&o?a:void 0}e.exports=function(t,e,r,n,s){var l=i(t,e,r,n,s);if(l){var c=l.cd,u=c[0].trace,f="h"===u.orientation,h=c[l.index];l[(f?"x":"y")+"LabelVal"]=h.s,l.percentInitial=h.begR,l.percentInitialLabel=a(h.begR,1),l.percentPrevious=h.difR,l.percentPreviousLabel=a(h.difR,1),l.percentTotal=h.sumR,l.percentTotalLabel=a(h.sumR,1);var p=h.hi||u.hoverinfo,d=[];if(p&&"none"!==p&&"skip"!==p){var m="all"===p,g=p.split('+'),v=function(t){return m||-1!==g.indexOf(t)};v('percent initial')&&d.push(l.percentInitialLabel+" of initial"),v('percent previous')&&d.push(l.percentPreviousLabel+" of previous"),v('percent total')&&d.push(l.percentTotalLabel+" of total")}return l.extraText=d.join('<br>'),l.color=o(u,h),[l]}}},{"../../components/color":650,"../../lib":787,"../bar/hover":932}],1055:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults').supplyDefaults,crossTraceDefaults:t('./defaults').crossTraceDefaults,supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc'),crossTraceCalc:t('./cross_trace_calc'),plot:t('./plot'),style:t('./style').style,hoverPoints:t('./hover'),eventData:t('./event_data'),selectPoints:t('../bar/select'),moduleType:"trace",name:"funnel",basePlotModule:t('../../plots/cartesian'),categories:["bar-like",'cartesian','svg','oriented','showLegend',"zoomScale"],meta:{}}},{"../../plots/cartesian":852,"../bar/select":937,"./attributes":1048,"./calc":1049,"./cross_trace_calc":1051,"./defaults":1052,"./event_data":1053,"./hover":1054,"./layout_attributes":1056,"./layout_defaults":1057,"./plot":1058,"./style":1059}],1056:[function(t,e,r){"use strict";e.exports={funnelmode:{valType:"enumerated",values:["stack",'group',"overlay"],dflt:"stack",editType:"calc"},funnelgap:{valType:"number",min:0,max:1,editType:"calc"},funnelgroupgap:{valType:"number",min:0,max:1,dflt:0,editType:"calc"}}},{}],1057:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e,r){var a=!1;function o(r,a){return n.coerce(t,e,i,r,a)}for(var s=0;s<r.length;s++){var l=r[s];if(l.visible&&"funnel"===l.type){a=!0;break}}a&&(o('funnelmode'),o('funnelgap',.2),o('funnelgroupgap'))}},{"../../lib":787,"./layout_attributes":1056}],1058:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../../constants/numerical').BADNUM,s=t('../bar/plot'),l=t('../bar/uniform_text').clearMinTextSize;function c(t,e,r,s){var l=e.xaxis,c=e.yaxis;i.makeTraceGroups(s,r,'trace bars').each((function(r){var s=n.select(this),u=r[0].trace,h=i.ensureSingle(s,'g','regions');if(u.connector&&u.connector.visible){var p="h"===u.orientation,d=h.selectAll('g.region').data(i.identity);d.enter().append('g').classed('region',!0),d.exit().remove();var m=d.size();d.each((function(r,s){if(s===m-1||r.cNext){var u=f(r,l,c,p),h=u[0],d=u[1],g='';h[0]!==o&&d[0]!==o&&h[1]!==o&&d[1]!==o&&h[2]!==o&&d[2]!==o&&h[3]!==o&&d[3]!==o&&(g+=p?"M"+h[0]+","+d[1]+"L"+h[2]+","+d[2]+"H"+h[3]+"L"+h[1]+","+d[1]+"Z":"M"+h[1]+","+d[1]+"L"+h[2]+","+d[3]+"V"+d[2]+"L"+h[1]+","+d[0]+"Z"),""===g&&(g='M0,0Z'),i.ensureSingle(n.select(this),'path').attr('d',g).call(a.setClipUrl,e.layerClipId,t)}}))}else h.remove()}))}function u(t,e,r,o){var s=e.xaxis,l=e.yaxis;i.makeTraceGroups(o,r,'trace bars').each((function(r){var o=n.select(this),c=r[0].trace,u=i.ensureSingle(o,'g','lines');if(c.connector&&c.connector.visible&&c.connector.line.width){var h="h"===c.orientation,p=u.selectAll('g.line').data(i.identity);p.enter().append('g').classed('line',!0),p.exit().remove();var d=p.size();p.each((function(r,o){if(o===d-1||r.cNext){var c=f(r,s,l,h),u=c[0],p=c[1],m='';void 0!==u[3]&&void 0!==p[3]&&(h?(m+="M"+u[0]+","+p[1]+"L"+u[2]+","+p[2],m+="M"+u[1]+","+p[1]+"L"+u[3]+","+p[2]):(m+="M"+u[1]+","+p[1]+"L"+u[2]+","+p[3],m+="M"+u[1]+","+p[0]+"L"+u[2]+","+p[2])),""===m&&(m='M0,0Z'),i.ensureSingle(n.select(this),'path').attr('d',m).call(a.setClipUrl,e.layerClipId,t)}}))}else u.remove()}))}function f(t,e,r,n){var i=[],a=[],o=n?e:r,s=n?r:e;return i[0]=o.c2p(t.s0,!0),a[0]=s.c2p(t.p0,!0),i[1]=o.c2p(t.s1,!0),a[1]=s.c2p(t.p1,!0),i[2]=o.c2p(t.nextS0,!0),a[2]=s.c2p(t.nextP0,!0),i[3]=o.c2p(t.nextS1,!0),a[3]=s.c2p(t.nextP1,!0),n?[i,a]:[a,i]}e.exports=function(t,e,r,n){var i=t._fullLayout;l('funnel',i),c(t,e,r,n),u(t,e,r,n),s.plot(t,e,r,n,{mode:i.funnelmode,norm:i.funnelmode,gap:i.funnelgap,groupgap:i.funnelgroupgap})}},{"../../components/drawing":672,"../../constants/numerical":763,"../../lib":787,"../bar/plot":936,"../bar/uniform_text":941,"@plotly/d3":58}],1059:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../../components/color'),o=t('../../constants/interactions').DESELECTDIM,s=t('../bar/style'),l=t('../bar/uniform_text').resizeText,c=s.styleTextPoints;function u(t,e,r){var s=r||n.select(t).selectAll('g.funnellayer').selectAll('g.trace');l(t,s,'funnel'),s.style('opacity',(function(t){return t[0].trace.opacity})),s.each((function(e){var r=n.select(this),s=e[0].trace;r.selectAll('.point > path').each((function(t){if(!t.isBlank){var e=s.marker;n.select(this).call(a.fill,t.mc||e.color).call(a.stroke,t.mlc||e.line.color).call(i.dashLine,e.line.dash,t.mlw||e.line.width).style('opacity',s.selectedpoints&&!t.selected?o:1)}})),c(r,s,t),r.selectAll('.regions').each((function(){n.select(this).selectAll('path').style('stroke-width',0).call(a.fill,s.connector.fillcolor)})),r.selectAll('.lines').each((function(){var t=s.connector.line;i.lineGroupStyle(n.select(this).selectAll('path'),t.width,t.color,t.dash)}))}))}e.exports={style:u}},{"../../components/color":650,"../../components/drawing":672,"../../constants/interactions":762,"../bar/style":939,"../bar/uniform_text":941,"@plotly/d3":58}],1060:[function(t,e,r){"use strict";var n=t('../pie/attributes'),i=t('../../plots/attributes'),a=t('../../plots/domain').attributes,o=t('../../plots/template_attributes').hovertemplateAttrs,s=t('../../plots/template_attributes').texttemplateAttrs,l=t('../../lib/extend').extendFlat;e.exports={labels:n.labels,label0:n.label0,dlabel:n.dlabel,values:n.values,marker:{colors:n.marker.colors,line:{color:l({},n.marker.line.color,{dflt:null}),width:l({},n.marker.line.width,{dflt:1}),editType:"calc"},editType:"calc"},text:n.text,hovertext:n.hovertext,scalegroup:l({},n.scalegroup,{}),textinfo:l({},n.textinfo,{flags:["label",'text','value',"percent"]}),texttemplate:s({editType:"plot"},{keys:["label",'color','value','text',"percent"]}),hoverinfo:l({},i.hoverinfo,{flags:["label",'text','value','percent',"name"]}),hovertemplate:o({},{keys:["label",'color','value','text',"percent"]}),textposition:l({},n.textposition,{values:["inside","none"],dflt:"inside"}),textfont:n.textfont,insidetextfont:n.insidetextfont,title:{text:n.title.text,font:n.title.font,position:l({},n.title.position,{values:["top left",'top center',"top right"],dflt:"top center"}),editType:"plot"},domain:a({name:"funnelarea",trace:!0,editType:"calc"}),aspectratio:{valType:"number",min:0,dflt:1,editType:"plot"},baseratio:{valType:"number",min:0,max:1,dflt:.333,editType:"plot"}}},{"../../lib/extend":777,"../../plots/attributes":834,"../../plots/domain":866,"../../plots/template_attributes":910,"../pie/attributes":1176}],1061:[function(t,e,r){"use strict";var n=t('../../plots/plots');r.name='funnelarea',r.plot=function(t,e,i,a){n.plotBasePlot(r.name,t,e,i,a)},r.clean=function(t,e,i,a){n.cleanBasePlot(r.name,t,e,i,a)}},{"../../plots/plots":901}],1062:[function(t,e,r){"use strict";var n=t('../pie/calc');function i(t,e){return n.calc(t,e)}function a(t){n.crossTraceCalc(t,{type:"funnelarea"})}e.exports={calc:i,crossTraceCalc:a}},{"../pie/calc":1178}],1063:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../plots/domain').defaults,o=t('../bar/defaults').handleText,s=t('../pie/defaults').handleLabelsAndValues;e.exports=function(t,e,r,l){function c(r,a){return n.coerce(t,e,i,r,a)}var u=c('labels'),f=c('values'),h=s(u,f),p=h.len;if(e._hasLabels=h.hasLabels,e._hasValues=h.hasValues,!e._hasLabels&&e._hasValues&&(c('label0'),c('dlabel')),p){e._length=p,c('marker.line.width')&&c('marker.line.color',l.paper_bgcolor),c('marker.colors'),c('scalegroup');var d,m=c('text'),g=c('texttemplate');if(g||(d=c('textinfo',Array.isArray(m)?"text+percent":"percent")),c('hovertext'),c('hovertemplate'),g||d&&"none"!==d){var v=c('textposition');o(t,e,l,c,v,{moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!1,moduleHasCliponaxis:!1,moduleHasTextangle:!1,moduleHasInsideanchor:!1})}a(e,l,c),c('title.text')&&(c('title.position'),n.coerceFont(c,'title.font',l.font)),c('aspectratio'),c('baseratio')}else e.visible=!1}},{"../../lib":787,"../../plots/domain":866,"../bar/defaults":929,"../pie/defaults":1179,"./attributes":1060}],1064:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"funnelarea",basePlotModule:t('./base_plot'),categories:["pie-like",'funnelarea',"showLegend"],attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults'),supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc').calc,crossTraceCalc:t('./calc').crossTraceCalc,plot:t('./plot'),style:t('./style'),styleOne:t('../pie/style_one'),meta:{}}},{"../pie/style_one":1187,"./attributes":1060,"./base_plot":1061,"./calc":1062,"./defaults":1063,"./layout_attributes":1065,"./layout_defaults":1066,"./plot":1067,"./style":1068}],1065:[function(t,e,r){"use strict";var n=t('../pie/layout_attributes').hiddenlabels;e.exports={hiddenlabels:n,funnelareacolorway:{valType:"colorlist",editType:"calc"},extendfunnelareacolors:{valType:"boolean",dflt:!0,editType:"calc"}}},{"../pie/layout_attributes":1183}],1066:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}r('hiddenlabels'),r('funnelareacolorway',e.colorway),r('extendfunnelareacolors')}},{"../../lib":787,"./layout_attributes":1065}],1067:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../../lib'),o=a.strScale,s=a.strTranslate,l=t('../../lib/svg_text_utils'),c=t('../bar/plot').toMoveInsideBar,u=t('../bar/uniform_text'),f=u.recordMinTextSize,h=u.clearMinTextSize,p=t('../pie/helpers'),d=t('../pie/plot'),m=d.attachFxHandlers,g=d.determineInsideTextFont,v=d.layoutAreas,y=d.prerenderTitles,x=d.positionTitleOutside,b=d.formatSliceLabel;function _(t,e){return"l"+(e[0]-t[0])+","+(e[1]-t[1])}function w(t,e){return[.5*(t[0]+e[0]),.5*(t[1]+e[1])]}function T(t){if(t.length){var e=t[0],r=e.trace,n=r.aspectratio,i=r.baseratio;i>.999&&(i=.999);var a,o,s,l=Math.pow(i,2),c=e.vTotal,u=c,f=c*l/(1-l)/c,h=[];for(h.push(E()),o=t.length-1;o>-1;o--)if(!(s=t[o]).hidden){var p=s.v/u;f+=p,h.push(E())}var d=1/0,m=-1/0;for(o=0;o<h.length;o++)a=h[o],d=Math.min(d,a[1]),m=Math.max(m,a[1]);for(o=0;o<h.length;o++)h[o][1]-=(m+d)/2;var g=h[h.length-1][0],v=e.r,y=(m-d)/2,x=v/g,b=v/y*n;for(e.r=b*y,o=0;o<h.length;o++)h[o][0]*=x,h[o][1]*=b;var _=[-(a=h[0])[0],a[1]],T=[a[0],a[1]],k=0;for(o=t.length-1;o>-1;o--)if(!(s=t[o]).hidden){var M=h[k+=1][0],A=h[k][1];s.TL=[-M,A],s.TR=[M,A],s.BL=_,s.BR=T,s.pxmid=w(s.TR,s.BR),_=s.TL,T=s.TR}}function S(){var t=Math.sqrt(f);return{x:t,y:-t}}function E(){var t=S();return[t.x,t.y]}}e.exports=function(t,e){var r=t._fullLayout;h('funnelarea',r),y(e,t),v(e,r._size),a.makeTraceGroups(r._funnelarealayer,e,'trace').each((function(e){var u=n.select(this),h=e[0],d=h.trace;T(e),u.each((function(){var u=n.select(this).selectAll('g.slice').data(e);u.enter().append('g').classed('slice',!0),u.exit().remove(),u.each((function(o,s){if(o.hidden)n.select(this).selectAll('path,g').remove();else{o.pointNumber=o.i,o.curveNumber=d.index;var u=h.cx,v=h.cy,y=n.select(this),x=y.selectAll('path.surface').data([o]);x.enter().append('path').classed('surface',!0).style({"pointer-events":"all"}),y.call(m,t,e);var w="M"+(u+o.TR[0])+","+(v+o.TR[1])+_(o.TR,o.BR)+_(o.BR,o.BL)+_(o.BL,o.TL)+"Z";x.attr('d',w),b(t,o,h);var T=p.castOption(d.textposition,o.pts),k=y.selectAll('g.slicetext').data(o.text&&"none"!==T?[0]:[]);k.enter().append('g').classed('slicetext',!0),k.exit().remove(),k.each((function(){var h=a.ensureSingle(n.select(this),'text','',(function(t){t.attr('data-notex',1)})),p=a.ensureUniformFontSize(t,g(d,o,r.font));h.text(o.text).attr({class:"slicetext",transform:"","text-anchor":"middle"}).call(i.font,p).call(l.convertToTspans,t);var m,y,x,b=i.bBox(h.node()),_=Math.min(o.BL[1],o.BR[1])+v,w=Math.max(o.TL[1],o.TR[1])+v;y=Math.max(o.TL[0],o.BL[0])+u,x=Math.min(o.TR[0],o.BR[0])+u,(m=c(y,x,_,w,b,{isHorizontal:!0,constrained:!0,angle:0,anchor:"middle"})).fontSize=p.size,f(d.type,m,r),e[s].transform=m,h.attr('transform',a.getTextTransform(m))}))}}));var v=n.select(this).selectAll('g.titletext').data(d.title.text?[0]:[]);v.enter().append('g').classed('titletext',!0),v.exit().remove(),v.each((function(){var e=a.ensureSingle(n.select(this),'text','',(function(t){t.attr('data-notex',1)})),c=d.title.text;d._meta&&(c=a.templateString(c,d._meta)),e.text(c).attr({class:"titletext",transform:"","text-anchor":"middle"}).call(i.font,d.title.font).call(l.convertToTspans,t);var u=x(h,r._size);e.attr('transform',s(u.x,u.y)+o(Math.min(1,u.scale))+s(u.tx,u.ty))}))}))}))}},{"../../components/drawing":672,"../../lib":787,"../../lib/svg_text_utils":813,"../bar/plot":936,"../bar/uniform_text":941,"../pie/helpers":1181,"../pie/plot":1185,"@plotly/d3":58}],1068:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../pie/style_one'),a=t('../bar/uniform_text').resizeText;e.exports=function(t){var e=t._fullLayout._funnelarealayer.selectAll('.trace');a(t,e,'funnelarea'),e.each((function(t){var e=t[0].trace,r=n.select(this);r.style({opacity:e.opacity}),r.selectAll('path.surface').each((function(t){n.select(this).call(i,t,e)}))}))}},{"../bar/uniform_text":941,"../pie/style_one":1187,"@plotly/d3":58}],1069:[function(t,e,r){"use strict";var n=t('../scatter/attributes'),i=t('../../plots/attributes'),a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,o=t('../../plots/template_attributes').hovertemplateAttrs,s=t('../../components/colorscale/attributes'),l=t('../../lib/extend').extendFlat;e.exports=l({z:{valType:"data_array",editType:"calc"},x:l({},n.x,{impliedEdits:{xtype:"array"}}),x0:l({},n.x0,{impliedEdits:{xtype:"scaled"}}),dx:l({},n.dx,{impliedEdits:{xtype:"scaled"}}),y:l({},n.y,{impliedEdits:{ytype:"array"}}),y0:l({},n.y0,{impliedEdits:{ytype:"scaled"}}),dy:l({},n.dy,{impliedEdits:{ytype:"scaled"}}),xperiod:l({},n.xperiod,{impliedEdits:{xtype:"scaled"}}),yperiod:l({},n.yperiod,{impliedEdits:{ytype:"scaled"}}),xperiod0:l({},n.xperiod0,{impliedEdits:{xtype:"scaled"}}),yperiod0:l({},n.yperiod0,{impliedEdits:{ytype:"scaled"}}),xperiodalignment:l({},n.xperiodalignment,{impliedEdits:{xtype:"scaled"}}),yperiodalignment:l({},n.yperiodalignment,{impliedEdits:{ytype:"scaled"}}),text:{valType:"data_array",editType:"calc"},hovertext:{valType:"data_array",editType:"calc"},transpose:{valType:"boolean",dflt:!1,editType:"calc"},xtype:{valType:"enumerated",values:["array","scaled"],editType:"calc+clearAxisTypes"},ytype:{valType:"enumerated",values:["array","scaled"],editType:"calc+clearAxisTypes"},zsmooth:{valType:"enumerated",values:["fast",'best',!1],dflt:!1,editType:"calc"},hoverongaps:{valType:"boolean",dflt:!0,editType:"none"},connectgaps:{valType:"boolean",editType:"calc"},xgap:{valType:"number",dflt:0,min:0,editType:"plot"},ygap:{valType:"number",dflt:0,min:0,editType:"plot"},xhoverformat:a('x'),yhoverformat:a('y'),zhoverformat:a('z',1),hovertemplate:o(),showlegend:l({},i.showlegend,{dflt:!1})},{transforms:void 0},s('',{cLetter:"z",autoColorDflt:!1}))},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../scatter/attributes":1202}],1070:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../../plots/cartesian/axes'),o=t('../../plots/cartesian/align_period'),s=t('../histogram2d/calc'),l=t('../../components/colorscale/calc'),c=t('./convert_column_xyz'),u=t('./clean_2d_array'),f=t('./interp2d'),h=t('./find_empties'),p=t('./make_bound_array'),d=t('../../constants/numerical').BADNUM;function m(t){for(var e=[],r=t.length,n=0;n<r;n++){var i=t[n];i!==d&&e.push(i)}return e}function g(t,e,r){for(var n=[],i=-1,a=0;a<r.length;a++)if(e[a]!==d){n[++i]=[];for(var o=0;o<r[a].length;o++)t[o]!==d&&n[i].push(r[a][o])}return n}e.exports=function(t,e){var r,d,v,y,x,b,_,w,T,k,M,A=a.getFromId(t,e.xaxis||"x"),S=a.getFromId(t,e.yaxis||"y"),E=n.traceIs(e,'contour'),L=n.traceIs(e,'histogram'),C=n.traceIs(e,'gl2d'),P=E?"best":e.zsmooth;if(A._minDtick=0,S._minDtick=0,L)y=(M=s(t,e)).orig_x,r=M.x,d=M.x0,v=M.dx,w=M.orig_y,x=M.y,b=M.y0,_=M.dy,T=M.z;else{var I=e.z;i.isArray1D(I)?(c(e,A,S,'x','y',["z"]),r=e._x,x=e._y,I=e._z):(y=e.x?A.makeCalcdata(e,'x'):[],w=e.y?S.makeCalcdata(e,'y'):[],r=o(e,A,'x',y).vals,x=o(e,S,'y',w).vals,e._x=r,e._y=x),d=e.x0,v=e.dx,b=e.y0,_=e.dy,T=u(I,e,A,S)}function z(t){P=e._input.zsmooth=e.zsmooth=!1,i.warn('cannot use zsmooth: "fast": '+t)}if((A.rangebreaks||S.rangebreaks)&&(T=g(r,x,T),L||(r=m(r),x=m(x),e._x=r,e._y=x)),L||!E&&!e.connectgaps||(e._emptypoints=h(T),f(T,e._emptypoints)),"fast"===P)if("log"===A.type||"log"===S.type)z('log axis found');else if(!L){if(r.length){var O=(r[r.length-1]-r[0])/(r.length-1),D=Math.abs(O/100);for(k=0;k<r.length-1;k++)if(Math.abs(r[k+1]-r[k]-O)>D){z('x scale is not linear');break}}if(x.length&&"fast"===P){var R=(x[x.length-1]-x[0])/(x.length-1),F=Math.abs(R/100);for(k=0;k<x.length-1;k++)if(Math.abs(x[k+1]-x[k]-R)>F){z('y scale is not linear');break}}}var B=i.maxRowLength(T),N="scaled"===e.xtype?"":r,j=p(e,N,d,v,B,A),U="scaled"===e.ytype?"":x,V=p(e,U,b,_,T.length,S);C||(e._extremes[A._id]=a.findExtremes(A,j),e._extremes[S._id]=a.findExtremes(S,V));var H={x:j,y:V,z:T,text:e._text||e.text,hovertext:e._hovertext||e.hovertext};if(e.xperiodalignment&&y&&(H.orig_x=y),e.yperiodalignment&&w&&(H.orig_y=w),N&&N.length===j.length-1&&(H.xCenter=N),U&&U.length===V.length-1&&(H.yCenter=U),L&&(H.xRanges=M.xRanges,H.yRanges=M.yRanges,H.pts=M.pts),E||l(t,e,{vals:T,cLetter:"z"}),E&&e.contours&&"heatmap"===e.contours.coloring){var q={type:"contour"===e.type?"heatmap":"histogram2d",xcalendar:e.xcalendar,ycalendar:e.ycalendar};H.xfill=p(q,N,d,v,B,A),H.yfill=p(q,U,b,_,T.length,S)}return[H]}},{"../../components/colorscale/calc":658,"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"../../registry":915,"../histogram2d/calc":1102,"./clean_2d_array":1071,"./convert_column_xyz":1073,"./find_empties":1075,"./interp2d":1078,"./make_bound_array":1079}],1071:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../constants/numerical').BADNUM;e.exports=function(t,e,r,o){var s,l,c,u,f,h;function p(t){if(n(t))return+t}if(e&&e.transpose){for(s=0,f=0;f<t.length;f++)s=Math.max(s,t[f].length);if(0===s)return!1;c=function(t){return t.length},u=function(t,e,r){return(t[r]||[])[e]}}else s=t.length,c=function(t,e){return t[e].length},u=function(t,e,r){return(t[e]||[])[r]};var d=function(t,e,r){return e===a||r===a?a:u(t,e,r)};function m(t){if(e&&"carpet"!==e.type&&"contourcarpet"!==e.type&&t&&"category"===t.type&&e["_"+t._id.charAt(0)].length){var r=t._id.charAt(0),n={},o=e["_"+r+"CategoryMap"]||e[r];for(f=0;f<o.length;f++)n[o[f]]=f;return function(e){var r=n[t._categories[e]];return r+1?r:a}}return i.identity}var g=m(r),v=m(o);o&&"category"===o.type&&(s=o._categories.length);var y=new Array(s);for(f=0;f<s;f++)for(l=r&&"category"===r.type?r._categories.length:c(t,f),y[f]=new Array(l),h=0;h<l;h++)y[f][h]=p(d(t,v(f),g(h)));return y}},{"../../constants/numerical":763,"../../lib":787,"fast-isnumeric":246}],1072:[function(t,e,r){"use strict";e.exports={min:"zmin",max:"zmax"}},{}],1073:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../constants/numerical').BADNUM,a=t('../../plots/cartesian/align_period');e.exports=function(t,e,r,o,s,l){var c=t._length,u=e.makeCalcdata(t,o),f=r.makeCalcdata(t,s);u=a(t,e,o,u).vals,f=a(t,r,s,f).vals;var h,p,d,m,g=t.text,v=void 0!==g&&n.isArray1D(g),y=t.hovertext,x=void 0!==y&&n.isArray1D(y),b=n.distinctVals(u),_=b.vals,w=n.distinctVals(f),T=w.vals,k=[],M=T.length,A=_.length;for(h=0;h<l.length;h++)k[h]=n.init2dArray(M,A);v&&(d=n.init2dArray(M,A)),x&&(m=n.init2dArray(M,A));var S=n.init2dArray(M,A);for(h=0;h<c;h++)if(u[h]!==i&&f[h]!==i){var E=n.findBin(u[h]+b.minDiff/2,_),L=n.findBin(f[h]+w.minDiff/2,T);for(p=0;p<l.length;p++){var C=t[l[p]];k[p][L][E]=C[h],S[L][E]=h}v&&(d[L][E]=g[h]),x&&(m[L][E]=y[h])}for(t["_"+o]=_,t["_"+s]=T,p=0;p<l.length;p++)t["_"+l[p]]=k[p];v&&(t._text=d),x&&(t._hovertext=m),e&&"category"===e.type&&(t["_"+o+"CategoryMap"]=_.map((function(t){return e._categories[t]}))),r&&"category"===r.type&&(t["_"+s+"CategoryMap"]=T.map((function(t){return r._categories[t]}))),t._after2before=S}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835}],1074:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./xyz_defaults'),a=t('../scatter/period_defaults'),o=t('./style_defaults'),s=t('../../components/colorscale/defaults'),l=t('./attributes');e.exports=function(t,e,r,c){function u(r,i){return n.coerce(t,e,l,r,i)}i(t,e,u,c)?(a(t,e,c,u),u('xhoverformat'),u('yhoverformat'),u('text'),u('hovertext'),u('hovertemplate'),o(t,e,u,c),u('hoverongaps'),u('connectgaps',n.isArray1D(e.z)&&!1!==e.zsmooth),s(t,e,c,u,{prefix:"",cLetter:"z"})):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"../scatter/period_defaults":1222,"./attributes":1069,"./style_defaults":1082,"./xyz_defaults":1083}],1075:[function(t,e,r){"use strict";var n=t('../../lib').maxRowLength;e.exports=function(t){var e,r,i,a,o,s,l,c,u=[],f={},h=[],p=t[0],d=[],m=[0,0,0],g=n(t);for(r=0;r<t.length;r++)for(e=d,d=p,p=t[r+1]||[],i=0;i<g;i++)void 0===d[i]&&((s=(void 0!==d[i-1]?1:0)+(void 0!==d[i+1]?1:0)+(void 0!==e[i]?1:0)+(void 0!==p[i]?1:0))?(0===r&&s++,0===i&&s++,r===t.length-1&&s++,i===d.length-1&&s++,s<4&&(f[[r,i]]=[r,i,s]),u.push([r,i,s])):h.push([r,i]));for(;h.length;)[for(l={],c=!1,o=h.length-1;o>=0;o--)(s=((f[[(r=(a=h[o])[0])-1,i=a[1]]]||m)[2]+(f[[r+1,i]]||m)[2]+(f[[r,i-1]]||m)[2]+(f[[r,i+1]]||m)[2])/20)&&(l[a]=[r,i,s],h.splice(o,1),c=!0);if(!c)throw"findEmpties iterated with no new neighbors";for(a in l)f[a]=l[a],u.push(l[a])}return u.sort((function(t,e){return e[2]-t[2]}))}},{"../../lib":787}],1076:[function(t,e,r){"use strict";var n=t('../../components/fx'),i=t('../../lib'),a=t('../../plots/cartesian/axes'),o=t('../../components/colorscale').extractOpts;e.exports=function(t,e,r,s,l){l||(l={});var c,u,f,h,p=l.isContour,d=t.cd[0],m=d.trace,g=t.xa,v=t.ya,y=d.x,x=d.y,b=d.z,_=d.xCenter,w=d.yCenter,T=d.zmask,k=m.zhoverformat,M=y,A=x;if(!1!==t.index){try{f=Math.round(t.index[1]),h=Math.round(t.index[0])}catch(N){return void i.error('Error hovering on heatmap, pointNumber must be [row,col], found:',t.index)}if(f<0||f>=b[0].length||h<0||h>b.length)return}else{if(n.inbox(e-y[0],e-y[y.length-1],0)>0||n.inbox(r-x[0],r-x[x.length-1],0)>0)return;if(p){var S;for(M=[2*y[0]-y[1]],S=1;S<y.length;S++)M.push((y[S]+y[S-1])/2);for(M.push([2*y[y.length-1]-y[y.length-2]]),A=[2*x[0]-x[1]],S=1;S<x.length;S++)A.push((x[S]+x[S-1])/2);A.push([2*x[x.length-1]-x[x.length-2]])}f=Math.max(0,Math.min(M.length-2,i.findBin(e,M))),h=Math.max(0,Math.min(A.length-2,i.findBin(r,A)))}var E,L,C=g.c2p(y[f]),P=g.c2p(y[f+1]),I=v.c2p(x[h]),z=v.c2p(x[h+1]);p?(E=d.orig_x||y,L=d.orig_y||x,P=C,c=E[f],z=I,u=L[h]):(E=d.orig_x||_||y,L=d.orig_y||w||x,c=_?E[f]:(E[f]+E[f+1])/2,u=w?L[h]:(L[h]+L[h+1])/2,g&&"category"===g.type&&(c=y[f]),v&&"category"===v.type&&(u=x[h]),m.zsmooth&&(C=P=g.c2p(c),I=z=v.c2p(u)));var O=b[h][f];if(T&&!T[h][f]&&(O=void 0),void 0!==O||m.hoverongaps){var D;Array.isArray(d.hovertext)&&Array.isArray(d.hovertext[h])?D=d.hovertext[h][f]:Array.isArray(d.text)&&Array.isArray(d.text[h])&&(D=d.text[h][f]);var R=o(m),F={type:"linear",range:[R.min,R.max],hoverformat:k,_separators:g._separators,_numFormat:g._numFormat},B=a.tickText(F,O,'hover').text;return[i.extendFlat(t,{index:m._after2before?m._after2before[h][f]:[h,f],distance:t.maxHoverDistance,spikeDistance:t.maxSpikeDistance,x0:C,x1:P,y0:I,y1:z,xLabelVal:c,yLabelVal:u,zLabelVal:O,zLabel:B,text:D})]}}},{"../../components/colorscale":662,"../../components/fx":690,"../../lib":787,"../../plots/cartesian/axes":838}],1077:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot'),colorbar:t('./colorbar'),style:t('./style'),hoverPoints:t('./hover'),moduleType:"trace",name:"heatmap",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','2dMap',"showLegend"],meta:{}}},{"../../plots/cartesian":852,"./attributes":1069,"./calc":1070,"./colorbar":1072,"./defaults":1074,"./hover":1076,"./plot":1080,"./style":1081}],1078:[function(t,e,r){"use strict";var n=t('../../lib'),i=.01,a=[[-1,0],[1,0],[0,-1],[0,1]];function o(t){return.5-.25*Math.min(1,.5*t)}function s(t,e,r){var n,i,o,s,l,c,u,f,h,p,d,m,g,v=0;for(s=0;s<e.length;s++){for(i=(n=e[s])[0],o=n[1],d=t[i][o],p=0,h=0,l=0;l<4;l++)(u=t[i+(c=a[l])[0]])&&void 0!==(f=u[o+c[1]])&&(0===p?m=g=f:(m=Math.min(m,f),g=Math.max(g,f)),h++,p+=f);if(0===h)throw"iterateInterp2d order is wrong: no defined neighbors";t[i][o]=p/h,void 0===d?h<4&&(v=1):(t[i][o]=(1+r)*t[i][o]-r*d,g>m&&(v=Math.max(v,Math.abs(t[i][o]-d)/(g-m))))}return v}e.exports=function(t,e){var r,a=1;for(s(t,e),r=0;r<e.length&&!(e[r][2]<4);r++);for(e=e.slice(r),r=0;r<100&&a>i;r++)a=s(t,e,o(a));return a>i&&n.log('interp2d didn't converge quickly',a),t}},{"../../lib":787}],1079:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib').isArrayOrTypedArray;e.exports=function(t,e,r,a,o,s){var l,c,u,f=[],h=n.traceIs(t,'contour'),p=n.traceIs(t,'histogram'),d=n.traceIs(t,'gl2d');if(i(e)&&e.length>1&&!p&&"category"!==s.type){var m=e.length;if(!(m<=o))return h?e.slice(0,o):e.slice(0,o+1);if(h||d)f=e.slice(0,o);else if(1===o)f=[e[0]-.5,e[0]+.5];else{for(f=[1.5*e[0]-.5*e[1]],u=1;u<m;u++)f.push(.5*(e[u-1]+e[u]));f.push(1.5*e[m-1]-.5*e[m-2])}if(m<o){var g=f[f.length-1],v=g-f[f.length-2];for(u=m;u<o;u++)g+=v,f.push(g)}}else{var y=t[s._id.charAt(0)+"calendar"];for(l=p?s.r2c(r,0,y):i(e)&&1===e.length?e[0]:void 0===r?0:("log"===s.type?s.d2c:s.r2c)(r,0,y),c=a||1,u=h||d?0:-.5;u<o;u++)f.push(l+c*u)}return f}},{"../../lib":787,"../../registry":915}],1080:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('tinycolor2'),a=t('../../registry'),o=t('../../lib'),s=t('../../components/colorscale').makeColorScaleFuncFromTrace,l=t('../../constants/xmlns_namespaces');function c(t,e){var r=e.length-2,n=o.constrain(o.findBin(t,e),0,r),i=e[n],a=e[n+1],s=o.constrain(n+(t-i)/(a-i)-.5,0,r),l=Math.round(s),c=Math.abs(s-l);return s&&s!==r&&c?{bin0:l,frac:c,bin1:Math.round(l+c/(s-l))}:{bin0:l,bin1:l,frac:0}}function u(t,e){var r=e.length-1,n=o.constrain(o.findBin(t,e),0,r),i=e[n],a=(t-i)/(e[n+1]-i)||0;return a<=0?{bin0:n,bin1:n,frac:0}:a<.5?{bin0:n,bin1:n+1,frac:a}:{bin0:n+1,bin1:n,frac:1-a}}function f(t,e,r){t[e]=r[0],t[e+1]=r[1],t[e+2]=r[2],t[e+3]=Math.round(255*r[3])}e.exports=function(t,e,r,h){var p=e.xaxis,d=e.yaxis;o.makeTraceGroups(h,r,'hm').each((function(e){var r,h,m,g,v,y,x=n.select(this),b=e[0],_=b.trace,w=b.z,T=b.x,k=b.y,M=b.xCenter,A=b.yCenter,S=a.traceIs(_,'contour'),E=S?"best":_.zsmooth,L=w.length,C=o.maxRowLength(w),P=!1,I=!1;for(y=0;void 0===r&&y<T.length-1;)r=p.c2p(T[y]),y++;for(y=T.length-1;void 0===h&&y>0;)h=p.c2p(T[y]),y--;for(h<r&&(m=h,h=r,r=m,P=!0),y=0;void 0===g&&y<k.length-1;)g=d.c2p(k[y]),y++;for(y=k.length-1;void 0===v&&y>0;)v=d.c2p(k[y]),y--;if(v<g&&(m=g,g=v,v=m,I=!0),S&&(M=T,A=k,T=b.xfill,k=b.yfill),"fast"!==E){var z="best"===E?0:.5;r=Math.max(-z*p._length,r),h=Math.min((1+z)*p._length,h),g=Math.max(-z*d._length,g),v=Math.min((1+z)*d._length,v)}var O=Math.round(h-r),D=Math.round(v-g);if(O<=0||D<=0)x.selectAll('image').data([]).exit().remove();else{var R,F;"fast"===E?(R=C,F=L):(R=O,F=D);var B=document.createElement('canvas');B.width=R,B.height=F;var N,j,U=B.getContext('2d'),V=s(_,{noNumericCheck:!0,returnArray:!0});"fast"===E?(N=P?function(t){return C-1-t}:o.identity,j=I?function(t){return L-1-t}:o.identity):(N=function(t){return o.constrain(Math.round(p.c2p(T[t])-r),0,O)},j=function(t){return o.constrain(Math.round(d.c2p(k[t])-g),0,D)});var H,q,G,Y,W,X=j(0),Z=[X,X],J=P?0:1,K=I?0:1,Q=0,$=0,tt=0,et=0;if(E){var rt,nt=0;try{rt=new Uint8Array(O*D*4)}catch(Mt)[rt=new Array(O*D*4)]if("best"===E){var it,at,ot,st=M||T,lt=A||k,ct=new Array(st.length),ut=new Array(lt.length),ft=new Array(O),ht=M?u:c,pt=A?u:c;for(y=0;y<st.length;y++)ct[y]=Math.round(p.c2p(st[y])-r);for(y=0;y<lt.length;y++)ut[y]=Math.round(d.c2p(lt[y])-g);for(y=0;y<O;y++)ft[y]=ht(y,ct);for(q=0;q<D;q++)for(at=w[(it=pt(q,ut)).bin0],ot=w[it.bin1],y=0;y<O;y++,nt+=4)f(rt,nt,W=kt(at,ot,ft[y],it))}else for(q=0;q<L;q++)for(Y=w[q],Z=j(q),y=0;y<O;y++)W=Tt(Y[y],1),f(rt,nt=4*(Z*O+N(y)),W);var dt=U.createImageData(O,D);try[dt.data.set(rt)]catch(Mt){var mt=dt.data,gt=mt.length;for(q=0;q<gt;q++)mt[q]=rt[q]}U.putImageData(dt,0,0)}else{var vt=_.xgap,yt=_.ygap,xt=Math.floor(vt/2),bt=Math.floor(yt/2);for(q=0;q<L;q++)if(Y=w[q],Z.reverse(),Z[K]=j(q+1),Z[0]!==Z[1]&&void 0!==Z[0]&&void 0!==Z[1])for(H=[G=N(0),G],y=0;y<C;y++)H.reverse(),H[J]=N(y+1),H[0]!==H[1]&&void 0!==H[0]&&void 0!==H[1]&&(W=Tt(Y[y],(H[1]-H[0])*(Z[1]-Z[0])),U.fillStyle='rgba('+W.join(',')+")",U.fillRect(H[0]+xt,Z[0]+bt,H[1]-H[0]-vt,Z[1]-Z[0]-yt))}$=Math.round($/Q),tt=Math.round(tt/Q),et=Math.round(et/Q);var _t=i('rgb('+$+','+tt+','+et+')');t._hmpixcount=(t._hmpixcount||0)+Q,t._hmlumcount=(t._hmlumcount||0)+Q*_t.getLuminance();var wt=x.selectAll('image').data(e);wt.enter().append('svg:image').attr({xmlns:l.svg,preserveAspectRatio:"none"}),wt.attr({height:D,width:O,x:r,y:g,"xlink:href":B.toDataURL('image/png')})}function Tt(t,e){if(void 0!==t){var r=V(t);return r[0]=Math.round(r[0]),r[1]=Math.round(r[1]),r[2]=Math.round(r[2]),Q+=e,$+=r[0]*e,tt+=r[1]*e,et+=r[2]*e,r}return[0,0,0,0]}function kt(t,e,r,n){var i=t[r.bin0];if(void 0===i)return Tt(void 0,1);var a,o=t[r.bin1],s=e[r.bin0],l=e[r.bin1],c=o-i||0,u=s-i||0;return a=void 0===o?void 0===l?0:void 0===s?2*(l-i):2*(2*l-s-i)/3:void 0===l?void 0===s?0:2*(2*i-o-s)/3:void 0===s?2*(2*l-o-i)/3:l+i-o-s,Tt(i+r.frac*c+n.frac*(u+r.frac*a))}}))}},{"../../components/colorscale":662,"../../constants/xmlns_namespaces":764,"../../lib":787,"../../registry":915,"@plotly/d3":58,tinycolor2:583}],1081:[function(t,e,r){"use strict";var n=t('@plotly/d3');e.exports=function(t){n.select(t).selectAll('.hm image').style('opacity',(function(t){return t.trace.opacity}))}},{"@plotly/d3":58}],1082:[function(t,e,r){"use strict";e.exports=function(t,e,r){!1===r('zsmooth')&&(r('xgap'),r('ygap')),r('zhoverformat')}},{}],1083:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../registry');function o(t,e){var r=e(t);return"scaled"===(r?e(t+"type",'array'):"scaled")&&(e(t+"0"),e("d"+t)),r}function s(t){for(var e,r=!0,a=!1,o=!1,s=0;s<t.length;s++){if(e=t[s],!i.isArrayOrTypedArray(e)){r=!1;break}e.length>0&&(a=!0);for(var l=0;l<e.length;l++)if(n(e[l])){o=!0;break}}return r&&a&&o}e.exports=function(t,e,r,n,l,c){var u,f,h=r('z');if(l=l||"x",c=c||"y",void 0===h||!h.length)return 0;if(i.isArray1D(t.z)){u=r(l),f=r(c);var p=i.minRowLength(u),d=i.minRowLength(f);if(0===p||0===d)return 0;e._length=Math.min(p,d,h.length)}else{if(u=o(l,r),f=o(c,r),!s(h))return 0;r('transpose'),e._length=null}return"heatmapgl"===t.type||a.getComponentMethod('calendars','handleTraceDefaults')(t,e,[l,c],n),!0}},{"../../lib":787,"../../registry":915,"fast-isnumeric":246}],1084:[function(t,e,r){"use strict";for(var n=t('../heatmap/attributes'),i=t('../../components/colorscale/attributes'),a=t('../../lib/extend').extendFlat,o=t('../../plot_api/edit_types').overrideAll,s=["z",'x','x0','dx','y','y0','dy','text','transpose','xtype',"ytype"],l={},c=0;c<s.length;c++){var u=s[c];l[u]=n[u]}l.zsmooth={valType:"enumerated",values:["fast",!1],dflt:"fast",editType:"calc"},a(l,i('',{cLetter:"z",autoColorDflt:!1})),e.exports=o(l,'calc','nested')},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/edit_types":820,"../heatmap/attributes":1069}],1085:[function(t,e,r){"use strict";var n=t('gl-heatmap2d'),i=t('../../plots/cartesian/axes'),a=t('../../lib/str2rgbarray');function o(t,e){this.scene=t,this.uid=e,this.type='heatmapgl',this.name='',this.hoverinfo='all',this.xData=[],this.yData=[],this.zData=[],this.textLabels=[],this.idToIndex=[],this.bounds=[0,0,0,0],this.options={zsmooth:"fast",z:[],x:[],y:[],shape:[0,0],colorLevels:[0],colorValues:[0,0,0,1]},this.heatmap=n(t.glplot,this.options),this.heatmap._trace=this}var s=o.prototype;function l(t){for(var e=t.colorscale,r=t.zmin,n=t.zmax,i=e.length,o=new Array(i),s=new Array(4*i),l=0;l<i;l++){var c=e[l],u=a(c[1]);o[l]=r+c[0]*(n-r);for(var f=0;f<4;f++)s[4*l+f]=u[f]}return{colorLevels:o,colorValues:s}}function c(t,e,r){var n=new o(t,e.uid);return n.update(e,r),n}s.handlePick=function(t){var e=this.options,r=e.shape,n=t.pointId,i=n%r[0],a=Math.floor(n/r[0]),o=n;return{trace:this,dataCoord:t.dataCoord,traceCoord:[e.x[i],e.y[a],e.z[o]],textLabel:this.textLabels[n],name:this.name,pointIndex:[a,i],hoverinfo:this.hoverinfo}},s.update=function(t,e){var r=e[0];this.index=t.index,this.name=t.name,this.hoverinfo=t.hoverinfo;var n=r.z;this.options.z=[].concat.apply([],n);var a=n[0].length,o=n.length;this.options.shape=[a,o],this.options.x=r.x,this.options.y=r.y,this.options.zsmooth=t.zsmooth;var s=l(t);this.options.colorLevels=s.colorLevels,this.options.colorValues=s.colorValues,this.textLabels=[].concat.apply([],t.text),this.heatmap.update(this.options);var c,u,f=this.scene.xaxis,h=this.scene.yaxis;!1===t.zsmooth&&(c={ppad:r.x[1]-r.x[0]},u={ppad:r.y[1]-r.y[0]}),t._extremes[f._id]=i.findExtremes(f,r.x,c),t._extremes[h._id]=i.findExtremes(h,r.y,u)},s.dispose=function()[this.heatmap.dispose()],e.exports=c},{"../../lib/str2rgbarray":812,"../../plots/cartesian/axes":838,"gl-heatmap2d":272}],1086:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../heatmap/xyz_defaults'),a=t('../../components/colorscale/defaults'),o=t('./attributes');e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}i(t,e,l,s)?(l('text'),l('zsmooth'),a(t,e,s,l,{prefix:"",cLetter:"z"})):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"../heatmap/xyz_defaults":1083,"./attributes":1084}],1087:[function(t,e,r){"use strict";["*heatmapgl* trace is deprecated!",'Please consider switching to the *heatmap* or *image* trace types.','Alternatively you could contribute/sponsor rewriting this trace type',"based on cartesian features and using regl framework."].join(' '),e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../heatmap/colorbar'),calc:t('../heatmap/calc'),plot:t('./convert'),moduleType:"trace",name:"heatmapgl",basePlotModule:t('../../plots/gl2d'),categories:["gl",'gl2d',"2dMap"],meta:{}}},{"../../plots/gl2d":878,"../heatmap/calc":1070,"../heatmap/colorbar":1072,"./attributes":1084,"./convert":1085,"./defaults":1086}],1088:[function(t,e,r){"use strict";var n=t('../bar/attributes'),i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('./bin_attributes'),s=t('./constants'),l=t('../../lib/extend').extendFlat;e.exports={x:{valType:"data_array",editType:"calc+clearAxisTypes"},y:{valType:"data_array",editType:"calc+clearAxisTypes"},xhoverformat:i('x'),yhoverformat:i('y'),text:l({},n.text,{}),hovertext:l({},n.hovertext,{}),orientation:n.orientation,histfunc:{valType:"enumerated",values:["count",'sum','avg','min',"max"],dflt:"count",editType:"calc"},histnorm:{valType:"enumerated",values:["",'percent','probability','density',"probability density"],dflt:"",editType:"calc"},cumulative:{enabled:{valType:"boolean",dflt:!1,editType:"calc"},direction:{valType:"enumerated",values:["increasing","decreasing"],dflt:"increasing",editType:"calc"},currentbin:{valType:"enumerated",values:["include",'exclude',"half"],dflt:"include",editType:"calc"},editType:"calc"},nbinsx:{valType:"integer",min:0,dflt:0,editType:"calc"},xbins:o('x',!0),nbinsy:{valType:"integer",min:0,dflt:0,editType:"calc"},ybins:o('y',!0),autobinx:{valType:"boolean",dflt:null,editType:"calc"},autobiny:{valType:"boolean",dflt:null,editType:"calc"},bingroup:{valType:"string",dflt:"",editType:"calc"},hovertemplate:a({},{keys:s.eventDataKeys}),marker:n.marker,offsetgroup:n.offsetgroup,alignmentgroup:n.alignmentgroup,selected:n.selected,unselected:n.unselected,_deprecated:{bardir:n._deprecated.bardir}}},{"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../bar/attributes":925,"./bin_attributes":1090,"./constants":1094}],1089:[function(t,e,r){"use strict";e.exports=function(t,e){for(var r=t.length,n=0,i=0;i<r;i++)e[i]?(t[i]/=e[i],n+=t[i]):t[i]=null;return n}},{}],1090:[function(t,e,r){"use strict";e.exports=function(t,e){return{start:{valType:"any",editType:"calc"},end:{valType:"any",editType:"calc"},size:{valType:"any",editType:"calc"},editType:"calc"}}},{}],1091:[function(t,e,r){"use strict";var n=t('fast-isnumeric');e.exports={count:function(t,e,r){return r[t]++,1},sum:function(t,e,r,i){var a=i[e];return n(a)?(a=Number(a),r[t]+=a,a):0},avg:function(t,e,r,i,a){var o=i[e];return n(o)&&(o=Number(o),r[t]+=o,a[t]++),0},min:function(t,e,r,i){var a=i[e];if(n(a)){if(a=Number(a),!n(r[t]))return r[t]=a,a;if(r[t]>a){var o=a-r[t];return r[t]=a,o}}return 0},max:function(t,e,r,i){var a=i[e];if(n(a)){if(a=Number(a),!n(r[t]))return r[t]=a,a;if(r[t]<a){var o=a-r[t];return r[t]=a,o}}return 0}}},{"fast-isnumeric":246}],1092:[function(t,e,r){"use strict";var n=t('../../constants/numerical'),i=n.ONEAVGYEAR,a=n.ONEAVGMONTH,o=n.ONEDAY,s=n.ONEHOUR,l=n.ONEMIN,c=n.ONESEC,u=t('../../plots/cartesian/axes').tickIncrement;function f(t,e,r,n){if(t*e<=0)return 1/0;for(var i=Math.abs(e-t),a="date"===r.type,o=h(i,a),s=0;s<10;s++){var l=h(80*o,a);if(o===l)break;if(!p(l,t,e,a,r,n))break;o=l}return o}function h(t,e){return e&&t>c?t>o?t>1.1*i?i:t>1.1*a?a:o:t>s?s:t>l?l:c:Math.pow(10,Math.floor(Math.log(t)/Math.LN10))}function p(t,e,r,n,a,s){if(n&&t>o){var l=d(e,a,s),c=d(r,a,s),u=t===i?0:1;return l[u]!==c[u]}return Math.floor(r/t)-Math.floor(e/t)>.1}function d(t,e,r){var n=e.c2d(t,i,r).split('-');return""===n[0]&&(n.unshift(),n[0]="-"+n[0]),n}e.exports=function(t,e,r,n,a){var s,l,c=-1.1*e,h=-.1*e,p=t-h,d=r[0],m=r[1],g=Math.min(f(d+h,d+p,n,a),f(m+h,m+p,n,a)),v=Math.min(f(d+c,d+h,n,a),f(m+c,m+h,n,a));if(g>v&&v<Math.abs(m-d)/4e3?(s=g,l=!1):(s=Math.min(g,v),l=!0),"date"===n.type&&s>o){var y=s===i?1:6,x=s===i?"M12":"M1";return function(e,r){var o=n.c2d(e,i,a),s=o.indexOf('-',y);s>0&&(o=o.substr(0,s));var c=n.d2c(o,0,a);if(c<e){var f=u(c,x,!1,a);(c+f)/2<e+t&&(c=f)}return r&&l?u(c,x,!0,a):c}}return function(e,r){var n=s*Math.round(e/s);return n+s/10<e&&n+.9*s<e+t&&(n+=s),r&&l&&(n-=s),n}}},{"../../constants/numerical":763,"../../plots/cartesian/axes":838}],1093:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../registry'),o=t('../../plots/cartesian/axes'),s=t('../bar/arrays_to_calcdata'),l=t('./bin_functions'),c=t('./norm_functions'),u=t('./average'),f=t('./bin_label_vals');function h(t,e){var r,a,h,d,m=[],v=[],y=o.getFromId(t,"h"===e.orientation?e.yaxis:e.xaxis),x="h"===e.orientation?"y":"x",b={x:"y",y:"x"}[x],_=e[x+"calendar"],w=e.cumulative,T=p(t,e,y,x),k=T[0],M=T[1],A="string"===typeof k.size,S=[],E=A?S:k,L=[],C=[],P=[],I=0,z=e.histnorm,O=e.histfunc,D=-1!==z.indexOf('density');w.enabled&&D&&(z=z.replace(/ ?density$/,''),D=!1);var R,F="max"===O||"min"===O?null:0,B=l.count,N=c[z],j=!1,U=function(t){return y.r2c(t,0,_)};for(i.isArrayOrTypedArray(e[b])&&"count"!==O&&(R=e[b],j="avg"===O,B=l[O]),r=U(k.start),h=U(k.end)+(r-o.tickIncrement(r,k.size,!1,_))/1e6;r<h&&m.length<1e6&&(a=o.tickIncrement(r,k.size,!1,_),m.push((r+a)/2),v.push(F),P.push([]),S.push(r),D&&L.push(1/(a-r)),j&&C.push(0),!(a<=r));)r=a;S.push(r),A||"date"!==y.type||(E={start:U(E.start),end:U(E.end),size:E.size}),t._fullLayout._roundFnOpts||(t._fullLayout._roundFnOpts={});var V=e["_"+x+"bingroup"],H={leftGap:1/0,rightGap:1/0};V&&(t._fullLayout._roundFnOpts[V]||(t._fullLayout._roundFnOpts[V]=H),H=t._fullLayout._roundFnOpts[V]);var q,G=v.length,Y=!0,W=H.leftGap,X=H.rightGap,Z={};for(r=0;r<M.length;r++){var J=M[r];(d=i.findBin(J,E))>=0&&d<G&&(I+=B(d,r,v,R,C),Y&&P[d].length&&J!==M[P[d][0]]&&(Y=!1),P[d].push(r),Z[r]=d,W=Math.min(W,J-S[d]),X=Math.min(X,S[d+1]-J))}H.leftGap=W,H.rightGap=X,Y||(q=function(e,r){return function(){var n=t._fullLayout._roundFnOpts[V];return f(n.leftGap,n.rightGap,S,y,_)(e,r)}}),j&&(I=u(v,C)),N&&N(v,I,L),w.enabled&&g(v,w.direction,w.currentbin);var K=Math.min(m.length,v.length),Q=[],$=0,tt=K-1;for(r=0;r<K;r++)if(v[r]){$=r;break}for(r=K-1;r>=$;r--)if(v[r]){tt=r;break}for(r=$;r<=tt;r++)if(n(m[r])&&n(v[r])){var et={p:m[r],s:v[r],b:0};w.enabled||(et.pts=P[r],Y?et.ph0=et.ph1=P[r].length?M[P[r][0]]:m[r]:(e._computePh=!0,et.ph0=q(S[r]),et.ph1=q(S[r+1],!0))),Q.push(et)}return 1===Q.length&&(Q[0].width1=o.tickIncrement(Q[0].p,k.size,!1,_)-Q[0].p),s(Q,e),i.isArrayOrTypedArray(e.selectedpoints)&&i.tagSelected(Q,e,Z),Q}function p(t,e,r,s,l){var c,u,f,h,p,m,g,v=s+"bins",y=t._fullLayout,x=e["_"+s+"bingroup"],b=y._histogramBinOpts[x],_="overlay"===y.barmode,w=function(t){return r.r2c(t,0,h)},T=function(t){return r.c2r(t,0,h)},k="date"===r.type?function(t){return t||0===t?i.cleanDate(t,null,h):null}:function(t){return n(t)?Number(t):null};function M(t,e,r){e[t+"Found"]?(e[t]=k(e[t]),null===e[t]&&(e[t]=r[t])):(m[t]=e[t]=r[t],i.nestedProperty(u[0],v+"."+t).set(r[t]))}if(e["_"+s+"autoBinFinished"])delete e["_"+s+"autoBinFinished"];else{u=b.traces;var A=[],S=!0,E=!1,L=!1;for(c=0;c<u.length;c++)if((f=u[c]).visible){var C=b.dirs[c];p=f["_"+C+"pos0"]=r.makeCalcdata(f,C),A=i.concat(A,p),delete f["_"+s+"autoBinFinished"],!0===e.visible&&(S?S=!1:(delete f._autoBin,f["_"+s+"autoBinFinished"]=1),a.traceIs(f,'2dMap')&&(E=!0),"histogram2dcontour"===f.type&&(L=!0))}h=u[0][s+"calendar"];var P=o.autoBin(A,r,b.nbins,E,h,b.sizeFound&&b.size),I=u[0]._autoBin={};if(m=I[b.dirs[0]]={},L&&(b.size||(P.start=T(o.tickIncrement(w(P.start),P.size,!0,h))),void 0===b.end&&(P.end=T(o.tickIncrement(w(P.end),P.size,!1,h)))),_&&!a.traceIs(e,'2dMap')&&0===P._dataSpan&&"category"!==r.type&&"multicategory"!==r.type){if(l)return[P,p,!0];P=d(t,e,r,s,v)}(g=f.cumulative||{}).enabled&&"include"!==g.currentbin&&("decreasing"===g.direction?P.start=T(o.tickIncrement(w(P.start),P.size,!0,h)):P.end=T(o.tickIncrement(w(P.end),P.size,!1,h))),b.size=P.size,b.sizeFound||(m.size=P.size,i.nestedProperty(u[0],v+".size").set(P.size)),M('start',b,P),M('end',b,P)}p=e["_"+s+"pos0"],delete e["_"+s+"pos0"];var z=e._input[v]||{},O=i.extendFlat({},b),D=b.start,R=r.r2l(z.start),F=void 0!==R;if((b.startFound||F)&&R!==r.r2l(D)){var B=F?R:i.aggNums(Math.min,null,p),N={type:"category"===r.type||"multicategory"===r.type?"linear":r.type,r2l:r.r2l,dtick:b.size,tick0:D,calendar:h,range:[B,o.tickIncrement(B,b.size,!1,h)].map(r.l2r)},j=o.tickFirst(N);j>r.r2l(B)&&(j=o.tickIncrement(j,b.size,!0,h)),O.start=r.l2r(j),F||i.nestedProperty(e,v+".start").set(O.start)}var U=b.end,V=r.r2l(z.end),H=void 0!==V;if((b.endFound||H)&&V!==r.r2l(U)){var q=H?V:i.aggNums(Math.max,null,p);O.end=r.l2r(q),H||i.nestedProperty(e,v+".start").set(O.end)}var G="autobin"+s;return!1===e._input[G]&&(e._input[v]=i.extendFlat({},e[v]||{}),delete e._input[G],delete e[G]),[O,p]}function d(t,e,r,n,a){var o,s,l,c=t._fullLayout,u=m(t,e),f=!1,h=1/0,d=[e];for(o=0;o<u.length;o++)if((s=u[o])===e)f=!0;else if(f){var g=p(t,s,r,n,!0),v=g[0],y=g[2];s["_"+n+"autoBinFinished"]=1,s["_"+n+"pos0"]=g[1],y?d.push(s):h=Math.min(h,v.size)}else l=c._histogramBinOpts[s["_"+n+"bingroup"]],h=Math.min(h,l.size||s[a].size);var x=new Array(d.length);for(o=0;o<d.length;o++)for(var b=d[o]["_"+n+"pos0"],_=0;_<b.length;_++)if(void 0!==b[_]){x[o]=b[_];break}for(isFinite(h)||(h=i.distinctVals(x).minDiff),o=0;o<d.length;o++){var w=(s=d[o])[n+"calendar"],T={start:r.c2r(x[o]-h/2,0,w),end:r.c2r(x[o]+h/2,0,w),size:h};s._input[a]=s[a]=T,(l=c._histogramBinOpts[s["_"+n+"bingroup"]])&&i.extendFlat(l,T)}return e[a]}function m(t,e){for(var r=e.xaxis,n=e.yaxis,i=e.orientation,a=[],o=t._fullData,s=0;s<o.length;s++){var l=o[s];"histogram"===l.type&&!0===l.visible&&l.orientation===i&&l.xaxis===r&&l.yaxis===n&&a.push(l)}return a}function g(t,e,r){var n,i,a;function o(e){a=t[e],t[e]/=2}function s(e){i=t[e],t[e]=a+i/2,a+=i}if("half"===r)if("increasing"===e)for(o(0),n=1;n<t.length;n++)s(n);else for(o(t.length-1),n=t.length-2;n>=0;n--)s(n);else if("increasing"===e){for(n=1;n<t.length;n++)t[n]+=t[n-1];"exclude"===r&&(t.unshift(0),t.pop())}else{for(n=t.length-2;n>=0;n--)t[n]+=t[n+1];"exclude"===r&&(t.push(0),t.shift())}}e.exports={calc:h,calcAllAutoBins:p}},{"../../lib":787,"../../plots/cartesian/axes":838,"../../registry":915,"../bar/arrays_to_calcdata":924,"./average":1089,"./bin_functions":1091,"./bin_label_vals":1092,"./norm_functions":1100,"fast-isnumeric":246}],1094:[function(t,e,r){"use strict";e.exports={eventDataKeys:["binNumber"]}},{}],1095:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axis_ids'),a=t('../../registry').traceIs,o=t('../bar/defaults').handleGroupingDefaults,s=n.nestedProperty,l=t('../../plots/cartesian/constraints').getAxisGroup,c=[{aStr:{x:"xbins.start",y:"ybins.start"},name:"start"},{aStr:{x:"xbins.end",y:"ybins.end"},name:"end"},{aStr:{x:"xbins.size",y:"ybins.size"},name:"size"},{aStr:{x:"nbinsx",y:"nbinsy"},name:"nbins"}],u=["x","y"];e.exports=function(t,e){var r,f,h,p,d,m,g,v=e._histogramBinOpts={},y=[],x={},b=[];function _(t,e){return n.coerce(r._input,r,r._module.attributes,t,e)}function w(t){return"v"===t.orientation?"x":"y"}function T(t,r){return i.getFromTrace({_fullLayout:e},t,r).type}function k(t,e,r){var i=t.uid+"__"+r;e||(e=i);var a=T(t,r),o=t[r+"calendar"]||"",s=v[e],l=!0;s&&(a===s.axType&&o===s.calendar?(l=!1,s.traces.push(t),s.dirs.push(r)):(e=i,a!==s.axType&&n.warn(["Attempted to group the bins of trace",t.index,'set on a',"type:"+a,'axis','with bins on',"type:"+s.axType,"axis."].join(' ')),o!==s.calendar&&n.warn(["Attempted to group the bins of trace",t.index,'set with a',o,'calendar','with bins',s.calendar?"on a '+s.calendar+' calendar":"w/o a set calendar"].join(' ')))),l&&(v[e]={traces:[t],dirs:[r],axType:a,calendar:t[r+"calendar"]||""}),t["_"+r+"bingroup"]=e}for(d=0;d<t.length;d++)r=t[d],a(r,'histogram')&&(y.push(r),delete r._xautoBinFinished,delete r._yautoBinFinished,a(r,'2dMap')||o(r._input,r,e,_));var M=e._alignmentOpts||{};for(d=0;d<y.length;d++){if(r=y[d],h='',!a(r,'2dMap')){if(p=w(r),"group"===e.barmode&&r.alignmentgroup){var A=r[p+"axis"],S=l(e,A)+r.orientation;(M[S]||{})[r.alignmentgroup]&&(h=S)}h||"overlay"===e.barmode||(h=l(e,r.xaxis)+l(e,r.yaxis)+w(r))}h?(x[h]||(x[h]=[]),x[h].push(r)):b.push(r)}for(h in x)if(1!==(f=x[h]).length){var E=!1;for(f.length&&(r=f[0],E=_('bingroup')),h=E||h,d=0;d<f.length;d++){var L=(r=f[d])._input.bingroup;L&&L!==h&&n.warn(["Trace",r.index,'must match','within bingroup',h+".",'Ignoring its bingroup:',L,"setting."].join(' ')),r.bingroup=h,k(r,h,w(r))}}else b.push(f[0]);for(d=0;d<b.length;d++){r=b[d];var C=_('bingroup');if(a(r,'2dMap'))for(g=0;g<2;g++){var P=_((p=u[g])+"bingroup",C?C+"__"+p:null);k(r,P,p)}else k(r,C,w(r))}for(h in v){var I=v[h];for(f=I.traces,m=0;m<c.length;m++){var z,O,D=c[m],R=D.name;if("nbins"!==R||!I.sizeFound){for(d=0;d<f.length;d++){if(r=f[d],p=I.dirs[d],z=D.aStr[p],void 0!==s(r._input,z).get()){I[R]=_(z),I[R+"Found"]=!0;break}(O=(r._autoBin||{})[p]||{})[R]&&s(r,z).set(O[R])}if("start"===R||"end"===R)for(;d<f.length;d++)(r=f[d])["_"+p+"bingroup"]&&_(z,(O=(r._autoBin||{})[p]||{})[R]);"nbins"!==R||I.sizeFound||I.nbinsFound||(r=f[0],I[R]=_(z))}}}}},{"../../lib":787,"../../plots/cartesian/axis_ids":842,"../../plots/cartesian/constraints":846,"../../registry":915,"../bar/defaults":929}],1096:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../../components/color'),o=t('../bar/style_defaults'),s=t('./attributes');e.exports=function(t,e,r,l){function c(r,n){return i.coerce(t,e,s,r,n)}var u=c('x'),f=c('y');c('cumulative.enabled')&&(c('cumulative.direction'),c('cumulative.currentbin')),c('text'),c('hovertext'),c('hovertemplate'),c('xhoverformat'),c('yhoverformat');var h=c('orientation',f&&!u?"h":"v"),p="v"===h?"x":"y",d="v"===h?"y":"x",m=u&&f?Math.min(i.minRowLength(u)&&i.minRowLength(f)):i.minRowLength(e[p]||[]);if(m){e._length=m,n.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x","y"],l),e[d]&&c('histfunc'),c('histnorm'),c("autobin"+p),o(t,e,c,r,l),i.coerceSelectionMarkerOpacity(e,c);var g=(e.marker.line||{}).color,v=n.getComponentMethod('errorbars','supplyDefaults');v(t,e,g||a.defaultLine,{axis:"y"}),v(t,e,g||a.defaultLine,{axis:"x",inherit:"y"})}else e.visible=!1}},{"../../components/color":650,"../../lib":787,"../../registry":915,"../bar/style_defaults":940,"./attributes":1088}],1097:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){if(t.x="xVal"in e?e.xVal:e.x,t.y="yVal"in e?e.yVal:e.y,"zLabelVal"in e&&(t.z=e.zLabelVal),e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),!(r.cumulative||{}).enabled){var a,o=Array.isArray(i)?n[0].pts[i[0]][i[1]]:n[i].pts;if(t.pointNumbers=o,t.binNumber=t.pointNumber,delete t.pointNumber,delete t.pointIndex,r._indexToPoints){a=[];for(var s=0;s<o.length;s++)a=a.concat(r._indexToPoints[o[s]])}else a=o;t.pointIndices=a}return t}},{}],1098:[function(t,e,r){"use strict";var n=t('../bar/hover').hoverPoints,i=t('../../plots/cartesian/axes').hoverLabelText;e.exports=function(t,e,r,a,o){var s=n(t,e,r,a,o);if(s){var l=(t=s[0]).cd[t.index],c=t.cd[0].trace;if(!c.cumulative.enabled){var u="h"===c.orientation?"y":"x";t[u+"Label"]=i(t[u+"a"],[l.ph0,l.ph1],c[u+"hoverformat"])}return s}}},{"../../plots/cartesian/axes":838,"../bar/hover":932}],1099:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),layoutAttributes:t('../bar/layout_attributes'),supplyDefaults:t('./defaults'),crossTraceDefaults:t('./cross_trace_defaults'),supplyLayoutDefaults:t('../bar/layout_defaults'),calc:t('./calc').calc,crossTraceCalc:t('../bar/cross_trace_calc').crossTraceCalc,plot:t('../bar/plot').plot,layerName:"barlayer",style:t('../bar/style').style,styleOnSelect:t('../bar/style').styleOnSelect,colorbar:t('../scatter/marker_colorbar'),hoverPoints:t('./hover'),selectPoints:t('../bar/select'),eventData:t('./event_data'),moduleType:"trace",name:"histogram",basePlotModule:t('../../plots/cartesian'),categories:["bar-like",'cartesian','svg','bar','histogram','oriented','errorBarsOK',"showLegend"],meta:{}}},{"../../plots/cartesian":852,"../bar/cross_trace_calc":928,"../bar/layout_attributes":934,"../bar/layout_defaults":935,"../bar/plot":936,"../bar/select":937,"../bar/style":939,"../scatter/marker_colorbar":1220,"./attributes":1088,"./calc":1093,"./cross_trace_defaults":1095,"./defaults":1096,"./event_data":1097,"./hover":1098}],1100:[function(t,e,r){"use strict";e.exports={percent:function(t,e){for(var r=t.length,n=100/e,i=0;i<r;i++)t[i]*=n},probability:function(t,e){for(var r=t.length,n=0;n<r;n++)t[n]/=e},density:function(t,e,r,n){var i=t.length;n=n||1;for(var a=0;a<i;a++)t[a]*=r[a]*n},"probability density":function(t,e,r,n){var i=t.length;n&&(e/=n);for(var a=0;a<i;a++)t[a]*=r[a]/e}}},{}],1101:[function(t,e,r){"use strict";var n=t('../histogram/attributes'),i=t('../histogram/bin_attributes'),a=t('../heatmap/attributes'),o=t('../../plots/attributes'),s=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,l=t('../../plots/template_attributes').hovertemplateAttrs,c=t('../../components/colorscale/attributes'),u=t('../../lib/extend').extendFlat;e.exports=u({x:n.x,y:n.y,z:{valType:"data_array",editType:"calc"},marker:{color:{valType:"data_array",editType:"calc"},editType:"calc"},histnorm:n.histnorm,histfunc:n.histfunc,nbinsx:n.nbinsx,xbins:i('x'),nbinsy:n.nbinsy,ybins:i('y'),autobinx:n.autobinx,autobiny:n.autobiny,bingroup:u({},n.bingroup,{}),xbingroup:u({},n.bingroup,{}),ybingroup:u({},n.bingroup,{}),xgap:a.xgap,ygap:a.ygap,zsmooth:a.zsmooth,xhoverformat:s('x'),yhoverformat:s('y'),zhoverformat:s('z',1),hovertemplate:l({},{keys:"z"}),showlegend:u({},o.showlegend,{dflt:!1})},c('',{cLetter:"z",autoColorDflt:!1}))},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../heatmap/attributes":1069,"../histogram/attributes":1088,"../histogram/bin_attributes":1090}],1102:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../histogram/bin_functions'),o=t('../histogram/norm_functions'),s=t('../histogram/average'),l=t('../histogram/bin_label_vals'),c=t('../histogram/calc').calcAllAutoBins;function u(t,e,r,n){var i,a=new Array(t);if(n)for(i=0;i<t;i++)a[i]=1/(e[i+1]-e[i]);else{var o=1/r;for(i=0;i<t;i++)a[i]=o}return a}function f(t,e){return{start:t(e.start),end:t(e.end),size:e.size}}function h(t,e,r,n,i,a){var o,s=t.length-1,c=new Array(s),u=l(r,n,t,i,a);for(o=0;o<s;o++){var f=(e||[])[o];c[o]=void 0===f?[u(t[o]),u(t[o+1],!0)]:[f,f]}return c}e.exports=function(t,e){var r,l,p,d,m=i.getFromId(t,e.xaxis),g=i.getFromId(t,e.yaxis),v=e.xcalendar,y=e.ycalendar,x=function(t){return m.r2c(t,0,v)},b=function(t){return g.r2c(t,0,y)},_=function(t){return m.c2r(t,0,v)},w=function(t){return g.c2r(t,0,y)},T=c(t,e,m,'x'),k=T[0],M=T[1],A=c(t,e,g,'y'),S=A[0],E=A[1],L=e._length;M.length>L&&M.splice(L,M.length-L),E.length>L&&E.splice(L,E.length-L);var C=[],P=[],I=[],z="string"===typeof k.size,O="string"===typeof S.size,D=[],R=[],F=z?D:k,B=O?R:S,N=0,j=[],U=[],V=e.histnorm,H=e.histfunc,q=-1!==V.indexOf('density'),G="max"===H||"min"===H?null:0,Y=a.count,W=o[V],X=!1,Z=[],J=[],K="z"in e?e.z:"marker"in e&&Array.isArray(e.marker.color)?e.marker.color:"";K&&"count"!==H&&(X="avg"===H,Y=a[H]);var Q=k.size,$=x(k.start),tt=x(k.end)+($-i.tickIncrement($,Q,!1,v))/1e6;for(r=$;r<tt;r=i.tickIncrement(r,Q,!1,v))P.push(G),D.push(r),X&&I.push(0);D.push(r);var et=P.length,rt=(r-$)/et,nt=_($+rt/2),it=S.size,at=b(S.start),ot=b(S.end)+(at-i.tickIncrement(at,it,!1,y))/1e6;for(r=at;r<ot;r=i.tickIncrement(r,it,!1,y)){C.push(P.slice()),R.push(r);var st=new Array(et);for(l=0;l<et;l++)st[l]=[];U.push(st),X&&j.push(I.slice())}R.push(r);var lt=C.length,ct=(r-at)/lt,ut=w(at+ct/2);q&&(Z=u(P.length,F,rt,z),J=u(C.length,B,ct,O)),z||"date"!==m.type||(F=f(x,F)),O||"date"!==g.type||(B=f(b,B));var ft=!0,ht=!0,pt=new Array(et),dt=new Array(lt),mt=1/0,gt=1/0,vt=1/0,yt=1/0;for(r=0;r<L;r++){var xt=M[r],bt=E[r];p=n.findBin(xt,F),d=n.findBin(bt,B),p>=0&&p<et&&d>=0&&d<lt&&(N+=Y(p,r,C[d],K,j[d]),U[d][p].push(r),ft&&(void 0===pt[p]?pt[p]=xt:pt[p]!==xt&&(ft=!1)),ht&&(void 0===dt[d]?dt[d]=bt:dt[d]!==bt&&(ht=!1)),mt=Math.min(mt,xt-D[p]),gt=Math.min(gt,D[p+1]-xt),vt=Math.min(vt,bt-R[d]),yt=Math.min(yt,R[d+1]-bt))}if(X)for(d=0;d<lt;d++)N+=s(C[d],j[d]);if(W)for(d=0;d<lt;d++)W(C[d],N,Z,J[d]);return{x:M,xRanges:h(D,ft&&pt,mt,gt,m,v),x0:nt,dx:rt,y:E,yRanges:h(R,ht&&dt,vt,yt,g,y),y0:ut,dy:ct,z:C,pts:U}}},{"../../lib":787,"../../plots/cartesian/axes":838,"../histogram/average":1089,"../histogram/bin_functions":1091,"../histogram/bin_label_vals":1092,"../histogram/calc":1093,"../histogram/norm_functions":1100}],1103:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./sample_defaults'),a=t('../heatmap/style_defaults'),o=t('../../components/colorscale/defaults'),s=t('./attributes');e.exports=function(t,e,r,l){function c(r,i){return n.coerce(t,e,s,r,i)}i(t,e,c,l),!1!==e.visible&&(a(t,e,c,l),o(t,e,l,c,{prefix:"",cLetter:"z"}),c('hovertemplate'),c('xhoverformat'),c('yhoverformat'))}},{"../../components/colorscale/defaults":660,"../../lib":787,"../heatmap/style_defaults":1082,"./attributes":1101,"./sample_defaults":1106}],1104:[function(t,e,r){"use strict";var n=t('../heatmap/hover'),i=t('../../plots/cartesian/axes').hoverLabelText;e.exports=function(t,e,r,a,o){var s=n(t,e,r,a,o);if(s){var l=(t=s[0]).index,c=l[0],u=l[1],f=t.cd[0],h=f.trace,p=f.xRanges[u],d=f.yRanges[c];return t.xLabel=i(t.xa,[p[0],p[1]],h.xhoverformat),t.yLabel=i(t.ya,[d[0],d[1]],h.yhoverformat),s}}},{"../../plots/cartesian/axes":838,"../heatmap/hover":1076}],1105:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),crossTraceDefaults:t('../histogram/cross_trace_defaults'),calc:t('../heatmap/calc'),plot:t('../heatmap/plot'),layerName:"heatmaplayer",colorbar:t('../heatmap/colorbar'),style:t('../heatmap/style'),hoverPoints:t('./hover'),eventData:t('../histogram/event_data'),moduleType:"trace",name:"histogram2d",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','2dMap','histogram',"showLegend"],meta:{}}},{"../../plots/cartesian":852,"../heatmap/calc":1070,"../heatmap/colorbar":1072,"../heatmap/plot":1080,"../heatmap/style":1081,"../histogram/cross_trace_defaults":1095,"../histogram/event_data":1097,"./attributes":1101,"./defaults":1103,"./hover":1104}],1106:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib');e.exports=function(t,e,r,a){var o=r('x'),s=r('y'),l=i.minRowLength(o),c=i.minRowLength(s);l&&c?(e._length=Math.min(l,c),n.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x","y"],a),(r('z')||r('marker.color'))&&r('histfunc'),r('histnorm'),r('autobinx'),r('autobiny')):e.visible=!1}},{"../../lib":787,"../../registry":915}],1107:[function(t,e,r){"use strict";var n=t('../histogram2d/attributes'),i=t('../contour/attributes'),a=t('../../components/colorscale/attributes'),o=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,s=t('../../lib/extend').extendFlat;e.exports=s({x:n.x,y:n.y,z:n.z,marker:n.marker,histnorm:n.histnorm,histfunc:n.histfunc,nbinsx:n.nbinsx,xbins:n.xbins,nbinsy:n.nbinsy,ybins:n.ybins,autobinx:n.autobinx,autobiny:n.autobiny,bingroup:n.bingroup,xbingroup:n.xbingroup,ybingroup:n.ybingroup,autocontour:i.autocontour,ncontours:i.ncontours,contours:i.contours,line:{color:i.line.color,width:s({},i.line.width,{dflt:.5}),dash:i.line.dash,smoothing:i.line.smoothing,editType:"plot"},xhoverformat:o('x'),yhoverformat:o('y'),zhoverformat:o('z',1),hovertemplate:n.hovertemplate},a('',{cLetter:"z",editTypeOverride:"calc"}))},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../contour/attributes":1012,"../histogram2d/attributes":1101}],1108:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../histogram2d/sample_defaults'),a=t('../contour/contours_defaults'),o=t('../contour/style_defaults'),s=t('./attributes');e.exports=function(t,e,r,l){function c(r,i){return n.coerce(t,e,s,r,i)}function u(r){return n.coerce2(t,e,s,r)}i(t,e,c,l),!1!==e.visible&&(a(t,e,c,u),o(t,e,c,l),c('hovertemplate'),c('xhoverformat'),c('yhoverformat'))}},{"../../lib":787,"../contour/contours_defaults":1019,"../contour/style_defaults":1033,"../histogram2d/sample_defaults":1106,"./attributes":1107}],1109:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),crossTraceDefaults:t('../histogram/cross_trace_defaults'),calc:t('../contour/calc'),plot:t('../contour/plot').plot,layerName:"contourlayer",style:t('../contour/style'),colorbar:t('../contour/colorbar'),hoverPoints:t('../contour/hover'),moduleType:"trace",name:"histogram2dcontour",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','2dMap','contour','histogram',"showLegend"],meta:{}}},{"../../plots/cartesian":852,"../contour/calc":1013,"../contour/colorbar":1015,"../contour/hover":1025,"../contour/plot":1030,"../contour/style":1032,"../histogram/cross_trace_defaults":1095,"./attributes":1107,"./defaults":1108}],1110:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../../components/colorscale/attributes'),o=t('../../plots/domain').attributes,s=t('../pie/attributes'),l=t('../sunburst/attributes'),c=t('../treemap/attributes'),u=t('../treemap/constants'),f=t('../../lib/extend').extendFlat;e.exports={labels:l.labels,parents:l.parents,values:l.values,branchvalues:l.branchvalues,count:l.count,level:l.level,maxdepth:l.maxdepth,tiling:{orientation:{valType:"enumerated",values:["v","h"],dflt:"h",editType:"plot"},flip:c.tiling.flip,pad:{valType:"number",min:0,dflt:0,editType:"plot"},editType:"calc"},marker:f({colors:l.marker.colors,line:l.marker.line,editType:"calc"},a('marker',{colorAttr:"colors",anim:!1})),leaf:l.leaf,pathbar:c.pathbar,text:s.text,textinfo:l.textinfo,texttemplate:i({editType:"plot"},{keys:u.eventDataKeys.concat(["label","value"])}),hovertext:s.hovertext,hoverinfo:l.hoverinfo,hovertemplate:n({},{keys:u.eventDataKeys}),textfont:s.textfont,insidetextfont:s.insidetextfont,outsidetextfont:c.outsidetextfont,textposition:c.textposition,sort:s.sort,root:l.root,domain:o({name:"icicle",trace:!0,editType:"calc"})}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/domain":866,"../../plots/template_attributes":910,"../pie/attributes":1176,"../sunburst/attributes":1314,"../treemap/attributes":1340,"../treemap/constants":1343}],1111:[function(t,e,r){"use strict";var n=t('../../plots/plots');r.name='icicle',r.plot=function(t,e,i,a){n.plotBasePlot(r.name,t,e,i,a)},r.clean=function(t,e,i,a){n.cleanBasePlot(r.name,t,e,i,a)}},{"../../plots/plots":901}],1112:[function(t,e,r){"use strict";var n=t('../sunburst/calc');r.calc=function(t,e){return n.calc(t,e)},r.crossTraceCalc=function(t){return n._runCrossTraceCalc('icicle',t)}},{"../sunburst/calc":1316}],1113:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../components/color'),o=t('../../plots/domain').defaults,s=t('../bar/defaults').handleText,l=t('../bar/constants').TEXTPAD,c=t('../../components/colorscale'),u=c.hasColorscale,f=c.handleDefaults;e.exports=function(t,e,r,c){function h(r,a){return n.coerce(t,e,i,r,a)}var p=h('labels'),d=h('parents');if(p&&p.length&&d&&d.length){var m=h('values');m&&m.length?h('branchvalues'):h('count'),h('level'),h('maxdepth'),h('tiling.orientation'),h('tiling.flip'),h('tiling.pad');var g=h('text');h('texttemplate'),e.texttemplate||h('textinfo',Array.isArray(g)?"text+label":"label"),h('hovertext'),h('hovertemplate');var v=h('pathbar.visible');s(t,e,c,h,'auto',{hasPathbar:v,moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!1,moduleHasCliponaxis:!1,moduleHasTextangle:!1,moduleHasInsideanchor:!1}),h('textposition'),h('marker.line.width')&&h('marker.line.color',c.paper_bgcolor),h('marker.colors');var y=e._hasColorscale=u(t,'marker','colors')||(t.marker||{}).coloraxis;y&&f(t,e,c,h,{prefix:"marker.",cLetter:"c"}),h('leaf.opacity',y?1:.7),e._hovered={marker:{line:{width:2,color:a.contrast(c.paper_bgcolor)}}},v&&(h('pathbar.thickness',e.pathbar.textfont.size+2*l),h('pathbar.side'),h('pathbar.edgeshape')),h('sort'),h('root.color'),o(e,c,h),e._length=null}else e.visible=!1}},{"../../components/color":650,"../../components/colorscale":662,"../../lib":787,"../../plots/domain":866,"../bar/constants":927,"../bar/defaults":929,"./attributes":1110}],1114:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../../lib/svg_text_utils'),s=t('./partition'),l=t('./style').styleOne,c=t('../treemap/constants'),u=t('../sunburst/helpers'),f=t('../sunburst/fx'),h=t('../sunburst/plot').formatSliceLabel,p=!1;e.exports=function(t,e,r,d,m){var g=m.width,v=m.height,y=m.viewX,x=m.viewY,b=m.pathSlice,_=m.toMoveInsideSlice,w=m.strTransform,T=m.hasTransition,k=m.handleSlicesExit,M=m.makeUpdateSliceInterpolator,A=m.makeUpdateTextInterpolator,S=m.prevEntry,E={},L=t._fullLayout,C=e[0].trace,P=-1!==C.textposition.indexOf('left'),I=-1!==C.textposition.indexOf('right'),z=-1!==C.textposition.indexOf('bottom'),O=s(r,[g,v],{flipX:C.tiling.flip.indexOf('x')>-1,flipY:C.tiling.flip.indexOf('y')>-1,orientation:C.tiling.orientation,pad:{inner:C.tiling.pad},maxDepth:C._maxDepth}).descendants(),D=1/0,R=-1/0;O.forEach((function(t){var e=t.depth;e>=C._maxDepth?(t.x0=t.x1=(t.x0+t.x1)/2,t.y0=t.y1=(t.y0+t.y1)/2):(D=Math.min(D,e),R=Math.max(R,e))})),d=d.data(O,u.getPtId),C._maxVisibleLayers=isFinite(R)?R-D+1:0,d.enter().append('g').classed('slice',!0),k(d,p,E,[g,v],b),d.order();var F=null;if(T&&S){var B=u.getPtId(S);d.each((function(t){null===F&&u.getPtId(t)===B&&(F={x0:t.x0,x1:t.x1,y0:t.y0,y1:t.y1})}))}var N=function(){return F||{x0:0,x1:g,y0:0,y1:v}},j=d;return T&&(j=j.transition().each('end',(function(){var e=n.select(this);u.setSliceCursor(e,t,{hideOnRoot:!0,hideOnLeaves:!1,isTransitioning:!1})}))),j.each((function(s){s._x0=y(s.x0),s._x1=y(s.x1),s._y0=x(s.y0),s._y1=x(s.y1),s._hoverX=y(s.x1-C.tiling.pad),s._hoverY=x(z?s.y1-C.tiling.pad/2:s.y0+C.tiling.pad/2);var d=n.select(this),m=i.ensureSingle(d,'path','surface',(function(t){t.style('pointer-events','all')}));T?m.transition().attrTween('d',(function(t){var e=M(t,p,N(),[g,v],{orientation:C.tiling.orientation,flipX:C.tiling.flip.indexOf('x')>-1,flipY:C.tiling.flip.indexOf('y')>-1});return function(t){return b(e(t))}})):m.attr('d',b),d.call(f,r,t,e,{styleOne:l,eventDataKeys:c.eventDataKeys,transitionTime:c.CLICK_TRANSITION_TIME,transitionEasing:c.CLICK_TRANSITION_EASING}).call(u.setSliceCursor,t,{isTransitioning:t._transitioning}),m.call(l,s,C,{hovered:!1}),s.x0===s.x1||s.y0===s.y1?s._text="":s._text=h(s,r,C,e,L)||"";var k=i.ensureSingle(d,'g','slicetext'),S=i.ensureSingle(k,'text','',(function(t){t.attr('data-notex',1)})),E=i.ensureUniformFontSize(t,u.determineTextFont(C,s,L.font));S.text(s._text||" ").classed('slicetext',!0).attr('text-anchor',I?"end":P?"start":"middle").call(a.font,E).call(o.convertToTspans,t),s.textBB=a.bBox(S.node()),s.transform=_(s,{fontSize:E.size}),s.transform.fontSize=E.size,T?S.transition().attrTween('transform',(function(t){var e=A(t,p,N(),[g,v]);return function(t){return w(e(t))}})):S.attr('transform',w(s))})),F}},{"../../components/drawing":672,"../../lib":787,"../../lib/svg_text_utils":813,"../sunburst/fx":1319,"../sunburst/helpers":1320,"../sunburst/plot":1324,"../treemap/constants":1343,"./partition":1118,"./style":1120,"@plotly/d3":58}],1115:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"icicle",basePlotModule:t('./base_plot'),categories:[],animatable:!0,attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults'),supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc').calc,crossTraceCalc:t('./calc').crossTraceCalc,plot:t('./plot'),style:t('./style').style,colorbar:t('../scatter/marker_colorbar'),meta:{}}},{"../scatter/marker_colorbar":1220,"./attributes":1110,"./base_plot":1111,"./calc":1112,"./defaults":1113,"./layout_attributes":1116,"./layout_defaults":1117,"./plot":1119,"./style":1120}],1116:[function(t,e,r){"use strict";e.exports={iciclecolorway:{valType:"colorlist",editType:"calc"},extendiciclecolors:{valType:"boolean",dflt:!0,editType:"calc"}}},{}],1117:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}r('iciclecolorway',e.colorway),r('extendiciclecolors')}},{"../../lib":787,"./layout_attributes":1116}],1118:[function(t,e,r){"use strict";var n=t('d3-hierarchy'),i=t('../treemap/flip_tree');e.exports=function(t,e,r){var a=r.flipX,o=r.flipY,s="h"===r.orientation,l=r.maxDepth,c=e[0],u=e[1];l&&(c=(t.height+1)*e[0]/Math.min(t.height+1,l),u=(t.height+1)*e[1]/Math.min(t.height+1,l));var f=n.partition().padding(r.pad.inner).size(s?[e[1],c]:[e[0],u])(t);return(s||a||o)&&i(f,e,{swapXY:s,flipX:a,flipY:o}),f}},{"../treemap/flip_tree":1348,"d3-hierarchy":167}],1119:[function(t,e,r){"use strict";var n=t('../treemap/draw'),i=t('./draw_descendants');e.exports=function(t,e,r,a){return n(t,e,r,a,{type:"icicle",drawDescendants:i})}},{"../treemap/draw":1345,"./draw_descendants":1114}],1120:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../../lib'),o=t('../bar/uniform_text').resizeText;function s(t){var e=t._fullLayout._iciclelayer.selectAll('.trace');o(t,e,'icicle'),e.each((function(t){var e=n.select(this),r=t[0].trace;e.style('opacity',r.opacity),e.selectAll('path.surface').each((function(t){n.select(this).call(l,t,r)}))}))}function l(t,e,r){var n=e.data.data,o=!e.children,s=n.i,l=a.castOption(r,s,'marker.line.color')||i.defaultLine,c=a.castOption(r,s,'marker.line.width')||0;t.style('stroke-width',c).call(i.fill,n.color).call(i.stroke,l).style('opacity',o?r.leaf.opacity:null)}e.exports={style:s,styleOne:l}},{"../../components/color":650,"../../lib":787,"../bar/uniform_text":941,"@plotly/d3":58}],1121:[function(t,e,r){"use strict";for(var n=t('../../plots/attributes'),i=t('../../plots/template_attributes').hovertemplateAttrs,a=t('../../lib/extend').extendFlat,o=t('./constants').colormodel,s=["rgb",'rgba','rgba256','hsl',"hsla"],l=[],c=[],u=0;u<s.length;u++){var f=o[s[u]];l.push("For the `"+s[u]+"` colormodel, it is ["+(f.zminDflt||f.min).join(', ')+"]."),c.push("For the `"+s[u]+"` colormodel, it is ["+(f.zmaxDflt||f.max).join(', ')+"].")}e.exports=a({source:{valType:"string",editType:"calc"},z:{valType:"data_array",editType:"calc"},colormodel:{valType:"enumerated",values:s,editType:"calc"},zsmooth:{valType:"enumerated",values:["fast",!1],dflt:!1,editType:"plot"},zmin:{valType:"info_array",items:[{valType:"number",editType:"calc"},{valType:"number",editType:"calc"},{valType:"number",editType:"calc"},{valType:"number",editType:"calc"}],editType:"calc"},zmax:{valType:"info_array",items:[{valType:"number",editType:"calc"},{valType:"number",editType:"calc"},{valType:"number",editType:"calc"},{valType:"number",editType:"calc"}],editType:"calc"},x0:{valType:"any",dflt:0,editType:"calc+clearAxisTypes"},y0:{valType:"any",dflt:0,editType:"calc+clearAxisTypes"},dx:{valType:"number",dflt:1,editType:"calc"},dy:{valType:"number",dflt:1,editType:"calc"},text:{valType:"data_array",editType:"plot"},hovertext:{valType:"data_array",editType:"plot"},hoverinfo:a({},n.hoverinfo,{flags:["x",'y','z','color','name',"text"],dflt:"x+y+z+text+name"}),hovertemplate:i({},{keys:["z",'color',"colormodel"]}),transforms:void 0})},{"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"./constants":1123}],1122:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./constants'),a=t('fast-isnumeric'),o=t('../../plots/cartesian/axes'),s=t('../../lib').maxRowLength,l=t('./helpers').getImageSize;function c(t,e,r,i){return function(a){return n.constrain((a-t)*e,r,i)}}function u(t,e){return function(r){return n.constrain(r,t,e)}}function f(t){var e=i.colormodel[t.colormodel],r=(e.colormodel||t.colormodel).length;t._sArray=[];for(var n=0;n<r;n++)e.min[n]!==t.zmin[n]||e.max[n]!==t.zmax[n]?t._sArray.push(c(t.zmin[n],(e.max[n]-e.min[n])/(t.zmax[n]-t.zmin[n]),e.min[n],e.max[n])):t._sArray.push(u(e.min[n],e.max[n]));return function(e){for(var n=e.slice(0,r),i=0;i<r;i++){var o=n[i];if(!a(o))return!1;n[i]=t._sArray[i](o)}return n}}e.exports=function(t,e){var r,n;if(e._hasZ)r=e.z.length,n=s(e.z);else if(e._hasSource){var i=l(e.source);r=i.height,n=i.width}var a,c=o.getFromId(t,e.xaxis||"x"),u=o.getFromId(t,e.yaxis||"y"),h=c.d2c(e.x0)-e.dx/2,p=u.d2c(e.y0)-e.dy/2,d=[h,h+n*e.dx],m=[p,p+r*e.dy];if(c&&"log"===c.type)for(a=0;a<n;a++)d.push(h+a*e.dx);if(u&&"log"===u.type)for(a=0;a<r;a++)m.push(p+a*e.dy);return e._extremes[c._id]=o.findExtremes(c,d),e._extremes[u._id]=o.findExtremes(u,m),e._scaler=f(e),[x0:h,y0:p,z:e.z,w:n,h:r]}},{"../../lib":787,"../../plots/cartesian/axes":838,"./constants":1123,"./helpers":1126,"fast-isnumeric":246}],1123:[function(t,e,r){"use strict";e.exports={colormodel:{rgb:{min:[0,0,0],max:[255,255,255],fmt:function(t){return t.slice(0,3)},suffix:["",'',""]},rgba:{min:[0,0,0,0],max:[255,255,255,1],fmt:function(t){return t.slice(0,4)},suffix:["",'','',""]},rgba256:{colormodel:"rgba",zminDflt:[0,0,0,0],zmaxDflt:[255,255,255,255],min:[0,0,0,0],max:[255,255,255,1],fmt:function(t){return t.slice(0,4)},suffix:["",'','',""]},hsl:{min:[0,0,0],max:[360,100,100],fmt:function(t){var e=t.slice(0,3);return e[1]=e[1]+"%",e[2]=e[2]+"%",e},suffix:["\xb0",'%',"%"]},hsla:{min:[0,0,0,0],max:[360,100,100,1],fmt:function(t){var e=t.slice(0,4);return e[1]=e[1]+"%",e[2]=e[2]+"%",e},suffix:["\xb0",'%','%',""]}},pixelatedStyle:["image-rendering: optimizeSpeed",'image-rendering: -moz-crisp-edges','image-rendering: -o-crisp-edges','image-rendering: -webkit-optimize-contrast','image-rendering: optimize-contrast','image-rendering: crisp-edges','image-rendering: pixelated',""].join('; ')}},{}],1124:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('./constants'),o=t('../../snapshot/helpers').IMAGE_URL_PREFIX;e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}r('source'),e.source&&!e.source.match(o)&&delete e.source,e._hasSource=!!e.source;var s,l=r('z');e._hasZ=!(void 0===l||!l.length||!l[0]||!l[0].length),e._hasZ||e._hasSource?(r('x0'),r('y0'),r('dx'),r('dy'),e._hasZ?(r('colormodel','rgb'),r('zmin',(s=a.colormodel[e.colormodel]).zminDflt||s.min),r('zmax',s.zmaxDflt||s.max)):e._hasSource&&(e.colormodel='rgba256',s=a.colormodel[e.colormodel],e.zmin=s.zminDflt,e.zmax=s.zmaxDflt),r('zsmooth'),r('text'),r('hovertext'),r('hovertemplate'),e._length=null):e.visible=!1}},{"../../lib":787,"../../snapshot/helpers":919,"./attributes":1121,"./constants":1123}],1125:[function(t,e,r){"use strict";e.exports=function(t,e){return"xVal"in e&&(t.x=e.xVal),"yVal"in e&&(t.y=e.yVal),e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),t.color=e.color,t.colormodel=e.trace.colormodel,t.z||(t.z=e.color),t}},{}],1126:[function(t,e,r){"use strict";var n=t('probe-image-size/sync'),i=t('../../snapshot/helpers').IMAGE_URL_PREFIX,a=t('buffer/').Buffer;r.getImageSize=function(t){var e=t.replace(i,''),r=new a(e,'base64');return n(r)}},{"../../snapshot/helpers":919,"buffer/":117,"probe-image-size/sync":513}],1127:[function(t,e,r){"use strict";var n=t('../../components/fx'),i=t('../../lib'),a=t('./constants');e.exports=function(t,e,r){var o=t.cd[0],s=o.trace,l=t.xa,c=t.ya;if(!(n.inbox(e-o.x0,e-(o.x0+o.w*s.dx),0)>0||n.inbox(r-o.y0,r-(o.y0+o.h*s.dy),0)>0)){var u,f=Math.floor((e-o.x0)/s.dx),h=Math.floor(Math.abs(r-o.y0)/s.dy);if(s._hasZ?u=o.z[h][f]:s._hasSource&&(u=s._canvas.el.getContext('2d').getImageData(f,h,1,1).data),u){var p,d=o.hi||s.hoverinfo;if(d){var m=d.split('+');-1!==m.indexOf('all')&&(m=["color"]),-1!==m.indexOf('color')&&(p=!0)}var g,v=a.colormodel[s.colormodel],y=v.colormodel||s.colormodel,x=y.length,b=s._scaler(u),_=v.suffix,w=[];(s.hovertemplate||p)&&(w.push("["+[b[0]+_[0],b[1]+_[1],b[2]+_[2]].join(', ')),4===x&&w.push(", "+b[3]+_[3]),w.push(']'),w=w.join(''),t.extraText=y.toUpperCase()+": "+w),Array.isArray(s.hovertext)&&Array.isArray(s.hovertext[h])?g=s.hovertext[h][f]:Array.isArray(s.text)&&Array.isArray(s.text[h])&&(g=s.text[h][f]);var T=c.c2p(o.y0+(h+.5)*s.dy),k=o.x0+(f+.5)*s.dx,M=o.y0+(h+.5)*s.dy,A="["+u.slice(0,s.colormodel.length).join(', ')+"]";return[i.extendFlat(t,{index:[h,f],x0:l.c2p(o.x0+f*s.dx),x1:l.c2p(o.x0+(f+1)*s.dx),y0:T,y1:T,color:b,xVal:k,xLabelVal:k,yVal:M,yLabelVal:M,zLabelVal:A,text:g,hovertemplateLabels:{zLabel:A,colorLabel:w,"color[0]Label":b[0]+_[0],"color[1]Label":b[1]+_[1],"color[2]Label":b[2]+_[2],"color[3]Label":b[3]+_[3]}})]}}}},{"../../components/fx":690,"../../lib":787,"./constants":1123}],1128:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot'),style:t('./style'),hoverPoints:t('./hover'),eventData:t('./event_data'),moduleType:"trace",name:"image",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','2dMap',"noSortingByValue"],animatable:!1,meta:{}}},{"../../plots/cartesian":852,"./attributes":1121,"./calc":1122,"./defaults":1124,"./event_data":1125,"./hover":1127,"./plot":1129,"./style":1130}],1129:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=i.strTranslate,o=t('../../constants/xmlns_namespaces'),s=t('./constants'),l=i.isIOS()||i.isSafari()||i.isIE();e.exports=function(t,e,r,c){var u=e.xaxis,f=e.yaxis,h=!(l||t._context._exportedPlot);i.makeTraceGroups(c,r,'im').each((function(e){var r=n.select(this),l=e[0],c=l.trace,p=("fast"===c.zsmooth||!1===c.zsmooth&&h)&&!c._hasZ&&c._hasSource&&"linear"===u.type&&"linear"===f.type;c._realImage=p;var d,m,g,v,y,x,b=l.z,_=l.x0,w=l.y0,T=l.w,k=l.h,M=c.dx,A=c.dy;for(x=0;void 0===d&&x<T;)d=u.c2p(_+x*M),x++;for(x=T;void 0===m&&x>0;)m=u.c2p(_+x*M),x--;for(x=0;void 0===v&&x<k;)v=f.c2p(w+x*A),x++;for(x=k;void 0===y&&x>0;)y=f.c2p(w+x*A),x--;if(m<d&&(g=m,m=d,d=g),y<v&&(g=v,v=y,y=g),!p){var S=.5;d=Math.max(-S*u._length,d),m=Math.min((1+S)*u._length,m),v=Math.max(-S*f._length,v),y=Math.min((1+S)*f._length,y)}var E=Math.round(m-d),L=Math.round(y-v);if(E<=0||L<=0)r.selectAll('image').data([]).exit().remove();else{var C=r.selectAll('image').data([e]);C.enter().append('svg:image').attr({xmlns:o.svg,preserveAspectRatio:"none"}),C.exit().remove();var P=!1===c.zsmooth?s.pixelatedStyle:"";if(p){var I=i.simpleMap(u.range,u.r2l),z=i.simpleMap(f.range,f.r2l),O=I[1]<I[0],D=z[1]>z[0];if(O||D){var R=d+E/2,F=v+L/2;P+="transform:"+a(R+"px",F+"px")+"scale('+(O?-1:1)+','+(D?-1:1)+')"+a(-R+"px",-F+"px")+";"}}C.attr('style',P);var B=new Promise((function(t){if(c._hasZ)t();else if(c._hasSource)if(c._canvas&&c._canvas.el.width===T&&c._canvas.el.height===k&&c._canvas.source===c.source)t();else{var e=document.createElement('canvas');e.width=T,e.height=k;var r=e.getContext('2d');c._image=c._image||new Image;var n=c._image;n.onload=function(){r.drawImage(n,0,0),c._canvas={el:e,source:c.source},t()},n.setAttribute('src',c.source)}})).then((function(){var t,e;if(c._hasZ)e=N((function(t,e){return b[e][t]})),t=e.toDataURL('image/png');else if(c._hasSource)if(p)t=c.source;else{var r=c._canvas.el.getContext('2d').getImageData(0,0,T,k).data;e=N((function(t,e){var n=4*(e*T+t);return[r[n],r[n+1],r[n+2],r[n+3]]})),t=e.toDataURL('image/png')}C.attr({"xlink:href":t,height:L,width:E,x:d,y:v})}));t._promises.push(B)}function N(t){var e=document.createElement('canvas');e.width=E,e.height=L;var r,n=e.getContext('2d'),a=function(t){return i.constrain(Math.round(u.c2p(_+t*M)-d),0,E)},o=function(t){return i.constrain(Math.round(f.c2p(w+t*A)-v),0,L)},h=s.colormodel[c.colormodel],p=h.colormodel||c.colormodel,m=h.fmt;for(x=0;x<l.w;x++){var g=a(x),y=a(x+1);if(y!==g&&!isNaN(y)&&!isNaN(g))for(var b=0;b<l.h;b++){var T=o(b),k=o(b+1);k===T||isNaN(k)||isNaN(T)||!t(x,b)||(r=c._scaler(t(x,b)),n.fillStyle=r?p+"('+m(r).join(',')+')":"rgba(0,0,0,0)",n.fillRect(g,T,y-g,k-T))}}return e}}))}},{"../../constants/xmlns_namespaces":764,"../../lib":787,"./constants":1123,"@plotly/d3":58}],1130:[function(t,e,r){"use strict";var n=t('@plotly/d3');e.exports=function(t){n.select(t).selectAll('.im image').style('opacity',(function(t){return t[0].trace.opacity}))}},{"@plotly/d3":58}],1131:[function(t,e,r){"use strict";var n=t('../../lib/extend').extendFlat,i=t('../../lib/extend').extendDeep,a=t('../../plot_api/edit_types').overrideAll,o=t('../../plots/font_attributes'),s=t('../../components/color/attributes'),l=t('../../plots/domain').attributes,c=t('../../plots/cartesian/layout_attributes'),u=t('../../plot_api/plot_template').templatedArray,f=t('../../constants/delta.js'),h=t('../../plots/cartesian/axis_format_attributes').descriptionOnlyNumbers,p=o({editType:"plot",colorEditType:"plot"}),d={color:{valType:"color",editType:"plot"},line:{color:{valType:"color",dflt:s.defaultLine,editType:"plot"},width:{valType:"number",min:0,dflt:0,editType:"plot"},editType:"calc"},thickness:{valType:"number",min:0,max:1,dflt:1,editType:"plot"},editType:"calc"},m={valType:"info_array",items:[{valType:"number",editType:"plot"},{valType:"number",editType:"plot"}],editType:"plot"},g=u('step',i({},d,{range:m}));e.exports={mode:{valType:"flaglist",editType:"calc",flags:["number",'delta',"gauge"],dflt:"number"},value:{valType:"number",editType:"calc",anim:!0},align:{valType:"enumerated",values:["left",'center',"right"],editType:"plot"},domain:l({name:"indicator",trace:!0,editType:"calc"}),title:{text:{valType:"string",editType:"plot"},align:{valType:"enumerated",values:["left",'center',"right"],editType:"plot"},font:n({},p,{}),editType:"plot"},number:{valueformat:{valType:"string",dflt:"",editType:"plot",description:h('value')},font:n({},p,{}),prefix:{valType:"string",dflt:"",editType:"plot"},suffix:{valType:"string",dflt:"",editType:"plot"},editType:"plot"},delta:{reference:{valType:"number",editType:"calc"},position:{valType:"enumerated",values:["top",'bottom','left',"right"],dflt:"bottom",editType:"plot"},relative:{valType:"boolean",editType:"plot",dflt:!1},valueformat:{valType:"string",editType:"plot",description:h('value')},increasing:{symbol:{valType:"string",dflt:f.INCREASING.SYMBOL,editType:"plot"},color:{valType:"color",dflt:f.INCREASING.COLOR,editType:"plot"},editType:"plot"},decreasing:{symbol:{valType:"string",dflt:f.DECREASING.SYMBOL,editType:"plot"},color:{valType:"color",dflt:f.DECREASING.COLOR,editType:"plot"},editType:"plot"},font:n({},p,{}),editType:"calc"},gauge:{shape:{valType:"enumerated",editType:"plot",dflt:"angular",values:["angular","bullet"]},bar:i({},d,{color:{dflt:"green"}}),bgcolor:{valType:"color",editType:"plot"},bordercolor:{valType:"color",dflt:s.defaultLine,editType:"plot"},borderwidth:{valType:"number",min:0,dflt:1,editType:"plot"},axis:a({range:m,visible:n({},c.visible,{dflt:!0}),tickmode:c.tickmode,nticks:c.nticks,tick0:c.tick0,dtick:c.dtick,tickvals:c.tickvals,ticktext:c.ticktext,ticks:n({},c.ticks,{dflt:"outside"}),ticklen:c.ticklen,tickwidth:c.tickwidth,tickcolor:c.tickcolor,showticklabels:c.showticklabels,tickfont:o({}),tickangle:c.tickangle,tickformat:c.tickformat,tickformatstops:c.tickformatstops,tickprefix:c.tickprefix,showtickprefix:c.showtickprefix,ticksuffix:c.ticksuffix,showticksuffix:c.showticksuffix,separatethousands:c.separatethousands,exponentformat:c.exponentformat,minexponent:c.minexponent,showexponent:c.showexponent,editType:"plot"},'plot'),steps:g,threshold:{line:{color:n({},d.line.color,{}),width:n({},d.line.width,{dflt:1}),editType:"plot"},thickness:n({},d.thickness,{dflt:.85}),value:{valType:"number",editType:"calc",dflt:!1},editType:"plot"},editType:"plot"}}},{"../../components/color/attributes":649,"../../constants/delta.js":757,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plot_api/plot_template":827,"../../plots/cartesian/axis_format_attributes":841,"../../plots/cartesian/layout_attributes":853,"../../plots/domain":866,"../../plots/font_attributes":867}],1132:[function(t,e,r){"use strict";var n=t('../../plots/plots');r.name='indicator',r.plot=function(t,e,i,a){n.plotBasePlot(r.name,t,e,i,a)},r.clean=function(t,e,i,a){n.cleanBasePlot(r.name,t,e,i,a)}},{"../../plots/plots":901}],1133:[function(t,e,r){"use strict";function n(t,e){var r=[],n=e.value;"number"!==typeof e._lastValue&&(e._lastValue=e.value);var i=e._lastValue,a=i;return e._hasDelta&&"number"===typeof e.delta.reference&&(a=e.delta.reference),r[0]={y:n,lastY:i,delta:n-a,relativeDelta:(n-a)/a},r}e.exports={calc:n}},{}],1134:[function(t,e,r){"use strict";e.exports={defaultNumberFontSize:80,bulletNumberDomainSize:.25,bulletPadding:.025,innerRadius:.75,valueThickness:.5,titlePadding:5,horizontalPadding:10}},{}],1135:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../plots/domain').defaults,o=t('../../plot_api/plot_template'),s=t('../../plots/array_container_defaults'),l=t('./constants.js'),c=t('../../plots/cartesian/tick_value_defaults'),u=t('../../plots/cartesian/tick_mark_defaults'),f=t('../../plots/cartesian/tick_label_defaults');function h(t,e,r,h){function d(r,a){return n.coerce(t,e,i,r,a)}a(e,h,d),d('mode'),e._hasNumber=-1!==e.mode.indexOf('number'),e._hasDelta=-1!==e.mode.indexOf('delta'),e._hasGauge=-1!==e.mode.indexOf('gauge');var m=d('value');e._range=[0,"number"===typeof m?1.5*m:1];var g,v,y,x,b,_,w=new Array(2);function T(t,e){return n.coerce(y,x,i.gauge,t,e)}function k(t,e){return n.coerce(b,_,i.gauge.axis,t,e)}if(e._hasNumber&&(d('number.valueformat'),d('number.font.color',h.font.color),d('number.font.family',h.font.family),d('number.font.size'),void 0===e.number.font.size&&(e.number.font.size=l.defaultNumberFontSize,w[0]=!0),d('number.prefix'),d('number.suffix'),g=e.number.font.size),e._hasDelta&&(d('delta.font.color',h.font.color),d('delta.font.family',h.font.family),d('delta.font.size'),void 0===e.delta.font.size&&(e.delta.font.size=(e._hasNumber?.5:1)*(g||l.defaultNumberFontSize),w[1]=!0),d('delta.reference',e.value),d('delta.relative'),d('delta.valueformat',e.delta.relative?"2%":""),d('delta.increasing.symbol'),d('delta.increasing.color'),d('delta.decreasing.symbol'),d('delta.decreasing.color'),d('delta.position'),v=e.delta.font.size),e._scaleNumbers=(!e._hasNumber||w[0])&&(!e._hasDelta||w[1])||!1,d('title.font.color',h.font.color),d('title.font.family',h.font.family),d('title.font.size',.25*(g||v||l.defaultNumberFontSize)),d('title.text'),e._hasGauge)[(y=t.gauge)||(y={]),x=o.newContainer(e,'gauge'),T('shape'),(e._isBullet="bullet"===e.gauge.shape)||d('title.align','center'),(e._isAngular="angular"===e.gauge.shape)||d('align','center'),T('bgcolor',h.paper_bgcolor),T('borderwidth'),T('bordercolor'),T('bar.color'),T('bar.line.color'),T('bar.line.width'),T('bar.thickness',l.valueThickness*("bullet"===e.gauge.shape?.5:1)),s(y,x,{name:"steps",handleItemDefaults:p}),T('threshold.value'),T('threshold.thickness'),T('threshold.line.width'),T('threshold.line.color'),b={},y&&(b=y.axis||{}),_=o.newContainer(x,'axis'),k('visible'),e._range=k('range',e._range);var M={outerTicks:!0};c(b,_,k,'linear'),f(b,_,k,'linear',M),u(b,_,k,M)}else d('title.align','center'),d('align','center'),e._isAngular=e._isBullet=!1;e._length=null}function p(t,e){function r(r,a){return n.coerce(t,e,i.gauge.steps,r,a)}r('color'),r('line.color'),r('line.width'),r('range'),r('thickness')}e.exports={supplyDefaults:h}},{"../../lib":787,"../../plot_api/plot_template":827,"../../plots/array_container_defaults":833,"../../plots/cartesian/tick_label_defaults":860,"../../plots/cartesian/tick_mark_defaults":861,"../../plots/cartesian/tick_value_defaults":862,"../../plots/domain":866,"./attributes":1131,"./constants.js":1134}],1136:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"indicator",basePlotModule:t('./base_plot'),categories:["svg",'noOpacity',"noHover"],animatable:!0,attributes:t('./attributes'),supplyDefaults:t('./defaults').supplyDefaults,calc:t('./calc').calc,plot:t('./plot'),meta:{}}},{"./attributes":1131,"./base_plot":1132,"./calc":1133,"./defaults":1135,"./plot":1137}],1137:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-interpolate').interpolate,a=t('d3-interpolate').interpolateNumber,o=t('../../lib'),s=o.strScale,l=o.strTranslate,c=o.rad2deg,u=t('../../constants/alignment').MID_SHIFT,f=t('../../components/drawing'),h=t('./constants'),p=t('../../lib/svg_text_utils'),d=t('../../plots/cartesian/axes'),m=t('../../plots/cartesian/axis_defaults'),g=t('../../plots/cartesian/position_defaults'),v=t('../../plots/cartesian/layout_attributes'),y=t('../../components/color'),x={left:"start",center:"middle",right:"end"},b={left:0,center:.5,right:1},_=/[yzafpn\xb5mkMGTPEZY]/;function w(t){return t&&t.duration>0}function T(t,e,r,n){var i,a,o,s,c,u=r[0].trace,f=n.gauge,p=n.layer,m=n.gaugeBg,g=n.gaugeOutline,v=n.size,x=u.domain,b=n.transitionOpts,_=n.onComplete;f.enter().append('g').classed('bullet',!0),f.attr('transform',l(v.l,v.t)),p.enter().append('g').classed('bulletaxis',!0).classed('crisp',!0),p.selectAll('g.xbulletaxistick,path,text').remove();var T=v.h,k=u.gauge.bar.thickness*T,M=x.x[0],S=x.x[0]+(x.x[1]-x.x[0])*(u._hasNumber||u._hasDelta?1-h.bulletNumberDomainSize:1);function L(t){t.attr('width',(function(t){return Math.max(0,i.c2p(t.range[1])-i.c2p(t.range[0]))})).attr('x',(function(t){return i.c2p(t.range[0])})).attr('y',(function(t){return.5*(1-t.thickness)*T})).attr('height',(function(t){return t.thickness*T}))}(i=E(t,u.gauge.axis))._id='xbulletaxis',i.domain=[M,S],i.setScale(),a=d.calcTicks(i),o=d.makeTransTickFn(i),s=d.getTickSigns(i)[2],c=v.t+v.h,i.visible&&(d.drawTicks(t,i,{vals:"inside"===i.ticks?d.clipEnds(i,a):a,layer:p,path:d.makeTickPath(i,c,s),transFn:o}),d.drawLabels(t,i,{vals:a,layer:p,transFn:o,labelFns:d.makeLabelFns(i,c)}));var C=[m].concat(u.gauge.steps),P=f.selectAll('g.bg-bullet').data(C);P.enter().append('g').classed('bg-bullet',!0).append('rect'),P.select('rect').call(L).call(A),P.exit().remove();var I=f.selectAll('g.value-bullet').data([u.gauge.bar]);I.enter().append('g').classed('value-bullet',!0).append('rect'),I.select('rect').attr('height',k).attr('y',(T-k)/2).call(A),w(b)?I.select('rect').transition().duration(b.duration).ease(b.easing).each('end',(function()[_&&_()])).each('interrupt',(function()[_&&_()])).attr('width',Math.max(0,i.c2p(Math.min(u.gauge.axis.range[1],r[0].y)))):I.select('rect').attr('width',"number"===typeof r[0].y?Math.max(0,i.c2p(Math.min(u.gauge.axis.range[1],r[0].y))):0),I.exit().remove();var z=r.filter((function(){return u.gauge.threshold.value||0===u.gauge.threshold.value})),O=f.selectAll('g.threshold-bullet').data(z);O.enter().append('g').classed('threshold-bullet',!0).append('line'),O.select('line').attr('x1',i.c2p(u.gauge.threshold.value)).attr('x2',i.c2p(u.gauge.threshold.value)).attr('y1',(1-u.gauge.threshold.thickness)/2*T).attr('y2',(1-(1-u.gauge.threshold.thickness)/2)*T).call(y.stroke,u.gauge.threshold.line.color).style('stroke-width',u.gauge.threshold.line.width),O.exit().remove();var D=f.selectAll('g.gauge-outline').data([g]);D.enter().append('g').classed('gauge-outline',!0).append('rect'),D.select('rect').call(L).call(A),D.exit().remove()}function k(t,e,r,i){var a,o,s,f,h=r[0].trace,p=i.size,m=i.radius,g=i.innerRadius,v=i.gaugeBg,y=i.gaugeOutline,x=[p.l+p.w/2,p.t+p.h/2+m/2],b=i.gauge,_=i.layer,T=i.transitionOpts,k=i.onComplete,M=Math.PI/2;function L(t){var e=h.gauge.axis.range[0],r=(t-e)/(h.gauge.axis.range[1]-e)*Math.PI-M;return r<-M?-M:r>M?M:r}function C(t){return n.svg.arc().innerRadius((g+m)/2-t/2*(m-g)).outerRadius((g+m)/2+t/2*(m-g)).startAngle(-M)}function P(t){t.attr('d',(function(t){return C(t.thickness).startAngle(L(t.range[0])).endAngle(L(t.range[1]))()}))}b.enter().append('g').classed('angular',!0),b.attr('transform',l(x[0],x[1])),_.enter().append('g').classed('angularaxis',!0).classed('crisp',!0),_.selectAll('g.xangularaxistick,path,text').remove(),(a=E(t,h.gauge.axis)).type='linear',a.range=h.gauge.axis.range,a._id='xangularaxis',a.ticklabeloverflow='allow',a.setScale();var I=function(t){return(a.range[0]-t.x)/(a.range[1]-a.range[0])*Math.PI+Math.PI},z={},O=d.makeLabelFns(a,0).labelStandoff;z.xFn=function(t){var e=I(t);return Math.cos(e)*O},z.yFn=function(t){var e=I(t),r=Math.sin(e)>0?.2:1;return-Math.sin(e)*(O+t.fontSize*r)+Math.abs(Math.cos(e))*(t.fontSize*u)},z.anchorFn=function(t){var e=I(t),r=Math.cos(e);return Math.abs(r)<.1?"middle":r>0?"start":"end"},z.heightFn=function(t,e,r){var n=I(t);return-.5*(1+Math.sin(n))*r};var D=function(t){return l(x[0]+m*Math.cos(t),x[1]-m*Math.sin(t))};s=function(t){return D(I(t))};var R=function(t){var e=I(t);return D(e)+"rotate('+-c(e)+')"};if(o=d.calcTicks(a),f=d.getTickSigns(a)[2],a.visible){f="inside"===a.ticks?-1:1;var F=(a.linewidth||1)/2;d.drawTicks(t,a,{vals:o,layer:_,path:"M"+f*F+",0h"+f*a.ticklen,transFn:R}),d.drawLabels(t,a,{vals:o,layer:_,transFn:s,labelFns:z})}var B=[v].concat(h.gauge.steps),N=b.selectAll('g.bg-arc').data(B);N.enter().append('g').classed('bg-arc',!0).append('path'),N.select('path').call(P).call(A),N.exit().remove();var j=C(h.gauge.bar.thickness),U=b.selectAll('g.value-arc').data([h.gauge.bar]);U.enter().append('g').classed('value-arc',!0).append('path');var V=U.select('path');w(T)?(V.transition().duration(T.duration).ease(T.easing).each('end',(function()[k&&k()])).each('interrupt',(function()[k&&k()])).attrTween('d',S(j,L(r[0].lastY),L(r[0].y))),h._lastValue=r[0].y):V.attr('d',"number"===typeof r[0].y?j.endAngle(L(r[0].y)):"M0,0Z"),V.call(A),U.exit().remove(),B=[];var H=h.gauge.threshold.value;(H||0===H)&&B.push({range:[H,H],color:h.gauge.threshold.color,line:{color:h.gauge.threshold.line.color,width:h.gauge.threshold.line.width},thickness:h.gauge.threshold.thickness});var q=b.selectAll('g.threshold-arc').data(B);q.enter().append('g').classed('threshold-arc',!0).append('path'),q.select('path').call(P).call(A),q.exit().remove();var G=b.selectAll('g.gauge-outline').data([y]);G.enter().append('g').classed('gauge-outline',!0).append('path'),G.select('path').call(P).call(A),G.exit().remove()}function M(t,e,r,i){var c,u,h,m=r[0].trace,g=i.numbersX,v=i.numbersY,T=m.align||"center",k=x[T],M=i.transitionOpts,A=i.onComplete,S=o.ensureSingle(e,'g','numbers'),L=[];m._hasNumber&&L.push('number'),m._hasDelta&&(L.push('delta'),"left"===m.delta.position&&L.reverse());var C=S.selectAll('text').data(L);function z(e,r,n,i){if(!e.match('s')||n>=0===i>=0||r(n).slice(-1).match(_)||r(i).slice(-1).match(_))return r;var a=e.slice().replace('s','f').replace(/\d+/,(function(t){return parseInt(t)-1})),o=E(t,{tickformat:a});return function(t){return Math.abs(t)<1?d.tickText(o,t).text:r(t)}}function O(){var e=E(t,{tickformat:m.number.valueformat},m._range);e.setScale(),d.prepTicks(e);var i=function(t){return d.tickText(e,t).text},o=m.number.suffix,s=m.number.prefix,l=S.select('text.number');function u(){var e="number"===typeof r[0].y?s+i(r[0].y)+o:"-";l.text(e).call(f.font,m.number.font).call(p.convertToTspans,t)}return w(M)?l.transition().duration(M.duration).ease(M.easing).each('end',(function(){u(),A&&A()})).each('interrupt',(function(){u(),A&&A()})).attrTween('text',(function(){var t=n.select(this),e=a(r[0].lastY,r[0].y);m._lastValue=r[0].y;var l=z(m.number.valueformat,i,r[0].lastY,r[0].y);return function(r){t.text(s+l(e(r))+o)}})):u(),c=P(s+i(r[0].y)+o,m.number.font,k,t),l}function D(){var e=E(t,{tickformat:m.delta.valueformat},m._range);e.setScale(),d.prepTicks(e);var i=function(t){return d.tickText(e,t).text},o=function(t){return m.delta.relative?t.relativeDelta:t.delta},s=function(t,e){return 0===t||"number"!==typeof t||isNaN(t)?"-":(t>0?m.delta.increasing.symbol:m.delta.decreasing.symbol)+e(t)},l=function(t){return t.delta>=0?m.delta.increasing.color:m.delta.decreasing.color};void 0===m._deltaLastValue&&(m._deltaLastValue=o(r[0]));var c=S.select('text.delta');function h(){c.text(s(o(r[0]),i)).call(y.fill,l(r[0])).call(p.convertToTspans,t)}return c.call(f.font,m.delta.font).call(y.fill,l({delta:m._deltaLastValue})),w(M)?c.transition().duration(M.duration).ease(M.easing).tween('text',(function(){var t=n.select(this),e=o(r[0]),c=m._deltaLastValue,u=z(m.delta.valueformat,i,c,e),f=a(c,e);return m._deltaLastValue=e,function(e){t.text(s(f(e),u)),t.call(y.fill,l({delta:f(e)}))}})).each('end',(function(){h(),A&&A()})).each('interrupt',(function(){h(),A&&A()})):h(),u=P(s(o(r[0]),i),m.delta.font,k,t),c}C.enter().append('text'),C.attr('text-anchor',(function(){return k})).attr('class',(function(t){return t})).attr('x',null).attr('y',null).attr('dx',null).attr('dy',null),C.exit().remove();var R,F=m.mode+m.align;if(m._hasDelta&&(R=D(),F+=m.delta.position+m.delta.font.size+m.delta.font.family+m.delta.valueformat,F+=m.delta.increasing.symbol+m.delta.decreasing.symbol,h=u),m._hasNumber&&(O(),F+=m.number.font.size+m.number.font.family+m.number.valueformat+m.number.suffix+m.number.prefix,h=c),m._hasDelta&&m._hasNumber){var B,N,j=[(c.left+c.right)/2,(c.top+c.bottom)/2],U=[(u.left+u.right)/2,(u.top+u.bottom)/2],V=.75*m.delta.font.size;"left"===m.delta.position&&(B=I(m,'deltaPos',0,-1*(c.width*b[m.align]+u.width*(1-b[m.align])+V),F,Math.min),N=j[1]-U[1],h={width:c.width+u.width+V,height:Math.max(c.height,u.height),left:u.left+B,right:c.right,top:Math.min(c.top,u.top+N),bottom:Math.max(c.bottom,u.bottom+N)}),"right"===m.delta.position&&(B=I(m,'deltaPos',0,c.width*(1-b[m.align])+u.width*b[m.align]+V,F,Math.max),N=j[1]-U[1],h={width:c.width+u.width+V,height:Math.max(c.height,u.height),left:c.left,right:u.right+B,top:Math.min(c.top,u.top+N),bottom:Math.max(c.bottom,u.bottom+N)}),"bottom"===m.delta.position&&(B=null,N=u.height,h={width:Math.max(c.width,u.width),height:c.height+u.height,left:Math.min(c.left,u.left),right:Math.max(c.right,u.right),top:c.bottom-c.height,bottom:c.bottom+u.height}),"top"===m.delta.position&&(B=null,N=c.top,h={width:Math.max(c.width,u.width),height:c.height+u.height,left:Math.min(c.left,u.left),right:Math.max(c.right,u.right),top:c.bottom-c.height-u.height,bottom:c.bottom}),R.attr({dx:B,dy:N})}(m._hasNumber||m._hasDelta)&&S.attr('transform',(function(){var t=i.numbersScaler(h);F+=t[2];var e,r=I(m,'numbersScale',1,t[0],F,Math.min);m._scaleNumbers||(r=1),e=m._isAngular?v-r*h.bottom:v-r*(h.top+h.bottom)/2,m._numbersTop=r*h.top+e;var n=h[T];"center"===T&&(n=(h.left+h.right)/2);var a=g-r*n;return a=I(m,'numbersTranslate',0,a,F,Math.max),l(a,e)+s(r)}))}function A(t){t.each((function(t){y.stroke(n.select(this),t.line.color)})).each((function(t){y.fill(n.select(this),t.color)})).style('stroke-width',(function(t){return t.line.width}))}function S(t,e,r){return function(){var n=i(e,r);return function(e){return t.endAngle(n(e))()}}}function E(t,e,r){var n=t._fullLayout,i=o.extendFlat({type:"linear",ticks:"outside",range:r,showline:!0},e),a={type:"linear",_id:"x"+e._id},s={letter:"x",font:n.font,noHover:!0,noTickson:!0};function l(t,e){return o.coerce(i,a,v,t,e)}return m(i,a,l,s,n),g(i,a,l,s),a}function L(t,e,r){return[Math.min(e/t.width,r/t.height),t,e+"x"+r]}function C(t,e){return[e/Math.sqrt(t.width/2*(t.width/2)+t.height*t.height),t,e]}function P(t,e,r,i){var a=document.createElementNS('http://www.w3.org/2000/svg','text'),o=n.select(a);return o.text(t).attr('x',0).attr('y',0).attr('text-anchor',r).attr('data-unformatted',t).call(p.convertToTspans,i).call(f.font,e),f.bBox(o.node())}function I(t,e,r,n,i,a){var s="_cache"+e;t[s]&&t[s].key===i||(t[s]={key:i,value:r});var l=o.aggNums(a,null,[t[s].value,n],2);return t[s].value=l,l}e.exports=function(t,e,r,i){var a,s=t._fullLayout;w(r)&&i&&(a=i()),o.makeTraceGroups(s._indicatorlayer,e,'trace').each((function(e){var i,o,c,u,d,m=e[0].trace,g=n.select(this),v=m._hasGauge,y=m._isAngular,_=m._isBullet,w=m.domain,A={w:s._size.w*(w.x[1]-w.x[0]),h:s._size.h*(w.y[1]-w.y[0]),l:s._size.l+s._size.w*w.x[0],r:s._size.r+s._size.w*(1-w.x[1]),t:s._size.t+s._size.h*(1-w.y[1]),b:s._size.b+s._size.h*w.y[0]},S=A.l+A.w/2,E=A.t+A.h/2,P=Math.min(A.w/2,A.h),I=h.innerRadius*P,z=m.align||"center";if(o=E,v){if(y&&(i=S,o=E+P/2,c=function(t){return C(t,.9*I)}),_){var O=h.bulletPadding,D=1-h.bulletNumberDomainSize+O;i=A.l+(D+(1-D)*b[z])*A.w,c=function(t){return L(t,(h.bulletNumberDomainSize-O)*A.w,A.h)}}}else i=A.l+b[z]*A.w,c=function(t){return L(t,A.w,A.h)};M(t,g,e,{numbersX:i,numbersY:o,numbersScaler:c,transitionOpts:r,onComplete:a}),v&&(u={range:m.gauge.axis.range,color:m.gauge.bgcolor,line:{color:m.gauge.bordercolor,width:0},thickness:1},d={range:m.gauge.axis.range,color:"rgba(0, 0, 0, 0)",line:{color:m.gauge.bordercolor,width:m.gauge.borderwidth},thickness:1});var R=g.selectAll('g.angular').data(y?e:[]);R.exit().remove();var F=g.selectAll('g.angularaxis').data(y?e:[]);F.exit().remove(),y&&k(t,g,e,{radius:P,innerRadius:I,gauge:R,layer:F,size:A,gaugeBg:u,gaugeOutline:d,transitionOpts:r,onComplete:a});var B=g.selectAll('g.bullet').data(_?e:[]);B.exit().remove();var N=g.selectAll('g.bulletaxis').data(_?e:[]);N.exit().remove(),_&&T(t,g,e,{gauge:B,layer:N,size:A,gaugeBg:u,gaugeOutline:d,transitionOpts:r,onComplete:a});var j=g.selectAll('text.title').data(e);j.exit().remove(),j.enter().append('text').classed('title',!0),j.attr('text-anchor',(function(){return _?x.right:x[m.title.align]})).text(m.title.text).call(f.font,m.title.font).call(p.convertToTspans,t),j.attr('transform',(function(){var t,e=A.l+A.w*b[m.title.align],r=h.titlePadding,n=f.bBox(j.node());return v?(y&&(t=m.gauge.axis.visible?f.bBox(F.node()).top-r-n.bottom:A.t+A.h/2-P/2-n.bottom-r),_&&(t=o-(n.top+n.bottom)/2,e=A.l-h.bulletPadding*A.w)):t=m._numbersTop-r-n.bottom,l(e,t)}))}))}},{"../../components/color":650,"../../components/drawing":672,"../../constants/alignment":755,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/cartesian/axes":838,"../../plots/cartesian/axis_defaults":840,"../../plots/cartesian/layout_attributes":853,"../../plots/cartesian/position_defaults":856,"./constants":1134,"@plotly/d3":58,"d3-interpolate":168}],1138:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../mesh3d/attributes'),s=t('../../plots/attributes'),l=t('../../lib/extend').extendFlat,c=t('../../plot_api/edit_types').overrideAll;function u(t){return{show:{valType:"boolean",dflt:!1},locations:{valType:"data_array",dflt:[]},fill:{valType:"number",min:0,max:1,dflt:1}}}function f(t){return{show:{valType:"boolean",dflt:!0},fill:{valType:"number",min:0,max:1,dflt:1}}}var h=e.exports=c(l({x:{valType:"data_array"},y:{valType:"data_array"},z:{valType:"data_array"},value:{valType:"data_array"},isomin:{valType:"number"},isomax:{valType:"number"},surface:{show:{valType:"boolean",dflt:!0},count:{valType:"integer",dflt:2,min:1},fill:{valType:"number",min:0,max:1,dflt:1},pattern:{valType:"flaglist",flags:["A",'B','C','D',"E"],extras:["all",'odd',"even"],dflt:"all"}},spaceframe:{show:{valType:"boolean",dflt:!1},fill:{valType:"number",min:0,max:1,dflt:.15}},slices:{x:u('x'),y:u('y'),z:u('z')},caps:{x:f('x'),y:f('y'),z:f('z')},text:{valType:"string",dflt:"",arrayOk:!0},hovertext:{valType:"string",dflt:"",arrayOk:!0},hovertemplate:a(),xhoverformat:i('x'),yhoverformat:i('y'),zhoverformat:i('z'),valuehoverformat:i('value',1),showlegend:l({},s.showlegend,{dflt:!1})},n('',{colorAttr:"`value`",showScaleDflt:!0,editTypeOverride:"calc"}),{opacity:o.opacity,lightposition:o.lightposition,lighting:o.lighting,flatshading:o.flatshading,contour:o.contour,hoverinfo:l({},s.hoverinfo)}),'calc','nested');h.flatshading.dflt=!0,h.lighting.facenormalsepsilon.dflt=0,h.x.editType=h.y.editType=h.z.editType=h.value.editType='calc+clearAxisTypes',h.transforms=void 0},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../mesh3d/attributes":1143}],1139:[function(t,e,r){"use strict";var n=t('../../components/colorscale/calc'),i=t('../streamtube/calc').processGrid,a=t('../streamtube/calc').filter;e.exports=function(t,e){e._len=Math.min(e.x.length,e.y.length,e.z.length,e.value.length),e._x=a(e.x,e._len),e._y=a(e.y,e._len),e._z=a(e.z,e._len),e._value=a(e.value,e._len);var r=i(e);e._gridFill=r.fill,e._Xs=r.Xs,e._Ys=r.Ys,e._Zs=r.Zs,e._len=r.len;for(var o=1/0,s=-1/0,l=0;l<e._len;l++){var c=e._value[l];o=Math.min(o,c),s=Math.max(s,c)}e._minValues=o,e._maxValues=s,e._vMin=void 0===e.isomin||null===e.isomin?o:e.isomin,e._vMax=void 0===e.isomax||null===e.isomin?s:e.isomax,n(t,e,{vals:[e._vMin,e._vMax],containerStr:"",cLetter:"c"})}},{"../../components/colorscale/calc":658,"../streamtube/calc":1310}],1140:[function(t,e,r){"use strict";var n=t('gl-mesh3d'),i=t('../../lib/gl_format_color').parseColorScale,a=t('../../lib/str2rgbarray'),o=t('../../components/colorscale').extractOpts,s=t('../../plots/gl3d/zip3'),l=function(t,e){for(var r=e.length-1;r>0;r--){var n=Math.min(e[r],e[r-1]),i=Math.max(e[r],e[r-1]);if(i>n&&n<t&&t<=i)return{id:r,distRatio:(i-t)/(i-n)}}return{id:0,distRatio:0}};function c(t,e,r){this.scene=t,this.uid=r,this.mesh=e,this.name='',this.data=null,this.showContour=!1}var u=c.prototype;u.handlePick=function(t){if(t.object===this.mesh){var e=t.data.index,r=this.data._meshX[e],n=this.data._meshY[e],i=this.data._meshZ[e],a=this.data._Ys.length,o=this.data._Zs.length,s=l(r,this.data._Xs).id,c=l(n,this.data._Ys).id,u=l(i,this.data._Zs).id,f=t.index=u+o*c+o*a*s;t.traceCoordinate=[this.data._meshX[f],this.data._meshY[f],this.data._meshZ[f],this.data._value[f]];var h=this.data.hovertext||this.data.text;return Array.isArray(h)&&void 0!==h[f]?t.textLabel=h[f]:h&&(t.textLabel=h),!0}},u.update=function(t){var e=this.scene,r=e.fullSceneLayout;function n(t,e,r,n){return e.map((function(e){return t.d2l(e,0,n)*r}))}this.data=h(t);var l={positions:s(n(r.xaxis,t._meshX,e.dataScale[0],t.xcalendar),n(r.yaxis,t._meshY,e.dataScale[1],t.ycalendar),n(r.zaxis,t._meshZ,e.dataScale[2],t.zcalendar)),cells:s(t._meshI,t._meshJ,t._meshK),lightPosition:[t.lightposition.x,t.lightposition.y,t.lightposition.z],ambient:t.lighting.ambient,diffuse:t.lighting.diffuse,specular:t.lighting.specular,roughness:t.lighting.roughness,fresnel:t.lighting.fresnel,vertexNormalsEpsilon:t.lighting.vertexnormalsepsilon,faceNormalsEpsilon:t.lighting.facenormalsepsilon,opacity:t.opacity,contourEnable:t.contour.show,contourColor:a(t.contour.color).slice(0,3),contourWidth:t.contour.width,useFacetNormals:t.flatshading},c=o(t);l.vertexIntensity=t._meshIntensity,l.vertexIntensityBounds=[c.min,c.max],l.colormap=i(t),this.mesh.update(l)},u.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()};var f=["xyz",'xzy','yxz','yzx','zxy',"zyx"];function h(t){t._meshI=[],t._meshJ=[],t._meshK=[];var e,r,n,i,a,o,s,c=t.surface.show,u=t.spaceframe.show,h=t.surface.fill,p=t.spaceframe.fill,d=!1,m=!1,g=0,v=t._Xs,y=t._Ys,x=t._Zs,b=v.length,_=y.length,w=x.length,T=f.indexOf(t._gridFill.replace(/-/g,'').replace(/\+/g,'')),k=function(t,e,r){switch(T){case 5:return r+w*e+w*_*t;case 4:return r+w*t+w*b*e;case 3:return e+_*r+_*w*t;case 2:return e+_*t+_*b*r;case 1:return t+b*r+b*w*e;default:return t+b*e+b*_*r}},M=t._minValues,A=t._maxValues,S=t._vMin,E=t._vMax;function L(t,e,s){for(var l=o.length,c=r;c<l;c++)if(t===n[c]&&e===i[c]&&s===a[c])return c;return-1}function C()[r=e]function P(){n=[],i=[],a=[],o=[],e=0,C()}function I(t,r,s,l){return n.push(t),i.push(r),a.push(s),o.push(l),++e-1}function z(e,r,n){return t._meshI.push(e),t._meshJ.push(r),t._meshK.push(n),++g-1}function O(t,e,r){for(var n=[],i=0;i<t.length;i++)n[i]=(t[i]+e[i]+r[i])/3;return n}function D(t,e,r){for(var n=[],i=0;i<t.length;i++)n[i]=t[i]*(1-r)+r*e[i];return n}function R(t)[s=t]function F(t,e){var r=t[0],n=t[1],i=t[2],a=O(r,n,i),o=Math.sqrt(1-s),l=D(a,r,o),c=D(a,n,o),u=D(a,i,o),f=e[0],h=e[1],p=e[2];return{xyzv:[[r,n,c],[c,l,r],[n,i,u],[u,c,n],[i,r,l],[l,u,i]],abc:[[f,h,-1],[-1,-1,f],[h,p,-1],[-1,-1,h],[p,f,-1],[-1,-1,p]]}}function B(t,e){return"all"===t||null===t||t.indexOf(e)>-1}function N(t,e){return null===t?e:t}function j(t,e,r){C();var n=[e],i=[r];if(s>=1)n=[e],i=[r];else if(s>0){var a=F(e,r);n=a.xyzv,i=a.abc}for(var o=0;o<n.length;o++){e=n[o],r=i[o];for(var l=[],c=0;c<3;c++){var u=e[c][0],f=e[c][1],h=e[c][2],p=e[c][3],d=r[c]>-1?r[c]:L(u,f,h);l[c]=d>-1?d:I(u,f,h,N(t,p))}z(l[0],l[1],l[2])}}function U(t,e,r){var n=function(n,i,a){j(t,[e[n],e[i],e[a]],[r[n],r[i],r[a]])};n(0,1,2),n(2,3,0)}function V(t,e,r){var n=function(n,i,a){j(t,[e[n],e[i],e[a]],[r[n],r[i],r[a]])};n(0,1,2),n(3,0,1),n(2,3,0),n(1,2,3)}function H(t,e,r,n){var i=t[3];i<r&&(i=r),i>n&&(i=n);for(var a=(t[3]-i)/(t[3]-e[3]+1e-9),o=[],s=0;s<4;s++)o[s]=(1-a)*t[s]+a*e[s];return o}function q(t,e,r){return t>=e&&t<=r}function G(t){var e=.001*(E-S);return t>=S-e&&t<=E+e}function Y(e){for(var r=[],n=0;n<4;n++){var i=e[n];r.push([t._x[i],t._y[i],t._z[i],t._value[i]])}return r}var W=3;function X(t,e,r,n,i,a){a||(a=1),r=[-1,-1,-1];var o=!1,s=[q(e[0][3],n,i),q(e[1][3],n,i),q(e[2][3],n,i)];if(!s[0]&&!s[1]&&!s[2])return!1;var l=function(t,e,r){return G(e[0][3])&&G(e[1][3])&&G(e[2][3])?(j(t,e,r),!0):a<W&&X(t,e,r,S,E,++a)};if(s[0]&&s[1]&&s[2])return l(t,e,r)||o;var c=!1;return[[0,1,2],[2,0,1],[1,2,0]].forEach((function(a){if(s[a[0]]&&s[a[1]]&&!s[a[2]]){var u=e[a[0]],f=e[a[1]],h=e[a[2]],p=H(h,u,n,i),d=H(h,f,n,i);o=l(t,[d,p,u],[-1,-1,r[a[0]]])||o,o=l(t,[u,f,d],[r[a[0]],r[a[1]],-1])||o,c=!0}})),c||[[0,1,2],[1,2,0],[2,0,1]].forEach((function(a){if(s[a[0]]&&!s[a[1]]&&!s[a[2]]){var u=e[a[0]],f=e[a[1]],h=e[a[2]],p=H(f,u,n,i),d=H(h,u,n,i);o=l(t,[d,p,u],[-1,-1,r[a[0]]])||o,c=!0}})),o}function Z(t,e,r,n){var i=!1,a=Y(e),o=[q(a[0][3],r,n),q(a[1][3],r,n),q(a[2][3],r,n),q(a[3][3],r,n)];if(!o[0]&&!o[1]&&!o[2]&&!o[3])return i;if(o[0]&&o[1]&&o[2]&&o[3])return m&&(i=V(t,a,e)||i),i;var s=!1;return[[0,1,2,3],[3,0,1,2],[2,3,0,1],[1,2,3,0]].forEach((function(l){if(o[l[0]]&&o[l[1]]&&o[l[2]]&&!o[l[3]]){var c=a[l[0]],u=a[l[1]],f=a[l[2]],h=a[l[3]];if(m)i=j(t,[c,u,f],[e[l[0]],e[l[1]],e[l[2]]])||i;else{var p=H(h,c,r,n),d=H(h,u,r,n),g=H(h,f,r,n);i=j(null,[p,d,g],[-1,-1,-1])||i}s=!0}})),s||([[0,1,2,3],[1,2,3,0],[2,3,0,1],[3,0,1,2],[0,2,3,1],[1,3,2,0]].forEach((function(l){if(o[l[0]]&&o[l[1]]&&!o[l[2]]&&!o[l[3]]){var c=a[l[0]],u=a[l[1]],f=a[l[2]],h=a[l[3]],p=H(f,c,r,n),d=H(f,u,r,n),g=H(h,u,r,n),v=H(h,c,r,n);m?(i=j(t,[c,v,p],[e[l[0]],-1,-1])||i,i=j(t,[u,d,g],[e[l[1]],-1,-1])||i):i=U(null,[p,d,g,v],[-1,-1,-1,-1])||i,s=!0}})),s||[[0,1,2,3],[1,2,3,0],[2,3,0,1],[3,0,1,2]].forEach((function(l){if(o[l[0]]&&!o[l[1]]&&!o[l[2]]&&!o[l[3]]){var c=a[l[0]],u=a[l[1]],f=a[l[2]],h=a[l[3]],p=H(u,c,r,n),d=H(f,c,r,n),g=H(h,c,r,n);m?(i=j(t,[c,p,d],[e[l[0]],-1,-1])||i,i=j(t,[c,d,g],[e[l[0]],-1,-1])||i,i=j(t,[c,g,p],[e[l[0]],-1,-1])||i):i=j(null,[p,d,g],[-1,-1,-1])||i,s=!0}}))),i}function J(t,e,r,n,i,a,o,s,l,c,u){var f=!1;return d&&(B(t,'A')&&(f=Z(null,[e,r,n,a],c,u)||f),B(t,'B')&&(f=Z(null,[r,n,i,l],c,u)||f),B(t,'C')&&(f=Z(null,[r,a,o,l],c,u)||f),B(t,'D')&&(f=Z(null,[n,a,s,l],c,u)||f),B(t,'E')&&(f=Z(null,[r,n,a,l],c,u)||f)),m&&(f=Z(t,[r,n,a,l],c,u)||f),f}function K(t,e,r,n,i,a,o,s){return[!0===s[0]||X(t,Y([e,r,n]),[e,r,n],a,o),!0===s[1]||X(t,Y([n,i,e]),[n,i,e],a,o)]}function Q(t,e,r,n,i,a,o,s,l){return s?K(t,e,r,i,n,a,o,l):K(t,r,i,n,e,a,o,l)}function $(t,e,r,n,i,a,o){var s,l,c,u,f=!1,h=function(){f=X(t,[s,l,c],[-1,-1,-1],i,a)||f,f=X(t,[c,u,s],[-1,-1,-1],i,a)||f},p=o[0],d=o[1],m=o[2];return p&&(s=D(Y([k(e,r-0,n-0)])[0],Y([k(e-1,r-0,n-0)])[0],p),l=D(Y([k(e,r-0,n-1)])[0],Y([k(e-1,r-0,n-1)])[0],p),c=D(Y([k(e,r-1,n-1)])[0],Y([k(e-1,r-1,n-1)])[0],p),u=D(Y([k(e,r-1,n-0)])[0],Y([k(e-1,r-1,n-0)])[0],p),h()),d&&(s=D(Y([k(e-0,r,n-0)])[0],Y([k(e-0,r-1,n-0)])[0],d),l=D(Y([k(e-0,r,n-1)])[0],Y([k(e-0,r-1,n-1)])[0],d),c=D(Y([k(e-1,r,n-1)])[0],Y([k(e-1,r-1,n-1)])[0],d),u=D(Y([k(e-1,r,n-0)])[0],Y([k(e-1,r-1,n-0)])[0],d),h()),m&&(s=D(Y([k(e-0,r-0,n)])[0],Y([k(e-0,r-0,n-1)])[0],m),l=D(Y([k(e-0,r-1,n)])[0],Y([k(e-0,r-1,n-1)])[0],m),c=D(Y([k(e-1,r-1,n)])[0],Y([k(e-1,r-1,n-1)])[0],m),u=D(Y([k(e-1,r-0,n)])[0],Y([k(e-1,r-0,n-1)])[0],m),h()),f}function tt(t,e,r,n,i,a,o,s,l,c,u,f){var h=t;return f?(d&&"even"===t&&(h=null),J(h,e,r,n,i,a,o,s,l,c,u)):(d&&"odd"===t&&(h=null),J(h,l,s,o,a,i,n,r,e,c,u))}function et(t,e,r,n,i){for(var a=[],o=0,s=0;s<e.length;s++)for(var l=e[s],c=1;c<w;c++)for(var u=1;u<_;u++)a.push(Q(t,k(l,u-1,c-1),k(l,u-1,c),k(l,u,c-1),k(l,u,c),r,n,(l+u+c)%2,i&&i[o]?i[o]:[])),o++;return a}function rt(t,e,r,n,i){for(var a=[],o=0,s=0;s<e.length;s++)for(var l=e[s],c=1;c<b;c++)for(var u=1;u<w;u++)a.push(Q(t,k(c-1,l,u-1),k(c,l,u-1),k(c-1,l,u),k(c,l,u),r,n,(c+l+u)%2,i&&i[o]?i[o]:[])),o++;return a}function nt(t,e,r,n,i){for(var a=[],o=0,s=0;s<e.length;s++)for(var l=e[s],c=1;c<_;c++)for(var u=1;u<b;u++)a.push(Q(t,k(u-1,c-1,l),k(u-1,c,l),k(u,c-1,l),k(u,c,l),r,n,(u+c+l)%2,i&&i[o]?i[o]:[])),o++;return a}function it(t,e,r){for(var n=1;n<w;n++)for(var i=1;i<_;i++)for(var a=1;a<b;a++)tt(t,k(a-1,i-1,n-1),k(a-1,i-1,n),k(a-1,i,n-1),k(a-1,i,n),k(a,i-1,n-1),k(a,i-1,n),k(a,i,n-1),k(a,i,n),e,r,(a+i+n)%2)}function at(t,e,r){m=!0,it(t,e,r),m=!1}function ot(t,e,r){d=!0,it(t,e,r),d=!1}function st(t,e,r,n,i,a){for(var o=[],s=0,l=0;l<e.length;l++)for(var c=e[l],u=1;u<w;u++)for(var f=1;f<_;f++)o.push($(t,c,f,u,r,n,i[l],a&&a[s]?a[s]:[])),s++;return o}function lt(t,e,r,n,i,a){for(var o=[],s=0,l=0;l<e.length;l++)for(var c=e[l],u=1;u<b;u++)for(var f=1;f<w;f++)o.push($(t,u,c,f,r,n,i[l],a&&a[s]?a[s]:[])),s++;return o}function ct(t,e,r,n,i,a){for(var o=[],s=0,l=0;l<e.length;l++)for(var c=e[l],u=1;u<_;u++)for(var f=1;f<b;f++)o.push($(t,f,u,c,r,n,i[l],a&&a[s]?a[s]:[])),s++;return o}function ut(t,e){for(var r=[],n=t;n<e;n++)r.push(n);return r}function ft(){for(var e=0;e<b;e++)for(var r=0;r<_;r++)for(var n=0;n<w;n++){var i=k(e,r,n);I(t._x[i],t._y[i],t._z[i],t._value[i])}}function ht(){P(),ft();var e=null;if(u&&p&&(R(p),at(e,S,E)),c&&h){R(h);for(var r=t.surface.pattern,s=t.surface.count,f=0;f<s;f++){var d=1===s?.5:f/(s-1),m=(1-d)*S+d*E,T=Math.abs(m-M)>Math.abs(m-A)?[M,m]:[m,A];ot(r,T[0],T[1])}}var k=[[Math.min(S,A),Math.max(S,A)],[Math.min(M,E),Math.max(M,E)]];["x",'y',"z"].forEach((function(r){for(var n=[],i=0;i<k.length;i++){var a=0,o=k[i][0],s=k[i][1],c=t.slices[r];if(c.show&&c.fill){R(c.fill);var u=[],f=[],h=[];if(c.locations.length)for(var p=0;p<c.locations.length;p++){var d=l(c.locations[p],"x"===r?v:"y"===r?y:x);0===d.distRatio?u.push(d.id):d.id>0&&(f.push(d.id),"x"===r?h.push([d.distRatio,0,0]):"y"===r?h.push([0,d.distRatio,0]):h.push([0,0,d.distRatio]))}else u=ut(1,"x"===r?b-1:"y"===r?_-1:w-1);f.length>0&&(n[a]="x"===r?st(e,f,o,s,h,n[a]):"y"===r?lt(e,f,o,s,h,n[a]):ct(e,f,o,s,h,n[a]),a++),u.length>0&&(n[a]="x"===r?et(e,u,o,s,n[a]):"y"===r?rt(e,u,o,s,n[a]):nt(e,u,o,s,n[a]),a++)}var m=t.caps[r];m.show&&m.fill&&(R(m.fill),n[a]="x"===r?et(e,[0,b-1],o,s,n[a]):"y"===r?rt(e,[0,_-1],o,s,n[a]):nt(e,[0,w-1],o,s,n[a]),a++)}})),0===g&&P(),t._meshX=n,t._meshY=i,t._meshZ=a,t._meshIntensity=o,t._Xs=v,t._Ys=y,t._Zs=x}return ht(),t}function p(t,e){var r=t.glplot.gl,i=n({gl:r}),a=new c(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}e.exports={findNearestOnAxis:l,generateIsoMeshes:h,createIsosurfaceTrace:p}},{"../../components/colorscale":662,"../../lib/gl_format_color":783,"../../lib/str2rgbarray":812,"../../plots/gl3d/zip3":891,"gl-mesh3d":309}],1141:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry'),a=t('./attributes'),o=t('../../components/colorscale/defaults');function s(t,e,r,i){function o(r,i){return n.coerce(t,e,a,r,i)}l(t,e,r,i,o)}function l(t,e,r,n,a){var s=a('isomin'),l=a('isomax');void 0!==l&&null!==l&&void 0!==s&&null!==s&&s>l&&(e.isomin=null,e.isomax=null);var c=a('x'),u=a('y'),f=a('z'),h=a('value');c&&c.length&&u&&u.length&&f&&f.length&&h&&h.length?(i.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x",'y',"z"],n),a('valuehoverformat'),["x",'y',"z"].forEach((function(t){a(t+"hoverformat");var e="caps."+t;a(e+".show")&&a(e+".fill");var r="slices."+t;a(r+".show")&&(a(r+".fill"),a(r+".locations"))})),a('spaceframe.show')&&a('spaceframe.fill'),a('surface.show')&&(a('surface.count'),a('surface.fill'),a('surface.pattern')),a('contour.show')&&(a('contour.color'),a('contour.width')),["text",'hovertext','hovertemplate','lighting.ambient','lighting.diffuse','lighting.specular','lighting.roughness','lighting.fresnel','lighting.vertexnormalsepsilon','lighting.facenormalsepsilon','lightposition.x','lightposition.y','lightposition.z','flatshading',"opacity"].forEach((function(t)[a(t)])),o(t,e,n,a,{prefix:"",cLetter:"c"}),e._length=null):e.visible=!1}e.exports={supplyDefaults:s,supplyIsoDefaults:l}},{"../../components/colorscale/defaults":660,"../../lib":787,"../../registry":915,"./attributes":1138}],1142:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults').supplyDefaults,calc:t('./calc'),colorbar:{min:"cmin",max:"cmax"},plot:t('./convert').createIsosurfaceTrace,moduleType:"trace",name:"isosurface",basePlotModule:t('../../plots/gl3d'),categories:["gl3d","showLegend"],meta:{}}},{"../../plots/gl3d":880,"./attributes":1138,"./calc":1139,"./convert":1140,"./defaults":1141}],1143:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../surface/attributes'),s=t('../../plots/attributes'),l=t('../../lib/extend').extendFlat;e.exports=l({x:{valType:"data_array",editType:"calc+clearAxisTypes"},y:{valType:"data_array",editType:"calc+clearAxisTypes"},z:{valType:"data_array",editType:"calc+clearAxisTypes"},i:{valType:"data_array",editType:"calc"},j:{valType:"data_array",editType:"calc"},k:{valType:"data_array",editType:"calc"},text:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},hovertext:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},hovertemplate:a({editType:"calc"}),xhoverformat:i('x'),yhoverformat:i('y'),zhoverformat:i('z'),delaunayaxis:{valType:"enumerated",values:["x",'y',"z"],dflt:"z",editType:"calc"},alphahull:{valType:"number",dflt:-1,editType:"calc"},intensity:{valType:"data_array",editType:"calc"},intensitymode:{valType:"enumerated",values:["vertex","cell"],dflt:"vertex",editType:"calc"},color:{valType:"color",editType:"calc"},vertexcolor:{valType:"data_array",editType:"calc"},facecolor:{valType:"data_array",editType:"calc"},transforms:void 0},n('',{colorAttr:"`intensity`",showScaleDflt:!0,editTypeOverride:"calc"}),{opacity:o.opacity,flatshading:{valType:"boolean",dflt:!1,editType:"calc"},contour:{show:l({},o.contours.x.show,{}),color:o.contours.x.color,width:o.contours.x.width,editType:"calc"},lightposition:{x:l({},o.lightposition.x,{dflt:1e5}),y:l({},o.lightposition.y,{dflt:1e5}),z:l({},o.lightposition.z,{dflt:0}),editType:"calc"},lighting:l({vertexnormalsepsilon:{valType:"number",min:0,max:1,dflt:1e-12,editType:"calc"},facenormalsepsilon:{valType:"number",min:0,max:1,dflt:1e-6,editType:"calc"},editType:"calc"},o.lighting),hoverinfo:l({},s.hoverinfo,{editType:"calc"}),showlegend:l({},s.showlegend,{dflt:!1})})},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../surface/attributes":1326}],1144:[function(t,e,r){"use strict";var n=t('../../components/colorscale/calc');e.exports=function(t,e){e.intensity&&n(t,e,{vals:e.intensity,containerStr:"",cLetter:"c"})}},{"../../components/colorscale/calc":658}],1145:[function(t,e,r){"use strict";var n=t('gl-mesh3d'),i=t('delaunay-triangulate'),a=t('alpha-shape'),o=t('convex-hull'),s=t('../../lib/gl_format_color').parseColorScale,l=t('../../lib/str2rgbarray'),c=t('../../components/colorscale').extractOpts,u=t('../../plots/gl3d/zip3');function f(t,e,r){this.scene=t,this.uid=r,this.mesh=e,this.name='',this.color='#fff',this.data=null,this.showContour=!1}var h=f.prototype;function p(t){for(var e=[],r=t.length,n=0;n<r;n++)e[n]=l(t[n]);return e}function d(t,e,r,n){for(var i=[],a=e.length,o=0;o<a;o++)i[o]=t.d2l(e[o],0,n)*r;return i}function m(t){for(var e=[],r=t.length,n=0;n<r;n++)e[n]=Math.round(t[n]);return e}function g(t,e){for(var r=["x",'y',"z"].indexOf(t),n=[],a=e.length,o=0;o<a;o++)n[o]=[e[o][(r+1)%3],e[o][(r+2)%3]];return i(n)}function v(t,e){for(var r=t.length,n=0;n<r;n++)if(t[n]<=-.5||t[n]>=e-.5)return!1;return!0}function y(t,e){var r=t.glplot.gl,i=n({gl:r}),a=new f(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}h.handlePick=function(t){if(t.object===this.mesh){var e=t.index=t.data.index;t.data._cellCenter?t.traceCoordinate=t.data.dataCoordinate:t.traceCoordinate=[this.data.x[e],this.data.y[e],this.data.z[e]];var r=this.data.hovertext||this.data.text;return Array.isArray(r)&&void 0!==r[e]?t.textLabel=r[e]:r&&(t.textLabel=r),!0}},h.update=function(t){var e=this.scene,r=e.fullSceneLayout;this.data=t;var n,i=t.x.length,f=u(d(r.xaxis,t.x,e.dataScale[0],t.xcalendar),d(r.yaxis,t.y,e.dataScale[1],t.ycalendar),d(r.zaxis,t.z,e.dataScale[2],t.zcalendar));if(t.i&&t.j&&t.k){if(t.i.length!==t.j.length||t.j.length!==t.k.length||!v(t.i,i)||!v(t.j,i)||!v(t.k,i))return;n=u(m(t.i),m(t.j),m(t.k))}else n=0===t.alphahull?o(f):t.alphahull>0?a(t.alphahull,f):g(t.delaunayaxis,f);var h={positions:f,cells:n,lightPosition:[t.lightposition.x,t.lightposition.y,t.lightposition.z],ambient:t.lighting.ambient,diffuse:t.lighting.diffuse,specular:t.lighting.specular,roughness:t.lighting.roughness,fresnel:t.lighting.fresnel,vertexNormalsEpsilon:t.lighting.vertexnormalsepsilon,faceNormalsEpsilon:t.lighting.facenormalsepsilon,opacity:t.opacity,contourEnable:t.contour.show,contourColor:l(t.contour.color).slice(0,3),contourWidth:t.contour.width,useFacetNormals:t.flatshading};if(t.intensity){var y=c(t);this.color='#fff';var x=t.intensitymode;h[x+"Intensity"]=t.intensity,h[x+"IntensityBounds"]=[y.min,y.max],h.colormap=s(t)}else t.vertexcolor?(this.color=t.vertexcolor[0],h.vertexColors=p(t.vertexcolor)):t.facecolor?(this.color=t.facecolor[0],h.cellColors=p(t.facecolor)):(this.color=t.color,h.meshColor=l(t.color));this.mesh.update(h)},h.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()},e.exports=y},{"../../components/colorscale":662,"../../lib/gl_format_color":783,"../../lib/str2rgbarray":812,"../../plots/gl3d/zip3":891,"alpha-shape":75,"convex-hull":141,"delaunay-triangulate":177,"gl-mesh3d":309}],1146:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../../components/colorscale/defaults'),o=t('./attributes');e.exports=function(t,e,r,s){function l(r,n){return i.coerce(t,e,o,r,n)}function c(t){var e=t.map((function(t){var e=l(t);return e&&i.isArrayOrTypedArray(e)?e:null}));return e.every((function(t){return t&&t.length===e[0].length}))&&e}c(["x",'y',"z"])?(c(["i",'j',"k"]),(!e.i||e.j&&e.k)&&(!e.j||e.k&&e.i)&&(!e.k||e.i&&e.j)?(n.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x",'y',"z"],s),["lighting.ambient",'lighting.diffuse','lighting.specular','lighting.roughness','lighting.fresnel','lighting.vertexnormalsepsilon','lighting.facenormalsepsilon','lightposition.x','lightposition.y','lightposition.z','flatshading','alphahull','delaunayaxis',"opacity"].forEach((function(t)[l(t)])),l('contour.show')&&(l('contour.color'),l('contour.width')),"intensity"in t?(l('intensity'),l('intensitymode'),a(t,e,s,l,{prefix:"",cLetter:"c"})):(e.showscale=!1,"facecolor"in t?l('facecolor'):"vertexcolor"in t?l('vertexcolor'):l('color',r)),l('text'),l('hovertext'),l('hovertemplate'),l('xhoverformat'),l('yhoverformat'),l('zhoverformat'),e._length=null):e.visible=!1):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"../../registry":915,"./attributes":1143}],1147:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),colorbar:{min:"cmin",max:"cmax"},plot:t('./convert'),moduleType:"trace",name:"mesh3d",basePlotModule:t('../../plots/gl3d'),categories:["gl3d","showLegend"],meta:{}}},{"../../plots/gl3d":880,"./attributes":1143,"./calc":1144,"./convert":1145,"./defaults":1146}],1148:[function(t,e,r){"use strict";var n=t('../../lib').extendFlat,i=t('../scatter/attributes'),a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,o=t('../../components/drawing/attributes').dash,s=t('../../components/fx/attributes'),l=t('../../constants/delta.js'),c=l.INCREASING.COLOR,u=l.DECREASING.COLOR,f=i.line;function h(t){return{line:{color:n({},f.color,{dflt:t}),width:f.width,dash:o,editType:"style"},editType:"style"}}e.exports={xperiod:i.xperiod,xperiod0:i.xperiod0,xperiodalignment:i.xperiodalignment,xhoverformat:a('x'),yhoverformat:a('y'),x:{valType:"data_array",editType:"calc+clearAxisTypes"},open:{valType:"data_array",editType:"calc"},high:{valType:"data_array",editType:"calc"},low:{valType:"data_array",editType:"calc"},close:{valType:"data_array",editType:"calc"},line:{width:n({},f.width,{}),dash:n({},o,{}),editType:"style"},increasing:h(c),decreasing:h(u),text:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},hovertext:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},tickwidth:{valType:"number",min:0,max:.5,dflt:.3,editType:"calc"},hoverlabel:n({},s.hoverlabel,{split:{valType:"boolean",dflt:!1,editType:"style"}})}},{"../../components/drawing/attributes":671,"../../components/fx/attributes":681,"../../constants/delta.js":757,"../../lib":787,"../../plots/cartesian/axis_format_attributes":841,"../scatter/attributes":1202}],1149:[function(t,e,r){"use strict";var n=t('../../lib'),i=n._,a=t('../../plots/cartesian/axes'),o=t('../../plots/cartesian/align_period'),s=t('../../constants/numerical').BADNUM;function l(t,e){var r=a.getFromId(t,e.xaxis),i=a.getFromId(t,e.yaxis),o=f(t,r,e),s=e._minDiff;e._minDiff=null;var l=e._origX;e._origX=null;var h=e._xcalc;e._xcalc=null;var p=u(t,e,l,h,i,c);return e._extremes[r._id]=a.findExtremes(r,h,{vpad:s/2}),p.length?(n.extendFlat(p[0].t,{wHover:s/2,tickLen:o}),p):[t:{empty:!0}}]function c(t,e,r,n){return{o:t,h:e,l:r,c:n}}function u(t,e,r,o,l,c){for(var u=l.makeCalcdata(e,'open'),f=l.makeCalcdata(e,'high'),h=l.makeCalcdata(e,'low'),p=l.makeCalcdata(e,'close'),d=Array.isArray(e.text),m=Array.isArray(e.hovertext),g=!0,v=null,y=!!e.xperiodalignment,x=[],b=0;b<o.length;b++){var _=o[b],w=u[b],T=f[b],k=h[b],M=p[b];if(_!==s&&w!==s&&T!==s&&k!==s&&M!==s){M===w?null!==v&&M!==v&&(g=M>v):g=M>w,v=M;var A=c(w,T,k,M);A.pos=_,A.yc=(w+M)/2,A.i=b,A.dir=g?"increasing":"decreasing",A.x=A.pos,A.y=[k,T],y&&(A.orig_p=r[b]),d&&(A.tx=e.text[b]),m&&(A.htx=e.hovertext[b]),x.push(A)}else x.push({pos:_,empty:!0})}return e._extremes[l._id]=a.findExtremes(l,n.concat(h,f),{padded:!0}),x.length&&(x[0].t={labels:{open:i(t,'open:')+" ',high:i(t,'high:')+' ',low:i(t,'low:')+' ',close:i(t,'close:')+' "}}),x}function f(t,e,r){var i=r._minDiff;if(!i){var a,s=t._fullData,l=[];for(i=1/0,a=0;a<s.length;a++){var c=s[a];if("ohlc"===c.type&&!0===c.visible&&c.xaxis===e._id){l.push(c);var u=e.makeCalcdata(c,'x');c._origX=u;var f=o(r,e,'x',u).vals;c._xcalc=f;var h=n.distinctVals(f).minDiff;h&&isFinite(h)&&(i=Math.min(i,h))}}for(i===1/0&&(i=1),a=0;a<l.length;a++)l[a]._minDiff=i}return i*r.tickwidth}e.exports={calc:l,calcCommon:u}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838}],1150:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./ohlc_defaults'),a=t('../scatter/period_defaults'),o=t('./attributes');function s(t,e,r,n){r(n+".line.color"),r(n+".line.width",e.line.width),r(n+".line.dash",e.line.dash)}e.exports=function(t,e,r,l){function c(r,i){return n.coerce(t,e,o,r,i)}i(t,e,c,l)?(a(t,e,l,c,{x:!0}),c('xhoverformat'),c('yhoverformat'),c('line.width'),c('line.dash'),s(t,e,c,'increasing'),s(t,e,c,'decreasing'),c('text'),c('hovertext'),c('tickwidth'),l._requestRangeslider[e.xaxis]=!0):e.visible=!1}},{"../../lib":787,"../scatter/period_defaults":1222,"./attributes":1148,"./ohlc_defaults":1153}],1151:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../lib'),a=t('../../components/fx'),o=t('../../components/color'),s=t('../../lib').fillText,l=t('../../constants/delta.js'),c={increasing:l.INCREASING.SYMBOL,decreasing:l.DECREASING.SYMBOL};function u(t,e,r,n){return t.cd[0].trace.hoverlabel.split?h(t,e,r,n):p(t,e,r,n)}function f(t,e,r,n){var i,s,l=t.cd,c=t.xa,u=l[0].trace,f=l[0].t,h=u.type,p="ohlc"===h?"l":"min",d="ohlc"===h?"h":"max",m=f.bPos||0,g=function(t){return t.pos+m-e},v=f.bdPos||f.tickLen,y=f.wHover,x=Math.min(1,v/Math.abs(c.r2c(c.range[1])-c.r2c(c.range[0])));function b(t){var e=g(t);return a.inbox(e-y,e+y,i)}function _(t){var e=t[p],n=t[d];return e===n||a.inbox(e-r,n-r,i)}function w(t){return(b(t)+_(t))/2}i=t.maxHoverDistance-x,s=t.maxSpikeDistance-x;var T=a.getDistanceFunction(n,b,_,w);if(a.getClosest(l,T,t),!1===t.index)return null;var k=l[t.index];if(k.empty)return null;var M=u[k.dir],A=M.line.color;return o.opacity(A)&&M.line.width?t.color=A:t.color=M.fillcolor,t.x0=c.c2p(k.pos+m-v,!0),t.x1=c.c2p(k.pos+m+v,!0),t.xLabelVal=void 0!==k.orig_p?k.orig_p:k.pos,t.spikeDistance=w(k)*s/i,t.xSpike=c.c2p(k.pos,!0),t}function h(t,e,r,a){var o=t.cd,s=t.ya,l=o[0].trace,c=o[0].t,u=[],h=f(t,e,r,a);if(!h)return[];var p=o[h.index].hi||l.hoverinfo,d=p.split('+');if("all"!==p&&-1===d.indexOf('y'))return[];for(var m=["high",'open','close',"low"],g={},v=0;v<m.length;v++){var y,x=m[v],b=l[x][h.index],_=s.c2p(b,!0);b in g?(y=g[b]).yLabel+="<br>"+c.labels[x]+n.hoverLabelText(s,b,l.yhoverformat):((y=i.extendFlat({},h)).y0=y.y1=_,y.yLabelVal=b,y.yLabel=c.labels[x]+n.hoverLabelText(s,b,l.yhoverformat),y.name='',u.push(y),g[b]=y)}return u}function p(t,e,r,i){var a=t.cd,o=t.ya,l=a[0].trace,u=a[0].t,h=f(t,e,r,i);if(!h)return[];var p=a[h.index],d=h.index=p.i,m=p.dir;function g(t){return u.labels[t]+n.hoverLabelText(o,l[t][d],l.yhoverformat)}var v=p.hi||l.hoverinfo,y=v.split('+'),x="all"===v,b=x||-1!==y.indexOf('y'),_=x||-1!==y.indexOf('text'),w=b?[g('open'),g('high'),g('low'),g('close')+"  '+c[m]]:[];return _&&s(p,l,w),h.extraText=w.join('<br>'),h.y0=h.y1=o.c2p(p.yc,!0),[h]}e.exports={hoverPoints:u,hoverSplit:h,hoverOnPoints:p}},{'../../components/color":650,"../../components/fx":690,"../../constants/delta.js":757,"../../lib":787,"../../plots/cartesian/axes":838}],1152:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"ohlc",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg',"showLegend"],meta:{},attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc').calc,plot:t('./plot'),style:t('./style'),hoverPoints:t('./hover').hoverPoints,selectPoints:t('./select')}},{"../../plots/cartesian":852,"./attributes":1148,"./calc":1149,"./defaults":1150,"./hover":1151,"./plot":1154,"./select":1155,"./style":1156}],1153:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib');e.exports=function(t,e,r,a){var o=r('x'),s=r('open'),l=r('high'),c=r('low'),u=r('close');if(r('hoverlabel.split'),n.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x"],a),s&&l&&c&&u){var f=Math.min(s.length,l.length,c.length,u.length);return o&&(f=Math.min(f,i.minRowLength(o))),e._length=f,f}}},{"../../lib":787,"../../registry":915}],1154:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib');e.exports=function(t,e,r,a){var o=e.yaxis,s=e.xaxis,l=!!s.rangebreaks;i.makeTraceGroups(a,r,'trace ohlc').each((function(t){var e=n.select(this),r=t[0],a=r.t;if(!0!==r.trace.visible||a.empty)e.remove();else{var c=a.tickLen,u=e.selectAll('path').data(i.identity);u.enter().append('path'),u.exit().remove(),u.attr('d',(function(t){if(t.empty)return'M0,0Z';var e=s.c2p(t.pos-c,!0),r=s.c2p(t.pos+c,!0),n=l?(e+r)/2:s.c2p(t.pos,!0);return"M"+e+","+o.c2p(t.o,!0)+"H"+n+"M"+n+","+o.c2p(t.h,!0)+"V"+o.c2p(t.l,!0)+"M"+r+","+o.c2p(t.c,!0)+"H"+n}))}}))}},{"../../lib":787,"@plotly/d3":58}],1155:[function(t,e,r){"use strict";e.exports=function(t,e){var r,n=t.cd,i=t.xaxis,a=t.yaxis,o=[],s=n[0].t.bPos||0;if(!1===e)for(r=0;r<n.length;r++)n[r].selected=0;else for(r=0;r<n.length;r++){var l=n[r];e.contains([i.c2p(l.pos+s),a.c2p(l.yc)],null,l.i,t)?(o.push({pointNumber:l.i,x:i.c2d(l.pos),y:a.c2d(l.yc)}),l.selected=1):l.selected=0}return o}},{}],1156:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../../components/color');e.exports=function(t,e,r){var o=r||n.select(t).selectAll('g.ohlclayer').selectAll('g.trace');o.style('opacity',(function(t){return t[0].trace.opacity})),o.each((function(t){var e=t[0].trace;n.select(this).selectAll('path').each((function(t){if(!t.empty){var r=e[t.dir].line;n.select(this).style('fill','none').call(a.stroke,r.color).call(i.dashLine,r.dash,r.width).style('opacity',e.selectedpoints&&!t.selected?.3:1)}}))}))}},{"../../components/color":650,"../../components/drawing":672,"@plotly/d3":58}],1157:[function(t,e,r){"use strict";var n=t('../../lib/extend').extendFlat,i=t('../../plots/attributes'),a=t('../../plots/font_attributes'),o=t('../../components/colorscale/attributes'),s=t('../../plots/template_attributes').hovertemplateAttrs,l=t('../../plots/domain').attributes,c=n({editType:"calc"},o('line',{editTypeOverride:"calc"}),{shape:{valType:"enumerated",values:["linear","hspline"],dflt:"linear",editType:"plot"},hovertemplate:s({editType:"plot",arrayOk:!1},{keys:["count","probability"]})});e.exports={domain:l({name:"parcats",trace:!0,editType:"calc"}),hoverinfo:n({},i.hoverinfo,{flags:["count","probability"],editType:"plot",arrayOk:!1}),hoveron:{valType:"enumerated",values:["category",'color',"dimension"],dflt:"category",editType:"plot"},hovertemplate:s({editType:"plot",arrayOk:!1},{keys:["count",'probability','category','categorycount','colorcount',"bandcolorcount"]}),arrangement:{valType:"enumerated",values:["perpendicular",'freeform',"fixed"],dflt:"perpendicular",editType:"plot"},bundlecolors:{valType:"boolean",dflt:!0,editType:"plot"},sortpaths:{valType:"enumerated",values:["forward","backward"],dflt:"forward",editType:"plot"},labelfont:a({editType:"calc"}),tickfont:a({editType:"calc"}),dimensions:{_isLinkedToArray:"dimension",label:{valType:"string",editType:"calc"},categoryorder:{valType:"enumerated",values:["trace",'category ascending','category descending',"array"],dflt:"trace",editType:"calc"},categoryarray:{valType:"data_array",editType:"calc"},ticktext:{valType:"data_array",editType:"calc"},values:{valType:"data_array",dflt:[],editType:"calc"},displayindex:{valType:"integer",editType:"calc"},editType:"calc",visible:{valType:"boolean",dflt:!0,editType:"calc"}},line:c,counts:{valType:"number",min:0,dflt:1,arrayOk:!0,editType:"calc"},customdata:void 0,hoverlabel:void 0,ids:void 0,legendgroup:void 0,legendrank:void 0,opacity:void 0,selectedpoints:void 0,showlegend:void 0}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/domain":866,"../../plots/font_attributes":867,"../../plots/template_attributes":910}],1158:[function(t,e,r){"use strict";var n=t('../../plots/get_data').getModuleCalcData,i=t('./plot'),a='parcats';r.name=a,r.plot=function(t,e,r,o){var s=n(t.calcdata,a);if(s.length){var l=s[0];i(t,l,r,o)}},r.clean=function(t,e,r,n){var i=n._has&&n._has('parcats'),a=e._has&&e._has('parcats');i&&!a&&n._paperdiv.selectAll('.parcats').remove()}},{"../../plots/get_data":875,"./plot":1163}],1159:[function(t,e,r){"use strict";var n=t('../../lib/gup').wrap,i=t('../../components/colorscale/helpers').hasColorscale,a=t('../../components/colorscale/calc'),o=t('../../lib/filter_unique.js'),s=t('../../components/drawing'),l=t('../../lib'),c=t('fast-isnumeric');function u(t,e,r){var n=t.map((function(t){return t.categories.length})).reduce((function(t,e){return Math.max(t,e)}));return{dimensions:t,paths:e,trace:void 0,maxCats:n,count:r}}function f(t,e,r,n,i){return{dimensionInd:t,containerInd:e,displayInd:r,dimensionLabel:n,count:i,categories:[],dragX:null}}function h(t,e,r,n){return{dimensionInd:t,categoryInd:e,categoryValue:r,displayInd:e,categoryLabel:n,valueInds:[],count:0,dragY:null}}function p(t,e,r){t.valueInds.push(e),t.count+=r}function d(t,e,r){return{categoryInds:t,color:e,rawColor:r,valueInds:[],count:0}}function m(t,e,r){t.valueInds.push(e),t.count+=r}function g(t,e){e=void 0===e||null===e?[]:e.map((function(t){return t}));var r={},n={},i=[];e.forEach((function(t,e){r[t]=0,n[t]=e}));for(var a=0;a<t.length;a++){var o,s=t[a];void 0===r[s]?(r[s]=1,o=e.push(s)-1,n[s]=o):(r[s]++,o=n[s]),i.push(o)}var l=e.map((function(t){return r[t]}));return{uniqueValues:e,uniqueCounts:l,inds:i}}function v(t){var e;if(x(t.map((function(t){return t.displayindex}))))for(e=0;e<t.length;e++)t[e]._displayindex=t[e].displayindex;else for(e=0;e<t.length;e++)t[e]._displayindex=e}function y(t,e){t._categoryarray=e.uniqueValues,null===t.ticktext||void 0===t.ticktext?t._ticktext=[]:t._ticktext=t.ticktext.slice();for(var r=t._ticktext.length;r<e.uniqueValues.length;r++)t._ticktext.push(e.uniqueValues[r])}function x(t){for(var e=new Array(t.length),r=0;r<t.length;r++){if(t[r]<0||t[r]>=t.length)return!1;if(void 0!==e[t[r]])return!1;e[t[r]]=!0}return!0}e.exports=function(t,e){var r=l.filterVisible(e.dimensions);if(0===r.length)return[];var x,b,_,w=r.map((function(t){var e;if("trace"===t.categoryorder)e=null;else if("array"===t.categoryorder)e=t.categoryarray;else{e=o(t.values);for(var r=!0,n=0;n<e.length;n++)if(!c(e[n])){r=!1;break}e.sort(r?l.sorterAsc:void 0),"category descending"===t.categoryorder&&(e=e.reverse())}return g(t.values,e)}));x=l.isArrayOrTypedArray(e.counts)?e.counts:[e.counts],v(r),r.forEach((function(t,e){y(t,w[e])}));var T,k=e.line;function M(t){var e,r;return l.isArrayOrTypedArray(k.color)?r=e=k.color[t%k.color.length]:e=k.color,{color:T(e),rawColor:r}}k?(i(e,'line')&&a(t,e,{vals:e.line.color,containerStr:"line",cLetter:"c"}),T=s.tryColorscale(k)):T=l.identity;var A,S,E=r[0].values.length,L={},C=w.map((function(t){return t.inds}));for(_=0,A=0;A<E;A++){var P=[];for(S=0;S<C.length;S++)P.push(C[S][A]);b=x[A%x.length],_+=b;var I=M(A),z=P+"-"+I.rawColor;void 0===L[z]&&(L[z]=d(P,I.color,I.rawColor)),m(L[z],A,b)}var O=r.map((function(t,e){return f(e,t._index,t._displayindex,t.label,_)}));for(A=0;A<E;A++)for(b=x[A%x.length],S=0;S<O.length;S++){var D=O[S].containerInd,R=w[S].inds[A],F=O[S].categories;if(void 0===F[R]){var B=e.dimensions[D]._categoryarray[R],N=e.dimensions[D]._ticktext[R];F[R]=h(S,R,B,N)}p(F[R],A,b)}return n(u(O,L,_))}},{"../../components/colorscale/calc":658,"../../components/colorscale/helpers":661,"../../components/drawing":672,"../../lib":787,"../../lib/filter_unique.js":778,"../../lib/gup":784,"fast-isnumeric":246}],1160:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/helpers').hasColorscale,a=t('../../components/colorscale/defaults'),o=t('../../plots/domain').defaults,s=t('../../plots/array_container_defaults'),l=t('./attributes'),c=t('../parcoords/merge_length');function u(t,e,r,o,s){s('line.shape'),s('line.hovertemplate');var l=s('line.color',o.colorway[0]);if(i(t,'line')&&n.isArrayOrTypedArray(l)){if(l.length)return s('line.colorscale'),a(t,e,o,s,{prefix:"line.",cLetter:"c"}),l.length;e.line.color=r}return 1/0}function f(t,e){function r(r,i){return n.coerce(t,e,l.dimensions,r,i)}var i=r('values'),a=r('visible');if(i&&i.length||(a=e.visible=!1),a){r('label'),r('displayindex',e._index);var o,s=t.categoryarray,c=Array.isArray(s)&&s.length>0;c&&(o='array');var u=r('categoryorder',o);"array"===u?(r('categoryarray'),r('ticktext')):(delete t.categoryarray,delete t.ticktext),c||"array"!==u||(e.categoryorder='trace')}}e.exports=function(t,e,r,i){function a(r,i){return n.coerce(t,e,l,r,i)}var h=s(t,e,{name:"dimensions",handleItemDefaults:f}),p=u(t,e,r,i,a);o(e,i,a),Array.isArray(h)&&h.length||(e.visible=!1),c(e,h,'values',p),a('hoveron'),a('hovertemplate'),a('arrangement'),a('bundlecolors'),a('sortpaths'),a('counts');var d={family:i.font.family,size:Math.round(i.font.size),color:i.font.color};n.coerceFont(a,'labelfont',d);var m={family:i.font.family,size:Math.round(i.font.size/1.2),color:i.font.color};n.coerceFont(a,'tickfont',m)}},{"../../components/colorscale/defaults":660,"../../components/colorscale/helpers":661,"../../lib":787,"../../plots/array_container_defaults":833,"../../plots/domain":866,"../parcoords/merge_length":1173,"./attributes":1157}],1161:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot'),colorbar:{container:"line",min:"cmin",max:"cmax"},moduleType:"trace",name:"parcats",basePlotModule:t('./base_plot'),categories:["noOpacity"],meta:{}}},{"./attributes":1157,"./base_plot":1158,"./calc":1159,"./defaults":1160,"./plot":1163}],1162:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-interpolate').interpolateNumber,a=t('../../plot_api/plot_api'),o=t('../../components/fx'),s=t('../../lib'),l=s.strTranslate,c=t('../../components/drawing'),u=t('tinycolor2'),f=t('../../lib/svg_text_utils');function h(t,e,r,i){var a=t.map(H.bind(0,e,r)),o=i.selectAll('g.parcatslayer').data([null]);o.enter().append('g').attr('class','parcatslayer').style('pointer-events','all');var u=o.selectAll('g.trace.parcats').data(a,p),h=u.enter().append('g').attr('class','trace parcats');u.attr('transform',(function(t){return l(t.x,t.y)})),h.append('g').attr('class','paths');var y=u.select('g.paths').selectAll('path.path').data((function(t){return t.paths}),p);y.attr('fill',(function(t){return t.model.color}));var x=y.enter().append('path').attr('class','path').attr('stroke-opacity',0).attr('fill',(function(t){return t.model.color})).attr('fill-opacity',0);_(x),y.attr('d',(function(t){return t.svgD})),x.empty()||y.sort(m),y.exit().remove(),y.on('mouseover',g).on('mouseout',v).on('click',b),h.append('g').attr('class','dimensions');var w=u.select('g.dimensions').selectAll('g.dimension').data((function(t){return t.dimensions}),p);w.enter().append('g').attr('class','dimension'),w.attr('transform',(function(t){return l(t.x,0)})),w.exit().remove();var T=w.selectAll('g.category').data((function(t){return t.categories}),p),M=T.enter().append('g').attr('class','category');T.attr('transform',(function(t){return l(0,t.y)})),M.append('rect').attr('class','catrect').attr('pointer-events','none'),T.select('rect.catrect').attr('fill','none').attr('width',(function(t){return t.width})).attr('height',(function(t){return t.height})),k(M);var S=T.selectAll('rect.bandrect').data((function(t){return t.bands}),p);S.each((function()[s.raiseToTop(this)])),S.attr('fill',(function(t){return t.color}));var E=S.enter().append('rect').attr('class','bandrect').attr('stroke-opacity',0).attr('fill',(function(t){return t.color})).attr('fill-opacity',0);S.attr('fill',(function(t){return t.color})).attr('width',(function(t){return t.width})).attr('height',(function(t){return t.height})).attr('y',(function(t){return t.y})).attr('cursor',(function(t){return"fixed"===t.parcatsViewModel.arrangement?"default":"perpendicular"===t.parcatsViewModel.arrangement?"ns-resize":"move"})),A(E),S.exit().remove(),M.append('text').attr('class','catlabel').attr('pointer-events','none');var L=e._fullLayout.paper_bgcolor;T.select('text.catlabel').attr('text-anchor',(function(t){return d(t)?"start":"end"})).attr('alignment-baseline','middle').style('text-shadow',f.makeTextShadow(L)).style('fill','rgb(0, 0, 0)').attr('x',(function(t){return d(t)?t.width+5:-5})).attr('y',(function(t){return t.height/2})).text((function(t){return t.model.categoryLabel})).each((function(t){c.font(n.select(this),t.parcatsViewModel.categorylabelfont),f.convertToTspans(n.select(this),e)})),M.append('text').attr('class','dimlabel'),T.select('text.dimlabel').attr('text-anchor','middle').attr('alignment-baseline','baseline').attr('cursor',(function(t){return"fixed"===t.parcatsViewModel.arrangement?"default":"ew-resize"})).attr('x',(function(t){return t.width/2})).attr('y',-5).text((function(t,e){return 0===e?t.parcatsViewModel.model.dimensions[t.model.dimensionInd].dimensionLabel:null})).each((function(t){c.font(n.select(this),t.parcatsViewModel.labelfont)})),T.selectAll('rect.bandrect').on('mouseover',D).on('mouseout',R),T.exit().remove(),w.call(n.behavior.drag().origin((function(t){return{x:t.x,y:0}})).on('dragstart',F).on('drag',B).on('dragend',N)),u.each((function(t){t.traceSelection=n.select(this),t.pathSelection=n.select(this).selectAll('g.paths').selectAll('path.path'),t.dimensionSelection=n.select(this).selectAll('g.dimensions').selectAll('g.dimension')})),u.exit().remove()}function p(t){return t.key}function d(t){var e=t.parcatsViewModel.dimensions.length,r=t.parcatsViewModel.dimensions[e-1].model.dimensionInd;return t.model.dimensionInd===r}function m(t,e){return t.model.rawColor>e.model.rawColor?1:t.model.rawColor<e.model.rawColor?-1:0}function g(t){if(!t.parcatsViewModel.dragDimension&&-1===t.parcatsViewModel.hoverinfoItems.indexOf('skip')){s.raiseToTop(this),w(n.select(this));var e=y(t),r=x(t);if(t.parcatsViewModel.graphDiv.emit('plotly_hover',{points:e,event:n.event,constraints:r}),-1===t.parcatsViewModel.hoverinfoItems.indexOf('none')){var i,a,l,c=n.mouse(this)[0],f=t.parcatsViewModel.graphDiv,h=t.parcatsViewModel.trace,p=f._fullLayout,d=p._paperdiv.node().getBoundingClientRect(),m=t.parcatsViewModel.graphDiv.getBoundingClientRect();for(l=0;l<t.leftXs.length-1;l++)if(t.leftXs[l]+t.dimWidths[l]-2<=c&&c<=t.leftXs[l+1]+2){var g=t.parcatsViewModel.dimensions[l],v=t.parcatsViewModel.dimensions[l+1];i=(g.x+g.width+v.x)/2,a=(t.topYs[l]+t.topYs[l+1]+t.height)/2;break}var b=t.parcatsViewModel.x+i,_=t.parcatsViewModel.y+a,T=u.mostReadable(t.model.color,["black","white"]),k=t.model.count,M=k/t.parcatsViewModel.model.count,A={countLabel:k,probabilityLabel:M.toFixed(3)},S=[];-1!==t.parcatsViewModel.hoverinfoItems.indexOf('count')&&S.push(["Count:",A.countLabel].join(' ')),-1!==t.parcatsViewModel.hoverinfoItems.indexOf('probability')&&S.push(["P:",A.probabilityLabel].join(' '));var E=S.join('<br>'),L=n.mouse(f)[0];o.loneHover({trace:h,x:b-d.left+m.left,y:_-d.top+m.top,text:E,color:t.model.color,borderColor:"black",fontFamily:'Monaco, 'Courier New', monospace',fontSize:10,fontColor:T,idealAlign:L<b?"right":"left",hovertemplate:(h.line||{}).hovertemplate,hovertemplateLabels:A,eventData:[data:h._input,fullData:h,count:k,probability:M]},{container:p._hoverlayer.node(),outerContainer:p._paper.node(),gd:f})}}}function v(t){if(!t.parcatsViewModel.dragDimension&&(_(n.select(this)),o.loneUnhover(t.parcatsViewModel.graphDiv._fullLayout._hoverlayer.node()),t.parcatsViewModel.pathSelection.sort(m),-1===t.parcatsViewModel.hoverinfoItems.indexOf('skip'))){var e=y(t),r=x(t);t.parcatsViewModel.graphDiv.emit('plotly_unhover',{points:e,event:n.event,constraints:r})}}function y(t){for(var e=[],r=j(t.parcatsViewModel),n=0;n<t.model.valueInds.length;n++){var i=t.model.valueInds[n];e.push({curveNumber:r,pointNumber:i})}return e}function x(t)[for(var e={],r=t.parcatsViewModel.model.dimensions,n=0;n<r.length;n++){var i=r[n],a=i.categories[t.model.categoryInds[n]];e[i.containerInd]=a.categoryValue}return void 0!==t.model.rawColor&&(e.color=t.model.rawColor),e}function b(t){if(-1===t.parcatsViewModel.hoverinfoItems.indexOf('skip')){var e=y(t),r=x(t);t.parcatsViewModel.graphDiv.emit('plotly_click',{points:e,event:n.event,constraints:r})}}function _(t){t.attr('fill',(function(t){return t.model.color})).attr('fill-opacity',.6).attr('stroke','lightgray').attr('stroke-width',.2).attr('stroke-opacity',1)}function w(t){t.attr('fill-opacity',.8).attr('stroke',(function(t){return u.mostReadable(t.model.color,["black","white"])})).attr('stroke-width',.3)}function T(t){t.select('rect.catrect').attr('stroke','black').attr('stroke-width',2.5)}function k(t){t.select('rect.catrect').attr('stroke','black').attr('stroke-width',1).attr('stroke-opacity',1)}function M(t){t.attr('stroke','black').attr('stroke-width',1.5)}function A(t){t.attr('stroke','black').attr('stroke-width',.2).attr('stroke-opacity',1).attr('fill-opacity',1)}function S(t){var e=t.parcatsViewModel.pathSelection,r=t.categoryViewModel.model.dimensionInd,n=t.categoryViewModel.model.categoryInd;return e.filter((function(e){return e.model.categoryInds[r]===n&&e.model.color===t.color}))}function E(t){n.select(t.parentNode).selectAll('rect.bandrect').each((function(t){var e=S(t);w(e),e.each((function(){s.raiseToTop(this)}))})),T(n.select(t.parentNode))}function L(t){var e=n.select(t).datum(),r=S(e);w(r),r.each((function(){s.raiseToTop(this)})),n.select(t.parentNode).selectAll('rect.bandrect').filter((function(t){return t.color===e.color})).each((function(){s.raiseToTop(this),M(n.select(this))}))}function C(t,e,r){var i=n.select(t).datum(),a=i.categoryViewModel.model,o=i.parcatsViewModel.graphDiv,s=n.select(t.parentNode).selectAll('rect.bandrect'),l=[];s.each((function(t){S(t).each((function(t){Array.prototype.push.apply(l,y(t))}))}));var c={};c[a.dimensionInd]=a.categoryValue,o.emit(e,{points:l,event:r,constraints:c})}function P(t,e,r){var i=n.select(t).datum(),a=i.categoryViewModel.model,o=i.parcatsViewModel.graphDiv,s=S(i),l=[];s.each((function(t){Array.prototype.push.apply(l,y(t))}));var c={};c[a.dimensionInd]=a.categoryValue,void 0!==i.rawColor&&(c.color=i.rawColor),o.emit(e,{points:l,event:r,constraints:c})}function I(t,e,r){t._fullLayout._calcInverseTransform(t);var i,a,o=t._fullLayout._invScaleX,s=t._fullLayout._invScaleY,l=n.select(r.parentNode).select('rect.catrect'),c=l.node().getBoundingClientRect(),u=l.datum(),f=u.parcatsViewModel,h=f.model.dimensions[u.model.dimensionInd],p=f.trace,d=c.top+c.height/2;f.dimensions.length>1&&h.displayInd===f.dimensions.length-1?(i=c.left,a='left'):(i=c.left+c.width,a='right');var m=u.model.count,g=u.model.categoryLabel,v=m/u.parcatsViewModel.model.count,y={countLabel:m,categoryLabel:g,probabilityLabel:v.toFixed(3)},x=[];-1!==u.parcatsViewModel.hoverinfoItems.indexOf('count')&&x.push(["Count:",y.countLabel].join(' ')),-1!==u.parcatsViewModel.hoverinfoItems.indexOf('probability')&&x.push(["P('+y.categoryLabel+'):",y.probabilityLabel].join(' '));var b=x.join('<br>');return{trace:p,x:o*(i-e.left),y:s*(d-e.top),text:b,color:"lightgray",borderColor:"black",fontFamily:'Monaco, 'Courier New', monospace',fontSize:12,fontColor:"black",idealAlign:a,hovertemplate:p.hovertemplate,hovertemplateLabels:y,eventData:[data:p._input,fullData:p,count:m,category:g,probability:v]}}function z(t,e,r){var i=[];return n.select(r.parentNode.parentNode).selectAll('g.category').select('rect.catrect').each((function(){var r=this;i.push(I(t,e,r))})),i}function O(t,e,r){t._fullLayout._calcInverseTransform(t);var i,a,o=t._fullLayout._invScaleX,s=t._fullLayout._invScaleY,l=r.getBoundingClientRect(),c=n.select(r).datum(),f=c.categoryViewModel,h=f.parcatsViewModel,p=h.model.dimensions[f.model.dimensionInd],d=h.trace,m=l.y+l.height/2;h.dimensions.length>1&&p.displayInd===h.dimensions.length-1?(i=l.left,a='left'):(i=l.left+l.width,a='right');var g=f.model.categoryLabel,v=c.parcatsViewModel.model.count,y=0;c.categoryViewModel.bands.forEach((function(t){t.color===c.color&&(y+=t.count)}));var x=f.model.count,b=0;h.pathSelection.each((function(t)[t.model.color===c.color&&(b+=t.model.count)]));var _=y/v,w=y/b,T=y/x,k={countLabel:v,categoryLabel:g,probabilityLabel:_.toFixed(3)},M=[];-1!==f.parcatsViewModel.hoverinfoItems.indexOf('count')&&M.push(["Count:",k.countLabel].join(' ')),-1!==f.parcatsViewModel.hoverinfoItems.indexOf('probability')&&(M.push("P(color \u2229 '+g+'): "+k.probabilityLabel),M.push("P('+g+' | color): "+w.toFixed(3)),M.push("P(color | '+g+'): "+T.toFixed(3)));var A=M.join('<br>'),S=u.mostReadable(c.color,["black","white"]);return{trace:d,x:o*(i-e.left),y:s*(m-e.top),text:A,color:c.color,borderColor:"black",fontFamily:'Monaco, 'Courier New', monospace',fontColor:S,fontSize:10,idealAlign:a,hovertemplate:d.hovertemplate,hovertemplateLabels:k,eventData:[data:d._input,fullData:d,category:g,count:v,probability:_,categorycount:x,colorcount:b,bandcolorcount:y]}}function D(t){if(!t.parcatsViewModel.dragDimension&&-1===t.parcatsViewModel.hoverinfoItems.indexOf('skip')){if(n.mouse(this)[1]<-1)return;var e,r=t.parcatsViewModel.graphDiv,i=r._fullLayout,a=i._paperdiv.node().getBoundingClientRect(),s=t.parcatsViewModel.hoveron,l=this;"color"===s?(L(l),P(l,'plotly_hover',n.event)):(E(l),C(l,'plotly_hover',n.event)),-1===t.parcatsViewModel.hoverinfoItems.indexOf('none')&&("category"===s?e=I(r,a,l):"color"===s?e=O(r,a,l):"dimension"===s&&(e=z(r,a,l)),e&&o.loneHover(e,{container:i._hoverlayer.node(),outerContainer:i._paper.node(),gd:r}))}}function R(t){var e=t.parcatsViewModel;if(!e.dragDimension&&(_(e.pathSelection),k(e.dimensionSelection.selectAll('g.category')),A(e.dimensionSelection.selectAll('g.category').selectAll('rect.bandrect')),o.loneUnhover(e.graphDiv._fullLayout._hoverlayer.node()),e.pathSelection.sort(m),-1===e.hoverinfoItems.indexOf('skip'))){var r=this;"color"===t.parcatsViewModel.hoveron?P(r,'plotly_unhover',n.event):C(r,'plotly_unhover',n.event)}}function F(t){"fixed"!==t.parcatsViewModel.arrangement&&(t.dragDimensionDisplayInd=t.model.displayInd,t.initialDragDimensionDisplayInds=t.parcatsViewModel.model.dimensions.map((function(t){return t.displayInd})),t.dragHasMoved=!1,t.dragCategoryDisplayInd=null,n.select(this).selectAll('g.category').select('rect.catrect').each((function(e){var r=n.mouse(this)[0],i=n.mouse(this)[1];-2<=r&&r<=e.width+2&&-2<=i&&i<=e.height+2&&(t.dragCategoryDisplayInd=e.model.displayInd,t.initialDragCategoryDisplayInds=t.model.categories.map((function(t){return t.displayInd})),e.model.dragY=e.y,s.raiseToTop(this.parentNode),n.select(this.parentNode).selectAll('rect.bandrect').each((function(e)[e.y<i&&i<=e.y+e.height&&(t.potentialClickBand=this)])))})),t.parcatsViewModel.dragDimension=t,o.loneUnhover(t.parcatsViewModel.graphDiv._fullLayout._hoverlayer.node()))}function B(t){if("fixed"!==t.parcatsViewModel.arrangement&&(t.dragHasMoved=!0,null!==t.dragDimensionDisplayInd)){var e=t.dragDimensionDisplayInd,r=e-1,i=e+1,a=t.parcatsViewModel.dimensions[e];if(null!==t.dragCategoryDisplayInd){var o=a.categories[t.dragCategoryDisplayInd];o.model.dragY+=n.event.dy;var s=o.model.dragY,l=o.model.displayInd,c=a.categories,u=c[l-1],f=c[l+1];void 0!==u&&s<u.y+u.height/2&&(o.model.displayInd=u.model.displayInd,u.model.displayInd=l),void 0!==f&&s+o.height>f.y+f.height/2&&(o.model.displayInd=f.model.displayInd,f.model.displayInd=l),t.dragCategoryDisplayInd=o.model.displayInd}if(null===t.dragCategoryDisplayInd||"freeform"===t.parcatsViewModel.arrangement){a.model.dragX=n.event.x;var h=t.parcatsViewModel.dimensions[r],p=t.parcatsViewModel.dimensions[i];void 0!==h&&a.model.dragX<h.x+h.width&&(a.model.displayInd=h.model.displayInd,h.model.displayInd=e),void 0!==p&&a.model.dragX+a.width>p.x&&(a.model.displayInd=p.model.displayInd,p.model.displayInd=t.dragDimensionDisplayInd),t.dragDimensionDisplayInd=a.model.displayInd}Y(t.parcatsViewModel),G(t.parcatsViewModel),V(t.parcatsViewModel),U(t.parcatsViewModel)}}function N(t){if("fixed"!==t.parcatsViewModel.arrangement&&null!==t.dragDimensionDisplayInd){n.select(this).selectAll('text').attr('font-weight','normal');var e={},r=j(t.parcatsViewModel),i=t.parcatsViewModel.model.dimensions.map((function(t){return t.displayInd})),o=t.initialDragDimensionDisplayInds.some((function(t,e){return t!==i[e]}));o&&i.forEach((function(r,n){var i=t.parcatsViewModel.model.dimensions[n].containerInd;e["dimensions["+i+"].displayindex"]=r}));var s=!1;if(null!==t.dragCategoryDisplayInd){var l=t.model.categories.map((function(t){return t.displayInd}));if(s=t.initialDragCategoryDisplayInds.some((function(t,e){return t!==l[e]}))){var c=t.model.categories.slice().sort((function(t,e){return t.displayInd-e.displayInd})),u=c.map((function(t){return t.categoryValue})),f=c.map((function(t){return t.categoryLabel}));e["dimensions["+t.model.containerInd+"].categoryarray"]=[u],e["dimensions["+t.model.containerInd+"].ticktext"]=[f],e["dimensions["+t.model.containerInd+"].categoryorder"]="array"}}-1===t.parcatsViewModel.hoverinfoItems.indexOf('skip')&&!t.dragHasMoved&&t.potentialClickBand&&("color"===t.parcatsViewModel.hoveron?P(t.potentialClickBand,'plotly_click',n.event.sourceEvent):C(t.potentialClickBand,'plotly_click',n.event.sourceEvent)),t.model.dragX=null,null!==t.dragCategoryDisplayInd&&(t.parcatsViewModel.dimensions[t.dragDimensionDisplayInd].categories[t.dragCategoryDisplayInd].model.dragY=null,t.dragCategoryDisplayInd=null),t.dragDimensionDisplayInd=null,t.parcatsViewModel.dragDimension=null,t.dragHasMoved=null,t.potentialClickBand=null,Y(t.parcatsViewModel),G(t.parcatsViewModel),n.transition().duration(300).ease('cubic-in-out').each((function(){V(t.parcatsViewModel,!0),U(t.parcatsViewModel,!0)})).each('end',(function(){(o||s)&&a.restyle(t.parcatsViewModel.graphDiv,e,[r])}))}}function j(t){for(var e,r=t.graphDiv._fullData,n=0;n<r.length;n++)if(t.key===r[n].uid){e=n;break}return e}function U(t,e){function r(t){return e?t.transition():t}void 0===e&&(e=!1),t.pathSelection.data((function(t){return t.paths}),p),r(t.pathSelection).attr('d',(function(t){return t.svgD}))}function V(t,e){function r(t){return e?t.transition():t}void 0===e&&(e=!1),t.dimensionSelection.data((function(t){return t.dimensions}),p);var i=t.dimensionSelection.selectAll('g.category').data((function(t){return t.categories}),p);r(t.dimensionSelection).attr('transform',(function(t){return l(t.x,0)})),r(i).attr('transform',(function(t){return l(0,t.y)})),i.select('.dimlabel').text((function(t,e){return 0===e?t.parcatsViewModel.model.dimensions[t.model.dimensionInd].dimensionLabel:null})),i.select('.catlabel').attr('text-anchor',(function(t){return d(t)?"start":"end"})).attr('x',(function(t){return d(t)?t.width+5:-5})).each((function(t){var e,r;d(t)?(e=t.width+5,r='start'):(e=-5,r='end'),n.select(this).selectAll('tspan').attr('x',e).attr('text-anchor',r)}));var a=i.selectAll('rect.bandrect').data((function(t){return t.bands}),p),o=a.enter().append('rect').attr('class','bandrect').attr('cursor','move').attr('stroke-opacity',0).attr('fill',(function(t){return t.color})).attr('fill-opacity',0);a.attr('fill',(function(t){return t.color})).attr('width',(function(t){return t.width})).attr('height',(function(t){return t.height})).attr('y',(function(t){return t.y})),A(o),a.each((function()[s.raiseToTop(this)])),a.exit().remove()}function H(t,e,r){var n,i=r[0],a=e.margin||{l:80,r:80,t:100,b:80},o=i.trace,s=o.domain,l=e.width,c=e.height,u=Math.floor(l*(s.x[1]-s.x[0])),f=Math.floor(c*(s.y[1]-s.y[0])),h=s.x[0]*l+a.l,p=e.height-s.y[1]*e.height+a.t,d=o.line.shape;n="all"===o.hoverinfo?["count","probability"]:(o.hoverinfo||"").split('+');var m={trace:o,key:o.uid,model:i,x:h,y:p,width:u,height:f,hoveron:o.hoveron,hoverinfoItems:n,arrangement:o.arrangement,bundlecolors:o.bundlecolors,sortpaths:o.sortpaths,labelfont:o.labelfont,categorylabelfont:o.tickfont,pathShape:d,dragDimension:null,margin:a,paths:[],dimensions:[],graphDiv:t,traceSelection:null,pathSelection:null,dimensionSelection:null};return i.dimensions&&(Y(m),G(m)),m}function q(t,e,r,n,a){var o,s,l=[],c=[];for(s=0;s<r.length-1;s++)o=i(r[s]+t[s],t[s+1]),l.push(o(a)),c.push(o(1-a));var u="M '+t[0]+',"+e[0];for(u+="l"+r[0]+",0 ",s=1;s<r.length;s++)u+="C"+l[s-1]+",'+e[s-1]+' '+c[s-1]+','+e[s]+' '+t[s]+',"+e[s],u+="l"+r[s]+",0 ";for(u+='l0,'+n+' ',u+="l -"+r[r.length-1]+",0 ",s=r.length-2;s>=0;s--)u+="C"+c[s]+",'+(e[s+1]+n)+' '+l[s]+','+(e[s]+n)+' '+(t[s]+r[s])+',"+(e[s]+n),u+="l-"+r[s]+",0 ";return u+="Z"}function G(t){var e=t.dimensions,r=t.model,n=e.map((function(t){return t.categories.map((function(t){return t.y}))})),i=t.model.dimensions.map((function(t){return t.categories.map((function(t){return t.displayInd}))})),a=t.model.dimensions.map((function(t){return t.displayInd})),o=t.dimensions.map((function(t){return t.model.dimensionInd})),s=e.map((function(t){return t.x})),l=e.map((function(t){return t.width})),c=[];for(var u in r.paths)r.paths.hasOwnProperty(u)&&c.push(r.paths[u]);function f(t){var e=t.categoryInds.map((function(t,e){return i[e][t]}));return o.map((function(t){return e[t]}))}c.sort((function(e,r){var n=f(e),i=f(r);return"backward"===t.sortpaths&&(n.reverse(),i.reverse()),n.push(e.valueInds[0]),i.push(r.valueInds[0]),t.bundlecolors&&(n.unshift(e.rawColor),i.unshift(r.rawColor)),n<i?-1:n>i?1:0}));for(var h=new Array(c.length),p=e[0].model.count,d=e[0].categories.map((function(t){return t.height})).reduce((function(t,e){return t+e})),m=0;m<c.length;m++){var g,v=c[m];g=p>0?d*(v.count/p):0;for(var y,x=new Array(n.length),b=0;b<v.categoryInds.length;b++){var _=v.categoryInds[b],w=i[b][_],T=a[b];x[T]=n[T][w],n[T][w]+=g;var k=t.dimensions[T].categories[w],M=k.bands.length,A=k.bands[M-1];if(void 0===A||v.rawColor!==A.rawColor){var S=void 0===A?0:A.y+A.height;k.bands.push({key:S,color:v.color,rawColor:v.rawColor,height:g,width:k.width,count:v.count,y:S,categoryViewModel:k,parcatsViewModel:t})}else{var E=k.bands[M-1];E.height+=g,E.count+=v.count}}y="hspline"===t.pathShape?q(s,x,l,g,.5):q(s,x,l,g,0),h[m]={key:v.valueInds[0],model:v,height:g,leftXs:s,topYs:x,dimWidths:l,svgD:y,parcatsViewModel:t}}t.paths=h}function Y(t){var e=t.model.dimensions.map((function(t){return{displayInd:t.displayInd,dimensionInd:t.dimensionInd}}));e.sort((function(t,e){return t.displayInd-e.displayInd}));var r=[];for(var n in e){var i=e[n].dimensionInd,a=t.model.dimensions[i];r.push(W(t,a))}t.dimensions=r}function W(t,e){var r,n=40,i=16,a=t.model.dimensions.length,o=e.displayInd;r=n+(a>1?(t.width-2*n-i)/(a-1):0)*o;var s,l,c,u,f,h=[],p=t.model.maxCats,d=e.categories.length,m=8,g=e.count,v=t.height-m*(p-1),y=(p-d)*m/2,x=e.categories.map((function(t){return{displayInd:t.displayInd,categoryInd:t.categoryInd}}));for(x.sort((function(t,e){return t.displayInd-e.displayInd})),f=0;f<d;f++)u=x[f].categoryInd,l=e.categories[u],s=g>0?l.count/g*v:0,c={key:l.valueInds[0],model:l,width:i,height:s,y:null!==l.dragY?l.dragY:y,bands:[],parcatsViewModel:t},y=y+s+m,h.push(c);return{key:e.dimensionInd,x:null!==e.dragX?e.dragX:r,y:0,width:i,model:e,categories:h,parcatsViewModel:t,dragCategoryDisplayInd:null,dragDimensionDisplayInd:null,initialDragDimensionDisplayInds:null,initialDragCategoryDisplayInds:null,dragHasMoved:null,potentialClickBand:null}}e.exports=function(t,e,r,n){h(r,t,n,e)}},{"../../components/drawing":672,"../../components/fx":690,"../../lib":787,"../../lib/svg_text_utils":813,"../../plot_api/plot_api":824,"@plotly/d3":58,"d3-interpolate":168,tinycolor2:583}],1163:[function(t,e,r){"use strict";var n=t('./parcats');e.exports=function(t,e,r,i){var a=t._fullLayout,o=a._paper,s=a._size;n(t,o,e,{width:s.w,height:s.h,margin:{t:s.t,r:s.r,b:s.b,l:s.l}},r,i)}},{"./parcats":1162}],1164:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../../plots/cartesian/layout_attributes'),a=t('../../plots/font_attributes'),o=t('../../plots/domain').attributes,s=t('../../lib/extend').extendFlat,l=t('../../plot_api/plot_template').templatedArray;e.exports={domain:o({name:"parcoords",trace:!0,editType:"plot"}),labelangle:{valType:"angle",dflt:0,editType:"plot"},labelside:{valType:"enumerated",values:["top","bottom"],dflt:"top",editType:"plot"},labelfont:a({editType:"plot"}),tickfont:a({editType:"plot"}),rangefont:a({editType:"plot"}),dimensions:l('dimension',{label:{valType:"string",editType:"plot"},tickvals:s({},i.tickvals,{editType:"plot"}),ticktext:s({},i.ticktext,{editType:"plot"}),tickformat:s({},i.tickformat,{editType:"plot"}),visible:{valType:"boolean",dflt:!0,editType:"plot"},range:{valType:"info_array",items:[{valType:"number",editType:"plot"},{valType:"number",editType:"plot"}],editType:"plot"},constraintrange:{valType:"info_array",freeLength:!0,dimensions:"1-2",items:[{valType:"any",editType:"plot"},{valType:"any",editType:"plot"}],editType:"plot"},multiselect:{valType:"boolean",dflt:!0,editType:"plot"},values:{valType:"data_array",editType:"calc"},editType:"calc"}),line:s({editType:"calc"},n('line',{colorscaleDflt:"Viridis",autoColorDflt:!1,editTypeOverride:"calc"}))}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/plot_template":827,"../../plots/cartesian/layout_attributes":853,"../../plots/domain":866,"../../plots/font_attributes":867}],1165:[function(t,e,r){"use strict";var n=t('./constants'),i=t('@plotly/d3'),a=t('../../lib/gup').keyFun,o=t('../../lib/gup').repeat,s=t('../../lib').sorterAsc,l=t('../../lib').strTranslate,c=n.bar.snapRatio;function u(t,e){return t*(1-c)+e*c}var f=n.bar.snapClose;function h(t,e){return t*(1-f)+e*f}function p(t,e,r,n){if(d(r,n))return r;var i=t?-1:1,a=0,o=e.length-1;if(i<0){var s=a;a=o,o=s}for(var l=e[a],c=l,f=a;i*f<i*o;f+=i){var p=f+i,m=e[p];if(i*r<i*h(l,m))return u(l,c);if(i*r<i*m||p===o)return u(m,l);c=l,l=m}}function d(t,e){for(var r=0;r<e.length;r++)if(t>=e[r][0]&&t<=e[r][1])return!0;return!1}function m(t){t.attr('x',-n.bar.captureWidth/2).attr('width',n.bar.captureWidth)}function g(t){t.attr('visibility','visible').style('visibility','visible').attr('fill','yellow').attr('opacity',0)}function v(t){if(!t.brush.filterSpecified)return"0,"+t.height;for(var e,r,n,i=y(t.brush.filter.getConsolidated(),t.height),a=[0],o=i.length?i[0][0]:null,s=0;s<i.length;s++)r=(e=i[s])[1]-e[0],a.push(o),a.push(r),(n=s+1)<i.length&&(o=i[n][0]-e[1]);return a.push(t.height),a}function y(t,e){return t.map((function(t){return t.map((function(t){return Math.max(0,t*e)})).sort(s)}))}function x(t,e){var r=n.bar.handleHeight;if(!(e>t[1]+r||e<t[0]-r))return e>=.9*t[1]+.1*t[0]?"n":e<=.9*t[0]+.1*t[1]?"s":"ns"}function b(){i.select(document.body).style('cursor',null)}function _(t){t.attr('stroke-dasharray',v)}function w(t,e){var r=i.select(t).selectAll('.highlight, .highlight-shadow');_(e?r.transition().duration(n.bar.snapDuration).each('end',e):r)}function T(t,e){var r,n=t.brush,i=NaN,a={};if(n.filterSpecified){var o=t.height,s=n.filter.getConsolidated(),l=y(s,o),c=NaN,u=NaN,f=NaN;for(r=0;r<=l.length;r++){var h=l[r];if(h&&h[0]<=e&&e<=h[1]){c=r;break}if(u=r?r-1:NaN,h&&h[0]>e){f=r;break}}if(i=c,isNaN(i)&&(i=isNaN(u)||isNaN(f)?isNaN(u)?f:u:e-l[u][1]<l[f][0]-e?u:f),!isNaN(i)){var p=l[i],d=x(p,e);d&&(a.interval=s[i],a.intervalPix=p,a.region=d)}}if(t.ordinal&&!a.region){var m=t.unitTickvals,g=t.unitToPaddedPx.invert(e);for(r=0;r<m.length;r++){var v=[.25*m[Math.max(r-1,0)]+.75*m[r],.25*m[Math.min(r+1,m.length-1)]+.75*m[r]];if(g>=v[0]&&g<=v[1]){a.clickableOrdinalRange=v;break}}}return a}function k(t,e){i.event.sourceEvent.stopPropagation();var r=e.height-i.mouse(t)[1]-2*n.verticalPadding,a=e.unitToPaddedPx.invert(r),o=e.brush,s=T(e,r),l=s.interval,c=o.svgBrush;if(c.wasDragged=!1,c.grabbingBar="ns"===s.region,c.grabbingBar){var u=l.map(e.unitToPaddedPx);c.grabPoint=r-u[0]-n.verticalPadding,c.barLength=u[1]-u[0]}c.clickableOrdinalRange=s.clickableOrdinalRange,c.stayingIntervals=e.multiselect&&o.filterSpecified?o.filter.getConsolidated():[],l&&(c.stayingIntervals=c.stayingIntervals.filter((function(t){return t[0]!==l[0]&&t[1]!==l[1]}))),c.startExtent=s.region?l["s"===s.region?1:0]:a,e.parent.inBrushDrag=!0,c.brushStartCallback()}function M(t,e){i.event.sourceEvent.stopPropagation();var r=e.height-i.mouse(t)[1]-2*n.verticalPadding,a=e.brush.svgBrush;a.wasDragged=!0,a._dragging=!0,a.grabbingBar?a.newExtent=[r-a.grabPoint,r+a.barLength-a.grabPoint].map(e.unitToPaddedPx.invert):a.newExtent=[a.startExtent,e.unitToPaddedPx.invert(r)].sort(s),e.brush.filterSpecified=!0,a.extent=a.stayingIntervals.concat([a.newExtent]),a.brushCallback(e),w(t.parentNode)}function A(t,e){var r=e.brush,n=r.filter,a=r.svgBrush;a._dragging||(S(t,e),M(t,e),e.brush.svgBrush.wasDragged=!1),a._dragging=!1,i.event.sourceEvent.stopPropagation();var o=a.grabbingBar;if(a.grabbingBar=!1,a.grabLocation=void 0,e.parent.inBrushDrag=!1,b(),!a.wasDragged)return a.wasDragged=void 0,a.clickableOrdinalRange?r.filterSpecified&&e.multiselect?a.extent.push(a.clickableOrdinalRange):(a.extent=[a.clickableOrdinalRange],r.filterSpecified=!0):o?(a.extent=a.stayingIntervals,0===a.extent.length&&z(r)):z(r),a.brushCallback(e),w(t.parentNode),void a.brushEndCallback(r.filterSpecified?n.getConsolidated():[]);var s=function(){n.set(n.getConsolidated())};if(e.ordinal){var l=e.unitTickvals;l[l.length-1]<l[0]&&l.reverse(),a.newExtent=[p(0,l,a.newExtent[0],a.stayingIntervals),p(1,l,a.newExtent[1],a.stayingIntervals)];var c=a.newExtent[1]>a.newExtent[0];a.extent=a.stayingIntervals.concat(c?[a.newExtent]:[]),a.extent.length||z(r),a.brushCallback(e),c?w(t.parentNode,s):(s(),w(t.parentNode))}else s();a.brushEndCallback(r.filterSpecified?n.getConsolidated():[])}function S(t,e){var r=T(e,e.height-i.mouse(t)[1]-2*n.verticalPadding),a='crosshair';r.clickableOrdinalRange?a="pointer":r.region&&(a=r.region+"-resize"),i.select(document.body).style('cursor',a)}function E(t){t.on('mousemove',(function(t){i.event.preventDefault(),t.parent.inBrushDrag||S(this,t)})).on('mouseleave',(function(t)[t.parent.inBrushDrag||b()])).call(i.behavior.drag().on('dragstart',(function(t){k(this,t)})).on('drag',(function(t){M(this,t)})).on('dragend',(function(t){A(this,t)})))}function L(t,e){return t[0]-e[0]}function C(t,e){var r=t.selectAll('.background').data(o);r.enter().append('rect').classed('background',!0).call(m).call(g).style('pointer-events','auto').attr('transform',l(0,n.verticalPadding)),r.call(E).attr('height',(function(t){return t.height-n.verticalPadding}));var i=t.selectAll('.highlight-shadow').data(o);i.enter().append('line').classed('highlight-shadow',!0).attr('x',-n.bar.width/2).attr('stroke-width',n.bar.width+n.bar.strokeWidth).attr('stroke',e).attr('opacity',n.bar.strokeOpacity).attr('stroke-linecap','butt'),i.attr('y1',(function(t){return t.height})).call(_);var a=t.selectAll('.highlight').data(o);a.enter().append('line').classed('highlight',!0).attr('x',-n.bar.width/2).attr('stroke-width',n.bar.width-n.bar.strokeWidth).attr('stroke',n.bar.fillColor).attr('opacity',n.bar.fillOpacity).attr('stroke-linecap','butt'),a.attr('y1',(function(t){return t.height})).call(_)}function P(t,e){var r=t.selectAll("."+n.cn.axisBrush).data(o,a);r.enter().append('g').classed(n.cn.axisBrush,!0),C(r,e)}function I(t){return t.svgBrush.extent.map((function(t){return t.slice()}))}function z(t){t.filterSpecified=!1,t.svgBrush.extent=[[-1/0,1/0]]}function O(t){return function(e){var r=e.brush,n=I(r).slice();r.filter.set(n),t()}}function D(t){for(var e,r=t.slice(),n=[],i=r.shift();i;){for(e=i.slice();(i=r.shift())&&i[0]<=e[1];)e[1]=Math.max(e[1],i[1]);n.push(e)}return 1===n.length&&n[0][0]>n[0][1]&&(n=[]),n}function R(){var t,e,r=[];return{set:function(n){1===(r=n.map((function(t){return t.slice().sort(s)})).sort(L)).length&&r[0][0]===-1/0&&r[0][1]===1/0&&(r=[[0,-1]]),t=D(r),e=r.reduce((function(t,e){return[Math.min(t[0],e[0]),Math.max(t[1],e[1])]}),[1/0,-1/0])},get:function(){return r.slice()},getConsolidated:function(){return t},getBounds:function(){return e}}}function F(t,e,r,n,i,a){var o=R();return o.set(r),{filter:o,filterSpecified:e,svgBrush:{extent:[],brushStartCallback:n,brushCallback:O(i),brushEndCallback:a}}}function B(t,e){if(Array.isArray(t[0])?(t=t.map((function(t){return t.sort(s)})),t=e.multiselect?D(t.sort(L)):[t[0]]):t=[t.sort(s)],e.tickvals){var r=e.tickvals.slice().sort(s);if(!(t=t.map((function(t){var e=[p(0,r,t[0],[]),p(1,r,t[1],[])];if(e[1]>e[0])return e})).filter((function(t){return t}))).length)return}return t.length>1?t:t[0]}e.exports={makeBrush:F,ensureAxisBrush:P,cleanRanges:B}},{"../../lib":787,"../../lib/gup":784,"./constants":1168,"@plotly/d3":58}],1166:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../plots/get_data').getModuleCalcData,a=t('./plot'),o=t('../../constants/xmlns_namespaces');r.name='parcoords',r.plot=function(t){var e=i(t.calcdata,'parcoords')[0];e.length&&a(t,e)},r.clean=function(t,e,r,n){var i=n._has&&n._has('parcoords'),a=e._has&&e._has('parcoords');i&&!a&&(n._paperdiv.selectAll('.parcoords').remove(),n._glimages.selectAll('*').remove())},r.toSVG=function(t){var e=t._fullLayout._glimages,r=n.select(t).selectAll('.svg-container');function i(){var t=this,r=t.toDataURL('image/png');e.append('svg:image').attr({xmlns:o.svg,"xlink:href":r,preserveAspectRatio:"none",x:0,y:0,width:t.style.width,height:t.style.height})}r.filter((function(t,e){return e===r.size()-1})).selectAll('.gl-canvas-context, .gl-canvas-focus').each(i),window.setTimeout((function(){n.selectAll('#filterBarPattern').attr('id','filterBarPattern')}),60)}},{"../../constants/xmlns_namespaces":764,"../../plots/get_data":875,"./plot":1175,"@plotly/d3":58}],1167:[function(t,e,r){"use strict";var n=t('../../lib').isArrayOrTypedArray,i=t('../../components/colorscale'),a=t('../../lib/gup').wrap;function o(t){for(var e=new Array(t),r=0;r<t;r++)e[r]=.5;return e}e.exports=function(t,e){var r,s;return i.hasColorscale(e,'line')&&n(e.line.color)?(r=e.line.color,s=i.extractOpts(e.line).colorscale,i.calc(t,e,{vals:r,containerStr:"line",cLetter:"c"})):(r=o(e._length),s=[[0,e.line.color],[1,e.line.color]]),a({lineColor:r,cscale:s})}},{"../../components/colorscale":662,"../../lib":787,"../../lib/gup":784}],1168:[function(t,e,r){"use strict";e.exports={maxDimensionCount:60,overdrag:45,verticalPadding:2,tickDistance:50,canvasPixelRatio:1,blockLineCount:5e3,layers:["contextLineLayer",'focusLineLayer',"pickLineLayer"],axisTitleOffset:28,axisExtentOffset:10,deselectedLineColor:"#777",bar:{width:4,captureWidth:10,fillColor:"magenta",fillOpacity:1,snapDuration:150,snapRatio:.25,snapClose:.01,strokeOpacity:1,strokeWidth:1,handleHeight:8,handleOpacity:1,handleOverlap:0},cn:{axisExtentText:"axis-extent-text",parcoordsLineLayers:"parcoords-line-layers",parcoordsLineLayer:"parcoords-lines",parcoords:"parcoords",parcoordsControlView:"parcoords-control-view",yAxis:"y-axis",axisOverlays:"axis-overlays",axis:"axis",axisHeading:"axis-heading",axisTitle:"axis-title",axisExtent:"axis-extent",axisExtentTop:"axis-extent-top",axisExtentTopText:"axis-extent-top-text",axisExtentBottom:"axis-extent-bottom",axisExtentBottomText:"axis-extent-bottom-text",axisBrush:"axis-brush"},id:{filterBarPattern:"filter-bar-pattern"}}},{}],1169:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/helpers').hasColorscale,a=t('../../components/colorscale/defaults'),o=t('../../plots/domain').defaults,s=t('../../plots/array_container_defaults'),l=t('../../plots/cartesian/axes'),c=t('./attributes'),u=t('./axisbrush'),f=t('./constants').maxDimensionCount,h=t('./merge_length');function p(t,e,r,o,s){var l=s('line.color',r);if(i(t,'line')&&n.isArrayOrTypedArray(l)){if(l.length)return s('line.colorscale'),a(t,e,o,s,{prefix:"line.",cLetter:"c"}),l.length;e.line.color=r}return 1/0}function d(t,e,r,i){function a(r,i){return n.coerce(t,e,c.dimensions,r,i)}var o=a('values'),s=a('visible');if(o&&o.length||(s=e.visible=!1),s){a('label'),a('tickvals'),a('ticktext'),a('tickformat');var f=a('range');e._ax={_id:"y",type:"linear",showexponent:"all",exponentformat:"B",range:f},l.setConvert(e._ax,i.layout),a('multiselect');var h=a('constraintrange');h&&(e.constraintrange=u.cleanRanges(h,e))}}e.exports=function(t,e,r,i){function a(r,i){return n.coerce(t,e,c,r,i)}var l=t.dimensions;Array.isArray(l)&&l.length>f&&(n.log('parcoords traces support up to '+f+' dimensions at the moment'),l.splice(f));var u=s(t,e,{name:"dimensions",layout:i,handleItemDefaults:d}),m=p(t,e,r,i,a);o(e,i,a),Array.isArray(u)&&u.length||(e.visible=!1),h(e,u,'values',m);var g={family:i.font.family,size:Math.round(i.font.size/1.2),color:i.font.color};n.coerceFont(a,'labelfont',g),n.coerceFont(a,'tickfont',g),n.coerceFont(a,'rangefont',g),a('labelangle'),a('labelside')}},{"../../components/colorscale/defaults":660,"../../components/colorscale/helpers":661,"../../lib":787,"../../plots/array_container_defaults":833,"../../plots/cartesian/axes":838,"../../plots/domain":866,"./attributes":1164,"./axisbrush":1165,"./constants":1168,"./merge_length":1173}],1170:[function(t,e,r){"use strict";var n=t('../../lib').isTypedArray;r.convertTypedArray=function(t){return n(t)?Array.prototype.slice.call(t):t},r.isOrdinal=function(t){return!!t.tickvals},r.isVisible=function(t){return t.visible||!("visible"in t)}},{"../../lib":787}],1171:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot'),colorbar:{container:"line",min:"cmin",max:"cmax"},moduleType:"trace",name:"parcoords",basePlotModule:t('./base_plot'),categories:["gl",'regl','noOpacity',"noHover"],meta:{}}},{"./attributes":1164,"./base_plot":1166,"./calc":1167,"./defaults":1169,"./plot":1175}],1172:[function(t,e,r){"use strict";var n=t('glslify'),i=n(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nattribute vec4 p01_04, p05_08, p09_12, p13_16,\n               p17_20, p21_24, p25_28, p29_32,\n               p33_36, p37_40, p41_44, p45_48,\n               p49_52, p53_56, p57_60, colors;\n\nuniform mat4 dim0A, dim1A, dim0B, dim1B, dim0C, dim1C, dim0D, dim1D,\n             loA, hiA, loB, hiB, loC, hiC, loD, hiD;\n\nuniform vec2 resolution, viewBoxPos, viewBoxSize;\nuniform float maskHeight;\nuniform float drwLayer; // 0: context, 1: focus, 2: pick\nuniform vec4 contextColor;\nuniform sampler2D maskTexture, palette;\n\nbool isPick    = (drwLayer > 1.5);\nbool isContext = (drwLayer < 0.5);\n\nconst vec4 ZEROS = vec4(0.0, 0.0, 0.0, 0.0);\nconst vec4 UNITS = vec4(1.0, 1.0, 1.0, 1.0);\n\nfloat val(mat4 p, mat4 v) {\n    return dot(matrixCompMult(p, v) * UNITS, UNITS);\n}\n\nfloat axisY(float ratio, mat4 A, mat4 B, mat4 C, mat4 D) {\n    float y1 = val(A, dim0A) + val(B, dim0B) + val(C, dim0C) + val(D, dim0D);\n    float y2 = val(A, dim1A) + val(B, dim1B) + val(C, dim1C) + val(D, dim1D);\n    return y1 * (1.0 - ratio) + y2 * ratio;\n}\n\nint iMod(int a, int b) {\n    return a - b * (a / b);\n}\n\nbool fOutside(float p, float lo, float hi) {\n    return (lo < hi) && (lo > p || p > hi);\n}\n\nbool vOutside(vec4 p, vec4 lo, vec4 hi) {\n    return (\n        fOutside(p[0], lo[0], hi[0]) ||\n        fOutside(p[1], lo[1], hi[1]) ||\n        fOutside(p[2], lo[2], hi[2]) ||\n        fOutside(p[3], lo[3], hi[3])\n    );\n}\n\nbool mOutside(mat4 p, mat4 lo, mat4 hi) {\n    return (\n        vOutside(p[0], lo[0], hi[0]) ||\n        vOutside(p[1], lo[1], hi[1]) ||\n        vOutside(p[2], lo[2], hi[2]) ||\n        vOutside(p[3], lo[3], hi[3])\n    );\n}\n\nbool outsideBoundingBox(mat4 A, mat4 B, mat4 C, mat4 D) {\n    return mOutside(A, loA, hiA) ||\n           mOutside(B, loB, hiB) ||\n           mOutside(C, loC, hiC) ||\n           mOutside(D, loD, hiD);\n}\n\nbool outsideRasterMask(mat4 A, mat4 B, mat4 C, mat4 D) {\n    mat4 pnts[4];\n    pnts[0] = A;\n    pnts[1] = B;\n    pnts[2] = C;\n    pnts[3] = D;\n\n    for(int i = 0; i < 4; ++i) {\n        for(int j = 0; j < 4; ++j) {\n            for(int k = 0; k < 4; ++k) {\n                if(0 == iMod(\n                    int(255.0 * texture2D(maskTexture,\n                        vec2(\n                            (float(i * 2 + j / 2) + 0.5) / 8.0,\n                            (pnts[i][j][k] * (maskHeight - 1.0) + 1.0) / maskHeight\n                        ))[3]\n                    ) / int(pow(2.0, float(iMod(j * 4 + k, 8)))),\n                    2\n                )) return true;\n            }\n        }\n    }\n    return false;\n}\n\nvec4 position(bool isContext, float v, mat4 A, mat4 B, mat4 C, mat4 D) {\n    float x = 0.5 * sign(v) + 0.5;\n    float y = axisY(x, A, B, C, D);\n    float z = 1.0 - abs(v);\n\n    z += isContext ? 0.0 : 2.0 * float(\n        outsideBoundingBox(A, B, C, D) ||\n        outsideRasterMask(A, B, C, D)\n    );\n\n    return vec4(\n        2.0 * (vec2(x, y) * viewBoxSize + viewBoxPos) / resolution - 1.0,\n        z,\n        1.0\n    );\n}\n\nvoid main() {\n    mat4 A = mat4(p01_04, p05_08, p09_12, p13_16);\n    mat4 B = mat4(p17_20, p21_24, p25_28, p29_32);\n    mat4 C = mat4(p33_36, p37_40, p41_44, p45_48);\n    mat4 D = mat4(p49_52, p53_56, p57_60, ZEROS);\n\n    float v = colors[3];\n\n    gl_Position = position(isContext, v, A, B, C, D);\n\n    fragColor =\n        isContext ? vec4(contextColor) :\n        isPick ? vec4(colors.rgb, 1.0) : texture2D(palette, vec2(abs(v), 0.5));\n}\n"]),a=n(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nvoid main() {\n    gl_FragColor = fragColor;\n}\n"]),o=t('./constants').maxDimensionCount,s=t('../../lib'),l=1e-6,c=2048,u=new Uint8Array(4),f=new Uint8Array(4),h={shape:[256,1],format:"rgba",type:"uint8",mag:"nearest",min:"nearest"};function p(t){t.read({x:0,y:0,width:1,height:1,data:u})}function d(t,e,r,n,i){var a=t._gl;a.enable(a.SCISSOR_TEST),a.scissor(e,r,n,i),t.clear({color:[0,0,0,0],depth:1})}function m(t,e,r,n,i,a){var o=a.key;function s(l){var c=Math.min(n,i-l*n);0===l&&(window.cancelAnimationFrame(r.currentRafs[o]),delete r.currentRafs[o],d(t,a.scissorX,a.scissorY,a.scissorWidth,a.viewBoxSize[1])),r.clearOnly||(a.count=2*c,a.offset=2*l*n,e(a),l*n+c<i&&(r.currentRafs[o]=window.requestAnimationFrame((function(){s(l+1)}))),r.drawCompleted=!1)}r.drawCompleted||(p(t),r.drawCompleted=!0),s(0)}function g(t){return Math.max(l,Math.min(1-l,t))}function v(t,e){for(var r=new Array(256),n=0;n<256;n++)r[n]=t(n/255).concat(e);return r}function y(t,e){return(t>>>8*e)%256/255}function x(t,e,r){for(var n=new Array(t*(o+4)),i=0,a=0;a<t;a++){for(var s=0;s<o;s++)n[i++]=s<e.length?e[s].paddedUnitValues[a]:.5;n[i++]=y(a,2),n[i++]=y(a,1),n[i++]=y(a,0),n[i++]=g(r[a])}return n}function b(t,e,r){for(var n=new Array(8*e),i=0,a=0;a<e;a++)for(var o=0;o<2;o++)for(var s=0;s<4;s++){var l=4*t+s,c=r[64*a+l];63===l&&0===o&&(c*=-1),n[i++]=c}return n}function _(t){var e="0"+t;return e.substr(e.length-2)}function w(t){return t<o?"p"+_(t+1)+"_"+_(t+4):"colors"}function T(t,e,r){for(var n=0;n<=o;n+=4)t[w(n)](b(n/4,e,r))}function k(t)[for(var e={],r=0;r<=o;r+=4)e[w(r)]=t.buffer({usage:"dynamic",type:"float",data:new Uint8Array(0)});return e}function M(t,e,r,n,i,a,o,l,c,u,f,h,p,d){for(var m=[[],[]],g=0;g<64;g++)m[0][g]=g===i?1:0,m[1][g]=g===a?1:0;o*=d,l*=d,c*=d,u*=d;var v=t.lines.canvasOverdrag*d,y=t.domain,x=t.canvasWidth*d,b=t.canvasHeight*d,_=t.pad.l*d,w=t.pad.b*d,T=t.layoutHeight*d,k=t.layoutWidth*d,M=t.deselectedLines.color;return s.extendFlat({key:f,resolution:[x,b],viewBoxPos:[o+v,l],viewBoxSize:[c,u],i0:i,i1:a,dim0A:m[0].slice(0,16),dim0B:m[0].slice(16,32),dim0C:m[0].slice(32,48),dim0D:m[0].slice(48,64),dim1A:m[1].slice(0,16),dim1B:m[1].slice(16,32),dim1C:m[1].slice(32,48),dim1D:m[1].slice(48,64),drwLayer:h,contextColor:[M[0]/255,M[1]/255,M[2]/255,M[3]<1?M[3]:Math.max(1/255,Math.pow(1/t.lines.color.length,1/3))],scissorX:(n===e?0:o+v)+(_-v)+k*y.x[0],scissorWidth:(n===r?x-o+v:c+.5)+(n===e?o+v:0),scissorY:l+w+T*y.y[0],scissorHeight:u,viewportX:_-v+k*y.x[0],viewportY:w+T*y.y[0],viewportWidth:x,viewportHeight:b},p)}function A(t){var e=c-1,r=Math.max(0,Math.floor(t[0]*e),0),n=Math.min(e,Math.ceil(t[1]*e),e);return[Math.min(r,n),Math.max(r,n)]}e.exports=function(t,e){var r,n,o,l,u,p=e.context,g=e.pick,y=e.regl,b=y._gl,_=b.getParameter(b.ALIASED_LINE_WIDTH_RANGE),w=Math.max(_[0],Math.min(_[1],e.viewModel.plotGlPixelRatio)),S={currentRafs:{},drawCompleted:!0,clearOnly:!1},E=k(y),L=y.texture(h),C=[];I(e);var P=y({profile:!1,blend:{enable:p,func:{srcRGB:"src alpha",dstRGB:"one minus src alpha",srcAlpha:1,dstAlpha:1},equation:{rgb:"add",alpha:"add"},color:[0,0,0,0]},depth:{enable:!p,mask:!0,func:"less",range:[0,1]},cull:{enable:!0,face:"back"},scissor:{enable:!0,box:{x:y.prop('scissorX'),y:y.prop('scissorY'),width:y.prop('scissorWidth'),height:y.prop('scissorHeight')}},viewport:{x:y.prop('viewportX'),y:y.prop('viewportY'),width:y.prop('viewportWidth'),height:y.prop('viewportHeight')},dither:!1,vert:i,frag:a,primitive:"lines",lineWidth:w,attributes:E,uniforms:{resolution:y.prop('resolution'),viewBoxPos:y.prop('viewBoxPos'),viewBoxSize:y.prop('viewBoxSize'),dim0A:y.prop('dim0A'),dim1A:y.prop('dim1A'),dim0B:y.prop('dim0B'),dim1B:y.prop('dim1B'),dim0C:y.prop('dim0C'),dim1C:y.prop('dim1C'),dim0D:y.prop('dim0D'),dim1D:y.prop('dim1D'),loA:y.prop('loA'),hiA:y.prop('hiA'),loB:y.prop('loB'),hiB:y.prop('hiB'),loC:y.prop('loC'),hiC:y.prop('hiC'),loD:y.prop('loD'),hiD:y.prop('hiD'),palette:L,contextColor:y.prop('contextColor'),maskTexture:y.prop('maskTexture'),drwLayer:y.prop('drwLayer'),maskHeight:y.prop('maskHeight')},offset:y.prop('offset'),count:y.prop('count')});function I(t){r=t.model,n=t.viewModel,o=n.dimensions.slice(),l=o[0]?o[0].values.length:0;var e=r.lines,i=g?e.color.map((function(t,r){return r/e.color.length})):e.color,a=x(l,o,i);T(E,l,a),p||g||(L=y.texture(s.extendFlat({data:v(r.unitToColor,255)},h)))}function z(t){var e,r,n,i=[[],[]];for(n=0;n<64;n++){var a=!t&&n<o.length?o[n].brush.filter.getBounds():[-1/0,1/0];i[0][n]=a[0],i[1][n]=a[1]}var s=8*c,l=new Array(s);for(e=0;e<s;e++)l[e]=255;if(!t)for(e=0;e<o.length;e++){var f=e%8,h=(e-f)/8,p=Math.pow(2,f),d=o[e].brush.filter.get();if(!(d.length<2)){var m=A(d[0])[1];for(r=1;r<d.length;r++){var g=A(d[r]);for(n=m+1;n<g[0];n++)l[8*n+h]&=~p;m=Math.max(m,g[1])}}}var v={shape:[8,c],format:"alpha",type:"uint8",mag:"nearest",min:"nearest",data:l};return u?u(v):u=y.texture(v),{maskTexture:u,maskHeight:c,loA:i[0].slice(0,16),loB:i[0].slice(16,32),loC:i[0].slice(32,48),loD:i[0].slice(48,64),hiA:i[1].slice(0,16),hiB:i[1].slice(16,32),hiC:i[1].slice(32,48),hiD:i[1].slice(48,64)}}function O(t,e,n){var i,a,o,s=t.length,c=1/0,u=-1/0;for(i=0;i<s;i++)t[i].dim0.canvasX<c&&(c=t[i].dim0.canvasX,a=i),t[i].dim1.canvasX>u&&(u=t[i].dim1.canvasX,o=i);0===s&&d(y,0,0,r.canvasWidth,r.canvasHeight);var f=z(p);for(i=0;i<s;i++){var h=t[i],v=h.dim0.crossfilterDimensionIndex,x=h.dim1.crossfilterDimensionIndex,b=h.canvasX,_=h.canvasY,w=b+h.panelSizeX,T=h.plotGlPixelRatio;if(e||!C[v]||C[v][0]!==b||C[v][1]!==w){C[v]=[b,w];var k=M(r,a,o,i,v,x,b,_,h.panelSizeX,h.panelSizeY,h.dim0.crossfilterDimensionIndex,p?0:g?2:1,f,T);S.clearOnly=n;var A=e?r.lines.blockLineCount:l;m(y,P,S,A,l,k)}}}function D(t,e){return y.read({x:t,y:e,width:1,height:1,data:f}),f}function R(t,e,r,n){var i=new Uint8Array(4*r*n);return y.read({x:t,y:e,width:r,height:n,data:i}),i}function F(){for(var e in t.style["pointer-events"]='none',L.destroy(),u&&u.destroy(),E)E[e].destroy()}return{render:O,readPixel:D,readPixels:R,destroy:F,update:I}}},{"../../lib":787,"./constants":1168,glslify:434}],1173:[function(t,e,r){"use strict";e.exports=function(t,e,r,n){var i,a;for(n||(n=1/0),i=0;i<e.length;i++)(a=e[i]).visible&&(n=Math.min(n,a[r].length));for(n===1/0&&(n=0),t._length=n,i=0;i<e.length;i++)(a=e[i]).visible&&(a._length=n);return n}},{}],1174:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=i.numberFormat,o=t('color-rgba'),s=t('../../plots/cartesian/axes'),l=i.strRotate,c=i.strTranslate,u=t('../../lib/svg_text_utils'),f=t('../../components/drawing'),h=t('../../components/colorscale'),p=t('../../lib/gup'),d=p.keyFun,m=p.repeat,g=p.unwrap,v=t('./helpers'),y=t('./constants'),x=t('./axisbrush'),b=t('./lines');function _(t,e,r){return i.aggNums(t,null,e,r)}function w(t,e){return k(_(Math.min,t,e),_(Math.max,t,e))}function T(t){var e=t.range;return e?k(e[0],e[1]):w(t.values,t._length)}function k(t,e){return!isNaN(t)&&isFinite(t)||(t=0),!isNaN(e)&&isFinite(e)||(e=0),t===e&&(0===t?(t-=1,e+=1):(t*=.9,e*=1.1)),[t,e]}function M(t,e){return e?function(r,n){var i=e[n];return null===i||void 0===i?t(r):i}:t}function A(t,e,r,i,o){var s=T(r);return i?n.scale.ordinal().domain(i.map(M(a(r.tickformat),o))).range(i.map((function(r){var n=(r-s[0])/(s[1]-s[0]);return t-e+n*(2*e-t)}))):n.scale.linear().domain(s).range([t-e,e])}function S(t,e){return n.scale.linear().range([e,t-e])}function E(t,e){return n.scale.linear().domain(T(t)).range([e,1-e])}function L(t){if(t.tickvals){var e=T(t);return n.scale.ordinal().domain(t.tickvals).range(t.tickvals.map((function(t){return(t-e[0])/(e[1]-e[0])})))}}function C(t){var e=t.map((function(t){return t[0]})),r=t.map((function(t){var e=o(t[1]);return n.rgb('rgb('+e[0]+','+e[1]+','+e[2]+')')})),i=function(t){return function(e){return e[t]}},a='rgb'.split('').map((function(t){return n.scale.linear().clamp(!0).domain(e).range(r.map(i(t)))}));return function(t){return a.map((function(e){return e(t)}))}}function P(t){return t.dimensions.some((function(t){return t.brush.filterSpecified}))}function I(t,e,r){var a=g(e),s=a.trace,l=v.convertTypedArray(a.lineColor),c=s.line,u={color:o(y.deselectedLineColor)},f=h.extractOpts(c),p=f.reversescale?h.flipScale(a.cscale):a.cscale,d=s.domain,m=s.dimensions,x=t.width,b=s.labelangle,_=s.labelside,w=s.labelfont,k=s.tickfont,M=s.rangefont,A=i.extendDeepNoArrays({},c,{color:l.map(n.scale.linear().domain(T({values:l,range:[f.min,f.max],_length:s._length}))),blockLineCount:y.blockLineCount,canvasOverdrag:y.overdrag*y.canvasPixelRatio}),S=Math.floor(x*(d.x[1]-d.x[0])),E=Math.floor(t.height*(d.y[1]-d.y[0])),L=t.margin||{l:80,r:80,t:100,b:80},P=S,I=E;return{key:r,colCount:m.filter(v.isVisible).length,dimensions:m,tickDistance:y.tickDistance,unitToColor:C(p),lines:A,deselectedLines:u,labelAngle:b,labelSide:_,labelFont:w,tickFont:k,rangeFont:M,layoutWidth:x,layoutHeight:t.height,domain:d,translateX:d.x[0]*x,translateY:t.height-d.y[1]*t.height,pad:L,canvasWidth:P*y.canvasPixelRatio+2*A.canvasOverdrag,canvasHeight:I*y.canvasPixelRatio,width:P,height:I,canvasPixelRatio:y.canvasPixelRatio}}function z(t,e,r){var n=r.width,o=r.height,s=r.dimensions,l=r.canvasPixelRatio,c=function(t){return n*t/Math.max(1,r.colCount-1)},u=y.verticalPadding/o,f=S(o,y.verticalPadding),h={key:r.key,xScale:c,model:r,inBrushDrag:!1},p={};return h.dimensions=s.filter(v.isVisible).map((function(n,s){var d=E(n,u),m=p[n.label];p[n.label]=(m||0)+1;var g=n.label+(m?"__"+m:""),b=n.constraintrange,_=b&&b.length;_&&!Array.isArray(b[0])&&(b=[b]);var w=_?b.map((function(t){return t.map(d)})):[[-1/0,1/0]],T=function(){var e=h;e.focusLayer&&e.focusLayer.render(e.panels,!0);var r=P(e);!t.contextShown()&&r?(e.contextLayer&&e.contextLayer.render(e.panels,!0),t.contextShown(!0)):t.contextShown()&&!r&&(e.contextLayer&&e.contextLayer.render(e.panels,!0,!0),t.contextShown(!1))},k=n.values;k.length>n._length&&(k=k.slice(0,n._length));var M,S=n.tickvals;function C(t,e){return{val:t,text:M[e]}}function I(t,e){return t.val-e.val}if(Array.isArray(S)&&S.length){M=n.ticktext,Array.isArray(M)&&M.length?M.length>S.length?M=M.slice(0,S.length):S.length>M.length&&(S=S.slice(0,M.length)):M=S.map(a(n.tickformat));for(var z=1;z<S.length;z++)if(S[z]<S[z-1]){for(var O=S.map(C).sort(I),D=0;D<S.length;D++)S[D]=O[D].val,M[D]=O[D].text;break}}else S=void 0;return k=v.convertTypedArray(k),{key:g,label:n.label,tickFormat:n.tickformat,tickvals:S,ticktext:M,ordinal:v.isOrdinal(n),multiselect:n.multiselect,xIndex:s,crossfilterDimensionIndex:s,visibleIndex:n._index,height:o,values:k,paddedUnitValues:k.map(d),unitTickvals:S&&S.map(d),xScale:c,x:c(s),canvasX:c(s)*l,unitToPaddedPx:f,domainScale:A(o,y.verticalPadding,n,S,M),ordinalScale:L(n),parent:h,model:r,brush:x.makeBrush(t,_,w,(function(){t.linePickActive(!1)}),T,(function(r){if(h.focusLayer.render(h.panels,!0),h.pickLayer&&h.pickLayer.render(h.panels,!0),t.linePickActive(!0),e&&e.filterChanged){var a=d.invert,o=r.map((function(t){return t.map(a).sort(i.sorterAsc)})).sort((function(t,e){return t[0]-e[0]}));e.filterChanged(h.key,n._index,o)}}))}})),h}function O(t){t.classed(y.cn.axisExtentText,!0).attr('text-anchor','middle').style('cursor','default')}function D(){var t=!0,e=!1;return{linePickActive:function(e){return arguments.length?t=!!e:t},contextShown:function(t){return arguments.length?e=!!t:e}}}function R(t,e){var r="top"===e?1:-1,n=t*Math.PI/180;return{dir:r,dx:Math.sin(n),dy:Math.cos(n),degrees:t}}function F(t,e,r){for(var n=e.panels||(e.panels=[]),i=t.data(),a=0;a<i.length-1;a++){var o=n[a]||(n[a]={}),s=i[a],l=i[a+1];o.dim0=s,o.dim1=l,o.canvasX=s.canvasX,o.panelSizeX=l.canvasX-s.canvasX,o.panelSizeY=e.model.canvasHeight,o.y=0,o.canvasY=0,o.plotGlPixelRatio=r}}function B(t){for(var e=0;e<t.length;e++)for(var r=0;r<t[e].length;r++)for(var n=t[e][r].trace,i=n.dimensions,a=0;a<i.length;a++){var o=i[a].values,l=i[a]._ax;l&&(l.range?l.range=k(l.range[0],l.range[1]):l.range=w(o,n._length),l.dtick||(l.dtick=.01*(Math.abs(l.range[1]-l.range[0])||1)),l.tickformat=i[a].tickformat,s.calcTicks(l),l.cleanRange())}}function N(t,e){return s.tickText(t._ax,e,!1).text}function j(t,e){if(t.ordinal)return'';var r=t.domainScale.domain(),n=r[e?r.length-1:0];return N(t.model.dimensions[t.visibleIndex],n)}e.exports=function(t,e,r,a){var o=t._fullLayout,s=o._toppaper,h=o._glcontainer,p=t._context.plotGlPixelRatio,_=t._fullLayout.paper_bgcolor;B(e);var w=D(),T=e.filter((function(t){return g(t).trace.visible})).map(I.bind(0,r)).map(z.bind(0,w,a));h.each((function(t,e){return i.extendFlat(t,T[e])}));var k=h.selectAll('.gl-canvas').each((function(t){t.viewModel=T[0],t.viewModel.plotGlPixelRatio=p,t.viewModel.paperColor=_,t.model=t.viewModel?t.viewModel.model:null})),M=null;k.filter((function(t){return t.pick})).style('pointer-events','auto').on('mousemove',(function(t){if(w.linePickActive()&&t.lineLayer&&a&&a.hover){var e=n.event,r=this.width,i=this.height,o=n.mouse(this),s=o[0],l=o[1];if(s<0||l<0||s>=r||l>=i)return;var c=t.lineLayer.readPixel(s,i-1-l),u=0!==c[3],f=u?c[2]+256*(c[1]+256*c[0]):null,h={x:s,y:l,clientX:e.clientX,clientY:e.clientY,dataIndex:t.model.key,curveNumber:f};f!==M&&(u?a.hover(h):a.unhover&&a.unhover(h),M=f)}})),k.style('opacity',(function(t){return t.pick?0:1})),s.style('background','rgba(255, 255, 255, 0)');var A=s.selectAll("."+y.cn.parcoords).data(T,d);A.exit().remove(),A.enter().append('g').classed(y.cn.parcoords,!0).style('shape-rendering','crispEdges').style('pointer-events','none'),A.attr('transform',(function(t){return c(t.model.translateX,t.model.translateY)}));var S=A.selectAll("."+y.cn.parcoordsControlView).data(m,d);S.enter().append('g').classed(y.cn.parcoordsControlView,!0),S.attr('transform',(function(t){return c(t.model.pad.l,t.model.pad.t)}));var E=S.selectAll("."+y.cn.yAxis).data((function(t){return t.dimensions}),d);E.enter().append('g').classed(y.cn.yAxis,!0),S.each((function(t){F(E,t,p)})),k.each((function(t){if(t.viewModel){!t.lineLayer||a?t.lineLayer=b(this,t):t.lineLayer.update(t),(t.key||0===t.key)&&(t.viewModel[t.key]=t.lineLayer);var e=!t.context||a;t.lineLayer.render(t.viewModel.panels,e)}})),E.attr('transform',(function(t){return c(t.xScale(t.xIndex),0)})),E.call(n.behavior.drag().origin((function(t){return t})).on('drag',(function(t){var e=t.parent;w.linePickActive(!1),t.x=Math.max(-y.overdrag,Math.min(t.model.width+y.overdrag,n.event.x)),t.canvasX=t.x*t.model.canvasPixelRatio,E.sort((function(t,e){return t.x-e.x})).each((function(e,r){e.xIndex=r,e.x=t===e?e.x:e.xScale(e.xIndex),e.canvasX=e.x*e.model.canvasPixelRatio})),F(E,e,p),E.filter((function(e){return 0!==Math.abs(t.xIndex-e.xIndex)})).attr('transform',(function(t){return c(t.xScale(t.xIndex),0)})),n.select(this).attr('transform',c(t.x,0)),E.each((function(r,n,i)[i===t.parent.key&&(e.dimensions[n]=r)])),e.contextLayer&&e.contextLayer.render(e.panels,!1,!P(e)),e.focusLayer.render&&e.focusLayer.render(e.panels)})).on('dragend',(function(t){var e=t.parent;t.x=t.xScale(t.xIndex),t.canvasX=t.x*t.model.canvasPixelRatio,F(E,e,p),n.select(this).attr('transform',(function(t){return c(t.x,0)})),e.contextLayer&&e.contextLayer.render(e.panels,!1,!P(e)),e.focusLayer&&e.focusLayer.render(e.panels),e.pickLayer&&e.pickLayer.render(e.panels,!0),w.linePickActive(!0),a&&a.axesMoved&&a.axesMoved(e.key,e.dimensions.map((function(t){return t.crossfilterDimensionIndex})))}))),E.exit().remove();var L=E.selectAll("."+y.cn.axisOverlays).data(m,d);L.enter().append('g').classed(y.cn.axisOverlays,!0),L.selectAll("."+y.cn.axis).remove();var C=L.selectAll("."+y.cn.axis).data(m,d);C.enter().append('g').classed(y.cn.axis,!0),C.each((function(t){var e=t.model.height/t.model.tickDistance,r=t.domainScale,i=r.domain();n.select(this).call(n.svg.axis().orient('left').tickSize(4).outerTickSize(2).ticks(e,t.tickFormat).tickValues(t.ordinal?i:null).tickFormat((function(e){return v.isOrdinal(t)?e:N(t.model.dimensions[t.visibleIndex],e)})).scale(r)),f.font(C.selectAll('text'),t.model.tickFont)})),C.selectAll('.domain, .tick>line').attr('fill','none').attr('stroke','black').attr('stroke-opacity',.25).attr('stroke-width','1px'),C.selectAll('text').style('text-shadow',u.makeTextShadow(_)).style('cursor','default');var U=L.selectAll("."+y.cn.axisHeading).data(m,d);U.enter().append('g').classed(y.cn.axisHeading,!0);var V=U.selectAll("."+y.cn.axisTitle).data(m,d);V.enter().append('text').classed(y.cn.axisTitle,!0).attr('text-anchor','middle').style('cursor','ew-resize').style('pointer-events','auto'),V.text((function(t){return t.label})).each((function(e){var r=n.select(this);f.font(r,e.model.labelFont),u.convertToTspans(r,t)})).attr('transform',(function(t){var e=R(t.model.labelAngle,t.model.labelSide),r=y.axisTitleOffset;return(e.dir>0?"":c(0,2*r+t.model.height))+l(e.degrees)+c(-r*e.dx,-r*e.dy)})).attr('text-anchor',(function(t){var e=R(t.model.labelAngle,t.model.labelSide);return 2*Math.abs(e.dx)>Math.abs(e.dy)?e.dir*e.dx<0?"start":"end":"middle"}));var H=L.selectAll("."+y.cn.axisExtent).data(m,d);H.enter().append('g').classed(y.cn.axisExtent,!0);var q=H.selectAll("."+y.cn.axisExtentTop).data(m,d);q.enter().append('g').classed(y.cn.axisExtentTop,!0),q.attr('transform',c(0,-y.axisExtentOffset));var G=q.selectAll("."+y.cn.axisExtentTopText).data(m,d);G.enter().append('text').classed(y.cn.axisExtentTopText,!0).call(O),G.text((function(t){return j(t,!0)})).each((function(t){f.font(n.select(this),t.model.rangeFont)}));var Y=H.selectAll("."+y.cn.axisExtentBottom).data(m,d);Y.enter().append('g').classed(y.cn.axisExtentBottom,!0),Y.attr('transform',(function(t){return c(0,t.model.height+y.axisExtentOffset)}));var W=Y.selectAll("."+y.cn.axisExtentBottomText).data(m,d);W.enter().append('text').classed(y.cn.axisExtentBottomText,!0).attr('dy','0.75em').call(O),W.text((function(t){return j(t,!1)})).each((function(t){f.font(n.select(this),t.model.rangeFont)})),x.ensureAxisBrush(L,_)}},{"../../components/colorscale":662,"../../components/drawing":672,"../../lib":787,"../../lib/gup":784,"../../lib/svg_text_utils":813,"../../plots/cartesian/axes":838,"./axisbrush":1165,"./constants":1168,"./helpers":1170,"./lines":1172,"@plotly/d3":58,"color-rgba":133}],1175:[function(t,e,r){"use strict";var n=t('./parcoords'),i=t('../../lib/prepare_regl'),a=t('./helpers').isVisible;function o(t,e,r){var n=e.indexOf(r),i=t.indexOf(n);return-1===i&&(i+=e.length),i}function s(t,e){return function(r,n){return o(t,e,r)-o(t,e,n)}}e.exports=function(t,e){var r=t._fullLayout;if(i(t)){var o={},l={},c={},u={},f=r._size;e.forEach((function(e,r){var n=e[0].trace;c[r]=n.index;var i=u[r]=n._fullInput.index;o[r]=t.data[i].dimensions,l[r]=t.data[i].dimensions.slice()}));var h=function(e,n,i){var a=l[e][n],o=i.map((function(t){return t.slice()})),s="dimensions["+n+"].constraintrange",f=r._tracePreGUI[t._fullData[c[e]]._fullInput.uid];if(void 0===f[s]){var h=a.constraintrange;f[s]=h||null}var p=t._fullData[c[e]].dimensions[n];o.length?(1===o.length&&(o=o[0]),a.constraintrange=o,p.constraintrange=o.slice(),o=[o]):(delete a.constraintrange,delete p.constraintrange,o=null);var d={};d[s]=o,t.emit('plotly_restyle',[d,[u[e]]])},p=function(e){t.emit('plotly_hover',e)},d=function(e){t.emit('plotly_unhover',e)},m=function(e,r){var n=s(r,l[e].filter(a));o[e].sort(n),l[e].filter((function(t){return!a(t)})).sort((function(t){return l[e].indexOf(t)})).forEach((function(t){o[e].splice(o[e].indexOf(t),1),o[e].splice(l[e].indexOf(t),0,t)})),t.emit('plotly_restyle',[{dimensions:[o[e]]},[u[e]]])};n(t,e,{width:f.w,height:f.h,margin:{t:f.t,r:f.r,b:f.b,l:f.l}},{filterChanged:h,hover:p,unhover:d,axesMoved:m})}}},{"../../lib/prepare_regl":800,"./helpers":1170,"./parcoords":1174}],1176:[function(t,e,r){"use strict";var n=t('../../plots/attributes'),i=t('../../plots/domain').attributes,a=t('../../plots/font_attributes'),o=t('../../components/color/attributes'),s=t('../../plots/template_attributes').hovertemplateAttrs,l=t('../../plots/template_attributes').texttemplateAttrs,c=t('../../lib/extend').extendFlat,u=a({editType:"plot",arrayOk:!0,colorEditType:"plot"});e.exports={labels:{valType:"data_array",editType:"calc"},label0:{valType:"number",dflt:0,editType:"calc"},dlabel:{valType:"number",dflt:1,editType:"calc"},values:{valType:"data_array",editType:"calc"},marker:{colors:{valType:"data_array",editType:"calc"},line:{color:{valType:"color",dflt:o.defaultLine,arrayOk:!0,editType:"style"},width:{valType:"number",min:0,dflt:0,arrayOk:!0,editType:"style"},editType:"calc"},editType:"calc"},text:{valType:"data_array",editType:"plot"},hovertext:{valType:"string",dflt:"",arrayOk:!0,editType:"style"},scalegroup:{valType:"string",dflt:"",editType:"calc"},textinfo:{valType:"flaglist",flags:["label",'text','value',"percent"],extras:["none"],editType:"calc"},hoverinfo:c({},n.hoverinfo,{flags:["label",'text','value','percent',"name"]}),hovertemplate:s({},{keys:["label",'color','value','percent',"text"]}),texttemplate:l({editType:"plot"},{keys:["label",'color','value','percent',"text"]}),textposition:{valType:"enumerated",values:["inside",'outside','auto',"none"],dflt:"auto",arrayOk:!0,editType:"plot"},textfont:c({},u,{}),insidetextorientation:{valType:"enumerated",values:["horizontal",'radial','tangential',"auto"],dflt:"auto",editType:"plot"},insidetextfont:c({},u,{}),outsidetextfont:c({},u,{}),automargin:{valType:"boolean",dflt:!1,editType:"plot"},title:{text:{valType:"string",dflt:"",editType:"plot"},font:c({},u,{}),position:{valType:"enumerated",values:["top left",'top center','top right','middle center','bottom left','bottom center',"bottom right"],editType:"plot"},editType:"plot"},domain:i({name:"pie",trace:!0,editType:"calc"}),hole:{valType:"number",min:0,max:1,dflt:0,editType:"calc"},sort:{valType:"boolean",dflt:!0,editType:"calc"},direction:{valType:"enumerated",values:["clockwise","counterclockwise"],dflt:"counterclockwise",editType:"calc"},rotation:{valType:"number",min:-360,max:360,dflt:0,editType:"calc"},pull:{valType:"number",min:0,max:1,dflt:0,arrayOk:!0,editType:"calc"},_deprecated:{title:{valType:"string",dflt:"",editType:"calc"},titlefont:c({},u,{}),titleposition:{valType:"enumerated",values:["top left",'top center','top right','middle center','bottom left','bottom center',"bottom right"],editType:"calc"}}}},{"../../components/color/attributes":649,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/domain":866,"../../plots/font_attributes":867,"../../plots/template_attributes":910}],1177:[function(t,e,r){"use strict";var n=t('../../plots/plots');r.name='pie',r.plot=function(t,e,i,a){n.plotBasePlot(r.name,t,e,i,a)},r.clean=function(t,e,i,a){n.cleanBasePlot(r.name,t,e,i,a)}},{"../../plots/plots":901}],1178:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('tinycolor2'),a=t('../../components/color'),o={};function s(t,e){var r,i,a=[],o=t._fullLayout,s=o.hiddenlabels||[],c=e.labels,u=e.marker.colors||[],f=e.values,h=e._length,p=e._hasValues&&h;if(e.dlabel)for(c=new Array(h),r=0;r<h;r++)c[r]=String(e.label0+r*e.dlabel);var d={},m=l(o["_"+e.type+"colormap"]),g=0,v=!1;for(r=0;r<h;r++){var y,x,b;if(p){if(y=f[r],!n(y))continue;if((y=+y)<0)continue}else y=1;void 0!==(x=c[r])&&""!==x||(x=r);var _=d[x=String(x)];void 0===_?(d[x]=a.length,(b=-1!==s.indexOf(x))||(g+=y),a.push({v:y,label:x,color:m(u[r],x),i:r,pts:[r],hidden:b})):(v=!0,(i=a[_]).v+=y,i.pts.push(r),i.hidden||(g+=y),!1===i.color&&u[r]&&(i.color=m(u[r],x)))}return("funnelarea"===e.type?v:e.sort)&&a.sort((function(t,e){return e.v-t.v})),a[0]&&(a[0].vTotal=g),a}function l(t){return function(e,r){return!!e&&!!(e=i(e)).isValid()&&(e=a.addOpacity(e,e.getAlpha()),t[r]||(t[r]=e),e)}}function c(t,e)[var r=(e||{]).type;r||(r='pie');var n=t._fullLayout,i=t.calcdata,a=n[r+"colorway"],s=n["_"+r+"colormap"];n["extend"+r+"colors"]&&(a=u(a,o));for(var l=0,c=0;c<i.length;c++){var f=i[c];if(f[0].trace.type===r)for(var h=0;h<f.length;h++){var p=f[h];!1===p.color&&(s[p.label]?p.color=s[p.label]:(s[p.label]=p.color=a[l%a.length],l++))}}}function u(t,e){var r,n=JSON.stringify(t),a=e[n];if(!a){for(a=t.slice(),r=0;r<t.length;r++)a.push(i(t[r]).lighten(20).toHexString());for(r=0;r<t.length;r++)a.push(i(t[r]).darken(20).toHexString());e[n]=a}return a}e.exports={calc:s,crossTraceCalc:c,makePullColorFn:l,generateExtendedColors:u}},{"../../components/color":650,"fast-isnumeric":246,tinycolor2:583}],1179:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('./attributes'),o=t('../../plots/domain').defaults,s=t('../bar/defaults').handleText;function l(t,e){var r=Array.isArray(t),a=i.isArrayOrTypedArray(e),o=Math.min(r?t.length:1/0,a?e.length:1/0);if(isFinite(o)||(o=0),o&&a){for(var s,l=0;l<o;l++){var c=e[l];if(n(c)&&c>0){s=!0;break}}s||(o=0)}return{hasLabels:r,hasValues:a,len:o}}function c(t,e,r,n){function c(r,n){return i.coerce(t,e,a,r,n)}var u=l(c('labels'),c('values')),f=u.len;if(e._hasLabels=u.hasLabels,e._hasValues=u.hasValues,!e._hasLabels&&e._hasValues&&(c('label0'),c('dlabel')),f){e._length=f,c('marker.line.width')&&c('marker.line.color'),c('marker.colors'),c('scalegroup');var h,p=c('text'),d=c('texttemplate');if(d||(h=c('textinfo',Array.isArray(p)?"text+percent":"percent")),c('hovertext'),c('hovertemplate'),d||h&&"none"!==h){var m=c('textposition');s(t,e,n,c,m,{moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!1,moduleHasCliponaxis:!1,moduleHasTextangle:!1,moduleHasInsideanchor:!1}),(Array.isArray(m)||"auto"===m||"outside"===m)&&c('automargin'),("inside"===m||"auto"===m||Array.isArray(m))&&c('insidetextorientation')}o(e,n,c);var g=c('hole');if(c('title.text')){var v=c('title.position',g?"middle center":"top center");g||"middle center"!==v||(e.title.position='top center'),i.coerceFont(c,'title.font',n.font)}c('sort'),c('direction'),c('rotation'),c('pull')}else e.visible=!1}e.exports={handleLabelsAndValues:l,supplyDefaults:c}},{"../../lib":787,"../../plots/domain":866,"../bar/defaults":929,"./attributes":1176,"fast-isnumeric":246}],1180:[function(t,e,r){"use strict";var n=t('../../components/fx/helpers').appendArrayMultiPointValues;e.exports=function(t,e){var r={curveNumber:e.index,pointNumbers:t.pts,data:e._input,fullData:e,label:t.label,color:t.color,value:t.v,percent:t.percent,text:t.text,bbox:t.bbox,v:t.v};return 1===t.pts.length&&(r.pointNumber=r.i=t.pts[0]),n(r,e,t.pts),"funnelarea"===e.type&&(delete r.v,delete r.i),r}},{"../../components/fx/helpers":686}],1181:[function(t,e,r){"use strict";var n=t('../../lib');function i(t){return-1!==t.indexOf('e')?t.replace(/[.]?0+e/,'e'):-1!==t.indexOf('.')?t.replace(/[.]?0+$/,''):t}r.formatPiePercent=function(t,e){var r=i((100*t).toPrecision(3));return n.numSeparate(r,e)+"%"},r.formatPieValue=function(t,e){var r=i(t.toPrecision(10));return n.numSeparate(r,e)},r.getFirstFilled=function(t,e){if(Array.isArray(t))for(var r=0;r<e.length;r++){var n=t[e[r]];if(n||0===n||""===n)return n}},r.castOption=function(t,e){return Array.isArray(t)?r.getFirstFilled(t,e):t||void 0},r.getRotationAngle=function(t){return("auto"===t?0:t)*Math.PI/180}},{"../../lib":787}],1182:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults').supplyDefaults,supplyLayoutDefaults:t('./layout_defaults'),layoutAttributes:t('./layout_attributes'),calc:t('./calc').calc,crossTraceCalc:t('./calc').crossTraceCalc,plot:t('./plot').plot,style:t('./style'),styleOne:t('./style_one'),moduleType:"trace",name:"pie",basePlotModule:t('./base_plot'),categories:["pie-like",'pie',"showLegend"],meta:{}}},{"./attributes":1176,"./base_plot":1177,"./calc":1178,"./defaults":1179,"./layout_attributes":1183,"./layout_defaults":1184,"./plot":1185,"./style":1186,"./style_one":1187}],1183:[function(t,e,r){"use strict";e.exports={hiddenlabels:{valType:"data_array",editType:"calc"},piecolorway:{valType:"colorlist",editType:"calc"},extendpiecolors:{valType:"boolean",dflt:!0,editType:"calc"}}},{}],1184:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}r('hiddenlabels'),r('piecolorway',e.colorway),r('extendpiecolors')}},{"../../lib":787,"./layout_attributes":1183}],1185:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../plots/plots'),a=t('../../components/fx'),o=t('../../components/color'),s=t('../../components/drawing'),l=t('../../lib'),c=l.strScale,u=l.strTranslate,f=t('../../lib/svg_text_utils'),h=t('../bar/uniform_text'),p=h.recordMinTextSize,d=h.clearMinTextSize,m=t('../bar/constants').TEXTPAD,g=t('./helpers'),v=t('./event_data'),y=t('../../lib').isValidTextValue;function x(t,e){var r=t._fullLayout,a=r._size;d('pie',r),k(e,t),j(e,a);var o=l.makeTraceGroups(r._pielayer,e,'trace').each((function(e){var o=n.select(this),h=e[0],d=h.trace;V(e),o.attr('stroke-linejoin','round'),o.each((function(){var m=n.select(this).selectAll('g.slice').data(e);m.enter().append('g').classed('slice',!0),m.exit().remove();var v=[[[],[]],[[],[]]],y=!1;m.each((function(i,a){if(i.hidden)n.select(this).selectAll('path,g').remove();else{i.pointNumber=i.i,i.curveNumber=d.index,v[i.pxmid[1]<0?0:1][i.pxmid[0]<0?0:1].push(i);var o=h.cx,c=h.cy,u=n.select(this),m=u.selectAll('path.surface').data([i]);if(m.enter().append('path').classed('surface',!0).style({"pointer-events":"all"}),u.call(_,t,e),d.pull){var x=+g.castOption(d.pull,i.pts)||0;x>0&&(o+=x*i.pxmid[0],c+=x*i.pxmid[1])}i.cxFinal=o,i.cyFinal=c;var b=d.hole;if(i.v===h.vTotal){var k="M"+(o+i.px0[0])+","+(c+i.px0[1])+C(i.px0,i.pxmid,!0,1)+C(i.pxmid,i.px0,!0,1)+"Z";b?m.attr('d',"M"+(o+b*i.px0[0])+","+(c+b*i.px0[1])+C(i.px0,i.pxmid,!1,b)+C(i.pxmid,i.px0,!1,b)+"Z"+k):m.attr('d',k)}else{var A=C(i.px0,i.px1,!0,1);if(b){var S=1-b;m.attr('d',"M"+(o+b*i.px1[0])+","+(c+b*i.px1[1])+C(i.px1,i.px0,!1,b)+"l"+S*i.px0[0]+","+S*i.px0[1]+A+"Z")}else m.attr('d',"M"+o+","+c+"l"+i.px0[0]+","+i.px0[1]+A+"Z")}q(t,i,h);var E=g.castOption(d.textposition,i.pts),L=u.selectAll('g.slicetext').data(i.text&&"none"!==E?[0]:[]);L.enter().append('g').classed('slicetext',!0),L.exit().remove(),L.each((function(){var u=l.ensureSingle(n.select(this),'text','',(function(t){t.attr('data-notex',1)})),m=l.ensureUniformFontSize(t,"outside"===E?w(d,i,r.font):T(d,i,r.font));u.text(i.text).attr({class:"slicetext",transform:"","text-anchor":"middle"}).call(s.font,m).call(f.convertToTspans,t);var g,v=s.bBox(u.node());if("outside"===E)g=z(v,i);else if(g=M(v,i,h),"auto"===E&&g.scale<1){var x=l.ensureUniformFontSize(t,d.outsidetextfont);u.call(s.font,x),g=z(v=s.bBox(u.node()),i)}var b=g.textPosAngle,_=void 0===b?i.pxmid:H(h.r,b);if(g.targetX=o+_[0]*g.rCenter+(g.x||0),g.targetY=c+_[1]*g.rCenter+(g.y||0),G(g,v),g.outside){var k=g.targetY;i.yLabelMin=k-v.height/2,i.yLabelMid=k,i.yLabelMax=k+v.height/2,i.labelExtraX=0,i.labelExtraY=0,y=!0}g.fontSize=m.size,p(d.type,g,r),e[a].transform=g,u.attr('transform',l.getTextTransform(g))}))}function C(t,e,r,n){var a=n*(e[0]-t[0]),o=n*(e[1]-t[1]);return"a"+n*h.r+",'+n*h.r+' 0 '+i.largeArc+(r?' 1 ':' 0 ')+a+',"+o}}));var x=n.select(this).selectAll('g.titletext').data(d.title.text?[0]:[]);if(x.enter().append('g').classed('titletext',!0),x.exit().remove(),x.each((function(){var e,r=l.ensureSingle(n.select(this),'text','',(function(t){t.attr('data-notex',1)})),i=d.title.text;d._meta&&(i=l.templateString(i,d._meta)),r.text(i).attr({class:"titletext",transform:"","text-anchor":"middle"}).call(s.font,d.title.font).call(f.convertToTspans,t),e="middle center"===d.title.position?O(h):D(h,a),r.attr('transform',u(e.x,e.y)+c(Math.min(1,e.scale))+u(e.tx,e.ty))})),y&&N(v,d),b(m,d),y&&d.automargin){var k=s.bBox(o.node()),A=d.domain,S=a.w*(A.x[1]-A.x[0]),E=a.h*(A.y[1]-A.y[0]),L=(.5*S-h.r)/a.w,C=(.5*E-h.r)/a.h;i.autoMargin(t,"pie."+d.uid+".automargin",{xl:A.x[0]-L,xr:A.x[1]+L,yb:A.y[0]-C,yt:A.y[1]+C,l:Math.max(h.cx-h.r-k.left,0),r:Math.max(k.right-(h.cx+h.r),0),b:Math.max(k.bottom-(h.cy+h.r),0),t:Math.max(h.cy-h.r-k.top,0),pad:5})}}))}));setTimeout((function(){o.selectAll('tspan').each((function(){var t=n.select(this);t.attr('dy')&&t.attr('dy',t.attr('dy'))}))}),0)}function b(t,e){t.each((function(t){var r=n.select(this);if(t.labelExtraX||t.labelExtraY){var i=r.select('g.slicetext text');t.transform.targetX+=t.labelExtraX,t.transform.targetY+=t.labelExtraY,i.attr('transform',l.getTextTransform(t.transform));var a=t.cxFinal+t.pxmid[0],s="M"+a+","+(t.cyFinal+t.pxmid[1]),c=(t.yLabelMax-t.yLabelMin)*(t.pxmid[0]<0?-1:1)/4;if(t.labelExtraX){var u=t.labelExtraX*t.pxmid[1]/t.pxmid[0],f=t.yLabelMid+t.labelExtraY-(t.cyFinal+t.pxmid[1]);Math.abs(u)>Math.abs(f)?s+="l"+f*t.pxmid[0]/t.pxmid[1]+","+f+"H"+(a+t.labelExtraX+c):s+="l"+t.labelExtraX+","+u+"v"+(f-u)+"h"+c}else s+="V"+(t.yLabelMid+t.labelExtraY)+"h"+c;l.ensureSingle(r,'path','textline').call(o.stroke,e.outsidetextfont.color).attr({"stroke-width":Math.min(2,e.outsidetextfont.size/8),d:s,fill:"none"})}else r.select('path.textline').remove()}))}function _(t,e,r){var i=r[0],o=i.cx,s=i.cy,c=i.trace,u="funnelarea"===c.type;"_hasHoverLabel"in c||(c._hasHoverLabel=!1),"_hasHoverEvent"in c||(c._hasHoverEvent=!1),t.on('mouseover',(function(t){var r=e._fullLayout,f=e._fullData[c.index];if(!e._dragging&&!1!==r.hovermode){var h=f.hoverinfo;if(Array.isArray(h)&&(h=a.castHoverinfo({hoverinfo:[g.castOption(h,t.pts)],_module:c._module},r,0)),"all"===h&&(h='label+text+value+percent+name'),f.hovertemplate||"none"!==h&&"skip"!==h&&h){var p=t.rInscribed||0,d=o+t.pxmid[0]*(1-p),m=s+t.pxmid[1]*(1-p),y=r.separators,x=[];if(h&&-1!==h.indexOf('label')&&x.push(t.label),t.text=g.castOption(f.hovertext||f.text,t.pts),h&&-1!==h.indexOf('text')){var b=t.text;l.isValidTextValue(b)&&x.push(b)}t.value=t.v,t.valueLabel=g.formatPieValue(t.v,y),h&&-1!==h.indexOf('value')&&x.push(t.valueLabel),t.percent=t.v/i.vTotal,t.percentLabel=g.formatPiePercent(t.percent,y),h&&-1!==h.indexOf('percent')&&x.push(t.percentLabel);var _=f.hoverlabel,w=_.font,T=[];a.loneHover({trace:c,x0:d-p*i.r,x1:d+p*i.r,y:m,_x0:u?o+t.TL[0]:d-p*i.r,_x1:u?o+t.TR[0]:d+p*i.r,_y0:u?s+t.TL[1]:m-p*i.r,_y1:u?s+t.BL[1]:m+p*i.r,text:x.join('<br>'),name:f.hovertemplate||-1!==h.indexOf('name')?f.name:void 0,idealAlign:t.pxmid[0]<0?"left":"right",color:g.castOption(_.bgcolor,t.pts)||t.color,borderColor:g.castOption(_.bordercolor,t.pts),fontFamily:g.castOption(w.family,t.pts),fontSize:g.castOption(w.size,t.pts),fontColor:g.castOption(w.color,t.pts),nameLength:g.castOption(_.namelength,t.pts),textAlign:g.castOption(_.align,t.pts),hovertemplate:g.castOption(f.hovertemplate,t.pts),hovertemplateLabels:t,eventData:[v(t,f)]},{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:e,inOut_bbox:T}),t.bbox=T[0],c._hasHoverLabel=!0}c._hasHoverEvent=!0,e.emit('plotly_hover',{points:[v(t,f)],event:n.event})}})),t.on('mouseout',(function(t){var r=e._fullLayout,i=e._fullData[c.index],o=n.select(this).datum();c._hasHoverEvent&&(t.originalEvent=n.event,e.emit('plotly_unhover',{points:[v(o,i)],event:n.event}),c._hasHoverEvent=!1),c._hasHoverLabel&&(a.loneUnhover(r._hoverlayer.node()),c._hasHoverLabel=!1)})),t.on('click',(function(t){var r=e._fullLayout,i=e._fullData[c.index];e._dragging||!1===r.hovermode||(e._hoverdata=[v(t,i)],a.click(e,n.event))}))}function w(t,e,r){return{color:g.castOption(t.outsidetextfont.color,e.pts)||g.castOption(t.textfont.color,e.pts)||r.color,family:g.castOption(t.outsidetextfont.family,e.pts)||g.castOption(t.textfont.family,e.pts)||r.family,size:g.castOption(t.outsidetextfont.size,e.pts)||g.castOption(t.textfont.size,e.pts)||r.size}}function T(t,e,r){var n=g.castOption(t.insidetextfont.color,e.pts);!n&&t._input.textfont&&(n=g.castOption(t._input.textfont.color,e.pts));var i=g.castOption(t.insidetextfont.family,e.pts)||g.castOption(t.textfont.family,e.pts)||r.family,a=g.castOption(t.insidetextfont.size,e.pts)||g.castOption(t.textfont.size,e.pts)||r.size;return{color:n||o.contrast(e.color),family:i,size:a}}function k(t,e){for(var r,n,i=0;i<t.length;i++)if((n=(r=t[i][0]).trace).title.text){var a=n.title.text;n._meta&&(a=l.templateString(a,n._meta));var o=s.tester.append('text').attr('data-notex',1).text(a).call(s.font,n.title.font).call(f.convertToTspans,e),c=s.bBox(o.node(),!0);r.titleBox={width:c.width,height:c.height},o.remove()}}function M(t,e,r){var n=r.r||e.rpx1,i=e.rInscribed;if(e.startangle===e.stopangle)return{rCenter:1-i,scale:0,rotate:0,textPosAngle:0};var a,o=e.ring,s=1===o&&Math.abs(e.startangle-e.stopangle)===2*Math.PI,l=e.halfangle,c=e.midangle,u=r.trace.insidetextorientation,f="horizontal"===u,h="tangential"===u,p="radial"===u,d="auto"===u,m=[];if(!d){var g,v=function(r,i){if(A(e,r)){var s=Math.abs(r-e.startangle),l=Math.abs(r-e.stopangle),c=s<l?s:l;(a="tan"===i?E(t,n,o,c,0):S(t,n,o,c,Math.PI/2)).textPosAngle=r,m.push(a)}};if(f||h){for(g=4;g>=-4;g-=2)v(Math.PI*g,'tan');for(g=4;g>=-4;g-=2)v(Math.PI*(g+1),'tan')}if(f||p){for(g=4;g>=-4;g-=2)v(Math.PI*(g+1.5),'rad');for(g=4;g>=-4;g-=2)v(Math.PI*(g+.5),'rad')}}if(s||d||f){var y=Math.sqrt(t.width*t.width+t.height*t.height);if((a={scale:i*n*2/y,rCenter:1-i,rotate:0}).textPosAngle=(e.startangle+e.stopangle)/2,a.scale>=1)return a;m.push(a)}(d||p)&&((a=S(t,n,o,l,c)).textPosAngle=(e.startangle+e.stopangle)/2,m.push(a)),(d||h)&&((a=E(t,n,o,l,c)).textPosAngle=(e.startangle+e.stopangle)/2,m.push(a));for(var x=0,b=0,_=0;_<m.length;_++){var w=m[_].scale;if(b<w&&(b=w,x=_),!d&&b>=1)break}return m[x]}function A(t,e){var r=t.startangle,n=t.stopangle;return r>e&&e>n||r<e&&e<n}function S(t,e,r,n,i){e=Math.max(0,e-2*m);var a=t.width/t.height,o=P(a,n,e,r);return{scale:2*o/t.height,rCenter:L(a,o/e),rotate:C(i)}}function E(t,e,r,n,i){e=Math.max(0,e-2*m);var a=t.height/t.width,o=P(a,n,e,r);return{scale:2*o/t.width,rCenter:L(a,o/e),rotate:C(i+Math.PI/2)}}function L(t,e){return Math.cos(e)-t*e}function C(t){return(180/Math.PI*t+720)%180-90}function P(t,e,r,n){var i=t+1/(2*Math.tan(e));return r*Math.min(1/(Math.sqrt(i*i+.5)+i),n/(Math.sqrt(t*t+n/2)+t))}function I(t,e){return t.v!==e.vTotal||e.trace.hole?Math.min(1/(1+1/Math.sin(t.halfangle)),t.ring/2):1}function z(t,e){var r=e.pxmid[0],n=e.pxmid[1],i=t.width/2,a=t.height/2;return r<0&&(i*=-1),n<0&&(a*=-1),{scale:1,rCenter:1,rotate:0,x:i+Math.abs(a)*(i>0?1:-1)/2,y:a/(1+r*r/(n*n)),outside:!0}}function O(t){var e=Math.sqrt(t.titleBox.width*t.titleBox.width+t.titleBox.height*t.titleBox.height);return{x:t.cx,y:t.cy,scale:t.trace.hole*t.r*2/e,tx:0,ty:-t.titleBox.height/2+t.trace.title.font.size}}function D(t,e){var r,n=1,i=1,a=t.trace,o={x:t.cx,y:t.cy},s={tx:0,ty:0};s.ty+=a.title.font.size,r=B(a),-1!==a.title.position.indexOf('top')?(o.y-=(1+r)*t.r,s.ty-=t.titleBox.height):-1!==a.title.position.indexOf('bottom')&&(o.y+=(1+r)*t.r);var l=R(t.r,t.trace.aspectratio),c=e.w*(a.domain.x[1]-a.domain.x[0])/2;return-1!==a.title.position.indexOf('left')?(c+=l,o.x-=(1+r)*l,s.tx+=t.titleBox.width/2):-1!==a.title.position.indexOf('center')?c*=2:-1!==a.title.position.indexOf('right')&&(c+=l,o.x+=(1+r)*l,s.tx-=t.titleBox.width/2),n=c/t.titleBox.width,i=F(t,e)/t.titleBox.height,{x:o.x,y:o.y,scale:Math.min(n,i),tx:s.tx,ty:s.ty}}function R(t,e){return t/(void 0===e?1:e)}function F(t,e){var r=t.trace,n=e.h*(r.domain.y[1]-r.domain.y[0]);return Math.min(t.titleBox.height,n/2)}function B(t){var e,r=t.pull;if(!r)return 0;if(Array.isArray(r))for(r=0,e=0;e<t.pull.length;e++)t.pull[e]>r&&(r=t.pull[e]);return r}function N(t,e){var r,n,i,a,o,s,l,c,u,f,h,p,d;function m(t,e){return t.pxmid[1]-e.pxmid[1]}function v(t,e){return e.pxmid[1]-t.pxmid[1]}function y(t,r)[r||(r={]);var i,c,u,h,p=r.labelExtraY+(n?r.yLabelMax:r.yLabelMin),d=n?t.yLabelMin:t.yLabelMax,m=n?t.yLabelMax:t.yLabelMin,v=t.cyFinal+o(t.px0[1],t.px1[1]),y=p-d;if(y*l>0&&(t.labelExtraY=y),Array.isArray(e.pull))for(c=0;c<f.length;c++)(u=f[c])===t||(g.castOption(e.pull,t.pts)||0)>=(g.castOption(e.pull,u.pts)||0)||((t.pxmid[1]-u.pxmid[1])*l>0?(y=u.cyFinal+o(u.px0[1],u.px1[1])-d-t.labelExtraY)*l>0&&(t.labelExtraY+=y):(m+t.labelExtraY-v)*l>0&&(i=3*s*Math.abs(c-f.indexOf(t)),(h=u.cxFinal+a(u.px0[0],u.px1[0])+i-(t.cxFinal+t.pxmid[0])-t.labelExtraX)*s>0&&(t.labelExtraX+=h)))}for(n=0;n<2;n++)for(i=n?m:v,o=n?Math.max:Math.min,l=n?1:-1,r=0;r<2;r++){for(a=r?Math.max:Math.min,s=r?1:-1,(c=t[n][r]).sort(i),u=t[1-n][r],f=u.concat(c),p=[],h=0;h<c.length;h++)void 0!==c[h].yLabelMid&&p.push(c[h]);for(d=!1,h=0;n&&h<u.length;h++)if(void 0!==u[h].yLabelMid){d=u[h];break}for(h=0;h<p.length;h++){var x=h&&p[h-1];d&&!h&&(x=d),y(p[h],x)}}}function j(t,e){for(var r=[],n=0;n<t.length;n++){var i=t[n][0],a=i.trace,o=a.domain,s=e.w*(o.x[1]-o.x[0]),l=e.h*(o.y[1]-o.y[0]);a.title.text&&"middle center"!==a.title.position&&(l-=F(i,e));var c=s/2,u=l/2;"funnelarea"!==a.type||a.scalegroup||(u/=a.aspectratio),i.r=Math.min(c,u)/(1+B(a)),i.cx=e.l+e.w*(a.domain.x[1]+a.domain.x[0])/2,i.cy=e.t+e.h*(1-a.domain.y[0])-l/2,a.title.text&&-1!==a.title.position.indexOf('bottom')&&(i.cy-=F(i,e)),a.scalegroup&&-1===r.indexOf(a.scalegroup)&&r.push(a.scalegroup)}U(t,r)}function U(t,e){for(var r,n,i,a=0;a<e.length;a++){var o=1/0,s=e[a];for(n=0;n<t.length;n++)if((i=(r=t[n][0]).trace).scalegroup===s){var l;if("pie"===i.type)l=r.r*r.r;else if("funnelarea"===i.type){var c,u;i.aspectratio>1?u=(c=r.r)/i.aspectratio:c=(u=r.r)*i.aspectratio,l=(c*=(1+i.baseratio)/2)*u}o=Math.min(o,l/r.vTotal)}for(n=0;n<t.length;n++)if((i=(r=t[n][0]).trace).scalegroup===s){var f=o*r.vTotal;"funnelarea"===i.type&&(f/=(1+i.baseratio)/2,f/=i.aspectratio),r.r=Math.sqrt(f)}}}function V(t){var e,r,n,i=t[0],a=i.r,o=i.trace,s=g.getRotationAngle(o.rotation),l=2*Math.PI/i.vTotal,c='px0',u='px1';if("counterclockwise"===o.direction){for(e=0;e<t.length&&t[e].hidden;e++);if(e===t.length)return;s+=l*t[e].v,l*=-1,c='px1',u="px0"}for(n=H(a,s),e=0;e<t.length;e++)(r=t[e]).hidden||(r[c]=n,r.startangle=s,s+=l*r.v/2,r.pxmid=H(a,s),r.midangle=s,n=H(a,s+=l*r.v/2),r.stopangle=s,r[u]=n,r.largeArc=r.v>i.vTotal/2?1:0,r.halfangle=Math.PI*Math.min(r.v/i.vTotal,.5),r.ring=1-o.hole,r.rInscribed=I(r,i))}function H(t,e){return[t*Math.sin(e),-t*Math.cos(e)]}function q(t,e,r){var n=t._fullLayout,i=r.trace,a=i.texttemplate,o=i.textinfo;if(!a&&o&&"none"!==o){var s,c=o.split('+'),u=function(t){return-1!==c.indexOf(t)},f=u('label'),h=u('text'),p=u('value'),d=u('percent'),m=n.separators;if(s=f?[e.label]:[],h){var v=g.getFirstFilled(i.text,e.pts);y(v)&&s.push(v)}p&&s.push(g.formatPieValue(e.v,m)),d&&s.push(g.formatPiePercent(e.v/r.vTotal,m)),e.text=s.join('<br>')}function x(t){return{label:t.label,value:t.v,valueLabel:g.formatPieValue(t.v,n.separators),percent:t.v/r.vTotal,percentLabel:g.formatPiePercent(t.v/r.vTotal,n.separators),color:t.color,text:t.text,customdata:l.castOption(i,t.i,'customdata')}}if(a){var b=l.castOption(i,e.i,'texttemplate');if(b){var _=x(e),w=g.getFirstFilled(i.text,e.pts);(y(w)||""===w)&&(_.text=w),e.text=l.texttemplateString(b,_,t._fullLayout._d3locale,_,i._meta||{})}else e.text=""}}function G(t,e){var r=t.rotate*Math.PI/180,n=Math.cos(r),i=Math.sin(r),a=(e.left+e.right)/2,o=(e.top+e.bottom)/2;t.textX=a*n-o*i,t.textY=a*i+o*n,t.noCenter=!0}e.exports={plot:x,formatSliceLabel:q,transformInsideText:M,determineInsideTextFont:T,positionTitleOutside:D,prerenderTitles:k,layoutAreas:j,attachFxHandlers:_,computeTransform:G}},{"../../components/color":650,"../../components/drawing":672,"../../components/fx":690,"../../lib":787,"../../lib/svg_text_utils":813,"../../plots/plots":901,"../bar/constants":927,"../bar/uniform_text":941,"./event_data":1180,"./helpers":1181,"@plotly/d3":58}],1186:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('./style_one'),a=t('../bar/uniform_text').resizeText;e.exports=function(t){var e=t._fullLayout._pielayer.selectAll('.trace');a(t,e,'pie'),e.each((function(t){var e=t[0].trace,r=n.select(this);r.style({opacity:e.opacity}),r.selectAll('path.surface').each((function(t){n.select(this).call(i,t,e)}))}))}},{"../bar/uniform_text":941,"./style_one":1187,"@plotly/d3":58}],1187:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('./helpers').castOption;e.exports=function(t,e,r){var a=r.marker.line,o=i(a.color,e.pts)||n.defaultLine,s=i(a.width,e.pts)||0;t.style('stroke-width',s).call(n.fill,e.color).call(n.stroke,o)}},{"../../components/color":650,"./helpers":1181}],1188:[function(t,e,r){"use strict";var n=t('../scatter/attributes');e.exports={x:n.x,y:n.y,xy:{valType:"data_array",editType:"calc"},indices:{valType:"data_array",editType:"calc"},xbounds:{valType:"data_array",editType:"calc"},ybounds:{valType:"data_array",editType:"calc"},text:n.text,marker:{color:{valType:"color",arrayOk:!1,editType:"calc"},opacity:{valType:"number",min:0,max:1,dflt:1,arrayOk:!1,editType:"calc"},blend:{valType:"boolean",dflt:null,editType:"calc"},sizemin:{valType:"number",min:.1,max:2,dflt:.5,editType:"calc"},sizemax:{valType:"number",min:.1,dflt:20,editType:"calc"},border:{color:{valType:"color",arrayOk:!1,editType:"calc"},arearatio:{valType:"number",min:0,max:1,dflt:0,editType:"calc"},editType:"calc"},editType:"calc"},transforms:void 0}},{"../scatter/attributes":1202}],1189:[function(t,e,r){"use strict";var n=t('gl-pointcloud2d'),i=t('../../lib/str2rgbarray'),a=t('../../plots/cartesian/autorange').findExtremes,o=t('../scatter/get_trace_color');function s(t,e){this.scene=t,this.uid=e,this.type='pointcloud',this.pickXData=[],this.pickYData=[],this.xData=[],this.yData=[],this.textLabels=[],this.color='rgb(0, 0, 0)',this.name='',this.hoverinfo='all',this.idToIndex=new Int32Array(0),this.bounds=[0,0,0,0],this.pointcloudOptions={positions:new Float32Array(0),idToIndex:this.idToIndex,sizemin:.5,sizemax:12,color:[0,0,0,1],areaRatio:1,borderColor:[0,0,0,1]},this.pointcloud=n(t.glplot,this.pointcloudOptions),this.pointcloud._trace=this}var l=s.prototype;function c(t,e){var r=new s(t,e.uid);return r.update(e),r}l.handlePick=function(t){var e=this.idToIndex[t.pointId];return{trace:this,dataCoord:t.dataCoord,traceCoord:this.pickXYData?[this.pickXYData[2*e],this.pickXYData[2*e+1]]:[this.pickXData[e],this.pickYData[e]],textLabel:Array.isArray(this.textLabels)?this.textLabels[e]:this.textLabels,color:this.color,name:this.name,pointIndex:e,hoverinfo:this.hoverinfo}},l.update=function(t){this.index=t.index,this.textLabels=t.text,this.name=t.name,this.hoverinfo=t.hoverinfo,this.bounds=[1/0,1/0,-1/0,-1/0],this.updateFast(t),this.color=o(t,{})},l.updateFast=function(t){var e,r,n,o,s,l,c=this.xData=this.pickXData=t.x,u=this.yData=this.pickYData=t.y,f=this.pickXYData=t.xy,h=t.xbounds&&t.ybounds,p=t.indices,d=this.bounds;if(f){if(n=f,e=f.length>>>1,h)d[0]=t.xbounds[0],d[2]=t.xbounds[1],d[1]=t.ybounds[0],d[3]=t.ybounds[1];else for(l=0;l<e;l++)o=n[2*l],s=n[2*l+1],o<d[0]&&(d[0]=o),o>d[2]&&(d[2]=o),s<d[1]&&(d[1]=s),s>d[3]&&(d[3]=s);if(p)r=p;else for(r=new Int32Array(e),l=0;l<e;l++)r[l]=l}else for(e=c.length,n=new Float32Array(2*e),r=new Int32Array(e),l=0;l<e;l++)o=c[l],s=u[l],r[l]=l,n[2*l]=o,n[2*l+1]=s,o<d[0]&&(d[0]=o),o>d[2]&&(d[2]=o),s<d[1]&&(d[1]=s),s>d[3]&&(d[3]=s);this.idToIndex=r,this.pointcloudOptions.idToIndex=r,this.pointcloudOptions.positions=n;var m=i(t.marker.color),g=i(t.marker.border.color),v=t.opacity*t.marker.opacity;m[3]*=v,this.pointcloudOptions.color=m;var y=t.marker.blend;if(null===y){var x=100;y=c.length<x||u.length<x}this.pointcloudOptions.blend=y,g[3]*=v,this.pointcloudOptions.borderColor=g;var b=t.marker.sizemin,_=Math.max(t.marker.sizemax,t.marker.sizemin);this.pointcloudOptions.sizeMin=b,this.pointcloudOptions.sizeMax=_,this.pointcloudOptions.areaRatio=t.marker.border.arearatio,this.pointcloud.update(this.pointcloudOptions);var w=this.scene.xaxis,T=this.scene.yaxis,k=_/2||.5;t._extremes[w._id]=a(w,[d[0],d[2]],{ppad:k}),t._extremes[T._id]=a(T,[d[1],d[3]],{ppad:k})},l.dispose=function()[this.pointcloud.dispose()],e.exports=c},{"../../lib/str2rgbarray":812,"../../plots/cartesian/autorange":837,"../scatter/get_trace_color":1212,"gl-pointcloud2d":321}],1190:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes');e.exports=function(t,e,r){function a(r,a){return n.coerce(t,e,i,r,a)}a('x'),a('y'),a('xbounds'),a('ybounds'),t.xy&&t.xy instanceof Float32Array&&(e.xy=t.xy),t.indices&&t.indices instanceof Int32Array&&(e.indices=t.indices),a('text'),a('marker.color',r),a('marker.opacity'),a('marker.blend'),a('marker.sizemin'),a('marker.sizemax'),a('marker.border.color',r),a('marker.border.arearatio'),e._length=null}},{"../../lib":787,"./attributes":1188}],1191:[function(t,e,r){"use strict";["*pointcloud* trace is deprecated!","Please consider switching to the *scattergl* trace type."].join(' '),e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('../scatter3d/calc'),plot:t('./convert'),moduleType:"trace",name:"pointcloud",basePlotModule:t('../../plots/gl2d'),categories:["gl",'gl2d',"showLegend"],meta:{}}},{"../../plots/gl2d":878,"../scatter3d/calc":1231,"./attributes":1188,"./convert":1189,"./defaults":1190}],1192:[function(t,e,r){"use strict";var n=t('../../plots/font_attributes'),i=t('../../plots/attributes'),a=t('../../components/color/attributes'),o=t('../../components/fx/attributes'),s=t('../../plots/domain').attributes,l=t('../../plots/template_attributes').hovertemplateAttrs,c=t('../../components/colorscale/attributes'),u=t('../../plot_api/plot_template').templatedArray,f=t('../../plots/cartesian/axis_format_attributes').descriptionOnlyNumbers,h=t('../../lib/extend').extendFlat,p=t('../../plot_api/edit_types').overrideAll;(e.exports=p({hoverinfo:h({},i.hoverinfo,{flags:[],arrayOk:!1}),hoverlabel:o.hoverlabel,domain:s({name:"sankey",trace:!0}),orientation:{valType:"enumerated",values:["v","h"],dflt:"h"},valueformat:{valType:"string",dflt:".3s",description:f('value')},valuesuffix:{valType:"string",dflt:""},arrangement:{valType:"enumerated",values:["snap",'perpendicular','freeform',"fixed"],dflt:"snap"},textfont:n({}),customdata:void 0,node:{label:{valType:"data_array",dflt:[]},groups:{valType:"info_array",impliedEdits:{x:[],y:[]},dimensions:2,freeLength:!0,dflt:[],items:{valType:"number",editType:"calc"}},x:{valType:"data_array",dflt:[]},y:{valType:"data_array",dflt:[]},color:{valType:"color",arrayOk:!0},customdata:{valType:"data_array",editType:"calc"},line:{color:{valType:"color",dflt:a.defaultLine,arrayOk:!0},width:{valType:"number",min:0,dflt:.5,arrayOk:!0}},pad:{valType:"number",arrayOk:!1,min:0,dflt:20},thickness:{valType:"number",arrayOk:!1,min:1,dflt:20},hoverinfo:{valType:"enumerated",values:["all",'none',"skip"],dflt:"all"},hoverlabel:o.hoverlabel,hovertemplate:l({},{keys:["value","label"]})},link:{label:{valType:"data_array",dflt:[]},color:{valType:"color",arrayOk:!0},customdata:{valType:"data_array",editType:"calc"},line:{color:{valType:"color",dflt:a.defaultLine,arrayOk:!0},width:{valType:"number",min:0,dflt:0,arrayOk:!0}},source:{valType:"data_array",dflt:[]},target:{valType:"data_array",dflt:[]},value:{valType:"data_array",dflt:[]},hoverinfo:{valType:"enumerated",values:["all",'none',"skip"],dflt:"all"},hoverlabel:o.hoverlabel,hovertemplate:l({},{keys:["value","label"]}),colorscales:u('concentrationscales',{editType:"calc",label:{valType:"string",editType:"calc",dflt:""},cmax:{valType:"number",editType:"calc",dflt:1},cmin:{valType:"number",editType:"calc",dflt:0},colorscale:h(c().colorscale,{dflt:[[0,"white"],[1,"black"]]})})}},'calc','nested')).transforms=void 0},{"../../components/color/attributes":649,"../../components/colorscale/attributes":657,"../../components/fx/attributes":681,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plot_api/plot_template":827,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/domain":866,"../../plots/font_attributes":867,"../../plots/template_attributes":910}],1193:[function(t,e,r){"use strict";var n=t('../../plot_api/edit_types').overrideAll,i=t('../../plots/get_data').getModuleCalcData,a=t('./plot'),o=t('../../components/fx/layout_attributes'),s=t('../../lib/setcursor'),l=t('../../components/dragelement'),c=t('../../plots/cartesian/select').prepSelect,u=t('../../lib'),f=t('../../registry'),h='sankey';function p(t,e){var r=t._fullData[e],n=t._fullLayout,i=n.dragmode,a="pan"===n.dragmode?"move":"crosshair",o=r._bgRect;if("pan"!==i&&"zoom"!==i){s(o,a);var h={_id:"x",c2p:u.identity,_offset:r._sankey.translateX,_length:r._sankey.width},p={_id:"y",c2p:u.identity,_offset:r._sankey.translateY,_length:r._sankey.height},d={gd:t,element:o.node(),plotinfo:{id:e,xaxis:h,yaxis:p,fillRangeItems:u.noop},subplot:e,xaxes:[h],yaxes:[p],doneFnCompleted:function(r){var n,i=t._fullData[e],a=i.node.groups.slice(),o=[];function s(t){for(var e=i._sankey.graph.nodes,r=0;r<e.length;r++)if(e[r].pointNumber===t)return e[r]}for(var l=0;l<r.length;l++){var c=s(r[l].pointNumber);if(c)if(c.group){for(var u=0;u<c.childrenNodes.length;u++)o.push(c.childrenNodes[u].pointNumber);a[c.pointNumber-i.node._count]=!1}else o.push(c.pointNumber)}n=a.filter(Boolean).concat([o]),f.call('_guiRestyle',t,{"node.groups":[n]},e)},prepFn:function(t,e,r){c(t,e,r,d,i)}};l.init(d)}}r.name=h,r.baseLayoutAttrOverrides=n({hoverlabel:o.hoverlabel},'plot','nested'),r.plot=function(t){var e=i(t.calcdata,h)[0];a(t,e),r.updateFx(t)},r.clean=function(t,e,r,n){var i=n._has&&n._has(h),a=e._has&&e._has(h);i&&!a&&(n._paperdiv.selectAll('.sankey').remove(),n._paperdiv.selectAll('.bgsankey').remove())},r.updateFx=function(t){for(var e=0;e<t._fullData.length;e++)p(t,e)}},{"../../components/dragelement":669,"../../components/fx/layout_attributes":691,"../../lib":787,"../../lib/setcursor":808,"../../plot_api/edit_types":820,"../../plots/cartesian/select":858,"../../plots/get_data":875,"../../registry":915,"./plot":1198}],1194:[function(t,e,r){"use strict";var n=t('strongly-connected-components'),i=t('../../lib'),a=t('../../lib/gup').wrap,o=i.isArrayOrTypedArray,s=i.isIndex,l=t('../../components/colorscale');function c(t){var e,r=t.node,n=t.link,a=[],c=o(n.color),f=o(n.customdata),h={},p={},d=n.colorscales.length;for(e=0;e<d;e++){var m=n.colorscales[e],g=l.extractScale(m,{cLetter:"c"}),v=l.makeColorScaleFunc(g);p[m.label]=v}var y=0;for(e=0;e<n.value.length;e++)n.source[e]>y&&(y=n.source[e]),n.target[e]>y&&(y=n.target[e]);var x,b=y+1;t.node._count=b;var _=t.node.groups,w={};for(e=0;e<_.length;e++){var T=_[e];for(x=0;x<T.length;x++){var k=T[x],M=b+e;w.hasOwnProperty(k)?i.warn('Node '+k+' is already part of a group.'):w[k]=M}}var A={source:[],target:[]};for(e=0;e<n.value.length;e++){var S=n.value[e],E=n.source[e],L=n.target[e];if(S>0&&s(E,b)&&s(L,b)&&(!w.hasOwnProperty(E)||!w.hasOwnProperty(L)||w[E]!==w[L])){w.hasOwnProperty(L)&&(L=w[L]),w.hasOwnProperty(E)&&(E=w[E]),L=+L,h[E=+E]=h[L]=!0;var C='';n.label&&n.label[e]&&(C=n.label[e]);var P=null;C&&p.hasOwnProperty(C)&&(P=p[C]),a.push({pointNumber:e,label:C,color:c?n.color[e]:n.color,customdata:f?n.customdata[e]:n.customdata,concentrationscale:P,source:E,target:L,value:+S}),A.source.push(E),A.target.push(L)}}var I=b+_.length,z=o(r.color),O=o(r.customdata),D=[];for(e=0;e<I;e++)if(h[e]){var R=r.label[e];D.push({group:e>b-1,childrenNodes:[],pointNumber:e,label:R,color:z?r.color[e]:r.color,customdata:O?r.customdata[e]:r.customdata})}var F=!1;return u(I,A.source,A.target)&&(F=!0),{circular:F,links:a,nodes:D,groups:_,groupLookup:w}}function u(t,e,r){for(var a=i.init2dArray(t,0),o=0;o<Math.min(e.length,r.length);o++)if(i.isIndex(e[o],t)&&i.isIndex(r[o],t)){if(e[o]===r[o])return!0;a[e[o]].push(r[o])}return n(a).components.some((function(t){return t.length>1}))}e.exports=function(t,e){var r=c(e);return a({circular:r.circular,_nodes:r.nodes,_links:r.links,_groups:r.groups,_groupLookup:r.groupLookup})}},{"../../components/colorscale":662,"../../lib":787,"../../lib/gup":784,"strongly-connected-components":575}],1195:[function(t,e,r){"use strict";e.exports={nodeTextOffsetHorizontal:4,nodeTextOffsetVertical:3,nodePadAcross:10,sankeyIterations:50,forceIterations:5,forceTicksPerFrame:10,duration:500,ease:"linear",cn:{sankey:"sankey",sankeyLinks:"sankey-links",sankeyLink:"sankey-link",sankeyNodeSet:"sankey-node-set",sankeyNode:"sankey-node",nodeRect:"node-rect",nodeLabel:"node-label"}}},{}],1196:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../components/color'),o=t('tinycolor2'),s=t('../../plots/domain').defaults,l=t('../../components/fx/hoverlabel_defaults'),c=t('../../plot_api/plot_template'),u=t('../../plots/array_container_defaults');function f(t,e){function r(r,a){return n.coerce(t,e,i.link.colorscales,r,a)}r('label'),r('cmin'),r('cmax'),r('colorscale')}e.exports=function(t,e,r,h){function p(r,a){return n.coerce(t,e,i,r,a)}var d=n.extendDeep(h.hoverlabel,t.hoverlabel),m=t.node,g=c.newContainer(e,'node');function v(t,e){return n.coerce(m,g,i.node,t,e)}v('label'),v('groups'),v('x'),v('y'),v('pad'),v('thickness'),v('line.color'),v('line.width'),v('hoverinfo',t.hoverinfo),l(m,g,v,d),v('hovertemplate');var y=h.colorway,x=function(t){return y[t%y.length]};v('color',g.label.map((function(t,e){return a.addOpacity(x(e),.8)}))),v('customdata');var b=t.link||{},_=c.newContainer(e,'link');function w(t,e){return n.coerce(b,_,i.link,t,e)}w('label'),w('source'),w('target'),w('value'),w('line.color'),w('line.width'),w('hoverinfo',t.hoverinfo),l(b,_,w,d),w('hovertemplate');var T,k=o(h.paper_bgcolor).getLuminance()<.333?"rgba(255, 255, 255, 0.6)":"rgba(0, 0, 0, 0.2)";w('color',n.repeat(k,_.value.length)),w('customdata'),u(b,_,{name:"colorscales",handleItemDefaults:f}),s(e,h,p),p('orientation'),p('valueformat'),p('valuesuffix'),g.x.length&&g.y.length&&(T='freeform'),p('arrangement',T),n.coerceFont(p,'textfont',n.extendFlat({},h.font)),e._length=null}},{"../../components/color":650,"../../components/fx/hoverlabel_defaults":688,"../../lib":787,"../../plot_api/plot_template":827,"../../plots/array_container_defaults":833,"../../plots/domain":866,"./attributes":1192,tinycolor2:583}],1197:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot'),moduleType:"trace",name:"sankey",basePlotModule:t('./base_plot'),selectPoints:t('./select.js'),categories:["noOpacity"],meta:{}}},{"./attributes":1192,"./base_plot":1193,"./calc":1194,"./defaults":1196,"./plot":1198,"./select.js":1200}],1198:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=i.numberFormat,o=t('./render'),s=t('../../components/fx'),l=t('../../components/color'),c=t('./constants').cn,u=i._;function f(t){return""!==t}function h(t,e){return t.filter((function(t){return t.key===e.traceId}))}function p(t,e){n.select(t).select('path').style('fill-opacity',e),n.select(t).select('rect').style('fill-opacity',e)}function d(t){n.select(t).select('text.name').style('fill','black')}function m(t){return function(e){return-1!==t.node.sourceLinks.indexOf(e.link)||-1!==t.node.targetLinks.indexOf(e.link)}}function g(t){return function(e){return-1!==e.node.sourceLinks.indexOf(t.link)||-1!==e.node.targetLinks.indexOf(t.link)}}function v(t,e,r){e&&r&&h(r,e).selectAll("."+c.sankeyLink).filter(m(e)).call(x.bind(0,e,r,!1))}function y(t,e,r){e&&r&&h(r,e).selectAll("."+c.sankeyLink).filter(m(e)).call(b.bind(0,e,r,!1))}function x(t,e,r,n){var i=n.datum().link.label;n.style('fill-opacity',(function(t){if(!t.link.concentrationscale)return.4})),i&&h(e,t).selectAll("."+c.sankeyLink).filter((function(t){return t.link.label===i})).style('fill-opacity',(function(t){if(!t.link.concentrationscale)return.4})),r&&h(e,t).selectAll("."+c.sankeyNode).filter(g(t)).call(v)}function b(t,e,r,n){var i=n.datum().link.label;n.style('fill-opacity',(function(t){return t.tinyColorAlpha})),i&&h(e,t).selectAll("."+c.sankeyLink).filter((function(t){return t.link.label===i})).style('fill-opacity',(function(t){return t.tinyColorAlpha})),r&&h(e,t).selectAll(c.sankeyNode).filter(g(t)).call(y)}function _(t,e)[var r=t.hoverlabel||{],n=i.nestedProperty(r,e).get();return!Array.isArray(n)&&n}e.exports=function(t,e){for(var r=t._fullLayout,i=r._paper,h=r._size,m=0;m<t._fullData.length;m++)if(t._fullData[m].visible&&t._fullData[m].type===c.sankey&&!t._fullData[m]._viewInitial){var g=t._fullData[m].node;t._fullData[m]._viewInitial={node:{groups:g.groups.slice(),x:g.x.slice(),y:g.y.slice()}}}var w=function(e,r){var i=r.link;i.originalEvent=n.event,t._hoverdata=[i],s.click(t,{target:!0})},T=function(e,r,i){!1!==t._fullLayout.hovermode&&(n.select(e).call(x.bind(0,r,i,!0)),"skip"!==r.link.trace.link.hoverinfo&&(r.link.fullData=r.link.trace,t.emit('plotly_hover',{event:n.event,points:[r.link]})))},k=u(t,'source:')+" ',M=u(t,'target:')+' ',A=u(t,'concentration:')+' ',S=u(t,'incoming flow count:')+' ',E=u(t,'outgoing flow count:')+' ",L=function(e,i){if(!1!==t._fullLayout.hovermode){var o=i.link.trace.link;if("none"!==o.hoverinfo&&"skip"!==o.hoverinfo){for(var c=[],u=0,h=0;h<i.flow.links.length;h++){var m=i.flow.links[h];if("closest"!==t._fullLayout.hovermode||i.link.pointNumber===m.pointNumber){i.link.pointNumber===m.pointNumber&&(u=h),m.fullData=m.trace,o=i.link.trace.link;var g=y(m),v={valueLabel:a(i.valueFormat)(m.value)+i.valueSuffix};c.push({x:g[0],y:g[1],name:v.valueLabel,text:[m.label||"",k+m.source.label,M+m.target.label,m.concentrationscale?A+a('%0.2f')(m.flow.labelConcentration):""].filter(f).join('<br>'),color:_(o,'bgcolor')||l.addOpacity(m.color,1),borderColor:_(o,'bordercolor'),fontFamily:_(o,'font.family'),fontSize:_(o,'font.size'),fontColor:_(o,'font.color'),nameLength:_(o,'namelength'),textAlign:_(o,'align'),idealAlign:n.event.x<g[0]?"right":"left",hovertemplate:o.hovertemplate,hovertemplateLabels:v,eventData:[m]})}}s.loneHover(c,{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:t,anchorIndex:u}).each((function(){var t=this;i.link.concentrationscale||p(t,.65),d(t)}))}}function y(t){var e,r;t.circular?(e=(t.circularPathData.leftInnerExtent+t.circularPathData.rightInnerExtent)/2,r=t.circularPathData.verticalFullExtent):(e=(t.source.x1+t.target.x0)/2,r=(t.y0+t.y1)/2);var n=[e,r];return"v"===t.trace.orientation&&n.reverse(),n[0]+=i.parent.translateX,n[1]+=i.parent.translateY,n}},C=function(e,i,a){!1!==t._fullLayout.hovermode&&(n.select(e).call(b.bind(0,i,a,!0)),"skip"!==i.link.trace.link.hoverinfo&&(i.link.fullData=i.link.trace,t.emit('plotly_unhover',{event:n.event,points:[i.link]})),s.loneUnhover(r._hoverlayer.node()))},P=function(e,r,i){var a=r.node;a.originalEvent=n.event,t._hoverdata=[a],n.select(e).call(y,r,i),s.click(t,{target:!0})},I=function(e,r,i){!1!==t._fullLayout.hovermode&&(n.select(e).call(v,r,i),"skip"!==r.node.trace.node.hoverinfo&&(r.node.fullData=r.node.trace,t.emit('plotly_hover',{event:n.event,points:[r.node]})))},z=function(e,i){if(!1!==t._fullLayout.hovermode){var o=i.node.trace.node;if("none"!==o.hoverinfo&&"skip"!==o.hoverinfo){var l=n.select(e).select("."+c.nodeRect),u=t._fullLayout._paperdiv.node().getBoundingClientRect(),h=l.node().getBoundingClientRect(),m=h.left-2-u.left,g=h.right+2-u.left,v=h.top+h.height/4-u.top,y={valueLabel:a(i.valueFormat)(i.node.value)+i.valueSuffix};i.node.fullData=i.node.trace,t._fullLayout._calcInverseTransform(t);var x=t._fullLayout._invScaleX,b=t._fullLayout._invScaleY,w=s.loneHover({x0:x*m,x1:x*g,y:b*v,name:a(i.valueFormat)(i.node.value)+i.valueSuffix,text:[i.node.label,S+i.node.targetLinks.length,E+i.node.sourceLinks.length].filter(f).join('<br>'),color:_(o,'bgcolor')||i.tinyColorHue,borderColor:_(o,'bordercolor'),fontFamily:_(o,'font.family'),fontSize:_(o,'font.size'),fontColor:_(o,'font.color'),nameLength:_(o,'namelength'),textAlign:_(o,'align'),idealAlign:"left",hovertemplate:o.hovertemplate,hovertemplateLabels:y,eventData:[i.node]},{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:t});p(w,.85),d(w)}}},O=function(e,i,a){!1!==t._fullLayout.hovermode&&(n.select(e).call(y,i,a),"skip"!==i.node.trace.node.hoverinfo&&(i.node.fullData=i.node.trace,t.emit('plotly_unhover',{event:n.event,points:[i.node]})),s.loneUnhover(r._hoverlayer.node()))};o(t,i,e,{width:h.w,height:h.h,margin:{t:h.t,r:h.r,b:h.b,l:h.l}},{linkEvents:{hover:T,follow:L,unhover:C,select:w},nodeEvents:{hover:I,follow:z,unhover:O,select:P}})}},{"../../components/color":650,"../../components/fx":690,"../../lib":787,"./constants":1195,"./render":1199,"@plotly/d3":58}],1199:[function(t,e,r){"use strict";var n=t('d3-force'),i=t('d3-interpolate').interpolateNumber,a=t('@plotly/d3'),o=t('@plotly/d3-sankey'),s=t('@plotly/d3-sankey-circular'),l=t('./constants'),c=t('tinycolor2'),u=t('../../components/color'),f=t('../../components/drawing'),h=t('../../lib'),p=h.strTranslate,d=h.strRotate,m=t('../../lib/gup'),g=m.keyFun,v=m.repeat,y=m.unwrap,x=t('../../lib/svg_text_utils'),b=t('../../registry'),_=t('../../constants/alignment'),w=_.CAP_SHIFT,T=_.LINE_SPACING,k=3;function M(t,e,r){var n,i=y(e),a=i.trace,u=a.domain,f="h"===a.orientation,p=a.node.pad,d=a.node.thickness,m=t.width*(u.x[1]-u.x[0]),g=t.height*(u.y[1]-u.y[0]),v=i._nodes,x=i._links,b=i.circular;(n=b?s.sankeyCircular().circularLinkGap(0):o.sankey()).iterations(l.sankeyIterations).size(f?[m,g]:[g,m]).nodeWidth(d).nodePadding(p).nodeId((function(t){return t.pointNumber})).nodes(v).links(x);var _,w,T,k=n();for(var M in n.nodePadding()<p&&h.warn('node.pad was reduced to ',n.nodePadding(),' to fit within the figure.'),i._groupLookup){var A,S=parseInt(i._groupLookup[M]);for(_=0;_<k.nodes.length;_++)if(k.nodes[_].pointNumber===S){A=k.nodes[_];break}if(A){var E={pointNumber:parseInt(M),x0:A.x0,x1:A.x1,y0:A.y0,y1:A.y1,partOfGroup:!0,sourceLinks:[],targetLinks:[]};k.nodes.unshift(E),A.childrenNodes.unshift(E)}}function L(){for(_=0;_<k.nodes.length;_++){var t,e,r=k.nodes[_],n={};for(w=0;w<r.targetLinks.length;w++)t=(e=r.targetLinks[w]).source.pointNumber+":"+e.target.pointNumber,n.hasOwnProperty(t)||(n[t]=[]),n[t].push(e);var i=Object.keys(n);for(w=0;w<i.length;w++){var a=n[t=i[w]],o=0,s={};for(T=0;T<a.length;T++)s[(e=a[T]).label]||(s[e.label]=0),s[e.label]+=e.value,o+=e.value;for(T=0;T<a.length;T++)(e=a[T]).flow={value:o,labelConcentration:s[e.label]/o,concentration:e.value/o,links:a},e.concentrationscale&&(e.color=c(e.concentrationscale(e.flow.labelConcentration)))}var l=0;for(w=0;w<r.sourceLinks.length;w++)l+=r.sourceLinks[w].value;for(w=0;w<r.sourceLinks.length;w++)(e=r.sourceLinks[w]).concentrationOut=e.value/l;var u=0;for(w=0;w<r.targetLinks.length;w++)u+=r.targetLinks[w].value;for(w=0;w<r.targetLinks.length;w++)(e=r.targetLinks[w]).concenrationIn=e.value/u}}function C(t){t.forEach((function(t){var e,r,n,i=0,a=t.length;for(t.sort((function(t,e){return t.y0-e.y0})),n=0;n<a;++n)(e=t[n]).y0>=i||(r=i-e.y0)>1e-6&&(e.y0+=r,e.y1+=r),i=e.y1+p}))}function P(t){var e,r,n=t.map((function(t,e){return{x0:t.x0,index:e}})).sort((function(t,e){return t.x0-e.x0})),i=[],a=-1,o=-1/0;for(_=0;_<n.length;_++){var s=t[n[_].index];s.x0>o+d&&(a+=1,e=s.x0),o=s.x0,i[a]||(i[a]=[]),i[a].push(s),r=e-s.x0,s.x0+=r,s.x1+=r}return i}if(L(),a.node.x.length&&a.node.y.length){for(_=0;_<Math.min(a.node.x.length,a.node.y.length,k.nodes.length);_++)if(a.node.x[_]&&a.node.y[_]){var I=[a.node.x[_]*m,a.node.y[_]*g];k.nodes[_].x0=I[0]-d/2,k.nodes[_].x1=I[0]+d/2;var z=k.nodes[_].y1-k.nodes[_].y0;k.nodes[_].y0=I[1]-z/2,k.nodes[_].y1=I[1]+z/2}"snap"===a.arrangement&&C(P(v=k.nodes)),n.update(k)}return{circular:b,key:r,trace:a,guid:h.randstr(),horizontal:f,width:m,height:g,nodePad:a.node.pad,nodeLineColor:a.node.line.color,nodeLineWidth:a.node.line.width,linkLineColor:a.link.line.color,linkLineWidth:a.link.line.width,valueFormat:a.valueformat,valueSuffix:a.valuesuffix,textFont:a.textfont,translateX:u.x[0]*t.width+t.margin.l,translateY:t.height-u.y[1]*t.height+t.margin.t,dragParallel:f?g:m,dragPerpendicular:f?m:g,arrangement:a.arrangement,sankey:n,graph:k,forceLayouts:{},interactionState:{dragInProgress:!1,hovered:!1}}}function A(t,e,r){var n=c(e.color),i=e.source.label+"|"+e.target.label+"__"+r;return e.trace=t.trace,e.curveNumber=t.trace.index,{circular:t.circular,key:i,traceId:t.key,pointNumber:e.pointNumber,link:e,tinyColorHue:u.tinyRGB(n),tinyColorAlpha:n.getAlpha(),linkPath:E,linkLineColor:t.linkLineColor,linkLineWidth:t.linkLineWidth,valueFormat:t.valueFormat,valueSuffix:t.valueSuffix,sankey:t.sankey,parent:t,interactionState:t.interactionState,flow:e.flow}}function S(t){var e=t.width/2,r=t.circularPathData;return"top"===t.circularLinkType?"M '+r.targetX+' '+(r.targetY+e)+' L"+r.rightInnerExtent+" "+(r.targetY+e)+"A"+(r.rightLargeArcRadius+e)+" '+(r.rightSmallArcRadius+e)+' 0 0 1 '+(r.rightFullExtent-e)+' "+(r.targetY-r.rightSmallArcRadius)+"L"+(r.rightFullExtent-e)+" "+r.verticalRightInnerExtent+"A"+(r.rightLargeArcRadius+e)+" '+(r.rightLargeArcRadius+e)+' 0 0 1 '+r.rightInnerExtent+' "+(r.verticalFullExtent-e)+"L"+r.leftInnerExtent+" "+(r.verticalFullExtent-e)+"A"+(r.leftLargeArcRadius+e)+" '+(r.leftLargeArcRadius+e)+' 0 0 1 '+(r.leftFullExtent+e)+' "+r.verticalLeftInnerExtent+"L"+(r.leftFullExtent+e)+" "+(r.sourceY-r.leftSmallArcRadius)+"A"+(r.leftLargeArcRadius+e)+" '+(r.leftSmallArcRadius+e)+' 0 0 1 '+r.leftInnerExtent+' "+(r.sourceY+e)+"L"+r.sourceX+" "+(r.sourceY+e)+"L"+r.sourceX+" "+(r.sourceY-e)+"L"+r.leftInnerExtent+" "+(r.sourceY-e)+"A"+(r.leftLargeArcRadius-e)+" '+(r.leftSmallArcRadius-e)+' 0 0 0 '+(r.leftFullExtent-e)+' "+(r.sourceY-r.leftSmallArcRadius)+"L"+(r.leftFullExtent-e)+" "+r.verticalLeftInnerExtent+"A"+(r.leftLargeArcRadius-e)+" '+(r.leftLargeArcRadius-e)+' 0 0 0 '+r.leftInnerExtent+' "+(r.verticalFullExtent+e)+"L"+r.rightInnerExtent+" "+(r.verticalFullExtent+e)+"A"+(r.rightLargeArcRadius-e)+" '+(r.rightLargeArcRadius-e)+' 0 0 0 '+(r.rightFullExtent+e)+' "+r.verticalRightInnerExtent+"L"+(r.rightFullExtent+e)+" "+(r.targetY-r.rightSmallArcRadius)+"A"+(r.rightLargeArcRadius-e)+" '+(r.rightSmallArcRadius-e)+' 0 0 0 '+r.rightInnerExtent+' "+(r.targetY-e)+"L"+r.targetX+" "+(r.targetY-e)+"Z":"M '+r.targetX+' '+(r.targetY-e)+' L"+r.rightInnerExtent+" "+(r.targetY-e)+"A"+(r.rightLargeArcRadius+e)+" '+(r.rightSmallArcRadius+e)+' 0 0 0 '+(r.rightFullExtent-e)+' "+(r.targetY+r.rightSmallArcRadius)+"L"+(r.rightFullExtent-e)+" "+r.verticalRightInnerExtent+"A"+(r.rightLargeArcRadius+e)+" '+(r.rightLargeArcRadius+e)+' 0 0 0 '+r.rightInnerExtent+' "+(r.verticalFullExtent+e)+"L"+r.leftInnerExtent+" "+(r.verticalFullExtent+e)+"A"+(r.leftLargeArcRadius+e)+" '+(r.leftLargeArcRadius+e)+' 0 0 0 '+(r.leftFullExtent+e)+' "+r.verticalLeftInnerExtent+"L"+(r.leftFullExtent+e)+" "+(r.sourceY+r.leftSmallArcRadius)+"A"+(r.leftLargeArcRadius+e)+" '+(r.leftSmallArcRadius+e)+' 0 0 0 '+r.leftInnerExtent+' "+(r.sourceY-e)+"L"+r.sourceX+" "+(r.sourceY-e)+"L"+r.sourceX+" "+(r.sourceY+e)+"L"+r.leftInnerExtent+" "+(r.sourceY+e)+"A"+(r.leftLargeArcRadius-e)+" '+(r.leftSmallArcRadius-e)+' 0 0 1 '+(r.leftFullExtent-e)+' "+(r.sourceY+r.leftSmallArcRadius)+"L"+(r.leftFullExtent-e)+" "+r.verticalLeftInnerExtent+"A"+(r.leftLargeArcRadius-e)+" '+(r.leftLargeArcRadius-e)+' 0 0 1 '+r.leftInnerExtent+' "+(r.verticalFullExtent-e)+"L"+r.rightInnerExtent+" "+(r.verticalFullExtent-e)+"A"+(r.rightLargeArcRadius-e)+" '+(r.rightLargeArcRadius-e)+' 0 0 1 '+(r.rightFullExtent+e)+' "+r.verticalRightInnerExtent+"L"+(r.rightFullExtent+e)+" "+(r.targetY+r.rightSmallArcRadius)+"A"+(r.rightLargeArcRadius-e)+" '+(r.rightSmallArcRadius-e)+' 0 0 1 '+r.rightInnerExtent+' "+(r.targetY+e)+"L"+r.targetX+" "+(r.targetY+e)+"Z"}function E(){var t=.5;function e(e){if(e.link.circular)return S(e.link);var r=e.link.source.x1,n=e.link.target.x0,a=i(r,n),o=a(t),s=a(1-t),l=e.link.y0-e.link.width/2,c=e.link.y0+e.link.width/2,u=e.link.y1-e.link.width/2,f=e.link.y1+e.link.width/2;return"M"+r+","+l+"C"+o+",'+l+' '+s+','+u+' '+n+',"+u+"L"+n+","+f+"C"+s+",'+f+' '+o+','+c+' '+r+',"+c+"Z"}return e}function L(t,e){var r=c(e.color),n=l.nodePadAcross,i=t.nodePad/2;e.dx=e.x1-e.x0,e.dy=e.y1-e.y0;var a=e.dx,o=Math.max(.5,e.dy),s="node_"+e.pointNumber;return e.group&&(s=h.randstr()),e.trace=t.trace,e.curveNumber=t.trace.index,{index:e.pointNumber,key:s,partOfGroup:e.partOfGroup||!1,group:e.group,traceId:t.key,trace:t.trace,node:e,nodePad:t.nodePad,nodeLineColor:t.nodeLineColor,nodeLineWidth:t.nodeLineWidth,textFont:t.textFont,size:t.horizontal?t.height:t.width,visibleWidth:Math.ceil(a),visibleHeight:o,zoneX:-n,zoneY:-i,zoneWidth:a+2*n,zoneHeight:o+2*i,labelY:t.horizontal?e.dy/2+1:e.dx/2+1,left:1===e.originalLayer,sizeAcross:t.width,forceLayouts:t.forceLayouts,horizontal:t.horizontal,darkBackground:r.getBrightness()<=128,tinyColorHue:u.tinyRGB(r),tinyColorAlpha:r.getAlpha(),valueFormat:t.valueFormat,valueSuffix:t.valueSuffix,sankey:t.sankey,graph:t.graph,arrangement:t.arrangement,uniqueNodeLabelPathId:[t.guid,t.key,s].join('_'),interactionState:t.interactionState,figure:t}}function C(t){t.attr('transform',(function(t){return p(t.node.x0.toFixed(3),t.node.y0.toFixed(3))}))}function P(t)[t.call(C)]function I(t,e){t.call(P),e.attr('d',E())}function z(t){t.attr('width',(function(t){return t.node.x1-t.node.x0})).attr('height',(function(t){return t.visibleHeight}))}function O(t){return t.link.width>1||t.linkLineWidth>0}function D(t){return p(t.translateX,t.translateY)+(t.horizontal?"matrix(1 0 0 1 0 0)":"matrix(0 1 1 0 0 0)")}function R(t,e,r){t.on('.basic',null).on('mouseover.basic',(function(t){t.interactionState.dragInProgress||t.partOfGroup||(r.hover(this,t,e),t.interactionState.hovered=[this,t])})).on('mousemove.basic',(function(t){t.interactionState.dragInProgress||t.partOfGroup||(r.follow(this,t),t.interactionState.hovered=[this,t])})).on('mouseout.basic',(function(t){t.interactionState.dragInProgress||t.partOfGroup||(r.unhover(this,t,e),t.interactionState.hovered=!1)})).on('click.basic',(function(t){t.interactionState.hovered&&(r.unhover(this,t,e),t.interactionState.hovered=!1),t.interactionState.dragInProgress||t.partOfGroup||r.select(this,t,e)}))}function F(t,e,r,n){var i=a.behavior.drag().origin((function(t){return{x:t.node.x0+t.visibleWidth/2,y:t.node.y0+t.visibleHeight/2}})).on('dragstart',(function(i){if("fixed"!==i.arrangement&&(h.ensureSingle(n._fullLayout._infolayer,'g','dragcover',(function(t){n._fullLayout._dragCover=t})),h.raiseToTop(this),i.interactionState.dragInProgress=i.node,H(i.node),i.interactionState.hovered&&(r.nodeEvents.unhover.apply(0,i.interactionState.hovered),i.interactionState.hovered=!1),"snap"===i.arrangement)){var a=i.traceId+"|"+i.key;i.forceLayouts[a]?i.forceLayouts[a].alpha(1):B(t,a,i,n),N(t,e,i,a,n)}})).on('drag',(function(r){if("fixed"!==r.arrangement){var n=a.event.x,i=a.event.y;"snap"===r.arrangement?(r.node.x0=n-r.visibleWidth/2,r.node.x1=n+r.visibleWidth/2,r.node.y0=i-r.visibleHeight/2,r.node.y1=i+r.visibleHeight/2):("freeform"===r.arrangement&&(r.node.x0=n-r.visibleWidth/2,r.node.x1=n+r.visibleWidth/2),i=Math.max(0,Math.min(r.size-r.visibleHeight/2,i)),r.node.y0=i-r.visibleHeight/2,r.node.y1=i+r.visibleHeight/2),H(r.node),"snap"!==r.arrangement&&(r.sankey.update(r.graph),I(t.filter(q(r)),e))}})).on('dragend',(function(t){if("fixed"!==t.arrangement){t.interactionState.dragInProgress=!1;for(var e=0;e<t.node.childrenNodes.length;e++)t.node.childrenNodes[e].x=t.node.x,t.node.childrenNodes[e].y=t.node.y;"snap"!==t.arrangement&&U(t,n)}}));t.on('.drag',null).call(i)}function B(t,e,r,i){G(r.graph.nodes);var a=r.graph.nodes.filter((function(t){return t.originalX===r.node.originalX})).filter((function(t){return!t.partOfGroup}));r.forceLayouts[e]=n.forceSimulation(a).alphaDecay(0).force('collide',n.forceCollide().radius((function(t){return t.dy/2+r.nodePad/2})).strength(1).iterations(l.forceIterations)).force('constrain',j(t,e,a,r,i)).stop()}function N(t,e,r,n,i){window.requestAnimationFrame((function a(){var o;for(o=0;o<l.forceTicksPerFrame;o++)r.forceLayouts[n].tick();if(Y(r.graph.nodes),r.sankey.update(r.graph),I(t.filter(q(r)),e),r.forceLayouts[n].alpha()>0)window.requestAnimationFrame(a);else{var s=r.node.originalX;r.node.x0=s-r.visibleWidth/2,r.node.x1=s+r.visibleWidth/2,U(r,i)}}))}function j(t,e,r,n){return function(){for(var t=0,i=0;i<r.length;i++){var a=r[i];a===n.interactionState.dragInProgress?(a.x=a.lastDraggedX,a.y=a.lastDraggedY):(a.vx=(a.originalX-a.x)/l.forceTicksPerFrame,a.y=Math.min(n.size-a.dy/2,Math.max(a.dy/2,a.y))),t=Math.max(t,Math.abs(a.vx),Math.abs(a.vy))}!n.interactionState.dragInProgress&&t<.1&&n.forceLayouts[e].alpha()>0&&n.forceLayouts[e].alpha(0)}}function U(t,e){for(var r=[],n=[],i=0;i<t.graph.nodes.length;i++){var a=(t.graph.nodes[i].x0+t.graph.nodes[i].x1)/2,o=(t.graph.nodes[i].y0+t.graph.nodes[i].y1)/2;r.push(a/t.figure.width),n.push(o/t.figure.height)}b.call('_guiRestyle',e,{"node.x":[r],"node.y":[n]},t.trace.index).then((function()[e._fullLayout._dragCover&&e._fullLayout._dragCover.remove()]))}function V(t){var e,r=[];for(e=0;e<t.length;e++)t[e].originalX=(t[e].x0+t[e].x1)/2,t[e].originalY=(t[e].y0+t[e].y1)/2,-1===r.indexOf(t[e].originalX)&&r.push(t[e].originalX);for(r.sort((function(t,e){return t-e})),e=0;e<t.length;e++)t[e].originalLayerIndex=r.indexOf(t[e].originalX),t[e].originalLayer=t[e].originalLayerIndex/(r.length-1)}function H(t){t.lastDraggedX=t.x0+t.dx/2,t.lastDraggedY=t.y0+t.dy/2}function q(t){return function(e){return e.node.originalX===t.node.originalX}}function G(t){for(var e=0;e<t.length;e++)t[e].y=(t[e].y0+t[e].y1)/2,t[e].x=(t[e].x0+t[e].x1)/2}function Y(t){for(var e=0;e<t.length;e++)t[e].y0=t[e].y-t[e].dy/2,t[e].y1=t[e].y0+t[e].dy,t[e].x0=t[e].x-t[e].dx/2,t[e].x1=t[e].x0+t[e].dx}e.exports=function(t,e,r,n,i){var o=!1;h.ensureSingle(t._fullLayout._infolayer,'g','first-render',(function(){o=!0}));var s=t._fullLayout._dragCover,m=r.filter((function(t){return y(t).trace.visible})).map(M.bind(null,n)),b=e.selectAll("."+l.cn.sankey).data(m,g);b.exit().remove(),b.enter().append('g').classed(l.cn.sankey,!0).style('box-sizing','content-box').style('position','absolute').style('left',0).style('shape-rendering','geometricPrecision').style('pointer-events','auto').attr('transform',D),b.each((function(e,r){t._fullData[r]._sankey=e;var n="bgsankey-"+e.trace.uid+"-"+r;h.ensureSingle(t._fullLayout._draggers,'rect',n),t._fullData[r]._bgRect=a.select("."+n),t._fullData[r]._bgRect.style('pointer-events','all').attr('width',e.width).attr('height',e.height).attr('x',e.translateX).attr('y',e.translateY).classed('bgsankey',!0).style({fill:"transparent","stroke-width":0})})),b.transition().ease(l.ease).duration(l.duration).attr('transform',D);var _=b.selectAll("."+l.cn.sankeyLinks).data(v,g);_.enter().append('g').classed(l.cn.sankeyLinks,!0).style('fill','none');var S=_.selectAll("."+l.cn.sankeyLink).data((function(t){return t.graph.links.filter((function(t){return t.value})).map(A.bind(null,t))}),g);S.enter().append('path').classed(l.cn.sankeyLink,!0).call(R,b,i.linkEvents),S.style('stroke',(function(t){return O(t)?u.tinyRGB(c(t.linkLineColor)):t.tinyColorHue})).style('stroke-opacity',(function(t){return O(t)?u.opacity(t.linkLineColor):t.tinyColorAlpha})).style('fill',(function(t){return t.tinyColorHue})).style('fill-opacity',(function(t){return t.tinyColorAlpha})).style('stroke-width',(function(t){return O(t)?t.linkLineWidth:1})).attr('d',E()),S.style('opacity',(function(){return t._context.staticPlot||o||s?1:0})).transition().ease(l.ease).duration(l.duration).style('opacity',1),S.exit().transition().ease(l.ease).duration(l.duration).style('opacity',0).remove();var P=b.selectAll("."+l.cn.sankeyNodeSet).data(v,g);P.enter().append('g').classed(l.cn.sankeyNodeSet,!0),P.style('cursor',(function(t){switch(t.arrangement){case"fixed":return'default';case"perpendicular":return'ns-resize';default:return"move"}}));var I=P.selectAll("."+l.cn.sankeyNode).data((function(t){var e=t.graph.nodes;return V(e),e.map(L.bind(null,t))}),g);I.enter().append('g').classed(l.cn.sankeyNode,!0).call(C).style('opacity',(function(e){return!t._context.staticPlot&&!o||e.partOfGroup?0:1})),I.call(R,b,i.nodeEvents).call(F,S,i,t),I.transition().ease(l.ease).duration(l.duration).call(C).style('opacity',(function(t){return t.partOfGroup?0:1})),I.exit().transition().ease(l.ease).duration(l.duration).style('opacity',0).remove();var B=I.selectAll("."+l.cn.nodeRect).data(v);B.enter().append('rect').classed(l.cn.nodeRect,!0).call(z),B.style('stroke-width',(function(t){return t.nodeLineWidth})).style('stroke',(function(t){return u.tinyRGB(c(t.nodeLineColor))})).style('stroke-opacity',(function(t){return u.opacity(t.nodeLineColor)})).style('fill',(function(t){return t.tinyColorHue})).style('fill-opacity',(function(t){return t.tinyColorAlpha})),B.transition().ease(l.ease).duration(l.duration).call(z);var N=I.selectAll("."+l.cn.nodeLabel).data(v);N.enter().append('text').classed(l.cn.nodeLabel,!0).style('cursor','default'),N.attr('data-notex',1).text((function(t){return t.node.label})).each((function(e){var r=a.select(this);f.font(r,e.textFont),x.convertToTspans(r,t)})).style('text-shadow',x.makeTextShadow(t._fullLayout.paper_bgcolor)).attr('text-anchor',(function(t){return t.horizontal&&t.left?"end":"start"})).attr('transform',(function(t){var e=a.select(this),r=x.lineCount(e),n=t.textFont.size*((r-1)*T-w),i=t.nodeLineWidth/2+k,o=((t.horizontal?t.visibleHeight:t.visibleWidth)-n)/2;t.horizontal&&(t.left?i=-i:i+=t.visibleWidth);var s=t.horizontal?"":"scale(-1,1)"+d(90);return p(t.horizontal?i:o,t.horizontal?o:i)+s})),N.transition().ease(l.ease).duration(l.duration)}},{"../../components/color":650,"../../components/drawing":672,"../../constants/alignment":755,"../../lib":787,"../../lib/gup":784,"../../lib/svg_text_utils":813,"../../registry":915,"./constants":1195,"@plotly/d3":58,"@plotly/d3-sankey":57,"@plotly/d3-sankey-circular":56,"d3-force":163,"d3-interpolate":168,tinycolor2:583}],1200:[function(t,e,r){"use strict";e.exports=function(t,e){for(var r=[],n=t.cd[0].trace,i=n._sankey.graph.nodes,a=0;a<i.length;a++){var o=i[a];if(!o.partOfGroup){var s=[(o.x0+o.x1)/2,(o.y0+o.y1)/2];"v"===n.orientation&&s.reverse(),e&&e.contains(s,!1,a,t)&&r.push({pointNumber:o.pointNumber})}}return r}},{}],1201:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){for(var r=0;r<t.length;r++)t[r].i=r;n.mergeArray(e.text,t,'tx'),n.mergeArray(e.texttemplate,t,'txt'),n.mergeArray(e.hovertext,t,'htx'),n.mergeArray(e.customdata,t,'data'),n.mergeArray(e.textposition,t,'tp'),e.textfont&&(n.mergeArrayCastPositive(e.textfont.size,t,'ts'),n.mergeArray(e.textfont.color,t,'tc'),n.mergeArray(e.textfont.family,t,'tf'));var i=e.marker;if(i){n.mergeArrayCastPositive(i.size,t,'ms'),n.mergeArrayCastPositive(i.opacity,t,'mo'),n.mergeArray(i.symbol,t,'mx'),n.mergeArray(i.color,t,'mc');var a=i.line;i.line&&(n.mergeArray(a.color,t,'mlc'),n.mergeArrayCastPositive(a.width,t,'mlw'));var o=i.gradient;o&&"none"!==o.type&&(n.mergeArray(o.type,t,'mgt'),n.mergeArray(o.color,t,'mgc'))}}},{"../../lib":787}],1202:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../../components/colorscale/attributes'),s=t('../../plots/font_attributes'),l=t('../../components/drawing/attributes').dash,c=t('../../components/drawing'),u=t('./constants'),f=t('../../lib/extend').extendFlat;function h(t){return{valType:"any",dflt:0,editType:"calc"}}function p(t){return{valType:"any",editType:"calc"}}function d(t){return{valType:"enumerated",values:["start",'middle',"end"],dflt:"middle",editType:"calc"}}e.exports={x:{valType:"data_array",editType:"calc+clearAxisTypes",anim:!0},x0:{valType:"any",dflt:0,editType:"calc+clearAxisTypes",anim:!0},dx:{valType:"number",dflt:1,editType:"calc",anim:!0},y:{valType:"data_array",editType:"calc+clearAxisTypes",anim:!0},y0:{valType:"any",dflt:0,editType:"calc+clearAxisTypes",anim:!0},dy:{valType:"number",dflt:1,editType:"calc",anim:!0},xperiod:h('x'),yperiod:h('y'),xperiod0:p('x0'),yperiod0:p('y0'),xperiodalignment:d('x'),yperiodalignment:d('y'),xhoverformat:n('x'),yhoverformat:n('y'),stackgroup:{valType:"string",dflt:"",editType:"calc"},orientation:{valType:"enumerated",values:["v","h"],editType:"calc"},groupnorm:{valType:"enumerated",values:["",'fraction',"percent"],dflt:"",editType:"calc"},stackgaps:{valType:"enumerated",values:["infer zero","interpolate"],dflt:"infer zero",editType:"calc"},text:{valType:"string",dflt:"",arrayOk:!0,editType:"calc"},texttemplate:i({},{}),hovertext:{valType:"string",dflt:"",arrayOk:!0,editType:"style"},mode:{valType:"flaglist",flags:["lines",'markers',"text"],extras:["none"],editType:"calc"},hoveron:{valType:"flaglist",flags:["points","fills"],editType:"style"},hovertemplate:a({},{keys:u.eventDataKeys}),line:{color:{valType:"color",editType:"style",anim:!0},width:{valType:"number",min:0,dflt:2,editType:"style",anim:!0},shape:{valType:"enumerated",values:["linear",'spline','hv','vh','hvh',"vhv"],dflt:"linear",editType:"plot"},smoothing:{valType:"number",min:0,max:1.3,dflt:1,editType:"plot"},dash:f({},l,{editType:"style"}),simplify:{valType:"boolean",dflt:!0,editType:"plot"},editType:"plot"},connectgaps:{valType:"boolean",dflt:!1,editType:"calc"},cliponaxis:{valType:"boolean",dflt:!0,editType:"plot"},fill:{valType:"enumerated",values:["none",'tozeroy','tozerox','tonexty','tonextx','toself',"tonext"],editType:"calc"},fillcolor:{valType:"color",editType:"style",anim:!0},marker:f({symbol:{valType:"enumerated",values:c.symbolList,dflt:"circle",arrayOk:!0,editType:"style"},opacity:{valType:"number",min:0,max:1,arrayOk:!0,editType:"style",anim:!0},size:{valType:"number",min:0,dflt:6,arrayOk:!0,editType:"calc",anim:!0},maxdisplayed:{valType:"number",min:0,dflt:0,editType:"plot"},sizeref:{valType:"number",dflt:1,editType:"calc"},sizemin:{valType:"number",min:0,dflt:0,editType:"calc"},sizemode:{valType:"enumerated",values:["diameter","area"],dflt:"diameter",editType:"calc"},line:f({width:{valType:"number",min:0,arrayOk:!0,editType:"style",anim:!0},editType:"calc"},o('marker.line',{anim:!0})),gradient:{type:{valType:"enumerated",values:["radial",'horizontal','vertical',"none"],arrayOk:!0,dflt:"none",editType:"calc"},color:{valType:"color",arrayOk:!0,editType:"calc"},editType:"calc"},editType:"calc"},o('marker',{anim:!0})),selected:{marker:{opacity:{valType:"number",min:0,max:1,editType:"style"},color:{valType:"color",editType:"style"},size:{valType:"number",min:0,editType:"style"},editType:"style"},textfont:{color:{valType:"color",editType:"style"},editType:"style"},editType:"style"},unselected:{marker:{opacity:{valType:"number",min:0,max:1,editType:"style"},color:{valType:"color",editType:"style"},size:{valType:"number",min:0,editType:"style"},editType:"style"},textfont:{color:{valType:"color",editType:"style"},editType:"style"},editType:"style"},textposition:{valType:"enumerated",values:["top left",'top center','top right','middle left','middle center','middle right','bottom left','bottom center',"bottom right"],dflt:"middle center",arrayOk:!0,editType:"calc"},textfont:s({editType:"calc",colorEditType:"style",arrayOk:!0})}},{"../../components/colorscale/attributes":657,"../../components/drawing":672,"../../components/drawing/attributes":671,"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../../plots/font_attributes":867,"../../plots/template_attributes":910,"./constants":1206}],1203:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../plots/cartesian/axes'),o=t('../../plots/cartesian/align_period'),s=t('../../constants/numerical').BADNUM,l=t('./subtypes'),c=t('./colorscale_calc'),u=t('./arrays_to_calcdata'),f=t('./calc_selection');function h(t,e){var r,l,h,g,y,x,b=t._fullLayout,_=a.getFromId(t,e.xaxis||"x"),w=a.getFromId(t,e.yaxis||"y"),T=_.makeCalcdata(e,'x'),k=w.makeCalcdata(e,'y'),M=o(e,_,'x',T),A=o(e,w,'y',k),S=M.vals,E=A.vals,L=e._length,C=new Array(L),P=e.ids,I=v(e,b,_,w),z=!1;m(b,e);var O,D='x',R='y';I?(i.pushUnique(I.traceIndices,e._expandedIndex),(r="v"===I.orientation)?(R='s',O='x'):(D='s',O='y'),y="interpolate"===I.stackgaps):p(t,e,_,w,S,E,d(e,L));var F=!!e.xperiodalignment,B=!!e.yperiodalignment;for(l=0;l<L;l++){var N=C[l]={},j=n(S[l]),U=n(E[l]);j&&U?(N[D]=S[l],N[R]=E[l],F&&(N.orig_x=T[l],N.xEnd=M.ends[l],N.xStart=M.starts[l]),B&&(N.orig_y=k[l],N.yEnd=A.ends[l],N.yStart=A.starts[l])):I&&(r?j:U)?(N[O]=r?S[l]:E[l],N.gap=!0,y?(N.s=s,z=!0):N.s=0):N[D]=N[R]=s,P&&(N.id=String(P[l]))}if(u(C,e),c(t,e),f(C,e),I){for(l=0;l<C.length;)C[l][O]===s?C.splice(l,1):l++;if(i.sort(C,(function(t,e){return t[O]-e[O]||t.i-e.i})),z){for(l=0;l<C.length-1&&C[l].gap;)l++;for((x=C[l].s)||(x=C[l].s=0),h=0;h<l;h++)C[h].s=x;for(g=C.length-1;g>l&&C[g].gap;)g--;for(x=C[g].s,h=C.length-1;h>g;h--)C[h].s=x;for(;l<g;)if(C[++l].gap){for(h=l+1;C[h].gap;)h++;for(var V=C[l-1][O],H=C[l-1].s,q=(C[h].s-H)/(C[h][O]-V);l<h;)C[l].s=H+(C[l][O]-V)*q,l++}}}return C}function p(t,e,r,n,i,o,s){var c=e._length,u=t._fullLayout,f=r._id,h=n._id,p=u._firstScatter[g(e)]===e.uid,d=(v(e,u,r,n)||{}).orientation,m=e.fill;r._minDtick=0,n._minDtick=0;var y={padded:!0},x={padded:!0};s&&(y.ppad=x.ppad=s);var b=c<2||i[0]!==i[c-1]||o[0]!==o[c-1];b&&("tozerox"===m||"tonextx"===m&&(p||"h"===d))?y.tozero=!0:(e.error_y||{}).visible||"tonexty"!==m&&"tozeroy"!==m&&(l.hasMarkers(e)||l.hasText(e))||(y.padded=!1,y.ppad=0),b&&("tozeroy"===m||"tonexty"===m&&(p||"v"===d))?x.tozero=!0:"tonextx"!==m&&"tozerox"!==m||(x.padded=!1),f&&(e._extremes[f]=a.findExtremes(r,i,y)),h&&(e._extremes[h]=a.findExtremes(n,o,x))}function d(t,e){if(l.hasMarkers(t)){var r,n=t.marker,o=1.6*(t.marker.sizeref||1);if(r="area"===t.marker.sizemode?function(t){return Math.max(Math.sqrt((t||0)/o),3)}:function(t){return Math.max((t||0)/o,3)},i.isArrayOrTypedArray(n.size)){var s={type:"linear"};a.setConvert(s);for(var c=s.makeCalcdata(t.marker,'size'),u=new Array(e),f=0;f<e;f++)u[f]=r(c[f]);return u}return r(n.size)}}function m(t,e){var r=g(e),n=t._firstScatter;n[r]||(n[r]=e.uid)}function g(t){var e=t.stackgroup;return t.xaxis+t.yaxis+t.type+(e?"-"+e:"")}function v(t,e,r,n){var i=t.stackgroup;if(i){var a=e._scatterStackOpts[r._id+n._id][i],o="v"===a.orientation?n:r;return"linear"===o.type||"log"===o.type?a:void 0}}e.exports={calc:h,calcMarkerSize:d,calcAxisExpansion:p,setFirstScatter:m,getStackOpts:v}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"./arrays_to_calcdata":1201,"./calc_selection":1204,"./colorscale_calc":1205,"./subtypes":1227,"fast-isnumeric":246}],1204:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){n.isArrayOrTypedArray(e.selectedpoints)&&n.tagSelected(t,e)}},{"../../lib":787}],1205:[function(t,e,r){"use strict";var n=t('../../components/colorscale/helpers').hasColorscale,i=t('../../components/colorscale/calc'),a=t('./subtypes');e.exports=function(t,e){a.hasLines(e)&&n(e,'line')&&i(t,e,{vals:e.line.color,containerStr:"line",cLetter:"c"}),a.hasMarkers(e)&&(n(e,'marker')&&i(t,e,{vals:e.marker.color,containerStr:"marker",cLetter:"c"}),n(e,'marker.line')&&i(t,e,{vals:e.marker.line.color,containerStr:"marker.line",cLetter:"c"}))}},{"../../components/colorscale/calc":658,"../../components/colorscale/helpers":661,"./subtypes":1227}],1206:[function(t,e,r){"use strict";e.exports={PTS_LINESONLY:20,minTolerance:.2,toleranceGrowth:10,maxScreensAway:20,eventDataKeys:[]}},{}],1207:[function(t,e,r){"use strict";var n=t('./calc');function i(t,e,r,n,i,o,s){i[n]=!0;var l={i:null,gap:!0,s:0};if(l[s]=r,t.splice(e,0,l),e&&r===t[e-1][s]){var c=t[e-1];l.s=c.s,l.i=c.i,l.gap=c.gap}else o&&(l.s=a(t,e,r,s));e||(t[0].t=t[1].t,t[0].trace=t[1].trace,delete t[1].t,delete t[1].trace)}function a(t,e,r,n){var i=t[e-1],a=t[e+1];return a?i?i.s+(a.s-i.s)*(r-i[n])/(a[n]-i[n]):a.s:i.s}e.exports=function(t,e){var r=e.xaxis,a=e.yaxis,o=r._id+a._id,s=t._fullLayout._scatterStackOpts[o];if(s){var l,c,u,f,h,p,d,m,g,v,y,x,b,_,w,T=t.calcdata;for(var k in s){var M=(v=s[k]).traceIndices;if(M.length){for(y="interpolate"===v.stackgaps,x=v.groupnorm,"v"===v.orientation?(b='x',_='y'):(b='y',_='x'),w=new Array(M.length),l=0;l<w.length;l++)w[l]=!1;p=T[M[0]];var A=new Array(p.length);for(l=0;l<p.length;l++)A[l]=p[l][b];for(l=1;l<M.length;l++){for(h=T[M[l]],c=u=0;c<h.length;c++){for(d=h[c][b];d>A[u]&&u<A.length;u++)i(h,c,A[u],l,w,y,b),c++;if(d!==A[u]){for(f=0;f<l;f++)i(T[M[f]],u,d,f,w,y,b);A.splice(u,0,d)}u++}for(;u<A.length;u++)i(h,c,A[u],l,w,y,b),c++}var S=A.length;for(c=0;c<p.length;c++){for(m=p[c][_]=p[c].s,l=1;l<M.length;l++)(h=T[M[l]])[0].trace._rawLength=h[0].trace._length,h[0].trace._length=S,m+=h[c].s,h[c][_]=m;if(x)for(g=("fraction"===x?m:m/100)||1,l=0;l<M.length;l++){var E=T[M[l]][c];E[_]/=g,E.sNorm=E.s/g}}for(l=0;l<M.length;l++){var L=(h=T[M[l]])[0].trace,C=n.calcMarkerSize(L,L._rawLength),P=Array.isArray(C);if(C&&w[l]||P){var I=C;for(C=new Array(S),c=0;c<S;c++)C[c]=h[c].gap?0:P?I[h[c].i]:I}var z=new Array(S),O=new Array(S);for(c=0;c<S;c++)z[c]=h[c].x,O[c]=h[c].y;n.calcAxisExpansion(t,L,r,a,z,O,C),h[0].t.orientation=v.orientation}}}}}},{"./calc":1203}],1208:[function(t,e,r){"use strict";e.exports=function(t){for(var e=0;e<t.length;e++){var r=t[e];if("scatter"===r.type){var n=r.fill;if("none"!==n&&"toself"!==n&&(r.opacity=void 0,"tonexty"===n||"tonextx"===n))for(var i=e-1;i>=0;i--){var a=t[i];if("scatter"===a.type&&a.xaxis===r.xaxis&&a.yaxis===r.yaxis){a.opacity=void 0;break}}}}}},{}],1209:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry'),a=t('./attributes'),o=t('./constants'),s=t('./subtypes'),l=t('./xy_defaults'),c=t('./period_defaults'),u=t('./stack_defaults'),f=t('./marker_defaults'),h=t('./line_defaults'),p=t('./line_shape_defaults'),d=t('./text_defaults'),m=t('./fillcolor_defaults');e.exports=function(t,e,r,g){function v(r,i){return n.coerce(t,e,a,r,i)}var y=l(t,e,g,v);if(y||(e.visible=!1),e.visible){c(t,e,g,v),v('xhoverformat'),v('yhoverformat');var x=u(t,e,g,v),b=!x&&y<o.PTS_LINESONLY?"lines+markers":"lines";v('text'),v('hovertext'),v('mode',b),s.hasLines(e)&&(h(t,e,r,g,v),p(t,e,v),v('connectgaps'),v('line.simplify')),s.hasMarkers(e)&&f(t,e,r,g,v,{gradient:!0}),s.hasText(e)&&(v('texttemplate'),d(t,e,g,v));var _=[];(s.hasMarkers(e)||s.hasText(e))&&(v('cliponaxis'),v('marker.maxdisplayed'),_.push('points')),v('fill',x?x.fillDflt:"none"),"none"!==e.fill&&(m(t,e,r,v),s.hasLines(e)||p(t,e,v));var w=(e.line||{}).color,T=(e.marker||{}).color;"tonext"!==e.fill&&"toself"!==e.fill||_.push('fills'),v('hoveron',_.join('+')||"points"),"fills"!==e.hoveron&&v('hovertemplate');var k=i.getComponentMethod('errorbars','supplyDefaults');k(t,e,w||T||r,{axis:"y"}),k(t,e,w||T||r,{axis:"x",inherit:"y"}),n.coerceSelectionMarkerOpacity(e,v)}}},{"../../lib":787,"../../registry":915,"./attributes":1202,"./constants":1206,"./fillcolor_defaults":1210,"./line_defaults":1215,"./line_shape_defaults":1217,"./marker_defaults":1221,"./period_defaults":1222,"./stack_defaults":1225,"./subtypes":1227,"./text_defaults":1228,"./xy_defaults":1229}],1210:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('../../lib').isArrayOrTypedArray;e.exports=function(t,e,r,a){var o=!1;if(e.marker){var s=e.marker.color,l=(e.marker.line||{}).color;s&&!i(s)?o=s:l&&!i(l)&&(o=l)}a('fillcolor',n.addOpacity((e.line||{}).color||o||r,.5))}},{"../../components/color":650,"../../lib":787}],1211:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes');e.exports=function(t,e,r){var i={},a={_fullLayout:r},o=n.getFromTrace(a,e,'x'),s=n.getFromTrace(a,e,'y');return i.xLabel=n.tickText(o,o.c2l(t.x),!0).text,i.yLabel=n.tickText(s,s.c2l(t.y),!0).text,i}},{"../../plots/cartesian/axes":838}],1212:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('./subtypes');e.exports=function(t,e){var r,a;if("lines"===t.mode)return(r=t.line.color)&&n.opacity(r)?r:t.fillcolor;if("none"===t.mode)return t.fill?t.fillcolor:"";var o=e.mcc||(t.marker||{}).color,s=e.mlcc||((t.marker||{}).line||{}).color;return(a=o&&n.opacity(o)?o:s&&n.opacity(s)&&(e.mlw||((t.marker||{}).line||{}).width)?s:"")?n.opacity(a)<.3?n.addOpacity(a,.3):a:(r=(t.line||{}).color)&&n.opacity(r)&&i.hasLines(t)&&t.line.width?r:t.fillcolor}},{"../../components/color":650,"./subtypes":1227}],1213:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/fx'),a=t('../../registry'),o=t('./get_trace_color'),s=t('../../components/color'),l=n.fillText;e.exports=function(t,e,r,c){var u=t.cd,f=u[0].trace,h=t.xa,p=t.ya,d=h.c2p(e),m=p.c2p(r),g=[d,m],v=f.hoveron||"",y=-1!==f.mode.indexOf('markers')?3:.5,x=!!f.xperiodalignment,b=!!f.yperiodalignment;if(-1!==v.indexOf('points')){var _=function(t){if(x){var e=h.c2p(t.xStart),r=h.c2p(t.xEnd);return d>=Math.min(e,r)&&d<=Math.max(e,r)?0:1/0}var n=Math.max(3,t.mrc||0),i=1-1/n,a=Math.abs(h.c2p(t.x)-d);return a<n?i*a/n:a-n+i},w=function(t){if(b){var e=p.c2p(t.yStart),r=p.c2p(t.yEnd);return m>=Math.min(e,r)&&m<=Math.max(e,r)?0:1/0}var n=Math.max(3,t.mrc||0),i=1-1/n,a=Math.abs(p.c2p(t.y)-m);return a<n?i*a/n:a-n+i},T=function(t){var e=Math.max(y,t.mrc||0),r=h.c2p(t.x)-d,n=p.c2p(t.y)-m;return Math.max(Math.sqrt(r*r+n*n)-e,1-y/e)},k=i.getDistanceFunction(c,_,w,T);if(i.getClosest(u,k,t),!1!==t.index){var M=u[t.index],A=h.c2p(M.x,!0),S=p.c2p(M.y,!0),E=M.mrc||1;t.index=M.i;var L=u[0].t.orientation,C=L&&(M.sNorm||M.s),P="h"===L?C:void 0!==M.orig_x?M.orig_x:M.x,I="v"===L?C:void 0!==M.orig_y?M.orig_y:M.y;return n.extendFlat(t,{color:o(f,M),x0:A-E,x1:A+E,xLabelVal:P,y0:S-E,y1:S+E,yLabelVal:I,spikeDistance:T(M),hovertemplate:f.hovertemplate}),l(M,f,t),a.getComponentMethod('errorbars','hoverInfo')(M,f,t),[t]}}if(-1!==v.indexOf('fills')&&f._polygons){var z,O,D,R,F,B,N,j,U,V=f._polygons,H=[],q=!1,G=1/0,Y=-1/0,W=1/0,X=-1/0;for(z=0;z<V.length;z++)(D=V[z]).contains(g)&&(q=!q,H.push(D),W=Math.min(W,D.ymin),X=Math.max(X,D.ymax));if(q){var Z=((W=Math.max(W,0))+(X=Math.min(X,p._length)))/2;for(z=0;z<H.length;z++)for(R=H[z].pts,O=1;O<R.length;O++)(j=R[O-1][1])>Z!==(U=R[O][1])>=Z&&(B=R[O-1][0],N=R[O][0],U-j&&(F=B+(N-B)*(Z-j)/(U-j),G=Math.min(G,F),Y=Math.max(Y,F)));G=Math.max(G,0),Y=Math.min(Y,h._length);var J=s.defaultLine;return s.opacity(f.fillcolor)?J=f.fillcolor:s.opacity((f.line||{}).color)&&(J=f.line.color),n.extendFlat(t,{distance:t.maxHoverDistance,x0:G,x1:Y,y0:Z,y1:Z,color:J,hovertemplate:!1}),delete t.index,f.text&&!Array.isArray(f.text)?t.text=String(f.text):t.text=f.name,[t]}}}},{"../../components/color":650,"../../components/fx":690,"../../lib":787,"../../registry":915,"./get_trace_color":1212}],1214:[function(t,e,r){"use strict";var n=t('./subtypes');e.exports={hasLines:n.hasLines,hasMarkers:n.hasMarkers,hasText:n.hasText,isBubble:n.isBubble,attributes:t('./attributes'),supplyDefaults:t('./defaults'),crossTraceDefaults:t('./cross_trace_defaults'),calc:t('./calc').calc,crossTraceCalc:t('./cross_trace_calc'),arraysToCalcdata:t('./arrays_to_calcdata'),plot:t('./plot'),colorbar:t('./marker_colorbar'),formatLabels:t('./format_labels'),style:t('./style').style,styleOnSelect:t('./style').styleOnSelect,hoverPoints:t('./hover'),selectPoints:t('./select'),animatable:!0,moduleType:"trace",name:"scatter",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','symbols','errorBarsOK','showLegend','scatter-like',"zoomScale"],meta:{}}},{"../../plots/cartesian":852,"./arrays_to_calcdata":1201,"./attributes":1202,"./calc":1203,"./cross_trace_calc":1207,"./cross_trace_defaults":1208,"./defaults":1209,"./format_labels":1211,"./hover":1213,"./marker_colorbar":1220,"./plot":1223,"./select":1224,"./style":1226,"./subtypes":1227}],1215:[function(t,e,r){"use strict";var n=t('../../lib').isArrayOrTypedArray,i=t('../../components/colorscale/helpers').hasColorscale,a=t('../../components/colorscale/defaults');e.exports=function(t,e,r,o,s,l){var c=(t.marker||{}).color;s('line.color',r),i(t,'line')?a(t,e,o,s,{prefix:"line.",cLetter:"c"}):s('line.color',!n(c)&&c||r),s('line.width'),(l||{}).noDash||s('line.dash')}},{"../../components/colorscale/defaults":660,"../../components/colorscale/helpers":661,"../../lib":787}],1216:[function(t,e,r){"use strict";var n=t('../../constants/numerical'),i=n.BADNUM,a=n.LOG_CLIP,o=a+.5,s=a-.5,l=t('../../lib'),c=l.segmentsIntersect,u=l.constrain,f=t('./constants');e.exports=function(t,e){var r,n,a,h,p,d,m,g,v,y,x,b,_,w,T,k,M,A,S=e.xaxis,E=e.yaxis,L="log"===S.type,C="log"===E.type,P=S._length,I=E._length,z=e.connectGaps,O=e.baseTolerance,D=e.shape,R="linear"===D,F=e.fill&&"none"!==e.fill,B=[],N=f.minTolerance,j=t.length,U=new Array(j),V=0;function H(r){var n=t[r];if(!n)return!1;var a=e.linearized?S.l2p(n.x):S.c2p(n.x),l=e.linearized?E.l2p(n.y):E.c2p(n.y);if(a===i){if(L&&(a=S.c2p(n.x,!0)),a===i)return!1;C&&l===i&&(a*=Math.abs(S._m*I*(S._m>0?o:s)/(E._m*P*(E._m>0?o:s)))),a*=1e3}if(l===i){if(C&&(l=E.c2p(n.y,!0)),l===i)return!1;l*=1e3}return[a,l]}function q(t,e,r,n){var i=r-t,a=n-e,o=.5-t,s=.5-e,l=i*i+a*a,c=i*o+a*s;if(c>0&&c<l){var u=o*a-s*i;if(u*u<l)return!0}}function G(t,e){var r=t[0]/P,n=t[1]/I,i=Math.max(0,-r,r-1,-n,n-1);return i&&void 0!==M&&q(r,n,M,A)&&(i=0),i&&e&&q(r,n,e[0]/P,e[1]/I)&&(i=0),(1+f.toleranceGrowth*i)*O}function Y(t,e){var r=t[0]-e[0],n=t[1]-e[1];return Math.sqrt(r*r+n*n)}var W,X,Z,J,K,Q,$,tt=f.maxScreensAway,et=-P*tt,rt=P*(1+tt),nt=-I*tt,it=I*(1+tt),at=[[et,nt,rt,nt],[rt,nt,rt,it],[rt,it,et,it],[et,it,et,nt]];function ot(t,e){for(var r=[],n=0,i=0;i<4;i++){var a=at[i],o=c(t[0],t[1],e[0],e[1],a[0],a[1],a[2],a[3]);o&&(!n||Math.abs(o.x-r[0][0])>1||Math.abs(o.y-r[0][1])>1)&&(o=[o.x,o.y],n&&Y(o,t)<Y(r[0],t)?r.unshift(o):r.push(o),n++)}return r}function st(t){if(t[0]<et||t[0]>rt||t[1]<nt||t[1]>it)return[u(t[0],et,rt),u(t[1],nt,it)]}function lt(t,e){return t[0]===e[0]&&(t[0]===et||t[0]===rt)||t[1]===e[1]&&(t[1]===nt||t[1]===it)||void 0}function ct(t,e){var r=[],n=st(t),i=st(e);return n&&i&&lt(n,i)||(n&&r.push(n),i&&r.push(i)),r}function ut(t,e,r){return function(n,i){var a=st(n),o=st(i),s=[];if(a&&o&&lt(a,o))return s;a&&s.push(a),o&&s.push(o);var c=2*l.constrain((n[t]+i[t])/2,e,r)-((a||n)[t]+(o||i)[t]);return c&&((a&&o?c>0===a[t]>o[t]?a:o:a||o)[t]+=c),s}}function ft(t,e){var r=e[0]-t[0],n=(e[1]-t[1])/r;return(t[1]*e[0]-e[1]*t[0])/r>0?[n>0?et:rt,it]:[n>0?rt:et,nt]}function ht(t){var e=t[0],r=t[1],n=e===U[V-1][0],i=r===U[V-1][1];if(!n||!i)if(V>1){var a=e===U[V-2][0],o=r===U[V-2][1];n&&(e===et||e===rt)&&a?o?V--:U[V-1]=t:i&&(r===nt||r===it)&&o?a?V--:U[V-1]=t:U[V++]=t}else U[V++]=t}function pt(t){U[V-1][0]!==t[0]&&U[V-1][1]!==t[1]&&ht([Z,J]),ht(t),K=null,Z=J=0}function dt(t){if(M=t[0]/P,A=t[1]/I,W=t[0]<et?et:t[0]>rt?rt:0,X=t[1]<nt?nt:t[1]>it?it:0,W||X){if(V)if(K){var e=$(K,t);e.length>1&&(pt(e[0]),U[V++]=e[1])}else Q=$(U[V-1],t)[0],U[V++]=Q;else U[V++]=[W||t[0],X||t[1]];var r=U[V-1];W&&X&&(r[0]!==W||r[1]!==X)?(K&&(Z!==W&&J!==X?ht(Z&&J?ft(K,t):[Z||W,J||X]):Z&&J&&ht([Z,J])),ht([W,X])):Z-W&&J-X&&ht([W||Z,X||J]),K=t,Z=W,J=X}else K&&pt($(K,t)[0]),U[V++]=t}for("linear"===D||"spline"===D?$=ot:"hv"===D||"vh"===D?$=ct:"hvh"===D?$=ut(0,et,rt):"vhv"===D&&($=ut(1,nt,it)),r=0;r<j;r++)if(n=H(r)){for(V=0,K=null,dt(n),r++;r<j;r++){if(!(h=H(r))){if(z)continue;break}if(R&&e.simplify){var mt=H(r+1);if(y=Y(h,n),F&&(0===V||V===j-1)||!(y<G(h,mt)*N)){for(g=[(h[0]-n[0])/y,(h[1]-n[1])/y],p=n,x=y,b=w=T=0,m=!1,a=h,r++;r<t.length;r++){if(d=mt,mt=H(r+1),!d){if(z)continue;break}if(k=(v=[d[0]-n[0],d[1]-n[1]])[0]*g[1]-v[1]*g[0],w=Math.min(w,k),(T=Math.max(T,k))-w>G(d,mt))break;a=d,(_=v[0]*g[0]+v[1]*g[1])>x?(x=_,h=d,m=!1):_<b&&(b=_,p=d,m=!0)}if(m?(dt(h),a!==p&&dt(p)):(p!==n&&dt(p),a!==h&&dt(h)),dt(a),r>=t.length||!d)break;dt(d),n=d}}else dt(h)}K&&ht([Z||K[0],J||K[1]]),B.push(U.slice(0,V))}return B}},{"../../constants/numerical":763,"../../lib":787,"./constants":1206}],1217:[function(t,e,r){"use strict";e.exports=function(t,e,r){"spline"===r('line.shape')&&r('line.smoothing')}},{}],1218:[function(t,e,r){"use strict";var n={tonextx:1,tonexty:1,tonext:1};e.exports=function(t,e,r){var i,a,o,s,l,c={},u=!1,f=-1,h=0,p=-1;for(a=0;a<r.length;a++)(o=(i=r[a][0].trace).stackgroup||"")?o in c?l=c[o]:(l=c[o]=h,h++):i.fill in n&&p>=0?l=p:(l=p=h,h++),l<f&&(u=!0),i._groupIndex=f=l;var d=r.slice();u&&d.sort((function(t,e){var r=t[0].trace,n=e[0].trace;return r._groupIndex-n._groupIndex||r.index-n.index}));var m={};for(a=0;a<d.length;a++)o=(i=d[a][0].trace).stackgroup||"",!0===i.visible?(i._nexttrace=null,i.fill in n&&(s=m[o],i._prevtrace=s||null,s&&(s._nexttrace=i)),i._ownfill=i.fill&&("tozero"===i.fill.substr(0,6)||"toself"===i.fill||"to"===i.fill.substr(0,2)&&!i._prevtrace),m[o]=i):i._prevtrace=i._nexttrace=i._ownfill=null;return d}},{}],1219:[function(t,e,r){"use strict";var n=t('fast-isnumeric');e.exports=function(t,e){e||(e=2);var r=t.marker,i=r.sizeref||1,a=r.sizemin||0,o="area"===r.sizemode?function(t){return Math.sqrt(t/i)}:function(t){return t/i};return function(t){var r=o(t/e);return n(r)&&r>0?Math.max(r,a):0}}},{"fast-isnumeric":246}],1220:[function(t,e,r){"use strict";e.exports={container:"marker",min:"cmin",max:"cmax"}},{}],1221:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('../../components/colorscale/helpers').hasColorscale,a=t('../../components/colorscale/defaults'),o=t('./subtypes');e.exports=function(t,e,r,s,l,c){var u=o.isBubble(t),f=(t.line||{}).color;c=c||{},f&&(r=f),l('marker.symbol'),l('marker.opacity',u?.7:1),l('marker.size'),l('marker.color',r),i(t,'marker')&&a(t,e,s,l,{prefix:"marker.",cLetter:"c"}),c.noSelect||(l('selected.marker.color'),l('unselected.marker.color'),l('selected.marker.size'),l('unselected.marker.size')),c.noLine||(l('marker.line.color',f&&!Array.isArray(f)&&e.marker.color!==f?f:u?n.background:n.defaultLine),i(t,'marker.line')&&a(t,e,s,l,{prefix:"marker.line.",cLetter:"c"}),l('marker.line.width',u?1:0)),u&&(l('marker.sizeref'),l('marker.sizemin'),l('marker.sizemode')),c.gradient&&"none"!==l('marker.gradient.type')&&l('marker.gradient.color')}},{"../../components/color":650,"../../components/colorscale/defaults":660,"../../components/colorscale/helpers":661,"./subtypes":1227}],1222:[function(t,e,r){"use strict";var n=t('../../lib').dateTick0,i=t('../../constants/numerical').ONEWEEK;function a(t,e){return n(e,t%i===0?1:0)}e.exports=function(t,e,r,n,i){if(i||(i={x:!0,y:!0}),i.x){var o=n('xperiod');o&&(n('xperiod0',a(o,e.xcalendar)),n('xperiodalignment'))}if(i.y){var s=n('yperiod');s&&(n('yperiod0',a(s,e.ycalendar)),n('yperiodalignment'))}}},{"../../constants/numerical":763,"../../lib":787}],1223:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../lib'),o=a.ensureSingle,s=a.identity,l=t('../../components/drawing'),c=t('./subtypes'),u=t('./line_points'),f=t('./link_traces'),h=t('../../lib/polygon').tester;function p(t,e,r){e.each((function(e){var i=o(n.select(this),'g','fills');l.setClipUrl(i,r.layerClipId,t);var a=e[0].trace,c=[];a._ownfill&&c.push('_ownFill'),a._nexttrace&&c.push('_nextFill');var u=i.selectAll('g').data(c,s);u.enter().append('g'),u.exit().each((function(t){a[t]=null})).remove(),u.order().each((function(t){a[t]=o(n.select(this),'path','js-fill')}))}))}function d(t,e,r,f,p,d,g){var v;m(t,e,r,f,p);var y=!!g&&g.duration>0;function x(t){return y?t.transition():t}var b=r.xaxis,_=r.yaxis,w=f[0].trace,T=w.line,k=n.select(d),M=o(k,'g','errorbars'),A=o(k,'g','lines'),S=o(k,'g','points'),E=o(k,'g','text');if(i.getComponentMethod('errorbars','plot')(t,M,r,g),!0===w.visible){var L,C;x(k).style('opacity',w.opacity);var P=w.fill.charAt(w.fill.length-1);"x"!==P&&"y"!==P&&(P=''),f[0][r.isRangePlot?"nodeRangePlot3":"node3"]=k;var I,z,O='',D=[],R=w._prevtrace;R&&(O=R._prevRevpath||"",C=R._nextFill,D=R._polygons);var F,B,N,j,U,V,H,q='',G='',Y=[],W=a.noop;if(L=w._ownFill,c.hasLines(w)||"none"!==w.fill){for(C&&C.datum(f),-1!==["hv",'vh','hvh',"vhv"].indexOf(T.shape)?(F=l.steps(T.shape),B=l.steps(T.shape.split('').reverse().join(''))):F=B="spline"===T.shape?function(t){var e=t[t.length-1];return t.length>1&&t[0][0]===e[0]&&t[0][1]===e[1]?l.smoothclosed(t.slice(1),T.smoothing):l.smoothopen(t,T.smoothing)}:function(t){return"M"+t.join('L')},N=function(t){return B(t.reverse())},Y=u(f,{xaxis:b,yaxis:_,connectGaps:w.connectgaps,baseTolerance:Math.max(T.width||1,3)/4,shape:T.shape,simplify:T.simplify,fill:w.fill}),H=w._polygons=new Array(Y.length),v=0;v<Y.length;v++)w._polygons[v]=h(Y[v]);Y.length&&(j=Y[0][0],V=(U=Y[Y.length-1])[U.length-1]),W=function(t){return function(e){if(I=F(e),z=N(e),q?P?(q+="L"+I.substr(1),G=z+"L"+G.substr(1)):(q+="Z"+I,G=z+"Z"+G):(q=I,G=z),c.hasLines(w)&&e.length>1){var r=n.select(this);if(r.datum(f),t)x(r.style('opacity',0).attr('d',I).call(l.lineGroupStyle)).style('opacity',1);else{var i=x(r);i.attr('d',I),l.singleLineStyle(f,i)}}}}}var X=A.selectAll('.js-line').data(Y);x(X.exit()).style('opacity',0).remove(),X.each(W(!1)),X.enter().append('path').classed('js-line',!0).style('vector-effect','non-scaling-stroke').call(l.lineGroupStyle).each(W(!0)),l.setClipUrl(X,r.layerClipId,t),Y.length?(L?(L.datum(f),j&&V&&(P?("y"===P?j[1]=V[1]=_.c2p(0,!0):"x"===P&&(j[0]=V[0]=b.c2p(0,!0)),x(L).attr('d',"M"+V+"L"+j+"L"+q.substr(1)).call(l.singleFillStyle)):x(L).attr('d',q+"Z").call(l.singleFillStyle))):C&&("tonext"===w.fill.substr(0,6)&&q&&O?("tonext"===w.fill?x(C).attr('d',q+"Z"+O+"Z").call(l.singleFillStyle):x(C).attr('d',q+"L"+O.substr(1)+"Z").call(l.singleFillStyle),w._polygons=w._polygons.concat(D)):(J(C),w._polygons=null)),w._prevRevpath=G,w._prevPolygons=H):(L?J(L):C&&J(C),w._polygons=w._prevRevpath=w._prevPolygons=null),S.datum(f),E.datum(f),nt(S,E,f);var Z=!1===w.cliponaxis?null:r.layerClipId;l.setClipUrl(S,Z,t),l.setClipUrl(E,Z,t)}function J(t){x(t).attr('d','M0,0Z')}function K(t){return t.filter((function(t){return!t.gap&&t.vis}))}function Q(t){return t.filter((function(t){return t.vis}))}function $(t){return t.filter((function(t){return!t.gap}))}function tt(t){return t.id}function et(t){if(t.ids)return tt}function rt(){return!1}function nt(e,i,a){var o,u=a[0].trace,f=c.hasMarkers(u),h=c.hasText(u),p=et(u),d=rt,m=rt;if(f||h){var g=s,v=u.stackgroup,w=v&&"infer zero"===t._fullLayout._scatterStackOpts[b._id+_._id][v].stackgaps;u.marker.maxdisplayed||u._needsCull?g=w?Q:K:v&&!w&&(g=$),f&&(d=g),h&&(m=g)}var T,k=(o=e.selectAll('path.point').data(d,p)).enter().append('path').classed('point',!0);y&&k.call(l.pointStyle,u,t).call(l.translatePoints,b,_).style('opacity',0).transition().style('opacity',1),o.order(),f&&(T=l.makePointStyleFns(u)),o.each((function(e){var i=n.select(this),a=x(i);l.translatePoint(e,a,b,_)?(l.singlePointStyle(e,a,u,T,t),r.layerClipId&&l.hideOutsideRangePoint(e,a,b,_,u.xcalendar,u.ycalendar),u.customdata&&i.classed('plotly-customdata',null!==e.data&&void 0!==e.data)):a.remove()})),y?o.exit().transition().style('opacity',0).remove():o.exit().remove(),(o=i.selectAll('g').data(m,p)).enter().append('g').classed('textpoint',!0).append('text'),o.order(),o.each((function(t){var e=n.select(this),i=x(e.select('text'));l.translatePoint(t,i,b,_)?r.layerClipId&&l.hideOutsideRangePoint(t,e,b,_,u.xcalendar,u.ycalendar):e.remove()})),o.selectAll('text').call(l.textPointStyle,u,t).each((function(t){var e=b.c2p(t.x),r=_.c2p(t.y);n.select(this).selectAll('tspan.line').each((function(){x(n.select(this)).attr({x:e,y:r})}))})),o.exit().remove()}}function m(t,e,r,i,o){var s=r.xaxis,l=r.yaxis,u=n.extent(a.simpleMap(s.range,s.r2c)),f=n.extent(a.simpleMap(l.range,l.r2c)),h=i[0].trace;if(c.hasMarkers(h)){var p=h.marker.maxdisplayed;if(0!==p){var d=i.filter((function(t){return t.x>=u[0]&&t.x<=u[1]&&t.y>=f[0]&&t.y<=f[1]})),m=Math.ceil(d.length/p),g=0;o.forEach((function(t,r){var n=t[0].trace;c.hasMarkers(n)&&n.marker.maxdisplayed>0&&r<e&&g++}));var v=Math.round(g*m/3+Math.floor(g/3)*m/7.1);i.forEach((function(t)[delete t.vis])),d.forEach((function(t,e)[0===Math.round((e+v)%m)&&(t.vis=!0)]))}}}e.exports=function(t,e,r,i,a,o){var s,l,c=!a,u=!!a&&a.duration>0,h=f(t,e,r);(s=i.selectAll('g.trace').data(h,(function(t){return t[0].trace.uid}))).enter().append('g').attr('class',(function(t){return"trace scatter trace"+t[0].trace.uid})).style('stroke-miterlimit',2),s.order(),p(t,s,e),u?(o&&(l=o()),n.transition().duration(a.duration).ease(a.easing).each('end',(function()[l&&l()])).each('interrupt',(function()[l&&l()])).each((function(){i.selectAll('g.trace').each((function(r,n){d(t,n,e,r,h,this,a)}))}))):s.each((function(r,n){d(t,n,e,r,h,this,a)})),c&&s.exit().remove(),i.selectAll('path:not([d])').remove()}},{"../../components/drawing":672,"../../lib":787,"../../lib/polygon":799,"../../registry":915,"./line_points":1216,"./link_traces":1218,"./subtypes":1227,"@plotly/d3":58}],1224:[function(t,e,r){"use strict";var n=t('./subtypes');e.exports=function(t,e){var r,i,a,o,s=t.cd,l=t.xaxis,c=t.yaxis,u=[],f=s[0].trace;if(!n.hasMarkers(f)&&!n.hasText(f))return[];if(!1===e)for(r=0;r<s.length;r++)s[r].selected=0;else for(r=0;r<s.length;r++)i=s[r],a=l.c2p(i.x),o=c.c2p(i.y),null!==i.i&&e.contains([a,o],!1,r,t)?(u.push({pointNumber:i.i,x:l.c2d(i.x),y:c.c2d(i.y)}),i.selected=1):i.selected=0;return u}},{"./subtypes":1227}],1225:[function(t,e,r){"use strict";var n=["orientation",'groupnorm',"stackgaps"];e.exports=function(t,e,r,i){var a=r._scatterStackOpts,o=i('stackgroup');if(o){var s=e.xaxis+e.yaxis,l=a[s];l||(l=a[s]={});var c=l[o],u=!1;c?c.traces.push(e):(c=l[o]={traceIndices:[],traces:[e]},u=!0);for(var f={orientation:e.x&&!e.y?"h":"v"},h=0;h<n.length;h++){var p=n[h],d=p+"Found";if(!c[d]){var m=void 0!==t[p],g="orientation"===p;if((m||u)&&(c[p]=i(p,f[p]),g&&(c.fillDflt="h"===c[p]?"tonextx":"tonexty"),m&&(c[d]=!0,!u&&(delete c.traces[0][p],g))))for(var v=0;v<c.traces.length-1;v++){var y=c.traces[v];y._input.fill!==y.fill&&(y.fill=c.fillDflt)}}}return c}}},{}],1226:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../../registry');function o(t){var e=n.select(t).selectAll('g.trace.scatter');e.style('opacity',(function(t){return t[0].trace.opacity})),e.selectAll('g.points').each((function(e){s(n.select(this),e.trace||e[0].trace,t)})),e.selectAll('g.text').each((function(e){l(n.select(this),e.trace||e[0].trace,t)})),e.selectAll('g.trace path.js-line').call(i.lineGroupStyle),e.selectAll('g.trace path.js-fill').call(i.fillGroupStyle),a.getComponentMethod('errorbars','style')(e)}function s(t,e,r){i.pointStyle(t.selectAll('path.point'),e,r)}function l(t,e,r){i.textPointStyle(t.selectAll('text'),e,r)}function c(t,e,r){var n=e[0].trace;n.selectedpoints?(i.selectedPointStyle(r.selectAll('path.point'),n),i.selectedTextStyle(r.selectAll('text'),n)):(s(r,n,t),l(r,n,t))}e.exports={style:o,stylePoints:s,styleText:l,styleOnSelect:c}},{"../../components/drawing":672,"../../registry":915,"@plotly/d3":58}],1227:[function(t,e,r){"use strict";var n=t('../../lib');e.exports={hasLines:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf('lines')},hasMarkers:function(t){return t.visible&&(t.mode&&-1!==t.mode.indexOf('markers')||"splom"===t.type)},hasText:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf('text')},isBubble:function(t){return n.isPlainObject(t.marker)&&n.isArrayOrTypedArray(t.marker.size)}}},{"../../lib":787}],1228:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e,r,i,a){a=a||{},i('textposition'),n.coerceFont(i,'textfont',r.font),a.noSelect||(i('selected.textfont.color'),i('unselected.textfont.color'))}},{"../../lib":787}],1229:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry');e.exports=function(t,e,r,a){var o,s=a('x'),l=a('y');if(i.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x","y"],r),s){var c=n.minRowLength(s);l?o=Math.min(c,n.minRowLength(l)):(o=c,a('y0'),a('dy'))}else{if(!l)return 0;o=n.minRowLength(l),a('x0'),a('dx')}return e._length=o,o}},{"../../lib":787,"../../registry":915}],1230:[function(t,e,r){"use strict";var n=t('../scatter/attributes'),i=t('../../components/colorscale/attributes'),a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,o=t('../../plots/template_attributes').hovertemplateAttrs,s=t('../../plots/template_attributes').texttemplateAttrs,l=t('../../plots/attributes'),c=t('../../constants/gl3d_dashes'),u=t('../../constants/gl3d_markers'),f=t('../../lib/extend').extendFlat,h=t('../../plot_api/edit_types').overrideAll,p=t('../../lib/sort_object_keys'),d=n.line,m=n.marker,g=m.line,v=f({width:d.width,dash:{valType:"enumerated",values:p(c),dflt:"solid"}},i('line'));function y(t){return{show:{valType:"boolean",dflt:!1},opacity:{valType:"number",min:0,max:1,dflt:1},scale:{valType:"number",min:0,max:10,dflt:2/3}}}var x=e.exports=h({x:n.x,y:n.y,z:{valType:"data_array"},text:f({},n.text,{}),texttemplate:s({},{}),hovertext:f({},n.hovertext,{}),hovertemplate:o(),xhoverformat:a('x'),yhoverformat:a('y'),zhoverformat:a('z'),mode:f({},n.mode,{dflt:"lines+markers"}),surfaceaxis:{valType:"enumerated",values:[-1,0,1,2],dflt:-1},surfacecolor:{valType:"color"},projection:{x:y('x'),y:y('y'),z:y('z')},connectgaps:n.connectgaps,line:v,marker:f({symbol:{valType:"enumerated",values:p(u),dflt:"circle",arrayOk:!0},size:f({},m.size,{dflt:8}),sizeref:m.sizeref,sizemin:m.sizemin,sizemode:m.sizemode,opacity:f({},m.opacity,{arrayOk:!1}),colorbar:m.colorbar,line:f({width:f({},g.width,{arrayOk:!1})},i('marker.line'))},i('marker')),textposition:f({},n.textposition,{dflt:"top center"}),textfont:{color:n.textfont.color,size:n.textfont.size,family:f({},n.textfont.family,{arrayOk:!1})},hoverinfo:f({},l.hoverinfo)},'calc','nested');x.x.editType=x.y.editType=x.z.editType="calc+clearAxisTypes"},{"../../components/colorscale/attributes":657,"../../constants/gl3d_dashes":760,"../../constants/gl3d_markers":761,"../../lib/extend":777,"../../lib/sort_object_keys":810,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../scatter/attributes":1202}],1231:[function(t,e,r){"use strict";var n=t('../scatter/arrays_to_calcdata'),i=t('../scatter/colorscale_calc');e.exports=function(t,e){var r=[{x:!1,y:!1,trace:e,t:{}}];return n(r,e),i(t,e),r}},{"../scatter/arrays_to_calcdata":1201,"../scatter/colorscale_calc":1205}],1232:[function(t,e,r){"use strict";var n=t('../../registry');function i(t,e,r,i){if(!e||!e.visible)return null;for(var a=n.getComponentMethod('errorbars','makeComputeError')(e),o=new Array(t.length),s=0;s<t.length;s++){var l=a(+t[s],s);if("log"===i.type){var c=i.c2l(t[s]),u=t[s]-l[0],f=t[s]+l[1];if(o[s]=[(i.c2l(u,!0)-c)*r,(i.c2l(f,!0)-c)*r],u>0){var h=i.c2l(u);i._lowerLogErrorBound||(i._lowerLogErrorBound=h),i._lowerErrorBound=Math.min(i._lowerLogErrorBound,h)}}else o[s]=[-l[0]*r,l[1]*r]}return o}function a(t){for(var e=0;e<t.length;e++)if(t[e])return t[e].length;return 0}function o(t,e,r){var n=[i(t.x,t.error_x,e[0],r.xaxis),i(t.y,t.error_y,e[1],r.yaxis),i(t.z,t.error_z,e[2],r.zaxis)],o=a(n);if(0===o)return null;for(var s=new Array(o),l=0;l<o;l++){for(var c=[[0,0,0],[0,0,0]],u=0;u<3;u++)if(n[u])for(var f=0;f<2;f++)c[f][u]=n[u][l][f];s[l]=c}return s}e.exports=o},{"../../registry":915}],1233:[function(t,e,r){"use strict";var n=t('gl-line3d'),i=t('gl-scatter3d'),a=t('gl-error3d'),o=t('gl-mesh3d'),s=t('delaunay-triangulate'),l=t('../../lib'),c=t('../../lib/str2rgbarray'),u=t('../../lib/gl_format_color').formatColor,f=t('../scatter/make_bubble_size_func'),h=t('../../constants/gl3d_dashes'),p=t('../../constants/gl3d_markers'),d=t('../../plots/cartesian/axes'),m=t('../../components/fx/helpers').appendArrayPointValue,g=t('./calc_errors');function v(t,e){this.scene=t,this.uid=e,this.linePlot=null,this.scatterPlot=null,this.errorBars=null,this.textMarkers=null,this.delaunayMesh=null,this.color=null,this.mode='',this.dataPoints=[],this.axesBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.textLabels=null,this.data=null}var y=v.prototype;function x(t,e,r){var n,i=(r+1)%3,a=(r+2)%3,o=[],l=[];for(n=0;n<t.length;++n){var c=t[n];!isNaN(c[i])&&isFinite(c[i])&&!isNaN(c[a])&&isFinite(c[a])&&(o.push([c[i],c[a]]),l.push(n))}var u=s(o);for(n=0;n<u.length;++n)for(var f=u[n],h=0;h<f.length;++h)f[h]=l[f[h]];return{positions:t,cells:u,meshColor:e}}function b(t){for(var e=[0,0,0],r=[[0,0,0],[0,0,0],[0,0,0]],n=[1,1,1],i=0;i<3;i++){var a=t[i];a&&!1!==a.copy_zstyle&&!1!==t[2].visible&&(a=t[2]),a&&a.visible&&(e[i]=a.width/2,r[i]=c(a.color),n[i]=a.thickness)}return{capSize:e,color:r,lineWidth:n}}function _(t){return null===t||void 0===t?0:t.indexOf('left')>-1?-1:t.indexOf('right')>-1?1:0}function w(t){return null===t||void 0===t?0:t.indexOf('top')>-1?-1:t.indexOf('bottom')>-1?1:0}function T(t){var e=0,r=0,n=[e,r];if(Array.isArray(t))for(var i=0;i<t.length;i++)n[i]=[e,r],t[i]&&(n[i][0]=_(t[i]),n[i][1]=w(t[i]));else n[0]=_(t),n[1]=w(t);return n}function k(t,e){return e(4*t)}function M(t){return p[t]}function A(t,e,r,n,i){var a=null;if(l.isArrayOrTypedArray(t)){a=[];for(var o=0;o<e;o++)void 0===t[o]?a[o]=n:a[o]=r(t[o],i)}else a=r(t,l.identity);return a}function S(t,e){var r,n,i,a,o,s,h=[],p=t.fullSceneLayout,v=t.dataScale,y=p.xaxis,x=p.yaxis,_=p.zaxis,w=e.marker,S=e.line,E=e.x||[],L=e.y||[],C=e.z||[],P=E.length,I=e.xcalendar,z=e.ycalendar,O=e.zcalendar;for(o=0;o<P;o++)r=y.d2l(E[o],0,I)*v[0],n=x.d2l(L[o],0,z)*v[1],i=_.d2l(C[o],0,O)*v[2],h[o]=[r,n,i];if(Array.isArray(e.text))s=e.text;else if(void 0!==e.text)for(s=new Array(P),o=0;o<P;o++)s[o]=e.text;function D(t,e){var r=p[t];return d.tickText(r,r.d2l(e),!0).text}var R=e.texttemplate;if(R){var F=t.fullLayout._d3locale,B=Array.isArray(R),N=B?Math.min(R.length,P):P,j=B?function(t){return R[t]}:function(){return R};for(s=new Array(N),o=0;o<N;o++){var U={x:E[o],y:L[o],z:C[o]},V={xLabel:D('xaxis',E[o]),yLabel:D('yaxis',L[o]),zLabel:D('zaxis',C[o])},H={};m(H,e,o);var q=e._meta||{};s[o]=l.texttemplateString(j(o),V,F,H,U,q)}}if(a={position:h,mode:e.mode,text:s},"line"in e&&(a.lineColor=u(S,1,P),a.lineWidth=S.width,a.lineDashes=S.dash),"marker"in e){var G=f(e);a.scatterColor=u(w,1,P),a.scatterSize=A(w.size,P,k,20,G),a.scatterMarker=A(w.symbol,P,M,'\u25cf'),a.scatterLineWidth=w.line.width,a.scatterLineColor=u(w.line,1,P),a.scatterAngle=0}"textposition"in e&&(a.textOffset=T(e.textposition),a.textColor=u(e.textfont,1,P),a.textSize=A(e.textfont.size,P,l.identity,12),a.textFont=e.textfont.family,a.textAngle=0);var Y=["x",'y',"z"];for(a.project=[!1,!1,!1],a.projectScale=[1,1,1],a.projectOpacity=[1,1,1],o=0;o<3;++o){var W=e.projection[Y[o]];(a.project[o]=W.show)&&(a.projectOpacity[o]=W.opacity,a.projectScale[o]=W.scale)}a.errorBounds=g(e,v,p);var X=b([e.error_x,e.error_y,e.error_z]);return a.errorColor=X.color,a.errorLineWidth=X.lineWidth,a.errorCapSize=X.capSize,a.delaunayAxis=e.surfaceaxis,a.delaunayColor=c(e.surfacecolor),a}function E(t){if(l.isArrayOrTypedArray(t)){var e=t[0];return l.isArrayOrTypedArray(e)&&(t=e),"rgb('+t.slice(0,3).map((function(t){return Math.round(255*t)}))+')"}return null}function L(t){return l.isArrayOrTypedArray(t)?4===t.length&&"number"===typeof t[0]?E(t):t.map(E):null}function C(t,e){var r=new v(t,e.uid);return r.update(e),r}y.handlePick=function(t){if(t.object&&(t.object===this.linePlot||t.object===this.delaunayMesh||t.object===this.textMarkers||t.object===this.scatterPlot)){var e=t.index=t.data.index;return t.object.highlight&&t.object.highlight(null),this.scatterPlot&&(t.object=this.scatterPlot,this.scatterPlot.highlight(t.data)),t.textLabel='',this.textLabels&&(Array.isArray(this.textLabels)?(this.textLabels[e]||0===this.textLabels[e])&&(t.textLabel=this.textLabels[e]):t.textLabel=this.textLabels),t.traceCoordinate=[this.data.x[e],this.data.y[e],this.data.z[e]],!0}},y.update=function(t){var e,r,s,l,c=this.scene.glplot.gl,u=h.solid;this.data=t;var f=S(this.scene,t);"mode"in f&&(this.mode=f.mode),"lineDashes"in f&&f.lineDashes in h&&(u=h[f.lineDashes]),this.color=L(f.scatterColor)||L(f.lineColor),this.dataPoints=f.position,e={gl:this.scene.glplot.gl,position:f.position,color:f.lineColor,lineWidth:f.lineWidth||1,dashes:u[0],dashScale:u[1],opacity:t.opacity,connectGaps:t.connectgaps},-1!==this.mode.indexOf('lines')?this.linePlot?this.linePlot.update(e):(this.linePlot=n(e),this.linePlot._trace=this,this.scene.glplot.add(this.linePlot)):this.linePlot&&(this.scene.glplot.remove(this.linePlot),this.linePlot.dispose(),this.linePlot=null);var p=t.opacity;if(t.marker&&t.marker.opacity&&(p*=t.marker.opacity),r={gl:this.scene.glplot.gl,position:f.position,color:f.scatterColor,size:f.scatterSize,glyph:f.scatterMarker,opacity:p,orthographic:!0,lineWidth:f.scatterLineWidth,lineColor:f.scatterLineColor,project:f.project,projectScale:f.projectScale,projectOpacity:f.projectOpacity},-1!==this.mode.indexOf('markers')?this.scatterPlot?this.scatterPlot.update(r):(this.scatterPlot=i(r),this.scatterPlot._trace=this,this.scatterPlot.highlightScale=1,this.scene.glplot.add(this.scatterPlot)):this.scatterPlot&&(this.scene.glplot.remove(this.scatterPlot),this.scatterPlot.dispose(),this.scatterPlot=null),l={gl:this.scene.glplot.gl,position:f.position,glyph:f.text,color:f.textColor,size:f.textSize,angle:f.textAngle,alignment:f.textOffset,font:f.textFont,orthographic:!0,lineWidth:0,project:!1,opacity:t.opacity},this.textLabels=t.hovertext||t.text,-1!==this.mode.indexOf('text')?this.textMarkers?this.textMarkers.update(l):(this.textMarkers=i(l),this.textMarkers._trace=this,this.textMarkers.highlightScale=1,this.scene.glplot.add(this.textMarkers)):this.textMarkers&&(this.scene.glplot.remove(this.textMarkers),this.textMarkers.dispose(),this.textMarkers=null),s={gl:this.scene.glplot.gl,position:f.position,color:f.errorColor,error:f.errorBounds,lineWidth:f.errorLineWidth,capSize:f.errorCapSize,opacity:t.opacity},this.errorBars?f.errorBounds?this.errorBars.update(s):(this.scene.glplot.remove(this.errorBars),this.errorBars.dispose(),this.errorBars=null):f.errorBounds&&(this.errorBars=a(s),this.errorBars._trace=this,this.scene.glplot.add(this.errorBars)),f.delaunayAxis>=0){var d=x(f.position,f.delaunayColor,f.delaunayAxis);d.opacity=t.opacity,this.delaunayMesh?this.delaunayMesh.update(d):(d.gl=c,this.delaunayMesh=o(d),this.delaunayMesh._trace=this,this.scene.glplot.add(this.delaunayMesh))}else this.delaunayMesh&&(this.scene.glplot.remove(this.delaunayMesh),this.delaunayMesh.dispose(),this.delaunayMesh=null)},y.dispose=function(){this.linePlot&&(this.scene.glplot.remove(this.linePlot),this.linePlot.dispose()),this.scatterPlot&&(this.scene.glplot.remove(this.scatterPlot),this.scatterPlot.dispose()),this.errorBars&&(this.scene.glplot.remove(this.errorBars),this.errorBars.dispose()),this.textMarkers&&(this.scene.glplot.remove(this.textMarkers),this.textMarkers.dispose()),this.delaunayMesh&&(this.scene.glplot.remove(this.delaunayMesh),this.delaunayMesh.dispose())},e.exports=C},{"../../components/fx/helpers":686,"../../constants/gl3d_dashes":760,"../../constants/gl3d_markers":761,"../../lib":787,"../../lib/gl_format_color":783,"../../lib/str2rgbarray":812,"../../plots/cartesian/axes":838,"../scatter/make_bubble_size_func":1219,"./calc_errors":1232,"delaunay-triangulate":177,"gl-error3d":267,"gl-line3d":275,"gl-mesh3d":309,"gl-scatter3d":327}],1234:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../scatter/subtypes'),o=t('../scatter/marker_defaults'),s=t('../scatter/line_defaults'),l=t('../scatter/text_defaults'),c=t('./attributes');function u(t,e,r,i){var a=0,o=r('x'),s=r('y'),l=r('z');return n.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x",'y',"z"],i),o&&s&&l&&(a=Math.min(o.length,s.length,l.length),e._length=e._xlength=e._ylength=e._zlength=a),a}e.exports=function(t,e,r,f){function h(r,n){return i.coerce(t,e,c,r,n)}if(u(t,e,h,f)){h('text'),h('hovertext'),h('hovertemplate'),h('xhoverformat'),h('yhoverformat'),h('zhoverformat'),h('mode'),a.hasLines(e)&&(h('connectgaps'),s(t,e,r,f,h)),a.hasMarkers(e)&&o(t,e,r,f,h,{noSelect:!0}),a.hasText(e)&&(h('texttemplate'),l(t,e,f,h,{noSelect:!0}));var p=(e.line||{}).color,d=(e.marker||{}).color;h('surfaceaxis')>=0&&h('surfacecolor',p||d);for(var m=["x",'y',"z"],g=0;g<3;++g){var v="projection."+m[g];h(v+".show")&&(h(v+".opacity"),h(v+".scale"))}var y=n.getComponentMethod('errorbars','supplyDefaults');y(t,e,p||d||r,{axis:"z"}),y(t,e,p||d||r,{axis:"y",inherit:"z"}),y(t,e,p||d||r,{axis:"x",inherit:"z"})}else e.visible=!1}},{"../../lib":787,"../../registry":915,"../scatter/line_defaults":1215,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"./attributes":1230}],1235:[function(t,e,r){"use strict";e.exports={plot:t('./convert'),attributes:t('./attributes'),markerSymbols:t('../../constants/gl3d_markers'),supplyDefaults:t('./defaults'),colorbar:[{container:"marker",min:"cmin",max:"cmax"},{container:"line",min:"cmin",max:"cmax"}],calc:t('./calc'),moduleType:"trace",name:"scatter3d",basePlotModule:t('../../plots/gl3d'),categories:["gl3d",'symbols','showLegend',"scatter-like"],meta:{}}},{"../../constants/gl3d_markers":761,"../../plots/gl3d":880,"./attributes":1230,"./calc":1231,"./convert":1233,"./defaults":1234}],1236:[function(t,e,r){"use strict";var n=t('../scatter/attributes'),i=t('../../plots/attributes'),a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../../plots/template_attributes').texttemplateAttrs,s=t('../../components/colorscale/attributes'),l=t('../../lib/extend').extendFlat,c=n.marker,u=n.line,f=c.line;e.exports={carpet:{valType:"string",editType:"calc"},a:{valType:"data_array",editType:"calc"},b:{valType:"data_array",editType:"calc"},mode:l({},n.mode,{dflt:"markers"}),text:l({},n.text,{}),texttemplate:o({editType:"plot"},{keys:["a",'b',"text"]}),hovertext:l({},n.hovertext,{}),line:{color:u.color,width:u.width,dash:u.dash,shape:l({},u.shape,{values:["linear","spline"]}),smoothing:u.smoothing,editType:"calc"},connectgaps:n.connectgaps,fill:l({},n.fill,{values:["none",'toself',"tonext"],dflt:"none"}),fillcolor:n.fillcolor,marker:l({symbol:c.symbol,opacity:c.opacity,maxdisplayed:c.maxdisplayed,size:c.size,sizeref:c.sizeref,sizemin:c.sizemin,sizemode:c.sizemode,line:l({width:f.width,editType:"calc"},s('marker.line')),gradient:c.gradient,editType:"calc"},s('marker')),textfont:n.textfont,textposition:n.textposition,selected:n.selected,unselected:n.unselected,hoverinfo:l({},i.hoverinfo,{flags:["a",'b','text',"name"]}),hoveron:n.hoveron,hovertemplate:a()}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"../scatter/attributes":1202}],1237:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../scatter/colorscale_calc'),a=t('../scatter/arrays_to_calcdata'),o=t('../scatter/calc_selection'),s=t('../scatter/calc').calcMarkerSize,l=t('../carpet/lookup_carpetid');e.exports=function(t,e){var r=e._carpetTrace=l(t,e);if(r&&r.visible&&"legendonly"!==r.visible){var c;e.xaxis=r.xaxis,e.yaxis=r.yaxis;var u,f,h=e._length,p=new Array(h),d=!1;for(c=0;c<h;c++)if(u=e.a[c],f=e.b[c],n(u)&&n(f)){var m=r.ab2xy(+u,+f,!0),g=r.isVisible(+u,+f);g||(d=!0),p[c]={x:m[0],y:m[1],a:u,b:f,vis:g}}else p[c]={x:!1,y:!1};return e._needsCull=d,p[0].carpet=r,p[0].trace=e,s(e,h),i(t,e),a(p,e),o(p,e),p}}},{"../carpet/lookup_carpetid":985,"../scatter/arrays_to_calcdata":1201,"../scatter/calc":1203,"../scatter/calc_selection":1204,"../scatter/colorscale_calc":1205,"fast-isnumeric":246}],1238:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/constants'),a=t('../scatter/subtypes'),o=t('../scatter/marker_defaults'),s=t('../scatter/line_defaults'),l=t('../scatter/line_shape_defaults'),c=t('../scatter/text_defaults'),u=t('../scatter/fillcolor_defaults'),f=t('./attributes');e.exports=function(t,e,r,h){function p(r,i){return n.coerce(t,e,f,r,i)}p('carpet'),e.xaxis='x',e.yaxis='y';var d=p('a'),m=p('b'),g=Math.min(d.length,m.length);if(g){e._length=g,p('text'),p('texttemplate'),p('hovertext'),p('mode',g<i.PTS_LINESONLY?"lines+markers":"lines"),a.hasLines(e)&&(s(t,e,r,h,p),l(t,e,p),p('connectgaps')),a.hasMarkers(e)&&o(t,e,r,h,p,{gradient:!0}),a.hasText(e)&&c(t,e,h,p);var v=[];(a.hasMarkers(e)||a.hasText(e))&&(p('marker.maxdisplayed'),v.push('points')),p('fill'),"none"!==e.fill&&(u(t,e,r,p),a.hasLines(e)||l(t,e,p)),"tonext"!==e.fill&&"toself"!==e.fill||v.push('fills'),"fills"!==p('hoveron',v.join('+')||"points")&&p('hovertemplate'),n.coerceSelectionMarkerOpacity(e,p)}else e.visible=!1}},{"../../lib":787,"../scatter/constants":1206,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/line_shape_defaults":1217,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"./attributes":1236}],1239:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){var a=n[i];return t.a=a.a,t.b=a.b,t.y=a.y,t}},{}],1240:[function(t,e,r){"use strict";e.exports=function(t,e){var r={},n=e._carpet,i=n.ab2ij([t.a,t.b]),a=Math.floor(i[0]),o=i[0]-a,s=Math.floor(i[1]),l=i[1]-s,c=n.evalxy([],a,s,o,l);return r.yLabel=c[1].toFixed(3),r}},{}],1241:[function(t,e,r){"use strict";var n=t('../scatter/hover'),i=t('../../lib').fillText;e.exports=function(t,e,r,a){var o=n(t,e,r,a);if(o&&!1!==o[0].index){var s=o[0];if(void 0===s.index){var l=1-s.y0/t.ya._length,c=t.xa._length,u=c*l/2,f=c-u;return s.x0=Math.max(Math.min(s.x0,f),u),s.x1=Math.max(Math.min(s.x1,f),u),o}var h=s.cd[s.index];s.a=h.a,s.b=h.b,s.xLabelVal=void 0,s.yLabelVal=void 0;var p=s.trace,d=p._carpet,m=p._module.formatLabels(h,p);s.yLabel=m.yLabel,delete s.text;var g=[];if(!p.hovertemplate){var v=(h.hi||p.hoverinfo).split('+');-1!==v.indexOf('all')&&(v=["a",'b',"text"]),-1!==v.indexOf('a')&&y(d.aaxis,h.a),-1!==v.indexOf('b')&&y(d.baxis,h.b),g.push("y: "+s.yLabel),-1!==v.indexOf('text')&&i(h,p,g),s.extraText=g.join('<br>')}return o}function y(t,e){var r;r=t.labelprefix&&t.labelprefix.length>0?t.labelprefix.replace(/ = $/,''):t._hovertitle,g.push(r+": '+e.toFixed(3)+t.labelsuffix)}}},{'../../lib":787,"../scatter/hover":1213}],1242:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('./calc'),plot:t('./plot'),style:t('../scatter/style').style,styleOnSelect:t('../scatter/style').styleOnSelect,hoverPoints:t('./hover'),selectPoints:t('../scatter/select'),eventData:t('./event_data'),moduleType:"trace",name:"scattercarpet",basePlotModule:t('../../plots/cartesian'),categories:["svg",'carpet','symbols','showLegend','carpetDependent',"zoomScale"],meta:{}}},{"../../plots/cartesian":852,"../scatter/marker_colorbar":1220,"../scatter/select":1224,"../scatter/style":1226,"./attributes":1236,"./calc":1237,"./defaults":1238,"./event_data":1239,"./format_labels":1240,"./hover":1241,"./plot":1243}],1243:[function(t,e,r){"use strict";var n=t('../scatter/plot'),i=t('../../plots/cartesian/axes'),a=t('../../components/drawing');e.exports=function(t,e,r,o){var s,l,c,u=r[0][0].carpet,f={xaxis:i.getFromId(t,u.xaxis||"x"),yaxis:i.getFromId(t,u.yaxis||"y"),plot:e.plot};for(n(t,f,r,o),s=0;s<r.length;s++)l=r[s][0].trace,c=o.selectAll("g.trace"+l.uid+" .js-line"),a.setClipUrl(c,r[s][0].carpet._clipPathId,t)}},{"../../components/drawing":672,"../../plots/cartesian/axes":838,"../scatter/plot":1223}],1244:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../scatter/attributes'),o=t('../../plots/attributes'),s=t('../../components/colorscale/attributes'),l=t('../../components/drawing/attributes').dash,c=t('../../lib/extend').extendFlat,u=t('../../plot_api/edit_types').overrideAll,f=a.marker,h=a.line,p=f.line;e.exports=u({lon:{valType:"data_array"},lat:{valType:"data_array"},locations:{valType:"data_array"},locationmode:{valType:"enumerated",values:["ISO-3",'USA-states','country names',"geojson-id"],dflt:"ISO-3"},geojson:{valType:"any",editType:"calc"},featureidkey:{valType:"string",editType:"calc",dflt:"id"},mode:c({},a.mode,{dflt:"markers"}),text:c({},a.text,{}),texttemplate:i({editType:"plot"},{keys:["lat",'lon','location',"text"]}),hovertext:c({},a.hovertext,{}),textfont:a.textfont,textposition:a.textposition,line:{color:h.color,width:h.width,dash:l},connectgaps:a.connectgaps,marker:c({symbol:f.symbol,opacity:f.opacity,size:f.size,sizeref:f.sizeref,sizemin:f.sizemin,sizemode:f.sizemode,colorbar:f.colorbar,line:c({width:p.width},s('marker.line')),gradient:f.gradient},s('marker')),fill:{valType:"enumerated",values:["none","toself"],dflt:"none"},fillcolor:a.fillcolor,selected:a.selected,unselected:a.unselected,hoverinfo:c({},o.hoverinfo,{flags:["lon",'lat','location','text',"name"]}),hovertemplate:n()},'calc','nested')},{"../../components/colorscale/attributes":657,"../../components/drawing/attributes":671,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../../plots/template_attributes":910,"../scatter/attributes":1202}],1245:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../constants/numerical').BADNUM,a=t('../scatter/colorscale_calc'),o=t('../scatter/arrays_to_calcdata'),s=t('../scatter/calc_selection'),l=t('../../lib')._;function c(t){return t&&"string"===typeof t}e.exports=function(t,e){var r,u=Array.isArray(e.locations),f=u?e.locations.length:e._length,h=new Array(f);r=e.geojson?function(t){return c(t)||n(t)}:c;for(var p=0;p<f;p++)[var d=h[p]={];if(u){var m=e.locations[p];d.loc=r(m)?m:null}else{var g=e.lon[p],v=e.lat[p];n(g)&&n(v)?d.lonlat=[+g,+v]:d.lonlat=[i,i]}}return o(h,e),a(t,e),s(h,e),f&&(h[0].t={labels:{lat:l(t,'lat:')+" ',lon:l(t,'lon:')+' '}}),h}},{'../../constants/numerical":763,"../../lib":787,"../scatter/arrays_to_calcdata":1201,"../scatter/calc_selection":1204,"../scatter/colorscale_calc":1205,"fast-isnumeric":246}],1246:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/subtypes'),a=t('../scatter/marker_defaults'),o=t('../scatter/line_defaults'),s=t('../scatter/text_defaults'),l=t('../scatter/fillcolor_defaults'),c=t('./attributes');e.exports=function(t,e,r,u){function f(r,i){return n.coerce(t,e,c,r,i)}var h,p=f('locations');if(p&&p.length){var d,m=f('geojson');("string"===typeof m&&""!==m||n.isPlainObject(m))&&(d='geojson-id'),"geojson-id"===f('locationmode',d)&&f('featureidkey'),h=p.length}else{var g=f('lon')||[],v=f('lat')||[];h=Math.min(g.length,v.length)}h?(e._length=h,f('text'),f('hovertext'),f('hovertemplate'),f('mode'),i.hasLines(e)&&(o(t,e,r,u,f),f('connectgaps')),i.hasMarkers(e)&&a(t,e,r,u,f,{gradient:!0}),i.hasText(e)&&(f('texttemplate'),s(t,e,u,f)),f('fill'),"none"!==e.fill&&l(t,e,r,f),n.coerceSelectionMarkerOpacity(e,f)):e.visible=!1}},{"../../lib":787,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"./attributes":1244}],1247:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){t.lon=e.lon,t.lat=e.lat,t.location=e.loc?e.loc:null;var a=n[i];return a.fIn&&a.fIn.properties&&(t.properties=a.fIn.properties),t}},{}],1248:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes');e.exports=function(t,e,r){var i={},a=r[e.geo]._subplot.mockAxis,o=t.lonlat;return i.lonLabel=n.tickText(a,a.c2l(o[0]),!0).text,i.latLabel=n.tickText(a,a.c2l(o[1]),!0).text,i}},{"../../plots/cartesian/axes":838}],1249:[function(t,e,r){"use strict";var n=t('../../components/fx'),i=t('../../constants/numerical').BADNUM,a=t('../scatter/get_trace_color'),o=t('../../lib').fillText,s=t('./attributes');function l(t,e,r,n){if(!t.hovertemplate){var i=e.hi||t.hoverinfo,a="all"===i?s.hoverinfo.flags:i.split('+'),l=-1!==a.indexOf('location')&&Array.isArray(t.locations),c=-1!==a.indexOf('lon'),u=-1!==a.indexOf('lat'),f=-1!==a.indexOf('text'),h=[];return l?h.push(e.loc):c&&u?h.push('('+p(r.latLabel)+', '+p(r.lonLabel)+')'):c?h.push(n.lon+p(r.lonLabel)):u&&h.push(n.lat+p(r.latLabel)),f&&o(e,t,h),h.join('<br>')}function p(t){return t+"\xb0"}}e.exports=function(t,e,r){var o=t.cd,s=o[0].trace,c=t.xa,u=t.ya,f=t.subplot,h=f.projection.isLonLatOverEdges,p=f.project;function d(t){var n=t.lonlat;if(n[0]===i)return 1/0;if(h(n))return 1/0;var a=p(n),o=p([e,r]),s=Math.abs(a[0]-o[0]),l=Math.abs(a[1]-o[1]),c=Math.max(3,t.mrc||0);return Math.max(Math.sqrt(s*s+l*l)-c,1-3/c)}if(n.getClosest(o,d,t),!1!==t.index){var m=o[t.index],g=m.lonlat,v=[c.c2p(g),u.c2p(g)],y=m.mrc||1;t.x0=v[0]-y,t.x1=v[0]+y,t.y0=v[1]-y,t.y1=v[1]+y,t.loc=m.loc,t.lon=g[0],t.lat=g[1];var x={};x[s.geo]={_subplot:f};var b=s._module.formatLabels(m,s,x);return t.lonLabel=b.lonLabel,t.latLabel=b.latLabel,t.color=a(s,m),t.extraText=l(s,m,t,o[0].t.labels),t.hovertemplate=s.hovertemplate,[t]}}},{"../../components/fx":690,"../../constants/numerical":763,"../../lib":787,"../scatter/get_trace_color":1212,"./attributes":1244}],1250:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('./calc'),calcGeoJSON:t('./plot').calcGeoJSON,plot:t('./plot').plot,style:t('./style'),styleOnSelect:t('../scatter/style').styleOnSelect,hoverPoints:t('./hover'),eventData:t('./event_data'),selectPoints:t('./select'),moduleType:"trace",name:"scattergeo",basePlotModule:t('../../plots/geo'),categories:["geo",'symbols','showLegend',"scatter-like"],meta:{}}},{"../../plots/geo":871,"../scatter/marker_colorbar":1220,"../scatter/style":1226,"./attributes":1244,"./calc":1245,"./defaults":1246,"./event_data":1247,"./format_labels":1248,"./hover":1249,"./plot":1251,"./select":1252,"./style":1253}],1251:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../lib/topojson_utils').getTopojsonFeatures,o=t('../../lib/geojson_utils'),s=t('../../lib/geo_location_utils'),l=t('../../plots/cartesian/autorange').findExtremes,c=t('../../constants/numerical').BADNUM,u=t('../scatter/calc').calcMarkerSize,f=t('../scatter/subtypes'),h=t('./style');function p(t,e,r){var a=e.layers.frontplot.select('.scatterlayer'),s=i.makeTraceGroups(a,r,'trace scattergeo');function l(t,e){t.lonlat[0]===c&&n.select(e).remove()}s.selectAll('*').remove(),s.each((function(e){var r=n.select(this),a=e[0].trace;if(f.hasLines(a)||"none"!==a.fill){var s=o.calcTraceToLineCoords(e),c="none"!==a.fill?o.makePolygon(s):o.makeLine(s);r.selectAll('path.js-line').data([geojson:c,trace:a]).enter().append('path').classed('js-line',!0).style('stroke-miterlimit',2)}f.hasMarkers(a)&&r.selectAll('path.point').data(i.identity).enter().append('path').classed('point',!0).each((function(t){l(t,this)})),f.hasText(a)&&r.selectAll('g').data(i.identity).enter().append('g').append('text').each((function(t){l(t,this)})),h(t,e)}))}function d(t,e){var r,n,i=t[0].trace,o=e[i.geo],f=o._subplot,h=i._length;if(Array.isArray(i.locations)){var p=i.locationmode,d="geojson-id"===p?s.extractTraceFeature(t):a(i,f.topojson);for(r=0;r<h;r++){n=t[r];var m="geojson-id"===p?n.fOut:s.locationToFeature(p,n.loc,d);n.lonlat=m?m.properties.ct:[c,c]}}var g,v,y={padded:!0};if("geojson"===o.fitbounds&&"geojson-id"===i.locationmode){var x=s.computeBbox(s.getTraceGeojson(i));g=[x[0],x[2]],v=[x[1],x[3]]}else{for(g=new Array(h),v=new Array(h),r=0;r<h;r++)n=t[r],g[r]=n.lonlat[0],v[r]=n.lonlat[1];y.ppad=u(i,h)}i._extremes.lon=l(o.lonaxis._ax,g,y),i._extremes.lat=l(o.lataxis._ax,v,y)}e.exports={calcGeoJSON:d,plot:p}},{"../../constants/numerical":763,"../../lib":787,"../../lib/geo_location_utils":780,"../../lib/geojson_utils":781,"../../lib/topojson_utils":816,"../../plots/cartesian/autorange":837,"../scatter/calc":1203,"../scatter/subtypes":1227,"./style":1253,"@plotly/d3":58}],1252:[function(t,e,r){"use strict";var n=t('../scatter/subtypes'),i=t('../../constants/numerical').BADNUM;e.exports=function(t,e){var r,a,o,s,l,c=t.cd,u=t.xaxis,f=t.yaxis,h=[],p=c[0].trace;if(!n.hasMarkers(p)&&!n.hasText(p))return[];if(!1===e)for(l=0;l<c.length;l++)c[l].selected=0;else for(l=0;l<c.length;l++)(a=(r=c[l]).lonlat)[0]!==i&&(o=u.c2p(a),s=f.c2p(a),e.contains([o,s],null,l,t)?(h.push({pointNumber:l,lon:a[0],lat:a[1]}),r.selected=1):r.selected=0);return h}},{"../../constants/numerical":763,"../scatter/subtypes":1227}],1253:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../../components/color'),o=t('../scatter/style'),s=o.stylePoints,l=o.styleText;function c(t,e){var r=e[0].trace,o=e[0].node3;o.style('opacity',e[0].trace.opacity),s(o,r,t),l(o,r,t),o.selectAll('path.js-line').style('fill','none').each((function(t){var e=n.select(this),r=t.trace,o=r.line||{};e.call(a.stroke,o.color).call(i.dashLine,o.dash||"",o.width||0),"none"!==r.fill&&e.call(a.fill,r.fillcolor)}))}e.exports=function(t,e){e&&c(t,e)}},{"../../components/color":650,"../../components/drawing":672,"../scatter/style":1226,"@plotly/d3":58}],1254:[function(t,e,r){"use strict";var n=t('../../plots/attributes'),i=t('../scatter/attributes'),a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,o=t('../../components/colorscale/attributes'),s=t('../../lib/sort_object_keys'),l=t('../../lib/extend').extendFlat,c=t('../../plot_api/edit_types').overrideAll,u=t('./constants').DASHES,f=i.line,h=i.marker,p=h.line,d=e.exports=c({x:i.x,x0:i.x0,dx:i.dx,y:i.y,y0:i.y0,dy:i.dy,xperiod:i.xperiod,yperiod:i.yperiod,xperiod0:i.xperiod0,yperiod0:i.yperiod0,xperiodalignment:i.xperiodalignment,yperiodalignment:i.yperiodalignment,xhoverformat:a('x'),yhoverformat:a('y'),text:i.text,hovertext:i.hovertext,textposition:i.textposition,textfont:i.textfont,mode:{valType:"flaglist",flags:["lines",'markers',"text"],extras:["none"]},line:{color:f.color,width:f.width,shape:{valType:"enumerated",values:["linear",'hv','vh','hvh',"vhv"],dflt:"linear",editType:"plot"},dash:{valType:"enumerated",values:s(u),dflt:"solid"}},marker:l({},o('marker'),{symbol:h.symbol,size:h.size,sizeref:h.sizeref,sizemin:h.sizemin,sizemode:h.sizemode,opacity:h.opacity,colorbar:h.colorbar,line:l({},o('marker.line'),{width:p.width})}),connectgaps:i.connectgaps,fill:l({},i.fill,{dflt:"none"}),fillcolor:i.fillcolor,selected:{marker:i.selected.marker,textfont:i.selected.textfont},unselected:{marker:i.unselected.marker,textfont:i.unselected.textfont},opacity:n.opacity},'calc','nested');d.x.editType=d.y.editType=d.x0.editType=d.y0.editType='calc+clearAxisTypes',d.hovertemplate=i.hovertemplate,d.texttemplate=i.texttemplate},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../lib/sort_object_keys":810,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../scatter/attributes":1202,"./constants":1256}],1255:[function(t,e,r){"use strict";var n=t('@plotly/point-cluster'),i=t('../../lib'),a=t('../../plots/cartesian/axis_ids'),o=t('../../plots/cartesian/autorange').findExtremes,s=t('../../plots/cartesian/align_period'),l=t('../scatter/calc'),c=l.calcMarkerSize,u=l.calcAxisExpansion,f=l.setFirstScatter,h=t('../scatter/colorscale_calc'),p=t('./convert'),d=t('./scene_update'),m=t('../../constants/numerical').BADNUM,g=t('./constants').TOO_MANY_POINTS;function v(t,e,r){var n=t._extremes[e._id],i=o(e,r._bnds,{padded:!0});n.min=n.min.concat(i.min),n.max=n.max.concat(i.max)}function y(t,e,r,n,a,o){var s=p.style(t,r);if(s.marker&&(s.marker.positions=n),s.line&&n.length>1&&i.extendFlat(s.line,p.linePositions(t,r,n)),s.errorX||s.errorY){var l=p.errorBarPositions(t,r,n,a,o);s.errorX&&i.extendFlat(s.errorX,l.x),s.errorY&&i.extendFlat(s.errorY,l.y)}return s.text&&(i.extendFlat(s.text,{positions:n},p.textPosition(t,r,s.text,s.marker)),i.extendFlat(s.textSel,{positions:n},p.textPosition(t,r,s.text,s.markerSel)),i.extendFlat(s.textUnsel,{positions:n},p.textPosition(t,r,s.text,s.markerUnsel))),s}e.exports=function(t,e){var r,i=t._fullLayout,o=a.getFromId(t,e.xaxis),l=a.getFromId(t,e.yaxis),p=i._plots[e.xaxis+e.yaxis],x=e._length,b=x>=g,_=2*x,w={},T=o.makeCalcdata(e,'x'),k=l.makeCalcdata(e,'y'),M=s(e,o,'x',T),A=s(e,l,'y',k),S=M.vals,E=A.vals;e._x=S,e._y=E,e.xperiodalignment&&(e._origX=T,e._xStarts=M.starts,e._xEnds=M.ends),e.yperiodalignment&&(e._origY=k,e._yStarts=A.starts,e._yEnds=A.ends);var L=new Array(_),C=new Array(x);for(r=0;r<x;r++)L[2*r]=S[r]===m?NaN:S[r],L[2*r+1]=E[r]===m?NaN:E[r],C[r]=r;if("log"===o.type)for(r=0;r<_;r+=2)L[r]=o.c2l(L[r]);if("log"===l.type)for(r=1;r<_;r+=2)L[r]=l.c2l(L[r]);b&&"log"!==o.type&&"log"!==l.type?w.tree=n(L):w.ids=C,h(t,e);var P,I=y(t,p,e,L,S,E),z=d(t,p);return f(i,e),b?I.marker&&(P=I.marker.sizeAvg||Math.max(I.marker.size,3)):P=c(e,x),u(t,e,o,l,S,E,P),I.errorX&&v(e,o,I.errorX),I.errorY&&v(e,l,I.errorY),I.fill&&!z.fill2d&&(z.fill2d=!0),I.marker&&!z.scatter2d&&(z.scatter2d=!0),I.line&&!z.line2d&&(z.line2d=!0),!I.errorX&&!I.errorY||z.error2d||(z.error2d=!0),I.text&&!z.glText&&(z.glText=!0),I.marker&&(I.marker.snap=x),z.lineOptions.push(I.line),z.errorXOptions.push(I.errorX),z.errorYOptions.push(I.errorY),z.fillOptions.push(I.fill),z.markerOptions.push(I.marker),z.markerSelectedOptions.push(I.markerSel),z.markerUnselectedOptions.push(I.markerUnsel),z.textOptions.push(I.text),z.textSelectedOptions.push(I.textSel),z.textUnselectedOptions.push(I.textUnsel),z.selectBatch.push([]),z.unselectBatch.push([]),w._scene=z,w.index=z.count,w.x=S,w.y=E,w.positions=L,z.count++,[x:!1,y:!1,t:w,trace:e]}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/autorange":837,"../../plots/cartesian/axis_ids":842,"../scatter/calc":1203,"../scatter/colorscale_calc":1205,"./constants":1256,"./convert":1257,"./scene_update":1265,"@plotly/point-cluster":59}],1256:[function(t,e,r){"use strict";var n=20;e.exports={TOO_MANY_POINTS:1e5,SYMBOL_SDF_SIZE:200,SYMBOL_SIZE:n,SYMBOL_STROKE:n/20,DOT_RE:/-dot/,OPEN_RE:/-open/,DASHES:{solid:[1],dot:[1,1],dash:[4,1],longdash:[8,1],dashdot:[4,1,1,1],longdashdot:[8,1,1,1]}}},{}],1257:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('svg-path-sdf'),a=t('color-normalize'),o=t('../../registry'),s=t('../../lib'),l=t('../../components/drawing'),c=t('../../plots/cartesian/axis_ids'),u=t('../../lib/gl_format_color').formatColor,f=t('../scatter/subtypes'),h=t('../scatter/make_bubble_size_func'),p=t('./helpers'),d=t('./constants'),m=t('../../constants/interactions').DESELECTDIM,g={start:1,left:1,end:-1,right:-1,middle:0,center:0,bottom:1,top:-1},v=t('../../components/fx/helpers').appendArrayPointValue;function y(t,e){var r,n={marker:void 0,markerSel:void 0,markerUnsel:void 0,line:void 0,fill:void 0,errorX:void 0,errorY:void 0,text:void 0,textSel:void 0,textUnsel:void 0},i=t._context.plotGlPixelRatio;if(!0!==e.visible)return n;if(f.hasText(e)&&(n.text=x(t,e),n.textSel=w(t,e,e.selected),n.textUnsel=w(t,e,e.unselected)),f.hasMarkers(e)&&(n.marker=b(e),n.markerSel=_(e,e.selected),n.markerUnsel=_(e,e.unselected),!e.unselected&&s.isArrayOrTypedArray(e.marker.opacity))){var a=e.marker.opacity;for(n.markerUnsel.opacity=new Array(a.length),r=0;r<a.length;r++)n.markerUnsel.opacity[r]=m*a[r]}if(f.hasLines(e)){n.line={overlay:!0,thickness:e.line.width*i,color:e.line.color,opacity:e.opacity};var o=(d.DASHES[e.line.dash]||[1]).slice();for(r=0;r<o.length;++r)o[r]*=e.line.width*i;n.line.dashes=o}return e.error_x&&e.error_x.visible&&(n.errorX=T(e,e.error_x,i)),e.error_y&&e.error_y.visible&&(n.errorY=T(e,e.error_y,i)),e.fill&&"none"!==e.fill&&(n.fill={closed:!0,fill:e.fillcolor,thickness:0}),n}function x(t,e){var r,i=t._fullLayout,a=e._length,o=e.textfont,l=e.textposition,c=Array.isArray(l)?l:[l],u=o.color,f=o.size,h=o.family,p={},d=t._context.plotGlPixelRatio,m=e.texttemplate;if(m){p.text=[];var g=i._d3locale,y=Array.isArray(m),x=y?Math.min(m.length,a):a,b=y?function(t){return m[t]}:function(){return m};for(r=0;r<x;r++){var _={i:r},w=e._module.formatLabels(_,e,i),T={};v(T,e,r);var k=e._meta||{};p.text.push(s.texttemplateString(b(r),w,g,T,_,k))}}else Array.isArray(e.text)&&e.text.length<a?p.text=e.text.slice():p.text=e.text;if(Array.isArray(p.text))for(r=p.text.length;r<a;r++)p.text[r]='';for(p.opacity=e.opacity,p.font={},p.align=[],p.baseline=[],r=0;r<c.length;r++){var M=c[r].split(/\s+/);switch(M[1]){case"left":p.align.push('right');break;case"right":p.align.push('left');break;default:p.align.push(M[1])}switch(M[0]){case"top":p.baseline.push('bottom');break;case"bottom":p.baseline.push('top');break;default:p.baseline.push(M[0])}}if(Array.isArray(u))for(p.color=new Array(a),r=0;r<a;r++)p.color[r]=u[r];else p.color=u;if(s.isArrayOrTypedArray(f)||Array.isArray(h))for(p.font=new Array(a),r=0;r<a;r++)[var A=p.font[r]={];A.size=(s.isTypedArray(f)?f[r]:Array.isArray(f)?n(f[r])?f[r]:0:f)*d,A.family=Array.isArray(h)?h[r]:h}else p.font={size:f*d,family:h};return p}function b(t){var e,r,n=t._length,i=t.marker,o={},l=s.isArrayOrTypedArray(i.symbol),c=s.isArrayOrTypedArray(i.color),f=s.isArrayOrTypedArray(i.line.color),d=s.isArrayOrTypedArray(i.opacity),m=s.isArrayOrTypedArray(i.size),g=s.isArrayOrTypedArray(i.line.width);if(l||(r=p.isOpenSymbol(i.symbol)),l||c||f||d){o.colors=new Array(n),o.borderColors=new Array(n);var v=u(i,i.opacity,n),y=u(i.line,i.opacity,n);if(!Array.isArray(y[0])){var x=y;for(y=Array(n),e=0;e<n;e++)y[e]=x}if(!Array.isArray(v[0])){var b=v;for(v=Array(n),e=0;e<n;e++)v[e]=b}for(o.colors=v,o.borderColors=y,e=0;e<n;e++){if(l){var _=i.symbol[e];r=p.isOpenSymbol(_)}r&&(y[e]=v[e].slice(),v[e]=v[e].slice(),v[e][3]=0)}o.opacity=t.opacity}else r?(o.color=a(i.color,'uint8'),o.color[3]=0,o.borderColor=a(i.color,'uint8')):(o.color=a(i.color,'uint8'),o.borderColor=a(i.line.color,'uint8')),o.opacity=t.opacity*i.opacity;if(l)for(o.markers=new Array(n),e=0;e<n;e++)o.markers[e]=L(i.symbol[e]);else o.marker=L(i.symbol);var w,T=h(t,1);if(m||g){var k,M=o.sizes=new Array(n),A=o.borderSizes=new Array(n),S=0;if(m){for(e=0;e<n;e++)M[e]=T(i.size[e]),S+=M[e];k=S/n}else for(w=T(i.size),e=0;e<n;e++)M[e]=w;if(g)for(e=0;e<n;e++)A[e]=i.line.width[e];else for(w=i.line.width,e=0;e<n;e++)A[e]=w;o.sizeAvg=k}else o.size=T(i&&i.size||10),o.borderSizes=T(i.line.width);return o}function _(t,e){var r=t.marker,n={};return e?(e.marker&&e.marker.symbol?n=b(s.extendFlat({},r,e.marker)):e.marker&&(e.marker.size&&(n.size=e.marker.size),e.marker.color&&(n.colors=e.marker.color),void 0!==e.marker.opacity&&(n.opacity=e.marker.opacity)),n):n}function w(t,e,r)[var n={];if(!r)return n;if(r.textfont){var i={opacity:1,text:e.text,texttemplate:e.texttemplate,textposition:e.textposition,textfont:s.extendFlat({},e.textfont)};r.textfont&&s.extendFlat(i.textfont,r.textfont),n=x(t,i)}return n}function T(t,e,r){var n={capSize:2*e.width*r,lineWidth:e.thickness*r,color:e.color};return e.copy_ystyle&&(n=t.error_y),n}var k=d.SYMBOL_SDF_SIZE,M=d.SYMBOL_SIZE,A=d.SYMBOL_STROKE,S={},E=l.symbolFuncs[0](.05*M);function L(t){if("circle"===t)return null;var e,r,n=l.symbolNumber(t),a=l.symbolFuncs[n%100],o=!!l.symbolNoDot[n%100],s=!!l.symbolNoFill[n%100],c=p.isDotSymbol(t);return S[t]?S[t]:(e=c&&!o?a(1.1*M)+E:a(M),r=i(e,{w:k,h:k,viewBox:[-M,-M,M,M],stroke:s?A:-A}),S[t]=r,r||null)}function C(t,e,r){var n,i,a=r.length,o=a/2;if(f.hasLines(e)&&o)if("hv"===e.line.shape){for(n=[],i=0;i<o-1;i++)isNaN(r[2*i])||isNaN(r[2*i+1])?n.push(NaN,NaN,NaN,NaN):(n.push(r[2*i],r[2*i+1]),isNaN(r[2*i+2])||isNaN(r[2*i+3])?n.push(NaN,NaN):n.push(r[2*i+2],r[2*i+1]));n.push(r[a-2],r[a-1])}else if("hvh"===e.line.shape){for(n=[],i=0;i<o-1;i++)if(isNaN(r[2*i])||isNaN(r[2*i+1])||isNaN(r[2*i+2])||isNaN(r[2*i+3]))isNaN(r[2*i])||isNaN(r[2*i+1])?n.push(NaN,NaN):n.push(r[2*i],r[2*i+1]),n.push(NaN,NaN);else{var s=(r[2*i]+r[2*i+2])/2;n.push(r[2*i],r[2*i+1],s,r[2*i+1],s,r[2*i+3])}n.push(r[a-2],r[a-1])}else if("vhv"===e.line.shape){for(n=[],i=0;i<o-1;i++)if(isNaN(r[2*i])||isNaN(r[2*i+1])||isNaN(r[2*i+2])||isNaN(r[2*i+3]))isNaN(r[2*i])||isNaN(r[2*i+1])?n.push(NaN,NaN):n.push(r[2*i],r[2*i+1]),n.push(NaN,NaN);else{var l=(r[2*i+1]+r[2*i+3])/2;n.push(r[2*i],r[2*i+1],r[2*i],l,r[2*i+2],l)}n.push(r[a-2],r[a-1])}else if("vh"===e.line.shape){for(n=[],i=0;i<o-1;i++)isNaN(r[2*i])||isNaN(r[2*i+1])?n.push(NaN,NaN,NaN,NaN):(n.push(r[2*i],r[2*i+1]),isNaN(r[2*i+2])||isNaN(r[2*i+3])?n.push(NaN,NaN):n.push(r[2*i],r[2*i+3]));n.push(r[a-2],r[a-1])}else n=r;var c=!1;for(i=0;i<n.length;i++)if(isNaN(n[i])){c=!0;break}var u=c||n.length>d.TOO_MANY_POINTS||f.hasMarkers(e)?"rect":"round";if(c&&e.connectgaps){var h=n[0],p=n[1];for(i=0;i<n.length;i+=2)isNaN(n[i])||isNaN(n[i+1])?(n[i]=h,n[i+1]=p):(h=n[i],p=n[i+1])}return{join:u,positions:n}}function P(t,e,r,i,a){var s=o.getComponentMethod('errorbars','makeComputeError'),l=c.getFromId(t,e.xaxis),u=c.getFromId(t,e.yaxis),f=r.length/2,h={};function p(t,i){var a=i._id.charAt(0),o=e["error_"+a];if(o&&o.visible&&("linear"===i.type||"log"===i.type)){for(var l=s(o),c={x:0,y:1}[a],u={x:[0,1,2,3],y:[2,3,0,1]}[a],p=new Float64Array(4*f),d=1/0,m=-1/0,g=0,v=0;g<f;g++,v+=4){var y=t[g];if(n(y)){var x=r[2*g+c],b=l(y,g),_=b[0],w=b[1];if(n(_)&&n(w)){var T=y-_,k=y+w;p[v+u[0]]=x-i.c2l(T),p[v+u[1]]=i.c2l(k)-x,p[v+u[2]]=0,p[v+u[3]]=0,d=Math.min(d,y-_),m=Math.max(m,y+w)}}}h[a]={positions:r,errors:p,_bnds:[d,m]}}}return p(i,l),p(a,u),h}function I(t,e,r,n){var i,a=e._length,o={};if(f.hasMarkers(e)){var s=r.font,l=r.align,c=r.baseline;for(o.offset=new Array(a),i=0;i<a;i++){var u=n.sizes?n.sizes[i]:n.size,h=Array.isArray(s)?s[i].size:s.size,p=Array.isArray(l)?l.length>1?l[i]:l[0]:l,d=Array.isArray(c)?c.length>1?c[i]:c[0]:c,m=g[p],v=g[d],y=u?u/.8+1:0,x=-v*y-.5*v;o.offset[i]=[m*y/h,x/h]}}return o}e.exports={style:y,markerStyle:b,markerSelection:_,linePositions:C,errorBarPositions:P,textPosition:I}},{"../../components/drawing":672,"../../components/fx/helpers":686,"../../constants/interactions":762,"../../lib":787,"../../lib/gl_format_color":783,"../../plots/cartesian/axis_ids":842,"../../registry":915,"../scatter/make_bubble_size_func":1219,"../scatter/subtypes":1227,"./constants":1256,"./helpers":1261,"color-normalize":131,"fast-isnumeric":246,"svg-path-sdf":580}],1258:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../registry'),a=t('./helpers'),o=t('./attributes'),s=t('../scatter/constants'),l=t('../scatter/subtypes'),c=t('../scatter/xy_defaults'),u=t('../scatter/period_defaults'),f=t('../scatter/marker_defaults'),h=t('../scatter/line_defaults'),p=t('../scatter/fillcolor_defaults'),d=t('../scatter/text_defaults');e.exports=function(t,e,r,m){function g(r,i){return n.coerce(t,e,o,r,i)}var v=!!t.marker&&a.isOpenSymbol(t.marker.symbol),y=l.isBubble(t),x=c(t,e,m,g);if(x){u(t,e,m,g),g('xhoverformat'),g('yhoverformat');var b=x<s.PTS_LINESONLY?"lines+markers":"lines";g('text'),g('hovertext'),g('hovertemplate'),g('mode',b),l.hasLines(e)&&(g('connectgaps'),h(t,e,r,m,g),g('line.shape')),l.hasMarkers(e)&&(f(t,e,r,m,g),g('marker.line.width',v||y?1:0)),l.hasText(e)&&(g('texttemplate'),d(t,e,m,g));var _=(e.line||{}).color,w=(e.marker||{}).color;g('fill'),"none"!==e.fill&&p(t,e,r,g);var T=i.getComponentMethod('errorbars','supplyDefaults');T(t,e,_||w||r,{axis:"y"}),T(t,e,_||w||r,{axis:"x",inherit:"y"}),n.coerceSelectionMarkerOpacity(e,g)}else e.visible=!1}},{"../../lib":787,"../../registry":915,"../scatter/constants":1206,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/marker_defaults":1221,"../scatter/period_defaults":1222,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"../scatter/xy_defaults":1229,"./attributes":1254,"./helpers":1261}],1259:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../../constants/interactions').DESELECTDIM;function o(t){var e,r,o=t[0],s=o.trace,l=o.t,c=l._scene,u=l.index,f=c.selectBatch[u],h=c.unselectBatch[u],p=c.textOptions[u],d=c.textSelectedOptions[u]||{},m=c.textUnselectedOptions[u]||{},g=n.extendFlat({},p);if(f.length||h.length){var v=d.color,y=m.color,x=p.color,b=Array.isArray(x);for(g.color=new Array(s._length),e=0;e<f.length;e++)r=f[e],g.color[r]=v||(b?x[r]:x);for(e=0;e<h.length;e++){r=h[e];var _=b?x[r]:x;g.color[r]=y||(v?_:i.addOpacity(_,a))}}c.glText[u].update(g)}e.exports={styleTextSelection:o}},{"../../components/color":650,"../../constants/interactions":762,"../../lib":787}],1260:[function(t,e,r){"use strict";var n=t('../scatter/format_labels');e.exports=function(t,e,r){var i=t.i;return"x"in t||(t.x=e._x[i]),"y"in t||(t.y=e._y[i]),n(t,e,r)}},{"../scatter/format_labels":1211}],1261:[function(t,e,r){"use strict";var n=t('./constants');r.isOpenSymbol=function(t){return"string"===typeof t?n.OPEN_RE.test(t):t%200>100},r.isDotSymbol=function(t){return"string"===typeof t?n.DOT_RE.test(t):t>200}},{"./constants":1256}],1262:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../scatter/get_trace_color');function o(t,e,r,n){var i,a,o,l,c,u,f,h,p,d,m=t.cd,g=m[0].t,v=m[0].trace,y=t.xa,x=t.ya,b=g.x,_=g.y,w=y.c2p(e),T=x.c2p(r),k=t.distance;if(g.tree){var M=y.p2c(w-k),A=y.p2c(w+k),S=x.p2c(T-k),E=x.p2c(T+k);i="x"===n?g.tree.range(Math.min(M,A),Math.min(x._rl[0],x._rl[1]),Math.max(M,A),Math.max(x._rl[0],x._rl[1])):g.tree.range(Math.min(M,A),Math.min(S,E),Math.max(M,A),Math.max(S,E))}else i=g.ids;var L=k;if("x"===n){var C=!!v.xperiodalignment,P=!!v.yperiodalignment;for(u=0;u<i.length;u++){if(l=b[a=i[u]],f=Math.abs(y.c2p(l)-w),C){var I=y.c2p(v._xStarts[a]),z=y.c2p(v._xEnds[a]);f=w>=Math.min(I,z)&&w<=Math.max(I,z)?0:1/0}if(f<L){if(L=f,c=_[a],h=x.c2p(c)-T,P){var O=x.c2p(v._yStarts[a]),D=x.c2p(v._yEnds[a]);h=T>=Math.min(O,D)&&T<=Math.max(O,D)?0:1/0}d=Math.sqrt(f*f+h*h),o=i[u]}}}else for(u=i.length-1;u>-1;u--)l=b[a=i[u]],c=_[a],f=y.c2p(l)-w,h=x.c2p(c)-T,(p=Math.sqrt(f*f+h*h))<L&&(L=d=p,o=a);return t.index=o,t.distance=L,t.dxy=d,void 0===o?[t]:[s(t,b,_,v)]}function s(t,e,r,o){var s=t.xa,l=t.ya,c=t.distance,u=t.dxy,f=t.index,h={pointNumber:f,x:e[f],y:r[f]};h.tx=Array.isArray(o.text)?o.text[f]:o.text,h.htx=Array.isArray(o.hovertext)?o.hovertext[f]:o.hovertext,h.data=Array.isArray(o.customdata)?o.customdata[f]:o.customdata,h.tp=Array.isArray(o.textposition)?o.textposition[f]:o.textposition;var p=o.textfont;p&&(h.ts=i.isArrayOrTypedArray(p.size)?p.size[f]:p.size,h.tc=Array.isArray(p.color)?p.color[f]:p.color,h.tf=Array.isArray(p.family)?p.family[f]:p.family);var d=o.marker;d&&(h.ms=i.isArrayOrTypedArray(d.size)?d.size[f]:d.size,h.mo=i.isArrayOrTypedArray(d.opacity)?d.opacity[f]:d.opacity,h.mx=i.isArrayOrTypedArray(d.symbol)?d.symbol[f]:d.symbol,h.mc=i.isArrayOrTypedArray(d.color)?d.color[f]:d.color);var m=d&&d.line;m&&(h.mlc=Array.isArray(m.color)?m.color[f]:m.color,h.mlw=i.isArrayOrTypedArray(m.width)?m.width[f]:m.width);var g=d&&d.gradient;g&&"none"!==g.type&&(h.mgt=Array.isArray(g.type)?g.type[f]:g.type,h.mgc=Array.isArray(g.color)?g.color[f]:g.color);var v=s.c2p(h.x,!0),y=l.c2p(h.y,!0),x=h.mrc||1,b=o.hoverlabel;b&&(h.hbg=Array.isArray(b.bgcolor)?b.bgcolor[f]:b.bgcolor,h.hbc=Array.isArray(b.bordercolor)?b.bordercolor[f]:b.bordercolor,h.hts=i.isArrayOrTypedArray(b.font.size)?b.font.size[f]:b.font.size,h.htc=Array.isArray(b.font.color)?b.font.color[f]:b.font.color,h.htf=Array.isArray(b.font.family)?b.font.family[f]:b.font.family,h.hnl=i.isArrayOrTypedArray(b.namelength)?b.namelength[f]:b.namelength);var _=o.hoverinfo;_&&(h.hi=Array.isArray(_)?_[f]:_);var w=o.hovertemplate;w&&(h.ht=Array.isArray(w)?w[f]:w);var T={};T[t.index]=h;var k=o._origX,M=o._origY,A=i.extendFlat({},t,{color:a(o,h),x0:v-x,x1:v+x,xLabelVal:k?k[f]:h.x,y0:y-x,y1:y+x,yLabelVal:M?M[f]:h.y,cd:T,distance:c,spikeDistance:u,hovertemplate:h.ht});return h.htx?A.text=h.htx:h.tx?A.text=h.tx:o.text&&(A.text=o.text),i.fillText(h,o,A),n.getComponentMethod('errorbars','hoverInfo')(h,o,A),A}e.exports={hoverPoints:o,calcHover:s}},{"../../lib":787,"../../registry":915,"../scatter/get_trace_color":1212}],1263:[function(t,e,r){"use strict";var n=t('./hover');e.exports={moduleType:"trace",name:"scattergl",basePlotModule:t('../../plots/cartesian'),categories:["gl",'regl','cartesian','symbols','errorBarsOK','showLegend',"scatter-like"],attributes:t('./attributes'),supplyDefaults:t('./defaults'),crossTraceDefaults:t('../scatter/cross_trace_defaults'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('./calc'),plot:t('./plot'),hoverPoints:n.hoverPoints,selectPoints:t('./select'),meta:{}}},{"../../plots/cartesian":852,"../scatter/cross_trace_defaults":1208,"../scatter/marker_colorbar":1220,"./attributes":1254,"./calc":1255,"./defaults":1258,"./format_labels":1260,"./hover":1262,"./plot":1264,"./select":1266}],1264:[function(t,e,r){"use strict";var n=t('regl-scatter2d'),i=t('regl-line2d'),a=t('regl-error2d'),o=t('gl-text'),s=t('../../lib'),l=t('../../components/dragelement/helpers').selectMode,c=t('../../lib/prepare_regl'),u=t('../scatter/subtypes'),f=t('../scatter/link_traces'),h=t('./edit_style').styleTextSelection;function p(t,e,r,n){var i=t._size,a=t.width*n,o=t.height*n,s=i.l*n,l=i.b*n,c=i.r*n,u=i.t*n,f=i.w*n,h=i.h*n;return[s+e.domain[0]*f,l+r.domain[0]*h,a-c-(1-e.domain[1])*f,o-u-(1-r.domain[1])*h]}e.exports=function(t,e,r){if(r.length){var d,m,g=t._fullLayout,v=e._scene,y=e.xaxis,x=e.yaxis;if(v)if(c(t,["ANGLE_instanced_arrays","OES_element_index_uint"])){var b=v.count,_=g._glcanvas.data()[0].regl;if(f(t,e,r),v.dirty){if(!0===v.error2d&&(v.error2d=a(_)),!0===v.line2d&&(v.line2d=i(_)),!0===v.scatter2d&&(v.scatter2d=n(_)),!0===v.fill2d&&(v.fill2d=i(_)),!0===v.glText)for(v.glText=new Array(b),d=0;d<b;d++)v.glText[d]=new o(_);if(v.glText){if(b>v.glText.length){var w=b-v.glText.length;for(d=0;d<w;d++)v.glText.push(new o(_))}else if(b<v.glText.length){var T=v.glText.length-b;v.glText.splice(b,T).forEach((function(t){t.destroy()}))}for(d=0;d<b;d++)v.glText[d].update(v.textOptions[d])}if(v.line2d&&(v.line2d.update(v.lineOptions),v.lineOptions=v.lineOptions.map((function(t){if(t&&t.positions){for(var e=t.positions,r=0;r<e.length&&(isNaN(e[r])||isNaN(e[r+1]));)r+=2;for(var n=e.length-2;n>r&&(isNaN(e[n])||isNaN(e[n+1]));)n-=2;t.positions=e.slice(r,n+2)}return t})),v.line2d.update(v.lineOptions)),v.error2d){var k=(v.errorXOptions||[]).concat(v.errorYOptions||[]);v.error2d.update(k)}v.scatter2d&&v.scatter2d.update(v.markerOptions),v.fillOrder=s.repeat(null,b),v.fill2d&&(v.fillOptions=v.fillOptions.map((function(t,e){var n=r[e];if(t&&n&&n[0]&&n[0].trace){var i,a,o=n[0],s=o.trace,l=o.t,c=v.lineOptions[e],u=[];s._ownfill&&u.push(e),s._nexttrace&&u.push(e+1),u.length&&(v.fillOrder[e]=u);var f,h,p=[],d=c&&c.positions||l.positions;if("tozeroy"===s.fill){for(f=0;f<d.length&&isNaN(d[f+1]);)f+=2;for(h=d.length-2;h>f&&isNaN(d[h+1]);)h-=2;0!==d[f+1]&&(p=[d[f],0]),p=p.concat(d.slice(f,h+2)),0!==d[h+1]&&(p=p.concat([d[h],0]))}else if("tozerox"===s.fill){for(f=0;f<d.length&&isNaN(d[f]);)f+=2;for(h=d.length-2;h>f&&isNaN(d[h]);)h-=2;0!==d[f]&&(p=[0,d[f+1]]),p=p.concat(d.slice(f,h+2)),0!==d[h]&&(p=p.concat([0,d[h+1]]))}else if("toself"===s.fill||"tonext"===s.fill){for(p=[],i=0,t.splitNull=!0,a=0;a<d.length;a+=2)(isNaN(d[a])||isNaN(d[a+1]))&&((p=p.concat(d.slice(i,a))).push(d[i],d[i+1]),p.push(null,null),i=a+2);p=p.concat(d.slice(i)),i&&p.push(d[i],d[i+1])}else{var m=s._nexttrace;if(m){var g=v.lineOptions[e+1];if(g){var y=g.positions;if("tonexty"===s.fill){for(p=d.slice(),e=Math.floor(y.length/2);e--;){var x=y[2*e],b=y[2*e+1];isNaN(x)||isNaN(b)||p.push(x,b)}t.fill=m.fillcolor}}}}if(s._prevtrace&&"tonext"===s._prevtrace.fill){var _=v.lineOptions[e-1].positions,w=p.length/2,T=[i=w];for(a=0;a<_.length;a+=2)(isNaN(_[a])||isNaN(_[a+1]))&&(T.push(a/2+w+1),i=a+2);p=p.concat(_),t.hole=T}return t.fillmode=s.fill,t.opacity=s.opacity,t.positions=p,t}})),v.fill2d.update(v.fillOptions))}var M=g.dragmode,A=l(M),S=g.clickmode.indexOf('select')>-1;for(d=0;d<b;d++){var E=r[d][0],L=E.trace,C=E.t,P=C.index,I=L._length,z=C.x,O=C.y;if(L.selectedpoints||A||S){if(A||(A=!0),L.selectedpoints){var D=v.selectBatch[P]=s.selIndices2selPoints(L),R={};for(m=0;m<D.length;m++)R[D[m]]=1;var F=[];for(m=0;m<I;m++)R[m]||F.push(m);v.unselectBatch[P]=F}var B=C.xpx=new Array(I),N=C.ypx=new Array(I);for(m=0;m<I;m++)B[m]=y.c2p(z[m]),N[m]=x.c2p(O[m])}else C.xpx=C.ypx=null}if(A){if(v.select2d||(v.select2d=n(g._glcanvas.data()[1].regl)),v.scatter2d){var j=new Array(b);for(d=0;d<b;d++)j[d]=v.selectBatch[d].length||v.unselectBatch[d].length?v.markerUnselectedOptions[d]:{};v.scatter2d.update(j)}v.select2d&&(v.select2d.update(v.markerOptions),v.select2d.update(v.markerSelectedOptions)),v.glText&&r.forEach((function(t)[var e=((t||[])[0]||{]).trace||{};u.hasText(e)&&h(t)}))}else v.scatter2d&&v.scatter2d.update(v.markerOptions);var U={viewport:p(g,y,x,t._context.plotGlPixelRatio),range:[(y._rl||y.range)[0],(x._rl||x.range)[0],(y._rl||y.range)[1],(x._rl||x.range)[1]]},V=s.repeat(U,v.count);v.fill2d&&v.fill2d.update(V),v.line2d&&v.line2d.update(V),v.error2d&&v.error2d.update(V.concat(V)),v.scatter2d&&v.scatter2d.update(V),v.select2d&&v.select2d.update(V),v.glText&&v.glText.forEach((function(t)[t.update(U)]))}else v.init()}}},{"../../components/dragelement/helpers":668,"../../lib":787,"../../lib/prepare_regl":800,"../scatter/link_traces":1218,"../scatter/subtypes":1227,"./edit_style":1259,"gl-text":347,"regl-error2d":522,"regl-line2d":523,"regl-scatter2d":524}],1265:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){var r=e._scene,i={count:0,dirty:!0,lineOptions:[],fillOptions:[],markerOptions:[],markerSelectedOptions:[],markerUnselectedOptions:[],errorXOptions:[],errorYOptions:[],textOptions:[],textSelectedOptions:[],textUnselectedOptions:[],selectBatch:[],unselectBatch:[]},a={fill2d:!1,scatter2d:!1,error2d:!1,line2d:!1,glText:!1,select2d:!1};return e._scene||((r=e._scene={}).init=function(){n.extendFlat(r,a,i)},r.init(),r.update=function(t){var e=n.repeat(t,r.count);if(r.fill2d&&r.fill2d.update(e),r.scatter2d&&r.scatter2d.update(e),r.line2d&&r.line2d.update(e),r.error2d&&r.error2d.update(e.concat(e)),r.select2d&&r.select2d.update(e),r.glText)for(var i=0;i<r.count;i++)r.glText[i].update(t)},r.draw=function(){for(var t=r.count,e=r.fill2d,i=r.error2d,a=r.line2d,o=r.scatter2d,s=r.glText,l=r.select2d,c=r.selectBatch,u=r.unselectBatch,f=0;f<t;f++){if(e&&r.fillOrder[f]&&e.draw(r.fillOrder[f]),a&&r.lineOptions[f]&&a.draw(f),i&&(r.errorXOptions[f]&&i.draw(f),r.errorYOptions[f]&&i.draw(f+t)),o&&r.markerOptions[f])if(u[f].length){var h=n.repeat([],r.count);h[f]=u[f],o.draw(h)}else c[f].length||o.draw(f);s[f]&&r.textOptions[f]&&s[f].render()}l&&l.draw(c),r.dirty=!1},r.destroy=function(){r.fill2d&&r.fill2d.destroy&&r.fill2d.destroy(),r.scatter2d&&r.scatter2d.destroy&&r.scatter2d.destroy(),r.error2d&&r.error2d.destroy&&r.error2d.destroy(),r.line2d&&r.line2d.destroy&&r.line2d.destroy(),r.select2d&&r.select2d.destroy&&r.select2d.destroy(),r.glText&&r.glText.forEach((function(t){t.destroy&&t.destroy()})),r.lineOptions=null,r.fillOptions=null,r.markerOptions=null,r.markerSelectedOptions=null,r.markerUnselectedOptions=null,r.errorXOptions=null,r.errorYOptions=null,r.textOptions=null,r.textSelectedOptions=null,r.textUnselectedOptions=null,r.selectBatch=null,r.unselectBatch=null,e._scene=null}),r.dirty||n.extendFlat(r,i),r}},{"../../lib":787}],1266:[function(t,e,r){"use strict";var n=t('../scatter/subtypes'),i=t('./edit_style').styleTextSelection;e.exports=function(t,e){var r=t.cd,a=t.xaxis,o=t.yaxis,s=[],l=r[0].trace,c=r[0].t,u=l._length,f=c.x,h=c.y,p=c._scene,d=c.index;if(!p)return s;var m=n.hasText(l),g=n.hasMarkers(l),v=!g&&!m;if(!0!==l.visible||v)return s;var y=[],x=[];if(!1!==e&&!e.degenerate)for(var b=0;b<u;b++)e.contains([c.xpx[b],c.ypx[b]],!1,b,t)?(y.push(b),s.push({pointNumber:b,x:a.c2d(f[b]),y:o.c2d(h[b])})):x.push(b);if(g){var _=p.scatter2d;if(y.length||x.length){if(!p.selectBatch[d].length&&!p.unselectBatch[d].length){var w=new Array(p.count);w[d]=p.markerUnselectedOptions[d],_.update.apply(_,w)}}else{var T=new Array(p.count);T[d]=p.markerOptions[d],_.update.apply(_,T)}}return p.selectBatch[d]=y,p.unselectBatch[d]=x,m&&i(r),s}},{"../scatter/subtypes":1227,"./edit_style":1259}],1267:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../scattergeo/attributes'),o=t('../scatter/attributes'),s=t('../../plots/mapbox/layout_attributes'),l=t('../../plots/attributes'),c=t('../../components/colorscale/attributes'),u=t('../../lib/extend').extendFlat,f=t('../../plot_api/edit_types').overrideAll,h=a.line,p=a.marker;e.exports=f({lon:a.lon,lat:a.lat,mode:u({},o.mode,{dflt:"markers"}),text:u({},o.text,{}),texttemplate:i({editType:"plot"},{keys:["lat",'lon',"text"]}),hovertext:u({},o.hovertext,{}),line:{color:h.color,width:h.width},connectgaps:o.connectgaps,marker:u({symbol:{valType:"string",dflt:"circle",arrayOk:!0},angle:{valType:"number",dflt:"auto",arrayOk:!0},allowoverlap:{valType:"boolean",dflt:!1},opacity:p.opacity,size:p.size,sizeref:p.sizeref,sizemin:p.sizemin,sizemode:p.sizemode},c('marker')),fill:a.fill,fillcolor:o.fillcolor,textfont:s.layers.symbol.textfont,textposition:s.layers.symbol.textposition,below:{valType:"string"},selected:{marker:o.selected.marker},unselected:{marker:o.unselected.marker},hoverinfo:u({},l.hoverinfo,{flags:["lon",'lat','text',"name"]}),hovertemplate:n()},'calc','nested')},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../../plots/mapbox/layout_attributes":897,"../../plots/template_attributes":910,"../scatter/attributes":1202,"../scattergeo/attributes":1244}],1268:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../lib'),a=t('../../constants/numerical').BADNUM,o=t('../../lib/geojson_utils'),s=t('../../components/colorscale'),l=t('../../components/drawing'),c=t('../scatter/make_bubble_size_func'),u=t('../scatter/subtypes'),f=t('../../plots/mapbox/convert_text_opts'),h=t('../../components/fx/helpers').appendArrayPointValue,p=t('../../lib/svg_text_utils').NEWLINES,d=t('../../lib/svg_text_utils').BR_TAG_ALL;function m(){return{geojson:o.makeBlank(),layout:{visibility:"none"},paint:{}}}function g(t){var e,r,a,o,u=t[0].trace,f=u.marker,h=u.selectedpoints,p=i.isArrayOrTypedArray(f.color),d=i.isArrayOrTypedArray(f.size),m=i.isArrayOrTypedArray(f.opacity);function g(t){return u.opacity*t}function v(t){return t/2}p&&(r=s.hasColorscale(u,'marker')?s.makeColorScaleFuncFromTrace(f):i.identity),d&&(a=c(u)),m&&(o=function(t){return g(n(t)?+i.constrain(t,0,1):0)});var y,x=[];for(e=0;e<t.length;e++){var _=t[e],w=_.lonlat;if(!b(w)){var T={};r&&(T.mcc=_.mcc=r(_.mc)),a&&(T.mrc=_.mrc=a(_.ms)),o&&(T.mo=o(_.mo)),h&&(T.selected=_.selected||0),x.push({type:"Feature",geometry:{type:"Point",coordinates:w},properties:T})}}if(h)for(y=l.makeSelectedPointStyleFns(u),e=0;e<x.length;e++){var k=x[e].properties;y.selectedOpacityFn&&(k.mo=g(y.selectedOpacityFn(k))),y.selectedColorFn&&(k.mcc=y.selectedColorFn(k)),y.selectedSizeFn&&(k.mrc=y.selectedSizeFn(k))}return{geojson:{type:"FeatureCollection",features:x},mcc:p||y&&y.selectedColorFn?{type:"identity",property:"mcc"}:f.color,mrc:d||y&&y.selectedSizeFn?{type:"identity",property:"mrc"}:v(f.size),mo:m||y&&y.selectedOpacityFn?{type:"identity",property:"mo"}:g(f.opacity)}}function v(t,e){for(var r=e._fullLayout,n=t[0].trace,a=n.marker||{},o=a.symbol,s=a.angle,l="circle"!==o?y(o):x,c="auto"!==s?y(s,!0):x,f=u.hasText(n)?y(n.text):x,m=[],g=0;g<t.length;g++){var v=t[g];if(!b(v.lonlat)){var _,w=n.texttemplate;if(w){var T=Array.isArray(w)?w[g]||"":w,k=n._module.formatLabels(v,n,r),M={};h(M,n,v.i);var A=n._meta||{};_=i.texttemplateString(T,k,r._d3locale,M,v,A)}else _=f(g);_&&(_=_.replace(p,'').replace(d,'\n')),m.push({type:"Feature",geometry:{type:"Point",coordinates:v.lonlat},properties:{symbol:l(g),angle:c(g),text:_}})}}return{type:"FeatureCollection",features:m}}function y(t,e){return i.isArrayOrTypedArray(t)?e?function(e){return n(t[e])?+t[e]:0}:function(e){return t[e]}:t?function(){return t}:x}function x(){return""}function b(t){return t[0]===a}e.exports=function(t,e){var r,n=e[0].trace,a=!0===n.visible&&0!==n._length,s="none"!==n.fill,l=u.hasLines(n),c=u.hasMarkers(n),h=u.hasText(n),p=c&&"circle"===n.marker.symbol,d=c&&"circle"!==n.marker.symbol,y=m(),x=m(),b=m(),_=m(),w={fill:y,line:x,circle:b,symbol:_};if(!a)return w;if((s||l)&&(r=o.calcTraceToLineCoords(e)),s&&(y.geojson=o.makePolygon(r),y.layout.visibility='visible',i.extendFlat(y.paint,{"fill-color":n.fillcolor})),l&&(x.geojson=o.makeLine(r),x.layout.visibility='visible',i.extendFlat(x.paint,{"line-width":n.line.width,"line-color":n.line.color,"line-opacity":n.opacity})),p){var T=g(e);b.geojson=T.geojson,b.layout.visibility='visible',i.extendFlat(b.paint,{"circle-color":T.mcc,"circle-radius":T.mrc,"circle-opacity":T.mo})}if((d||h)&&(_.geojson=v(e,t),i.extendFlat(_.layout,{visibility:"visible","icon-image":"{symbol}-15","text-field":"[text]"}),d&&(i.extendFlat(_.layout,{"icon-size":n.marker.size/10}),"angle"in n.marker&&"auto"!==n.marker.angle&&i.extendFlat(_.layout,{"icon-rotate":{type:"identity",property:"angle"},"icon-rotation-alignment":"map"}),_.layout["icon-allow-overlap"]=n.marker.allowoverlap,i.extendFlat(_.paint,{"icon-opacity":n.opacity*n.marker.opacity,"icon-color":n.marker.color})),h))[var k=(n.marker||{]).size,M=f(n.textposition,k);i.extendFlat(_.layout,{"text-size":n.textfont.size,"text-anchor":M.anchor,"text-offset":M.offset}),i.extendFlat(_.paint,{"text-color":n.textfont.color,"text-opacity":n.opacity})}return w}},{"../../components/colorscale":662,"../../components/drawing":672,"../../components/fx/helpers":686,"../../constants/numerical":763,"../../lib":787,"../../lib/geojson_utils":781,"../../lib/svg_text_utils":813,"../../plots/mapbox/convert_text_opts":894,"../scatter/make_bubble_size_func":1219,"../scatter/subtypes":1227,"fast-isnumeric":246}],1269:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/subtypes'),a=t('../scatter/marker_defaults'),o=t('../scatter/line_defaults'),s=t('../scatter/text_defaults'),l=t('../scatter/fillcolor_defaults'),c=t('./attributes');function u(t,e,r){var n=r('lon')||[],i=r('lat')||[],a=Math.min(n.length,i.length);return e._length=a,a}e.exports=function(t,e,r,f){function h(r,i){return n.coerce(t,e,c,r,i)}if(u(t,e,h)){if(h('text'),h('texttemplate'),h('hovertext'),h('hovertemplate'),h('mode'),h('below'),i.hasLines(e)&&(o(t,e,r,f,h,{noDash:!0}),h('connectgaps')),i.hasMarkers(e)){a(t,e,r,f,h,{noLine:!0}),h('marker.allowoverlap'),h('marker.angle');var p=e.marker;"circle"!==p.symbol&&(n.isArrayOrTypedArray(p.size)&&(p.size=p.size[0]),n.isArrayOrTypedArray(p.color)&&(p.color=p.color[0]))}i.hasText(e)&&s(t,e,f,h,{noSelect:!0}),h('fill'),"none"!==e.fill&&l(t,e,r,h),n.coerceSelectionMarkerOpacity(e,h)}else e.visible=!1}},{"../../lib":787,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"./attributes":1267}],1270:[function(t,e,r){"use strict";e.exports=function(t,e){return t.lon=e.lon,t.lat=e.lat,t}},{}],1271:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes');e.exports=function(t,e,r){var i={},a=r[e.subplot]._subplot.mockAxis,o=t.lonlat;return i.lonLabel=n.tickText(a,a.c2l(o[0]),!0).text,i.latLabel=n.tickText(a,a.c2l(o[1]),!0).text,i}},{"../../plots/cartesian/axes":838}],1272:[function(t,e,r){"use strict";var n=t('../../components/fx'),i=t('../../lib'),a=t('../scatter/get_trace_color'),o=i.fillText,s=t('../../constants/numerical').BADNUM;function l(t,e,r){var o=t.cd,l=o[0].trace,u=t.xa,f=t.ya,h=t.subplot,p=360*(e>=0?Math.floor((e+180)/360):Math.ceil((e-180)/360)),d=e-p;function m(t){var e=t.lonlat;if(e[0]===s)return 1/0;var n=i.modHalf(e[0],360),a=e[1],o=h.project([n,a]),l=o.x-u.c2p([d,a]),c=o.y-f.c2p([n,r]),p=Math.max(3,t.mrc||0);return Math.max(Math.sqrt(l*l+c*c)-p,1-3/p)}if(n.getClosest(o,m,t),!1!==t.index){var g=o[t.index],v=g.lonlat,y=[i.modHalf(v[0],360)+p,v[1]],x=u.c2p(y),b=f.c2p(y),_=g.mrc||1;t.x0=x-_,t.x1=x+_,t.y0=b-_,t.y1=b+_;var w={};w[l.subplot]={_subplot:h};var T=l._module.formatLabels(g,l,w);return t.lonLabel=T.lonLabel,t.latLabel=T.latLabel,t.color=a(l,g),t.extraText=c(l,g,o[0].t.labels),t.hovertemplate=l.hovertemplate,[t]}}function c(t,e,r){if(!t.hovertemplate){var n=(e.hi||t.hoverinfo).split('+'),i=-1!==n.indexOf('all'),a=-1!==n.indexOf('lon'),s=-1!==n.indexOf('lat'),l=e.lonlat,c=[];return i||a&&s?c.push('('+u(l[1])+', '+u(l[0])+')'):a?c.push(r.lon+u(l[0])):s&&c.push(r.lat+u(l[1])),(i||-1!==n.indexOf('text'))&&o(e,t,c),c.join('<br>')}function u(t){return t+"\xb0"}}e.exports={hoverPoints:l,getExtraText:c}},{"../../components/fx":690,"../../constants/numerical":763,"../../lib":787,"../scatter/get_trace_color":1212}],1273:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('../scattergeo/calc'),plot:t('./plot'),hoverPoints:t('./hover').hoverPoints,eventData:t('./event_data'),selectPoints:t('./select'),styleOnSelect:function(t,e){e&&e[0].trace._glTrace.update(e)},moduleType:"trace",name:"scattermapbox",basePlotModule:t('../../plots/mapbox'),categories:["mapbox",'gl','symbols','showLegend',"scatter-like"],meta:{}}},{"../../plots/mapbox":895,"../scatter/marker_colorbar":1220,"../scattergeo/calc":1245,"./attributes":1267,"./defaults":1269,"./event_data":1270,"./format_labels":1271,"./hover":1272,"./plot":1274,"./select":1275}],1274:[function(t,e,r){"use strict";var n=t('./convert'),i=t('../../plots/mapbox/constants').traceLayerPrefix,a=["fill",'line','circle',"symbol"];function o(t,e){this.type='scattermapbox',this.subplot=t,this.uid=e,this.sourceIds={fill:"source-"+e+"-fill",line:"source-"+e+"-line",circle:"source-"+e+"-circle",symbol:"source-"+e+"-symbol"},this.layerIds={fill:i+e+"-fill",line:i+e+"-line",circle:i+e+"-circle",symbol:i+e+"-symbol"},this.below=null}var s=o.prototype;s.addSource=function(t,e){this.subplot.map.addSource(this.sourceIds[t],{type:"geojson",data:e.geojson})},s.setSourceData=function(t,e)[this.subplot.map.getSource(this.sourceIds[t]).setData(e.geojson)],s.addLayer=function(t,e,r){this.subplot.addLayer({type:t,id:this.layerIds[t],source:this.sourceIds[t],layout:e.layout,paint:e.paint},r)},s.update=function(t){var e,r,i,o=this.subplot,s=o.map,l=n(o.gd,t),c=o.belowLookup["trace-"+this.uid];if(c!==this.below){for(e=a.length-1;e>=0;e--)r=a[e],s.removeLayer(this.layerIds[r]);for(e=0;e<a.length;e++)i=l[r=a[e]],this.addLayer(r,i,c);this.below=c}for(e=0;e<a.length;e++)i=l[r=a[e]],o.setOptions(this.layerIds[r],'setLayoutProperty',i.layout),"visible"===i.layout.visibility&&(this.setSourceData(r,i),o.setOptions(this.layerIds[r],'setPaintProperty',i.paint));t[0].trace._glTrace=this},s.dispose=function(){for(var t=this.subplot.map,e=a.length-1;e>=0;e--){var r=a[e];t.removeLayer(this.layerIds[r]),t.removeSource(this.sourceIds[r])}},e.exports=function(t,e){for(var r=e[0].trace,i=new o(t,r.uid),s=n(t.gd,e),l=i.below=t.belowLookup["trace-"+r.uid],c=0;c<a.length;c++){var u=a[c],f=s[u];i.addSource(u,f),i.addLayer(u,f,l)}return e[0].trace._glTrace=i,i}},{"../../plots/mapbox/constants":893,"./convert":1268}],1275:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/subtypes'),a=t('../../constants/numerical').BADNUM;e.exports=function(t,e){var r,o=t.cd,s=t.xaxis,l=t.yaxis,c=[],u=o[0].trace;if(!i.hasMarkers(u))return[];if(!1===e)for(r=0;r<o.length;r++)o[r].selected=0;else for(r=0;r<o.length;r++){var f=o[r],h=f.lonlat;if(h[0]!==a){var p=[n.modHalf(h[0],360),h[1]],d=[s.c2p(p),l.c2p(p)];e.contains(d,null,r,t)?(c.push({pointNumber:r,lon:h[0],lat:h[1]}),f.selected=1):f.selected=0}}return c}},{"../../constants/numerical":763,"../../lib":787,"../scatter/subtypes":1227}],1276:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../../lib/extend').extendFlat,o=t('../scatter/attributes'),s=t('../../plots/attributes'),l=o.line;e.exports={mode:o.mode,r:{valType:"data_array",editType:"calc+clearAxisTypes"},theta:{valType:"data_array",editType:"calc+clearAxisTypes"},r0:{valType:"any",dflt:0,editType:"calc+clearAxisTypes"},dr:{valType:"number",dflt:1,editType:"calc"},theta0:{valType:"any",dflt:0,editType:"calc+clearAxisTypes"},dtheta:{valType:"number",editType:"calc"},thetaunit:{valType:"enumerated",values:["radians",'degrees',"gradians"],dflt:"degrees",editType:"calc+clearAxisTypes"},text:o.text,texttemplate:i({editType:"plot"},{keys:["r",'theta',"text"]}),hovertext:o.hovertext,line:{color:l.color,width:l.width,dash:l.dash,shape:a({},l.shape,{values:["linear","spline"]}),smoothing:l.smoothing,editType:"calc"},connectgaps:o.connectgaps,marker:o.marker,cliponaxis:a({},o.cliponaxis,{dflt:!1}),textposition:o.textposition,textfont:o.textfont,fill:a({},o.fill,{values:["none",'toself',"tonext"],dflt:"none"}),fillcolor:o.fillcolor,hoverinfo:a({},s.hoverinfo,{flags:["r",'theta','text',"name"]}),hoveron:o.hoveron,hovertemplate:n(),selected:o.selected,unselected:o.unselected}},{"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"../scatter/attributes":1202}],1277:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../../constants/numerical').BADNUM,a=t('../../plots/cartesian/axes'),o=t('../scatter/colorscale_calc'),s=t('../scatter/arrays_to_calcdata'),l=t('../scatter/calc_selection'),c=t('../scatter/calc').calcMarkerSize;e.exports=function(t,e){for(var r=t._fullLayout,u=e.subplot,f=r[u].radialaxis,h=r[u].angularaxis,p=f.makeCalcdata(e,'r'),d=h.makeCalcdata(e,'theta'),m=e._length,g=new Array(m),v=0;v<m;v++){var y=p[v],x=d[v],b=g[v]={};n(y)&&n(x)?(b.r=y,b.theta=x):b.r=i}var _=c(e,m);return e._extremes.x=a.findExtremes(f,p,{ppad:_}),o(t,e),s(g,e),l(g,e),g}},{"../../constants/numerical":763,"../../plots/cartesian/axes":838,"../scatter/arrays_to_calcdata":1201,"../scatter/calc":1203,"../scatter/calc_selection":1204,"../scatter/colorscale_calc":1205,"fast-isnumeric":246}],1278:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/subtypes'),a=t('../scatter/marker_defaults'),o=t('../scatter/line_defaults'),s=t('../scatter/line_shape_defaults'),l=t('../scatter/text_defaults'),c=t('../scatter/fillcolor_defaults'),u=t('../scatter/constants').PTS_LINESONLY,f=t('./attributes');function h(t,e,r,h){function d(r,i){return n.coerce(t,e,f,r,i)}var m=p(t,e,h,d);if(m){d('thetaunit'),d('mode',m<u?"lines+markers":"lines"),d('text'),d('hovertext'),"fills"!==e.hoveron&&d('hovertemplate'),i.hasLines(e)&&(o(t,e,r,h,d),s(t,e,d),d('connectgaps')),i.hasMarkers(e)&&a(t,e,r,h,d,{gradient:!0}),i.hasText(e)&&(d('texttemplate'),l(t,e,h,d));var g=[];(i.hasMarkers(e)||i.hasText(e))&&(d('cliponaxis'),d('marker.maxdisplayed'),g.push('points')),d('fill'),"none"!==e.fill&&(c(t,e,r,d),i.hasLines(e)||s(t,e,d)),"tonext"!==e.fill&&"toself"!==e.fill||g.push('fills'),d('hoveron',g.join('+')||"points"),n.coerceSelectionMarkerOpacity(e,d)}else e.visible=!1}function p(t,e,r,n){var i,a=n('r'),o=n('theta');if(a)o?i=Math.min(a.length,o.length):(i=a.length,n('theta0'),n('dtheta'));else{if(!o)return 0;i=e.theta.length,n('r0'),n('dr')}return e._length=i,i}e.exports={handleRThetaDefaults:p,supplyDefaults:h}},{"../../lib":787,"../scatter/constants":1206,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/line_shape_defaults":1217,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"./attributes":1276}],1279:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes');e.exports=function(t,e,r){var a,o,s={},l=r[e.subplot]._subplot;l?(a=l.radialAxis,o=l.angularAxis):(a=(l=r[e.subplot]).radialaxis,o=l.angularaxis);var c=a.c2l(t.r);s.rLabel=i.tickText(a,c,!0).text;var u="degrees"===o.thetaunit?n.rad2deg(t.theta):t.theta;return s.thetaLabel=i.tickText(o,u,!0).text,s}},{"../../lib":787,"../../plots/cartesian/axes":838}],1280:[function(t,e,r){"use strict";var n=t('../scatter/hover');function i(t,e,r,i){var o=n(t,e,r,i);if(o&&!1!==o[0].index){var s=o[0];if(void 0===s.index)return o;var l=t.subplot,c=s.cd[s.index],u=s.trace;if(l.isPtInside(c))return s.xLabelVal=void 0,s.yLabelVal=void 0,a(c,u,l,s),s.hovertemplate=u.hovertemplate,o}}function a(t,e,r,n){var i=r.radialAxis,a=r.angularAxis;i._hovertitle='r',a._hovertitle='\u03b8';var o={};o[e.subplot]={_subplot:r};var s=e._module.formatLabels(t,e,o);n.rLabel=s.rLabel,n.thetaLabel=s.thetaLabel;var l=t.hi||e.hoverinfo,c=[];function u(t,e){c.push(t._hovertitle+": "+e)}if(!e.hovertemplate){var f=l.split('+');-1!==f.indexOf('all')&&(f=["r",'theta',"text"]),-1!==f.indexOf('r')&&u(i,n.rLabel),-1!==f.indexOf('theta')&&u(a,n.thetaLabel),-1!==f.indexOf('text')&&n.text&&(c.push(n.text),delete n.text),n.extraText=c.join('<br>')}}e.exports={hoverPoints:i,makeHoverPointText:a}},{"../scatter/hover":1213}],1281:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"scatterpolar",basePlotModule:t('../../plots/polar'),categories:["polar",'symbols','showLegend',"scatter-like"],attributes:t('./attributes'),supplyDefaults:t('./defaults').supplyDefaults,colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('./calc'),plot:t('./plot'),style:t('../scatter/style').style,styleOnSelect:t('../scatter/style').styleOnSelect,hoverPoints:t('./hover').hoverPoints,selectPoints:t('../scatter/select'),meta:{}}},{"../../plots/polar":904,"../scatter/marker_colorbar":1220,"../scatter/select":1224,"../scatter/style":1226,"./attributes":1276,"./calc":1277,"./defaults":1278,"./format_labels":1279,"./hover":1280,"./plot":1282}],1282:[function(t,e,r){"use strict";var n=t('../scatter/plot'),i=t('../../constants/numerical').BADNUM;e.exports=function(t,e,r){for(var a=e.layers.frontplot.select('g.scatterlayer'),o={xaxis:e.xaxis,yaxis:e.yaxis,plot:e.framework,layerClipId:e._hasClipOnAxisFalse?e.clipIds.forTraces:null},s=e.radialAxis,l=e.angularAxis,c=0;c<r.length;c++)for(var u=r[c],f=0;f<u.length;f++){var h=u[f],p=h.r;if(p===i)h.x=h.y=i;else{var d=s.c2g(p),m=l.c2g(h.theta);h.x=d*Math.cos(m),h.y=d*Math.sin(m)}}n(t,o,r,a)}},{"../../constants/numerical":763,"../scatter/plot":1223}],1283:[function(t,e,r){"use strict";var n=t('../scatterpolar/attributes'),i=t('../scattergl/attributes'),a=t('../../plots/template_attributes').texttemplateAttrs;e.exports={mode:n.mode,r:n.r,theta:n.theta,r0:n.r0,dr:n.dr,theta0:n.theta0,dtheta:n.dtheta,thetaunit:n.thetaunit,text:n.text,texttemplate:a({editType:"plot"},{keys:["r",'theta',"text"]}),hovertext:n.hovertext,hovertemplate:n.hovertemplate,line:i.line,connectgaps:i.connectgaps,marker:i.marker,fill:i.fill,fillcolor:i.fillcolor,textposition:i.textposition,textfont:i.textfont,hoverinfo:n.hoverinfo,selected:n.selected,unselected:n.unselected}},{"../../plots/template_attributes":910,"../scattergl/attributes":1254,"../scatterpolar/attributes":1276}],1284:[function(t,e,r){"use strict";var n=t('../scatter/colorscale_calc'),i=t('../scatter/calc').calcMarkerSize,a=t('../scattergl/convert'),o=t('../../plots/cartesian/axes'),s=t('../scattergl/constants').TOO_MANY_POINTS;e.exports=function(t,e){var r=t._fullLayout,l=e.subplot,c=r[l].radialaxis,u=r[l].angularaxis,f=e._r=c.makeCalcdata(e,'r'),h=e._theta=u.makeCalcdata(e,'theta'),p=e._length,d={};p<f.length&&(f=f.slice(0,p)),p<h.length&&(h=h.slice(0,p)),d.r=f,d.theta=h,n(t,e);var m,g=d.opts=a.style(t,e);return p<s?m=i(e,p):g.marker&&(m=2*(g.marker.sizeAvg||Math.max(g.marker.size,3))),e._extremes.x=o.findExtremes(c,f,{ppad:m}),[x:!1,y:!1,t:d,trace:e]}},{"../../plots/cartesian/axes":838,"../scatter/calc":1203,"../scatter/colorscale_calc":1205,"../scattergl/constants":1256,"../scattergl/convert":1257}],1285:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/subtypes'),a=t('../scatterpolar/defaults').handleRThetaDefaults,o=t('../scatter/marker_defaults'),s=t('../scatter/line_defaults'),l=t('../scatter/text_defaults'),c=t('../scatter/fillcolor_defaults'),u=t('../scatter/constants').PTS_LINESONLY,f=t('./attributes');e.exports=function(t,e,r,h){function p(r,i){return n.coerce(t,e,f,r,i)}var d=a(t,e,h,p);d?(p('thetaunit'),p('mode',d<u?"lines+markers":"lines"),p('text'),p('hovertext'),"fills"!==e.hoveron&&p('hovertemplate'),i.hasLines(e)&&(s(t,e,r,h,p),p('connectgaps')),i.hasMarkers(e)&&o(t,e,r,h,p),i.hasText(e)&&(p('texttemplate'),l(t,e,h,p)),p('fill'),"none"!==e.fill&&c(t,e,r,p),n.coerceSelectionMarkerOpacity(e,p)):e.visible=!1}},{"../../lib":787,"../scatter/constants":1206,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"../scatterpolar/defaults":1278,"./attributes":1283}],1286:[function(t,e,r){"use strict";var n=t('../scatterpolar/format_labels');e.exports=function(t,e,r){var i=t.i;return"r"in t||(t.r=e._r[i]),"theta"in t||(t.theta=e._theta[i]),n(t,e,r)}},{"../scatterpolar/format_labels":1279}],1287:[function(t,e,r){"use strict";var n=t('../scattergl/hover'),i=t('../scatterpolar/hover').makeHoverPointText;function a(t,e,r,a){var o=t.cd[0].t,s=o.r,l=o.theta,c=n.hoverPoints(t,e,r,a);if(c&&!1!==c[0].index){var u=c[0];if(void 0===u.index)return c;var f=t.subplot,h=u.cd[u.index],p=u.trace;if(h.r=s[u.index],h.theta=l[u.index],f.isPtInside(h))return u.xLabelVal=void 0,u.yLabelVal=void 0,i(h,p,f,u),c}}e.exports={hoverPoints:a}},{"../scattergl/hover":1262,"../scatterpolar/hover":1280}],1288:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"scatterpolargl",basePlotModule:t('../../plots/polar'),categories:["gl",'regl','polar','symbols','showLegend',"scatter-like"],attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('./calc'),plot:t('./plot'),hoverPoints:t('./hover').hoverPoints,selectPoints:t('../scattergl/select'),meta:{}}},{"../../plots/polar":904,"../scatter/marker_colorbar":1220,"../scattergl/select":1266,"./attributes":1283,"./calc":1284,"./defaults":1285,"./format_labels":1286,"./hover":1287,"./plot":1289}],1289:[function(t,e,r){"use strict";var n=t('@plotly/point-cluster'),i=t('fast-isnumeric'),a=t('../scattergl/plot'),o=t('../scattergl/scene_update'),s=t('../scattergl/convert'),l=t('../../lib'),c=t('../scattergl/constants').TOO_MANY_POINTS;e.exports=function(t,e,r){if(r.length){var u=e.radialAxis,f=e.angularAxis,h=o(t,e);return r.forEach((function(r){if(r&&r[0]&&r[0].trace){var a,o=r[0],p=o.trace,d=o.t,m=p._length,g=d.r,v=d.theta,y=d.opts,x=g.slice(),b=v.slice();for(a=0;a<g.length;a++)e.isPtInside({r:g[a],theta:v[a]})||(x[a]=NaN,b[a]=NaN);var _=new Array(2*m),w=Array(m),T=Array(m);for(a=0;a<m;a++){var k,M,A=x[a];if(i(A)){var S=u.c2g(A),E=f.c2g(b[a],p.thetaunit);k=S*Math.cos(E),M=S*Math.sin(E)}else k=M=NaN;w[a]=_[2*a]=k,T[a]=_[2*a+1]=M}d.tree=n(_),y.marker&&m>=c&&(y.marker.cluster=d.tree),y.marker&&(y.markerSel.positions=y.markerUnsel.positions=y.marker.positions=_),y.line&&_.length>1&&l.extendFlat(y.line,s.linePositions(t,p,_)),y.text&&(l.extendFlat(y.text,{positions:_},s.textPosition(t,p,y.text,y.marker)),l.extendFlat(y.textSel,{positions:_},s.textPosition(t,p,y.text,y.markerSel)),l.extendFlat(y.textUnsel,{positions:_},s.textPosition(t,p,y.text,y.markerUnsel))),y.fill&&!h.fill2d&&(h.fill2d=!0),y.marker&&!h.scatter2d&&(h.scatter2d=!0),y.line&&!h.line2d&&(h.line2d=!0),y.text&&!h.glText&&(h.glText=!0),h.lineOptions.push(y.line),h.fillOptions.push(y.fill),h.markerOptions.push(y.marker),h.markerSelectedOptions.push(y.markerSel),h.markerUnselectedOptions.push(y.markerUnsel),h.textOptions.push(y.text),h.textSelectedOptions.push(y.textSel),h.textUnselectedOptions.push(y.textUnsel),h.selectBatch.push([]),h.unselectBatch.push([]),d.x=w,d.y=T,d.rawx=w,d.rawy=T,d.r=g,d.theta=v,d.positions=_,d._scene=h,d.index=h.count,h.count++}})),a(t,e,r)}}},{"../../lib":787,"../scattergl/constants":1256,"../scattergl/convert":1257,"../scattergl/plot":1264,"../scattergl/scene_update":1265,"@plotly/point-cluster":59,"fast-isnumeric":246}],1290:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../scatter/attributes'),o=t('../../plots/attributes'),s=t('../../components/colorscale/attributes'),l=t('../../components/drawing/attributes').dash,c=t('../../lib/extend').extendFlat,u=a.marker,f=a.line,h=u.line;e.exports={a:{valType:"data_array",editType:"calc"},b:{valType:"data_array",editType:"calc"},c:{valType:"data_array",editType:"calc"},sum:{valType:"number",dflt:0,min:0,editType:"calc"},mode:c({},a.mode,{dflt:"markers"}),text:c({},a.text,{}),texttemplate:i({editType:"plot"},{keys:["a",'b','c',"text"]}),hovertext:c({},a.hovertext,{}),line:{color:f.color,width:f.width,dash:l,shape:c({},f.shape,{values:["linear","spline"]}),smoothing:f.smoothing,editType:"calc"},connectgaps:a.connectgaps,cliponaxis:a.cliponaxis,fill:c({},a.fill,{values:["none",'toself',"tonext"],dflt:"none"}),fillcolor:a.fillcolor,marker:c({symbol:u.symbol,opacity:u.opacity,maxdisplayed:u.maxdisplayed,size:u.size,sizeref:u.sizeref,sizemin:u.sizemin,sizemode:u.sizemode,line:c({width:h.width,editType:"calc"},s('marker.line')),gradient:u.gradient,editType:"calc"},s('marker')),textfont:a.textfont,textposition:a.textposition,selected:a.selected,unselected:a.unselected,hoverinfo:c({},o.hoverinfo,{flags:["a",'b','c','text',"name"]}),hoveron:a.hoveron,hovertemplate:n()}},{"../../components/colorscale/attributes":657,"../../components/drawing/attributes":671,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/template_attributes":910,"../scatter/attributes":1202}],1291:[function(t,e,r){"use strict";var n=t('fast-isnumeric'),i=t('../scatter/colorscale_calc'),a=t('../scatter/arrays_to_calcdata'),o=t('../scatter/calc_selection'),s=t('../scatter/calc').calcMarkerSize,l=["a",'b',"c"],c={a:["b","c"],b:["a","c"],c:["a","b"]};e.exports=function(t,e){var r,u,f,h,p,d,m=t._fullLayout[e.subplot].sum,g=e.sum||m,v={a:e.a,b:e.b,c:e.c};for(r=0;r<l.length;r++)if(!v[f=l[r]]){for(p=v[c[f][0]],d=v[c[f][1]],h=new Array(p.length),u=0;u<p.length;u++)h[u]=g-p[u]-d[u];v[f]=h}var y,x,b,_,w,T,k=e._length,M=new Array(k);for(r=0;r<k;r++)y=v.a[r],x=v.b[r],b=v.c[r],n(y)&&n(x)&&n(b)?(1!==(_=m/((y=+y)+(x=+x)+(b=+b)))&&(y*=_,x*=_,b*=_),T=y,w=b-x,M[r]={x:w,y:T,a:y,b:x,c:b}):M[r]={x:!1,y:!1};return s(e,k),i(t,e),a(M,e),o(M,e),M}},{"../scatter/arrays_to_calcdata":1201,"../scatter/calc":1203,"../scatter/calc_selection":1204,"../scatter/colorscale_calc":1205,"fast-isnumeric":246}],1292:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/constants'),a=t('../scatter/subtypes'),o=t('../scatter/marker_defaults'),s=t('../scatter/line_defaults'),l=t('../scatter/line_shape_defaults'),c=t('../scatter/text_defaults'),u=t('../scatter/fillcolor_defaults'),f=t('./attributes');e.exports=function(t,e,r,h){function p(r,i){return n.coerce(t,e,f,r,i)}var d,m=p('a'),g=p('b'),v=p('c');if(m?(d=m.length,g?(d=Math.min(d,g.length),v&&(d=Math.min(d,v.length))):d=v?Math.min(d,v.length):0):g&&v&&(d=Math.min(g.length,v.length)),d){e._length=d,p('sum'),p('text'),p('hovertext'),"fills"!==e.hoveron&&p('hovertemplate'),p('mode',d<i.PTS_LINESONLY?"lines+markers":"lines"),a.hasLines(e)&&(s(t,e,r,h,p),l(t,e,p),p('connectgaps')),a.hasMarkers(e)&&o(t,e,r,h,p,{gradient:!0}),a.hasText(e)&&(p('texttemplate'),c(t,e,h,p));var y=[];(a.hasMarkers(e)||a.hasText(e))&&(p('cliponaxis'),p('marker.maxdisplayed'),y.push('points')),p('fill'),"none"!==e.fill&&(u(t,e,r,p),a.hasLines(e)||l(t,e,p)),"tonext"!==e.fill&&"toself"!==e.fill||y.push('fills'),p('hoveron',y.join('+')||"points"),n.coerceSelectionMarkerOpacity(e,p)}else e.visible=!1}},{"../../lib":787,"../scatter/constants":1206,"../scatter/fillcolor_defaults":1210,"../scatter/line_defaults":1215,"../scatter/line_shape_defaults":1217,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scatter/text_defaults":1228,"./attributes":1290}],1293:[function(t,e,r){"use strict";e.exports=function(t,e,r,n,i){if(e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),n[i]){var a=n[i];t.a=a.a,t.b=a.b,t.c=a.c}else t.a=e.a,t.b=e.b,t.c=e.c;return t}},{}],1294:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes');e.exports=function(t,e,r){var i={},a=r[e.subplot]._subplot;return i.aLabel=n.tickText(a.aaxis,t.a,!0).text,i.bLabel=n.tickText(a.baxis,t.b,!0).text,i.cLabel=n.tickText(a.caxis,t.c,!0).text,i}},{"../../plots/cartesian/axes":838}],1295:[function(t,e,r){"use strict";var n=t('../scatter/hover');e.exports=function(t,e,r,i){var a=n(t,e,r,i);if(a&&!1!==a[0].index){var o=a[0];if(void 0===o.index){var s=1-o.y0/t.ya._length,l=t.xa._length,c=l*s/2,u=l-c;return o.x0=Math.max(Math.min(o.x0,u),c),o.x1=Math.max(Math.min(o.x1,u),c),a}var f=o.cd[o.index],h=o.trace,p=o.subplot;o.a=f.a,o.b=f.b,o.c=f.c,o.xLabelVal=void 0,o.yLabelVal=void 0;var d={};d[h.subplot]={_subplot:p};var m=h._module.formatLabels(f,h,d);o.aLabel=m.aLabel,o.bLabel=m.bLabel,o.cLabel=m.cLabel;var g=f.hi||h.hoverinfo,v=[];if(!h.hovertemplate){var y=g.split('+');-1!==y.indexOf('all')&&(y=["a",'b',"c"]),-1!==y.indexOf('a')&&x(p.aaxis,o.aLabel),-1!==y.indexOf('b')&&x(p.baxis,o.bLabel),-1!==y.indexOf('c')&&x(p.caxis,o.cLabel)}return o.extraText=v.join('<br>'),o.hovertemplate=h.hovertemplate,a}function x(t,e){v.push(t._hovertitle+": '+e)}}},{'../scatter/hover":1213}],1296:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../scatter/marker_colorbar'),formatLabels:t('./format_labels'),calc:t('./calc'),plot:t('./plot'),style:t('../scatter/style').style,styleOnSelect:t('../scatter/style').styleOnSelect,hoverPoints:t('./hover'),selectPoints:t('../scatter/select'),eventData:t('./event_data'),moduleType:"trace",name:"scatterternary",basePlotModule:t('../../plots/ternary'),categories:["ternary",'symbols','showLegend',"scatter-like"],meta:{}}},{"../../plots/ternary":911,"../scatter/marker_colorbar":1220,"../scatter/select":1224,"../scatter/style":1226,"./attributes":1290,"./calc":1291,"./defaults":1292,"./event_data":1293,"./format_labels":1294,"./hover":1295,"./plot":1297}],1297:[function(t,e,r){"use strict";var n=t('../scatter/plot');e.exports=function(t,e,r){var i=e.plotContainer;i.select('.scatterlayer').selectAll('*').remove();var a={xaxis:e.xaxis,yaxis:e.yaxis,plot:i,layerClipId:e._hasClipOnAxisFalse?e.clipIdRelative:null},o=e.layers.frontplot.select('g.scatterlayer');n(t,a,r,o)}},{"../scatter/plot":1223}],1298:[function(t,e,r){"use strict";var n=t('../scatter/attributes'),i=t('../../components/colorscale/attributes'),a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,o=t('../../plots/template_attributes').hovertemplateAttrs,s=t('../scattergl/attributes'),l=t('../../plots/cartesian/constants').idRegex,c=t('../../plot_api/plot_template').templatedArray,u=t('../../lib/extend').extendFlat,f=n.marker,h=f.line,p=u(i('marker.line',{editTypeOverride:"calc"}),{width:u({},h.width,{editType:"calc"}),editType:"calc"}),d=u(i('marker'),{symbol:f.symbol,size:u({},f.size,{editType:"markerSize"}),sizeref:f.sizeref,sizemin:f.sizemin,sizemode:f.sizemode,opacity:f.opacity,colorbar:f.colorbar,line:p,editType:"calc"});function m(t){return{valType:"info_array",freeLength:!0,editType:"calc",items:{valType:"subplotid",regex:l[t],editType:"plot"}}}d.color.editType=d.cmin.editType=d.cmax.editType='style',e.exports={dimensions:c('dimension',{visible:{valType:"boolean",dflt:!0,editType:"calc"},label:{valType:"string",editType:"calc"},values:{valType:"data_array",editType:"calc+clearAxisTypes"},axis:{type:{valType:"enumerated",values:["linear",'log','date',"category"],editType:"calc+clearAxisTypes"},matches:{valType:"boolean",dflt:!1,editType:"calc"},editType:"calc+clearAxisTypes"},editType:"calc+clearAxisTypes"}),text:u({},s.text,{}),hovertext:u({},s.hovertext,{}),hovertemplate:o(),xhoverformat:a('x'),yhoverformat:a('y'),marker:d,xaxes:m('x'),yaxes:m('y'),diagonal:{visible:{valType:"boolean",dflt:!0,editType:"calc"},editType:"calc"},showupperhalf:{valType:"boolean",dflt:!0,editType:"calc"},showlowerhalf:{valType:"boolean",dflt:!0,editType:"calc"},selected:{marker:s.selected.marker,editType:"calc"},unselected:{marker:s.unselected.marker,editType:"calc"},opacity:s.opacity}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/plot_template":827,"../../plots/cartesian/axis_format_attributes":841,"../../plots/cartesian/constants":845,"../../plots/template_attributes":910,"../scatter/attributes":1202,"../scattergl/attributes":1254}],1299:[function(t,e,r){"use strict";var n=t('regl-line2d'),i=t('../../registry'),a=t('../../lib/prepare_regl'),o=t('../../plots/get_data').getModuleCalcData,s=t('../../plots/cartesian'),l=t('../../plots/cartesian/axis_ids').getFromId,c=t('../../plots/cartesian/axes').shouldShowZeroLine,u='splom';function f(t){var e=t._fullLayout,r=i.getModule(u),n=o(t.calcdata,r)[0];a(t,["ANGLE_instanced_arrays","OES_element_index_uint"])&&(e._hasOnlyLargeSploms&&d(t),r.plot(t,{},n))}function h(t){var e=t.calcdata,r=t._fullLayout;r._hasOnlyLargeSploms&&d(t);for(var n=0;n<e.length;n++){var i=e[n][0].trace,a=r._splomScenes[i.uid];"splom"===i.type&&a&&a.matrix&&p(t,i,a)}}function p(t,e,r){for(var n=r.matrixOptions.data.length,i=e._visibleDims,a=r.viewOpts.ranges=new Array(n),o=0;o<i.length;o++){var s=i[o],c=a[o]=new Array(4),u=l(t,e._diag[s][0]);u&&(c[0]=u.r2l(u.range[0]),c[2]=u.r2l(u.range[1]));var f=l(t,e._diag[s][1]);f&&(c[1]=f.r2l(f.range[0]),c[3]=f.r2l(f.range[1]))}r.selectBatch.length||r.unselectBatch.length?r.matrix.update({ranges:a},{ranges:a}):r.matrix.update({ranges:a})}function d(t){var e=t._fullLayout,r=e._glcanvas.data()[0].regl,i=e._splomGrid;i||(i=e._splomGrid=n(r)),i.update(m(t))}function m(t){var e,r=t._context.plotGlPixelRatio,n=t._fullLayout,i=n._size,a=[0,0,n.width*r,n.height*r],o={};function s(t,e,n,i,s,l){n*=r,i*=r,s*=r,l*=r;var c=e[t+"color"],u=e[t+"width"],f=String(c+u);f in o?o[f].data.push(NaN,NaN,n,i,s,l):o[f]={data:[n,i,s,l],join:"rect",thickness:u*r,color:c,viewport:a,range:a,overlay:!1}}for(e in n._splomSubplots){var l,u,f=n._plots[e],h=f.xaxis,p=f.yaxis,d=h._gridVals,m=p._gridVals,g=h._offset,v=h._length,y=p._length,x=i.b+p.domain[0]*i.h,b=-p._m,_=-b*p.r2l(p.range[0],p.calendar);if(h.showgrid)for(e=0;e<d.length;e++)l=g+h.l2p(d[e].x),s('grid',h,l,x,l,x+y);if(p.showgrid)for(e=0;e<m.length;e++)s('grid',p,g,u=x+_+b*m[e].x,g+v,u);c(t,h,p)&&(l=g+h.l2p(0),s('zeroline',h,l,x,l,x+y)),c(t,p,h)&&s('zeroline',p,g,u=x+_+0,g+v,u)}var w=[];for(e in o)w.push(o[e]);return w}function g(t,e,r,n){var i,a={};if(n._splomScenes){for(i=0;i<t.length;i++){var o=t[i];"splom"===o.type&&(a[o.uid]=1)}for(i=0;i<r.length;i++){var l=r[i];if(!a[l.uid]){var c=n._splomScenes[l.uid];c&&c.destroy&&c.destroy(),n._splomScenes[l.uid]=null,delete n._splomScenes[l.uid]}}}0===Object.keys(n._splomScenes||{}).length&&delete n._splomScenes,n._splomGrid&&!e._hasOnlyLargeSploms&&n._hasOnlyLargeSploms&&(n._splomGrid.destroy(),n._splomGrid=null,delete n._splomGrid),s.clean(t,e,r,n)}e.exports={name:u,attr:s.attr,attrRegex:s.attrRegex,layoutAttributes:s.layoutAttributes,supplyLayoutDefaults:s.supplyLayoutDefaults,drawFramework:s.drawFramework,plot:f,drag:h,updateGrid:d,clean:g,updateFx:s.updateFx,toSVG:s.toSVG}},{"../../lib/prepare_regl":800,"../../plots/cartesian":852,"../../plots/cartesian/axes":838,"../../plots/cartesian/axis_ids":842,"../../plots/get_data":875,"../../registry":915,"regl-line2d":523}],1300:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axis_ids'),a=t('../scatter/calc').calcMarkerSize,o=t('../scatter/calc').calcAxisExpansion,s=t('../scatter/colorscale_calc'),l=t('../scattergl/convert').markerSelection,c=t('../scattergl/convert').markerStyle,u=t('./scene_update'),f=t('../../constants/numerical').BADNUM,h=t('../scattergl/constants').TOO_MANY_POINTS;e.exports=function(t,e){var r,p,d,m,g,v,y=e.dimensions,x=e._length,b={},_=b.cdata=[],w=b.data=[],T=e._visibleDims=[];function k(t,r){for(var i=t.makeCalcdata({v:r.values,vcalendar:e.calendar},'v'),a=0;a<i.length;a++)i[a]=i[a]===f?NaN:i[a];_.push(i),w.push("log"===t.type?n.simpleMap(i,t.c2l):i)}for(r=0;r<y.length;r++)if((d=y[r]).visible){if(m=i.getFromId(t,e._diag[r][0]),g=i.getFromId(t,e._diag[r][1]),m&&g&&m.type!==g.type){n.log('Skipping splom dimension '+r+' with conflicting axis types');continue}m?(k(m,d),g&&"category"===g.type&&(g._categories=m._categories.slice())):k(g,d),T.push(r)}for(s(t,e),n.extendFlat(b,c(e)),v=_.length*x>h?b.sizeAvg||Math.max(b.size,3):a(e,x),p=0;p<T.length;p++)d=y[r=T[p]],m=i.getFromId(t,e._diag[r][0])||{},g=i.getFromId(t,e._diag[r][1])||{},o(t,e,m,g,_[p],_[p],v);var M=u(t,e);return M.matrix||(M.matrix=!0),M.matrixOptions=b,M.selectedOptions=l(e,e.selected),M.unselectedOptions=l(e,e.unselected),[x:!1,y:!1,t:{},trace:e}]},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/axis_ids":842,"../scatter/calc":1203,"../scatter/colorscale_calc":1205,"../scattergl/constants":1256,"../scattergl/convert":1257,"./scene_update":1307}],1301:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/array_container_defaults'),a=t('./attributes'),o=t('../scatter/subtypes'),s=t('../scatter/marker_defaults'),l=t('../parcoords/merge_length'),c=t('../scattergl/helpers').isOpenSymbol;function u(t,e){function r(r,i){return n.coerce(t,e,a.dimensions,r,i)}r('label');var i=r('values');i&&i.length?r('visible'):e.visible=!1,r('axis.type'),r('axis.matches')}function f(t,e,r,n){var i,a,o=e.dimensions,s=o.length,l=e.showupperhalf,c=e.showlowerhalf,u=e.diagonal.visible,f=new Array(s),h=new Array(s);for(i=0;i<s;i++){var p=i?i+1:"";f[i]="x"+p,h[i]="y"+p}var d=n('xaxes',f),m=n('yaxes',h),g=e._diag=new Array(s);e._xaxes={},e._yaxes={};var v=[],y=[];function x(t,n,i,a){if(t){var o=t.charAt(0),s=r._splomAxes[o];if(e["_"+o+"axes"][t]=1,a.push(t),!(t in s)){var l=s[t]={};i&&(l.label=i.label||"",i.visible&&i.axis&&(i.axis.type&&(l.type=i.axis.type),i.axis.matches&&(l.matches=n)))}}}var b=!u&&!c,_=!u&&!l;for(e._axesDim={},i=0;i<s;i++){var w=o[i],T=0===i,k=i===s-1,M=T&&b||k&&_?void 0:d[i],A=T&&_||k&&b?void 0:m[i];x(M,A,w,v),x(A,M,w,y),g[i]=[M,A],e._axesDim[M]=i,e._axesDim[A]=i}for(i=0;i<v.length;i++)for(a=0;a<y.length;a++){var S=v[i]+y[a];i>a&&l||i<a&&c?r._splomSubplots[S]=1:i!==a||!u&&c&&l||(r._splomSubplots[S]=1)}(!c||!u&&l&&c)&&(r._splomGridDflt.xside='bottom',r._splomGridDflt.yside='left')}e.exports=function(t,e,r,h){function p(r,i){return n.coerce(t,e,a,r,i)}var d=i(t,e,{name:"dimensions",handleItemDefaults:u}),m=p('diagonal.visible'),g=p('showupperhalf'),v=p('showlowerhalf');if(l(e,d,'values')&&(m||g||v)){p('text'),p('hovertext'),p('hovertemplate'),p('xhoverformat'),p('yhoverformat'),s(t,e,r,h,p);var y=c(e.marker.symbol),x=o.isBubble(e);p('marker.line.width',y||x?1:0),f(t,e,h,p),n.coerceSelectionMarkerOpacity(e,p)}else e.visible=!1}},{"../../lib":787,"../../plots/array_container_defaults":833,"../parcoords/merge_length":1173,"../scatter/marker_defaults":1221,"../scatter/subtypes":1227,"../scattergl/helpers":1261,"./attributes":1298}],1302:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/colorscale_calc'),a=t('../scattergl/convert').markerStyle;e.exports=function(t,e){var r=e.trace,o=t._fullLayout._splomScenes[r.uid];if(o){i(t,r),n.extendFlat(o.matrixOptions,a(r));var s=n.extendFlat({},o.matrixOptions,o.viewOpts);o.matrix.update(s,null)}}},{"../../lib":787,"../scatter/colorscale_calc":1205,"../scattergl/convert":1257}],1303:[function(t,e,r){"use strict";r.getDimIndex=function(t,e){for(var r=e._id,n={x:0,y:1}[r.charAt(0)],i=t._visibleDims,a=0;a<i.length;a++){var o=i[a];if(t._diag[o][n]===r)return a}return!1}},{}],1304:[function(t,e,r){"use strict";var n=t('./helpers'),i=t('../scattergl/hover').calcHover;function a(t,e,r){var a=t.cd[0].trace,o=t.scene.matrixOptions.cdata,s=t.xa,l=t.ya,c=s.c2p(e),u=l.c2p(r),f=t.distance,h=n.getDimIndex(a,s),p=n.getDimIndex(a,l);if(!1===h||!1===p)return[t];for(var d,m,g=o[h],v=o[p],y=f,x=0;x<g.length;x++){var b=g[x],_=v[x],w=s.c2p(b)-c,T=l.c2p(_)-u,k=Math.sqrt(w*w+T*T);k<y&&(y=m=k,d=x)}return t.index=d,t.distance=y,t.dxy=m,void 0===d?[t]:[i(t,g,v,a)]}e.exports={hoverPoints:a}},{"../scattergl/hover":1262,"./helpers":1303}],1305:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../components/grid');e.exports={moduleType:"trace",name:"splom",basePlotModule:t('./base_plot'),categories:["gl",'regl','cartesian','symbols','showLegend',"scatter-like"],attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:t('../scatter/marker_colorbar'),calc:t('./calc'),plot:t('./plot'),hoverPoints:t('./hover').hoverPoints,selectPoints:t('./select'),editStyle:t('./edit_style'),meta:{}},n.register(i)},{"../../components/grid":694,"../../registry":915,"../scatter/marker_colorbar":1220,"./attributes":1298,"./base_plot":1299,"./calc":1300,"./defaults":1301,"./edit_style":1302,"./hover":1304,"./plot":1306,"./select":1308}],1306:[function(t,e,r){"use strict";var n=t('regl-splom'),i=t('../../lib'),a=t('../../plots/cartesian/axis_ids'),o=t('../../components/dragelement/helpers').selectMode;function s(t,e){var r,s,l,c,u,f=t._fullLayout,h=f._size,p=e.trace,d=e.t,m=f._splomScenes[p.uid],g=m.matrixOptions,v=g.cdata,y=f._glcanvas.data()[0].regl,x=f.dragmode;if(0!==v.length){g.lower=p.showupperhalf,g.upper=p.showlowerhalf,g.diagonal=p.diagonal.visible;var b=p._visibleDims,_=v.length,w=m.viewOpts={};for(w.ranges=new Array(_),w.domains=new Array(_),u=0;u<b.length;u++){l=b[u];var T=w.ranges[u]=new Array(4),k=w.domains[u]=new Array(4);(r=a.getFromId(t,p._diag[l][0]))&&(T[0]=r._rl[0],T[2]=r._rl[1],k[0]=r.domain[0],k[2]=r.domain[1]),(s=a.getFromId(t,p._diag[l][1]))&&(T[1]=s._rl[0],T[3]=s._rl[1],k[1]=s.domain[0],k[3]=s.domain[1])}var M=t._context.plotGlPixelRatio,A=h.l*M,S=h.b*M,E=h.w*M,L=h.h*M;w.viewport=[A,S,E+A,L+S],!0===m.matrix&&(m.matrix=n(y));var C=f.clickmode.indexOf('select')>-1,P=!0;if(o(x)||p.selectedpoints||C){var I=p._length;if(p.selectedpoints){m.selectBatch=p.selectedpoints;var z=p.selectedpoints,O={};for(l=0;l<z.length;l++)O[z[l]]=!0;var D=[];for(l=0;l<I;l++)O[l]||D.push(l);m.unselectBatch=D}var R=d.xpx=new Array(_),F=d.ypx=new Array(_);for(u=0;u<b.length;u++){if(l=b[u],r=a.getFromId(t,p._diag[l][0]))for(R[u]=new Array(I),c=0;c<I;c++)R[u][c]=r.c2p(v[u][c]);if(s=a.getFromId(t,p._diag[l][1]))for(F[u]=new Array(I),c=0;c<I;c++)F[u][c]=s.c2p(v[u][c])}if(m.selectBatch.length||m.unselectBatch.length)[var B=i.extendFlat({],g,m.unselectedOptions,w),N=i.extendFlat({},g,m.selectedOptions,w);m.matrix.update(B,N),P=!1}}else d.xpx=d.ypx=null;if(P)[var j=i.extendFlat({],g,w);m.matrix.update(j,null)}}}e.exports=function(t,e,r){if(r.length)for(var n=0;n<r.length;n++)s(t,r[n][0])}},{"../../components/dragelement/helpers":668,"../../lib":787,"../../plots/cartesian/axis_ids":842,"regl-splom":525}],1307:[function(t,e,r){"use strict";var n=t('../../lib');e.exports=function(t,e){var r=t._fullLayout,i=e.uid,a=r._splomScenes;a||(a=r._splomScenes={});var o={dirty:!0,selectBatch:[],unselectBatch:[]},s={matrix:!1,selectBatch:[],unselectBatch:[]},l=a[e.uid];return l||((l=a[i]=n.extendFlat({},o,s)).draw=function(){l.matrix&&l.matrix.draw&&(l.selectBatch.length||l.unselectBatch.length?l.matrix.draw(l.unselectBatch,l.selectBatch):l.matrix.draw()),l.dirty=!1},l.destroy=function(){l.matrix&&l.matrix.destroy&&l.matrix.destroy(),l.matrixOptions=null,l.selectBatch=null,l.unselectBatch=null,l=null}),l.dirty||n.extendFlat(l,o),l}},{"../../lib":787}],1308:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../scatter/subtypes'),a=t('./helpers');e.exports=function(t,e){var r=t.cd,o=r[0].trace,s=r[0].t,l=t.scene,c=l.matrixOptions.cdata,u=t.xaxis,f=t.yaxis,h=[];if(!l)return h;var p=!i.hasMarkers(o)&&!i.hasText(o);if(!0!==o.visible||p)return h;var d=a.getDimIndex(o,u),m=a.getDimIndex(o,f);if(!1===d||!1===m)return h;var g=s.xpx[d],v=s.ypx[m],y=c[d],x=c[m],b=[],_=[];if(!1!==e&&!e.degenerate)for(var w=0;w<y.length;w++)e.contains([g[w],v[w]],null,w,t)?(b.push(w),h.push({pointNumber:w,x:y[w],y:x[w]})):_.push(w);var T=l.matrixOptions;return b.length||_.length?l.selectBatch.length||l.unselectBatch.length||l.matrix.update(l.unselectedOptions,n.extendFlat({},T,l.selectedOptions,l.viewOpts)):l.matrix.update(T,null),l.selectBatch=b,l.unselectBatch=_,h}},{"../../lib":787,"../scatter/subtypes":1227,"./helpers":1303}],1309:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,a=t('../../plots/template_attributes').hovertemplateAttrs,o=t('../mesh3d/attributes'),s=t('../../plots/attributes'),l=t('../../lib/extend').extendFlat,c={x:{valType:"data_array",editType:"calc+clearAxisTypes"},y:{valType:"data_array",editType:"calc+clearAxisTypes"},z:{valType:"data_array",editType:"calc+clearAxisTypes"},u:{valType:"data_array",editType:"calc"},v:{valType:"data_array",editType:"calc"},w:{valType:"data_array",editType:"calc"},starts:{x:{valType:"data_array",editType:"calc"},y:{valType:"data_array",editType:"calc"},z:{valType:"data_array",editType:"calc"},editType:"calc"},maxdisplayed:{valType:"integer",min:0,dflt:1e3,editType:"calc"},sizeref:{valType:"number",editType:"calc",min:0,dflt:1},text:{valType:"string",dflt:"",editType:"calc"},hovertext:{valType:"string",dflt:"",editType:"calc"},hovertemplate:a({editType:"calc"},{keys:["tubex",'tubey','tubez','tubeu','tubev','tubew','norm',"divergence"]}),uhoverformat:i('u',1),vhoverformat:i('v',1),whoverformat:i('w',1),xhoverformat:i('x'),yhoverformat:i('y'),zhoverformat:i('z'),showlegend:l({},s.showlegend,{dflt:!1})};l(c,n('',{colorAttr:"u/v/w norm",showScaleDflt:!0,editTypeOverride:"calc"})),["opacity",'lightposition',"lighting"].forEach((function(t)[c[t]=o[t]])),c.hoverinfo=l({},s.hoverinfo,{editType:"calc",flags:["x",'y','z','u','v','w','norm','divergence','text',"name"],dflt:"x+y+z+norm+text+name"}),c.transforms=void 0,e.exports=c},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../mesh3d/attributes":1143}],1310:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/calc');function a(t,e){e._len=Math.min(e.u.length,e.v.length,e.w.length,e.x.length,e.y.length,e.z.length),e._u=l(e.u,e._len),e._v=l(e.v,e._len),e._w=l(e.w,e._len),e._x=l(e.x,e._len),e._y=l(e.y,e._len),e._z=l(e.z,e._len);var r=o(e);e._gridFill=r.fill,e._Xs=r.Xs,e._Ys=r.Ys,e._Zs=r.Zs,e._len=r.len;var n,a,s,c=0;e.starts&&(n=l(e.starts.x||[]),a=l(e.starts.y||[]),s=l(e.starts.z||[]),c=Math.min(n.length,a.length,s.length)),e._startsX=n||[],e._startsY=a||[],e._startsZ=s||[];var u,f=0,h=1/0;for(u=0;u<e._len;u++){var p=e._u[u],d=e._v[u],m=e._w[u],g=Math.sqrt(p*p+d*d+m*m);f=Math.max(f,g),h=Math.min(h,g)}for(i(t,e,{vals:[h,f],containerStr:"",cLetter:"c"}),u=0;u<c;u++){var v=n[u];r.xMax=Math.max(r.xMax,v),r.xMin=Math.min(r.xMin,v);var y=a[u];r.yMax=Math.max(r.yMax,y),r.yMin=Math.min(r.yMin,y);var x=s[u];r.zMax=Math.max(r.zMax,x),r.zMin=Math.min(r.zMin,x)}e._slen=c,e._normMax=f,e._xbnds=[r.xMin,r.xMax],e._ybnds=[r.yMin,r.yMax],e._zbnds=[r.zMin,r.zMax]}function o(t){var e,r,i,a,o,l,c,u,f,h,p,d,m=t._x,g=t._y,v=t._z,y=t._len,x=-1/0,b=1/0,_=-1/0,w=1/0,T=-1/0,k=1/0,M='';for(y&&(c=m[0],f=g[0],p=v[0]),y>1&&(u=m[y-1],h=g[y-1],d=v[y-1]),e=0;e<y;e++)x=Math.max(x,m[e]),b=Math.min(b,m[e]),_=Math.max(_,g[e]),w=Math.min(w,g[e]),T=Math.max(T,v[e]),k=Math.min(k,v[e]),a||m[e]===c||(a=!0,M+='x'),o||g[e]===f||(o=!0,M+='y'),l||v[e]===p||(l=!0,M+='z');a||(M+='x'),o||(M+='y'),l||(M+='z');var A=s(t._x),S=s(t._y),E=s(t._z);M=(M=(M=M.replace('x',(c>u?"-":"+")+"x")).replace('y',(f>h?"-":"+")+"y")).replace('z',(p>d?"-":"+")+"z");var L=function(){y=0,A=[],S=[],E=[]};(!y||y<A.length*S.length*E.length)&&L();var C=function(t){return"x"===t?m:"y"===t?g:v},P=function(t){return"x"===t?A:"y"===t?S:E},I=function(t){return t[y-1]<t[0]?-1:1},z=C(M[1]),O=C(M[3]),D=C(M[5]),R=P(M[1]).length,F=P(M[3]).length,B=P(M[5]).length,N=!1,j=function(t,e,r){return R*(F*t+e)+r},U=I(C(M[1])),V=I(C(M[3])),H=I(C(M[5]));for(e=0;e<B-1;e++){for(r=0;r<F-1;r++){for(i=0;i<R-1;i++){var q=j(e,r,i),G=j(e,r,i+1),Y=j(e,r+1,i),W=j(e+1,r,i);if(z[q]*U<z[G]*U&&O[q]*V<O[Y]*V&&D[q]*H<D[W]*H||(N=!0),N)break}if(N)break}if(N)break}return N&&(n.warn('Encountered arbitrary coordinates! Unable to input data grid.'),L()),{xMin:b,yMin:w,zMin:k,xMax:x,yMax:_,zMax:T,Xs:A,Ys:S,Zs:E,len:y,fill:M}}function s(t){return n.distinctVals(t).vals}function l(t,e){if(void 0===e&&(e=t.length),n.isTypedArray(t))return t.subarray(0,e);for(var r=[],i=0;i<e;i++)r[i]=+t[i];return r}e.exports={calc:a,filter:l,processGrid:o}},{"../../components/colorscale/calc":658,"../../lib":787}],1311:[function(t,e,r){"use strict";var n=t('gl-streamtube3d'),i=n.createTubeMesh,a=t('../../lib'),o=t('../../lib/gl_format_color').parseColorScale,s=t('../../components/colorscale').extractOpts,l=t('../../plots/gl3d/zip3'),c={xaxis:0,yaxis:1,zaxis:2};function u(t,e){this.scene=t,this.uid=e,this.mesh=null,this.data=null}var f=u.prototype;function h(t){var e=t.length;return e>2?t.slice(1,e-1):2===e?[(t[0]+t[1])/2]:t}function p(t){var e=t.length;return 1===e?[.5,.5]:[t[1]-t[0],t[e-1]-t[e-2]]}function d(t,e){var r=t.fullSceneLayout,i=t.dataScale,u=e._len,f={};function d(t,e){var n=r[e],o=i[c[e]];return a.simpleMap(t,(function(t){return n.d2l(t)*o}))}if(f.vectors=l(d(e._u,'xaxis'),d(e._v,'yaxis'),d(e._w,'zaxis'),u),!u)return{positions:[],cells:[]};var m=d(e._Xs,'xaxis'),g=d(e._Ys,'yaxis'),v=d(e._Zs,'zaxis');if(f.meshgrid=[m,g,v],f.gridFill=e._gridFill,e._slen)f.startingPositions=l(d(e._startsX,'xaxis'),d(e._startsY,'yaxis'),d(e._startsZ,'zaxis'));else{for(var y=g[0],x=h(m),b=h(v),_=new Array(x.length*b.length),w=0,T=0;T<x.length;T++)for(var k=0;k<b.length;k++)_[w++]=[x[T],y,b[k]];f.startingPositions=_}f.colormap=o(e),f.tubeSize=e.sizeref,f.maxLength=e.maxdisplayed;var M=d(e._xbnds,'xaxis'),A=d(e._ybnds,'yaxis'),S=d(e._zbnds,'zaxis'),E=p(m),L=p(g),C=p(v),P=[[M[0]-E[0],A[0]-L[0],S[0]-C[0]],[M[1]+E[1],A[1]+L[1],S[1]+C[1]]],I=n(f,P),z=s(e);I.vertexIntensityBounds=[z.min/e._normMax,z.max/e._normMax];var O=e.lightposition;return I.lightPosition=[O.x,O.y,O.z],I.ambient=e.lighting.ambient,I.diffuse=e.lighting.diffuse,I.specular=e.lighting.specular,I.roughness=e.lighting.roughness,I.fresnel=e.lighting.fresnel,I.opacity=e.opacity,e._pad=I.tubeScale*e.sizeref*2,I}function m(t,e){var r=t.glplot.gl,n=d(t,e),a=i(r,n),o=new u(t,e.uid);return o.mesh=a,o.data=e,a._trace=o,t.glplot.add(a),o}f.handlePick=function(t){var e=this.scene.fullSceneLayout,r=this.scene.dataScale;function n(t,n){var i=e[n],a=r[c[n]];return i.l2c(t)/a}if(t.object===this.mesh){var i=t.data.position,a=t.data.velocity;return t.traceCoordinate=[n(i[0],'xaxis'),n(i[1],'yaxis'),n(i[2],'zaxis'),n(a[0],'xaxis'),n(a[1],'yaxis'),n(a[2],'zaxis'),t.data.intensity*this.data._normMax,t.data.divergence],t.textLabel=this.data.hovertext||this.data.text,!0}},f.update=function(t){this.data=t;var e=d(this.scene,t);this.mesh.update(e)},f.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()},e.exports=m},{"../../components/colorscale":662,"../../lib":787,"../../lib/gl_format_color":783,"../../plots/gl3d/zip3":891,"gl-streamtube3d":344}],1312:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/colorscale/defaults'),a=t('./attributes');e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l=s('u'),c=s('v'),u=s('w'),f=s('x'),h=s('y'),p=s('z');l&&l.length&&c&&c.length&&u&&u.length&&f&&f.length&&h&&h.length&&p&&p.length?(s('starts.x'),s('starts.y'),s('starts.z'),s('maxdisplayed'),s('sizeref'),s('lighting.ambient'),s('lighting.diffuse'),s('lighting.specular'),s('lighting.roughness'),s('lighting.fresnel'),s('lightposition.x'),s('lightposition.y'),s('lightposition.z'),i(t,e,o,s,{prefix:"",cLetter:"c"}),s('text'),s('hovertext'),s('hovertemplate'),s('uhoverformat'),s('vhoverformat'),s('whoverformat'),s('xhoverformat'),s('yhoverformat'),s('zhoverformat'),e._length=null):e.visible=!1}},{"../../components/colorscale/defaults":660,"../../lib":787,"./attributes":1309}],1313:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"streamtube",basePlotModule:t('../../plots/gl3d'),categories:["gl3d","showLegend"],attributes:t('./attributes'),supplyDefaults:t('./defaults'),colorbar:{min:"cmin",max:"cmax"},calc:t('./calc').calc,plot:t('./convert'),eventData:function(t,e){return t.tubex=t.x,t.tubey=t.y,t.tubez=t.z,t.tubeu=e.traceCoordinate[3],t.tubev=e.traceCoordinate[4],t.tubew=e.traceCoordinate[5],t.norm=e.traceCoordinate[6],t.divergence=e.traceCoordinate[7],delete t.x,delete t.y,delete t.z,t},meta:{}}},{"../../plots/gl3d":880,"./attributes":1309,"./calc":1310,"./convert":1311,"./defaults":1312}],1314:[function(t,e,r){"use strict";var n=t('../../plots/attributes'),i=t('../../plots/template_attributes').hovertemplateAttrs,a=t('../../plots/template_attributes').texttemplateAttrs,o=t('../../components/colorscale/attributes'),s=t('../../plots/domain').attributes,l=t('../pie/attributes'),c=t('./constants'),u=t('../../lib/extend').extendFlat;e.exports={labels:{valType:"data_array",editType:"calc"},parents:{valType:"data_array",editType:"calc"},values:{valType:"data_array",editType:"calc"},branchvalues:{valType:"enumerated",values:["remainder","total"],dflt:"remainder",editType:"calc"},count:{valType:"flaglist",flags:["branches","leaves"],dflt:"leaves",editType:"calc"},level:{valType:"any",editType:"plot",anim:!0},maxdepth:{valType:"integer",editType:"plot",dflt:-1},marker:u({colors:{valType:"data_array",editType:"calc"},line:{color:u({},l.marker.line.color,{dflt:null}),width:u({},l.marker.line.width,{dflt:1}),editType:"calc"},editType:"calc"},o('marker',{colorAttr:"colors",anim:!1})),leaf:{opacity:{valType:"number",editType:"style",min:0,max:1},editType:"plot"},text:l.text,textinfo:{valType:"flaglist",flags:["label",'text','value','current path','percent root','percent entry',"percent parent"],extras:["none"],editType:"plot"},texttemplate:a({editType:"plot"},{keys:c.eventDataKeys.concat(["label","value"])}),hovertext:l.hovertext,hoverinfo:u({},n.hoverinfo,{flags:["label",'text','value','name','current path','percent root','percent entry',"percent parent"],dflt:"label+text+value+name"}),hovertemplate:i({},{keys:c.eventDataKeys}),textfont:l.textfont,insidetextorientation:l.insidetextorientation,insidetextfont:l.insidetextfont,outsidetextfont:u({},l.outsidetextfont,{}),rotation:{valType:"angle",dflt:0,editType:"plot"},sort:l.sort,root:{color:{valType:"color",editType:"calc",dflt:"rgba(0,0,0,0)"},editType:"calc"},domain:s({name:"sunburst",trace:!0,editType:"calc"})}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/domain":866,"../../plots/template_attributes":910,"../pie/attributes":1176,"./constants":1317}],1315:[function(t,e,r){"use strict";var n=t('../../plots/plots');r.name='sunburst',r.plot=function(t,e,i,a){n.plotBasePlot(r.name,t,e,i,a)},r.clean=function(t,e,i,a){n.cleanBasePlot(r.name,t,e,i,a)}},{"../../plots/plots":901}],1316:[function(t,e,r){"use strict";var n=t('d3-hierarchy'),i=t('fast-isnumeric'),a=t('../../lib'),o=t('../../components/colorscale').makeColorScaleFuncFromTrace,s=t('../pie/calc').makePullColorFn,l=t('../pie/calc').generateExtendedColors,c=t('../../components/colorscale').calc,u=t('../../constants/numerical').ALMOST_EQUAL,f={},h={},p={};function d(t,e,r){var n=0,i=t.children;if(i){for(var a=i.length,o=0;o<a;o++)n+=d(i[o],e,r);r.branches&&n++}else r.leaves&&n++;return t.value=t.data.data.value=n,e._values||(e._values=[]),e._values[t.data.data.i]=n,n}r.calc=function(t,e){var r,l,f,h,p=t._fullLayout,m=e.ids,g=a.isArrayOrTypedArray(m),v=e.labels,y=e.parents,x=e.values,b=a.isArrayOrTypedArray(x),_=[],w={},T={},k=function(t,e){w[t]?w[t].push(e):w[t]=[e],T[e]=1},M=function(t){return t||"number"===typeof t},A=function(t){return!b||i(x[t])&&x[t]>=0};g?(r=Math.min(m.length,y.length),l=function(t){return M(m[t])&&A(t)},f=function(t){return String(m[t])}):(r=Math.min(v.length,y.length),l=function(t){return M(v[t])&&A(t)},f=function(t){return String(v[t])}),b&&(r=Math.min(r,x.length));for(var S=0;S<r;S++)if(l(S)){var E=f(S),L=M(y[S])?String(y[S]):"",C={i:S,id:E,pid:L,label:M(v[S])?String(v[S]):""};b&&(C.v=+x[S]),_.push(C),k(L,E)}if(w[""]){if(w[""].length>1){for(var P=a.randstr(),I=0;I<_.length;I++)""===_[I].pid&&(_[I].pid=P);_.unshift({hasMultipleRoots:!0,id:P,pid:"",label:""})}}else{var z,O=[];for(z in w)T[z]||O.push(z);if(1!==O.length)return a.warn(["Multiple implied roots, cannot build",e.type,'hierarchy of',e.name+".",'These roots include:',O.join(', ')].join(' '));z=O[0],_.unshift({hasImpliedRoot:!0,id:z,pid:"",label:z})}try{h=n.stratify().id((function(t){return t.id})).parentId((function(t){return t.pid}))(_)}catch(U){return a.warn(["Failed to build",e.type,'hierarchy of',e.name+".",'Error:',U.message].join(' '))}var D=n.hierarchy(h),R=!1;if(b)switch(e.branchvalues){case"remainder":D.sum((function(t){return t.data.v}));break;case"total":D.each((function(t){var r=t.data.data,n=r.v;if(t.children){var i=t.children.reduce((function(t,e){return t+e.data.data.v}),0);if((r.hasImpliedRoot||r.hasMultipleRoots)&&(n=i),n<i*u)return R=!0,a.warn(["Total value for node",t.data.data.id,'of',e.name,'is smaller than the sum of its children.','\nparent value =',n,'\nchildren sum =',i].join(' '))}t.value=n}))}else d(D,e,{branches:-1!==e.count.indexOf('branches'),leaves:-1!==e.count.indexOf('leaves')});if(!R){var F,B;e.sort&&D.sort((function(t,e){return e.value-t.value}));var N=e.marker.colors||[],j=!!N.length;return e._hasColorscale?(j||(N=b?e.values:e._values),c(t,e,{vals:N,containerStr:"marker",cLetter:"c"}),B=o(e.marker)):F=s(p["_"+e.type+"colormap"]),D.each((function(t){var r=t.data.data;r.color=e._hasColorscale?B(N[r.i]):F(N[r.i],r.id)})),_[0].hierarchy=D,_}},r._runCrossTraceCalc=function(t,e){var r=e._fullLayout,n=e.calcdata,i=r[t+"colorway"],a=r["_"+t+"colormap"];r["extend"+t+"colors"]&&(i=l(i,"icicle"===t?p:"treemap"===t?h:f));var o,s=0;function c(t){var e=t.data.data,r=e.id;!1===e.color&&(a[r]?e.color=a[r]:t.parent?t.parent.parent?e.color=t.parent.data.data.color:(a[r]=e.color=i[s%i.length],s++):e.color=o)}for(var u=0;u<n.length;u++){var d=n[u][0];d.trace.type===t&&d.hierarchy&&(o=d.trace.root.color,d.hierarchy.each(c))}},r.crossTraceCalc=function(t){return r._runCrossTraceCalc('sunburst',t)}},{"../../components/colorscale":662,"../../constants/numerical":763,"../../lib":787,"../pie/calc":1178,"d3-hierarchy":167,"fast-isnumeric":246}],1317:[function(t,e,r){"use strict";e.exports={CLICK_TRANSITION_TIME:750,CLICK_TRANSITION_EASING:"linear",eventDataKeys:["currentPath",'root','entry','percentRoot','percentEntry',"percentParent"]}},{}],1318:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../plots/domain').defaults,o=t('../bar/defaults').handleText,s=t('../../components/colorscale'),l=s.hasColorscale,c=s.handleDefaults;e.exports=function(t,e,r,s){function u(r,a){return n.coerce(t,e,i,r,a)}var f=u('labels'),h=u('parents');if(f&&f.length&&h&&h.length){var p=u('values');p&&p.length?u('branchvalues'):u('count'),u('level'),u('maxdepth'),u('marker.line.width')&&u('marker.line.color',s.paper_bgcolor),u('marker.colors');var d=e._hasColorscale=l(t,'marker','colors')||(t.marker||{}).coloraxis;d&&c(t,e,s,u,{prefix:"marker.",cLetter:"c"}),u('leaf.opacity',d?1:.7);var m=u('text');u('texttemplate'),e.texttemplate||u('textinfo',Array.isArray(m)?"text+label":"label"),u('hovertext'),u('hovertemplate'),o(t,e,s,u,'auto',{moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!1,moduleHasCliponaxis:!1,moduleHasTextangle:!1,moduleHasInsideanchor:!1}),u('insidetextorientation'),u('sort'),u('rotation'),u('root.color'),a(e,s,u),e._length=null}else e.visible=!1}},{"../../components/colorscale":662,"../../lib":787,"../../plots/domain":866,"../bar/defaults":929,"./attributes":1314}],1319:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../registry'),a=t('../../components/fx/helpers').appendArrayPointValue,o=t('../../components/fx'),s=t('../../lib'),l=t('../../lib/events'),c=t('./helpers'),u=t('../pie/helpers').formatPieValue;function f(t,e,r){for(var n=t.data.data,i={curveNumber:e.index,pointNumber:n.i,data:e._input,fullData:e},o=0;o<r.length;o++){var s=r[o];s in t&&(i[s]=t[s])}return"parentString"in t&&!c.isHierarchyRoot(t)&&(i.parent=t.parentString),a(i,e,n.i),i}e.exports=function(t,e,r,a,h){var p=a[0],d=p.trace,m=p.hierarchy,g="sunburst"===d.type,v="treemap"===d.type||"icicle"===d.type;"_hasHoverLabel"in d||(d._hasHoverLabel=!1),"_hasHoverEvent"in d||(d._hasHoverEvent=!1);var y=function(i){var a=r._fullLayout;if(!r._dragging&&!1!==a.hovermode){var l,y=r._fullData[d.index],x=i.data.data,b=x.i,_=c.isHierarchyRoot(i),w=c.getParent(m,i),T=c.getValue(i),k=function(t){return s.castOption(y,b,t)},M=k('hovertemplate'),A=o.castHoverinfo(y,a,b),S=a.separators;if(M||A&&"none"!==A&&"skip"!==A){var E,L;g&&(E=p.cx+i.pxmid[0]*(1-i.rInscribed),L=p.cy+i.pxmid[1]*(1-i.rInscribed)),v&&(E=i._hoverX,L=i._hoverY);var C,P={},I=[],z=[],O=function(t){return-1!==I.indexOf(t)};A&&(I="all"===A?y._module.attributes.hoverinfo.flags:A.split('+')),P.label=x.label,O('label')&&P.label&&z.push(P.label),x.hasOwnProperty('v')&&(P.value=x.v,P.valueLabel=u(P.value,S),O('value')&&z.push(P.valueLabel)),P.currentPath=i.currentPath=c.getPath(i.data),O('current path')&&!_&&z.push(P.currentPath);var D=[],R=function(){-1===D.indexOf(C)&&(z.push(C),D.push(C))};P.percentParent=i.percentParent=T/c.getValue(w),P.parent=i.parentString=c.getPtLabel(w),O('percent parent')&&(C=c.formatPercent(P.percentParent,S)+" of '+P.parent,R()),P.percentEntry=i.percentEntry=T/c.getValue(e),P.entry=i.entry=c.getPtLabel(e),!O('percent entry')||_||i.onPathbar||(C=c.formatPercent(P.percentEntry,S)+' of '+P.entry,R()),P.percentRoot=i.percentRoot=T/c.getValue(m),P.root=i.root=c.getPtLabel(m),O('percent root')&&!_&&(C=c.formatPercent(P.percentRoot,S)+' of "+P.root,R()),P.text=k('hovertext')||k('text'),O('text')&&(C=P.text,s.isValidTextValue(C)&&z.push(C)),l=[f(i,y,h.eventDataKeys)];var F={trace:y,y:L,_x0:i._x0,_x1:i._x1,_y0:i._y0,_y1:i._y1,text:z.join('<br>'),name:M||O('name')?y.name:void 0,color:k('hoverlabel.bgcolor')||x.color,borderColor:k('hoverlabel.bordercolor'),fontFamily:k('hoverlabel.font.family'),fontSize:k('hoverlabel.font.size'),fontColor:k('hoverlabel.font.color'),nameLength:k('hoverlabel.namelength'),textAlign:k('hoverlabel.align'),hovertemplate:M,hovertemplateLabels:P,eventData:l};g&&(F.x0=E-i.rInscribed*i.rpx1,F.x1=E+i.rInscribed*i.rpx1,F.idealAlign=i.pxmid[0]<0?"left":"right"),v&&(F.x=E,F.idealAlign=E<0?"left":"right");var B=[];o.loneHover(F,{container:a._hoverlayer.node(),outerContainer:a._paper.node(),gd:r,inOut_bbox:B}),l[0].bbox=B[0],d._hasHoverLabel=!0}if(v){var N=t.select('path.surface');h.styleOne(N,i,y,{hovered:!0})}d._hasHoverEvent=!0,r.emit('plotly_hover',{points:l||[f(i,y,h.eventDataKeys)],event:n.event})}},x=function(e){var i=r._fullLayout,a=r._fullData[d.index],s=n.select(this).datum();if(d._hasHoverEvent&&(e.originalEvent=n.event,r.emit('plotly_unhover',{points:[f(s,a,h.eventDataKeys)],event:n.event}),d._hasHoverEvent=!1),d._hasHoverLabel&&(o.loneUnhover(i._hoverlayer.node()),d._hasHoverLabel=!1),v){var l=t.select('path.surface');h.styleOne(l,s,a,{hovered:!1})}},b=function(t){var e=r._fullLayout,a=r._fullData[d.index],s=g&&(c.isHierarchyRoot(t)||c.isLeaf(t)),u=c.getPtId(t),p=c.isEntry(t)?c.findEntryWithChild(m,u):c.findEntryWithLevel(m,u),v=c.getPtId(p),y={points:[f(t,a,h.eventDataKeys)],event:n.event};s||(y.nextLevel=v);var x=l.triggerHandler(r,"plotly_"+d.type+"click",y);if(!1!==x&&e.hovermode&&(r._hoverdata=[f(t,a,h.eventDataKeys)],o.click(r,n.event)),!s&&!1!==x&&!r._dragging&&!r._transitioning){i.call('_storeDirectGUIEdit',a,e._tracePreGUI[a.uid],{level:a.level});var b={data:[level:v],traces:[d.index]},_={frame:{redraw:!1,duration:h.transitionTime},transition:{duration:h.transitionTime,easing:h.transitionEasing},mode:"immediate",fromcurrent:!0};o.loneUnhover(e._hoverlayer.node()),i.call('animate',r,b,_)}};t.on('mouseover',y),t.on('mouseout',x),t.on('click',b)}},{"../../components/fx":690,"../../components/fx/helpers":686,"../../lib":787,"../../lib/events":776,"../../registry":915,"../pie/helpers":1181,"./helpers":1320,"@plotly/d3":58}],1320:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../../lib/setcursor'),o=t('../pie/helpers');function s(t,e,n){return{color:r.getOutsideTextFontKey('color',t,e,n),family:r.getOutsideTextFontKey('family',t,e,n),size:r.getOutsideTextFontKey('size',t,e,n)}}function l(t,e,a,o)[var s=(o||{]).onPathbar,l=e.data.data,c=l.i,u=n.castOption(t,c,(s?"pathbar.textfont":"insidetextfont")+".color");return!u&&t._input.textfont&&(u=n.castOption(t._input,c,'textfont.color')),{color:u||i.contrast(l.color),family:r.getInsideTextFontKey('family',t,e,a,o),size:r.getInsideTextFontKey('size',t,e,a,o)}}function c(t){return t.data.data.pid}r.findEntryWithLevel=function(t,e){var n;return e&&t.eachAfter((function(t){if(r.getPtId(t)===e)return n=t.copy()})),n||t},r.findEntryWithChild=function(t,e){var n;return t.eachAfter((function(t){for(var i=t.children||[],a=0;a<i.length;a++){var o=i[a];if(r.getPtId(o)===e)return n=t.copy()}})),n||t},r.isEntry=function(t){return!t.parent},r.isLeaf=function(t){return!t.children},r.getPtId=function(t){return t.data.data.id},r.getPtLabel=function(t){return t.data.data.label},r.getValue=function(t){return t.value},r.isHierarchyRoot=function(t){return""===c(t)},r.setSliceCursor=function(t,e,n){var i=n.isTransitioning;if(!i){var o=t.datum();i=n.hideOnRoot&&r.isHierarchyRoot(o)||n.hideOnLeaves&&r.isLeaf(o)}a(t,i?null:"pointer")},r.getInsideTextFontKey=function(t,e,r,i,a)[var o=(a||{]).onPathbar?"pathbar.textfont":"insidetextfont",s=r.data.data.i;return n.castOption(e,s,o+"."+t)||n.castOption(e,s,"textfont."+t)||i.size},r.getOutsideTextFontKey=function(t,e,r,i){var a=r.data.data.i;return n.castOption(e,a,"outsidetextfont."+t)||n.castOption(e,a,"textfont."+t)||i.size},r.isOutsideText=function(t,e){return!t._hasColorscale&&r.isHierarchyRoot(e)},r.determineTextFont=function(t,e,n,i){return r.isOutsideText(t,e)?s(t,e,n):l(t,e,n,i)},r.hasTransition=function(t){return!!(t&&t.duration>0)},r.getMaxDepth=function(t){return t.maxdepth>=0?t.maxdepth:1/0},r.isHeader=function(t,e){return!(r.isLeaf(t)||t.depth===e._maxDepth-1)},r.getParent=function(t,e){return r.findEntryWithLevel(t,c(e))},r.listPath=function(t,e){var n=t.parent;if(!n)return[];var i=e?[n.data[e]]:[n];return r.listPath(n,e).concat(i)},r.getPath=function(t){return r.listPath(t,'label').join('/')+"/"},r.formatValue=o.formatPieValue,r.formatPercent=function(t,e){var r=n.formatPercent(t,0);return"0%"===r&&(r=o.formatPiePercent(t,e)),r}},{"../../components/color":650,"../../lib":787,"../../lib/setcursor":808,"../pie/helpers":1181}],1321:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"sunburst",basePlotModule:t('./base_plot'),categories:[],animatable:!0,attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults'),supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc').calc,crossTraceCalc:t('./calc').crossTraceCalc,plot:t('./plot').plot,style:t('./style').style,colorbar:t('../scatter/marker_colorbar'),meta:{}}},{"../scatter/marker_colorbar":1220,"./attributes":1314,"./base_plot":1315,"./calc":1316,"./defaults":1318,"./layout_attributes":1322,"./layout_defaults":1323,"./plot":1324,"./style":1325}],1322:[function(t,e,r){"use strict";e.exports={sunburstcolorway:{valType:"colorlist",editType:"calc"},extendsunburstcolors:{valType:"boolean",dflt:!0,editType:"calc"}}},{}],1323:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}r('sunburstcolorway',e.colorway),r('extendsunburstcolors')}},{"../../lib":787,"./layout_attributes":1322}],1324:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-hierarchy'),a=t('d3-interpolate').interpolate,o=t('../../components/drawing'),s=t('../../lib'),l=t('../../lib/svg_text_utils'),c=t('../bar/uniform_text'),u=c.recordMinTextSize,f=c.clearMinTextSize,h=t('../pie/plot'),p=t('../pie/helpers').getRotationAngle,d=h.computeTransform,m=h.transformInsideText,g=t('./style').styleOne,v=t('../bar/style').resizeText,y=t('./fx'),x=t('./constants'),b=t('./helpers');function _(t,e,i,c){var f=t._fullLayout,h=!f.uniformtext.mode&&b.hasTransition(c),v=n.select(i).selectAll('g.slice'),_=e[0],M=_.trace,A=_.hierarchy,S=b.findEntryWithLevel(A,M.level),E=b.getMaxDepth(M),L=f._size,C=M.domain,P=L.w*(C.x[1]-C.x[0]),I=L.h*(C.y[1]-C.y[0]),z=.5*Math.min(P,I),O=_.cx=L.l+L.w*(C.x[1]+C.x[0])/2,D=_.cy=L.t+L.h*(1-C.y[0])-I/2;if(!S)return v.remove();var R=null,F={};h&&v.each((function(t){F[b.getPtId(t)]={rpx0:t.rpx0,rpx1:t.rpx1,x0:t.x0,x1:t.x1,transform:t.transform},!R&&b.isEntry(t)&&(R=t)}));var B=w(S).descendants(),N=S.height+1,j=0,U=E;_.hasMultipleRoots&&b.isHierarchyRoot(S)&&(B=B.slice(1),N-=1,j=1,U+=1),B=B.filter((function(t){return t.y1<=U}));var V=p(M.rotation);V&&B.forEach((function(t){t.x0+=V,t.x1+=V}));var H=Math.min(N,E),q=function(t){return(t-j)/H*z},G=function(t,e){return[t*Math.cos(e),-t*Math.sin(e)]},Y=function(t){return s.pathAnnulus(t.rpx0,t.rpx1,t.x0,t.x1,O,D)},W=function(t){return O+k(t)[0]*(t.transform.rCenter||0)+(t.transform.x||0)},X=function(t){return D+k(t)[1]*(t.transform.rCenter||0)+(t.transform.y||0)};(v=v.data(B,b.getPtId)).enter().append('g').classed('slice',!0),h?v.exit().transition().each((function(){var t=n.select(this);t.select('path.surface').transition().attrTween('d',(function(t){var e=Q(t);return function(t){return Y(e(t))}})),t.select('g.slicetext').attr('opacity',0)})).remove():v.exit().remove(),v.order();var Z=null;if(h&&R){var J=b.getPtId(R);v.each((function(t){null===Z&&b.getPtId(t)===J&&(Z=t.x1)}))}var K=v;function Q(t){var e,r=b.getPtId(t),n=F[r],i=F[b.getPtId(S)];if(i){var o=(t.x1>i.x1?2*Math.PI:0)+V;e=t.rpx1<i.rpx1?{x0:t.x0,x1:t.x1,rpx0:0,rpx1:0}:{x0:o,x1:o,rpx0:t.rpx0,rpx1:t.rpx1}}else{var s,l=b.getPtId(t.parent);v.each((function(t){if(b.getPtId(t)===l)return s=t}));var c,u=s.children;u.forEach((function(t,e){if(b.getPtId(t)===r)return c=e}));var f=u.length,h=a(s.x0,s.x1);e={rpx0:z,rpx1:z,x0:h(c/f),x1:h((c+1)/f)}}return a(n,e)}function $(t){var e,r=F[b.getPtId(t)],n={x0:t.x0,x1:t.x1,rpx0:t.rpx0,rpx1:t.rpx1};if(r)e=r;else if(R)if(t.parent)if(Z){var i=(t.x1>Z?2*Math.PI:0)+V;e={x0:i,x1:i}}else e={rpx0:z,rpx1:z},s.extendFlat(e,et(t));else e={rpx0:0,rpx1:0};else e={x0:V,x1:V};return a(e,n)}function tt(t){var e,r=F[b.getPtId(t)],n=t.transform;if(r)e=r;else if(e={rpx1:t.rpx1,transform:{textPosAngle:n.textPosAngle,scale:0,rotate:n.rotate,rCenter:n.rCenter,x:n.x,y:n.y}},R)if(t.parent)if(Z){var i=t.x1>Z?2*Math.PI:0;e.x0=e.x1=i}else s.extendFlat(e,et(t));else e.x0=e.x1=V;else e.x0=e.x1=V;var o=a(e.transform.textPosAngle,t.transform.textPosAngle),l=a(e.rpx1,t.rpx1),c=a(e.x0,t.x0),h=a(e.x1,t.x1),p=a(e.transform.scale,n.scale),d=a(e.transform.rotate,n.rotate),m=0===n.rCenter?3:0===e.transform.rCenter?1/3:1,g=a(e.transform.rCenter,n.rCenter),v=function(t){return g(Math.pow(t,m))};return function(t){var e=l(t),r=c(t),i=h(t),a=v(t),s={pxmid:G(e,(r+i)/2),rpx1:e,transform:{textPosAngle:o(t),rCenter:a,x:n.x,y:n.y}};return u(M.type,n,f),{transform:{targetX:W(s),targetY:X(s),scale:p(t),rotate:d(t),rCenter:a}}}}function et(t){var e=t.parent,r=F[b.getPtId(e)],n={};if(r){var i=e.children,o=i.indexOf(t),s=i.length,l=a(r.x0,r.x1);n.x0=l(o/s),n.x1=l(o/s)}else n.x0=n.x1=0;return n}h&&(K=K.transition().each('end',(function(){var e=n.select(this);b.setSliceCursor(e,t,{hideOnRoot:!0,hideOnLeaves:!0,isTransitioning:!1})}))),K.each((function(i){var a=n.select(this),c=s.ensureSingle(a,'path','surface',(function(t){t.style('pointer-events','all')}));i.rpx0=q(i.y0),i.rpx1=q(i.y1),i.xmid=(i.x0+i.x1)/2,i.pxmid=G(i.rpx1,i.xmid),i.midangle=-(i.xmid-Math.PI/2),i.startangle=-(i.x0-Math.PI/2),i.stopangle=-(i.x1-Math.PI/2),i.halfangle=.5*Math.min(s.angleDelta(i.x0,i.x1)||Math.PI,Math.PI),i.ring=1-i.rpx0/i.rpx1,i.rInscribed=T(i,M),h?c.transition().attrTween('d',(function(t){var e=$(t);return function(t){return Y(e(t))}})):c.attr('d',Y),a.call(y,S,t,e,{eventDataKeys:x.eventDataKeys,transitionTime:x.CLICK_TRANSITION_TIME,transitionEasing:x.CLICK_TRANSITION_EASING}).call(b.setSliceCursor,t,{hideOnRoot:!0,hideOnLeaves:!0,isTransitioning:t._transitioning}),c.call(g,i,M);var p=s.ensureSingle(a,'g','slicetext'),v=s.ensureSingle(p,'text','',(function(t){t.attr('data-notex',1)})),w=s.ensureUniformFontSize(t,b.determineTextFont(M,i,f.font));v.text(r.formatSliceLabel(i,S,M,e,f)).classed('slicetext',!0).attr('text-anchor','middle').call(o.font,w).call(l.convertToTspans,t);var k=o.bBox(v.node());i.transform=m(k,i,_),i.transform.targetX=W(i),i.transform.targetY=X(i);var A=function(t,e){var r=t.transform;return d(r,e),r.fontSize=w.size,u(M.type,r,f),s.getTextTransform(r)};h?v.transition().attrTween('transform',(function(t){var e=tt(t);return function(t){return A(e(t),k)}})):v.attr('transform',A(i,k))}))}function w(t){return i.partition().size([2*Math.PI,t.height+1])(t)}function T(t){return 0===t.rpx0&&s.isFullCircle([t.x0,t.x1])?1:Math.max(0,Math.min(1/(1+1/Math.sin(t.halfangle)),t.ring/2))}function k(t){return M(t.rpx1,t.transform.textPosAngle)}function M(t,e){return[t*Math.sin(e),-t*Math.cos(e)]}r.plot=function(t,e,r,i){var a,o,s=t._fullLayout,l=s._sunburstlayer,c=!r,u=!s.uniformtext.mode&&b.hasTransition(r);f('sunburst',s),(a=l.selectAll('g.trace.sunburst').data(e,(function(t){return t[0].trace.uid}))).enter().append('g').classed('trace',!0).classed('sunburst',!0).attr('stroke-linejoin','round'),a.order(),u?(i&&(o=i()),n.transition().duration(r.duration).ease(r.easing).each('end',(function()[o&&o()])).each('interrupt',(function()[o&&o()])).each((function(){l.selectAll('g.trace').each((function(e){_(t,e,this,r)}))}))):(a.each((function(e){_(t,e,this,r)})),s.uniformtext.mode&&v(t,s._sunburstlayer.selectAll('.trace'),'sunburst')),c&&a.exit().remove()},r.formatSliceLabel=function(t,e,r,n,i){var a=r.texttemplate,o=r.textinfo;if(!a&&(!o||"none"===o))return'';var l=i.separators,c=n[0],u=t.data.data,f=c.hierarchy,h=b.isHierarchyRoot(t),p=b.getParent(f,t),d=b.getValue(t);if(!a){var m,g=o.split('+'),v=function(t){return-1!==g.indexOf(t)},y=[];if(v('label')&&u.label&&y.push(u.label),u.hasOwnProperty('v')&&v('value')&&y.push(b.formatValue(u.v,l)),!h){v('current path')&&y.push(b.getPath(t.data));var x=0;v('percent parent')&&x++,v('percent entry')&&x++,v('percent root')&&x++;var _=x>1;if(x){var w,T=function(t){m=b.formatPercent(w,l),_&&(m+=" of "+t),y.push(m)};v('percent parent')&&!h&&(w=d/b.getValue(p),T('parent')),v('percent entry')&&(w=d/b.getValue(e),T('entry')),v('percent root')&&(w=d/b.getValue(f),T('root'))}}return v('text')&&(m=s.castOption(r,u.i,'text'),s.isValidTextValue(m)&&y.push(m)),y.join('<br>')}var k=s.castOption(r,u.i,'texttemplate');if(!k)return'';var M={};u.label&&(M.label=u.label),u.hasOwnProperty('v')&&(M.value=u.v,M.valueLabel=b.formatValue(u.v,l)),M.currentPath=b.getPath(t.data),h||(M.percentParent=d/b.getValue(p),M.percentParentLabel=b.formatPercent(M.percentParent,l),M.parent=b.getPtLabel(p)),M.percentEntry=d/b.getValue(e),M.percentEntryLabel=b.formatPercent(M.percentEntry,l),M.entry=b.getPtLabel(e),M.percentRoot=d/b.getValue(f),M.percentRootLabel=b.formatPercent(M.percentRoot,l),M.root=b.getPtLabel(f),u.hasOwnProperty('color')&&(M.color=u.color);var A=s.castOption(r,u.i,'text');return(s.isValidTextValue(A)||""===A)&&(M.text=A),M.customdata=s.castOption(r,u.i,'customdata'),s.texttemplateString(k,M,i._d3locale,M,r._meta||{})}},{"../../components/drawing":672,"../../lib":787,"../../lib/svg_text_utils":813,"../bar/style":939,"../bar/uniform_text":941,"../pie/helpers":1181,"../pie/plot":1185,"./constants":1317,"./fx":1319,"./helpers":1320,"./style":1325,"@plotly/d3":58,"d3-hierarchy":167,"d3-interpolate":168}],1325:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../../lib'),o=t('../bar/uniform_text').resizeText;function s(t){var e=t._fullLayout._sunburstlayer.selectAll('.trace');o(t,e,'sunburst'),e.each((function(t){var e=n.select(this),r=t[0].trace;e.style('opacity',r.opacity),e.selectAll('path.surface').each((function(t){n.select(this).call(l,t,r)}))}))}function l(t,e,r){var n=e.data.data,o=!e.children,s=n.i,l=a.castOption(r,s,'marker.line.color')||i.defaultLine,c=a.castOption(r,s,'marker.line.width')||0;t.style('stroke-width',c).call(i.fill,n.color).call(i.stroke,l).style('opacity',o?r.leaf.opacity:null)}e.exports={style:s,styleOne:l}},{"../../components/color":650,"../../lib":787,"../bar/uniform_text":941,"@plotly/d3":58}],1326:[function(t,e,r){"use strict";var n=t('../../components/color'),i=t('../../components/colorscale/attributes'),a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,o=t('../../plots/template_attributes').hovertemplateAttrs,s=t('../../plots/attributes'),l=t('../../lib/extend').extendFlat,c=t('../../plot_api/edit_types').overrideAll;function u(t){return{valType:"boolean",dflt:!1}}function f(t){return{show:{valType:"boolean",dflt:!1},start:{valType:"number",dflt:null,editType:"plot"},end:{valType:"number",dflt:null,editType:"plot"},size:{valType:"number",dflt:null,min:0,editType:"plot"},project:{x:u('x'),y:u('y'),z:u('z')},color:{valType:"color",dflt:n.defaultLine},usecolormap:{valType:"boolean",dflt:!1},width:{valType:"number",min:1,max:16,dflt:2},highlight:{valType:"boolean",dflt:!0},highlightcolor:{valType:"color",dflt:n.defaultLine},highlightwidth:{valType:"number",min:1,max:16,dflt:2}}}var h=e.exports=c(l({z:{valType:"data_array"},x:{valType:"data_array"},y:{valType:"data_array"},text:{valType:"string",dflt:"",arrayOk:!0},hovertext:{valType:"string",dflt:"",arrayOk:!0},hovertemplate:o(),xhoverformat:a('x'),yhoverformat:a('y'),zhoverformat:a('z'),connectgaps:{valType:"boolean",dflt:!1,editType:"calc"},surfacecolor:{valType:"data_array"}},i('',{colorAttr:"z or surfacecolor",showScaleDflt:!0,autoColorDflt:!1,editTypeOverride:"calc"}),{contours:{x:f('x'),y:f('y'),z:f('z')},hidesurface:{valType:"boolean",dflt:!1},lightposition:{x:{valType:"number",min:-1e5,max:1e5,dflt:10},y:{valType:"number",min:-1e5,max:1e5,dflt:1e4},z:{valType:"number",min:-1e5,max:1e5,dflt:0}},lighting:{ambient:{valType:"number",min:0,max:1,dflt:.8},diffuse:{valType:"number",min:0,max:1,dflt:.8},specular:{valType:"number",min:0,max:2,dflt:.05},roughness:{valType:"number",min:0,max:1,dflt:.5},fresnel:{valType:"number",min:0,max:5,dflt:.2}},opacity:{valType:"number",min:0,max:1,dflt:1},opacityscale:{valType:"any",editType:"calc"},_deprecated:{zauto:l({},i.zauto,{}),zmin:l({},i.zmin,{}),zmax:l({},i.zmax,{})},hoverinfo:l({},s.hoverinfo),showlegend:l({},s.showlegend,{dflt:!1})}),'calc','nested');h.x.editType=h.y.editType=h.z.editType='calc+clearAxisTypes',h.transforms=void 0},{"../../components/color":650,"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910}],1327:[function(t,e,r){"use strict";var n=t('../../components/colorscale/calc');e.exports=function(t,e){e.surfacecolor?n(t,e,{vals:e.surfacecolor,containerStr:"",cLetter:"c"}):n(t,e,{vals:e.z,containerStr:"",cLetter:"c"})}},{"../../components/colorscale/calc":658}],1328:[function(t,e,r){"use strict";var n=t('gl-surface3d'),i=t('ndarray'),a=t('ndarray-linear-interpolate').d2,o=t('../heatmap/interp2d'),s=t('../heatmap/find_empties'),l=t('../../lib').isArrayOrTypedArray,c=t('../../lib/gl_format_color').parseColorScale,u=t('../../lib/str2rgbarray'),f=t('../../components/colorscale').extractOpts;function h(t,e,r){this.scene=t,this.uid=r,this.surface=e,this.data=null,this.showContour=[!1,!1,!1],this.contourStart=[null,null,null],this.contourEnd=[null,null,null],this.contourSize=[0,0,0],this.minValues=[1/0,1/0,1/0],this.maxValues=[-1/0,-1/0,-1/0],this.dataScaleX=1,this.dataScaleY=1,this.refineData=!0,this.objectOffset=[0,0,0]}var p=h.prototype;function d(t){var e=t[0].rgb,r=t[t.length-1].rgb;return e[0]===r[0]&&e[1]===r[1]&&e[2]===r[2]&&e[3]===r[3]}p.getXat=function(t,e,r,n){var i=l(this.data.x)?l(this.data.x[0])?this.data.x[e][t]:this.data.x[t]:t;return void 0===r?i:n.d2l(i,0,r)},p.getYat=function(t,e,r,n){var i=l(this.data.y)?l(this.data.y[0])?this.data.y[e][t]:this.data.y[e]:e;return void 0===r?i:n.d2l(i,0,r)},p.getZat=function(t,e,r,n){var i=this.data.z[e][t];return null===i&&this.data.connectgaps&&this.data._interpolatedZ&&(i=this.data._interpolatedZ[e][t]),void 0===r?i:n.d2l(i,0,r)},p.handlePick=function(t){if(t.object===this.surface){var e=(t.data.index[0]-1)/this.dataScaleX-1,r=(t.data.index[1]-1)/this.dataScaleY-1,n=Math.max(Math.min(Math.round(e),this.data.z[0].length-1),0),i=Math.max(Math.min(Math.round(r),this.data._ylength-1),0);t.index=[n,i],t.traceCoordinate=[this.getXat(n,i),this.getYat(n,i),this.getZat(n,i)],t.dataCoordinate=[this.getXat(n,i,this.data.xcalendar,this.scene.fullSceneLayout.xaxis),this.getYat(n,i,this.data.ycalendar,this.scene.fullSceneLayout.yaxis),this.getZat(n,i,this.data.zcalendar,this.scene.fullSceneLayout.zaxis)];for(var a=0;a<3;a++){var o=t.dataCoordinate[a];null!==o&&void 0!==o&&(t.dataCoordinate[a]*=this.scene.dataScale[a])}var s=this.data.hovertext||this.data.text;return Array.isArray(s)&&s[i]&&void 0!==s[i][n]?t.textLabel=s[i][n]:t.textLabel=s||"",t.data.dataCoordinate=t.dataCoordinate.slice(),this.surface.highlight(t.data),this.scene.glplot.spikes.position=t.dataCoordinate,!0}};var m=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509,521,523,541,547,557,563,569,571,577,587,593,599,601,607,613,617,619,631,641,643,647,653,659,661,673,677,683,691,701,709,719,727,733,739,743,751,757,761,769,773,787,797,809,811,821,823,827,829,839,853,857,859,863,877,881,883,887,907,911,919,929,937,941,947,953,967,971,977,983,991,997,1009,1013,1019,1021,1031,1033,1039,1049,1051,1061,1063,1069,1087,1091,1093,1097,1103,1109,1117,1123,1129,1151,1153,1163,1171,1181,1187,1193,1201,1213,1217,1223,1229,1231,1237,1249,1259,1277,1279,1283,1289,1291,1297,1301,1303,1307,1319,1321,1327,1361,1367,1373,1381,1399,1409,1423,1427,1429,1433,1439,1447,1451,1453,1459,1471,1481,1483,1487,1489,1493,1499,1511,1523,1531,1543,1549,1553,1559,1567,1571,1579,1583,1597,1601,1607,1609,1613,1619,1621,1627,1637,1657,1663,1667,1669,1693,1697,1699,1709,1721,1723,1733,1741,1747,1753,1759,1777,1783,1787,1789,1801,1811,1823,1831,1847,1861,1867,1871,1873,1877,1879,1889,1901,1907,1913,1931,1933,1949,1951,1973,1979,1987,1993,1997,1999,2003,2011,2017,2027,2029,2039,2053,2063,2069,2081,2083,2087,2089,2099,2111,2113,2129,2131,2137,2141,2143,2153,2161,2179,2203,2207,2213,2221,2237,2239,2243,2251,2267,2269,2273,2281,2287,2293,2297,2309,2311,2333,2339,2341,2347,2351,2357,2371,2377,2381,2383,2389,2393,2399,2411,2417,2423,2437,2441,2447,2459,2467,2473,2477,2503,2521,2531,2539,2543,2549,2551,2557,2579,2591,2593,2609,2617,2621,2633,2647,2657,2659,2663,2671,2677,2683,2687,2689,2693,2699,2707,2711,2713,2719,2729,2731,2741,2749,2753,2767,2777,2789,2791,2797,2801,2803,2819,2833,2837,2843,2851,2857,2861,2879,2887,2897,2903,2909,2917,2927,2939,2953,2957,2963,2969,2971,2999];function g(t,e){if(t<e)return 0;for(var r=0;0===Math.floor(t%e);)t/=e,r++;return r}function v(t){for(var e=[],r=0;r<m.length;r++){var n=m[r];e.push(g(t,n))}return e}function y(t){for(var e=v(t),r=t,n=0;n<m.length;n++)if(e[n]>0){r=m[n];break}return r}function x(t,e){if(!(t<1||e<1)){for(var r=v(t),n=v(e),i=1,a=0;a<m.length;a++)i*=Math.pow(m[a],Math.max(r[a],n[a]));return i}}function b(t){if(0!==t.length){for(var e=1,r=0;r<t.length;r++)e=x(e,t[r]);return e}}p.calcXnums=function(t){var e,r=[];for(e=1;e<t;e++){var n=this.getXat(e-1,0),i=this.getXat(e,0);r[e-1]=i!==n&&void 0!==n&&null!==n&&void 0!==i&&null!==i?Math.abs(i-n):0}var a=0;for(e=1;e<t;e++)a+=r[e-1];for(e=1;e<t;e++)0===r[e-1]?r[e-1]=1:r[e-1]=Math.round(a/r[e-1]);return r},p.calcYnums=function(t){var e,r=[];for(e=1;e<t;e++){var n=this.getYat(0,e-1),i=this.getYat(0,e);r[e-1]=i!==n&&void 0!==n&&null!==n&&void 0!==i&&null!==i?Math.abs(i-n):0}var a=0;for(e=1;e<t;e++)a+=r[e-1];for(e=1;e<t;e++)0===r[e-1]?r[e-1]=1:r[e-1]=Math.round(a/r[e-1]);return r};var _=[1,2,4,6,12,24,36,48,60,120,180,240,360,720,840,1260],w=_[9],T=_[13];function k(t,e,r){var n=r[8]+r[2]*e[0]+r[5]*e[1];return t[0]=(r[6]+r[0]*e[0]+r[3]*e[1])/n,t[1]=(r[7]+r[1]*e[0]+r[4]*e[1])/n,t}function M(t,e,r){return A(t,e,k,r),t}function A(t,e,r,n){for(var i=[0,0],o=t.shape[0],s=t.shape[1],l=0;l<o;l++)for(var c=0;c<s;c++)r(i,[l,c],n),t.set(l,c,a(e,i[0],i[1]));return t}function S(t,e){for(var r=!1,n=0;n<t.length;n++)if(e===t[n]){r=!0;break}!1===r&&t.push(e)}function E(t,e){var r=t.glplot.gl,i=n({gl:r}),a=new h(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}p.estimateScale=function(t,e){for(var r=1+b(0===e?this.calcXnums(t):this.calcYnums(t));r<w;)r*=2;for(;r>T;)r--,r/=y(r),++r<w&&(r=T);var n=Math.round(r/t);return n>1?n:1},p.refineCoords=function(t){for(var e=this.dataScaleX,r=this.dataScaleY,n=t[0].shape[0],a=t[0].shape[1],o=0|Math.floor(t[0].shape[0]*e+1),s=0|Math.floor(t[0].shape[1]*r+1),l=1+n+1,c=1+a+1,u=i(new Float32Array(l*c),[l,c]),f=[1/e,0,0,0,1/r,0,0,0,1],h=0;h<t.length;++h){this.surface.padField(u,t[h]);var p=i(new Float32Array(o*s),[o,s]);M(p,u,f),t[h]=p}},p.setContourLevels=function(){var t,e,r,n=[[],[],[]],i=[!1,!1,!1],a=!1;for(t=0;t<3;++t)if(this.showContour[t]&&(a=!0,this.contourSize[t]>0&&null!==this.contourStart[t]&&null!==this.contourEnd[t]&&this.contourEnd[t]>this.contourStart[t]))for(i[t]=!0,e=this.contourStart[t];e<this.contourEnd[t];e+=this.contourSize[t])r=e*this.scene.dataScale[t],S(n[t],r);if(a){var o=[[],[],[]];for(t=0;t<3;++t)this.showContour[t]&&(o[t]=i[t]?n[t]:this.scene.contourLevels[t]);this.surface.update({levels:o})}},p.update=function(t){var e,r,n,a,l=this.scene,h=l.fullSceneLayout,p=this.surface,m=c(t),g=l.dataScale,v=t.z[0].length,y=t._ylength,x=l.contourLevels;this.data=t;var b=[];for(e=0;e<3;e++)for(b[e]=[],r=0;r<v;r++)b[e][r]=[];for(r=0;r<v;r++)for(n=0;n<y;n++)b[0][r][n]=this.getXat(r,n,t.xcalendar,h.xaxis),b[1][r][n]=this.getYat(r,n,t.ycalendar,h.yaxis),b[2][r][n]=this.getZat(r,n,t.zcalendar,h.zaxis);if(t.connectgaps)for(t._emptypoints=s(b[2]),o(b[2],t._emptypoints),t._interpolatedZ=[],r=0;r<v;r++)for(t._interpolatedZ[r]=[],n=0;n<y;n++)t._interpolatedZ[r][n]=b[2][r][n];for(e=0;e<3;e++)for(r=0;r<v;r++)for(n=0;n<y;n++)null===(a=b[e][r][n])||void 0===a?b[e][r][n]=NaN:a=b[e][r][n]*=g[e];for(e=0;e<3;e++)for(r=0;r<v;r++)for(n=0;n<y;n++)null!==(a=b[e][r][n])&&void 0!==a&&(this.minValues[e]>a&&(this.minValues[e]=a),this.maxValues[e]<a&&(this.maxValues[e]=a));for(e=0;e<3;e++)this.objectOffset[e]=.5*(this.minValues[e]+this.maxValues[e]);for(e=0;e<3;e++)for(r=0;r<v;r++)for(n=0;n<y;n++)null!==(a=b[e][r][n])&&void 0!==a&&(b[e][r][n]-=this.objectOffset[e]);var _=[i(new Float32Array(v*y),[v,y]),i(new Float32Array(v*y),[v,y]),i(new Float32Array(v*y),[v,y])];for(e=0;e<3;e++)for(r=0;r<v;r++)for(n=0;n<y;n++)_[e].set(r,n,b[e][r][n]);b=[];var w={colormap:m,levels:[[],[],[]],showContour:[!0,!0,!0],showSurface:!t.hidesurface,contourProject:[[!1,!1,!1],[!1,!1,!1],[!1,!1,!1]],contourWidth:[1,1,1],contourColor:[[1,1,1,1],[1,1,1,1],[1,1,1,1]],contourTint:[1,1,1],dynamicColor:[[1,1,1,1],[1,1,1,1],[1,1,1,1]],dynamicWidth:[1,1,1],dynamicTint:[1,1,1],opacityscale:t.opacityscale,opacity:t.opacity},k=f(t);if(w.intensityBounds=[k.min,k.max],t.surfacecolor){var M=i(new Float32Array(v*y),[v,y]);for(r=0;r<v;r++)for(n=0;n<y;n++)M.set(r,n,t.surfacecolor[n][r]);_.push(M)}else w.intensityBounds[0]*=g[2],w.intensityBounds[1]*=g[2];(T<_[0].shape[0]||T<_[0].shape[1])&&(this.refineData=!1),!0===this.refineData&&(this.dataScaleX=this.estimateScale(_[0].shape[0],0),this.dataScaleY=this.estimateScale(_[0].shape[1],1),1===this.dataScaleX&&1===this.dataScaleY||this.refineCoords(_)),t.surfacecolor&&(w.intensity=_.pop());var A=[!0,!0,!0],S=["x",'y',"z"];for(e=0;e<3;++e){var E=t.contours[S[e]];A[e]=E.highlight,w.showContour[e]=E.show||E.highlight,w.showContour[e]&&(w.contourProject[e]=[E.project.x,E.project.y,E.project.z],E.show?(this.showContour[e]=!0,w.levels[e]=x[e],p.highlightColor[e]=w.contourColor[e]=u(E.color),E.usecolormap?p.highlightTint[e]=w.contourTint[e]=0:p.highlightTint[e]=w.contourTint[e]=1,w.contourWidth[e]=E.width,this.contourStart[e]=E.start,this.contourEnd[e]=E.end,this.contourSize[e]=E.size):(this.showContour[e]=!1,this.contourStart[e]=null,this.contourEnd[e]=null,this.contourSize[e]=0),E.highlight&&(w.dynamicColor[e]=u(E.highlightcolor),w.dynamicWidth[e]=E.highlightwidth))}d(m)&&(w.vertexColor=!0),w.objectOffset=this.objectOffset,w.coords=_,p.update(w),p.visible=t.visible,p.enableDynamic=A,p.enableHighlight=A,p.snapToData=!0,"lighting"in t&&(p.ambientLight=t.lighting.ambient,p.diffuseLight=t.lighting.diffuse,p.specularLight=t.lighting.specular,p.roughness=t.lighting.roughness,p.fresnel=t.lighting.fresnel),"lightposition"in t&&(p.lightPosition=[t.lightposition.x,t.lightposition.y,t.lightposition.z])},p.dispose=function(){this.scene.glplot.remove(this.surface),this.surface.dispose()},e.exports=E},{"../../components/colorscale":662,"../../lib":787,"../../lib/gl_format_color":783,"../../lib/str2rgbarray":812,"../heatmap/find_empties":1075,"../heatmap/interp2d":1078,"gl-surface3d":346,ndarray:472,"ndarray-linear-interpolate":466}],1329:[function(t,e,r){"use strict";var n=t('../../registry'),i=t('../../lib'),a=t('../../components/colorscale/defaults'),o=t('./attributes'),s=.1;function l(t,e){for(var r=[],n=32,i=0;i<n;i++){var a=i/(n-1),o=e+(1-e)*(1-Math.pow(Math.sin(t*a*Math.PI),2));r.push([a,Math.max(0,Math.min(1,o))])}return r}function c(t){var e=0;if(!Array.isArray(t)||t.length<2)return!1;if(!t[0]||!t[t.length-1])return!1;if(0!==+t[0][0]||1!==+t[t.length-1][0])return!1;for(var r=0;r<t.length;r++){var n=t[r];if(2!==n.length||+n[0]<e)return!1;e=+n[0]}return!0}function u(t,e,r,s){var l,c;function u(r,n){return i.coerce(t,e,o,r,n)}var p=u('x'),d=u('y'),m=u('z');if(!m||!m.length||p&&p.length<1||d&&d.length<1)e.visible=!1;else{e._xlength=Array.isArray(p)&&i.isArrayOrTypedArray(p[0])?m.length:m[0].length,e._ylength=m.length,n.getComponentMethod('calendars','handleTraceDefaults')(t,e,["x",'y',"z"],s),u('text'),u('hovertext'),u('hovertemplate'),u('xhoverformat'),u('yhoverformat'),u('zhoverformat'),["lighting.ambient",'lighting.diffuse','lighting.specular','lighting.roughness','lighting.fresnel','lightposition.x','lightposition.y','lightposition.z','hidesurface','connectgaps',"opacity"].forEach((function(t){u(t)}));var g=u('surfacecolor'),v=["x",'y',"z"];for(l=0;l<3;++l){var y="contours."+v[l],x=u(y+".show"),b=u(y+".highlight");if(x||b)for(c=0;c<3;++c)u(y+".project."+v[c]);x&&(u(y+".color"),u(y+".width"),u(y+".usecolormap")),b&&(u(y+".highlightcolor"),u(y+".highlightwidth")),u(y+".start"),u(y+".end"),u(y+".size")}g||(h(t,'zmin','cmin'),h(t,'zmax','cmax'),h(t,'zauto','cauto')),a(t,e,s,u,{prefix:"",cLetter:"c"}),f(t,e,s,u),e._length=null}}function f(t,e,r,n){var i=n('opacityscale');"max"===i?e.opacityscale=[[0,s],[1,1]]:"min"===i?e.opacityscale=[[0,1],[1,s]]:"extremes"===i?e.opacityscale=l(1,s):c(i)||(e.opacityscale=void 0)}function h(t,e,r)[e in t&&!(r in t)&&(t[r]=t[e])]e.exports={supplyDefaults:u,opacityscaleDefaults:f}},{"../../components/colorscale/defaults":660,"../../lib":787,"../../registry":915,"./attributes":1326}],1330:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults').supplyDefaults,colorbar:{min:"cmin",max:"cmax"},calc:t('./calc'),plot:t('./convert'),moduleType:"trace",name:"surface",basePlotModule:t('../../plots/gl3d'),categories:["gl3d",'2dMap',"showLegend"],meta:{}}},{"../../plots/gl3d":880,"./attributes":1326,"./calc":1327,"./convert":1328,"./defaults":1329}],1331:[function(t,e,r){"use strict";var n=t('../../components/annotations/attributes'),i=t('../../lib/extend').extendFlat,a=t('../../plot_api/edit_types').overrideAll,o=t('../../plots/font_attributes'),s=t('../../plots/domain').attributes,l=t('../../plots/cartesian/axis_format_attributes').descriptionOnlyNumbers;(e.exports=a({domain:s({name:"table",trace:!0}),columnwidth:{valType:"number",arrayOk:!0,dflt:null},columnorder:{valType:"data_array"},header:{values:{valType:"data_array",dflt:[]},format:{valType:"data_array",dflt:[],description:l('cell value')},prefix:{valType:"string",arrayOk:!0,dflt:null},suffix:{valType:"string",arrayOk:!0,dflt:null},height:{valType:"number",dflt:28},align:i({},n.align,{arrayOk:!0}),line:{width:{valType:"number",arrayOk:!0,dflt:1},color:{valType:"color",arrayOk:!0,dflt:"grey"}},fill:{color:{valType:"color",arrayOk:!0,dflt:"white"}},font:i({},o({arrayOk:!0}))},cells:{values:{valType:"data_array",dflt:[]},format:{valType:"data_array",dflt:[],description:l('cell value')},prefix:{valType:"string",arrayOk:!0,dflt:null},suffix:{valType:"string",arrayOk:!0,dflt:null},height:{valType:"number",dflt:20},align:i({},n.align,{arrayOk:!0}),line:{width:{valType:"number",arrayOk:!0,dflt:1},color:{valType:"color",arrayOk:!0,dflt:"grey"}},fill:{color:{valType:"color",arrayOk:!0,dflt:"white"}},font:i({},o({arrayOk:!0}))}},'calc','from-root')).transforms=void 0},{"../../components/annotations/attributes":633,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/cartesian/axis_format_attributes":841,"../../plots/domain":866,"../../plots/font_attributes":867}],1332:[function(t,e,r){"use strict";var n=t('../../plots/get_data').getModuleCalcData,i=t('./plot'),a='table';r.name=a,r.plot=function(t){var e=n(t.calcdata,a)[0];e.length&&i(t,e)},r.clean=function(t,e,r,n){var i=n._has&&n._has(a),o=e._has&&e._has(a);i&&!o&&n._paperdiv.selectAll('.table').remove()}},{"../../plots/get_data":875,"./plot":1339}],1333:[function(t,e,r){"use strict";var n=t('../../lib/gup').wrap;e.exports=function(){return n({})}},{"../../lib/gup":784}],1334:[function(t,e,r){"use strict";e.exports={cellPad:8,columnExtentOffset:10,columnTitleOffset:28,emptyHeaderHeight:16,latexCheck:/^\$.*\$$/,goldenRatio:1.618,lineBreaker:"<br>",maxDimensionCount:60,overdrag:45,releaseTransitionDuration:120,releaseTransitionEase:"cubic-out",scrollbarCaptureWidth:18,scrollbarHideDelay:1e3,scrollbarHideDuration:1e3,scrollbarOffset:5,scrollbarWidth:8,transitionDuration:100,transitionEase:"cubic-out",uplift:5,wrapSpacer:" ',wrapSplitCharacter:' ",cn:{table:"table",tableControlView:"table-control-view",scrollBackground:"scroll-background",yColumn:"y-column",columnBlock:"column-block",scrollAreaClip:"scroll-area-clip",scrollAreaClipRect:"scroll-area-clip-rect",columnBoundary:"column-boundary",columnBoundaryClippath:"column-boundary-clippath",columnBoundaryRect:"column-boundary-rect",columnCells:"column-cells",columnCell:"column-cell",cellRect:"cell-rect",cellText:"cell-text",cellTextHolder:"cell-text-holder",scrollbarKit:"scrollbar-kit",scrollbar:"scrollbar",scrollbarSlider:"scrollbar-slider",scrollbarGlyph:"scrollbar-glyph",scrollbarCaptureZone:"scrollbar-capture-zone"}}},{}],1335:[function(t,e,r){"use strict";var n=t('./constants'),i=t('../../lib/extend').extendFlat,a=t('fast-isnumeric');function o(t){if(Array.isArray(t)){for(var e=0,r=0;r<t.length;r++)e=Math.max(e,o(t[r]));return e}return t}function s(t,e){return t+e}function l(t){var e,r=t.slice(),n=1/0,i=0;for(e=0;e<r.length;e++)Array.isArray(r[e])||(r[e]=[r[e]]),n=Math.min(n,r[e].length),i=Math.max(i,r[e].length);if(n!==i)for(e=0;e<r.length;e++){var a=i-r[e].length;a&&(r[e]=r[e].concat(c(a)))}return r}function c(t){for(var e=new Array(t),r=0;r<t;r++)e[r]='';return e}function u(t){return t.calcdata.columns.reduce((function(e,r){return r.xIndex<t.xIndex?e+r.columnWidth:e}),0)}function f(t,e){return Object.keys(t).map((function(r){return i({},t[r],{auxiliaryBlocks:e})}))}function h(t,e){for(var r,n={},i=0,a=0,o=p(),s=0,l=0,c=0;c<t.length;c++)r=t[c],o.rows.push({rowIndex:c,rowHeight:r}),((a+=r)>=e||c===t.length-1)&&(n[i]=o,o.key=l++,o.firstRowIndex=s,o.lastRowIndex=c,o=p(),i+=a,s=c+1,a=0);return n}function p(){return{firstRowIndex:null,lastRowIndex:null,rows:[]}}e.exports=function(t,e){var r=l(e.cells.values),p=function(t){return t.slice(e.header.values.length,t.length)},d=l(e.header.values);d.length&&!d[0].length&&(d[0]=[""],d=l(d));var m=d.concat(p(r).map((function(){return c((d[0]||[""]).length)}))),g=e.domain,v=Math.floor(t._fullLayout._size.w*(g.x[1]-g.x[0])),y=Math.floor(t._fullLayout._size.h*(g.y[1]-g.y[0])),x=e.header.values.length?m[0].map((function(){return e.header.height})):[n.emptyHeaderHeight],b=r.length?r[0].map((function(){return e.cells.height})):[],_=x.reduce(s,0),w=h(b,y-_+n.uplift),T=f(h(x,_),[]),k=f(w,T),M={},A=e._fullInput.columnorder.concat(p(r.map((function(t,e){return e})))),S=m.map((function(t,r){var n=Array.isArray(e.columnwidth)?e.columnwidth[Math.min(r,e.columnwidth.length-1)]:e.columnwidth;return a(n)?Number(n):1})),E=S.reduce(s,0);S=S.map((function(t){return t/E*v}));var L=Math.max(o(e.header.line.width),o(e.cells.line.width)),C={key:e.uid+t._context.staticPlot,translateX:g.x[0]*t._fullLayout._size.w,translateY:t._fullLayout._size.h*(1-g.y[1]),size:t._fullLayout._size,width:v,maxLineWidth:L,height:y,columnOrder:A,groupHeight:y,rowBlocks:k,headerRowBlocks:T,scrollY:0,cells:i({},e.cells,{values:r}),headerCells:i({},e.header,{values:m}),gdColumns:m.map((function(t){return t[0]})),gdColumnsOriginalOrder:m.map((function(t){return t[0]})),prevPages:[0,0],scrollbarState:{scrollbarScrollInProgress:!1},columns:m.map((function(t,e){var r=M[t];return M[t]=(r||0)+1,{key:t+"__"+M[t],label:t,specIndex:e,xIndex:A[e],xScale:u,x:void 0,calcdata:void 0,columnWidth:S[e]}}))};return C.columns.forEach((function(t){t.calcdata=C,t.x=u(t)})),C}},{"../../lib/extend":777,"./constants":1334,"fast-isnumeric":246}],1336:[function(t,e,r){"use strict";var n=t('../../lib/extend').extendFlat;function i(t){var e=t.rowBlocks[t.page],r=e?e.rows[0].rowIndex:0;return[r,e?r+e.rows.length:0]}r.splitToPanels=function(t){var e=[0,0],r=n({},t,{key:"header",type:"header",page:0,prevPages:e,currentRepaint:[null,null],dragHandle:!0,values:t.calcdata.headerCells.values[t.specIndex],rowBlocks:t.calcdata.headerRowBlocks,calcdata:n({},t.calcdata,{cells:t.calcdata.headerCells})});return[n({},t,{key:"cells1",type:"cells",page:0,prevPages:e,currentRepaint:[null,null],dragHandle:!1,values:t.calcdata.cells.values[t.specIndex],rowBlocks:t.calcdata.rowBlocks}),n({},t,{key:"cells2",type:"cells",page:1,prevPages:e,currentRepaint:[null,null],dragHandle:!1,values:t.calcdata.cells.values[t.specIndex],rowBlocks:t.calcdata.rowBlocks}),r]},r.splitToCells=function(t){var e=i(t);return(t.values||[]).slice(e[0],e[1]).map((function(r,n){return{keyWithinBlock:n+("string"===typeof r&&r.match(/[<$&> ]/)?"_keybuster_"+Math.random():""),key:e[0]+n,column:t,calcdata:t.calcdata,page:t.page,rowBlocks:t.rowBlocks,value:r}}))}},{"../../lib/extend":777}],1337:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../plots/domain').defaults;function o(t,e){for(var r=t.columnorder||[],n=t.header.values.length,i=r.slice(0,n),a=i.slice().sort((function(t,e){return t-e})),o=i.map((function(t){return a.indexOf(t)})),s=o.length;s<n;s++)o.push(s);e('columnorder',o)}e.exports=function(t,e,r,s){function l(r,a){return n.coerce(t,e,i,r,a)}a(e,s,l),l('columnwidth'),l('header.values'),l('header.format'),l('header.align'),l('header.prefix'),l('header.suffix'),l('header.height'),l('header.line.width'),l('header.line.color'),l('header.fill.color'),n.coerceFont(l,'header.font',n.extendFlat({},s.font)),o(e,l),l('cells.values'),l('cells.format'),l('cells.align'),l('cells.prefix'),l('cells.suffix'),l('cells.height'),l('cells.line.width'),l('cells.line.color'),l('cells.fill.color'),n.coerceFont(l,'cells.font',n.extendFlat({},s.font)),e._length=null}},{"../../lib":787,"../../plots/domain":866,"./attributes":1331}],1338:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('./calc'),plot:t('./plot'),moduleType:"trace",name:"table",basePlotModule:t('./base_plot'),categories:["noOpacity"],meta:{}}},{"./attributes":1331,"./base_plot":1332,"./calc":1333,"./defaults":1337,"./plot":1339}],1339:[function(t,e,r){"use strict";var n=t('./constants'),i=t('@plotly/d3'),a=t('../../lib').numberFormat,o=t('../../lib/gup'),s=t('../../components/drawing'),l=t('../../lib/svg_text_utils'),c=t('../../lib').raiseToTop,u=t('../../lib').strTranslate,f=t('../../lib').cancelTransition,h=t('./data_preparation_helper'),p=t('./data_split_helpers'),d=t('../../components/color');function m(t){return Math.ceil(t.calcdata.maxLineWidth/2)}function g(t,e){return"clip"+t._fullLayout._uid+"_scrollAreaBottomClip_"+e.key}function v(t,e){return"clip"+t._fullLayout._uid+"_columnBoundaryClippath_"+e.calcdata.key+"_"+e.specIndex}function y(t){return[].concat.apply([],t.map((function(t){return t}))).map((function(t){return t.__data__}))}function x(t,e,r){function a(t){var e=t.rowBlocks;return Y(e,e.length-1)+(e.length?W(e[e.length-1],1/0):1)}var s=t.selectAll("."+n.cn.scrollbarKit).data(o.repeat,o.keyFun);s.enter().append('g').classed(n.cn.scrollbarKit,!0).style('shape-rendering','geometricPrecision'),s.each((function(t){var e=t.scrollbarState;e.totalHeight=a(t),e.scrollableAreaHeight=t.groupHeight-F(t),e.currentlyVisibleHeight=Math.min(e.totalHeight,e.scrollableAreaHeight),e.ratio=e.currentlyVisibleHeight/e.totalHeight,e.barLength=Math.max(e.ratio*e.currentlyVisibleHeight,n.goldenRatio*n.scrollbarWidth),e.barWiggleRoom=e.currentlyVisibleHeight-e.barLength,e.wiggleRoom=Math.max(0,e.totalHeight-e.scrollableAreaHeight),e.topY=0===e.barWiggleRoom?0:t.scrollY/e.wiggleRoom*e.barWiggleRoom,e.bottomY=e.topY+e.barLength,e.dragMultiplier=e.wiggleRoom/e.barWiggleRoom})).attr('transform',(function(t){var e=t.width+n.scrollbarWidth/2+n.scrollbarOffset;return u(e,F(t))}));var l=s.selectAll("."+n.cn.scrollbar).data(o.repeat,o.keyFun);l.enter().append('g').classed(n.cn.scrollbar,!0);var c=l.selectAll("."+n.cn.scrollbarSlider).data(o.repeat,o.keyFun);c.enter().append('g').classed(n.cn.scrollbarSlider,!0),c.attr('transform',(function(t){return u(0,t.scrollbarState.topY||0)}));var f=c.selectAll("."+n.cn.scrollbarGlyph).data(o.repeat,o.keyFun);f.enter().append('line').classed(n.cn.scrollbarGlyph,!0).attr('stroke','black').attr('stroke-width',n.scrollbarWidth).attr('stroke-linecap','round').attr('y1',n.scrollbarWidth/2),f.attr('y2',(function(t){return t.scrollbarState.barLength-n.scrollbarWidth/2})).attr('stroke-opacity',(function(t){return t.columnDragInProgress||!t.scrollbarState.barWiggleRoom||r?0:.4})),f.transition().delay(0).duration(0),f.transition().delay(n.scrollbarHideDelay).duration(n.scrollbarHideDuration).attr('stroke-opacity',0);var h=l.selectAll("."+n.cn.scrollbarCaptureZone).data(o.repeat,o.keyFun);h.enter().append('line').classed(n.cn.scrollbarCaptureZone,!0).attr('stroke','white').attr('stroke-opacity',.01).attr('stroke-width',n.scrollbarCaptureWidth).attr('stroke-linecap','butt').attr('y1',0).on('mousedown',(function(r){var n=i.event.y,a=this.getBoundingClientRect(),o=r.scrollbarState,s=n-a.top,l=i.scale.linear().domain([0,o.scrollableAreaHeight]).range([0,o.totalHeight]).clamp(!0);o.topY<=s&&s<=o.bottomY||j(e,t,null,l(s-o.barLength/2))(r)})).call(i.behavior.drag().origin((function(t){return i.event.stopPropagation(),t.scrollbarState.scrollbarScrollInProgress=!0,t})).on('drag',j(e,t)).on('dragend',(function(){}))),h.attr('y2',(function(t){return t.scrollbarState.scrollableAreaHeight})),e._context.staticPlot&&(f.remove(),h.remove())}function b(t,e,r,n){var i=w(_(r));A(i),E(T(i));var a=k(M(i));S(a),L(a,e,n,t),G(i)}function _(t){var e=t.selectAll("."+n.cn.columnCells).data(o.repeat,o.keyFun);return e.enter().append('g').classed(n.cn.columnCells,!0),e.exit().remove(),e}function w(t){var e=t.selectAll("."+n.cn.columnCell).data(p.splitToCells,(function(t){return t.keyWithinBlock}));return e.enter().append('g').classed(n.cn.columnCell,!0),e.exit().remove(),e}function T(t){var e=t.selectAll("."+n.cn.cellRect).data(o.repeat,(function(t){return t.keyWithinBlock}));return e.enter().append('rect').classed(n.cn.cellRect,!0),e}function k(t){var e=t.selectAll("."+n.cn.cellText).data(o.repeat,(function(t){return t.keyWithinBlock}));return e.enter().append('text').classed(n.cn.cellText,!0).style('cursor',(function(){return"auto"})).on('mousedown',(function()[i.event.stopPropagation()])),e}function M(t){var e=t.selectAll("."+n.cn.cellTextHolder).data(o.repeat,(function(t){return t.keyWithinBlock}));return e.enter().append('g').classed(n.cn.cellTextHolder,!0).style('shape-rendering','geometricPrecision'),e}function A(t){t.each((function(t,e){var r=t.calcdata.cells.font,n=t.column.specIndex,i={size:z(r.size,n,e),color:z(r.color,n,e),family:z(r.family,n,e)};t.rowNumber=t.key,t.align=z(t.calcdata.cells.align,n,e),t.cellBorderWidth=z(t.calcdata.cells.line.width,n,e),t.font=i}))}function S(t){t.each((function(t){s.font(i.select(this),t.font)}))}function E(t){t.attr('width',(function(t){return t.column.columnWidth})).attr('stroke-width',(function(t){return t.cellBorderWidth})).each((function(t){var e=i.select(this);d.stroke(e,z(t.calcdata.cells.line.color,t.column.specIndex,t.rowNumber)),d.fill(e,z(t.calcdata.cells.fill.color,t.column.specIndex,t.rowNumber))}))}function L(t,e,r,o){t.text((function(t){var e=t.column.specIndex,r=t.rowNumber,i=t.value,o="string"===typeof i,s=o&&i.match(/<br>/i),l=!o||s;t.mayHaveMarkup=o&&i.match(/[<&>]/);var c=C(i);t.latex=c;var u,f,h=c?"":z(t.calcdata.cells.prefix,e,r)||"",p=c?"":z(t.calcdata.cells.suffix,e,r)||"",d=c?null:z(t.calcdata.cells.format,e,r)||null,m=h+(d?a(d)(t.value):t.value)+p;if(t.wrappingNeeded=!t.wrapped&&!l&&!c&&(u=P(m)),t.cellHeightMayIncrease=s||c||t.mayHaveMarkup||(void 0===u?P(m):u),t.needsConvertToTspans=t.mayHaveMarkup||t.wrappingNeeded||t.latex,t.wrappingNeeded){var g=(" '===n.wrapSplitCharacter?m.replace(/<a href=/gi,'<a_href='):m).split(n.wrapSplitCharacter),v=' "===n.wrapSplitCharacter?g.map((function(t){return t.replace(/<a_href=/gi,'<a href=')})):g;t.fragments=v.map((function(t){return{text:t,width:null}})),t.fragments.push({fragment:n.wrapSpacer,width:null}),f=v.join(n.lineBreaker)+n.lineBreaker+n.wrapSpacer}else delete t.fragments,f=m;return f})).attr('dy',(function(t){return t.needsConvertToTspans?0:"0.75em"})).each((function(t){var a=this,s=i.select(a),c=t.wrappingNeeded?V:H;t.needsConvertToTspans?l.convertToTspans(s,o,c(r,a,e,o,t)):i.select(a.parentNode).attr('transform',(function(t){return u(q(t),n.cellPad)})).attr('text-anchor',(function(t){return{left:"start",center:"middle",right:"end"}[t.align]}))}))}function C(t){return"string"===typeof t&&t.match(n.latexCheck)}function P(t){return-1!==t.indexOf(n.wrapSplitCharacter)}function I(t,e,r){var n=e.gdColumnsOriginalOrder;e.gdColumns.sort((function(t,e){return r[n.indexOf(t)]-r[n.indexOf(e)]})),e.columnorder=r,t.emit('plotly_restyle')}function z(t,e,r){if(Array.isArray(t)){var n=t[Math.min(e,t.length-1)];return Array.isArray(n)?n[Math.min(r,n.length-1)]:n}return t}function O(t,e,r){t.transition().ease(n.releaseTransitionEase).duration(n.releaseTransitionDuration).attr('transform',u(e.x,r))}function D(t){return"cells"===t.type}function R(t){return"header"===t.type}function F(t){return(t.rowBlocks.length?t.rowBlocks[0].auxiliaryBlocks:[]).reduce((function(t,e){return t+W(e,1/0)}),0)}function B(t,e,r){for(var n=[],i=0,a=0;a<t.length;a++){for(var o=t[a],s=o.rows,l=0,c=0;c<s.length;c++)l+=s[c].rowHeight;o.allRowsHeight=l,e<i+l&&e+r>i&&n.push(a),i+=l}return n}function N(t,e,r){var n=y(e)[0];if(void 0!==n){var i=n.rowBlocks,a=n.calcdata,o=Y(i,i.length),s=n.calcdata.groupHeight-F(n),l=a.scrollY=Math.max(0,Math.min(o-s,a.scrollY)),c=B(i,l,s);1===c.length&&(c[0]===i.length-1?c.unshift(c[0]-1):c.push(c[0]+1)),c[0]%2&&c.reverse(),e.each((function(t,e){t.page=c[e],t.scrollY=l})),e.attr('transform',(function(t){var e=Y(t.rowBlocks,t.page)-t.scrollY;return u(0,e)})),t&&(U(t,r,e,c,n.prevPages,n,0),U(t,r,e,c,n.prevPages,n,1),x(r,t))}}function j(t,e,r,a){return function(o){var s=o.calcdata?o.calcdata:o,l=e.filter((function(t){return s.key===t.key})),c=r||s.scrollbarState.dragMultiplier,u=s.scrollY;s.scrollY=void 0===a?s.scrollY+c*i.event.dy:a;var f=l.selectAll("."+n.cn.yColumn).selectAll("."+n.cn.columnBlock).filter(D);return N(t,f,l),s.scrollY===u}}function U(t,e,r,n,i,a,o){n[o]!==i[o]&&(clearTimeout(a.currentRepaint[o]),a.currentRepaint[o]=setTimeout((function(){var a=r.filter((function(t,e){return e===o&&n[e]!==i[e]}));b(t,e,a,r),i[o]=n[o]})))}function V(t,e,r,a){return function(){var o=i.select(e.parentNode);o.each((function(t){var e=t.fragments;o.selectAll('tspan.line').each((function(t,r){e[r].width=this.getComputedTextLength()}));var r,i,a=e[e.length-1].width,s=e.slice(0,-1),l=[],c=0,u=t.column.columnWidth-2*n.cellPad;for(t.value='';s.length;)c+(i=(r=s.shift()).width+a)>u&&(t.value+=l.join(n.wrapSpacer)+n.lineBreaker,l=[],c=0),l.push(r.text),c+=i;c&&(t.value+=l.join(n.wrapSpacer)),t.wrapped=!0})),o.selectAll('tspan.line').remove(),L(o.select("."+n.cn.cellText),r,t,a),i.select(e.parentNode.parentNode).call(G)}}function H(t,e,r,a,o){return function(){if(!o.settledY){var s=i.select(e.parentNode),l=Z(o),c=o.key-l.firstRowIndex,f=l.rows[c].rowHeight,h=o.cellHeightMayIncrease?e.parentNode.getBoundingClientRect().height+2*n.cellPad:f,p=Math.max(h,f);p-l.rows[c].rowHeight&&(l.rows[c].rowHeight=p,t.selectAll("."+n.cn.columnCell).call(G),N(null,t.filter(D),0),x(r,a,!0)),s.attr('transform',(function(){var t=this,e=t.parentNode.getBoundingClientRect(),r=i.select(t.parentNode).select("."+n.cn.cellRect).node().getBoundingClientRect(),a=t.transform.baseVal.consolidate(),s=r.top-e.top+(a?a.matrix.f:n.cellPad);return u(q(o,i.select(t.parentNode).select("."+n.cn.cellTextHolder).node().getBoundingClientRect().width),s)})),o.settledY=!0}}}function q(t,e){switch(t.align){case"left":default:return n.cellPad;case"right":return t.column.columnWidth-(e||0)-n.cellPad;case"center":return(t.column.columnWidth-(e||0))/2}}function G(t){t.attr('transform',(function(t){var e=t.rowBlocks[0].auxiliaryBlocks.reduce((function(t,e){return t+W(e,1/0)}),0),r=W(Z(t),t.key);return u(0,r+e)})).selectAll("."+n.cn.cellRect).attr('height',(function(t){return J(Z(t),t.key).rowHeight}))}function Y(t,e){for(var r=0,n=e-1;n>=0;n--)r+=X(t[n]);return r}function W(t,e){for(var r=0,n=0;n<t.rows.length&&t.rows[n].rowIndex<e;n++)r+=t.rows[n].rowHeight;return r}function X(t){var e=t.allRowsHeight;if(void 0!==e)return e;for(var r=0,n=0;n<t.rows.length;n++)r+=t.rows[n].rowHeight;return t.allRowsHeight=r,r}function Z(t){return t.rowBlocks[t.page]}function J(t,e){return t.rows[e-t.firstRowIndex]}e.exports=function(t,e){var r=!t._context.staticPlot,a=t._fullLayout._paper.selectAll("."+n.cn.table).data(e.map((function(e){var r=o.unwrap(e).trace;return h(t,r)})),o.keyFun);a.exit().remove(),a.enter().append('g').classed(n.cn.table,!0).attr('overflow','visible').style('box-sizing','content-box').style('position','absolute').style('left',0).style('overflow','visible').style('shape-rendering','crispEdges').style('pointer-events','all'),a.attr('width',(function(t){return t.width+t.size.l+t.size.r})).attr('height',(function(t){return t.height+t.size.t+t.size.b})).attr('transform',(function(t){return u(t.translateX,t.translateY)}));var l=a.selectAll("."+n.cn.tableControlView).data(o.repeat,o.keyFun),d=l.enter().append('g').classed(n.cn.tableControlView,!0).style('box-sizing','content-box');if(r){var _="onwheel"in document?"wheel":"mousewheel";d.on('mousemove',(function(e){l.filter((function(t){return e===t})).call(x,t)})).on(_,(function(e){if(!e.scrollbarState.wheeling){e.scrollbarState.wheeling=!0;var r=e.scrollY+i.event.deltaY;j(t,l,null,r)(e)||(i.event.stopPropagation(),i.event.preventDefault()),e.scrollbarState.wheeling=!1}})).call(x,t,!0)}l.attr('transform',(function(t){return u(t.size.l,t.size.t)}));var w=l.selectAll("."+n.cn.scrollBackground).data(o.repeat,o.keyFun);w.enter().append('rect').classed(n.cn.scrollBackground,!0).attr('fill','none'),w.attr('width',(function(t){return t.width})).attr('height',(function(t){return t.height})),l.each((function(e){s.setClipUrl(i.select(this),g(t,e),t)}));var T=l.selectAll("."+n.cn.yColumn).data((function(t){return t.columns}),o.keyFun);T.enter().append('g').classed(n.cn.yColumn,!0),T.exit().remove(),T.attr('transform',(function(t){return u(t.x,0)})),r&&T.call(i.behavior.drag().origin((function(e){return O(i.select(this),e,-n.uplift),c(this),e.calcdata.columnDragInProgress=!0,x(l.filter((function(t){return e.calcdata.key===t.key})),t),e})).on('drag',(function(t){var e=i.select(this),r=function(e){return(t===e?i.event.x:e.x)+e.columnWidth/2};t.x=Math.max(-n.overdrag,Math.min(t.calcdata.width+n.overdrag-t.columnWidth,i.event.x)),y(T).filter((function(e){return e.calcdata.key===t.calcdata.key})).sort((function(t,e){return r(t)-r(e)})).forEach((function(e,r){e.xIndex=r,e.x=t===e?e.x:e.xScale(e)})),T.filter((function(e){return t!==e})).transition().ease(n.transitionEase).duration(n.transitionDuration).attr('transform',(function(t){return u(t.x,0)})),e.call(f).attr('transform',u(t.x,-n.uplift))})).on('dragend',(function(e){var r=i.select(this),n=e.calcdata;e.x=e.xScale(e),e.calcdata.columnDragInProgress=!1,O(r,e,0),I(t,n,n.columns.map((function(t){return t.xIndex})))}))),T.each((function(e){s.setClipUrl(i.select(this),v(t,e),t)}));var k=T.selectAll("."+n.cn.columnBlock).data(p.splitToPanels,o.keyFun);k.enter().append('g').classed(n.cn.columnBlock,!0).attr('id',(function(t){return t.key})),k.style('cursor',(function(t){return t.dragHandle?"ew-resize":t.calcdata.scrollbarState.barWiggleRoom?"ns-resize":"default"}));var M=k.filter(R),A=k.filter(D);r&&A.call(i.behavior.drag().origin((function(t){return i.event.stopPropagation(),t})).on('drag',j(t,l,-1)).on('dragend',(function(){}))),b(t,l,M,k),b(t,l,A,k);var S=l.selectAll("."+n.cn.scrollAreaClip).data(o.repeat,o.keyFun);S.enter().append('clipPath').classed(n.cn.scrollAreaClip,!0).attr('id',(function(e){return g(t,e)}));var E=S.selectAll("."+n.cn.scrollAreaClipRect).data(o.repeat,o.keyFun);E.enter().append('rect').classed(n.cn.scrollAreaClipRect,!0).attr('x',-n.overdrag).attr('y',-n.uplift).attr('fill','none'),E.attr('width',(function(t){return t.width+2*n.overdrag})).attr('height',(function(t){return t.height+n.uplift})),T.selectAll("."+n.cn.columnBoundary).data(o.repeat,o.keyFun).enter().append('g').classed(n.cn.columnBoundary,!0);var L=T.selectAll("."+n.cn.columnBoundaryClippath).data(o.repeat,o.keyFun);L.enter().append('clipPath').classed(n.cn.columnBoundaryClippath,!0),L.attr('id',(function(e){return v(t,e)}));var C=L.selectAll("."+n.cn.columnBoundaryRect).data(o.repeat,o.keyFun);C.enter().append('rect').classed(n.cn.columnBoundaryRect,!0).attr('fill','none'),C.attr('width',(function(t){return t.columnWidth+2*m(t)})).attr('height',(function(t){return t.calcdata.height+2*m(t)+n.uplift})).attr('x',(function(t){return-m(t)})).attr('y',(function(t){return-m(t)})),N(null,A,l)}},{"../../components/color":650,"../../components/drawing":672,"../../lib":787,"../../lib/gup":784,"../../lib/svg_text_utils":813,"./constants":1334,"./data_preparation_helper":1335,"./data_split_helpers":1336,"@plotly/d3":58}],1340:[function(t,e,r){"use strict";var n=t('../../plots/template_attributes').hovertemplateAttrs,i=t('../../plots/template_attributes').texttemplateAttrs,a=t('../../components/colorscale/attributes'),o=t('../../plots/domain').attributes,s=t('../pie/attributes'),l=t('../sunburst/attributes'),c=t('./constants'),u=t('../../lib/extend').extendFlat;e.exports={labels:l.labels,parents:l.parents,values:l.values,branchvalues:l.branchvalues,count:l.count,level:l.level,maxdepth:l.maxdepth,tiling:{packing:{valType:"enumerated",values:["squarify",'binary','dice','slice','slice-dice',"dice-slice"],dflt:"squarify",editType:"plot"},squarifyratio:{valType:"number",min:1,dflt:1,editType:"plot"},flip:{valType:"flaglist",flags:["x","y"],dflt:"",editType:"plot"},pad:{valType:"number",min:0,dflt:3,editType:"plot"},editType:"calc"},marker:u({pad:{t:{valType:"number",min:0,editType:"plot"},l:{valType:"number",min:0,editType:"plot"},r:{valType:"number",min:0,editType:"plot"},b:{valType:"number",min:0,editType:"plot"},editType:"calc"},colors:l.marker.colors,depthfade:{valType:"enumerated",values:[!0,!1,"reversed"],editType:"style"},line:l.marker.line,editType:"calc"},a('marker',{colorAttr:"colors",anim:!1})),pathbar:{visible:{valType:"boolean",dflt:!0,editType:"plot"},side:{valType:"enumerated",values:["top","bottom"],dflt:"top",editType:"plot"},edgeshape:{valType:"enumerated",values:[">",'<','|','/',"\\"],dflt:">",editType:"plot"},thickness:{valType:"number",min:12,editType:"plot"},textfont:u({},s.textfont,{}),editType:"calc"},text:s.text,textinfo:l.textinfo,texttemplate:i({editType:"plot"},{keys:c.eventDataKeys.concat(["label","value"])}),hovertext:s.hovertext,hoverinfo:l.hoverinfo,hovertemplate:n({},{keys:c.eventDataKeys}),textfont:s.textfont,insidetextfont:s.insidetextfont,outsidetextfont:u({},s.outsidetextfont,{}),textposition:{valType:"enumerated",values:["top left",'top center','top right','middle left','middle center','middle right','bottom left','bottom center',"bottom right"],dflt:"top left",editType:"plot"},sort:s.sort,root:l.root,domain:o({name:"treemap",trace:!0,editType:"calc"})}},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plots/domain":866,"../../plots/template_attributes":910,"../pie/attributes":1176,"../sunburst/attributes":1314,"./constants":1343}],1341:[function(t,e,r){"use strict";var n=t('../../plots/plots');r.name='treemap',r.plot=function(t,e,i,a){n.plotBasePlot(r.name,t,e,i,a)},r.clean=function(t,e,i,a){n.cleanBasePlot(r.name,t,e,i,a)}},{"../../plots/plots":901}],1342:[function(t,e,r){"use strict";var n=t('../sunburst/calc');r.calc=function(t,e){return n.calc(t,e)},r.crossTraceCalc=function(t){return n._runCrossTraceCalc('treemap',t)}},{"../sunburst/calc":1316}],1343:[function(t,e,r){"use strict";e.exports={CLICK_TRANSITION_TIME:750,CLICK_TRANSITION_EASING:"poly",eventDataKeys:["currentPath",'root','entry','percentRoot','percentEntry',"percentParent"],gapWithPathbar:1}},{}],1344:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../../components/color'),o=t('../../plots/domain').defaults,s=t('../bar/defaults').handleText,l=t('../bar/constants').TEXTPAD,c=t('../../components/colorscale'),u=c.hasColorscale,f=c.handleDefaults;e.exports=function(t,e,r,c){function h(r,a){return n.coerce(t,e,i,r,a)}var p=h('labels'),d=h('parents');if(p&&p.length&&d&&d.length){var m=h('values');m&&m.length?h('branchvalues'):h('count'),h('level'),h('maxdepth'),"squarify"===h('tiling.packing')&&h('tiling.squarifyratio'),h('tiling.flip'),h('tiling.pad');var g=h('text');h('texttemplate'),e.texttemplate||h('textinfo',Array.isArray(g)?"text+label":"label"),h('hovertext'),h('hovertemplate');var v=h('pathbar.visible');s(t,e,c,h,'auto',{hasPathbar:v,moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!1,moduleHasCliponaxis:!1,moduleHasTextangle:!1,moduleHasInsideanchor:!1}),h('textposition');var y=-1!==e.textposition.indexOf('bottom');h('marker.line.width')&&h('marker.line.color',c.paper_bgcolor);var x=h('marker.colors');(e._hasColorscale=u(t,'marker','colors')||(t.marker||{}).coloraxis)?f(t,e,c,h,{prefix:"marker.",cLetter:"c"}):h('marker.depthfade',!(x||[]).length);var b=2*e.textfont.size;h('marker.pad.t',y?b/4:b),h('marker.pad.l',b/4),h('marker.pad.r',b/4),h('marker.pad.b',y?b:b/4),e._hovered={marker:{line:{width:2,color:a.contrast(c.paper_bgcolor)}}},v&&(h('pathbar.thickness',e.pathbar.textfont.size+2*l),h('pathbar.side'),h('pathbar.edgeshape')),h('sort'),h('root.color'),o(e,c,h),e._length=null}else e.visible=!1}},{"../../components/color":650,"../../components/colorscale":662,"../../lib":787,"../../plots/domain":866,"../bar/constants":927,"../bar/defaults":929,"./attributes":1340}],1345:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../sunburst/helpers'),a=t('../bar/uniform_text').clearMinTextSize,o=t('../bar/style').resizeText,s=t('./plot_one');e.exports=function(t,e,r,l,c){var u,f,h=c.type,p=c.drawDescendants,d=t._fullLayout,m=d["_"+h+"layer"],g=!r;a(h,d),(u=m.selectAll("g.trace."+h).data(e,(function(t){return t[0].trace.uid}))).enter().append('g').classed('trace',!0).classed(h,!0),u.order(),!d.uniformtext.mode&&i.hasTransition(r)?(l&&(f=l()),n.transition().duration(r.duration).ease(r.easing).each('end',(function()[f&&f()])).each('interrupt',(function()[f&&f()])).each((function(){m.selectAll('g.trace').each((function(e){s(t,e,this,r,p)}))}))):(u.each((function(e){s(t,e,this,r,p)})),d.uniformtext.mode&&o(t,m.selectAll('.trace'),h)),g&&u.exit().remove()}},{"../bar/style":939,"../bar/uniform_text":941,"../sunburst/helpers":1320,"./plot_one":1354,"@plotly/d3":58}],1346:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../../lib/svg_text_utils'),s=t('./partition'),l=t('./style').styleOne,c=t('./constants'),u=t('../sunburst/helpers'),f=t('../sunburst/fx'),h=!0;e.exports=function(t,e,r,p,d){var m=d.barDifY,g=d.width,v=d.height,y=d.viewX,x=d.viewY,b=d.pathSlice,_=d.toMoveInsideSlice,w=d.strTransform,T=d.hasTransition,k=d.handleSlicesExit,M=d.makeUpdateSliceInterpolator,A=d.makeUpdateTextInterpolator,S={},E=t._fullLayout,L=e[0],C=L.trace,P=L.hierarchy,I=g/C._entryDepth,z=u.listPath(r.data,'id'),O=s(P.copy(),[g,v],{packing:"dice",pad:{inner:0,top:0,left:0,right:0,bottom:0}}).descendants();(O=O.filter((function(t){var e=z.indexOf(t.data.id);return-1!==e&&(t.x0=I*e,t.x1=I*(e+1),t.y0=m,t.y1=m+v,t.onPathbar=!0,!0)}))).reverse(),(p=p.data(O,u.getPtId)).enter().append('g').classed('pathbar',!0),k(p,h,S,[g,v],b),p.order();var D=p;T&&(D=D.transition().each('end',(function(){var e=n.select(this);u.setSliceCursor(e,t,{hideOnRoot:!1,hideOnLeaves:!1,isTransitioning:!1})}))),D.each((function(s){s._x0=y(s.x0),s._x1=y(s.x1),s._y0=x(s.y0),s._y1=x(s.y1),s._hoverX=y(s.x1-Math.min(g,v)/2),s._hoverY=x(s.y1-v/2);var p=n.select(this),d=i.ensureSingle(p,'path','surface',(function(t){t.style('pointer-events','all')}));T?d.transition().attrTween('d',(function(t){var e=M(t,h,S,[g,v]);return function(t){return b(e(t))}})):d.attr('d',b),p.call(f,r,t,e,{styleOne:l,eventDataKeys:c.eventDataKeys,transitionTime:c.CLICK_TRANSITION_TIME,transitionEasing:c.CLICK_TRANSITION_EASING}).call(u.setSliceCursor,t,{hideOnRoot:!1,hideOnLeaves:!1,isTransitioning:t._transitioning}),d.call(l,s,C,{hovered:!1}),s._text=(u.getPtLabel(s)||"").split('<br>').join(' ')||"";var m=i.ensureSingle(p,'g','slicetext'),k=i.ensureSingle(m,'text','',(function(t){t.attr('data-notex',1)})),L=i.ensureUniformFontSize(t,u.determineTextFont(C,s,E.font,{onPathbar:!0}));k.text(s._text||" ').classed('slicetext',!0).attr('text-anchor','start').call(a.font,L).call(o.convertToTspans,t),s.textBB=a.bBox(k.node()),s.transform=_(s,{fontSize:L.size,onPathbar:!0}),s.transform.fontSize=L.size,T?k.transition().attrTween('transform',(function(t){var e=A(t,h,S,[g,v]);return function(t){return w(e(t))}})):k.attr('transform',w(s))}))}},{'../../components/drawing":672,"../../lib":787,"../../lib/svg_text_utils":813,"../sunburst/fx":1319,"../sunburst/helpers":1320,"./constants":1343,"./partition":1352,"./style":1355,"@plotly/d3":58}],1347:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../../lib/svg_text_utils'),s=t('./partition'),l=t('./style').styleOne,c=t('./constants'),u=t('../sunburst/helpers'),f=t('../sunburst/fx'),h=t('../sunburst/plot').formatSliceLabel,p=!1;e.exports=function(t,e,r,d,m){var g=m.width,v=m.height,y=m.viewX,x=m.viewY,b=m.pathSlice,_=m.toMoveInsideSlice,w=m.strTransform,T=m.hasTransition,k=m.handleSlicesExit,M=m.makeUpdateSliceInterpolator,A=m.makeUpdateTextInterpolator,S=m.prevEntry,E={},L=t._fullLayout,C=e[0].trace,P=-1!==C.textposition.indexOf('left'),I=-1!==C.textposition.indexOf('right'),z=-1!==C.textposition.indexOf('bottom'),O=!z&&!C.marker.pad.t||z&&!C.marker.pad.b,D=s(r,[g,v],{packing:C.tiling.packing,squarifyratio:C.tiling.squarifyratio,flipX:C.tiling.flip.indexOf('x')>-1,flipY:C.tiling.flip.indexOf('y')>-1,pad:{inner:C.tiling.pad,top:C.marker.pad.t,left:C.marker.pad.l,right:C.marker.pad.r,bottom:C.marker.pad.b}}).descendants(),R=1/0,F=-1/0;D.forEach((function(t){var e=t.depth;e>=C._maxDepth?(t.x0=t.x1=(t.x0+t.x1)/2,t.y0=t.y1=(t.y0+t.y1)/2):(R=Math.min(R,e),F=Math.max(F,e))})),d=d.data(D,u.getPtId),C._maxVisibleLayers=isFinite(F)?F-R+1:0,d.enter().append('g').classed('slice',!0),k(d,p,E,[g,v],b),d.order();var B=null;if(T&&S){var N=u.getPtId(S);d.each((function(t){null===B&&u.getPtId(t)===N&&(B={x0:t.x0,x1:t.x1,y0:t.y0,y1:t.y1})}))}var j=function(){return B||{x0:0,x1:g,y0:0,y1:v}},U=d;return T&&(U=U.transition().each('end',(function(){var e=n.select(this);u.setSliceCursor(e,t,{hideOnRoot:!0,hideOnLeaves:!1,isTransitioning:!1})}))),U.each((function(s){var d=u.isHeader(s,C);s._x0=y(s.x0),s._x1=y(s.x1),s._y0=x(s.y0),s._y1=x(s.y1),s._hoverX=y(s.x1-C.marker.pad.r),s._hoverY=x(z?s.y1-C.marker.pad.b/2:s.y0+C.marker.pad.t/2);var m=n.select(this),k=i.ensureSingle(m,'path','surface',(function(t){t.style('pointer-events','all')}));T?k.transition().attrTween('d',(function(t){var e=M(t,p,j(),[g,v]);return function(t){return b(e(t))}})):k.attr('d',b),m.call(f,r,t,e,{styleOne:l,eventDataKeys:c.eventDataKeys,transitionTime:c.CLICK_TRANSITION_TIME,transitionEasing:c.CLICK_TRANSITION_EASING}).call(u.setSliceCursor,t,{isTransitioning:t._transitioning}),k.call(l,s,C,{hovered:!1}),s.x0===s.x1||s.y0===s.y1?s._text="":s._text=d?O?"":u.getPtLabel(s)||"":h(s,r,C,e,L)||"";var S=i.ensureSingle(m,'g','slicetext'),E=i.ensureSingle(S,'text','',(function(t){t.attr('data-notex',1)})),D=i.ensureUniformFontSize(t,u.determineTextFont(C,s,L.font));E.text(s._text||" ").classed('slicetext',!0).attr('text-anchor',I?"end":P||d?"start":"middle").call(a.font,D).call(o.convertToTspans,t),s.textBB=a.bBox(E.node()),s.transform=_(s,{fontSize:D.size,isHeader:d}),s.transform.fontSize=D.size,T?E.transition().attrTween('transform',(function(t){var e=A(t,p,j(),[g,v]);return function(t){return w(e(t))}})):E.attr('transform',w(s))})),B}},{"../../components/drawing":672,"../../lib":787,"../../lib/svg_text_utils":813,"../sunburst/fx":1319,"../sunburst/helpers":1320,"../sunburst/plot":1324,"./constants":1343,"./partition":1352,"./style":1355,"@plotly/d3":58}],1348:[function(t,e,r){"use strict";e.exports=function t(e,r,n){var i;n.swapXY&&(i=e.x0,e.x0=e.y0,e.y0=i,i=e.x1,e.x1=e.y1,e.y1=i),n.flipX&&(i=e.x0,e.x0=r[0]-e.x1,e.x1=r[0]-i),n.flipY&&(i=e.y0,e.y0=r[1]-e.y1,e.y1=r[1]-i);var a=e.children;if(a)for(var o=0;o<a.length;o++)t(a[o],r,n)}},{}],1349:[function(t,e,r){"use strict";e.exports={moduleType:"trace",name:"treemap",basePlotModule:t('./base_plot'),categories:[],animatable:!0,attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults'),supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc').calc,crossTraceCalc:t('./calc').crossTraceCalc,plot:t('./plot'),style:t('./style').style,colorbar:t('../scatter/marker_colorbar'),meta:{}}},{"../scatter/marker_colorbar":1220,"./attributes":1340,"./base_plot":1341,"./calc":1342,"./defaults":1344,"./layout_attributes":1350,"./layout_defaults":1351,"./plot":1353,"./style":1355}],1350:[function(t,e,r){"use strict";e.exports={treemapcolorway:{valType:"colorlist",editType:"calc"},extendtreemapcolors:{valType:"boolean",dflt:!0,editType:"calc"}}},{}],1351:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e){function r(r,a){return n.coerce(t,e,i,r,a)}r('treemapcolorway',e.colorway),r('extendtreemapcolors')}},{"../../lib":787,"./layout_attributes":1350}],1352:[function(t,e,r){"use strict";var n=t('d3-hierarchy'),i=t('./flip_tree');function a(t,e){switch(t){case"squarify":return n.treemapSquarify.ratio(e);case"binary":return n.treemapBinary;case"dice":return n.treemapDice;case"slice":return n.treemapSlice;default:return n.treemapSliceDice}}e.exports=function(t,e,r){var o,s=r.flipX,l=r.flipY,c="dice-slice"===r.packing,u=r.pad[l?"bottom":"top"],f=r.pad[s?"right":"left"],h=r.pad[s?"left":"right"],p=r.pad[l?"top":"bottom"];c&&(o=f,f=u,u=o,o=h,h=p,p=o);var d=n.treemap().tile(a(r.packing,r.squarifyratio)).paddingInner(r.pad.inner).paddingLeft(f).paddingRight(h).paddingTop(u).paddingBottom(p).size(c?[e[1],e[0]]:e)(t);return(c||s||l)&&i(d,e,{swapXY:c,flipX:s,flipY:l}),d}},{"./flip_tree":1348,"d3-hierarchy":167}],1353:[function(t,e,r){"use strict";var n=t('./draw'),i=t('./draw_descendants');e.exports=function(t,e,r,a){return n(t,e,r,a,{type:"treemap",drawDescendants:i})}},{"./draw":1345,"./draw_descendants":1347}],1354:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('d3-interpolate').interpolate,a=t('../sunburst/helpers'),o=t('../../lib'),s=t('../bar/constants').TEXTPAD,l=t('../bar/plot').toMoveInsideBar,c=t('../bar/uniform_text').recordMinTextSize,u=t('./constants'),f=t('./draw_ancestors');function h(t){return a.isHierarchyRoot(t)?"":a.getPtId(t)}e.exports=function(t,e,r,p,d){var m=t._fullLayout,g=e[0],v=g.trace,y="icicle"===v.type,x=g.hierarchy,b=a.findEntryWithLevel(x,v.level),_=n.select(r),w=_.selectAll('g.pathbar'),T=_.selectAll('g.slice');if(!b)return w.remove(),void T.remove();var k=a.isHierarchyRoot(b),M=!m.uniformtext.mode&&a.hasTransition(p),A=a.getMaxDepth(v),S=function(t){return t.data.depth-b.data.depth<A},E=m._size,L=v.domain,C=E.w*(L.x[1]-L.x[0]),P=E.h*(L.y[1]-L.y[0]),I=C,z=v.pathbar.thickness,O=v.marker.line.width+u.gapWithPathbar,D=v.pathbar.visible?v.pathbar.side.indexOf('bottom')>-1?P+O:-(z+O):0,R={x0:I,x1:I,y0:D,y1:D+z},F=function(t,e,r){var n=v.tiling.pad,i=function(t){return t-n<=e.x0},a=function(t){return t+n>=e.x1},o=function(t){return t-n<=e.y0},s=function(t){return t+n>=e.y1};return t.x0===e.x0&&t.x1===e.x1&&t.y0===e.y0&&t.y1===e.y1?{x0:t.x0,x1:t.x1,y0:t.y0,y1:t.y1}:{x0:i(t.x0-n)?0:a(t.x0-n)?r[0]:t.x0,x1:i(t.x1+n)?0:a(t.x1+n)?r[0]:t.x1,y0:o(t.y0-n)?0:s(t.y0-n)?r[1]:t.y0,y1:o(t.y1+n)?0:s(t.y1+n)?r[1]:t.y1}},B=null,N={},j={},U=null,V=function(t,e){return e?N[h(t)]:j[h(t)]},H=function(t,e,r,n){if(e)return N[h(x)]||R;var i=j[v.level]||r;return S(t)?F(t,i,n):{}};g.hasMultipleRoots&&k&&A++,v._maxDepth=A,v._backgroundColor=m.paper_bgcolor,v._entryDepth=b.data.depth,v._atRootLevel=k;var q=-C/2+E.l+E.w*(L.x[1]+L.x[0])/2,G=-P/2+E.t+E.h*(1-(L.y[1]+L.y[0])/2),Y=function(t){return q+t},W=function(t){return G+t},X=W(0),Z=Y(0),J=function(t){return Z+t},K=function(t){return X+t};function Q(t,e){return t+","+e}var $=J(0),tt=function(t){t.x=Math.max($,t.x)},et=v.pathbar.edgeshape,rt=function(t){var e=J(Math.max(Math.min(t.x0,t.x0),0)),r=J(Math.min(Math.max(t.x1,t.x1),I)),n=K(t.y0),i=K(t.y1),a=z/2,o={},s={};o.x=e,s.x=r,o.y=s.y=(n+i)/2;var l={x:e,y:n},c={x:r,y:n},u={x:r,y:i},f={x:e,y:i};return">"===et?(l.x-=a,c.x-=a,u.x-=a,f.x-=a):"/"===et?(u.x-=a,f.x-=a,o.x-=a/2,s.x-=a/2):"\\"===et?(l.x-=a,c.x-=a,o.x-=a/2,s.x-=a/2):"<"===et&&(o.x-=a,s.x-=a),tt(l),tt(f),tt(o),tt(c),tt(u),tt(s),"M"+Q(l.x,l.y)+"L"+Q(c.x,c.y)+"L"+Q(s.x,s.y)+"L"+Q(u.x,u.y)+"L"+Q(f.x,f.y)+"L"+Q(o.x,o.y)+"Z"},nt=function(t){var e=Y(t.x0),r=Y(t.x1),n=W(t.y0),i=W(t.y1),a=r-e,o=i-n;if(!a||!o)return'';var s=0,l=a>2*s&&o>2*s?s:0,c=function(t,e){return l?"a"+Q(l,l)+" 0 0 1 "+Q(t,e):""};return"M"+Q(e,n+l)+c(l,-l)+"L"+Q(r-l,n)+c(l,l)+"L"+Q(r,i-l)+c(-l,l)+"L"+Q(e+l,i)+c(-l,-l)+"Z"},it=function(t,e){var r=t.x0,n=t.x1,i=t.y0,a=t.y1,o=t.textBB,u=function(t){return-1!==v.textposition.indexOf(t)},f=u('bottom'),h=u('top')||e.isHeader&&!f?"start":f?"end":"middle",p=u('right'),d=u('left')||e.onPathbar?-1:p?1:0,g=v[y?"tiling":"marker"].pad;if(e.isHeader){if((r+=(y?g:g.l)-s)>=(n-=(y?g:g.r)-s)){var x=(r+n)/2;r=x,n=x}var b;f?i<(b=a-(y?g:g.b))&&b<a&&(i=b):i<(b=i+(y?g:g.t))&&b<a&&(a=b)}var _=l(r,n,i,a,o,{isHorizontal:!1,constrained:!0,angle:0,anchor:h,leftToRight:d});return _.fontSize=e.fontSize,_.targetX=Y(_.targetX),_.targetY=W(_.targetY),isNaN(_.targetX)||isNaN(_.targetY)?{}:(r!==n&&i!==a&&c(v.type,_,m),{scale:_.scale,rotate:_.rotate,textX:_.textX,textY:_.textY,anchorX:_.anchorX,anchorY:_.anchorY,targetX:_.targetX,targetY:_.targetY})},at=function(t,e){for(var r,n=0,i=t;!r&&n<A;)n++,(i=i.parent)?r=V(i,e):n=A;return r||{}},ot=function(t,e,r,n){var a,o=V(t,e);if(e)a=R;else{var s=V(b,e);a=s?F(t,s,n):{}}return i(o,a)},st=function(t,e,r,n,a){var s,l=V(t,e);if(l)s=l;else if(e)s=R;else if(B)if(t.parent){var c=U||r;c&&!e?s=F(t,c,n):(s={},o.extendFlat(s,at(t,e)))}else s=o.extendFlat({},t),y&&("h"===a.orientation?a.flipX?s.x0=t.x1:s.x1=0:a.flipY?s.y0=t.y1:s.y1=0);else s={};return i(s,{x0:t.x0,x1:t.x1,y0:t.y0,y1:t.y1})},lt=function(t,e,r,n){var s=V(t,e),l={},u=H(t,e,r,n);o.extendFlat(l,{transform:it({x0:u.x0,x1:u.x1,y0:u.y0,y1:u.y1,textBB:t.textBB,_text:t._text},{isHeader:a.isHeader(t,v)})}),s?l=s:t.parent&&o.extendFlat(l,at(t,e));var f=t.transform;return t.x0!==t.x1&&t.y0!==t.y1&&c(v.type,f,m),i(l,{transform:{scale:f.scale,rotate:f.rotate,textX:f.textX,textY:f.textY,anchorX:f.anchorX,anchorY:f.anchorY,targetX:f.targetX,targetY:f.targetY}})},ct=function(t,e,r,i,a){var o=i[0],s=i[1];M?t.exit().transition().each((function(){var t=n.select(this);t.select('path.surface').transition().attrTween('d',(function(t){var n=ot(t,e,r,[o,s]);return function(t){return a(n(t))}})),t.select('g.slicetext').attr('opacity',0)})).remove():t.exit().remove()},ut=function(t){var e=t.transform;return t.x0!==t.x1&&t.y0!==t.y1&&c(v.type,e,m),o.getTextTransform({textX:e.textX,textY:e.textY,anchorX:e.anchorX,anchorY:e.anchorY,targetX:e.targetX,targetY:e.targetY,scale:e.scale,rotate:e.rotate})};M&&(w.each((function(t){N[h(t)]={x0:t.x0,x1:t.x1,y0:t.y0,y1:t.y1},t.transform&&(N[h(t)].transform={textX:t.transform.textX,textY:t.transform.textY,anchorX:t.transform.anchorX,anchorY:t.transform.anchorY,targetX:t.transform.targetX,targetY:t.transform.targetY,scale:t.transform.scale,rotate:t.transform.rotate})})),T.each((function(t){j[h(t)]={x0:t.x0,x1:t.x1,y0:t.y0,y1:t.y1},t.transform&&(j[h(t)].transform={textX:t.transform.textX,textY:t.transform.textY,anchorX:t.transform.anchorX,anchorY:t.transform.anchorY,targetX:t.transform.targetX,targetY:t.transform.targetY,scale:t.transform.scale,rotate:t.transform.rotate}),!B&&a.isEntry(t)&&(B=t)}))),U=d(t,e,b,T,{width:C,height:P,viewX:Y,viewY:W,pathSlice:nt,toMoveInsideSlice:it,prevEntry:B,makeUpdateSliceInterpolator:st,makeUpdateTextInterpolator:lt,handleSlicesExit:ct,hasTransition:M,strTransform:ut}),v.pathbar.visible?f(t,e,b,w,{barDifY:D,width:I,height:z,viewX:J,viewY:K,pathSlice:rt,toMoveInsideSlice:it,makeUpdateSliceInterpolator:st,makeUpdateTextInterpolator:lt,handleSlicesExit:ct,hasTransition:M,strTransform:ut}):w.remove()}},{"../../lib":787,"../bar/constants":927,"../bar/plot":936,"../bar/uniform_text":941,"../sunburst/helpers":1320,"./constants":1343,"./draw_ancestors":1346,"@plotly/d3":58,"d3-interpolate":168}],1355:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../../lib'),o=t('../sunburst/helpers'),s=t('../bar/uniform_text').resizeText;function l(t){var e=t._fullLayout._treemaplayer.selectAll('.trace');s(t,e,'treemap'),e.each((function(t){var e=n.select(this),r=t[0].trace;e.style('opacity',r.opacity),e.selectAll('path.surface').each((function(t){n.select(this).call(c,t,r,{hovered:!1})}))}))}function c(t,e,r,n){var s,l,c=(n||{}).hovered,u=e.data.data,f=u.i,h=u.color,p=o.isHierarchyRoot(e),d=1;if(c)s=r._hovered.marker.line.color,l=r._hovered.marker.line.width;else if(p&&h===r.root.color)d=100,s='rgba(0,0,0,0)',l=0;else if(s=a.castOption(r,f,'marker.line.color')||i.defaultLine,l=a.castOption(r,f,'marker.line.width')||0,!r._hasColorscale&&!e.onPathbar){var m=r.marker.depthfade;if(m){var g,v=i.combine(i.addOpacity(r._backgroundColor,.75),h);if(!0===m){var y=o.getMaxDepth(r);g=isFinite(y)?o.isLeaf(e)?0:r._maxVisibleLayers-(e.data.depth-r._entryDepth):e.data.height+1}else g=e.data.depth-r._entryDepth,r._atRootLevel||g++;if(g>0)for(var x=0;x<g;x++){var b=.5*x/g;h=i.combine(i.addOpacity(v,b),h)}}}t.style('stroke-width',l).call(i.fill,h).call(i.stroke,s).style('opacity',d)}e.exports={style:l,styleOne:c}},{"../../components/color":650,"../../lib":787,"../bar/uniform_text":941,"../sunburst/helpers":1320,"@plotly/d3":58}],1356:[function(t,e,r){"use strict";var n=t('../box/attributes'),i=t('../../lib/extend').extendFlat,a=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat;e.exports={y:n.y,x:n.x,x0:n.x0,y0:n.y0,xhoverformat:a('x'),yhoverformat:a('y'),name:i({},n.name,{}),orientation:i({},n.orientation,{}),bandwidth:{valType:"number",min:0,editType:"calc"},scalegroup:{valType:"string",dflt:"",editType:"calc"},scalemode:{valType:"enumerated",values:["width","count"],dflt:"width",editType:"calc"},spanmode:{valType:"enumerated",values:["soft",'hard',"manual"],dflt:"soft",editType:"calc"},span:{valType:"info_array",items:[{valType:"any",editType:"calc"},{valType:"any",editType:"calc"}],editType:"calc"},line:{color:{valType:"color",editType:"style"},width:{valType:"number",min:0,dflt:2,editType:"style"},editType:"plot"},fillcolor:n.fillcolor,points:i({},n.boxpoints,{}),jitter:i({},n.jitter,{}),pointpos:i({},n.pointpos,{}),width:i({},n.width,{}),marker:n.marker,text:n.text,hovertext:n.hovertext,hovertemplate:n.hovertemplate,box:{visible:{valType:"boolean",dflt:!1,editType:"plot"},width:{valType:"number",min:0,max:1,dflt:.25,editType:"plot"},fillcolor:{valType:"color",editType:"style"},line:{color:{valType:"color",editType:"style"},width:{valType:"number",min:0,editType:"style"},editType:"style"},editType:"plot"},meanline:{visible:{valType:"boolean",dflt:!1,editType:"plot"},color:{valType:"color",editType:"style"},width:{valType:"number",min:0,editType:"style"},editType:"plot"},side:{valType:"enumerated",values:["both",'positive',"negative"],dflt:"both",editType:"calc"},offsetgroup:n.offsetgroup,alignmentgroup:n.alignmentgroup,selected:n.selected,unselected:n.unselected,hoveron:{valType:"flaglist",flags:["violins",'points',"kde"],dflt:"violins+points+kde",extras:["all"],editType:"style"}}},{"../../lib/extend":777,"../../plots/cartesian/axis_format_attributes":841,"../box/attributes":950}],1357:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../box/calc'),o=t('./helpers'),s=t('../../constants/numerical').BADNUM;function l(t,e,r){return 1.059*Math.min(e,r/1.349)*Math.pow(t,-.2)}function c(t,e,r){var i=e.max-e.min;if(!i)return t.bandwidth?t.bandwidth:0;if(t.bandwidth)return Math.max(t.bandwidth,i/1e4);var a=r.length,o=n.stdev(r,a-1,e.mean);return Math.max(l(a,o,e.q3-e.q1),i/100)}function u(t,e,r,n){var a,o=t.spanmode,l=t.span||[],c=[e.min,e.max],u=[e.min-2*n,e.max+2*n];function f(n){var i=l[n],a="multicategory"===r.type?r.r2c(i):r.d2c(i,0,t[e.valLetter+"calendar"]);return a===s?u[n]:a}var h={type:"linear",range:a="soft"===o?u:"hard"===o?c:[f(0),f(1)]};return i.setConvert(h),h.cleanRange(),a}e.exports=function(t,e){var r=a(t,e);if(r[0].t.empty)return r;for(var s=t._fullLayout,l=i.getFromId(t,e["h"===e.orientation?"xaxis":"yaxis"]),f=1/0,h=-1/0,p=0,d=0,m=0;m<r.length;m++){var g=r[m],v=g.pts.map(o.extractVal),y=g.bandwidth=c(e,g,v),x=g.span=u(e,g,l,y);if(g.min===g.max&&0===y)x=g.span=[g.min,g.max],g.density=[v:1,t:x[0]],g.bandwidth=y,p=Math.max(p,1);else{var b=x[1]-x[0],_=Math.ceil(b/(y/3)),w=b/_;if(!isFinite(w)||!isFinite(_))return n.error('Something went wrong with computing the violin span'),r[0].t.empty=!0,r;var T=o.makeKDE(g,e,v);g.density=new Array(_);for(var k=0,M=x[0];M<x[1]+w/2;k++,M+=w){var A=T(M);g.density[k]={v:A,t:M},p=Math.max(p,A)}}d=Math.max(d,v.length),f=Math.min(f,x[0]),h=Math.max(h,x[1])}var S=i.findExtremes(l,[f,h],{padded:!0});if(e._extremes[l._id]=S,e.width)r[0].t.maxKDE=p;else{var E=s._violinScaleGroupStats,L=e.scalegroup,C=E[L];C?(C.maxKDE=Math.max(C.maxKDE,p),C.maxCount=Math.max(C.maxCount,d)):E[L]={maxKDE:p,maxCount:d}}return r[0].t.labels.kde=n._(t,'kde:'),r}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/axes":838,"../box/calc":951,"./helpers":1360}],1358:[function(t,e,r){"use strict";var n=t('../box/cross_trace_calc').setPositionOffset,i=["v","h"];e.exports=function(t,e){for(var r=t.calcdata,a=e.xaxis,o=e.yaxis,s=0;s<i.length;s++){for(var l=i[s],c="h"===l?o:a,u=[],f=0;f<r.length;f++){var h=r[f],p=h[0].t,d=h[0].trace;!0!==d.visible||"violin"!==d.type||p.empty||d.orientation!==l||d.xaxis!==a._id||d.yaxis!==o._id||u.push(f)}n('violin',t,u,c)}}},{"../box/cross_trace_calc":952}],1359:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../components/color'),a=t('../box/defaults'),o=t('./attributes');e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}function c(r,i){return n.coerce2(t,e,o,r,i)}if(a.handleSampleDefaults(t,e,l,s),!1!==e.visible){l('bandwidth'),l('side'),l('width')||(l('scalegroup',e.name),l('scalemode'));var u,f=l('span');Array.isArray(f)&&(u='manual'),l('spanmode',u);var h=l('line.color',(t.marker||{}).color||r),p=l('line.width'),d=l('fillcolor',i.addOpacity(e.line.color,.5));a.handlePointsDefaults(t,e,l,{prefix:""});var m=c('box.width'),g=c('box.fillcolor',d),v=c('box.line.color',h),y=c('box.line.width',p);l('box.visible',Boolean(m||g||v||y))||(e.box={visible:!1});var x=c('meanline.color',h),b=c('meanline.width',p);l('meanline.visible',Boolean(x||b))||(e.meanline={visible:!1})}}},{"../../components/color":650,"../../lib":787,"../box/defaults":953,"./attributes":1356}],1360:[function(t,e,r){"use strict";var n=t('../../lib'),i={gaussian:function(t){return 1/Math.sqrt(2*Math.PI)*Math.exp(-.5*t*t)}};r.makeKDE=function(t,e,r){var n=r.length,a=i.gaussian,o=t.bandwidth,s=1/(n*o);return function(t){for(var e=0,i=0;i<n;i++)e+=a((t-r[i])/o);return s*e}},r.getPositionOnKdePath=function(t,e,r){var i,a;"h"===e.orientation?(i='y',a='x'):(i='x',a='y');var o=n.findPointOnPath(t.path,r,a,{pathLength:t.pathLength}),s=t.posCenterPx,l=o[i];return[l,"both"===e.side?2*s-l:s]},r.getKdeValue=function(t,e,n){var i=t.pts.map(r.extractVal);return r.makeKDE(t,e,i)(n)/t.posDensityScale},r.extractVal=function(t){return t.v}},{"../../lib":787}],1361:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../../plots/cartesian/axes'),a=t('../box/hover'),o=t('./helpers');e.exports=function(t,e,r,s,l){l||(l={});var c,u,f=l.hoverLayer,h=t.cd,p=h[0].trace,d=p.hoveron,m=-1!==d.indexOf('violins'),g=-1!==d.indexOf('kde'),v=[];if(m||g){var y=a.hoverOnBoxes(t,e,r,s);if(g&&y.length>0){var x,b,_,w,T,k=t.xa,M=t.ya;"h"===p.orientation?(T=e,x='y',_=M,b='x',w=k):(T=r,x='x',_=k,b='y',w=M);var A=h[t.index];if(T>=A.span[0]&&T<=A.span[1]){var S=n.extendFlat({},t),E=w.c2p(T,!0),L=o.getKdeValue(A,p,T),C=o.getPositionOnKdePath(A,p,E),P=_._offset,I=_._length;S[x+"0"]=C[0],S[x+"1"]=C[1],S[b+"0"]=S[b+"1"]=E,S[b+"Label"]=b+": "+i.hoverLabelText(w,T,p[b+"hoverformat"])+", '+h[0].t.labels.kde+' "+L.toFixed(3),S.spikeDistance=y[0].spikeDistance;var z=x+"Spike";S[z]=y[0][z],y[0].spikeDistance=void 0,y[0][z]=void 0,S.hovertemplate=!1,v.push(S),(u={stroke:t.color})[x+"1"]=n.constrain(P+C[0],P,P+I),u[x+"2"]=n.constrain(P+C[1],P,P+I),u[b+"1"]=u[b+"2"]=w._offset+E}}m&&(v=v.concat(y))}-1!==d.indexOf('points')&&(c=a.hoverOnPoints(t,e,r));var O=f.selectAll(".violinline-"+p.uid).data(u?[0]:[]);return O.enter().append('line').classed("violinline-"+p.uid,!0).attr('stroke-width',1.5),O.exit().remove(),O.attr(u),"closest"===s?c?[c]:v:c?(v.push(c),v):v}},{"../../lib":787,"../../plots/cartesian/axes":838,"../box/hover":955,"./helpers":1360}],1362:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults'),crossTraceDefaults:t('../box/defaults').crossTraceDefaults,supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc'),crossTraceCalc:t('./cross_trace_calc'),plot:t('./plot'),style:t('./style'),styleOnSelect:t('../scatter/style').styleOnSelect,hoverPoints:t('./hover'),selectPoints:t('../box/select'),moduleType:"trace",name:"violin",basePlotModule:t('../../plots/cartesian'),categories:["cartesian",'svg','symbols','oriented','box-violin','showLegend','violinLayout',"zoomScale"],meta:{}}},{"../../plots/cartesian":852,"../box/defaults":953,"../box/select":960,"../scatter/style":1226,"./attributes":1356,"./calc":1357,"./cross_trace_calc":1358,"./defaults":1359,"./hover":1361,"./layout_attributes":1363,"./layout_defaults":1364,"./plot":1365,"./style":1366}],1363:[function(t,e,r){"use strict";var n=t('../box/layout_attributes'),i=t('../../lib').extendFlat;e.exports={violinmode:i({},n.boxmode,{}),violingap:i({},n.boxgap,{}),violingroupgap:i({},n.boxgroupgap,{})}},{"../../lib":787,"../box/layout_attributes":957}],1364:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes'),a=t('../box/layout_defaults');e.exports=function(t,e,r){function o(r,a){return n.coerce(t,e,i,r,a)}a._supply(t,e,r,o,'violin')}},{"../../lib":787,"../box/layout_defaults":958,"./layout_attributes":1363}],1365:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../box/plot'),s=t('../scatter/line_points'),l=t('./helpers');e.exports=function(t,e,r,c){var u=t._fullLayout,f=e.xaxis,h=e.yaxis;function p(t){var e=s(t,{xaxis:f,yaxis:h,connectGaps:!0,baseTolerance:.75,shape:"spline",simplify:!0,linearized:!0});return a.smoothopen(e[0],1)}i.makeTraceGroups(c,r,'trace violins').each((function(t){var r=n.select(this),a=t[0],s=a.t,c=a.trace;if(!0!==c.visible||s.empty)r.remove();else{var d=s.bPos,m=s.bdPos,g=e[s.valLetter+"axis"],v=e[s.posLetter+"axis"],y="both"===c.side,x=y||"positive"===c.side,b=y||"negative"===c.side,_=r.selectAll('path.violin').data(i.identity);_.enter().append('path').style('vector-effect','non-scaling-stroke').attr('class','violin'),_.exit().remove(),_.each((function(t){var e,r,i,a,o,l,f,h,_=n.select(this),w=t.density,T=w.length,k=v.c2l(t.pos+d,!0),M=v.l2p(k);if(c.width)e=s.maxKDE/m;else{var A=u._violinScaleGroupStats[c.scalegroup];e="count"===c.scalemode?A.maxKDE/m*(A.maxCount/t.pts.length):A.maxKDE/m}if(x){for(f=new Array(T),o=0;o<T;o++)(h=f[o]={})[s.posLetter]=k+w[o].v/e,h[s.valLetter]=g.c2l(w[o].t,!0);r=p(f)}if(b){for(f=new Array(T),l=0,o=T-1;l<T;l++,o--)(h=f[l]={})[s.posLetter]=k-w[o].v/e,h[s.valLetter]=g.c2l(w[o].t,!0);i=p(f)}if(y)a=r+"L"+i.substr(1)+"Z";else{var S=[M,g.c2p(w[0].t)],E=[M,g.c2p(w[T-1].t)];"h"===c.orientation&&(S.reverse(),E.reverse()),a=x?"M"+S+"L"+r.substr(1)+"L"+E:"M"+E+"L"+i.substr(1)+"L"+S}_.attr('d',a),t.posCenterPx=M,t.posDensityScale=e*m,t.path=_.node(),t.pathLength=t.path.getTotalLength()/(y?2:1)}));var w,T,k,M=c.box,A=M.width,S=(M.line||{}).width;y?(w=m*A,T=0):x?(w=[0,m*A/2],T=S*{x:1,y:-1}[s.posLetter]):(w=[m*A/2,0],T=S*{x:-1,y:1}[s.posLetter]),o.plotBoxAndWhiskers(r,{pos:v,val:g},c,{bPos:d,bdPos:w,bPosPxOffset:T}),o.plotBoxMean(r,{pos:v,val:g},c,{bPos:d,bdPos:w,bPosPxOffset:T}),!c.box.visible&&c.meanline.visible&&(k=i.identity);var E=r.selectAll('path.meanline').data(k||[]);E.enter().append('path').attr('class','meanline').style('fill','none').style('vector-effect','non-scaling-stroke'),E.exit().remove(),E.each((function(t){var e=g.c2p(t.mean,!0),r=l.getPositionOnKdePath(t,c,e);n.select(this).attr('d',"h"===c.orientation?"M"+e+","+r[0]+"V"+r[1]:"M"+r[0]+","+e+"H"+r[1])})),o.plotPoints(r,{x:f,y:h},c,s)}}))}},{"../../components/drawing":672,"../../lib":787,"../box/plot":959,"../scatter/line_points":1216,"./helpers":1360,"@plotly/d3":58}],1366:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/color'),a=t('../scatter/style').stylePoints;e.exports=function(t){var e=n.select(t).selectAll('g.trace.violins');e.style('opacity',(function(t){return t[0].trace.opacity})),e.each((function(e){var r=e[0].trace,o=n.select(this),s=r.box||{},l=s.line||{},c=r.meanline||{},u=c.width;o.selectAll('path.violin').style('stroke-width',r.line.width+"px").call(i.stroke,r.line.color).call(i.fill,r.fillcolor),o.selectAll('path.box').style('stroke-width',l.width+"px").call(i.stroke,l.color).call(i.fill,s.fillcolor);var f={"stroke-width":u+"px","stroke-dasharray":2*u+"px,"+u+"px"};o.selectAll('path.mean').style(f).call(i.stroke,c.color),o.selectAll('path.meanline').style(f).call(i.stroke,c.color),a(o,r,t)}))}},{"../../components/color":650,"../scatter/style":1226,"@plotly/d3":58}],1367:[function(t,e,r){"use strict";var n=t('../../components/colorscale/attributes'),i=t('../isosurface/attributes'),a=t('../surface/attributes'),o=t('../../plots/attributes'),s=t('../../lib/extend').extendFlat,l=t('../../plot_api/edit_types').overrideAll,c=e.exports=l(s({x:i.x,y:i.y,z:i.z,value:i.value,isomin:i.isomin,isomax:i.isomax,surface:i.surface,spaceframe:{show:{valType:"boolean",dflt:!1},fill:{valType:"number",min:0,max:1,dflt:1}},slices:i.slices,caps:i.caps,text:i.text,hovertext:i.hovertext,xhoverformat:i.xhoverformat,yhoverformat:i.yhoverformat,zhoverformat:i.zhoverformat,valuehoverformat:i.valuehoverformat,hovertemplate:i.hovertemplate},n('',{colorAttr:"`value`",showScaleDflt:!0,editTypeOverride:"calc"}),{colorbar:i.colorbar,opacity:i.opacity,opacityscale:a.opacityscale,lightposition:i.lightposition,lighting:i.lighting,flatshading:i.flatshading,contour:i.contour,hoverinfo:s({},o.hoverinfo),showlegend:s({},o.showlegend,{dflt:!1})}),'calc','nested');c.x.editType=c.y.editType=c.z.editType=c.value.editType='calc+clearAxisTypes',c.transforms=void 0},{"../../components/colorscale/attributes":657,"../../lib/extend":777,"../../plot_api/edit_types":820,"../../plots/attributes":834,"../isosurface/attributes":1138,"../surface/attributes":1326}],1368:[function(t,e,r){"use strict";var n=t('gl-mesh3d'),i=t('../../lib/gl_format_color').parseColorScale,a=t('../../lib/str2rgbarray'),o=t('../../components/colorscale').extractOpts,s=t('../../plots/gl3d/zip3'),l=t('../isosurface/convert').findNearestOnAxis,c=t('../isosurface/convert').generateIsoMeshes;function u(t,e,r){this.scene=t,this.uid=r,this.mesh=e,this.name='',this.data=null,this.showContour=!1}var f=u.prototype;function h(t,e){var r=t.glplot.gl,i=n({gl:r}),a=new u(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}f.handlePick=function(t){if(t.object===this.mesh){var e=t.data.index,r=this.data._meshX[e],n=this.data._meshY[e],i=this.data._meshZ[e],a=this.data._Ys.length,o=this.data._Zs.length,s=l(r,this.data._Xs).id,c=l(n,this.data._Ys).id,u=l(i,this.data._Zs).id,f=t.index=u+o*c+o*a*s;t.traceCoordinate=[this.data._meshX[f],this.data._meshY[f],this.data._meshZ[f],this.data._value[f]];var h=this.data.hovertext||this.data.text;return Array.isArray(h)&&void 0!==h[f]?t.textLabel=h[f]:h&&(t.textLabel=h),!0}},f.update=function(t){var e=this.scene,r=e.fullSceneLayout;function n(t,e,r,n){return e.map((function(e){return t.d2l(e,0,n)*r}))}this.data=c(t);var l={positions:s(n(r.xaxis,t._meshX,e.dataScale[0],t.xcalendar),n(r.yaxis,t._meshY,e.dataScale[1],t.ycalendar),n(r.zaxis,t._meshZ,e.dataScale[2],t.zcalendar)),cells:s(t._meshI,t._meshJ,t._meshK),lightPosition:[t.lightposition.x,t.lightposition.y,t.lightposition.z],ambient:t.lighting.ambient,diffuse:t.lighting.diffuse,specular:t.lighting.specular,roughness:t.lighting.roughness,fresnel:t.lighting.fresnel,vertexNormalsEpsilon:t.lighting.vertexnormalsepsilon,faceNormalsEpsilon:t.lighting.facenormalsepsilon,opacity:t.opacity,opacityscale:t.opacityscale,contourEnable:t.contour.show,contourColor:a(t.contour.color).slice(0,3),contourWidth:t.contour.width,useFacetNormals:t.flatshading},u=o(t);l.vertexIntensity=t._meshIntensity,l.vertexIntensityBounds=[u.min,u.max],l.colormap=i(t),this.mesh.update(l)},f.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()},e.exports=h},{"../../components/colorscale":662,"../../lib/gl_format_color":783,"../../lib/str2rgbarray":812,"../../plots/gl3d/zip3":891,"../isosurface/convert":1140,"gl-mesh3d":309}],1369:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./attributes'),a=t('../isosurface/defaults').supplyIsoDefaults,o=t('../surface/defaults').opacityscaleDefaults;e.exports=function(t,e,r,s){function l(r,a){return n.coerce(t,e,i,r,a)}a(t,e,r,s,l),o(t,e,s,l)}},{"../../lib":787,"../isosurface/defaults":1141,"../surface/defaults":1329,"./attributes":1367}],1370:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),supplyDefaults:t('./defaults'),calc:t('../isosurface/calc'),colorbar:{min:"cmin",max:"cmax"},plot:t('./convert'),moduleType:"trace",name:"volume",basePlotModule:t('../../plots/gl3d'),categories:["gl3d","showLegend"],meta:{}}},{"../../plots/gl3d":880,"../isosurface/calc":1139,"./attributes":1367,"./convert":1368,"./defaults":1369}],1371:[function(t,e,r){"use strict";var n=t('../bar/attributes'),i=t('../scatter/attributes').line,a=t('../../plots/attributes'),o=t('../../plots/cartesian/axis_format_attributes').axisHoverFormat,s=t('../../plots/template_attributes').hovertemplateAttrs,l=t('../../plots/template_attributes').texttemplateAttrs,c=t('./constants'),u=t('../../lib/extend').extendFlat,f=t('../../components/color');function h(t){return{marker:{color:u({},n.marker.color,{arrayOk:!1,editType:"style"}),line:{color:u({},n.marker.line.color,{arrayOk:!1,editType:"style"}),width:u({},n.marker.line.width,{arrayOk:!1,editType:"style"}),editType:"style"},editType:"style"},editType:"style"}}e.exports={measure:{valType:"data_array",dflt:[],editType:"calc"},base:{valType:"number",dflt:null,arrayOk:!1,editType:"calc"},x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,xperiod:n.xperiod,yperiod:n.yperiod,xperiod0:n.xperiod0,yperiod0:n.yperiod0,xperiodalignment:n.xperiodalignment,yperiodalignment:n.yperiodalignment,xhoverformat:o('x'),yhoverformat:o('y'),hovertext:n.hovertext,hovertemplate:s({},{keys:c.eventDataKeys}),hoverinfo:u({},a.hoverinfo,{flags:["name",'x','y','text','initial','delta',"final"]}),textinfo:{valType:"flaglist",flags:["label",'text','initial','delta',"final"],extras:["none"],editType:"plot",arrayOk:!1},texttemplate:l({editType:"plot"},{keys:c.eventDataKeys.concat(["label"])}),text:n.text,textposition:n.textposition,insidetextanchor:n.insidetextanchor,textangle:n.textangle,textfont:n.textfont,insidetextfont:n.insidetextfont,outsidetextfont:n.outsidetextfont,constraintext:n.constraintext,cliponaxis:n.cliponaxis,orientation:n.orientation,offset:n.offset,width:n.width,increasing:h('increasing'),decreasing:h('decreasing'),totals:h('intermediate sums and total'),connector:{line:{color:u({},i.color,{dflt:f.defaultLine}),width:u({},i.width,{editType:"plot"}),dash:i.dash,editType:"plot"},mode:{valType:"enumerated",values:["spanning","between"],dflt:"between",editType:"plot"},visible:{valType:"boolean",dflt:!0,editType:"plot"},editType:"plot"},offsetgroup:n.offsetgroup,alignmentgroup:n.alignmentgroup}},{"../../components/color":650,"../../lib/extend":777,"../../plots/attributes":834,"../../plots/cartesian/axis_format_attributes":841,"../../plots/template_attributes":910,"../bar/attributes":925,"../scatter/attributes":1202,"./constants":1373}],1372:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes'),i=t('../../plots/cartesian/align_period'),a=t('../../lib').mergeArray,o=t('../scatter/calc_selection'),s=t('../../constants/numerical').BADNUM;function l(t){return"a"===t||"absolute"===t}function c(t){return"t"===t||"total"===t}e.exports=function(t,e){var r,u,f,h,p,d,m=n.getFromId(t,e.xaxis||"x"),g=n.getFromId(t,e.yaxis||"y");"h"===e.orientation?(r=m.makeCalcdata(e,'x'),f=g.makeCalcdata(e,'y'),h=i(e,g,'y',f),p=!!e.yperiodalignment,d='y'):(r=g.makeCalcdata(e,'y'),f=m.makeCalcdata(e,'x'),h=i(e,m,'x',f),p=!!e.xperiodalignment,d='x'),u=h.vals;for(var v,y=Math.min(u.length,r.length),x=new Array(y),b=0,_=!1,w=0;w<y;w++){var T=r[w]||0,k=!1;(r[w]!==s||c(e.measure[w])||l(e.measure[w]))&&w+1<y&&(r[w+1]!==s||c(e.measure[w+1])||l(e.measure[w+1]))&&(k=!0);var M=x[w]={i:w,p:u[w],s:T,rawS:T,cNext:k};l(e.measure[w])?(b=M.s,M.isSum=!0,M.dir='totals',M.s=b):c(e.measure[w])?(M.isSum=!0,M.dir='totals',M.s=b):(M.isSum=!1,M.dir=M.rawS<0?"decreasing":"increasing",v=M.s,M.s=b+v,b+=v),"totals"===M.dir&&(_=!0),p&&(x[w].orig_p=f[w],x[w][d+"End"]=h.ends[w],x[w][d+"Start"]=h.starts[w]),e.ids&&(M.id=String(e.ids[w])),M.v=(e.base||0)+b}return x.length&&(x[0].hasTotals=_),a(e.text,x,'tx'),a(e.hovertext,x,'htx'),o(x,e),x}},{"../../constants/numerical":763,"../../lib":787,"../../plots/cartesian/align_period":835,"../../plots/cartesian/axes":838,"../scatter/calc_selection":1204}],1373:[function(t,e,r){"use strict";e.exports={eventDataKeys:["initial",'delta',"final"]}},{}],1374:[function(t,e,r){"use strict";var n=t('../bar/cross_trace_calc').setGroupPositions;e.exports=function(t,e){var r,i,a=t._fullLayout,o=t._fullData,s=t.calcdata,l=e.xaxis,c=e.yaxis,u=[],f=[],h=[];for(i=0;i<o.length;i++){var p=o[i];!0===p.visible&&p.xaxis===l._id&&p.yaxis===c._id&&"waterfall"===p.type&&(r=s[i],"h"===p.orientation?h.push(r):f.push(r),u.push(r))}var d={mode:a.waterfallmode,norm:a.waterfallnorm,gap:a.waterfallgap,groupgap:a.waterfallgroupgap};for(n(t,l,c,f,d),n(t,c,l,h,d),i=0;i<u.length;i++){r=u[i];for(var m=0;m<r.length;m++){var g=r[m];!1===g.isSum&&(g.s0+=0===m?0:r[m-1].s),m+1<r.length&&(r[m].nextP0=r[m+1].p0,r[m].nextS0=r[m+1].s0)}}}},{"../bar/cross_trace_calc":928}],1375:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('../bar/defaults').handleGroupingDefaults,a=t('../bar/defaults').handleText,o=t('../scatter/xy_defaults'),s=t('../scatter/period_defaults'),l=t('./attributes'),c=t('../../components/color'),u=t('../../constants/delta.js'),f=u.INCREASING.COLOR,h=u.DECREASING.COLOR,p='#4499FF';function d(t,e,r){t(e+".marker.color",r),t(e+".marker.line.color",c.defaultLine),t(e+".marker.line.width")}function m(t,e,r,i){function c(r,i){return n.coerce(t,e,l,r,i)}if(o(t,e,i,c)){s(t,e,i,c),c('xhoverformat'),c('yhoverformat'),c('measure'),c('orientation',e.x&&!e.y?"h":"v"),c('base'),c('offset'),c('width'),c('text'),c('hovertext'),c('hovertemplate');var u=c('textposition');a(t,e,i,c,u,{moduleHasSelected:!1,moduleHasUnselected:!1,moduleHasConstrain:!0,moduleHasCliponaxis:!0,moduleHasTextangle:!0,moduleHasInsideanchor:!0}),"none"!==e.textposition&&(c('texttemplate'),e.texttemplate||c('textinfo')),d(c,'increasing',f),d(c,'decreasing',h),d(c,'totals',p),c('connector.visible')&&(c('connector.mode'),c('connector.line.width')&&(c('connector.line.color'),c('connector.line.dash')))}else e.visible=!1}function g(t,e){var r,a;function o(t){return n.coerce(a._input,a,l,t)}if("group"===e.waterfallmode)for(var s=0;s<t.length;s++)r=(a=t[s])._input,i(r,a,e,o)}e.exports={supplyDefaults:m,crossTraceDefaults:g}},{"../../components/color":650,"../../constants/delta.js":757,"../../lib":787,"../bar/defaults":929,"../scatter/period_defaults":1222,"../scatter/xy_defaults":1229,"./attributes":1371}],1376:[function(t,e,r){"use strict";e.exports=function(t,e){return t.x="xVal"in e?e.xVal:e.x,t.y="yVal"in e?e.yVal:e.y,"initial"in e&&(t.initial=e.initial),"delta"in e&&(t.delta=e.delta),"final"in e&&(t.final=e.final),e.xa&&(t.xaxis=e.xa),e.ya&&(t.yaxis=e.ya),t}},{}],1377:[function(t,e,r){"use strict";var n=t('../../plots/cartesian/axes').hoverLabelText,i=t('../../components/color').opacity,a=t('../bar/hover').hoverOnBars,o=t('../../constants/delta.js'),s={increasing:o.INCREASING.SYMBOL,decreasing:o.DECREASING.SYMBOL};function l(t,e){var r=t[e.dir].marker,n=r.color,a=r.line.color,o=r.line.width;return i(n)?n:i(a)&&o?a:void 0}e.exports=function(t,e,r,i,o){var c=a(t,e,r,i,o);if(c){var u=c.cd,f=u[0].trace,h="h"===f.orientation,p=h?"x":"y",d=h?t.xa:t.ya,m=u[c.index],g=m.isSum?m.b+m.s:m.rawS;if(!m.isSum){c.initial=m.b+m.s-g,c.delta=g,c.final=c.initial+c.delta;var v=T(Math.abs(c.delta));c.deltaLabel=g<0?"('+v+')":v,c.finalLabel=T(c.final),c.initialLabel=T(c.initial)}var y=m.hi||f.hoverinfo,x=[];if(y&&"none"!==y&&"skip"!==y){var b="all"===y,_=y.split('+'),w=function(t){return b||-1!==_.indexOf(t)};m.isSum||(!w('final')||w(h?"x":"y")||x.push(c.finalLabel),w('delta')&&(g<0?x.push(c.deltaLabel+" '+s.decreasing):x.push(c.deltaLabel+' "+s.increasing)),w('initial')&&x.push("Initial: "+c.initialLabel))}return x.length&&(c.extraText=x.join('<br>')),c.color=l(f,m),[c]}function T(t){return n(d,t,f[p+"hoverformat"])}}},{"../../components/color":650,"../../constants/delta.js":757,"../../plots/cartesian/axes":838,"../bar/hover":932}],1378:[function(t,e,r){"use strict";e.exports={attributes:t('./attributes'),layoutAttributes:t('./layout_attributes'),supplyDefaults:t('./defaults').supplyDefaults,crossTraceDefaults:t('./defaults').crossTraceDefaults,supplyLayoutDefaults:t('./layout_defaults'),calc:t('./calc'),crossTraceCalc:t('./cross_trace_calc'),plot:t('./plot'),style:t('./style').style,hoverPoints:t('./hover'),eventData:t('./event_data'),selectPoints:t('../bar/select'),moduleType:"trace",name:"waterfall",basePlotModule:t('../../plots/cartesian'),categories:["bar-like",'cartesian','svg','oriented','showLegend',"zoomScale"],meta:{}}},{"../../plots/cartesian":852,"../bar/select":937,"./attributes":1371,"./calc":1372,"./cross_trace_calc":1374,"./defaults":1375,"./event_data":1376,"./hover":1377,"./layout_attributes":1379,"./layout_defaults":1380,"./plot":1381,"./style":1382}],1379:[function(t,e,r){"use strict";e.exports={waterfallmode:{valType:"enumerated",values:["group","overlay"],dflt:"group",editType:"calc"},waterfallgap:{valType:"number",min:0,max:1,editType:"calc"},waterfallgroupgap:{valType:"number",min:0,max:1,dflt:0,editType:"calc"}}},{}],1380:[function(t,e,r){"use strict";var n=t('../../lib'),i=t('./layout_attributes');e.exports=function(t,e,r){var a=!1;function o(r,a){return n.coerce(t,e,i,r,a)}for(var s=0;s<r.length;s++){var l=r[s];if(l.visible&&"waterfall"===l.type){a=!0;break}}a&&(o('waterfallmode'),o('waterfallgap',.2),o('waterfallgroupgap'))}},{"../../lib":787,"./layout_attributes":1379}],1381:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../lib'),a=t('../../components/drawing'),o=t('../../constants/numerical').BADNUM,s=t('../bar/plot'),l=t('../bar/uniform_text').clearMinTextSize;function c(t,e,r,s){var l=e.xaxis,c=e.yaxis;i.makeTraceGroups(s,r,'trace bars').each((function(r){var s=n.select(this),f=r[0].trace,h=i.ensureSingle(s,'g','lines');if(f.connector&&f.connector.visible){var p="h"===f.orientation,d=f.connector.mode,m=h.selectAll('g.line').data(i.identity);m.enter().append('g').classed('line',!0),m.exit().remove();var g=m.size();m.each((function(r,s){if(s===g-1||r.cNext){var f=u(r,l,c,p),h=f[0],m=f[1],v='';h[0]!==o&&m[0]!==o&&h[1]!==o&&m[1]!==o&&("spanning"===d&&!r.isSum&&s>0&&(v+=p?"M"+h[0]+","+m[1]+"V"+m[0]:"M"+h[1]+","+m[0]+"H"+h[0]),"between"!==d&&(r.isSum||s<g-1)&&(v+=p?"M"+h[1]+","+m[0]+"V"+m[1]:"M"+h[0]+","+m[1]+"H"+h[1]),h[2]!==o&&m[2]!==o&&(v+=p?"M"+h[1]+","+m[1]+"V"+m[2]:"M"+h[1]+","+m[1]+"H"+h[2])),""===v&&(v='M0,0Z'),i.ensureSingle(n.select(this),'path').attr('d',v).call(a.setClipUrl,e.layerClipId,t)}}))}else h.remove()}))}function u(t,e,r,n){var i=[],a=[],o=n?e:r,s=n?r:e;return i[0]=o.c2p(t.s0,!0),a[0]=s.c2p(t.p0,!0),i[1]=o.c2p(t.s1,!0),a[1]=s.c2p(t.p1,!0),i[2]=o.c2p(t.nextS0,!0),a[2]=s.c2p(t.nextP0,!0),n?[i,a]:[a,i]}e.exports=function(t,e,r,n){var i=t._fullLayout;l('waterfall',i),s.plot(t,e,r,n,{mode:i.waterfallmode,norm:i.waterfallmode,gap:i.waterfallgap,groupgap:i.waterfallgroupgap}),c(t,e,r,n)}},{"../../components/drawing":672,"../../constants/numerical":763,"../../lib":787,"../bar/plot":936,"../bar/uniform_text":941,"@plotly/d3":58}],1382:[function(t,e,r){"use strict";var n=t('@plotly/d3'),i=t('../../components/drawing'),a=t('../../components/color'),o=t('../../constants/interactions').DESELECTDIM,s=t('../bar/style'),l=t('../bar/uniform_text').resizeText,c=s.styleTextPoints;function u(t,e,r){var s=r||n.select(t).selectAll('g.waterfalllayer').selectAll('g.trace');l(t,s,'waterfall'),s.style('opacity',(function(t){return t[0].trace.opacity})),s.each((function(e){var r=n.select(this),s=e[0].trace;r.selectAll('.point > path').each((function(t){if(!t.isBlank){var e=s[t.dir].marker;n.select(this).call(a.fill,e.color).call(a.stroke,e.line.color).call(i.dashLine,e.line.dash,e.line.width).style('opacity',s.selectedpoints&&!t.selected?o:1)}})),c(r,s,t),r.selectAll('.lines').each((function(){var t=s.connector.line;i.lineGroupStyle(n.select(this).selectAll('path'),t.width,t.color,t.dash)}))}))}e.exports={style:u}},{"../../components/color":650,"../../components/drawing":672,"../../constants/interactions":762,"../bar/style":939,"../bar/uniform_text":941,"@plotly/d3":58}],1383:[function(t,e,r){"use strict";var n=t('../plots/cartesian/axes'),i=t('../lib'),a=t('../plot_api/plot_schema'),o=t('./helpers').pointsAccessorFunction,s=t('../constants/numerical').BADNUM;r.moduleType='transform',r.name='aggregate';var l=r.attributes={enabled:{valType:"boolean",dflt:!0,editType:"calc"},groups:{valType:"string",strict:!0,noBlank:!0,arrayOk:!0,dflt:"x",editType:"calc"},aggregations:{_isLinkedToArray:"aggregation",target:{valType:"string",editType:"calc"},func:{valType:"enumerated",values:["count",'sum','avg','median','mode','rms','stddev','min','max','first','last','change',"range"],dflt:"first",editType:"calc"},funcmode:{valType:"enumerated",values:["sample","population"],dflt:"sample",editType:"calc"},enabled:{valType:"boolean",dflt:!0,editType:"calc"},editType:"calc"},editType:"calc"},c=l.aggregations;function u(t,e,r,a){if(a.enabled){for(var o=a.target,s=i.nestedProperty(e,o),l=s.get(),c=f(a,n.getDataConversions(t,e,o,l)),u=new Array(r.length),h=0;h<r.length;h++)u[h]=c(l,r[h]);s.set(u),"count"===a.func&&i.pushUnique(e._arrayAttrs,o)}}function f(t,e){var r=t.func,n=e.d2c,a=e.c2d;switch(r){case"count":return h;case"first":return p;case"last":return d;case"sum":return function(t,e){for(var r=0,i=0;i<e.length;i++){var o=n(t[e[i]]);o!==s&&(r+=o)}return a(r)};case"avg":return function(t,e){for(var r=0,i=0,o=0;o<e.length;o++){var l=n(t[e[o]]);l!==s&&(r+=l,i++)}return i?a(r/i):s};case"min":return function(t,e){for(var r=1/0,i=0;i<e.length;i++){var o=n(t[e[i]]);o!==s&&(r=Math.min(r,o))}return r===1/0?s:a(r)};case"max":return function(t,e){for(var r=-1/0,i=0;i<e.length;i++){var o=n(t[e[i]]);o!==s&&(r=Math.max(r,o))}return r===-1/0?s:a(r)};case"range":return function(t,e){for(var r=1/0,i=-1/0,o=0;o<e.length;o++){var l=n(t[e[o]]);l!==s&&(r=Math.min(r,l),i=Math.max(i,l))}return i===-1/0||r===1/0?s:a(i-r)};case"change":return function(t,e){var r=n(t[e[0]]),i=n(t[e[e.length-1]]);return r===s||i===s?s:a(i-r)};case"median":return function(t,e){for(var r=[],o=0;o<e.length;o++){var l=n(t[e[o]]);l!==s&&r.push(l)}if(!r.length)return s;r.sort(i.sorterAsc);var c=(r.length-1)/2;return a((r[Math.floor(c)]+r[Math.ceil(c)])/2)};case"mode":return function(t,e)[for(var r={],i=0,o=s,l=0;l<e.length;l++){var c=n(t[e[l]]);if(c!==s){var u=r[c]=(r[c]||0)+1;u>i&&(i=u,o=c)}}return i?a(o):s};case"rms":return function(t,e){for(var r=0,i=0,o=0;o<e.length;o++){var l=n(t[e[o]]);l!==s&&(r+=l*l,i++)}return i?a(Math.sqrt(r/i)):s};case"stddev":return function(e,r){var i,a=0,o=0,l=1,c=s;for(i=0;i<r.length&&c===s;i++)c=n(e[r[i]]);if(c===s)return s;for(;i<r.length;i++){var u=n(e[r[i]]);if(u!==s){var f=u-c;a+=f,o+=f*f,l++}}var h="sample"===t.funcmode?l-1:l;return h?Math.sqrt((o-a*a/l)/h):0}}}function h(t,e){return e.length}function p(t,e){return t[e[0]]}function d(t,e){return t[e[e.length-1]]}r.supplyDefaults=function(t,e){var r,n={};function o(e,r){return i.coerce(t,n,l,e,r)}if(!o('enabled'))return n;var s=a.findArrayAttributes(e),u={};for(r=0;r<s.length;r++)u[s[r]]=1;var f=o('groups');if(!Array.isArray(f)){if(!u[f])return n.enabled=!1,n;u[f]=0}var h,p=t.aggregations||[],d=n.aggregations=new Array(p.length);function m(t,e){return i.coerce(p[r],h,c,t,e)}for(r=0;r<p.length;r++){h={_index:r};var g=m('target'),v=m('func');m('enabled')&&g&&(u[g]||"count"===v&&void 0===u[g])?("stddev"===v&&m('funcmode'),u[g]=0,d[r]=h):d[r]={enabled:!1,_index:r}}for(r=0;r<s.length;r++)u[s[r]]&&d.push({target:s[r],func:c.func.dflt,enabled:!0,_index:-1});return n},r.calcTransform=function(t,e,r){if(r.enabled){var n=r.groups,a=i.getTargetArray(e,{target:n});if(a){var s,l,c,f,h={},p={},d=[],m=o(e.transforms,r),g=a.length;for(e._length&&(g=Math.min(g,e._length)),s=0;s<g;s++)void 0===(c=h[l=a[s]])?(h[l]=d.length,f=[s],d.push(f),p[h[l]]=m(s)):(d[c].push(s),p[h[l]]=(p[h[l]]||[]).concat(m(s)));r._indexToPoints=p;var v=r.aggregations;for(s=0;s<v.length;s++)u(t,e,d,v[s]);"string"===typeof n&&u(t,e,d,{target:n,func:"first",enabled:!0}),e._length=d.length}}}},{"../constants/numerical":763,"../lib":787,"../plot_api/plot_schema":826,"../plots/cartesian/axes":838,"./helpers":1386}],1384:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../registry'),a=t('../plots/cartesian/axes'),o=t('./helpers').pointsAccessorFunction,s=t('../constants/filter_ops'),l=s.COMPARISON_OPS,c=s.INTERVAL_OPS,u=s.SET_OPS;function f(t,e,r){var n=t.operation,i=t.value,a=Array.isArray(i);function o(t){return-1!==t.indexOf(n)}var s,f=function(r){return e(r,0,t.valuecalendar)},h=function(t){return e(t,0,r)};switch(o(l)?s=f(a?i[0]:i):o(c)?s=a?[f(i[0]),f(i[1])]:[f(i),f(i)]:o(u)&&(s=a?i.map(f):[f(i)]),n){case"=":return function(t){return h(t)===s};case"!=":return function(t){return h(t)!==s};case"<":return function(t){return h(t)<s};case"<=":return function(t){return h(t)<=s};case">":return function(t){return h(t)>s};case">=":return function(t){return h(t)>=s};case"[]":return function(t){var e=h(t);return e>=s[0]&&e<=s[1]};case"()":return function(t){var e=h(t);return e>s[0]&&e<s[1]};case"[)":return function(t){var e=h(t);return e>=s[0]&&e<s[1]};case"(]":return function(t){var e=h(t);return e>s[0]&&e<=s[1]};case"][":return function(t){var e=h(t);return e<=s[0]||e>=s[1]};case")(":return function(t){var e=h(t);return e<s[0]||e>s[1]};case"](':return function(t){var e=h(t);return e<=s[0]||e>s[1]};case')[":return function(t){var e=h(t);return e<s[0]||e>=s[1]};case"{}":return function(t){return-1!==s.indexOf(h(t))};case"}{":return function(t){return-1===s.indexOf(h(t))}}}r.moduleType='transform',r.name='filter',r.attributes={enabled:{valType:"boolean",dflt:!0,editType:"calc"},target:{valType:"string",strict:!0,noBlank:!0,arrayOk:!0,dflt:"x",editType:"calc"},operation:{valType:"enumerated",values:[].concat(l).concat(c).concat(u),dflt:"=",editType:"calc"},value:{valType:"any",dflt:0,editType:"calc"},preservegaps:{valType:"boolean",dflt:!1,editType:"calc"},editType:"calc"},r.supplyDefaults=function(t)[var e={];function a(i,a){return n.coerce(t,e,r.attributes,i,a)}if(a('enabled')){var o=a('target');if(n.isArrayOrTypedArray(o)&&0===o.length)return e.enabled=!1,e;a('preservegaps'),a('operation'),a('value');var s=i.getComponentMethod('calendars','handleDefaults');s(t,e,'valuecalendar',null),s(t,e,'targetcalendar',null)}return e},r.calcTransform=function(t,e,r){if(r.enabled){var i=n.getTargetArray(e,r);if(i){var s=r.target,l=i.length;e._length&&(l=Math.min(l,e._length));var c=r.targetcalendar,u=e._arrayAttrs,h=r.preservegaps;if("string"===typeof s){var p=n.nestedProperty(e,s+"calendar").get();p&&(c=p)}var d,m,g=f(r,a.getDataToCoordFunc(t,e,s,i),c),v={},y={},x=0;h?(d=function(t){v[t.astr]=n.extendDeep([],t.get()),t.set(new Array(l))},m=function(t,e){var r=v[t.astr][e];t.get()[e]=r}):(d=function(t){v[t.astr]=n.extendDeep([],t.get()),t.set([])},m=function(t,e){var r=v[t.astr][e];t.get().push(r)}),w(d);for(var b=o(e.transforms,r),_=0;_<l;_++)g(i[_])?(w(m,_),y[x++]=b(_)):h&&x++;r._indexToPoints=y,e._length=x}}function w(t,r){for(var i=0;i<u.length;i++)t(n.nestedProperty(e,u[i]),r)}}},{"../constants/filter_ops":759,"../lib":787,"../plots/cartesian/axes":838,"../registry":915,"./helpers":1386}],1385:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plot_api/plot_schema'),a=t('../plots/plots'),o=t('./helpers').pointsAccessorFunction;function s(t,e){var r,s,l,c,u,f,h,p,d,m,g=e.transform,v=e.transformIndex,y=t.transforms[v].groups,x=o(t.transforms,g);if(!n.isArrayOrTypedArray(y)||0===y.length)return[t];var b=n.filterUnique(y),_=new Array(b.length),w=y.length,T=i.findArrayAttributes(t),k=g.styles||[],M={};for(r=0;r<k.length;r++)M[k[r].target]=k[r].value;g.styles&&(m=n.keyedContainer(g,'styles','target','value.name'));var A={},S={};for(r=0;r<b.length;r++){A[f=b[r]]=r,S[f]=0,(h=_[r]=n.extendDeepNoArrays({},t))._group=f,h.transforms[v]._indexToPoints={};var E=null;for(m&&(E=m.get(f)),h.name=E||""===E?E:n.templateString(g.nameformat,{trace:t.name,group:f}),p=h.transforms,h.transforms=[],s=0;s<p.length;s++)h.transforms[s]=n.extendDeepNoArrays({},p[s]);for(s=0;s<T.length;s++)n.nestedProperty(h,T[s]).set([])}for(l=0;l<T.length;l++){for(c=T[l],s=0,d=[];s<b.length;s++)d[s]=n.nestedProperty(_[s],c).get();for(u=n.nestedProperty(t,c).get(),s=0;s<w;s++)d[A[y[s]]].push(u[s])}for(s=0;s<w;s++)(h=_[A[y[s]]]).transforms[v]._indexToPoints[S[y[s]]]=x(s),S[y[s]]++;for(r=0;r<b.length;r++)f=b[r],h=_[r],a.clearExpandedTraceDefaultColors(h),h=n.extendDeepNoArrays(h,M[f]||{});return _}r.moduleType='transform',r.name='groupby',r.attributes={enabled:{valType:"boolean",dflt:!0,editType:"calc"},groups:{valType:"data_array",dflt:[],editType:"calc"},nameformat:{valType:"string",editType:"calc"},styles:{_isLinkedToArray:"style",target:{valType:"string",editType:"calc"},value:{valType:"any",dflt:{},editType:"calc",_compareAsJSON:!0},editType:"calc"},editType:"calc"},r.supplyDefaults=function(t,e,i){var a,o={};function s(e,i){return n.coerce(t,o,r.attributes,e,i)}if(!s('enabled'))return o;s('groups'),s('nameformat',i._dataLength>1?"%[group] (%[trace])":"%[group]");var l=t.styles,c=o.styles=[];if(l)for(a=0;a<l.length;a++)[var u=c[a]={];n.coerce(l[a],c[a],r.attributes.styles,'target');var f=n.coerce(l[a],c[a],r.attributes.styles,'value');n.isPlainObject(f)?u.value=n.extendDeep({},f):f&&delete u.value}return o},r.transform=function(t,e){var r,n,i,a=[];for(n=0;n<t.length;n++)for(r=s(t[n],e),i=0;i<r.length;i++)a.push(r[i]);return a}},{"../lib":787,"../plot_api/plot_schema":826,"../plots/plots":901,"./helpers":1386}],1386:[function(t,e,r){"use strict";r.pointsAccessorFunction=function(t,e){for(var r,n,i=0;i<t.length&&(r=t[i])!==e;i++)r._indexToPoints&&!1!==r.enabled&&(n=r._indexToPoints);var a=n?function(t){return n[t]}:function(t){return[t]};return a}},{}],1387:[function(t,e,r){"use strict";var n=t('../lib'),i=t('../plots/cartesian/axes'),a=t('./helpers').pointsAccessorFunction,o=t('../constants/numerical').BADNUM;function s(t,e,r,n){var i,a=new Array(n),o=new Array(n);for(i=0;i<n;i++)a[i]={v:e[i],i:i};for(a.sort(l(t,r)),i=0;i<n;i++)o[i]=a[i].i;return o}function l(t,e){switch(t.order){case"ascending":return function(t,r){var n=e(t.v),i=e(r.v);return n===o?1:i===o?-1:n-i};case"descending":return function(t,r){var n=e(t.v),i=e(r.v);return n===o?1:i===o?-1:i-n}}}r.moduleType='transform',r.name='sort',r.attributes={enabled:{valType:"boolean",dflt:!0,editType:"calc"},target:{valType:"string",strict:!0,noBlank:!0,arrayOk:!0,dflt:"x",editType:"calc"},order:{valType:"enumerated",values:["ascending","descending"],dflt:"ascending",editType:"calc"},editType:"calc"},r.supplyDefaults=function(t)[var e={];function i(i,a){return n.coerce(t,e,r.attributes,i,a)}return i('enabled')&&(i('target'),i('order')),e},r.calcTransform=function(t,e,r){if(r.enabled){var o=n.getTargetArray(e,r);if(o){var l=r.target,c=o.length;e._length&&(c=Math.min(c,e._length));var u,f,h=e._arrayAttrs,p=s(r,o,i.getDataToCoordFunc(t,e,l,o),c),d=a(e.transforms,r),m={};for(u=0;u<h.length;u++){var g=n.nestedProperty(e,h[u]),v=g.get(),y=new Array(c);for(f=0;f<c;f++)y[f]=v[p[f]];g.set(y)}for(f=0;f<c;f++)m[f]=d(p[f]);r._indexToPoints=m,e._length=c}}}},{"../constants/numerical":763,"../lib":787,"../plots/cartesian/axes":838,"./helpers":1386}],1388:[function(t,e,r){"use strict";r.version="2.5.1"},{}]},{},[27])(27)}()},67664:function(t,e,r){"use strict";Object.defineProperty(e,'__esModule',{value:!0});var n=function(){function t(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(e,r,n){return r&&t(e.prototype,r),n&&t(e,n),e}}();e.default=function(t){var e=function(e){function r(t){!function(t,e){if(!(t instanceof e))throw new TypeError('Cannot call a class as a function')}(this,r);var e=function(t,e){if(!t)throw new ReferenceError('this hasn't been initialised - super() hasn't been called');return!e||"object"!==typeof e&&"function"!==typeof e?t:e}(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,t));return e.p=Promise.resolve(),e.resizeHandler=null,e.handlers={},e.syncWindowResize=e.syncWindowResize.bind(e),e.syncEventHandlers=e.syncEventHandlers.bind(e),e.attachUpdateEvents=e.attachUpdateEvents.bind(e),e.getRef=e.getRef.bind(e),e.handleUpdate=e.handleUpdate.bind(e),e.figureCallback=e.figureCallback.bind(e),e}return function(t,e){if("function"!==typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):t.__proto__=e)}(r,e),n(r,[{key:"componentDidMount",value:function(){var e=this;this.p=this.p.then((function(){return t.newPlot(e.el,{data:e.props.data,layout:e.props.layout,config:e.props.config,frames:e.props.frames})})).then((function(){return e.syncWindowResize(null,!0)})).then(this.syncEventHandlers).then(this.attachUpdateEvents).then((function(){return e.figureCallback(e.props.onInitialized)})).catch((function(t){return console.error('Error while plotting:',t),e.props.onError&&e.props.onError(t)}))}},{key:"componentWillUpdate",value:function(e){var r=this;if(void 0===e.revision||e.revision!==this.props.revision){var n=this.props.frames&&this.props.frames.length?this.props.frames.length:0,i=e.frames&&e.frames.length?e.frames.length:0;e.layout===this.props.layout&&e.data===this.props.data&&e.config===this.props.config&&i===n||(this.p=this.p.then((function(){return t.react(r.el,{data:e.data,layout:e.layout,config:e.config,frames:e.frames})})).then((function(){return r.syncEventHandlers(e)})).then((function(){return r.syncWindowResize(e)})).then((function(){return r.figureCallback(e.onUpdate)})).catch((function(t){console.error('Error while plotting:',t),r.props.onError&&r.props.onError(t)})))}}},{key:"componentWillUnmount",value:function(){this.figureCallback(this.props.onPurge),this.resizeHandler&&u&&(window.removeEventListener('resize',this.resizeHandler),this.resizeHandler=null),this.removeUpdateEvents(),t.purge(this.el)}},{key:"attachUpdateEvents",value:function(){if(this.el&&this.el.removeListener)for(var t=0;t<c.length;t++)this.el.on(c[t],this.handleUpdate)}},{key:"removeUpdateEvents",value:function(){if(this.el&&this.el.removeListener)for(var t=0;t<c.length;t++)this.el.removeListener(c[t],this.handleUpdate)}},{key:"handleUpdate",value:function(){this.figureCallback(this.props.onUpdate)}},{key:"figureCallback",value:function(t){if("function"===typeof t){var e=this.el;t({data:e.data,layout:e.layout,frames:this.el._transitionData?this.el._transitionData._frames:null},this.el)}}},{key:"syncWindowResize",value:function(e,r){var n=this,i=e||this.props;u&&(i.useResizeHandler&&!this.resizeHandler?(this.resizeHandler=function(){return t.Plots.resize(n.el)},window.addEventListener('resize',this.resizeHandler),r&&this.resizeHandler()):!i.useResizeHandler&&this.resizeHandler&&(window.removeEventListener('resize',this.resizeHandler),this.resizeHandler=null))}},{key:"getRef",value:function(t){this.el=t,this.props.debug&&u&&(window.gd=this.el)}},{key:"syncEventHandlers",value:function(t){for(var e=t||this.props,r=0;r<l.length;r++){var n=l[r],i=e["on"+n],a=!!this.handlers[n];i&&!a?(this.handlers[n]=i,this.el.on("plotly_"+n.toLowerCase(),this.handlers[n])):!i&&a&&(this.el.removeListener("plotly_"+n.toLowerCase(),this.handlers[n]),delete this.handlers[n])}}},{key:"render",value:function(){return a.default.createElement('div',{id:this.props.divId,style:this.props.style,ref:this.getRef,className:this.props.className})}}]),r}(i.Component);e.propTypes={data:o.default.arrayOf(o.default.object),config:o.default.object,layout:o.default.object,frames:o.default.arrayOf(o.default.object),revision:o.default.number,onInitialized:o.default.func,onPurge:o.default.func,onError:o.default.func,onUpdate:o.default.func,debug:o.default.bool,style:o.default.object,className:o.default.string,useResizeHandler:o.default.bool,divId:o.default.string};for(var r=0;r<l.length;r++)e.propTypes["on"+l[r]]=o.default.func;return e.defaultProps={debug:!1,useResizeHandler:!1,data:[],style:{position:"relative",display:"inline-block"}},e};var i=r(31014),a=s(i),o=s(r(15662));function s(t){return t&&t.__esModule?t:{default:t}}var l=["AfterExport",'AfterPlot','Animated','AnimatingFrame','AnimationInterrupted','AutoSize','BeforeExport','ButtonClicked','Click','ClickAnnotation','Deselect','DoubleClick','Framework','Hover','LegendClick','LegendDoubleClick','Relayout','Restyle','Redraw','Selected','Selecting','SliderChange','SliderEnd','SliderStart','Transitioning','TransitionInterrupted',"Unhover"],c=["plotly_restyle",'plotly_redraw','plotly_relayout','plotly_doubleclick',"plotly_animated"],u="undefined"!==typeof window;t.exports=e.default},84850:function(t,e,r){"use strict";Object.defineProperty(e,'__esModule',{value:!0});var n=a(r(67664)),i=a(r(72985));function a(t){return t&&t.__esModule?t:{default:t}}var o=(0,n.default)(i.default);e.default=o,t.exports=e.default}}]);

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### index.ts

- **Line 24:** remove later
- **Line 133:** Other constants as well
- **Line 79:** possibly, it should be readonly
- **Line 7:** Implement tool discovery system to automatically register compatible tools
- **Line 8:** Add capability matching for optimal tool orchestration based on request needs

### bfrfp

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### bfui

### convert-chakra-to-tailwind.js

- **Line 24:** map Chakra props (bg, p, borderRadius, boxShadow) to Tailwind classes

### BFUIProvider.d.ts

- **Line 2:** Create comprehensive test suite for BFUIProvider

### AgentHealthMonitor.d.ts

- **Line 2:** Create comprehensive test suite for AgentHealthMonitor component

### llm_platform_recipe

### UnifiedComplianceBridgeTest.php

- **Line 31:** Mock Process to simulate failure and assert exception is thrown
- **Line 37:** Mock callMethod and assert correct parameters
- **Line 43:** Mock callMethod to return plugins array
- **Line 49:** Mock callMethod to return dashboard data
- **Line 55:** Mock callMethod to return success

### UnifiedComplianceManagerTest.php

- **Line 42:** Mock bridge->callMethod and logger, assert correct behavior
- **Line 84:** Mock bridge->callPluginMethod and logger, assert correct behavior
- **Line 108:** Mock bridge->callPluginMethod, callMethod and logger, assert correct behavior

### PerformanceCommands.php

- **Line 198:** Implement actual provider testing

### secure_project

### SeparationOfDutiesFunctionalTest.php

- **Line 67:** Define or mock the 'perform financial approval' permission if it doesn't exist.
- **Line 68:** Define a route or path that requires 'perform financial approval'.
- **Line 77:** Replace '/admin/finance/approve-transaction' with the actual path

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

